/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(G){for(var e=[],E=0,C=G.length;E<C;E++)e[E]=te[G[E]];return e};define(te[133],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=void 0;function E(b,d){const c=C(b,d);if(c!==-1)return b[c]}e.$_e=E;function C(b,d){for(let c=b.length-1;c>=0;c--){const a=b[c];if(d(a))return c}return-1}e.$af=C;function s(b,d){const c=M(b,d);return c===-1?void 0:b[c]}e.$bf=s;function M(b,d,c=0,a=b.length){let w=c,k=a;for(;w<k;){const g=Math.floor((w+k)/2);d(b[g])?w=g+1:k=g}return w-1}e.$cf=M;function A(b,d){const c=S(b,d);return c===b.length?void 0:b[c]}e.$df=A;function S(b,d,c=0,a=b.length){let w=c,k=a;for(;w<k;){const g=Math.floor((w+k)/2);d(b[g])?k=g:w=g+1}return w}e.$ef=S;function f(b,d,c=0,a=b.length){const w=S(b,d,c,a);return w===b.length?-1:w}e.$ff=f;class u{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(u.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!d(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const c=M(this.e,d,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$gf=u;function p(b,d){if(b.length===0)return;let c=b[0];for(let a=1;a<b.length;a++){const w=b[a];d(w,c)>0&&(c=w)}return c}e.$hf=p;function $(b,d){if(b.length===0)return;let c=b[0];for(let a=1;a<b.length;a++){const w=b[a];d(w,c)>=0&&(c=w)}return c}e.$if=$;function v(b,d){return p(b,(c,a)=>-d(c,a))}e.$jf=v;function h(b,d){if(b.length===0)return-1;let c=0;for(let a=1;a<b.length;a++){const w=b[a];d(w,b[c])>0&&(c=a)}return c}e.$kf=h;function y(b,d){for(const c of b){const a=d(c);if(a!==void 0)return a}}e.$lf=y}),define(te[134],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=e.$Ks=e.$Js=e.$Is=void 0;function E(S,f){const u=Math.pow(10,f);return Math.round(S*u)/u}class C{constructor(f,u,p,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=E(Math.max(Math.min(1,$),0),3)}static equals(f,u){return f.r===u.r&&f.g===u.g&&f.b===u.b&&f.a===u.a}}e.$Is=C;class s{constructor(f,u,p,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.l=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,$),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.l===u.l&&f.a===u.a}static fromRGBA(f){const u=f.r/255,p=f.g/255,$=f.b/255,v=f.a,h=Math.max(u,p,$),y=Math.min(u,p,$);let b=0,d=0;const c=(y+h)/2,a=h-y;if(a>0){switch(d=Math.min(c<=.5?a/(2*c):a/(2-2*c),1),h){case u:b=(p-$)/a+(p<$?6:0);break;case p:b=($-u)/a+2;break;case $:b=(u-p)/a+4;break}b*=60,b=Math.round(b)}return new s(b,d,c,v)}static i(f,u,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?f+(u-f)*6*p:p<1/2?u:p<2/3?f+(u-f)*(2/3-p)*6:f}static toRGBA(f){const u=f.h/360,{s:p,l:$,a:v}=f;let h,y,b;if(p===0)h=y=b=$;else{const d=$<.5?$*(1+p):$+p-$*p,c=2*$-d;h=s.i(c,d,u+1/3),y=s.i(c,d,u),b=s.i(c,d,u-1/3)}return new C(Math.round(h*255),Math.round(y*255),Math.round(b*255),v)}}e.$Js=s;class M{constructor(f,u,p,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.v=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,$),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.v===u.v&&f.a===u.a}static fromRGBA(f){const u=f.r/255,p=f.g/255,$=f.b/255,v=Math.max(u,p,$),h=Math.min(u,p,$),y=v-h,b=v===0?0:y/v;let d;return y===0?d=0:v===u?d=((p-$)/y%6+6)%6:v===p?d=($-u)/y+2:d=(u-p)/y+4,new M(Math.round(d*60),b,v,f.a)}static toRGBA(f){const{h:u,s:p,v:$,a:v}=f,h=$*p,y=h*(1-Math.abs(u/60%2-1)),b=$-h;let[d,c,a]=[0,0,0];return u<60?(d=h,c=y):u<120?(d=y,c=h):u<180?(c=h,a=y):u<240?(c=y,a=h):u<300?(d=y,a=h):u<=360&&(d=h,a=y),d=Math.round((d+b)*255),c=Math.round((c+b)*255),a=Math.round((a+b)*255),new C(d,c,a,v)}}e.$Ks=M;class A{static fromHex(f){return A.Format.CSS.parseHex(f)||A.red}static equals(f,u){return!f&&!u?!0:!f||!u?!1:f.equals(u)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof C)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof M)this.j=f,this.rgba=M.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&C.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&M.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=A.k(this.rgba.r),u=A.k(this.rgba.g),p=A.k(this.rgba.b),$=.2126*f+.7152*u+.0722*p;return E($,4)}static k(f){const u=f/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(f){const u=this.getRelativeLuminance(),p=f.getRelativeLuminance();return u>p?(u+.05)/(p+.05):(p+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const u=this.getRelativeLuminance(),p=f.getRelativeLuminance();return u>p}isDarkerThan(f){const u=this.getRelativeLuminance(),p=f.getRelativeLuminance();return u<p}lighten(f){return new A(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new A(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:u,g:p,b:$,a:v}=this.rgba;return new A(new C(u,p,$,v*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const u=f.rgba,p=this.rgba.a,$=u.a,v=p+$*(1-p);if(v<1e-6)return A.transparent;const h=this.rgba.r*p/v+u.r*$*(1-p)/v,y=this.rgba.g*p/v+u.g*$*(1-p)/v,b=this.rgba.b*p/v+u.b*$*(1-p)/v;return new A(new C(h,y,b,v))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:u,g:p,b:$,a:v}=this.rgba;return new A(new C(f.rgba.r-v*(f.rgba.r-u),f.rgba.g-v*(f.rgba.g-p),f.rgba.b-v*(f.rgba.b-$),1))}flatten(...f){const u=f.reduceRight((p,$)=>A.o($,p));return A.o(this,u)}static o(f,u){const p=1-f.rgba.a;return new A(new C(p*u.rgba.r+f.rgba.a*f.rgba.r,p*u.rgba.g+f.rgba.a*f.rgba.g,p*u.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(f,u,p){if(f.isLighterThan(u))return f;p=p||.5;const $=f.getRelativeLuminance(),v=u.getRelativeLuminance();return p=p*(v-$)/v,f.lighten(p)}static getDarkerColor(f,u,p){if(f.isDarkerThan(u))return f;p=p||.5;const $=f.getRelativeLuminance(),v=u.getRelativeLuminance();return p=p*($-v)/$,f.darken(p)}static{this.white=new A(new C(255,255,255,1))}static{this.black=new A(new C(0,0,0,1))}static{this.red=new A(new C(255,0,0,1))}static{this.blue=new A(new C(0,0,255,1))}static{this.green=new A(new C(0,255,0,1))}static{this.cyan=new A(new C(0,255,255,1))}static{this.lightgrey=new A(new C(211,211,211,1))}static{this.transparent=new A(new C(0,0,0,0))}}e.$Ls=A,function(S){let f;(function(u){let p;(function($){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}$.formatRGB=v;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}$.formatRGBA=h;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}$.formatHSL=y;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}$.formatHSLA=b;function d(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function c(t){return`#${d(t.rgba.r)}${d(t.rgba.g)}${d(t.rgba.b)}`}$.formatHex=c;function a(t,l=!1){return l&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${d(t.rgba.r)}${d(t.rgba.g)}${d(t.rgba.b)}${d(Math.round(t.rgba.a*255))}`}$.formatHexA=a;function w(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}$.format=w;function k(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const r=16*g(t.charCodeAt(1))+g(t.charCodeAt(2)),i=16*g(t.charCodeAt(3))+g(t.charCodeAt(4)),n=16*g(t.charCodeAt(5))+g(t.charCodeAt(6));return new S(new C(r,i,n,1))}if(l===9){const r=16*g(t.charCodeAt(1))+g(t.charCodeAt(2)),i=16*g(t.charCodeAt(3))+g(t.charCodeAt(4)),n=16*g(t.charCodeAt(5))+g(t.charCodeAt(6)),o=16*g(t.charCodeAt(7))+g(t.charCodeAt(8));return new S(new C(r,i,n,o/255))}if(l===4){const r=g(t.charCodeAt(1)),i=g(t.charCodeAt(2)),n=g(t.charCodeAt(3));return new S(new C(16*r+r,16*i+i,16*n+n))}if(l===5){const r=g(t.charCodeAt(1)),i=g(t.charCodeAt(2)),n=g(t.charCodeAt(3)),o=g(t.charCodeAt(4));return new S(new C(16*r+r,16*i+i,16*n+n,(16*o+o)/255))}return null}$.parseHex=k;function g(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=u.CSS||(u.CSS={}))})(f=S.Format||(S.Format={}))}(A||(e.$Ls=A={}))}),define(te[55],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=e.$5g=e.$4g=void 0;function E(A){return(S,f,u)=>{let p=null,$=null;if(typeof u.value=="function"?(p="value",$=u.value):typeof u.get=="function"&&(p="get",$=u.get),!$)throw new Error("not supported");u[p]=A($,f)}}function C(A,S,f){let u=null,p=null;if(typeof f.value=="function"?(u="value",p=f.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",p=f.get),!p)throw new Error("not supported");const $=`$memoize$${S}`;f[u]=function(...v){return this.hasOwnProperty($)||Object.defineProperty(this,$,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,v)}),this[$]}}e.$4g=C;function s(A,S,f){return E((u,p)=>{const $=`$debounce$${p}`,v=`$debounce$result$${p}`;return function(...h){this[v]||(this[v]=f?f():void 0),clearTimeout(this[$]),S&&(this[v]=S(this[v],...h),h=[this[v]]),this[$]=setTimeout(()=>{u.apply(this,h),this[v]=f?f():void 0},A)}})}e.$5g=s;function M(A,S,f){return E((u,p)=>{const $=`$throttle$timer$${p}`,v=`$throttle$result$${p}`,h=`$throttle$lastRun$${p}`,y=`$throttle$pending$${p}`;return function(...b){if(this[v]||(this[v]=f?f():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[v]=S(this[v],...b)),this[y])return;const d=this[h]+A;d<=Date.now()?(this[h]=Date.now(),u.apply(this,[this[v]]),this[v]=f?f():void 0):(this[y]=!0,this[$]=setTimeout(()=>{this[y]=!1,this[h]=Date.now(),u.apply(this,[this[v]]),this[v]=f?f():void 0},d-Date.now()))}})}e.$6g=M}),define(te[14],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class E{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?w.isErrorNoTelemetry(t)?new w(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=E,e.$V=new E;function C(g){e.$V.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=C;function s(g){if(!g||typeof g!="object")return!1;const t=g;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=s;function M(g){u(g)||e.$V.onUnexpectedError(g)}e.$Y=M;function A(g){u(g)||e.$V.onUnexpectedExternalError(g)}e.$Z=A;function S(g){if(g instanceof Error){const{name:t,message:l}=g,r=g.stacktrace||g.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:w.isErrorNoTelemetry(g)}}return g}e.$1=S;const f="Canceled";function u(g){return g instanceof p?!0:g instanceof Error&&g.name===f&&g.message===f}e.$2=u;class p extends Error{constructor(){super(f),this.name=this.message}}e.$3=p;function $(){const g=new Error(f);return g.name=g.message,g}e.$4=$;function v(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.$5=v;function h(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.$6=h;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=y;function b(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.$8=b;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=d;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=c;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=a;class w extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof w)return t;const l=new w;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=w;class k extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$ab=k}),define(te[24],ie([0,1,14,133]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.CompareResult=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.top=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=void 0;function s(N,W=0){return N[N.length-(1+W)]}e.$mf=s;function M(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$nf=M;function A(N,W,q=(V,re)=>V===re){if(N===W)return!0;if(!N||!W||N.length!==W.length)return!1;for(let V=0,re=N.length;V<re;V++)if(!q(N[V],W[V]))return!1;return!0}e.$of=A;function S(N,W){const q=N.length-1;W<q&&(N[W]=N[q]),N.pop()}e.$pf=S;function f(N,W,q){return u(N.length,V=>q(N[V],W))}e.$qf=f;function u(N,W){let q=0,V=N-1;for(;q<=V;){const re=(q+V)/2|0,$e=W(re);if($e<0)q=re+1;else if($e>0)V=re-1;else return re}return-(q+1)}e.$rf=u;function p(N,W,q){if(N=N|0,N>=W.length)throw new TypeError("invalid index");const V=W[Math.floor(W.length*Math.random())],re=[],$e=[],de=[];for(const ue of W){const me=q(ue,V);me<0?re.push(ue):me>0?$e.push(ue):de.push(ue)}return N<re.length?p(N,re,q):N<re.length+de.length?de[0]:p(N-(re.length+de.length),$e,q)}e.$sf=p;function $(N,W){const q=[];let V;for(const re of N.slice(0).sort(W))!V||W(V[0],re)!==0?(V=[re],q.push(V)):V.push(re);return q}e.$tf=$;function*v(N,W){let q,V;for(const re of N)V!==void 0&&W(V,re)?q.push(re):(q&&(yield q),q=[re]),V=re;q&&(yield q)}e.$uf=v;function h(N,W){for(let q=0;q<=N.length;q++)W(q===0?void 0:N[q-1],q===N.length?void 0:N[q])}e.$vf=h;function y(N,W,q){const V=[];function re(ue,me,we){if(me===0&&we.length===0)return;const Se=V[V.length-1];Se&&Se.start+Se.deleteCount===ue?(Se.deleteCount+=me,Se.toInsert.push(...we)):V.push({start:ue,deleteCount:me,toInsert:we})}let $e=0,de=0;for(;;){if($e===N.length){re($e,0,W.slice(de));break}if(de===W.length){re($e,N.length-$e,[]);break}const ue=N[$e],me=W[de],we=q(ue,me);we===0?($e+=1,de+=1):we<0?(re($e,1,[]),$e+=1):we>0&&(re($e,0,[me]),de+=1)}return V}e.$wf=y;function b(N,W,q){const V=y(N,W,q),re=[],$e=[];for(const de of V)re.push(...N.slice(de.start,de.start+de.deleteCount)),$e.push(...de.toInsert);return{removed:re,added:$e}}e.$xf=b;function d(N,W,q){if(q===0)return[];const V=N.slice(0,q).sort(W);return a(N,W,V,q,N.length),V}e.top=d;function c(N,W,q,V,re){return q===0?Promise.resolve([]):new Promise(($e,de)=>{(async()=>{const ue=N.length,me=N.slice(0,q).sort(W);for(let we=q,Se=Math.min(q+V,ue);we<ue;we=Se,Se=Math.min(Se+V,ue)){if(we>q&&await new Promise(Oe=>setTimeout(Oe)),re&&re.isCancellationRequested)throw new E.$3;a(N,W,me,we,Se)}return me})().then($e,de)})}e.$zf=c;function a(N,W,q,V,re){for(const $e=q.length;V<re;V++){const de=N[V];if(W(de,q[$e-1])<0){q.pop();const ue=(0,C.$ef)(q,me=>W(de,me)<0);q.splice(ue,0,de)}}}function w(N){return N.filter(W=>!!W)}e.$Af=w;function k(N){let W=0;for(let q=0;q<N.length;q++)N[q]&&(N[W]=N[q],W+=1);N.length=W}e.$Bf=k;function g(N,W,q){N.splice(q,0,N.splice(W,1)[0])}e.$Cf=g;function t(N){return!Array.isArray(N)||N.length===0}e.$Df=t;function l(N){return Array.isArray(N)&&N.length>0}e.$Ef=l;function r(N,W=q=>q){const q=new Set;return N.filter(V=>{const re=W(V);return q.has(re)?!1:(q.add(re),!0)})}e.$Ff=r;function i(N){const W=new Set;return q=>{const V=N(q);return W.has(V)?!1:(W.add(V),!0)}}e.$Gf=i;function n(N,W){return N.length>0?N[0]:W}e.$Hf=n;function o(N,W){return N.length>0?N[N.length-1]:W}e.$If=o;function m(N,W,q=(V,re)=>V===re){let V=0;for(let re=0,$e=Math.min(N.length,W.length);re<$e&&q(N[re],W[re]);re++)V++;return V}e.$Jf=m;function I(N){return[].concat(...N)}e.$Kf=I;function D(N,W){let q=typeof W=="number"?N:0;typeof W=="number"?q=N:(q=0,W=N);const V=[];if(q<=W)for(let re=q;re<W;re++)V.push(re);else for(let re=q;re>W;re--)V.push(re);return V}e.$Lf=D;function P(N,W,q){return N.reduce((V,re)=>(V[W(re)]=q?q(re):re,V),Object.create(null))}e.$Mf=P;function R(N,W){return N.push(W),()=>j(N,W)}e.$Nf=R;function j(N,W){const q=N.indexOf(W);if(q>-1)return N.splice(q,1),W}e.$Of=j;function T(N,W,q){const V=N.slice(0,W),re=N.slice(W);return V.concat(q,re)}e.$Pf=T;function z(N,W){let q;if(typeof W=="number"){let V=W;q=()=>{const re=Math.sin(V++)*179426549;return re-Math.floor(re)}}else q=Math.random;for(let V=N.length-1;V>0;V-=1){const re=Math.floor(q()*(V+1)),$e=N[V];N[V]=N[re],N[re]=$e}}e.$Qf=z;function ne(N,W){const q=N.indexOf(W);q>-1&&(N.splice(q,1),N.unshift(W))}e.$Rf=ne;function ee(N,W){const q=N.indexOf(W);q>-1&&(N.splice(q,1),N.push(W))}e.$Sf=ee;function ce(N,W){for(const q of W)N.push(q)}e.$Tf=ce;function se(N,W){return Array.isArray(N)?N.map(W):W(N)}e.$Uf=se;function ae(N){return Array.isArray(N)?N:[N]}e.$Vf=ae;function J(N){return N[Math.floor(Math.random()*N.length)]}e.$Wf=J;function Y(N,W,q){const V=F(N,W),re=N.length,$e=q.length;N.length=re+$e;for(let de=re-1;de>=V;de--)N[de+$e]=N[de];for(let de=0;de<$e;de++)N[de+V]=q[de]}e.$Xf=Y;function B(N,W,q,V){const re=F(N,W);let $e=N.splice(re,q);return $e===void 0&&($e=[]),Y(N,re,V),$e}e.$Yf=B;function F(N,W){return W<0?Math.max(W+N.length,0):Math.min(W,N.length)}var U;(function(N){function W($e){return $e<0}N.isLessThan=W;function q($e){return $e<=0}N.isLessThanOrEqual=q;function V($e){return $e>0}N.isGreaterThan=V;function re($e){return $e===0}N.isNeitherLessOrGreaterThan=re,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(U||(e.CompareResult=U={}));function H(N,W){return(q,V)=>W(N(q),N(V))}e.$Zf=H;function Q(...N){return(W,q)=>{for(const V of N){const re=V(W,q);if(!U.isNeitherLessOrGreaterThan(re))return re}return U.neitherLessOrGreaterThan}}e.$1f=Q;const x=(N,W)=>N-W;e.$2f=x;const oe=(N,W)=>(0,e.$2f)(N?1:0,W?1:0);e.$3f=oe;function K(N){return(W,q)=>-N(W,q)}e.$4f=K;class O{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let q=this.c;for(;q<this.g.length&&W(this.g[q]);)q++;const V=q===this.c?null:this.g.slice(this.c,q);return this.c=q,V}takeFromEndWhile(W){let q=this.d;for(;q>=0&&W(this.g[q]);)q--;const V=q===this.d?null:this.g.slice(q+1,this.d+1);return this.d=q,V}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const q=this.g.slice(this.c,this.c+W);return this.c+=W,q}}e.$5f=O;class L{static{this.empty=new L(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(q=>(W(q),!0))}toArray(){const W=[];return this.iterate(q=>(W.push(q),!0)),W}filter(W){return new L(q=>this.iterate(V=>W(V)?q(V):!0))}map(W){return new L(q=>this.iterate(V=>q(W(V))))}some(W){let q=!1;return this.iterate(V=>(q=W(V),!q)),q}findFirst(W){let q;return this.iterate(V=>W(V)?(q=V,!1):!0),q}findLast(W){let q;return this.iterate(V=>(W(V)&&(q=V),!0)),q}findLastMaxBy(W){let q,V=!0;return this.iterate(re=>((V||U.isGreaterThan(W(re,q)))&&(V=!1,q=re),!0)),q}}e.$6f=L}),define(te[135],ie([0,1,14]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ab=e.$zb=e.$yb=e.$xb=e.ok=void 0;function C(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=C;function s(f,u="Unreachable"){throw new Error(u)}e.$xb=s;function M(f){if(!f)throw new E.$ab("Assertion Failed")}e.$yb=M;function A(f){if(!f()){debugger;f(),(0,E.$Y)(new E.$ab("Assertion Failed"))}}e.$zb=A;function S(f,u){let p=0;for(;p<f.length-1;){const $=f[p],v=f[p+1];if(!u($,v))return!1;p++}return!0}e.$Ab=S}),define(te[49],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function E(C){const s=this;let M=!1,A;return function(){return M||(M=!0,A=C.apply(s,arguments)),A}}e.$bb=E}),define(te[68],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(C){function s(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}C.is=s;const M=Object.freeze([]);function A(){return M}C.empty=A;function*S(k){yield k}C.single=S;function f(k){return s(k)?k:S(k)}C.wrap=f;function u(k){return k||M}C.from=u;function p(k){return!k||k[Symbol.iterator]().next().done===!0}C.isEmpty=p;function $(k){return k[Symbol.iterator]().next().value}C.first=$;function v(k,g){for(const t of k)if(g(t))return!0;return!1}C.some=v;function h(k,g){for(const t of k)if(g(t))return t}C.find=h;function*y(k,g){for(const t of k)g(t)&&(yield t)}C.filter=y;function*b(k,g){let t=0;for(const l of k)yield g(l,t++)}C.map=b;function*d(...k){for(const g of k)for(const t of g)yield t}C.concat=d;function c(k,g,t){let l=t;for(const r of k)l=g(l,r);return l}C.reduce=c;function*a(k,g,t=k.length){for(g<0&&(g+=k.length),t<0?t+=k.length:t>k.length&&(t=k.length);g<t;g++)yield k[g]}C.slice=a;function w(k,g=Number.POSITIVE_INFINITY){const t=[];if(g===0)return[t,k];const l=k[Symbol.iterator]();for(let r=0;r<g;r++){const i=l.next();if(i.done)return[t,C.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return l}}]}C.consume=w})(E||(e.Iterable=E={}))}),define(te[44],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(t,l=!1){let r=0;const i=t.length;let n="",o=0,m=16,I=0;function D(ee){let ce=0,se=0;for(;ce<ee;){const ae=t.charCodeAt(r);if(ae>=48&&ae<=57)se=se*16+ae-48;else if(ae>=65&&ae<=70)se=se*16+ae-65+10;else if(ae>=97&&ae<=102)se=se*16+ae-97+10;else break;r++,ce++}return ce<ee&&(se=-1),se}function P(ee){r=ee,n="",o=0,m=16,I=0}function R(){const ee=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&u(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&u(t.charCodeAt(r)))for(r++;r<t.length&&u(t.charCodeAt(r));)r++;else return I=3,t.substring(ee,r);let ce=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&u(t.charCodeAt(r))){for(r++;r<t.length&&u(t.charCodeAt(r));)r++;ce=r}else I=3;return t.substring(ee,ce)}function j(){let ee="",ce=r;for(;;){if(r>=i){ee+=t.substring(ce,r),I=2;break}const se=t.charCodeAt(r);if(se===34){ee+=t.substring(ce,r),r++;break}if(se===92){if(ee+=t.substring(ce,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const J=D(4);J>=0?ee+=String.fromCharCode(J):I=4;break}default:I=5}ce=r;continue}if(se>=0&&se<=31)if(f(se)){ee+=t.substring(ce,r),I=2;break}else I=6;r++}return ee}function T(){if(n="",I=0,o=r,r>=i)return o=i,m=17;let ee=t.charCodeAt(r);if(S(ee)){do r++,n+=String.fromCharCode(ee),ee=t.charCodeAt(r);while(S(ee));return m=15}if(f(ee))return r++,n+=String.fromCharCode(ee),ee===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),m=14;switch(ee){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,n=j(),m=10;case 47:{const ce=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(ce,r),m=12}if(t.charCodeAt(r+1)===42){r+=2;const se=i-1;let ae=!1;for(;r<se;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ae=!0;break}r++}return ae||(r++,I=1),n=t.substring(ce,r),m=13}return n+=String.fromCharCode(ee),r++,m=16}case 45:if(n+=String.fromCharCode(ee),r++,r===i||!u(t.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),m=11;default:for(;r<i&&z(ee);)r++,ee=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return n+=String.fromCharCode(ee),r++,m=16}}function z(ee){if(S(ee)||f(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let ee;do ee=T();while(ee>=12&&ee<=15);return ee}return{setPosition:P,getPosition:()=>r,scan:l?ne:T,getToken:()=>m,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>I}}e.$Hm=A;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function $(t,l){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function I(D,P,R,j){o.value=D,o.offset=P,o.length=R,o.type=j,o.colonOffset=void 0,n=o}try{w(t,{onObjectBegin:(D,P)=>{if(l<=D)throw i;n=void 0,m=l>D,r.push("")},onObjectProperty:(D,P,R)=>{if(l<P||(I(D,P,R,"property"),r[r.length-1]=D,l<=P+R))throw i},onObjectEnd:(D,P)=>{if(l<=D)throw i;n=void 0,r.pop()},onArrayBegin:(D,P)=>{if(l<=D)throw i;n=void 0,r.push(0)},onArrayEnd:(D,P)=>{if(l<=D)throw i;n=void 0,r.pop()},onLiteralValue:(D,P,R)=>{if(l<P||(I(D,P,R,g(D)),l<=P+R))throw i},onSeparator:(D,P,R)=>{if(l<=P)throw i;if(D===":"&&n&&n.type==="property")n.colonOffset=P,m=!1,n=void 0;else if(D===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(m=!0,r[r.length-1]=""),n=void 0}}})}catch(D){if(D!==i)throw D}return{path:r,previousNode:n,isAtPropertyKey:m,matches:D=>{let P=0;for(let R=0;P<D.length&&R<r.length;R++)if(D[P]===r[R]||D[P]==="*")P++;else if(D[P]!=="**")return!1;return P===D.length}}}e.$Im=$;function v(t,l=[],r=M.DEFAULT){let i=null,n=[];const o=[];function m(D){Array.isArray(n)?n.push(D):i!==null&&(n[i]=D)}return w(t,{onObjectBegin:()=>{const D={};m(D),o.push(n),n=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const D=[];m(D),o.push(n),n=D,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:m,onError:(D,P,R)=>{l.push({error:D,offset:P,length:R})}},r),n[0]}e.$Jm=v;function h(t,l=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function o(D){return i.children.push(D),D}w(t,{onObjectBegin:D=>{i=o({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,P,R)=>{i=o({type:"property",offset:P,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:P,length:R,parent:i})},onObjectEnd:(D,P)=>{i.length=D+P-i.offset,i=i.parent,n(D+P)},onArrayBegin:(D,P)=>{i=o({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,P)=>{i.length=D+P-i.offset,i=i.parent,n(D+P)},onLiteralValue:(D,P,R)=>{o({type:g(D),offset:P,length:R,parent:i,value:D}),n(P+R)},onSeparator:(D,P,R)=>{i.type==="property"&&(D===":"?i.colonOffset=P:D===","&&n(P))},onError:(D,P,R)=>{l.push({error:D,offset:P,length:R})}},r);const I=i.children[0];return I&&delete I.parent,I}e.$Km=h;function y(t,l){if(!t)return;let r=t;for(const i of l)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Lm=y;function b(t){if(!t.parent||!t.parent.children)return[];const l=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}e.$Mm=b;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const l=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(l[r.children[0].value]=d(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Nm=d;function c(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}e.$Om=c;function a(t,l,r=!1){if(c(t,l,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=l;n++){const o=a(i[n],l,r);if(o)return o}return t}}e.$Pm=a;function w(t,l,r=M.DEFAULT){const i=A(t,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Q){return Q?x=>Q(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const m=n(l.onObjectBegin),I=o(l.onObjectProperty),D=n(l.onObjectEnd),P=n(l.onArrayBegin),R=n(l.onArrayEnd),j=o(l.onLiteralValue),T=o(l.onSeparator),z=n(l.onComment),ne=o(l.onError),ee=r&&r.disallowComments,ce=r&&r.allowTrailingComma;function se(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:ee||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Q){case 12:case 13:ee?ae(10):z();break;case 16:ae(1);break;case 15:case 14:break;default:return Q}}}function ae(Q,x=[],oe=[]){if(ne(Q),x.length+oe.length>0){let K=i.getToken();for(;K!==17;){if(x.indexOf(K)!==-1){se();break}else if(oe.indexOf(K)!==-1)break;K=se()}}}function J(Q){const x=i.getTokenValue();return Q?j(x):I(x),se(),!0}function Y(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(ae(2),Q=0)}catch{ae(2)}j(Q);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return se(),!0}function B(){return i.getToken()!==10?(ae(3,[],[2,5]),!1):(J(!1),i.getToken()===6?(T(":"),se(),H()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function F(){m(),se();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||ae(4,[],[]),T(","),se(),i.getToken()===2&&ce)break}else Q&&ae(6,[],[]);B()||ae(4,[],[2,5]),Q=!0}return D(),i.getToken()!==2?ae(7,[2],[]):se(),!0}function U(){P(),se();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||ae(4,[],[]),T(","),se(),i.getToken()===4&&ce)break}else Q&&ae(6,[],[]);H()||ae(4,[],[4,5]),Q=!0}return R(),i.getToken()!==4?ae(8,[4],[]):se(),!0}function H(){switch(i.getToken()){case 3:return U();case 1:return F();case 10:return J(!0);default:return Y()}}return se(),i.getToken()===17?r.allowEmptyContent?!0:(ae(4,[],[]),!1):H()?(i.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$Qm=w;function k(t,l){const r=A(t),i=[];let n,o=0,m;do switch(m=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:o!==m&&i.push(t.substring(o,m)),l!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,l)),o=r.getPosition();break}while(n!==17);return i.join("")}e.$Rm=k;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Sm=g}),define(te[136],ie([0,1,44]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nS=e.$mS=e.$lS=e.$kS=void 0;function C(u,p,$){let v,h,y,b,d;if(p){for(b=p.offset,d=b+p.length,y=b;y>0&&!f(u,y-1);)y--;let m=d;for(;m<u.length&&!f(u,m);)m++;h=u.substring(y,m),v=A(h,$)}else h=u,v=0,y=0,b=0,d=u.length;const c=S($,u);let a=!1,w=0,k;$.insertSpaces?k=M(" ",$.tabSize||4):k="	";const g=(0,E.$Hm)(h,!1);let t=!1;function l(){return c+M(k,v+w)}function r(){let m=g.scan();for(a=!1;m===15||m===14;)a=a||m===14,m=g.scan();return t=m===16||g.getTokenError()!==0,m}const i=[];function n(m,I,D){!t&&I<d&&D>b&&u.substring(I,D)!==m&&i.push({offset:I,length:D-I,content:m})}let o=r();if(o!==17){const m=g.getTokenOffset()+y,I=M(k,v);n(I,y,m)}for(;o!==17;){let m=g.getTokenOffset()+g.getTokenLength()+y,I=r(),D="";for(;!a&&(I===12||I===13);){const R=g.getTokenOffset()+y;n(" ",m,R),m=g.getTokenOffset()+g.getTokenLength()+y,D=I===12?l():"",I=r()}if(I===2)o!==1&&(w--,D=l());else if(I===4)o!==3&&(w--,D=l());else{switch(o){case 3:case 1:w++,D=l();break;case 5:case 12:D=l();break;case 13:a?D=l():D=" ";break;case 6:D=" ";break;case 10:if(I===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?D=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}a&&(I===12||I===13)&&(D=l())}const P=g.getTokenOffset()+y;n(D,m,P),o=I}return i}e.$kS=C;function s(u,p){const $=JSON.stringify(u,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?$.replace(/\r\n|\r|\n/g,p.eol):$}e.$lS=s;function M(u,p){let $="";for(let v=0;v<p;v++)$+=u;return $}function A(u,p){let $=0,v=0;const h=p.tabSize||4;for(;$<u.length;){const y=u.charAt($);if(y===" ")v++;else if(y==="	")v+=h;else break;$++}return Math.floor(v/h)}function S(u,p){for(let $=0;$<p.length;$++){const v=p.charAt($);if(v==="\r")return $+1<p.length&&p.charAt($+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return u&&u.eol||`
`}e.$mS=S;function f(u,p){return`\r
`.indexOf(u.charAt(p))!==-1}e.$nS=f}),define(te[137],ie([0,1,44,136]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sS=e.$rS=e.$qS=e.$pS=e.$oS=void 0;function s(u,p,$){return M(u,p,void 0,$)}e.$oS=s;function M(u,p,$,v,h){const y=p.slice(),b=[],d=(0,E.$Km)(u,b);let c,a;for(;y.length>0&&(a=y.pop(),c=(0,E.$Lm)(d,y),c===void 0&&$!==void 0);)typeof a=="string"?$={[a]:$}:$=[$];if(c)if(c.type==="object"&&typeof a=="string"&&Array.isArray(c.children)){const w=(0,E.$Lm)(c,[a]);if(w!==void 0)if($===void 0){if(!w.parent)throw new Error("Malformed AST");const k=c.children.indexOf(w.parent);let g,t=w.parent.offset+w.parent.length;if(k>0){const l=c.children[k-1];g=l.offset+l.length}else g=c.offset+1,c.children.length>1&&(t=c.children[1].offset);return A(u,{offset:g,length:t-g,content:""},v)}else return A(u,{offset:w.offset,length:w.length,content:JSON.stringify($)},v);else{if($===void 0)return[];const k=`${JSON.stringify(a)}: ${JSON.stringify($)}`,g=h?h(c.children.map(l=>l.children[0].value)):c.children.length;let t;if(g>0){const l=c.children[g-1];t={offset:l.offset+l.length,length:0,content:","+k}}else c.children.length===0?t={offset:c.offset+1,length:0,content:k}:t={offset:c.offset+1,length:0,content:k+","};return A(u,t,v)}}else if(c.type==="array"&&typeof a=="number"&&Array.isArray(c.children))if($!==void 0){const w=`${JSON.stringify($)}`;let k;if(c.children.length===0||a===0)k={offset:c.offset+1,length:0,content:c.children.length===0?w:w+","};else{const g=a===-1||a>c.children.length?c.children.length:a,t=c.children[g-1];k={offset:t.offset+t.length,length:0,content:","+w}}return A(u,k,v)}else{const w=a,k=c.children[w];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===w){const t=c.children[w-1],l=t.offset+t.length,r=c.offset+c.length;g={offset:l,length:r-2-l,content:""}}else g={offset:k.offset,length:c.children[w+1].offset-k.offset,content:""};return A(u,g,v)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${c.type}`);else{if($===void 0)throw new Error("Can not delete in empty document");return A(u,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify($)},v)}}e.$pS=M;function A(u,p,$){let v=S(u,p),h=p.offset,y=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;h>0&&!(0,C.$nS)(v,h-1);)h--;for(;y<v.length&&!(0,C.$nS)(v,y);)y++}const b=(0,C.$kS)(v,{offset:h,length:y-h},$);for(let c=b.length-1;c>=0;c--){const a=b[c];v=S(v,a),h=Math.min(h,a.offset),y=Math.max(y,a.offset+a.length),y+=a.content.length-a.length}const d=u.length-(v.length-y)-h;return[{offset:h,length:d,content:v.substring(h,y)}]}e.$qS=A;function S(u,p){return u.substring(0,p.offset)+p.content+u.substring(p.offset+p.length)}e.$rS=S;function f(u,p){const $=p.slice(0).sort((h,y)=>{const b=h.offset-y.offset;return b===0?h.length-y.length:b});let v=u.length;for(let h=$.length-1;h>=0;h--){const y=$[h];if(y.offset+y.length<=v)u=S(u,y);else throw new Error("Overlapping edit");v=y.offset}return u}e.$sS=f}),define(te[84],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class E{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=E}),define(te[2],ie([0,1,49,68]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=e.$cb=void 0;const s=!1;let M=null;function A(o){M=o}if(e.$cb=A,s){const o="__is_disposable_tracked__";A(new class{trackDisposable(m){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[o]||console.log(I)},3e3)}setParent(m,I){if(m&&m!==a.None)try{m[o]=!0}catch{}}markAsDisposed(m){if(m&&m!==a.None)try{m[o]=!0}catch{}}markAsSingleton(m){}})}function S(o){return M?.trackDisposable(o),o}e.$db=S;function f(o){M?.markAsDisposed(o)}e.$eb=f;function u(o,m){M?.setParent(o,m)}function p(o,m){if(M)for(const I of o)M.setParent(I,m)}function $(o){return M?.markAsSingleton(o),o}e.$fb=$;function v(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.$gb=v;function h(o){if(C.Iterable.is(o)){const m=[];for(const I of o)if(I)try{I.dispose()}catch(D){m.push(D)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.$hb=h;function y(o){for(const m of o)v(m)&&m.dispose();return[]}e.$ib=y;function b(...o){const m=d(()=>h(o));return p(o,m),m}e.$jb=b;function d(o){const m=S({dispose:(0,E.$bb)(()=>{f(m),o()})});return m}e.$kb=d;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return u(m,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}}e.$lb=c;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,S(this),u(this.q,this)}dispose(){f(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}e.$mb=a;class w{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&u(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&u(m,null),m}}e.$nb=w;class k{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$ob=k;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(m){let I=m;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,f(this))},this}}e.$pb=g;class t{constructor(){this.a=new Map}acquire(m,...I){let D=this.a.get(m);D||(D={counter:0,object:this.b(m,...I)},this.a.set(m,D));const{object:P}=D,R=(0,E.$bb)(()=>{--D.counter===0&&(this.c(m,D.object),this.a.delete(m))});return D.counter++,{object:P,dispose:R}}}e.$qb=t;class l{constructor(m){this.a=m}async acquire(m,...I){const D=this.a.acquire(m,...I);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(P){throw D.dispose(),P}}}e.$rb=l;class r{constructor(m){this.object=m}dispose(){}}e.$sb=r;function i(o){const m=new c;try{o(m)}finally{m.dispose()}}e.$tb=i;class n{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get size(){return this.a.size}get(m){return this.a.get(m)}set(m,I,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(m)?.dispose(),this.a.set(m,I)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$ub=n}),define(te[101],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vb=void 0;class E{static{this.Undefined=new E(void 0)}constructor(M){this.element=M,this.next=E.Undefined,this.prev=E.Undefined}}class C{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let M=this.a;for(;M!==E.Undefined;){const A=M.next;M.prev=E.Undefined,M.next=E.Undefined,M=A}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const S=new E(M);if(this.a===E.Undefined)this.a=S,this.b=S;else if(A){const u=this.b;this.b=S,S.prev=u,u.next=S}else{const u=this.a;this.a=S,S.next=u,u.prev=S}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(S))}}shift(){if(this.a!==E.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==E.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==E.Undefined&&M.next!==E.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===E.Undefined&&M.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):M.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):M.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==E.Undefined;)yield M.element,M=M.next}}e.$vb=C}),define(te[34],ie([0,1]),function(G,e){"use strict";var E,C,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.Touch=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;function M(d,c,a){let w=d.get(c);return w===void 0&&(w=a,d.set(c,w)),w}e.$ui=M;function A(d){const c=[];return d.forEach((a,w)=>{c.push(`${w} => ${a}`)}),`Map(${d.size}) {${c.join(", ")}}`}e.$vi=A;function S(d){const c=[];return d.forEach(a=>{c.push(a)}),`Set(${d.size}) {${c.join(", ")}}`}e.$wi=S;class f{constructor(c,a){this.uri=c,this.value=a}}class u{static{this.a=c=>c.toString()}constructor(c,a){this[E]="ResourceMap",c instanceof u?(this.b=new Map(c.b),this.c=a??u.a):(this.b=new Map,this.c=c??u.a)}set(c,a){return this.b.set(this.c(c),new f(c,a)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,a){typeof a<"u"&&(c=c.bind(a));for(const[w,k]of this.b)c(k.value,k.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$xi=u;class p{constructor(c,a){this[C]="ResourceSet",!c||typeof c=="function"?this.a=new u(c):(this.a=new u(a),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,a){this.a.forEach((w,k)=>c.call(a,k,k,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$yi=p;var $;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})($||(e.Touch=$={}));class v{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,a=0){const w=this.a.get(c);if(w)return a!==0&&this.j(w,a),w.value}set(c,a,w=0){let k=this.a.get(c);if(k)k.value=a,w!==0&&this.j(k,w);else{switch(k={key:c,value:a,next:void 0,previous:void 0},w){case 0:this.h(k);break;case 1:this.g(k);break;case 2:this.h(k);break;default:this.h(k);break}this.a.set(c,k),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const a=this.a.get(c);if(a)return this.a.delete(c),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,a){const w=this.e;let k=this.b;for(;k;){if(a?c.bind(a)(k.value,k.key,this):c(k.value,k.key,this),this.e!==w)throw new Error("LinkedMap got modified during iteration.");k=k.next}}keys(){const c=this,a=this.e;let w=this.b;const k={[Symbol.iterator](){return k},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const g={value:w.key,done:!1};return w=w.next,g}else return{value:void 0,done:!0}}};return k}values(){const c=this,a=this.e;let w=this.b;const k={[Symbol.iterator](){return k},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const g={value:w.value,done:!1};return w=w.next,g}else return{value:void 0,done:!0}}};return k}entries(){const c=this,a=this.e;let w=this.b;const k={[Symbol.iterator](){return k},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const g={value:[w.key,w.value],done:!1};return w=w.next,g}else return{value:void 0,done:!0}}};return k}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let a=this.b,w=this.size;for(;a&&w>c;)this.a.delete(a.key),a=a.next,w--;this.b=a,this.d=w,a&&(a.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const a=c.next,w=c.previous;if(!a||!w)throw new Error("Invalid list");a.previous=w,w.next=a}c.next=void 0,c.previous=void 0,this.e++}j(c,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(c===this.b)return;const w=c.next,k=c.previous;c===this.c?(k.next=void 0,this.c=k):(w.previous=k,k.next=w),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(a===2){if(c===this.c)return;const w=c.next,k=c.previous;c===this.b?(w.previous=void 0,this.b=w):(w.previous=k,k.next=w),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((a,w)=>{c.push([w,a])}),c}fromJSON(c){this.clear();for(const[a,w]of c)this.set(a,w)}}e.$zi=v;class h extends v{constructor(c,a=1){super(),this.k=c,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,a=2){return super.get(c,a)}peek(c){return super.get(c,0)}set(c,a){return super.set(c,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ai=h;class y{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let a=this.a.get(c)||0;return a===0?!1:(a--,a===0?this.a.delete(c):this.a.set(c,a),!0)}has(c){return this.a.has(c)}}e.$Bi=y;class b{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[a,w]of c)this.set(a,w)}clear(){this.a.clear(),this.b.clear()}set(c,a){this.a.set(c,a),this.b.set(a,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const a=this.a.get(c);return a===void 0?!1:(this.a.delete(c),this.b.delete(a),!0)}forEach(c,a){this.a.forEach((w,k)=>{c.call(a,w,k,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ci=b}),define(te[85],ie([0,1,34]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=void 0;const C=new E.$Ai(1e4);function s(u){return f(u,"NFC",C)}e.$fl=s;const M=new E.$Ai(1e4);function A(u){return f(u,"NFD",M)}e.$gl=A;const S=/[^\u0000-\u0080]/;function f(u,p,$){if(!u)return u;const v=$.get(u);if(v)return v;let h;return S.test(u)?h=u.normalize(p):h=u,$.set(u,h),h}e.$hl=function(){const u=/[\u0300-\u036f]/g;return function(p){return A(p).replace(u,"")}}()}),define(te[138],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.rot=e.$Fl=void 0;function E(S,f,u){return Math.min(Math.max(S,f),u)}e.$Fl=E;function C(S,f){return(f+S%f)%f}e.rot=C;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Hl=s;class M{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Il=M;class A{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const u=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jl=A}),function(){function G(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function A(f){M.push(f,Date.now())}function S(){const f=[];for(let u=0;u<M.length;u+=2)f.push({name:M[u],startTime:M[u+1]});return f}return{mark:A,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(s+A.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function E(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=E(C))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var C in E)(typeof exports=="object"?exports:G)[C]=E[C]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function E(C){if(e[C])return e[C].exports;var s=e[C]={i:C,l:!1,exports:{}};return G[C].call(s.exports,s,s.exports,E),s.l=!0,s.exports}return E.m=G,E.c=e,E.d=function(C,s,M){E.o(C,s)||Object.defineProperty(C,s,{enumerable:!0,get:M})},E.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},E.t=function(C,s){if(1&s&&(C=E(C)),8&s||4&s&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&s&&typeof C!="string")for(var A in C)E.d(M,A,function(S){return C[S]}.bind(null,A));return M},E.n=function(C){var s=C&&C.__esModule?function(){return C.default}:function(){return C};return E.d(s,"a",s),s},E.o=function(C,s){return Object.prototype.hasOwnProperty.call(C,s)},E.p="",E(E.s=0)}([function(G,e,E){(function(C){var s;e=G.exports=oe,s=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],f=e.src=[],u=0,p=u++;f[p]="0|[1-9]\\d*";var $=u++;f[$]="[0-9]+";var v=u++;f[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=u++;f[h]="("+f[p]+")\\.("+f[p]+")\\.("+f[p]+")";var y=u++;f[y]="("+f[$]+")\\.("+f[$]+")\\.("+f[$]+")";var b=u++;f[b]="(?:"+f[p]+"|"+f[v]+")";var d=u++;f[d]="(?:"+f[$]+"|"+f[v]+")";var c=u++;f[c]="(?:-("+f[b]+"(?:\\."+f[b]+")*))";var a=u++;f[a]="(?:-?("+f[d]+"(?:\\."+f[d]+")*))";var w=u++;f[w]="[0-9A-Za-z-]+";var k=u++;f[k]="(?:\\+("+f[w]+"(?:\\."+f[w]+")*))";var g=u++,t="v?"+f[h]+f[c]+"?"+f[k]+"?";f[g]="^"+t+"$";var l="[v=\\s]*"+f[y]+f[a]+"?"+f[k]+"?",r=u++;f[r]="^"+l+"$";var i=u++;f[i]="((?:<|>)?=?)";var n=u++;f[n]=f[$]+"|x|X|\\*";var o=u++;f[o]=f[p]+"|x|X|\\*";var m=u++;f[m]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[c]+")?"+f[k]+"?)?)?";var I=u++;f[I]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[a]+")?"+f[k]+"?)?)?";var D=u++;f[D]="^"+f[i]+"\\s*"+f[m]+"$";var P=u++;f[P]="^"+f[i]+"\\s*"+f[I]+"$";var R=u++;f[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=u++;f[j]="(?:~>?)";var T=u++;f[T]="(\\s*)"+f[j]+"\\s+",S[T]=new RegExp(f[T],"g");var z=u++;f[z]="^"+f[j]+f[m]+"$";var ne=u++;f[ne]="^"+f[j]+f[I]+"$";var ee=u++;f[ee]="(?:\\^)";var ce=u++;f[ce]="(\\s*)"+f[ee]+"\\s+",S[ce]=new RegExp(f[ce],"g");var se=u++;f[se]="^"+f[ee]+f[m]+"$";var ae=u++;f[ae]="^"+f[ee]+f[I]+"$";var J=u++;f[J]="^"+f[i]+"\\s*("+l+")$|^$";var Y=u++;f[Y]="^"+f[i]+"\\s*("+t+")$|^$";var B=u++;f[B]="(\\s*)"+f[i]+"\\s*("+l+"|"+f[m]+")",S[B]=new RegExp(f[B],"g");var F=u++;f[F]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var U=u++;f[U]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var H=u++;f[H]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)s(Q,f[Q]),S[Q]||(S[Q]=new RegExp(f[Q]));function x(X,le){if(X instanceof oe)return X;if(typeof X!="string"||X.length>M||!(le?S[r]:S[g]).test(X))return null;try{return new oe(X,le)}catch{return null}}function oe(X,le){if(X instanceof oe){if(X.loose===le)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof oe))return new oe(X,le);s("SemVer",X,le),this.loose=le;var fe=X.trim().match(le?S[r]:S[g]);if(!fe)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Re=+Ee;if(Re>=0&&Re<A)return Re}return Ee}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=x,e.valid=function(X,le){var fe=x(X,le);return fe?fe.version:null},e.clean=function(X,le){var fe=x(X.trim().replace(/^[=v]+/,""),le);return fe?fe.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(X){return s("SemVer.compare",this.version,this.loose,X),X instanceof oe||(X=new oe(X,this.loose)),this.compareMain(X)||this.comparePre(X)},oe.prototype.compareMain=function(X){return X instanceof oe||(X=new oe(X,this.loose)),O(this.major,X.major)||O(this.minor,X.minor)||O(this.patch,X.patch)},oe.prototype.comparePre=function(X){if(X instanceof oe||(X=new oe(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var le=0;do{var fe=this.prerelease[le],Ee=X.prerelease[le];if(s("prerelease compare",le,fe,Ee),fe===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ee)return O(fe,Ee)}while(++le)},oe.prototype.inc=function(X,le){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,le,fe,Ee){typeof fe=="string"&&(Ee=fe,fe=void 0);try{return new oe(X,fe).inc(le,Ee).version}catch{return null}},e.diff=function(X,le){if(q(X,le))return null;var fe=x(X),Ee=x(le);if(fe.prerelease.length||Ee.prerelease.length){for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==Ee[Re])return"pre"+Re;return"prerelease"}for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==Ee[Re])return Re},e.compareIdentifiers=O;var K=/^[0-9]+$/;function O(X,le){var fe=K.test(X),Ee=K.test(le);return fe&&Ee&&(X=+X,le=+le),fe&&!Ee?-1:Ee&&!fe?1:X<le?-1:X>le?1:0}function L(X,le,fe){return new oe(X,fe).compare(new oe(le,fe))}function N(X,le,fe){return L(X,le,fe)>0}function W(X,le,fe){return L(X,le,fe)<0}function q(X,le,fe){return L(X,le,fe)===0}function V(X,le,fe){return L(X,le,fe)!==0}function re(X,le,fe){return L(X,le,fe)>=0}function $e(X,le,fe){return L(X,le,fe)<=0}function de(X,le,fe,Ee){var Re;switch(le){case"===":typeof X=="object"&&(X=X.version),typeof fe=="object"&&(fe=fe.version),Re=X===fe;break;case"!==":typeof X=="object"&&(X=X.version),typeof fe=="object"&&(fe=fe.version),Re=X!==fe;break;case"":case"=":case"==":Re=q(X,fe,Ee);break;case"!=":Re=V(X,fe,Ee);break;case">":Re=N(X,fe,Ee);break;case">=":Re=re(X,fe,Ee);break;case"<":Re=W(X,fe,Ee);break;case"<=":Re=$e(X,fe,Ee);break;default:throw new TypeError("Invalid operator: "+le)}return Re}function ue(X,le){if(X instanceof ue){if(X.loose===le)return X;X=X.value}if(!(this instanceof ue))return new ue(X,le);s("comparator",X,le),this.loose=le,this.parse(X),this.semver===me?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(X,le){return O(le,X)},e.major=function(X,le){return new oe(X,le).major},e.minor=function(X,le){return new oe(X,le).minor},e.patch=function(X,le){return new oe(X,le).patch},e.compare=L,e.compareLoose=function(X,le){return L(X,le,!0)},e.rcompare=function(X,le,fe){return L(le,X,fe)},e.sort=function(X,le){return X.sort(function(fe,Ee){return e.compare(fe,Ee,le)})},e.rsort=function(X,le){return X.sort(function(fe,Ee){return e.rcompare(fe,Ee,le)})},e.gt=N,e.lt=W,e.eq=q,e.neq=V,e.gte=re,e.lte=$e,e.cmp=de,e.Comparator=ue;var me={};function we(X,le){if(X instanceof we)return X.loose===le?X:new we(X.raw,le);if(X instanceof ue)return new we(X.value,le);if(!(this instanceof we))return new we(X,le);if(this.loose=le,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Se(X){return!X||X.toLowerCase()==="x"||X==="*"}function Oe(X,le,fe,Ee,Re,Ne,Ce,ze,We,Z,he,ge,ye){return((le=Se(fe)?"":Se(Ee)?">="+fe+".0.0":Se(Re)?">="+fe+"."+Ee+".0":">="+le)+" "+(ze=Se(We)?"":Se(Z)?"<"+(+We+1)+".0.0":Se(he)?"<"+We+"."+(+Z+1)+".0":ge?"<="+We+"."+Z+"."+he+"-"+ge:"<="+ze)).trim()}function Le(X,le){for(var fe=0;fe<X.length;fe++)if(!X[fe].test(le))return!1;if(le.prerelease.length){for(fe=0;fe<X.length;fe++)if(s(X[fe].semver),X[fe].semver!==me&&X[fe].semver.prerelease.length>0){var Ee=X[fe].semver;if(Ee.major===le.major&&Ee.minor===le.minor&&Ee.patch===le.patch)return!0}return!1}return!0}function ve(X,le,fe){try{le=new we(le,fe)}catch{return!1}return le.test(X)}function pe(X,le,fe,Ee){var Re,Ne,Ce,ze,We;switch(X=new oe(X,Ee),le=new we(le,Ee),fe){case">":Re=N,Ne=$e,Ce=W,ze=">",We=">=";break;case"<":Re=W,Ne=re,Ce=N,ze="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(X,le,Ee))return!1;for(var Z=0;Z<le.set.length;++Z){var he=le.set[Z],ge=null,ye=null;if(he.forEach(function(De){De.semver===me&&(De=new ue(">=0.0.0")),ge=ge||De,ye=ye||De,Re(De.semver,ge.semver,Ee)?ge=De:Ce(De.semver,ye.semver,Ee)&&(ye=De)}),ge.operator===ze||ge.operator===We||(!ye.operator||ye.operator===ze)&&Ne(X,ye.semver)||ye.operator===We&&Ce(X,ye.semver))return!1}return!0}ue.prototype.parse=function(X){var le=this.loose?S[J]:S[Y],fe=X.match(le);if(!fe)throw new TypeError("Invalid comparator: "+X);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new oe(fe[2],this.loose):this.semver=me},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(X){return s("Comparator.test",X,this.loose),this.semver===me||(typeof X=="string"&&(X=new oe(X,this.loose)),de(X,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(X,le){if(!(X instanceof ue))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(X.value,le),ve(this.value,fe,le);if(X.operator==="")return fe=new we(this.value,le),ve(X.semver,fe,le);var Ee=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Ne=this.semver.version===X.semver.version,Ce=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ze=de(this.semver,"<",X.semver,le)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),We=de(this.semver,">",X.semver,le)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Ee||Re||Ne&&Ce||ze||We},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(X){var le=this.loose;X=X.trim(),s("range",X,le);var fe=le?S[U]:S[F];X=X.replace(fe,Oe),s("hyphen replace",X),X=X.replace(S[B],"$1$2$3"),s("comparator trim",X,S[B]),X=(X=(X=X.replace(S[T],"$1~")).replace(S[ce],"$1^")).split(/\s+/).join(" ");var Ee=le?S[J]:S[Y],Re=X.split(" ").map(function(Ne){return function(Ce,ze){return s("comp",Ce),Ce=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function(ge,ye){s("caret",ge,ye);var De=ye?S[ae]:S[se];return ge.replace(De,function(Fe,Me,Te,Be,qe){var He;return s("caret",ge,Fe,Me,Te,Be,qe),Se(Me)?He="":Se(Te)?He=">="+Me+".0.0 <"+(+Me+1)+".0.0":Se(Be)?He=Me==="0"?">="+Me+"."+Te+".0 <"+Me+"."+(+Te+1)+".0":">="+Me+"."+Te+".0 <"+(+Me+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=Me==="0"?Te==="0"?">="+Me+"."+Te+"."+Be+qe+" <"+Me+"."+Te+"."+(+Be+1):">="+Me+"."+Te+"."+Be+qe+" <"+Me+"."+(+Te+1)+".0":">="+Me+"."+Te+"."+Be+qe+" <"+(+Me+1)+".0.0"):(s("no pr"),He=Me==="0"?Te==="0"?">="+Me+"."+Te+"."+Be+" <"+Me+"."+Te+"."+(+Be+1):">="+Me+"."+Te+"."+Be+" <"+Me+"."+(+Te+1)+".0":">="+Me+"."+Te+"."+Be+" <"+(+Me+1)+".0.0"),s("caret return",He),He})}(he,Z)}).join(" ")}(Ce,ze),s("caret",Ce),Ce=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function(ge,ye){var De=ye?S[ne]:S[z];return ge.replace(De,function(Fe,Me,Te,Be,qe){var He;return s("tilde",ge,Fe,Me,Te,Be,qe),Se(Me)?He="":Se(Te)?He=">="+Me+".0.0 <"+(+Me+1)+".0.0":Se(Be)?He=">="+Me+"."+Te+".0 <"+Me+"."+(+Te+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=">="+Me+"."+Te+"."+Be+qe+" <"+Me+"."+(+Te+1)+".0"):He=">="+Me+"."+Te+"."+Be+" <"+Me+"."+(+Te+1)+".0",s("tilde return",He),He})}(he,Z)}).join(" ")}(Ce,ze),s("tildes",Ce),Ce=function(We,Z){return s("replaceXRanges",We,Z),We.split(/\s+/).map(function(he){return function(ge,ye){ge=ge.trim();var De=ye?S[P]:S[D];return ge.replace(De,function(Fe,Me,Te,Be,qe,He){s("xRange",ge,Fe,Me,Te,Be,qe,He);var xe=Se(Te),Qe=xe||Se(Be),tt=Qe||Se(qe);return Me==="="&&tt&&(Me=""),xe?Fe=Me===">"||Me==="<"?"<0.0.0":"*":Me&&tt?(Qe&&(Be=0),tt&&(qe=0),Me===">"?(Me=">=",Qe?(Te=+Te+1,Be=0,qe=0):tt&&(Be=+Be+1,qe=0)):Me==="<="&&(Me="<",Qe?Te=+Te+1:Be=+Be+1),Fe=Me+Te+"."+Be+"."+qe):Qe?Fe=">="+Te+".0.0 <"+(+Te+1)+".0.0":tt&&(Fe=">="+Te+"."+Be+".0 <"+Te+"."+(+Be+1)+".0"),s("xRange return",Fe),Fe})}(he,Z)}).join(" ")}(Ce,ze),s("xrange",Ce),Ce=function(We,Z){return s("replaceStars",We,Z),We.trim().replace(S[H],"")}(Ce,ze),s("stars",Ce),Ce}(Ne,le)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ne){return!!Ne.match(Ee)})),Re=Re.map(function(Ne){return new ue(Ne,le)})},we.prototype.intersects=function(X,le){if(!(X instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ee){return X.set.some(function(Re){return Re.every(function(Ne){return Ee.intersects(Ne,le)})})})})},e.toComparators=function(X,le){return new we(X,le).set.map(function(fe){return fe.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},we.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new oe(X,this.loose));for(var le=0;le<this.set.length;le++)if(Le(this.set[le],X))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(X,le,fe){var Ee=null,Re=null;try{var Ne=new we(le,fe)}catch{return null}return X.forEach(function(Ce){Ne.test(Ce)&&(Ee&&Re.compare(Ce)!==-1||(Re=new oe(Ee=Ce,fe)))}),Ee},e.minSatisfying=function(X,le,fe){var Ee=null,Re=null;try{var Ne=new we(le,fe)}catch{return null}return X.forEach(function(Ce){Ne.test(Ce)&&(Ee&&Re.compare(Ce)!==1||(Re=new oe(Ee=Ce,fe)))}),Ee},e.validRange=function(X,le){try{return new we(X,le).range||"*"}catch{return null}},e.ltr=function(X,le,fe){return pe(X,le,"<",fe)},e.gtr=function(X,le,fe){return pe(X,le,">",fe)},e.outside=pe,e.prerelease=function(X,le){var fe=x(X,le);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(X,le,fe){return X=new we(X,fe),le=new we(le,fe),X.intersects(le)},e.coerce=function(X){if(X instanceof oe)return X;if(typeof X!="string")return null;var le=X.match(S[R]);return le==null?null:x((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,E(1))},function(G,e){var E,C,s=G.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function S(d){if(E===setTimeout)return setTimeout(d,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(d,0);try{return E(d,0)}catch{try{return E.call(null,d,0)}catch{return E.call(this,d,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{C=typeof clearTimeout=="function"?clearTimeout:A}catch{C=A}})();var f,u=[],p=!1,$=-1;function v(){p&&f&&(p=!1,f.length?u=f.concat(u):$=-1,u.length&&h())}function h(){if(!p){var d=S(v);p=!0;for(var c=u.length;c;){for(f=u,u=[];++$<c;)f&&f[$].run();$=-1,c=u.length}f=null,p=!1,function(a){if(C===clearTimeout)return clearTimeout(a);if((C===A||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(a);try{C(a)}catch{try{return C.call(null,a)}catch{return C.call(this,a)}}}(d)}}function y(d,c){this.fun=d,this.array=c}function b(){}s.nextTick=function(d){var c=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)c[a-1]=arguments[a];u.push(new y(d,c)),u.length!==1||p||S(h)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=b,s.addListener=b,s.once=b,s.off=b,s.removeListener=b,s.removeAllListeners=b,s.emit=b,s.prependListener=b,s.prependOnceListener=b,s.listeners=function(d){return[]},s.binding=function(d){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(d){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(G,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class C{constructor(S,f,u){this.level=S,this.key=f,this.value=u,this.forward=[]}}const s=void 0;class M{constructor(S,f=2**16){this.comparator=S,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new C(this.c,s,s)}get size(){return this.f}clear(){this.e=new C(this.c,s,s)}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,f){return M.h(this,S,f,this.comparator)&&(this.f+=1),this}delete(S){const f=M.k(this,S,this.comparator);return f&&(this.f-=1),f}forEach(S,f){let u=this.e.forward[0];for(;u;)S.call(f,u.value,u.key,this),u=u.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",f=this.e.forward[0];for(;f;)S+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return S}static g(S,f,u){let p=S.e;for(let $=S.d-1;$>=0;$--)for(;p.forward[$]&&u(p.forward[$].key,f)<0;)p=p.forward[$];if(p=p.forward[0],p&&u(p.key,f)===0)return p}static h(S,f,u,p){const $=[];let v=S.e;for(let h=S.d-1;h>=0;h--){for(;v.forward[h]&&p(v.forward[h].key,f)<0;)v=v.forward[h];$[h]=v}if(v=v.forward[0],v&&p(v.key,f)===0)return v.value=u,!1;{const h=M.j(S);if(h>S.d){for(let y=S.d;y<h;y++)$[y]=S.e;S.d=h}v=new C(h,f,u);for(let y=0;y<h;y++)v.forward[y]=$[y].forward[y],$[y].forward[y]=v;return!0}}static j(S,f=.5){let u=1;for(;Math.random()<f&&u<S.c;)u+=1;return u}static k(S,f,u){const p=[];let $=S.e;for(let v=S.d-1;v>=0;v--){for(;$.forward[v]&&u($.forward[v].key,f)<0;)$=$.forward[v];p[v]=$}if($=$.forward[0],!$||u($.key,f)!==0)return!1;for(let v=0;v<S.d&&p[v].forward[v]===$;v++)p[v].forward[v]=$.forward[v];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$lr=M}),define(te[69],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(M){return new C(M)}constructor(M){this.c=E&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$dc=C}),define(te[3],ie([0,1,14,49,2,101,69]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.Event=void 0;const S=!1,f=!1;var u;(function(D){D.None=()=>s.$mb.None;function P(de){if(f){const{onDidAddListener:ue}=de,me=y.create();let we=0;de.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),ue?.()}}}function R(de,ue){return Y(de,()=>{},0,void 0,!0,void 0,ue)}D.defer=R;function j(de){return(ue,me=null,we)=>{let Se=!1,Oe;return Oe=de(Le=>{if(!Se)return Oe?Oe.dispose():Se=!0,ue.call(me,Le)},null,we),Se&&Oe.dispose(),Oe}}D.once=j;function T(de,ue,me){return ae((we,Se=null,Oe)=>de(Le=>we.call(Se,ue(Le)),null,Oe),me)}D.map=T;function z(de,ue,me){return ae((we,Se=null,Oe)=>de(Le=>{ue(Le),we.call(Se,Le)},null,Oe),me)}D.forEach=z;function ne(de,ue,me){return ae((we,Se=null,Oe)=>de(Le=>ue(Le)&&we.call(Se,Le),null,Oe),me)}D.filter=ne;function ee(de){return de}D.signal=ee;function ce(...de){return(ue,me=null,we)=>{const Se=(0,s.$jb)(...de.map(Oe=>Oe(Le=>ue.call(me,Le))));return J(Se,we)}}D.any=ce;function se(de,ue,me,we){let Se=me;return T(de,Oe=>(Se=ue(Se,Oe),Se),we)}D.reduce=se;function ae(de,ue){let me;const we={onWillAddFirstListener(){me=de(Se.fire,Se)},onDidRemoveLastListener(){me?.dispose()}};ue||P(we);const Se=new w(we);return ue?.add(Se),Se.event}function J(de,ue){return ue instanceof Array?ue.push(de):ue&&ue.add(de),de}function Y(de,ue,me=100,we=!1,Se=!1,Oe,Le){let ve,pe,X,le=0,fe;const Ee={leakWarningThreshold:Oe,onWillAddFirstListener(){ve=de(Ne=>{le++,pe=ue(pe,Ne),we&&!X&&(Re.fire(pe),pe=void 0),fe=()=>{const Ce=pe;pe=void 0,X=void 0,(!we||le>1)&&Re.fire(Ce),le=0},typeof me=="number"?(clearTimeout(X),X=setTimeout(fe,me)):X===void 0&&(X=0,queueMicrotask(fe))})},onWillRemoveListener(){Se&&le>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,ve.dispose()}};Le||P(Ee);const Re=new w(Ee);return Le?.add(Re),Re.event}D.debounce=Y;function B(de,ue=0,me){return D.debounce(de,(we,Se)=>we?(we.push(Se),we):[Se],ue,void 0,!0,void 0,me)}D.accumulate=B;function F(de,ue=(we,Se)=>we===Se,me){let we=!0,Se;return ne(de,Oe=>{const Le=we||!ue(Oe,Se);return we=!1,Se=Oe,Le},me)}D.latch=F;function U(de,ue,me){return[D.filter(de,ue,me),D.filter(de,we=>!ue(we),me)]}D.split=U;function H(de,ue=!1,me=[]){let we=me.slice(),Se=de(ve=>{we?we.push(ve):Le.fire(ve)});const Oe=()=>{we?.forEach(ve=>Le.fire(ve)),we=null},Le=new w({onWillAddFirstListener(){Se||(Se=de(ve=>Le.fire(ve)))},onDidAddFirstListener(){we&&(ue?setTimeout(Oe):Oe())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return Le.event}D.buffer=H;function Q(de,ue){return(we,Se,Oe)=>{const Le=ue(new oe);return de(function(ve){const pe=Le.evaluate(ve);pe!==x&&we.call(Se,pe)},void 0,Oe)}}D.chain=Q;const x=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(me=>(ue(me),me)),this}filter(ue){return this.f.push(me=>ue(me)?me:x),this}reduce(ue,me){let we=me;return this.f.push(Se=>(we=ue(we,Se),we)),this}latch(ue=(me,we)=>me===we){let me=!0,we;return this.f.push(Se=>{const Oe=me||!ue(Se,we);return me=!1,we=Se,Oe?Se:x}),this}evaluate(ue){for(const me of this.f)if(ue=me(ue),ue===x)break;return ue}}function K(de,ue,me=we=>we){const we=(...ve)=>Le.fire(me(...ve)),Se=()=>de.on(ue,we),Oe=()=>de.removeListener(ue,we),Le=new w({onWillAddFirstListener:Se,onDidRemoveLastListener:Oe});return Le.event}D.fromNodeEventEmitter=K;function O(de,ue,me=we=>we){const we=(...ve)=>Le.fire(me(...ve)),Se=()=>de.addEventListener(ue,we),Oe=()=>de.removeEventListener(ue,we),Le=new w({onWillAddFirstListener:Se,onDidRemoveLastListener:Oe});return Le.event}D.fromDOMEventEmitter=O;function L(de){return new Promise(ue=>j(de)(ue))}D.toPromise=L;function N(de){const ue=new w;return de.then(me=>{ue.fire(me)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}D.fromPromise=N;function W(de,ue){return ue(void 0),de(me=>ue(me))}D.runAndSubscribe=W;function q(de,ue){let me=null;function we(Oe){me?.dispose(),me=new s.$lb,ue(Oe,me)}we(void 0);const Se=de(Oe=>we(Oe));return(0,s.$kb)(()=>{Se.dispose(),me?.dispose()})}D.runAndSubscribeWithStore=q;class V{constructor(ue,me){this._observable=ue,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};me||P(we),this.emitter=new w(we),me&&me.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,me){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function re(de,ue){return new V(de,ue).emitter.event}D.fromObservable=re;function $e(de){return ue=>{let me=0,we=!1;const Se={beginUpdate(){me++},endUpdate(){me--,me===0&&(de.reportChanges(),we&&(we=!1,ue()))},handlePossibleChange(){},handleChange(){we=!0}};return de.addObserver(Se),de.reportChanges(),{dispose(){de.removeObserver(Se)}}}}D.fromObservableLight=$e})(u||(e.Event=u={}));class p{static{this.all=new Set}static{this.f=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${p.f++}`,p.all.add(this)}start(P){this.g=new A.$dc,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}e.$fc=p;let $=-1;function v(D){const P=$;return $=D,{dispose(){$=P}}}e.$gc=v;class h{constructor(P,R=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=R,this.g=0}dispose(){this.f?.clear()}check(P,R){const j=this.threshold;if(j<=0||R<j)return;this.f||(this.f=new Map);const T=this.f.get(P.value)||0;if(this.f.set(P.value,T+1),this.g-=1,this.g<=0){this.g=j*.5;let z,ne=0;for(const[ee,ce]of this.f)(!z||ne<ce)&&(z=ee,ne=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${ne}):`),console.warn(z)}return()=>{const z=this.f.get(P.value)||0;this.f.set(P.value,z-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class d{constructor(P){this.value=P,this.id=b++}}const c=2,a=(D,P)=>{if(D instanceof d)P(D);else for(let R=0;R<D.length;R++){const j=D[R];j&&P(j)}};class w{constructor(P){this.w=0,this.f=P,this.g=$>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const P=this.t;queueMicrotask(()=>{a(P,R=>R.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(P,R,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$mb.None;if(this.m)return s.$mb.None;R&&(P=P.bind(R));const T=new d(P);let z,ne;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=y.create(),z=this.g.check(T.stack,this.w+1)),S&&(T.stack=ne??y.create()),this.t?this.t instanceof d?(this.u??=new g,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,s.$kb)(()=>{z?.(),this.x(T)});return j instanceof s.$lb?j.add(ee):Array.isArray(j)&&j.push(ee),ee},this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const R=this.t,j=R.indexOf(P);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,R[j]=void 0;const T=this.u.current===this;if(this.w*c<=R.length){let z=0;for(let ne=0;ne<R.length;ne++)R[ne]?R[z++]=R[ne]:T&&(this.u.end--,z<this.u.i&&this.u.i--);R.length=z}}y(P,R){if(!P)return;const j=this.f?.onListenerError||E.$Y;if(!j){P.value(R);return}try{P.value(R)}catch(T){j(T)}}z(P){const R=P.current.t;for(;P.i<P.end;)this.y(R[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,P);else{const R=this.u;R.enqueue(this,P,this.t.length),this.z(R)}this.j?.stop()}hasListeners(){return this.w>0}}e.$hc=w;const k=()=>new g;e.$ic=k;class g{constructor(){this.i=-1,this.end=0}enqueue(P,R,j){this.i=0,this.end=j,this.current=P,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends w{async fireAsync(P,R,j){if(this.t)for(this.h||(this.h=new M.$vb),a(this.t,T=>this.h.push([T.value,P]));this.h.size>0&&!R.isCancellationRequested;){const[T,z]=this.h.shift(),ne=[],ee={...z,token:R,waitUntil:ce=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");j&&(ce=j(ce,T)),ne.push(ce)}};try{T(ee)}catch(ce){(0,E.$Y)(ce);continue}Object.freeze(ne),await Promise.allSettled(ne).then(ce=>{for(const se of ce)se.status==="rejected"&&(0,E.$Y)(se.reason)})}}}e.$jc=t;class l extends w{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new M.$vb,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}e.$kc=l;class r extends l{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}e.$lc=r;class i extends w{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(R=>super.fire(R)),this.h=[]}))}}e.$mc=i;class n{constructor(){this.g=!1,this.h=[],this.f=new w({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const R={event:P,listener:null};this.h.push(R),this.g&&this.m(R);const j=()=>{this.g&&this.o(R);const T=this.h.indexOf(R);this.h.splice(T,1)};return(0,s.$kb)((0,C.$bb)(j))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(R=>this.f.fire(R))}o(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.f.dispose()}}e.$nc=n;class o{constructor(P,R,j,T){this.f=new s.$lb;const z=this.f.add(new n),ne=this.f.add(new s.$ub);function ee(ce){ne.set(ce,z.add(T(ce)))}for(const ce of P)ee(ce);this.f.add(R(ce=>{ee(ce)})),this.f.add(j(ce=>{ne.deleteAndDispose(ce)})),this.event=z.event}dispose(){this.f.dispose()}}e.$oc=o;class m{constructor(){this.f=[]}wrapEvent(P){return(R,j,T)=>P(z=>{const ne=this.f[this.f.length-1];ne?ne.push(()=>R.call(j,z)):R.call(j,z)},void 0,T)}bufferEvents(P){const R=[];this.f.push(R);const j=P();return this.f.pop(),R.forEach(T=>T()),j}}e.$pc=m;class I{constructor(){this.f=!1,this.g=u.None,this.h=s.$mb.None,this.j=new w({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qc=I}),define(te[22],ie([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.CancellationToken=void 0;const C=Object.freeze(function(S,f){const u=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(u)}}});var s;(function(S){function f(u){return u===S.None||u===S.Cancelled||u instanceof M?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new E.$hc),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$rc=A}),define(te[140],ie([0,1,22]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ld=e.$kd=e.$jd=void 0;class C{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new E.$rc,f=this.b(S.token);return this.a={promise:f,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$jd=C;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const f=JSON.stringify(S);return this.b!==f&&(this.b=f,this.a=this.c(S)),this.a}}e.$kd=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const f=this.b(S);return this.a.set(S,f),f}}e.$ld=M}),define(te[56],ie([0,1,14,2]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=void 0;function s(k){const g=k;return g?typeof g.read=="function":!1}e.$sc=s;function M(k){const g=k;return g?[g.on,g.pause,g.resume,g.destroy].every(t=>typeof t=="function"):!1}e.$tc=M;function A(k){const g=k;return g?M(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$uc=A;function S(k,g){return new f(k,g)}e.$vc=S;class f{constructor(g,t){this.e=g,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(t=>t(g))}h(g){this.c.error.length===0?(0,E.$Y)(g):this.c.error.slice(0).forEach(t=>t(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,t){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(g,t){if(this.a.destroyed)return;let l;switch(g){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(k,g){const t=[];let l;for(;(l=k.read())!==null;)t.push(l);return g(t)}e.$wc=u;function p(k,g,t){const l=[];let r;for(;(r=k.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?g(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return k.read()}}}e.$xc=p;function $(k,g){return new Promise((t,l)=>{const r=[];v(k,{onData:i=>{g&&r.push(i)},onError:i=>{g?l(i):t(void 0)},onEnd:()=>{t(g?g(r):void 0)}})})}e.$yc=$;function v(k,g,t){k.on("error",l=>{t?.isCancellationRequested||g.onError(l)}),k.on("end",()=>{t?.isCancellationRequested||g.onEnd()}),k.on("data",l=>{t?.isCancellationRequested||g.onData(l)})}e.$zc=v;function h(k,g){return new Promise((t,l)=>{const r=new C.$lb,i=[],n=I=>{if(i.push(I),i.length>g)return r.dispose(),k.pause(),t({stream:k,buffer:i,ended:!1})},o=I=>(r.dispose(),l(I)),m=()=>(r.dispose(),t({stream:k,buffer:i,ended:!0}));r.add((0,C.$kb)(()=>k.removeListener("error",o))),k.on("error",o),r.add((0,C.$kb)(()=>k.removeListener("end",m))),k.on("end",m),r.add((0,C.$kb)(()=>k.removeListener("data",n))),k.on("data",n)})}e.$Ac=h;function y(k,g){const t=S(g);return t.end(k),t}e.$Bc=y;function b(){const k=S(()=>{throw new Error("not supported")});return k.end(),k}e.$Cc=b;function d(k){let g=!1;return{read:()=>g?null:(g=!0,k)}}e.$Dc=d;function c(k,g,t){const l=S(t);return v(k,{onData:r=>l.write(g.data(r)),onError:r=>l.error(g.error?g.error(r):r),onEnd:()=>l.end()}),l}e.$Ec=c;function a(k,g,t){let l=!1;return{read:()=>{const r=g.read();return l?r:(l=!0,r!==null?t([k,r]):k)}}}e.$Fc=a;function w(k,g,t){let l=!1;const r=S(t);return v(g,{onData:i=>l?r.write(i):(l=!0,r.write(t([k,i]))),onError:i=>r.error(i),onEnd:()=>{l||(l=!0,r.write(k)),r.end()}}),r}e.$Gc=w}),define(te[17],ie([0,1,84,56]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const s=typeof Buffer<"u",M=new E.$T(()=>new Uint8Array(256));let A,S;class f{static alloc(R){return s?new f(Buffer.allocUnsafe(R)):new f(new Uint8Array(R))}static wrap(R){return s&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new f(R)}static fromString(R,j){return!(j?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(R)):(A||(A=new TextEncoder),new f(A.encode(R)))}static fromByteArray(R){const j=f.alloc(R.length);for(let T=0,z=R.length;T<z;T++)j.buffer[T]=R[T];return j}static concat(R,j){if(typeof j>"u"){j=0;for(let ne=0,ee=R.length;ne<ee;ne++)j+=R[ne].byteLength}const T=f.alloc(j);let z=0;for(let ne=0,ee=R.length;ne<ee;ne++){const ce=R[ne];T.set(ce,z),z+=ce.byteLength}return T}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=f.alloc(this.byteLength);return R.set(this),R}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(R,j){return new f(this.buffer.subarray(R,j))}set(R,j){if(R instanceof f)this.buffer.set(R.buffer,j);else if(R instanceof Uint8Array)this.buffer.set(R,j);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),j);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return v(this.buffer,R)}writeUInt32BE(R,j){h(this.buffer,R,j)}readUInt32LE(R){return y(this.buffer,R)}writeUInt32LE(R,j){b(this.buffer,R,j)}readUInt8(R){return d(this.buffer,R)}writeUInt8(R,j){c(this.buffer,R,j)}indexOf(R,j=0){return u(this.buffer,R instanceof f?R.buffer:R,j)}}e.$Hc=f;function u(P,R,j=0){const T=R.byteLength,z=P.byteLength;if(T===0)return 0;if(T===1)return P.indexOf(R[0]);if(T>z-j)return-1;const ne=M.value;ne.fill(R.length);for(let ae=0;ae<R.length;ae++)ne[R[ae]]=R.length-ae-1;let ee=j+R.length-1,ce=ee,se=-1;for(;ee<z;)if(P[ee]===R[ce]){if(ce===0){se=ee;break}ee--,ce--}else ee+=Math.max(R.length-ce,ne[P[ee]]),ce=R.length-1;return se}e.$Ic=u;function p(P,R){return P[R+0]<<0>>>0|P[R+1]<<8>>>0}e.$Jc=p;function $(P,R,j){P[j+0]=R&255,R=R>>>8,P[j+1]=R&255}e.$Kc=$;function v(P,R){return P[R]*2**24+P[R+1]*2**16+P[R+2]*2**8+P[R+3]}e.$Lc=v;function h(P,R,j){P[j+3]=R,R=R>>>8,P[j+2]=R,R=R>>>8,P[j+1]=R,R=R>>>8,P[j]=R}e.$Mc=h;function y(P,R){return P[R+0]<<0>>>0|P[R+1]<<8>>>0|P[R+2]<<16>>>0|P[R+3]<<24>>>0}e.$Nc=y;function b(P,R,j){P[j+0]=R&255,R=R>>>8,P[j+1]=R&255,R=R>>>8,P[j+2]=R&255,R=R>>>8,P[j+3]=R&255}e.$Oc=b;function d(P,R){return P[R]}e.$Pc=d;function c(P,R,j){P[j]=R}e.$Qc=c;function a(P){return C.$wc(P,R=>f.concat(R))}e.$Rc=a;function w(P){return C.$Dc(P)}e.$Sc=w;function k(P){return C.$yc(P,R=>f.concat(R))}e.$Tc=k;async function g(P){return P.ended?f.concat(P.buffer):f.concat([...P.buffer,await k(P.stream)])}e.$Uc=g;function t(P){return C.$Bc(P,R=>f.concat(R))}e.$Vc=t;function l(P){return C.$Ec(P,{data:R=>typeof R=="string"?f.fromString(R):f.wrap(R)},R=>f.concat(R))}e.$Wc=l;function r(P){return C.$vc(R=>f.concat(R),P)}e.$Xc=r;function i(P,R){return C.$Fc(P,R,j=>f.concat(j))}e.$Yc=i;function n(P,R){return C.$Gc(P,R,j=>f.concat(j))}e.$Zc=n;function o(P){let R=0,j=0,T=0;const z=new Uint8Array(Math.floor(P.length/4*3)),ne=ce=>{switch(j){case 3:z[T++]=R|ce,j=0;break;case 2:z[T++]=R|ce>>>2,R=ce<<6,j=3;break;case 1:z[T++]=R|ce>>>4,R=ce<<4,j=2;break;default:R=ce<<2,j=1}};for(let ce=0;ce<P.length;ce++){const se=P.charCodeAt(ce);if(se>=65&&se<=90)ne(se-65);else if(se>=97&&se<=122)ne(se-97+26);else if(se>=48&&se<=57)ne(se-48+52);else if(se===43||se===45)ne(62);else if(se===47||se===95)ne(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${P[ce]}`)}}const ee=T;for(;j>0;)ne(0);return f.wrap(z).slice(0,ee)}e.$1c=o;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:P},R=!0,j=!1){const T=j?I:m;let z="";const ne=P.byteLength%3;let ee=0;for(;ee<P.byteLength-ne;ee+=3){const ce=P[ee+0],se=P[ee+1],ae=P[ee+2];z+=T[ce>>>2],z+=T[(ce<<4|se>>>4)&63],z+=T[(se<<2|ae>>>6)&63],z+=T[ae&63]}if(ne===1){const ce=P[ee+0];z+=T[ce>>>2],z+=T[ce<<4&63],R&&(z+="==")}else if(ne===2){const ce=P[ee+0],se=P[ee+1];z+=T[ce>>>2],z+=T[(ce<<4|se>>>4)&63],z+=T[se<<2&63],R&&(z+="=")}return z}e.$2c=D}),define(te[26],ie([0,1,140,84]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=e.$je=e.$ie=e.$he=e.GraphemeBreakType=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=void 0;function s(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.$od=s;const M=/{(\d+)}/g;function A(Z,...he){return he.length===0?Z:Z.replace(M,function(ge,ye){const De=parseInt(ye,10);return isNaN(De)||De<0||De>=he.length?ge:he[De]})}e.$pd=A;const S=/{([^}]+)}/g;function f(Z,he){return Z.replace(S,(ge,ye)=>he[ye]??ge)}e.$qd=f;function u(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$rd=u;function p(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$sd=p;function $(Z,he){let ge=0;const ye=he.charCodeAt(0);for(let De=Z.length-1;De>=0;De--)Z.charCodeAt(De)===ye&&ge++;return ge}e.$td=$;function v(Z,he,ge="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${ge}`}e.$ud=v;function h(Z,he=" "){const ge=y(Z,he);return b(ge,he)}e.$vd=h;function y(Z,he){if(!Z||!he)return Z;const ge=he.length;if(ge===0||Z.length===0)return Z;let ye=0;for(;Z.indexOf(he,ye)===ye;)ye=ye+ge;return Z.substring(ye)}e.$wd=y;function b(Z,he){if(!Z||!he)return Z;const ge=he.length,ye=Z.length;if(ge===0||ye===0)return Z;let De=ye,Fe=-1;for(;Fe=Z.lastIndexOf(he,De-1),!(Fe===-1||Fe+ge!==De);){if(Fe===0)return"";De=Fe}return Z.substring(0,De)}e.$xd=b;function d(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$yd=d;function c(Z){return Z.replace(/\*/g,"")}e.$zd=c;function a(Z,he,ge={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=p(Z)),ge.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ye="";return ge.global&&(ye+="g"),ge.matchCase||(ye+="i"),ge.multiline&&(ye+="m"),ge.unicode&&(ye+="u"),new RegExp(Z,ye)}e.$Ad=a;function w(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.$Bd=w;function k(Z){return Z.split(/\r\n|\r|\n/)}e.$Cd=k;function g(Z){for(let he=0,ge=Z.length;he<ge;he++){const ye=Z.charCodeAt(he);if(ye!==32&&ye!==9)return he}return-1}e.$Dd=g;function t(Z,he=0,ge=Z.length){for(let ye=he;ye<ge;ye++){const De=Z.charCodeAt(ye);if(De!==32&&De!==9)return Z.substring(he,ye)}return Z.substring(he,ge)}e.$Ed=t;function l(Z,he=Z.length-1){for(let ge=he;ge>=0;ge--){const ye=Z.charCodeAt(ge);if(ye!==32&&ye!==9)return ge}return-1}e.$Fd=l;function r(Z,he,ge){const ye=[];let De=0;for(const Fe of Z.matchAll(he)){if(ye.push(Z.slice(De,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");De=Fe.index+Fe[0].length,ye.push(ge(Fe[0],...Fe.slice(1),Fe.index,Z,Fe.groups))}return ye.push(Z.slice(De)),Promise.all(ye).then(Fe=>Fe.join(""))}e.$Gd=r;function i(Z,he){return Z<he?-1:Z>he?1:0}e.$Hd=i;function n(Z,he,ge=0,ye=Z.length,De=0,Fe=he.length){for(;ge<ye&&De<Fe;ge++,De++){const Be=Z.charCodeAt(ge),qe=he.charCodeAt(De);if(Be<qe)return-1;if(Be>qe)return 1}const Me=ye-ge,Te=Fe-De;return Me<Te?-1:Me>Te?1:0}e.$Id=n;function o(Z,he){return m(Z,he,0,Z.length,0,he.length)}e.$Jd=o;function m(Z,he,ge=0,ye=Z.length,De=0,Fe=he.length){for(;ge<ye&&De<Fe;ge++,De++){let Be=Z.charCodeAt(ge),qe=he.charCodeAt(De);if(Be===qe)continue;if(Be>=128||qe>=128)return n(Z.toLowerCase(),he.toLowerCase(),ge,ye,De,Fe);D(Be)&&(Be-=32),D(qe)&&(qe-=32);const He=Be-qe;if(He!==0)return He}const Me=ye-ge,Te=Fe-De;return Me<Te?-1:Me>Te?1:0}e.$Kd=m;function I(Z){return Z>=48&&Z<=57}e.$Ld=I;function D(Z){return Z>=97&&Z<=122}e.$Md=D;function P(Z){return Z>=65&&Z<=90}e.$Nd=P;function R(Z,he){return Z.length===he.length&&m(Z,he)===0}e.$Od=R;function j(Z,he){const ge=he.length;return he.length>Z.length?!1:m(Z,he,0,ge)===0}e.$Pd=j;function T(Z,he){const ge=Math.min(Z.length,he.length);let ye;for(ye=0;ye<ge;ye++)if(Z.charCodeAt(ye)!==he.charCodeAt(ye))return ye;return ge}e.$Qd=T;function z(Z,he){const ge=Math.min(Z.length,he.length);let ye;const De=Z.length-1,Fe=he.length-1;for(ye=0;ye<ge;ye++)if(Z.charCodeAt(De-ye)!==he.charCodeAt(Fe-ye))return ye;return ge}e.$Rd=z;function ne(Z){return 55296<=Z&&Z<=56319}e.$Sd=ne;function ee(Z){return 56320<=Z&&Z<=57343}e.$Td=ee;function ce(Z,he){return(Z-55296<<10)+(he-56320)+65536}e.$Ud=ce;function se(Z,he,ge){const ye=Z.charCodeAt(ge);if(ne(ye)&&ge+1<he){const De=Z.charCodeAt(ge+1);if(ee(De))return ce(ye,De)}return ye}e.$Vd=se;function ae(Z,he){const ge=Z.charCodeAt(he-1);if(ee(ge)&&he>1){const ye=Z.charCodeAt(he-2);if(ne(ye))return ce(ye,ge)}return ge}class J{get offset(){return this.e}constructor(he,ge=0){this.c=he,this.d=he.length,this.e=ge}setOffset(he){this.e=he}prevCodePoint(){const he=ae(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=se(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$Wd=J;class Y{get offset(){return this.c.offset}constructor(he,ge=0){this.c=new J(he,ge)}nextGraphemeLength(){const he=le.getInstance(),ge=this.c,ye=ge.offset;let De=he.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Fe=ge.offset,Me=he.getGraphemeBreakType(ge.nextCodePoint());if(pe(De,Me)){ge.setOffset(Fe);break}De=Me}return ge.offset-ye}prevGraphemeLength(){const he=le.getInstance(),ge=this.c,ye=ge.offset;let De=he.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Fe=ge.offset,Me=he.getGraphemeBreakType(ge.prevCodePoint());if(pe(Me,De)){ge.setOffset(Fe);break}De=Me}return ye-ge.offset}eol(){return this.c.eol()}}e.$Xd=Y;function B(Z,he){return new Y(Z,he).nextGraphemeLength()}e.$Yd=B;function F(Z,he){return new Y(Z,he).prevGraphemeLength()}e.$Zd=F;function U(Z,he){he>0&&ee(Z.charCodeAt(he))&&he--;const ge=he+B(Z,he);return[ge-F(Z,ge),ge]}e.$1d=U;function H(Z){const he=new Y(Z);let ge=0;for(;!he.eol();)ge++,he.nextGraphemeLength();return ge}e.$2d=H;let Q;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Z){return Q||(Q=x()),Q.test(Z)}e.$3d=oe;const K=/^[\t\n\r\x20-\x7E]*$/;function O(Z){return K.test(Z)}e.$4d=O,e.$5d=/[\u2028\u2029]/;function L(Z){return e.$5d.test(Z)}e.$6d=L;function N(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.$7d=N;function W(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.$8d=W;function q(Z,he){if(Z.length<he)return Z;const ge=/\b/g;let ye=0;for(;ge.test(Z)&&!(Z.length-ge.lastIndex<he);)ye=ge.lastIndex,ge.lastIndex+=1;return Z.substring(ye).replace(/^\s/,"")}e.$9d=q;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function $e(Z){return Z&&(Z=Z.replace(V,"").replace(re,"")),Z}e.$0d=$e,e.$$d=String.fromCharCode(65279);function de(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.$_d=de;function ue(Z){return de(Z)?Z.substr(1):Z}e.$ae=ue;function me(Z,he){if(!Z||!he||Z.length<he.length)return!1;const ge=he.length,ye=Z.toLowerCase();let De=0,Fe=-1;for(;De<ge;){const Me=ye.indexOf(he[De],Fe+1);if(Me<0)return!1;Fe=Me,De++}return!0}e.$be=me;function we(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.$ce=we;function Se(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.$de=Se;function Oe(Z,he=1){if(he===0)return"";let ge=-1;do ge=Z.indexOf(`
`,ge+1),he--;while(he>0&&ge>=0);return ge===-1?Z:(Z[ge-1]==="\r"&&ge--,Z.substr(0,ge))}e.$ee=Oe;function Le(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}e.$fe=Le;function ve(Z){return le.getInstance().getGraphemeBreakType(Z)}e.$ge=ve;function pe(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var X;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(X||(e.GraphemeBreakType=X={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=fe()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const ge=this.d,ye=ge.length/3;let De=1;for(;De<=ye;)if(he<ge[3*De])De=2*De;else if(he>ge[3*De+1])De=2*De+1;else return ge[3*De+2];return 0}}function fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(Z,he){if(Z===0)return 0;const ge=Re(Z,he);if(ge!==void 0)return ge;const ye=new J(he,Z);return ye.prevCodePoint(),ye.offset}e.$he=Ee;function Re(Z,he){const ge=new J(he,Z);let ye=ge.prevCodePoint();for(;Ne(ye)||ye===65039||ye===8419;){if(ge.offset===0)return;ye=ge.prevCodePoint()}if(!W(ye))return;let De=ge.offset;return De>0&&ge.prevCodePoint()===8205&&(De=ge.offset),De}function Ne(Z){return 127995<=Z&&Z<=127999}var Ce;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={})),e.$ie="\xA0";class ze{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new E.$kd(he=>{function ge(He){const xe=new Map;for(let Qe=0;Qe<He.length;Qe+=2)xe.set(He[Qe],He[Qe+1]);return xe}function ye(He,xe){const Qe=new Map(He);for(const[tt,st]of xe)Qe.set(tt,st);return Qe}function De(He,xe){if(!He)return xe;const Qe=new Map;for(const[tt,st]of He)xe.has(tt)&&Qe.set(tt,st);return Qe}const Fe=this.c.value;let Me=he.filter(He=>!He.startsWith("_")&&He in Fe);Me.length===0&&(Me=["_default"]);let Te;for(const He of Me){const xe=ge(Fe[He]);Te=De(Te,xe)}const Be=ge(Fe._common),qe=ye(Be,Te);return new ze(qe)})}static getInstance(he){return ze.d.get(Array.from(he))}static{this.e=new C.$T(()=>Object.keys(ze.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return ze.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$je=ze;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(he){return We.e().has(he)}static get codePoints(){return We.e()}}e.$ke=We}),define(te[57],ie([0,1,26]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0;function C(c){return s(c,0)}e.$ni=C;function s(c,a){switch(typeof c){case"object":return c===null?M(349,a):Array.isArray(c)?f(c,a):u(c,a);case"string":return S(c,a);case"boolean":return A(c,a);case"number":return M(c,a);case"undefined":return M(937,a);default:return M(617,a)}}e.$oi=s;function M(c,a){return(a<<5)-a+c|0}e.$pi=M;function A(c,a){return M(c?433:863,a)}function S(c,a){a=M(149417,a);for(let w=0,k=c.length;w<k;w++)a=M(c.charCodeAt(w),a);return a}e.$qi=S;function f(c,a){return a=M(104579,a),c.reduce((w,k)=>s(k,w),a)}function u(c,a){return a=M(181387,a),Object.keys(c).sort().reduce((w,k)=>(w=S(k,w),s(c[k],w)),a)}class p{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=s(a,this.g),this.g}}e.$ri=p;var $;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function v(c,a,w=32){const k=w-a,g=~((1<<k)-1);return(c<<a|(g&c)>>>k)>>>0}function h(c,a=0,w=c.byteLength,k=0){for(let g=0;g<w;g++)c[a+g]=k}function y(c,a,w="0"){for(;c.length<a;)c=w+c;return c}function b(c,a=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(w=>w.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),a/4)}e.$si=b;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const w=a.length;if(w===0)return;const k=this.p;let g=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=a.charCodeAt(0),r=0);;){let i=l;if(E.$Sd(l))if(r+1<w){const n=a.charCodeAt(r+1);E.$Td(n)?(r++,i=E.$Ud(l,n)):i=65533}else{t=l;break}else E.$Td(l)&&(i=65533);if(g=this.w(k,g,i),r++,r<w)l=a.charCodeAt(r);else break}this.r=g,this.u=t}w(a,w,k){return k<128?a[w++]=k:k<2048?(a[w++]=192|(k&1984)>>>6,a[w++]=128|(k&63)>>>0):k<65536?(a[w++]=224|(k&61440)>>>12,a[w++]=128|(k&4032)>>>6,a[w++]=128|(k&63)>>>0):(a[w++]=240|(k&1835008)>>>18,a[w++]=128|(k&258048)>>>12,a[w++]=128|(k&4032)>>>6,a[w++]=128|(k&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=d.g,w=this.q;for(let m=0;m<64;m+=4)a.setUint32(m,w.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)a.setUint32(m,v(a.getUint32(m-12,!1)^a.getUint32(m-32,!1)^a.getUint32(m-56,!1)^a.getUint32(m-64,!1),1),!1);let k=this.h,g=this.l,t=this.m,l=this.n,r=this.o,i,n,o;for(let m=0;m<80;m++)m<20?(i=g&t|~g&l,n=1518500249):m<40?(i=g^t^l,n=1859775393):m<60?(i=g&t|g&l|t&l,n=2400959708):(i=g^t^l,n=3395469782),o=v(k,5)+i+r+n+a.getUint32(m*4,!1)&4294967295,r=l,l=t,t=v(g,30),g=k,k=o;this.h=this.h+k&4294967295,this.l=this.l+g&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.$ti=d}),define(te[70],ie([0,1,26]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(C||(C={})),function(s){const M="error",A="warning",S="warn",f="info",u="ignore";function p(v){return v?E.$Od(M,v)?s.Error:E.$Od(A,v)||E.$Od(S,v)?s.Warning:E.$Od(f,v)?s.Info:s.Ignore:s.Ignore}s.fromValue=p;function $(v){switch(v){case s.Error:return M;case s.Warning:return A;case s.Info:return f;default:return u}}s.toString=$}(C||(C={})),e.default=C}),define(te[141],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=void 0,e.$ec=Symbol("MicrotaskDelay")}),define(te[58],ie([0,1,24,26]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;class s{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const y=h.charCodeAt(0),b=this.b.charCodeAt(this.c);return y-b}value(){return this.b[this.c]}}e.$Bh=s;class M{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$Id)(h,this.b,0,h.length,this.c,this.d):(0,C.$Kd)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ch=M;class A{constructor(h=!0,y=!0){this.f=h,this.g=y}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let y=h.length-1;y>=0;y--,this.c--){const b=this.b.charCodeAt(y);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$Id)(h,this.b,0,h.length,this.d,this.e):(0,C.$Kd)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Dh=A;var S;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(S||(S={}));class f{constructor(h,y){this.f=h,this.g=y,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$Jd)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$Jd)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$Hd)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$Hd)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Eh=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(p||(p={}));class ${static forUris(h=()=>!1,y=()=>!1){return new $(new f(h,y))}static forPaths(h=!1){return new $(new A(void 0,!h))}static forStrings(){return new $(new s)}static forConfigKeys(){return new $(new M)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,y){if(y){const b=y.slice(0);(0,E.$Qf)(b);for(const d of b)this.set(d,h)}else{const b=h.slice(0);(0,E.$Qf)(b);for(const d of b)this.set(d[0],d[1])}}set(h,y){const b=this.b.reset(h);let d;this.c||(this.c=new u,this.c.segment=b.value());const c=[];for(d=this.c;;){const w=b.cmp(d.segment);if(w>0)d.left||(d.left=new u,d.left.segment=b.value()),c.push([-1,d]),d=d.left;else if(w<0)d.right||(d.right=new u,d.right.segment=b.value()),c.push([1,d]),d=d.right;else if(b.hasNext())b.next(),d.mid||(d.mid=new u,d.mid.segment=b.value()),c.push([0,d]),d=d.mid;else break}const a=d.value;d.value=y,d.key=h;for(let w=c.length-1;w>=0;w--){const k=c[w][1];k.updateHeight();const g=k.balanceFactor();if(g<-1||g>1){const t=c[w][0],l=c[w+1][0];if(t===1&&l===1)c[w][1]=k.rotateLeft();else if(t===-1&&l===-1)c[w][1]=k.rotateRight();else if(t===1&&l===-1)k.right=c[w+1][1]=c[w+1][1].rotateRight(),c[w][1]=k.rotateLeft();else if(t===-1&&l===1)k.left=c[w+1][1]=c[w+1][1].rotateLeft(),c[w][1]=k.rotateRight();else throw new Error;if(w>0)switch(c[w-1][0]){case-1:c[w-1][1].left=c[w][1];break;case 1:c[w-1][1].right=c[w][1];break;case 0:c[w-1][1].mid=c[w][1];break}else this.c=c[0][1]}}return a}get(h){return this.d(h)?.value}d(h){const y=this.b.reset(h);let b=this.c;for(;b;){const d=y.cmp(b.segment);if(d>0)b=b.left;else if(d<0)b=b.right;else if(y.hasNext())y.next(),b=b.mid;else break}return b}has(h){const y=this.d(h);return!(y?.value===void 0&&y?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,y){const b=this.b.reset(h),d=[];let c=this.c;for(;c;){const a=b.cmp(c.segment);if(a>0)d.push([-1,c]),c=c.left;else if(a<0)d.push([1,c]),c=c.right;else if(b.hasNext())b.next(),d.push([0,c]),c=c.mid;else break}if(c){if(y?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const a=this.f(c.right);if(a.key){const{key:w,value:k,segment:g}=a;this.e(a.key,!1),c.key=w,c.value=k,c.segment=g}}else{const a=c.left??c.right;if(d.length>0){const[w,k]=d[d.length-1];switch(w){case-1:k.left=a;break;case 0:k.mid=a;break;case 1:k.right=a;break}}else this.c=a}for(let a=d.length-1;a>=0;a--){const w=d[a][1];w.updateHeight();const k=w.balanceFactor();if(k>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),d[a][1]=w.rotateLeft()):k<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),d[a][1]=w.rotateRight()),a>0)switch(d[a-1][0]){case-1:d[a-1][1].left=d[a][1];break;case 1:d[a-1][1].right=d[a][1];break;case 0:d[a-1][1].mid=d[a][1];break}else this.c=d[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const y=this.b.reset(h);let b=this.c,d;for(;b;){const c=y.cmp(b.segment);if(c>0)b=b.left;else if(c<0)b=b.right;else if(y.hasNext())y.next(),d=b.value||d,b=b.mid;else break}return b&&b.value||d}findSuperstr(h){return this.g(h,!1)}g(h,y){const b=this.b.reset(h);let d=this.c;for(;d;){const c=b.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(b.hasNext())b.next(),d=d.mid;else return d.mid?this.h(d.mid):y?d.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[y,b]of this)h(b,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const y=[];return this.j(h,y),y[Symbol.iterator]()}j(h,y){h&&(h.left&&this.j(h.left,y),h.value&&y.push([h.key,h.value]),h.mid&&this.j(h.mid,y),h.right&&this.j(h.right,y))}_isBalanced(){const h=y=>{if(!y)return!0;const b=y.balanceFactor();return b<-1||b>1?!1:h(y.left)&&h(y.right)};return h(this.c)}}e.$Fh=$}),define(te[12],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function E(g){return typeof g=="string"}e.$le=E;function C(g){return Array.isArray(g)&&g.every(t=>E(t))}e.$me=C;function s(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.$ne=s;function M(g){const t=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof t}e.$oe=M;function A(g){return typeof g=="number"&&!isNaN(g)}e.$pe=A;function S(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.$qe=S;function f(g){return g===!0||g===!1}e.$re=f;function u(g){return typeof g>"u"}e.$se=u;function p(g){return!$(g)}e.$te=p;function $(g){return u(g)||g===null}e.$ue=$;function v(g,t){if(!g)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$ve=v;function h(g){if($(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.$we=h;function y(...g){const t=[];for(let l=0;l<g.length;l++){const r=g[l];if($(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(r)}return t}e.$xe=y;const b=Object.prototype.hasOwnProperty;function d(g){if(!s(g))return!1;for(const t in g)if(b.call(g,t))return!1;return!0}e.$ye=d;function c(g){return typeof g=="function"}e.$ze=c;function a(...g){return g.length>0&&g.every(c)}e.$Ae=a;function w(g,t){const l=Math.min(g.length,t.length);for(let r=0;r<l;r++)k(g[r],t[r])}e.$Be=w;function k(g,t){if(E(t)){if(typeof g!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(g instanceof t)return}catch{}if(!$(g)&&g.constructor===t||t.length===1&&t.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Ce=k}),define(te[71],ie([0,1,12]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=void 0;const C=Object.create(null);function s(S,f){if((0,E.$le)(f)){const u=C[f];if(u===void 0)throw new Error(`${S} references an unknown codicon: ${f}`);f=u}return C[S]=f,{id:S}}function M(){return C}e.$Lj=M;function A(){return Object.values(e.$Nj)}e.$Mj=A,e.$Nj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=void 0;function C(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const a=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([w,k])=>{a[w]=k&&typeof k=="object"?C(k):k}),a}e.$Tm=C;function s(c){if(!c||typeof c!="object")return c;const a=[c];for(;a.length>0;){const w=a.shift();Object.freeze(w);for(const k in w)if(M.call(w,k)){const g=w[k];typeof g=="object"&&!Object.isFrozen(g)&&!(0,E.$oe)(g)&&a.push(g)}}return c}e.$Um=s;const M=Object.prototype.hasOwnProperty;function A(c,a){return S(c,a,new Set)}e.$Vm=A;function S(c,a,w){if((0,E.$ue)(c))return c;const k=a(c);if(typeof k<"u")return k;if(Array.isArray(c)){const g=[];for(const t of c)g.push(S(t,a,w));return g}if((0,E.$ne)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const g={};for(const t in c)M.call(c,t)&&(g[t]=S(c[t],a,w));return w.delete(c),g}return c}function f(c,a,w=!0){return(0,E.$ne)(c)?((0,E.$ne)(a)&&Object.keys(a).forEach(k=>{k in c?w&&((0,E.$ne)(c[k])&&(0,E.$ne)(a[k])?f(c[k],a[k],w):c[k]=a[k]):c[k]=a[k]}),c):a}e.$Wm=f;function u(c,a){if(c===a)return!0;if(c==null||a===null||a===void 0||typeof c!=typeof a||typeof c!="object"||Array.isArray(c)!==Array.isArray(a))return!1;let w,k;if(Array.isArray(c)){if(c.length!==a.length)return!1;for(w=0;w<c.length;w++)if(!u(c[w],a[w]))return!1}else{const g=[];for(k in c)g.push(k);g.sort();const t=[];for(k in a)t.push(k);if(t.sort(),!u(g,t))return!1;for(w=0;w<g.length;w++)if(!u(c[g[w]],a[g[w]]))return!1}return!0}e.$Xm=u;function p(c){const a=new Set;return JSON.stringify(c,(w,k)=>{if((0,E.$ne)(k)||Array.isArray(k)){if(a.has(k))return"[Circular]";a.add(k)}return k})}e.$Ym=p;function $(c,a){const w=Object.create(null);return!c||!a||Object.keys(a).forEach(g=>{const t=c[g],l=a[g];u(t,l)||(w[g]=l)}),w}e.$Zm=$;function v(c,a){const w=a.toLowerCase(),k=Object.keys(c).find(g=>g.toLowerCase()===w);return k?c[k]:c[a]}e.$1m=v;function h(c,a){const w=Object.create(null);for(const[k,g]of Object.entries(c))a(k,g)&&(w[k]=g);return w}e.$2m=h;function y(c){let a=[];for(;Object.prototype!==c;)a=a.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return a}e.$3m=y;function b(c){const a=[];for(const w of y(c))typeof c[w]=="function"&&a.push(w);return a}e.$4m=b;function d(c,a){const w=g=>function(){const t=Array.prototype.slice.call(arguments,0);return a(g,t)},k={};for(const g of c)k[g]=w(g);return k}e.$5m=d}),define(te[102],ie([0,1,71]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Oj=e.ThemeColor=void 0;var C;(function(A){function S(f){return f&&typeof f=="object"&&typeof f.id=="string"}A.isThemeColor=S})(C||(e.ThemeColor=C={}));function s(A){return{id:A}}e.$Oj=s;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function f(a){const w=S.exec(a.id);if(!w)return f(E.$Nj.error);const[,k,g]=w,t=["codicon","codicon-"+k];return g&&t.push("codicon-modifier-"+g.substring(1)),t}A.asClassNameArray=f;function u(a){return f(a).join(" ")}A.asClassName=u;function p(a){return"."+f(a).join(".")}A.asCSSSelector=p;function $(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||C.isThemeColor(a.color))}A.isThemeIcon=$;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function h(a){const w=v.exec(a);if(!w)return;const[,k]=w;return{id:k}}A.fromString=h;function y(a){return{id:a}}A.fromId=y;function b(a,w){let k=a.id;const g=k.lastIndexOf("~");return g!==-1&&(k=k.substring(0,g)),w&&(k=`${k}~${w}`),{id:k}}A.modify=b;function d(a){const w=a.id.lastIndexOf("~");if(w!==-1)return a.id.substring(w+1)}A.getModifier=d;function c(a,w){return a.id===w.id&&a.color?.id===w.color?.id}A.isEqual=c})(M||(e.ThemeIcon=M={}))}),define(te[31],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(s){return E.test(s)}e.$5e=C,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let f=0;f<S.length;f++)S[f]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,u="";return u+=A[M[f++]],u+=A[M[f++]],u+=A[M[f++]],u+=A[M[f++]],u+="-",u+=A[M[f++]],u+=A[M[f++]],u+="-",u+=A[M[f++]],u+=A[M[f++]],u+="-",u+=A[M[f++]],u+=A[M[f++]],u+="-",u+=A[M[f++]],u+=A[M[f++]],u+=A[M[f++]],u+=A[M[f++]],u+=A[M[f++]],u+=A[M[f++]],u}}()}),define(te[142],ie([0,1,72,45,49]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AS=void 0;async function M(A,S){if(await new Promise((p,$)=>{const v=C.createReadStream(A),h=E.createHash("sha1");v.pipe(h);const y=(0,s.$bb)((b,d)=>{v.removeAllListeners(),h.removeAllListeners(),b?$(b):p(d)});v.once("error",y),v.once("end",y),h.once("error",y),h.once("data",b=>y(void 0,b.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$AS=M}),define(te[143],ie([0,1,27]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=void 0;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(A){const S=A.replace(/\-/g,":").toLowerCase();return!C.has(S)}function M(){const A=(0,E.networkInterfaces)();for(const S in A){const f=A[S];if(f){for(const{mac:u}of f)if(s(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Em=M}),define(te[86],ie([0,1,27,58,31,143]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=void 0,e.$Fm=new class{c(u){return this.a||(this.a=C.$Fh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(u)}value(){if(this.b===void 0){let u=0,p=0;const $=(0,E.networkInterfaces)();for(const v in $){const h=$[v];if(h)for(const{mac:y,internal:b}of h)b||(p+=1,this.c(y.toUpperCase())&&(u+=1))}this.b=p>0?u/p:0}return this.b}};let A;async function S(u){return A||(A=(async()=>await f(u)||s.$6e())()),A}e.$Gm=S;async function f(u){try{const p=await new Promise((v,h)=>{G(["crypto"],v,h)}),$=(0,M.$Em)();return p.createHash("sha256").update($,"utf8").digest("hex")}catch(p){u(p);return}}}),define(te[103],ie([0,1,87]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$8e=void 0;function C(S,f,u,p=1){let $=!1;return new Promise(v=>{const h=setTimeout(()=>{if(!$)return $=!0,v(0)},u);s(S,f,p,y=>{if(!$)return $=!0,clearTimeout(h),v(y)})})}e.$8e=C;function s(S,f,u,p){if(f===0)return p(0);const $=new E.Socket;$.once("connect",()=>(A($),s(S+u,f-1,u,p))),$.once("data",()=>{}),$.once("error",v=>(A($),v.code!=="ECONNREFUSED"?s(S+u,f-1,u,p):p(S))),$.connect(S,"127.0.0.1")}e.$9e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,f,u,p="127.0.0.1"){let $=!1,v,h=1;const y=E.createServer({pauseOnConnect:!0});function b(d,c){$||($=!0,y.removeAllListeners(),y.close(),v&&clearTimeout(v),c(d))}return new Promise(d=>{v=setTimeout(()=>{b(0,d)},u),y.on("listening",()=>{b(S,d)}),y.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&h<f?(S++,h++,y.listen(S,p)):b(0,d)}),y.on("close",()=>{b(0,d)}),y.listen(S,p)})}e.$0e=M;function A(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),function(){function G(){function e(){return process.uncHostAllowlist}function E(f){const u=new Set;if(Array.isArray(f))for(const p of f)typeof p=="string"&&u.add(p);return Array.from(u)}function C(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const u=e();if(u)if(typeof f=="string")u.add(f.toLowerCase());else for(const p of E(f))s(p)}function M(f){if(typeof f!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let p;for(const $ of u){if(f.indexOf($)!==0)continue;const h=f.indexOf("\\",$.length);if(h===-1)continue;const y=f.substring($.length,h);if(y){p=y;break}}return p}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return G()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=G():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ES=e.$DS=void 0,e.$DS="vscode:contextmenu",e.$ES="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LS=void 0;class E{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$LS=E}),define(te[38],ie([0,1,15,14]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FS=void 0;class s{constructor(){this.a=new WeakMap}on(A,S){const f=(u,...p)=>{this.b(A,u)&&S(u,...p)};return this.a.set(S,f),E.ipcMain.on(A,f),this}once(A,S){return E.ipcMain.once(A,(f,...u)=>{this.b(A,f)&&S(f,...u)}),this}handle(A,S){return E.ipcMain.handle(A,(f,...u)=>this.b(A,f)?S(f,...u):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return E.ipcMain.removeHandler(A),this}removeListener(A,S){const f=this.a.get(S);return f&&(E.ipcMain.removeListener(A,f),this.a.delete(S)),this}b(A,S){if(!A||!A.startsWith("vscode:"))return(0,C.$Y)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const f=S.senderFrame,u=f.url;if(!u||u==="about:blank")return!0;let p="unknown";try{p=new URL(u).host}catch{return(0,C.$Y)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${u}'.`),!1}return p!=="vscode-app"?((0,C.$Y)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${p}'.`),!1):f.parent!==null?((0,C.$Y)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.$FS=new s}),define(te[146],ie([0,1,15,38,144]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GS=void 0;function M(){C.$FS.on(s.$DS,(S,f,u,p,$)=>{const v=A(S,p,u);v.popup({window:E.BrowserWindow.fromWebContents(S.sender)??void 0,x:$?$.x:void 0,y:$?$.y:void 0,positioningItem:$?$.positioningItem:void 0,callback:()=>{v&&S.sender.send(s.$ES,f)}})})}e.$GS=M;function A(S,f,u){const p=new E.Menu;return u.forEach($=>{let v;$.type==="separator"?v=new E.MenuItem({type:$.type}):Array.isArray($.submenu)?v=new E.MenuItem({submenu:A(S,f,$.submenu),label:$.label}):v=new E.MenuItem({label:$.label,type:$.type,accelerator:$.accelerator,checked:$.checked,enabled:$.enabled,visible:$.visible,click:(h,y,b)=>S.sender.send(f,$.id,b)}),p.append(v)}),p}}),define(te[147],ie([11,10]),function(G,e){return G.create("vs/base/common/date",e)}),define(te[148],ie([0,1,147]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0;const C=60,s=C*60,M=s*24,A=M*7,S=M*30,f=M*365;function u($,v,h,y){typeof $!="number"&&($=$.getTime());const b=Math.round((new Date().getTime()-$)/1e3);if(b<-30)return(0,E.localize)(0,null,u(new Date().getTime()+b*1e3,!1));if(!y&&b<30)return(0,E.localize)(1,null);let d;return b<C?(d=b,v?d===1?h?(0,E.localize)(2,null,d):(0,E.localize)(3,null,d):h?(0,E.localize)(4,null,d):(0,E.localize)(5,null,d):d===1?h?(0,E.localize)(6,null,d):(0,E.localize)(7,null,d):h?(0,E.localize)(8,null,d):(0,E.localize)(9,null,d)):b<s?(d=Math.floor(b/C),v?d===1?h?(0,E.localize)(10,null,d):(0,E.localize)(11,null,d):h?(0,E.localize)(12,null,d):(0,E.localize)(13,null,d):d===1?h?(0,E.localize)(14,null,d):(0,E.localize)(15,null,d):h?(0,E.localize)(16,null,d):(0,E.localize)(17,null,d)):b<M?(d=Math.floor(b/s),v?d===1?h?(0,E.localize)(18,null,d):(0,E.localize)(19,null,d):h?(0,E.localize)(20,null,d):(0,E.localize)(21,null,d):d===1?h?(0,E.localize)(22,null,d):(0,E.localize)(23,null,d):h?(0,E.localize)(24,null,d):(0,E.localize)(25,null,d)):b<A?(d=Math.floor(b/M),v?d===1?(0,E.localize)(26,null,d):(0,E.localize)(27,null,d):d===1?(0,E.localize)(28,null,d):(0,E.localize)(29,null,d)):b<S?(d=Math.floor(b/A),v?d===1?h?(0,E.localize)(30,null,d):(0,E.localize)(31,null,d):h?(0,E.localize)(32,null,d):(0,E.localize)(33,null,d):d===1?h?(0,E.localize)(34,null,d):(0,E.localize)(35,null,d):h?(0,E.localize)(36,null,d):(0,E.localize)(37,null,d)):b<f?(d=Math.floor(b/S),v?d===1?h?(0,E.localize)(38,null,d):(0,E.localize)(39,null,d):h?(0,E.localize)(40,null,d):(0,E.localize)(41,null,d):d===1?h?(0,E.localize)(42,null,d):(0,E.localize)(43,null,d):h?(0,E.localize)(44,null,d):(0,E.localize)(45,null,d)):(d=Math.floor(b/f),v?d===1?h?(0,E.localize)(46,null,d):(0,E.localize)(47,null,d):h?(0,E.localize)(48,null,d):(0,E.localize)(49,null,d):d===1?h?(0,E.localize)(50,null,d):(0,E.localize)(51,null,d):h?(0,E.localize)(52,null,d):(0,E.localize)(53,null,d))}e.$4l=u;function p($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$5l=p}),define(te[149],ie([11,10]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,24,12,149]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=void 0;function M($,v){return v&&($.stack||$.stacktrace)?s.localize(0,null,S($),A($.stack)||A($.stacktrace)):S($)}function A($){return Array.isArray($)?$.join(`
`):$}function S($){return $.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${$.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof $.code=="string"&&typeof $.errno=="number"&&typeof $.syscall=="string"?s.localize(1,null,$.message):$.message||s.localize(2,null)}function f($=null,v=!1){if(!$)return s.localize(3,null);if(Array.isArray($)){const h=E.$Af($),y=f(h[0],v);return h.length>1?s.localize(4,null,y,h.length):y}if(C.$le($))return $;if($.detail){const h=$.detail;if(h.error)return M(h.error,v);if(h.exception)return M(h.exception,v)}return $.stack?M($,v):$.message?$.message:s.localize(5,null)}e.$ki=f;function u($){const v=$;return v instanceof Error&&Array.isArray(v.actions)}e.$li=u;function p($,v){let h;return typeof $=="string"?h=new Error($):h=$,h.actions=v,h}e.$mi=p}),define(te[150],ie([11,10]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(te[151],ie([0,1,150]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;function C(s){switch(s){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.$jp=C}),define(te[152],ie([11,10]),function(G,e){return G.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,152]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let C=!1,s=!1,M=!1,A=!1,S=!1,f=!1,u=!1,p=!1,$=!1,v=!1,h,y=e.$f,b=e.$f,d,c;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?a=e.$g.vscode.process:typeof process<"u"&&(a=process);const w=typeof a?.versions?.electron=="string",k=w&&a?.type==="renderer";if(typeof navigator=="object"&&!k)c=navigator.userAgent,C=c.indexOf("Windows")>=0,s=c.indexOf("Macintosh")>=0,p=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=c.indexOf("Linux")>=0,v=c?.indexOf("Mobi")>=0,f=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||e.$f,y=h,b=navigator.language;else if(typeof a=="object"){C=a.platform==="win32",s=a.platform==="darwin",M=a.platform==="linux",A=M&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,u=w,$=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$f,y=e.$f;const I=a.env.VSCODE_NLS_CONFIG;if(I)try{const D=JSON.parse(I),P=D.availableLanguages["*"];h=D.locale,b=D.osLocale,y=P||e.$f,d=D._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var g;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(g||(e.Platform=g={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let l=0;s?l=1:C?l=3:M&&(l=2),e.$i=C,e.$j=s,e.$k=M,e.$l=A,e.$m=S,e.$n=u,e.$o=f,e.$p=f&&typeof e.$g.importScripts=="function",e.$q=p,e.$r=v,e.$s=$,e.$t=l,e.$u=c,e.$v=y;var r;(function(I){function D(){return e.$v}I.value=D;function P(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}I.isDefaultVariant=P;function R(){return e.$v==="en"}I.isDefault=R})(r||(e.Language=r={})),e.$w=h,e.$x=b,e.$y=d,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const I=[];e.$g.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let R=0,j=I.length;R<j;R++){const T=I[R];if(T.id===P.data.vscodeScheduleAsyncWork){I.splice(R,1),T.callback();return}}});let D=0;return P=>{const R=++D;I.push({id:R,callback:P}),e.$g.postMessage({vscodeScheduleAsyncWork:R},"*")}}return I=>setTimeout(I)})();var i;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||p?2:C?1:3;let n=!0,o=!1;function m(){if(!o){o=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,n=new Uint16Array(I.buffer)[0]===(2<<8)+1}return n}e.$C=m,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.env=e.cwd=void 0;let C;if(typeof E.$g.vscode<"u"&&typeof E.$g.vscode.process<"u"){const s=E.$g.vscode.process;C={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return E.$i?"win32":E.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$5c=C.platform,e.$6c=C.arch}),define(te[9],ie([0,1,35]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.sep=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;const C=65,s=97,M=90,A=122,S=46,f=47,u=92,p=58,$=63;class v extends Error{constructor(l,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=l.indexOf(".")!==-1?"property":"argument";let m=`The "${l}" ${o} ${n} of type ${r}`;m+=`. Received type ${typeof i}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,l){if(t===null||typeof t!="object")throw new v(l,"Object",t)}function y(t,l){if(typeof t!="string")throw new v(l,"string",t)}const b=E.$5c==="win32";function d(t){return t===f||t===u}function c(t){return t===f}function a(t){return t>=C&&t<=M||t>=s&&t<=A}function w(t,l,r,i){let n="",o=0,m=-1,I=0,D=0;for(let P=0;P<=t.length;++P){if(P<t.length)D=t.charCodeAt(P);else{if(i(D))break;D=f}if(i(D)){if(!(m===P-1||I===1))if(I===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const R=n.lastIndexOf(r);R===-1?(n="",o=0):(n=n.slice(0,R),o=n.length-1-n.lastIndexOf(r)),m=P,I=0;continue}else if(n.length!==0){n="",o=0,m=P,I=0;continue}}l&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(m+1,P)}`:n=t.slice(m+1,P),o=P-m-1;m=P,I=0}else D===S&&I!==-1?++I:I=-1}return n}function k(t,l){h(l,"pathObject");const r=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${i}`:`${r}${t}${i}`:i}e.$7c={resolve(...t){let l="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else l.length===0?o=E.cwd():(o=E.env[`=${l}`]||E.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===u)&&(o=`${l}\\`));const m=o.length;let I=0,D="",P=!1;const R=o.charCodeAt(0);if(m===1)d(R)&&(I=1,P=!0);else if(d(R))if(P=!0,d(o.charCodeAt(1))){let j=2,T=j;for(;j<m&&!d(o.charCodeAt(j));)j++;if(j<m&&j!==T){const z=o.slice(T,j);for(T=j;j<m&&d(o.charCodeAt(j));)j++;if(j<m&&j!==T){for(T=j;j<m&&!d(o.charCodeAt(j));)j++;(j===m||j!==T)&&(D=`\\\\${z}\\${o.slice(T,j)}`,I=j)}}}else I=1;else a(R)&&o.charCodeAt(1)===p&&(D=o.slice(0,2),I=2,m>2&&d(o.charCodeAt(2))&&(P=!0,I=3));if(D.length>0)if(l.length>0){if(D.toLowerCase()!==l.toLowerCase())continue}else l=D;if(i){if(l.length>0)break}else if(r=`${o.slice(I)}\\${r}`,i=P,P&&l.length>0)break}return r=w(r,!i,"\\",d),i?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){y(t,"path");const l=t.length;if(l===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(l===1)return c(o)?"\\":t;if(d(o))if(n=!0,d(t.charCodeAt(1))){let I=2,D=I;for(;I<l&&!d(t.charCodeAt(I));)I++;if(I<l&&I!==D){const P=t.slice(D,I);for(D=I;I<l&&d(t.charCodeAt(I));)I++;if(I<l&&I!==D){for(D=I;I<l&&!d(t.charCodeAt(I));)I++;if(I===l)return`\\\\${P}\\${t.slice(D)}\\`;I!==D&&(i=`\\\\${P}\\${t.slice(D,I)}`,r=I)}}}else r=1;else a(o)&&t.charCodeAt(1)===p&&(i=t.slice(0,2),r=2,l>2&&d(t.charCodeAt(2))&&(n=!0,r=3));let m=r<l?w(t.slice(r),!n,"\\",d):"";return m.length===0&&!n&&(m="."),m.length>0&&d(t.charCodeAt(l-1))&&(m+="\\"),i===void 0?n?`\\${m}`:m:n?`${i}\\${m}`:`${i}${m}`},isAbsolute(t){y(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return d(r)||l>2&&a(r)&&t.charCodeAt(1)===p&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let o=0;o<t.length;++o){const m=t[o];y(m,"path"),m.length>0&&(l===void 0?l=r=m:l+=`\\${m}`)}if(l===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++n;const o=r.length;o>1&&d(r.charCodeAt(1))&&(++n,o>2&&(d(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<l.length&&d(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.$7c.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l)return"";const r=e.$7c.resolve(t),i=e.$7c.resolve(l);if(r===i||(t=r.toLowerCase(),l=i.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===u;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===u;)o--;const m=o-n;let I=0;for(;I<l.length&&l.charCodeAt(I)===u;)I++;let D=l.length;for(;D-1>I&&l.charCodeAt(D-1)===u;)D--;const P=D-I,R=m<P?m:P;let j=-1,T=0;for(;T<R;T++){const ne=t.charCodeAt(n+T);if(ne!==l.charCodeAt(I+T))break;ne===u&&(j=T)}if(T!==R){if(j===-1)return i}else{if(P>R){if(l.charCodeAt(I+T)===u)return i.slice(I+T+1);if(T===2)return i.slice(I+T)}m>R&&(t.charCodeAt(n+T)===u?j=T:T===2&&(j=3)),j===-1&&(j=0)}let z="";for(T=n+j+1;T<=o;++T)(T===o||t.charCodeAt(T)===u)&&(z+=z.length===0?"..":"\\..");return I+=j,z.length>0?`${z}${i.slice(I,D)}`:(i.charCodeAt(I)===u&&++I,i.slice(I,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$7c.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const r=l.charCodeAt(2);if(r!==$&&r!==S)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(a(l.charCodeAt(0))&&l.charCodeAt(1)===p&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return t},dirname(t){y(t,"path");const l=t.length;if(l===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(l===1)return d(n)?t:".";if(d(n)){if(r=i=1,d(t.charCodeAt(1))){let I=2,D=I;for(;I<l&&!d(t.charCodeAt(I));)I++;if(I<l&&I!==D){for(D=I;I<l&&d(t.charCodeAt(I));)I++;if(I<l&&I!==D){for(D=I;I<l&&!d(t.charCodeAt(I));)I++;if(I===l)return t;I!==D&&(r=i=I+1)}}}}else a(n)&&t.charCodeAt(1)===p&&(r=l>2&&d(t.charCodeAt(2))?3:2,i=r);let o=-1,m=!0;for(let I=l-1;I>=i;--I)if(d(t.charCodeAt(I))){if(!m){o=I;break}}else m=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let m=l.length-1,I=-1;for(o=t.length-1;o>=r;--o){const D=t.charCodeAt(o);if(d(D)){if(!n){r=o+1;break}}else I===-1&&(n=!1,I=o+1),m>=0&&(D===l.charCodeAt(m)?--m===-1&&(i=o):(m=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if(d(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let l=0,r=-1,i=0,n=-1,o=!0,m=0;t.length>=2&&t.charCodeAt(1)===p&&a(t.charCodeAt(0))&&(l=i=2);for(let I=t.length-1;I>=l;--I){const D=t.charCodeAt(I);if(d(D)){if(!o){i=I+1;break}continue}n===-1&&(o=!1,n=I+1),D===S?r===-1?r=I:m!==1&&(m=1):r!==-1&&(m=-1)}return r===-1||n===-1||m===0||m===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:k.bind(null,"\\"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return d(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(d(n)){if(i=1,d(t.charCodeAt(1))){let j=2,T=j;for(;j<r&&!d(t.charCodeAt(j));)j++;if(j<r&&j!==T){for(T=j;j<r&&d(t.charCodeAt(j));)j++;if(j<r&&j!==T){for(T=j;j<r&&!d(t.charCodeAt(j));)j++;j===r?i=j:j!==T&&(i=j+1)}}}}else if(a(n)&&t.charCodeAt(1)===p){if(r<=2)return l.root=l.dir=t,l;if(i=2,d(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let o=-1,m=i,I=-1,D=!0,P=t.length-1,R=0;for(;P>=i;--P){if(n=t.charCodeAt(P),d(n)){if(!D){m=P+1;break}continue}I===-1&&(D=!1,I=P+1),n===S?o===-1?o=P:R!==1&&(R=1):o!==-1&&(R=-1)}return I!==-1&&(o===-1||R===0||R===1&&o===I-1&&o===m+1?l.base=l.name=t.slice(m,I):(l.name=t.slice(m,o),l.base=t.slice(m,I),l.ext=t.slice(o,I))),m>0&&m!==i?l.dir=t.slice(0,m-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(b){const t=/\\/g;return()=>{const l=E.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();e.$8c={resolve(...t){let l="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:g();y(n,"path"),n.length!==0&&(l=`${n}/${l}`,r=n.charCodeAt(0)===f)}return l=w(l,!r,"/",c),r?`/${l}`:l.length>0?l:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=w(t,!l,"/",c),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.$8c.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l||(t=e.$8c.resolve(t),l=e.$8c.resolve(l),t===l))return"";const r=1,i=t.length,n=i-r,o=1,m=l.length-o,I=n<m?n:m;let D=-1,P=0;for(;P<I;P++){const j=t.charCodeAt(r+P);if(j!==l.charCodeAt(o+P))break;j===f&&(D=P)}if(P===I)if(m>I){if(l.charCodeAt(o+P)===f)return l.slice(o+P+1);if(P===0)return l.slice(o+P)}else n>I&&(t.charCodeAt(r+P)===f?D=P:P===0&&(D=0));let R="";for(P=r+D+1;P<=i;++P)(P===i||t.charCodeAt(P)===f)&&(R+=R.length===0?"..":"/..");return`${R}${l.slice(o+D)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let m=l.length-1,I=-1;for(o=t.length-1;o>=0;--o){const D=t.charCodeAt(o);if(D===f){if(!n){r=o+1;break}}else I===-1&&(n=!1,I=o+1),m>=0&&(D===l.charCodeAt(m)?--m===-1&&(i=o):(m=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===f){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let l=-1,r=0,i=-1,n=!0,o=0;for(let m=t.length-1;m>=0;--m){const I=t.charCodeAt(m);if(I===f){if(!n){r=m+1;break}continue}i===-1&&(n=!1,i=m+1),I===S?l===-1?l=m:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||i===-1||o===0||o===1&&l===i-1&&l===r+1?"":t.slice(l,i)},format:k.bind(null,"/"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===f;let i;r?(l.root="/",i=1):i=0;let n=-1,o=0,m=-1,I=!0,D=t.length-1,P=0;for(;D>=i;--D){const R=t.charCodeAt(D);if(R===f){if(!I){o=D+1;break}continue}m===-1&&(I=!1,m=D+1),R===S?n===-1?n=D:P!==1&&(P=1):n!==-1&&(P=-1)}if(m!==-1){const R=o===0&&r?1:o;n===-1||P===0||P===1&&n===m-1&&n===o+1?l.base=l.name=t.slice(R,m):(l.name=t.slice(R,n),l.base=t.slice(R,m),l.ext=t.slice(n,m))}return o>0?l.dir=t.slice(0,o-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$8c.win32=e.$7c.win32=e.$7c,e.$8c.posix=e.$7c.posix=e.$8c,e.$9c=b?e.$7c.normalize:e.$8c.normalize,e.$0c=b?e.$7c.isAbsolute:e.$8c.isAbsolute,e.$$c=b?e.$7c.join:e.$8c.join,e.$_c=b?e.$7c.resolve:e.$8c.resolve,e.$ad=b?e.$7c.relative:e.$8c.relative,e.$bd=b?e.$7c.dirname:e.$8c.dirname,e.$cd=b?e.$7c.basename:e.$8c.basename,e.$dd=b?e.$7c.extname:e.$8c.extname,e.$ed=b?e.$7c.format:e.$8c.format,e.$fd=b?e.$7c.parse:e.$8c.parse,e.$gd=b?e.$7c.toNamespacedPath:e.$8c.toNamespacedPath,e.sep=b?e.$7c.sep:e.$8c.sep,e.$id=b?e.$7c.delimiter:e.$8c.delimiter}),define(te[32],ie([0,1,9,4,26,12]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function A(o){return o===47||o===92}e.$De=A;function S(o){return o.replace(/[\\/]/g,E.$8c.sep)}e.$Ee=S;function f(o){return o.indexOf("/")===-1&&(o=S(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Fe=f;function u(o,m=E.$8c.sep){if(!o)return"";const I=o.length,D=o.charCodeAt(0);if(A(D)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let R=3;const j=R;for(;R<I&&!A(o.charCodeAt(R));R++);if(j!==R&&!A(o.charCodeAt(R+1))){for(R+=1;R<I;R++)if(A(o.charCodeAt(R)))return o.slice(0,R+1).replace(/[\\/]/g,m)}}return m}else if(c(D)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+m:o.slice(0,2);let P=o.indexOf("://");if(P!==-1){for(P+=3;P<I;P++)if(A(o.charCodeAt(P)))return o.slice(0,P+1)}return""}e.$Ge=u;function p(o){if(!C.$i||!o||o.length<5)return!1;let m=o.charCodeAt(0);if(m!==92||(m=o.charCodeAt(1),m!==92))return!1;let I=2;const D=I;for(;I<o.length&&(m=o.charCodeAt(I),m!==92);I++);return!(D===I||(m=o.charCodeAt(I+1),isNaN(m)||m===92))}e.$He=p;const $=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,m=C.$i){const I=m?$:v;return!(!o||o.length===0||/^\s+$/.test(o)||(I.lastIndex=0,I.test(o))||m&&h.test(o)||o==="."||o===".."||m&&o[o.length-1]==="."||m&&o.length!==o.trim().length||o.length>255)}e.$Ie=y;function b(o,m,I){const D=o===m;return!I||D?D:!o||!m?!1:(0,s.$Od)(o,m)}e.$Je=b;function d(o,m,I,D=E.sep){if(o===m)return!0;if(!o||!m||m.length>o.length)return!1;if(I){if(!(0,s.$Pd)(o,m))return!1;if(m.length===o.length)return!0;let R=m.length;return m.charAt(m.length-1)===D&&R--,o.charAt(R)===D}return m.charAt(m.length-1)!==D&&(m+=D),o.indexOf(m)===0}e.$Ke=d;function c(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Le=c;function a(o,m){return C.$i&&o.endsWith(":")&&(o+=E.sep),(0,E.$0c)(o)||(o=(0,E.$$c)(m,o)),o=(0,E.$9c)(o),C.$i?(o=(0,s.$xd)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,s.$xd)(o,E.sep),o||(o=E.sep)),o}e.$Me=a;function w(o){const m=(0,E.$9c)(o);return C.$i?o.length>3?!1:k(m)&&(o.length===2||m.charCodeAt(2)===92):m===E.$8c.sep}e.$Ne=w;function k(o,m=C.$i){return m?c(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Oe=k;function g(o,m=C.$i){return k(o,m)?o[0]:void 0}e.$Pe=g;function t(o,m,I){return m.length>o.length?-1:o===m?0:(I&&(o=o.toLowerCase(),m=m.toLowerCase()),o.indexOf(m))}e.$Qe=t;function l(o){const m=o.split(":");let I,D,P;for(const R of m){const j=Number(R);(0,M.$pe)(j)?D===void 0?D=j:P===void 0&&(P=j):I=I?[I,R].join(":"):R}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:D!==void 0?D:void 0,column:P!==void 0?P:D!==void 0?1:void 0}}e.$Re=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,m,I=8){let D="";for(let R=0;R<I;R++){let j;R===0&&C.$i&&!m&&(I===3||I===4)?j=i:j=r,D+=j.charAt(Math.floor(Math.random()*j.length))}let P;return m?P=`${m}-${D}`:P=D,o?(0,E.$$c)(o,P):P}e.$Se=n}),define(te[73],ie([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.TerminateResponseCode=e.Source=void 0;var C;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(C||(e.Source=C={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...f){const u=f.reduce((v,h)=>(v[h]=!0,v),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(v=>!u[v]).forEach(v=>{for(let h=0;h<p.length;h++)if(v.search(p[h])!==-1){delete S[v];break}})}e.$ql=M;function A(S){S&&(delete S.DEBUG,E.$j&&delete S.DYLD_LIBRARY_PATH,E.$k&&delete S.LD_PRELOAD)}e.$rl=A}),define(te[7],ie([0,1,9,4]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ve=e.$Ue=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function u(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==$&&(n=$+n):n=$;break}return n}const p="",$="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,m,I,D,P=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=f(n,P),this.authority=o||p,this.path=u(this.scheme,m||p),this.query=I||p,this.fragment=D||p,S(this,P))}get fsPath(){return k(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:m,path:I,query:D,fragment:P}=n;return o===void 0?o=this.scheme:o===null&&(o=p),m===void 0?m=this.authority:m===null&&(m=p),I===void 0?I=this.path:I===null&&(I=p),D===void 0?D=this.query:D===null&&(D=p),P===void 0?P=this.fragment:P===null&&(P=p),o===this.scheme&&m===this.authority&&I===this.path&&D===this.query&&P===this.fragment?this:new d(o,m,I,D,P)}static parse(n,o=!1){const m=v.exec(n);return m?new d(m[2]||p,r(m[4]||p),r(m[5]||p),r(m[7]||p),r(m[9]||p),o):new d(p,p,p,p,p)}static file(n){let o=p;if(C.$i&&(n=n.replace(/\\/g,$)),n[0]===$&&n[1]===$){const m=n.indexOf($,2);m===-1?(o=n.substring(2),n=$):(o=n.substring(2,m),n=n.substring(m)||$)}return new d("file",o,n,p,p)}static from(n,o){return new d(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return C.$i&&n.scheme==="file"?m=h.file(E.$7c.join(k(n,!0),...o)).path:m=E.$8c.join(n.path,...o),n.with({path:m})}toString(n=!1){return g(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const o=new d(n);return o._formatted=n.external??null,o._fsPath=n._sep===b?n.fsPath??null:null,o}}else return n}}e.URI=h;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Ue=y;const b=C.$i?1:void 0;class d extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(n=!1){return n?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=b),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,n,o){let m,I=-1;for(let D=0;D<i.length;D++){const P=i.charCodeAt(D);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47||o&&P===91||o&&P===93||o&&P===58)I!==-1&&(m+=encodeURIComponent(i.substring(I,D)),I=-1),m!==void 0&&(m+=i.charAt(D));else{m===void 0&&(m=i.substr(0,D));const R=c[P];R!==void 0?(I!==-1&&(m+=encodeURIComponent(i.substring(I,D)),I=-1),m+=R):I===-1&&(I=D)}}return I!==-1&&(m+=encodeURIComponent(i.substring(I))),m!==void 0?m:i}function w(i){let n;for(let o=0;o<i.length;o++){const m=i.charCodeAt(o);m===35||m===63?(n===void 0&&(n=i.substr(0,o)),n+=c[m]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function k(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,C.$i&&(o=o.replace(/\//g,"\\")),o}e.$Ve=k;function g(i,n){const o=n?w:a;let m="",{scheme:I,authority:D,path:P,query:R,fragment:j}=i;if(I&&(m+=I,m+=":"),(D||I==="file")&&(m+=$,m+=$),D){let T=D.indexOf("@");if(T!==-1){const z=D.substr(0,T);D=D.substr(T+1),T=z.lastIndexOf(":"),T===-1?m+=o(z,!1,!1):(m+=o(z.substr(0,T),!1,!1),m+=":",m+=o(z.substr(T+1),!1,!0)),m+="@"}D=D.toLowerCase(),T=D.lastIndexOf(":"),T===-1?m+=o(D,!1,!0):(m+=o(D.substr(0,T),!1,!0),m+=D.substr(T))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const T=P.charCodeAt(1);T>=65&&T<=90&&(P=`/${String.fromCharCode(T+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const T=P.charCodeAt(0);T>=65&&T<=90&&(P=`${String.fromCharCode(T+32)}:${P.substr(2)}`)}m+=o(P,!0,!1)}return R&&(m+="?",m+=o(R,!1,!1)),j&&(m+="#",m+=n?j:a(j,!1,!1)),m}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(l)?i.replace(l,n=>t(n)):i}}),define(te[153],ie([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Mp=e.$Lp=e.$Kp=void 0;function C(u){const p=u;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.$Kp=C;function s(u){const p=[];let $;try{const v=JSON.parse(u.arguments),h=v[v.length-1];h&&h.__$stack&&(v.pop(),$=h.__$stack),p.push(...v)}catch{p.push("Unable to log remote console arguments",u.arguments)}return{args:p,stack:$}}e.$Lp=s;function M(u){if(typeof u!="string")return M(s(u).stack);const p=u;if(p){const $=A(p),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec($||"");if(v&&v.length===4)return{uri:E.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Mp=M;function A(u){if(!u)return u;const p=u.indexOf(`
`);return p===-1?u:u.substring(0,p)}function S(u,p){const{args:$,stack:v}=s(u),h=typeof $[0]=="string"&&$.length===1;let y=A(v);y&&(y=`(${y.trim()})`);let b=[];if(typeof $[0]=="string"?y&&h?b=[`%c[${p}] %c${$[0]} %c${y}`,f("blue"),f(""),f("grey")]:b=[`%c[${p}] %c${$[0]}`,f("blue"),f(""),...$.slice(1)]:b=[`%c[${p}]%`,f("blue"),...$],y&&!h&&b.push(y),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,b)}e.log=S;function f(u){return`color: ${u}`}}),define(te[74],ie([0,1,17,7]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.$8g=e.$7g=void 0;function s(f){return JSON.stringify(f,A)}e.$7g=s;function M(f){let u=JSON.parse(f);return u=S(u),u}e.$8g=M;function A(f,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function S(f,u=0){if(!f||u>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return C.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 16:return new Date(f.source)}if(f instanceof E.$Hc||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let p=0;p<f.length;++p)f[p]=S(f[p],u+1);else for(const p in f)Object.hasOwnProperty.call(f,p)&&(f[p]=S(f[p],u+1))}return f}e.$9g=S}),define(te[13],ie([0,1,14,4,7]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var M;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$We="vscode-tkn",e.$Xe="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${M.vscodeRemoteResource}`}set(p,$,v){this.a[p]=$,this.b[p]=v}setConnectionToken(p,$){this.c[p]=$}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(d){return E.$Y(d),p}const $=p.authority;let v=this.a[$];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const h=this.b[$],y=this.c[$];let b=`path=${encodeURIComponent(p.path)}`;return typeof y=="string"&&(b+=`&${e.$Xe}=${encodeURIComponent(y)}`),s.URI.from({scheme:C.$o?this.d:M.vscodeRemoteResource,authority:`${v}:${h}`,path:this.f,query:b})}}e.$Ye=new A,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class S{static{this.a="vscode-app"}asBrowserUri(p){const $=this.b(p,G);return this.uriToBrowserUri($)}uriToBrowserUri(p){return p.scheme===M.vscodeRemote?e.$Ye.rewrite(p):p.scheme===M.file&&(C.$m||C.$p&&C.$g.origin===`${M.vscodeFileResource}://${S.a}`)?p.with({scheme:M.vscodeFileResource,authority:p.authority||S.a,query:null,fragment:null}):p}asFileUri(p){const $=this.b(p,G);return this.uriToFileUri($)}uriToFileUri(p){return p.scheme===M.vscodeFileResource?p.with({scheme:M.file,authority:p.authority!==S.a?p.authority:null,query:null,fragment:null}):p}b(p,$){return s.URI.isUri(p)?p:s.URI.parse($.toUrl(p))}}e.$4e=new S;var f;(function(u){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(p.get("3"));const $="vscode-coi";function v(y){let b;typeof y=="string"?b=new URL(y).searchParams:y instanceof URL?b=y.searchParams:s.URI.isUri(y)&&(b=new URL(y.toString(!0)).searchParams);const d=b?.get($);if(d)return p.get(d)}u.getHeadersFromQuery=v;function h(y,b,d){if(!globalThis.crossOriginIsolated)return;const c=b&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set($,c):y[$]=c}u.addSearchParam=h})(f||(e.COI=f={}))}),define(te[19],ie([0,1,32,13,9,4,26,7]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.DataUri=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=void 0;function f(h){return(0,S.$Ve)(h,!0)}e.$7f=f;class u{constructor(y){this.a=y}compare(y,b,d=!1){return y===b?0:(0,A.$Hd)(this.getComparisonKey(y,d),this.getComparisonKey(b,d))}isEqual(y,b,d=!1){return y===b?!0:!y||!b?!1:this.getComparisonKey(y,d)===this.getComparisonKey(b,d)}getComparisonKey(y,b=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,b,d=!1){if(y.scheme===b.scheme){if(y.scheme===C.Schemas.file)return E.$Ke(f(y),f(b),this.a(y))&&y.query===b.query&&(d||y.fragment===b.fragment);if((0,e.$lg)(y.authority,b.authority))return E.$Ke(y.path,b.path,this.a(y),"/")&&y.query===b.query&&(d||y.fragment===b.fragment)}return!1}joinPath(y,...b){return S.URI.joinPath(y,...b)}basenameOrAuthority(y){return(0,e.$dg)(y)||y.authority}basename(y){return s.$8c.basename(y.path)}extname(y){return s.$8c.extname(y.path)}dirname(y){if(y.path.length===0)return y;let b;return y.scheme===C.Schemas.file?b=S.URI.file(s.$bd(f(y))).path:(b=s.$8c.dirname(y.path),y.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),b="/")),y.with({path:b})}normalizePath(y){if(!y.path.length)return y;let b;return y.scheme===C.Schemas.file?b=S.URI.file(s.$9c(f(y))).path:b=s.$8c.normalize(y.path),y.with({path:b})}relativePath(y,b){if(y.scheme!==b.scheme||!(0,e.$lg)(y.authority,b.authority))return;if(y.scheme===C.Schemas.file){const a=s.$ad(f(y),f(b));return M.$i?E.$Ee(a):a}let d=y.path||"/";const c=b.path||"/";if(this.a(y)){let a=0;for(const w=Math.min(d.length,c.length);a<w&&!(d.charCodeAt(a)!==c.charCodeAt(a)&&d.charAt(a).toLowerCase()!==c.charAt(a).toLowerCase());a++);d=c.substr(0,a)+d.substr(a)}return s.$8c.relative(d,c)}resolvePath(y,b){if(y.scheme===C.Schemas.file){const d=S.URI.file(s.$_c(f(y),b));return y.with({authority:d.authority,path:d.path})}return b=E.$Fe(b),y.with({path:s.$8c.resolve(y.path,b)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,b){return y===b||y!==void 0&&b!==void 0&&(0,A.$Od)(y,b)}hasTrailingPathSeparator(y,b=s.sep){if(y.scheme===C.Schemas.file){const d=f(y);return d.length>E.$Ge(d).length&&d[d.length-1]===b}else{const d=y.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,b=s.sep){return(0,e.$mg)(y,b)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,b=s.sep){let d=!1;if(y.scheme===C.Schemas.file){const c=f(y);d=c!==void 0&&c.length===E.$Ge(c).length&&c[c.length-1]===b}else{b="/";const c=y.path;d=c.length===1&&c.charCodeAt(c.length-1)===47}return!d&&!(0,e.$mg)(y,b)?y.with({path:y.path+"/"}):y}}e.$8f=u,e.$9f=new u(()=>!1),e.$0f=new u(h=>h.scheme===C.Schemas.file?!M.$k:!0),e.$$f=new u(h=>!0),e.$_f=e.$9f.isEqual.bind(e.$9f),e.$ag=e.$9f.isEqualOrParent.bind(e.$9f),e.$bg=e.$9f.getComparisonKey.bind(e.$9f),e.$cg=e.$9f.basenameOrAuthority.bind(e.$9f),e.$dg=e.$9f.basename.bind(e.$9f),e.$eg=e.$9f.extname.bind(e.$9f),e.$fg=e.$9f.dirname.bind(e.$9f),e.$gg=e.$9f.joinPath.bind(e.$9f),e.$hg=e.$9f.normalizePath.bind(e.$9f),e.$ig=e.$9f.relativePath.bind(e.$9f),e.$jg=e.$9f.resolvePath.bind(e.$9f),e.$kg=e.$9f.isAbsolutePath.bind(e.$9f),e.$lg=e.$9f.isEqualAuthority.bind(e.$9f),e.$mg=e.$9f.hasTrailingPathSeparator.bind(e.$9f),e.$ng=e.$9f.removeTrailingPathSeparator.bind(e.$9f),e.$og=e.$9f.addTrailingPathSeparator.bind(e.$9f);function p(h,y){const b=[];for(let d=0;d<h.length;d++){const c=y(h[d]);h.some((a,w)=>w===d?!1:(0,e.$ag)(c,y(a)))||b.push(h[d])}return b}e.$pg=p;var $;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function y(b){const d=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(w=>{const[k,g]=w.split(":");k&&g&&d.set(k,g)});const a=b.path.substring(0,b.path.indexOf(";"));return a&&d.set(h.META_DATA_MIME,a),d}h.parseMetaData=y})($||(e.DataUri=$={}));function v(h,y,b){if(y){let d=h.path;return d&&d[0]!==s.$8c.sep&&(d=s.$8c.sep+d),h.with({scheme:b,authority:y,path:d})}return h.with({scheme:b})}e.$qg=v}),define(te[8],ie([0,1,22,14,3,2,19,4,141]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.$2g=e.$1g=e.Promises=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function u(O){return!!O&&typeof O.then=="function"}e.$rg=u;function p(O){const L=new E.$rc,N=O(L.token),W=new Promise((q,V)=>{const re=L.token.onCancellationRequested(()=>{re.dispose(),L.dispose(),V(new C.$3)});Promise.resolve(N).then($e=>{re.dispose(),L.dispose(),q($e)},$e=>{re.dispose(),L.dispose(),V($e)})});return new class{cancel(){L.cancel()}then(q,V){return W.then(q,V)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.$sg=p;function $(O,L,N){return new Promise((W,q)=>{const V=L.onCancellationRequested(()=>{V.dispose(),W(N)});O.then(W,q).finally(()=>V.dispose())})}e.$tg=$;function v(O,L){return new Promise((N,W)=>{const q=L.onCancellationRequested(()=>{q.dispose(),W(new C.$3)});O.then(N,W).finally(()=>q.dispose())})}e.$ug=v;async function h(O){let L=-1;const N=O.map((W,q)=>W.then(V=>(L=q,V)));try{return await Promise.race(N)}finally{O.forEach((W,q)=>{q!==L&&W.cancel()})}}e.$vg=h;function y(O,L,N){let W;const q=setTimeout(()=>{W?.(void 0),N?.()},L);return Promise.race([O.finally(()=>clearTimeout(q)),new Promise(V=>W=V)])}e.$wg=y;function b(O){return new Promise((L,N)=>{const W=O();u(W)?W.then(L,N):L(W)})}e.$xg=b;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=L,!this.b){const N=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(N,N).then(W)})}return new Promise((N,W)=>{this.b.then(N,W)})}return this.a=L(),new Promise((N,W)=>{this.a.then(q=>{this.a=null,N(q)},q=>{this.a=null,W(q)})})}dispose(){this.f=!0}}e.$yg=d;class c{constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$zg=c;class a{constructor(){this.a=new Map}queue(L,N){const q=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(L)===q&&this.a.delete(L)});return this.a.set(L,q),q}}e.$Ag=a;const w=(O,L)=>{let N=!0;const W=setTimeout(()=>{N=!1,L()},O);return{isTriggered:()=>N,dispose:()=>{clearTimeout(W),N=!1}}},k=O=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,O())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class g{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,N=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((q,V)=>{this.d=q,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=N===f.$ec?k(W):w(N,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bg=g;class t{constructor(L){this.a=new g(L),this.b=new d}trigger(L,N){return this.a.trigger(()=>this.b.queue(L),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Cg=t;class l{constructor(){this.a=!1,this.b=new Promise((L,N)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dg=l;class r extends l{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$Eg=r;function i(O,L){return L?new Promise((N,W)=>{const q=setTimeout(()=>{V.dispose(),N()},O),V=L.onCancellationRequested(()=>{clearTimeout(q),V.dispose(),W(new C.$3)})}):p(N=>i(O,N))}e.$Fg=i;function n(O,L=0){const N=setTimeout(O,L);return(0,M.$kb)(()=>clearTimeout(N))}e.$Gg=n;function o(O){const L=[];let N=0;const W=O.length;function q(){return N<W?O[N++]():null}function V(re){re!=null&&L.push(re);const $e=q();return $e?$e.then(V):Promise.resolve(L)}return Promise.resolve(null).then(V)}e.$Hg=o;function m(O,L=W=>!!W,N=null){let W=0;const q=O.length,V=()=>{if(W>=q)return Promise.resolve(N);const re=O[W++];return Promise.resolve(re()).then(de=>L(de)?Promise.resolve(de):V())};return V()}e.$Ig=m;function I(O,L=W=>!!W,N=null){if(O.length===0)return Promise.resolve(N);let W=O.length;const q=()=>{W=-1;for(const V of O)V.cancel?.()};return new Promise((V,re)=>{for(const $e of O)$e.then(de=>{--W>=0&&L(de)?(q(),V(de)):W===0&&V(N)}).catch(de=>{--W>=0&&(q(),re(de))})})}e.$Jg=I;class D{constructor(L){this.a=0,this.d=L,this.f=[],this.b=0,this.g=new s.$hc}get onDrained(){return this.g.event}get size(){return this.a}queue(L){return this.a++,new Promise((N,W)=>{this.f.push({factory:L,c:N,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const L=this.f.shift();this.b++;const N=L.factory();N.then(L.c,L.e),N.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Kg=D;class P extends D{constructor(){super(1)}}e.$Lg=P;class R{constructor(){this.a=new Y,this.b=0}queue(L){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,L())):this.a.run(this.b++,L())}}e.$Mg=R;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const L=new U;return this.b.add(L),L.p}g(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueFor(L,N=A.$9f){const W=N.getComparisonKey(L);let q=this.a.get(W);if(!q){q=new P;const V=this.f++,re=s.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(V),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$ub),this.d.set(V,re),this.a.set(W,q)}return q}h(){this.g()&&this.j()}j(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ng=j;class T{constructor(L,N){this.a=-1,typeof L=="function"&&typeof N=="number"&&this.setIfNotSet(L,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},N)}setIfNotSet(L,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},N))}}e.$Og=T;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(L,N){this.cancel(),this.a=setInterval(()=>{L()},N)}}e.$Pg=z;class ne{constructor(L,N){this.b=-1,this.a=L,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qg=ne;class ee{constructor(L,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=L,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rg=ee;class ce extends ne{constructor(L,N){super(L,N),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$Sg=ce;class se extends M.$mb{constructor(L,N){super(),this.g=L,this.h=N,this.a=[],this.b=this.B(new M.$nb),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const N of L)this.a.push(N);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Tg=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ug=O=>{(0,S.$A)(()=>{if(L)return;const N=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.$Ug=(O,L)=>{const N=requestIdleCallback(O,typeof L=="number"?{timeout:L}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(N))}}}}();class ae{constructor(L){this.d=!1,this.a=()=>{try{this.f=L()}catch(N){this.g=N}finally{this.d=!0}},this.b=(0,e.$Ug)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Vg=ae;async function J(O,L,N){let W;for(let q=0;q<N;q++)try{return await O()}catch(V){W=V,await i(L)}throw W}e.$Wg=J;class Y{isRunning(L){return typeof L=="number"?this.a?.taskId===L:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(L,N,W){return this.a={taskId:L,cancel:()=>W?.(),promise:N},N.then(()=>this.d(L),()=>this.d(L)),N}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this.b)this.b.run=L;else{let N,W;const q=new Promise((V,re)=>{N=V,W=re});this.b={run:L,promise:q,promiseResolve:N,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xg=Y;class B{constructor(L,N=()=>Date.now()){this.d=L,this.f=N,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$Yg=B;var F;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(F||(F={}));class U{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,N)=>{this.a=L,this.b=N})}complete(L){return new Promise(N=>{this.a(L),this.d={outcome:0,value:L},N()})}error(L){return new Promise(N=>{this.b(L),this.d={outcome:1,value:L},N()})}cancel(){return this.error(new C.$3)}}e.$Zg=U;var H;(function(O){async function L(W){let q;const V=await Promise.all(W.map(re=>re.then($e=>$e,$e=>{q||(q=$e)})));if(typeof q<"u")throw q;return V}O.settled=L;function N(W){return new Promise(async(q,V)=>{try{await W(q,V)}catch(re){V(re)}})}O.withAsyncBody=N})(H||(e.Promises=H={}));var Q;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Q||(Q={}));class x{static fromArray(L){return new x(N=>{N.emitMany(L)})}static fromPromise(L){return new x(async N=>{N.emitMany(await L)})}static fromPromises(L){return new x(async N=>{await Promise.all(L.map(async W=>N.emitOne(await W)))})}static merge(L){return new x(async N=>{await Promise.all(L.map(async W=>{for await(const q of W)N.emitOne(q)}))})}static{this.EMPTY=x.fromArray([])}constructor(L){this.a=0,this.b=[],this.d=null,this.f=new s.$hc,queueMicrotask(async()=>{const N={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(L(N)),this.j()}catch(W){this.k(W)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(L,N){return new x(async W=>{for await(const q of L)W.emitOne(N(q))})}map(L){return x.map(this,L)}static filter(L,N){return new x(async W=>{for await(const q of L)N(q)&&W.emitOne(q)})}filter(L){return x.filter(this,L)}static coalesce(L){return x.filter(L,N=>!!N)}coalesce(){return x.coalesce(this)}static async toPromise(L){const N=[];for await(const W of L)N.push(W);return N}toPromise(){return x.toPromise(this)}g(L){this.a===0&&(this.b.push(L),this.f.fire())}h(L){this.a===0&&(this.b=this.b.concat(L),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(L){this.a===0&&(this.a=2,this.d=L,this.f.fire())}}e.$1g=x;class oe extends x{constructor(L,N){super(N),this.l=L}cancel(){this.l.cancel()}}e.$2g=oe;function K(O){const L=new E.$rc,N=O(L.token);return new oe(L,async W=>{const q=L.token.onCancellationRequested(()=>{q.dispose(),L.dispose(),W.reject(new C.$3)});try{for await(const V of N){if(L.token.isCancellationRequested)return;W.emitOne(V)}q.dispose(),L.dispose()}catch(V){q.dispose(),L.dispose(),W.reject(V)}})}e.$3g=K}),define(te[104],ie([0,1,24,8,32,34,9,4,26]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0;function u(){return Object.create(null)}e.$kj=u,e.$lj="**",e.$mj="/";const p="[/\\\\]",$="[^/\\\\]",v=/\//g;function h(Y,B){switch(Y){case 0:return"";case 1:return`${$}*?`;default:return`(?:${p}|${$}+${p}${B?`|${p}${$}+`:""})*?`}}function y(Y,B){if(!Y)return[];const F=[];let U=!1,H=!1,Q="";for(const x of Y){switch(x){case B:if(!U&&!H){F.push(Q),Q="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":H=!0;break;case"]":H=!1;break}Q+=x}return Q&&F.push(Q),F}e.$nj=y;function b(Y){if(!Y)return"";let B="";const F=y(Y,e.$mj);if(F.every(U=>U===e.$lj))B=".*";else{let U=!1;F.forEach((H,Q)=>{if(H===e.$lj){if(U)return;B+=h(2,Q===F.length-1)}else{let x=!1,oe="",K=!1,O="";for(const L of H){if(L!=="}"&&x){oe+=L;continue}if(K&&(L!=="]"||!O)){let N;L==="-"?N=L:(L==="^"||L==="!")&&!O?N="^":L===e.$mj?N="":N=(0,f.$sd)(L),O+=N;continue}switch(L){case"{":x=!0;continue;case"[":K=!0;continue;case"}":{const W=`(?:${y(oe,",").map(q=>b(q)).join("|")})`;B+=W,x=!1,oe="";break}case"]":{B+="["+O+"]",K=!1,O="";break}case"?":B+=$;continue;case"*":B+=h(1);continue;default:B+=(0,f.$sd)(L)}}Q<F.length-1&&(F[Q+1]!==e.$lj||Q+2<F.length)&&(B+=p)}U=H===e.$lj})}return B}const d=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Ai(1e4),l=function(){return!1},r=function(){return null};function i(Y,B){if(!Y)return r;let F;typeof Y!="string"?F=Y.pattern:F=Y,F=F.trim();const U=`${F}_${!!B.trimForExclusions}`;let H=t.get(U);if(H)return n(H,Y);let Q;return d.test(F)?H=m(F.substr(4),F):(Q=c.exec(o(F,B)))?H=I(Q[1],F):(B.trimForExclusions?w:a).test(F)?H=D(F,B):(Q=k.exec(o(F,B)))?H=P(Q[1].substr(1),F,!0):(Q=g.exec(o(F,B)))?H=P(Q[1],F,!1):H=R(F),t.set(U,H),n(H,Y)}function n(Y,B){if(typeof B=="string")return Y;const F=function(U,H){return(0,s.$Ke)(U,B.base,!S.$k)?Y((0,f.$wd)(U.substr(B.base.length),A.sep),H):null};return F.allBasenames=Y.allBasenames,F.allPaths=Y.allPaths,F.basenames=Y.basenames,F.patterns=Y.patterns,F}function o(Y,B){return B.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function m(Y,B){return function(F,U){return typeof F=="string"&&F.endsWith(Y)?B:null}}function I(Y,B){const F=`/${Y}`,U=`\\${Y}`,H=function(x,oe){return typeof x!="string"?null:oe?oe===Y?B:null:x===Y||x.endsWith(F)||x.endsWith(U)?B:null},Q=[Y];return H.basenames=Q,H.patterns=[B],H.allBasenames=Q,H}function D(Y,B){const F=ae(Y.slice(1,-1).split(",").map(oe=>i(oe,B)).filter(oe=>oe!==r),Y),U=F.length;if(!U)return r;if(U===1)return F[0];const H=function(oe,K){for(let O=0,L=F.length;O<L;O++)if(F[O](oe,K))return Y;return null},Q=F.find(oe=>!!oe.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const x=F.reduce((oe,K)=>K.allPaths?oe.concat(K.allPaths):oe,[]);return x.length&&(H.allPaths=x),H}function P(Y,B,F){const U=A.sep===A.$8c.sep,H=U?Y:Y.replace(v,A.sep),Q=A.sep+H,x=A.$8c.sep+Y;let oe;return F?oe=function(K,O){return typeof K=="string"&&(K===H||K.endsWith(Q)||!U&&(K===Y||K.endsWith(x)))?B:null}:oe=function(K,O){return typeof K=="string"&&(K===H||!U&&K===Y)?B:null},oe.allPaths=[(F?"*/":"./")+Y],oe}function R(Y){try{const B=new RegExp(`^${b(Y)}$`);return function(F){return B.lastIndex=0,typeof F=="string"&&B.test(F)?Y:null}}catch{return r}}function j(Y,B,F){return!Y||typeof B!="string"?!1:T(Y)(B,void 0,F)}e.$oj=j;function T(Y,B={}){if(!Y)return l;if(typeof Y=="string"||z(Y)){const F=i(Y,B);if(F===r)return l;const U=function(H,Q){return!!F(H,Q)};return F.allBasenames&&(U.allBasenames=F.allBasenames),F.allPaths&&(U.allPaths=F.allPaths),U}return ce(Y,B)}e.$pj=T;function z(Y){const B=Y;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.$qj=z;function ne(Y){return Y.allBasenames||[]}e.$rj=ne;function ee(Y){return Y.allPaths||[]}e.$sj=ee;function ce(Y,B){const F=ae(Object.getOwnPropertyNames(Y).map(oe=>se(oe,Y[oe],B)).filter(oe=>oe!==r)),U=F.length;if(!U)return r;if(!F.some(oe=>!!oe.requiresSiblings)){if(U===1)return F[0];const oe=function(L,N){let W;for(let q=0,V=F.length;q<V;q++){const re=F[q](L,N);if(typeof re=="string")return re;(0,C.$rg)(re)&&(W||(W=[]),W.push(re))}return W?(async()=>{for(const q of W){const V=await q;if(typeof V=="string")return V}return null})():null},K=F.find(L=>!!L.allBasenames);K&&(oe.allBasenames=K.allBasenames);const O=F.reduce((L,N)=>N.allPaths?L.concat(N.allPaths):L,[]);return O.length&&(oe.allPaths=O),oe}const H=function(oe,K,O){let L,N;for(let W=0,q=F.length;W<q;W++){const V=F[W];V.requiresSiblings&&O&&(K||(K=(0,A.$cd)(oe)),L||(L=K.substr(0,K.length-(0,A.$dd)(oe).length)));const re=V(oe,K,L,O);if(typeof re=="string")return re;(0,C.$rg)(re)&&(N||(N=[]),N.push(re))}return N?(async()=>{for(const W of N){const q=await W;if(typeof q=="string")return q}return null})():null},Q=F.find(oe=>!!oe.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const x=F.reduce((oe,K)=>K.allPaths?oe.concat(K.allPaths):oe,[]);return x.length&&(H.allPaths=x),H}function se(Y,B,F){if(B===!1)return r;const U=i(Y,F);if(U===r)return r;if(typeof B=="boolean")return U;if(B){const H=B.when;if(typeof H=="string"){const Q=(x,oe,K,O)=>{if(!O||!U(x,oe))return null;const L=H.replace("$(basename)",()=>K),N=O(L);return(0,C.$rg)(N)?N.then(W=>W?Y:null):N?Y:null};return Q.requiresSiblings=!0,Q}}return U}function ae(Y,B){const F=Y.filter(oe=>!!oe.basenames);if(F.length<2)return Y;const U=F.reduce((oe,K)=>{const O=K.basenames;return O?oe.concat(O):oe},[]);let H;if(B){H=[];for(let oe=0,K=U.length;oe<K;oe++)H.push(B)}else H=F.reduce((oe,K)=>{const O=K.patterns;return O?oe.concat(O):oe},[]);const Q=function(oe,K){if(typeof oe!="string")return null;if(!K){let L;for(L=oe.length;L>0;L--){const N=oe.charCodeAt(L-1);if(N===47||N===92)break}K=oe.substr(L)}const O=U.indexOf(K);return O!==-1?H[O]:null};Q.basenames=U,Q.patterns=H,Q.allBasenames=U;const x=Y.filter(oe=>!oe.basenames);return x.push(Q),x}function J(Y,B){return(0,E.$of)(Y,B,(F,U)=>typeof F=="string"&&typeof U=="string"?F===U:typeof F!="string"&&typeof U!="string"?F.base===U.base&&F.pattern===U.pattern:!1)}e.$tj=J}),define(te[46],ie([0,1,24,32,9,4,19,26]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=e.$bA=e.$aA=void 0;function f(i,n){const{os:o,tildify:m,relative:I}=n;if(I){const R=u(i,I,o);if(typeof R=="string")return R}let D=i.fsPath;if(o===1&&!M.$i?D=D.replace(/\//g,"\\"):o!==1&&M.$i&&(D=D.replace(/\\/g,"/")),o!==1&&m?.userHome){const R=m.userHome.fsPath;let j;i.scheme!==m.userHome.scheme&&i.path.startsWith(s.$8c.sep)?j=m.userHome.with({path:i.path}).fsPath:j=i.fsPath,D=v(j,R,o)}return(o===1?s.$7c:s.$8c).normalize(p(D,o===1))}e.$aA=f;function u(i,n,o){const m=o===1?s.$7c:s.$8c,I=o===3?A.$9f:A.$$f,D=n.getWorkspace(),P=(0,E.$Hf)(D.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path.startsWith(s.$8c.sep)&&(i=P.uri.with({path:i.path}));const R=n.getWorkspaceFolder(i);if(!R)return;let j;if(I.isEqual(R.uri,i)?j="":j=I.relativePath(R.uri,i)??"",j&&(j=m.normalize(j)),D.folders.length>1&&!n.noPrefix){const T=R.name?R.name:I.basenameOrAuthority(R.uri);j=j?`${T} \u2022 ${j}`:T}return j}function p(i,n=M.$i){return(0,C.$Oe)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$bA=p;let $=Object.create(null);function v(i,n,o=M.OS){if(o===1||!i||!n)return i;let m=$.original===n?$.normalized:void 0;m||(m=n,M.$i&&(m=(0,C.$Ee)(m)),m=`${(0,S.$xd)(m,s.$8c.sep)}${s.$8c.sep}`,$={original:n,normalized:m});let I=i;return M.$i&&(I=(0,C.$Ee)(I)),(o===3?I.startsWith(m):(0,S.$Pd)(I,m))?`~/${I.substr(m.length)}`:i}e.$cA=v;function h(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$dA=h;const y="\u2026",b="\\\\",d="~";function c(i,n=s.sep){const o=new Array(i.length);let m=!1;for(let I=0;I<i.length;I++){const D=i[I];if(D===""){o[I]=`.${n}`;continue}if(!D){o[I]=D;continue}m=!0;let P="",R=D;R.indexOf(b)===0?(P=R.substr(0,R.indexOf(b)+b.length),R=R.substr(R.indexOf(b)+b.length)):R.indexOf(n)===0?(P=R.substr(0,R.indexOf(n)+n.length),R=R.substr(R.indexOf(n)+n.length)):R.indexOf(d)===0&&(P=R.substr(0,R.indexOf(d)+d.length),R=R.substr(R.indexOf(d)+d.length));const j=R.split(n);for(let T=1;m&&T<=j.length;T++)for(let z=j.length-T;m&&z>=0;z--){m=!1;let ne=j.slice(z,z+T).join(n);for(let ee=0;!m&&ee<i.length;ee++)if(ee!==I&&i[ee]&&i[ee].indexOf(ne)>-1){const ce=z+T===j.length,se=z>0&&i[ee].indexOf(n)>-1?n+ne:ne,ae=i[ee].endsWith(se);m=!ce||ae}if(!m){let ee="";(j[0].endsWith(":")||P!=="")&&(z===1&&(z=0,T++,ne=j[0]+n+ne),z>0&&(ee=j[0]+n),ee=P+ee),z>0&&(ee=ee+y+n),ee=ee+ne,z+T<j.length&&(ee=ee+n+y),o[I]=ee}}m&&(o[I]=D)}return o}e.$eA=c;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function w(i,n=Object.create(null)){const o=[];let m=!1,I="";for(const D of i)if(D==="$"||m&&D==="{")I&&o.push({value:I,type:a.TEXT}),I="",m=!0;else if(D==="}"&&m){const P=n[I];if(typeof P=="string")P.length&&o.push({value:P,type:a.VARIABLE});else if(P){const R=o[o.length-1];(!R||R.type!==a.SEPARATOR)&&o.push({value:P.label,type:a.SEPARATOR})}I="",m=!1}else I+=D;return I&&!m&&o.push({value:I,type:a.TEXT}),o.filter((D,P)=>{if(D.type===a.SEPARATOR){const R=o[P-1],j=o[P+1];return[R,j].every(T=>T&&(T.type===a.VARIABLE||T.type===a.TEXT)&&T.value.length>0)}return!0}).map(D=>D.value).join("")}e.$fA=w;function k(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$gA=k;function g(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$hA=g;function t(i){return i.replace(/&/g,"&&")}e.$iA=t;function l(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=r(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return r(i)}e.$jA=l;function r(i){const n=i.indexOf("/")!==-1?s.$8c:s.$7c,o=n.basename(i),m=n.dirname(i);return o.length?{name:o,parentPath:m}:{name:m,parentPath:""}}}),define(te[154],ie([0,1,17,7]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=void 0;function s($){return $.toJSON()}class M{constructor(v){this.a=v}transformIncoming(v){const h=this.a.transformIncoming(v);return h===v?v:s(C.URI.from(h))}transformOutgoing(v){const h=this.a.transformOutgoing(v);return h===v?v:s(C.URI.from(h))}transformOutgoingURI(v){const h=this.a.transformOutgoing(v);return h===v?v:C.URI.from(h)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$zm=M,e.$Am=new class{transformIncoming($){return $}transformOutgoing($){return $}transformOutgoingURI($){return $}transformOutgoingScheme($){return $}};function A($,v,h){if(!$||h>200)return null;if(typeof $=="object"){if($ instanceof C.URI)return v.transformOutgoing($);for(const y in $)if(Object.hasOwnProperty.call($,y)){const b=A($[y],v,h+1);b!==null&&($[y]=b)}}return null}function S($,v){const h=A($,v,0);return h===null?$:h}e.$Bm=S;function f($,v,h,y){if(!$||y>200)return null;if(typeof $=="object"){if($.$mid===1)return h?C.URI.revive(v.transformIncoming($)):v.transformIncoming($);if($ instanceof E.$Hc)return null;for(const b in $)if(Object.hasOwnProperty.call($,b)){const d=f($[b],v,h,y+1);d!==null&&($[b]=d)}}return null}function u($,v){const h=f($,v,!1,0);return h===null?$:h}e.$Cm=u;function p($,v){const h=f($,v,!0,0);return h===null?$:h}e.$Dm=p}),define(te[21],ie([0,1,45,27,155,8,32,85,9,4,19,7]),function(G,e,E,C,s,M,A,S,f,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function h(se,ae=v.UNLINK,J){if((0,A.$Ne)(se))throw new Error("rimraf - will refuse to recursively delete root");return ae===v.UNLINK?b(se):y(se,J)}async function y(se,ae=(0,A.$Se)((0,C.tmpdir)())){try{try{await E.promises.rename(se,ae)}catch(J){return J.code==="ENOENT"?void 0:b(se)}b(ae).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function b(se){return(0,s.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function d(se){if((0,A.$Ne)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function c(se,ae){return k(await(ae?a(se):(0,s.promisify)(E.readdir)(se)))}async function a(se){try{return await(0,s.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ae=[],J=await c(se);for(const Y of J){let B=!1,F=!1,U=!1;try{const H=await e.Promises.lstat((0,f.$$c)(se,Y));B=H.isFile(),F=H.isDirectory(),U=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ae.push({name:Y,isFile:()=>B,isDirectory:()=>F,isSymbolicLink:()=>U})}return ae}function w(se){return k(E.readdirSync(se))}e.readdirSync=w;function k(se){return se.map(ae=>typeof ae=="string"?u.$j?(0,S.$fl)(ae):ae:(ae.name=u.$j?(0,S.$fl)(ae.name):ae.name,ae))}async function g(se){const ae=await c(se),J=[];for(const Y of ae)await l.existsDirectory((0,f.$$c)(se,Y))&&J.push(Y);return J}function t(se,ae=1e3){return new Promise(J=>{let Y=!1;const B=setInterval(()=>{Y||(Y=!0,E.access(se,F=>{Y=!1,F&&(clearInterval(B),J(void 0))}))},ae)})}e.whenDeleted=t;var l;(function(se){async function ae(B){let F;try{if(F=await e.Promises.lstat(B),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(u.$i&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw H}throw U}}se.stat=ae;async function J(B){try{const{stat:F,symbolicLink:U}=await se.stat(B);return F.isFile()&&U?.dangling!==!0}catch{}return!1}se.existsFile=J;async function Y(B){try{const{stat:F,symbolicLink:U}=await se.stat(B);return F.isDirectory()&&U?.dangling!==!0}catch{}return!1}se.existsDirectory=Y})(l||(e.SymlinkSupport=l={}));const r=new M.$Ng;function i(se,ae,J){return r.queueFor($.URI.file(se),p.$0f).queue(()=>{const Y=D(J);return new Promise((B,F)=>m(se,ae,Y,U=>U?F(U):B()))})}let n=!0;function o(se){n=se}e.configureFlushOnWrite=o;function m(se,ae,J,Y){if(!n)return E.writeFile(se,ae,{mode:J.mode,flag:J.flag},Y);E.open(se,J.flag,J.mode,(B,F)=>{if(B)return Y(B);E.writeFile(F,ae,U=>{if(U)return E.close(F,()=>Y(U));E.fdatasync(F,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),o(!1)),E.close(F,Q=>Y(Q))))})})}function I(se,ae,J){const Y=D(J);if(!n)return E.writeFileSync(se,ae,{mode:Y.mode,flag:Y.flag});const B=E.openSync(se,Y.flag,Y.mode);try{E.writeFileSync(B,ae);try{E.fdatasyncSync(B)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),o(!1)}}finally{E.closeSync(B)}}e.writeFileSync=I;function D(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function P(se,ae,J=6e4){if(se!==ae)try{u.$i&&typeof J=="number"?await R(se,ae,Date.now(),J):await(0,s.promisify)(E.rename)(se,ae)}catch(Y){if(se.toLowerCase()!==ae.toLowerCase()&&Y.code==="EXDEV"||se.endsWith("."))await j(se,ae,{preserveSymlinks:!1}),await h(se,v.MOVE);else throw Y}}async function R(se,ae,J,Y,B=0){try{return await(0,s.promisify)(E.rename)(se,ae)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-J>=Y)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${F}`),F;if(B===0){let U=!1;try{const{stat:H}=await l.stat(ae);H.isFile()||(U=!0)}catch{}if(U)throw F}return await(0,M.$Fg)(Math.min(100,B*10)),R(se,ae,J,Y,B+1)}}async function j(se,ae,J){return z(se,ae,{root:{source:se,target:ae},options:J,handledSourcePaths:new Set})}const T=511;async function z(se,ae,J){if(J.handledSourcePaths.has(se))return;J.handledSourcePaths.add(se);const{stat:Y,symbolicLink:B}=await l.stat(se);if(B){if(J.options.preserveSymlinks)try{return await ce(se,ae,J)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(B.dangling)return}return Y.isDirectory()?ne(se,ae,Y.mode&T,J):ee(se,ae,Y.mode&T)}async function ne(se,ae,J,Y){await e.Promises.mkdir(ae,{recursive:!0,mode:J});const B=await c(se);for(const F of B)await z((0,f.$$c)(se,F),(0,f.$$c)(ae,F),Y)}async function ee(se,ae,J){await e.Promises.copyFile(se,ae),await e.Promises.chmod(ae,J)}async function ce(se,ae,J){let Y=await e.Promises.readlink(se);(0,A.$Ke)(Y,J.root.source,!u.$k)&&(Y=(0,f.$$c)(J.root.target,Y.substr(J.root.source.length+1))),await e.Promises.symlink(Y,ae)}e.Promises=new class{get access(){return(0,s.promisify)(E.access)}get stat(){return(0,s.promisify)(E.stat)}get lstat(){return(0,s.promisify)(E.lstat)}get utimes(){return(0,s.promisify)(E.utimes)}get read(){return(se,ae,J,Y,B)=>new Promise((F,U)=>{E.read(se,ae,J,Y,B,(H,Q,x)=>H?U(H):F({bytesRead:Q,buffer:x}))})}get readFile(){return(0,s.promisify)(E.readFile)}get write(){return(se,ae,J,Y,B)=>new Promise((F,U)=>{E.write(se,ae,J,Y,B,(H,Q,x)=>H?U(H):F({bytesWritten:Q,buffer:x}))})}get appendFile(){return(0,s.promisify)(E.appendFile)}get fdatasync(){return(0,s.promisify)(E.fdatasync)}get truncate(){return(0,s.promisify)(E.truncate)}get copyFile(){return(0,s.promisify)(E.copyFile)}get open(){return(0,s.promisify)(E.open)}get close(){return(0,s.promisify)(E.close)}get symlink(){return(0,s.promisify)(E.symlink)}get readlink(){return(0,s.promisify)(E.readlink)}get chmod(){return(0,s.promisify)(E.chmod)}get mkdir(){return(0,s.promisify)(E.mkdir)}get unlink(){return(0,s.promisify)(E.unlink)}get rmdir(){return(0,s.promisify)(E.rmdir)}get realpath(){return(0,s.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return g}get writeFile(){return i}get rm(){return h}get rename(){return P}get copy(){return j}}}),define(te[105],ie([0,1,45,9,4,26,21]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function S(v){if(s.$k)return v;const h=(0,C.$bd)(v);if(v===h)return v;const y=((0,C.$cd)(v)||v).toLowerCase();try{const d=(0,A.readdirSync)(h).filter(c=>c.toLowerCase()===y);if(d.length===1){const c=S(h);if(c)return(0,C.$$c)(c,d[0])}else if(d.length>1){const c=d.indexOf(y);if(c>=0){const a=S(h);if(a)return(0,C.$$c)(a,d[c])}}}catch{}return null}e.$Rp=S;async function f(v){if(s.$k)return v;const h=(0,C.$bd)(v);if(v===h)return v;const y=((0,C.$cd)(v)||v).toLowerCase();try{const d=(await A.Promises.readdir(h)).filter(c=>c.toLowerCase()===y);if(d.length===1){const c=await f(h);if(c)return(0,C.$$c)(c,d[0])}else if(d.length>1){const c=d.indexOf(y);if(c>=0){const a=await f(h);if(a)return(0,C.$$c)(a,d[c])}}}catch{}return null}e.$Sp=f;async function u(v){try{return await A.Promises.realpath(v)}catch{const y=$(v);return await A.Promises.access(y,E.constants.R_OK),y}}e.$Tp=u;function p(v){try{return E.realpathSync(v)}catch{const y=$(v);return E.accessSync(y,E.constants.R_OK),y}}e.$Up=p;function $(v){return(0,M.$xd)((0,C.$9c)(v),C.sep)}}),define(te[106],ie([0,1,27,9,21]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=void 0;const M=/^\d+$/,A=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class ${constructor(g,t,l){this.exePath=g,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:k=!1}={}){return k?u===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:k=!1,findPreview:g=!1}={}){const t=v({useAlternateBitness:k});if(!t)return null;const l=C.$$c(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(l))return null;let r=-1,i=null;for(const m of await s.Promises.readdir(l)){let I=-1;if(g){const P=m.indexOf("-");if(P<0)continue;const R=m.substring(0,P);if(!M.test(R)||m.substring(P+1)!=="preview")continue;I=parseInt(R,10)}else{if(!M.test(m))continue;I=parseInt(m,10)}if(I<=r)continue;const D=C.$$c(l,m,"pwsh.exe");await s.SymlinkSupport.existsFile(D)&&(i=D,r=I)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=g?" Preview":"";return new $(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const g=C.$$c(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=k?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(g))if(t.test(r)){const i=C.$$c(g,r,"pwsh.exe");return new $(i,l)}return null}function b(){const k=C.$$c(E.homedir(),".dotnet","tools","pwsh.exe");return new $(k,".NET Core PowerShell Global Tool")}function d(){const k=C.$$c(process.env.windir,u===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new $(k,"Windows PowerShell",!0)}async function*c(){let k=await h();k&&(yield k),k=await h({useAlternateBitness:!0}),k&&(yield k),k=await y(),k&&(yield k),k=b(),k&&(yield k),k=await h({findPreview:!0}),k&&(yield k),k=await y({findPreview:!0}),k&&(yield k),k=await h({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=d(),k&&(yield k)}async function*a(){for await(const k of c())await k.exists()&&(yield k)}e.$ol=a;async function w(){for await(const k of a())return k;return null}e.$pl=w}),define(te[88],ie([0,1,9,4,35,73,12,21]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f($=s.env){return $.comspec||"cmd.exe"}e.$sl=f;function u($){let v=[],h=!1;const y=function(b){if(h){v.push(b);return}(!$.send(b,c=>{if(c&&console.error(c),h=!1,v.length>0){const a=v.slice(0);v=[],a.forEach(w=>y(w))}})||C.$i)&&(h=!0)};return{send:y}}e.$tl=u;var p;(function($){async function v(h,y,b){if(E.$0c(h))return h;if(y===void 0&&(y=s.cwd()),E.$bd(h)!=="."||(b===void 0&&A.$le(s.env.PATH)&&(b=s.env.PATH.split(E.$id)),b===void 0||b.length===0))return E.$$c(y,h);async function c(a){if(await S.Promises.exists(a)){let w;try{w=await S.Promises.stat(a)}catch(k){k.message.startsWith("EACCES")&&(w=await S.Promises.lstat(a))}return w?!w.isDirectory():!1}return!1}for(const a of b){let w;if(E.$0c(a)?w=E.$$c(a,h):w=E.$$c(y,a,h),await c(w))return w;let k=w+".com";if(await c(k)||(k=w+".exe",await c(k)))return k}return E.$$c(y,h)}$.findExecutable=v})(p||(e.win32=p={}))}),define(te[107],ie([0,1,47,13]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;function s(A){return new Promise((S,f)=>{let u;const p=new Map;function $(h,y,b,d,c){const a=p.get(y);if(h===A||a){const w={name:v(b),cmd:b,pid:h,ppid:y,load:d,mem:c};p.set(h,w),h===A&&(u=w),a&&(a.children||(a.children=[]),a.children.push(w),a.children.length>1&&(a.children=a.children.sort((k,g)=>k.pid-g.pid)))}}function v(h){const y=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,d=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,a=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(d.exec(h))return"electron-crash-reporter";if(c.exec(h))return"winpty-agent";if(a.exec(h))return"conpty-agent";let k=w.exec(h);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?y.exec(h)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const g=/[a-zA-Z-]+\.js/g;let t="";do k=g.exec(h),k&&(t+=k+" ");while(k);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,b)=>{G(["@vscode/windows-process-tree"],y,b)}).then(y=>{y.getProcessList(A,b=>{if(!b){f(new Error(`Root process ${A} not found`));return}y.getProcessCpuUsage(b,d=>{const c=new Map;d.forEach(a=>{const w=h(a.commandLine||"");c.set(a.pid,{name:v(w),cmd:w,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),u=c.get(A),u?(c.forEach(a=>{const w=c.get(a.ppid);w&&(w.children||(w.children=[]),w.children.push(a))}),c.forEach(a=>{a.children&&(a.children=a.children.sort((w,k)=>w.pid-k.pid))}),S(u)):f(new Error(`Root process ${A} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let h=function(){let y=[u];const b=[];for(;y.length;){const c=y.shift();c&&(b.push(c.pid),c.children&&(y=y.concat(c.children)))}let d=JSON.stringify(C.$4e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+b.join(" "),(0,E.exec)(d,{},(c,a,w)=>{if(c||w)f(c||new Error(w.toString()));else{const k=a.toString().split(`
`);for(let g=0;g<b.length;g++){const t=p.get(b[g]);t.load=parseFloat(k[g])}if(!u){f(new Error(`Root process ${A} not found`));return}S(u)}})};(0,E.exec)("which ps",{},(y,b,d)=>{if(y||d)if(process.platform!=="linux")f(y||new Error(d.toString()));else{const c=JSON.stringify(C.$4e.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(c,{},(a,w,k)=>{a||k?f(a||new Error(k.toString())):(M(w,$),h())})}else{const c=b.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${c} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,k,g)=>{w||g&&!g.includes("screen size is bogus")?f(w||new Error(g.toString())):(M(k,$),process.platform==="linux"?h():u?S(u):f(new Error(`Root process ${A} not found`)))})}})}})}e.$pr=s;function M(A,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=A.toString().split(`
`);for(const p of u){const $=f.exec(p.trim());$&&$.length===6&&S(parseInt($[1]),parseInt($[2]),$[5],parseFloat($[3]),parseFloat($[4]))}}}),define(te[108],ie([0,1,27,4,106,88]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0;async function A($,v){return $===1?C.$i?p():M.$sl(v):f($,v)}e.$ul=A;let S=null;function f($,v){if(C.$k&&$===2||C.$j&&$===3)return"/bin/bash";if(!S){let h;if(C.$i)h="/bin/bash";else{if(h=v.SHELL,!h)try{h=(0,E.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}S=h}return S}let u=null;async function p(){return u||(u=(await(0,s.$pl)()).exePath),u}});var ke=this&&this.__decorate||function(G,e,E,C){var s=arguments.length,M=s<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,E):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(G,e,E,C);else for(var S=G.length-1;S>=0;S--)(A=G[S])&&(M=(s<3?A(M):s>3?A(e,E,M):A(e,E))||M);return s>3&&M&&Object.defineProperty(e,E,M),M};define(te[42],ie([0,1,24,8,17,22,55,14,3,2,74,26,12]),function(G,e,E,C,s,M,A,S,f,u,p,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.ProxyChannel=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.RequestInitiator=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=void 0;var h;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(h||(h={}));function y(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(b||(b={}));function d(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(c||(c={}));function a(B){let F=0;for(let U=0;;U+=7){const H=B.read(1);if(F|=(H.buffer[0]&127)<<U,!(H.buffer[0]&128))return F}}const w=r(0);function k(B,F){if(F===0){B.write(w);return}let U=0;for(let Q=F;Q!==0;Q=Q>>>7)U++;const H=s.$Hc.alloc(U);for(let Q=0;F!==0;Q++)H.buffer[Q]=F&127,F=F>>>7,F>0&&(H.buffer[Q]|=128);B.write(H)}class g{constructor(F){this.b=F,this.a=0}read(F){const U=this.b.slice(this.a,this.a+F);return this.a+=U.byteLength,U}}e.$0g=g;class t{constructor(){this.a=[]}get buffer(){return s.$Hc.concat(this.a)}write(F){this.a.push(F)}}e.$$g=t;var l;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(l||(l={}));function r(B){const F=s.$Hc.alloc(1);return F.writeUInt8(B,0),F}const i={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},n=typeof Buffer<"u";function o(B,F){if(typeof F>"u")B.write(i.Undefined);else if(typeof F=="string"){const U=s.$Hc.fromString(F);B.write(i.String),k(B,U.byteLength),B.write(U)}else if(n&&Buffer.isBuffer(F)){const U=s.$Hc.wrap(F);B.write(i.Buffer),k(B,U.byteLength),B.write(U)}else if(F instanceof s.$Hc)B.write(i.VSBuffer),k(B,F.byteLength),B.write(F);else if(Array.isArray(F)){B.write(i.Array),k(B,F.length);for(const U of F)o(B,U)}else if(typeof F=="number"&&(F|0)===F)B.write(i.Uint),k(B,F);else{const U=s.$Hc.fromString(JSON.stringify(F));B.write(i.Object),k(B,U.byteLength),B.write(U)}}e.$_g=o;function m(B){switch(B.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return B.read(a(B)).toString();case l.Buffer:return B.read(a(B)).buffer;case l.VSBuffer:return B.read(a(B));case l.Array:{const U=a(B),H=[];for(let Q=0;Q<U;Q++)H.push(m(B));return H}case l.Object:return JSON.parse(B.read(a(B)).toString());case l.Int:return a(B)}}e.$ah=m;class I{constructor(F,U,H=null,Q=1e3){this.h=F,this.j=U,this.k=H,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(F,U){this.b.set(F,U),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const U=this.o([F.type]);this.k?.logOutgoing(U,0,1,d(F.type));return}case 201:case 202:case 204:case 203:{const U=this.o([F.type,F.id],F.data);this.k?.logOutgoing(U,F.id,1,d(F.type),F.data);return}}}o(F,U=void 0){const H=new t;return o(H,F),o(H,U),this.p(H.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const U=new g(F),H=m(U),Q=m(U),x=H[0];switch(x){case 100:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(x)}: ${H[2]}.${H[3]}`,Q),this.s({type:x,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(x)}: ${H[2]}.${H[3]}`,Q),this.t({type:x,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(x)}`),this.u({type:x,id:H[1]});case 103:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(x)}`),this.u({type:x,id:H[1]})}}s(F){const U=this.b.get(F.channelName);if(!U){this.v(F);return}const H=new M.$rc;let Q;try{Q=U.call(this.j,F.name,F.arg,H.token)}catch(K){Q=Promise.reject(K)}const x=F.id;Q.then(K=>{this.m({id:x,data:K,type:201}),this.d.delete(F.id)},K=>{K instanceof Error?this.m({id:x,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:x,data:K,type:203}),this.d.delete(F.id)});const oe=(0,u.$kb)(()=>H.cancel());this.d.set(F.id,oe)}t(F){const U=this.b.get(F.channelName);if(!U){this.v(F);return}const H=F.id,x=U.listen(this.j,F.name,F.arg)(oe=>this.m({id:H,data:oe,type:204}));this.d.set(F.id,x)}u(F){const U=this.d.get(F.id);U&&(U.dispose(),this.d.delete(F.id))}v(F){let U=this.g.get(F.channelName);U||(U=[],this.g.set(F.channelName,U));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:F,timeoutTimer:H})}w(F){const U=this.g.get(F);if(U){for(const H of U)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$hb)(this.d.values()),this.d.clear()}}e.$bh=I;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class P{constructor(F,U=null){this.l=F,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$hc,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=U}getChannel(F){const U=this;return{call(H,Q,x){return U.a?Promise.reject(new S.$3):U.m(F,H,Q,x)},listen(H,Q){return U.a?f.Event.None:U.o(F,H,Q)}}}m(F,U,H,Q=M.CancellationToken.None){const x=this.g++,K={id:x,type:100,channelName:F,name:U,arg:H};if(Q.isCancellationRequested)return Promise.reject(new S.$3);let O;return new Promise((N,W)=>{if(Q.isCancellationRequested)return W(new S.$3);const q=()=>{const de=ue=>{switch(ue.type){case 201:this.f.delete(x),N(ue.data);break;case 202:{this.f.delete(x);const me=new Error(ue.data.message);me.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,me.name=ue.data.name,W(me);break}case 203:this.f.delete(x),W(ue.data);break}};this.f.set(x,de),this.p(K)};let V=null;this.b===c.Idle?q():(V=(0,C.$sg)(de=>this.u()),V.then(()=>{V=null,q()}));const re=()=>{V?(V.cancel(),V=null):this.p({id:x,type:101}),W(new S.$3)},$e=Q.onCancellationRequested(re);O=(0,u.$jb)((0,u.$kb)(re),$e),this.d.add(O)}).finally(()=>{this.d.delete(O)})}o(F,U,H){const Q=this.g++,oe={id:Q,type:102,channelName:F,name:U,arg:H};let K=null;const O=new f.$hc({onWillAddFirstListener:()=>{K=(0,C.$sg)(N=>this.u()),K.then(()=>{K=null,this.d.add(O),this.p(oe)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(O),this.p({id:Q,type:103}))}}),L=N=>O.fire(N.data);return this.f.set(Q,L),O.event}p(F){switch(F.type){case 100:case 102:{const U=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(U,F.id,0,`${y(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const U=this.q([F.type,F.id]);this.j?.logOutgoing(U,F.id,0,y(F.type));return}}}q(F,U=void 0){const H=new t;return o(H,F),o(H,U),this.r(H.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const U=new g(F),H=m(U),Q=m(U),x=H[0];switch(x){case 200:return this.j?.logIncoming(F.byteLength,0,0,d(x)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,H[1],0,d(x),Q),this.t({type:H[0],id:H[1],data:Q})}}t(F){if(F.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$hb)(this.d.values()),this.d.clear()}}e.$ch=P,ke([A.$4g],P.prototype,"onDidInitializePromise",null);class R{get connections(){const F=[];return this.f.forEach(U=>F.push(U)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new f.$hc,this.onDidAddConnection=this.g.event,this.h=new f.$hc,this.onDidRemoveConnection=this.h.event,F(({protocol:U,onDidClientDisconnect:H})=>{f.Event.once(U.onMessage)(x=>{const oe=new g(x),K=m(oe),O=new I(U,K),L=new P(U);this.a.forEach((W,q)=>O.registerChannel(q,W));const N={channelServer:O,channelClient:L,ctx:K};this.f.add(N),this.g.fire(N),H(()=>{O.dispose(),L.dispose(),this.f.delete(N),this.h.fire(N)})})})}getChannel(F,U){const H=this;return{call(Q,x,oe){let K;if((0,v.$ze)(U)){const L=(0,E.$Wf)(H.connections.filter(U));K=L?Promise.resolve(L):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,U))}else K=U.routeCall(H,Q,x);const O=K.then(L=>L.channelClient.getChannel(F));return T(O).call(Q,x,oe)},listen(Q,x){if((0,v.$ze)(U))return H.j(F,U,Q,x);const oe=U.routeEvent(H,Q,x).then(K=>K.channelClient.getChannel(F));return T(oe).listen(Q,x)}}}j(F,U,H,Q){const x=this;let oe=new u.$lb;const K=new f.$hc({onWillAddFirstListener:()=>{oe=new u.$lb;const O=new f.$nc,L=new Map,N=q=>{const re=q.channelClient.getChannel(F).listen(H,Q),$e=O.add(re);L.set(q,$e)},W=q=>{const V=L.get(q);V&&(V.dispose(),L.delete(q))};x.connections.filter(U).forEach(N),f.Event.filter(x.onDidAddConnection,U)(N,void 0,oe),x.onDidRemoveConnection(W,void 0,oe),O.event(K.fire,K,oe),oe.add(O)},onDidRemoveLastListener:()=>{oe.dispose()}});return K.event}registerChannel(F,U){this.a.set(F,U),this.f.forEach(H=>{H.channelServer.registerChannel(F,U)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$dh=R;class j{constructor(F,U,H=null){const Q=new t;o(Q,U),F.send(Q.buffer),this.a=new P(F,H),this.d=new I(F,U,H)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,U){this.d.registerChannel(F,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.$eh=j;function T(B){return{call(F,U,H){return B.then(Q=>Q.call(F,U,H))},listen(F,U){const H=new f.$qc;return B.then(Q=>H.input=Q.listen(F,U)),H.event}}}e.$fh=T;function z(B){let F=!1;return{call(U,H,Q){return F?B.call(U,H,Q):(0,C.$Fg)(0).then(()=>F=!0).then(()=>B.call(U,H,Q))},listen(U,H){if(F)return B.listen(U,H);const Q=new f.$qc;return(0,C.$Fg)(0).then(()=>F=!0).then(()=>Q.input=B.listen(U,H)),Q.event}}}e.$gh=z;class ne{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const U of F.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await f.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$hh=ne;var ee;(function(B){function F(x,oe){const K=x,O=oe&&oe.disableMarshalling,L=new Map;for(const N in K)H(N)&&L.set(N,f.Event.buffer(K[N],!0));return new class{listen(N,W,q){const V=L.get(W);if(V)return V;if(Q(W)){const re=K[W];if(typeof re=="function")return re.call(K,q)}throw new S.$_(`Event not found: ${W}`)}call(N,W,q){const V=K[W];if(typeof V=="function"){if(!O&&Array.isArray(q))for(let re=0;re<q.length;re++)q[re]=(0,p.$9g)(q[re]);return V.apply(K,q)}throw new S.$_(`Method not found: ${W}`)}}}B.fromService=F;function U(x,oe){const K=oe&&oe.disableMarshalling;return new Proxy({},{get(O,L){if(typeof L=="string")return oe?.properties?.has(L)?oe.properties.get(L):Q(L)?function(N){return x.listen(L,N)}:H(L)?x.listen(L):async function(...N){let W;oe&&!(0,v.$ue)(oe.context)?W=[oe.context,...N]:W=N;const q=await x.call(L,W);return K?q:(0,p.$9g)(q)};throw new S.$_(`Property not found: ${String(L)}`)}})}B.toService=U;function H(x){return x[0]==="o"&&x[1]==="n"&&$.$Nd(x.charCodeAt(2))}function Q(x){return/^onDynamic/.test(x)&&$.$Nd(x.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const F=B.toString();if(F!=="[object Object]")return F}return B}function ae(B){return Array.isArray(B)?B.map(se):se(B)}function J(B,F,U,H,Q,x,oe){oe=ae(oe);const K=ce[Q],O=K[H%K.length];let L=[`%c[${B}]%c[${String(F).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(x)?(L=L.concat(oe),L.push(")")):L.push(oe),console.log.apply(console,L)}class Y{constructor(F,U){this.d=F,this.f=U,this.a=0,this.b=0}logOutgoing(F,U,H,Q,x){this.b+=F,J(this.d,this.b,F,U,H,Q,x)}logIncoming(F,U,H,Q,x){this.a+=F,J(this.f,this.a,F,U,H,Q,x)}}e.$ih=Y}),define(te[156],ie([0,1,17,3,42]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JS=e.$IS=void 0;class M{constructor(f){this.a=f,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",u=>E.$Hc.wrap(u.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$IS=M;class A extends s.$eh{constructor(f,u){const p=new M(f);super(p,u),this.b=p}dispose(){this.b.disconnect()}}e.$JS=A}),define(te[109],ie([0,1,17,3,2,42]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=e.$kh=e.ProtocolConstants=e.$jh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function m(D,P){if(!n.has(D)){const R=String(++o);n.set(D,R)}return n.get(D)}function I(D,P,R,j){if(!i.enableDiagnostics)return;const T=m(D,P);if(j instanceof E.$Hc||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const z=E.$Hc.alloc(j.byteLength);z.set(j),i.records.push({timestamp:Date.now(),id:T,label:P,type:R,buff:z})}else i.records.push({timestamp:Date.now(),id:T,label:P,type:R,data:j})}i.traceSocketEvent=I})(S||(e.SocketDiagnostics=S={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let u=null;function p(){return u||(u=E.$Hc.alloc(0)),u}class ${get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return p();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const P=this.a[0];return o&&(this.a.shift(),this.b-=n),P}if(this.a[0].byteLength>n){const P=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),P}const m=E.$Hc.alloc(n);let I=0,D=0;for(;n>0;){const P=this.a[D];if(P.byteLength>n){const R=P.slice(0,n);m.set(R,I),I+=n,o&&(this.a[D]=P.slice(n),this.b-=n),n-=n}else m.set(P,I),I+=P.byteLength,o?(this.a.shift(),this.b-=P.byteLength):D++,n-=P.byteLength}return m}}e.$jh=$;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function h(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class b{constructor(n,o,m,I){this.type=n,this.id=o,this.ack=m,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends s.$mb{constructor(n){super(),this.f=this.B(new C.$hc),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new $,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,I=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new b(m,I,D,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=E.$Hc.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const m=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,m}h(){const n=E.$Hc.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class a extends s.$mb{constructor(n){super(),this.f=new C.$hc,this.onMessage=this.f.event,this.g=new C.$hc,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new c(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(1,0,0,n))}}e.$kh=a;class w extends M.$eh{static fromSocket(n,o){return new w(new a(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,m=null){super(n,o,m),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$lh=w;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$hc({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$mh=k;class g{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,m=this.a;for(;m;)n[o++]=m.data,m=m.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new g(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<l.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=l.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+l.a)*1e3;let m=0;for(let I=0;I<l.a;I++)n-this.c[I]<=o&&m++;return 1-m/l.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??l.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$lb,this.o=n.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(5,0,0,p());this.p.write(n),this.p.flush()}sendPause(){const n=new b(7,0,0,p());this.p.write(n)}sendResume(){const n=new b(8,0,0,p());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new s.$lb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(3,0,this.h,p());this.p.write(n);const o=this.b.toArray();for(let m=0,I=o.length;m<I;m++)this.p.write(o[m]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new b(6,0,0,p())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let m=0,I=o.length;m<I;m++)this.p.write(o[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const m=new b(1,o,this.h,n);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(n){const o=new b(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,m=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(o>=2e4&&m>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:m});return}const D=Math.max(2e4-o,2e4-m,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(3,0,this.h,p());this.p.write(n)}D(){this.h=this.g;const n=new b(9,0,this.h,p());this.p.write(n)}}e.$nh=r}),define(te[157],ie([0,1,38,17,3,2,42,145]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MS=void 0;function f(p,$){const v=s.Event.fromNodeEventEmitter(E.$FS,$,(y,b)=>({event:y,message:b})),h=s.Event.filter(v,({event:y})=>y.sender.id===p);return s.Event.map(h,({message:y})=>y&&C.$Hc.wrap(y))}class u extends A.$dh{static{this.b=new Map}static d(){const $=s.Event.fromNodeEventEmitter(E.$FS,"vscode:hello",({sender:v})=>v);return s.Event.map($,v=>{const h=v.id;u.b.get(h)?.dispose();const b=new s.$hc;u.b.set(h,(0,M.$kb)(()=>b.fire()));const d=f(h,"vscode:message"),c=s.Event.any(s.Event.signal(f(h,"vscode:disconnect")),b.event);return{protocol:new S.$LS(v,d),onDidClientDisconnect:c}})}constructor(){super(u.d())}}e.$MS=u}),define(te[110],ie([0,1,38,3,31,156]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OS=e.$NS=void 0;class A extends M.$JS{constructor(u,p){super({addEventListener:($,v)=>u.addListener($,v),removeEventListener:($,v)=>u.removeListener($,v),postMessage:$=>u.postMessage($),start:()=>u.start(),close:()=>u.close()},p)}}e.$NS=A;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,s.$6e)();f.webContents.send("vscode:createMessageChannel",u);const p=C.Event.fromNodeEventEmitter(E.$FS,"vscode:createMessageChannelResult",(v,h)=>({nonce:h,port:v.ports[0]})),{port:$}=await C.Event.toPromise(C.Event.once(C.Event.filter(p,v=>v.nonce===u)));return $}e.$OS=S}),define(te[158],ie([0,1,47,8,17,22,153,14,3,2,37,88,73,42]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class y extends h.$bh{constructor(c){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",a=>s.$Hc.wrap(Buffer.from(a,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Op=y;class b{constructor(c,a){this.i=c,this.j=a,this.c=new Set,this.g=new Map,this.h=new f.$hc,this.onDidProcessExit=this.h.event;const w=a&&a.timeout?a.timeout:6e4;this.b=new C.$Bg(w),this.d=null,this.f=null}getChannel(c){const a=this;return{call(w,k,g){return a.k(c,w,k,g)},listen(w,k){return a.l(c,w,k)}}}k(c,a,w,k=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(S.$4());this.b.cancel();const g=this.n(c),t=(0,C.$sg)(i=>g.call(a,w,i)),l=k.onCancellationRequested(()=>t.cancel()),r=(0,u.$kb)(()=>t.cancel());return this.c.add(r),t.finally(()=>{l.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,a,w){if(!this.b)return f.Event.None;this.b.cancel();let k;const g=new f.$hc({onWillAddFirstListener:()=>{k=this.n(c).listen(a,w)(g.fire,g),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,p.$Tm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,v.$rl)(a.env),this.d=(0,E.fork)(this.i,c,a);const w=new f.$hc;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$Kp)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}w.fire(s.$Hc.wrap(Buffer.from(n,"base64")))});const g=this.j.useQueue?(0,$.$tl)(this.d):this.d,t=n=>this.d&&this.d.connected&&g.send(n.buffer.toString("base64")),l=w.event,r={send:t,onMessage:l};this.f=new h.$ch(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(m=>(0,u.$hb)(m)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(c){let a=this.g.get(c);return a||(a=this.m.getChannel(c),this.g.set(c,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pp=b}),define(te[111],ie([0,1,8,3,2,74,12]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.StorageState=e.$No=e.StorageHint=void 0;var S;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function f(v){const h=v;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$No=f;var u;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(u||(e.StorageState=u={}));class p extends s.$mb{static{this.a=100}constructor(h,y=Object.create(null)){super(),this.m=h,this.n=y,this.b=this.B(new C.$kc),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=new E.$Cg(p.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((y,b)=>this.s(b,y)),h.deleted?.forEach(y=>this.s(y,void 0))}finally{this.b.resume()}}s(h,y){if(this.c===u.Closed)return;let b=!1;(0,A.$ue)(y)?b=this.f.delete(h):this.f.get(h)!==y&&(this.f.set(h,y),b=!0),b&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.n.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,y){const b=this.f.get(h);return(0,A.$ue)(b)?y:b}getBoolean(h,y){const b=this.get(h);return(0,A.$ue)(b)?y:b==="true"}getNumber(h,y){const b=this.get(h);return(0,A.$ue)(b)?y:parseInt(b,10)}getObject(h,y){const b=this.get(h);return(0,A.$ue)(b)?y:(0,M.$8g)(b)}async set(h,y,b=!1){if(this.c===u.Closed)return;if((0,A.$ue)(y))return this.delete(h,b);const d=(0,A.$ne)(y)||Array.isArray(y)?(0,M.$7g)(y):String(y);if(this.f.get(h)!==d)return this.f.set(h,d),this.j.set(h,d),this.h.delete(h),this.b.fire({key:h,external:b}),this.w()}async delete(h,y=!1){if(!(this.c===u.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:y}),this.w()}async optimize(){if(this.c!==u.Closed)return await this.flush(0),this.m.optimize()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=u.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===S.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Oo=p;class ${constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((y,b)=>this.a.set(b,y)),h.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Po=$}),define(te[159],ie([0,1,8,3,34,9,21]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_S=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return C.Event.None}static{this.a=2e3}static{this.b=256}constructor(p,$=Object.create(null)){this.g=p,this.h=$,this.c=(0,M.$cd)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,$=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(h=>$.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${$.size} rows`),$}async updateItems(p){const $=await this.f;return this.j($,p)}j(p,$){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${$.insert?(0,s.$vi)($.insert):"0"}), delete(${$.delete?(0,s.$wi)($.delete):"0"})`),this.t(p,()=>{const v=$.insert,h=$.delete;if(v&&v.size>0){const y=[];y.push([]);let b=0;v.forEach((d,c)=>{let a=y[b];a.length>S.b&&(b++,a=[],y.push(a)),a.push(c,d)}),y.forEach(d=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(d.length/2).fill("(?,?)").join(",")}`,c=>c.run(d),()=>{const c=[];let a=0;return v.forEach((w,k)=>{c.push(k),a+=w.length}),`Keys: ${c.join(", ")} Length: ${a}`})})}if(h&&h.size){const y=[];y.push([]);let b=0;h.forEach(d=>{let c=y[b];c.length>S.b&&(b++,c=[],y.push(c)),c.push(d)}),y.forEach(d=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(d.length).fill("?").join(",")})`,c=>c.run(d),()=>{const c=[];return h.forEach(a=>{c.push(a)}),`Keys: ${c.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const p=await this.f;return this.q(p,"VACUUM")}async close(p){this.d.trace(`[storage ${this.c}] close()`);const $=await this.f;return this.k($,p)}k(p,$){return new Promise((v,h)=>{p.db.close(y=>(y&&this.o(p,`[storage ${this.c}] close(): ${y}`),this.g===S.IN_MEMORY_PATH?v():!p.isErroneous&&!p.isInMemory?this.l().then(v,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),v())):typeof $=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const d=()=>this.k(b,void 0);return this.j(b,{insert:$()}).then(()=>d(),c=>(d(),Promise.reject(c)))})).then(v,h):h(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return A.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const $=await this.f,v=await this.r($,p?"PRAGMA integrity_check":"PRAGMA quick_check"),h=p?v.integrity_check:v.quick_check;return $.isErroneous?`${h} (last error: ${$.lastError})`:$.isInMemory?`${h} (in-memory!)`:h}async n(p,$=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${$})`);try{return await this.p(p)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&$)return await(0,E.$Fg)(S.a),this.n(p,!1);try{await A.Promises.unlink(p);try{await A.Promises.rename(this.m(p),p,!1)}catch{}return await this.p(p)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(S.IN_MEMORY_PATH)}}}o(p,$){p.isErroneous=!0,p.lastError=$,this.d.error($)}p(p){return new Promise(($,v)=>{new Promise((h,y)=>{G(["@vscode/sqlite3"],h,y)}).then(h=>{const y={db:new(this.d.isTracing?h.verbose().Database:h.Database)(p,b=>b?y.db&&b.code!=="SQLITE_CANTOPEN"?y.db.close(()=>v(b)):v(b):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>$(y),d=>y.db.close(()=>v(d)))),isInMemory:p===S.IN_MEMORY_PATH};y.db.on("error",b=>this.o(y,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&y.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},v)})}q(p,$){return new Promise((v,h)=>{p.db.exec($,y=>y?(this.o(p,`[storage ${this.c}] exec(): ${y}`),h(y)):v())})}r(p,$){return new Promise((v,h)=>{p.db.get($,(y,b)=>y?(this.o(p,`[storage ${this.c}] get(): ${y}`),h(y)):v(b))})}s(p,$){return new Promise((v,h)=>{p.db.all($,(y,b)=>y?(this.o(p,`[storage ${this.c}] all(): ${y}`),h(y)):v(b))})}t(p,$){return new Promise((v,h)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),$(),p.db.run("END TRANSACTION",y=>y?(this.o(p,`[storage ${this.c}] transaction(): ${y}`),h(y)):v())})})}u(p,$,v,h){const y=p.db.prepare($),b=d=>{this.o(p,`[storage ${this.c}] prepare(): ${d} (${$}). Details: ${h()}`)};y.on("error",b),v(y),y.finalize(d=>{d&&b(d),y.removeListener("error",b)})}}e.$_S=S;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(p){p&&typeof p.logTrace=="function"&&process.env[f.a]&&(this.b=p.logTrace),p&&typeof p.logError=="function"&&(this.c=p.logError)}get isTracing(){return!!this.b}trace(p){this.b?.(p)}error(p){this.c?.(p)}}}),define(te[160],ie([11,10]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(te[161],ie([11,10]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([11,10]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([11,10]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([11,10]),function(G,e){return G.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([11,10]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([11,10]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([11,10]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([11,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([11,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([11,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([11,10]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([11,10]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([11,10]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([11,10]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(te[175],ie([11,10]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(te[176],ie([11,10]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([11,10]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([11,10]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([11,10]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([11,10]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([11,10]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(te[182],ie([11,10]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([11,10]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([11,10]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([11,10]),function(G,e){return G.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([11,10]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([11,10]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([11,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([11,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([11,10]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([11,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([11,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3T=e.$2T=void 0;function E(s){return s&&s.hasOwnProperty("folderUri")}e.$2T=E;function C(s){return s&&s.hasOwnProperty("workspace")}e.$3T=C}),define(te[194],ie([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$34b=e.$24b=e.$14b=void 0;function C(A){return typeof A?.backupFolder=="string"}e.$14b=C;function s(A){let S=[];try{Array.isArray(A.workspaces)&&(S=A.workspaces.map(f=>({workspace:{id:f.id,configPath:E.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$24b=s;function M(A){let S=[];try{Array.isArray(A.folders)&&(S=A.folders.map(f=>({folderUri:E.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$34b=M}),define(te[195],ie([0,1,14,163]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.TokenType=void 0;var s;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...u){switch(u.length){case 1:return(0,C.localize)(0,null,u[0]);case 2:return(0,C.localize)(1,null,u[0],u[1]);case 3:return(0,C.localize)(2,null,u[0],u[1],u[2]);default:return}}const A=(0,C.localize)(3,null),S=(0,C.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,E.$6)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const $=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:$})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const $=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:$})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const $=this.d,v=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:v};this.g.push({offset:$,lexeme:v,additionalInfo:p}),this.f.push(h)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const $=this.c.substring(this.d,this.e),v=f.b.get($);v?this.k(v):this.f.push({type:17,lexeme:$,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,$=!1,v=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(S);return}const y=this.c.charCodeAt(p);if($)$=!1;else if(y===47&&!v){p++;break}else y===91?v=!0:y===92?$=!0:y===93&&(v=!1);p++}for(;p<this.c.length&&f.a.has(this.c.charCodeAt(p));)p++;this.e=p;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$Di=f}),define(te[196],ie([0,1,3,2]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=void 0;class s{constructor(){this.a=new E.$hc,this.b=new E.$hc,this.c=new E.$hc,this.d=new E.$hc}static{this.ChannelName="extensionhostdebugservice"}call(S,f,u){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(S,f,u){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$zn=s;class M extends C.$mb{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,f,u){this.b.call("attach",[S,f,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,f){this.b.call("terminate",[S,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.b.call("openExtensionDevelopmentHostWindow",[S,f])}}e.$An=M}),define(te[197],ie([0,1,148,55,13,9,35,19,7]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,M.$bd)(s.$4e.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$$c)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,S.$gg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$gg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,E.$5l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$$c)(this.userDataPath,"logs",h)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$gg)(f.URI.file((0,M.$$c)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$gg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$gg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$gg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=A.env.VSCODE_PORTABLE;return h?f.URI.file((0,M.$$c)(h,"argv.json")):(0,S.$gg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$$c)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,M.$_c)(h):(0,M.$9c)((0,M.$$c)(s.$4e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?f.URI.file((0,M.$_c)(h)):f.URI.file((0,M.$$c)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,M.$_c)(h);const y=A.env.VSCODE_EXTENSIONS;if(y)return y;const b=A.env.VSCODE_PORTABLE;return b?(0,M.$$c)(b,"extensions"):(0,S.$gg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,M.$9c)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,M.$9c)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$6l.test(h))}get extensionLogLevel(){const h=[];for(const y of this.args.log||[]){const b=e.$6l.exec(y);b&&b[1]&&b[2]&&h.push([b[1],b[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,S.$gg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=A.env.VSCODE_PORTABLE;return h?f.URI.file((0,M.$$c)(h,"policy.json")):(0,S.$gg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,y,b){this.a=h,this.b=y,this.c=b,this.editSessionId=this.args.editSessionId}}e.$7l=u,ke([C.$4g],u.prototype,"appRoot",null),ke([C.$4g],u.prototype,"userHome",null),ke([C.$4g],u.prototype,"userDataPath",null),ke([C.$4g],u.prototype,"appSettingsHome",null),ke([C.$4g],u.prototype,"tmpDir",null),ke([C.$4g],u.prototype,"cacheHome",null),ke([C.$4g],u.prototype,"stateResource",null),ke([C.$4g],u.prototype,"userRoamingDataHome",null),ke([C.$4g],u.prototype,"userDataSyncHome",null),ke([C.$4g],u.prototype,"sync",null),ke([C.$4g],u.prototype,"machineSettingsResource",null),ke([C.$4g],u.prototype,"workspaceStorageHome",null),ke([C.$4g],u.prototype,"localHistoryHome",null),ke([C.$4g],u.prototype,"keyboardLayoutResource",null),ke([C.$4g],u.prototype,"argvResource",null),ke([C.$4g],u.prototype,"isExtensionDevelopment",null),ke([C.$4g],u.prototype,"untitledWorkspacesHome",null),ke([C.$4g],u.prototype,"builtinExtensionsPath",null),ke([C.$4g],u.prototype,"extensionsPath",null),ke([C.$4g],u.prototype,"extensionDevelopmentLocationURI",null),ke([C.$4g],u.prototype,"extensionDevelopmentKind",null),ke([C.$4g],u.prototype,"extensionTestsLocationURI",null),ke([C.$4g],u.prototype,"debugExtensionHost",null),ke([C.$4g],u.prototype,"logLevel",null),ke([C.$4g],u.prototype,"extensionLogLevel",null),ke([C.$4g],u.prototype,"serviceMachineIdResource",null),ke([C.$4g],u.prototype,"disableTelemetry",null),ke([C.$4g],u.prototype,"disableWorkspaceTrust",null),ke([C.$4g],u.prototype,"disableKeytar",null),ke([C.$4g],u.prototype,"policyFile",null);function p(v,h){return $(v["inspect-extensions"],v["inspect-brk-extensions"],5870,h,v.debugId,v.extensionEnvironment)}e.$8l=p;function $(v,h,y,b,d,c){const w=Number(h||v)||(b?null:y),k=w?!!h:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:w,break:k,debugId:d,env:g}}e.$9l=$}),define(te[112],ie([0,1,306,4,166]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$vl=["tunnel","serve-web"],e.$wl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(b,d,c=A){const a=b.find(o=>o.length>0&&o[0]!=="-"),w={},k=["_"],g=[],t={};let l;for(const o in d){const m=d[o];m.type==="subcommand"?o===a&&(l=m):(m.alias&&(w[o]=m.alias),m.type==="string"||m.type==="string[]"?(k.push(o),m.deprecates&&k.push(...m.deprecates)):m.type==="boolean"&&(g.push(o),m.deprecates&&g.push(...m.deprecates)),m.global&&(t[o]=m))}if(l&&a){const o=t;for(const P in l.options)o[P]=l.options[P];const m=b.filter(P=>P!==a),I=c.getSubcommandReporter?c.getSubcommandReporter(a):void 0,D=S(m,o,I);return{[a]:D,_:[]}}const r=E(b,{string:k,boolean:g,alias:w}),i={},n=r;i._=r._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in d){const m=d[o];if(m.type==="subcommand")continue;m.alias&&delete n[m.alias];let I=n[o];if(m.deprecates)for(const D of m.deprecates)n.hasOwnProperty(D)&&(I||(I=n[D],I&&c.onDeprecatedOption(D,m.deprecationMessage||(0,s.localize)(37,null,o))),delete n[D]);if(typeof I<"u"){if(m.type==="string[]"){if(Array.isArray(I)||(I=[I]),!m.allowEmptyValue){const D=I.filter(P=>P.length>0);D.length!==I.length&&(c.onEmptyValue(o),I=D.length>0?D:void 0)}}else m.type==="string"&&(Array.isArray(I)?(I=I.pop(),c.onMultipleValues(o,I)):!I&&!m.allowEmptyValue&&(c.onEmptyValue(o),I=void 0));i[o]=I,m.deprecationMessage&&c.onDeprecatedOption(o,m.deprecationMessage)}delete n[o]}for(const o in n)c.onUnknownOption(o);return i}e.$xl=S;function f(b,d){let c="";return d.args&&(Array.isArray(d.args)?c=` <${d.args.join("> <")}>`:c=` <${d.args}>`),d.alias?`-${d.alias} --${b}${c}`:`--${b}${c}`}function u(b,d){const c=[];for(const a in b){const w=b[a],k=f(a,w);c.push([k,w.description])}return p(c,d)}e.$yl=u;function p(b,d){const a=b.reduce((g,t)=>Math.max(g,t[0].length),12)+2+1;if(d-a<25)return b.reduce((g,t)=>g.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const w=d-a-1,k=[];for(const g of b){const t=g[0],l=v(g[1],w),r=$(a-t.length-2);k.push("  "+t+r+l[0]);for(let i=1;i<l.length;i++)k.push($(a)+l[i])}return k}function $(b){return" ".repeat(b)}function v(b,d){const c=[];for(;b.length;){const a=b.length<d?b.length:b.lastIndexOf(" ",d),w=b.slice(0,a).trim();b=b.slice(a),c.push(w)}return c}function h(b,d,c,a,w){const k=process.stdout.isTTY&&process.stdout.columns||80,g=w?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${b} ${c}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${d} [${(0,s.localize)(40,null)}]${g}`),t.push(""),w?.noPipe!==!0&&(C.$i?t.push((0,s.localize)(41,null,d)):t.push((0,s.localize)(42,null,d)),t.push(""));const l={},r=[];for(const i in a){const n=a[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let o=l[n.cat];o||(l[n.cat]=o={}),o[i]=n}}for(const i in l){const n=i,o=l[n];o&&(t.push(M[n]),t.push(...u(o,k)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...p(r.map(i=>[i.command,i.description]),k)),t.push("")),t.join(`
`)}e.$zl=h;function y(b,d){return`${b||(0,s.localize)(44,null)}
${d||(0,s.localize)(45,null)}
${process.arch}`}e.$Al=y}),define(te[198],ie([0,1,87,196,112]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$04b=void 0;class M extends C.$zn{constructor(S){super(),this.f=S}call(S,f,u){return f==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(S,f,u)}async g(S,f){const u=(0,s.$xl)(S,s.$wl);u.debugRenderer=f;const p=u.extensionDevelopmentPath;if(!p)return{success:!1};const[$]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!f)return{success:!0};const v=$.win;if(!v)return{success:!0};const h=v.webContents.debugger;let y=h.isAttached()?1/0:0;const b=(0,E.createServer)(d=>{y++===0&&h.attach();let c=!1;const a=g=>{c||d.write(JSON.stringify(g)+"\0")},w=(g,t,l,r)=>a({method:t,params:l,sessionId:r});v.on("close",()=>{h.removeListener("message",w),d.end(),c=!0}),h.addListener("message",w);let k=Buffer.alloc(0);d.on("data",g=>{k=Buffer.concat([k,g]);for(let t=k.indexOf(0);t!==-1;t=k.indexOf(0)){let l;try{const r=k.slice(0,t).toString("utf8");k=k.slice(t+1),l=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}h.sendCommand(l.method,l.params,l.sessionId).then(r=>a({id:l.id,sessionId:l.sessionId,result:r})).catch(r=>a({id:l.id,sessionId:l.sessionId,error:{code:0,message:r.message}}))}}),d.on("error",g=>{console.error("error on cdp pipe:",g)}),d.on("close",()=>{c=!0,--y===0&&h.detach()})});return await new Promise(d=>b.listen(0,d)),v.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$04b=M}),define(te[63],ie([0,1,307,167,112]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=void 0;function M($,v){const h=(w,k)=>{console.warn((0,C.localize)(0,null,w,k))},y=w=>{console.warn((0,C.localize)(1,null,w))},b=(w,k)=>{console.warn((0,C.localize)(2,null,w,k))},d=w=>({onUnknownOption:k=>{s.$vl.includes(w)||console.warn((0,C.localize)(3,null,k,w))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:s.$vl.includes(w)?d:void 0}),c={onUnknownOption:w=>{console.warn((0,C.localize)(4,null,w))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:d},a=(0,s.$xl)($,s.$wl,v?c:void 0);return a.goto&&a._.forEach(w=>E(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(w),(0,C.localize)(5,null))),a}function A($){const v=$.findIndex(h=>!/^-/.test(h));if(v>-1)return[...$.slice(0,v),...$.slice(v+1)]}function S($){let[,...v]=$;process.env.VSCODE_DEV&&(v=A(v)||[]);const h=!p(process.env);return M(v,h)}e.$Bl=S;function f($){let[,,...v]=$;return process.env.VSCODE_DEV&&(v=A(v)||[]),M(v,!0)}e.$Cl=f;function u($,...v){const h=$.indexOf("--");return h===-1?$.push(...v):$.splice(h,0,...v),$}e.$Dl=u;function p($){return $.VSCODE_CLI==="1"}e.$El=p}),function(){"use strict";function G(e,E,C){function s(A,S){const f=M(A,S),u=[f];return e.isAbsolute(f)||u.unshift(C),e.resolve(...u)}function M(A,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,S);const p=A["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const $=process.env.USERPROFILE;if(typeof $!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join($,"AppData","Roaming")}break;case"darwin":u=e.join(E.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,S)}return{getUserDataPath:s}}if(typeof define=="function")define(te[199],ie([113,27,35]),function(e,E,C){return G(e,E,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=G(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,27,197,199]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=void 0;class M extends C.$7l{constructor(u,p){super(u,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,s.getUserDataPath)(u,p.nameShort)},p)}}e.$0l=M;function A(f,u){return(0,C.$9l)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,u,f.extensionEnvironment)}e.$$l=A;function S(f,u){return(0,C.$9l)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,u,f.extensionEnvironment)}e.$_l=S}),define(te[200],ie([0,1,45,27,32]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=void 0;function M(A){const S=(0,s.$Se)((0,C.tmpdir)());try{return(0,E.writeFileSync)(S,""),A&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){A&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$z6b=M}),define(te[201],ie([0,1,12,169]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;function s(A,S,f){try{M(A,S,f)}catch(u){console.error(u?.message??u)}return A}e.$kp=s;function M(A,S,f){const u=(p,$,v)=>{const h=p[$];if((0,E.$le)(h)){const y=h,b=y.length;if(b>1&&y[0]==="%"&&y[b-1]==="%"){const d=y.substr(1,b-2);let c=S[d];c===void 0&&f&&(c=f[d]);const a=typeof c=="string"?c:c?.message,w=f?.[d],k=typeof w=="string"?w:w?.message;if(!a){k||console.warn(`[${A.name}]: ${(0,C.localize)(0,null,d)}`);return}if(v&&($==="title"||$==="category")&&k&&k!==a){const g={value:a,original:k};p[$]=g}else p[$]=a}}else if((0,E.$ne)(h))for(const y in h)h.hasOwnProperty(y)&&(y==="commands"?u(h,y,!0):u(h,y,v));else if(Array.isArray(h))for(let y=0;y<h.length;y++)u(h,y,v)};for(const p in A)A.hasOwnProperty(p)&&u(A,p)}}),define(te[202],ie([0,1,19,70,171,203]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function f(c){return c=c.trim(),c==="*"||A.test(c)}e.$zo=f;function u(c){if(!f(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=c.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$Ao=u;function p(c){if(!c)return null;const a=c.majorBase,w=c.majorMustEqual,k=c.minorBase;let g=c.minorMustEqual;const t=c.patchBase;let l=c.patchMustEqual;c.hasCaret&&(a===0||(g=!1),l=!1);let r=0;if(c.preRelease){const i=S.exec(c.preRelease);if(i){const[,n,o,m]=i;r=Date.UTC(Number(n),Number(o)-1,Number(m))}}return{majorBase:a,majorMustEqual:w,minorBase:k,minorMustEqual:g,patchBase:t,patchMustEqual:l,isMinimum:c.hasGreaterEquals,notBefore:r}}e.$Bo=p;function $(c,a,w){let k;typeof c=="string"?k=p(u(c)):k=c;let g;a instanceof Date?g=a.getTime():typeof a=="string"&&(g=new Date(a).getTime());let t;if(typeof w=="string"?t=p(u(w)):t=w,!k||!t)return!1;const l=k.majorBase,r=k.minorBase,i=k.patchBase;let n=t.majorBase,o=t.minorBase,m=t.patchBase;const I=t.notBefore;let D=t.majorMustEqual,P=t.minorMustEqual,R=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:r>o?!0:r<o||g&&g<I?!1:i>=m:(l===1&&n===0&&(!D||!P||!R)&&(n=1,o=0,m=0,D=!0,P=!1,R=!1),l<n?!1:l>n?!D:r<o?!1:r>o?!P:i<m?!1:i>m?!R:!(g&&g<I))}e.$Co=$;function v(c,a,w,k,g){const t=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return t.push([C.default.Error,s.localize(0,null)]),t;if(typeof k.name!="string")return t.push([C.default.Error,s.localize(1,null,"name")]),t;if(typeof k.version!="string")return t.push([C.default.Error,s.localize(2,null,"version")]),t;if(!k.engines)return t.push([C.default.Error,s.localize(3,null,"engines")]),t;if(typeof k.engines.vscode!="string")return t.push([C.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof k.extensionDependencies<"u"&&!d(k.extensionDependencies))return t.push([C.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof k.activationEvents<"u"){if(!d(k.activationEvents))return t.push([C.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof k.main>"u"&&typeof k.browser>"u")return t.push([C.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&t.push([C.default.Warning,s.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return t.push([C.default.Error,s.localize(9,null,"main")]),t;{const i=(0,E.$gg)(w,k.main);(0,E.$ag)(i,w)||t.push([C.default.Warning,s.localize(10,null,i.path,w.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return t.push([C.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,E.$gg)(w,k.browser);(0,E.$ag)(i,w)||t.push([C.default.Warning,s.localize(12,null,i.path,w.path)])}}if(!M.valid(k.version))return t.push([C.default.Error,s.localize(13,null)]),t;const l=[];if(!h(c,a,k,g,l))for(const i of l)t.push([C.default.Error,i]);return t}e.$Do=v;function h(c,a,w,k,g){return k||typeof w.main>"u"&&typeof w.browser>"u"?!0:b(c,a,w.engines.vscode,g)}e.$Eo=h;function y(c,a,w){return c==="*"||b(a,w,c)}e.$Fo=y;function b(c,a,w,k=[]){const g=p(u(w));if(!g)return k.push(s.localize(14,null,w)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return k.push(s.localize(15,null,w)),!1}else if(!g.majorMustEqual)return k.push(s.localize(16,null,w)),!1;return $(c,a,g)?!0:(k.push(s.localize(17,null,c,w)),!1)}function d(c){if(!Array.isArray(c))return!1;for(let a=0,w=c.length;a<w;a++)if(typeof c[a]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0;async function s(M,A,S){let f=S&&S.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const p=(await A.readFile(M.serviceMachineIdResource)).value.toString();f=(0,C.$5e)(p)?p:null}catch{f=null}if(!f){f=(0,C.$6e)();try{await A.writeFile(M.serviceMachineIdResource,E.$Hc.fromString(f))}catch{}}return S?.store("storage.serviceMachineId",f,-1,1),f}e.$Yo=s}),define(te[75],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=void 0;class E{constructor(s,M=[],A=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$wh=E}),define(te[205],ie([0,1,75]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.InstantiationType=void 0;const C=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,f,u){f instanceof E.$wh||(f=new E.$wh(f,[],!!u)),C.push([S,f])}e.$jr=M;function A(){return C}e.$kr=A}),define(te[206],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class E{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$1p=E;class C{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const S=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(A);S.outgoing.set(f.key,f),f.incoming.set(S.key,S)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const S of this.a.values())S.outgoing.delete(A),S.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let S=this.a.get(A);return S||(S=new E(A,M),this.a.set(A,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,S]of this.a)M.push(`${A}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const S=new Set([M]),f=this.c(A,S);if(f)return f}}c(M,A){for(const[S,f]of M.outgoing){if(A.has(S))return[...A,S].join(" -> ");A.add(S);const u=this.c(f,A);if(u)return u;A.delete(S)}}}e.$2p=C}),define(te[6],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=S})(E||(e._util=E={})),e.$yh=s("instantiationService");function C(A,S,f){S[E.DI_TARGET]===S?S[E.DI_DEPENDENCIES].push({id:A,index:f}):(S[E.DI_DEPENDENCIES]=[{id:A,index:f}],S[E.DI_TARGET]=S)}function s(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const S=function(f,u,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(S,f,p)};return S.toString=()=>A,E.serviceIds.set(A,S),S}e.$zh=s;function M(A){return A}e.$Ah=M}),define(te[64],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=void 0,e.$44b=(0,E.$zh)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.ConfigurationTarget=e.$8h=e.$7h=e.$6h=void 0,e.$6h=(0,s.$zh)("configurationService");function M(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof C.URI)}e.$7h=M;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof C.URI)}e.$8h=A;var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function f(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$9h=f;function u(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$0h=u;function p(c,a){const w=Object.create(null);for(const k in c)$(w,k,c[k],a);return w}e.$$h=p;function $(c,a,w,k){const g=a.split("."),t=g.pop();let l=c;for(let r=0;r<g.length;r++){const i=g[r];let n=l[i];switch(typeof n){case"undefined":n=l[i]=Object.create(null);break;case"object":break;default:k(`Ignoring ${a} as ${g.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=w}catch{k(`Ignoring ${a} as ${g.join(".")} is ${JSON.stringify(l)}`)}else k(`Ignoring ${a} as ${g.join(".")} is ${JSON.stringify(l)}`)}e.$_h=$;function v(c,a){const w=a.split(".");h(c,w)}e.$ai=v;function h(c,a){const w=a.shift();if(a.length===0){delete c[w];return}if(Object.keys(c).indexOf(w)!==-1){const k=c[w];typeof k=="object"&&!Array.isArray(k)&&(h(k,a),Object.keys(k).length===0&&delete c[w])}}function y(c,a,w){function k(l,r){let i=l;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const g=a.split("."),t=k(c,g);return typeof t>"u"?w:t}e.$bi=y;function b(c,a,w){Object.keys(a).forEach(k=>{k!=="__proto__"&&(k in c?E.$ne(c[k])&&E.$ne(a[k])?b(c[k],a[k],w):w&&(c[k]=a[k]):c[k]=a[k])})}e.$ci=b;function d(c){return c.replace(/[\[\]]/g,"")}e.$di=d}),define(te[114],ie([0,1,4,26,195,6,162,14]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.ContextKeyExprType=e.$Ei=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",E.$j),f.set("isLinux",E.$k),f.set("isWindows",E.$i),f.set("isWeb",E.$o),f.set("isMacNative",E.$j&&!E.$o),f.set("isEdge",E.$G),f.set("isFirefox",E.$E),f.set("isChrome",E.$D),f.set("isSafari",E.$F);function u(K,O){if(f.get(K)!==void 0)throw(0,S.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(K,O)}e.$Ei=u;const p=Object.prototype.hasOwnProperty;var $;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const v={regexParsingWithErrorRecovery:!0},h=(0,A.localize)(0,null),y=(0,A.localize)(1,null),b=(0,A.localize)(2,null),d=(0,A.localize)(3,null),c=(0,A.localize)(4,null),a=(0,A.localize)(5,null),w=(0,A.localize)(6,null),k=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=v){this.k=O,this.d=new s.$Di,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const N=this.D(),W=N.type===17?a:void 0;throw this.h.push({message:c,offset:N.offset,lexeme:s.$Di.getLexeme(N),additionalInfo:W}),g.c}return L}catch(L){if(L!==g.c)throw L;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const L=this.o();O.push(L)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const L=this.s();O.push(L)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const L=this.l();return this.A(1,d),L?.negate()}case 17:return this.z(),j.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const L=this.l();return this.A(1,d),L}case 17:{const L=O.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const q=W.lexeme,V=q.lastIndexOf("/"),re=V===q.length-1?void 0:this.w(q.substring(V+1));let $e;try{$e=new RegExp(q.substring(1,V),re)}catch{throw this.B("REGEX",W)}return se.create(L,$e)}switch(W.type){case 10:case 19:{const q=[W.lexeme];this.z();let V=this.D(),re=0;for(let we=0;we<W.lexeme.length;we++)W.lexeme.charCodeAt(we)===40?re++:W.lexeme.charCodeAt(we)===41&&re--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let we=0;we<V.lexeme.length;we++)V.lexeme.charCodeAt(we)===40?re++:W.lexeme.charCodeAt(we)===41&&re--}if(re<0)break;q.push(s.$Di.getLexeme(V)),this.z(),V=this.D()}const $e=q.join(""),de=$e.lastIndexOf("/"),ue=de===$e.length-1?void 0:this.w($e.substring(de+1));let me;try{me=new RegExp($e.substring(1,de),ue)}catch{throw this.B("REGEX",W)}return t.regex(L,me)}case 18:{const q=W.lexeme;this.z();let V=null;if(!(0,C.$od)(q)){const re=q.indexOf("/"),$e=q.lastIndexOf("/");if(re!==$e&&re>=0){const de=q.slice(re+1,$e),ue=q[$e+1]==="i"?"i":"";try{V=new RegExp(de,ue)}catch{throw this.B("REGEX",W)}}}if(V===null)throw this.B("REGEX",W);return se.create(L,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const W=this.u();return t.notIn(L,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return t.equals(L,W);switch(W){case"true":return t.has(L);case"false":return t.not(L);default:return t.equals(L,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return t.notEquals(L,W);switch(W){case"true":return t.not(L);case"false":return t.has(L);default:return t.notEquals(L,W)}}case 5:return this.z(),ee.create(L,this.u());case 6:return this.z(),ce.create(L,this.u());case 7:return this.z(),z.create(L,this.u());case 8:return this.z(),ne.create(L,this.u());case 13:return this.z(),t.in(L,this.u());default:return t.has(L)}}case 20:throw this.h.push({message:w,offset:O.offset,lexeme:"",additionalInfo:k}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,L){if(this.C(O))return this.z();throw this.B(L,this.D())}B(O,L,N){const W=(0,A.localize)(8,null,O,s.$Di.getLexeme(L)),q=L.offset,V=s.$Di.getLexeme(L);return this.h.push({message:W,offset:q,lexeme:V,additionalInfo:N}),g.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Fi=g;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(O){return m.create(O)}static equals(O,L){return I.create(O,L)}static notEquals(O,L){return R.create(O,L)}static regex(O,L){return se.create(O,L)}static in(O,L){return D.create(O,L)}static notIn(O,L){return P.create(O,L)}static not(O){return j.create(O)}static and(...O){return Y.create(O,null,!0)}static or(...O){return B.create(O,null,!0)}static greater(O,L){return z.create(O,L)}static greaterEquals(O,L){return ne.create(O,L)}static smaller(O,L){return ee.create(O,L)}static smallerEquals(O,L){return ce.create(O,L)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Gi=t;function l(K){const O=new g({regexParsingWithErrorRecovery:!1});return K.map(L=>(O.parse(L),O.lexingErrors.length>0?O.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,A.localize)(9,null,N.additionalInfo):(0,A.localize)(10,null),offset:N.offset,length:N.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}e.$Hi=l;function r(K,O){const L=K?K.substituteConstants():void 0,N=O?O.substituteConstants():void 0;return!L&&!N?!0:!L||!N?!1:L.equals(N)}e.$Ii=r;function i(K,O){return K.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return o.INSTANCE}}e.$Ji=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Ki=o;class m{static create(O,L=null){const N=f.get(O);return typeof N=="boolean"?N?o.INSTANCE:n.INSTANCE:new m(O,L)}constructor(O,L){this.key=O,this.c=L,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:U(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?o.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Li=m;class I{static create(O,L,N=null){if(typeof L=="boolean")return L?m.create(O,N):j.create(O,N);const W=f.get(O);return typeof W=="boolean"?L===(W?"true":"false")?o.INSTANCE:n.INSTANCE:new I(O,L,N)}constructor(O,L,N){this.c=O,this.d=L,this.f=N,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const L=O?"true":"false";return this.d===L?o.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Mi=I;class D{static create(O,L){return new D(O,L)}constructor(O,L){this.d=O,this.f=L,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:H(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const L=O.getValue(this.f),N=O.getValue(this.d);return Array.isArray(L)?L.includes(N):typeof N=="string"&&typeof L=="object"&&L!==null?p.call(L,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=P.create(this.d,this.f)),this.c}}e.$Ni=D;class P{static create(O,L){return new P(O,L)}constructor(O,L){this.d=O,this.f=L,this.type=11,this.c=D.create(O,L)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oi=P;class R{static create(O,L,N=null){if(typeof L=="boolean")return L?j.create(O,N):m.create(O,N);const W=f.get(O);return typeof W=="boolean"?L===(W?"true":"false")?n.INSTANCE:o.INSTANCE:new R(O,L,N)}constructor(O,L,N){this.c=O,this.d=L,this.f=N,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const L=O?"true":"false";return this.d===L?n.INSTANCE:o.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Pi=R;class j{static create(O,L=null){const N=f.get(O);return typeof N=="boolean"?N?n.INSTANCE:o.INSTANCE:new j(O,L)}constructor(O,L){this.c=O,this.d=L,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:U(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:o.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$Qi=j;function T(K,O){if(typeof K=="string"){const L=parseFloat(K);isNaN(L)||(K=L)}return typeof K=="string"||typeof K=="number"?O(K):n.INSTANCE}class z{static create(O,L,N=null){return T(L,W=>new z(O,W,N))}constructor(O,L,N){this.c=O,this.d=L,this.f=N,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Ri=z;class ne{static create(O,L,N=null){return T(L,W=>new ne(O,W,N))}constructor(O,L,N){this.c=O,this.d=L,this.f=N,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Si=ne;class ee{static create(O,L,N=null){return T(L,W=>new ee(O,W,N))}constructor(O,L,N){this.c=O,this.d=L,this.f=N,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Ti=ee;class ce{static create(O,L,N=null){return T(L,W=>new ce(O,W,N))}constructor(O,L,N){this.c=O,this.d=L,this.f=N,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Ui=ce;class se{static create(O,L){return new se(O,L)}constructor(O,L){this.d=O,this.f=L,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const L=this.f?this.f.source:"",N=O.f?O.f.source:"";return L<N?-1:L>N?1:0}equals(O){if(O.type===this.type){const L=this.f?this.f.source:"",N=O.f?O.f.source:"";return this.d===O.d&&L===N}return!1}substituteConstants(){return this}evaluate(O){const L=O.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$Vi=se;class ae{static create(O){return new ae(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ae(this.c.map(O))}negate(){return this.c}}e.$Wi=ae;function J(K){let O=null;for(let L=0,N=K.length;L<N;L++){const W=K[L].substituteConstants();if(K[L]!==W&&O===null){O=[];for(let q=0;q<L;q++)O[q]=K[q]}O!==null&&(O[L]=W)}return O===null?K:O}class Y{static create(O,L,N){return Y.d(O,L,N)}constructor(O,L){this.expr=O,this.c=L,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let L=0,N=this.expr.length;L<N;L++){const W=i(this.expr[L],O.expr[L]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let L=0,N=this.expr.length;L<N;L++)if(!this.expr[L].equals(O.expr[L]))return!1;return!0}return!1}substituteConstants(){const O=J(this.expr);return O===this.expr?this:Y.create(O,this.c,!1)}evaluate(O){for(let L=0,N=this.expr.length;L<N;L++)if(!this.expr[L].evaluate(O))return!1;return!0}static d(O,L,N){const W=[];let q=!1;for(const V of O)if(V){if(V.type===1){q=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){W.push(...V.expr);continue}W.push(V)}if(W.length===0&&q)return o.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];for(;W.length>1;){const V=W[W.length-1];if(V.type!==9)break;W.pop();const re=W.pop(),$e=W.length===0,de=B.create(V.expr.map(ue=>Y.create([ue,re],null,N)),null,$e);de&&(W.push(de),W.sort(i))}if(W.length===1)return W[0];if(N){for(let V=0;V<W.length;V++)for(let re=V+1;re<W.length;re++)if(W[V].negate().equals(W[re]))return n.INSTANCE;if(W.length===1)return W[0]}return new Y(W,L)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const L of this.expr)O.push(...L.keys());return O}map(O){return new Y(this.expr.map(L=>L.map(O)),null)}negate(){if(!this.c){const O=[];for(const L of this.expr)O.push(L.negate());this.c=B.create(O,this,!0)}return this.c}}e.$Xi=Y;class B{static create(O,L,N){return B.d(O,L,N)}constructor(O,L){this.expr=O,this.c=L,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let L=0,N=this.expr.length;L<N;L++){const W=i(this.expr[L],O.expr[L]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let L=0,N=this.expr.length;L<N;L++)if(!this.expr[L].equals(O.expr[L]))return!1;return!0}return!1}substituteConstants(){const O=J(this.expr);return O===this.expr?this:B.create(O,this.c,!1)}evaluate(O){for(let L=0,N=this.expr.length;L<N;L++)if(this.expr[L].evaluate(O))return!0;return!1}static d(O,L,N){let W=[],q=!1;if(O){for(let V=0,re=O.length;V<re;V++){const $e=O[V];if($e){if($e.type===0){q=!0;continue}if($e.type===1)return o.INSTANCE;if($e.type===9){W=W.concat($e.expr);continue}W.push($e)}}if(W.length===0&&q)return n.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];if(N){for(let V=0;V<W.length;V++)for(let re=V+1;re<W.length;re++)if(W[V].negate().equals(W[re]))return o.INSTANCE;if(W.length===1)return W[0]}return new B(W,L)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const L of this.expr)O.push(...L.keys());return O}map(O){return new B(this.expr.map(L=>L.map(O)),null)}negate(){if(!this.c){const O=[];for(const L of this.expr)O.push(L.negate());for(;O.length>1;){const L=O.shift(),N=O.shift(),W=[];for(const q of oe(L))for(const V of oe(N))W.push(Y.create([q,V],null,!1));O.unshift(B.create(W,null,!1))}this.c=B.create(O,this,!0)}return this.c}}e.$Yi=B;class F extends m{static{this.d=[]}static all(){return F.d.values()}constructor(O,L,N){super(O,null),this.f=L,typeof N=="object"?F.d.push({...N,key:O}):N!==!0&&F.d.push({key:O,description:N,type:L!=null?typeof L:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return I.create(this.key,O)}notEqualsTo(O){return R.create(this.key,O)}}e.$Zi=F,e.$1i=(0,M.$zh)("contextKeyService");function U(K,O){return K<O?-1:K>O?1:0}function H(K,O,L,N){return K<L?-1:K>L?1:O<N?-1:O>N?1:0}function Q(K,O){if(K.type===0||O.type===1)return!0;if(K.type===9)return O.type===9?x(K.expr,O.expr):!1;if(O.type===9){for(const L of O.expr)if(Q(K,L))return!0;return!1}if(K.type===6){if(O.type===6)return x(O.expr,K.expr);for(const L of K.expr)if(Q(L,O))return!0;return!1}return K.equals(O)}e.$2i=Q;function x(K,O){let L=0,N=0;for(;L<K.length&&N<O.length;){const W=K[L].cmp(O[N]);if(W<0)return!1;W===0&&L++,N++}return L===K.length}function oe(K){return K.type===9?K.expr:[K]}}),define(te[90],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.ID=void 0,e.ID="diagnosticsService",e.$em=(0,E.$zh)(e.ID);function C(M){return!!M.hostName&&!!M.errorMessage}e.$fm=C;class s{async getPerformanceInfo(A,S){return{}}async getSystemInfo(A,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,S){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$gm=s}),define(te[91],ie([0,1,19,70,164,6,46,4,37]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oA=e.$nA=e.ConfirmResult=e.$mA=e.$lA=e.$kA=void 0,e.$kA=(0,M.$zh)("dialogService");var u;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(u||(u={}));class p{a(d){return this.d(d,u.Confirmation)}b(d){return this.d(d,u.Prompt)}c(d){return this.d(d,u.Input)}d(d,c){const a=[];switch(c){case u.Confirmation:{const w=d;w.primaryButton?a.push(w.primaryButton):a.push((0,s.localize)(0,null)),w.cancelButton?a.push(w.cancelButton):a.push((0,s.localize)(1,null));break}case u.Prompt:{const w=d;Array.isArray(w.buttons)&&w.buttons.length>0&&a.push(...w.buttons.map(k=>k.label)),w.cancelButton&&(w.cancelButton===!0?a.push((0,s.localize)(2,null)):typeof w.cancelButton=="string"?a.push(w.cancelButton):w.cancelButton.label?a.push(w.cancelButton.label):a.push((0,s.localize)(3,null))),a.length===0&&a.push((0,s.localize)(4,null));break}case u.Input:{const w=d;w.primaryButton?a.push(w.primaryButton):a.push((0,s.localize)(5,null)),w.cancelButton?a.push(w.cancelButton):a.push((0,s.localize)(6,null));break}}return a}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===C.default.Info?"info":d===C.default.Error?"error":d===C.default.Warning?"warning":"none"}async f(d,c,a){const w=[...d.buttons??[]];return d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&w.push(d.cancelButton),{result:await w[c]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.$lA=p,e.$mA=(0,M.$zh)("fileDialogService");var $;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})($||(e.ConfirmResult=$={}));const v=10;function h(b){const d=[];return d.push(...b.slice(0,v).map(c=>typeof c=="string"?c:(0,E.$dg)(c))),b.length>v&&(b.length-v===1?d.push((0,s.localize)(7,null)):d.push((0,s.localize)(8,null,b.length-v))),d.push(""),d.join(`
`)}e.$nA=h;function y(b,d){const c=(0,f.$Tm)(b);let a=(c.buttons??[]).map(t=>(0,A.$hA)(t)),w=(b.buttons||[]).map((t,l)=>l),k=0,g=c.cancelId??a.length-1;if(a.length>1){const t=typeof g=="number"?a[g]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&a.length>1&&g!==1){a.splice(g,1),a.splice(1,0,t);const l=w[g];w.splice(g,1),w.splice(1,0,l),g=1}S.$k&&a.length>1&&(a=a.reverse(),w=w.reverse(),k=a.length-1,typeof t=="string"&&(g=k-1))}else if(S.$i&&typeof t=="string"&&a.length>1&&g!==a.length-1){a.splice(g,1),a.push(t);const l=w[g];w.splice(g,1),w.push(l),g=a.length-1}}return c.buttons=a,c.defaultId=k,c.cancelId=g,c.noLink=!0,c.title=c.title||d.nameLong,{options:c,buttonIndeces:w}}e.$oA=y}),define(te[115],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qT=e.$pT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$oT=e.$nT=void 0,e.$nT=(0,E.$zh)("encryptionService"),e.$oT=(0,E.$zh)("encryptionMainService");var C;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(C||(e.PasswordStoreCLIOption=C={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$pT=M;function A(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$qT=A}),define(te[36],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=void 0,e.$Gh=(0,E.$zh)("environmentService"),e.$Hh=(0,E.$Ah)(e.$Gh)}),define(te[116],ie([0,1,168,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Xn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0,e.$Kn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ln=new RegExp(e.$Kn),e.$Mn="__web_extension",e.$Nn="skipWalkthrough",e.$On="extensionsSync",e.$Pn="dependecyOrPackExtensionInstall";function s(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Qn=s;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Rn=M;function A(a,w){switch(a){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Sn=A;function S(a,w){return w==="web"&&!a.includes("web")}e.$Tn=S;function f(a,w,k){return S(w,k)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===k?!0:u(k).includes(a)}e.$Un=f;function u(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Vn=u;function p(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$Wn=p;var $;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var v;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var h;(function(a){a.Install="install",a.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var y;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$Xn=(0,C.$zh)("extensionGalleryService");var b;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var d;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class c extends Error{constructor(w,k){super(w),this.code=k,this.name=k}}e.$Yn=c,e.$Zn=(0,C.$zh)("extensionManagementService"),e.$1n="extensionsIdentifiers/disabled",e.$2n="extensionsIdentifiers/enabled",e.$3n=(0,C.$zh)("IGlobalExtensionEnablementService"),e.$4n=(0,C.$zh)("IExtensionTipsService"),e.$5n=(0,E.localize)(0,null),e.$6n={value:e.$5n,original:"Extensions"},e.$7n={value:(0,E.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkb=void 0,e.$Gkb=(0,E.$zh)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n5b=e.$m5b=void 0,e.$m5b=(0,E.$zh)("extensionHostStarter"),e.$n5b="extensionHostStarter"}),define(te[117],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BWb=e.$AWb=e.$zWb=void 0,e.$zWb=(0,E.$zh)("externalTerminal"),e.$AWb="Terminal.app",e.$BWb=(0,E.$zh)("externalTerminal")}),define(te[209],ie([0,1,47,13,9,4,73,21,88,172,117]),function(G,e,E,C,s,M,A,S,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r5b=e.$q5b=e.$p5b=void 0;const $=u.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends v{static{this.b="cmd.exe"}openTerminal(k,g){return this.spawnTerminal(E,k,f.$sl(),g)}spawnTerminal(k,g,t,l){const r=g.windowsExec||h.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=s.$cd(r,".exe").toLowerCase();if(i==="cmder")return k.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((o,m)=>{const I=d(process),D=k.spawn(t,n,{cwd:l,env:I});D.on("error",m),D.on("exit",()=>o())})}runInTerminal(k,g,t,l,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:h.getDefaultTerminalWindows();return new Promise((n,o)=>{const m=`"${g} - ${$}"`,I=`""${t.join('" "')}" & pause"`,D=Object.assign({},d(process),l);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const P={cwd:g,env:D,windowsVerbatimArguments:!0};let R,j;s.$cd(i,".exe")==="wt"?(R=i,j=["-d",".",h.b,"/c",I]):(R=h.b,j=["/c","start",m,"/wait",i,"/c",I]),E.spawn(R,j,P).on("error",z=>{o(c(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const k=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${k?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.$p5b=h;class y extends v{static{this.b="/usr/bin/osascript"}openTerminal(k,g){return this.spawnTerminal(E,k,g)}runInTerminal(k,g,t,l,r){const i=r.osxExec||p.$AWb;return new Promise((n,o)=>{if(i===p.$AWb||i==="iTerm.app"){const m=i===p.$AWb?"TerminalHelper":"iTermHelper",D=[C.$4e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`).fsPath,"-t",k||$,"-w",g];for(const j of t)D.push("-a"),D.push(j);if(l){const j=Object.assign({},d(process),l);for(const T in j){const z=j[T];z===null?(D.push("-u"),D.push(T)):(D.push("-e"),D.push(`${T}=${z}`))}}let P="";const R=E.spawn(y.b,D);R.on("error",j=>{o(c(j))}),R.stderr.on("data",j=>{P+=j.toString()}),R.on("exit",j=>{if(j===0)n(void 0);else if(P){const T=P.split(`
`,1);o(new Error(T[0]))}else o(new Error(u.localize(1,null,m,j)))})}else o(new Error(u.localize(2,null,i)))})}spawnTerminal(k,g,t){const l=g.osxExec||p.$AWb;return new Promise((r,i)=>{const n=["-a",l];t&&n.push(t);const o=d(process),m=k.spawn("/usr/bin/open",n,{cwd:t,env:o});m.on("error",i),m.on("exit",()=>r())})}}e.$q5b=y;class b extends v{static{this.b=u.localize(3,null)}openTerminal(k,g){return this.spawnTerminal(E,k,g)}runInTerminal(k,g,t,l,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const m=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const D=`${a(t)}; echo; read -p "${b.b}" -n1;`;m.push(`''${D}''`);const P=Object.assign({},d(process),l);Object.keys(P).filter(z=>P[z]===null).forEach(z=>delete P[z]);const R={cwd:g,env:P};let j="";const T=E.spawn(I,m,R);T.on("error",z=>{o(c(z))}),T.stderr.on("data",z=>{j+=z.toString()}),T.on("exit",z=>{if(z===0)n(void 0);else if(j){const ne=j.split(`
`,1);o(new Error(ne[0]))}else o(new Error(u.localize(4,null,I,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!M.$k)b.d=Promise.resolve("xterm");else{const k=await S.Promises.exists("/etc/debian_version");b.d=new Promise(g=>{k?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return b.d}spawnTerminal(k,g,t){const l=g.linuxExec?Promise.resolve(g.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{l.then(n=>{const o=d(process),m=k.spawn(n,[],{cwd:t,env:o});m.on("error",i),m.on("exit",()=>r())})})}}e.$r5b=b;function d(w){const k={...w.env};return(0,A.$ql)(k),k}function c(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(u.localize(5,null,w.path)):w}function a(w){let k="";for(const g of w)g.indexOf(" ")>=0?k+='"'+g+'"':k+=g,k+=" ";return k}}),define(te[16],ie([0,1,58,9,26,12,7,174,6,4,13]),function(G,e,E,C,s,M,A,S,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileKind=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileOperationResult=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileChangeType=e.$ik=e.FileOperation=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderErrorCode=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$5j=e.$4j=void 0,e.$4j=(0,f.$zh)("fileService");function $(U){return U.create===!0}e.$5j=$;var v;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var h;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var y;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function b(U){return!!(U.capabilities&2)}e.$6j=b;function d(U){return!!(U.capabilities&8)}e.$7j=d;function c(U){return!!(U.capabilities&131072)}e.$8j=c;function a(U){return!!(U.capabilities&4)}e.$9j=a;function w(U){return!!(U.capabilities&16)}e.$0j=w;function k(U){return b(U)?!!(U.capabilities&16384):!1}e.$$j=k;function g(U){return b(U)?!!(U.capabilities&32768):!1}e.$_j=g;function t(U){return!!(U.capabilities&65536)}e.$ak=t;function l(U){return!!(U.capabilities&2048)}e.$bk=l;var r;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(H,Q){const x=new i(H.toString(),Q);return m(x,Q),x}constructor(H,Q){super(H),this.code=Q}}e.$ck=i;function n(U,H){return i.create(U,H)}e.$dk=n;function o(U){return U||n((0,S.localize)(0,null),r.Unknown)}e.$ek=o;function m(U,H){return U.name=H?`${H} (FileSystemError)`:"FileSystemError",U}e.$fk=m;function I(U){if(!U)return r.Unknown;if(U instanceof i)return U.code;const H=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!H)return r.Unknown;switch(H[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$gk=I;function D(U){if(U instanceof ne)return U.fileOperationResult;switch(I(U)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$hk=D;var P;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class R{constructor(H,Q,x){this.resource=H,this.operation=Q,this.target=x}isOperation(H){return this.operation===H}}e.$ik=R;var j;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class T{constructor(H,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const x=new Map;for(const oe of H){const K=x.get(oe.type);switch(K?K.push([oe.resource,oe]):x.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,K]of x)switch(oe){case 1:this.a=E.$Fh.forUris(()=>Q),this.a.fill(K);break;case 0:this.b=E.$Fh.forUris(()=>Q),this.b.fill(K);break;case 2:this.c=E.$Fh.forUris(()=>Q),this.c.fill(K);break}}contains(H,...Q){return this.d(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.d(H,{includeChildren:!0},...Q)}d(H,Q,...x){if(!H)return!1;const oe=x.length>0;return!!((!oe||x.includes(1))&&(this.a?.get(H)||Q.includeChildren&&this.a?.findSuperstr(H))||(!oe||x.includes(0))&&(this.b?.get(H)||Q.includeChildren&&this.b?.findSuperstr(H))||(!oe||x.includes(2))&&(this.c?.findSubstr(H)||Q.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$jk=T;function z(U,H,Q){return!U||!H||U===H||H.length>U.length?!1:(H.charAt(H.length-1)!==C.sep&&(H+=C.sep),Q?(0,s.$Pd)(U,H):U.indexOf(H)===0)}e.$kk=z;class ne extends Error{constructor(H,Q,x){super(H),this.fileOperationResult=Q,this.options=x}}e.$lk=ne;class ee extends ne{constructor(H,Q,x,oe){super(H,Q,oe),this.fileOperationResult=Q,this.size=x}}e.$mk=ee;class ce extends ne{constructor(H,Q,x){super(H,2,x),this.stat=Q}}e.$nk=ce;var se;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$qk="files.associations",e.$rk="files.exclude",e.$sk="files.readonlyInclude",e.$tk="files.readonlyExclude",e.$uk="files.readonlyFromPermissions";var ae;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.$vk="";function J(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.$wk=J;async function Y(U,H){if(!H.hasProvider(A.URI.from({scheme:U.scheme})))return new Promise(Q=>{const x=H.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===U.scheme&&oe.added&&(x.dispose(),Q())})})}e.$xk=Y;class B{static{this.KB=1024}static{this.MB=B.KB*B.KB}static{this.GB=B.MB*B.KB}static{this.TB=B.GB*B.KB}static formatSize(H){return(0,M.$pe)(H)||(H=0),H<B.KB?(0,S.localize)(1,null,H.toFixed(0)):H<B.MB?(0,S.localize)(2,null,(H/B.KB).toFixed(2)):H<B.GB?(0,S.localize)(3,null,(H/B.MB).toFixed(2)):H<B.TB?(0,S.localize)(4,null,(H/B.GB).toFixed(2)):(0,S.localize)(5,null,(H/B.TB).toFixed(2))}}e.$yk=B;function F(U){const H=typeof U=="string"||U?.scheme===p.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===p.Schemas.file?1024*B.MB:H?10*B.MB:u.$o?50*B.MB:1024*B.MB}e.$zk=F}),define(te[210],ie([0,1,17,50,14,3,2,56,7,31,16]),function(G,e,E,C,s,M,A,S,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=void 0,e.$XM="localFilesystem";class $ extends A.$mb{constructor(h,y){super(),this.a=h,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$hc),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$hc),this.onDidWatchError=this.g.event,this.h=(0,u.$6e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,y){const{buffer:b}=await this.a.call("readFile",[h,y]);return b}readFileStream(h,y,b){const d=(0,S.$vc)(a=>E.$Hc.concat(a.map(w=>E.$Hc.wrap(w))).buffer),c=this.a.listen("readFileStream",[h,y])(a=>{if(a instanceof E.$Hc)d.write(a.buffer);else{if(a==="end")d.end();else{let w;if(a instanceof Error)w=a;else{const k=a;w=(0,p.$dk)(k.message??(0,C.$ki)(k),k.code??p.FileSystemProviderErrorCode.Unknown)}d.error(w),d.end()}c.dispose()}});return b.onCancellationRequested(()=>{d.error((0,s.$4)()),d.end(),c.dispose()}),d}writeFile(h,y,b){return this.a.call("writeFile",[h,E.$Hc.wrap(y),b])}open(h,y){return this.a.call("open",[h,y])}close(h){return this.a.call("close",[h])}async read(h,y,b,d,c){const[a,w]=await this.a.call("read",[h,y,c]);return b.set(a.buffer.slice(0,w),d),w}write(h,y,b,d,c){return this.a.call("write",[h,y,E.$Hc.wrap(b),d,c])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,y){return this.a.call("delete",[h,y])}rename(h,y,b){return this.a.call("rename",[h,y,b])}copy(h,y,b){return this.a.call("copy",[h,y,b])}cloneFile(h,y){return this.a.call("cloneFile",[h,y])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const y=h;this.f.fire(y.map(b=>({resource:f.URI.revive(b.resource),type:b.type})))}else{const y=h;this.g.fire(y)}}))}watch(h,y){const b=(0,u.$6e)();return this.a.call("watch",[this.h,b,h,y]),(0,A.$kb)(()=>this.a.call("unwatch",[this.h,b]))}}e.$YM=$}),define(te[118],ie([0,1,17,14,175,16]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;async function A(p,$,v,h,y,b){let d;try{await S(p,$,v,h,y,b)}catch(c){d=c}finally{d&&y.errorTransformer&&(d=y.errorTransformer(d)),typeof d<"u"&&v.error(d),v.end()}}e.$zp=A;async function S(p,$,v,h,y,b){f(b);const d=await p.open($,{create:!1});try{f(b);let c=0,a=0,w=y&&typeof y.length=="number"?y.length:void 0,k=E.$Hc.alloc(Math.min(y.bufferSize,typeof w=="number"?w:y.bufferSize)),g=y&&typeof y.position=="number"?y.position:0,t=0;do a=await p.read(d,g,k.buffer,t,k.byteLength-t),g+=a,t+=a,c+=a,typeof w=="number"&&(w-=a),t===k.byteLength&&(await v.write(h(k)),k=E.$Hc.alloc(Math.min(y.bufferSize,typeof w=="number"?w:y.bufferSize)),t=0);while(a>0&&(typeof w!="number"||w>0)&&f(b)&&u(c,y));if(t>0){let l=t;typeof w=="number"&&(l=Math.min(t,w)),v.write(h(k.slice(0,l)))}}catch(c){throw(0,M.$ek)(c)}finally{await p.close(d)}}function f(p){if(p.isCancellationRequested)throw(0,C.$4)();return!0}function u(p,$){if(typeof $?.limits?.size=="number"&&p>$.limits.size)throw(0,M.$dk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[76],ie([0,1,104,2,9,4,7,16]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0;function f(c){return c.recursive===!0}e.$Bp=f;class u extends C.$mb{static{this.a=5}constructor(a,w,k,g){super(),this.h=a,this.i=w,this.j=k,this.k=g,this.c=this.B(new C.$nb),this.f=void 0,this.g=0}m(){const a=new C.$lb;this.c.value=a,this.b=this.l(a),this.b.setVerboseLogging(this.j),a.add(this.b.onDidChangeFile(w=>this.h(w))),a.add(this.b.onDidLogMessage(w=>this.i(w))),a.add(this.b.onDidError(w=>this.n(w)))}n(a){this.k.restartOnError?this.g<u.a&&this.f?(this.r(`restarting watcher after error: ${a}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${a}`):this.r(a)}p(a){this.g++,this.m(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.j=a,await this.b?.setVerboseLogging(a)}r(a){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${a}`})}s(a){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Cp=u;class p extends u{constructor(a,w,k){super(a,w,k,{type:"node.js",restartOnError:!1})}}e.$Dp=p;class $ extends u{constructor(a,w,k){super(a,w,k,{type:"universal",restartOnError:!0})}}e.$Ep=$;function v(c){return c.map(a=>({type:a.type,resource:A.URI.file(a.path)}))}e.$Fp=v;function h(c){const a=new d;for(const w of c)a.processEvent(w);return a.coalesce()}e.$Gp=h;function y(c,a){return typeof a=="string"&&!a.startsWith(E.$lj)&&!(0,s.$0c)(a)?{base:c,pattern:a}:a}e.$Hp=y;function b(c,a){const w=[];for(const k of a)w.push((0,E.$pj)(y(c,k)));return w}e.$Ip=b;class d{constructor(){this.a=new Set,this.b=new Map}c(a){return M.$k?a.path:a.path.toLowerCase()}processEvent(a){const w=this.b.get(this.c(a));let k=!1;if(w){const g=w.type,t=a.type;w.path!==a.path&&(a.type===2||a.type===1)?k=!0:g===1&&t===2?(this.b.delete(this.c(a)),this.a.delete(w)):g===2&&t===1?w.type=0:g===1&&t===0||(w.type=t)}else k=!0;k&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],w=[];return Array.from(this.a).filter(k=>k.type!==2?(a.push(k),!1):!0).sort((k,g)=>k.path.length-g.path.length).filter(k=>w.some(g=>(0,S.$kk)(k.path,g,!M.$k))?!1:(w.push(k.path),!0)).concat(a)}}}),define(te[211],ie([0,1,45,8,22,32,2,85,9,4,105,21,76]),function(G,e,E,C,s,M,A,S,f,u,p,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0;class h extends A.$mb{static{this.a=100}static{this.b=75}constructor(d,c,a,w){super(),this.j=d,this.k=c,this.l=a,this.m=w,this.c=this.B(new C.$Tg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},k=>this.k(k))),this.f=this.B(new C.$Sg(k=>this.u(k),h.b)),this.g=(0,v.$Ip)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,v.$Ip)(this.j.path,this.j.includes):void 0,this.i=new s.$rc,this.ready=this.n()}async n(){try{const d=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const c=await $.Promises.stat(d);this.B(await this.s(d,c.isDirectory()))}catch(d){d.code!=="ENOENT"?this.w(d):this.z(d)}}async r(d){let c=d.path;try{c=await $.Promises.realpath(d.path),d.path===c&&(c=await(0,p.$Sp)(d.path)??d.path),d.path!==c&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${c})`)}catch{}return c}async s(d,c){if(u.$j&&(0,M.$Ke)(d,"/Volumes/",!0))return this.w(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$mb.None;const a=new s.$rc(this.i.token),w=new A.$lb;try{const k=(0,f.$cd)(d),g=(0,E.watch)(d);w.add((0,A.$kb)(()=>{g.removeAllListeners(),g.close()})),this.z(`Started watching: '${d}'`);const t=new Set;if(c)try{for(const r of await $.Promises.readdir(d))t.add(r)}catch(r){this.w(r)}const l=new Map;w.add((0,A.$kb)(()=>{for(const[,r]of l)r.dispose();l.clear()})),g.on("error",(r,i)=>{this.w(`Failed to watch ${d} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),g.on("change",(r,i)=>{if(a.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${i}`);let n="";if(i&&(n=i.toString(),u.$j&&(n=(0,S.$fl)(n))),!(!n||r!=="change"&&r!=="rename"))if(c)if(r==="rename"){l.get(n)?.dispose();const o=setTimeout(async()=>{if(l.delete(n),n===k&&!await $.Promises.exists(d)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.v((0,f.$$c)(d,n));if(a.token.isCancellationRequested)return;let I;m?t.has(n)?I=0:(I=1,t.add(n)):(t.delete(n),I=2),this.t({path:(0,f.$$c)(this.j.path,n),type:I})},h.a);l.set(n,(0,A.$kb)(()=>clearTimeout(o)))}else{let o;t.has(n)?o=0:(o=1,t.add(n)),this.t({path:(0,f.$$c)(this.j.path,n),type:o})}else if(r==="rename"||n!==k){const o=setTimeout(async()=>{const m=await $.Promises.exists(d);a.token.isCancellationRequested||(m?(this.t({path:this.j.path,type:0},!0),w.add(await this.s(d,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);w.clear(),w.add((0,A.$kb)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(k){await $.Promises.exists(d)&&!a.token.isCancellationRequested&&this.w(`Failed to watch ${d} for changes using fs.watch() (${k.toString()})`)}return(0,A.$kb)(()=>{a.dispose(!0),w.dispose()})}t(d,c=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!c&&this.g.some(a=>a(d.path))?this.m&&this.z(` >> ignored (excluded) ${d.path}`):!c&&this.h&&this.h.length>0&&!this.h.some(a=>a(d.path))?this.m&&this.z(` >> ignored (not included) ${d.path}`):this.f.work(d))}u(d){const c=(0,v.$Gp)(d);if(c.length>0){if(this.m)for(const w of c)this.z(`>> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`);this.c.work(c)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(d){if(u.$k)return $.Promises.exists(d);try{const c=(0,f.$cd)(d);return(await $.Promises.readdir((0,f.$bd)(d))).some(w=>w===c)}catch(c){return this.z(c),!1}}setVerboseLogging(d){this.m=d}w(d){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}y(d){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}z(d){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Vp=h;async function y(b,d,c,a,w=512){const k=await $.Promises.open(b,"r"),g=Buffer.allocUnsafe(w),t=new s.$rc(a);let l,r=!1;const i={path:b,excludes:[],recursive:!1},n=new h(i,o=>{(async()=>{for(const{type:m}of o)if(m===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await $.Promises.read(k,g,0,w,null);if(!I||t.token.isCancellationRequested)break;d(g.slice(0,I))}}catch(I){l=new Error(I),t.dispose(!0)}finally{r=!1}}})()});return await n.ready,c(),new Promise((o,m)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await $.Promises.close(k)}catch(I){l=new Error(I)}l?m(l):o()})})}e.$Wp=y}),define(te[212],ie([0,1,3,104,2,4,211]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class S extends s.$mb{constructor(){super(...arguments),this.a=this.B(new E.$hc),this.onDidChangeFile=this.a.event,this.b=this.B(new E.$hc),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(u){const p=this.i(u),$=p.filter(h=>{const y=this.c.get(h.path);return y?!(0,C.$tj)(y.request.excludes,h.excludes)||!(0,C.$tj)(y.request.includes,h.includes):!0}),v=Array.from(this.c.values()).filter(({request:h})=>!p.find(y=>y.path===h.path&&(0,C.$tj)(y.excludes,h.excludes)&&(0,C.$tj)(y.includes,h.includes))).map(({request:h})=>h.path);$.length&&this.j(`Request to start watching: ${$.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const h of v)this.h(h);for(const h of $)this.g(h)}g(u){const p=new A.$Vp(u,v=>this.a.fire(v),v=>this.b.fire(v),this.f),$={request:u,instance:p};this.c.set(u.path,$)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const p=this.c.get(u);p&&(this.c.delete(u),p.instance.dispose())}i(u){const p=new Map;for(const $ of u){const v=M.$k?$.path:$.path.toLowerCase();p.set(v,$)}return Array.from(p.values())}async setVerboseLogging(u){this.f=u;for(const[,p]of this.c)p.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,p){return p?`[File Watcher (node.js)] ${u} (path: ${p.request.path})`:`[File Watcher (node.js)] ${u}`}}e.$Xp=S}),define(te[213],ie([0,1,76,212]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class s extends E.$Dp{constructor(A,S,f){super(A,S,f),this.m()}l(A){return A.add(new C.$Xp)}}e.$Yp=s}),define(te[214],ie([0,1,13,42,158,76]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class A extends M.$Ep{constructor(f,u,p){super(f,u,p),this.m()}l(f){const u=f.add(new s.$Pp(E.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(u.onDidProcessExit(({code:p,signal:$})=>this.n(`terminated by itself with code ${p}, signal: ${$}`))),C.ProxyChannel.toService((0,C.$gh)(u.getChannel("watcher")))}}e.$Qp=A}),define(te[92],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class E{constructor(...s){this.a=new Map;for(const[M,A]of s)this.set(M,A)}set(s,M){const A=this.a.get(s);return this.a.set(s,M),A}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$xh=E}),define(te[215],ie([0,1,8,14,2,75,206,6,92,101]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;const p=!1;class $ extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new f.$xh,c=!1,a,w=p){this.f=d,this.g=c,this.h=a,this.i=w,this.o=new Set,this.f.set(S.$yh,this),this._globalGraph=w?a?._globalGraph??new A.$2p(k=>k):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...c){const a=y.traceInvocation(this.i,d);let w=!1;try{return d({get:g=>{if(w)throw(0,C.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(g,a);if(!t)throw new Error(`[invokeFunction] unknown service '${g}'`);return t}},...c)}finally{w=!0,a.stop()}}createInstance(d,...c){let a,w;return d instanceof M.$wh?(a=y.traceCreation(this.i,d.ctor),w=this.j(d.ctor,d.staticArguments.concat(c),a)):(a=y.traceCreation(this.i,d),w=this.j(d,c,a)),a.stop(),w}j(d,c=[],a){const w=S._util.getServiceDependencies(d).sort((t,l)=>t.index-l.index),k=[];for(const t of w){const l=this.m(t.id,a);l||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),k.push(l)}const g=w.length>0?w[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${c.length} static arguments`);const t=g-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,g)}return Reflect.construct(d,c.concat(k))}k(d,c){if(this.f.get(d)instanceof M.$wh)this.f.set(d,c);else if(this.h)this.h.k(d,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const c=this.f.get(d);return!c&&this.h?this.h.l(d):c}m(d,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const a=this.l(d);return a instanceof M.$wh?this.q(d,a,c.branch(d,!0)):(c.branch(d,!1),a)}q(d,c,a){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,c,a)}finally{this.o.delete(d)}}r(d,c,a){const w=new A.$2p(t=>t.id.toString());let k=0;const g=[{id:d,desc:c,_trace:a}];for(;g.length;){const t=g.pop();if(w.lookupOrInsertNode(t),k++>1e3)throw new $(w);for(const l of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof M.$wh){const i={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};w.insertEdge(t,i),g.push(i)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new $(w);break}for(const{data:l}of t){if(this.l(l.id)instanceof M.$wh){const i=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,i)}w.removeNode(l)}}return this.l(d)}s(d,c,a=[],w,k){if(this.f.get(d)instanceof M.$wh)return this.t(d,c,a,w,k);if(this.h)return this.h.s(d,c,a,w,k);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(d,c,a=[],w,k){if(w){const g=new v(void 0,this.g,this,this.i);g.c=String(d);const t=new Map,l=new E.$Vg(()=>{const r=g.j(c,a,k);for(const[i,n]of t){const o=r[i];if(typeof o=="function")for(const m of n)o.apply(r,m)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let m=t.get(i);return m||(m=new u.$vb,t.set(i,m)),(D,P,R)=>{const j=m.push([D,P,R]);return(0,s.$kb)(j)}}if(i in r)return r[i];const n=l.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),r[i]=o),o},set(r,i,n){return l.value[i]=n,!0},getPrototypeOf(r){return c.prototype}})}else return this.j(c,a,k)}u(d,c){if(c&&console.warn(d),this.g)throw new Error(d)}}e.$3p=v;var h;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(h||(h={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,c){return d?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(d,c){return d?new y(1,c.name):y.c}static{this.f=0}constructor(d,c){this.type=d,this.name=c,this.g=Date.now(),this.h=[]}branch(d,c){const a=new y(3,d.toString());return this.h.push([d,c,a]),a}stop(){const d=Date.now()-this.g;y.f+=d;let c=!1;function a(k,g){const t=[],l=new Array(k+1).join("	");for(const[r,i,n]of g.h)if(i&&n){c=!0,t.push(`${l}CREATES -> ${r}`);const o=a(k+1,n);o&&t.push(o)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(d>2||c)&&y.all.add(w.join(`
`))}}e.$4p=y}),define(te[216],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ysb=e.IssueType=void 0;var C;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={})),e.$Ysb=(0,E.$zh)("issueService")}),define(te[5],ie([0,1,50,3,57,2,34,4,19,12,7,114,6]),function(G,e,E,C,s,M,A,S,f,u,p,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.log=e.$6i=e.LogLevel=e.$5i=e.$4i=e.$3i=void 0,e.$3i=(0,v.$zh)("logService"),e.$4i=(0,v.$zh)("loggerService");function h(){return new Date().toISOString()}function y(D){return(0,u.$pe)(D)}e.$5i=y;var b;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$6i=b.Info;function d(D,P,R){switch(P){case b.Trace:D.trace(R);break;case b.Debug:D.debug(R);break;case b.Info:D.info(R);break;case b.Warning:D.warn(R);break;case b.Error:D.error(R);break;case b.Off:break;default:throw new Error(`Invalid log level ${P}`)}}e.log=d;function c(D,P=!1){let R="";for(let j=0;j<D.length;j++){let T=D[j];if(T instanceof Error&&(T=(0,E.$ki)(T,P)),typeof T=="object")try{T=JSON.stringify(T)}catch{}R+=(j>0?" ":"")+T}return R}class a extends M.$mb{constructor(){super(...arguments),this.b=e.$6i,this.c=this.B(new C.$hc),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==b.Off&&this.b<=P}}e.$8i=a;class w extends a{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...R){this.f(b.Trace)&&this.g(b.Trace,c([P,...R],!0))}debug(P,...R){this.f(b.Debug)&&this.g(b.Debug,c([P,...R]))}info(P,...R){this.f(b.Info)&&this.g(b.Info,c([P,...R]))}warn(P,...R){this.f(b.Warning)&&this.g(b.Warning,c([P,...R]))}error(P,...R){if(this.f(b.Error))if(P instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=P.stack,this.g(b.Error,c(j))}else this.g(b.Error,c([P,...R]))}flush(){}}e.$9i=w;class k extends a{constructor(P=e.$6i){super(),this.setLevel(P),this.g=!S.$i}trace(P,...R){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...R):console.log(`[main ${h()}]`,P,...R))}debug(P,...R){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...R):console.log(`[main ${h()}]`,P,...R))}info(P,...R){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...R):console.log(`[main ${h()}]`,P,...R))}warn(P,...R){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,P,...R):console.warn(`[main ${h()}]`,P,...R))}error(P,...R){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,P,...R):console.error(`[main ${h()}]`,P,...R))}dispose(){}flush(){}}e.$0i=k;class g extends a{constructor(P=e.$6i,R=!0){super(),this.g=R,this.setLevel(P)}trace(P,...R){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...R):console.log(P,...R))}debug(P,...R){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...R):console.log(P,...R))}info(P,...R){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...R):console.log(P,...R))}warn(P,...R){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...R):console.log(P,...R))}error(P,...R){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...R):console.error(P,...R))}dispose(){}flush(){}}e.$$i=g;class t extends a{constructor(P,R=e.$6i){super(),this.g=P,this.setLevel(R)}trace(P,...R){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(P),...R])}debug(P,...R){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(P),...R])}info(P,...R){this.f(b.Info)&&this.g.log(b.Info,[this.h(P),...R])}warn(P,...R){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(P),...R])}error(P,...R){this.f(b.Error)&&this.g.log(b.Error,[this.h(P),...R])}h(P){return typeof P=="string"?P:(0,E.$ki)(P,this.f(b.Trace))}dispose(){}flush(){}}e.$_i=t;class l extends a{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const R of this.g)R.setLevel(P);super.setLevel(P)}trace(P,...R){for(const j of this.g)j.trace(P,...R)}debug(P,...R){for(const j of this.g)j.debug(P,...R)}info(P,...R){for(const j of this.g)j.info(P,...R)}warn(P,...R){for(const j of this.g)j.warn(P,...R)}error(P,...R){for(const j of this.g)j.error(P,...R)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose()}}e.$aj=l;class r extends M.$mb{constructor(P,R,j){if(super(),this.h=P,this.j=R,this.b=new A.$xi,this.c=this.B(new C.$hc),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$hc),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$hc),this.onDidChangeVisibility=this.g.event,j)for(const T of j)this.b.set(T.resource,{logger:void 0,info:T})}k(P){return(0,u.$le)(P)?[...this.b.values()].find(R=>R.info.id===P):this.b.get(P)}getLogger(P){return this.k(P)?.logger}createLogger(P,R){const j=this.l(P),T=(0,u.$le)(P)?P:R?.id??(0,s.$ni)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const ne=R?.logLevel==="always"?b.Trace:R?.logLevel;z||(z=this.m(j,ne??this.getLogLevel(j)??this.h,{...R,id:T}));const ee={logger:z,info:{resource:j,id:T,logLevel:ne,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(ee.info),this.b.set(j,ee),z}l(P){return(0,u.$le)(P)?(0,f.$gg)(this.j,`${P}.log`):P}setLogLevel(P,R){if(p.URI.isUri(P)){const j=P,T=R,z=this.b.get(j);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([j,T]))}else{this.h=P;for(const[j,T]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,R){const j=this.k(P);j&&R!==!j.info.hidden&&(j.info.hidden=!R,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,R]))}getLogLevel(P){let R;return P&&(R=this.b.get(P)?.info.logLevel),R??this.h}registerLogger(P){const R=this.b.get(P.resource);R?R.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const R=this.b.get(P);R&&(R.logger&&R.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bj=r;class i{constructor(){this.onDidChangeLogLevel=new C.$hc().event}setLevel(P){}getLevel(){return b.Info}trace(P,...R){}debug(P,...R){}info(P,...R){}warn(P,...R){}error(P,...R){}critical(P,...R){}dispose(){}flush(){}}e.$cj=i;class n extends i{}e.$dj=n;function o(D){if(D.verbose)return b.Trace;if(typeof D.logLevel=="string"){const P=I(D.logLevel.toLowerCase());if(P!==void 0)return P}return e.$6i}e.$ej=o;function m(D){switch(D){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$fj=m;function I(D){switch(D){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$gj=I,e.$hj=new $.$Zi("logLevel",m(b.Info))});var _=this&&this.__param||function(G,e){return function(E,C){e(E,C,G)}};define(te[217],ie([0,1,15,4,5]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k5b=void 0;const M=E.safeStorage;let A=class{constructor(f){this.a=f,E.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(M.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.a.error(u),u}}async decrypt(f){let u;try{if(u=JSON.parse(f),!u.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const p=Buffer.from(u.data);this.a.trace("[EncryptionMainService] Decrypting value.");const $=M.decryptString(p);return this.a.trace("[EncryptionMainService] Decrypted value."),$}catch(p){throw this.a.error(p),p}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const f=M.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$k5b=A,e.$k5b=A=ke([_(0,s.$3i)],A)}),define(te[218],ie([0,1,24,8,14,3,2,9,76,5]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;class p extends A.$mb{constructor(v,h){super(),this.a=v,this.b=h,this.c=this.B(new M.$hc),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$hc),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new C.$Cg(0)),this.s=[],this.t=this.B(new C.$Cg(0))}watch(v,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(v,h):this.u(v,h)}l(v,h){const y={path:this.C(v),excludes:h.excludes,includes:h.includes,recursive:h.recursive},b=(0,E.$Nf)(this.j,y);return this.m(),(0,A.$kb)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,s.$Y)(v))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,f.$Fp)(h)),h=>this.z(h),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const h of this.j)(0,f.$Bp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const h of this.j)(0,f.$Bp)(h)&&v.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,h){const y={path:this.C(v),excludes:h.excludes,includes:h.includes,recursive:!1},b=(0,E.$Nf)(this.s,y);return this.v(),(0,A.$kb)(()=>{b(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,s.$Y)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,f.$Fp)(v)),v=>this.z(v),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,S.$9c)(v.fsPath)}}e.$Jp=p}),define(te[219],ie([0,1,24,8,17,22,3,57,68,2,58,13,65,19,56,173,16,118,5,14]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;let k=class extends u.$mb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new A.$hc),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$hc),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$hc),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.$hc),this.onDidRunOperation=this.m.event,this.R=this.B(new A.$hc),this.onDidFilesChange=this.R.event,this.S=this.B(new A.$hc),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new C.$Ng)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const r=new u.$lb;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),r.add(l.onDidChangeFile(i=>this.R.fire(new d.$jk(i,!this.O(l))))),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(i=>this.S.fire(new Error(i)))),r.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,u.$kb)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,u.$hb)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(r){l.push(r)}}),!this.h.has(t)&&await C.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return f.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,h.$kg)(t))throw new d.$lk((0,b.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const r=new w.$_;throw r.message=(0,b.localize)(1,null,t.toString()),r}return l}async k(t){const l=await this.j(t);if((0,d.$9j)(l)||(0,d.$6j)(l)||(0,d.$0j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const l=await this.j(t);if((0,d.$9j)(l)||(0,d.$6j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.n(t,l)}catch(r){throw(0,d.$gk)(r)===d.FileSystemProviderErrorCode.FileNotFound?new d.$lk((0,b.localize)(2,null,this.nb(t)),1):(0,d.$ek)(r)}}async n(t,l){const r=await this.j(t),i=this.O(r),n=l?.resolveTo,o=l?.resolveSingleChildDescendants,m=l?.resolveMetadata,I=await r.stat(t);let D;return this.p(r,t,I,void 0,!!m,(P,R)=>(D||(D=p.$Fh.forUris(()=>!i),D.set(t,!0),n&&D.fill(!0,n)),D.get(P.resource)||D.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&o?R===1:!1))}async p(t,l,r,i,n,o){const{providerExtUri:m}=this.N(t),I={resource:l,name:m.basename(l),isFile:(r.type&d.FileType.File)!==0,isDirectory:(r.type&d.FileType.Directory)!==0,isSymbolicLink:(r.type&d.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&d.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&d.FilePermission.Locked),etag:(0,d.$wk)({mtime:r.mtime,size:r.size}),children:void 0};if(I.isDirectory&&o(I,i)){try{const D=await t.readdir(l),P=await C.Promises.settled(D.map(async([R,j])=>{try{const T=m.joinPath(l,R),z=n?await t.stat(T):{type:j};return await this.p(t,T,z,D.length,n,o)}catch(T){return this.b.trace(T),null}}));I.children=(0,E.$Af)(P)}catch(D){this.b.trace(D),I.children=[]}return I}return I}async resolveAll(t){return C.Promises.settled(t.map(async l=>{try{return{stat:await this.n(l.resource,l.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),r=await l.stat(t);return this.p(l,t,r,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.r(t,l)}catch(r){return r}return!0}async r(t,l){if(!l?.overwrite&&await this.exists(t))throw new d.$lk((0,b.localize)(3,null,this.nb(t)),3,l)}async createFile(t,l=s.$Hc.fromString(""),r){await this.r(t,r);const i=await this.writeFile(t,l);return this.m.fire(new d.$ik(t,0,i)),i}async writeFile(t,l,r){const i=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(i);try{await this.s(i,t,r)||await this.P(i,n.dirname(t));let m;if((0,d.$6j)(i)&&!(l instanceof s.$Hc))if((0,y.$tc)(l)){const I=await(0,y.$Ac)(l,3);I.ended?m=s.$Hc.concat(I.buffer):m=I}else m=(0,y.$xc)(l,I=>s.$Hc.concat(I),3);else m=l;if(!(0,d.$9j)(i)||(0,d.$6j)(i)&&m instanceof s.$Hc)await this.cb(i,t,r,m);else{const I=m instanceof s.$Hc?(0,s.$Sc)(m):m;r?.atomic!==!1&&r?.atomic?.postfix?await this.Y(i,t,(0,h.$gg)((0,h.$fg)(t),`${(0,h.$dg)(t)}${r.atomic.postfix}`),r,I):await this.Z(i,t,r,I)}this.m.fire(new d.$ik(t,4))}catch(o){throw new d.$lk((0,b.localize)(4,null,this.nb(t),(0,d.$ek)(o).toString()),(0,d.$hk)(o),r)}return this.resolve(t,{resolveMetadata:!0})}async s(t,l,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.nb(l)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,b.localize)(6,null,this.nb(l)));if(i)throw new Error((0,b.localize)(7,null,this.nb(l)))}let o;try{o=await t.stat(l)}catch{return}if(o.type&d.FileType.Directory)throw new d.$lk((0,b.localize)(8,null,this.nb(l)),0,r);if(this.mb(l,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==d.$vk&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,d.$wk)({mtime:r.mtime,size:o.size}))throw new d.$lk((0,b.localize)(9,null),3,r);return o}async readFile(t,l,r){const i=await this.k(t);return l?.atomic?this.t(i,t,l,r):this.u(i,t,l,r)}async t(t,l,r,i){return new Promise((n,o)=>{this.X.queueFor(l,this.N(t).providerExtUri).queue(async()=>{try{const m=await this.u(t,l,r,i);n(m)}catch(m){o(m)}})})}async u(t,l,r,i){const n=await this.v(t,l,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$Tc)(n.value)}}async readFileStream(t,l,r){const i=await this.k(t);return this.v(i,t,l,r)}async v(t,l,r,i){const n=new M.$rc(i),o=this.F(l,r).then(I=>I,I=>{throw n.dispose(!0),I});let m;try{return typeof r?.etag=="string"&&r.etag!==d.$vk&&await o,r?.atomic&&(0,d.$$j)(t)||!((0,d.$9j)(t)||(0,d.$0j)(t))||(0,d.$6j)(t)&&r?.preferUnbuffered?m=this.D(t,l,r):(0,d.$0j)(t)?m=this.z(t,l,n.token,r):m=this.C(t,l,n.token,r),m.on("end",()=>n.dispose()),m.on("error",()=>n.dispose()),{...await o,value:m}}catch(I){throw m&&await(0,y.$yc)(m),this.w(I,l,r)}}w(t,l,r){const i=(0,b.localize)(10,null,this.nb(l),(0,d.$ek)(t).toString());return t instanceof d.$nk?new d.$nk(i,t.stat,r):t instanceof d.$mk?new d.$mk(i,t.fileOperationResult,t.size,t.options):new d.$lk(i,(0,d.$hk)(t),r)}z(t,l,r,i=Object.create(null)){const n=t.readFileStream(l,i,r);return(0,y.$Ec)(n,{data:o=>o instanceof s.$Hc?o:s.$Hc.wrap(o),error:o=>this.w(o,l,i)},o=>s.$Hc.concat(o))}C(t,l,r,i=Object.create(null)){const n=(0,s.$Xc)();return(0,c.$zp)(t,l,n,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.w(o,l,i)},r),n}D(t,l,r){const i=(0,y.$vc)(n=>s.$Hc.concat(n));return(async()=>{try{let n;r?.atomic&&(0,d.$$j)(t)?n=await t.readFile(l,{atomic:!0}):n=await t.readFile(l),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.G(l,n.byteLength,r),i.end(s.$Hc.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async F(t,l){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new d.$lk((0,b.localize)(11,null,this.nb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==d.$vk&&l.etag===r.etag)throw new d.$nk((0,b.localize)(12,null),r,l);return this.G(t,r.size,l),r}G(t,l,r){if(typeof r?.limits?.size=="number"&&l>r.limits.size)throw new d.$mk((0,b.localize)(13,null,this.nb(t)),7,l,r)}async canMove(t,l,r){return this.H(t,l,"move",r)}async canCopy(t,l,r){return this.H(t,l,"copy",r)}async H(t,l,r,i){if(t.toString()!==l.toString())try{const n=r==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(l),l);await this.M(n,t,o,l,r,i)}catch(n){return n}return!0}async move(t,l,r){const i=this.lb(await this.l(t),t),n=this.lb(await this.l(l),l),o=await this.I(i,t,n,l,"move",!!r),m=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new d.$ik(t,o==="move"?2:3,m)),m}async copy(t,l,r){const i=await this.k(t),n=this.lb(await this.l(l),l),o=await this.I(i,t,n,l,"copy",!!r),m=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new d.$ik(t,o==="copy"?3:2,m)),m}async I(t,l,r,i,n,o){if(l.toString()===i.toString())return n;const{exists:m,isSameResourceWithDifferentPathCase:I}=await this.M(t,l,r,i,n,o);if(m&&!I&&o&&await this.del(i,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,d.$7j)(t))await t.copy(l,i,{overwrite:o});else{const D=await this.resolve(l);D.isDirectory?await this.L(t,D,r,i):await this.J(t,l,r,i)}return n}else return t===r?(await t.rename(l,i,{overwrite:o}),n):(await this.I(t,l,r,i,"copy",o),await this.del(l,{recursive:!0}),"copy")}async J(t,l,r,i){if((0,d.$9j)(t)&&(0,d.$9j)(r))return this.eb(t,l,r,i);if((0,d.$9j)(t)&&(0,d.$6j)(r))return this.kb(t,l,r,i);if((0,d.$6j)(t)&&(0,d.$9j)(r))return this.ib(t,l,r,i);if((0,d.$6j)(t)&&(0,d.$6j)(r))return this.gb(t,l,r,i)}async L(t,l,r,i){await r.mkdir(i),Array.isArray(l.children)&&await C.Promises.settled(l.children.map(async n=>{const o=this.N(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),r,o):this.J(t,n.resource,r,o)}))}async M(t,l,r,i,n,o){let m=!1;if(t===r){const{providerExtUri:D,isPathCaseSensitive:P}=this.N(t);if(P||(m=D.isEqual(l,i)),m&&n==="copy")throw new Error((0,b.localize)(14,null,this.nb(l),this.nb(i)));if(!m&&D.isEqualOrParent(i,l))throw new Error((0,b.localize)(15,null,this.nb(l),this.nb(i)))}const I=await this.exists(i);if(I&&!m){if(!o)throw new d.$lk((0,b.localize)(16,null,this.nb(l),this.nb(i)),4);if(t===r){const{providerExtUri:D}=this.N(t);if(D.isEqualOrParent(l,i))throw new Error((0,b.localize)(17,null,this.nb(l),this.nb(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:m}}N(t){const l=this.O(t);return{providerExtUri:l?h.$9f:h.$$f,isPathCaseSensitive:l}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.lb(await this.j(t),t);await this.P(l,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new d.$ik(t,0,r)),r}async P(t,l){const r=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&d.FileType.Directory))throw new Error((0,b.localize)(18,null,this.nb(l)));break}catch(n){if((0,d.$gk)(n)!==d.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(l)),l=i.dirname(l)}for(let n=r.length-1;n>=0;n--){l=i.joinPath(l,r[n]);try{await t.mkdir(l)}catch(o){if((0,d.$gk)(o)!==d.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,l){try{await this.Q(t,l)}catch(r){return r}return!0}async Q(t,l){const r=this.lb(await this.j(t),t),i=!!l?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,b.localize)(19,null,this.nb(t)));const n=l?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,b.localize)(20,null,this.nb(t)));if(i&&n)throw new Error((0,b.localize)(21,null,this.nb(t)));let o;try{o=await r.stat(t)}catch{}if(o)this.mb(t,o);else throw new d.$lk((0,b.localize)(22,null,this.nb(t)),1);if(!!!l?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,b.localize)(23,null,this.nb(t)))}return r}async del(t,l){const r=await this.Q(t,l),i=!!l?.useTrash,n=!!l?.recursive,o=l?.atomic??!1;await r.delete(t,{recursive:n,useTrash:i,atomic:o}),this.m.fire(new d.$ik(t,1))}async cloneFile(t,l){const r=await this.j(t),i=this.lb(await this.l(l),l);if(r===i&&this.N(r).providerExtUri.isEqual(t,l))return;if(r===i&&(0,d.$8j)(r))return r.cloneFile(t,l);await this.P(i,this.N(i).providerExtUri.dirname(l));const n=this.X.queueFor(t,this.N(r).providerExtUri);return r===i&&(0,d.$7j)(r)?n.queue(()=>r.copy(t,l,{overwrite:!0})):n.queue(()=>this.J(r,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const r=new u.$lb;let i=!1,n=()=>{i=!0};return r.add((0,u.$kb)(()=>n())),(async()=>{try{const o=await this.W(t,l);i?(0,u.$hb)(o):n=()=>(0,u.$hb)(o)}catch(o){this.b.error(o)}})(),r}async W(t,l){const r=await this.j(t),i=(0,S.$ni)([this.N(r).providerExtUri.getComparisonKey(t),l]);let n=this.U.get(i);return n||(n={count:0,disposable:r.watch(t,l)},this.U.set(i,n)),n.count+=1,(0,u.$kb)(()=>{n&&(n.count--,n.count===0&&((0,u.$hb)(n.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,u.$hb)(t.disposable);this.U.clear()}async Y(t,l,r,i,n){await this.Z(t,r,i,n);try{await t.rename(r,l,{overwrite:!0})}catch(o){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(t,l,r,i){return this.X.queueFor(l,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,y.$tc)(i)||(0,y.$uc)(i)?await this.$(t,n,i):await this.ab(t,n,i)}catch(o){throw(0,d.$ek)(o)}finally{await t.close(n)}})}async $(t,l,r){let i=0,n;if((0,y.$uc)(r)){if(r.buffer.length>0){const o=s.$Hc.concat(r.buffer);await this.bb(t,l,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,m)=>{(0,y.$zc)(n,{onData:async I=>{n.pause();try{await this.bb(t,l,I,I.byteLength,i,0)}catch(D){return m(D)}i+=I.byteLength,setTimeout(()=>n.resume())},onError:I=>m(I),onEnd:()=>o()})})}async ab(t,l,r){let i=0,n;for(;(n=r.read())!==null;)await this.bb(t,l,n,n.byteLength,i,0),i+=n.byteLength}async bb(t,l,r,i,n,o){let m=0;for(;m<i;){const I=await t.write(l,n+m,r.buffer,o+m,i-m);m+=I}}async cb(t,l,r,i){return this.X.queueFor(l,this.N(t).providerExtUri).queue(()=>this.db(t,l,r,i))}async db(t,l,r,i){let n;i instanceof s.$Hc?n=i:(0,y.$tc)(i)?n=await(0,s.$Tc)(i):(0,y.$uc)(i)?n=await(0,s.$Uc)(i):n=(0,s.$Rc)(i),await t.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async eb(t,l,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.fb(t,l,r,i))}async fb(t,l,r,i){let n,o;try{n=await t.open(l,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const m=s.$Hc.alloc(this.a);let I=0,D=0,P=0;do P=await t.read(n,I,m.buffer,D,m.byteLength-D),await this.bb(r,o,m,P,I,D),I+=P,D+=P,D===m.byteLength&&(D=0);while(P>0)}catch(m){throw(0,d.$ek)(m)}finally{await C.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async gb(t,l,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.hb(t,l,r,i))}async hb(t,l,r,i){return r.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,l,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.jb(t,l,r,i))}async jb(t,l,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(l);await this.bb(r,n,s.$Hc.wrap(o),o.byteLength,0,0)}catch(o){throw(0,d.$ek)(o)}finally{await r.close(n)}}async kb(t,l,r,i){const n=await(0,s.$Tc)(this.C(t,l,M.CancellationToken.None));await this.cb(r,i,void 0,n)}lb(t,l){if(t.capabilities&2048)throw new d.$lk((0,b.localize)(24,null,this.nb(l)),6);return t}mb(t,l){if((l.permissions??0)&d.FilePermission.Readonly)throw new d.$lk((0,b.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===$.Schemas.file?t.fsPath:t.toString(!0)}};e.$Ap=k,e.$Ap=k=ke([_(0,a.$3i)],k)}),define(te[93],ie([0,1,45,308,8,34,17,3,32,2,9,4,19,56,21,177,16,118,218,50,214,213]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0,(()=>{try{(0,C.gracefulify)(E)}catch(l){console.error(`Error enabling graceful-fs: ${(0,w.$ki)(l)}`)}})();class t extends a.$Jp{static{this.D=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.I=new M.$xi(n=>v.$0f.getComparisonKey(n)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,$.$k&&(this.F|=1024)),this.F}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.C(r));return{type:this.H(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.ab(i)}}async G(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.C(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let m;o.isSymbolicLink()?m=(await this.stat((0,v.$gg)(r,o.name))).type:m=this.H(o),n.push([o.name,m])}catch(m){this.a.trace(m)}})),n}catch(i){throw this.ab(i)}}H(r,i){let n;return i?.dangling?n=d.FileType.Unknown:r.isFile()?n=d.FileType.File:r.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,i&&(n|=d.FileType.SymbolicLink),n}async J(r){const i=this.C(r);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.I.get(r);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new s.$Dg;return this.I.set(r,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,u.$kb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(r)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(r)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),n=await this.J(r));const o=this.C(r);return await y.Promises.readFile(o)}catch(o){throw this.ab(o)}finally{n?.dispose()}}L(r){t.D&&this.a.trace(r)}readFileStream(r,i,n){const o=(0,h.$vc)(m=>A.$Hc.concat(m.map(I=>A.$Hc.wrap(I))).buffer);return(0,c.$zp)(this,r,o,m=>m.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.M(r,(0,v.$gg)((0,v.$fg)(r),`${(0,v.$dg)(r)}${n.atomic.postfix}`),i,n):this.N(r,i,n)}async M(r,i,n,o){await this.N(i,n,o);try{await this.rename(i,r,{overwrite:!0})}catch(m){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw m}}async N(r,i,n){let o;try{const m=this.C(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(m)){if(!n.overwrite)throw(0,d.$dk)((0,b.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$dk)((0,b.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(m){throw await this.bb(r,m)}finally{typeof o=="number"&&await this.close(o)}}static{this.R=!0}static configureFlushOnWrite(r){t.R=r}async open(r,i){const n=this.C(r);let o;(0,d.$5j)(i)&&(o=await this.J(r));let m;try{if((0,d.$5j)(i)&&i.unlock)try{const{stat:D}=await y.SymlinkSupport.stat(n);D.mode&128||await y.Promises.chmod(n,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let I;if((0,d.$5j)(i)){if($.$i)try{await y.Promises.truncate(n,0),I="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}I||(I="w")}else I="r";m=await y.Promises.open(n,I)}catch(I){throw o?.dispose(),(0,d.$5j)(i)?await this.bb(r,I):this.ab(I)}if(this.O.set(m,0),(0,d.$5j)(i)&&this.Q.set(m,r),o){const I=this.P.get(m);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${m} (${n})`),this.P.set(m,o),I&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${m} (${n})`),I.dispose())}return m}async close(r){const i=this.P.get(r);try{if(this.O.delete(r),this.Q.delete(r)&&t.R)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.ab(n)}finally{i&&(this.P.get(r)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.P.delete(r)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,o,m){const I=this.S(r,i);let D=null;try{D=(await y.Promises.read(r,n,o,m,I)).bytesRead}catch(P){throw this.ab(P)}finally{this.U(r,I,D)}return D}S(r,i){return i===this.O.get(r)?null:i}U(r,i,n){const o=this.O.get(r);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.O.set(r,o+n):this.O.delete(r)))}async write(r,i,n,o,m){return(0,s.$Wg)(()=>this.W(r,i,n,o,m),100,3)}async W(r,i,n,o,m){const I=this.S(r,i);let D=null;try{D=(await y.Promises.write(r,n,o,m,I)).bytesWritten}catch(P){throw await this.bb(this.Q.get(r),P)}finally{this.U(r,I,D)}return D}async mkdir(r){try{await y.Promises.mkdir(this.C(r))}catch(i){throw this.ab(i)}}async delete(r,i){try{const n=this.C(r);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,p.$$c)((0,p.$bd)(n),`${(0,p.$cd)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let m=!1;try{const{stat:I,symbolicLink:D}=await y.SymlinkSupport.stat(n);m=I.isDirectory()&&!D}catch{}if(m)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.ab(n)}}async rename(r,i,n){const o=this.C(r),m=this.C(i);if(o!==m)try{await this.X(r,i,"move",n.overwrite),await y.Promises.rename(o,m)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(2,null,(0,p.$cd)(o),(0,p.$cd)((0,p.$bd)(m)),I.toString()))),this.ab(I)}}async copy(r,i,n){const o=this.C(r),m=this.C(i);if(o!==m)try{await this.X(r,i,"copy",n.overwrite),await y.Promises.copy(o,m,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(3,null,(0,p.$cd)(o),(0,p.$cd)((0,p.$bd)(m)),I.toString()))),this.ab(I)}}async X(r,i,n,o){const m=this.C(r),I=this.C(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,f.$Je)(m,I,!0)),D){if(n==="copy")throw(0,d.$dk)((0,b.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.G(r);if(!R)throw(0,d.$dk)((0,b.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const j=await this.G(i);if(j){if(!o)throw(0,d.$dk)((0,b.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);R.type&d.FileType.File&&j.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.Y(r,i,!1)}async Y(r,i,n){const o=this.C(r),m=this.C(i),I=!!(this.capabilities&1024);if((0,f.$Je)(o,m,!I))return;const D=new u.$lb;try{const[P,R]=await Promise.all([this.J(r),this.J(i)]);D.add(P),D.add(R),n&&await y.Promises.mkdir((0,p.$bd)(m),{recursive:!0}),await y.Promises.copyFile(o,m)}catch(P){if(P.code==="ENOENT"&&!n)return this.Y(r,i,!0);throw this.ab(P)}finally{D.dispose()}}p(r,i,n){return new k.$Qp(o=>r(o),o=>i(o),n)}y(r,i,n){return new g.$Yp(o=>r(o),o=>i(o),n)}ab(r){if(r instanceof d.$ck)return r;let i=r,n;switch(r.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$dk)(i,n)}async bb(r,i){let n=this.ab(i);if(r&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.C(r));o.mode&128||(n=(0,d.$dk)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$Zp=t}),define(te[220],ie([0,1,3,93,2,17,56,22]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;class f extends s.$mb{constructor($,v){super(),this.a=$,this.b=v,this.w=new Map,this.y=new Map}call($,v,h){const y=this.c($);switch(v){case"stat":return this.g(y,h[0]);case"readdir":return this.h(y,h[0]);case"open":return this.l(y,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(y,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(y,h[0],h[1],h[2]);case"rename":return this.t(y,h[0],h[1],h[2]);case"copy":return this.u(y,h[0],h[1],h[2]);case"cloneFile":return this.v(y,h[0],h[1]);case"mkdir":return this.r(y,h[0]);case"delete":return this.s(y,h[0],h[1]);case"watch":return this.C(y,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${v} not found`)}listen($,v,h){const y=this.c($);switch(v){case"fileChange":return this.z(y,h[0]);case"readFileStream":return this.j(y,h[0],h[1])}throw new Error(`Unknown event ${v}`)}g($,v){const h=this.f($,v,!0);return this.a.stat(h)}h($,v){const h=this.f($,v);return this.a.readdir(h)}async i($,v,h){const y=this.f($,v,!0),b=await this.a.readFile(y,h);return M.$Hc.wrap(b)}j($,v,h){const y=this.f($,v,!0),b=new S.$rc,d=new E.$hc({onDidRemoveLastListener:()=>{b.cancel()}}),c=this.a.readFileStream(y,h,b.token);return(0,A.$zc)(c,{onData:a=>d.fire(M.$Hc.wrap(a)),onError:a=>d.fire(a),onEnd:()=>{d.fire("end"),d.dispose(),b.dispose()}}),d.event}k($,v,h,y){const b=this.f($,v);return this.a.writeFile(b,h.buffer,y)}l($,v,h){const y=this.f($,v,!0);return this.a.open(y,h)}m($){return this.a.close($)}async n($,v,h){const y=M.$Hc.alloc(h),b=0,d=await this.a.read($,v,y.buffer,b,h);return[y,d]}p($,v,h,y,b){return this.a.write($,v,h.buffer,y,b)}r($,v){const h=this.f($,v);return this.a.mkdir(h)}s($,v,h){const y=this.f($,v);return this.a.delete(y,h)}t($,v,h,y){const b=this.f($,v),d=this.f($,h);return this.a.rename(b,d,y)}u($,v,h,y){const b=this.f($,v),d=this.f($,h);return this.a.copy(b,d,y)}v($,v,h){const y=this.f($,v),b=this.f($,h);return this.a.cloneFile(y,b)}z($,v){const h=new E.$hc({onWillAddFirstListener:()=>{this.w.set(v,this.F($,h))},onDidRemoveLastListener:()=>{(0,s.$hb)(this.w.get(v)),this.w.delete(v)}});return h.event}async C($,v,h,y,b){const d=this.w.get(v);if(d){const c=this.f($,y),a=d.watch(h,c,b);this.y.set(v+h,a)}}async D($,v){const h=$+v,y=this.y.get(h);y&&((0,s.$hb)(y),this.y.delete(h))}dispose(){super.dispose();for(const[,$]of this.y)$.dispose();this.y.clear();for(const[,$]of this.w)$.dispose();this.w.clear()}}e.$vr=f;class u extends s.$mb{constructor($,v,h,y){super(),this.c=$,this.f=h,this.g=y,this.a=new Map,this.b=this.B(new C.$Zp(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(v)}h($){const v=this.B(new E.$hc);this.B(v.event(h=>{$.fire(h.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(h=>v.fire(h))),this.B(this.b.onDidWatchError(h=>$.fire(h)))}i($){}j($){}watch($,v,h){const y=this.j(this.g);return Array.isArray(y)&&(h.excludes=[...h.excludes,...y]),this.a.set($,this.b.watch(v,h)),(0,s.$kb)(()=>{(0,s.$hb)(this.a.get($)),this.a.delete($)})}dispose(){for(const[,$]of this.a)$.dispose();this.a.clear(),super.dispose()}}e.$wr=u}),define(te[221],ie([0,1,15,176,4,7,16,9,220,154]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s5b=void 0;class p extends f.$vr{constructor(h,y,b){super(h,y),this.G=b}c(h){return u.$Am}f(h,y){return M.URI.revive(y)}async s(h,y,b){if(!b.useTrash)return super.s(h,y,b);const d=this.f(h,y),c=(0,S.$9c)(d.fsPath);try{await E.shell.trashItem(c)}catch{throw(0,A.$dk)(s.$i?(0,C.localize)(0,null,(0,S.$cd)(c)):(0,C.localize)(1,null,(0,S.$cd)(c)),A.FileSystemProviderErrorCode.Unknown)}}F(h,y){return new $(h,y,this.b,this.G)}}e.$s5b=p;class $ extends f.$wr{watch(h,y,b){if(b.recursive)throw(0,A.$dk)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(h,y,b)}}}),define(te[222],ie([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t2b=void 0;class C extends E.$9i{constructor(M=E.$6i){super(),this.k=[],this.l=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(M){this.l=M;for(const{level:A,message:S}of this.k)(0,E.log)(M,A,S);this.k=[]}g(M,A){this.l?(0,E.log)(this.l,M,A):this.getLevel()<=M&&this.k.push({level:M,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.$t2b=C}),define(te[223],ie([0,1,7,3,5,2]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=void 0;class A extends s.$bj{constructor($,v,h,y,b){super(v,h,y),this.n=$,this.p=b,this.B(b.listen("onDidChangeLogLevel",$)(d=>{(0,s.$5i)(d)?super.setLogLevel(d):super.setLogLevel(E.URI.revive(d[0]),d[1])})),this.B(b.listen("onDidChangeVisibility",$)(([d,c])=>super.setVisibility(E.URI.revive(d),c))),this.B(b.listen("onDidChangeLoggers",$)(({added:d,removed:c})=>{for(const a of d)super.registerLogger({...a,resource:E.URI.revive(a.resource)});for(const a of c)super.deregisterLogger(a.resource)}))}createConsoleMainLogger(){return new s.$_i({log:($,v)=>{this.p.call("consoleLog",[$,v])}})}registerLogger($){super.registerLogger($),this.p.call("registerLogger",[$,this.n])}deregisterLogger($){super.deregisterLogger($),this.p.call("deregisterLogger",[$,this.n])}setLogLevel($,v){super.setLogLevel($,v),this.p.call("setLogLevel",[$,v])}setVisibility($,v){super.setVisibility($,v),this.p.call("setVisibility",[this.l($),v])}m($,v,h){return new S(this.p,$,v,h,this.n)}static setLogLevel($,v,h){return $.call("setLogLevel",[v,h])}}e.$Xq=A;class S extends s.$9i{constructor($,v,h,y,b){super(y?.logLevel==="always"),this.m=$,this.n=v,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[v,y,b]).then(()=>{this.r(this.l),this.k=!0})}g($,v){const h=[[$,v]];this.k?this.r(h):this.l.push(...h)}r($){this.m.call("log",[this.n,$])}}class f{constructor($,v){this.a=$,this.b=v}listen($,v){const h=this.b($);switch(v){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(b=>this.c(b,h)),removed:[...y.removed].map(b=>this.c(b,h))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,y=>[h.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$5i)(y)?y:[h.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${v}`)}async call($,v,h){const y=this.b($);switch(v){case"setLogLevel":return(0,s.$5i)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(E.URI.revive(y.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,y)))}throw new Error(`Call not found: ${v}`)}c($,v){return{...$,resource:v.transformOutgoingURI($.resource)}}}e.$Yq=f;class u extends M.$mb{constructor($,v){super(),v.call("setLogLevel",[$.getLogLevel()]),this.B($.onDidChangeLogLevel(h=>v.call("setLogLevel",[h]))),v.call("getRegisteredLoggers").then(h=>{for(const y of h)$.registerLogger({...y,resource:E.URI.revive(y.resource)})}),this.B(v.listen("onDidChangeVisibility")(([h,y])=>$.setVisibility(E.URI.revive(h),y))),this.B(v.listen("onDidChangeLoggers")(({added:h,removed:y})=>{for(const b of h)$.registerLogger({...b,resource:E.URI.revive(b.resource)});for(const b of y)$.deregisterLogger(b.resource)}))}}e.$Zq=u}),define(te[224],ie([0,1,2,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=void 0;class s extends E.$mb{constructor(A,S=[]){super(),this.a=new C.$aj([A,...S]),this.B(A.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...S){this.a.trace(A,...S)}debug(A,...S){this.a.debug(A,...S)}info(A,...S){this.a.info(A,...S)}warn(A,...S){this.a.warn(A,...S)}error(A,...S){this.a.error(A,...S)}flush(){this.a.flush()}}e.$dN=s}),define(te[225],ie([0,1,34,7,5]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=void 0;class M{constructor(S){this.b=S,this.a=new E.$xi}listen(S,f,u){switch(f){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(S,f,u){switch(f){case"createLogger":this.c(C.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(C.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,s.$5i)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(C.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:C.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(u[0]))}throw new Error(`Call not found: ${f}`)}c(S,f,u){this.a.set(S,this.b.createLogger(S,f,u))}d(S,f){let u=console.log;switch(S){case s.LogLevel.Error:u=console.error;break;case s.LogLevel.Warning:u=console.warn;break;case s.LogLevel.Info:u=console.info;break}u.call(console,...f)}e(S,f){const u=this.a.get(S);if(!u)throw new Error("Create the logger before logging");for(const[p,$]of f)(0,s.log)(u,p,$)}}e.$q6b=M}),define(te[226],ie([0,1,16,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=void 0;var s;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(s||(s={}));async function M(u,p,$,v,h){try{const y=await new Promise((d,c)=>{G(["@vscode/spdlog"],d,c)});y.setFlushOn(s.Trace);const b=await y.createAsyncRotatingLogger(u,p,$,v);return h?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(y){console.error(y)}return null}function A(u,p,$){switch(p){case C.LogLevel.Trace:u.trace($);break;case C.LogLevel.Debug:u.debug($);break;case C.LogLevel.Info:u.info($);break;case C.LogLevel.Warning:u.warn($);break;case C.LogLevel.Error:u.error($);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function S(u,p){switch(p){case C.LogLevel.Trace:u.setLevel(s.Trace);break;case C.LogLevel.Debug:u.setLevel(s.Debug);break;case C.LogLevel.Info:u.setLevel(s.Info);break;case C.LogLevel.Warning:u.setLevel(s.Warning);break;case C.LogLevel.Error:u.setLevel(s.Error);break;case C.LogLevel.Off:u.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class f extends C.$9i{constructor(p,$,v,h,y){super(),this.k=[],this.setLevel(y),this.l=this.n(p,$,v,h),this.B(this.onDidChangeLogLevel(b=>{this.m&&S(this.m,b)}))}async n(p,$,v,h){const y=v?6:1,b=30/y*E.$yk.MB,d=await M(p,$,b,y,h);if(d){this.m=d,S(this.m,this.getLevel());for(const{level:c,message:a}of this.k)A(this.m,c,a);this.k=[]}}g(p,$){this.m?A(this.m,p,$):this.getLevel()<=p&&this.k.push({level:p,message:$})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$5M=f}),define(te[227],ie([0,1,31,5,226]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=void 0;class M extends C.$bj{m(S,f,u){return new s.$5M((0,E.$6e)(),S.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,f)}}e.$6M=M}),define(te[66],ie([0,1,34,3,6,5,227]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R5b=e.$Q5b=void 0,e.$Q5b=(0,s.$Ah)(M.$4i);class S extends A.$6M{constructor(){super(...arguments),this.p=new E.$xi}createLogger(u,p,$){$!==void 0&&this.p.set(this.l(u),$);try{return super.createLogger(u,p)}catch(v){throw this.p.delete(this.l(u)),v}}registerLogger(u,p){p!==void 0&&this.p.set(u.resource,p),super.registerLogger(u)}deregisterLogger(u){this.p.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const p=[];for(const $ of super.getRegisteredLoggers())u===this.p.get($.resource)&&p.push($);return p}getOnDidChangeLogLevelEvent(u){return C.Event.filter(this.onDidChangeLogLevel,p=>(0,M.$5i)(p)||this.s(p[0],u))}getOnDidChangeVisibilityEvent(u){return C.Event.filter(this.onDidChangeVisibility,([p])=>this.s(p,u))}getOnDidChangeLoggersEvent(u){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(v=>this.s(v.resource,u)),removed:[...p.removed].filter(v=>this.s(v.resource,u))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(u){for(const[p,$]of this.p)$===u&&this.deregisterLogger(p)}s(u,p){const $=this.p.get(u);return $===void 0||$===p}dispose(){super.dispose(),this.p.clear()}}e.$R5b=S}),define(te[228],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K5b=e.$J5b=e.$I5b=e.$H5b=void 0;function E(A){return A.submenu!==void 0}e.$H5b=E;function C(A){return A.id==="vscode.menubar.separator"}e.$I5b=C;function s(A){return A.uri!==void 0}e.$J5b=s;function M(A){return!E(A)&&!C(A)&&!s(A)}e.$K5b=M}),define(te[39],ie([0,1,3,68,2,6]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=void 0,e.$8m=(0,M.$zh)("policy");class A extends s.$mb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$hc),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const p=Object.keys(this.f).length;return this.f={...u,...this.f},p!==Object.keys(this.f).length&&await this.i(u),C.Iterable.reduce(this.g.entries(),($,[v,h])=>({...$,[v]:h}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(u,[p,$])=>({...u,[p]:{definition:$,value:this.g.get(p)}}),{})}}e.$9m=A;class S{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$0m=S}),define(te[229],ie([0,1,8,3,68,12,16,5,39]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=void 0;function u($,v){const h=[];for(const y of new Set(s.Iterable.concat($.keys(),v.keys())))$.get(y)!==v.get(y)&&h.push(y);return h}let p=class extends f.$9m{constructor(v,h,y){super(),this.j=v,this.k=h,this.l=y,this.c=this.B(new E.$Cg(500));const b=C.Event.filter(h.onDidFilesChange,d=>d.affects(v));this.B(h.watch(v)),this.B(b(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const v=new Map;try{const h=await this.k.readFile(this.j),y=JSON.parse(h.value.toString());if(!(0,M.$ne)(y))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(y))this.f[b]&&v.set(b,y[b])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return v}async p(){const v=await this.n(),h=u(this.g,v);this.g=v,h.length>0&&this.h.fire(h)}};e.$I6b=p,e.$I6b=p=ke([_(1,A.$4j),_(2,S.$3i)],p)}),define(te[230],ie([0,1,3,2,39]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=e.$j6b=void 0;class M{constructor(f){this.b=f,this.a=new C.$lb}listen(f,u){switch(u){case"onDidChange":return E.Event.map(this.b.onDidChange,p=>p.reduce(($,v)=>({...$,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(f,u,p){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.$j6b=M;class A extends s.$9m{constructor(f,u){super(),this.a=u;for(const p in f){const{definition:$,value:v}=f[p];this.f[p]=$,v!==void 0&&this.g.set(p,v)}this.a.listen("onDidChange")(p=>{for(const $ in p){const v=p[$];v===null?this.g.delete($):this.g.set($,v)}this.h.fire(Object.keys(p))})}async i(f){const u=await this.a.call("updatePolicyDefinitions",f);for(const p in u)this.g.set(p,u[p])}}e.$k6b=A}),define(te[231],ie([0,1,39,8,309,2,5]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=void 0;let S=class extends E.$9m{constructor(u,p){super(),this.j=u,this.k=p,this.a=new C.$yg,this.b=this.B(new M.$nb)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((p,$)=>{try{this.b.value=(0,s.createWatcher)(this.k,u,v=>{this.m(v),p()})}catch(v){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),$(v)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const p in u){const $=u[p];$===void 0?this.g.delete(p):this.g.set(p,$)}this.h.fire(Object.keys(u))}};e.$H6b=S,e.$H6b=S=ke([_(0,A.$3i)],S)}),define(te[77],ie([0,1,4,35]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof E.$g.vscode<"u"&&typeof E.$g.vscode.context<"u"){const M=E.$g.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,C.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[23],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=void 0,e.$ij=(0,E.$zh)("productService"),e.$jj="vscode://schemas/vscode-product"}),define(te[232],ie([0,1,72,5,23]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l5b=void 0;let M=class{constructor(S,f){this.b=S,this.c=f,this.a=new Map}async isExtensionUrlTrusted(S,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const u=/^(.*)#([^#]+)$/.exec(f);if(!u)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,p,$]=u;let v=this.a.get(S);if(!v){if(v=this.b.trustedExtensionUrlPublicKeys[S],!v||v.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.a.set(S,[...v])}const h=Buffer.from(decodeURIComponent($),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const y=h.slice(0,6),b=h.readUIntBE(0,6),d=Date.now()-b;if(d<0||d>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const c=h.slice(6),a=E.createVerify("SHA256");a.write(y),a.write(Buffer.from(p)),a.end();for(let w=0;w<v.length;w++){let k=v[w];if(k!==null){if(typeof k=="string")try{k=E.createPublicKey({key:Buffer.from(k,"base64"),format:"der",type:"spki"}),v[w]=k}catch(g){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${w+1} for ${S}:`,g),v[w]=null;continue}if(a.verify(k,c))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};e.$l5b=M,e.$l5b=M=ke([_(0,s.$ij),_(1,C.$3i)],M)}),define(te[233],ie([0,1,8,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0;let s=class{constructor(A,S,f){this.a=A,this.b=S,this.c=f}async inspect(A){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.$Fg)(A);const f=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.$x5b=s,e.$x5b=s=ke([_(2,C.$3i)],s)}),define(te[78],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A5b=void 0,e.$A5b=(0,E.$zh)("protocolMainService")}),define(te[43],ie([0,1,135,12]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;class s{constructor(){this.a=new Map}add(A,S){E.ok(C.$le(A)),E.ok(C.$ne(S)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,S)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$6m=new s}),define(te[234],ie([0,1,3,43]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$7m={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new E.$hc,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,u){this.a[s(f)]=u,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;C.$6m.add(e.$7m.JSONContribution,A)}),define(te[59],ie([0,1,24,3,12,161,18,234,43]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ConfigurationScope=e.$$m=e.EditPresentationTypes=void 0;var u;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$$m={Configuration:"base.contributions.configuration"};var p;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.$_m={properties:{},patternProperties:{}},e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn="vscode://schemas/settings/resourceLanguage",e.$gn="vscode://schemas/settings/configurationDefaults";const $=f.$6m.as(S.$7m.JSONContribution);class v{constructor(){this.h=new Set,this.i=new C.$hc,this.onDidSchemaChange=this.i.event,this.j=new C.$hc,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},$.registerSchema(e.$fn,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),$.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),$.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),$.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(l.add(o),e.$in.test(o)){const m=this.a.get(o),I=m?.valuesSources??new Map;if(n)for(const j of Object.keys(i[o]))I.set(j,n);const D={...m?.value||{},...i[o]};this.a.set(o,{source:n,value:D,valuesSources:I});const P=(0,A.$di)(o),R={type:"object",default:D,description:M.localize(1,null,P),$ref:e.$fn,defaultDefaultValue:D,source:s.$le(n)?void 0:n,defaultValueSource:n};r.push(...b(o)),this.d[o]=R,this.b.properties[o]=R}else{this.a.set(o,{value:i[o],source:n});const m=this.d[o];m&&(this.w(o,m),this.r(o,m))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),m=s.$le(i)?i:i?.id,I=s.$le(o?.source)?o?.source:o?.source?.id;if(m===I)if(l.add(n),this.a.delete(n),e.$in.test(n))delete this.d[n],delete this.b.properties[n];else{const D=this.d[n];D&&(this.w(n,D),this.r(n,D))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(i=>{this.p(i,l,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,l){const r=i=>{if(i.properties)for(const n in i.properties){l.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,l=!0,r,i,n=3,o){n=s.$ue(t.scope)?n:t.scope;const m=t.properties;if(m)for(const D in m){const P=m[D];if(l&&w(D,P)){delete m[D];continue}if(P.source=r,P.defaultDefaultValue=m[D].default,this.w(D,P),e.$in.test(D)?P.scope=void 0:(P.scope=s.$ue(P.scope)?n:P.scope,P.restricted=s.$ue(P.restricted)?!!i?.includes(D):P.restricted),m[D].hasOwnProperty("included")&&!m[D].included){this.f[D]=m[D],delete m[D];continue}else this.d[D]=m[D],m[D].policy?.name&&this.e.set(m[D].policy.name,D);!m[D].deprecationMessage&&m[D].markdownDeprecationMessage&&(m[D].deprecationMessage=m[D].markdownDeprecationMessage),o.add(D)}const I=t.allOf;if(I)for(const D of I)this.p(D,l,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$_m.properties[t]=l,l.scope){case 1:e.$an.properties[t]=l;break;case 2:e.$bn.properties[t]=l;break;case 6:e.$cn.properties[t]=l;break;case 3:e.$dn.properties[t]=l;break;case 4:e.$en.properties[t]=l;break;case 5:e.$en.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$_m.properties[t],l.scope){case 1:delete e.$an.properties[t];break;case 2:delete e.$bn.properties[t];break;case 6:delete e.$cn.properties[t];break;case 3:delete e.$dn.properties[t];break;case 4:case 5:delete e.$en.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$fn};this.w(l,r),e.$_m.properties[l]=r,e.$an.properties[l]=r,e.$bn.properties[l]=r,e.$cn.properties[l]=r,e.$dn.properties[l]=r,e.$en.properties[l]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$fn};e.$_m.patternProperties[e.$hn]=t,e.$an.patternProperties[e.$hn]=t,e.$bn.patternProperties[e.$hn]=t,e.$cn.patternProperties[e.$hn]=t,e.$dn.patternProperties[e.$hn]=t,e.$en.patternProperties[e.$hn]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$se(i)&&(i=l.defaultDefaultValue,n=void 0),s.$se(i)&&(i=c(l.type)),l.default=i,l.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",y=new RegExp(h,"g");e.$hn=`^(${h})+$`,e.$in=new RegExp(e.$hn);function b(g){const t=[];if(e.$in.test(g)){let l=y.exec(g);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=y.exec(g)}}return(0,E.$Ff)(t)}e.$jn=b;function d(g){return g.reduce((t,l)=>`${t}[${l}]`,"")}e.$kn=d;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ln=c;const a=new v;f.$6m.add(e.$$m.Configuration,a);function w(g,t){return g.trim()?e.$in.test(g)?M.localize(7,null,g):a.getConfigurationProperties()[g]!==void 0?M.localize(8,null,g):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,g,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$mn=w;function k(){const g=[],t=a.getConfigurationProperties();for(const l of Object.keys(t))g.push([l,t[l].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$nn=k}),define(te[119],ie([0,1,24,3,44,2,34,37,12,7,18,59,43]),function(G,e,E,C,s,M,A,S,f,u,p,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=void 0;function h(l){return Object.isFrozen(l)?l:S.$Um(l)}class y{constructor(r={},i=[],n=[],o){this.b=r,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new b("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,p.$bi)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),o=i?this.rawConfiguration.getOverrideValue(r,i):void 0,m=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:o,merged:m}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,p.$bi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return E.$Ff(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return E.$Ff(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$Tm(this.contents),n=S.$Tm(this.overrides),o=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const I of r)if(m.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const D of I.overrides){const[P]=n.filter(R=>E.$of(R.identifiers,D.identifiers));P?(this.h(P.contents,D.contents),P.keys.push(...D.keys),P.keys=E.$Ff(P.keys)):n.push(S.$Tm(D))}for(const D of I.keys)o.indexOf(D)===-1&&o.push(D)}return new y(i,o,n,m.every(I=>I instanceof y)?void 0:m)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of E.$Ff([...Object.keys(this.contents),...Object.keys(i)])){let m=this.contents[o];const I=i[o];I&&(typeof m=="object"&&typeof I=="object"?(m=S.$Tm(m),this.h(m,I)):m=I),n[o]=m}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$ne(r[n])&&f.$ne(i[n])){this.h(r[n],i[n]);continue}r[n]=S.$Tm(i[n])}}i(r){let i=null,n=null;const o=m=>{m&&(n?this.h(n,m):n=S.$Tm(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===r?i=m.contents:m.identifiers.includes(r)&&o(m.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,p.$ai)(this.contents,r),$.$in.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>E.$of(n.identifiers,(0,$.$jn)(r))),1))}j(r,i,n){(0,p.$_h)(this.contents,r,i,o=>console.error(o)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),$.$in.test(r)&&this.overrides.push({identifiers:(0,$.$jn)(r),keys:Object.keys(this.contents[r]),contents:(0,p.$$h)(this.contents[r],o=>console.error(o))})}}e.$on=y;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$ue(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:o,overrides:m,restricted:I,hasExcludedProperties:D}=this.h(r,i);this.b=new y(n,o,m,D?[r]:void 0),this.c=I||[]}g(r){let i={},n=null,o=[];const m=[],I=[];function D(R){Array.isArray(o)?o.push(R):n!==null&&(o[n]=R)}const P={onObjectBegin:()=>{const R={};D(R),m.push(o),o=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const R=[];D(R),m.push(o),o=R,n=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:D,onError:(R,j,T)=>{I.push({error:R,offset:j,length:T})}};if(r)try{s.$Qm(r,P),i=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return i}h(r,i){const n=v.$6m.as($.$$m.Configuration).getConfigurationProperties(),o=this.i(r,n,!0,i);r=o.raw;const m=(0,p.$$h)(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`)),I=Object.keys(r),D=this.j(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:m,keys:I,overrides:D,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(r,i,n,o){let m=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:m};const I={},D=[];for(const P in r)if($.$in.test(P)&&n){const R=this.i(r[P],i,!1,o);I[P]=R.raw,m=m||R.hasExcludedProperties,D.push(...R.restricted)}else{const R=i[P],j=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&D.push(P),!o.exclude?.includes(P)&&(o.include?.includes(P)||(j===void 0||o.scopes===void 0||o.scopes.includes(j))&&!(o.skipRestricted&&R?.restricted))?I[P]=r[P]:m=!0}return{raw:I,restricted:D,hasExcludedProperties:m}}j(r,i){const n=[];for(const o of Object.keys(r))if($.$in.test(o)){const m={};for(const I in r[o])m[I]=r[o][I];n.push({identifiers:(0,$.$jn)(o),keys:Object.keys(m),contents:(0,p.$$h)(m,i)})}return n}}e.$pn=b;class d extends M.$mb{constructor(r,i,n,o){super(),this.c=r,this.f=i,this.g=o,this.b=this.B(new C.$hc),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&n.isEqual(m.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qn=d;class c{constructor(r,i,n,o,m,I,D,P,R,j,T,z,ne){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=m,this.f=I,this.g=D,this.h=P,this.i=R,this.j=j,this.k=T,this.l=z,this.m=ne}get value(){return h(this.c)}n(r,i,n){const o=r.inspect(i,n);return{get value(){return h(o.value)},get override(){return h(o.override)},get merged(){return h(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(r,i,n,o,m=new y,I=new y,D=new A.$xi,P=new y,R=new A.$xi){this.c=r,this.d=i,this.f=n,this.g=o,this.h=m,this.i=I,this.j=D,this.l=P,this.m=R,this.a=null,this.b=new A.$xi,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new y,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const o=this.q(r,i,n),m=this.u(i.resource,n),I=i.resource?this.m.get(i.resource)||this.l:this.l,D=new Set;for(const P of o.overrides)for(const R of P.identifiers)o.getOverrideValue(r,R)!==void 0&&D.add(R);return new c(r,i,o.getValue(r),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,m||void 0,I)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:m,removed:I}=g(this.c,r);i=[...o,...m,...I]}for(const o of i)for(const m of(0,$.$jn)(o)){const I=this.c.getKeysForOverrideIdentifier(m),D=r.getKeysForOverrideIdentifier(m),P=[...D.filter(R=>I.indexOf(R)===-1),...I.filter(R=>D.indexOf(R)===-1),...I.filter(R=>!S.$Xm(this.c.override(m).getValue(R),r.override(m).getValue(R)))];n.push([m,P])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=g(this.d,r),m=[...i,...n,...o];return m.length&&this.updatePolicyConfiguration(r),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:m}=g(this.applicationConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:m}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:m}=g(this.localUserConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:m}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:m}=g(this.remoteUserConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:m}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:m}=g(this.workspaceConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:m}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:o,updated:m,removed:I,overrides:D}=g(n,i),P=[...o,...m,...I];return(P.length||!n)&&this.updateFolderConfiguration(r,i),{keys:P,overrides:D}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:m,overrides:I}=g(i,void 0);return{keys:[...n,...o,...m],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}r({resource:r},i){let n=this.s();if(i&&r){const o=i.getFolder(r);o&&(n=this.t(o.uri)||n);const m=this.m.get(r);m&&(n=n.merge(m))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),o=this.j.get(r);o?(i=n.merge(o),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:m}=this.j.get(i);return r.push([i,{contents:n,overrides:o,keys:m}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),o=this.x(r.application),m=this.x(r.user),I=this.x(r.workspace),D=r.folders.reduce((P,R)=>(P.set(u.URI.revive(R[0]),this.x(R[1])),P),new A.$xi);return new a(i,n,o,m,new y,I,D,new y,new A.$xi)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$rn=a;function w(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,i=new Map;for(const o of l)o.keys.forEach(m=>r.add(m)),o.overrides.forEach(([m,I])=>{const D=(0,A.$ui)(i,m,new Set);I.forEach(P=>D.add(P))});const n=[];return i.forEach((o,m)=>n.push([m,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.$sn=w;class k{constructor(r,i,n,o){this.change=r,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const m of r.keys)this.affectedKeys.add(m);for(const[,m]of r.overrides)for(const I of m)this.affectedKeys.add(I);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,o=this.d.indexOf(n);if(o<0)return!1;const m=o+n.length;if(m>=this.d.length)return!1;const I=this.d.charCodeAt(m);if(I!==this.b&&I!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,P=this.g.getValue(r,i,this.h);return!S.$Xm(D,P)}return!0}}e.$tn=k;function g(l,r){const{added:i,removed:n,updated:o}=t(r?.rawConfiguration,l?.rawConfiguration),m=[],I=l?.getAllOverrideIdentifiers()||[],D=r?.getAllOverrideIdentifiers()||[];if(r){const P=D.filter(R=>!I.includes(R));for(const R of P)m.push([R,r.getKeysForOverrideIdentifier(R)])}if(l){const P=I.filter(R=>!D.includes(R));for(const R of P)m.push([R,l.getKeysForOverrideIdentifier(R)])}if(r&&l){for(const P of I)if(D.includes(P)){const R=t({contents:l.getOverrideValue(void 0,P)||{},keys:l.getKeysForOverrideIdentifier(P)},{contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)});m.push([P,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:n,updated:o,overrides:m}}function t(l,r){const i=l?r?l.keys.filter(m=>r.keys.indexOf(m)===-1):[...l.keys]:[],n=r?l?r.keys.filter(m=>l.keys.indexOf(m)===-1):[...r.keys]:[],o=[];if(l&&r){for(const m of r.keys)if(l.keys.indexOf(m)!==-1){const I=(0,p.$bi)(r.contents,m),D=(0,p.$bi)(l.contents,m);S.$Xm(I,D)||o.push(m)}}return{added:i,removed:n,updated:o}}}),define(te[235],ie([0,1,24,3,2,37,12,119,59,5,39,43]),function(G,e,E,C,s,M,A,S,f,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=void 0;class v extends s.$mb{constructor(){super(...arguments),this.a=this.B(new C.$hc),this.onDidChangeConfiguration=this.a.event,this.b=new S.$on}get configurationModel(){return this.b}async initialize(){return this.g(),this.B($.$6m.as(f.$$m.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:c})=>this.c(Array.from(d),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,c){this.h(d,$.$6m.as(f.$$m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new S.$on;const d=$.$6m.as(f.$$m.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,c){const a=this.f();for(const w of d){const k=a[w],g=c[w];k!==void 0?this.b.addValue(w,k):g?this.b.addValue(w,g.default):this.b.removeValue(w)}}}e.$un=v;class h{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new S.$on}async initialize(){return this.configurationModel}}e.$vn=h;let y=class extends s.$mb{get configurationModel(){return this.b}constructor(d,c,a){super(),this.c=d,this.f=c,this.g=a,this.a=this.B(new C.$hc),this.onDidChangeConfiguration=this.a.event,this.b=new S.$on}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const c={},a=[],w=$.$6m.as(f.$$m.Configuration).getConfigurationProperties();for(const k of d){const g=w[k];if(!g){a.push(k);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}a.push(k),c[g.policy.name]={type:g.type}}}return(0,A.$ye)(c)||await this.f.updatePolicyDefinitions(c),a}i(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const c=$.$6m.as(f.$$m.Configuration).getPolicyConfigurations(),a=(0,E.$Af)(d.map(w=>c.get(w)));this.j(a,!0)}j(d,c){this.g.trace("PolicyConfiguration#update",d);const a=$.$6m.as(f.$$m.Configuration).getConfigurationProperties(),w=[],k=this.b.isEmpty();for(const g of d){const t=a[g]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(k?l!==void 0:!(0,M.$Xm)(this.b.getValue(g),l))&&w.push([g,l])}else this.b.getValue(g)!==void 0&&w.push([g,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const g=this.b;this.b=new S.$on;for(const t of g.keys)this.b.setValue(t,g.getValue(t));for(const[t,l]of w)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);c&&this.a.fire(this.b)}}};e.$wn=y,e.$wn=y=ke([_(1,p.$8m),_(2,u.$3i)],y)}),define(te[236],ie([0,1,8,3,2,19,18,119,235,39]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=void 0;class p extends s.$mb{constructor(v,h,y,b){super(),this.i=v,this.h=this.B(new C.$hc),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$un),this.c=y instanceof u.$0m?new f.$vn:this.B(new f.$wn(this.b,y,b)),this.f=this.B(new S.$qn(this.i,{},M.$0f,h)),this.a=new S.$rn(this.b.configurationModel,this.c.configurationModel,new S.$on,new S.$on),this.g=this.B(new E.$Qg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:c})=>this.k(d,c))),this.B(this.c.onDidChangeConfiguration(d=>this.l(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,h,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$rn(v,h,new S.$on,y)}getConfigurationData(){return this.a.toData()}getValue(v,h){const y=typeof v=="string"?v:void 0,b=(0,A.$7h)(v)?v:(0,A.$7h)(h)?h:{};return this.a.getValue(y,b,void 0)}updateValue(v,h,y,b){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const h=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(y,h,2)}k(v,h){const y=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(v,h);this.m(b,y,7)}l(v){const h=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(v);this.m(y,h,7)}m(v,h,y){const b=new S.$tn(v,{data:h},this.a);b.source=y,b.sourceConfig=this.n(y),this.h.fire(b)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$xn=p}),define(te[237],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=e.$w6b=e.$v6b=void 0,e.$v6b="request",e.$w6b="remoteResourceHandler";class E{async routeCall(s,M,A){if(M!==e.$v6b)throw new Error(`Call not found: ${M}`);const S=A[0];if(S?.authority){const f=s.connections.find(u=>u.ctx===S.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$x6b=E}),define(te[238],ie([0,1,14,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.RemoteAuthorityResolverErrorCode=e.$Jk=e.$Ik=e.RemoteConnectionType=e.$Hk=void 0,e.$Hk=(0,C.$zh)("remoteAuthorityResolverService");var s;(function(p){p[p.WebSocket=0]="WebSocket",p[p.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor($){this.id=$,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ik=M;class A{constructor($,v){this.host=$,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jk=A;var S;(function(p){p.Unknown="Unknown",p.NotAvailable="NotAvailable",p.TemporarilyNotAvailable="TemporarilyNotAvailable",p.NoResolverFound="NoResolverFound",p.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class f extends E.$_{static isNotAvailable($){return $ instanceof f&&$._code===S.NotAvailable}static isTemporarilyNotAvailable($){return $ instanceof f&&$._code===S.TemporarilyNotAvailable}static isNoResolverFound($){return $ instanceof f&&$._code===S.NoResolverFound}static isInvalidAuthority($){return $ instanceof f&&$._code===S.InvalidAuthority}static isHandled($){return $ instanceof f&&$.isHandled}constructor($,v=S.Unknown,h){super($),this._message=$,this._code=v,this._detail=h,this.isHandled=v===S.NotAvailable&&h===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Kk=f;function u(p){const $=p.indexOf("+");return $===-1?p:p.substring(0,$)}e.$Lk=u}),define(te[60],ie([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=void 0;function C(u){return u.scheme===E.Schemas.vscodeRemote?u.authority:void 0}e.$Mk=C;function s(u){if(!u)return;const p=u.indexOf("+");return p<0?u:u.substr(0,p)}e.$Nk=s;function M(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.$Ok=M;function A(u){const{host:p,port:$}=f(u);if(typeof $>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:$}}e.$Pk=A;function S(u,p){let{host:$,port:v}=f(u);return typeof v>"u"&&(v=p),{host:$,port:v}}e.$Qk=S;function f(u){const p=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const $=u.match(/^(\[[0-9a-z:]+\])$/);if($)return{host:$[1],port:void 0};const v=u.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:u,port:void 0}}}),define(te[120],ie([0,1,26,6,60]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.TargetPlatform=e.ExtensionType=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl="extensions.user.cache",e.$Ol="extensions.builtin.cache",e.$Pl="undefined_publisher",e.$Ql=["ui","workspace","web"];function M(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Rl=M,e.$Sl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(A||(e.ExtensionType=A={}));var S;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class f{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,c){if(typeof d>"u"||d===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof d=="string"||typeof c=="string"){const a=typeof d=="string"?d:d.value,w=typeof c=="string"?c:c.value;return E.$Od(a,w)}return d._lower===c._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Tl=f;class u{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const c of d)this.add(c)}add(d){this.c.add(f.toKey(d))}delete(d){return this.c.delete(f.toKey(d))}has(d){return this.c.has(f.toKey(d))}}e.$Ul=u;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(f.toKey(d))}get(d){return this.c.get(f.toKey(d))}has(d){return this.c.has(f.toKey(d))}set(d,c){this.c.set(f.toKey(d),c)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vl=p;function $(b){return v(b)}e.$Wl=$;function v(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$Xl=v;function h(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$Yl=h;function y(b,d){if(d){const c=`onResolveRemoteAuthority:${(0,s.$Nk)(d)}`;return!!b.activationEvents?.includes(c)}return!1}e.$Zl=y,e.$1l=(0,C.$zh)("IBuiltinExtensionsScannerService")}),define(te[239],ie([0,1,8,17,22,14,3,2,65,69,31,109,238,60]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.PersistentConnectionEventType=e.$Xk=e.$Wk=e.$Vk=e.ConnectionType=void 0;const y=30*1e3;var b;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function d(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(K){const O=new s.$rc;return setTimeout(()=>O.cancel(),K),O.token}function a(K,O){if(K.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const L=new s.$rc;return K.onCancellationRequested(()=>L.cancel()),O.onCancellationRequested(()=>L.cancel()),L.token}class w{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new S.$lb,this.promise=new Promise((L,N)=>{this.f=L,this.g=N}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function k(K,O){const L=new w(O);return L.registerDisposable(K.onControlMessage(N=>{const W=JSON.parse(N.toString()),q=F(W);q?L.reject(q):L.resolve(W)})),L.promise}function g(K,O,L,N,W,q,V,re){const $e=new w(re),de=u.$dc.create(!1);return K.info(`Creating a socket (${V})...`),f.mark(`code/willCreateSocket/${q}`),O.connect(L,N,W,V).then(ue=>{$e.didTimeout?(f.mark(`code/didCreateSocketError/${q}`),K.info(`Creating a socket (${V}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(f.mark(`code/didCreateSocketOK/${q}`),K.info(`Creating a socket (${V}) was successful after ${de.elapsed()} ms.`),$e.resolve(ue))},ue=>{f.mark(`code/didCreateSocketError/${q}`),K.info(`Creating a socket (${V}) returned an error after ${de.elapsed()} ms.`),K.error(ue),$e.reject(ue)}),$e.promise}function t(K,O){const L=new w(O);return K.then(N=>{L.didTimeout||L.resolve(N)},N=>{L.didTimeout||L.reject(N)}),L.promise}async function l(K,O,L,N){const W=x(K,O);K.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let q;try{q=await g(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,h.$Ok)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,d(O),`renderer-${d(O)}-${K.reconnectionToken}`,N)}catch(ue){throw K.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ue),ue}K.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let V,re;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(q,null),V=K.reconnectionProtocol,re=!1):(V=new $.$nh({socket:q}),re=!0),K.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const $e=await t(K.signService.createNewMessage((0,p.$6e)()),N),de={type:"auth",auth:K.connectionToken||"00000000000000000000",data:$e.data};V.sendControl(C.$Hc.fromString(JSON.stringify(de)));try{const ue=await k(V,a(N,c(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(K.logService.trace(`${W} 4/6. received SignRequest control message.`),!await t(K.signService.validate($e,ue.signedData),N)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const we=await t(K.signService.sign(ue.data),N),Se={type:"connectionType",commit:K.commit,signedData:we,desiredConnectionType:O};return L&&(Se.args=L),K.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(C.$Hc.fromString(JSON.stringify(Se))),{protocol:V,ownsProtocol:re}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(K.logService.error(`${W} the handshake timed out. Error:`),K.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${W} received error control message when negotiating connection. Error:`),K.logService.error(ue)),re&&B(V),ue}}async function r(K,O,L,N){const W=Date.now(),q=x(K,O),{protocol:V,ownsProtocol:re}=await l(K,O,L,N),$e=new w(N);return $e.registerDisposable(V.onControlMessage(de=>{const ue=JSON.parse(de.toString()),me=F(ue);me?(K.logService.error(`${q} received error control message when negotiating connection. Error:`),K.logService.error(me),re&&B(V),$e.reject(me)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${oe(W)}!`),$e.resolve({protocol:V,firstMessage:ue}))})),$e.promise}async function i(K,O){const{protocol:L}=await r(K,1,void 0,O);return{protocol:L}}async function n(K,O,L){const{protocol:N,firstMessage:W}=await r(K,2,O,L),q=W&&W.debugPort;return{protocol:N,debugPort:q}}async function o(K,O,L){const N=Date.now(),W=x(K,3),{protocol:q}=await l(K,3,O,L);return K.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${oe(N)}!`),q}async function m(K,O,L){const{connectTo:N,connectionToken:W}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:N,connectionToken:W,reconnectionToken:O,reconnectionProtocol:L,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function I(K,O,L){return P(K,async N=>{const{protocol:W}=await i(N,s.CancellationToken.None);return new J(K,O,L,N.reconnectionToken,W)})}e.$Vk=I;async function D(K,O){return P(K,async L=>{const{protocol:N,debugPort:W}=await n(L,O,s.CancellationToken.None);return new Y(K,O,L.reconnectionToken,N,W)})}e.$Wk=D;async function P(K,O){for(let N=1;;N++)try{const W=(0,p.$6e)(),q=await m(K,W,null);return await O(q)}catch(W){if(N<5)K.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(W);else throw K.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(W),ae.triggerPermanentFailure(0,0,v.$Kk.isHandled(W)),W}}async function R(K,O,L){const N=await m(K,(0,p.$6e)(),null);return await o(N,{host:O,port:L},s.CancellationToken.None)}e.$Xk=R;function j(K){return(0,E.$sg)(O=>new Promise((L,N)=>{const W=setTimeout(L,K*1e3);O.onCancellationRequested(()=>{clearTimeout(W),L()})}))}var T;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class z{constructor(O,L){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.type=0}}e.$Yk=z;class ne{constructor(O,L,N,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.durationSeconds=N,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.$Zk=ne;class ee{constructor(O,L,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.attempt=N,this.type=2}}e.$1k=ee;class ce{constructor(O,L,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.attempt=N,this.type=4}}e.$2k=ce;class se{constructor(O,L,N,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.attempt=N,this.handled=W,this.type=3}}e.$3k=se;class ae extends S.$mb{static triggerPermanentFailure(O,L,N){this._permanentFailure=!0,this.f=O,this.g=L,this.h=N,this.i.forEach(W=>W.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(O=>O.s())}static debugPauseSocketWriting(){this.i.forEach(O=>O.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||ae._permanentFailure}constructor(O,L,N,W,q){super(),this.n=O,this.p=L,this.reconnectionToken=N,this.protocol=W,this.r=q,this.j=this.B(new A.$hc),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new ce(this.reconnectionToken,0,0)),this.B(W.onSocketClose(V=>{const re=Q(this.n,this.reconnectionToken,!0);V?V.type===0?(this.p.logService.info(`${re} received socket close event (hadError: ${V.hadError}).`),V.error&&this.p.logService.error(V.error)):(this.p.logService.info(`${re} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.p.logService.error(V.event)):this.p.logService.info(`${re} received socket close event.`),this.s()})),this.B(W.onSocketTimeout(V=>{const re=Q(this.n,this.reconnectionToken,!0);this.p.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.s()})),ae.i.push(this),this.B((0,S.$kb)(()=>{const V=ae.i.indexOf(this);V>=0&&ae.i.splice(V,1)})),this.k&&this.v(ae.f,ae.g,ae.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const O=Q(this.n,this.reconnectionToken,!0);this.p.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const W=N<L.length?L[N]:L[L.length-1];try{if(W>0){const V=j(W);this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,V)),this.p.logService.info(`${O} waiting for ${W} seconds before reconnecting...`);try{await V}catch{}}if(this.k){this.p.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.p.logService.info(`${O} resolving connection...`);const q=await m(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${O} connecting to ${q.connectTo}...`),await this.y(q,c(y)),this.p.logService.info(`${O} reconnected!`),this.j.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(q),this.u(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.p.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(q),this.u(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(v.$Kk.isTemporarilyNotAvailable(q)){this.p.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.p.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(q);continue}if((0,M.$2)(q)){this.p.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(q);continue}if(q instanceof v.$Kk){this.p.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(q),this.u(this.protocol.getMillisSinceLastIncomingData(),N+1,v.$Kk.isHandled(q));break}this.p.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(q),this.u(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.k&&!this.m)}u(O,L,N){this.r?ae.triggerPermanentFailure(O,L,N):this.v(O,L,N)}v(O,L,N){this.j.fire(new se(this.reconnectionToken,O,L,N)),B(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$4k=ae;class J extends ae{constructor(O,L,N,W,q){super(1,O,W,q,!0),this.client=this.B(new $.$lh(q,{remoteAuthority:L,clientId:N},O.ipcLogger))}async y(O,L){await i(O,L)}}e.$5k=J;class Y extends ae{constructor(O,L,N,W,q){super(2,O,N,W,!1),this.z=L,this.debugPort=q}async y(O,L){await n(O,this.z,L)}}e.$6k=Y;function B(K){try{K.acceptDisconnect();const O=K.getSocket();K.dispose(),O.dispose()}catch(O){(0,M.$Y)(O)}}function F(K){if(K&&K.type==="error"){const O=new Error(`Connection error: ${K.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function U(K,O){for(;K.length<O;)K+=" ";return K}function H(K,O){return`[remote-connection][${U(d(K),13)}][${O.substr(0,5)}\u2026]`}function Q(K,O,L){return`${H(K,O)}[${L?"reconnect":"initial"}]`}function x(K,O){return`${Q(O,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function oe(K){return`${Date.now()-K} ms`}}),define(te[240],ie([0,1,2,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=void 0,e.$Rk=(0,C.$zh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(A,S){return this.a[A]??=[],this.a[A].push(S),(0,E.$kb)(()=>{const f=this.a[A]?.indexOf(S);typeof f=="number"&&f>=0&&this.a[A]?.splice(f,1)})}b(A){return(this.a[A.type]||[]).find(f=>f.supports(A))}connect(A,S,f,u){const p=this.b(A);if(!p)throw new Error(`No socket factory found for ${A}`);return p.connect(A,S,f,u)}}e.$Sk=s}),define(te[241],ie([0,1,27,47,21,113]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=void 0;let A;async function S(h=!1){return(A===void 0||h)&&(A=f()),A}e.$w5b=S;async function f(){const h=u();if(h===void 0)return!1;if(h>=22e3){const y=$();if(y)return new Promise(b=>{C.execFile(y,["--status"],d=>b(!d))})}else{const y=v();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function u(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(h)return parseInt(h[3])}function p(h){const y=process.env.SystemRoot;if(y){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,b?"Sysnative":"System32",h)}}function $(){return p("wsl.exe")}function v(){return p("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,14,2,181,59,6,5,43]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=void 0,e.$Go=(0,S.$zh)("requestService");class p{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?g[t]="*****":g[t]=this.b[t];this.a=g}return this.a}}class $ extends s.$mb{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,M.localize)(0,null),when:f.$hj.isEqualTo((0,f.$fj)(f.LogLevel.Trace)).serialize()})}async c(g,t,l){const r=`${g} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new p(t.headers??{}));try{const i=await l();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,C.$8)(i)),i}}}e.$Ho=$;function v(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}e.$Io=v;function h(k){return k.res.statusCode===204}async function y(k){return h(k)?null:(await(0,E.$Tc)(k.stream)).toString()}e.$Jo=y;async function b(k){if(!v(k))throw new Error("Server returned "+k.res.statusCode);return y(k)}e.$Ko=b;async function d(k){if(!v(k))throw new Error("Server returned "+k.res.statusCode);if(h(k))return null;const t=(await(0,E.$Tc)(k.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.$Lo=d;function c(k){w(k)}e.$Mo=c;let a;function w(k){const g=u.$6m.as(A.$$m.Configuration),t=a;a={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0}}},g.updateConfigurations({add:[a],remove:t?[t]:[]})}w(1)}),define(te[242],ie([0,1,17,22]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0;class s{constructor(S){this.a=S}listen(S,f){throw new Error("Invalid listen")}call(S,f,u,p=C.CancellationToken.None){switch(f){case"request":return this.a.request(u[0],p).then(async({res:$,stream:v})=>{const h=await(0,E.$Tc)(v);return[{statusCode:$.statusCode,headers:$.headers},h]});case"resolveProxy":return this.a.resolveProxy(u[0])}throw new Error("Invalid call")}}e.$Iq=s;class M{constructor(S){this.a=S}async request(S,f){const[u,p]=await this.a.call("request",[S],f);return{res:u,stream:(0,E.$Vc)(p)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Jq=M}),define(te[243],ie([0,1,244,12]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;function s(A,S){return A.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:A.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(A,S,f={}){const u=(0,E.parse)(A),p=f.proxyUrl||s(u,S);if(!p)return null;const $=(0,E.parse)(p);if(!/^https?:$/.test($.protocol||""))return null;const v={host:$.hostname||"",port:$.port||($.protocol==="https"?"443":"80"),auth:$.auth,rejectUnauthorized:(0,C.$re)(f.strictSSL)?f.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((h,y)=>{G(["http-proxy-agent"],h,y)}))(v):new(await new Promise((h,y)=>{G(["https-proxy-agent"],h,y)}))(v)}e.$Kq=M}),define(te[245],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=e.$T5b=e.$S5b=void 0,e.$S5b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$T5b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$U5b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[94],ie([0,1,47,9,182,22,50,14,4,31,108,63,8,138]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0;let y;async function b(c,a,w,k){return w["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,$.$El)(k)&&!w["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,$.$El)(k)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=v.Promises.withAsyncBody(async(g,t)=>{const l=new M.$rc;let r=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,h.$Fl)(i,1,120)*1e3);const n=setTimeout(()=>{l.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{g(await d(a,l.token))}catch(o){!(0,S.$2)(o)&&!l.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,A.$ki)(o)))):g({})}finally{clearTimeout(n),l.dispose()}})),y)}e.$Kl=b;async function d(c,a){const w=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",w);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",k);const g=(0,u.$6e)().replace(/-/g,"").substr(0,12),t=new RegExp(g+"({.*})"+g),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",l);const r=await(0,p.$ul)(f.OS,l);return c.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(a.isCancellationRequested)return n(new S.$3);const o=(0,C.$cd)(r);let m,I;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(m=`& '${process.execPath}' ${D} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,I=["-Login","-Command"]):o==="nu"?(m=`^'${process.execPath}' ${D} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,I=["-i","-l","-c"]):(m=`'${process.execPath}' ${D} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?I=["-ic"]:I=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),m);const P=(0,E.spawn)(r,[...I,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});a.onCancellationRequested(()=>(P.kill(),n(new S.$3))),P.on("error",T=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$ki)(T)),n(T)});const R=[];P.stdout.on("data",T=>R.push(T));const j=[];P.stderr.on("data",T=>j.push(T)),P.on("close",(T,z)=>{const ne=Buffer.concat(R).toString("utf8");c.trace("getUnixShellEnvironment#raw",ne);const ee=Buffer.concat(j).toString("utf8");if(ee.trim()&&c.trace("getUnixShellEnvironment#stderr",ee),T||z)return n(new Error((0,s.localize)(2,null,T,z)));const ce=t.exec(ne),se=ce?ce[1]:"{}";try{const ae=JSON.parse(se);w?ae.ELECTRON_RUN_AS_NODE=w:delete ae.ELECTRON_RUN_AS_NODE,k?ae.ELECTRON_NO_ATTACH_CONSOLE=k:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),i(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,A.$ki)(ae)),n(ae)}})})}}),define(te[246],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U1b=void 0;class E{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const A=String(E.a++);return this.b.set(A,M),{id:A,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const A=this.b.get(s.id);if(!A)return!1;this.b.delete(s.id);try{return A.validate(M)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$U1b=E}),define(te[95],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk="signService",e.$Uk=(0,E.$zh)(e.$Tk)}),define(te[247],ie([0,1,246]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0;class C extends E.$U1b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(A=>new A.signer().sign(M))}h(){return new Promise((M,A)=>G(["vsda"],M,A))}}e.$G6b=C}),define(te[33],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=void 0,e.$7M=(0,E.$zh)("stateReadService"),e.$8M=(0,E.$zh)("stateService")}),define(te[121],ie([0,1,8,17,2,12,36,16,5]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.$9M=e.SaveStrategy=void 0;var u;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class p extends s.$mb{constructor(y,b,d,c){super(),this.h=y,this.i=d,this.j=c,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=b===0?void 0:this.B(new E.$Cg(100))}init(){return this.f||(this.f=this.k()),this.f}async k(){try{this.b=(await this.j.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.i.error(y)}}getItem(y,b){const d=this.a[y];return(0,M.$ue)(d)?b:d}setItem(y,b){this.setItems([{key:y,data:b}])}setItems(y){let b=!1;for(const{key:d,data:c}of y)this.a[d]!==c&&((0,M.$ue)(c)?(0,M.$se)(this.a[d])||(this.a[d]=void 0,b=!0):(this.a[d]=c,b=!0));b&&this.l()}removeItem(y){(0,M.$se)(this.a[y])||(this.a[y]=void 0,this.l())}async l(){if(!this.g)return this.c?this.c.trigger(()=>this.m()):this.m()}async m(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.j.writeFile(this.h,C.$Hc.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(b){this.i.error(b)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.m(),0):this.m()),this.g}}e.$9M=p;let $=class extends s.$mb{constructor(y,b,d,c){super(),this.a=this.B(new p(b.stateResource,y,d,c))}async init(){await this.a.init()}getItem(y,b){return this.a.getItem(y,b)}};e.$0M=$,e.$0M=$=ke([_(1,A.$Gh),_(2,f.$3i),_(3,S.$4j)],$);class v extends ${setItem(y,b){this.a.setItem(y,b)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$$M=v}),define(te[122],ie([0,1,4,35,31]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=void 0;function M(f){if(E.$t===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function A(f,u,p,$,v,h,y,b){const d=Object.create(null);d["common.machineId"]=h,d.sessionID=(0,s.$6e)()+Date.now(),d.commitHash=$,d.version=v,d["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,E.$h)(E.$t),d["common.nodePlatform"]=C.$5c,d["common.nodeArch"]=p,d["common.product"]=b||"desktop",y&&(d["common.msftInternal"]=y);let c=0;const a=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),E.$l&&(d["common.snap"]="true");const w=M(u);return w&&(d["common.platformDetail"]=w),d}e.$8n=A;function S(f){const u=C.env.USERDNSDOMAIN;if(!u)return!1;const p=u.toLowerCase();return f.some($=>p===$)}e.$9n=S}),define(te[25],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0,e.$7k=(0,E.$zh)("telemetryService"),e.$8k=(0,E.$zh)("customEndpointTelemetryService"),e.$9k="telemetry.currentSessionDate",e.$0k="telemetry.firstSessionDate",e.$$k="telemetry.lastSessionDate",e.$_k="telemetry.machineId",e.$al="telemetry",e.$bl="telemetry.telemetryLevel",e.$cl="telemetry.enableCrashReporter",e.$dl="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[248],ie([0,1,27,8,44,13,9,4,7,86,21,107,90,16,23,25]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=void 0;const d=new Map;async function c(t,l){const r=`${t}::${l.join(":")}`,i=d.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,m=new Map,I=2e4;function D(R,j,T,z){const ne=j.substring(R.length+1);return C.Promises.withAsyncBody(async ee=>{let ce;try{ce=await p.Promises.readdir(j,{withFileTypes:!0})}catch{ee();return}if(z.count>=I){z.count+=ce.length,z.maxReached=!0,ee();return}let se=ce.length;if(se===0){ee();return}let ae=ce;z.count+ce.length>I&&(z.maxReached=!0,se=I-z.count,ae=ce.slice(0,se)),z.count+=ce.length;for(const J of ae)if(J.isDirectory()){if(T.includes(J.name)||await D(R,(0,A.$$c)(j,J.name),T,z),--se===0){ee();return}}else{const Y=J.name.lastIndexOf(".");if(Y>=0){const B=J.name.substring(Y+1);B&&o.set(B,(o.get(B)??0)+1)}for(const B of n)B.relativePathPattern?.test(ne)!==!1&&B.filePattern.test(J.name)&&m.set(B.tag,(m.get(B.tag)??0)+1);if(--se===0){ee();return}}})}const P=C.Promises.withAsyncBody(async R=>{const j={count:0,maxReached:!1};await D(t,t,l,j);const T=await k(t);R({configFiles:a(m),fileTypes:a(o),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:T})});return d.set(r,P),P}e.$qr=c;function a(t){return Array.from(t.entries(),([l,r])=>({name:l,count:r})).sort((l,r)=>r.count-l.count)}function w(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/h.$yk.GB).toFixed(2)}GB (${(E.freemem()/h.$yk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$Fm.value()*100)}%`},l=E.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.$rr=w;async function k(t){try{const l=new Map,r=(0,A.$$c)(t,".vscode","launch.json"),i=await p.Promises.readFile(r),n=[],o=(0,s.$Jm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$Sm)(o)==="object"&&o.configurations)for(const m of o.configurations){const I=m.type;I&&(l.has(I)?l.set(I,l.get(I)+1):l.set(I,1))}return a(l)}catch{return[]}}e.$sr=k;let g=class{constructor(l,r){this.c=l,this.d=r}f(l){const r=[];return r.push(`OS Version:       ${l.os}`),r.push(`CPUs:             ${l.cpus}`),r.push(`Memory (System):  ${l.memory}`),r.push(`VM:               ${l.vmHint}`),r.join(`
`)}g(l){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(E.totalmem()/h.$yk.GB).toFixed(2)}GB (${(E.freemem()/h.$yk.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${E.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(u.$Fm.value()*100)}%`),r.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${l.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(l,r){return Promise.all([(0,$.$pr)(l.mainPID),this.k(l)]).then(async i=>{let[n,o]=i,m=this.m(l,n);return r.forEach(I=>{if((0,v.$fm)(I))m+=`
${I.errorMessage}`,o+=`
${I.errorMessage}`;else if(m+=`

Remote: ${I.hostName}`,I.processes&&(m+=`
${this.m(l,I.processes)}`),I.workspaceMetadata){o+=`
|  Remote: ${I.hostName}`;for(const D of Object.keys(I.workspaceMetadata)){const P=I.workspaceMetadata[D];let R=`${P.fileCount} files`;P.maxFilesReached&&(R=`more than ${R}`),o+=`|    Folder (${D}): ${R}`,o+=this.h(P)}}}),{processInfo:m,workspaceInfo:o}})}async getSystemInfo(l,r){const{memory:i,vmHint:n,os:o,cpus:m}=w(),I={os:o,memory:i,cpus:m,vmHint:n,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(I.load=`${E.loadavg().map(D=>Math.round(D)).join(", ")}`),S.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(l,r){const i=[];return(0,$.$pr)(l.mainPID).then(async n=>(i.push(""),i.push(this.g(l)),i.push(""),i.push(this.m(l,n)),l.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(l))),r.forEach(o=>{if((0,v.$fm)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(l,o.processes)),o.workspaceMetadata)for(const m of Object.keys(o.workspaceMetadata)){const I=o.workspaceMetadata[m];let D=`${I.fileCount} files`;I.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${m}): ${D}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(l){const r=[];let n=0;const o=(P,R)=>{const j=` ${P}(${R})`;n+j.length>60?(r.push(m),m="|                 ",n=m.length):n+=j.length,m+=j};let m="|      File types:";const I=10,D=l.fileTypes.length>I?I:l.fileTypes.length;for(let P=0;P<D;P++){const R=l.fileTypes[P];o(R.name,R.count)}if(r.push(m),l.configFiles.length>=0&&(m="|      Conf files:",n=0,l.configFiles.forEach(P=>{o(P.name,P.count)}),r.push(m)),l.launchConfigFiles.length>0){let P="|      Launch Configs:";l.launchConfigFiles.forEach(R=>{const j=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;P+=j}),r.push(P)}return r.join(`
`)}j(l){const r=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${l[i]}`).join(`
                  `)}k(l){const r=[],i=[];return l.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const m=f.URI.revive(o);if(m.scheme===M.Schemas.file){const I=m.fsPath;i.push(c(I,["node_modules",".git"]).then(D=>{let P=`${D.fileCount} files`;D.maxFilesReached&&(P=`more than ${P}`),r.push(`|    Folder (${(0,A.$cd)(I)}): ${P}`),r.push(this.h(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${I} (${D.toString()})`)}))}else r.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(l,r){const i=new Map;l.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),l.pidToNames.forEach(({pid:o,name:m})=>i.set(o,m));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(l.mainPID,i,n,r,0),n.join(`
`)}n(l,r,i,n,o){const m=o===0;let I;m?I=n.pid===l?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?I=r.get(n.pid):I=`${"  ".repeat(o)} ${n.name}`;const D=process.platform==="win32"?n.mem:E.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(D/h.$yk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(n.children)&&n.children.forEach(P=>this.n(l,r,i,P,o+1))}async getWorkspaceFileExtensions(l){const r=new Set;for(const{uri:i}of l.folders){const n=f.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const o=n.fsPath;try{(await c(o,["node_modules",".git"])).fileTypes.forEach(I=>r.add(I.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(l){for(const{uri:r}of l.folders){const i=f.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const o=await c(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),o.fileTypes.forEach(m=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})}),o.launchConfigFiles.forEach(m=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})}),o.configFiles.forEach(m=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};e.$tr=g,e.$tr=g=ke([_(0,b.$7k),_(1,y.$ij)],g)}),define(te[249],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=void 0;class E{constructor(M){this.b=M}listen(M,A){throw new Error(`Event not found: ${A}`)}call(M,A,{eventName:S,data:f}){return this.b.forEach(u=>u.log(S,f)),Promise.resolve(null)}}e.$X5b=E;class C{constructor(M){this.b=M}log(M,A){return this.b.call("log",{eventName:M,data:A}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Y5b=C}),define(te[52],ie([0,1,37,12,3,18,60,122,25]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0;class u{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$0n=u;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$$n=p,e.$_n=new p;class ${async publicLog(n,o,m){}async publicLogError(n,o,m){}}e.$ao=$,e.$bo="telemetry",e.$co="extensionTelemetryLog",e.$do={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(m,I)=>{const D=m?new Set([...m.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:D}},1e3,!0)(m=>{m.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$9h)(m.source),configurationKeys:Array.from(m.affectedKeys)})})}e.$eo=v;function h(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$fo=h;function y(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$go=y;function b(i){const n=i.getValue(f.$bl),o=i.getValue(f.$cl);if(i.getValue(f.$dl)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ho=b;function d(i){const n={},o={},m={};w(i,m);for(let I in m){I=I.length>150?I.substr(I.length-149):I;const D=m[I];typeof D=="number"?o[I]=D:typeof D=="boolean"?o[I]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${D.length}`),n[I]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[I]=D)}return{properties:n,measurements:o}}e.$io=d;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const n=(0,A.$Nk)(i);return c.has(n)?n:"other"}e.$jo=a;function w(i,n,o=0,m){if(i)for(const I of Object.getOwnPropertyNames(i)){const D=i[I],P=m?m+I:I;Array.isArray(D)?n[P]=(0,E.$Ym)(D):D instanceof Date?n[P]=D.toISOString():(0,C.$ne)(D)?o<2?w(D,n,o+1,P+"."):n[P]=(0,E.$Ym)(D):n[P]=D}}function k(i,n){const o=i.msftInternalDomains||[],m=n.getValue("telemetry.internalTesting");return(0,S.$9n)(o)||m}e.$ko=k;function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$lo=g;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const m=[];for(const R of n)for(;;){const j=R.exec(i);if(!j)break;m.push([j.index,R.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(o="";;){const R=D.exec(i);if(!R)break;const j=m.some(([T,z])=>R.index<z&&T<D.lastIndex);!I.test(R[0])&&!j&&(o+=i.substring(P,R.index)+"<REDACTED: user-file-path>",P=D.lastIndex)}return P<i.length&&(o+=i.substr(P)),o}function l(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function r(i,n){return(0,E.$Vm)(i,o=>{if(o instanceof u||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let m=o.replaceAll("%20"," ");m=t(m,n);for(const I of n)m=m.replace(I,"");return m=l(m),m}})}e.$mo=r}),define(te[123],ie([0,1,26,116,120,4,7,14,35,52]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;function p(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,E.$Jd)(r.id,i.id)===0}e.$no=p;const $=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,n,o)}static parse(i){const n=$.exec(i);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?p(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$oo=v;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=h.exec(r);return i&&i[1]?[d(i[1]),i[2]]:[d(r),void 0]}e.$po=y;function b(r,i){return`${r}.${i}`}e.$qo=b;function d(r){return r.toLowerCase()}e.$ro=d;function c(r,i){return d(b(r??s.$Pl,i))}e.$so=c;function a(r,i){const n=[],o=m=>{for(const I of n)if(I.some(D=>p(i(D),i(m))))return I;return null};for(const m of r){const I=o(m);I?I.push(m):n.push([m])}return n}e.$to=a;function w(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$uo=w;function k(r){return{id:new u.$0n(r.identifier.id),name:new u.$0n(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$vo=k,e.$wo=new s.$Tl("pprice.better-merge");function g(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const m=o.shift();if(m&&n.every(I=>!p(I.identifier,{id:m}))){const I=r.filter(D=>p(D.identifier,{id:m}));I.length===1&&(n.push(I[0]),o.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$xo=g;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){i.debug("Error while getting the os-release file.",(0,S.$8)(m))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,i){const n=await t(r,i),o=(0,C.$Sn)(n?"alpine":M.$t,f.$6c);return i.debug("ComputeTargetPlatform:",o),o}e.$yo=l}),define(te[250],ie([0,1,204,52]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0;async function s(M,A,S,f,u,p,$){const v={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${A.nameShort})`};if((0,C.$fo)(A,S)&&(0,C.$ho)(f)===3){const h=await(0,E.$Yo)(S,u,p);v["X-Market-User-Id"]=h,v["VSCode-SessionId"]=$.machineId||h}return v}e.$Zo=s}),define(te[251],ie([0,1,2,37,4,26,183,18,59,77,23,43,25,52]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,a,w){this.k=a,this.l=w,this.d={},this.i=new E.$lb,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,M.$sd)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$sd)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(v.$bl)||k.affectsConfiguration(v.$dl)||k.affectsConfiguration(v.$cl))&&this.m()}))}setExperimentProperty(c,a){this.d[c]=a}m(){let c=(0,h.$ho)(this.k);const a=this.l.enabledTelemetryLevels;if(a){this.h=this.sendErrorTelemetry?a.error:!1;const w=a.usage?3:a.error?2:0;c=Math.min(c,w)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,a,w){this.g<a||(w=(0,C.$Wm)(w,this.d),w=(0,h.$mo)(w,this.j),w=(0,C.$Wm)(w,this.c),this.b.forEach(k=>k.log(c,w)))}publicLog(c,a){this.n(c,3,a)}publicLog2(c,a){this.publicLog(c,a)}publicLogError(c,a){this.h&&this.n(c,2,a)}publicLogError2(c,a){this.publicLogError(c,a)}};e.$Nq=y,e.$Nq=y=ke([_(1,S.$6h),_(2,p.$ij)],y);function b(){const d=(0,A.localize)(0,null,u.default.nameLong),c=u.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=s.$o?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),k=(0,A.localize)(5,null),g=(0,A.localize)(6,null),t=(0,A.localize)(7,null),l=`
|       | ${w} | ${k} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${d} ${c} ${a}

&nbsp;

${t}
${l}

&nbsp;

${r}
`}$.$6m.as(f.$$m.Configuration).registerConfiguration({id:v.$al,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[v.$bl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),$.$6m.as(f.$$m.Configuration).registerConfiguration({id:v.$al,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[v.$dl]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,A.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,A.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${v.$bl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[252],ie([0,1,4,86,25]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=void 0;async function M(A,S){let f=A.getItem(s.$_k);return(typeof f!="string"||E.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,C.$Gm)(S.error.bind(S))),f}e.$o6b=M}),define(te[253],ie([0,1,25,252]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=void 0;async function s(M,A){const S=await(0,C.$o6b)(M,A);return M.setItem(E.$_k,S),S}e.$p6b=s}),define(te[124],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(E||(e.EnvironmentVariableMutatorType=E={}))}),define(te[254],ie([0,1,4,124]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;const s=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(p){this.collections=p,this.a=new Map,this.b=new Map,p.forEach(($,v)=>{this.d($,v);const h=$.map.entries();let y=h.next();for(;!y.done;){const b=y.value[1],d=y.value[0];let c=this.a.get(d);if(c||(c=[],this.a.set(d,c)),c.length>0&&c[0].type===C.EnvironmentVariableMutatorType.Replace){y=h.next();continue}const a={extensionIdentifier:v,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};a.scope||delete a.scope,c.unshift(a),y=h.next()}})}async applyToProcessEnvironment(p,$,v){let h;E.$i&&(h={},Object.keys(p).forEach(y=>h[y.toLowerCase()]=y));for(const[y,b]of this.getVariableMap($)){const d=E.$i&&h[y.toLowerCase()]||y;for(const c of b){const a=v?await v(c.value):c.value;if(c.options?.applyAtProcessCreation??!0)switch(c.type){case C.EnvironmentVariableMutatorType.Append:p[d]=(p[d]||"")+a;break;case C.EnvironmentVariableMutatorType.Prepend:p[d]=a+(p[d]||"");break;case C.EnvironmentVariableMutatorType.Replace:p[d]=a;break}if(c.options?.applyAtShellIntegration??!1){const w=`VSCODE_ENV_${s.get(c.type)}`;p[w]=(p[w]?p[w]+":":"")+y+"="+this.c(a)}}}}c(p){return p.replaceAll(":","\\x3a")}diff(p,$){const v=new Map,h=new Map,y=new Map;if(p.getVariableMap($).forEach((b,d)=>{const c=this.getVariableMap($).get(d),a=S(b,c);a&&v.set(d,a)}),this.getVariableMap($).forEach((b,d)=>{const c=p.getVariableMap($).get(d),a=S(b,c);a&&y.set(d,a)}),this.getVariableMap($).forEach((b,d)=>{const c=p.getVariableMap($).get(d),a=f(b,c);a&&h.set(d,a)}),!(v.size===0&&h.size===0&&y.size===0))return{added:v,changed:h,removed:y}}getVariableMap(p){const $=new Map;for(const v of this.a.values()){const h=v.filter(y=>A(y,p));h.length>0&&$.set(h[0].variable,h)}return $}getDescriptionMap(p){const $=new Map;for(const v of this.b.values()){const h=v.filter(y=>A(y,p,!0));for(const y of h)$.set(y.extensionIdentifier,y.description)}return $}d(p,$){if(!p.descriptionMap)return;const v=p.descriptionMap.entries();let h=v.next();for(;!h.done;){const y=h.value[1],b=h.value[0];let d=this.b.get(b);d||(d=[],this.b.set(b,d));const c={extensionIdentifier:$,scope:y.scope,description:y.description};c.scope||delete c.scope,d.push(c),h=v.next()}}}e.$dr=M;function A(u,p,$=!1){return u.scope?!!(u.scope.workspaceFolder&&p?.workspaceFolder&&u.scope.workspaceFolder.index===p.workspaceFolder.index):$?p===u.scope:!0}function S(u,p){if(!p)return u;const $=new Set;p.forEach(h=>$.add(h.extensionIdentifier));const v=[];return u.forEach(h=>{$.has(h.extensionIdentifier)||v.push(h)}),v.length===0?void 0:v}function f(u,p){if(!p)return;const $=new Map;p.forEach(h=>$.set(h.extensionIdentifier,h));const v=[];return u.forEach(h=>{const y=$.get(h.extensionIdentifier);y&&(h.type!==y.type||h.value!==y.value||h.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&v.push(y)}),v.length===0?void 0:v}}),define(te[255],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=e.$ar=e.$_q=e.$$q=e.$0q=void 0;function E(f){return[...f.entries()]}e.$0q=E;function C(f){return f?[...f.entries()]:[]}e.$$q=C;function s(f){return new Map(f)}e.$_q=s;function M(f){return new Map(f??[])}e.$ar=M;function A(f){return Array.from(f.entries()).map(u=>[u[0],E(u[1].map),C(u[1].descriptionMap)])}e.$br=A;function S(f){return new Map(f.map(u=>[u[0],{map:s(u[1]),descriptionMap:M(u[2])}]))}e.$cr=S}),define(te[256],ie([0,1,8,22,3,2,5]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let S=class extends M.$mb{constructor(u,p){super(),this.h=p,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$hc),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u,this.B((0,M.$kb)(()=>{for(const $ of this.f.values())(0,M.$hb)($)}))}createRequest(u){return new Promise((p,$)=>{const v=++this.a;this.c.set(v,p),this.g.fire({requestId:v,...u});const h=new C.$rc;(0,E.$Fg)(this.b,h.token).then(()=>$(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,M.$kb)(()=>h.cancel())])})}acceptReply(u,p){const $=this.c.get(u);$?(this.c.delete(u),(0,M.$hb)(this.f.get(u)||[]),this.f.delete(u),$(p)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$1q=S,e.$1q=S=ke([_(1,A.$3i)],S)}),define(te[125],ie([0,1,6,114,43]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Tq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Sq=void 0,e.$Sq=new C.$Zi("terminalTabFocusMode",!1,!0);var M;(function(g){g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var A;(function(g){g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsDefaultColor="terminal.integrated.tabs.defaultColor",g.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.TabStopWidth="terminal.integrated.tabStopWidth",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorStyleInactive="terminal.integrated.cursorStyleInactive",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.TabFocusMode="terminal.integrated.tabFocusMode",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.HideOnStartup="terminal.integrated.hideOnStartup",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",g.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",g.EnableImages="terminal.integrated.enableImages",g.SmoothScrolling="terminal.integrated.smoothScrolling",g.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",g.FocusAfterRun="terminal.integrated.focusAfterRun",g.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",g.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",g.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var S;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(S||(e.PosixShellType=S={}));var f;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var u;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var p;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.PtyHostWindow="ptyHostWindow",g.Logger="logger",g.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var $;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions",g.FailedShellIntegrationActivation="failedShellIntegrationActivation",g.UsedShellIntegrationInjection="usedShellIntegrationInjection"})($||(e.ProcessPropertyType=$={})),e.$Tq=(0,E.$zh)("ptyService");var v;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var h;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var y;(function(g){g.TerminalView="view",g.Editor="editor"})(y||(e.TerminalLocationString=y={}));var b;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var d;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var c;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var a;(function(g){g[g.Off=0]="Off",g[g.FinalTerm=1]="FinalTerm",g[g.VSCode=2]="VSCode"})(a||(e.ShellIntegrationStatus=a={}));var w;(function(g){g[g.Unknown=0]="Unknown",g[g.Shutdown=1]="Shutdown",g[g.Process=2]="Process",g[g.User=3]="User",g[g.Extension=4]="Extension"})(w||(e.TerminalExitReason=w={})),e.$Uq={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$6m.add(e.$Uq.Backend,new k),e.$Vq=(0,E.$zh)("localPtyService"),e.$Wq=(0,E.$zh)("terminalLogService")}),define(te[257],ie([0,1,71,7,185,102]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=e.$2q=void 0;function A(v,h){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...v.map(b=>({name:b.profileName,description:S(b)}))),h&&y.push(...h.map(b=>({name:b.title,description:f(b)}))),{values:y.map(b=>b.name),markdownDescriptions:y.map(b=>b.description)}}e.$2q=A;function S(v){let h=`$(${M.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:E.$Nj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?h+=`
- args: "${v.args}"`:h+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(h+=`
- overrideName: ${v.overrideName}`),v.color&&(h+=`
- color: ${v.color}`),v.env&&(h+=`
- env: ${JSON.stringify(v.env)}`),h}function f(v){return`$(${M.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:E.$Nj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function u(v,h){if(!v&&!h)return!0;if(typeof v=="string"&&typeof h=="string")return v===h;if(Array.isArray(v)&&Array.isArray(h)){if(v.length!==h.length)return!1;for(let y=0;y<v.length;y++)if(v[y]!==h[y])return!1;return!0}return!1}e.$3q=u;function p(v,h){if(!v&&!h)return!0;if(!v||!h)return!1;if(M.ThemeIcon.isThemeIcon(v)&&M.ThemeIcon.isThemeIcon(h))return v.id===h.id&&v.color===h.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof h=="object"&&"light"in h&&"dark"in h){const y=v,b=h;if((C.URI.isUri(y.light)||$(y.light))&&(C.URI.isUri(y.dark)||$(y.dark))&&(C.URI.isUri(b.light)||$(b.light))&&(C.URI.isUri(b.dark)||$(b.dark)))return y.light.path===b.light.path&&y.dark.path===b.dark.path}if(C.URI.isUri(v)&&C.URI.isUri(h)||$(v)||$(h)){const y=v,b=h;return y.path===b.path&&y.scheme===b.scheme}return!1}e.$4q=p;function $(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.$5q=$}),define(te[258],ie([0,1,71,4,184,59,43,257]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=void 0,e.$6q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$7q={type:"string",enum:Array.from((0,E.$Mj)(),d=>d.id),markdownEnumDescriptions:Array.from((0,E.$Mj)(),d=>`$(${d.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$7q},color:{description:(0,s.localize)(3,null),...e.$6q},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},p={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function $(d){const c=d===2?"linux":d===1?"osx":"windows";return(0,s.localize)(7,null,(0,C.$h)(d),'```json\n"terminal.integrated.profile.'+c+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:$(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:$(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:$(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,s.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){A.$6m.as(M.$$m.Configuration).registerConfiguration(v),b()}e.$8q=h;let y;function b(d,c){const a=A.$6m.as(M.$$m.Configuration);let w;d&&(w=(0,S.$2q)(d?.profiles,c));const k=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:d?.os===3?w?.values:void 0,markdownEnumDescriptions:d?.os===3?w?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:d?.os===2?w?.values:void 0,markdownEnumDescriptions:d?.os===2?w?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:d?.os===1?w?.values:void 0,markdownEnumDescriptions:d?.os===1?w?.markdownDescriptions:void 0}}},a.updateConfigurations({add:[y],remove:k?[k]:[]})}e.$9q=b}),define(te[259],ie([0,1,27,13,37,9,4,35,26,12,21,124,255,254]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$er=y;async function b(i,n,o,m=S.env,I=p.Promises.exists){if(M.$0c(i))return await I(i)?i:void 0;if(n===void 0&&(n=S.cwd()),M.$bd(i)!=="."){const j=M.$$c(n,i);return await I(j)?j:void 0}const P=(0,s.$1m)(m,"PATH");if(o===void 0&&(0,u.$le)(P)&&(o=P.split(M.$id)),o===void 0||o.length===0){const j=M.$$c(n,i);return await I(j)?j:void 0}for(const j of o){let T;if(M.$0c(j)?T=M.$$c(j,i):T=M.$$c(n,j,i),await I(T))return T;if(A.$i){let z=T+".com";if(await I(z)||(z=T+".exe",await I(z)))return z}}const R=M.$$c(n,i);return await I(R)?R:void 0}e.$fr=b;function d(i,n,o,m,I){const D=A.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||D)return;const P=i.args,R=S.$5c==="win32"?M.$cd(i.executable).toLowerCase():M.$cd(i.executable),j=M.$bd(C.$4e.asFileUri("").fsPath);let T;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),A.$i){if(R==="pwsh.exe"||R==="powershell.exe")return!P||l(P)?T=w.get(a.WindowsPwsh):t(P)&&(T=w.get(a.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,f.$pd)(T[T.length-1],j,""),{newArgs:T,envMixin:z}):void 0;m.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(R){case"bash":return!P||P.length===0?T=w.get(a.Bash):r(P)&&(z.VSCODE_SHELL_LOGIN="1",c(n,z),T=w.get(a.Bash)),T?(T=[...T],T[T.length-1]=(0,f.$pd)(T[T.length-1],j),{newArgs:T,envMixin:z}):void 0;case"fish":{const ne=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=M.$$c(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${ne}:${ee}`,c(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!P||l(P)?T=w.get(a.Pwsh):t(P)&&(T=w.get(a.PwshLogin)),T?(T=[...T],T[T.length-1]=(0,f.$pd)(T[T.length-1],j,""),{newArgs:T,envMixin:z}):void 0;case"zsh":{if(!P||P.length===0?T=w.get(a.Zsh):r(P)?(T=w.get(a.ZshLogin),c(n,z)):(P===w.get(a.Zsh)||P===w.get(a.ZshLogin))&&(T=P),!T)return;T=[...T],T[T.length-1]=(0,f.$pd)(T[T.length-1],j);let ne;try{ne=E.userInfo().username}catch{ne="unknown"}const ee=M.$$c(E.tmpdir(),`${ne}-${I.applicationName}-zsh`);z.ZDOTDIR=ee;const ce=o?.ZDOTDIR??E.homedir()??"~";z.USER_ZDOTDIR=ce;const se=[];return se.push({source:M.$$c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$$c(ee,".zshrc")}),se.push({source:M.$$c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$$c(ee,".zprofile")}),se.push({source:M.$$c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$$c(ee,".zshenv")}),se.push({source:M.$$c(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$$c(ee,".zlogin")}),{newArgs:T,envMixin:z,filesToCopy:se}}}m.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$gr=d;function c(i,n){if(A.$j&&i.environmentVariableCollections){const o=(0,v.$cr)(i.environmentVariableCollections),I=new h.$dr(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),D=[];if(I)for(const P of I)P.type===$.EnvironmentVariableMutatorType.Prepend&&D.push(P.value);D.length>0&&(n.VSCODE_PATH_PREFIX=D.join(""))}}var a;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(a||(a={}));const w=new Map;w.set(a.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(a.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(a.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),w.set(a.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),w.set(a.Zsh,["-i"]),w.set(a.ZshLogin,["-il"]),w.set(a.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],g=["-nol","-nologo"];function t(i){return typeof i=="string"?k.includes(i.toLowerCase()):i.length===1&&k.includes(i[0].toLowerCase())||i.length===2&&(k.includes(i[0].toLowerCase())||k.includes(i[1].toLowerCase()))&&(g.includes(i[0].toLowerCase())||g.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?g.includes(i.toLowerCase()):i.length===0||i?.length===1&&g.includes(i[0].toLowerCase())}function r(i){return i==="string"&&k.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&k.includes(i[0].toLowerCase())}}),define(te[260],ie([0,1,47,71,9,4,12,21,106,259,113]),function(G,e,E,C,s,M,A,S,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;let $,v=!0;function h(n,o,m,I,D=process.env,P,R,j,T){return P=P||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?y(m,P,D,R,I.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:I.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:I.getValue("terminal.integrated.defaultProfile.windows"),T,j):l(P,R,m,n&&typeof n=="object"?{...n}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,j,D)}e.$hr=h;async function y(n,o,m,I,D,P,R,j,T){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let ee=!1;(0,u.$er)()>=16299&&(ee=!0),await a(j);const ce=new Map;if(n){ce.set("PowerShell",{source:"PowerShell",icon:C.$Nj.terminalPowershell,isAutoDetected:!0}),ce.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Nj.terminalPowershell,isAutoDetected:!0}),ce.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ce.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:C.$Nj.terminalCmd,isAutoDetected:!0}),ce.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ce.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:C.$Nj.terminalBash,isAutoDetected:!0});const ae=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ce.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",ae],requiresPath:process.env.CMDER_ROOT?ae:{path:ae,isUnsafe:!0},isAutoDetected:!0})}r(P,ce);const se=await b(ce.entries(),R,o,m,I,T);if(n&&D)try{const ae=await g(`${ne}\\${ee?"wsl":"bash"}.exe`,R);for(const J of ae)(!P||!(J.profileName in P))&&se.push(J)}catch{v&&(I?.info("WSL is not installed, so could not detect WSL profiles"),v=!1)}return se}async function b(n,o,m,I=process.env,D,P){const R=[];for(const[j,T]of n)R.push(d(j,T,o,m,I,D,P));return(await Promise.all(R)).filter(j=>!!j)}async function d(n,o,m,I,D=process.env,P,R){if(o===null)return;let j,T,z;if("source"in o&&!("path"in o)){const se=$?.get(o.source);if(!se)return;j=se.paths,T=o.args||se.args,o.icon?z=c(o.icon):se.icon&&(z=se.icon)}else j=Array.isArray(o.path)?o.path:[o.path],T=M.$i||Array.isArray(o.args)?o.args:void 0,z=c(o.icon);let ne;if(R){const se=j.map(J=>typeof J=="string"?J:J.path),ae=await R(se);ne=new Array(j.length);for(let J=0;J<j.length;J++)typeof j[J]=="string"?ne[J]=ae[J]:ne[J]={path:ae[J],isUnsafe:!0}}else ne=j.slice();let ee;if(o.requiresPath){let se;if((0,A.$le)(o.requiresPath)?se=o.requiresPath:(se=o.requiresPath.path,o.requiresPath.isUnsafe&&(ee=se)),!await I.existsFile(se))return}const ce=await i(n,m,ne,I,D,T,o.env,o.overrideName,o.isAutoDetected,ee);if(!ce){P?.debug("Terminal profile not validated",n,j);return}return ce.isAutoDetected=o.isAutoDetected,ce.icon=z,ce.color=o.color,ce}function c(n){return typeof n=="string"?{id:n}:n}async function a(n){if($&&!n)return;const[o,m]=await Promise.all([w(),n||k()]);$=new Map,$.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),$.set("PowerShell",{profileName:"PowerShell",paths:m,icon:C.$Nj.terminalPowershell})}async function w(){const n=new Set,o=await(0,u.$fr)("git.exe");if(o){const D=(0,p.dirname)(o);n.add((0,p.resolve)(D,"../.."))}function m(D,P){P&&D.add(P)}m(n,process.env.ProgramW6432),m(n,process.env.ProgramFiles),m(n,process.env["ProgramFiles(X86)"]),m(n,`${process.env.LocalAppData}\\Program`);const I=[];for(const D of n)I.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function k(){const n=[];for await(const o of(0,f.$ol)())n.push(o.exePath);return n}async function g(n,o){const m=[],I=await new Promise((R,j)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,z)=>{if(T)return j("Problem occurred when getting wsl distros");R(z)})});if(!I)return[];const D=new RegExp(/[\r?\n]/),P=I.split(D).filter(R=>R.trim().length>0&&R!=="");for(const R of P){if(R===""||R.startsWith("docker-desktop"))continue;const j=`${R} (WSL)`,T={profileName:j,path:n,args:["-d",`${R}`],isDefault:j===o,icon:t(R),isAutoDetected:!1};m.push(T)}return m}function t(n){return n.includes("Ubuntu")?C.$Nj.terminalUbuntu:n.includes("Debian")?C.$Nj.terminalDebian:C.$Nj.terminalLinux}async function l(n,o,m,I,D,P,R,j){const T=new Map;if(m){const z=(await n.readFile("/etc/shells")).toString(),ne=(P||z.split(`
`)).map(ce=>{const se=ce.indexOf("#");return se===-1?ce:ce.substring(0,se)}).filter(ce=>ce.trim().length>0),ee=new Map;for(const ce of ne){let se=(0,s.$cd)(ce),ae=ee.get(se)||0;ae++,ae>1&&(se=`${se} (${ae})`),ee.set(se,ae),T.set(se,{path:ce,isAutoDetected:!0})}}return r(I,T),await b(T.entries(),D,n,j,o,R)}function r(n,o){if(n)for(const[m,I]of Object.entries(n))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?o.delete(m):(I.icon=I.icon||o.get(m)?.icon,o.set(m,I))}async function i(n,o,m,I,D,P,R,j,T,z){if(m.length===0)return Promise.resolve(void 0);const ne=m.shift();if(ne==="")return i(n,o,m,I,D,P,R,j,T);const ee=typeof ne!="string"&&ne.isUnsafe,ce=typeof ne=="string"?ne:ne.path,se={profileName:n,path:ce,args:P,env:R,overrideName:j,isAutoDetected:T,isDefault:n===o,isUnsafePath:ee,requiresUnsafePath:z};if((0,s.$cd)(ce)===ce){const J=D.PATH?D.PATH.split(s.$id):void 0,Y=await(0,u.$fr)(ce,void 0,J,void 0,I.existsFile);return Y?(se.path=Y,se.isFromPath=!0,se):i(n,o,m,I,D,P)}return await I.existsFile((0,s.$9c)(ce))?se:i(n,o,m,I,D,P,R,j,T)}}),define(te[261],ie([0,1,3,2,4,42,18,5,223,94,256,125,258,260,108,69]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;var d;(function(a){a[a.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let c=class extends C.$mb{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.P()}constructor(w,k,g,t){super(),this.H=w,this.I=k,this.J=g,this.L=t,this.j=!1,this.k=0,this.l=!0,this.m=!1,this.r=this.B(new E.$hc),this.onPtyHostExit=this.r.event,this.s=this.B(new E.$hc),this.onPtyHostStart=this.s.event,this.t=this.B(new E.$hc),this.onPtyHostUnresponsive=this.t.event,this.u=this.B(new E.$hc),this.onPtyHostResponsive=this.u.event,this.v=this.B(new E.$hc),this.onPtyHostRequestResolveVariables=this.v.event,this.w=this.B(new E.$hc),this.onProcessData=this.w.event,this.y=this.B(new E.$hc),this.onProcessReady=this.y.event,this.z=this.B(new E.$hc),this.onProcessReplay=this.z.event,this.C=this.B(new E.$hc),this.onProcessOrphanQuestion=this.C.event,this.D=this.B(new E.$hc),this.onDidRequestDetach=this.D.event,this.F=this.B(new E.$hc),this.onDidChangeProperty=this.F.event,this.G=this.B(new E.$hc),this.onProcessExit=this.G.event,(0,v.$8q)(),this.B(this.H),this.B((0,C.$kb)(()=>this.Q())),this.i=this.B(new p.$1q(void 0,this.J)),this.i.onCreateRequest(this.v.fire,this.v),this.H.onRequestConnection&&E.Event.once(this.H.onRequestConnection)(()=>this.h()),this.H.onWillShutdown?.(()=>this.j=!0)}get M(){return this.I.getValue("terminal.integrated.ignoreProcessNames")}async N(){return this.g?.refreshIgnoreProcessNames?.(this.M)}async O(){if(s.$i)return process.env;try{return await(0,u.$Kl)(this.I,this.J,{_:[]},process.env)}catch(w){return this.J.error("ptyHost was unable to resolve shell environment",w),{}}}P(){const w=this.H.start(),k=w.client;this.J.getLevel()===S.LogLevel.Trace&&this.J.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(k.getChannel($.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.R()),this.R(!0),this.B(w.onDidProcessExit(l=>{this.r.fire(l.code),!this.j&&!this.m&&(this.k<=d.MaxRestarts?(this.J.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.k++,this.restartPtyHost()):this.J.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=M.ProxyChannel.toService(k.getChannel($.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(l=>this.w.fire(l))),this.B(t.onProcessReady(l=>this.y.fire(l))),this.B(t.onProcessExit(l=>this.G.fire(l))),this.B(t.onDidChangeProperty(l=>this.F.fire(l))),this.B(t.onProcessReplay(l=>this.z.fire(l))),this.B(t.onProcessOrphanQuestion(l=>this.C.fire(l))),this.B(t.onDidRequestDetach(l=>this.D.fire(l))),this.B(new f.$Zq(this.L,k.getChannel($.TerminalIpcChannels.Logger))),this.a=w,this.b=t,this.s.fire(),this.B(this.I.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.N()})),this.N(),[w,t]}dispose(){this.m=!0,super.dispose()}async createProcess(w,k,g,t,l,r,i,n,o,m,I){const D=setTimeout(()=>this.W(),$.HeartbeatConstants.CreateProcessTimeout),P=await this.f.createProcess(w,k,g,t,l,r,i,n,o,m,I);return clearTimeout(D),P}updateTitle(w,k,g){return this.f.updateTitle(w,k,g)}updateIcon(w,k,g,t){return this.f.updateIcon(w,k,g,t)}attachToProcess(w){return this.f.attachToProcess(w)}detachFromProcess(w,k){return this.f.detachFromProcess(w,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(w){return this.f.start(w)}shutdown(w,k){return this.f.shutdown(w,k)}input(w,k){return this.f.input(w,k)}processBinary(w,k){return this.f.processBinary(w,k)}resize(w,k,g){return this.f.resize(w,k,g)}clearBuffer(w){return this.f.clearBuffer(w)}acknowledgeDataEvent(w,k){return this.f.acknowledgeDataEvent(w,k)}setUnicodeVersion(w,k){return this.f.setUnicodeVersion(w,k)}getInitialCwd(w){return this.f.getInitialCwd(w)}getCwd(w){return this.f.getCwd(w)}async getLatency(){const w=new b.$dc,k=await this.f.getLatency();return w.stop(),[{label:"ptyhostservice<->ptyhost",latency:w.elapsed()},...k]}orphanQuestionReply(w){return this.f.orphanQuestionReply(w)}installAutoReply(w,k){return this.f.installAutoReply(w,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(w){return this.f.uninstallAutoReply(w)}getDefaultSystemShell(w){return this.g?.getDefaultSystemShell(w)??(0,y.$ul)(w??s.OS,process.env)}async getProfiles(w,k,g,t=!1){const l=await this.O();return(0,h.$hr)(k,g,t,this.I,l,void 0,this.J,this.Y.bind(this,w))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(w,k){return this.f.getWslPath(w,k)}getRevivedPtyNewId(w,k){return this.f.getRevivedPtyNewId(w,k)}setTerminalLayoutInfo(w){return this.f.setTerminalLayoutInfo(w)}async getTerminalLayoutInfo(w){return this.g?.getTerminalLayoutInfo(w)}async requestDetachInstance(w,k){return this.f.requestDetachInstance(w,k)}async acceptDetachInstanceReply(w,k){return this.f.acceptDetachInstanceReply(w,k)}async freePortKillProcess(w){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(w)}async serializeTerminalState(w){return this.f.serializeTerminalState(w)}async reviveTerminalProcesses(w,k,g){return this.f.reviveTerminalProcesses(w,k,g)}async refreshProperty(w,k){return this.f.refreshProperty(w,k)}async updateProperty(w,k,g){return this.f.updateProperty(w,k,g)}async restartPtyHost(){this.Q(),this.l=!0,this.P()}Q(){this.f.shutdownAll(),this.c.store.dispose()}R(w){this.X(),this.n=setTimeout(()=>this.S(),w?$.HeartbeatConstants.ConnectingBeatInterval:$.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.FirstWaitMultiplier),this.l||(this.l=!0,this.u.fire())}S(){this.J.warn(`No ptyHost heartbeat after ${$.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.n=void 0,this.p=setTimeout(()=>this.U(),$.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.SecondWaitMultiplier)}U(){this.J.error(`No ptyHost heartbeat after ${($.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.FirstWaitMultiplier+$.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.p=void 0,this.l&&(this.l=!1,this.t.fire())}W(){this.X(),this.J.error(`No ptyHost response to createProcess after ${$.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.l&&(this.l=!1,this.t.fire())}X(){this.n&&(clearTimeout(this.n),this.n=void 0),this.p&&(clearTimeout(this.p),this.p=void 0)}Y(w,k){return this.i.createRequest({workspaceId:w,originalText:k})}async acceptPtyHostResolvedVariables(w,k){this.i.acceptReply(w,k)}};e.$ir=c,e.$ir=c=ke([_(1,A.$6h),_(2,S.$3i),_(3,S.$4i)],c)}),define(te[79],ie([0,1,15,3,2,4,18,6,33]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v5b=e.$u5b=void 0;const u="#FFFFFF",p="#1E1E1E",$="#000000",v="#FFFFFF",h="theme",y="themeBackground",b="windowSplash";e.$u5b=(0,S.$zh)("themeMainService");let d=class extends s.$mb{constructor(a,w){super(),this.b=a,this.c=w,this.a=this.B(new C.$hc),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const a=this.getColorScheme();if(a.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return a.dark?$:v;let w=this.b.getItem(y,null);if(!w)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":w=u;break;case"hc-black":w=$;break;case"hc-light":w=v;break;default:w=p}return M.$j&&w.toUpperCase()===p&&(w="#171717"),w}saveWindowSplash(a,w){this.b.setItems([{key:h,data:w.baseTheme},{key:y,data:w.colorInfo.background},{key:b,data:w}]),typeof a=="number"&&this.f(a,w)}f(a,w){for(const k of E.BrowserWindow.getAllWindows())if(k.id===a){k.setBackgroundColor(w.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};e.$v5b=d,e.$v5b=d=ke([_(0,f.$8M),_(1,A.$6h)],d)}),define(te[126],ie([0,1,3,18,6,5]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.$Vz=e.ProvidedOnAutoForward=e.$Uz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tz=e.$Sz=void 0,e.$Sz=(0,s.$zh)("tunnelService"),e.$Tz=(0,s.$zh)("sharedTunnelsService");var A;(function(d){d.Http="http",d.Https="https"})(A||(e.TunnelProtocol=A={}));var S;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(S||(e.TunnelPrivacyId=S={}));function f(d){return!!d.forwardPort}e.$Uz=f;var u;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function p(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(c)return{address:c[1],port:+c[2]}}e.$Vz=p,e.$Wz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function $(d){return e.$Wz.indexOf(d)>=0}e.$Xz=$,e.$Yz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(d){return e.$Yz.indexOf(d)>=0}e.$Zz=v;function h(d,c,a,w){if(a===1)return!1;if(a===2&&v(c)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(k?.length===4&&parseInt(k[1])>=18)return!1}return d<1024}e.$1z=h;class y{constructor(c,a,w){this.remoteAddress=c,this.localAddress=a,this.b=w,this.a=new E.$hc,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$2z=y;let b=class{constructor(c,a){this.j=c,this.k=a,this.a=new E.$hc,this.onTunnelOpened=this.a.event,this.b=new E.$hc,this.onTunnelClosed=this.b.event,this.c=new E.$hc,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],a=Array.from(this.e.values());for(const w of a){const k=Array.from(w.values());for(const g of k){const t=await g.value;t&&typeof t!="string"&&c.push(t)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:a}of c.values())await a.then(w=>typeof w!="string"?w?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,a,w,k,g){this.p(c,a,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:a,localAddress:w,privacy:k,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,a){(v(c)||$(c))&&(c=e.$Wz[0]);const w=this.r(c,a);if(w)return++w.refcount,w.value}openTunnel(c,a,w,k,g,t=!1,l,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${w} on local port ${g}.`);const i=this.f??c;if(!i)return;if(a||(a="localhost"),k||(k=this.l),this.f&&this.i.has(w)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,a,w,k,g,t,l,r);return n?n.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,w),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,w);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.n(o);return(o.tunnelRemoteHost!==a||o.tunnelRemotePort!==w)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&o.privacy!==l&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const a=this.e.get(c.tunnelRemoteHost);if(a){const w=a.get(c.tunnelRemotePort);w&&(w.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,w))}}}}async o(c,a,w){if(w.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${a}.`);const k=w.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(a),k}}async closeTunnel(c,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${a} `);const w=this.e.get(c);if(w&&w.has(a)){const k=w.get(a);k.refcount=0,await this.o(c,a,k)}}p(c,a,w){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(a,{refcount:1,value:w})}async q(c,a){const w=this.e.get(c);if(w){const k=w.get(a),g=k?await k.value:void 0;(!g||typeof g=="string")&&w.delete(a),w.size===0&&this.e.delete(c)}}r(c,a){const w=[c];$(c)?(w.push(...e.$Wz),w.push(...e.$Yz)):v(c)&&w.push(...e.$Yz);const k=w.map(g=>this.e.get(g));for(const g of k){const t=g?.get(a);if(t)return t}}canTunnel(c){return!!p(c)}t(c,a,w,k,g,t,l){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${w} on local port ${k}.`);const r=w;this.i.add(r);const i=k===void 0?w:k,n={elevationRequired:g?this.isPortPrivileged(i):!1},o={remoteAddress:{host:a,port:w},localAddressPort:k,privacy:t,public:t?t!==S.Private:void 0,protocol:l},m=c.forwardPort(o,n);return m?(this.p(a,w,m),m.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),m}};e.$3z=b,e.$3z=b=ke([_(0,M.$3i),_(1,C.$6h)],b)}),define(te[48],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GT=e.$FT=e.DisablementReason=e.UpdateType=e.StateType=void 0;var C;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(C||(e.StateType=C={}));var s;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$FT={Uninitialized:{type:"uninitialized"},Disabled:A=>({type:"disabled",reason:A}),Idle:(A,S)=>({type:"idle",updateType:A,error:S}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.$GT=(0,E.$zh)("updateService")}),define(te[262],ie([0,1,4,186,59,43]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$6m.as(s.$$m.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:E.$i&&!E.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[263],ie([0,1,3,48]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.$Z5b=void 0;class s{constructor(S){this.a=S}listen(S,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,u){switch(f){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${f}`)}}e.$Z5b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new E.$hc,this.onStateChange=this.a.event,this.b=C.$FT.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$15b=M}),define(te[40],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=void 0,e.$Ak=(0,E.$zh)("IUriIdentityService")}),define(te[264],ie([0,1,40,205,16,19,139,3,2]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class u{static{this._clock=0}constructor(v){this.uri=v,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let p=class{constructor(v){this.g=v,this.c=new f.$lb,this.f=2**16;const h=new Map,y=b=>{let d=h.get(b.scheme);return d===void 0&&(d=v.hasProvider(b)&&!this.g.hasCapability(b,1024),h.set(b.scheme,d)),d};this.c.add(S.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(b=>{h.delete(b.scheme)})),this.extUri=new M.$8f(y),this.d=new A.$lr((b,d)=>this.extUri.compare(b,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,M.$hg)(v));const h=this.d.get(v);return h?h.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new u(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((y,b)=>y[1].time<b[1].time?1:y[1].time>b[1].time?-1:0);u._clock=0,this.d.clear();const h=this.f*.5;for(let y=0;y<h;y++)this.d.set(v[y][0],v[y][1].touch())}};e.$mr=p,e.$mr=p=ke([_(0,s.$4j)],p),(0,C.$jr)(E.$Ak,p,1)}),define(te[127],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uT=void 0,e.$uT=(0,E.$zh)("urlService")}),define(te[265],ie([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=e.$85b=void 0;class C{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,u){switch(f){case"handleURL":return this.a.handleURL(E.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${f}`)}}e.$85b=C;class s{constructor(S){this.a=S}handleURL(S,f){return this.a.call("handleURL",[S.toJSON(),f])}}e.$95b=s;class M{constructor(S,f){this.a=S,this.b=f}async routeCall(S,f,u,p){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(u)&&u.length>0){const $=E.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",$.toString(!0)),$.query){const v=/\bwindowId=(\d+)/.exec($.query);if(v){const h=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,$.toString(!0));const y=new RegExp(`window:${h}`),b=S.connections.find(d=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",d.ctx),y.test(d.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",$.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",$.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",$.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,f,u,p)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.$05b=M}),define(te[266],ie([0,1,8,2,7,23]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wT=e.$vT=void 0;class A extends C.$mb{constructor(){super(...arguments),this.a=new Set}open(u,p){const $=[...this.a.values()];return(0,E.$Ig)($.map(v=>()=>v.handleURL(u,p)),void 0,!1).then(v=>v||!1)}registerHandler(u){return this.a.add(u),(0,C.$kb)(()=>this.a.delete(u))}}e.$vT=A;let S=class extends A{constructor(u){super(),this.b=u}create(u){let{authority:p,path:$,query:v,fragment:h}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&$&&$.indexOf("/")!==0&&($=`/${$}`),s.URI.from({scheme:this.b.urlProtocol,authority:p,path:$,query:v,fragment:h})}};e.$wT=S,e.$wT=S=ke([_(0,M.$ij)],S)}),define(te[267],ie([0,1,15,8,3,2,4,7]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$5b=void 0;class f{constructor(p,$,v,h,y,b){if(this.f=$,this.g=b,this.a=[],this.b=0,this.c=M.$mb.None,this.d=new M.$lb,p&&(b.trace("ElectronURLListener initialUrisToHandle:",p.map(a=>a.originalUrl)),this.a=p),A.$i){const a=h.isBuilt?[]:[`"${h.appRoot}"`];a.push("--open-url","--"),E.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,a)}const d=s.Event.map(s.Event.fromNodeEventEmitter(E.app,"open-url",(a,w)=>({event:a,url:w})),({event:a,url:w})=>(a.preventDefault(),w));this.d.add(d(a=>{const w=this.h(a);w&&this.f.open(w,{originalUrl:a})})),v.getWindows().filter(a=>a.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(v.onDidSignalReadyWindow)(this.i,this,this.d))}h(p){try{return S.URI.parse(p)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const $ of this.a)await this.f.open($.uri,{originalUrl:$.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",$.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",$.originalUrl),p.push($));p.length!==0&&(this.a=p,this.c=(0,C.$Gg)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$$5b=f}),define(te[268],ie([0,1,3,2,16,56,58,17,12]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=void 0;class u extends C.$mb{get capabilities(){return this.f.capabilities&-5}constructor($,v,h,y){super(),this.c=$,this.f=v,this.g=h,this.h=y,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new E.$hc),this.onDidChangeFile=this.a.event,this.b=A.$Fh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(b=>this.i(b)))}watch($,v){this.b.set($,$);const h=this.f.watch(this.j($),v);return(0,C.$kb)(()=>{this.b.delete($),h.dispose()})}stat($){return this.f.stat(this.j($))}mkdir($){return this.f.mkdir(this.j($))}rename($,v,h){return this.f.rename(this.j($),this.j(v),h)}readFile($){return this.f.readFile(this.j($),{atomic:!0})}readFileStream($,v,h){const y=(0,M.$vc)(b=>S.$Hc.concat(b.map(d=>S.$Hc.wrap(d))).buffer);return(async()=>{try{const b=await this.readFile($);y.end(b)}catch(b){y.error(b),y.end()}})(),y}readdir($){return this.f.readdir(this.j($))}writeFile($,v,h){return!(0,f.$ne)(h.atomic)&&(0,s.$_j)(this.f)&&(h={...h,atomic:{postfix:".vsctmp"}}),this.f.writeFile(this.j($),v,h)}delete($,v){return this.f.delete(this.j($),v)}copy($,v,h){if((0,s.$7j)(this.f))return this.f.copy(this.j($),this.j(v),h);throw new Error("copy not supported")}i($){const v=[];for(const h of $){if(h.resource.scheme!==this.c)continue;const y=this.k(h.resource);this.b.findSubstr(y)&&v.push({resource:y,type:h.type})}v.length&&(this.h.debug("User data changed"),this.a.fire(v))}j($){return $.with({scheme:this.c})}k($){return $.with({scheme:this.g})}}e.$J6b=u}),define(te[269],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0,e.$r6b="utilityProcessWorker"}),define(te[270],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=void 0,e.$_5b=(0,E.$zh)("webviewManagerService")}),define(te[271],ie([0,1,15,2,13,7]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=void 0;class A extends C.$mb{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);E.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,u){try{const p=M.URI.parse(f.url),$=A.a.get(p.path);if(typeof $=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${$}`,h=s.$4e.asFileUri(v);return u({path:h.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.$a6b=A}),define(te[80],ie([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.$ND=e.$MD=e.$LD=void 0,e.$LD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(p){return!!p.workspaceUri}e.$MD=C;function s(p){return!!p.folderUri}e.$ND=s;function M(p){return!!p.fileUri}e.$OD=M;function A(p){const $=S(p),v=p.getValue("window.menuBarVisibility");return v==="default"||$==="native"&&v==="compact"||E.$j&&E.$m?"classic":v}e.$PD=A;function S(p){if(E.$o)return"custom";const $=p.getValue("window");if($){if(E.$j&&$.nativeTabs===!0||E.$j&&$.nativeFullScreen===!1)return"native";const y=$.titleBarStyle;if(y==="native"||y==="custom")return y}return E.$k?"native":"custom"}e.$QD=S;function f(p){return!(!E.$i||E.$o||S(p)==="native")}e.$RD=f;function u(p=0){return Math.pow(1.2,p)}e.$SD=u}),define(te[128],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$J4b=e.UnloadReason=e.LoadReason=void 0;var E;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var C;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(C||(e.UnloadReason=C={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$J4b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var A;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(A||(e.WindowError=A={}))}),define(te[30],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$Y4b=void 0,e.$Y4b=(0,E.$zh)("windowsMainService");var C;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(C||(e.OpenContext=C={}))}),define(te[272],ie([0,1,15,24,4,7,21,18,63,6,5,127,30]),function(G,e,E,C,s,M,A,S,f,u,p,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G5b=e.$F5b=e.ID=void 0,e.ID="launchMainService",e.$F5b=(0,u.$zh)(e.ID);let h=class{constructor(b,d,c,a){this.a=b,this.b=d,this.c=c,this.d=a}async start(b,d){this.a.trace("Received data from other instance: ",b,d),s.$j&&E.app.focus({steal:!0});const c=this.e(b);if(c.length){let a=Promise.resolve();if(this.b.getWindowCount()===0){const w=(0,C.$Hf)(await this.b.openEmptyWindow({context:4}));w&&(a=w.ready())}a.then(()=>{for(const{uri:w,originalUrl:k}of c)this.c.open(w,{originalUrl:k})})}else return this.f(b,d)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,C.$Af)(b._urls.map(d=>{try{return{uri:M.URI.parse(d),originalUrl:d}}catch{return null}})):[]}async f(b,d){const c=(0,f.$El)(d)?0:4;let a=[];const w=b.wait&&b.waitMarkerFilePath?M.URI.file(b.waitMarkerFilePath):void 0,k=b.remote||void 0,g={context:c,cli:b,userEnv:d,waitMarkerFileURI:w,remoteAuthority:k,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,g);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||g.forceProfile||g.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)a=await this.b.open({...g,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,g),a=[l]):a=await this.b.open({...g,forceEmpty:!0})}}else a=await this.b.open({...g,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(w&&a.length===1&&a[0])return Promise.race([a[0].whenClosedOrLoaded,(0,A.whenDeleted)(w.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$G5b=h,e.$G5b=h=ke([_(0,p.$3i),_(1,v.$Y4b),_(2,$.$uT),_(3,S.$6h)],h)}),define(te[273],ie([0,1,15,3,2,271,30]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=void 0;let S=class extends s.$mb{constructor(u){super(),this.b=u,this.a=this.B(new C.$hc),this.onFoundInFrame=this.a.event,this.B(new M.$a6b)}async setIgnoreMenuShortcuts(u,p){let $;if(typeof u.windowId=="number"){const{windowId:v}=u,h=this.b.getWindowById(v);if(!h?.win)throw new Error(`Invalid windowId: ${v}`);$=h.win.webContents}else{const{webContentsId:v}=u;if($=E.webContents.fromId(v),!$)throw new Error(`Invalid webContentsId: ${v}`)}$.isDestroyed()||$.setIgnoreMenuShortcuts(p)}async findInFrame(u,p,$,v){const y=this.c(u,p);if(typeof y.findInFrame=="function"){y.findInFrame($,{findNext:v.findNext,forward:v.forward});const b=(d,c)=>{c.finalUpdate&&(this.a.fire(c),y.removeListener("found-in-frame",b))};y.on("found-in-frame",b)}}async stopFindInFrame(u,p,$){const h=this.c(u,p);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame($.keepSelection?"keepSelection":"clearSelection")}c(u,p){const $=this.b.getWindowById(u.windowId);if(!$?.win)throw new Error(`Invalid windowId: ${u}`);const v=$.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===p);if(!v)throw new Error(`Unknown frame: ${p}`);return v}};e.$b6b=S,e.$b6b=S=ke([_(0,A.$Y4b)],S)}),define(te[274],ie([0,1,8,3,2]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=void 0;class M extends s.$mb{constructor({onDidOpenWindow:S,onDidFocusWindow:f,getActiveWindowId:u}){super(),this.a=this.B(new s.$lb),C.Event.latch(C.Event.any(S,f))(this.f,this,this.a),this.b=(0,E.$sg)(()=>u()),(async()=>{try{const $=await this.b;this.c=typeof this.c=="number"?this.c:$}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$h6b=M}),define(te[29],ie([0,1,190,9,58,19,7,6,13]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.WorkbenchState=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0,e.$Ih=(0,S.$zh)("contextService");function u(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$Jh=u;function p(i){return typeof i?.id=="string"&&!u(i)&&!v(i)}e.$Kh=p,e.$Lh={id:"ext-dev"},e.$Mh={id:"empty-window"};function $(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$cd)(i)}:n?e.$Lh:e.$Mh;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Nh=$;function v(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$Oh=v;function h(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$Ph=h;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Qh=b;function d(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Rh=d;class c{constructor(n,o,m,I,D){this.h=n,this.j=m,this.k=I,this.l=D,this.c=s.$Fh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Fh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Sh=c;class a{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$gg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Th=a;function w(i){return new a({uri:i,index:0,name:(0,M.$cg)(i)},{uri:i.toString()})}e.$Uh=w,e.$Vh="code-workspace",e.$Wh=`.${e.$Vh}`,e.$Xh=[{name:(0,E.localize)(0,null),extensions:[e.$Vh]}],e.$Yh="workspace.json";function k(i,n){return M.$0f.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$Zh=k;function g(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$1h=g,e.$2h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$2h}e.$3h=t;function l(i,n){return!k(i,n)&&!g(i)}e.$4h=l;function r(i){return(typeof i=="string"?(0,C.$dd)(i):(0,M.$eg)(i))===e.$Wh}e.$5h=r}),define(te[61],ie([0,1,15,8,57,46,2,85,4,21,165,91,6,5,23,29]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_4b=e.$$4b=void 0,e.$$4b=(0,v.$zh)("dialogMainService");let d=class{constructor(a,w){this.d=a,this.e=w,this.a=new Map,this.b=new Map,this.c=new C.$Lg}pickFileFolder(a,w){return this.f({...a,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},w)}pickFolder(a,w){return this.f({...a,pickFolders:!0,title:(0,p.localize)(1,null)},w)}pickFile(a,w){return this.f({...a,pickFiles:!0,title:(0,p.localize)(2,null)},w)}pickWorkspace(a,w){const k=(0,p.localize)(3,null),g=(0,M.$hA)((0,p.localize)(4,null)),t=b.$Xh;return this.f({...a,pickFiles:!0,title:k,filters:t,buttonLabel:g},w)}async f(a,w){const k={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters,defaultPath:a.defaultPath};(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(k.properties=void 0,a.pickFiles&&a.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&k.properties.push("treatPackageAsDirectory");const g=await this.showOpenDialog(k,(w||E.BrowserWindow.getFocusedWindow())??void 0);if(g&&g.filePaths&&g.filePaths.length>0)return g.filePaths}g(a){if(a){let w=this.b.get(a.id);return w||(w=new C.$Lg,this.b.set(a.id,w)),w}else return this.c}showMessageBox(a,w){return this.g(w).queue(async()=>{const{options:k,buttonIndeces:g}=(0,$.$oA)(a,this.e);let t;return w?t=await E.dialog.showMessageBox(w,k):t=await E.dialog.showMessageBox(k),{response:g[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(a,w){const k=this.j(a,w);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(w).queue(async()=>{let g;return w?g=await E.dialog.showSaveDialog(w,a):g=await E.dialog.showSaveDialog(a),g.filePath=this.h(g.filePath),g})}finally{(0,A.$hb)(k)}}h(a){return a&&f.$j&&(a=(0,S.$fl)(a)),a}i(a){return a.map(w=>this.h(w))}async showOpenDialog(a,w){a.defaultPath&&(await u.Promises.exists(a.defaultPath)||(a.defaultPath=void 0));const k=this.j(a,w);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(w).queue(async()=>{let g;return w?g=await E.dialog.showOpenDialog(w,a):g=await E.dialog.showOpenDialog(a),g.filePaths=this.i(g.filePaths),g})}finally{(0,A.$hb)(k)}}j(a,w){if(!w)return A.$mb.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",a);let k=this.a.get(w.id);k||(k=new Set,this.a.set(w.id,k));const g=(0,s.$ni)(a);if(!k.has(g))return this.d.trace("[DialogMainService]: new file dialog lock created",a),k.add(g),(0,A.$kb)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",a),k?.delete(g),k?.size===0&&this.a.delete(w.id)})}};e.$_4b=d,e.$_4b=d=ke([_(0,h.$3i),_(1,y.$ij)],d)}),define(te[275],ie([0,1,3,2,74,29]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=void 0;class A extends C.$mb{static{this.a=100}constructor(f,u){super(),this.f=f,this.g=u,this.b=this.B(new E.$hc),this.c=new Map,this.h(u.applicationStorage,this.b)}h(f,u){this.B(E.Event.debounce(f.onDidChangeStorage,(p,$)=>(p?p.push($):p=[$],p),A.a)(p=>{p.length&&u.fire(this.i(p,f))}))}i(f,u){const p=new Map,$=new Set;return f.forEach(v=>{const h=u.get(v.key);typeof h=="string"?p.set(v.key,h):$.add(v.key)}),{changed:Array.from(p.entries()),deleted:Array.from($.values())}}listen(f,u,p){switch(u){case"onDidChangeStorage":{const $=p.profile?(0,s.$9g)(p.profile):void 0;if(!$)return this.b.event;let v=this.c.get($.id);return v||(v=this.B(new E.$hc),this.h(this.g.profileStorage($),v),this.c.set($.id,v)),v.event}}throw new Error(`Event not found: ${u}`)}async call(f,u,p){const $=p.profile?(0,s.$9g)(p.profile):void 0,v=(0,M.$Ph)(p.workspace),h=await this.j($,v);switch(u){case"getItems":return Array.from(h.items.entries());case"updateItems":{const y=p;if(y.insert)for(const[b,d]of y.insert)h.set(b,d);y.delete?.forEach(b=>h.delete(b));break}case"optimize":return h.optimize();case"isUsed":{const y=p.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${u}`)}}async j(f,u){let p;u?p=this.g.workspaceStorage(u):f?p=this.g.profileStorage(f):p=this.g.applicationStorage;try{await p.init()}catch($){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":f?"profile":"application"} storage due to ${$}`)}return p}}e.$W5b=A}),define(te[41],ie([0,1,57,3,2,19,7,187,36,16,6,5,29,34,40,8,31,26,12]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.ProfileResourceType=void 0;var w;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(w||(e.ProfileResourceType=w={}));function k(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Bk=k,e.$Ck=(0,p.$zh)("IUserDataProfilesService");function g(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Dk=g;function t(i,n,o,m,I,D){return{id:i,name:n,location:o,isDefault:!1,shortName:I?.shortName,globalStorageHome:D&&I?.useDefaultFlags?.globalState?D.globalStorageHome:(0,M.$gg)(o,"globalStorage"),settingsResource:D&&I?.useDefaultFlags?.settings?D.settingsResource:(0,M.$gg)(o,"settings.json"),keybindingsResource:D&&I?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,M.$gg)(o,"keybindings.json"),tasksResource:D&&I?.useDefaultFlags?.tasks?D.tasksResource:(0,M.$gg)(o,"tasks.json"),snippetsHome:D&&I?.useDefaultFlags?.snippets?D.snippetsHome:(0,M.$gg)(o,"snippets"),extensionsResource:D&&I?.useDefaultFlags?.extensions?D.extensionsResource:(0,M.$gg)(o,"extensions.json"),cacheHome:(0,M.$gg)(m,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$Ek=t;let l=class extends s.$mb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,o,m,I){super(),this.n=n,this.r=o,this.s=m,this.t=I,this.f=!0,this.h=this.B(new C.$hc),this.onDidChangeProfiles=this.h.event,this.i=this.B(new C.$hc),this.onWillCreateProfile=this.i.event,this.j=this.B(new C.$hc),this.onWillRemoveProfile=this.j.event,this.k=this.B(new C.$hc),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$xi,emptyWindows:new Map},this.profilesHome=(0,M.$gg)(this.n.userRoamingDataHome,"profiles"),this.g=(0,M.$gg)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=this.w(),o=[n];if(this.f)try{for(const D of this.J()){if(!D.name||!(0,a.$le)(D.name)||!D.location){this.t.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(t((0,M.$dg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,useDefaultFlags:D.useDefaultFlags},n))}}catch(D){this.t.error(D)}const m=new h.$xi,I=new Map;if(o.length)try{const D=this.M();if(D.workspaces)for(const[P,R]of Object.entries(D.workspaces)){const j=A.URI.parse(P),T=o.find(z=>z.id===R);T&&m.set(j,T)}if(D.emptyWindows)for(const[P,R]of Object.entries(D.emptyWindows)){const j=o.find(T=>T.id===R);j&&I.set(P,j)}}catch(D){this.t.error(D)}this.u={profiles:o,workspaces:m,emptyWindows:I}}return this.u}w(){const n=t("__default__profile__",(0,S.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...n,extensionsResource:this.O()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",m=new RegExp(`${(0,c.$sd)(o)}\\s(\\d+)`);let I=0;for(const P of this.profiles){const R=m.exec(P.name),j=R?parseInt(R[1]):0;I=j>I?j:I}const D=`${o} ${I+1}`;return this.createProfile((0,E.$ni)((0,d.$6e)()).toString(16),D,{transient:!0},n)}async createNamedProfile(n,o,m){return this.createProfile((0,E.$ni)((0,d.$6e)()).toString(16),n,o,m)}async createProfile(n,o,m,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.y(n,o,m);return I&&await this.setProfileForWorkspace(I,D),D}async y(n,o,m){if(!(0,a.$le)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.l.get(o);return I||(I=(async()=>{try{const D=this.profiles.find(j=>j.name===o||j.id===n);if(D)return D;const P=t(n,o,(0,M.$gg)(this.profilesHome,n),this.g,m,this.defaultProfile);await this.r.createFolder(P.location);const R=[];return this.i.fire({profile:P,join(j){R.push(j)}}),await b.Promises.settled(R),this.D([P],[],[]),P}finally{this.l.delete(o)}})(),this.l.set(o,I)),I}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(I=>I.id===n.id);if(!m)throw new Error(`Profile '${n.name}' does not exist`);return m=t(m.id,o.name??m.name,m.location,this.g,{shortName:o.shortName??m.shortName,transient:o.transient??m.isTransient,useDefaultFlags:o.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.D([],[],[m]),m}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(I=>I.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const m=[];this.j.fire({profile:o,join(I){m.push(I)}});try{await Promise.allSettled(m)}catch(I){this.t.error(I)}for(const I of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(I)?.id&&this.v.emptyWindows.delete(I);for(const I of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(I)?.id&&this.v.workspaces.delete(I);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(I){(0,u.$hk)(I)!==1&&this.t.error(I)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(I=>I.id===o.id);if(!m)throw new Error(`Profile '${o.name}' does not exist`);this.G(n,m)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(m=>!this.s.extUri.isEqual(m.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.z(n);return A.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(n){return(0,v.$Jh)(n)?n.uri:(0,v.$Oh)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location)))}D(n,o,m){const I=[...this.profiles,...n],D=[];this.m.profiles=[];for(let P of I)P.isDefault||o.some(R=>P.id===R.id)||(P=m.find(R=>P.id===R.id)??P,P.isTransient?this.m.profiles.push(P):D.push({location:P.location,name:P.name,shortName:P.shortName,useDefaultFlags:P.useDefaultFlags}));this.L(D),this.u=void 0,this.F(n,o,m)}F(n,o,m){this.h.fire({added:n,removed:o,updated:m,all:this.profiles})}G(n,o,m){m=o?.isTransient?!0:m,m||this.G(n,void 0,!0);const I=this.z(n),D=m?this.m:this.v;A.URI.isUri(I)?(D.workspaces.delete(I),o&&D.workspaces.set(I,o)):(D.emptyWindows.delete(I),o&&D.emptyWindows.set(I,o)),m||this.H()}H(){const n={};for(const[m,I]of this.v.workspaces.entries())n[m.toString()]=I.id;const o={};for(const[m,I]of this.v.emptyWindows.entries())o[m.toString()]=I.id;this.N({workspaces:n,emptyWindows:o}),this.u=void 0}I(n){const o={},m=this.w();if(n.workspaces)for(const[D,P]of Object.entries(n.workspaces)){const R=A.URI.parse(P);o[D]=this.s.extUri.isEqual(R,m.location)?m.id:this.s.extUri.basename(R)}const I={};if(n.emptyWindows)for(const[D,P]of Object.entries(n.emptyWindows)){const R=A.URI.parse(P);I[D]=this.s.extUri.isEqual(R,m.location)?m.id:this.s.extUri.basename(R)}return{workspaces:o,emptyWindows:I}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};e.$Fk=l,e.$Fk=l=ke([_(0,f.$Gh),_(1,u.$4j),_(2,y.$Ak),_(3,$.$3i)],l);class r extends l{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.$Gk=r}),define(te[81],ie([0,1,8,17,2,3,34,7,116,123,16,6,5,41,40,12,14,25]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.ExtensionsProfileScanningErrorCode=void 0;var a;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(a||(e.ExtensionsProfileScanningErrorCode=a={}));class w extends Error{constructor(r,i){super(r),this.code=i}}e.$gp=w,e.$hp=(0,$.$zh)("IExtensionsProfileScannerService");let k=class extends s.$mb{constructor(r,i,n,o,m,I){super(),this.i=r,this.j=i,this.k=n,this.l=o,this.m=m,this.n=I,this.b=this.B(new M.$hc),this.onAddExtensions=this.b.event,this.c=this.B(new M.$hc),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$hc),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$hc),this.onDidRemoveExtensions=this.g.event,this.h=new A.$xi}scanProfileExtensions(r,i){return this.p(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],o=[];try{return await this.p(i,m=>{const I=[];for(const D of m)r.some(([P])=>(0,u.$no)(P.identifier,D.identifier)&&P.manifest.version!==D.version)?n.push(D):I.push(D);for(const[D,P]of r){const R=I.findIndex(T=>(0,u.$no)(T.identifier,D.identifier)&&T.version===D.manifest.version),j={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:P};R===-1?(o.push(j),I.push(j)):I.splice(R,1,j)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),I}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(m){throw o.length&&this.c.fire({extensions:o,error:m,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:m,profileLocation:i}),m}}async updateMetadata(r,i){const n=[];return await this.p(i,o=>{const m=[];for(const I of o){const D=r.find(([P])=>(0,u.$no)(P.identifier,I.identifier)&&P.manifest.version===I.version);D&&(I.metadata={...I.metadata,...D[1]},n.push(I)),m.push(I)}return m}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.p(i,o=>{const m=[];for(const I of o)(0,u.$no)(I.identifier,r.identifier)?n.push(I):m.push(I);return n.length&&this.f.fire({extensions:n,profileLocation:i}),m}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async p(r,i,n){return this.w(r).queue(async()=>{let o=[],m;try{const I=await this.j.readFile(r);m=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,p.$hk)(I)!==1)throw I;if(this.l.extUri.isEqual(r,this.k.defaultProfile.extensionsResource)&&(m=await this.v()),!m&&n?.bailOutWhenFileNotFound)throw new w((0,d.$8)(I),"ERROR_PROFILE_NOT_FOUND")}if(m){Array.isArray(m)||this.r(r);let I=!1;for(const D of m){g(D)||this.r(r);let P;if((0,b.$le)(D.relativeLocation)&&D.relativeLocation)P=this.t(D.relativeLocation);else if((0,b.$le)(D.location))P=this.t(D.location),I=!0,D.relativeLocation=D.location,D.location=P.toJSON();else{P=S.URI.revive(D.location);const R=this.s(P);R&&(I=!0,D.relativeLocation=R)}o.push({identifier:D.identifier,location:P,version:D.version,metadata:D.metadata})}I&&await this.j.writeFile(r,C.$Hc.fromString(JSON.stringify(m)))}if(i){o=i(o);const I=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.s(D.location),metadata:D.metadata}));await this.j.writeFile(r,C.$Hc.fromString(JSON.stringify(I)))}return o})}r(r){const i=new w(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(r){return this.l.extUri.isEqual(this.l.extUri.dirname(r),this.i)?this.l.extUri.basename(r):void 0}t(r){return this.l.extUri.joinPath(this.i,r)}async v(){return this.u||(this.u=(async()=>{const r=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(r)).value.toString()}catch(m){if((0,p.$hk)(m)===1)return;throw m}this.n.info("Migrating extensions from old default profile location",r.toString());let o;try{const m=JSON.parse(n);Array.isArray(m)&&m.every(I=>g(I))?o=m:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",m)}catch(m){this.n.error(m)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,C.$Hc.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",r.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(m){if((0,p.$hk)(m)===3)this.n.info("Migration from old default profile location to new location is done by another window",r.toString(),this.k.defaultProfile.extensionsResource.toString());else throw m}try{await this.j.del(r)}catch(m){(0,p.$hk)(m)!==1&&this.n.error(m)}try{await this.j.del(i)}catch(m){(0,p.$hk)(m)!==1&&this.n.error(m)}return o})()),this.u}w(r){let i=this.h.get(r);return i||(i=new E.$Lg,this.h.set(r,i)),i}};e.$ip=k,e.$ip=k=ke([_(1,p.$4j),_(2,h.$Ck),_(3,y.$Ak),_(4,c.$7k),_(5,v.$3i)],k);function g(l){return(0,b.$ne)(l)&&(0,f.$Wn)(l.identifier)&&(t(l.location)||(0,b.$le)(l.location)&&l.location)&&((0,b.$se)(l.relativeLocation)||(0,b.$le)(l.relativeLocation))&&l.version&&(0,b.$le)(l.version)}function t(l){return l?(0,b.$le)(l.path)&&(0,b.$le)(l.scheme):!1}}),define(te[129],ie([0,1,24,8,37,17,14,44,151,2,13,9,4,19,203,70,12,7,170,36,123,120,202,16,6,5,23,3,74,81,41,40,201]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g,t,l,r,i,n,o,m,I,D,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.Translations=void 0;var j;(function(ae){function J(Y,B){if(Y===B)return!0;const F=Object.keys(Y),U=new Set;for(const H of Object.keys(B))U.add(H);if(F.length!==U.size)return!1;for(const H of F){if(Y[H]!==B[H])return!1;U.delete(H)}return U.size===0}ae.equals=J})(j||(e.Translations=j={})),e.$lp=(0,r.$zh)("IExtensionsScannerService");let T=class extends u.$mb{constructor(J,Y,B,F,U,H,Q,x,oe,K,O,L){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=Y,this.l=B,this.m=F,this.n=U,this.r=H,this.s=Q,this.t=x,this.u=oe,this.v=K,this.w=O,this.y=L,this.g=this.B(new o.$hc),this.onDidChangeCache=this.g.event,this.h=(0,h.$gg)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ee,this.m,this.h)),this.j=this.B(this.y.createInstance(ee,this.m,this.h)),this.k=this.B(this.y.createInstance(ne,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,k.$yo)(this.s,this.t)),this.z}async scanAllExtensions(J,Y,B){const[F,U]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(Y)]),H=B?await this.scanExtensionsUnderDevelopment(J,[...F,...U]):[];return this.G(F,U,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const Y=[];Y.push(this.H(!!J.useCache,J.language)),Y.push(this.I(J.language,!!J.checkControlFile));const[B,F]=await Promise.all(Y);return this.F([...B,...F],0,J,!1)}async scanUserExtensions(J){const Y=J.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",Y);const B=this.w.extUri.isEqual(J.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.L(Y,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,B),U=J.useCache&&!F.devMode&&F.excludeObsolete?this.j:this.k;let H;try{H=await U.scanExtensions(F)}catch(Q){if(Q instanceof I.$gp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),H=await U.scanExtensions(F);else throw Q}return H=await this.F(H,1,J,!0),this.t.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(J,Y){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const B=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(F=>F.scheme===p.Schemas.file).map(async F=>{const U=await this.L(F,!1,1,!0,J.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(U)).map(Q=>(Q.type=Y.find(x=>(0,k.$no)(x.identifier,Q.identifier))?.type??Q.type,this.k.validate(Q,U)))}))).flat();return this.F(B,"development",J,!0)}return[]}async scanExistingExtension(J,Y,B){const F=await this.L(J,!1,Y,!0,B.language,!0,void 0),U=await this.k.scanExtension(F);return!U||!B.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(J,Y,B){const F=await this.L(J,!1,Y,!0,B.language,!0,void 0),U=await this.k.scanOneOrMultipleExtensions(F);return this.F(U,Y,B,!0)}async scanMetadata(J){const Y=(0,h.$gg)(J,"package.json"),B=(await this.s.readFile(Y)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(J,Y){const B=(0,h.$gg)(J,"package.json"),F=(await this.s.readFile(B)).value.toString(),U=JSON.parse(F);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,U.__metadata={...U.__metadata,...Y},await this.s.writeFile((0,h.$gg)(J,"package.json"),M.$Hc.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof I.$gp&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw J}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.r.addExtensionsToProfile(J.map(Y=>[Y,Y.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,M.$Hc.fromString(JSON.stringify([])))}catch(Y){(0,l.$hk)(Y)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$8)(Y))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.t.error(J)}finally{this.C=void 0}})()),this.C}async F(J,Y,B,F){return B.includeAllVersions||(J=this.G(Y===0?J:void 0,Y===1?J:void 0,Y==="development"?J:void 0,await this.getTargetPlatform(),F)),B.includeInvalid||(J=J.filter(U=>U.isValid)),J.sort((U,H)=>{const Q=$.$cd(U.location.fsPath),x=$.$cd(H.location.fsPath);return Q<x?-1:Q>x?1:0})}G(J,Y,B,F,U){const H=(x,oe,K)=>{if(x.isValid&&!oe.isValid)return!1;if(x.isValid===oe.isValid){if(U&&y.gt(x.manifest.version,oe.manifest.version))return this.t.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(y.eq(x.manifest.version,oe.manifest.version)){if(x.type===0)return this.t.debug(`Skipping extension ${oe.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===F)return this.t.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return K?this.t.warn(`Overwriting user extension ${x.location.path} with ${oe.location.path}.`):this.t.debug(`Overwriting user extension ${x.location.path} with ${oe.location.path}.`),!0},Q=new g.$Vl;return J?.forEach(x=>{const oe=Q.get(x.identifier.id);(!oe||H(oe,x,!1))&&Q.set(x.identifier.id,x)}),Y?.forEach(x=>{const oe=Q.get(x.identifier.id);if(!oe&&J&&x.type===0){this.t.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!oe||H(oe,x,!1))&&Q.set(x.identifier.id,x)}),B?.forEach(x=>{const oe=Q.get(x.identifier.id);(!oe||H(oe,x,!0))&&Q.set(x.identifier.id,x),Q.set(x.identifier.id,x)}),[...Q.values()]}async H(J,Y){this.t.trace("Started scanning system extensions");const B=await this.L(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),U=await(J&&!B.devMode?this.i:this.k).scanExtensions(B);return this.t.trace("Scanned system extensions:",U.length),U}async I(J,Y){const B=this.u.isBuilt?[]:this.v.builtInExtensions;if(!B?.length)return[];this.t.trace("Started scanning dev system extensions");const F=Y?await this.J():{},U=[],H=c.URI.file($.$9c($.$$c(p.$4e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of B){const oe=F[x.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":U.push((0,h.$gg)(H,x.name));break;default:U.push(c.URI.file(oe));break}}const Q=await Promise.all(U.map(async x=>this.k.scanExtension(await this.L(x,!1,0,!0,J,!0,void 0))));return this.t.trace("Scanned dev system extensions:",Q.length),(0,E.$Af)(Q)}async J(){try{const J=await this.s.readFile(this.l);return JSON.parse(J.value.toString())}catch{return{}}}async L(J,Y,B,F,U,H,Q){const x=await this.f(U??v.$v),oe=await this.M(J),K=Y&&!this.w.extUri.isEqual(J,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,O=K?await this.M(K):void 0;return new z(J,oe,K,O,Y,Q,B,F,H,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,U,x)}async M(J){try{const Y=await this.s.stat(J);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$mp=T,e.$mp=T=ke([_(4,D.$Ck),_(5,I.$hp),_(6,l.$4j),_(7,i.$3i),_(8,w.$Gh),_(9,n.$ij),_(10,P.$Ak),_(11,r.$yh)],T);class z{constructor(J,Y,B,F,U,H,Q,x,oe,K,O,L,N,W,q){this.location=J,this.mtime=Y,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=F,this.profile=U,this.profileScanOptions=H,this.type=Q,this.excludeObsolete=x,this.validate=oe,this.productVersion=K,this.productDate=O,this.productCommit=L,this.devMode=N,this.language=W,this.translations=q}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,Y){return(0,h.$_f)(J.location,Y.location)&&J.mtime===Y.mtime&&(0,h.$_f)(J.applicationExtensionslocation,Y.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&J.profile===Y.profile&&s.$Xm(J.profileScanOptions,Y.profileScanOptions)&&J.type===Y.type&&J.excludeObsolete===Y.excludeObsolete&&J.validate===Y.validate&&J.productVersion===Y.productVersion&&J.productDate===Y.productDate&&J.productCommit===Y.productCommit&&J.devMode===Y.devMode&&J.language===Y.language&&j.equals(J.translations,Y.translations)}}e.$np=z;let ne=class extends u.$mb{constructor(J,Y,B,F,U){super(),this.f=J,this.g=Y,this.h=B,this.i=F,this.j=U}async scanExtensions(J){const Y=J.profile?await this.l(J):await this.k(J);let B={};if(J.excludeObsolete&&J.type===1)try{const F=(await this.i.readFile(this.f)).value.toString();B=JSON.parse(F)}catch{}return(0,d.$ye)(B)?Y:Y.filter(F=>!B[k.$oo.create(F).toString()])}async k(J){const Y=await this.i.resolve(J.location);if(!Y.children?.length)return[];const B=await Promise.all(Y.children.map(async F=>{if(!F.isDirectory||J.type===1&&(0,h.$dg)(F.resource).indexOf(".")===0)return null;const U=new z(F.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(U)}));return(0,E.$Af)(B).sort((F,U)=>F.location.path<U.location.path?-1:1)}async l(J){let Y=await this.m(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){Y=Y.filter(F=>!F.metadata?.isApplicationScoped);const B=await this.m(J.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,J);Y.push(...B)}return Y}async m(J,Y,B){const F=await this.g.scanProfileExtensions(J,B.profileScanOptions);if(!F.length)return[];const U=await Promise.all(F.map(async H=>{if(Y(H)){const Q=new z(H.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Q,H.metadata)}return null}));return(0,E.$Af)(U)}async scanOneOrMultipleExtensions(J){try{if(await this.i.exists((0,h.$gg)(J.location,"package.json"))){const Y=await this.scanExtension(J);return Y?[Y]:[]}else return await this.scanExtensions(J)}catch(Y){return this.j.error(`Error scanning extensions at ${J.location.path}:`,(0,A.$8)(Y)),[]}}async scanExtension(J,Y){try{let B=await this.scanExtensionManifest(J.location);if(B){B.publisher||(B.publisher=g.$Pl),Y=Y??B.__metadata,delete B.__metadata;const F=(0,k.$so)(B.publisher,B.name),U=Y?.id?{id:F,uuid:Y.id}:{id:F},H=Y?.isSystem?0:J.type,Q=H===0||!!Y?.isBuiltin;B=await this.n(J.location,B,z.createNlsConfiguration(J));const x={type:H,identifier:U,manifest:B,location:J.location,isBuiltin:Q,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return J.validate?this.validate(x,J):x}}catch(B){J.type!==0&&this.j.error(B)}return null}validate(J,Y){let B=!0;const F=(0,t.$Do)(Y.productVersion,Y.productDate,Y.location,J.manifest,J.isBuiltin);for(const[U,H]of F)U===b.default.Error&&(B=!1,this.j.error(this.u(Y.location,H)));return J.isValid=B,J.validations=F,J}async scanExtensionManifest(J){const Y=(0,h.$gg)(J,"package.json");let B;try{B=(await this.i.readFile(Y)).value.toString()}catch(U){return(0,l.$hk)(U)!==1&&this.j.error(this.u(J,(0,a.localize)(0,null,Y.path,U.message))),null}let F;try{F=JSON.parse(B)}catch{const H=[];(0,S.$Jm)(B,H);for(const Q of H)this.j.error(this.u(J,(0,a.localize)(1,null,Y.path,Q.offset,Q.length,(0,f.$jp)(Q.error))));return null}return(0,S.$Sm)(F)!=="object"?(this.j.error(this.u(J,(0,a.localize)(2,null,Y.path))),null):F}async n(J,Y,B){const F=await this.r(J,Y,B);if(F)try{const U=[],H=await this.s(F.default,U);if(U.length>0)return U.forEach(x=>{this.j.error(this.u(J,(0,a.localize)(3,null,F.default?.path,(0,f.$jp)(x.error))))}),Y;if((0,S.$Sm)(F)!=="object")return this.j.error(this.u(J,(0,a.localize)(4,null,F.default?.path))),Y;const Q=F.values||Object.create(null);return(0,R.$kp)(Y,Q,H)}catch{}return Y}async r(J,Y,B){const F=(0,h.$gg)(J,"package.nls.json"),U=(oe,K)=>{K.forEach(O=>{this.j.error(this.u(J,(0,a.localize)(5,null,oe?.path,(0,f.$jp)(O.error))))})},H=oe=>{this.j.error(this.u(J,(0,a.localize)(6,null,oe?.path)))},Q=`${Y.publisher}.${Y.name}`,x=B.translations[Q];if(x)try{const oe=c.URI.file(x),K=(await this.i.readFile(oe)).value.toString(),O=[],L=(0,S.$Jm)(K,O);return O.length>0?(U(oe,O),{values:void 0,default:F}):(0,S.$Sm)(L)!=="object"?(H(oe),{values:void 0,default:F}):{values:L.contents?L.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.i.exists(F))return;let K;try{K=await this.t(J,B)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const O=(await this.i.readFile(K.localized)).value.toString(),L=[],N=(0,S.$Jm)(O,L);return L.length>0?(U(K.localized,L),{values:void 0,default:K.original}):(0,S.$Sm)(N)!=="object"?(H(K.localized),{values:void 0,default:K.original}):{values:N,default:K.original}}catch{return{values:void 0,default:K.original}}}}async s(J,Y){if(J)try{const B=(await this.i.readFile(J)).value.toString();return(0,S.$Jm)(B,Y)}catch{}}t(J,Y){return new Promise((B,F)=>{const U=H=>{const Q=(0,h.$gg)(J,`package.nls.${H}.json`);this.i.exists(Q).then(x=>{x&&B({localized:Q,original:(0,h.$gg)(J,"package.nls.json")});const oe=H.lastIndexOf("-");oe===-1?B({localized:(0,h.$gg)(J,"package.nls.json"),original:null}):(H=H.substring(0,oe),U(H))})};if(Y.devMode||Y.pseudo||!Y.language)return B({localized:(0,h.$gg)(J,"package.nls.json"),original:null});U(Y.language)})}u(J,Y){return`[${J.path}]: ${Y}`}};ne=ke([_(1,I.$hp),_(2,P.$Ak),_(3,l.$4j),_(4,i.$3i)],ne);let ee=class extends ne{constructor(J,Y,B,F,U,H,Q){super(Y,F,U,H,Q),this.z=J,this.C=B,this.w=this.B(new C.$Cg(3e3)),this.y=this.B(new o.$hc),this.onDidChangeCache=this.y.event}async scanExtensions(J){const Y=this.H(J),B=await this.D(Y);if(this.v=J,B&&B.input&&z.equals(B.input,this.v))return this.j.debug("Using cached extensions scan result",J.location.toString()),this.w.trigger(()=>this.G()),B.result.map(U=>(U.location=c.URI.revive(U.location),U));const F=await super.scanExtensions(J);return await this.F(Y,{input:J,result:F}),F}async D(J){try{const Y=await this.i.readFile(J),B=JSON.parse(Y.value.toString());return{result:B.result,input:(0,m.$9g)(B.input)}}catch(Y){this.j.debug("Error while reading the extension cache file:",J.path,(0,A.$8)(Y))}return null}async F(J,Y){try{await this.i.writeFile(J,M.$Hc.fromString(JSON.stringify(Y)))}catch(B){this.j.debug("Error while writing the extension cache file:",J.path,(0,A.$8)(B))}}async G(){if(!this.v)return;const J=this.H(this.v),Y=await this.D(J);if(!Y)return;const B=Y.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!s.$Xm(F,B))try{this.j.info("Invalidating Cache",B,F),await this.i.del(J),this.y.fire()}catch(U){this.j.error(U)}}H(J){const Y=this.I(J);return this.h.extUri.joinPath(Y.cacheHome,J.type===0?g.$Ol:g.$Nl)}I(J){return J.type===0?this.C.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.z.extensionsResource)?this.z:this.C.profiles.find(Y=>this.h.extUri.isEqual(J.location,Y.extensionsResource))??this.z:this.C.defaultProfile}};ee=ke([_(2,D.$Ck),_(3,I.$hp),_(4,P.$Ak),_(5,l.$4j),_(6,i.$3i)],ee);function ce(ae,J){const Y=(0,k.$qo)(ae.manifest.publisher,ae.manifest.name);return{id:Y,identifier:new g.$Tl(Y),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:J,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$op=ce;class se extends T{constructor(J,Y,B,F,U,H,Q,x,oe,K,O,L){super(J,Y,(0,h.$gg)(B,".vscode-oss-dev","extensions","control.json"),F,U,H,Q,x,oe,K,O,L),this.N=(async()=>{if(v.$y)try{const N=await this.s.readFile(c.URI.file(v.$y));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(J){return this.N}}e.$pp=se}),define(te[276],ie([0,1,5,41,40,25,81,16,36,7]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=void 0;let p=class extends A.$ip{constructor(v,h,y,b,d,c){super(u.URI.file(v.extensionsPath),h,y,b,d,c)}};e.$cN=p,e.$cN=p=ke([_(0,f.$Hh),_(1,S.$4j),_(2,C.$Ck),_(3,s.$Ak),_(4,M.$7k),_(5,E.$3i)],p)}),define(te[277],ie([0,1,7,36,81,129,16,6,5,23,40,41]),function(G,e,E,C,s,M,A,S,f,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0;let v=class extends M.$pp{constructor(y,b,d,c,a,w,k,g){super(E.URI.file(a.builtinExtensionsPath),E.URI.file(a.extensionsPath),a.userHome,y.defaultProfile,y,b,d,c,a,w,k,g)}};e.$l6b=v,e.$l6b=v=ke([_(0,$.$Ck),_(1,s.$hp),_(2,A.$4j),_(3,f.$3i),_(4,C.$Hh),_(5,u.$ij),_(6,p.$Ak),_(7,S.$yh)],v)}),define(te[278],ie([0,1,15,2,13,9,4,58,7,31,38,36,5,41]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;let y=class extends C.$mb{constructor(d,c,a){super(),this.c=d,this.f=a,this.a=S.$Fh.forPaths(!A.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(d.appRoot),this.addValidFileRoot(d.extensionsPath),this.addValidFileRoot(c.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(d.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:d}=E.session;d.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(c,a)=>this.i(c,a)),d.protocol.interceptFileProtocol(s.Schemas.file,(c,a)=>this.h(c,a)),this.B((0,C.$kb)(()=>{d.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(d){const c=(0,M.$9c)(d);return this.a.get(c)?C.$mb.None:(this.a.set(c,!0),(0,C.$kb)(()=>this.a.delete(c)))}h(d,c){const a=f.URI.parse(d.url);return this.f.error(`Refused to load resource ${a.fsPath} from ${s.Schemas.file}: protocol (original URL: ${d.url})`),c({error:-3})}i(d,c){const a=this.j(d);let w;return this.c.crossOriginIsolated&&((0,M.$cd)(a)==="workbench.html"||(0,M.$cd)(a)==="workbench-dev.html"?w=s.COI.CoopAndCoep:w=s.COI.getHeadersFromQuery(d.url)),this.a.findSubstr(a)?c({path:a,headers:w}):this.b.has((0,M.$dd)(a).toLowerCase())?c({path:a}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${a} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),c({error:-3}))}j(d){const c=f.URI.parse(d.url),a=s.$4e.uriToFileUri(c);return(0,M.$9c)(a.fsPath)}createIPCObjectUrl(){let d;const c=f.URI.from({scheme:"vscode",path:(0,u.$6e)()}),a=c.toString(),w=async()=>d;return p.$FS.handle(a,w),this.f.trace(`IPC Object URL: Registered new channel ${a}.`),{resource:c,update:k=>d=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${a}.`),p.$FS.removeHandler(a)}}}};e.$A6b=y,e.$A6b=y=ke([_(0,$.$Hh),_(1,h.$Ck),_(2,v.$3i)],y)}),define(te[96],ie([0,1,8,3,2,65,12,111,6,41]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$So=e.$Ro=e.$Qo=void 0,e.$Qo="__$__isNewStorageMarker",e.$Ro="__$__targetStorageMarker",e.$So=(0,f.$zh)("storageService");var p;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var $;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})($||(e.StorageScope=$={}));var v;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function h(a){const w=a.get(e.$Ro);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.$To=h;class y extends s.$mb{static{this.a=60*1e3}constructor(w={flushInterval:y.a}){super(),this.j=w,this.b=this.B(new C.$kc),this.c=this.B(new C.$kc),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$hc),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Qg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new s.$nb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(w,k,g){return C.Event.filter(this.b.event,t=>t.scope===w&&(k===void 0||t.key===k),g)}k(){this.i.value=(0,E.$Ug)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,s.$hb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.J()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(w,k){const{key:g,external:t}=k;if(g===e.$Ro){switch(w){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:g,target:this.F(w)[g],external:t})}r(w){this.f.fire({reason:w})}get(w,k,g){return this.L(k)?.get(w,g)}getBoolean(w,k,g){return this.L(k)?.getBoolean(w,g)}getNumber(w,k,g){return this.L(k)?.getNumber(w,g)}getObject(w,k,g){return this.L(k)?.getObject(w,g)}storeAll(w,k){this.t(()=>{for(const g of w)this.store(g.key,g.value,g.scope,g.target,k)})}store(w,k,g,t,l=!1){if((0,A.$ue)(k)){this.remove(w,g,l);return}this.t(()=>{this.u(w,g,t),this.L(g)?.set(w,k,l)})}remove(w,k,g=!1){this.t(()=>{this.u(w,k,void 0),this.L(k)?.delete(w,g)})}t(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,k){const g=[],t=this.F(w);for(const l of Object.keys(t))t[l]===k&&g.push(l);return g}u(w,k,g,t=!1){const l=this.F(k);typeof g=="number"?l[w]!==g&&(l[w]=g,this.L(k)?.set(e.$Ro,JSON.stringify(l),t)):typeof l[w]=="number"&&(delete l[w],this.L(k)?.set(e.$Ro,JSON.stringify(l),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(w){switch(w){case-1:return this.D;case 0:return this.z;default:return this.w}}G(w){const k=this.L(w);return k?h(k):Object.create(null)}isNew(w){return this.getBoolean(e.$Qo,w)===!0}async flush(w=p.NONE){this.f.fire({reason:w});const k=this.L(-1),g=this.L(0),t=this.L(1);switch(w){case p.NONE:await E.Promises.settled([k?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await E.Promises.settled([k?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.L(-1)?.items??new Map,k=this.L(0)?.items??new Map,g=this.L(1)?.items??new Map;return c(w,k,g,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async optimize(w){return await this.flush(),this.L(w)?.optimize()}async switch(w,k){return this.r(p.NONE),(0,u.$Bk)(w)?this.N(w,k):this.O(w,k)}H(w,k){return!(w.id===k.id||b(k)&&b(w))}I(w,k,g){this.t(()=>{const t=new Set;for(const[l,r]of w)t.add(l),k.get(l)!==r&&this.n(g,{key:l,external:!0});for(const[l]of k.items)t.has(l)||this.n(g,{key:l,external:!0})})}}e.$Uo=y;function b(a){return a.isDefault||!!a.useDefaultFlags?.globalState}e.$Vo=b;class d extends y{constructor(){super(),this.p=this.B(new S.$Oo(new S.$Po,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new S.$Oo(new S.$Po,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new S.$Oo(new S.$Po,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(w=>this.n(1,w))),this.B(this.P.onDidChangeStorage(w=>this.n(0,w))),this.B(this.p.onDidChangeStorage(w=>this.n(-1,w)))}L(w){switch(w){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(w){return!1}}e.$Wo=d;async function c(a,w,k,g,t,l){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;a.forEach((j,T)=>{i.set(T,j),n.set(T,r(j))});const o=new Map,m=new Map;w.forEach((j,T)=>{o.set(T,j),m.set(T,r(j))});const I=new Map,D=new Map;k.forEach((j,T)=>{I.set(T,j),D.set(T,r(j))}),console.group(g!==t?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const P=[];if(i.forEach((j,T)=>{P.push({key:T,value:j})}),console.table(P),console.groupEnd(),console.log(n),g!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];o.forEach((T,z)=>{j.push({key:z,value:T})}),console.table(j),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${l})`);const R=[];I.forEach((j,T)=>{R.push({key:T,value:j})}),console.table(R),console.groupEnd(),console.log(D)}e.$Xo=c}),define(te[279],ie([0,1,24,8,3,2,9,69,7,21,111,159,5,96,25,29,13]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R4b=e.$Q4b=e.$P4b=e.$O4b=void 0;class c extends M.$mb{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.j=r,this.k=i,this.b=this.B(new s.$hc),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$hc),this.onDidCloseStorage=this.c.event,this.f=this.B(new p.$Oo(new p.$Po,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new C.$Zg,this.whenInit=this.h.p,this.i=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===p.StorageState.None)try{const r=this.B(await this.n());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.m(r);const i=r.getBoolean(h.$Qo);i===void 0?r.set(h.$Qo,!0):i&&r.set(h.$Qo,!1)}catch(r){this.j.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.i=p.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===v.LogLevel.Trace?r=>this.j.trace(r):void 0,logError:r=>this.j.error(r)}}m(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$dc(!1);await this.s(),r.stop(),r.elapsed()>c.a&&await this.r(r),this.c.fire()}async r(r){if(this.path)try{const i=(0,E.top)(Array.from(this.f.items.entries()).map(([o,m])=>({key:o,length:m.length})),(o,m)=>m.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=p.StorageState.Closed,await this.f.close()}}class a extends c{static{this.t="state.vscdb"}get path(){if(!this.v.useInMemoryStorage)return(0,A.$$c)(this.u.globalStorageHome.with({scheme:d.Schemas.file}).fsPath,a.t)}constructor(r,i,n,o){super(n,o),this.u=r,this.v=i}async n(){return new p.$Oo(new $.$_S(this.path??$.$_S.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}class w extends a{constructor(r,i,n,o){super(r,i,n,o)}}e.$O4b=w;class k extends a{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async m(r){await super.m(r),this.z(r)}z(r){r.get(y.$0k,void 0)===void 0&&r.set(y.$0k,new Date().toUTCString());const n=r.get(y.$9k,void 0),o=new Date().toUTCString();r.set(y.$$k,typeof n>"u"?null:n),r.set(y.$9k,o)}}e.$P4b=k;class g extends c{static{this.t="state.vscdb"}static{this.u="workspace.json"}get path(){if(!this.w.useInMemoryStorage)return(0,A.$$c)(this.y.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,this.v.id,g.t)}constructor(r,i,n,o,m){super(n,m),this.v=r,this.w=i,this.y=o}async n(){const{storageFilePath:r,wasCreated:i}=await this.C();return new p.$Oo(new $.$_S(r,{logging:this.l()}),{hint:this.w.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:$.$_S.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.$$c)(this.y.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,this.v.id),i=(0,A.$$c)(r,g.t);return await u.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await u.Promises.mkdir(r,{recursive:!0}),this.D(r),{storageFilePath:i,wasCreated:!0})}async D(r){let i;if((0,b.$Jh)(this.v)?i={folder:this.v.uri.toString()}:(0,b.$Oh)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const n=(0,A.$$c)(r,g.u);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$Q4b=g;class t extends c{get path(){}async n(){return new p.$Oo(new p.$Po,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.$R4b=t}),define(te[280],ie([0,1,3,2,96]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=void 0;class M extends C.$mb{constructor(S,f,u){super(),this.b=S,this.c=f,this.f=u;const p=this.B(new C.$nb);this.a=this.B(new E.$hc({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new C.$lb;return S.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,u)=>(f?f.push(u.key):f=[u.key],f),100)(f=>this.h(f))),S.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(f,u)=>{f||(f=new Map);let p=f.get(u.profile.id);return p||f.set(u.profile.id,p={profile:u.profile,keys:[],storage:u.storage}),p.keys.push(u.key),f},100)(f=>this.i(f))),S}h(S){const f=S.includes(s.$Ro)?[this.c.defaultProfile]:[],u=[];if(S=S.filter(p=>p!==s.$Ro),S.length){const p=(0,s.$To)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:S.map($=>({key:$,scope:0,target:p[$]}))})}this.j(f,u)}i(S){const f=[],u=new Map;for(const[p,$]of S.entries()){$.keys.includes(s.$Ro)&&f.push($.profile);const v=$.keys.filter(h=>h!==s.$Ro);if(v.length){const h=(0,s.$To)($.storage.storage);u.set(p,{profile:$.profile,changes:v.map(y=>({key:y,scope:0,target:h[y]}))})}}this.j(f,[...u.values()])}j(S,f){(S.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:S})}listen(S,f,u){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(S,f){throw new Error(`Call not found: ${f}`)}}e.$n6b=M}),define(te[281],ie([0,1,7,36,16,5,33,40,41,12,121]),function(G,e,E,C,s,M,A,S,f,u,p){"use strict";var $,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=e.$_M=void 0;let h=class extends f.$Fk{static{$=this}static{this.a="profileAssociationsMigration"}constructor(c,a,w,k,g){super(w,k,a,g),this.P=c,this.Q=w}J(){return this.P.getItem($.b,[]).map(a=>({...a,location:(0,u.$le)(a.location)?this.s.extUri.joinPath(this.profilesHome,a.location):E.URI.revive(a.location)}))}M(){const c=this.P.getItem($.c,{});return this.P.getItem($.a,!1)?c:this.I(c)}O(){return this.s.extUri.joinPath(E.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$_M=h,e.$_M=h=$=ke([_(0,A.$7M),_(1,S.$Ak),_(2,C.$Hh),_(3,s.$4j),_(4,M.$3i)],h);let y=v=class extends h{constructor(c,a,w,k,g){super(c,a,w,k,g),this.W=c}L(c){c.length?this.W.setItem(v.b,c.map(a=>({...a,location:this.s.extUri.basename(a.location)}))):this.W.removeItem(v.b)}J(){const c=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(c),this.W.setItem("userDataProfilesMigration",!0)),c}N(c){c.emptyWindows||c.workspaces?this.W.setItem(v.c,c):this.W.removeItem(v.c)}M(){const c="workspaceAndProfileInfo",a=this.W.getItem(c,void 0);if(a){this.W.removeItem(c);const k=a.reduce((g,{workspace:t,profile:l})=>(g[E.URI.revive(t).toString()]=E.URI.revive(l).toString(),g),{});this.W.setItem(v.c,{workspaces:k})}const w=super.M();return this.W.getItem(v.a,!1)||(this.N(w),this.W.setItem(v.a,!0)),w}};e.$aN=y,e.$aN=y=v=ke([_(0,A.$8M),_(1,S.$Ak),_(2,C.$Hh),_(3,s.$4j),_(4,M.$3i)],y);let b=class extends y{constructor(c,a,w,k){super(new p.$$M(0,a,k,w),c,a,w,k)}async init(){return await this.W.init(),super.init()}};e.$bN=b,e.$bN=b=ke([_(0,S.$Ak),_(1,C.$Hh),_(2,s.$4j),_(3,M.$3i)],b)}),define(te[53],ie([0,1,36,16,6,5,40,41,281,33]),function(G,e,E,C,s,M,A,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T4b=e.$S4b=void 0,e.$S4b=(0,s.$Ah)(S.$Ck);let p=class extends f.$aN{constructor(v,h,y,b,d){super(v,h,y,b,d)}getAssociatedEmptyWindows(){const v=[];for(const h of this.v.emptyWindows.keys())v.push({id:h});return v}};e.$T4b=p,e.$T4b=p=ke([_(0,u.$8M),_(1,A.$Ak),_(2,E.$Hh),_(3,C.$4j),_(4,M.$3i)],p)}),define(te[130],ie([0,1,19,7,29]),function(G,e,E,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c5b=e.$b5b=e.$a5b=void 0;async function M(f,u,p){for(const v of f){const h=v.openedWorkspace;if((0,s.$Oh)(h)){const y=await p(h);if(y){if(y.folders.some(b=>E.$0f.isEqualOrParent(u,b.uri)))return v}else if(E.$0f.isEqualOrParent(u,h.configPath))return v}}const $=f.filter(v=>(0,s.$Jh)(v.openedWorkspace)&&E.$0f.isEqualOrParent(u,v.openedWorkspace.uri));if($.length)return $.sort((v,h)=>-(v.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.$a5b=M;function A(f,u){for(const p of f)if((0,s.$Oh)(p.openedWorkspace)&&E.$0f.isEqual(p.openedWorkspace.configPath,u)||(0,s.$Jh)(p.openedWorkspace)&&E.$0f.isEqual(p.openedWorkspace.uri,u))return p}e.$b5b=A;function S(f,u){const p=$=>u.some(v=>E.$0f.isEqual(C.URI.file(v),C.URI.file($)));for(const $ of f)if($.config?.extensionDevelopmentPath?.some(v=>p(v)))return $}e.$c5b=S}),define(te[97],ie([0,1,32,44,137,46,13,9,4,19,7,6,60,29]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aU=e.$_T=e.$$T=e.$0T=e.$9T=e.$8T=e.$7T=e.$6T=e.$5T=e.$4T=void 0,e.$4T=(0,$.$zh)("workspacesService");function y(D){return D.hasOwnProperty("workspace")}e.$5T=y;function b(D){return D.hasOwnProperty("folderUri")}e.$6T=b;function d(D){return D.hasOwnProperty("fileUri")}e.$7T=d;function c(D){return a(D)||w(D)}e.$8T=c;function a(D){const P=D;return typeof P?.path=="string"&&(!P.name||typeof P.name=="string")}function w(D){const P=D;return typeof P?.uri=="string"&&(!P.name||typeof P.name=="string")}function k(D,P,R,j,T){if(D.scheme!==j.scheme)return{name:R,uri:D.toString(!0)};let z=P?void 0:T.relativePath(j,D);if(z!==void 0)z.length===0?z=".":f.$i&&(z=g(z));else if(D.scheme===A.Schemas.file)z=D.fsPath,f.$i&&(z=g(z));else if(T.isEqualAuthority(D.authority,j.authority))z=D.path;else return{name:R,uri:D.toString(!0)};return{name:R,path:z}}e.$9T=k;function g(D){return D=(0,M.$bA)(D),(0,E.$He)(D)||(D=(0,E.$Ee)(D)),D}function t(D,P,R){const j=[],T=new Set,z=R.dirname(P);for(const ne of D){let ee;if(a(ne))ne.path&&(ee=R.resolvePath(z,ne.path));else if(w(ne))try{ee=p.URI.parse(ne.uri),ee.path[0]!==S.$8c.sep&&(ee=ee.with({path:S.$8c.sep+ee.path}))}catch(ce){console.warn(ce)}if(ee){const ce=R.getComparisonKey(ee);if(!T.has(ce)){T.add(ce);const se=ne.name||R.basenameOrAuthority(ee);j.push(new h.$Th({uri:ee,name:se,index:j.length},ne))}}}return j}e.$0T=t;function l(D,P,R,j,T){const z=r(P,D),ne=T.dirname(P),ee=T.dirname(j),ce=[];for(const Y of z.folders){const B=a(Y)?T.resolvePath(ne,Y.path):p.URI.parse(Y.uri);let F;R?F=!1:F=!a(Y)||(0,S.$0c)(Y.path),ce.push(k(B,F,Y.name,ee,T))}const se={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},ae=s.$pS(D,["folders"],ce,se);let J=s.$sS(D,ae);return(0,u.$lg)(z.remoteAuthority,(0,v.$Mk)(j))&&(J=s.$sS(J,s.$oS(J,["remoteAuthority"],se))),J}e.$$T=l;function r(D,P){const R=C.$Jm(P);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(j=>c(j));else throw new Error(`${D} looks like an invalid workspace file.`);return R}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function n(D){return typeof D.folderUri=="string"}function o(D){return typeof D.fileUri=="string"}function m(D,P){const R={workspaces:[],files:[]};if(D){const j=function(z,ne){for(let ee=0;ee<z.length;ee++)try{ne(z[ee],ee)}catch(ce){P.warn(`Error restoring recent entry ${JSON.stringify(z[ee])}: ${ce.toString()}. Skip entry.`)}},T=D;Array.isArray(T.entries)&&j(T.entries,z=>{const ne=z.label,ee=z.remoteAuthority;i(z)?R.workspaces.push({label:ne,remoteAuthority:ee,workspace:{id:z.workspace.id,configPath:p.URI.parse(z.workspace.configPath)}}):n(z)?R.workspaces.push({label:ne,remoteAuthority:ee,folderUri:p.URI.parse(z.folderUri)}):o(z)&&R.files.push({label:ne,remoteAuthority:ee,fileUri:p.URI.parse(z.fileUri)})})}return R}e.$_T=m;function I(D){const P={entries:[]};for(const R of D.workspaces)b(R)?P.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):P.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of D.files)P.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return P}e.$aU=I}),define(te[98],ie([0,1,72,13,4,19]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$84b=e.$74b=e.$64b=e.$54b=void 0,e.$54b=128/4;function A(u){function p(){let $=u.scheme===C.Schemas.file?(0,M.$7f)(u):u.toString();return s.$k||($=$.toLowerCase()),(0,E.createHash)("md5").update($).digest("hex")}return{id:p(),configPath:u}}e.$64b=A;function S(u,p){function $(){if(u.scheme!==C.Schemas.file)return(0,E.createHash)("md5").update(u.toString()).digest("hex");if(!p)return;let h;return s.$k?h=p.ino:s.$j?h=p.birthtime.getTime():s.$i&&(typeof p.birthtimeMs=="number"?h=Math.floor(p.birthtimeMs):h=p.birthtime.getTime()),(0,E.createHash)("md5").update(u.fsPath).update(h?String(h):"").digest("hex")}const v=$();if(typeof v=="string")return{id:v,uri:u}}e.$74b=S;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$84b=f}),define(te[99],ie([0,1,72,87,27,282,17,14,3,2,9,4,31,42,109]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;class b{traceSocketEvent(P,R){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,R)}constructor(P,R=""){this.f=!0,this.debugLabel=R,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,S.$Y)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(P){const R=j=>{this.traceSocketEvent("read",j),P(A.$Hc.wrap(j))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(P){const R=j=>{P({type:0,hadError:j,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(P){const R=()=>{P()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(P){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,S.$Y)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,S.$Y)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$oh=b;var d;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var c;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(c||(c={}));class a extends u.$mb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(P,R){this.socket.traceSocketEvent(P,R)}constructor(P,R,j,T){super(),this.f=this.B(new f.$hc),this.g=this.B(new f.$hc),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:j?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new w(this,R,j,T,this.f,(z,ne)=>this.k(z,ne))),this.B(this.a.onError(z=>{console.error(z),(0,S.$Y)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new y.$jh,this.B(this.socket.onData(z=>this.l(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this.f.event(P)}onClose(P){return this.g.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let R=0;for(;R<P.byteLength;)this.a.writeMessage(P.slice(R,Math.min(R+262144,P.byteLength))),R+=262144}k(P,R){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let j=2;P.byteLength<126?j+=0:P.byteLength<2**16?j+=2:j+=8;const T=A.$Hc.alloc(j);if(R?T.writeUInt8(194,0):T.writeUInt8(130,0),P.byteLength<126)T.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){T.writeUInt8(126,1);let z=1;T.writeUInt8(P.byteLength>>>8&255,++z),T.writeUInt8(P.byteLength>>>0&255,++z)}else{T.writeUInt8(127,1);let z=1;T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(P.byteLength>>>24&255,++z),T.writeUInt8(P.byteLength>>>16&255,++z),T.writeUInt8(P.byteLength>>>8&255,++z),T.writeUInt8(P.byteLength>>>0&255,++z)}this.socket.write(A.$Hc.concat([T,P]))}end(){this.h=!0,this.socket.end()}l(P){if(P.byteLength!==0){for(this.b.acceptChunk(P);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const R=this.b.peek(this.j.readLen),j=R.readUInt8(0),T=(j&128)>>>7,z=(j&64)>>>6,ne=R.readUInt8(1),ee=(ne&128)>>>7,ce=ne&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(ce===126?2:0)+(ce===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const R=this.b.read(this.j.readLen),j=R.readUInt8(1),T=(j&128)>>>7;let z=j&127,ne=1;z===126?z=R.readUInt8(++ne)*2**8+R.readUInt8(++ne):z===127&&(z=R.readUInt8(++ne)*0+R.readUInt8(++ne)*0+R.readUInt8(++ne)*0+R.readUInt8(++ne)*0+R.readUInt8(++ne)*2**24+R.readUInt8(++ne)*2**16+R.readUInt8(++ne)*2**8+R.readUInt8(++ne));let ee=0;T&&(ee=R.readUInt8(++ne)*2**24+R.readUInt8(++ne)*2**16+R.readUInt8(++ne)*2**8+R.readUInt8(++ne)),this.j.state=3,this.j.readLen=z,this.j.mask=ee,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const R=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),t(R,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(R,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$ph=a;class w extends u.$mb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Hc.alloc(0)}constructor(P,R,j,T,z,ne){super(),this.l=P,this.m=z,this.n=ne,this.a=this.B(new f.$hc),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$hc),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new f.$hc),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,R?(this.b=this.B(new k(this.l,T,j,{windowBits:15})),this.f=this.B(new g(this.l,{windowBits:15})),this.B(this.b.onError(ee=>this.a.fire(ee))),this.B(this.f.onError(ee=>this.a.fire(ee)))):(this.b=null,this.f=null)}writeMessage(P){this.g.push(P),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const P=this.g.shift();if(this.f){const R=await this.s(this.f,P);this.n(R,!0)}else this.n(P,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(P,R){return new Promise((j,T)=>{P.write(R),P.flush(z=>j(z))})}acceptFrame(P,R,j){this.h.push({data:P,isCompressed:R,isLastFrameOfMessage:j}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const P=this.h.shift();if(this.b&&P.isCompressed){const R=await this.w(this.b,P.data,P.isLastFrameOfMessage);this.m.fire(R)}else this.m.fire(P.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(P,R,j){return new Promise((T,z)=>{P.write(R),j&&P.write(A.$Hc.fromByteArray([0,0,255,255])),P.flush(ne=>T(ne))})}}class k extends u.$mb{get recordedInflateBytes(){return this.j?A.$Hc.concat(this.f):A.$Hc.alloc(0)}constructor(P,R,j,T){super(),this.h=P,this.j=R,this.a=this.B(new f.$hc),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(T),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(A.$Hc.wrap(z))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(P){this.j&&this.f.push(P.clone()),this.h.traceSocketEvent("zlibInflateWrite",P),this.b.write(P.buffer)}flush(P){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const R=A.$Hc.concat(this.g);this.g.length=0,P(R)})}}class g extends u.$mb{constructor(P,R){super(),this.g=P,this.a=this.B(new f.$hc),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(A.$Hc.wrap(j))})}write(P){this.g.traceSocketEvent("zlibDeflateWrite",P.buffer),this.b.write(P.buffer)}flush(P){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let R=A.$Hc.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),P(R)})}}function t(D,P){if(P===0)return;const R=D.byteLength>>>2;for(let ce=0;ce<R;ce++){const se=D.readUInt32BE(ce*4);D.writeUInt32BE(se^P,ce*4)}const j=R*4,T=D.byteLength-j,z=P>>>24&255,ne=P>>>16&255,ee=P>>>8&255;T>=1&&D.writeUInt8(D.readUInt8(j)^z,j),T>=2&&D.writeUInt8(D.readUInt8(j+1)^ne,j+1),T>=3&&D.writeUInt8(D.readUInt8(j+2)^ee,j+2)}e.$qh=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function r(){const D=(0,v.$6e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const P=process.platform!=="darwin"&&e.$qh?e.$qh:(0,s.tmpdir)(),R=(0,p.$$c)(P,`vscode-ipc-${D}.sock`);return n(R),R}e.$rh=r;function i(D,P,R){const j=(0,E.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${R}-${P}-sock`;const T=R.substr(0,4),z=P.substr(0,6),ne=j.substr(0,8);let ee;return process.platform!=="darwin"&&e.$qh&&!process.env.VSCODE_PORTABLE?ee=(0,p.$$c)(e.$qh,`vscode-${ne}-${T}-${z}.sock`):ee=(0,p.$$c)(D,`${T}-${z}.sock`),n(ee),ee}e.$sh=i;function n(D){const P=l[$.$t];typeof P=="number"&&D.length>=P&&console.warn(`WARNING: IPC handle "${D}" is longer than ${P} chars, try a shorter --user-data-dir`)}class o extends h.$dh{static b(P){const R=f.Event.fromNodeEventEmitter(P,"connection");return f.Event.map(R,j=>({protocol:new y.$kh(new b(j,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(j,"close"))}))}constructor(P){super(o.b(P)),this.d=P}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$th=o;function m(D){return new Promise((P,R)=>{const j=(0,C.createServer)();j.on("error",R),j.listen(D,()=>{j.removeListener("error",R),P(new o(j))})})}e.$uh=m;function I(D,P){return new Promise((R,j)=>{const T=(0,C.createConnection)(D,()=>{T.removeListener("error",j),R(y.$lh.fromSocket(new b(T,`ipc-client${P}`),P))});T.once("error",j)})}e.$vh=I}),define(te[28],ie([0,1,55,9,4,99,36,89,6]),function(G,e,E,C,s,M,A,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L4b=e.$K4b=void 0,e.$K4b=(0,f.$Ah)(A.$Gh);class u extends S.$0l{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$$c)(this.userDataPath,"clp")}get backupHome(){return(0,C.$$c)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$sh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$$c)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const $ in process.env)if($.endsWith("_VSCODE_SNAP_ORIG")){const v=$.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[$]?process.env[v]=process.env[$]:delete process.env[v]}}}restoreSnapExportedVariables(){if(s.$k)for(const $ in this.d)process.env[$]=this.d[$],delete this.d[$]}}e.$L4b=u,ke([E.$4g],u.prototype,"cachedLanguagesPath",null),ke([E.$4g],u.prototype,"backupHome",null),ke([E.$4g],u.prototype,"mainIPCHandle",null),ke([E.$4g],u.prototype,"mainLockfile",null),ke([E.$4g],u.prototype,"disableUpdates",null),ke([E.$4g],u.prototype,"crossOriginIsolated",null),ke([E.$4g],u.prototype,"codeCachePath",null),ke([E.$4g],u.prototype,"useCodeCache",null)}),define(te[283],ie([0,1,72,32,13,9,4,19,21,194,18,28,33,16,5,193,29,98]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$94b=void 0;let w=class{static{a=this}static{this.a="backupWorkspaces"}constructor(g,t,l,r){this.j=g,this.k=t,this.l=l,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$0f,this.i={isEqual:(i,n)=>(0,C.$Je)(i,n,!A.$k)}}async initialize(){const g=this.m.getItem(a.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(g.emptyWindows),this.d=await this.u((0,u.$24b)(g)),this.e=await this.v((0,u.$34b)(g)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.$pk.OFF}q(){return this.s()===h.$pk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.$pk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(g,t){this.d.some(r=>g.workspace.id===r.workspace.id)||(this.d.push(g),this.C());const l=(0,M.$$c)(this.c,g.workspace.id);return t?this.t(l,t).then(()=>l):l}async t(g,t){if(await f.Promises.exists(g)&&await this.z(g),await f.Promises.exists(t))try{await f.Promises.rename(t,g,!1)}catch(l){this.l.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}registerFolderBackup(g){return this.e.some(t=>this.h.isEqual(g.folderUri,t.folderUri))||(this.e.push(g),this.C()),(0,M.$$c)(this.c,this.D(g))}registerEmptyWindowBackup(g){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,g.backupFolder))||(this.g.push(g),this.C()),(0,M.$$c)(this.c,g.backupFolder)}async u(g){if(!Array.isArray(g))return[];const t=new Set,l=[];for(const r of g){const i=r.workspace;if(!(0,d.$Oh)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$$c)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?l.push(r):await this.z(n):await this.x(n)}}return l}async v(g){if(!Array.isArray(g))return[];const t=[],l=new Set;for(const r of g){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!l.has(n)){l.add(n);const o=(0,M.$$c)(this.c,this.D(r));await this.B(o)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(o):await this.x(o)}}return t}async w(g){if(!Array.isArray(g))return[];const t=[],l=new Set;for(const r of g){const i=r.backupFolder;if(typeof i!="string")return[];if(!l.has(i)){l.add(i);const n=(0,M.$$c)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(g){try{await f.Promises.rm(g,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let g=(0,c.$84b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,g.id));)g=(0,c.$84b)();return{backupFolder:g.id}}async z(g){const t=this.y(),l=(0,M.$$c)(this.c,t.backupFolder);try{await f.Promises.rename(g,l,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const g=[];for(const t of this.d)await this.A(t)&&g.push(t);for(const t of this.e)await this.A(t)&&g.push(t);return g}A(g){let t;return(0,u.$14b)(g)?t=(0,M.$$c)(this.c,g.backupFolder):(0,b.$2T)(g)?t=(0,M.$$c)(this.c,this.D(g)):t=(0,M.$$c)(this.c,g.workspace.id),this.B(t)}async B(g){try{const t=await f.Promises.readdir(g);for(const l of t)try{if((await f.Promises.readdir((0,M.$$c)(g,l))).length>0)return!0}catch{}}catch{}return!1}C(){const g={workspaces:this.d.map(({workspace:t,remoteAuthority:l})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return l&&(r.remoteAuthority=l),r}),folders:this.e.map(({folderUri:t,remoteAuthority:l})=>{const r={folderUri:t.toString()};return l&&(r.remoteAuthority=l),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:l})=>{const r={backupFolder:t};return l&&(r.remoteAuthority=l),r})};this.m.setItem(a.a,g)}D(g){const t=g.folderUri;let l;return t.scheme===s.Schemas.file?l=A.$k?t.fsPath:t.fsPath.toLowerCase():l=t.toString().toLowerCase(),(0,E.createHash)("md5").update(l).digest("hex")}};e.$94b=w,e.$94b=w=a=ke([_(0,$.$K4b),_(1,p.$6h),_(2,y.$3i),_(3,v.$8M)],w)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,33,28]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$N4b=e.LifecycleMainPhase=e.ShutdownReason=e.$M4b=void 0,e.$M4b=(0,p.$zh)("lifecycleMainService");var b;(function(a){a[a.QUIT=1]="QUIT",a[a.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var d;(function(a){a[a.Starting=1]="Starting",a[a.Ready=2]="Ready",a[a.AfterWindowOpen=3]="AfterWindowOpen",a[a.Eventually=4]="Eventually"})(d||(e.LifecycleMainPhase=d={}));let c=class extends A.$mb{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(w,k,g){super(),this.w=w,this.y=k,this.z=g,this.c=this.B(new M.$hc),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$hc),this.onWillShutdown=this.f.event,this.g=this.B(new M.$hc),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$hc),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.v=void 0,this.C(),this.when(2).then(()=>this.D())}C(){this.j=!!this.y.getItem(y.b),this.j&&this.y.removeItem(y.b)}D(){const w=()=>{this.i||(this.N("Lifecycle#app.on(before-quit)"),this.i=!0,this.N("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.n===0&&this.F(1))};E.app.addListener("before-quit",w);const k=()=>{this.N("Lifecycle#app.on(window-all-closed)"),(this.i||!S.$j)&&E.app.quit()};E.app.addListener("window-all-closed",k),E.app.once("will-quit",g=>{this.N("Lifecycle#app.on(will-quit) - begin"),g.preventDefault(),this.F(1).finally(()=>{this.N("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.I(!1),E.app.removeListener("before-quit",w),E.app.removeListener("window-all-closed",k),this.N("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}F(w){if(this.s)return this.s;const k=this.w;this.N("Lifecycle#onWillShutdown.fire()");const g=[];return this.f.fire({reason:w,join(t,l){k.trace(`Lifecycle#onWillShutdown - begin '${t}'`),g.push(l.finally(()=>{k.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.s=(async()=>{try{await s.Promises.settled(g)}catch(t){this.w.error(t)}try{await this.y.close()}catch(t){this.w.error(t)}})(),this.s}set phase(w){if(w<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===w)return;this.N(`lifecycle (main): phase changed (value: ${w})`),this.k=w;const k=this.u.get(this.k);k&&(k.open(),this.u.delete(this.k))}async when(w){if(w<=this.k)return;let k=this.u.get(w);k||(k=new s.$Dg,this.u.set(w,k)),await k.wait()}registerWindow(w){const k=new A.$lb;this.n++,k.add(w.onWillLoad(t=>this.g.fire({window:w,workspace:t.workspace,reason:t.reason})));const g=(0,u.$we)(w.win);g.on("close",t=>{const l=w.id;if(this.l.has(l)){this.l.delete(l);return}this.N(`Lifecycle#window.on('close') - window ID ${w.id}`),t.preventDefault(),this.unload(w,1).then(r=>{if(r){this.l.delete(l);return}this.l.add(l),this.N(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this.h.fire(w),w.close()})}),g.on("closed",()=>{this.N(`Lifecycle#window.on('closed') - window ID ${w.id}`),this.n--,k.dispose(),this.n===0&&(!S.$j||this.i)&&this.F(1)})}async reload(w,k){await this.unload(w,3)||w.reload(k)}unload(w,k){const g=this.t.get(w.id);if(g)return g;const t=this.G(w,k).finally(()=>{this.t.delete(w.id)});return this.t.set(w.id,t),t}async G(w,k){if(!w.isReady)return!1;this.N(`Lifecycle#unload() - window ID ${w.id}`);const g=this.i?2:k,t=await this.J(w,g);return t?(this.N(`Lifecycle#unload() - veto in renderer (window ID ${w.id})`),this.H(t)):(await this.L(w,g),!1)}H(w){return w?(this.I(!0),this.i=!1,!0):!1}I(w){this.r&&(this.r(w),this.r=void 0,this.p=void 0)}J(w,k){return new Promise(g=>{const t=this.m++,l=`vscode:ok${t}`,r=`vscode:cancel${t}`;C.$FS.once(l,()=>{g(!1)}),C.$FS.once(r,()=>{g(!0)}),w.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:r,reason:k})})}L(w,k){return new Promise(g=>{const l=`vscode:reply${this.m++}`;C.$FS.once(l,()=>g()),w.send("vscode:onWillUnload",{replyChannel:l,reason:k})})}quit(w){return this.M(w).then(k=>{if(!k&&w)try{if(S.$i){const g=(0,f.cwd)();g!==process.cwd()&&process.chdir(g)}}catch(g){this.w.error(g)}return k})}M(w){return this.N(`Lifecycle#quit() - begin (willRestart: ${w})`),this.p?(this.N("Lifecycle#quit() - returning pending quit promise"),this.p):(w&&this.y.setItem(y.b,!0),this.p=new Promise(k=>{this.r=k,this.N("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}N(w){this.z.args["enable-smoke-test-driver"]?this.w.info(w):this.w.trace(w)}setRelaunchHandler(w){this.v=w}async relaunch(w){this.N("Lifecycle#relaunch()");const k=process.argv.slice(1);if(w?.addArgs&&k.push(...w.addArgs),w?.removeArgs)for(const l of w.removeArgs){const r=k.indexOf(l);r>=0&&k.splice(r,1)}const g=()=>{this.v?.handleRelaunch(w)||(this.N("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:k}))};E.app.once("quit",g),await this.quit(!0)&&E.app.removeListener("quit",g)}async kill(w){this.N("Lifecycle#kill()"),await this.F(2),await Promise.race([(0,s.$Fg)(1e3),(async()=>{for(const k of E.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let g;k.webContents&&!k.webContents.isDestroyed()?g=new Promise(t=>k.once("closed",t)):g=Promise.resolve(),k.destroy(),await g}})()]),E.app.exit(w)}};e.$N4b=c,e.$N4b=c=y=ke([_(0,$.$3i),_(1,v.$8M),_(2,h.$K4b)],c)}),define(te[284],ie([0,1,4,3,2,6,20]),function(G,e,E,C,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D5b=e.$C5b=void 0,e.$C5b=(0,M.$zh)("keyboardLayoutMainService");let S=class extends s.$mb{constructor(p){super(),this.a=this.B(new C.$hc),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise(($,v)=>{G(["native-keymap"],$,v)});this.c=f(p),E.$s||p.onDidChangeKeyboardLayout(()=>{this.c=f(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$D5b=S,e.$D5b=S=ke([_(0,A.$M4b)],S);function f(u){const p=u.getKeyMap(),$=u.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:$}}}),define(te[285],ie([0,1,244,8,17,14,12,18,36,94,5,51,243,282]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;let y=class extends $.$Ho{constructor(a,w,k,g){super(g),this.j=a,this.k=w,this.l=k,this.m(),this.B(a.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const a=this.j.getValue("http");this.f=a?.proxy,this.g=!!a?.proxyStrictSSL,this.h=a?.proxyAuthorization}async request(a,w){const{f:k,g}=this;let t;try{t=await(0,u.$Kl)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,M.$8)(i)))}const l={...process.env,...t},r=a.agent?a.agent:await(0,v.$Kq)(a.url||"",l,{proxyUrl:k,strictSSL:g});return a.agent=r,a.strictSSL=g,this.h&&(a.headers={...a.headers||{},"Proxy-Authorization":this.h}),this.c(a.isChromiumNetwork?"electron":"node",a,()=>d(a,w))}async resolveProxy(a){}};e.$Lq=y,e.$Lq=y=ke([_(0,S.$6h),_(1,f.$Hh),_(2,p.$3i),_(3,p.$4i)],y);async function b(c){return((0,E.parse)(c.url).protocol==="https:"?await new Promise((k,g)=>{G(["https"],k,g)}):await new Promise((k,g)=>{G(["http"],k,g)})).request}async function d(c,a){return C.Promises.withAsyncBody(async(w,k)=>{const g=(0,E.parse)(c.url),t=c.getRawRequest?c.getRawRequest(c):await b(c),l={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$re)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(l.auth=c.user+":"+c.password);const r=t(l,i=>{const n=(0,A.$pe)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)d({...c,url:i.headers.location,followRedirects:n-1},a).then(w,k);else{let o=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,h.createGunzip)())),w({res:i,stream:(0,s.$Wc)(o)})}});r.on("error",k),c.timeout&&r.setTimeout(c.timeout),c.isChromiumNetwork&&r.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&r.write(c.data),r.end(),a.onCancellationRequested(()=>{r.abort(),k(new M.$3)})})}e.$Mq=d}),define(te[286],ie([0,1,15,285]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=void 0;function s(A){return E.net.request}class M extends C.$Lq{request(S,f){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$F6b=M}),define(te[82],ie([0,1,7,49,3,2,36,16,6,20,5,96,279,41,53,40,13]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X4b=e.$W4b=e.$V4b=e.$U4b=void 0,e.$U4b=(0,f.$zh)("storageMainService");let c=class extends M.$mb{constructor(k,g,t,l,r,i){super(),this.c=k,this.f=g,this.g=t,this.h=l,this.i=r,this.j=i,this.a=void 0,this.b=this.B(new s.$hc),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.m()),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join("applicationStorage",this.applicationStorage.close());for(const[,g]of this.n)k.join("profileStorage",g.close());for(const[,g]of this.r)k.join("workspaceStorage",g.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.i.exists(k.profile.globalStorageHome)||await this.i.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const g=this.n.get(k.profile.id);g&&k.join(g.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const k=new v.$P4b(this.k(),this.g,this.c,this.i);return this.B((0,C.$bb)(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),k}profileStorage(k){if((0,$.$Vo)(k))return this.applicationStorage;let g=this.n.get(k.id);if(!g){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),g=this.B(this.p(k)),this.n.set(k.id,g);const t=this.B(g.onDidChangeStorage(l=>this.b.fire({...l,storage:g,profile:k})));this.B((0,C.$bb)(g.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.n.delete(k.id),t.dispose()}))}return g}p(k){return this.a===2?new v.$R4b(this.c,this.i):new v.$O4b(k,this.k(),this.c,this.i)}workspaceStorage(k){let g=this.r.get(k.id);return g||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),g=this.B(this.s(k)),this.r.set(k.id,g),this.B((0,C.$bb)(g.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.r.delete(k.id)}))),g}s(k){return this.a===2?new v.$R4b(this.c,this.i):new v.$Q4b(k,this.k(),this.c,this.f,this.i)}isUsed(k){const g=E.URI.file(k);for(const t of[this.applicationStorage,...this.n.values(),...this.r.values()])if(t.path&&this.j.extUri.isEqualOrParent(E.URI.file(t.path),g))return!0;return!1}};e.$V4b=c,e.$V4b=c=ke([_(0,p.$3i),_(1,A.$Gh),_(2,y.$S4b),_(3,u.$M4b),_(4,S.$4j),_(5,b.$Ak)],c),e.$W4b=(0,f.$zh)("applicationStorageMainService");let a=class extends $.$Uo{constructor(k,g){super(),this.p=k,this.s=g,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(k){if(k===-1)return this.s.applicationStorage.storage}M(k){if(k===-1)return this.p.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$X4b=a,e.$X4b=a=ke([_(0,h.$Ck),_(1,e.$U4b)],a)}),define(te[287],ie([0,1,15,22,3,57,2,31,115,5,82,30]),function(G,e,E,C,s,M,A,S,f,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z4b=void 0;var v;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let h=class extends A.$mb{constructor(b,d,c,a){super(),this.g=b,this.h=d,this.i=c,this.j=a,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.k()}k(){const b=s.Event.fromNodeEventEmitter(E.app,"login",(d,c,a,w,k)=>({event:d,webContents:c,req:a,authInfo:w,callback:k}));this.B(b(this.l,this))}async l({event:b,authInfo:d,req:c,callback:a}){if(!d.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&c.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let w;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),w=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.m(d);try{w=await this.b}finally{this.b=void 0}}a(w?.username,w?.password)}async m(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const d=await this.n(b);if(d)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),d;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async n(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const d=String((0,M.$ni)({scheme:b.scheme,host:b.host,port:b.port}));let c,a;try{const t=this.j.get(this.a+d,-1);if(t){const l=JSON.parse(await this.i.decrypt(t));c=l.username,a=l.password}}catch(t){this.g.error(t)}if(this.c!==v.StoredCredentialsUsed&&typeof c=="string"&&typeof a=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:c,password:a};const w=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!w){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${w.id} to handle proxy login`);const k={authInfo:b,username:this.f?.username??c,password:this.f?.password??a,replyChannel:`vscode:proxyAuthResponse:${(0,S.$6e)()}`};w.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,k),this.c=v.LoginDialogShown;const g=await new Promise(t=>{const l=async(r,i,n)=>{if(i===k.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${w.id}`),w.win?.webContents.off("ipc-message",l),n){const o={username:n.username,password:n.password};try{if(n.remember){const m=await this.i.encrypt(JSON.stringify(o));this.j.store(this.a+d,m,-1,1)}else this.j.remove(this.a+d,-1)}catch(m){this.g.error(m)}t({username:o.username,password:o.password})}else t(void 0)};w.win?.webContents.on("ipc-message",l)});return this.f=g,g}};e.$Z4b=h,e.$Z4b=h=ke([_(0,u.$3i),_(1,$.$Y4b),_(2,f.$oT),_(3,p.$W4b)],h)}),define(te[288],ie([0,1,87,27,103,99,8,2,4,18,5,23,239,240,95,126,17]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.$D6b=e.$C6b=e.$B6b=void 0;async function c(t,l,r,i,n){let o;for(let m=3;m&&(o?.dispose(),o=await new a(t,l,r,i,n).waitForReady(),!(n&&s.$9e[n]||!s.$9e[o.tunnelLocalPort]));m--);return o}class a extends S.$mb{constructor(l,r,i,n,o){super(),this.j=r,this.k=o,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=l,this.b=E.createServer(),this.c=new A.$Dg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=m=>this.l(m),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(r=>{r()})}async waitForReady(){const l=this.k??this.tunnelRemotePort,r=(0,b.$Zz)(this.j)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$0e)(l,2,1e3,r),n=null;return this.b.listen(i,this.j),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(l){l.pause();const r=(0,b.$Xz)(this.tunnelRemoteHost)||(0,b.$Zz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$Xk)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this.i.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this.i.delete(l.localAddress),n instanceof M.$oh?n.socket.destroy():n.end()}),n instanceof M.$oh?this.n(l,n):this.m(l,n),l.localAddress&&this.i.set(l.localAddress,()=>{l.end(),n.end()})}m(l,r){r.onClose(()=>l.destroy()),r.onEnd(()=>l.end()),r.onData(i=>l.write(i.buffer)),l.on("data",i=>r.write(d.$Hc.wrap(i))),l.resume()}n(l,r){const i=r.socket;i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),i.pipe(l),l.pipe(i)}}e.$B6b=a;let w=class extends b.$3z{constructor(l,r,i,n,o){super(r,o),this.u=l,this.v=i,this.w=n}isPortPrivileged(l){return(0,b.$1z)(l,this.l,f.OS,C.release())}s(l,r,i,n,o,m,I,D){const P=this.r(r,i);if(P)return++P.refcount,P.value;if((0,b.$Uz)(l))return this.t(l,r,i,o,m,I,D);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const R={commit:this.w.commit,quality:this.w.quality,addressProvider:l,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=c(R,n,r,i,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,j),j}}};e.$C6b=w,e.$C6b=w=ke([_(0,h.$Rk),_(1,p.$3i),_(2,y.$Uk),_(3,$.$ij),_(4,u.$6h)],w);let k=class extends w{constructor(l,r,i,n,o){super(l,r,i,n,o)}};e.$D6b=k,e.$D6b=k=ke([_(0,h.$Rk),_(1,p.$3i),_(2,y.$Uk),_(3,$.$ij),_(4,u.$6h)],k);let g=class extends S.$mb{constructor(l,r,i,n,o){super(),this.b=l,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(l,r,i,n,o,m,I,D,P){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${m}.`),!this.a.has(l)){const R=new k(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(l,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(r,i,n,o,m,I,D,P)}};e.$E6b=g,e.$E6b=g=ke([_(0,h.$Rk),_(1,p.$3i),_(2,$.$ij),_(3,y.$Uk),_(4,u.$6h)],g)}),define(te[100],ie([0,1,8,22,3,18,28,20,5,23,51,48]),function(G,e,E,C,s,M,A,S,f,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=e.$25b=void 0;function v(y,b,d){return`${d.updateUrl}/api/update/${y}/${b}/${d.commit}`}e.$25b=v;let h=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,d,c,a,w,k){this.f=b,this.g=d,this.h=c,this.i=a,this.j=w,this.k=k,this.b=$.$FT.Uninitialized,this.c=new s.$hc,this.onStateChange=this.c.event,b.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d($.$FT.Disabled(0));return}if(this.h.disableUpdates){this.d($.$FT.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d($.$FT.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),d=this.m(b);if(!d){this.d($.$FT.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(d),!this.a){this.d($.$FT.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d($.$FT.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,c=>this.j.error(c))}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,E.$Fg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(d){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(d);return}}async _applySpecificUpdate(b){}q(){return 1}r(){}};e.$35b=h,e.$35b=h=ke([_(0,S.$M4b),_(1,M.$6h),_(2,A.$K4b),_(3,p.$Go),_(4,f.$3i),_(5,u.$ij)],h)}),define(te[289],ie([0,1,15,55,3,2,18,28,20,5,23,51,25,48,100]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$45b=void 0;let b=class extends y.$35b{get v(){return s.Event.fromNodeEventEmitter(E.autoUpdater,"error",(c,a)=>a)}get w(){return s.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(c,a,w)=>({url:a,version:w,productVersion:w}))}get y(){return s.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(c,a,w,k)=>({releaseNotes:a,version:w,productVersion:w,date:k}))}constructor(c,a,w,k,g,t,l){super(c,a,k,g,t,l),this.z=w,this.u=new M.$lb,c.setRelaunchHandler(this)}handleRelaunch(c){return c?.addArgs||c?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(c){this.j.error("UpdateService error:",c);const a=this.state.type==="checking for updates"&&this.state.explicit?c:void 0;this.d(h.$FT.Idle(1,a))}s(c){let a;this.k.darwinUniversalAssetId?a=this.k.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const w=(0,y.$25b)(a,c,this.k);try{E.autoUpdater.setFeedURL({url:w})}catch(k){this.j.error("Failed to set update feed URL",k);return}return w}t(c){this.d(h.$FT.CheckingForUpdates(c)),E.autoUpdater.checkForUpdates()}E(c){this.state.type==="checking for updates"&&this.d(h.$FT.Downloading(c))}F(c){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:c.version}),this.d(h.$FT.Ready(c)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.$FT.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$45b=b,ke([C.$4g],b.prototype,"v",null),ke([C.$4g],b.prototype,"w",null),ke([C.$4g],b.prototype,"x",null),ke([C.$4g],b.prototype,"y",null),e.$45b=b=ke([_(0,f.$M4b),_(1,A.$6h),_(2,v.$7k),_(3,S.$K4b),_(4,$.$Go),_(5,u.$3i),_(6,p.$ij)],b)}),define(te[290],ie([0,1,47,45,8,3,9,28,20,5,25,48]),function(G,e,E,C,s,M,A,S,f,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=void 0;let v=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,d,c){if(this.f=b,this.g=c,this.a=$.$FT.Uninitialized,this.b=new M.$hc,this.onStateChange=this.b.event,d.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d($.$FT.Idle(this.k())),this.h(30*1e3).then(void 0,a=>this.g.error(a))}h(b=60*60*1e3){return(0,s.$Fg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};v=ke([_(0,f.$M4b),_(1,S.$K4b),_(2,u.$3i)],v);let h=class extends v{constructor(b,d,c,a,w,k){super(c,a,w),this.o=b,this.p=d,this.q=k;const g=(0,C.watch)(A.$bd(this.o)),t=M.Event.fromNodeEventEmitter(g,"change",(n,o)=>o),l=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(l,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));c.onWillShutdown(()=>{i.dispose(),g.close()})}m(){this.d($.$FT.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d($.$FT.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d($.$FT.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d($.$FT.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+A.$cd(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise((c,a)=>(0,C.realpath)(`${A.$bd(this.o)}/current`,(w,k)=>w?a(w):c(k))),d=A.$cd(b);return this.p!==d}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$65b=h,e.$65b=h=ke([_(2,f.$M4b),_(3,S.$K4b),_(4,u.$3i),_(5,p.$7k)],h)}),define(te[291],ie([0,1,2,20,53,29,8,30]),function(G,e,E,C,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=void 0;let f=class extends E.$mb{constructor(p,$,v){super(),this.a=$,this.b=v,this.B(p.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B(p.onBeforeCloseWindow(h=>this.c(h))),this.B(new A.$Qg(()=>this.g(),30*1e3)).schedule()}async c(p){const $=this.f(p),v=this.a.getProfileForWorkspace($);v?.isTransient&&(this.a.unsetWorkspace($,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,M.$Nh)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const $=this.b.getWindows().map(v=>this.f(v));for(const v of p)$.some(h=>h.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$m6b=f,e.$m6b=f=ke([_(0,C.$M4b),_(1,s.$S4b),_(2,S.$Y4b)],f)}),define(te[62],ie([0,1,15,2,3,5,310,8,13,30,70,25,20,73,37,4,131]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=e.$f5b=void 0;function a(g){return typeof g.responseWindowId=="number"}let w=class extends C.$mb{static{c=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(c.b.values())}constructor(t,l,r){super(),this.n=t,this.p=l,this.r=r,this.c=String(++c.a),this.f=this.B(new s.$hc),this.onStdout=this.f.event,this.g=this.B(new s.$hc),this.onStderr=this.g.event,this.h=this.B(new s.$hc),this.onMessage=this.h.event,this.i=this.B(new s.$hc),this.onExit=this.i.event,this.j=this.B(new s.$hc),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(t,l){let r;switch(this.m?.correlationId?r=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${t}`,l){case p.default.Error:this.n.error(r);break;case p.default.Warning:this.n.warn(r);break;case p.default.Info:this.n.trace(r);break}}t(){return this.k?(this.s("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(t){const l=this.u(t);return l&&t.payload&&this.postMessage(t.payload),l}u(t){if(!this.t())return!1;this.m=t;const l=`${this.m.type}-${this.c}`,r=f.$4e.asFileUri("bootstrap-fork.js").fsPath,i=this.m.args??[],n=this.m.execArgv??[],o=this.m.allowLoadingUnsignedLibraries,m=this.m.forceAllocationsToV8Sandbox,I="pipe",D=this.v(t);return this.s("creating new...",p.default.Info),this.k=E.utilityProcess.fork(r,i,{serviceName:l,env:D,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:m,stdio:I}),this.w(this.k,this.m,l),!0}v(t){const l=t.env?{...t.env}:{...(0,y.$Tm)(process.env)};l.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(l.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),l.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,b.$i&&((0,d.isUNCAccessRestrictionsDisabled)()?l.NODE_DISABLE_UNC_ACCESS_CHECKS="1":l.NODE_UNC_HOST_ALLOWLIST=(0,d.getUNCHostAllowlist)().join("\\")),(0,h.$rl)(l);for(const r of Object.keys(l))l[r]=String(l[r]);return l}w(t,l,r){if(t.stdout){const i=new A.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new A.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.l=t.pid,typeof t.pid=="number"&&c.b.set(t.pid,{pid:t.pid,name:a(l)?`${l.type} [${l.responseWindowId}]`:l.type}),this.s("successfully created",p.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.s(`received exit event with code ${i}`,p.default.Info),this.i.fire({pid:this.l,code:i,signal:"unknown"}),this.y()})),this.B(s.Event.fromNodeEventEmitter(E.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.s(`crashed with code ${i.exitCode} and reason '${i.reason}'`,p.default.Error),this.p.publicLog2("utilityprocesscrash",{type:l.type,reason:i.reason,code:i.exitCode}),this.j.fire({pid:this.l,code:i.exitCode,reason:i.reason}),this.y())}))}once(t,l){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),l())}))}postMessage(t,l){this.k&&this.k.postMessage(t,l)}connect(t){const{port1:l,port2:r}=new E.MessageChannelMain;return this.postMessage(t,[r]),l}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",p.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",p.default.Info),this.k.kill()?(this.s("successfully killed the process",p.default.Info),this.y()):this.s("unable to kill the process",p.default.Warning)}y(){typeof this.l=="number"&&c.b.delete(this.l),this.k=void 0}async waitForExit(t){this.k&&(this.s("waiting to exit...",p.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Fg)(t)]),this.k&&(this.s(`did not exit within ${t}ms, will kill it now...`,p.default.Info),this.kill()))}};e.$f5b=w,e.$f5b=w=c=ke([_(0,M.$3i),_(1,$.$7k),_(2,v.$M4b)],w);let k=class extends w{constructor(t,l,r,i){super(t,r,i),this.z=l}start(t){const l=this.z.getWindowById(t.responseWindowId);if(!l?.win||l.win.isDestroyed()||l.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.u(t))return!1;this.C(l.win,t);const i=this.connect(t.payload);return l.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}C(t,l){l.windowLifecycleBound&&(this.B(s.Event.filter(this.r.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$g5b=k,e.$g5b=k=ke([_(0,M.$3i),_(1,u.$Y4b),_(2,$.$7k),_(3,v.$M4b)],k)}),define(te[292],ie([0,1,14,5,20,8,62,30,25]),function(G,e,E,C,s,M,A,S,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$o5b=void 0;let p=class{static{u=this}static{this.a=0}constructor(v,h,y,b){this.d=v,this.f=h,this.g=y,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown(d=>{this.c=!0,d.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(v){const h=this.b.get(v);if(!h)throw new Error("Unknown extension host!");return h}onDynamicStdout(v){return this.i(v).onStdout}onDynamicStderr(v){return this.i(v).onStderr}onDynamicMessage(v){return this.i(v).onMessage}onDynamicExit(v){return this.i(v).onExit}async createExtensionHost(){if(this.c)throw(0,E.$4)();const v=String(++u.a),h=new A.$g5b(this.d,this.g,this.h,this.f);return this.b.set(v,h),h.onExit(({pid:y,code:b,signal:d})=>{this.d.info(`Extension host with pid ${y} exited with code: ${b}, signal: ${d}.`),setTimeout(()=>{h.dispose(),this.b.delete(v)})}),{id:v}}async start(v,h){if(this.c)throw(0,E.$4)();this.i(v).start({...h,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:h.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:v})}async enableInspectPort(v){if(this.c)throw(0,E.$4)();const h=this.b.get(v);return h?h.enableInspectPort():!1}async kill(v){if(this.c)throw(0,E.$4)();const h=this.b.get(v);h&&h.kill()}async _killAllNow(){for(const[,v]of this.b)v.kill()}async _waitForAllExit(v){const h=[];for(const[,y]of this.b)h.push(y.waitForExit(v));return M.Promises.settled(h).then(()=>{})}};e.$o5b=p,e.$o5b=p=u=ke([_(0,C.$3i),_(1,s.$M4b),_(2,S.$Y4b),_(3,f.$7k)],p)}),define(te[293],ie([0,1,38,8,2,28,20,5,41,39,66,62,52,89,12,245,23]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=void 0;let c=class extends s.$mb{constructor(w,k,g,t,l,r,i,n){super(),this.c=w,this.f=k,this.g=g,this.h=t,this.i=l,this.j=r,this.k=i,this.l=n,this.a=new C.$Dg,this.b=void 0,this.s=void 0,this.t=void 0,this.m()}m(){E.$FS.on(b.$T5b.request,(w,k)=>this.n(w,k,b.$T5b.response)),E.$FS.on(b.$U5b.request,(w,k)=>this.n(w,k,b.$U5b.response)),this.B(this.h.onWillShutdown(()=>this.r()))}async n(w,k,g){this.i.trace(`[SharedProcess] onWindowConnection for: ${g}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(g);if(w.sender.isDestroyed())return t.close();w.sender.postMessage(g,k,[t])}r(){this.i.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(b.$S5b.exit),this.b=void 0}whenReady(){return this.s||(this.s=(async()=>{await this.u;const w=new C.$Zg;this.b?this.b.once(b.$S5b.initDone,()=>w.complete()):E.$FS.once(b.$S5b.initDone,()=>w.complete()),await w.p,this.i.trace("[SharedProcess] Overall ready")})()),this.s}get u(){return this.t||(this.t=(async()=>{await this.a.wait(),this.v();const w=new C.$Zg;this.b?this.b.once(b.$S5b.ipcReady,()=>w.complete()):E.$FS.once(b.$S5b.ipcReady,()=>w.complete()),await w.p,this.i.trace("[SharedProcess] IPC ready")})()),this.t}v(){this.b=this.B(new $.$f5b(this.i,v.$_n,this.h));const w=(0,h.$_l)(this.f.args,this.f.isBuilt);let k;w.port&&(k=["--nolazy"],w.break?k.push(`--inspect-brk=${w.port}`):k.push(`--inspect=${w.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.w(),execArgv:k,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.l.quality!=="stable"})}w(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.j.getLogLevel(),loggers:this.j.getRegisteredLoggers(),policiesData:this.k.serialize()}}async connect(w){return await this.u,(0,y.$we)(this.b).connect(w)}};e.$V5b=c,e.$V5b=c=ke([_(1,M.$K4b),_(2,f.$Ck),_(3,A.$M4b),_(4,S.$3i),_(5,p.$Q5b),_(6,u.$8m),_(7,d.$ij)],c)}),define(te[294],ie([0,1,28,89,20,5,52,62,110,38,2,3,37,18,13]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=void 0;let b=class extends p.$mb{constructor(c,a,w,k,g){super(),this.f=c,this.g=a,this.h=w,this.i=k,this.j=g,this.a=void 0,this.b=new $.$hc,this.onRequestConnection=this.b.event,this.c=new $.$hc,this.onWillShutdown=this.c.event,this.i.onWillShutdown(()=>this.c.fire()),u.$FS.on("vscode:createPtyHostMessageChannel",(t,l)=>this.l(t,l)),this.B((0,p.$kb)(()=>{u.$FS.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$f5b(this.j,A.$_n,this.i);const c=(0,C.$$l)(this.h.args,this.h.isBuilt),a=c.port?["--nolazy",`--inspect${c.break?"-brk":""}=${c.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:a,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.k()});const w=this.a.connect(),k=new f.$NS(w,"ptyHost"),g=new p.$lb;return g.add(k),g.add((0,p.$kb)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:k,store:g,onDidProcessExit:this.a.onExit}}k(){this.h.unsetSnapExportedVariables();const c={...(0,v.$Tm)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},a=this.g.getValue("terminal.integrated.developer.ptyHost.latency");a&&typeof a=="number"&&(c.VSCODE_LATENCY=String(a));const w=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return w&&typeof w=="number"&&(c.VSCODE_STARTUP_DELAY=String(w)),this.h.restoreSnapExportedVariables(),c}l(c,a){this.b.fire();const w=this.a.connect();if(c.sender.isDestroyed()){w.close();return}c.sender.postMessage("vscode:createPtyHostMessageChannelResult",a,[w])}};e.$u6b=b,e.$u6b=b=ke([_(1,h.$6h),_(2,E.$K4b),_(3,s.$M4b),_(4,M.$3i)],b)}),define(te[295],ie([0,1,2,6,5,30,62,25,57,3,8,20]),function(G,e,E,C,s,M,A,S,f,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t6b=e.$s6b=void 0,e.$s6b=(0,C.$zh)("utilityProcessWorker");let v=class extends E.$mb{constructor(b,d,c,a){super(),this.b=b,this.c=d,this.f=c,this.g=a,this.a=new Map}async createWorker(b){const d=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${d})`);const c=this.h(b);this.a.has(c)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${d})`),this.disposeWorker(b));const a=new h(this.b,this.c,this.f,this.g,b);if(!a.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(c,a);const w=new p.$Zg;return u.Event.once(a.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(c),w.complete({reason:k})}),w.p}h(b){return(0,f.$ni)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const d=this.h(b),c=this.a.get(d);c&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),c.kill(),this.a.delete(d))}};e.$t6b=v,e.$t6b=v=ke([_(0,s.$3i),_(1,M.$Y4b),_(2,S.$7k),_(3,$.$M4b)],v);let h=class extends E.$mb{constructor(b,d,c,a,w){super(),this.c=b,this.f=d,this.g=c,this.h=a,this.i=w,this.a=this.B(new u.$hc),this.onDidTerminate=this.a.event,this.b=new A.$g5b(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.B(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const d=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:d,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};h=ke([_(0,s.$3i),_(1,M.$Y4b),_(2,S.$7k),_(3,$.$M4b)],h)}),define(te[296],ie([0,1,15,2,4,19,7,18,20,5,33,30,128,29]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=e.$e6b=e.$d6b=void 0;let b=class extends C.$mb{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(g,t,l,r,i){super(),this.g=g,this.h=t,this.i=l,this.j=r,this.k=i,this.b=d(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(g=>this.p(g)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(g=>{g.newCount-g.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(g=>this.p(g))}m(){this.f=!0,this.n()}n(){const g=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.r(i),t.lastActiveWindow.uiState.mode===3&&g.add(t.lastActiveWindow.uiState.display))}const l=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);l&&(t.lastPluginDevelopmentHostWindow=this.r(l),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(g.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!l.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):g.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.r(i);return n.uiState.mode===3&&(g.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):g.add(n.uiState.display)),n}));const r=a(t);this.h.setItem(y.a,r),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",r)}p(g){if(this.i.quitRequested)return;const t=this.r(g);g.isExtensionDevelopmentHost&&!g.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!g.isExtensionDevelopmentHost&&g.openedWorkspace&&this.b.openedWindows.forEach(l=>{const r=(0,h.$Oh)(g.openedWorkspace)&&l.workspace?.id===g.openedWorkspace.id,i=(0,h.$Jh)(g.openedWorkspace)&&l.folderUri&&M.$0f.isEqual(l.folderUri,g.openedWorkspace.uri);(r||i)&&(l.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}r(g){return{windowId:g.id,workspace:(0,h.$Oh)(g.openedWorkspace)?g.openedWorkspace:void 0,folderUri:(0,h.$Jh)(g.openedWorkspace)?g.openedWorkspace.uri:void 0,backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.serializeWindowState()}}getNewWindowState(g){const t=this.s(g),l=this.k.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):r=!!(this.i.wasRestarted||l?.restoreFullscreen),r||(t.mode=1)}return t}s(g){const t=this.g.getLastActiveWindow();if(!g.extensionTestsPath){if(g.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const m=g.workspace;if((0,h.$Oh)(m)){const D=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===m.id).map(P=>P.uiState);if(D.length)return D[0]}if((0,h.$Jh)(m)){const D=this.state.openedWindows.filter(P=>P.folderUri&&M.$0f.isEqual(P.folderUri,m.uri)).map(P=>P.uiState);if(D.length)return D[0]}else if(g.backupPath){const D=this.state.openedWindows.filter(P=>P.backupPath===g.backupPath).map(P=>P.uiState);if(D.length)return D[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let l;const r=E.screen.getAllDisplays();if(r.length===1)l=r[0];else{if(s.$j){const m=E.screen.getCursorScreenPoint();l=E.screen.getDisplayNearestPoint(m)}!l&&t&&(l=E.screen.getDisplayMatching(t.getBounds())),l||(l=E.screen.getPrimaryDisplay()||r[0])}let i=(0,v.$J4b)();i.x=Math.round(l.bounds.x+l.bounds.width/2-i.width/2),i.y=Math.round(l.bounds.y+l.bounds.height/2-i.height/2);const n=this.k.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const m=t.serializeWindowState();m.mode===3?i.mode=3:i=m,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.t(i)),i.hasDefaultState=!0,i}t(g){if(this.g.getWindows().length===0)return g;g.x=typeof g.x=="number"?g.x:0,g.y=typeof g.y=="number"?g.y:0;const t=this.g.getWindows().map(l=>l.getBounds());for(;t.some(l=>l.x===g.x||l.y===g.y);)g.x+=30,g.y+=30;return g}};e.$d6b=b,e.$d6b=b=y=ke([_(0,$.$Y4b),_(1,p.$8M),_(2,f.$M4b),_(3,u.$3i),_(4,S.$6h)],b);function d(k){const g={openedWindows:[]},t=k||{openedWindows:[]};return t.lastActiveWindow&&(g.lastActiveWindow=c(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(g.lastPluginDevelopmentHostWindow=c(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(g.openedWindows=t.openedWindows.map(l=>c(l))),g}e.$e6b=d;function c(k){const g={uiState:k.uiState};return k.backupPath&&(g.backupPath=k.backupPath),k.remoteAuthority&&(g.remoteAuthority=k.remoteAuthority),k.folder&&(g.folderUri=A.URI.parse(k.folder)),k.workspaceIdentifier&&(g.workspace={id:k.workspaceIdentifier.id,configPath:A.URI.parse(k.workspaceIdentifier.configURIPath)}),g}function a(k){return{lastActiveWindow:k.lastActiveWindow&&w(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&w(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(g=>w(g))}}e.$f6b=a;function w(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(te[54],ie([0,1,15,3,44,2,13,9,19,21,192,64,61,28,6,5,53,130,29,97,98]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e5b=e.$d5b=void 0,e.$d5b=(0,y.$zh)("workspacesManagementMainService");let g=class extends M.$mb{constructor(l,r,i,n,o){super(),this.g=l,this.h=r,this.i=i,this.j=n,this.k=o,this.a=this.B(new C.$hc),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$hc),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const l=(await u.Promises.readdir(this.c.with({scheme:A.Schemas.file}).fsPath)).map(r=>(0,f.$gg)(this.c,r,a.$Yh));for(const r of l){const i=(0,k.$64b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(l){l.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${l}).`)}}resolveLocalWorkspace(l){return this.l(l,r=>u.Promises.readFile(r,"utf8"))}l(l,r){if(this.m(l)&&l.scheme===A.Schemas.file)try{const i=r(l.fsPath);return i instanceof Promise?i.then(n=>this.n(l,n),n=>{}):this.n(l,i)}catch{return}}m(l){return(0,a.$Zh)(l,this.g)||(0,a.$5h)(l)}n(l,r){try{const i=this.p(l,r),n=(0,k.$64b)(l);return{id:n.id,configPath:n.configPath,folders:(0,w.$0T)(i.folders,n.configPath,f.$0f),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}p(l,r){const i=(0,s.$Jm)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,w.$8T)(n));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(l,r){const{workspace:i,storedWorkspace:n}=this.r(l,r),o=i.configPath.fsPath;return await u.Promises.mkdir((0,S.$bd)(o),{recursive:!0}),await u.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}r(l=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$gg)(this.c,i),o=(0,f.$gg)(n,a.$Yh),m=[];for(const I of l)m.push((0,w.$9T)(I.uri,!0,I.name,n,f.$0f));return{workspace:(0,k.$64b)(o),storedWorkspace:{folders:m,remoteAuthority:r}}}async getWorkspaceIdentifier(l){return(0,k.$64b)(l)}isUntitledWorkspace(l){return(0,a.$Zh)(l.configPath,this.g)}async deleteUntitledWorkspace(l){this.isUntitledWorkspace(l)&&(await this.s(l),this.i.isEnabled()&&this.i.unsetWorkspace(l),this.a.fire(l))}async s(l){const r=(0,f.$7f)(l.configPath);try{await u.Promises.rm((0,S.$bd)(r));const i=(0,S.$$c)(this.g.workspaceStorageHome.with({scheme:A.Schemas.file}).fsPath,l.id);await u.Promises.exists(i)&&await u.Promises.writeFile((0,S.$$c)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==l.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(l,r,i){if(!l||!l.win||!l.isReady||!await this.t(l,r,i))return;const o=await this.u(l,(0,k.$64b)(i));if(o)return this.b.fire({window:l,workspace:o.workspace}),o}async t(l,r,i){return i?(0,a.$Oh)(l.openedWorkspace)&&f.$0f.isEqual(l.openedWorkspace.configPath,i)?!1:(0,c.$b5b)(r,i)?(await this.k.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:(0,p.localize)(1,null,(0,f.$dg)(i)),detail:(0,p.localize)(2,null)},E.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async u(l,r){if(!l.config)return;l.focus();let i;return l.config.extensionDevelopmentPath||(l.config.backupPath?i=await this.j.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority},l.config.backupPath):i=this.j.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority})),(0,a.$Oh)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=r,l.config.backupPath=i,{workspace:r,backupPath:i}}};e.$e5b=g,e.$e5b=g=ke([_(0,h.$K4b),_(1,b.$3i),_(2,d.$S4b),_(3,$.$44b),_(4,v.$$4b)],g)}),define(te[132],ie([0,1,15,38,22,6,30,29,54,12,5,62]),function(G,e,E,C,s,M,A,S,f,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=e.$i5b=e.ID=void 0,e.ID="diagnosticsMainService",e.$i5b=(0,M.$zh)(e.ID);let v=class{constructor(y,b,d){this.a=y,this.b=b,this.c=d}async getRemoteDiagnostics(y){const b=this.a.getWindows();return(await Promise.all(b.map(async c=>{const a=c.remoteAuthority;if(!a)return;const w=`vscode:getDiagnosticInfoResponse${c.id}`,k={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(c):void 0};return new Promise(g=>{c.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:w,args:k}),C.$FS.once(w,(t,l)=>{l||g({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),g(l)}),setTimeout(()=>{g({hostName:a,errorMessage:`Connection to '${a}' could not be established`})},5e3)})}))).filter(c=>!!c)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const d of E.BrowserWindow.getAllWindows()){const c=this.a.getWindowById(d.id);c?y.push(await this.d(c)):y.push(this.e(d))}const b=[];for(const{pid:d,name:c}of $.$f5b.getAll())b.push({pid:d,name:c});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:b,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(y){const b=await this.f(y),d=(0,u.$we)(y.win);return this.e(d,b,y.remoteAuthority)}e(y,b=[],d){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:b,remoteAuthority:d}}async f(y){const b=[],d=y.openedWorkspace;if((0,S.$Jh)(d))b.push(d.uri);else if((0,S.$Oh)(d)){const c=await this.b.resolveLocalWorkspace(d.configPath);c&&c.folders.forEach(w=>{b.push(w.uri)})}return b}};e.$j5b=v,e.$j5b=v=ke([_(0,A.$Y4b),_(1,f.$d5b),_(2,p.$3i)],v)}),define(te[67],ie([0,1,47,15,27,155,55,3,2,13,9,4,7,105,86,21,103,180,61,28,6,20,5,23,79,30,29,54,17,241,233]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g,t,l,r,i,n,o,m,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z5b=e.$y5b=void 0,e.$y5b=(0,k.$zh)("nativeHostMainService");let P=class extends f.$mb{constructor(j,T,z,ne,ee,ce,se,ae){super(),this.a=j,this.b=T,this.c=z,this.f=ne,this.g=ee,this.h=ce,this.i=se,this.j=ae,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,J=>J.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:J,x:Y,y:B})=>({windowId:J.id,x:Y,y:B})),({windowId:J})=>!!this.a.getWindowById(J)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-maximize",(J,Y)=>Y.id),J=>!!this.a.getWindowById(J)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-unmaximize",(J,Y)=>Y.id),J=>!!this.a.getWindowById(J)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(J,Y)=>Y.id),J=>!!this.a.getWindowById(J)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),J=>!!J),J=>J.id),S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(J,Y)=>Y.id),J=>!!this.a.getWindowById(J))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.i.onDidChangeColorScheme,this.k=this.B(new S.$hc),this.onDidChangePassword=this.k.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(J,Y,B)=>B),J=>!(Array.isArray(J)&&J.length===1&&J[0]==="workArea")),S.Event.fromNodeEventEmitter(C.screen,"display-added"),S.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace??(0,n.$Nh)(T.backupPath,T.isExtensionDevelopmentHost),title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(j){return this.a.getWindowCount()}async getActiveWindowId(j){const T=C.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(j,T,z){return Array.isArray(T)?this.l(j,T,z):this.m(j,T)}async l(j,T,z=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:j,urisToOpen:T,cli:this.f.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async m(j,T){await this.a.openEmptyWindow({context:5,contextWindowId:j},T)}async toggleFullScreen(j){this.t(j)?.toggleFullScreen()}async handleTitleDoubleClick(j){this.t(j)?.handleTitleDoubleClick()}async isMaximized(j){const T=this.t(j);return T?.win?T.win.isMaximized():!1}async maximizeWindow(j){const T=this.t(j);T?.win&&T.win.maximize()}async unmaximizeWindow(j){const T=this.t(j);T?.win&&T.win.unmaximize()}async minimizeWindow(j){const T=this.t(j);T?.win&&T.win.minimize()}async updateWindowControls(j,T){const z=this.t(j);z&&z.updateWindowControls(T)}async focusWindow(j,T){T&&typeof T.windowId=="number"&&(j=T.windowId),this.t(j)?.focus({force:T?.force??!1})}async setMinimumSize(j,T,z){const ne=this.t(j);if(ne?.win){const[ee,ce]=ne.win.getSize(),[se,ae]=ne.win.getMinimumSize(),[J,Y]=[T??se,z??ae],[B,F]=[Math.max(ee,J),Math.max(ce,Y)];(se!==J||ae!==Y)&&ne.win.setMinimumSize(J,Y),(ee!==B||ce!==F)&&ne.win.setSize(B,F)}}async saveWindowSplash(j,T){this.i.saveWindowSplash(j,T)}async installShellCommand(j){const{source:T,target:z}=await this.n();try{const{symbolicLink:ne}=await b.SymlinkSupport.stat(T);if(ne&&!ne.dangling){const ee=await(0,h.$Tp)(T);if(z===ee)return}await b.Promises.unlink(T)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await b.Promises.symlink(z,T)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:ee}=await this.showMessageBox(j,{type:"info",message:(0,c.localize)(0,null,this.h.nameShort),buttons:[(0,c.localize)(1,null),(0,c.localize)(2,null)]});if(ee===0)try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${T}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(ce)}catch{throw new Error((0,c.localize)(3,null,T))}}}async uninstallShellCommand(j){const{source:T}=await this.n();try{await b.Promises.unlink(T)}catch(z){switch(z.code){case"EACCES":{const{response:ne}=await this.showMessageBox(j,{type:"info",message:(0,c.localize)(4,null,this.h.nameShort),buttons:[(0,c.localize)(5,null),(0,c.localize)(6,null)]});if(ne===0)try{const ee=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(ee)}catch{throw new Error((0,c.localize)(7,null,T))}break}case"ENOENT":break;default:throw z}}}async n(){const j=(0,p.$_c)(this.f.appRoot,"bin","code"),T=`/usr/local/bin/${this.h.applicationName}`;if(!await b.Promises.exists(j))throw new Error((0,c.localize)(8,null,j));return{source:T,target:j}}async showMessageBox(j,T){return this.b.showMessageBox(T,this.p(j))}async showSaveDialog(j,T){return this.b.showSaveDialog(T,this.p(j))}async showOpenDialog(j,T){return this.b.showOpenDialog(T,this.p(j))}p(j){const T=this.t(j);if(T?.win)return T.win}async pickFileFolderAndOpen(j,T){const z=await this.b.pickFileFolder(T);z&&await this.r(await Promise.all(z.map(async ne=>await b.SymlinkSupport.existsDirectory(ne)?{folderUri:v.URI.file(ne)}:{fileUri:v.URI.file(ne)})),T,j)}async pickFolderAndOpen(j,T){const z=await this.b.pickFolder(T);z&&await this.r(z.map(ne=>({folderUri:v.URI.file(ne)})),T,j)}async pickFileAndOpen(j,T){const z=await this.b.pickFile(T);z&&await this.r(z.map(ne=>({fileUri:v.URI.file(ne)})),T,j)}async pickWorkspaceAndOpen(j,T){const z=await this.b.pickWorkspace(T);z&&await this.r(z.map(ne=>({workspaceUri:v.URI.file(ne)})),T,j)}async r(j,T,z){await this.a.open({context:3,contextWindowId:z,cli:this.f.args,urisToOpen:j,forceNewWindow:T.forceNewWindow})}async showItemInFolder(j,T){C.shell.showItemInFolder(T)}async setRepresentedFilename(j,T){this.t(j)?.setRepresentedFilename(T)}async setDocumentEdited(j,T){this.t(j)?.setDocumentEdited(T)}async openExternal(j,T){return this.f.unsetSnapExportedVariables(),C.shell.openExternal(T),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(j,T){return C.shell.trashItem(T)}async isAdmin(){let j;return $.$i?j=(await new Promise((T,z)=>{G(["native-is-elevated"],T,z)}))():j=process.getuid?.()===0,j}async writeElevated(j,T,z,ne){const ee=await new Promise((ce,se)=>{G(["@vscode/sudo-prompt"],ce,se)});return new Promise((ce,se)=>{const ae=[`"${this.s}"`];ne?.unlock&&ae.push("--file-chmod"),ae.push("--file-write",`"${T.fsPath}"`,`"${z.fsPath}"`);const J={name:this.h.nameLong.replace("-",""),icns:$.$j&&this.f.isBuilt?(0,p.$$c)((0,p.$bd)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ee.exec(ae.join(" "),J,(Y,B,F)=>{B&&this.g.trace(`[sudo-prompt] received stdout: ${B}`),F&&this.g.trace(`[sudo-prompt] received stderr: ${F}`),Y?se(Y):ce(void 0)})})}async isRunningUnderARM64Translation(){return $.$k||$.$i?!1:C.app.runningUnderARM64Translation}get s(){return $.$i?this.f.isBuilt?(0,p.$$c)((0,p.$bd)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,p.$$c)(this.f.appRoot,"scripts","code-cli.bat"):$.$k?this.f.isBuilt?(0,p.$$c)((0,p.$bd)(process.execPath),"bin",`${this.h.applicationName}`):(0,p.$$c)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,p.$$c)(this.f.appRoot,"bin","code"):(0,p.$$c)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Fm.value()}async getOSColorScheme(){return this.i.getColorScheme()}async hasWSLFeatureInstalled(){return $.$i&&(0,I.$w5b)()}async killProcess(j,T,z){process.kill(T,z)}async readClipboardText(j,T){return C.clipboard.readText(T)}async writeClipboardText(j,T,z){return C.clipboard.writeText(T,z)}async readClipboardFindText(j){return C.clipboard.readFindText()}async writeClipboardFindText(j,T){return C.clipboard.writeFindText(T)}async writeClipboardBuffer(j,T,z,ne){return C.clipboard.writeBuffer(T,Buffer.from(z.buffer),ne)}async readClipboardBuffer(j,T){return m.$Hc.wrap(C.clipboard.readBuffer(T))}async hasClipboard(j,T,z){return C.clipboard.has(T,z)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(j,T){this.t(j)?.updateTouchBar(T)}async notifyReady(j){this.t(j)?.setReady()}async relaunch(j,T){return this.c.relaunch(T)}async reload(j,T){const z=this.t(j);if(z){if((0,n.$Oh)(z.openedWorkspace)){const ne=z.openedWorkspace.configPath;if(ne.scheme===u.Schemas.file&&(await this.j.resolveLocalWorkspace(ne))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.c.reload(z,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(j){this.closeWindowById(j,j)}async closeWindowById(j,T){const z=this.t(T);if(z?.win)return z.win.close()}async quit(j){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.c.quit()}async exit(j,T){await this.c.kill(T)}async resolveProxy(j,T){return this.t(j)?.win?.webContents?.session?.resolveProxy(T)}findFreePort(j,T,z,ne,ee=1){return(0,d.$8e)(T,z,ne,ee)}async openDevTools(j,T){const z=this.t(j);z?.win&&z.win.webContents.openDevTools(T)}async toggleDevTools(j){const T=this.t(j);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(j,T){const z=this.t(j);z?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&z.win.webContents.sendInputEvent(T)}async profileRenderer(j,T,z){const ne=this.t(j);if(!ne||!ne.win)throw new Error;return await new D.$x5b(ne.win,T,this.g).inspect(z)}async windowsGetStringRegKey(j,T,z,ne){if(!$.$i)return;const ee=await new Promise((ce,se)=>{G(["@vscode/windows-registry"],ce,se)});try{return ee.GetStringRegKey(T,z,ne)}catch{return}}t(j){if(typeof j=="number")return this.a.getWindowById(j)}};e.$z5b=P,ke([A.$4g],P.prototype,"s",null),e.$z5b=P=ke([_(0,i.$Y4b),_(1,a.$$4b),_(2,g.$M4b),_(3,w.$K4b),_(4,t.$3i),_(5,l.$ij),_(6,r.$u5b),_(7,o.$d5b)],P)}),define(te[297],ie([0,1,15,38,27,2,13,4,107,178,90,132,61,28,5,67,77,23,78,80,32,33,62,22,7,30,8]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g,t,l,r,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$B5b=void 0;const m="issue.processExplorerWindowState";let I=class{static{o=this}static{this.a="#1E1E1E"}constructor(R,j,T,z,ne,ee,ce,se,ae,J,Y){this.g=R,this.h=j,this.i=T,this.j=z,this.k=ne,this.l=ee,this.m=ce,this.n=se,this.o=ae,this.p=J,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){C.$FS.on("vscode:listProcesses",async R=>{const j=[];try{j.push({name:(0,u.localize)(0,null),rootProcess:await(0,f.$pr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,p.$fm)(z)?j.push({name:z.hostName,rootProcess:z}):z.processes&&j.push({name:z.hostName,rootProcess:z.processes})})}catch(T){this.i.error(`Listing processes failed: ${T}`)}this.t(R,"vscode:listProcessesResponse",j)}),C.$FS.on("vscode:workbenchCommand",(R,j)=>{const{id:T,from:z,args:ne}=j;let ee;switch(z){case"processExplorer":ee=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}ee?.webContents.send("vscode:runAction",{id:T,from:z,args:ne})}),C.$FS.on("vscode:closeProcessExplorer",R=>{this.d?.close()}),C.$FS.on("vscode:pidToNameRequest",async R=>{const j=await this.k.getMainDiagnostics(),T=[];for(const z of j.windows)T.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:ne}of t.$f5b.getAll())T.push([z,ne]);this.t(R,"vscode:pidToNameResponse",T)})}async openReporter(R){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const j=new M.$lb,T=j.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,T,{backgroundColor:R.styles.backgroundColor,title:(0,u.localize)(1,null),zoomLevel:R.zoomLevel,alwaysOnTop:!1},"issue-reporter"),T.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:R,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:d.default}),this.b.loadURL(A.$4e.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(R){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const j=new M.$lb,T=j.add(this.n.createIPCObjectUrl()),z=this.p.getItem(m,void 0),ne=D(z)?z:this.v(this.f,800,500);this.d=this.u(ne,T,{backgroundColor:R.styles.backgroundColor,title:(0,u.localize)(2,null),zoomLevel:R.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:R,product:d.default}),this.d.loadURL(A.$4e.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const ee=()=>{if(!this.d)return;const ce=this.d.getSize(),se=this.d.getPosition();if(!ce||!se)return;const ae={width:ce[0],height:ce[1],x:se[0],y:se[1]};this.p.setItem(m,ae)};this.d.on("moved",ee),this.d.on("resized",ee)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const R=await E.contentTracing.stopRecording(`${(0,k.$Se)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null,R),buttons:[(0,u.localize)(5,null)]},E.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,R)}async getSystemStatus(){const[R,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(R,j)}async $getSystemInfo(){const[R,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(R,j)}async $getPerformanceInfo(){try{const[R,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(R,j)}catch(R){throw this.i.warn("issueService#getPerformanceInfo ",R.message),R}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(R){this.i.error(R)}}async $showConfirmCloseDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(6,null),buttons:[(0,u.localize)(7,null),(0,u.localize)(8,null)]},this.b);R===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(9,null),buttons:[(0,u.localize)(10,null),(0,u.localize)(11,null)]},this.b);return R===0}return!1}async $getIssueReporterUri(R){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");const T=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return n.Promises.withAsyncBody(async(z,ne)=>{const ee=new l.$rc;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",ee.token,{replyChannel:T,extensionId:R}),C.$FS.once(T,(ce,se)=>{z(r.URI.parse(se))});try{await(0,n.$Fg)(5e3),ee.cancel(),ne(new Error("Timed out waiting for issue reporter URI"))}finally{C.$FS.removeHandler(T)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(R){R.isMinimized()&&R.restore(),R.focus()}t(R,j,...T){R.sender.isDestroyed()||R.sender.send(j,...T)}u(R,j,T,z){const ne=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:R.width,height:R.height,minWidth:300,minHeight:200,x:R.x,y:R.y,title:T.title,backgroundColor:T.backgroundColor||o.a,webPreferences:{preload:A.$4e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,w.$SD)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return ne.setMenuBarVisibility(!1),ne}v(R,j,T){let z;const ne=E.screen.getAllDisplays();if(ne.length===1)z=ne[0];else{if(S.$j){const se=E.screen.getCursorScreenPoint();z=E.screen.getDisplayNearestPoint(se)}!z&&R&&(z=E.screen.getDisplayMatching(R.getBounds())),z||(z=E.screen.getPrimaryDisplay()||ne[0])}const ee=z.bounds,ce={width:j,height:T,x:ee.x+ee.width/2-j/2,y:ee.y+ee.height/2-T/2};return ee.width>0&&ee.height>0&&(ce.x<ee.x&&(ce.x=ee.x),ce.y<ee.y&&(ce.y=ee.y),ce.x>ee.x+ee.width&&(ce.x=ee.x),ce.y>ee.y+ee.height&&(ce.y=ee.y),ce.width>ee.width&&(ce.width=ee.width),ce.height>ee.height&&(ce.height=ee.height)),ce}};e.$B5b=I,e.$B5b=I=o=ke([_(1,h.$K4b),_(2,y.$3i),_(3,p.$em),_(4,$.$i5b),_(5,v.$$4b),_(6,b.$y5b),_(7,a.$A5b),_(8,c.$ij),_(9,g.$8M),_(10,i.$Y4b)],I);function D(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(te[298],ie([0,1,22,18,28,20,5,67,23,51,25,48,100]),function(G,e,E,C,s,M,A,S,f,u,p,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=void 0;let h=class extends v.$35b{constructor(b,d,c,a,w,k,g,t){super(b,d,a,w,k,t),this.e=c,this.u=g}s(b){return(0,v.$25b)(`linux-${process.arch}`,b,this.k)}t(b){this.a&&(this.d($.$FT.CheckingForUpdates(b)),this.i.request({url:this.a},E.CancellationToken.None).then(u.$Lo).then(d=>{!d||!d.url||!d.version||!d.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d($.$FT.Idle(1))):this.d($.$FT.AvailableForDownload(d))}).then(void 0,d=>{this.j.error(d),this.e.publicLog2("update:notAvailable",{explicit:!!b});const c=b?d.message||d:void 0;this.d($.$FT.Idle(1,c))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d($.$FT.Idle(1))}};e.$55b=h,e.$55b=h=ke([_(0,M.$M4b),_(1,C.$6h),_(2,p.$7k),_(3,s.$K4b),_(4,u.$Go),_(5,A.$3i),_(6,S.$y5b),_(7,f.$ij)],h)}),define(te[299],ie([0,1,47,45,27,8,22,55,9,7,142,21,18,28,16,20,5,67,23,51,25,48,100]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=void 0;async function l(o,m=1e3){for(;!o();)await(0,M.$Fg)(m)}let r;function i(){return typeof r>"u"&&(r=C.existsSync(f.$$c(f.$bd(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$35b{get cachePath(){const m=f.$$c((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return $.Promises.mkdir(m,{recursive:!0}).then(()=>m)}constructor(m,I,D,P,R,j,T,z,ne){super(m,I,P,R,j,ne),this.u=D,this.v=T,this.w=z,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(g.$FT.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(m){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,t.$25b)(I,m,this.k)}t(m){this.a&&(this.d(g.$FT.CheckingForUpdates(m)),this.i.request({url:this.a},A.CancellationToken.None).then(w.$Lo).then(I=>{const D=i();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!m}),this.d(g.$FT.Idle(D)),Promise.resolve(null)):D===1?(this.d(g.$FT.AvailableForDownload(I)),Promise.resolve(null)):(this.d(g.$FT.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(P=>$.Promises.exists(P).then(R=>{if(R)return Promise.resolve(P);const j=I.url,T=I.hash,z=`${P}.tmp`;return this.i.request({url:j},A.CancellationToken.None).then(ne=>this.v.writeFile(u.URI.file(z),ne.stream)).then(T?()=>(0,p.$AS)(z,I.hash):()=>{}).then(()=>$.Promises.rename(z,P,!1)).then(()=>P)})).then(P=>{const R=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:P},R?this.k.target==="user"?this.p():this.d(g.$FT.Downloaded(I)):this.d(g.$FT.Ready(I))})))}).then(void 0,I=>{this.j.error(I),this.u.publicLog2("update:notAvailable",{explicit:!!m});const D=m?I.message||I:void 0;this.d(g.$FT.Idle(i(),D))}))}async o(m){m.update.url&&this.w.openExternal(void 0,m.update.url),this.d(g.$FT.Idle(i()))}async B(m){const I=await this.cachePath;return f.$$c(I,`CodeSetup-${this.k.quality}-${m}.exe`)}async C(m=null){const I=m?j=>!new RegExp(`${this.k.quality}-${m}\\.exe$`).test(j):()=>!0,D=await this.cachePath,R=(await $.Promises.readdir(D)).filter(I).map(async j=>{try{await $.Promises.unlink(f.$$c(D,j))}catch{}});await Promise.all(R)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const m=this.state.update;this.d(g.$FT.Updating(m));const I=await this.cachePath;this.e.updateFilePath=f.$$c(I,`CodeSetup-${this.k.quality}-${m.version}.flag`),await $.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(g.$FT.Idle(i()))});const P=`${this.k.win32MutexName}-ready`,R=await new Promise((j,T)=>{G(["@vscode/windows-mutex"],j,T)});l(()=>R.isActive(P)).then(()=>this.d(g.$FT.Ready(m)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(m){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.d(g.$FT.Downloading(D)),this.e={packagePath:m},I?this.k.target==="user"?this.p():this.d(g.$FT.Downloaded(D)):this.d(g.$FT.Ready(D))}};e.$75b=n,ke([S.$4g],n.prototype,"cachePath",null),e.$75b=n=ke([_(0,b.$M4b),_(1,v.$6h),_(2,k.$7k),_(3,h.$K4b),_(4,w.$Go),_(5,d.$3i),_(6,y.$4j),_(7,c.$y5b),_(8,a.$ij)],n)}),define(te[300],ie([0,1,15,8,22,50,3,2,13,9,65,4,7,188,64,18,61,28,63,16,20,5,23,78,250,82,25,102,79,80,30,29,54,128,134,39,33,53,66,24]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g,t,l,r,i,n,o,m,I,D,P,R,j,T,z,ne,ee,ce,se){"use strict";var ae;Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=void 0;var J;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(J||(J={}));let Y=class extends S.$mb{static{ae=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.k}get lastFocusTime(){return this.l}get backupPath(){return this.m?.backupPath}get openedWorkspace(){return this.m?.workspace}get profile(){if(!this.config)return;const F=this.O.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.O.getProfileForWorkspace(this.config.workspace??(0,P.$Nh)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.m?.remoteAuthority}get config(){return this.m}get isExtensionDevelopmentHost(){return!!this.m?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.m?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.m?.debugId}constructor(F,U,H,Q,x,oe,K,O,L,N,W,q,V,re,$e,de,ue,me,we,Se){super(),this.J=U,this.L=H,this.M=Q,this.N=x,this.O=oe,this.P=K,this.Q=O,this.R=L,this.S=N,this.U=W,this.W=q,this.X=V,this.Y=re,this.Z=$e,this.$=de,this.ab=ue,this.bb=me,this.db=we,this.eb=Se,this.b=this.B(new A.$hc),this.onWillLoad=this.b.event,this.c=this.B(new A.$hc),this.onDidSignalReady=this.c.event,this.f=this.B(new A.$hc),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new A.$hc),this.onDidClose=this.g.event,this.h=this.B(new A.$hc),this.onDidDestroy=this.h.event,this.l=-1,this.s=void 0,this.t=void 0,this.w=!1,this.z=[],this.C=[],this.D=void 0,this.F=void 0,this.G=this.B(this.bb.createIPCObjectUrl()),this.I=!1,this.fb=0;{const[Oe,Le]=this.pb(F.state);this.n=Oe,this.J.trace("window#ctor: using window state",Oe);const ve=this.n.mode===0||this.n.mode===3,pe=this.S.getValue("window"),X={width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y,backgroundColor:this.U.getBackgroundColor(),minWidth:I.$LD.WIDTH,minHeight:I.$LD.HEIGHT,show:!ve,title:this.ab.nameLong,webPreferences:{preload:f.$4e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.G.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.$SD)(pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};$.$k?X.icon=(0,u.$$c)(this.M.appRoot,"resources/linux/code.png"):$.$i&&!this.M.isBuilt&&(X.icon=(0,u.$$c)(this.M.appRoot,"resources/win32/code_150x150.png")),$.$j&&!this.wb()&&(X.fullscreenable=!1),$.$j&&(X.acceptFirstMouse=!0,pe?.clickThroughInactive===!1&&(X.acceptFirstMouse=!1));const le=$.$j&&pe?.nativeTabs===!0;le&&(X.tabbingIdentifier=this.ab.nameShort);const fe=(0,I.$QD)(this.S)==="custom";if(fe&&(X.titleBarStyle="hidden",$.$j||(X.frame=!1),(0,I.$RD)(this.S))){const Ee=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Re=T.$Ls.fromHex(Ee).isDarker()?"#FFFFFF":"#000000";X.titleBarOverlay={height:29,color:Ee,symbolColor:Re},this.w=!0}if((0,p.mark)("code/willCreateCodeBrowserWindow"),this.k=new E.BrowserWindow(X),(0,p.mark)("code/didCreateCodeBrowserWindow"),this.j=this.k.id,$.$j&&fe&&this.k.setSheetOffset(22),fe&&($.$i&&(0,I.$RD)(this.S)||$.$j)){const Ee=this.eb.getItem(ae.a);Ee&&this.updateWindowControls({height:Ee})}$.$i&&fe&&this.k.hookWindowMessage(278,()=>{const[Re,Ne]=this.k.getPosition(),Ce=E.screen.getCursorScreenPoint(),ze=Ce.x-Re,We=Ce.y-Ne;return(()=>!(ze>30&&We>=0&&We<=Math.max(this.k.getBounds().height*.15,35)))()||(this.k.setEnabled(!1),this.k.setEnabled(!0),this.f.fire({x:ze,y:We})),0}),($.$j||$.$i)&&Le&&(!le||E.BrowserWindow.getAllWindows().length===1)&&[this.n.width,this.n.height,this.n.x,this.n.y].every(Ee=>typeof Ee=="number")&&this.k.setBounds({width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y}),ve&&((0,p.mark)("code/willMaximizeCodeWindow"),this.k.maximize(),this.n.mode===3&&this.sb(!0),this.k.show(),(0,p.mark)("code/didMaximizeCodeWindow")),this.l=Date.now()}this.M.args["open-devtools"]===!0&&this.k.webContents.openDevTools(),this.mb(),this.Ab(),this.gb()}setRepresentedFilename(F){$.$j?this.k.setRepresentedFilename(F):this.u=F}getRepresentedFilename(){return $.$j?this.k.getRepresentedFilename():this.u}setDocumentEdited(F){$.$j&&this.k.setDocumentEdited(F),this.v=F}isDocumentEdited(){return $.$j?this.k.isDocumentEdited():!!this.v}focus(F){$.$j&&F?.force&&E.app.focus({steal:!0}),this.k&&(this.k.isMinimized()&&this.k.restore(),this.k.focus())}setReady(){for(this.J.trace(`window#load: window reported ready (id: ${this.j})`),this.fb=2;this.z.length;)this.z.pop()(this);this.c.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.z.push(F)})}get isReady(){return this.fb===2}get whenClosedOrLoaded(){return new Promise(F=>{function U(){H.dispose(),Q.dispose(),F()}const H=this.onDidClose(()=>U()),Q=this.onWillLoad(()=>U())})}gb(){this.k.on("unresponsive",()=>this.jb(1)),this.k.webContents.on("render-process-gone",(U,H)=>this.jb(2,{...H})),this.k.webContents.on("did-fail-load",(U,H,Q)=>this.jb(3,{reason:Q,exitCode:H})),this.k.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this.k.on("closed",()=>{this.g.fire(),this.dispose()}),this.k.webContents.on("did-finish-load",()=>{this.H&&(this.m=this.H,this.H=void 0)}),this.k.on("focus",()=>{this.l=Date.now()}),this.k.on("maximize",U=>{this.m&&(this.m.maximized=!0),E.app.emit("browser-window-maximize",U,this.k)}),this.k.on("unmaximize",U=>{this.m&&(this.m.maximized=!1),E.app.emit("browser-window-unmaximize",U,this.k)}),this.k.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.k.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.B(this.S.onDidChangeConfiguration(U=>this.mb(U))),this.B(this.W.onDidDeleteUntitledWorkspace(U=>this.lb(U)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.k.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(U,H)=>{const Q=await this.ib();H({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,Q)})})}ib(){return this.hb||(this.hb=(0,r.$Zo)(this.ab.version,this.ab,this.M,this.S,this.P,this.Q,this.Y)),this.hb}async jb(F,U){switch(F){case 2:this.J.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.J.error("CodeWindow: detected unresponsive");break;case 3:this.J.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:F,reason:U?.reason,code:U?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.$.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.kb(!1,!1),this.$.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.k&&this.k.webContents&&this.k.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:Q}=await this.Z.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null),(0,h.localize)(2,null)],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),checkboxLabel:this.m?.workspace?(0,h.localize)(5,null):void 0},this.k);if(H!==2){const x=H===0;await this.kb(x,Q)}}else if(F===2){let H;U?H=(0,h.localize)(7,null,U.reason,U.exitCode??"<unknown>"):H=(0,h.localize)(6,null);const{response:Q,checkboxChecked:x}=await this.Z.showMessageBox({type:"warning",buttons:[this.m?.workspace?(0,h.localize)(8,null):(0,h.localize)(9,null),(0,h.localize)(10,null)],message:H,detail:this.m?.workspace?(0,h.localize)(11,null):(0,h.localize)(12,null),checkboxLabel:this.m?.workspace?(0,h.localize)(13,null):void 0},this.k),oe=Q===0;await this.kb(oe,x)}break}}async kb(F,U){const H=this.m?.workspace;if(U&&H)try{const Q=this.R.workspaceStorage(H);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.J.error(Q)}if(this.h.fire(),this.k?.destroy(),F&&this.m){let Q,x;(0,P.$Jh)(H)?Q={folderUri:H.uri}:(0,P.$Oh)(H)?Q={workspaceUri:H.configPath}:x=!0,(0,se.$Hf)(await this.db.open({context:5,userEnv:this.m.userEnv,cli:{...this.M.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:x,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}lb(F){this.m?.workspace?.id===F.id&&(this.m.workspace=void 0)}mb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const U=this.xb();U!==this.r&&(this.r=U,this.yb(U))}if(!F||F.affectsConfiguration("http.proxy")){let U=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.D||H!==this.F)){this.D=U,this.F=H;const Q=U||"",x=H?`${H},<local>`:"<local>";this.J.trace(`Setting proxy to '${Q}', bypassing '${x}'`),this.k.webContents.session.setProxy({proxyRules:Q,proxyBypassRules:x,pacScript:""})}}}addTabbedWindow(F){$.$j&&F.win&&this.k.addTabbedWindow(F.win)}load(F,U=Object.create(null)){this.J.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!U.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.k.setTitle(this.ab.nameLong)),this.nb(F,U),this.fb===0?this.m=F:this.H=F,this.fb=1,this.k.loadURL(f.$4e.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.I;this.I=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new C.$Qg(()=>{this.k&&!this.k.isVisible()&&!this.k.isMinimized()&&(this.k.show(),this.focus({force:!0}),this.k.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:F.workspace,reason:U.isReload?3:H?2:1})}nb(F,U){const H=(this.m??this.H)?.userEnv;if(H){const Q=(0,a.$El)(H)&&!(0,a.$El)(F.userEnv),x=this.isExtensionDevelopmentHost;(Q||x)&&(F.userEnv={...H,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(F["disable-extensions"]=U.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.k.isMaximized(),F.partsSplash=this.U.getWindowSplash(),(0,p.mark)("code/willOpenNewWindow"),F.perfMarks=(0,p.getMarks)(),this.G.update(F)}async reload(F){const U=Object.assign({},this.m);U.workspace=await this.ob(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&F&&(U.verbose=F.verbose,U.debugId=F.debugId,U.extensionEnvironment=F.extensionEnvironment,U["inspect-extensions"]=F["inspect-extensions"],U["inspect-brk-extensions"]=F["inspect-brk-extensions"],U["extensions-dir"]=F["extensions-dir"]),U.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.N.serialize(),U.continueOn=this.M.continueOn,U.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile,home:this.O.profilesHome},U.logLevel=this.L.getLogLevel(),U.loggers={window:this.L.getRegisteredLoggers(this.id),global:this.L.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async ob(F){if((0,P.$Oh)(F.workspace)){const U=F.workspace.configPath;if(U.scheme===f.Schemas.file&&!await this.P.exists(U))return}else if((0,P.$Jh)(F.workspace)){const U=F.workspace.uri;if(U.scheme===f.Schemas.file&&!await this.P.exists(U))return}return F.workspace}serializeWindowState(){if(!this.k)return(0,j.$J4b)();if(this.isFullScreen){let H;try{H=E.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,j.$J4b)();return{mode:3,display:H?H.id:void 0,width:this.n.width||Q.width,height:this.n.height||Q.height,x:this.n.x||0,y:this.n.y||0}}const F=Object.create(null);let U;if(!$.$j&&this.k.isMaximized()?U=0:U=1,U===0?F.mode=0:F.mode=1,U===1||U===0){let H;U===1?H=this.getBounds():H=this.k.getNormalBounds(),F.x=H.x,F.y=H.y,F.width=H.width,F.height=H.height}return F}updateWindowControls(F){if(F.height&&this.eb.setItem(ae.a,F.height),$.$i&&this.w)this.k.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if($.$j&&F.height!==void 0){const U=(F.height-15)/2;U?this.k.setWindowButtonPosition({x:U,y:U}):this.k.setWindowButtonPosition(null)}}pb(F){(0,p.mark)("code/willRestoreCodeWindowState");let U=!1;if(F)try{const H=E.screen.getAllDisplays();U=H.length>1,F=this.qb(F,H)}catch(H){this.J.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,p.mark)("code/didRestoreCodeWindowState"),[F||(0,j.$J4b)(),U]}qb(F,U){if(this.J.trace(`window#validateWindowState: validating window state on ${U.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.J.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.J.trace("window#validateWindowState: unexpected negative values");return}if(U.length===1){const x=this.rb(U[0]);if(x){let oe=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!x||(F.x<x.x&&(F.x=x.x),F.y<x.y&&(F.y=x.y))};this.J.trace("window#validateWindowState: 1 monitor working area",x),oe(),F.width>x.width&&(F.width=x.width),F.height>x.height&&(F.height=x.height),F.x>x.x+x.width-128&&(F.x=x.x+x.width-F.width),F.y>x.y+x.height-128&&(F.y=x.y+x.height-F.height),oe()}return F}if(F.display&&F.mode===3){const x=U.find(oe=>oe.id===F.display);if(x&&typeof x.bounds?.x=="number"&&typeof x.bounds?.y=="number"){this.J.trace("window#validateWindowState: restoring fullscreen to previous display");const oe=(0,j.$J4b)(3);return oe.x=x.bounds.x,oe.y=x.bounds.y,oe}}let H,Q;try{H=E.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),Q=this.rb(H)}catch{}if(H&&Q&&F.x+F.width>Q.x&&F.y+F.height>Q.y&&F.x<Q.x+Q.width&&F.y<Q.y+Q.height)return this.J.trace("window#validateWindowState: multi-monitor working area",Q),F}rb(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,U]=this.k.getPosition(),[H,Q]=this.k.getSize();return{x:F,y:U,width:H,height:Q}}toggleFullScreen(){this.sb(!this.isFullScreen)}sb(F){this.wb()?this.tb(F):this.vb(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.r&&this.yb(this.r,!1)}get isFullScreen(){return $.$j&&typeof this.s=="boolean"?this.s:this.k.isFullScreen()||this.k.isSimpleFullScreen()}tb(F){this.k.isSimpleFullScreen()&&this.k.setSimpleFullScreen(!1),this.ub(F)}ub(F){$.$j&&(this.s=F,this.t=new C.$Zg,Promise.race([this.t.p,(0,C.$Fg)(1e3)]).finally(()=>this.s=void 0)),this.k.setFullScreen(F)}vb(F){this.k.isFullScreen()&&this.ub(!1),this.k.setSimpleFullScreen(F),this.k.webContents.focus()}wb(){const F=this.S.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this.k.isMinimized()}xb(){let F=(0,I.$PD)(this.S);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}yb(F,U=!0){$.$j||(F==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,h.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.zb(F)}):this.zb(F))}zb(F){const U=this.isFullScreen;switch(F){case"classic":this.k.setMenuBarVisibility(!U),this.k.autoHideMenuBar=U;break;case"visible":this.k.setMenuBarVisibility(!0),this.k.autoHideMenuBar=!1;break;case"toggle":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!0;break;case"hidden":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if($.$j)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.k.minimize();break;case"None":break;case"Maximize":default:this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}else this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}close(){this.k?.close()}sendWhenReady(F,U,...H){this.isReady?this.send(F,...H):this.ready().then(()=>{U.isCancellationRequested||this.send(F,...H)})}send(F,...U){if(this.k){if(this.k.isDestroyed()||this.k.webContents.isDestroyed()){this.J.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.k.webContents.send(F,...U)}catch(H){this.J.warn(`Error sending IPC message to channel '${F}' of window ${this.j}: ${(0,M.$ki)(H)}`)}}}updateTouchBar(F){$.$j&&this.C.forEach((U,H)=>{const Q=F[H];U.segments=this.Cb(Q)})}Ab(){if($.$j){for(let F=0;F<10;F++){const U=this.Bb();this.C.push(U)}this.k.setTouchBar(new E.TouchBar({items:this.C}))}}Bb(F=[]){const U=this.Cb(F),H=new E.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[Q].id,from:"touchbar"})}});return H}Cb(F=[]){return F.map(H=>{let Q;H.icon&&!o.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(Q=E.nativeImage.createFromPath(v.URI.revive(H.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let x;return typeof H.title=="string"?x=H.title:x=H.title.value,{id:H.id,label:Q?void 0:x,icon:Q}})}dispose(){super.dispose(),this.L.deregisterLoggers(this.id),this.k=null}};e.$c6b=Y,e.$c6b=Y=ae=ke([_(1,g.$3i),_(2,ce.$Q5b),_(3,c.$K4b),_(4,z.$8m),_(5,ee.$S4b),_(6,w.$4j),_(7,i.$W4b),_(8,i.$U4b),_(9,b.$6h),_(10,m.$u5b),_(11,R.$d5b),_(12,y.$44b),_(13,n.$7k),_(14,d.$$4b),_(15,k.$M4b),_(16,t.$ij),_(17,l.$A5b),_(18,D.$Y4b),_(19,ne.$8M)],Y)}),define(te[83],ie([0,1,15,24,8,3,46,2,13,4,19,7,21,191,6,20,5,82,97,29,54,34]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$M5b=e.$L5b=void 0,e.$L5b=(0,y.$zh)("workspacesHistoryMainService");let l=class extends S.$mb{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,o,m){super(),this.f=i,this.g=n,this.h=o,this.j=m,this.c=this.B(new M.$hc),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new s.$Cg(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const I of i)if((0,a.$5T)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.r(n,I.workspace)&&n.push(I);else if((0,a.$6T)(I))this.s(n,I.folderUri)||n.push(I);else{const D=this.t(o,I.fileUri),P=I.fileUri.scheme===f.Schemas.file&&t.y.indexOf((0,p.$dg)(I.fileUri))>=0;!D&&!P&&(o.push(I),u.$i&&I.fileUri.scheme===f.Schemas.file&&E.app.addRecentDocument(I.fileUri.fsPath))}const m=await this.l({workspaces:n,files:o});n=m.workspaces,o=m.files,n.length>t.a&&(n.length=t.a),o.length>t.a&&(o.length=t.a),await this.n({workspaces:n,files:o}),this.c.fire(),u.$j&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const n=D=>{const P=this.p(D);for(const R of i)if(p.$0f.isEqual(R,P))return!1;return!0},o=await this.getRecentlyOpened(),m=o.workspaces.filter(n),I=o.files.filter(n);(m.length!==o.workspaces.length||I.length!==o.files.length)&&(await this.n({files:I,workspaces:m}),this.c.fire(),u.$j&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const n=new g.$xi(I=>p.$0f.getComparisonKey(I));if(i?.workspaces)for(const I of i.workspaces)n.set(this.p(I),I);const o=new g.$xi(I=>p.$0f.getComparisonKey(I));if(i?.files)for(const I of i.files)o.set(this.p(I),I);const m=await this.m();for(const I of m.workspaces){const D=n.get(this.p(I));D?D.label=D.label??I.label:n.set(this.p(I),I)}for(const I of m.files){const D=o.get(this.p(I));D?D.label=D.label??I.label:o.set(this.p(I),I)}return{workspaces:[...n.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,a.$_T)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,a.$aU)(i)),-1,1)}p(i){return(0,a.$6T)(i)?i.folderUri:(0,a.$7T)(i)?i.fileUri:i.workspace.configPath}r(i,n){return!!i.find(o=>(0,a.$5T)(o)&&o.workspace.id===n.id)}s(i,n){return!!i.find(o=>(0,a.$6T)(o)&&p.$0f.isEqual(o.folderUri,n))}t(i,n){return!!i.find(o=>p.$0f.isEqual(o.fileUri,n))}static{this.u=7}static{this.v=10}static{this.w=7}static{this.y=["COMMIT_EDITMSG","MERGE_MSG"]}async C(){u.$i&&(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!u.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const I of E.app.getJumpListSettings().removedItems){const D=I.args;if(D){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);P&&n.push($.URI.parse(P[2]))}}await this.removeRecentlyOpened(n);let o=!1;const m=(0,C.$Af)((await this.getRecentlyOpened()).workspaces.slice(0,t.w).map(I=>{const D=(0,a.$5T)(I)?I.workspace:I.folderUri,{title:P,description:R}=this.F(D,I.label);let j;return $.URI.isUri(D)?j=`--folder-uri "${D.toString()}"`:(o=!0,j=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:R.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));m.length>0&&i.push({type:"custom",name:o?(0,h.localize)(2,null):(0,h.localize)(3,null),items:m})}i.push({type:"recent"});try{const n=E.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}F(i,n){if(n)return{title:(0,A.$jA)(n).name,description:n};if($.URI.isUri(i))return{title:(0,p.$dg)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,h.localize)(4,null),description:""};let o=(0,p.$dg)(i.configPath);return o.endsWith(w.$Vh)&&(o=o.substr(0,o.length-w.$Vh.length-1)),{title:(0,h.localize)(5,null,o),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,A.$bA)(i.fsPath):i.toString()}async H(){if(!u.$j)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let I=0;I<i.workspaces.length&&o<t.u;I++){const D=this.p(i.workspaces[I]);if(D.scheme===f.Schemas.file){const P=(0,p.$7f)(D);await v.Promises.exists(P)&&(n.push(P),o++)}}const m=[];for(let I=0;I<i.files.length&&o<t.v;I++){const D=this.p(i.files[I]);if(D.scheme===f.Schemas.file){const P=(0,p.$7f)(D);if(t.y.includes((0,p.$dg)(D))||n.includes(P))continue;await v.Promises.exists(P)&&(m.push(P),o++)}}m.reverse().forEach(I=>E.app.addRecentDocument(I)),n.reverse().forEach(I=>E.app.addRecentDocument(I))}};e.$M5b=l,e.$M5b=l=t=ke([_(0,d.$3i),_(1,k.$d5b),_(2,b.$M4b),_(3,c.$W4b)],l)}),define(te[301],ie([0,1,15,8,22,46,4,7,179,18,28,20,5,228,67,23,33,25,48,80,30,83]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$N5b=void 0;const l="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(o,m,I,D,P,R,j,T,z,ne,ee){this.n=o,this.o=m,this.p=I,this.q=D,this.r=P,this.s=R,this.t=j,this.u=T,this.v=z,this.w=ne,this.x=ee,this.m=Object.create(null),this.g=new C.$Qg(()=>this.E(),0),this.h=new C.$Qg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.$j||(0,w.$QD)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(t.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(R,j,T)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.newWindow"]=(R,j,T)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.files.openFileFolder"]=(R,j,T)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:l}}),this.m["workbench.action.files.openFolder"]=(R,j,T)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:l}}),this.m["workbench.action.openWorkspace"]=(R,j,T)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:l}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.youTubeUrl;o&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(o,"openYouTubeUrl"));const m=this.x.requestFeatureUrl;m&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(m,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(I,"openReportIssues"));const D=this.x.licenseUrl;D&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.$v){const R=D.indexOf("?")>0?"&":"?";this.Z(`${D}${R}lang=${A.$v}`,"openLicenseUrl")}else this.Z(D,"openLicenseUrl")});const P=this.x.privacyStatementUrl;P&&D&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(P,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!A.$j)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,m){this.k=o.menus,this.l=o.keybindings,this.t.setItem(t.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){A.$j&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){A.$j&&(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=E.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(A.$j?new E.Menu:null);return}const m=new E.Menu;let I;if(A.$j){const P=new E.Menu;I=new E.MenuItem({label:this.x.nameShort,submenu:P}),this.I(P),m.append(I)}if(A.$j&&!this.c){this.c=!0;const P=new E.Menu;P.append(new E.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(P)}if(this.K("File")){const P=new E.Menu,R=new E.MenuItem({label:this.ab(f.localize(1,null)),submenu:P});this.M(P,"File"),m.append(R)}if(this.K("Edit")){const P=new E.Menu,R=new E.MenuItem({label:this.ab(f.localize(2,null)),submenu:P});this.M(P,"Edit"),m.append(R)}if(this.K("Selection")){const P=new E.Menu,R=new E.MenuItem({label:this.ab(f.localize(3,null)),submenu:P});this.M(P,"Selection"),m.append(R)}if(this.K("View")){const P=new E.Menu,R=new E.MenuItem({label:this.ab(f.localize(4,null)),submenu:P});this.M(P,"View"),m.append(R)}if(this.K("Go")){const P=new E.Menu,R=new E.MenuItem({label:this.ab(f.localize(5,null)),submenu:P});this.M(P,"Go"),m.append(R)}if(this.K("Run")){const P=new E.Menu,R=new E.MenuItem({label:this.ab(f.localize(6,null)),submenu:P});this.M(P,"Run"),m.append(R)}if(this.K("Terminal")){const P=new E.Menu,R=new E.MenuItem({label:this.ab(f.localize(7,null)),submenu:P});this.M(P,"Terminal"),m.append(R)}let D;if(this.K("Window")){const P=new E.Menu;D=new E.MenuItem({label:this.ab(f.localize(8,null)),submenu:P,role:"window"}),this.S(P)}if(D&&m.append(D),this.K("Help")){const P=new E.Menu,R=new E.MenuItem({label:this.ab(f.localize(9,null)),submenu:P,role:"help"});this.M(P,"Help"),m.append(R)}m.items&&m.items.length>0?E.Menu.setApplicationMenu(m):E.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const m=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.T();let D;if(this.K("Preferences")){const ce=new E.Menu;this.M(ce,"Preferences"),D=new E.MenuItem({label:this.ab(f.localize(11,null)),submenu:ce})}const P=new E.Menu,R=new E.MenuItem({label:f.localize(12,null),role:"services",submenu:P}),j=new E.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),T=new E.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new E.MenuItem({label:f.localize(15,null),role:"unhide"}),ne=new E.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ce,se,ae)=>{const J=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||J?.isMinimized())&&await this.J(ae)&&this.w.quit(void 0)}})),ee=[m];ee.push(...I),D&&ee.push(i(),D),ee.push(i(),R,i(),j,T,z,i(),ne),ee.forEach(ce=>o.append(ce))}async J(o){if(this.p.getWindowCount()===0)return!0;const m=this.o.getValue("window.confirmBeforeClose");if(m==="always"||m==="keyboardOnly"&&this.Q(o)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return I===0}return!0}K(o){if(!A.$j&&(0,w.$QD)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,m){m.forEach(I=>{if((0,h.$I5b)(I))o.append(i());else if((0,h.$H5b)(I)){const D=new E.Menu,P=new E.MenuItem({label:this.ab(I.label),submenu:D});this.L(D,I.submenu.items),o.append(P)}else(0,h.$J5b)(I)?o.append(this.O(I)):(0,h.$K5b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.N(o),A.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?o.append(new E.MenuItem(this.Y(I.id,{label:this.ab(I.label),click:this.m[I.id]}))):o.append(this.U(I.label,I.id,!1,I.checked)):o.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)):o.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)))})}M(o,m){this.k&&this.k[m]&&this.L(o,this.k[m].items)}N(o){const m=this.T();m.length&&(m.forEach(I=>o.append(I)),o.append(i()))}O(o){const m=S.URI.revive(o.uri),I=o.id,D=I==="openRecentFile"?{fileUri:m}:I==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new E.MenuItem(this.Y(I,{label:o.label,click:async(P,R,j)=>{const T=this.P(j);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[D],forceNewWindow:T,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([m])}},!1))}P(o){return!!(o&&(!A.$j&&(o.ctrlKey||o.shiftKey)||A.$j&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,m,I){const D={label:this.ab(o),role:I,enabled:!0};return new E.MenuItem(this.X(m,D))}S(o){const m=new E.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new E.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),D=new E.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),P=this.U(f.localize(23,null),"workbench.action.switchWindow"),R=[];this.C&&(R.push(i()),R.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),R.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,I,i(),P,...R,i(),D].forEach(j=>o.append(j))}T(){switch(this.n.state.type){case"idle":return[new E.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(o,m,I,D){const P=this.ab(o),R=typeof m=="function"?m:(ee,ce,se)=>{const ae=ee?ee.userSettingsLabel:null;let J=m;Array.isArray(m)&&(J=this.P(se)?m[1]:m[0]),ae&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ae}):this.W({type:"commandId",commandId:J})},j=typeof I=="boolean"?I:this.p.getWindowCount()>0,T=typeof D=="boolean"?D:!1,z={label:P,click:R,enabled:j};T&&(z.type="checkbox",z.checked=T);let ne;return typeof m=="string"?ne=m:Array.isArray(m)&&(ne=m[0]),A.$j&&(ne==="editor.action.clipboardCutAction"?z.role="cut":ne==="editor.action.clipboardCopyAction"?z.role="copy":ne==="editor.action.clipboardPasteAction"&&(z.role="paste"),ne==="undo"?z.click=this.V(R,{inDevTools:ee=>ee.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?z.click=this.V(R,{inDevTools:ee=>ee.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(z.click=this.V(R,{inDevTools:ee=>ee.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(ne,z))}V(o,m){return(I,D,P)=>{const R=E.BrowserWindow.getFocusedWindow();if(!R)return m.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return m.inDevTools(R.webContents.devToolsWebContents);o(I,D||R,P)}}W(o){let m=E.BrowserWindow.getFocusedWindow();if(!m){const D=this.p.getLastActiveWindow();D?.isMinimized()&&(m=D.win)}const I=m?this.p.getWindowById(m.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",o),A.$j&&!this.q.isBuilt&&!I.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const D={id:o.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,D)}else{const D={userSettingsLabel:o.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,D)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,m){const I=typeof o=="string"?this.l[o]:void 0;if(I?.label){if(I.isNative!==!1)m.accelerator=I.label,m.userSettingsLabel=I.userSettingsLabel;else if(typeof m.label=="string"){const D=m.label.indexOf("[");D>=0?m.label=`${m.label.substr(0,D)} [${I.label}]`:m.label=`${m.label} [${I.label}]`}}else m.accelerator=void 0;return m}Y(o,m,I=!m.accelerator){I&&(m=this.X(o,m));const D=m.click;return m.click=(P,R,j)=>{this.$(o),D?.(P,R,j)},m}Z(o,m){this.w.openExternal(void 0,o),this.$(m)}$(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:l})}ab(o){return(0,M.$gA)(o,!this.B)}};e.$N5b=r,e.$N5b=r=t=ke([_(0,a.$GT),_(1,u.$6h),_(2,k.$Y4b),_(3,p.$K4b),_(4,c.$7k),_(5,g.$L5b),_(6,d.$8M),_(7,$.$M4b),_(8,v.$3i),_(9,y.$y5b),_(10,b.$ij)],r);function i(){return new E.MenuItem({type:"separator"})}}),define(te[302],ie([0,1,6,20,5,301]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P5b=e.$O5b=void 0,e.$O5b=(0,E.$zh)("menubarMainService");let A=class{constructor(f,u,p){this.b=f,this.c=u,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$N5b)}async updateMenubar(f,u){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(u,f)}};e.$P5b=A,e.$P5b=A=ke([_(0,E.$yh),_(1,C.$M4b),_(2,s.$3i)],A)}),define(te[303],ie([0,1,15,21,131,27,24,22,3,32,49,46,2,13,9,65,4,35,19,12,7,189,64,18,61,28,16,6,20,5,77,78,60,33,80,300,130,296,29,98,83,54,79,39,53,66]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g,t,l,r,i,n,o,m,I,D,P,R,j,T,z,ne,ee,ce,se,ae,J,Y,B,F,U){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=void 0;function Q(K){return(0,ce.$Oh)(K?.workspace)}function x(K){return(0,ce.$Jh)(K?.workspace)}let oe=class extends v.$mb{static{H=this}static{this.a=[]}constructor(O,L,N,W,q,V,re,$e,de,ue,me,we,Se,Oe,Le,ve,pe,X){super(),this.k=O,this.l=L,this.m=N,this.n=W,this.r=q,this.s=V,this.t=re,this.u=$e,this.v=de,this.w=ue,this.z=me,this.C=we,this.D=Se,this.F=Oe,this.G=Le,this.H=ve,this.I=pe,this.J=X,this.b=this.B(new f.$hc),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$hc),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$hc),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$hc),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$hc),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ee.$d6b(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(O=>this.c.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const L=new v.$lb;if(L.add(f.Event.any(O.onDidClose,O.onDidDestroy)(()=>L.dispose())),O.config.extensionDevelopmentPath)for(const N of O.config.extensionDevelopmentPath)L.add(this.I.addValidFileRoot(N));O.config.extensionTestsPath&&L.add(this.I.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,L){const N=this.t.args,W=L?.remoteAuthority||void 0,q=!0,V=L?.forceReuseWindow,re=!V;return this.open({...O,cli:N,forceEmpty:q,forceNewWindow:re,forceReuseWindow:V,remoteAuthority:W})}openExistingWindow(O,L){O.focus(),this.M(L,[O])}async open(O){this.m.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const L=[],N=[],W=[],q=[],V=[];let re,$e=0;const de=await this.S(O);this.m.trace("windowsManager#open pathsToOpen",de);for(const Oe of de)x(Oe)?O.addMode?L.push(Oe):N.push(Oe):Q(Oe)?W.push(Oe):Oe.fileUri?(re||(re={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Oe.remoteAuthority}),re.filesToOpenOrCreate.push(Oe)):Oe.backupPath?V.push({backupFolder:(0,y.$cd)(Oe.backupPath),remoteAuthority:Oe.remoteAuthority}):$e++;O.diffMode&&re&&re.filesToOpenOrCreate.length>=2&&(re.filesToDiff=re.filesToOpenOrCreate.slice(0,2),re.filesToOpenOrCreate=[]),O.mergeMode&&re&&re.filesToOpenOrCreate.length===4&&(re.filesToMerge=re.filesToOpenOrCreate.slice(0,4),re.filesToOpenOrCreate=[],re.filesToDiff=[]),re&&O.waitMarkerFileURI&&(re.filesToWait={paths:(0,A.$Af)([...re.filesToDiff,re.filesToMerge[3],...re.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(q.push(...this.D.getUntitledWorkspaces()),W.push(...q),V.push(...this.w.getEmptyWindowBackups())):V.length=0;const{windows:ue,filesOpenedInWindow:me}=await this.N(O,W,N,V,$e,re,L);if(this.m.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${W.length}, foldersToOpen: ${N.length}, emptyToRestore: ${V.length}, emptyToOpen: ${$e})`),ue.length>1)if(me)me.focus();else{const Oe=this.j.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Le=!0,ve=!0;if(Oe){const pe=ue.filter(X=>this.j.state.lastActiveWindow&&X.backupPath===this.j.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ve=!1)}if(Le)for(let pe=ue.length-1;pe>=0;pe--){const X=ue[pe];if(!(X.openedWorkspace&&q.some(le=>X.openedWorkspace&&le.workspace.id===X.openedWorkspace.id)||X.backupPath&&V.some(le=>X.backupPath&&le.backupFolder===(0,y.$cd)(X.backupPath)))){X.focus(),ve=!1;break}}ve&&ue[ue.length-1].focus()}const we=re&&re.filesToDiff.length>0,Se=re&&re.filesToMerge.length>0;if(!ue.some(Oe=>Oe.isExtensionDevelopmentHost)&&!we&&!Se&&!O.noRecentEntry){const Oe=[];for(const Le of de)Q(Le)&&!Le.transient?Oe.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):x(Le)?Oe.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Oe.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.C.addRecentlyOpened(Oe)}return this.M(O,ue),ue}M(O,L){const N=O.waitMarkerFileURI;O.context===0&&N&&L.length===1&&L[0]&&(async()=>{await L[0].whenClosedOrLoaded;try{await this.H.del(N)}catch{}})()}async N(O,L,N,W,q,V,re){const $e=[];let de;function ue(pe,X){$e.push(pe),X&&(de=pe,V=void 0)}let{openFolderInNewWindow:me,openFilesInNewWindow:we}=this.fb(O);if(!O.initialStartup&&re.length>0){const pe=re[0].remoteAuthority,X=this.kb(pe);X&&ue(this.P(X,re.map(le=>le.workspace.uri)))}const Se=N.length+L.length+W.length;if(V&&Se===0){const pe=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],X=this.getWindows().filter(fe=>V&&(0,a.$lg)(fe.remoteAuthority,V.remoteAuthority));let le;pe?.fileUri&&!we&&((O.context===4||O.context===0||O.context===1)&&(le=await(0,ne.$a5b)(X,pe.fileUri,async fe=>fe.configPath.scheme===h.Schemas.file?this.D.resolveLocalWorkspace(fe.configPath):void 0)),le||(le=this.lb(X))),le?(0,ce.$Oh)(le.openedWorkspace)?L.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):(0,ce.$Jh)(le.openedWorkspace)?N.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):ue(this.O(O,le,V),!0):ue(await this.gb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Oe=(0,A.$Ff)(L,pe=>pe.workspace.id);if(Oe.length>0){const pe=(0,A.$Af)(Oe.map(X=>(0,ne.$b5b)(this.getWindows(),X.workspace.configPath)));if(pe.length>0){const X=pe[0],le=(0,a.$lg)(V?.remoteAuthority,X.remoteAuthority)?V:void 0;ue(this.O(O,X,le),!!le),me=!0}for(const X of Oe){if(pe.some(Ee=>Ee.openedWorkspace&&Ee.openedWorkspace.id===X.workspace.id))continue;const le=X.remoteAuthority,fe=(0,a.$lg)(V?.remoteAuthority,le)?V:void 0;ue(await this.R(O,X,me,fe),!!fe),me=!0}}const Le=(0,A.$Ff)(N,pe=>a.$0f.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,A.$Af)(Le.map(X=>(0,ne.$b5b)(this.getWindows(),X.workspace.uri)));if(pe.length>0){const X=pe[0],le=(0,a.$lg)(V?.remoteAuthority,X.remoteAuthority)?V:void 0;ue(this.O(O,X,le),!!le),me=!0}for(const X of Le){if(pe.some(Ee=>(0,ce.$Jh)(Ee.openedWorkspace)&&a.$0f.isEqual(Ee.openedWorkspace.uri,X.workspace.uri)))continue;const le=X.remoteAuthority,fe=(0,a.$lg)(V?.remoteAuthority,le)?V:void 0;ue(await this.R(O,X,me,fe),!!fe),me=!0}}const ve=(0,A.$Ff)(W,pe=>pe.backupFolder);if(ve.length>0)for(const pe of ve){const X=pe.remoteAuthority,le=(0,a.$lg)(V?.remoteAuthority,X)?V:void 0;ue(await this.Q(O,!0,X,le,pe),!!le),me=!0}if($e.length===0||V){V&&!q&&q++;const pe=V?V.remoteAuthority:O.remoteAuthority;for(let X=0;X<q;X++)ue(await this.Q(O,me,pe,V),!!V),me=!0}return{windows:(0,A.$Ff)($e),filesOpenedInWindow:de}}O(O,L,N){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),L.focus();const W={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return L.sendWhenReady("vscode:openFiles",S.CancellationToken.None,W),L}P(O,L){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:L}),O.focus();const N={foldersToAdd:L};return O.sendWhenReady("vscode:addFolders",S.CancellationToken.None,N),O}Q(O,L,N,W,q){this.m.trace("windowsManager#doOpenEmpty",{restore:!!q,remoteAuthority:N,filesToOpen:W,forceNewWindow:L});let V;return!L&&typeof O.contextWindowId=="number"&&(V=this.getWindowById(O.contextWindowId)),this.gb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:N,forceNewWindow:L,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:W,windowToUse:V,emptyWindowBackupInfo:q,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}R(O,L,N,W,q){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:L,filesToOpen:W}),!N&&!q&&typeof O.contextWindowId=="number"&&(q=this.getWindowById(O.contextWindowId)),this.gb({workspace:L.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:L.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:W,windowToUse:q,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async S(O){let L,N=!1,W=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(L=await this.U(O),N=!0):O.forceEmpty?L=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(L=await this.W(O.cli),L.length===0&&L.push(Object.create(null)),N=!0):(L=await this.Y(),L.length===0&&L.push(Object.create(null)),W=!0),!O.addMode&&N){const q=L.filter(V=>x(V));if(q.length>1){const V=q[0].remoteAuthority;if(q.every(re=>(0,a.$lg)(re.remoteAuthority,V))){const re=await this.D.createUntitledWorkspace(q.map($e=>({uri:$e.workspace.uri})));L.push({workspace:re,remoteAuthority:V}),L=L.filter($e=>!x($e))}}}if(O.initialStartup&&!W&&this.z.getValue("window")?.restoreWindows==="preserve"){const q=await this.Y();L.unshift(...q.filter(V=>Q(V)||x(V)||V.backupPath))}return L}async U(O){const L={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},N=await Promise.all((0,A.$Af)(O.urisToOpen||[]).map(async W=>{const q=await this.$(W,L);if(q)return q.label=W.label,q;const V=this.bb(W);this.G.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:V.scheme===h.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:V.scheme===h.Schemas.file?(0,g.localize)(3,null,(0,$.$aA)(V,{os:d.OS,tildify:this.t})):(0,g.localize)(4,null,V.toString(!0))},E.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.$Af)(N)}async W(O){const L=[],N={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},W=O["folder-uri"];if(W){const re=await Promise.all(W.map($e=>{const de=this.X($e);if(de)return this.$({folderUri:de},N)}));L.push(...(0,A.$Af)(re))}const q=O["file-uri"];if(q){const re=await Promise.all(q.map($e=>{const de=this.X($e);if(de)return this.$((0,ce.$5h)($e)?{workspaceUri:de}:{fileUri:de},N)}));L.push(...(0,A.$Af)(re))}const V=await Promise.all(O._.map(re=>N.remoteAuthority?this.eb(re,N):this.cb(re,N)));return L.push(...(0,A.$Af)(V)),L}X(O){try{const L=k.URI.parse(O);if(!L.scheme){this.m.error(`Invalid URI input string, scheme missing: ${O}`);return}return L.path?L:L.with({path:"/"})}catch(L){this.m.error(`Invalid URI input string: ${O}, ${L.message}`)}}async Y(){const O=this.Z();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const L=[];O!=="one"&&L.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&L.push(this.j.state.lastActiveWindow);const N=await Promise.all(L.map(async W=>{if(W.workspace){const q=await this.$({workspaceUri:W.workspace.configPath},{remoteAuthority:W.remoteAuthority,rejectTransientWorkspaces:!0});if(Q(q))return q}else if(W.folderUri){const q=await this.$({folderUri:W.folderUri},{remoteAuthority:W.remoteAuthority});if(x(q))return q}else if(O!=="folders"&&W.backupPath)return{backupPath:W.backupPath,remoteAuthority:W.remoteAuthority}}));return(0,A.$Af)(N)}}}Z(){let O;return this.v.wasRestarted?O="all":(O=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async $(O,L=Object.create(null)){const N=this.bb(O);return N.scheme===h.Schemas.file?((0,T.$OD)(O)&&(L={...L,forceOpenWorkspaceAsFile:!0}),this.cb(N.fsPath,L)):this.ab(O,L)}ab(O,L){let N=this.bb(O);const W=(0,R.$Mk)(N)||L.remoteAuthority;if(N=(0,a.$ng)((0,a.$hg)(N)),(0,T.$OD)(O)){if(L.gotoLineMode){const{path:q,line:V,column:re}=(0,u.$Re)(N.path);return{fileUri:N.with({path:q}),options:{selection:V?{startLineNumber:V,startColumn:re||1}:void 0},remoteAuthority:W}}return{fileUri:N,remoteAuthority:W}}else if((0,T.$MD)(O))return{workspace:(0,se.$64b)(N),remoteAuthority:W};return{workspace:(0,se.$74b)(N),remoteAuthority:W}}bb(O){return(0,T.$MD)(O)?O.workspaceUri:(0,T.$ND)(O)?O.folderUri:O.fileUri}async cb(O,L,N){let W,q;L.gotoLineMode&&({path:O,line:W,column:q}=(0,u.$Re)(O)),O=(0,u.$Me)((0,y.$9c)(O),(0,c.cwd)());try{const V=await C.Promises.stat(O);if(V.isFile()){if(!L.forceOpenWorkspaceAsFile){const re=await this.D.resolveLocalWorkspace(k.URI.file(O));if(re)return re.transient&&L.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:n.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:k.URI.file(O),type:n.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:q||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,se.$74b)(k.URI.file(O),V),type:n.FileType.Directory,exists:!0};if(!d.$i&&O==="/dev/null")return{fileUri:k.URI.file(O),type:n.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!N)return this.db(O,L);const re=k.URI.file(O);if(this.C.removeRecentlyOpened([re]),L.ignoreFileNotFound)return{fileUri:re,type:n.FileType.File,exists:!1}}}async db(O,L){const N=k.URI.file(O),{response:W,checkboxChecked:q}=await this.G.showMessageBox({type:"warning",buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null),(0,g.localize)(7,null)],message:(0,g.localize)(8,null,N.authority),detail:(0,g.localize)(9,null,(0,$.$aA)(N,{os:d.OS,tildify:this.t})),checkboxLabel:(0,g.localize)(10,null,N.authority),cancelId:1});if(W===0)return(0,s.addUNCHostToAllowlist)(N.authority),q&&this.B(f.Event.once(this.onDidOpenWindow)(V=>{V.sendWhenReady("vscode:configureAllowedUNCHost",S.CancellationToken.None,N.authority)})),this.cb(O,L,!0);if(W===2)return E.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.db(O,L)}eb(O,L){const N=O.charCodeAt(0),W=L.remoteAuthority;let q,V;L.gotoLineMode&&({path:O,line:q,column:V}=(0,u.$Re)(O)),N!==47&&((0,u.$Le)(N)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,u.$Ee)(O)),O=`/${O}`);const re=k.URI.from({scheme:h.Schemas.vscodeRemote,authority:W,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,ce.$5h)(O))return L.forceOpenWorkspaceAsFile?{fileUri:re,options:{selection:q?{startLineNumber:q,startColumn:V||1}:void 0},remoteAuthority:L.remoteAuthority}:{workspace:(0,se.$64b)(re),remoteAuthority:W};if(L.gotoLineMode||y.$8c.basename(O).indexOf(".")!==-1)return{fileUri:re,options:{selection:q?{startLineNumber:q,startColumn:V||1}:void 0},remoteAuthority:W}}return{workspace:(0,se.$74b)(re),remoteAuthority:W}}fb(O){const L=this.z.getValue("window"),N=L?.openFoldersInNewWindow||"default",W=L?.openFilesInNewWindow||"off";let q=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(N==="on"||N==="off")&&(q=N==="on");let V=!1;return O.forceNewWindow||O.forceReuseWindow?V=!!O.forceNewWindow&&!O.forceReuseWindow:(d.$j?O.context===1&&(V=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!O.cli.extensionDevelopmentPath&&(W==="on"||W==="off")&&(V=W==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(O,L){const N=(0,ne.$c5b)(this.getWindows(),O);if(N)return this.v.reload(N,L.cli),N.focus(),[N];let W=L.cli["folder-uri"]||[],q=L.cli["file-uri"]||[],V=L.cli._;if(!V.length&&!W.length&&!q.length&&!L.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(k.URI.isUri(ue)?ue.scheme===h.Schemas.file?V=[ue.fsPath]:W=[ue.toString()]:ue.configPath.scheme===h.Schemas.file?V=[(0,a.$7f)(ue.configPath)]:q=[ue.configPath.toString()])}let re=L.remoteAuthority;for(const de of O)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=k.URI.parse(de),me=(0,R.$Mk)(ue);me&&(re?(0,a.$lg)(me,re)||this.m.error("more than one extension development path authority"):re=me)}V=V.filter(de=>{const ue=k.URI.file(de);return(0,ne.$b5b)(this.getWindows(),ue)?!1:(0,a.$lg)((0,R.$Mk)(ue),re)}),W=W.filter(de=>{const ue=this.X(de);return ue&&(0,ne.$b5b)(this.getWindows(),ue)?!1:ue?(0,a.$lg)((0,R.$Mk)(ue),re):!1}),q=q.filter(de=>{const ue=this.X(de);return ue&&(0,ne.$b5b)(this.getWindows(),ue)?!1:ue?(0,a.$lg)((0,R.$Mk)(ue),re):!1}),L.cli._=V,L.cli["folder-uri"]=W,L.cli["file-uri"]=q;const $e={context:L.context,cli:L.cli,forceNewWindow:!0,forceEmpty:!V.length&&!W.length&&!q.length,userEnv:L.userEnv,noRecentEntry:!0,waitMarkerFileURI:L.waitMarkerFileURI,remoteAuthority:re,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile};return this.open($e)}async gb(O){const L=this.z.getValue("window"),N=this.getLastActiveWindow(),W=N?.profile??this.u.defaultProfile;let q;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(q=O.windowToUse||N,q&&q.focus());const V={...this.t.args,...O.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,y.$$c)(this.t.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:W},homeDir:this.t.userHome.with({scheme:h.Schemas.file}).fsPath,tmpDir:this.t.tmpDir.with({scheme:h.Schemas.file}).fsPath,userDataDir:this.t.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.l,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.with({scheme:h.Schemas.file}).fsPath,product:D.default,isInitialStartup:O.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof L?.zoomLevel=="number"?L.zoomLevel:void 0,autoDetectHighContrast:L?.autoDetectHighContrast??!0,autoDetectColorScheme:L?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(q){const re=q.config;!V.extensionDevelopmentPath&&re?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=re.extensionDevelopmentPath,V.extensionDevelopmentKind=re.extensionDevelopmentKind,V["enable-proposed-api"]=re["enable-proposed-api"],V.verbose=re.verbose,V["inspect-extensions"]=re["inspect-extensions"],V["inspect-brk-extensions"]=re["inspect-brk-extensions"],V.debugId=re.debugId,V.extensionEnvironment=re.extensionEnvironment,V["extensions-dir"]=re["extensions-dir"],V["disable-extensions"]=re["disable-extensions"]),V.loggers={global:V.loggers.global,window:re?.loggers.window??V.loggers.window}}else{const re=this.j.getNewWindowState(V);(0,b.mark)("code/willCreateCodeWindow");const $e=q=this.F.createInstance(z.$c6b,{state:re,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,b.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow($e),H.a.push($e),this.b.fire($e),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,p.$bb)($e.onDidSignalReady)(()=>this.c.fire($e)),(0,p.$bb)($e.onDidClose)(()=>this.jb($e)),(0,p.$bb)($e.onDidDestroy)(()=>this.f.fire($e)),$e.onDidTriggerSystemContextMenu(({x:ue,y:me})=>this.h.fire({window:$e,x:ue,y:me}));const de=(0,w.$we)($e.win?.webContents);de.removeAllListeners("devtools-reload-page"),de.on("devtools-reload-page",()=>this.v.reload($e)),this.v.registerWindow($e)}return V.windowId=q.id,q.isReady?this.v.unload(q,4).then(async re=>{re||await this.hb(q,V,O,W)}):await this.hb(q,V,O,W),q}async hb(O,L,N,W){if(L.extensionDevelopmentPath||((0,ce.$Oh)(L.workspace)?L.backupPath=this.w.registerWorkspaceBackup({workspace:L.workspace,remoteAuthority:L.remoteAuthority}):(0,ce.$Jh)(L.workspace)?L.backupPath=this.w.registerFolderBackup({folderUri:L.workspace.uri,remoteAuthority:L.remoteAuthority}):L.backupPath=this.w.registerEmptyWindowBackup({backupFolder:N.emptyWindowBackupInfo?.backupFolder??(0,se.$84b)().id,remoteAuthority:L.remoteAuthority})),this.u.isEnabled()){const q=L.workspace??(0,ce.$Nh)(L.backupPath,!1),V=this.ib(N,q,W),re=V instanceof Promise?await V:V;L.profiles.profile=re,L.extensionDevelopmentPath||await this.u.setProfileForWorkspace(q,re)}O.load(L)}ib(O,L,N){return O.forceProfile?this.u.profiles.find(W=>W.name===O.forceProfile)??this.u.createNamedProfile(O.forceProfile):O.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(L)??N}jb(O){const L=H.a.indexOf(O);H.a.splice(L,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=E.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(O){return this.lb(this.getWindows().filter(L=>(0,a.$lg)(L.remoteAuthority,O)))}lb(O){const L=Math.max.apply(Math,O.map(N=>N.lastFocusTime));return O.find(N=>N.lastFocusTime===L)}sendToFocused(O,...L){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,S.CancellationToken.None,...L)}sendToAll(O,L,N){for(const W of this.getWindows())N&&N.indexOf(W.id)>=0||W.sendWhenReady(O,S.CancellationToken.None,L)}getWindows(){return H.a}getWindowCount(){return H.a.length}getWindowById(O){const L=this.getWindows().filter(N=>N.id===O);return(0,A.$Hf)(L)}getWindowByWebContents(O){const L=E.BrowserWindow.fromWebContents(O);if(L)return this.getWindowById(L.id)}};e.$g6b=oe,e.$g6b=oe=H=ke([_(2,I.$3i),_(3,U.$Q5b),_(4,j.$8M),_(5,B.$8m),_(6,i.$K4b),_(7,F.$S4b),_(8,m.$M4b),_(9,t.$44b),_(10,l.$6h),_(11,ae.$L5b),_(12,J.$d5b),_(13,o.$yh),_(14,r.$$4b),_(15,n.$4j),_(16,P.$A5b),_(17,Y.$u5b)],oe)}),define(te[304],ie([0,1,64,30,83,54]),function(G,e,E,C,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i6b=void 0;let A=class{constructor(f,u,p,$){this.a=f,this.b=u,this.c=p,this.d=$,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,u){const p=this.b.getWindowById(f);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),u)}createUntitledWorkspace(f,u,p){return this.a.createUntitledWorkspace(u,p)}deleteUntitledWorkspace(f,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(f,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(f,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$i6b=A,e.$i6b=A=ke([_(0,M.$d5b),_(1,C.$Y4b),_(2,s.$L5b),_(3,E.$44b)],A)}),define(te[305],ie([0,1,15,131,38,27,17,50,14,32,49,44,46,2,13,9,4,12,7,31,146,42,157,110,287,160,64,283,18,198,90,132,61,115,217,28,63,94,207,232,208,292,117,209,210,16,221,93,75,6,92,216,297,284,272,20,5,302,67,23,60,293,95,33,275,82,122,25,249,251,52,48,263,289,298,290,299,127,265,266,267,270,273,30,303,274,29,97,83,304,54,39,230,53,242,51,81,129,277,291,280,8,253,276,225,66,91,295,269,24,125,294,261,237,84]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g,t,l,r,i,n,o,m,I,D,P,R,j,T,z,ne,ee,ce,se,ae,J,Y,B,F,U,H,Q,x,oe,K,O,L,N,W,q,V,re,$e,de,ue,me,we,Se,Oe,Le,ve,pe,X,le,fe,Ee,Re,Ne,Ce,ze,We,Z,he,ge,ye,De,Fe,Me,Te,Be,qe,He,xe,Qe,tt,st,gt,rt,$t,mt,wt,bt,pt,yt,vt,ot,kt,Et,St,Pt,It,at,At,ht,ct,Dt,Ot,lt,Rt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=void 0;let ut=class extends h.$mb{constructor(Ie,Pe,be,je,Ae,Ue,Ke,Ze,Xe,Ge,Ve,Je){super(),this.c=Ie,this.f=Pe,this.g=be,this.h=je,this.i=Ae,this.j=Ue,this.k=Ke,this.l=Ze,this.m=Xe,this.n=Ge,this.p=Ve,this.s=Je,this.t(),this.u()}t(){const Ie=Ge=>Ge?.startsWith(`${y.Schemas.vscodeWebview}://`),Pe=new Set(this.p.quality==="stable"?[]:["media"]),be=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ge,Ve,Je,Ye)=>Ie(Ye.requestingUrl)?Je(be.has(Ve)):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Je(Pe.has(Ve)):Je(!1)),E.session.defaultSession.setPermissionCheckHandler((Ge,Ve,Je,Ye)=>Ie(Ye.requestingUrl)?be.has(Ve):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Pe.has(Ve):!1);const je=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),Ae=Ge=>{for(let Ve=Ge;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ue=Ge=>Ge.resourceType==="xhr"||Ae(Ge.frame),Ke=Ge=>{const Ve=Ge.frame;if(!Ve||!this.a)return!1;const Je=E.BrowserWindow.getAllWindows();for(const Ye of Je)if(Ve.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ze=(Ge,Ve)=>{if(Ge.path!=="/index.html")return!0;const Je=Ve.frame;if(!Je||!this.a)return!1;for(const Ye of this.a.getWindows())if(Ye.win&&Je.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ge,Ve)=>{const Je=a.URI.parse(Ge.url);return Je.scheme===y.Schemas.vscodeWebview&&!Ze(Je,Ge)?(this.h.error("Blocked vscode-webview request",Ge.url),Ve({cancel:!0})):Je.scheme===y.Schemas.vscodeFileResource&&!Ke(Ge)?(this.h.error("Blocked vscode-file request",Ge.url),Ve({cancel:!0})):Je.path.endsWith(".svg")&&!je.has(Je.scheme)?Ve({cancel:!Ue(Ge)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ge,Ve)=>{const Je=Ge.responseHeaders,Ye=Je["content-type"]||Je["Content-Type"];if(Ye&&Array.isArray(Ye)){const it=a.URI.parse(Ge.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return Je["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Je});if(!it.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(_e=>_e.toLowerCase().includes("image/svg")))return Ve({cancel:!Ue(Ge)})}return Ve({cancel:!1})});const Xe=E.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.j.codeCachePath&&Xe.setCodeCachePath((0,b.$$c)(this.j.codeCachePath,"chrome")),d.$i&&(this.l.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.l.getValue("security.allowedUNCHosts")))}u(){(0,f.setUnexpectedErrorHandler)(be=>this.w(be)),process.on("uncaughtException",be=>{(0,f.$X)(be)||(0,f.$Y)(be)}),process.on("unhandledRejection",be=>(0,f.$Y)(be)),this.k.onWillShutdown(()=>this.dispose()),(0,k.$GS)(),E.app.on("accessibility-support-changed",(be,je)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",je)}),E.app.on("activate",async(be,je)=>{this.h.trace("app#activate"),je||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(be,je)=>{je.on("will-navigate",Ae=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),je.setWindowOpenHandler(({url:Ae})=>(this.b?.openExternal(void 0,Ae),{action:"deny"}))});let Ie=[],Pe;E.app.on("open-file",(be,je)=>{this.h.trace("app#open-file: ",je),be.preventDefault(),Ie.push((0,qe.$5h)(je)?{workspaceUri:a.URI.file(je)}:{fileUri:a.URI.file(je)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.j.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Pe=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.$FS.handle("vscode:fetchShellEnv",be=>{const je=this.a?.getWindowByWebContents(be.sender);let Ae,Ue;return je?.config?(Ae=je.config,Ue={...process.env,...je.config.userEnv}):(Ae=this.j.args,Ue=process.env),this.O(Ae,Ue,!1)}),s.$FS.handle("vscode:writeNlsFile",(be,je,Ae)=>{const Ue=this.v([je]);if(!Ue||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.n.writeFile(Ue,A.$Hc.fromString(Ae))}),s.$FS.handle("vscode:readNlsFile",async(be,...je)=>{const Ae=this.v(je);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.n.readFile(Ae)).value.toString()}),s.$FS.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),s.$FS.on("vscode:openDevTools",be=>be.sender.openDevTools()),s.$FS.on("vscode:reloadWindow",be=>be.sender.reload())}v(Ie){let Pe;for(const be of Ie)typeof be=="string"&&(typeof Pe!="string"?Pe=be:Pe=(0,b.$$c)(Pe,be));if(!(typeof Pe!="string"||!(0,b.$0c)(Pe)||!(0,u.$Ke)(Pe,this.j.cachedLanguagesPath,!d.$k)))return a.URI.file(Pe)}w(Ie){if(Ie){const Pe={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.h.error(Ie.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.j.appRoot}`),this.h.debug("args:",this.j.args);const Ie=this.p.win32AppUserModelId;d.$i&&Ie&&E.app.setAppUserModelId(Ie);try{d.$j&&this.l.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Xe){this.h.error(Xe)}const Pe=new t.$MS;this.k.onWillShutdown(Xe=>{Xe.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const be=await(0,kt.$p6b)(this.m,this.h);this.h.trace(`Resolved machine identifier: ${be}`);const{sharedProcessReady:je,sharedProcessClient:Ae}=this.H(be),Ue=await this.I(be,je);this.B(Ue.createInstance(r.$Z4b)),this.B(Ue.createInstance(yt.$m6b)),Ue.invokeFunction(Xe=>this.J(Xe,Pe,Ae));const Ke=Ue.invokeFunction(Xe=>this.y(Xe,Pe));this.z(Pe),this.k.phase=2,await Ue.invokeFunction(Xe=>this.L(Xe,Ke)),this.k.phase=3,this.M(),this.B(new ot.$Qg(()=>{this.B((0,ot.$Ug)(()=>this.k.phase=4,2500))},2500)).schedule()}y(Ie,Pe){const be=this.a=Ie.get(Me.$Y4b),je=Ie.get(Z.$uT),Ae=this.b=Ie.get($e.$y5b),Ue=this;je.registerHandler({async handleURL(Je,Ye){return Ue.G(be,je,Je,Ye)}});const Ke=this.B(new Be.$h6b({onDidOpenWindow:Ae.onDidOpenWindow,onDidFocusWindow:Ae.onDidFocusWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),Ze=new g.$hh(Je=>Ke.getActiveClientId().then(Ye=>Je===Ye)),Xe=new he.$05b(Ze,this.h),Ge=Pe.getChannel("urlHandler",Xe);je.registerHandler(new he.$95b(Ge));const Ve=this.C();return this.B(new ye.$$5b(Ve?.urls,je,be,this.j,this.p,this.h)),Ve}z(Ie){const Pe=()=>({statusCode:404,data:"Not found"}),be=new Rt.$T(()=>Ie.getChannel(lt.$w6b,new lt.$x6b));E.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(je,Ae)=>{const Ue=a.URI.parse(je.url);if(!Ue.authority.startsWith("window:"))return Ae(Pe());be.value.call(lt.$v6b,[Ue]).then(Ke=>Ae({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.h.warn("error dispatching remote resource call",Ke),Ae({statusCode:500,data:String(Ke)})})})}C(){const Ie=this.j.args["open-url"]?this.j.args._urls||[]:[];Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ie);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ie.length+Pe.length===0)return;const be=[];return{urls:[...Ie,...Pe].map(Ae=>{try{return{uri:a.URI.parse(Ae),originalUrl:Ae}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ae);return}}).filter(Ae=>{if(!Ae)return!1;if(this.D(Ae.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ae.uri.toString(!0)),!1;const Ue=this.F(Ae.uri);return Ue?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ae.uri.toString(!0),Ue),be.push(Ue),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ae.uri.toString(!0)),!0)}),openables:be}}D(Ie){if(Ie.authority===y.Schemas.file&&d.$i){const{options:Pe,buttonIndeces:be}=(0,It.$oA)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.$aA)(Ie,{os:d.OS,tildify:this.j}),this.p.nameShort),detail:(0,i.localize)(3,null)},this.p);if(be[E.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}F(Ie){if(Ie.path){if(Ie.authority===y.Schemas.file){const Pe=a.URI.file(Ie.fsPath);return(0,qe.$5h)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ie.authority===y.Schemas.vscodeRemote){const Pe=Ie.path.indexOf(b.$8c.sep,1);if(Pe!==-1){const be=Ie.path.substring(1,Pe),je=Ie.path.substring(Pe);let Ae=Ie.query;const Ue=new URLSearchParams(Ie.query);Ue.get("windowId")==="_blank"&&(Ue.delete("windowId"),Ae=Ue.toString());const Ke=a.URI.from({scheme:y.Schemas.vscodeRemote,authority:be,path:je,query:Ae,fragment:Ie.fragment});return(0,qe.$5h)(je)?{workspaceUri:Ke}:/:[\d]+$/.test(je)?{fileUri:Ke}:{folderUri:Ke}}}}}async G(Ie,Pe,be,je){if(this.h.trace("app#handleProtocolUrl():",be.toString(!0),je),be.scheme===this.p.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:a.URI.parse(be.query).path,query:""})),this.D(be))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0;let Ae=!1;const Ue=new URLSearchParams(be.query);Ue.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),Ue.delete("windowId"),be=be.with({query:Ue.toString()}),Ae=!0):d.$j&&Ie.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),Ae=!0);const Ke=Ue.get("continueOn");Ke!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),Ue.delete("continueOn"),be=be.with({query:Ue.toString()}),this.j.continueOn=Ke??void 0);const Ze=this.F(be);return Ze?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ze,be.toString(!0)),(0,ht.$Hf)(await Ie.open({context:5,cli:{...this.j.args},urisToOpen:[Ze],forceNewWindow:Ae,gotoLineMode:!0}))?.focus(),!0):Ae?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,ht.$Hf)(await Ie.open({context:5,cli:{...this.j.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.$Mk)(be)}))?.ready(),Pe.open(be,je)):(this.h.trace("app#handleProtocolUrl(): not handled",be.toString(!0),je),!1)}H(Ie){const Pe=this.B(this.g.createInstance(me.$V5b,Ie)),be=(async()=>{this.h.trace("Main->SharedProcess#connect");const Ae=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new l.$NS(Ae,"main")})();return{sharedProcessReady:(async()=>(await Pe.whenReady(),be))(),sharedProcessClient:be}}async I(Ie,Pe){const be=new K.$xh;switch(process.platform){case"win32":be.set(Ee.$GT,new x.$wh(We.$75b));break;case"linux":d.$l?be.set(Ee.$GT,new x.$wh(ze.$65b,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(Ee.$GT,new x.$wh(Ce.$55b));break;case"darwin":be.set(Ee.$GT,new x.$wh(Ne.$45b));break}be.set(Me.$Y4b,new x.$wh(Te.$g6b,[Ie,this.f],!1));const je=new R.$_4b(this.h,this.p);be.set(R.$$4b,je),be.set(W.$F5b,new x.$wh(W.$G5b,void 0,!1)),be.set(P.$i5b,new x.$wh(P.$j5b,void 0,!1)),be.set(D.$em,g.ProxyChannel.toService((0,g.$fh)(Pe.then(Xe=>Xe.getChannel("diagnostics"))))),be.set(O.$Ysb,new x.$wh(L.$B5b,[this.f])),be.set(j.$oT,new x.$wh(T.$k5b)),be.set(N.$C5b,new x.$wh(N.$D5b)),be.set($e.$y5b,new x.$wh($e.$z5b,void 0,!1)),be.set(De.$_5b,new x.$wh(Fe.$b6b)),be.set(re.$O5b,new x.$wh(re.$P5b)),be.set(ce.$Gkb,new x.$wh(se.$l5b)),be.set(ae.$m5b,new x.$wh(J.$o5b)),be.set(Le.$U4b,new x.$wh(Le.$V4b)),be.set(Le.$W4b,new x.$wh(Le.$X4b));const Ae=new Dt.$u6b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.l.getValue("terminal.integrated.persistentSessionScrollback")??100},this.l,this.j,this.k,this.h),Ue=new Ot.$ir(Ae,this.l,this.h,this.i);be.set(ct.$Vq,Ue),d.$i?be.set(Y.$BWb,new x.$wh(B.$p5b)):d.$j?be.set(Y.$BWb,new x.$wh(B.$q5b)):d.$k&&be.set(Y.$BWb,new x.$wh(B.$r5b));const Ke=new o.$94b(this.j,this.l,this.h,this.m);be.set(n.$44b,Ke);const Ze=new tt.$e5b(this.j,this.h,this.s,Ke,je);if(be.set(tt.$d5b,Ze),be.set(He.$4T,new x.$wh(Qe.$i6b,void 0,!1)),be.set(xe.$L5b,new x.$wh(xe.$M5b,void 0,!1)),be.set(Z.$uT,new x.$wh(ge.$wT,void 0,!1)),(0,fe.$fo)(this.p,this.j)){const Xe=(0,fe.$ko)(this.p,this.l),Ge=(0,g.$fh)(Pe.then(_e=>_e.getChannel("telemetryAppender"))),Ve=new X.$Y5b(Ge),Je=(0,ve.$8n)((0,M.release)(),(0,M.hostname)(),process.arch,this.p.commit,this.p.version,Ie,Xe),Ye=(0,fe.$lo)(this.j),it={appenders:[Ve],commonProperties:Je,piiPaths:Ye,sendErrorTelemetry:!0};be.set(pe.$7k,new x.$wh(le.$Nq,[it],!1))}else be.set(pe.$7k,fe.$_n);return be.set(wt.$hp,new x.$wh(Et.$cN,void 0,!0)),be.set(bt.$lp,new x.$wh(pt.$l6b,void 0,!0)),be.set(at.$s6b,new x.$wh(at.$t6b,void 0,!0)),await ot.Promises.settled([Ke.initialize(),Ze.initialize()]),this.g.createChild(be)}J(Ie,Pe,be){const je=g.ProxyChannel.fromService(Ie.get(W.$F5b),{disableMarshalling:!0});this.c.registerChannel("launch",je);const Ae=g.ProxyChannel.fromService(Ie.get(P.$i5b),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Ae);const Ue=new gt.$j6b(Ie.get(st.$8m));Pe.registerChannel("policy",Ue),be.then(et=>et.registerChannel("policy",Ue));const Ke=this.n.getProvider(y.Schemas.file);(0,c.$ve)(Ke instanceof Q.$Zp);const Ze=new H.$s5b(Ke,this.h,this.j);Pe.registerChannel(F.$XM,Ze),be.then(et=>et.registerChannel(F.$XM,Ze));const Xe=g.ProxyChannel.fromService(Ie.get(rt.$S4b));Pe.registerChannel("userDataProfiles",Xe),be.then(et=>et.registerChannel("userDataProfiles",Xe));const Ge=new $t.$Iq(Ie.get(mt.$Go));be.then(et=>et.registerChannel("request",Ge));const Ve=new Re.$Z5b(Ie.get(Ee.$GT));Pe.registerChannel("update",Ve);const Je=g.ProxyChannel.fromService(Ie.get(O.$Ysb));Pe.registerChannel("issue",Je);const Ye=g.ProxyChannel.fromService(Ie.get(j.$oT));Pe.registerChannel("encryption",Ye);const it=g.ProxyChannel.fromService(Ie.get(we.$Uk));Pe.registerChannel("sign",it);const _e=g.ProxyChannel.fromService(Ie.get(N.$C5b));Pe.registerChannel("keyboardLayout",_e),this.b=Ie.get($e.$y5b);const nt=g.ProxyChannel.fromService(this.b);Pe.registerChannel("nativeHost",nt),be.then(et=>et.registerChannel("nativeHost",nt));const Ct=g.ProxyChannel.fromService(Ie.get(He.$4T));Pe.registerChannel("workspaces",Ct);const Mt=g.ProxyChannel.fromService(Ie.get(re.$O5b));Pe.registerChannel("menubar",Mt);const Lt=g.ProxyChannel.fromService(Ie.get(Z.$uT));Pe.registerChannel("url",Lt);const jt=g.ProxyChannel.fromService(Ie.get(ce.$Gkb));Pe.registerChannel("extensionUrlTrust",jt);const Ft=g.ProxyChannel.fromService(Ie.get(De.$_5b));Pe.registerChannel("webview",Ft);const ft=this.B(new Oe.$W5b(this.h,Ie.get(Le.$U4b)));Pe.registerChannel("storage",ft),be.then(et=>et.registerChannel("storage",ft));const Nt=this.B(new vt.$n6b(Ie.get(Le.$U4b),Ie.get(rt.$S4b),this.h));be.then(et=>et.registerChannel("profileStorageListener",Nt));const Tt=g.ProxyChannel.fromService(Ie.get(ct.$Vq));Pe.registerChannel(ct.TerminalIpcChannels.LocalPty,Tt);const Ut=g.ProxyChannel.fromService(Ie.get(Y.$BWb));Pe.registerChannel("externalTerminal",Ut);const dt=new St.$q6b(Ie.get(Pt.$Q5b));Pe.registerChannel("logger",dt),be.then(et=>et.registerChannel("logger",dt));const Wt=new I.$04b(Ie.get(Me.$Y4b));Pe.registerChannel("extensionhostdebugservice",Wt);const zt=g.ProxyChannel.fromService(Ie.get(ae.$m5b));Pe.registerChannel(ae.$n5b,zt);const Bt=g.ProxyChannel.fromService(Ie.get(at.$s6b));Pe.registerChannel(At.$r6b,Bt)}async L(Ie,Pe){const be=this.a=Ie.get(Me.$Y4b),je=(0,ne.$El)(process.env)?0:4,Ae=this.j.args;if(Pe){if(Pe.openables.length>0)return be.open({context:je,cli:Ae,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const _e of Pe.urls){const nt=new URLSearchParams(_e.uri.query);if(nt.get("windowId")==="_blank")return nt.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:nt.toString()}),be.open({context:je,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ue=global.macOpenFiles,Ke=Ae._.length,Ze=!!Ae["folder-uri"],Xe=!!Ae["file-uri"],Ge=Ae["skip-add-to-recently-opened"]===!0,Ve=Ae.wait&&Ae.waitMarkerFilePath?a.URI.file(Ae.waitMarkerFilePath):void 0,Je=Ae.remote||void 0,Ye=Ae.profile,it=Ae["profile-temp"];if(!Ke&&!Ze&&!Xe){if(Ae["new-window"]||Ye||it)return be.open({context:je,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:Ye,forceTempProfile:it});if(Ue.length)return be.open({context:1,cli:Ae,urisToOpen:Ue.map(_e=>(0,qe.$5h)(_e)?{workspaceUri:a.URI.file(_e)}:{fileUri:a.URI.file(_e)}),noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0})}return be.open({context:je,cli:Ae,forceNewWindow:Ae["new-window"]||!Ke&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:Ge,waitMarkerFileURI:Ve,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:Ye,forceTempProfile:it})}M(){this.N(),E.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ie,Pe)=>{Pe({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.O(this.j.args,process.env,!0),this.P(),d.$j&&E.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async N(){const Ie=this.p.win32MutexName;if(d.$i&&Ie)try{const Pe=await new Promise((je,Ae)=>{G(["@vscode/windows-mutex"],je,Ae)}),be=new Pe.Mutex(Ie);(0,p.$bb)(this.k.onWillShutdown)(()=>be.release())}catch(Pe){this.h.error(Pe)}}async O(Ie,Pe,be){try{return await(0,ee.$Kl)(this.l,this.h,Ie,Pe)}catch(je){const Ae=(0,S.$ki)(je);be?this.a?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.h.error(Ae)}return{}}async P(){try{const Pe=(await this.n.readFile(this.j.argvResource)).value.toString(),be=JSON.parse((0,$.$Rm)(Pe)),Ae=(0,fe.$ho)(this.l)>=1;if(be["enable-crash-reporter"]===void 0){const Ue=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,w.$6e)()}"`,"}"],Ke=Pe.substring(0,Pe.length-2).concat(`,
`,Ue.join(`
`));await this.n.writeFile(this.j.argvResource,A.$Hc.fromString(Ke))}else{const Ue=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);Ue!==Pe&&await this.n.writeFile(this.j.argvResource,A.$Hc.fromString(Ue))}}catch(Ie){this.h.error(Ie)}}};e.$y6b=ut,e.$y6b=ut=ke([_(2,oe.$yh),_(3,V.$3i),_(4,V.$4i),_(5,z.$K4b),_(6,q.$M4b),_(7,m.$6h),_(8,Se.$8M),_(9,U.$4j),_(10,de.$ij),_(11,rt.$S4b)],ut)}),define(te[311],ie([0,1,15,45,7,24,8,50,14,32,49,46,13,9,65,4,35,26,21,42,99,305,10,18,236,248,28,63,200,16,219,93,75,215,92,20,222,5,77,23,78,278,126,288,51,286,95,247,33,52,79,53,39,231,229,2,40,264,66,224,91,121,268,262]),function(G,e,E,C,s,M,A,S,f,u,p,$,v,h,y,b,d,c,a,w,k,g,t,l,r,i,n,o,m,I,D,P,R,j,T,z,ne,ee,ce,se,ae,J,Y,B,F,U,H,Q,x,oe,K,O,L,N,W,q,V,re,$e,de,ue,me,we){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ve){console.error(ve.message),E.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Ce=>console.error(Ce));const[ve,pe,X,le,fe,Ee,Re,Ne]=this.b();try{try{await this.d(X,Ne,le,fe,Re)}catch(Ce){throw this.f(X,Re,Ce),Ce}await ve.invokeFunction(async Ce=>{const ze=Ce.get(ee.$3i),We=Ce.get(z.$M4b),Z=Ce.get(I.$4j),he=Ce.get(ee.$4i),ge=await this.e(ze,X,We,ve,Re,!0);return a.Promises.writeFile(X.mainLockfile,String(process.pid)).catch(ye=>{ze.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Ee.logger=he.createLogger("main",{name:(0,t.localize)(0,null)}),(0,p.$bb)(We.onWillShutdown)(ye=>{Z.dispose(),le.dispose(),ye.join("instanceLockfile",a.Promises.unlink(X.mainLockfile).catch(()=>{}))}),ve.createInstance(g.$y6b,ge,pe).startup()})}catch(Ce){ve.invokeFunction(this.i,Ce)}}b(){const ve=new T.$xh,pe=new q.$lb;process.once("exit",()=>pe.dispose());const X={_serviceBrand:void 0,...ce.default};ve.set(se.$ij,X);const le=new n.$L4b(this.j(),X),fe=this.c(le);ve.set(n.$K4b,le);const Ee=new $e.$R5b((0,ee.$ej)(le),le.logsHome);ve.set($e.$Q5b,Ee);const Re=new ne.$t2b(Ee.getLogLevel()),Ne=pe.add(new de.$dN(Re,[new ee.$0i(Ee.getLogLevel())]));ve.set(ee.$3i,Ne);const Ce=new D.$Ap(Ne);ve.set(I.$4j,Ce);const ze=new P.$Zp(Ne);Ce.registerProvider(v.Schemas.file,ze),Ce.registerProvider(v.Schemas.vscodeUserData,new we.$J6b(v.Schemas.file,ze,v.Schemas.vscodeUserData,Ne));const We=new re.$mr(Ce);ve.set(V.$Ak,We);const Z=new me.$$M(1,le,Ne,Ce);ve.set(x.$7M,Z),ve.set(x.$8M,Z);const he=new O.$T4b(Z,We,le,Ce,Ne);ve.set(O.$S4b,he);const ge=b.$i&&X.win32RegValueName?pe.add(new N.$H6b(Ne,X.win32RegValueName)):le.policyFile?pe.add(new W.$I6b(le.policyFile,Ce,Ne)):new L.$0m;ve.set(L.$8m,ge);const ye=new r.$xn(he.defaultProfile.settingsResource,Ce,ge,Ne);return ve.set(l.$6h,ye),ve.set(z.$M4b,new R.$wh(z.$N4b,void 0,!1)),ve.set(F.$Go,new R.$wh(U.$F6b,void 0,!0)),ve.set(K.$u5b,new R.$wh(K.$v5b)),ve.set(H.$Uk,new R.$wh(Q.$G6b,void 0,!1)),ve.set(Y.$Sz,new R.$wh(B.$D6b)),ve.set(ae.$A5b,new J.$A6b(le,he,Ne)),[new j.$3p(ve,!0),fe,le,ye,Z,Re,X,he]}c(ve){const pe={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(X=>{const le=process.env[X];typeof le=="string"&&(pe[X]=le)}),Object.assign(process.env,pe),pe}async d(ve,pe,X,le,fe){await A.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsHome.with({scheme:v.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,ve.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,ve.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,ve.backupHome].map(Ee=>Ee?a.Promises.mkdir(Ee,{recursive:!0}):void 0)),le.init(),X.initialize()]),pe.init()}async e(ve,pe,X,le,fe,Ee){let Re;try{(0,y.mark)("code/willStartMainServer"),Re=await(0,k.$uh)(pe.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,p.$bb)(X.onWillShutdown)(()=>Re.dispose())}catch(Ne){if(Ne.code!=="EADDRINUSE")throw this.f(pe,fe,Ne),Ne;let Ce;try{Ce=await(0,k.$vh)(pe.mainIPCHandle,"main")}catch(he){if(!Ee||b.$i||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,t.localize)(1,null,fe.nameShort),(0,t.localize)(2,null),fe),he;try{(0,C.unlinkSync)(pe.mainIPCHandle)}catch(ge){throw ve.warn("Could not delete obsolete instance handle",ge),ge}return this.e(ve,pe,X,le,fe,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${fe.nameShort} is running.`;throw ve.error(he),Ce.dispose(),new Error(he)}let ze;!pe.args.wait&&!pe.args.status&&(ze=setTimeout(()=>{this.g((0,t.localize)(3,null,fe.nameShort),(0,t.localize)(4,null),fe)},1e4));const We=w.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),Z=w.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return le.invokeFunction(async()=>{const he=new i.$tr(oe.$_n,fe),ge=await Z.getMainDiagnostics(),ye=await Z.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),De=await he.getDiagnostics(ge,ye);throw console.log(De),new f.$$});throw b.$i&&await this.h(We,ve),ve.trace("Sending env to running instance..."),await We.start(pe.args,process.env),Ce.dispose(),ze&&clearTimeout(ze),new f.$$("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,t.localize)(5,null,fe.nameShort)),new f.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}f(ve,pe,X){if(X.code==="EACCES"||X.code==="EPERM"){const le=(0,M.$Af)([ve.userDataPath,ve.extensionsPath,k.$qh]).map(fe=>(0,$.$aA)(s.URI.file(fe),{os:b.OS,tildify:ve}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$ki)(X),le.join(`
`)),pe)}}g(ve,pe,X){E.dialog.showMessageBoxSync((0,ue.$oA)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ve,detail:pe},X).options)}async h(ve,pe){if(b.$i){const X=await ve.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",X);try{(await new Promise((le,fe)=>{G(["windows-foreground-love"],le,fe)})).allowSetForegroundWindow(X)}catch(le){pe.error(le)}}}i(ve,pe){const X=ve.get(ee.$3i),le=ve.get(z.$M4b);let fe=0;pe&&(pe.isExpected?pe.message&&X.trace(pe.message):(fe=1,pe.stack?X.error(pe.stack):X.error(`Startup error: ${pe.toString()}`))),le.kill(fe)}j(){const ve=this.k((0,o.$Bl)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const pe=(0,m.$z6b)(ve.verbose);pe&&((0,o.$Dl)(process.argv,"--waitMarkerFilePath",pe),ve.waitMarkerFilePath=pe)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const pe=this.l(ve._,ve.goto);ve._=pe}return ve}l(ve,pe){const X=(0,d.cwd)(),le=ve.map(Re=>{let Ne=String(Re),Ce;pe&&(Ce=(0,u.$Re)(Ne),Ne=Ce.path),Ne&&(Ne=this.m(X,Ne));const ze=(0,u.$Me)(Ne,X),We=(0,h.$cd)(ze);return We&&!(0,u.$Ie)(We)?null:pe&&Ce?(Ce.path=ze,this.n(Ce)):ze}),fe=b.$i||b.$j,Ee=(0,M.$Ff)(le,Re=>Re&&fe?Re.toLowerCase():Re||"");return(0,M.$Af)(Ee)}m(ve,pe){return b.$i&&(pe=(0,c.$xd)(pe,'"')),pe=(0,c.$vd)((0,c.$vd)(pe," "),"	"),b.$i&&(pe=(0,h.$_c)(ve,pe),pe=(0,c.$xd)(pe,".")),pe}n(ve){const pe=[ve.path];return typeof ve.line=="number"&&pe.push(String(ve.line)),typeof ve.column=="number"&&pe.push(String(ve.column)),pe.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5a400e53e985dc5e24f6ee574b07ab23943841c5/core/vs/code/electron-main/main.js.map
