/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,N=J.length;L<N;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class L{static get(){const R=new Map,A=new Map,j=new Map,y=new Map;function u(d,w){d.has(w.detail)||d.set(w.detail,-w.timestamp)}function l(d,w){const v=d.get(w.detail);v&&(v>=0||d.set(w.detail,v+w.timestamp))}let O=[];typeof J=="function"&&typeof J.getStats=="function"&&(O=J.getStats().slice(0).sort((d,w)=>d.timestamp-w.timestamp));for(const d of O)switch(d.type){case 10:u(R,d);break;case 11:case 12:l(R,d);break;case 21:u(A,d);break;case 22:l(A,d);break;case 33:u(j,d);break;case 34:l(j,d);break;case 31:u(y,d);break;case 32:l(y,d);break}let k=0;j.forEach(d=>k+=d);function g(d){const w=[];return d.forEach((v,$)=>w.push([$,v])),w}return{amdLoad:g(R),amdInvoke:g(A),nodeRequire:g(j),nodeEval:g(y),nodeRequireTotal:k}}static toMarkdownTable(R,A){let j="";const y=[];return R.forEach((u,l)=>{y[l]=u.length}),A.forEach(u=>{u.forEach((l,O)=>{typeof l>"u"&&(l=u[O]="-");const k=l.toString().length;y[O]=Math.max(k,y[O])})}),R.forEach((u,l)=>{j+=`| ${u+" ".repeat(y[l]-u.toString().length)} `}),j+=`|
`,R.forEach((u,l)=>{j+=`| ${"-".repeat(y[l])} `}),j+=`|
`,A.forEach(u=>{u.forEach((l,O)=>{typeof l<"u"&&(j+=`| ${l+" ".repeat(y[O]-l.toString().length)} `)}),j+=`|
`}),j}}e.$S=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=e.$5g=e.$4g=void 0;function L(j){return(y,u,l)=>{let O=null,k=null;if(typeof l.value=="function"?(O="value",k=l.value):typeof l.get=="function"&&(O="get",k=l.get),!k)throw new Error("not supported");l[O]=j(k,u)}}function N(j,y,u){let l=null,O=null;if(typeof u.value=="function"?(l="value",O=u.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",O=u.get),!O)throw new Error("not supported");const k=`$memoize$${y}`;u[l]=function(...g){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,g)}),this[k]}}e.$4g=N;function R(j,y,u){return L((l,O)=>{const k=`$debounce$${O}`,g=`$debounce$result$${O}`;return function(...d){this[g]||(this[g]=u?u():void 0),clearTimeout(this[k]),y&&(this[g]=y(this[g],...d),d=[this[g]]),this[k]=setTimeout(()=>{l.apply(this,d),this[g]=u?u():void 0},j)}})}e.$5g=R;function A(j,y,u){return L((l,O)=>{const k=`$throttle$timer$${O}`,g=`$throttle$result$${O}`,d=`$throttle$lastRun$${O}`,w=`$throttle$pending$${O}`;return function(...v){if(this[g]||(this[g]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[g]=y(this[g],...v)),this[w])return;const $=this[d]+j;$<=Date.now()?(this[d]=Date.now(),l.apply(this,[this[g]]),this[g]=u?u():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[d]=Date.now(),l.apply(this,[this[g]]),this[g]=u?u():void 0},$-Date.now()))}})}e.$6g=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ab=e.$zb=e.$yb=e.$xb=e.ok=void 0;function N(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=N;function R(u,l="Unreachable"){throw new Error(l)}e.$xb=R;function A(u){if(!u)throw new L.$ab("Assertion Failed")}e.$yb=A;function j(u){if(!u()){debugger;u(),(0,L.$Y)(new L.$ab("Assertion Failed"))}}e.$zb=j;function y(u,l){let O=0;for(;O<u.length-1;){const k=u[O],g=u[O+1];if(!l(k,g))return!1;O++}return!0}e.$Ab=y}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(t,o=!1){let i=0;const s=t.length;let n="",r=0,c=16,P=0;function I(te){let ce=0,ue=0;for(;ce<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)ue=ue*16+ie-48;else if(ie>=65&&ie<=70)ue=ue*16+ie-65+10;else if(ie>=97&&ie<=102)ue=ue*16+ie-97+10;else break;i++,ce++}return ce<te&&(ue=-1),ue}function b(te){i=te,n="",r=0,c=16,P=0}function D(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return P=3,t.substring(te,i);let ce=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;ce=i}else P=3;return t.substring(te,ce)}function H(){let te="",ce=i;for(;;){if(i>=s){te+=t.substring(ce,i),P=2;break}const ue=t.charCodeAt(i);if(ue===34){te+=t.substring(ce,i),i++;break}if(ue===92){if(te+=t.substring(ce,i),i++,i>=s){P=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=I(4);q>=0?te+=String.fromCharCode(q):P=4;break}default:P=5}ce=i;continue}if(ue>=0&&ue<=31)if(u(ue)){te+=t.substring(ce,i),P=2;break}else P=6;i++}return te}function _(){if(n="",P=0,r=i,i>=s)return r=s,c=17;let te=t.charCodeAt(i);if(y(te)){do i++,n+=String.fromCharCode(te),te=t.charCodeAt(i);while(y(te));return c=15}if(u(te))return i++,n+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),c=14;switch(te){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,n=H(),c=10;case 47:{const ce=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!u(t.charCodeAt(i));)i++;return n=t.substring(ce,i),c=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=s-1;let ie=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,P=1),n=t.substring(ce,i),c=13}return n+=String.fromCharCode(te),i++,c=16}case 45:if(n+=String.fromCharCode(te),i++,i===s||!l(t.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=D(),c=11;default:for(;i<s&&x(te);)i++,te=t.charCodeAt(i);if(r!==i){switch(n=t.substring(r,i),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(te),i++,c=16}}function x(te){if(y(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let te;do te=_();while(te>=12&&te<=15);return te}return{setPosition:b,getPosition:()=>i,scan:o?le:_,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>P}}e.$Hm=j;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function k(t,o){const i=[],s=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function P(I,b,D,H){r.value=I,r.offset=b,r.length=D,r.type=H,r.colonOffset=void 0,n=r}try{S(t,{onObjectBegin:(I,b)=>{if(o<=I)throw s;n=void 0,c=o>I,i.push("")},onObjectProperty:(I,b,D)=>{if(o<b||(P(I,b,D,"property"),i[i.length-1]=I,o<=b+D))throw s},onObjectEnd:(I,b)=>{if(o<=I)throw s;n=void 0,i.pop()},onArrayBegin:(I,b)=>{if(o<=I)throw s;n=void 0,i.push(0)},onArrayEnd:(I,b)=>{if(o<=I)throw s;n=void 0,i.pop()},onLiteralValue:(I,b,D)=>{if(o<b||(P(I,b,D,E(I)),o<=b+D))throw s},onSeparator:(I,b,D)=>{if(o<=b)throw s;if(I===":"&&n&&n.type==="property")n.colonOffset=b,c=!1,n=void 0;else if(I===","){const H=i[i.length-1];typeof H=="number"?i[i.length-1]=H+1:(c=!0,i[i.length-1]=""),n=void 0}}})}catch(I){if(I!==s)throw I}return{path:i,previousNode:n,isAtPropertyKey:c,matches:I=>{let b=0;for(let D=0;b<I.length&&D<i.length;D++)if(I[b]===i[D]||I[b]==="*")b++;else if(I[b]!=="**")return!1;return b===I.length}}}e.$Im=k;function g(t,o=[],i=A.DEFAULT){let s=null,n=[];const r=[];function c(I){Array.isArray(n)?n.push(I):s!==null&&(n[s]=I)}return S(t,{onObjectBegin:()=>{const I={};c(I),r.push(n),n=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const I=[];c(I),r.push(n),n=I,s=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:c,onError:(I,b,D)=>{o.push({error:I,offset:b,length:D})}},i),n[0]}e.$Jm=g;function d(t,o=[],i=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){s.type==="property"&&(s.length=I-s.offset,s=s.parent)}function r(I){return s.children.push(I),I}S(t,{onObjectBegin:I=>{s=r({type:"object",offset:I,length:-1,parent:s,children:[]})},onObjectProperty:(I,b,D)=>{s=r({type:"property",offset:b,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:I,offset:b,length:D,parent:s})},onObjectEnd:(I,b)=>{s.length=I+b-s.offset,s=s.parent,n(I+b)},onArrayBegin:(I,b)=>{s=r({type:"array",offset:I,length:-1,parent:s,children:[]})},onArrayEnd:(I,b)=>{s.length=I+b-s.offset,s=s.parent,n(I+b)},onLiteralValue:(I,b,D)=>{r({type:E(I),offset:b,length:D,parent:s,value:I}),n(b+D)},onSeparator:(I,b,D)=>{s.type==="property"&&(I===":"?s.colonOffset=b:I===","&&n(b))},onError:(I,b,D)=>{o.push({error:I,offset:b,length:D})}},i);const P=s.children[0];return P&&delete P.parent,P}e.$Km=d;function w(t,o){if(!t)return;let i=t;for(const s of o)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===s){i=r.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.$Lm=w;function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;o.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&o.push(i)}return o}e.$Mm=v;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const o=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(o[i.children[0].value]=$(s))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Nm=$;function h(t,o,i=!1){return o>=t.offset&&o<t.offset+t.length||i&&o===t.offset+t.length}e.$Om=h;function f(t,o,i=!1){if(h(t,o,i)){const s=t.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=o;n++){const r=f(s[n],o,i);if(r)return r}return t}}e.$Pm=f;function S(t,o,i=A.DEFAULT){const s=j(t,!1);function n(K){return K?()=>K(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(K){return K?Q=>K(Q,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=n(o.onObjectBegin),P=r(o.onObjectProperty),I=n(o.onObjectEnd),b=n(o.onArrayBegin),D=n(o.onArrayEnd),H=r(o.onLiteralValue),_=r(o.onSeparator),x=n(o.onComment),le=r(o.onError),te=i&&i.disallowComments,ce=i&&i.allowTrailingComma;function ue(){for(;;){const K=s.scan();switch(s.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(K){case 12:case 13:te?ie(10):x();break;case 16:ie(1);break;case 15:case 14:break;default:return K}}}function ie(K,Q=[],C=[]){if(le(K),Q.length+C.length>0){let z=s.getToken();for(;z!==17;){if(Q.indexOf(z)!==-1){ue();break}else if(C.indexOf(z)!==-1)break;z=ue()}}}function q(K){const Q=s.getTokenValue();return K?H(Q):P(Q),ue(),!0}function G(){switch(s.getToken()){case 11:{let K=0;try{K=JSON.parse(s.getTokenValue()),typeof K!="number"&&(ie(2),K=0)}catch{ie(2)}H(K);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return ue(),!0}function F(){return s.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),s.getToken()===6?(_(":"),ue(),Y()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function U(){c(),ue();let K=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(K||ie(4,[],[]),_(","),ue(),s.getToken()===2&&ce)break}else K&&ie(6,[],[]);F()||ie(4,[],[2,5]),K=!0}return I(),s.getToken()!==2?ie(7,[2],[]):ue(),!0}function B(){b(),ue();let K=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(K||ie(4,[],[]),_(","),ue(),s.getToken()===4&&ce)break}else K&&ie(6,[],[]);Y()||ie(4,[],[4,5]),K=!0}return D(),s.getToken()!==4?ie(8,[4],[]):ue(),!0}function Y(){switch(s.getToken()){case 3:return B();case 1:return U();case 10:return q(!0);default:return G()}}return ue(),s.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):Y()?(s.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Qm=S;function p(t,o){const i=j(t),s=[];let n,r=0,c;do switch(c=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:r!==c&&s.push(t.substring(r,c)),o!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,o)),r=i.getPosition();break}while(n!==17);return s.join("")}e.$Rm=p;function E(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Sm=E}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.rot=e.$Fl=void 0;function L(y,u,l){return Math.min(Math.max(y,u),l)}e.$Fl=L;function N(y,u){return(u+y%u)%u}e.rot=N;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Hl=R;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Il=A;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const l=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jl=j}),function(){function J(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function j(u){A.push(u,Date.now())}function y(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:j,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(R+j.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=L(N))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var N in L)(typeof exports=="object"?exports:J)[N]=L[N]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(N){if(e[N])return e[N].exports;var R=e[N]={i:N,l:!1,exports:{}};return J[N].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(N,R,A){L.o(N,R)||Object.defineProperty(N,R,{enumerable:!0,get:A})},L.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},L.t=function(N,R){if(1&R&&(N=L(N)),8&R||4&R&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&R&&typeof N!="string")for(var j in N)L.d(A,j,function(y){return N[y]}.bind(null,j));return A},L.n=function(N){var R=N&&N.__esModule?function(){return N.default}:function(){return N};return L.d(R,"a",R),R},L.o=function(N,R){return Object.prototype.hasOwnProperty.call(N,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(N){var R;e=J.exports=C,R=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],u=e.src=[],l=0,O=l++;u[O]="0|[1-9]\\d*";var k=l++;u[k]="[0-9]+";var g=l++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=l++;u[d]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var w=l++;u[w]="("+u[k]+")\\.("+u[k]+")\\.("+u[k]+")";var v=l++;u[v]="(?:"+u[O]+"|"+u[g]+")";var $=l++;u[$]="(?:"+u[k]+"|"+u[g]+")";var h=l++;u[h]="(?:-("+u[v]+"(?:\\."+u[v]+")*))";var f=l++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var S=l++;u[S]="[0-9A-Za-z-]+";var p=l++;u[p]="(?:\\+("+u[S]+"(?:\\."+u[S]+")*))";var E=l++,t="v?"+u[d]+u[h]+"?"+u[p]+"?";u[E]="^"+t+"$";var o="[v=\\s]*"+u[w]+u[f]+"?"+u[p]+"?",i=l++;u[i]="^"+o+"$";var s=l++;u[s]="((?:<|>)?=?)";var n=l++;u[n]=u[k]+"|x|X|\\*";var r=l++;u[r]=u[O]+"|x|X|\\*";var c=l++;u[c]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var P=l++;u[P]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var I=l++;u[I]="^"+u[s]+"\\s*"+u[c]+"$";var b=l++;u[b]="^"+u[s]+"\\s*"+u[P]+"$";var D=l++;u[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=l++;u[H]="(?:~>?)";var _=l++;u[_]="(\\s*)"+u[H]+"\\s+",y[_]=new RegExp(u[_],"g");var x=l++;u[x]="^"+u[H]+u[c]+"$";var le=l++;u[le]="^"+u[H]+u[P]+"$";var te=l++;u[te]="(?:\\^)";var ce=l++;u[ce]="(\\s*)"+u[te]+"\\s+",y[ce]=new RegExp(u[ce],"g");var ue=l++;u[ue]="^"+u[te]+u[c]+"$";var ie=l++;u[ie]="^"+u[te]+u[P]+"$";var q=l++;u[q]="^"+u[s]+"\\s*("+o+")$|^$";var G=l++;u[G]="^"+u[s]+"\\s*("+t+")$|^$";var F=l++;u[F]="(\\s*)"+u[s]+"\\s*("+o+"|"+u[c]+")",y[F]=new RegExp(u[F],"g");var U=l++;u[U]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var B=l++;u[B]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var Y=l++;u[Y]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)R(K,u[K]),y[K]||(y[K]=new RegExp(u[K]));function Q(V,Z){if(V instanceof C)return V;if(typeof V!="string"||V.length>A||!(Z?y[i]:y[E]).test(V))return null;try{return new C(V,Z)}catch{return null}}function C(V,Z){if(V instanceof C){if(V.loose===Z)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof C))return new C(V,Z);R("SemVer",V,Z),this.loose=Z;var ee=V.trim().match(Z?y[i]:y[E]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<j)return ye}return me}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Q,e.valid=function(V,Z){var ee=Q(V,Z);return ee?ee.version:null},e.clean=function(V,Z){var ee=Q(V.trim().replace(/^[=v]+/,""),Z);return ee?ee.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof C||(V=new C(V,this.loose)),this.compareMain(V)||this.comparePre(V)},C.prototype.compareMain=function(V){return V instanceof C||(V=new C(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},C.prototype.comparePre=function(V){if(V instanceof C||(V=new C(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Z=0;do{var ee=this.prerelease[Z],me=V.prerelease[Z];if(R("prerelease compare",Z,ee,me),ee===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(ee===void 0)return-1;if(ee!==me)return a(ee,me)}while(++Z)},C.prototype.inc=function(V,Z){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Z,ee,me){typeof ee=="string"&&(me=ee,ee=void 0);try{return new C(V,ee).inc(Z,me).version}catch{return null}},e.diff=function(V,Z){if(X(V,Z))return null;var ee=Q(V),me=Q(Z);if(ee.prerelease.length||me.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return ye},e.compareIdentifiers=a;var z=/^[0-9]+$/;function a(V,Z){var ee=z.test(V),me=z.test(Z);return ee&&me&&(V=+V,Z=+Z),ee&&!me?-1:me&&!ee?1:V<Z?-1:V>Z?1:0}function m(V,Z,ee){return new C(V,ee).compare(new C(Z,ee))}function M(V,Z,ee){return m(V,Z,ee)>0}function T(V,Z,ee){return m(V,Z,ee)<0}function X(V,Z,ee){return m(V,Z,ee)===0}function W(V,Z,ee){return m(V,Z,ee)!==0}function oe(V,Z,ee){return m(V,Z,ee)>=0}function ae(V,Z,ee){return m(V,Z,ee)<=0}function pe(V,Z,ee,me){var ye;switch(Z){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=X(V,ee,me);break;case"!=":ye=W(V,ee,me);break;case">":ye=M(V,ee,me);break;case">=":ye=oe(V,ee,me);break;case"<":ye=T(V,ee,me);break;case"<=":ye=ae(V,ee,me);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function de(V,Z){if(V instanceof de){if(V.loose===Z)return V;V=V.value}if(!(this instanceof de))return new de(V,Z);R("comparator",V,Z),this.loose=Z,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Z){return a(Z,V)},e.major=function(V,Z){return new C(V,Z).major},e.minor=function(V,Z){return new C(V,Z).minor},e.patch=function(V,Z){return new C(V,Z).patch},e.compare=m,e.compareLoose=function(V,Z){return m(V,Z,!0)},e.rcompare=function(V,Z,ee){return m(Z,V,ee)},e.sort=function(V,Z){return V.sort(function(ee,me){return e.compare(ee,me,Z)})},e.rsort=function(V,Z){return V.sort(function(ee,me){return e.rcompare(ee,me,Z)})},e.gt=M,e.lt=T,e.eq=X,e.neq=W,e.gte=oe,e.lte=ae,e.cmp=pe,e.Comparator=de;var ge={};function fe(V,Z){if(V instanceof fe)return V.loose===Z?V:new fe(V.raw,Z);if(V instanceof de)return new fe(V.value,Z);if(!(this instanceof fe))return new fe(V,Z);if(this.loose=Z,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Z,ee,me,ye,De,ke,Le,Ie,Ae,Ce,Oe,je){return((Z=he(ee)?"":he(me)?">="+ee+".0.0":he(ye)?">="+ee+"."+me+".0":">="+Z)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Ce)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Ce+"-"+Oe:"<="+Le)).trim()}function be(V,Z){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Z))return!1;if(Z.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var me=V[ee].semver;if(me.major===Z.major&&me.minor===Z.minor&&me.patch===Z.patch)return!0}return!1}return!0}function Se(V,Z,ee){try{Z=new fe(Z,ee)}catch{return!1}return Z.test(V)}function Me(V,Z,ee,me){var ye,De,ke,Le,Ie;switch(V=new C(V,me),Z=new fe(Z,me),ee){case">":ye=M,De=ae,ke=T,Le=">",Ie=">=";break;case"<":ye=T,De=oe,ke=M,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(V,Z,me))return!1;for(var Ae=0;Ae<Z.set.length;++Ae){var Ce=Z.set[Ae],Oe=null,je=null;if(Ce.forEach(function(Ne){Ne.semver===ge&&(Ne=new de(">=0.0.0")),Oe=Oe||Ne,je=je||Ne,ye(Ne.semver,Oe.semver,me)?Oe=Ne:ke(Ne.semver,je.semver,me)&&(je=Ne)}),Oe.operator===Le||Oe.operator===Ie||(!je.operator||je.operator===Le)&&De(V,je.semver)||je.operator===Ie&&ke(V,je.semver))return!1}return!0}de.prototype.parse=function(V){var Z=this.loose?y[q]:y[G],ee=V.match(Z);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new C(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new C(V,this.loose)),pe(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Z){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Z),Se(this.value,ee,Z);if(V.operator==="")return ee=new fe(this.value,Z),Se(V.semver,ee,Z);var me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=pe(this.semver,"<",V.semver,Z)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=pe(this.semver,">",V.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return me||ye||De&&ke||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Z=this.loose;V=V.trim(),R("range",V,Z);var ee=Z?y[B]:y[U];V=V.replace(ee,we),R("hyphen replace",V),V=V.replace(y[F],"$1$2$3"),R("comparator trim",V,y[F]),V=(V=(V=V.replace(y[_],"$1~")).replace(y[ce],"$1^")).split(/\s+/).join(" ");var me=Z?y[q]:y[G],ye=V.split(" ").map(function(De){return function(ke,Le){return R("comp",ke),ke=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,je){R("caret",Oe,je);var Ne=je?y[ie]:y[ue];return Oe.replace(Ne,function(Ue,ve,Ee,Pe,Re){var ze;return R("caret",Oe,Ue,ve,Ee,Pe,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",ze),ze})}(Ce,Ae)}).join(" ")}(ke,Le),R("caret",ke),ke=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,je){var Ne=je?y[le]:y[x];return Oe.replace(Ne,function(Ue,ve,Ee,Pe,Re){var ze;return R("tilde",Oe,Ue,ve,Ee,Pe,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",ze),ze})}(Ce,Ae)}).join(" ")}(ke,Le),R("tildes",ke),ke=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Ce){return function(Oe,je){Oe=Oe.trim();var Ne=je?y[b]:y[I];return Oe.replace(Ne,function(Ue,ve,Ee,Pe,Re,ze){R("xRange",Oe,Ue,ve,Ee,Pe,Re,ze);var qe=he(Ee),Te=qe||he(Pe),Fe=Te||he(Re);return ve==="="&&Fe&&(ve=""),qe?Ue=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Fe?(Te&&(Pe=0),Fe&&(Re=0),ve===">"?(ve=">=",Te?(Ee=+Ee+1,Pe=0,Re=0):Fe&&(Pe=+Pe+1,Re=0)):ve==="<="&&(ve="<",Te?Ee=+Ee+1:Pe=+Pe+1),Ue=ve+Ee+"."+Pe+"."+Re):Te?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Fe&&(Ue=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Ue),Ue})}(Ce,Ae)}).join(" ")}(ke,Le),R("xrange",ke),ke=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(y[Y],"")}(ke,Le),R("stars",ke),ke}(De,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(me)})),ye=ye.map(function(De){return new de(De,Z)})},fe.prototype.intersects=function(V,Z){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(me){return V.set.some(function(ye){return ye.every(function(De){return me.intersects(De,Z)})})})})},e.toComparators=function(V,Z){return new fe(V,Z).set.map(function(ee){return ee.map(function(me){return me.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new C(V,this.loose));for(var Z=0;Z<this.set.length;Z++)if(be(this.set[Z],V))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(V,Z,ee){var me=null,ye=null;try{var De=new fe(Z,ee)}catch{return null}return V.forEach(function(ke){De.test(ke)&&(me&&ye.compare(ke)!==-1||(ye=new C(me=ke,ee)))}),me},e.minSatisfying=function(V,Z,ee){var me=null,ye=null;try{var De=new fe(Z,ee)}catch{return null}return V.forEach(function(ke){De.test(ke)&&(me&&ye.compare(ke)!==1||(ye=new C(me=ke,ee)))}),me},e.validRange=function(V,Z){try{return new fe(V,Z).range||"*"}catch{return null}},e.ltr=function(V,Z,ee){return Me(V,Z,"<",ee)},e.gtr=function(V,Z,ee){return Me(V,Z,">",ee)},e.outside=Me,e.prerelease=function(V,Z){var ee=Q(V,Z);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Z,ee){return V=new fe(V,ee),Z=new fe(Z,ee),V.intersects(Z)},e.coerce=function(V){if(V instanceof C)return V;if(typeof V!="string")return null;var Z=V.match(y[D]);return Z==null?null:Q((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,L(1))},function(J,e){var L,N,R=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function y($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{N=typeof clearTimeout=="function"?clearTimeout:j}catch{N=j}})();var u,l=[],O=!1,k=-1;function g(){O&&u&&(O=!1,u.length?l=u.concat(l):k=-1,l.length&&d())}function d(){if(!O){var $=y(g);O=!0;for(var h=l.length;h;){for(u=l,l=[];++k<h;)u&&u[k].run();k=-1,h=l.length}u=null,O=!1,function(f){if(N===clearTimeout)return clearTimeout(f);if((N===j||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(f);try{N(f)}catch{try{return N.call(null,f)}catch{return N.call(this,f)}}}($)}}function w($,h){this.fun=$,this.array=h}function v(){}R.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];l.push(new w($,h)),l.length!==1||O||y(d)},w.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=v,R.addListener=v,R.once=v,R.off=v,R.removeListener=v,R.removeAllListeners=v,R.emit=v,R.prependListener=v,R.prependOnceListener=v,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class N{constructor(y,u,l){this.level=y,this.key=u,this.value=l,this.forward=[]}}const R=void 0;class A{constructor(y,u=2**16){this.comparator=y,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new N(this.c,R,R)}get size(){return this.f}clear(){this.e=new N(this.c,R,R)}has(y){return!!A.g(this,y,this.comparator)}get(y){return A.g(this,y,this.comparator)?.value}set(y,u){return A.h(this,y,u,this.comparator)&&(this.f+=1),this}delete(y){const u=A.k(this,y,this.comparator);return u&&(this.f-=1),u}forEach(y,u){let l=this.e.forward[0];for(;l;)y.call(u,l.value,l.key,this),l=l.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this.e.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this.e.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this.e.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",u=this.e.forward[0];for(;u;)y+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return y}static g(y,u,l){let O=y.e;for(let k=y.d-1;k>=0;k--)for(;O.forward[k]&&l(O.forward[k].key,u)<0;)O=O.forward[k];if(O=O.forward[0],O&&l(O.key,u)===0)return O}static h(y,u,l,O){const k=[];let g=y.e;for(let d=y.d-1;d>=0;d--){for(;g.forward[d]&&O(g.forward[d].key,u)<0;)g=g.forward[d];k[d]=g}if(g=g.forward[0],g&&O(g.key,u)===0)return g.value=l,!1;{const d=A.j(y);if(d>y.d){for(let w=y.d;w<d;w++)k[w]=y.e;y.d=d}g=new N(d,u,l);for(let w=0;w<d;w++)g.forward[w]=k[w].forward[w],k[w].forward[w]=g;return!0}}static j(y,u=.5){let l=1;for(;Math.random()<u&&l<y.c;)l+=1;return l}static k(y,u,l){const O=[];let k=y.e;for(let g=y.d-1;g>=0;g--){for(;k.forward[g]&&l(k.forward[g].key,u)<0;)k=k.forward[g];O[g]=k}if(k=k.forward[0],!k||l(k.key,u)!==0)return!1;for(let g=0;g<y.d&&O[g].forward[g]===k;g++)O[g].forward[g]=k.forward[g];for(;y.d>0&&y.e.forward[y.d-1]===R;)y.d-=1;return!0}}e.$lr=A}),define(ne[41],re([0,1,9,2]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=void 0;function R(p){const E=p;return E?typeof E.read=="function":!1}e.$sc=R;function A(p){const E=p;return E?[E.on,E.pause,E.resume,E.destroy].every(t=>typeof t=="function"):!1}e.$tc=A;function j(p){const E=p;return E?A(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$uc=j;function y(p,E){return new u(p,E)}e.$vc=y;class u{constructor(E,t){this.e=E,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(t=>t(E))}h(E){this.c.error.length===0?(0,L.$Y)(E):this.c.error.slice(0).forEach(t=>t(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,t){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(E,t){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const i=o.indexOf(t);i>=0&&o.splice(i,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(p,E){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return E(t)}e.$wc=l;function O(p,E,t){const o=[];let i;for(;(i=p.read())!==null&&o.length<t;)o.push(i);return i===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return p.read()}}}e.$xc=O;function k(p,E){return new Promise((t,o)=>{const i=[];g(p,{onData:s=>{E&&i.push(s)},onError:s=>{E?o(s):t(void 0)},onEnd:()=>{t(E?E(i):void 0)}})})}e.$yc=k;function g(p,E,t){p.on("error",o=>{t?.isCancellationRequested||E.onError(o)}),p.on("end",()=>{t?.isCancellationRequested||E.onEnd()}),p.on("data",o=>{t?.isCancellationRequested||E.onData(o)})}e.$zc=g;function d(p,E){return new Promise((t,o)=>{const i=new N.$lb,s=[],n=P=>{if(s.push(P),s.length>E)return i.dispose(),p.pause(),t({stream:p,buffer:s,ended:!1})},r=P=>(i.dispose(),o(P)),c=()=>(i.dispose(),t({stream:p,buffer:s,ended:!0}));i.add((0,N.$kb)(()=>p.removeListener("error",r))),p.on("error",r),i.add((0,N.$kb)(()=>p.removeListener("end",c))),p.on("end",c),i.add((0,N.$kb)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$Ac=d;function w(p,E){const t=y(E);return t.end(p),t}e.$Bc=w;function v(){const p=y(()=>{throw new Error("not supported")});return p.end(),p}e.$Cc=v;function $(p){let E=!1;return{read:()=>E?null:(E=!0,p)}}e.$Dc=$;function h(p,E,t){const o=y(t);return g(p,{onData:i=>o.write(E.data(i)),onError:i=>o.error(E.error?E.error(i):i),onEnd:()=>o.end()}),o}e.$Ec=h;function f(p,E,t){let o=!1;return{read:()=>{const i=E.read();return o?i:(o=!0,i!==null?t([p,i]):p)}}}e.$Fc=f;function S(p,E,t){let o=!1;const i=y(t);return g(E,{onData:s=>o?i.write(s):(o=!0,i.write(t([p,s]))),onError:s=>i.error(s),onEnd:()=>{o||(o=!0,i.write(p)),i.end()}}),i}e.$Gc=S}),define(ne[14],re([0,1,164,41]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const R=typeof Buffer<"u",A=new L.$T(()=>new Uint8Array(256));let j,y;class u{static alloc(D){return R?new u(Buffer.allocUnsafe(D)):new u(new Uint8Array(D))}static wrap(D){return R&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new u(D)}static fromString(D,H){return!(H?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(D)):(j||(j=new TextEncoder),new u(j.encode(D)))}static fromByteArray(D){const H=u.alloc(D.length);for(let _=0,x=D.length;_<x;_++)H.buffer[_]=D[_];return H}static concat(D,H){if(typeof H>"u"){H=0;for(let le=0,te=D.length;le<te;le++)H+=D[le].byteLength}const _=u.alloc(H);let x=0;for(let le=0,te=D.length;le<te;le++){const ce=D[le];_.set(ce,x),x+=ce.byteLength}return _}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=u.alloc(this.byteLength);return D.set(this),D}toString(){return R?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(D,H){return new u(this.buffer.subarray(D,H))}set(D,H){if(D instanceof u)this.buffer.set(D.buffer,H);else if(D instanceof Uint8Array)this.buffer.set(D,H);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),H);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return g(this.buffer,D)}writeUInt32BE(D,H){d(this.buffer,D,H)}readUInt32LE(D){return w(this.buffer,D)}writeUInt32LE(D,H){v(this.buffer,D,H)}readUInt8(D){return $(this.buffer,D)}writeUInt8(D,H){h(this.buffer,D,H)}indexOf(D,H=0){return l(this.buffer,D instanceof u?D.buffer:D,H)}}e.$Hc=u;function l(b,D,H=0){const _=D.byteLength,x=b.byteLength;if(_===0)return 0;if(_===1)return b.indexOf(D[0]);if(_>x-H)return-1;const le=A.value;le.fill(D.length);for(let ie=0;ie<D.length;ie++)le[D[ie]]=D.length-ie-1;let te=H+D.length-1,ce=te,ue=-1;for(;te<x;)if(b[te]===D[ce]){if(ce===0){ue=te;break}te--,ce--}else te+=Math.max(D.length-ce,le[b[te]]),ce=D.length-1;return ue}e.$Ic=l;function O(b,D){return b[D+0]<<0>>>0|b[D+1]<<8>>>0}e.$Jc=O;function k(b,D,H){b[H+0]=D&255,D=D>>>8,b[H+1]=D&255}e.$Kc=k;function g(b,D){return b[D]*2**24+b[D+1]*2**16+b[D+2]*2**8+b[D+3]}e.$Lc=g;function d(b,D,H){b[H+3]=D,D=D>>>8,b[H+2]=D,D=D>>>8,b[H+1]=D,D=D>>>8,b[H]=D}e.$Mc=d;function w(b,D){return b[D+0]<<0>>>0|b[D+1]<<8>>>0|b[D+2]<<16>>>0|b[D+3]<<24>>>0}e.$Nc=w;function v(b,D,H){b[H+0]=D&255,D=D>>>8,b[H+1]=D&255,D=D>>>8,b[H+2]=D&255,D=D>>>8,b[H+3]=D&255}e.$Oc=v;function $(b,D){return b[D]}e.$Pc=$;function h(b,D,H){b[H]=D}e.$Qc=h;function f(b){return N.$wc(b,D=>u.concat(D))}e.$Rc=f;function S(b){return N.$Dc(b)}e.$Sc=S;function p(b){return N.$yc(b,D=>u.concat(D))}e.$Tc=p;async function E(b){return b.ended?u.concat(b.buffer):u.concat([...b.buffer,await p(b.stream)])}e.$Uc=E;function t(b){return N.$Bc(b,D=>u.concat(D))}e.$Vc=t;function o(b){return N.$Ec(b,{data:D=>typeof D=="string"?u.fromString(D):u.wrap(D)},D=>u.concat(D))}e.$Wc=o;function i(b){return N.$vc(D=>u.concat(D),b)}e.$Xc=i;function s(b,D){return N.$Fc(b,D,H=>u.concat(H))}e.$Yc=s;function n(b,D){return N.$Gc(b,D,H=>u.concat(H))}e.$Zc=n;function r(b){let D=0,H=0,_=0;const x=new Uint8Array(Math.floor(b.length/4*3)),le=ce=>{switch(H){case 3:x[_++]=D|ce,H=0;break;case 2:x[_++]=D|ce>>>2,D=ce<<6,H=3;break;case 1:x[_++]=D|ce>>>4,D=ce<<4,H=2;break;default:D=ce<<2,H=1}};for(let ce=0;ce<b.length;ce++){const ue=b.charCodeAt(ce);if(ue>=65&&ue<=90)le(ue-65);else if(ue>=97&&ue<=122)le(ue-97+26);else if(ue>=48&&ue<=57)le(ue-48+52);else if(ue===43||ue===45)le(62);else if(ue===47||ue===95)le(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${b[ce]}`)}}const te=_;for(;H>0;)le(0);return u.wrap(x).slice(0,te)}e.$1c=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:b},D=!0,H=!1){const _=H?P:c;let x="";const le=b.byteLength%3;let te=0;for(;te<b.byteLength-le;te+=3){const ce=b[te+0],ue=b[te+1],ie=b[te+2];x+=_[ce>>>2],x+=_[(ce<<4|ue>>>4)&63],x+=_[(ue<<2|ie>>>6)&63],x+=_[ie&63]}if(le===1){const ce=b[te+0];x+=_[ce>>>2],x+=_[ce<<4&63],D&&(x+="==")}else if(le===2){const ce=b[te+0],ue=b[te+1];x+=_[ce>>>2],x+=_[(ce<<4|ue>>>4)&63],x+=_[ue<<2&63],D&&(x+="=")}return x}e.$2c=I}),define(ne[42],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0;function N(h){return R(h,0)}e.$ni=N;function R(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):l(h,f);case"string":return y(h,f);case"boolean":return j(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$oi=R;function A(h,f){return(f<<5)-f+h|0}e.$pi=A;function j(h,f){return A(h?433:863,f)}function y(h,f){f=A(149417,f);for(let S=0,p=h.length;S<p;S++)f=A(h.charCodeAt(S),f);return f}e.$qi=y;function u(h,f){return f=A(104579,f),h.reduce((S,p)=>R(p,S),f)}function l(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((S,p)=>(S=y(p,S),R(h[p],S)),f)}class O{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=R(f,this.g),this.g}}e.$ri=O;var k;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function g(h,f,S=32){const p=S-f,E=~((1<<p)-1);return(h<<f|(E&h)>>>p)>>>0}function d(h,f=0,S=h.byteLength,p=0){for(let E=0;E<S;E++)h[f+E]=p}function w(h,f,S="0"){for(;h.length<f;)h=S+h;return h}function v(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(S=>S.toString(16).padStart(2,"0")).join(""):w((h>>>0).toString(16),f/4)}e.$si=v;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const S=f.length;if(S===0)return;const p=this.p;let E=this.r,t=this.u,o,i;for(t!==0?(o=t,i=-1,t=0):(o=f.charCodeAt(0),i=0);;){let s=o;if(L.$Sd(o))if(i+1<S){const n=f.charCodeAt(i+1);L.$Td(n)?(i++,s=L.$Ud(o,n)):s=65533}else{t=o;break}else L.$Td(o)&&(s=65533);if(E=this.w(p,E,s),i++,i<S)o=f.charCodeAt(i);else break}this.r=E,this.u=t}w(f,S,p){return p<128?f[S++]=p:p<2048?(f[S++]=192|(p&1984)>>>6,f[S++]=128|(p&63)>>>0):p<65536?(f[S++]=224|(p&61440)>>>12,f[S++]=128|(p&4032)>>>6,f[S++]=128|(p&63)>>>0):(f[S++]=240|(p&1835008)>>>18,f[S++]=128|(p&258048)>>>12,f[S++]=128|(p&4032)>>>6,f[S++]=128|(p&63)>>>0),S>=64&&(this.y(),S-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,S=this.q;for(let c=0;c<64;c+=4)f.setUint32(c,S.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)f.setUint32(c,g(f.getUint32(c-12,!1)^f.getUint32(c-32,!1)^f.getUint32(c-56,!1)^f.getUint32(c-64,!1),1),!1);let p=this.h,E=this.l,t=this.m,o=this.n,i=this.o,s,n,r;for(let c=0;c<80;c++)c<20?(s=E&t|~E&o,n=1518500249):c<40?(s=E^t^o,n=1859775393):c<60?(s=E&t|E&o|t&o,n=2400959708):(s=E^t^o,n=3395469782),r=g(p,5)+s+i+n+f.getUint32(c*4,!1)&4294967295,i=o,o=t,t=g(E,30),E=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+E&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+i&4294967295}}e.$ti=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(N||(N={})),function(R){const A="error",j="warning",y="warn",u="info",l="ignore";function O(g){return g?L.$Od(A,g)?R.Error:L.$Od(j,g)||L.$Od(y,g)?R.Warning:L.$Od(u,g)?R.Info:R.Ignore:R.Ignore}R.fromValue=O;function k(g){switch(g){case R.Error:return A;case R.Warning:return j;case R.Info:return u;default:return l}}R.toString=k}(N||(N={})),e.default=N}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=void 0;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([S,p])=>{f[S]=p&&typeof p=="object"?N(p):p}),f}e.$Tm=N;function R(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const S=f.shift();Object.freeze(S);for(const p in S)if(A.call(S,p)){const E=S[p];typeof E=="object"&&!Object.isFrozen(E)&&!(0,L.$oe)(E)&&f.push(E)}}return h}e.$Um=R;const A=Object.prototype.hasOwnProperty;function j(h,f){return y(h,f,new Set)}e.$Vm=j;function y(h,f,S){if((0,L.$ue)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const E=[];for(const t of h)E.push(y(t,f,S));return E}if((0,L.$ne)(h)){if(S.has(h))throw new Error("Cannot clone recursive data-structure");S.add(h);const E={};for(const t in h)A.call(h,t)&&(E[t]=y(h[t],f,S));return S.delete(h),E}return h}function u(h,f,S=!0){return(0,L.$ne)(h)?((0,L.$ne)(f)&&Object.keys(f).forEach(p=>{p in h?S&&((0,L.$ne)(h[p])&&(0,L.$ne)(f[p])?u(h[p],f[p],S):h[p]=f[p]):h[p]=f[p]}),h):f}e.$Wm=u;function l(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let S,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(S=0;S<h.length;S++)if(!l(h[S],f[S]))return!1}else{const E=[];for(p in h)E.push(p);E.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!l(E,t))return!1;for(S=0;S<E.length;S++)if(!l(h[E[S]],f[E[S]]))return!1}return!0}e.$Xm=l;function O(h){const f=new Set;return JSON.stringify(h,(S,p)=>{if((0,L.$ne)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$Ym=O;function k(h,f){const S=Object.create(null);return!h||!f||Object.keys(f).forEach(E=>{const t=h[E],o=f[E];l(t,o)||(S[E]=o)}),S}e.$Zm=k;function g(h,f){const S=f.toLowerCase(),p=Object.keys(h).find(E=>E.toLowerCase()===S);return p?h[p]:h[f]}e.$1m=g;function d(h,f){const S=Object.create(null);for(const[p,E]of Object.entries(h))f(p,E)&&(S[p]=E);return S}e.$2m=d;function w(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$3m=w;function v(h){const f=[];for(const S of w(h))typeof h[S]=="function"&&f.push(S);return f}e.$4m=v;function $(h,f){const S=E=>function(){const t=Array.prototype.slice.call(arguments,0);return f(E,t)},p={};for(const E of h)p[E]=S(E);return p}e.$5m=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(R){return L.test(R)}e.$5e=N,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let u=0;u<y.length;u++)y[u]=Math.floor(Math.random()*256);return y};const A=new Uint8Array(16),j=[];for(let y=0;y<256;y++)j.push(y.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=j[A[u++]],l+=j[A[u++]],l+=j[A[u++]],l+=j[A[u++]],l+="-",l+=j[A[u++]],l+=j[A[u++]],l+="-",l+=j[A[u++]],l+=j[A[u++]],l+="-",l+=j[A[u++]],l+=j[A[u++]],l+="-",l+=j[A[u++]],l+=j[A[u++]],l+=j[A[u++]],l+=j[A[u++]],l+=j[A[u++]],l+=j[A[u++]],l}}()}),define(ne[74],re([0,1,32]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(j){const y=j.replace(/\-/g,":").toLowerCase();return!N.has(y)}function A(){const j=(0,L.networkInterfaces)();for(const y in j){const u=j[y];if(u){for(const{mac:l}of u)if(R(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Em=A}),define(ne[75],re([0,1,32,46,28,74]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=void 0,e.$Fm=new class{c(l){return this.a||(this.a=N.$Fh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,O=0;const k=(0,L.networkInterfaces)();for(const g in k){const d=k[g];if(d)for(const{mac:w,internal:v}of d)v||(O+=1,this.c(w.toUpperCase())&&(l+=1))}this.b=O>0?l/O:0}return this.b}};let j;async function y(l){return j||(j=(async()=>await u(l)||R.$6e())()),j}e.$Gm=y;async function u(l){try{const O=await new Promise((g,d)=>{J(["crypto"],g,d)}),k=(0,A.$Em)();return O.createHash("sha256").update(k,"utf8").digest("hex")}catch(O){l(O);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0;const N=60,R=N*60,A=R*24,j=A*7,y=A*30,u=A*365;function l(k,g,d,w){typeof k!="number"&&(k=k.getTime());const v=Math.round((new Date().getTime()-k)/1e3);if(v<-30)return(0,L.localize)(0,null,l(new Date().getTime()+v*1e3,!1));if(!w&&v<30)return(0,L.localize)(1,null);let $;return v<N?($=v,g?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):v<R?($=Math.floor(v/N),g?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):v<A?($=Math.floor(v/R),g?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):v<j?($=Math.floor(v/A),g?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):v<y?($=Math.floor(v/j),g?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):v<u?($=Math.floor(v/y),g?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(v/u),g?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$4l=l;function O(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$5l=O}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[33],re([0,1,19,3,78]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=void 0;function A(k,g){return g&&(k.stack||k.stacktrace)?R.localize(0,null,y(k),j(k.stack)||j(k.stacktrace)):y(k)}function j(k){return Array.isArray(k)?k.join(`
`):k}function y(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?R.localize(1,null,k.message):k.message||R.localize(2,null)}function u(k=null,g=!1){if(!k)return R.localize(3,null);if(Array.isArray(k)){const d=L.$Af(k),w=u(d[0],g);return d.length>1?R.localize(4,null,w,d.length):w}if(N.$le(k))return k;if(k.detail){const d=k.detail;if(d.error)return A(d.error,g);if(d.exception)return A(d.exception,g)}return k.stack?A(k,g):k.message?k.message:R.localize(5,null)}e.$ki=u;function l(k){const g=k;return g instanceof Error&&Array.isArray(g.actions)}e.$li=l;function O(k,g){let d;return typeof k=="string"?d=new Error(k):d=k,d.actions=g,d}e.$mi=O}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;function N(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$jp=N}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.TerminateResponseCode=e.Source=void 0;var N;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(N||(e.Source=N={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(y,...u){const l=u.reduce((g,d)=>(g[d]=!0,g),{}),O=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(g=>!l[g]).forEach(g=>{for(let d=0;d<O.length;d++)if(g.search(O[d])!==-1){delete y[g];break}})}e.$ql=A;function j(y){y&&(delete y.DEBUG,L.$j&&delete y.DYLD_LIBRARY_PATH,L.$k&&delete y.LD_PRELOAD)}e.$rl=j}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Mp=e.$Lp=e.$Kp=void 0;function N(l){const O=l;return O&&typeof O.type=="string"&&typeof O.severity=="string"}e.$Kp=N;function R(l){const O=[];let k;try{const g=JSON.parse(l.arguments),d=g[g.length-1];d&&d.__$stack&&(g.pop(),k=d.__$stack),O.push(...g)}catch{O.push("Unable to log remote console arguments",l.arguments)}return{args:O,stack:k}}e.$Lp=R;function A(l){if(typeof l!="string")return A(R(l).stack);const O=l;if(O){const k=j(O),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$Mp=A;function j(l){if(!l)return l;const O=l.indexOf(`
`);return O===-1?l:l.substring(0,O)}function y(l,O){const{args:k,stack:g}=R(l),d=typeof k[0]=="string"&&k.length===1;let w=j(g);w&&(w=`(${w.trim()})`);let v=[];if(typeof k[0]=="string"?w&&d?v=[`%c[${O}] %c${k[0]} %c${w}`,u("blue"),u(""),u("grey")]:v=[`%c[${O}] %c${k[0]}`,u("blue"),u(""),...k.slice(1)]:v=[`%c[${O}]%`,u("blue"),...k],w&&!d&&v.push(w),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,v)}e.log=y;function u(l){return`color: ${l}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.$8g=e.$7g=void 0;function R(u){return JSON.stringify(u,j)}e.$7g=R;function A(u){let l=JSON.parse(u);return l=y(l),l}e.$8g=A;function j(u,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function y(u,l=0){if(!u||l>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return N.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof L.$Hc||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let O=0;O<u.length;++O)u[O]=y(u[O],l+1);else for(const O in u)Object.hasOwnProperty.call(u,O)&&(u[O]=y(u[O],l+1))}return u}e.$9g=y}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9C=void 0;class j{constructor(g,d,w){this.id=g,this.dependencies=d,this.callback=w}}class y{static{this.INSTANCE=new y}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,d,w)=>{typeof g!="string"&&(w=d,d=g,g=null),(typeof d!="object"||!Array.isArray(d))&&(w=d,d=null),this.c.push(new j(g,d,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const d=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!d)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(g){return new Promise((d,w)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const $=()=>{v.removeEventListener("load",h),v.removeEventListener("error",f)},h=S=>{$(),d(this.c.pop())},f=S=>{$(),w(S)};v.addEventListener("load",h),v.addEventListener("error",f),this.f&&(g=this.f.createScriptURL(g)),v.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(v)})}i(g){return new Promise((d,w)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),d(this.c.pop())}catch(v){w(v)}})}async j(g){try{const d=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(g).fsPath,h=d.readFileSync($).toString(),f=v.wrap(h.replace(/^#!.*/,""));return new w.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function O(k,g,d){if(L.$R){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[k]&&(k=l[k]);const w=`${k}/${g}`;if(u.has(w))return u.get(w);let v;if(/^\w[\w\d+.-]*:\/\//.test(w))v=w;else{const S=`${d&&!R.$o?N.$2e:N.$1e}/${w}`;v=N.$4e.asBrowserUri(S).toString(!0)}const $=y.INSTANCE.load(v);return u.set(w,$),$}else return await new Promise((w,v)=>{J([k],w,v)})}e.$9C=O}),define(ne[83],re([0,1,32,16,24]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=void 0;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let O;process.env.PROCESSOR_ARCHITEW6432?O=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?O=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?O=1:O=0;class k{constructor(E,t,o){this.exePath=E,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:O===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:E=!1}={}){const t=g({useAlternateBitness:p});if(!t)return null;const o=N.$$c(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let i=-1,s=null;for(const c of await R.Promises.readdir(o)){let P=-1;if(E){const b=c.indexOf("-");if(b<0)continue;const D=c.substring(0,b);if(!A.test(D)||c.substring(b+1)!=="preview")continue;P=parseInt(D,10)}else{if(!A.test(c))continue;P=parseInt(c,10)}if(P<=i)continue;const I=N.$$c(o,c,"pwsh.exe");await R.SymlinkSupport.existsFile(I)&&(s=I,i=P)}if(!s)return null;const n=t.includes("x86")?" (x86)":"",r=E?" Preview":"";return new k(s,`PowerShell${r}${n}`,!0)}async function w({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const E=N.$$c(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(E))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=p?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(E))if(t.test(i)){const s=N.$$c(E,i,"pwsh.exe");return new k(s,o)}return null}function v(){const p=N.$$c(L.homedir(),".dotnet","tools","pwsh.exe");return new k(p,".NET Core PowerShell Global Tool")}function $(){const p=N.$$c(process.env.windir,l===1&&O!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await w(),p&&(yield p),p=v(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await w({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$ol=f;async function S(){for await(const p of f())return p;return null}e.$pl=S}),define(ne[56],re([0,1,16,13,34,55,3,24]),function(J,e,L,N,R,A,j,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(k=R.env){return k.comspec||"cmd.exe"}e.$sl=u;function l(k){let g=[],d=!1;const w=function(v){if(d){g.push(v);return}(!k.send(v,h=>{if(h&&console.error(h),d=!1,g.length>0){const f=g.slice(0);g=[],f.forEach(S=>w(S))}})||N.$i)&&(d=!0)};return{send:w}}e.$tl=l;var O;(function(k){async function g(d,w,v){if(L.$0c(d))return d;if(w===void 0&&(w=R.cwd()),L.$bd(d)!=="."||(v===void 0&&j.$le(R.env.PATH)&&(v=R.env.PATH.split(L.$id)),v===void 0||v.length===0))return L.$$c(w,d);async function h(f){if(await y.Promises.exists(f)){let S;try{S=await y.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(S=await y.Promises.lstat(f))}return S?!S.isDirectory():!1}return!1}for(const f of v){let S;if(L.$0c(f)?S=L.$$c(f,d):S=L.$$c(w,f,d),await h(S))return S;let p=S+".com";if(await h(p)||(p=S+".exe",await h(p)))return p}return L.$$c(w,d)}k.findExecutable=g})(O||(e.win32=O={}))}),define(ne[84],re([0,1,32,13,83,56]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0;async function j(k,g){return k===1?N.$i?O():A.$sl(g):u(k,g)}e.$ul=j;let y=null;function u(k,g){if(N.$k&&k===2||N.$j&&k===3)return"/bin/bash";if(!y){let d;if(N.$i)d="/bin/bash";else{if(d=g.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let l=null;async function O(){return l||(l=(await(0,R.$pl)()).exePath),l}});var $e=this&&this.__decorate||function(J,e,L,N){var R=arguments.length,A=R<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,L):N,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,N);else for(var y=J.length-1;y>=0;y--)(j=J[y])&&(A=(R<3?j(A):R>3?j(e,L,A):j(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,N,R,A,j,y,u,l,O,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.ProxyChannel=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.RequestInitiator=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=void 0;var d;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(d||(d={}));function w(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(v||(v={}));function $(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(h||(h={}));function f(F){let U=0;for(let B=0;;B+=7){const Y=F.read(1);if(U|=(Y.buffer[0]&127)<<B,!(Y.buffer[0]&128))return U}}const S=i(0);function p(F,U){if(U===0){F.write(S);return}let B=0;for(let K=U;K!==0;K=K>>>7)B++;const Y=R.$Hc.alloc(B);for(let K=0;U!==0;K++)Y.buffer[K]=U&127,U=U>>>7,U>0&&(Y.buffer[K]|=128);F.write(Y)}class E{constructor(U){this.b=U,this.a=0}read(U){const B=this.b.slice(this.a,this.a+U);return this.a+=B.byteLength,B}}e.$0g=E;class t{constructor(){this.a=[]}get buffer(){return R.$Hc.concat(this.a)}write(U){this.a.push(U)}}e.$$g=t;var o;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(o||(o={}));function i(F){const U=R.$Hc.alloc(1);return U.writeUInt8(F,0),U}const s={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object),Uint:i(o.Int)},n=typeof Buffer<"u";function r(F,U){if(typeof U>"u")F.write(s.Undefined);else if(typeof U=="string"){const B=R.$Hc.fromString(U);F.write(s.String),p(F,B.byteLength),F.write(B)}else if(n&&Buffer.isBuffer(U)){const B=R.$Hc.wrap(U);F.write(s.Buffer),p(F,B.byteLength),F.write(B)}else if(U instanceof R.$Hc)F.write(s.VSBuffer),p(F,U.byteLength),F.write(U);else if(Array.isArray(U)){F.write(s.Array),p(F,U.length);for(const B of U)r(F,B)}else if(typeof U=="number"&&(U|0)===U)F.write(s.Uint),p(F,U);else{const B=R.$Hc.fromString(JSON.stringify(U));F.write(s.Object),p(F,B.byteLength),F.write(B)}}e.$_g=r;function c(F){switch(F.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return F.read(f(F)).toString();case o.Buffer:return F.read(f(F)).buffer;case o.VSBuffer:return F.read(f(F));case o.Array:{const B=f(F),Y=[];for(let K=0;K<B;K++)Y.push(c(F));return Y}case o.Object:return JSON.parse(F.read(f(F)).toString());case o.Int:return f(F)}}e.$ah=c;class P{constructor(U,B,Y=null,K=1e3){this.h=U,this.j=B,this.k=Y,this.l=K,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(U,B){this.b.set(U,B),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const B=this.o([U.type]);this.k?.logOutgoing(B,0,1,$(U.type));return}case 201:case 202:case 204:case 203:{const B=this.o([U.type,U.id],U.data);this.k?.logOutgoing(B,U.id,1,$(U.type),U.data);return}}}o(U,B=void 0){const Y=new t;return r(Y,U),r(Y,B),this.p(Y.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const B=new E(U),Y=c(B),K=c(B),Q=Y[0];switch(Q){case 100:return this.k?.logIncoming(U.byteLength,Y[1],1,`${w(Q)}: ${Y[2]}.${Y[3]}`,K),this.s({type:Q,id:Y[1],channelName:Y[2],name:Y[3],arg:K});case 102:return this.k?.logIncoming(U.byteLength,Y[1],1,`${w(Q)}: ${Y[2]}.${Y[3]}`,K),this.t({type:Q,id:Y[1],channelName:Y[2],name:Y[3],arg:K});case 101:return this.k?.logIncoming(U.byteLength,Y[1],1,`${w(Q)}`),this.u({type:Q,id:Y[1]});case 103:return this.k?.logIncoming(U.byteLength,Y[1],1,`${w(Q)}`),this.u({type:Q,id:Y[1]})}}s(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const Y=new A.$rc;let K;try{K=B.call(this.j,U.name,U.arg,Y.token)}catch(z){K=Promise.reject(z)}const Q=U.id;K.then(z=>{this.m({id:Q,data:z,type:201}),this.d.delete(U.id)},z=>{z instanceof Error?this.m({id:Q,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:Q,data:z,type:203}),this.d.delete(U.id)});const C=(0,l.$kb)(()=>Y.cancel());this.d.set(U.id,C)}t(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const Y=U.id,Q=B.listen(this.j,U.name,U.arg)(C=>this.m({id:Y,data:C,type:204}));this.d.set(U.id,Q)}u(U){const B=this.d.get(U.id);B&&(B.dispose(),this.d.delete(U.id))}v(U){let B=this.g.get(U.channelName);B||(B=[],this.g.set(U.channelName,B));const Y=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:U,timeoutTimer:Y})}w(U){const B=this.g.get(U);if(B){for(const Y of B)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$hb)(this.d.values()),this.d.clear()}}e.$bh=P;var I;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class b{constructor(U,B=null){this.l=U,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$hc,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=B}getChannel(U){const B=this;return{call(Y,K,Q){return B.a?Promise.reject(new y.$3):B.m(U,Y,K,Q)},listen(Y,K){return B.a?u.Event.None:B.o(U,Y,K)}}}m(U,B,Y,K=A.CancellationToken.None){const Q=this.g++,z={id:Q,type:100,channelName:U,name:B,arg:Y};if(K.isCancellationRequested)return Promise.reject(new y.$3);let a;return new Promise((M,T)=>{if(K.isCancellationRequested)return T(new y.$3);const X=()=>{const pe=de=>{switch(de.type){case 201:this.f.delete(Q),M(de.data);break;case 202:{this.f.delete(Q);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,T(ge);break}case 203:this.f.delete(Q),T(de.data);break}};this.f.set(Q,pe),this.p(z)};let W=null;this.b===h.Idle?X():(W=(0,N.$sg)(pe=>this.u()),W.then(()=>{W=null,X()}));const oe=()=>{W?(W.cancel(),W=null):this.p({id:Q,type:101}),T(new y.$3)},ae=K.onCancellationRequested(oe);a=(0,l.$jb)((0,l.$kb)(oe),ae),this.d.add(a)}).finally(()=>{this.d.delete(a)})}o(U,B,Y){const K=this.g++,C={id:K,type:102,channelName:U,name:B,arg:Y};let z=null;const a=new u.$hc({onWillAddFirstListener:()=>{z=(0,N.$sg)(M=>this.u()),z.then(()=>{z=null,this.d.add(a),this.p(C)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(a),this.p({id:K,type:103}))}}),m=M=>a.fire(M.data);return this.f.set(K,m),a.event}p(U){switch(U.type){case 100:case 102:{const B=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(B,U.id,0,`${w(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const B=this.q([U.type,U.id]);this.j?.logOutgoing(B,U.id,0,w(U.type));return}}}q(U,B=void 0){const Y=new t;return r(Y,U),r(Y,B),this.r(Y.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const B=new E(U),Y=c(B),K=c(B),Q=Y[0];switch(Q){case 200:return this.j?.logIncoming(U.byteLength,0,0,$(Q)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,Y[1],0,$(Q),K),this.t({type:Y[0],id:Y[1],data:K})}}t(U){if(U.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$hb)(this.d.values()),this.d.clear()}}e.$ch=b,$e([j.$4g],b.prototype,"onDidInitializePromise",null);class D{get connections(){const U=[];return this.f.forEach(B=>U.push(B)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$hc,this.onDidAddConnection=this.g.event,this.h=new u.$hc,this.onDidRemoveConnection=this.h.event,U(({protocol:B,onDidClientDisconnect:Y})=>{u.Event.once(B.onMessage)(Q=>{const C=new E(Q),z=c(C),a=new P(B,z),m=new b(B);this.a.forEach((T,X)=>a.registerChannel(X,T));const M={channelServer:a,channelClient:m,ctx:z};this.f.add(M),this.g.fire(M),Y(()=>{a.dispose(),m.dispose(),this.f.delete(M),this.h.fire(M)})})})}getChannel(U,B){const Y=this;return{call(K,Q,C){let z;if((0,g.$ze)(B)){const m=(0,L.$Wf)(Y.connections.filter(B));z=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(Y.onDidAddConnection,B))}else z=B.routeCall(Y,K,Q);const a=z.then(m=>m.channelClient.getChannel(U));return _(a).call(K,Q,C)},listen(K,Q){if((0,g.$ze)(B))return Y.j(U,B,K,Q);const C=B.routeEvent(Y,K,Q).then(z=>z.channelClient.getChannel(U));return _(C).listen(K,Q)}}}j(U,B,Y,K){const Q=this;let C=new l.$lb;const z=new u.$hc({onWillAddFirstListener:()=>{C=new l.$lb;const a=new u.$nc,m=new Map,M=X=>{const oe=X.channelClient.getChannel(U).listen(Y,K),ae=a.add(oe);m.set(X,ae)},T=X=>{const W=m.get(X);W&&(W.dispose(),m.delete(X))};Q.connections.filter(B).forEach(M),u.Event.filter(Q.onDidAddConnection,B)(M,void 0,C),Q.onDidRemoveConnection(T,void 0,C),a.event(z.fire,z,C),C.add(a)},onDidRemoveLastListener:()=>{C.dispose()}});return z.event}registerChannel(U,B){this.a.set(U,B),this.f.forEach(Y=>{Y.channelServer.registerChannel(U,B)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$dh=D;class H{constructor(U,B,Y=null){const K=new t;r(K,B),U.send(K.buffer),this.a=new b(U,Y),this.d=new P(U,B,Y)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,B){this.d.registerChannel(U,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$eh=H;function _(F){return{call(U,B,Y){return F.then(K=>K.call(U,B,Y))},listen(U,B){const Y=new u.$qc;return F.then(K=>Y.input=K.listen(U,B)),Y.event}}}e.$fh=_;function x(F){let U=!1;return{call(B,Y,K){return U?F.call(B,Y,K):(0,N.$Fg)(0).then(()=>U=!0).then(()=>F.call(B,Y,K))},listen(B,Y){if(U)return F.listen(B,Y);const K=new u.$qc;return(0,N.$Fg)(0).then(()=>U=!0).then(()=>K.input=F.listen(B,Y)),K.event}}}e.$gh=x;class le{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const B of U.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$hh=le;var te;(function(F){function U(Q,C){const z=Q,a=C&&C.disableMarshalling,m=new Map;for(const M in z)Y(M)&&m.set(M,u.Event.buffer(z[M],!0));return new class{listen(M,T,X){const W=m.get(T);if(W)return W;if(K(T)){const oe=z[T];if(typeof oe=="function")return oe.call(z,X)}throw new y.$_(`Event not found: ${T}`)}call(M,T,X){const W=z[T];if(typeof W=="function"){if(!a&&Array.isArray(X))for(let oe=0;oe<X.length;oe++)X[oe]=(0,O.$9g)(X[oe]);return W.apply(z,X)}throw new y.$_(`Method not found: ${T}`)}}}F.fromService=U;function B(Q,C){const z=C&&C.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return C?.properties?.has(m)?C.properties.get(m):K(m)?function(M){return Q.listen(m,M)}:Y(m)?Q.listen(m):async function(...M){let T;C&&!(0,g.$ue)(C.context)?T=[C.context,...M]:T=M;const X=await Q.call(m,T);return z?X:(0,O.$9g)(X)};throw new y.$_(`Property not found: ${String(m)}`)}})}F.toService=B;function Y(Q){return Q[0]==="o"&&Q[1]==="n"&&k.$Nd(Q.charCodeAt(2))}function K(Q){return/^onDynamic/.test(Q)&&k.$Nd(Q.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const U=F.toString();if(U!=="[object Object]")return U}return F}function ie(F){return Array.isArray(F)?F.map(ue):ue(F)}function q(F,U,B,Y,K,Q,C){C=ie(C);const z=ce[K],a=z[Y%z.length];let m=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(Q)?(m=m.concat(C),m.push(")")):m.push(C),console.log.apply(console,m)}class G{constructor(U,B){this.d=U,this.f=B,this.a=0,this.b=0}logOutgoing(U,B,Y,K,Q){this.b+=U,q(this.d,this.b,U,B,Y,K,Q)}logIncoming(U,B,Y,K,Q){this.a+=U,q(this.f,this.a,U,B,Y,K,Q)}}e.$ih=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class w extends d.$bh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>R.$Hc.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Op=w;class v{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$hc,this.onDidProcessExit=this.h.event;const S=f&&f.timeout?f.timeout:6e4;this.b=new N.$Bg(S),this.d=null,this.f=null}getChannel(h){const f=this;return{call(S,p,E){return f.k(h,S,p,E)},listen(S,p){return f.l(h,S,p)}}}k(h,f,S,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(y.$4());this.b.cancel();const E=this.n(h),t=(0,N.$sg)(s=>E.call(f,S,s)),o=p.onCancellationRequested(()=>t.cancel()),i=(0,l.$kb)(()=>t.cancel());return this.c.add(i),t.finally(()=>{o.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,S){if(!this.b)return u.Event.None;this.b.cancel();let p;const E=new u.$hc({onWillAddFirstListener:()=>{p=this.n(h).listen(f,S)(E.fire,E),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,O.$Tm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.$rl)(f.env),this.d=(0,L.fork)(this.i,h,f);const S=new u.$hc;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,j.$Kp)(n)){(0,j.log)(n,`IPC Library: ${this.j.serverName}`);return}S.fire(R.$Hc.wrap(Buffer.from(n,"base64")))});const E=this.j.useQueue?(0,k.$tl)(this.d):this.d,t=n=>this.d&&this.d.connected&&E.send(n.buffer.toString("base64")),o=S.event,i={send:t,onMessage:o};this.f=new d.$ch(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",s),this.c.forEach(c=>(0,l.$hb)(c)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pp=v}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,N,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.StorageState=e.$No=e.StorageHint=void 0;var y;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(y||(e.StorageHint=y={}));function u(g){const d=g;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$No=u;var l;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(l||(e.StorageState=l={}));class O extends R.$mb{static{this.a=100}constructor(d,w=Object.create(null)){super(),this.m=d,this.n=w,this.b=this.B(new N.$kc),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=new L.$Cg(O.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(d=>this.r(d)))}r(d){this.b.pause();try{d.changed?.forEach((w,v)=>this.s(v,w)),d.deleted?.forEach(w=>this.s(w,void 0))}finally{this.b.resume()}}s(d,w){if(this.c===l.Closed)return;let v=!1;(0,j.$ue)(w)?v=this.f.delete(d):this.f.get(d)!==w&&(this.f.set(d,w),v=!0),v&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.n.hint!==y.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(d,w){const v=this.f.get(d);return(0,j.$ue)(v)?w:v}getBoolean(d,w){const v=this.get(d);return(0,j.$ue)(v)?w:v==="true"}getNumber(d,w){const v=this.get(d);return(0,j.$ue)(v)?w:parseInt(v,10)}getObject(d,w){const v=this.get(d);return(0,j.$ue)(v)?w:(0,A.$8g)(v)}async set(d,w,v=!1){if(this.c===l.Closed)return;if((0,j.$ue)(w))return this.delete(d,v);const $=(0,j.$ne)(w)||Array.isArray(w)?(0,A.$7g)(w):String(w);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:v}),this.w()}async delete(d,w=!1){if(!(this.c===l.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:w}),this.w()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.m.optimize()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=l.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(d).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(d){if(this.u)return this.w(d)}async w(d){return this.g.trigger(()=>this.v(),d)}async whenFlushed(){if(this.u)return new Promise(d=>this.l.push(d))}isInMemory(){return this.n.hint===y.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Oo=O;class k{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((w,v)=>this.a.set(v,w)),d.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Po=k}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.TokenType=void 0;var R;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...l){switch(l.length){case 1:return(0,N.localize)(0,null,l[0]);case 2:return(0,N.localize)(1,null,l[0],l[1]);case 3:return(0,N.localize)(2,null,l[0],l[1],l[2]);default:return}}const j=(0,N.localize)(3,null),y=(0,N.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,L.$6)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(O=>O.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const k=this.d,g=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:g};this.g.push({offset:k,lexeme:g,additionalInfo:O}),this.f.push(d)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const k=this.c.substring(this.d,this.e),g=u.b.get(k);g?this.k(g):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,k=!1,g=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(y);return}const w=this.c.charCodeAt(O);if(k)k=!1;else if(w===47&&!g){O++;break}else w===91?g=!0:w===92?k=!0:w===93&&(g=!1);O++}for(;O<this.c.length&&u.a.has(this.c.charCodeAt(O));)O++;this.e=O;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Di=u}),define(ne[109],re([0,1,77,52,15,16,34,17,11]),function(J,e,L,N,R,A,j,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.$bd)(R.$4e.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$$c)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,y.$gg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,y.$gg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$5l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$$c)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.$gg)(u.URI.file((0,A.$$c)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.$gg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.$gg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.$gg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$$c)(d,"argv.json")):(0,y.$gg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$$c)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$_c)(d):(0,A.$9c)((0,A.$$c)(R.$4e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.$_c)(d)):u.URI.file((0,A.$$c)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$_c)(d);const w=j.env.VSCODE_EXTENSIONS;if(w)return w;const v=j.env.VSCODE_PORTABLE;return v?(0,A.$$c)(v,"extensions"):(0,y.$gg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(w=>/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,A.$9c)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.$9c)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return O(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$6l.test(d))}get extensionLogLevel(){const d=[];for(const w of this.args.log||[]){const v=e.$6l.exec(w);v&&v[1]&&v[2]&&d.push([v[1],v[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,y.$gg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$$c)(d,"policy.json")):(0,y.$gg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,w,v){this.a=d,this.b=w,this.c=v,this.editSessionId=this.args.editSessionId}}e.$7l=l,$e([N.$4g],l.prototype,"appRoot",null),$e([N.$4g],l.prototype,"userHome",null),$e([N.$4g],l.prototype,"userDataPath",null),$e([N.$4g],l.prototype,"appSettingsHome",null),$e([N.$4g],l.prototype,"tmpDir",null),$e([N.$4g],l.prototype,"cacheHome",null),$e([N.$4g],l.prototype,"stateResource",null),$e([N.$4g],l.prototype,"userRoamingDataHome",null),$e([N.$4g],l.prototype,"userDataSyncHome",null),$e([N.$4g],l.prototype,"sync",null),$e([N.$4g],l.prototype,"machineSettingsResource",null),$e([N.$4g],l.prototype,"workspaceStorageHome",null),$e([N.$4g],l.prototype,"localHistoryHome",null),$e([N.$4g],l.prototype,"keyboardLayoutResource",null),$e([N.$4g],l.prototype,"argvResource",null),$e([N.$4g],l.prototype,"isExtensionDevelopment",null),$e([N.$4g],l.prototype,"untitledWorkspacesHome",null),$e([N.$4g],l.prototype,"builtinExtensionsPath",null),$e([N.$4g],l.prototype,"extensionsPath",null),$e([N.$4g],l.prototype,"extensionDevelopmentLocationURI",null),$e([N.$4g],l.prototype,"extensionDevelopmentKind",null),$e([N.$4g],l.prototype,"extensionTestsLocationURI",null),$e([N.$4g],l.prototype,"debugExtensionHost",null),$e([N.$4g],l.prototype,"logLevel",null),$e([N.$4g],l.prototype,"extensionLogLevel",null),$e([N.$4g],l.prototype,"serviceMachineIdResource",null),$e([N.$4g],l.prototype,"disableTelemetry",null),$e([N.$4g],l.prototype,"disableWorkspaceTrust",null),$e([N.$4g],l.prototype,"disableKeytar",null),$e([N.$4g],l.prototype,"policyFile",null);function O(g,d){return k(g["inspect-extensions"],g["inspect-brk-extensions"],5870,d,g.debugId,g.extensionEnvironment)}e.$8l=O;function k(g,d,w,v,$,h){const S=Number(d||g)||(v?null:w),p=S?!!d:!1;let E;if(h)try{E=JSON.parse(h)}catch{}return{port:S,break:p,debugId:$,env:E}}e.$9l=k}),function(){"use strict";function J(e,L,N){function R(j,y){const u=A(j,y),l=[u];return e.isAbsolute(u)||l.unshift(N),e.resolve(...l)}function A(j,y){process.env.VSCODE_DEV&&(y="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,y);const O=j["user-data-dir"];if(O)return O;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(k,"AppData","Roaming")}break;case"darwin":l=e.join(L.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,y)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,32,34]),function(e,L,N){return J(e,L,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,32,109,110]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=void 0;class A extends N.$7l{constructor(l,O){super(l,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(l,O.nameShort)},O)}}e.$0l=A;function j(u,l){return(0,N.$9l)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.$$l=j;function y(u,l){return(0,N.$9l)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.$_l=y}),define(ne[112],re([0,1,3,94]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;function R(j,y,u){try{A(j,y,u)}catch(l){console.error(l?.message??l)}return j}e.$kp=R;function A(j,y,u){const l=(O,k,g)=>{const d=O[k];if((0,L.$le)(d)){const w=d,v=w.length;if(v>1&&w[0]==="%"&&w[v-1]==="%"){const $=w.substr(1,v-2);let h=y[$];h===void 0&&u&&(h=u[$]);const f=typeof h=="string"?h:h?.message,S=u?.[$],p=typeof S=="string"?S:S?.message;if(!f){p||console.warn(`[${j.name}]: ${(0,N.localize)(0,null,$)}`);return}if(g&&(k==="title"||k==="category")&&p&&p!==f){const E={value:f,original:p};O[k]=E}else O[k]=f}}else if((0,L.$ne)(d))for(const w in d)d.hasOwnProperty(w)&&(w==="commands"?l(d,w,!0):l(d,w,g));else if(Array.isArray(d))for(let w=0;w<d.length;w++)l(d,w,g)};for(const O in j)j.hasOwnProperty(O)&&l(j,O)}}),define(ne[48],re([0,1,17,54,98,43]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||j.test(h)}e.$zo=u;function l(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(j);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Ao=l;function O(h){if(!h)return null;const f=h.majorBase,S=h.majorMustEqual,p=h.minorBase;let E=h.minorMustEqual;const t=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(E=!1),o=!1);let i=0;if(h.preRelease){const s=y.exec(h.preRelease);if(s){const[,n,r,c]=s;i=Date.UTC(Number(n),Number(r)-1,Number(c))}}return{majorBase:f,majorMustEqual:S,minorBase:p,minorMustEqual:E,patchBase:t,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:i}}e.$Bo=O;function k(h,f,S){let p;typeof h=="string"?p=O(l(h)):p=h;let E;f instanceof Date?E=f.getTime():typeof f=="string"&&(E=new Date(f).getTime());let t;if(typeof S=="string"?t=O(l(S)):t=S,!p||!t)return!1;const o=p.majorBase,i=p.minorBase,s=p.patchBase;let n=t.majorBase,r=t.minorBase,c=t.patchBase;const P=t.notBefore;let I=t.majorMustEqual,b=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:i>r?!0:i<r||E&&E<P?!1:s>=c:(o===1&&n===0&&(!I||!b||!D)&&(n=1,r=0,c=0,I=!0,b=!1,D=!1),o<n?!1:o>n?!I:i<r?!1:i>r?!b:s<c?!1:s>c?!D:!(E&&E<P))}e.$Co=k;function g(h,f,S,p,E){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([N.default.Error,R.localize(0,null)]),t;if(typeof p.name!="string")return t.push([N.default.Error,R.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([N.default.Error,R.localize(2,null,"version")]),t;if(!p.engines)return t.push([N.default.Error,R.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([N.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return t.push([N.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return t.push([N.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([N.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([N.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([N.default.Error,R.localize(9,null,"main")]),t;{const s=(0,L.$gg)(S,p.main);(0,L.$ag)(s,S)||t.push([N.default.Warning,R.localize(10,null,s.path,S.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([N.default.Error,R.localize(11,null,"browser")]),t;{const s=(0,L.$gg)(S,p.browser);(0,L.$ag)(s,S)||t.push([N.default.Warning,R.localize(12,null,s.path,S.path)])}}if(!A.valid(p.version))return t.push([N.default.Error,R.localize(13,null)]),t;const o=[];if(!d(h,f,p,E,o))for(const s of o)t.push([N.default.Error,s]);return t}e.$Do=g;function d(h,f,S,p,E){return p||typeof S.main>"u"&&typeof S.browser>"u"?!0:v(h,f,S.engines.vscode,E)}e.$Eo=d;function w(h,f,S){return h==="*"||v(f,S,h)}e.$Fo=w;function v(h,f,S,p=[]){const E=O(l(S));if(!E)return p.push(R.localize(14,null,S)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return p.push(R.localize(15,null,S)),!1}else if(!E.majorMustEqual)return p.push(R.localize(16,null,S)),!1;return k(h,f,E)?!0:(p.push(R.localize(17,null,h,S)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,S=h.length;f<S;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0;async function R(A,j,y){let u=y&&y.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const O=(await j.readFile(A.serviceMachineIdResource)).value.toString();u=(0,N.$5e)(O)?O:null}catch{u=null}if(!u){u=(0,N.$6e)();try{await j.writeFile(A.serviceMachineIdResource,L.$Hc.fromString(u))}catch{}}return y?.store("storage.serviceMachineId",u,-1,1),u}e.$Yo=R}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=void 0;class L{constructor(R,A=[],j=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$wh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.InstantiationType=void 0;const N=[];var R;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(y,u,l){u instanceof L.$wh||(u=new L.$wh(u,[],!!l)),N.push([y,u])}e.$jr=A;function j(){return N}e.$kr=j}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$1p=L;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const y=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(j);y.outgoing.set(u.key,u),u.incoming.set(y.key,y)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const y of this.a.values())y.outgoing.delete(j),y.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let y=this.a.get(j);return y||(y=new L(j,A),this.a.set(j,y)),y}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,y]of this.a)A.push(`${j}
	(-> incoming)[${[...y.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...y.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const y=new Set([A]),u=this.c(j,y);if(u)return u}}c(A,j){for(const[y,u]of A.outgoing){if(j.has(y))return[...j,y].join(" -> ");j.add(y);const l=this.c(u,j);if(l)return l;j.delete(y)}}}e.$2p=N}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.ConfigurationTarget=e.$8h=e.$7h=e.$6h=void 0,e.$6h=(0,R.$zh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}e.$7h=A;function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}e.$8h=j;var y;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(y||(e.ConfigurationTarget=y={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$9h=u;function l(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$0h=l;function O(h,f){const S=Object.create(null);for(const p in h)k(S,p,h[p],f);return S}e.$$h=O;function k(h,f,S,p){const E=f.split("."),t=E.pop();let o=h;for(let i=0;i<E.length;i++){const s=E[i];let n=o[s];switch(typeof n){case"undefined":n=o[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${E.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=S}catch{p(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$_h=k;function g(h,f){const S=f.split(".");d(h,S)}e.$ai=g;function d(h,f){const S=f.shift();if(f.length===0){delete h[S];return}if(Object.keys(h).indexOf(S)!==-1){const p=h[S];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[S])}}function w(h,f,S){function p(o,i){let s=o;for(const n of i){if(typeof s!="object"||s===null)return;s=s[n]}return s}const E=f.split("."),t=p(h,E);return typeof t>"u"?S:t}e.$bi=w;function v(h,f,S){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$ne(h[p])&&L.$ne(f[p])?v(h[p],f[p],S):S&&(h[p]=f[p]):h[p]=f[p])})}e.$ci=v;function $(h){return h.replace(/[\[\]]/g,"")}e.$di=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,N,R,A,j,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.ContextKeyExprType=e.$Ei=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$j),u.set("isLinux",L.$k),u.set("isWindows",L.$i),u.set("isWeb",L.$o),u.set("isMacNative",L.$j&&!L.$o),u.set("isEdge",L.$G),u.set("isFirefox",L.$E),u.set("isChrome",L.$D),u.set("isSafari",L.$F);function l(z,a){if(u.get(z)!==void 0)throw(0,y.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,a)}e.$Ei=l;const O=Object.prototype.hasOwnProperty;var k;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const g={regexParsingWithErrorRecovery:!0},d=(0,j.localize)(0,null),w=(0,j.localize)(1,null),v=(0,j.localize)(2,null),$=(0,j.localize)(3,null),h=(0,j.localize)(4,null),f=(0,j.localize)(5,null),S=(0,j.localize)(6,null),p=(0,j.localize)(7,null);class E{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=g){this.k=a,this.d=new R.$Di,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const M=this.D(),T=M.type===17?f:void 0;throw this.h.push({message:h,offset:M.offset,lexeme:R.$Di.getLexeme(M),additionalInfo:T}),E.c}return m}catch(m){if(m!==E.c)throw m;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const m=this.o();a.push(m)}return a.length===1?a[0]:t.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const m=this.s();a.push(m)}return a.length===1?a[0]:t.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),H.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=a.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const X=T.lexeme,W=X.lastIndexOf("/"),oe=W===X.length-1?void 0:this.w(X.substring(W+1));let ae;try{ae=new RegExp(X.substring(1,W),oe)}catch{throw this.B("REGEX",T)}return ue.create(m,ae)}switch(T.type){case 10:case 19:{const X=[T.lexeme];this.z();let W=this.D(),oe=0;for(let fe=0;fe<T.lexeme.length;fe++)T.lexeme.charCodeAt(fe)===40?oe++:T.lexeme.charCodeAt(fe)===41&&oe--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?oe++:T.lexeme.charCodeAt(fe)===41&&oe--}if(oe<0)break;X.push(R.$Di.getLexeme(W)),this.z(),W=this.D()}const ae=X.join(""),pe=ae.lastIndexOf("/"),de=pe===ae.length-1?void 0:this.w(ae.substring(pe+1));let ge;try{ge=new RegExp(ae.substring(1,pe),de)}catch{throw this.B("REGEX",T)}return t.regex(m,ge)}case 18:{const X=T.lexeme;this.z();let W=null;if(!(0,N.$od)(X)){const oe=X.indexOf("/"),ae=X.lastIndexOf("/");if(oe!==ae&&oe>=0){const pe=X.slice(oe+1,ae),de=X[ae+1]==="i"?"i":"";try{W=new RegExp(pe,de)}catch{throw this.B("REGEX",T)}}}if(W===null)throw this.B("REGEX",T);return ue.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const T=this.u();return t.notIn(m,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return t.equals(m,T);switch(T){case"true":return t.has(m);case"false":return t.not(m);default:return t.equals(m,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return t.notEquals(m,T);switch(T){case"true":return t.not(m);case"false":return t.has(m);default:return t.notEquals(m,T)}}case 5:return this.z(),te.create(m,this.u());case 6:return this.z(),ce.create(m,this.u());case 7:return this.z(),x.create(m,this.u());case 8:return this.z(),le.create(m,this.u());case 13:return this.z(),t.in(m,this.u());default:return t.has(m)}}case 20:throw this.h.push({message:S,offset:a.offset,lexeme:"",additionalInfo:p}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,m){if(this.C(a))return this.z();throw this.B(m,this.D())}B(a,m,M){const T=(0,j.localize)(8,null,a,R.$Di.getLexeme(m)),X=m.offset,W=R.$Di.getLexeme(m);return this.h.push({message:T,offset:X,lexeme:W,additionalInfo:M}),E.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Fi=E;class t{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return c.create(a)}static equals(a,m){return P.create(a,m)}static notEquals(a,m){return D.create(a,m)}static regex(a,m){return ue.create(a,m)}static in(a,m){return I.create(a,m)}static notIn(a,m){return b.create(a,m)}static not(a){return H.create(a)}static and(...a){return G.create(a,null,!0)}static or(...a){return F.create(a,null,!0)}static greater(a,m){return x.create(a,m)}static greaterEquals(a,m){return le.create(a,m)}static smaller(a,m){return te.create(a,m)}static smallerEquals(a,m){return ce.create(a,m)}static{this.c=new E({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Gi=t;function o(z){const a=new E({regexParsingWithErrorRecovery:!1});return z.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,j.localize)(9,null,M.additionalInfo):(0,j.localize)(10,null),offset:M.offset,length:M.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.$Hi=o;function i(z,a){const m=z?z.substituteConstants():void 0,M=a?a.substituteConstants():void 0;return!m&&!M?!0:!m||!M?!1:m.equals(M)}e.$Ii=i;function s(z,a){return z.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$Ji=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$Ki=r;class c{static create(a,m=null){const M=u.get(a);return typeof M=="boolean"?M?r.INSTANCE:n.INSTANCE:new c(a,m)}constructor(a,m){this.key=a,this.c=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$Li=c;class P{static create(a,m,M=null){if(typeof m=="boolean")return m?c.create(a,M):H.create(a,M);const T=u.get(a);return typeof T=="boolean"?m===(T?"true":"false")?r.INSTANCE:n.INSTANCE:new P(a,m,M)}constructor(a,m,M){this.c=a,this.d=m,this.f=M,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Mi=P;class I{static create(a,m){return new I(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.f),M=a.getValue(this.d);return Array.isArray(m)?m.includes(M):typeof M=="string"&&typeof m=="object"&&m!==null?O.call(m,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Ni=I;class b{static create(a,m){return new b(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=11,this.c=I.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oi=b;class D{static create(a,m,M=null){if(typeof m=="boolean")return m?H.create(a,M):c.create(a,M);const T=u.get(a);return typeof T=="boolean"?m===(T?"true":"false")?n.INSTANCE:r.INSTANCE:new D(a,m,M)}constructor(a,m,M){this.c=a,this.d=m,this.f=M,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Pi=D;class H{static create(a,m=null){const M=u.get(a);return typeof M=="boolean"?M?n.INSTANCE:r.INSTANCE:new H(a,m)}constructor(a,m){this.c=a,this.d=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:B(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=u.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.$Qi=H;function _(z,a){if(typeof z=="string"){const m=parseFloat(z);isNaN(m)||(z=m)}return typeof z=="string"||typeof z=="number"?a(z):n.INSTANCE}class x{static create(a,m,M=null){return _(m,T=>new x(a,T,M))}constructor(a,m,M){this.c=a,this.d=m,this.f=M,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Ri=x;class le{static create(a,m,M=null){return _(m,T=>new le(a,T,M))}constructor(a,m,M){this.c=a,this.d=m,this.f=M,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Si=le;class te{static create(a,m,M=null){return _(m,T=>new te(a,T,M))}constructor(a,m,M){this.c=a,this.d=m,this.f=M,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Ti=te;class ce{static create(a,m,M=null){return _(m,T=>new ce(a,T,M))}constructor(a,m,M){this.c=a,this.d=m,this.f=M,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:Y(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Ui=ce;class ue{static create(a,m){return new ue(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const m=this.f?this.f.source:"",M=a.f?a.f.source:"";return m<M?-1:m>M?1:0}equals(a){if(a.type===this.type){const m=this.f?this.f.source:"",M=a.f?a.f.source:"";return this.d===a.d&&m===M}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Vi=ue;class ie{static create(a){return new ie(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new ie(this.c.map(a))}negate(){return this.c}}e.$Wi=ie;function q(z){let a=null;for(let m=0,M=z.length;m<M;m++){const T=z[m].substituteConstants();if(z[m]!==T&&a===null){a=[];for(let X=0;X<m;X++)a[X]=z[X]}a!==null&&(a[m]=T)}return a===null?z:a}class G{static create(a,m,M){return G.d(a,m,M)}constructor(a,m){this.expr=a,this.c=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,M=this.expr.length;m<M;m++){const T=s(this.expr[m],a.expr[m]);if(T!==0)return T}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:G.create(a,this.c,!1)}evaluate(a){for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static d(a,m,M){const T=[];let X=!1;for(const W of a)if(W){if(W.type===1){X=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){T.push(...W.expr);continue}T.push(W)}if(T.length===0&&X)return r.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(s);for(let W=1;W<T.length;W++)T[W-1].equals(T[W])&&(T.splice(W,1),W--);if(T.length===1)return T[0];for(;T.length>1;){const W=T[T.length-1];if(W.type!==9)break;T.pop();const oe=T.pop(),ae=T.length===0,pe=F.create(W.expr.map(de=>G.create([de,oe],null,M)),null,ae);pe&&(T.push(pe),T.sort(s))}if(T.length===1)return T[0];if(M){for(let W=0;W<T.length;W++)for(let oe=W+1;oe<T.length;oe++)if(T[W].negate().equals(T[oe]))return n.INSTANCE;if(T.length===1)return T[0]}return new G(T,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new G(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());this.c=F.create(a,this,!0)}return this.c}}e.$Xi=G;class F{static create(a,m,M){return F.d(a,m,M)}constructor(a,m){this.expr=a,this.c=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,M=this.expr.length;m<M;m++){const T=s(this.expr[m],a.expr[m]);if(T!==0)return T}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:F.create(a,this.c,!1)}evaluate(a){for(let m=0,M=this.expr.length;m<M;m++)if(this.expr[m].evaluate(a))return!0;return!1}static d(a,m,M){let T=[],X=!1;if(a){for(let W=0,oe=a.length;W<oe;W++){const ae=a[W];if(ae){if(ae.type===0){X=!0;continue}if(ae.type===1)return r.INSTANCE;if(ae.type===9){T=T.concat(ae.expr);continue}T.push(ae)}}if(T.length===0&&X)return n.INSTANCE;T.sort(s)}if(T.length!==0){if(T.length===1)return T[0];for(let W=1;W<T.length;W++)T[W-1].equals(T[W])&&(T.splice(W,1),W--);if(T.length===1)return T[0];if(M){for(let W=0;W<T.length;W++)for(let oe=W+1;oe<T.length;oe++)if(T[W].negate().equals(T[oe]))return r.INSTANCE;if(T.length===1)return T[0]}return new F(T,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new F(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),M=a.shift(),T=[];for(const X of C(m))for(const W of C(M))T.push(G.create([X,W],null,!1));a.unshift(F.create(T,null,!1))}this.c=F.create(a,this,!0)}return this.c}}e.$Yi=F;class U extends c{static{this.d=[]}static all(){return U.d.values()}constructor(a,m,M){super(a,null),this.f=m,typeof M=="object"?U.d.push({...M,key:a}):M!==!0&&U.d.push({key:a,description:M,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return P.create(this.key,a)}notEqualsTo(a){return D.create(this.key,a)}}e.$Zi=U,e.$1i=(0,A.$zh)("contextKeyService");function B(z,a){return z<a?-1:z>a?1:0}function Y(z,a,m,M){return z<m?-1:z>m?1:a<M?-1:a>M?1:0}function K(z,a){if(z.type===0||a.type===1)return!0;if(z.type===9)return a.type===9?Q(z.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(K(z,m))return!0;return!1}if(z.type===6){if(a.type===6)return Q(a.expr,z.expr);for(const m of z.expr)if(K(m,a))return!0;return!1}return z.equals(a)}e.$2i=K;function Q(z,a){let m=0,M=0;for(;m<z.length&&M<a.length;){const T=z[m].cmp(a[M]);if(T<0)return!1;T===0&&m++,M++}return m===z.length}function C(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=void 0,e.$Bn=(0,L.$zh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=void 0,e.$Gh=(0,L.$zh)("environmentService"),e.$Hh=(0,L.$Ah)(e.$Gh)}),define(ne[21],re([0,1,92,10]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Xn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0,e.$Kn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ln=new RegExp(e.$Kn),e.$Mn="__web_extension",e.$Nn="skipWalkthrough",e.$On="extensionsSync",e.$Pn="dependecyOrPackExtensionInstall";function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Qn=R;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Rn=A;function j(f,S){switch(f){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Sn=j;function y(f,S){return S==="web"&&!f.includes("web")}e.$Tn=y;function u(f,S,p){return y(S,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:l(p).includes(f)}e.$Un=u;function l(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Vn=l;function O(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$Wn=O;var k;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var g;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var w;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Xn=(0,N.$zh)("extensionGalleryService");var v;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(S,p){super(S),this.code=p,this.name=p}}e.$Yn=h,e.$Zn=(0,N.$zh)("extensionManagementService"),e.$1n="extensionsIdentifiers/disabled",e.$2n="extensionsIdentifiers/enabled",e.$3n=(0,N.$zh)("IGlobalExtensionEnablementService"),e.$4n=(0,N.$zh)("IExtensionTipsService"),e.$5n=(0,L.localize)(0,null),e.$6n={value:e.$5n,original:"Extensions"},e.$7n={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=void 0,e.$4o=(0,L.$zh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,j)=>J(["node-vsce-sign"],async y=>A(y),j))),this.a}async verify(A,j,y){let u;try{u=await this.b()}catch{return!1}return u.verify(A,j,y)}}e.$5o=N}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;async function j(O,k,g,d,w,v){let $;try{await y(O,k,g,d,w,v)}catch(h){$=h}finally{$&&w.errorTransformer&&($=w.errorTransformer($)),typeof $<"u"&&g.error($),g.end()}}e.$zp=j;async function y(O,k,g,d,w,v){u(v);const $=await O.open(k,{create:!1});try{u(v);let h=0,f=0,S=w&&typeof w.length=="number"?w.length:void 0,p=L.$Hc.alloc(Math.min(w.bufferSize,typeof S=="number"?S:w.bufferSize)),E=w&&typeof w.position=="number"?w.position:0,t=0;do f=await O.read($,E,p.buffer,t,p.byteLength-t),E+=f,t+=f,h+=f,typeof S=="number"&&(S-=f),t===p.byteLength&&(await g.write(d(p)),p=L.$Hc.alloc(Math.min(w.bufferSize,typeof S=="number"?S:w.bufferSize)),t=0);while(f>0&&(typeof S!="number"||S>0)&&u(v)&&l(h,w));if(t>0){let o=t;typeof S=="number"&&(o=Math.min(t,S)),g.write(d(p.slice(0,o)))}}catch(h){throw(0,A.$ek)(h)}finally{await O.close($)}}function u(O){if(O.isCancellationRequested)throw(0,N.$4)();return!0}function l(O,k){if(typeof k?.limits?.size=="number"&&O>k.limits.size)throw(0,A.$dk)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,N,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class y extends R.$mb{constructor(){super(...arguments),this.a=this.B(new L.$hc),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$hc),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(l){const O=this.i(l),k=O.filter(d=>{const w=this.c.get(d.path);return w?!(0,N.$tj)(w.request.excludes,d.excludes)||!(0,N.$tj)(w.request.includes,d.includes):!0}),g=Array.from(this.c.values()).filter(({request:d})=>!O.find(w=>w.path===d.path&&(0,N.$tj)(w.excludes,d.excludes)&&(0,N.$tj)(w.includes,d.includes))).map(({request:d})=>d.path);k.length&&this.j(`Request to start watching: ${k.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),g.length&&this.j(`Request to stop watching: ${g.join(",")}`);for(const d of g)this.h(d);for(const d of k)this.g(d)}g(l){const O=new j.$Vp(l,g=>this.a.fire(g),g=>this.b.fire(g),this.f),k={request:l,instance:O};this.c.set(l.path,k)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const O=this.c.get(l);O&&(this.c.delete(l),O.instance.dispose())}i(l){const O=new Map;for(const k of l){const g=A.$k?k.path:k.path.toLowerCase();O.set(g,k)}return Array.from(O.values())}async setVerboseLogging(l){this.f=l;for(const[,O]of this.c)O.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,O){return O?`[File Watcher (node.js)] ${l} (path: ${O.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Xp=y}),define(ne[118],re([0,1,62,117]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class R extends L.$Dp{constructor(j,y,u){super(j,y,u),this.m()}l(j){return j.add(new N.$Xp)}}e.$Yp=R}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class j extends A.$Ep{constructor(u,l,O){super(u,l,O),this.m()}l(u){const l=u.add(new R.$Pp(L.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:O,signal:k})=>this.n(`terminated by itself with code ${O}, signal: ${k}`))),N.ProxyChannel.toService((0,N.$gh)(l.getChannel("watcher")))}}e.$Qp=j}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,j]of R)this.set(A,j)}set(R,A){const j=this.a.get(R);return this.a.set(R,A),j}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$xh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,N,R,A,j,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;const O=!1;class k extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class g{constructor($=new u.$xh,h=!1,f,S=O){this.f=$,this.g=h,this.h=f,this.i=S,this.o=new Set,this.f.set(y.$yh,this),this._globalGraph=S?f?._globalGraph??new j.$2p(p=>p):void 0}createChild($){return new g($,this.g,this,this.i)}invokeFunction($,...h){const f=w.traceInvocation(this.i,$);let S=!1;try{return $({get:E=>{if(S)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(E,f);if(!t)throw new Error(`[invokeFunction] unknown service '${E}'`);return t}},...h)}finally{S=!0,f.stop()}}createInstance($,...h){let f,S;return $ instanceof A.$wh?(f=w.traceCreation(this.i,$.ctor),S=this.j($.ctor,$.staticArguments.concat(h),f)):(f=w.traceCreation(this.i,$),S=this.j($,h,f)),f.stop(),S}j($,h=[],f){const S=y._util.getServiceDependencies($).sort((t,o)=>t.index-o.index),p=[];for(const t of S){const o=this.m(t.id,f);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(o)}const E=S.length>0?S[0].index:h.length;if(h.length!==E){console.trace(`[createInstance] First service dependency of ${$.name} at position ${E+1} conflicts with ${h.length} static arguments`);const t=E-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,E)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof A.$wh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof A.$wh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const S=new j.$2p(t=>t.id.toString());let p=0;const E=[{id:$,desc:h,_trace:f}];for(;E.length;){const t=E.pop();if(S.lookupOrInsertNode(t),p++>1e3)throw new k(S);for(const o of y._util.getServiceDependencies(t.desc.ctor)){const i=this.l(o.id);if(i||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),i instanceof A.$wh){const s={id:o.id,desc:i,_trace:t._trace.branch(o.id,!0)};S.insertEdge(t,s),E.push(s)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new k(S);break}for(const{data:o}of t){if(this.l(o.id)instanceof A.$wh){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}S.removeNode(o)}}return this.l($)}s($,h,f=[],S,p){if(this.f.get($)instanceof A.$wh)return this.t($,h,f,S,p);if(this.h)return this.h.s($,h,f,S,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],S,p){if(S){const E=new g(void 0,this.g,this,this.i);E.c=String($);const t=new Map,o=new L.$Vg(()=>{const i=E.j(h,f,p);for(const[s,n]of t){const r=i[s];if(typeof r=="function")for(const c of n)r.apply(i,c)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let c=t.get(s);return c||(c=new l.$vb,t.set(s,c)),(I,b,D)=>{const H=c.push([I,b,D]);return(0,R.$kb)(H)}}if(s in i)return i[s];const n=o.value;let r=n[s];return typeof r!="function"||(r=r.bind(n),i[s]=r),r},set(i,s,n){return o.value[s]=n,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$3p=g;var d;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(d||(d={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new w(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation($,h){return $?new w(1,h.name):w.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new w(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;w.f+=$;let h=!1;function f(p,E){const t=[],o=new Array(p+1).join("	");for(const[i,s,n]of E.h)if(s&&n){h=!0,t.push(`${o}CREATES -> ${i}`);const r=f(p+1,n);r&&t.push(r)}else t.push(`${o}uses -> ${i}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];($>2||h)&&w.all.add(S.join(`
`))}}e.$4p=w});var se=this&&this.__param||function(J,e){return function(L,N){e(L,N,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,N,R,A,j,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=void 0;function u(O){return O.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$Eq=u,e.$Fq=(0,y.$zh)("languagePackService");let l=class extends N.$mb{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new L.$rc;setTimeout(()=>k.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const w=g.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some($=>$.startsWith("lp-"))).map(v=>{const $=v.properties.localizedLanguages?.[0],h=u(v);return{...this.f(h,$,v),extensionId:v.identifier.id,galleryExtension:v}});return w.push(this.f("en","English")),w}f(k,g,d){const w=g??k;let v;if(w!==k&&(v=`(${k})`),k.toLowerCase()===R.$v.toLowerCase()&&(v??="",v+=(0,A.localize)(0,null)),d?.installCount){v??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),v+=` $(cloud-download) ${h}`}return{id:k,label:w,description:v}}};e.$Gq=l,e.$Gq=l=$e([se(0,j.$Xn)],l)}),define(ne[6],re([0,1,33,4,42,2,35,13,17,3,11,116,10]),function(J,e,L,N,R,A,j,y,u,l,O,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.log=e.$6i=e.LogLevel=e.$5i=e.$4i=e.$3i=void 0,e.$3i=(0,g.$zh)("logService"),e.$4i=(0,g.$zh)("loggerService");function d(){return new Date().toISOString()}function w(I){return(0,l.$pe)(I)}e.$5i=w;var v;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$6i=v.Info;function $(I,b,D){switch(b){case v.Trace:I.trace(D);break;case v.Debug:I.debug(D);break;case v.Info:I.info(D);break;case v.Warning:I.warn(D);break;case v.Error:I.error(D);break;case v.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=$;function h(I,b=!1){let D="";for(let H=0;H<I.length;H++){let _=I[H];if(_ instanceof Error&&(_=(0,L.$ki)(_,b)),typeof _=="object")try{_=JSON.stringify(_)}catch{}D+=(H>0?" ":"")+_}return D}class f extends A.$mb{constructor(){super(...arguments),this.b=e.$6i,this.c=this.B(new N.$hc),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==v.Off&&this.b<=b}}e.$8i=f;class S extends f{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...D){this.f(v.Trace)&&this.g(v.Trace,h([b,...D],!0))}debug(b,...D){this.f(v.Debug)&&this.g(v.Debug,h([b,...D]))}info(b,...D){this.f(v.Info)&&this.g(v.Info,h([b,...D]))}warn(b,...D){this.f(v.Warning)&&this.g(v.Warning,h([b,...D]))}error(b,...D){if(this.f(v.Error))if(b instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=b.stack,this.g(v.Error,h(H))}else this.g(v.Error,h([b,...D]))}flush(){}}e.$9i=S;class p extends f{constructor(b=e.$6i){super(),this.setLevel(b),this.g=!y.$i}trace(b,...D){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...D):console.log(`[main ${d()}]`,b,...D))}debug(b,...D){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...D):console.log(`[main ${d()}]`,b,...D))}info(b,...D){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...D):console.log(`[main ${d()}]`,b,...D))}warn(b,...D){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,b,...D):console.warn(`[main ${d()}]`,b,...D))}error(b,...D){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,b,...D):console.error(`[main ${d()}]`,b,...D))}dispose(){}flush(){}}e.$0i=p;class E extends f{constructor(b=e.$6i,D=!0){super(),this.g=D,this.setLevel(b)}trace(b,...D){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...D):console.log(b,...D))}debug(b,...D){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...D):console.log(b,...D))}info(b,...D){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...D):console.log(b,...D))}warn(b,...D){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...D):console.log(b,...D))}error(b,...D){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...D):console.error(b,...D))}dispose(){}flush(){}}e.$$i=E;class t extends f{constructor(b,D=e.$6i){super(),this.g=b,this.setLevel(D)}trace(b,...D){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(b),...D])}debug(b,...D){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(b),...D])}info(b,...D){this.f(v.Info)&&this.g.log(v.Info,[this.h(b),...D])}warn(b,...D){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(b),...D])}error(b,...D){this.f(v.Error)&&this.g.log(v.Error,[this.h(b),...D])}h(b){return typeof b=="string"?b:(0,L.$ki)(b,this.f(v.Trace))}dispose(){}flush(){}}e.$_i=t;class o extends f{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const D of this.g)D.setLevel(b);super.setLevel(b)}trace(b,...D){for(const H of this.g)H.trace(b,...D)}debug(b,...D){for(const H of this.g)H.debug(b,...D)}info(b,...D){for(const H of this.g)H.info(b,...D)}warn(b,...D){for(const H of this.g)H.warn(b,...D)}error(b,...D){for(const H of this.g)H.error(b,...D)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$aj=o;class i extends A.$mb{constructor(b,D,H){if(super(),this.h=b,this.j=D,this.b=new j.$xi,this.c=this.B(new N.$hc),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$hc),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$hc),this.onDidChangeVisibility=this.g.event,H)for(const _ of H)this.b.set(_.resource,{logger:void 0,info:_})}k(b){return(0,l.$le)(b)?[...this.b.values()].find(D=>D.info.id===b):this.b.get(b)}getLogger(b){return this.k(b)?.logger}createLogger(b,D){const H=this.l(b),_=(0,l.$le)(b)?b:D?.id??(0,R.$ni)(H.toString()).toString(16);let x=this.b.get(H)?.logger;const le=D?.logLevel==="always"?v.Trace:D?.logLevel;x||(x=this.m(H,le??this.getLogLevel(H)??this.h,{...D,id:_}));const te={logger:x,info:{resource:H,id:_,logLevel:le,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(te.info),this.b.set(H,te),x}l(b){return(0,l.$le)(b)?(0,u.$gg)(this.j,`${b}.log`):b}setLogLevel(b,D){if(O.URI.isUri(b)){const H=b,_=D,x=this.b.get(H);x&&_!==x.info.logLevel&&(x.info.logLevel=_===this.h?void 0:_,x.logger?.setLevel(_),this.b.set(x.info.resource,x),this.f.fire([H,_]))}else{this.h=b;for(const[H,_]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,D){const H=this.k(b);H&&D!==!H.info.hidden&&(H.info.hidden=!D,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,D]))}getLogLevel(b){let D;return b&&(D=this.b.get(b)?.info.logLevel),D??this.h}registerLogger(b){const D=this.b.get(b.resource);D?D.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const D=this.b.get(b);D&&(D.logger&&D.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bj=i;class s{constructor(){this.onDidChangeLogLevel=new N.$hc().event}setLevel(b){}getLevel(){return v.Info}trace(b,...D){}debug(b,...D){}info(b,...D){}warn(b,...D){}error(b,...D){}critical(b,...D){}dispose(){}flush(){}}e.$cj=s;class n extends s{}e.$dj=n;function r(I){if(I.verbose)return v.Trace;if(typeof I.logLevel=="string"){const b=P(I.logLevel.toLowerCase());if(b!==void 0)return b}return e.$6i}e.$ej=r;function c(I){switch(I){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$fj=c;function P(I){switch(I){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$gj=P,e.$hj=new k.$Zi("logLevel",c(v.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,N,R,A,j,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;class O extends j.$mb{constructor(g,d){super(),this.a=g,this.b=d,this.c=this.B(new A.$hc),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$hc),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new N.$Cg(0)),this.s=[],this.t=this.B(new N.$Cg(0))}watch(g,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(g,d):this.u(g,d)}l(g,d){const w={path:this.C(g),excludes:d.excludes,includes:d.includes,recursive:d.recursive},v=(0,L.$Nf)(this.j,w);return this.m(),(0,j.$kb)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(g=>(0,R.$Y)(g))}n(){this.h||(this.h=this.B(this.p(d=>this.c.fire((0,u.$Fp)(d)),d=>this.z(d),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const d of this.j)(0,u.$Bp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const d of this.j)(0,u.$Bp)(d)&&g.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(g,d){const w={path:this.C(g),excludes:d.excludes,includes:d.includes,recursive:!1},v=(0,L.$Nf)(this.s,w);return this.v(),(0,j.$kb)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(g=>(0,R.$Y)(g))}w(){return this.r||(this.r=this.B(this.y(g=>this.c.fire((0,u.$Fp)(g)),g=>this.z(g),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}C(g){return(0,y.$9c)(g.fsPath)}}e.$Jp=O}),define(ne[122],re([0,1,19,8,14,20,4,42,65,2,46,15,123,17,41,99,12,61,6,9]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;let p=class extends l.$mb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new j.$hc),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$hc),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$hc),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new j.$hc),this.onDidRunOperation=this.m.event,this.R=this.B(new j.$hc),this.onDidFilesChange=this.R.event,this.S=this.B(new j.$hc),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new N.$Ng)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new l.$lb;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),i.add(o.onDidChangeFile(s=>this.R.fire(new $.$jk(s,!this.O(o))))),typeof o.onDidWatchError=="function"&&i.add(o.onDidWatchError(s=>this.S.fire(new Error(s)))),i.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,l.$kb)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,l.$hb)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(i){o.push(i)}}),!this.h.has(t)&&await N.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&o)}listCapabilities(){return u.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,d.$kg)(t))throw new $.$lk((0,v.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const i=new S.$_;throw i.message=(0,v.localize)(1,null,t.toString()),i}return o}async k(t){const o=await this.j(t);if((0,$.$9j)(o)||(0,$.$6j)(o)||(0,$.$0j)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const o=await this.j(t);if((0,$.$9j)(o)||(0,$.$6j)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.n(t,o)}catch(i){throw(0,$.$gk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$lk((0,v.localize)(2,null,this.nb(t)),1):(0,$.$ek)(i)}}async n(t,o){const i=await this.j(t),s=this.O(i),n=o?.resolveTo,r=o?.resolveSingleChildDescendants,c=o?.resolveMetadata,P=await i.stat(t);let I;return this.p(i,t,P,void 0,!!c,(b,D)=>(I||(I=O.$Fh.forUris(()=>!s),I.set(t,!0),n&&I.fill(!0,n)),I.get(b.resource)||I.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&r?D===1:!1))}async p(t,o,i,s,n,r){const{providerExtUri:c}=this.N(t),P={resource:o,name:c.basename(o),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$wk)({mtime:i.mtime,size:i.size}),children:void 0};if(P.isDirectory&&r(P,s)){try{const I=await t.readdir(o),b=await N.Promises.settled(I.map(async([D,H])=>{try{const _=c.joinPath(o,D),x=n?await t.stat(_):{type:H};return await this.p(t,_,x,I.length,n,r)}catch(_){return this.b.trace(_),null}}));P.children=(0,L.$Af)(b)}catch(I){this.b.trace(I),P.children=[]}return P}return P}async resolveAll(t){return N.Promises.settled(t.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),i=await o.stat(t);return this.p(o,t,i,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.r(t,o)}catch(i){return i}return!0}async r(t,o){if(!o?.overwrite&&await this.exists(t))throw new $.$lk((0,v.localize)(3,null,this.nb(t)),3,o)}async createFile(t,o=R.$Hc.fromString(""),i){await this.r(t,i);const s=await this.writeFile(t,o);return this.m.fire(new $.$ik(t,0,s)),s}async writeFile(t,o,i){const s=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(s);try{await this.s(s,t,i)||await this.P(s,n.dirname(t));let c;if((0,$.$6j)(s)&&!(o instanceof R.$Hc))if((0,w.$tc)(o)){const P=await(0,w.$Ac)(o,3);P.ended?c=R.$Hc.concat(P.buffer):c=P}else c=(0,w.$xc)(o,P=>R.$Hc.concat(P),3);else c=o;if(!(0,$.$9j)(s)||(0,$.$6j)(s)&&c instanceof R.$Hc)await this.cb(s,t,i,c);else{const P=c instanceof R.$Hc?(0,R.$Sc)(c):c;i?.atomic!==!1&&i?.atomic?.postfix?await this.Y(s,t,(0,d.$gg)((0,d.$fg)(t),`${(0,d.$dg)(t)}${i.atomic.postfix}`),i,P):await this.Z(s,t,i,P)}this.m.fire(new $.$ik(t,4))}catch(r){throw new $.$lk((0,v.localize)(4,null,this.nb(t),(0,$.$ek)(r).toString()),(0,$.$hk)(r),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,o,i){const s=!!i?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(o)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,v.localize)(6,null,this.nb(o)));if(s)throw new Error((0,v.localize)(7,null,this.nb(o)))}let r;try{r=await t.stat(o)}catch{return}if(r.type&$.FileType.Directory)throw new $.$lk((0,v.localize)(8,null,this.nb(o)),0,i);if(this.mb(o,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$vk&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,$.$wk)({mtime:i.mtime,size:r.size}))throw new $.$lk((0,v.localize)(9,null),3,i);return r}async readFile(t,o,i){const s=await this.k(t);return o?.atomic?this.t(s,t,o,i):this.u(s,t,o,i)}async t(t,o,i,s){return new Promise((n,r)=>{this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{try{const c=await this.u(t,o,i,s);n(c)}catch(c){r(c)}})})}async u(t,o,i,s){const n=await this.v(t,o,{...i,preferUnbuffered:!0},s);return{...n,value:await(0,R.$Tc)(n.value)}}async readFileStream(t,o,i){const s=await this.k(t);return this.v(s,t,o,i)}async v(t,o,i,s){const n=new A.$rc(s),r=this.F(o,i).then(P=>P,P=>{throw n.dispose(!0),P});let c;try{return typeof i?.etag=="string"&&i.etag!==$.$vk&&await r,i?.atomic&&(0,$.$$j)(t)||!((0,$.$9j)(t)||(0,$.$0j)(t))||(0,$.$6j)(t)&&i?.preferUnbuffered?c=this.D(t,o,i):(0,$.$0j)(t)?c=this.z(t,o,n.token,i):c=this.C(t,o,n.token,i),c.on("end",()=>n.dispose()),c.on("error",()=>n.dispose()),{...await r,value:c}}catch(P){throw c&&await(0,w.$yc)(c),this.w(P,o,i)}}w(t,o,i){const s=(0,v.localize)(10,null,this.nb(o),(0,$.$ek)(t).toString());return t instanceof $.$nk?new $.$nk(s,t.stat,i):t instanceof $.$mk?new $.$mk(s,t.fileOperationResult,t.size,t.options):new $.$lk(s,(0,$.$hk)(t),i)}z(t,o,i,s=Object.create(null)){const n=t.readFileStream(o,s,i);return(0,w.$Ec)(n,{data:r=>r instanceof R.$Hc?r:R.$Hc.wrap(r),error:r=>this.w(r,o,s)},r=>R.$Hc.concat(r))}C(t,o,i,s=Object.create(null)){const n=(0,R.$Xc)();return(0,h.$zp)(t,o,n,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.w(r,o,s)},i),n}D(t,o,i){const s=(0,w.$vc)(n=>R.$Hc.concat(n));return(async()=>{try{let n;i?.atomic&&(0,$.$$j)(t)?n=await t.readFile(o,{atomic:!0}):n=await t.readFile(o),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.G(o,n.byteLength,i),s.end(R.$Hc.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async F(t,o){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new $.$lk((0,v.localize)(11,null,this.nb(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==$.$vk&&o.etag===i.etag)throw new $.$nk((0,v.localize)(12,null),i,o);return this.G(t,i.size,o),i}G(t,o,i){if(typeof i?.limits?.size=="number"&&o>i.limits.size)throw new $.$mk((0,v.localize)(13,null,this.nb(t)),7,o,i)}async canMove(t,o,i){return this.H(t,o,"move",i)}async canCopy(t,o,i){return this.H(t,o,"copy",i)}async H(t,o,i,s){if(t.toString()!==o.toString())try{const n=i==="move"?this.lb(await this.l(t),t):await this.k(t),r=this.lb(await this.l(o),o);await this.M(n,t,r,o,i,s)}catch(n){return n}return!0}async move(t,o,i){const s=this.lb(await this.l(t),t),n=this.lb(await this.l(o),o),r=await this.I(s,t,n,o,"move",!!i),c=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new $.$ik(t,r==="move"?2:3,c)),c}async copy(t,o,i){const s=await this.k(t),n=this.lb(await this.l(o),o),r=await this.I(s,t,n,o,"copy",!!i),c=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new $.$ik(t,r==="copy"?3:2,c)),c}async I(t,o,i,s,n,r){if(o.toString()===s.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:P}=await this.M(t,o,i,s,n,r);if(c&&!P&&r&&await this.del(s,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(s)),n==="copy"){if(t===i&&(0,$.$7j)(t))await t.copy(o,s,{overwrite:r});else{const I=await this.resolve(o);I.isDirectory?await this.L(t,I,i,s):await this.J(t,o,i,s)}return n}else return t===i?(await t.rename(o,s,{overwrite:r}),n):(await this.I(t,o,i,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async J(t,o,i,s){if((0,$.$9j)(t)&&(0,$.$9j)(i))return this.eb(t,o,i,s);if((0,$.$9j)(t)&&(0,$.$6j)(i))return this.kb(t,o,i,s);if((0,$.$6j)(t)&&(0,$.$9j)(i))return this.ib(t,o,i,s);if((0,$.$6j)(t)&&(0,$.$6j)(i))return this.gb(t,o,i,s)}async L(t,o,i,s){await i.mkdir(s),Array.isArray(o.children)&&await N.Promises.settled(o.children.map(async n=>{const r=this.N(i).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),i,r):this.J(t,n.resource,i,r)}))}async M(t,o,i,s,n,r){let c=!1;if(t===i){const{providerExtUri:I,isPathCaseSensitive:b}=this.N(t);if(b||(c=I.isEqual(o,s)),c&&n==="copy")throw new Error((0,v.localize)(14,null,this.nb(o),this.nb(s)));if(!c&&I.isEqualOrParent(s,o))throw new Error((0,v.localize)(15,null,this.nb(o),this.nb(s)))}const P=await this.exists(s);if(P&&!c){if(!r)throw new $.$lk((0,v.localize)(16,null,this.nb(o),this.nb(s)),4);if(t===i){const{providerExtUri:I}=this.N(t);if(I.isEqualOrParent(o,s))throw new Error((0,v.localize)(17,null,this.nb(o),this.nb(s)))}}return{exists:P,isSameResourceWithDifferentPathCase:c}}N(t){const o=this.O(t);return{providerExtUri:o?d.$9f:d.$$f,isPathCaseSensitive:o}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.lb(await this.j(t),t);await this.P(o,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new $.$ik(t,0,i)),i}async P(t,o){const i=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(o,s.dirname(o));)try{if(!((await t.stat(o)).type&$.FileType.Directory))throw new Error((0,v.localize)(18,null,this.nb(o)));break}catch(n){if((0,$.$gk)(n)!==$.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(s.basename(o)),o=s.dirname(o)}for(let n=i.length-1;n>=0;n--){o=s.joinPath(o,i[n]);try{await t.mkdir(o)}catch(r){if((0,$.$gk)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,o){try{await this.Q(t,o)}catch(i){return i}return!0}async Q(t,o){const i=this.lb(await this.j(t),t),s=!!o?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,v.localize)(19,null,this.nb(t)));const n=o?.atomic;if(n&&!(i.capabilities&65536))throw new Error((0,v.localize)(20,null,this.nb(t)));if(s&&n)throw new Error((0,v.localize)(21,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new $.$lk((0,v.localize)(22,null,this.nb(t)),1);if(!!!o?.recursive){const P=await this.resolve(t);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,v.localize)(23,null,this.nb(t)))}return i}async del(t,o){const i=await this.Q(t,o),s=!!o?.useTrash,n=!!o?.recursive,r=o?.atomic??!1;await i.delete(t,{recursive:n,useTrash:s,atomic:r}),this.m.fire(new $.$ik(t,1))}async cloneFile(t,o){const i=await this.j(t),s=this.lb(await this.l(o),o);if(i===s&&this.N(i).providerExtUri.isEqual(t,o))return;if(i===s&&(0,$.$8j)(i))return i.cloneFile(t,o);await this.P(s,this.N(s).providerExtUri.dirname(o));const n=this.X.queueFor(t,this.N(i).providerExtUri);return i===s&&(0,$.$7j)(i)?n.queue(()=>i.copy(t,o,{overwrite:!0})):n.queue(()=>this.J(i,t,s,o))}watch(t,o={recursive:!1,excludes:[]}){const i=new l.$lb;let s=!1,n=()=>{s=!0};return i.add((0,l.$kb)(()=>n())),(async()=>{try{const r=await this.W(t,o);s?(0,l.$hb)(r):n=()=>(0,l.$hb)(r)}catch(r){this.b.error(r)}})(),i}async W(t,o){const i=await this.j(t),s=(0,y.$ni)([this.N(i).providerExtUri.getComparisonKey(t),o]);let n=this.U.get(s);return n||(n={count:0,disposable:i.watch(t,o)},this.U.set(s,n)),n.count+=1,(0,l.$kb)(()=>{n&&(n.count--,n.count===0&&((0,l.$hb)(n.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.$hb)(t.disposable);this.U.clear()}async Y(t,o,i,s,n){await this.Z(t,i,s,n);try{await t.rename(i,o,{overwrite:!0})}catch(r){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async Z(t,o,i,s){return this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(o,{create:!0,unlock:i?.unlock??!1});try{(0,w.$tc)(s)||(0,w.$uc)(s)?await this.$(t,n,s):await this.ab(t,n,s)}catch(r){throw(0,$.$ek)(r)}finally{await t.close(n)}})}async $(t,o,i){let s=0,n;if((0,w.$uc)(i)){if(i.buffer.length>0){const r=R.$Hc.concat(i.buffer);await this.bb(t,o,r,r.byteLength,s,0),s+=r.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((r,c)=>{(0,w.$zc)(n,{onData:async P=>{n.pause();try{await this.bb(t,o,P,P.byteLength,s,0)}catch(I){return c(I)}s+=P.byteLength,setTimeout(()=>n.resume())},onError:P=>c(P),onEnd:()=>r()})})}async ab(t,o,i){let s=0,n;for(;(n=i.read())!==null;)await this.bb(t,o,n,n.byteLength,s,0),s+=n.byteLength}async bb(t,o,i,s,n,r){let c=0;for(;c<s;){const P=await t.write(o,n+c,i.buffer,r+c,s-c);c+=P}}async cb(t,o,i,s){return this.X.queueFor(o,this.N(t).providerExtUri).queue(()=>this.db(t,o,i,s))}async db(t,o,i,s){let n;s instanceof R.$Hc?n=s:(0,w.$tc)(s)?n=await(0,R.$Tc)(s):(0,w.$uc)(s)?n=await(0,R.$Uc)(s):n=(0,R.$Rc)(s),await t.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async eb(t,o,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.fb(t,o,i,s))}async fb(t,o,i,s){let n,r;try{n=await t.open(o,{create:!1}),r=await i.open(s,{create:!0,unlock:!1});const c=R.$Hc.alloc(this.a);let P=0,I=0,b=0;do b=await t.read(n,P,c.buffer,I,c.byteLength-I),await this.bb(i,r,c,b,P,I),P+=b,I+=b,I===c.byteLength&&(I=0);while(b>0)}catch(c){throw(0,$.$ek)(c)}finally{await N.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async gb(t,o,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.hb(t,o,i,s))}async hb(t,o,i,s){return i.writeFile(s,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,o,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.jb(t,o,i,s))}async jb(t,o,i,s){const n=await i.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(o);await this.bb(i,n,R.$Hc.wrap(r),r.byteLength,0,0)}catch(r){throw(0,$.$ek)(r)}finally{await i.close(n)}}async kb(t,o,i,s){const n=await(0,R.$Tc)(this.C(t,o,A.CancellationToken.None));await this.cb(i,s,void 0,n)}lb(t,o){if(t.capabilities&2048)throw new $.$lk((0,v.localize)(24,null,this.nb(o)),6);return t}mb(t,o){if((o.permissions??0)&$.FilePermission.Readonly)throw new $.$lk((0,v.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===k.Schemas.file?t.fsPath:t.toString(!0)}};e.$Ap=p,e.$Ap=p=$e([se(0,f.$3i)],p)}),define(ne[124],re([0,1,125,169,8,35,14,4,170,2,16,13,17,41,24,101,12,61,121,33,119,118]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0,(()=>{try{(0,N.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,S.$ki)(o)}`)}})();class t extends f.$Jp{static{this.D=!1}constructor(i,s){super(i,s),this.onDidChangeCapabilities=y.Event.None,this.I=new A.$xi(n=>g.$0f.getComparisonKey(n)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,k.$k&&(this.F|=1024)),this.F}async stat(i){try{const{stat:s,symbolicLink:n}=await w.SymlinkSupport.stat(this.C(i));return{type:this.H(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:$.FilePermission.Locked}}catch(s){throw this.ab(s)}}async G(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const s=await w.Promises.readdir(this.C(i),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async r=>{try{let c;r.isSymbolicLink()?c=(await this.stat((0,g.$gg)(i,r.name))).type:c=this.H(r),n.push([r.name,c])}catch(c){this.a.trace(c)}})),n}catch(s){throw this.ab(s)}}H(i,s){let n;return s?.dangling?n=$.FileType.Unknown:i.isFile()?n=$.FileType.File:i.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,s&&(n|=$.FileType.SymbolicLink),n}async J(i){const s=this.C(i);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let n;for(;n=this.I.get(i);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await n.wait();const r=new R.$Dg;return this.I.set(i,r),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,l.$kb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.I.get(i)===r&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.I.delete(i)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(i,s){let n;try{s?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),n=await this.J(i));const r=this.C(i);return await w.Promises.readFile(r)}catch(r){throw this.ab(r)}finally{n?.dispose()}}L(i){t.D&&this.a.trace(i)}readFileStream(i,s,n){const r=(0,d.$vc)(c=>j.$Hc.concat(c.map(P=>j.$Hc.wrap(P))).buffer);return(0,h.$zp)(this,i,r,c=>c.buffer,{...s,bufferSize:256*1024},n),r}async writeFile(i,s,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.M(i,(0,g.$gg)((0,g.$fg)(i),`${(0,g.$dg)(i)}${n.atomic.postfix}`),s,n):this.N(i,s,n)}async M(i,s,n,r){await this.N(s,n,r);try{await this.rename(s,i,{overwrite:!0})}catch(c){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async N(i,s,n){let r;try{const c=this.C(i);if(!n.create||!n.overwrite){if(await w.Promises.exists(c)){if(!n.overwrite)throw(0,$.$dk)((0,v.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$dk)((0,v.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(c){throw await this.bb(i,c)}finally{typeof r=="number"&&await this.close(r)}}static{this.R=!0}static configureFlushOnWrite(i){t.R=i}async open(i,s){const n=this.C(i);let r;(0,$.$5j)(s)&&(r=await this.J(i));let c;try{if((0,$.$5j)(s)&&s.unlock)try{const{stat:I}=await w.SymlinkSupport.stat(n);I.mode&128||await w.Promises.chmod(n,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let P;if((0,$.$5j)(s)){if(k.$i)try{await w.Promises.truncate(n,0),P="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}P||(P="w")}else P="r";c=await w.Promises.open(n,P)}catch(P){throw r?.dispose(),(0,$.$5j)(s)?await this.bb(i,P):this.ab(P)}if(this.O.set(c,0),(0,$.$5j)(s)&&this.Q.set(c,i),r){const P=this.P.get(c);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${n})`),this.P.set(c,r),P&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${n})`),P.dispose())}return c}async close(i){const s=this.P.get(i);try{if(this.O.delete(i),this.Q.delete(i)&&t.R)try{await w.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await w.Promises.close(i)}catch(n){throw this.ab(n)}finally{s&&(this.P.get(i)===s&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.P.delete(i)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,n,r,c){const P=this.S(i,s);let I=null;try{I=(await w.Promises.read(i,n,r,c,P)).bytesRead}catch(b){throw this.ab(b)}finally{this.U(i,P,I)}return I}S(i,s){return s===this.O.get(i)?null:s}U(i,s,n){const r=this.O.get(i);typeof r=="number"&&(typeof s=="number"||(typeof n=="number"?this.O.set(i,r+n):this.O.delete(i)))}async write(i,s,n,r,c){return(0,R.$Wg)(()=>this.W(i,s,n,r,c),100,3)}async W(i,s,n,r,c){const P=this.S(i,s);let I=null;try{I=(await w.Promises.write(i,n,r,c,P)).bytesWritten}catch(b){throw await this.bb(this.Q.get(i),b)}finally{this.U(i,P,I)}return I}async mkdir(i){try{await w.Promises.mkdir(this.C(i))}catch(s){throw this.ab(s)}}async delete(i,s){try{const n=this.C(i);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,O.$$c)((0,O.$bd)(n),`${(0,O.$cd)(n)}${s.atomic.postfix}`)),await w.Promises.rm(n,w.RimRafMode.MOVE,r)}else try{await w.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let c=!1;try{const{stat:P,symbolicLink:I}=await w.SymlinkSupport.stat(n);c=P.isDirectory()&&!I}catch{}if(c)await w.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.ab(n)}}async rename(i,s,n){const r=this.C(i),c=this.C(s);if(r!==c)try{await this.X(i,s,"move",n.overwrite),await w.Promises.rename(r,c)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,v.localize)(2,null,(0,O.$cd)(r),(0,O.$cd)((0,O.$bd)(c)),P.toString()))),this.ab(P)}}async copy(i,s,n){const r=this.C(i),c=this.C(s);if(r!==c)try{await this.X(i,s,"copy",n.overwrite),await w.Promises.copy(r,c,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,v.localize)(3,null,(0,O.$cd)(r),(0,O.$cd)((0,O.$bd)(c)),P.toString()))),this.ab(P)}}async X(i,s,n,r){const c=this.C(i),P=this.C(s);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$Je)(c,P,!0)),I){if(n==="copy")throw(0,$.$dk)((0,v.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const D=await this.G(i);if(!D)throw(0,$.$dk)((0,v.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.G(s);if(H){if(!r)throw(0,$.$dk)((0,v.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);D.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,s){return this.Y(i,s,!1)}async Y(i,s,n){const r=this.C(i),c=this.C(s),P=!!(this.capabilities&1024);if((0,u.$Je)(r,c,!P))return;const I=new l.$lb;try{const[b,D]=await Promise.all([this.J(i),this.J(s)]);I.add(b),I.add(D),n&&await w.Promises.mkdir((0,O.$bd)(c),{recursive:!0}),await w.Promises.copyFile(r,c)}catch(b){if(b.code==="ENOENT"&&!n)return this.Y(i,s,!0);throw this.ab(b)}finally{I.dispose()}}p(i,s,n){return new p.$Qp(r=>i(r),r=>s(r),n)}y(i,s,n){return new E.$Yp(r=>i(r),r=>s(r),n)}ab(i){if(i instanceof $.$ck)return i;let s=i,n;switch(i.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$dk)(s,n)}async bb(i,s){let n=this.ab(s);if(i&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await w.SymlinkSupport.stat(this.C(i));r.mode&128||(n=(0,$.$dk)(s,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$Zp=t}),define(ne[126],re([0,1,2,6]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=void 0;class R extends L.$mb{constructor(j,y=[]){super(),this.a=new N.$aj([j,...y]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...y){this.a.trace(j,...y)}debug(j,...y){this.a.debug(j,...y)}info(j,...y){this.a.info(j,...y)}warn(j,...y){this.a.warn(j,...y)}error(j,...y){this.a.error(j,...y)}flush(){this.a.flush()}}e.$dN=R}),define(ne[127],re([0,1,12,6]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=void 0;var R;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(R||(R={}));async function A(l,O,k,g,d){try{const w=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});w.setFlushOn(R.Trace);const v=await w.createAsyncRotatingLogger(l,O,k,g);return d?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(w){console.error(w)}return null}function j(l,O,k){switch(O){case N.LogLevel.Trace:l.trace(k);break;case N.LogLevel.Debug:l.debug(k);break;case N.LogLevel.Info:l.info(k);break;case N.LogLevel.Warning:l.warn(k);break;case N.LogLevel.Error:l.error(k);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function y(l,O){switch(O){case N.LogLevel.Trace:l.setLevel(R.Trace);break;case N.LogLevel.Debug:l.setLevel(R.Debug);break;case N.LogLevel.Info:l.setLevel(R.Info);break;case N.LogLevel.Warning:l.setLevel(R.Warning);break;case N.LogLevel.Error:l.setLevel(R.Error);break;case N.LogLevel.Off:l.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${O}`)}}class u extends N.$9i{constructor(O,k,g,d,w){super(),this.k=[],this.setLevel(w),this.l=this.n(O,k,g,d),this.B(this.onDidChangeLogLevel(v=>{this.m&&y(this.m,v)}))}async n(O,k,g,d){const w=g?6:1,v=30/w*L.$yk.MB,$=await A(O,k,v,w,d);if($){this.m=$,y(this.m,this.getLevel());for(const{level:h,message:f}of this.k)j(this.m,h,f);this.k=[]}}g(O,k){this.m?j(this.m,O,k):this.getLevel()<=O&&this.k.push({level:O,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$5M=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=void 0;class A extends N.$bj{m(y,u,l){return new R.$5M((0,L.$6e)(),y.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.$6M=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=void 0,e.$8m=(0,A.$zh)("policy");class j extends R.$mb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$hc),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const O=Object.keys(this.f).length;return this.f={...l,...this.f},O!==Object.keys(this.f).length&&await this.i(l),N.Iterable.reduce(this.g.entries(),(k,[g,d])=>({...k,[g]:d}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(l,[O,k])=>({...l,[O]:{definition:k,value:this.g.get(O)}}),{})}}e.$9m=j;class y{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$0m=y}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,N,R,A,j,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=void 0;function l(k,g){const d=[];for(const w of new Set(R.Iterable.concat(k.keys(),g.keys())))k.get(w)!==g.get(w)&&d.push(w);return d}let O=class extends u.$9m{constructor(g,d,w){super(),this.j=g,this.k=d,this.l=w,this.c=this.B(new L.$Cg(500));const v=N.Event.filter(d.onDidFilesChange,$=>$.affects(g));this.B(d.watch(g)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const g=new Map;try{const d=await this.k.readFile(this.j),w=JSON.parse(d.value.toString());if(!(0,A.$ne)(w))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(w))this.f[v]&&g.set(v,w[v])}catch(d){d.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",d)}return g}async p(){const g=await this.n(),d=l(this.g,g);this.g=g,d.length>0&&this.h.fire(d)}};e.$I6b=O,e.$I6b=O=$e([se(1,j.$4j),se(2,y.$3i)],O)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,N,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=void 0;let y=class extends L.$9m{constructor(l,O){super(),this.j=l,this.k=O,this.a=new N.$yg,this.b=this.B(new A.$nb)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((O,k)=>{try{this.b.value=(0,R.createWatcher)(this.k,l,g=>{this.m(g),O()})}catch(g){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),k(g)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const O in l){const k=l[O];k===void 0?this.g.delete(O):this.g.set(O,k)}this.h.fire(Object.keys(l))}};e.$H6b=y,e.$H6b=y=$e([se(0,j.$3i)],y)}),define(ne[31],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=void 0,e.$ij=(0,L.$zh)("productService"),e.$jj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;class R{constructor(){this.a=new Map}add(j,y){L.ok(N.$le(j)),L.ok(N.$ne(y)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,y)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$6m=new R}),define(ne[131],re([0,1,4,36]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$7m={JSONContribution:"base.contributions.json"};function R(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class A{constructor(){this.b=new L.$hc,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,l){this.a[R(u)]=l,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;N.$6m.add(e.$7m.JSONContribution,j)}),define(ne[44],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,N,R,A,j,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ConfigurationScope=e.$$m=e.EditPresentationTypes=void 0;var l;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$$m={Configuration:"base.contributions.configuration"};var O;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.$_m={properties:{},patternProperties:{}},e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn="vscode://schemas/settings/resourceLanguage",e.$gn="vscode://schemas/settings/configurationDefaults";const k=u.$6m.as(y.$7m.JSONContribution);class g{constructor(){this.h=new Set,this.i=new N.$hc,this.onDidSchemaChange=this.i.event,this.j=new N.$hc,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$fn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const i=new Set;this.n(t,o,i),k.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const o=new Set;this.o(t,o),k.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const i=new Set;this.o(o,i),this.n(t,!1,i),k.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const i=[];for(const{overrides:s,source:n}of t)for(const r in s)if(o.add(r),e.$in.test(r)){const c=this.a.get(r),P=c?.valuesSources??new Map;if(n)for(const H of Object.keys(s[r]))P.set(H,n);const I={...c?.value||{},...s[r]};this.a.set(r,{source:n,value:I,valuesSources:P});const b=(0,j.$di)(r),D={type:"object",default:I,description:A.localize(1,null,b),$ref:e.$fn,defaultDefaultValue:I,source:R.$le(n)?void 0:n,defaultValueSource:n};i.push(...v(r)),this.d[r]=D,this.b.properties[r]=D}else{this.a.set(r,{value:s[r],source:n});const c=this.d[r];c&&(this.w(r,c),this.r(r,c))}this.m(i)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:i,source:s}of t)for(const n in i){const r=this.a.get(n),c=R.$le(s)?s:s?.id,P=R.$le(r?.source)?r?.source:r?.source?.id;if(c===P)if(o.add(n),this.a.delete(n),e.$in.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,i){t.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,o){const i=s=>{if(s.properties)for(const n in s.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,s.properties[n])}s.allOf?.forEach(n=>i(n))};for(const s of t){i(s);const n=this.c.indexOf(s);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,i,s,n=3,r){n=R.$ue(t.scope)?n:t.scope;const c=t.properties;if(c)for(const I in c){const b=c[I];if(o&&S(I,b)){delete c[I];continue}if(b.source=i,b.defaultDefaultValue=c[I].default,this.w(I,b),e.$in.test(I)?b.scope=void 0:(b.scope=R.$ue(b.scope)?n:b.scope,b.restricted=R.$ue(b.restricted)?!!s?.includes(I):b.restricted),c[I].hasOwnProperty("included")&&!c[I].included){this.f[I]=c[I],delete c[I];continue}else this.d[I]=c[I],c[I].policy?.name&&this.e.set(c[I].policy.name,I);!c[I].deprecationMessage&&c[I].markdownDeprecationMessage&&(c[I].deprecationMessage=c[I].markdownDeprecationMessage),r.add(I)}const P=t.allOf;if(P)for(const I of P)this.p(I,o,i,s,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=i=>{const s=i.properties;if(s)for(const r in s)this.r(r,s[r]);i.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$_m.properties[t]=o,o.scope){case 1:e.$an.properties[t]=o;break;case 2:e.$bn.properties[t]=o;break;case 6:e.$cn.properties[t]=o;break;case 3:e.$dn.properties[t]=o;break;case 4:e.$en.properties[t]=o;break;case 5:e.$en.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$_m.properties[t],o.scope){case 1:delete e.$an.properties[t];break;case 2:delete e.$bn.properties[t];break;case 6:delete e.$cn.properties[t];break;case 3:delete e.$dn.properties[t];break;case 4:case 5:delete e.$en.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$fn};this.w(o,i),e.$_m.properties[o]=i,e.$an.properties[o]=i,e.$bn.properties[o]=i,e.$cn.properties[o]=i,e.$dn.properties[o]=i,e.$en.properties[o]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$fn};e.$_m.patternProperties[e.$hn]=t,e.$an.patternProperties[e.$hn]=t,e.$bn.patternProperties[e.$hn]=t,e.$cn.patternProperties[e.$hn]=t,e.$dn.patternProperties[e.$hn]=t,e.$en.patternProperties[e.$hn]=t,this.i.fire()}w(t,o){const i=this.a.get(t);let s=i?.value,n=i?.source;R.$se(s)&&(s=o.defaultDefaultValue,n=void 0),R.$se(s)&&(s=h(o.type)),o.default=s,o.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",w=new RegExp(d,"g");e.$hn=`^(${d})+$`,e.$in=new RegExp(e.$hn);function v(E){const t=[];if(e.$in.test(E)){let o=w.exec(E);for(;o?.length;){const i=o[1].trim();i&&t.push(i),o=w.exec(E)}}return(0,L.$Ff)(t)}e.$jn=v;function $(E){return E.reduce((t,o)=>`${t}[${o}]`,"")}e.$kn=$;function h(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ln=h;const f=new g;u.$6m.add(e.$$m.Configuration,f);function S(E,t){return E.trim()?e.$in.test(E)?A.localize(7,null,E):f.getConfigurationProperties()[E]!==void 0?A.localize(8,null,E):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,E,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$mn=S;function p(){const E=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))E.push([o,t[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$nn=p}),define(ne[66],re([0,1,19,4,53,2,35,30,3,11,25,44,36]),function(J,e,L,N,R,A,j,y,u,l,O,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=void 0;function d(o){return Object.isFrozen(o)?o:y.$Um(o)}class w{constructor(i={},s=[],n=[],r){this.b=i,this.c=s,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof w)return s;const n=new v("");return n.parseRaw(s),n.configurationModel});this.f=i.reduce((s,n)=>n===s?n:s.merge(n),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,O.$bi)(this.contents,i):this.contents}inspect(i,s){const n=this.rawConfiguration.getValue(i),r=s?this.rawConfiguration.getOverrideValue(i,s):void 0,c=s?this.rawConfiguration.override(s).getValue(i):n;return{value:n,override:r,merged:c}}getOverrideValue(i,s){const n=this.i(s);return n?i?(0,O.$bi)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const n of this.overrides)n.identifiers.includes(i)&&s.push(...n.keys);return L.$Ff(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return L.$Ff(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=y.$Tm(this.contents),n=y.$Tm(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const P of i)if(c.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(s,P.contents);for(const I of P.overrides){const[b]=n.filter(D=>L.$of(D.identifiers,I.identifiers));b?(this.h(b.contents,I.contents),b.keys.push(...I.keys),b.keys=L.$Ff(b.keys)):n.push(y.$Tm(I))}for(const I of P.keys)r.indexOf(I)===-1&&r.push(I)}return new w(s,r,n,c.every(P=>P instanceof w)?void 0:c)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const n={};for(const r of L.$Ff([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[r];const P=s[r];P&&(typeof c=="object"&&typeof P=="object"?(c=y.$Tm(c),this.h(c,P)):c=P),n[r]=c}return new w(n,this.keys,this.overrides)}h(i,s){for(const n of Object.keys(s)){if(n in i&&u.$ne(i[n])&&u.$ne(s[n])){this.h(i[n],s[n]);continue}i[n]=y.$Tm(s[n])}}i(i){let s=null,n=null;const r=c=>{c&&(n?this.h(n,c):n=y.$Tm(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===i?s=c.contents:c.identifiers.includes(i)&&r(c.contents);return r(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,O.$ai)(this.contents,i),k.$in.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>L.$of(n.identifiers,(0,k.$jn)(i))),1))}j(i,s,n){(0,O.$_h)(this.contents,i,s,r=>console.error(r)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),k.$in.test(i)&&this.overrides.push({identifiers:(0,k.$jn)(i),keys:Object.keys(this.contents[i]),contents:(0,O.$$h)(this.contents[i],r=>console.error(r))})}}e.$on=w;class v{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!u.$ue(i)){const n=this.g(i);this.parseRaw(n,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:n,keys:r,overrides:c,restricted:P,hasExcludedProperties:I}=this.h(i,s);this.b=new w(n,r,c,I?[i]:void 0),this.c=P||[]}g(i){let s={},n=null,r=[];const c=[],P=[];function I(D){Array.isArray(r)?r.push(D):n!==null&&(r[n]=D)}const b={onObjectBegin:()=>{const D={};I(D),c.push(r),r=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const D=[];I(D),c.push(r),r=D,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:I,onError:(D,H,_)=>{P.push({error:D,offset:H,length:_})}};if(i)try{R.$Qm(i,b),s=r[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return s}h(i,s){const n=g.$6m.as(k.$$m.Configuration).getConfigurationProperties(),r=this.i(i,n,!0,s);i=r.raw;const c=(0,O.$$h)(i,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),P=Object.keys(i),I=this.j(i,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:c,keys:P,overrides:I,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(i,s,n,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:c};const P={},I=[];for(const b in i)if(k.$in.test(b)&&n){const D=this.i(i[b],s,!1,r);P[b]=D.raw,c=c||D.hasExcludedProperties,I.push(...D.restricted)}else{const D=s[b],H=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&I.push(b),!r.exclude?.includes(b)&&(r.include?.includes(b)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&D?.restricted))?P[b]=i[b]:c=!0}return{raw:P,restricted:I,hasExcludedProperties:c}}j(i,s){const n=[];for(const r of Object.keys(i))if(k.$in.test(r)){const c={};for(const P in i[r])c[P]=i[r][P];n.push({identifiers:(0,k.$jn)(r),keys:Object.keys(c),contents:(0,O.$$h)(c,s)})}return n}}e.$pn=v;class $ extends A.$mb{constructor(i,s,n,r){super(),this.c=i,this.f=s,this.g=r,this.b=this.B(new N.$hc),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,c=>c.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&n.isEqual(c.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qn=$;class h{constructor(i,s,n,r,c,P,I,b,D,H,_,x,le){this.a=i,this.b=s,this.c=n,this.overrideIdentifiers=r,this.d=c,this.f=P,this.g=I,this.h=b,this.i=D,this.j=H,this.k=_,this.l=x,this.m=le}get value(){return d(this.c)}n(i,s,n){const r=i.inspect(s,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,s,n,r,c=new w,P=new w,I=new j.$xi,b=new w,D=new j.$xi){this.c=i,this.d=s,this.f=n,this.g=r,this.h=c,this.i=P,this.j=I,this.l=b,this.m=D,this.a=null,this.b=new j.$xi,this.n=null}getValue(i,s,n){return this.q(i,s,n).getValue(i)}updateValue(i,s,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new w,this.m.set(n.resource,r))):r=this.l,s===void 0?r.removeValue(i):r.setValue(i,s),n.resource||(this.a=null)}inspect(i,s,n){const r=this.q(i,s,n),c=this.u(s.resource,n),P=s.resource?this.m.get(s.resource)||this.l:this.l,I=new Set;for(const b of r.overrides)for(const D of b.identifiers)r.getOverrideValue(i,D)!==void 0&&I.add(D);return new h(i,s,r.getValue(i),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,c||void 0,P)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const n=[];if(!s){const{added:r,updated:c,removed:P}=E(this.c,i);s=[...r,...c,...P]}for(const r of s)for(const c of(0,k.$jn)(r)){const P=this.c.getKeysForOverrideIdentifier(c),I=i.getKeysForOverrideIdentifier(c),b=[...I.filter(D=>P.indexOf(D)===-1),...P.filter(D=>I.indexOf(D)===-1),...P.filter(D=>!y.$Xm(this.c.override(c).getValue(D),i.override(c).getValue(D)))];n.push([c,b])}return this.updateDefaultConfiguration(i),{keys:s,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:n,removed:r}=E(this.d,i),c=[...s,...n,...r];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=E(this.applicationConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateApplicationConfiguration(i),{keys:P,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=E(this.localUserConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateLocalUserConfiguration(i),{keys:P,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=E(this.remoteUserConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateRemoteUserConfiguration(i),{keys:P,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=E(this.workspaceConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateWorkspaceConfiguration(i),{keys:P,overrides:c}}compareAndUpdateFolderConfiguration(i,s){const n=this.p.get(i),{added:r,updated:c,removed:P,overrides:I}=E(n,s),b=[...r,...c,...P];return(b.length||!n)&&this.updateFolderConfiguration(i,s),{keys:b,overrides:I}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:c,overrides:P}=E(s,void 0);return{keys:[...n,...r,...c],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,n){let r=this.r(s,n);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}r({resource:i},s){let n=this.s();if(s&&i){const r=s.getFolder(i);r&&(n=this.t(r.uri)||n);const c=this.m.get(i);c&&(n=n.merge(c))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const n=this.s(),r=this.j.get(i);r?(s=n.merge(r),this.b.set(i,s)):s=n}return s}u(i,s){if(s&&i){const n=s.getFolder(i);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:n,overrides:r,keys:c}=this.j.get(s);return i.push([s,{contents:n,overrides:r,keys:c}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(n=>i.add(n))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.i.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r))),[...s.values()]}static parse(i){const s=this.x(i.defaults),n=this.x(i.policy),r=this.x(i.application),c=this.x(i.user),P=this.x(i.workspace),I=i.folders.reduce((b,D)=>(b.set(l.URI.revive(D[0]),this.x(D[1])),b),new j.$xi);return new f(s,n,r,c,new w,P,I,new w,new j.$xi)}static x(i){return new w(i.contents,i.keys,i.overrides)}}e.$rn=f;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,s=new Map;for(const r of o)r.keys.forEach(c=>i.add(c)),r.overrides.forEach(([c,P])=>{const I=(0,j.$ui)(s,c,new Set);P.forEach(b=>I.add(b))});const n=[];return s.forEach((r,c)=>n.push([c,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.$sn=S;class p{constructor(i,s,n,r){this.change=i,this.f=s,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const P of c)this.affectedKeys.add(P);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,s){const n=this.a+i,r=this.d.indexOf(n);if(r<0)return!1;const c=r+n.length;if(c>=this.d.length)return!1;const P=this.d.charCodeAt(c);if(P!==this.b&&P!==this.c)return!1;if(s){const I=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,b=this.g.getValue(i,s,this.h);return!y.$Xm(I,b)}return!0}}e.$tn=p;function E(o,i){const{added:s,removed:n,updated:r}=t(i?.rawConfiguration,o?.rawConfiguration),c=[],P=o?.getAllOverrideIdentifiers()||[],I=i?.getAllOverrideIdentifiers()||[];if(i){const b=I.filter(D=>!P.includes(D));for(const D of b)c.push([D,i.getKeysForOverrideIdentifier(D)])}if(o){const b=P.filter(D=>!I.includes(D));for(const D of b)c.push([D,o.getKeysForOverrideIdentifier(D)])}if(i&&o){for(const b of P)if(I.includes(b)){const D=t({contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)},{contents:i.getOverrideValue(void 0,b)||{},keys:i.getKeysForOverrideIdentifier(b)});c.push([b,[...D.added,...D.removed,...D.updated]])}}return{added:s,removed:n,updated:r,overrides:c}}function t(o,i){const s=o?i?o.keys.filter(c=>i.keys.indexOf(c)===-1):[...o.keys]:[],n=i?o?i.keys.filter(c=>o.keys.indexOf(c)===-1):[...i.keys]:[],r=[];if(o&&i){for(const c of i.keys)if(o.keys.indexOf(c)!==-1){const P=(0,O.$bi)(i.contents,c),I=(0,O.$bi)(o.contents,c);y.$Xm(P,I)||r.push(c)}}return{added:s,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,44,6,38,36]),function(J,e,L,N,R,A,j,y,u,l,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=void 0;class g extends R.$mb{constructor(){super(...arguments),this.a=this.B(new N.$hc),this.onDidChangeConfiguration=this.a.event,this.b=new y.$on}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$6m.as(u.$$m.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,k.$6m.as(u.$$m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new y.$on;const $=k.$6m.as(u.$$m.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const S of $){const p=f[S],E=h[S];p!==void 0?this.b.addValue(S,p):E?this.b.addValue(S,E.default):this.b.removeValue(S)}}}e.$un=g;class d{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new y.$on}async initialize(){return this.configurationModel}}e.$vn=d;let w=class extends R.$mb{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new N.$hc),this.onDidChangeConfiguration=this.a.event,this.b=new y.$on}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.i($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.j(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],S=k.$6m.as(u.$$m.Configuration).getConfigurationProperties();for(const p of $){const E=S[p];if(!E){f.push(p);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}f.push(p),h[E.policy.name]={type:E.type}}}return(0,j.$ye)(h)||await this.f.updatePolicyDefinitions(h),f}i($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=k.$6m.as(u.$$m.Configuration).getPolicyConfigurations(),f=(0,L.$Af)($.map(S=>h.get(S)));this.j(f,!0)}j($,h){this.g.trace("PolicyConfiguration#update",$);const f=k.$6m.as(u.$$m.Configuration).getConfigurationProperties(),S=[],p=this.b.isEmpty();for(const E of $){const t=f[E]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(p?o!==void 0:!(0,A.$Xm)(this.b.getValue(E),o))&&S.push([E,o])}else this.b.getValue(E)!==void 0&&S.push([E,void 0])}if(S.length){this.g.trace("PolicyConfiguration#changed",S);const E=this.b;this.b=new y.$on;for(const t of E.keys)this.b.setValue(t,E.getValue(t));for(const[t,o]of S)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);h&&this.a.fire(this.b)}}};e.$wn=w,e.$wn=w=$e([se(1,O.$8m),se(2,l.$3i)],w)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,N,R,A,j,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=void 0;class O extends R.$mb{constructor(g,d,w,v){super(),this.i=g,this.h=this.B(new N.$hc),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$un),this.c=w instanceof l.$0m?new u.$vn:this.B(new u.$wn(this.b,w,v)),this.f=this.B(new y.$qn(this.i,{},A.$0f,d)),this.a=new y.$rn(this.b.configurationModel,this.c.configurationModel,new y.$on,new y.$on),this.g=this.B(new L.$Qg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.k($,h))),this.B(this.c.onDidChangeConfiguration($=>this.l($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,d,w]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new y.$rn(g,d,new y.$on,w)}getConfigurationData(){return this.a.toData()}getValue(g,d){const w=typeof g=="string"?g:void 0,v=(0,j.$7h)(g)?g:(0,j.$7h)(d)?d:{};return this.a.getValue(w,v,void 0)}updateValue(g,d,w,v){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.j(g)}j(g){const d=this.a.toData(),w=this.a.compareAndUpdateLocalUserConfiguration(g);this.m(w,d,2)}k(g,d){const w=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(g,d);this.m(v,w,7)}l(g){const d=this.a.toData(),w=this.a.compareAndUpdatePolicyConfiguration(g);this.m(w,d,7)}m(g,d,w){const v=new y.$tn(g,{data:d},this.a);v.source=w,v.sourceConfig=this.n(w),this.h.fire(v)}n(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$xn=O}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=void 0;function N(l){return l.scheme===L.Schemas.vscodeRemote?l.authority:void 0}e.$Mk=N;function R(l){if(!l)return;const O=l.indexOf("+");return O<0?l:l.substr(0,O)}e.$Nk=R;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$Ok=A;function j(l){const{host:O,port:k}=u(l);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:k}}e.$Pk=j;function y(l,O){let{host:k,port:g}=u(l);return typeof g>"u"&&(g=O),{host:k,port:g}}e.$Qk=y;function u(l){const O=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const k=l.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const g=l.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:l,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.TargetPlatform=e.ExtensionType=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl="extensions.user.cache",e.$Ol="extensions.builtin.cache",e.$Pl="undefined_publisher",e.$Ql=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Rl=A,e.$Sl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(j||(e.ExtensionType=j={}));var y;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(y||(e.TargetPlatform=y={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,S=typeof h=="string"?h:h.value;return L.$Od(f,S)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Tl=u;class l{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$Ul=l;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vl=O;function k(v){return g(v)}e.$Wl=k;function g(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Xl=g;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$Yl=d;function w(v,$){if($){const h=`onResolveRemoteAuthority:${(0,R.$Nk)($)}`;return!!v.activationEvents?.includes(h)}return!1}e.$Zl=w,e.$1l=(0,N.$zh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;class A extends L.$mb{constructor(y,u,l,O,k){super(),this.a=y,this.b=u,this.c=l,this.f=k,this.B(O.onDidInstallExtensions(g=>this.g(g))),this.B(O.onDidUninstallExtension(g=>this.h(g)))}g(y){for(const u of y)u.local&&this.invalidate(u.profileLocation)}h(y){y.error||this.invalidate(y.profileLocation)}async invalidate(y){if(y)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,y)&&await this.i(u);else await this.i(this.a.defaultProfile)}async i(y){try{await this.b.del(this.c.extUri.joinPath(y.cacheHome,N.$Nl))}catch(u){(0,R.$hk)(u)!==1&&this.f.error(u)}}}e.$tp=A}),define(ne[45],re([0,1,14,9,2,103,44,10,6,36]),function(J,e,L,N,R,A,j,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=void 0,e.$Go=(0,y.$zh)("requestService");class O{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?E[t]="*****":E[t]=this.b[t];this.a=E}return this.a}}class k extends R.$mb{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,A.localize)(0,null),when:u.$hj.isEqualTo((0,u.$fj)(u.LogLevel.Trace)).serialize()})}async c(E,t,o){const i=`${E} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new O(t.headers??{}));try{const s=await o();return this.a.trace(`${i} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${i} - error`,t.type,(0,N.$8)(s)),s}}}e.$Ho=k;function g(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Io=g;function d(p){return p.res.statusCode===204}async function w(p){return d(p)?null:(await(0,L.$Tc)(p.stream)).toString()}e.$Jo=w;async function v(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);return w(p)}e.$Ko=v;async function $(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,L.$Tc)(p.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$Lo=$;function h(p){S(p)}e.$Mo=h;let f;function S(p){const E=l.$6m.as(j.$$m.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},E.updateConfigurations({add:[f],remove:t?[t]:[]})}S(1)}),define(ne[135],re([0,1,20,15,12,45]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;let j=class{constructor(u,l){this.a=u,this.b=l}async download(u,l,O=L.CancellationToken.None){if(u.scheme===N.Schemas.file||u.scheme===N.Schemas.vscodeRemote){await this.b.copy(u,l);return}const k={type:"GET",url:u.toString(!0)},g=await this.a.request(k,O);if(g.res.statusCode===200)await this.b.writeFile(l,g.stream);else{const d=await(0,A.$Ko)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${d}`)}}};e.$sN=j,e.$sN=j=$e([se(0,A.$Go),se(1,R.$4j)],j)}),define(ne[136],re([0,1,137,3]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;function R(j,y){return j.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:j.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function A(j,y,u={}){const l=(0,L.parse)(j),O=u.proxyUrl||R(l,y);if(!O)return null;const k=(0,L.parse)(O);if(!/^https?:$/.test(k.protocol||""))return null;const g={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,N.$re)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((d,w)=>{J(["http-proxy-agent"],d,w)}))(g):new(await new Promise((d,w)=>{J(["https-proxy-agent"],d,w)}))(g)}e.$Kq=A}),define(ne[138],re([0,1,58,16,104,20,33,9,13,28,84,172,8,72]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0;let w;async function v(h,f,S,p){return S["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.$El)(p)&&!S["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.$El)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=g.Promises.withAsyncBody(async(E,t)=>{const o=new A.$rc;let i=1e4;const s=h.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,d.$Fl)(s,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{E(await $(f,o.token))}catch(r){!(0,y.$2)(r)&&!o.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,j.$ki)(r)))):E({})}finally{clearTimeout(n),o.dispose()}})),w)}e.$Kl=v;async function $(h,f){const S=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",S);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const E=(0,l.$6e)().replace(/-/g,"").substr(0,12),t=new RegExp(E+"({.*})"+E),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",o);const i=await(0,O.$ul)(u.OS,o);return h.trace("getUnixShellEnvironment#shell",i),new Promise((s,n)=>{if(f.isCancellationRequested)return n(new y.$3);const r=(0,N.$cd)(i);let c,P;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(c=`& '${process.execPath}' ${I} -p '''${E}'' + JSON.stringify(process.env) + ''${E}'''`,P=["-Login","-Command"]):r==="nu"?(c=`^'${process.execPath}' ${I} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,P=["-i","-l","-c"]):(c=`'${process.execPath}' ${I} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,r==="tcsh"||r==="csh"?P=["-ic"]:P=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),c);const b=(0,L.spawn)(i,[...P,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(b.kill(),n(new y.$3))),b.on("error",_=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,j.$ki)(_)),n(_)});const D=[];b.stdout.on("data",_=>D.push(_));const H=[];b.stderr.on("data",_=>H.push(_)),b.on("close",(_,x)=>{const le=Buffer.concat(D).toString("utf8");h.trace("getUnixShellEnvironment#raw",le);const te=Buffer.concat(H).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),_||x)return n(new Error((0,R.localize)(2,null,_,x)));const ce=t.exec(le),ue=ce?ce[1]:"{}";try{const ie=JSON.parse(ue);S?ie.ELECTRON_RUN_AS_NODE=S:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),s(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,j.$ki)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=void 0,e.$7M=(0,L.$zh)("stateReadService"),e.$8M=(0,L.$zh)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,L,N,R,A,j,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.$9M=e.SaveStrategy=void 0;var l;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class O extends R.$mb{constructor(w,v,$,h){super(),this.h=w,this.i=$,this.j=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=v===0?void 0:this.B(new L.$Cg(100))}init(){return this.f||(this.f=this.k()),this.f}async k(){try{this.b=(await this.j.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.i.error(w)}}getItem(w,v){const $=this.a[w];return(0,A.$ue)($)?v:$}setItem(w,v){this.setItems([{key:w,data:v}])}setItems(w){let v=!1;for(const{key:$,data:h}of w)this.a[$]!==h&&((0,A.$ue)(h)?(0,A.$se)(this.a[$])||(this.a[$]=void 0,v=!0):(this.a[$]=h,v=!0));v&&this.l()}removeItem(w){(0,A.$se)(this.a[w])||(this.a[w]=void 0,this.l())}async l(){if(!this.g)return this.c?this.c.trigger(()=>this.m()):this.m()}async m(){if(!this.f)return;await this.f;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.j.writeFile(this.h,N.$Hc.fromString(w),{atomic:{postfix:".vsctmp"}}),this.b=w}catch(v){this.i.error(v)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.m(),0):this.m()),this.g}}e.$9M=O;let k=class extends R.$mb{constructor(w,v,$,h){super(),this.a=this.B(new O(v.stateResource,w,$,h))}async init(){await this.a.init()}getItem(w,v){return this.a.getItem(w,v)}};e.$0M=k,e.$0M=k=$e([se(1,j.$Gh),se(2,u.$3i),se(3,y.$4j)],k);class g extends k{setItem(w,v){this.a.setItem(w,v)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}e.$$M=g}),define(ne[69],re([0,1,13,34,28]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=void 0;function A(u){if(L.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,l,O,k,g,d,w,v){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,R.$6e)()+Date.now(),$.commitHash=k,$.version=g,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$h)(L.$t),$["common.nodePlatform"]=N.$5c,$["common.nodeArch"]=O,$["common.product"]=v||"desktop",w&&($["common.msftInternal"]=w);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$l&&($["common.snap"]="true");const S=A(l);return S&&($["common.platformDetail"]=S),$}e.$8n=j;function y(u){const l=N.env.USERDNSDOMAIN;if(!l)return!1;const O=l.toLowerCase();return u.some(k=>O===k)}e.$9n=y}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0,e.$7k=(0,L.$zh)("telemetryService"),e.$8k=(0,L.$zh)("customEndpointTelemetryService"),e.$9k="telemetry.currentSessionDate",e.$0k="telemetry.firstSessionDate",e.$$k="telemetry.lastSessionDate",e.$_k="telemetry.machineId",e.$al="telemetry",e.$bl="telemetry.telemetryLevel",e.$cl="telemetry.enableCrashReporter",e.$dl="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,N,R,A,j,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$0n=l;class O{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$$n=O,e.$_n=new O;class k{async publicLog(n,r,c){}async publicLogError(n,r,c){}}e.$ao=k,e.$bo="telemetry",e.$co="extensionTelemetryLog",e.$do={log:()=>null,flush:()=>Promise.resolve(null)};function g(s,n){return R.Event.debounce(n.onDidChangeConfiguration,(c,P)=>{const I=c?new Set([...c.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:I}},1e3,!0)(c=>{c.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,A.$9h)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.$eo=g;function d(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry||n.extensionTestsLocationURI)}e.$fo=d;function w(s,n){return!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$go=w;function v(s){const n=s.getValue(u.$bl),r=s.getValue(u.$cl);if(s.getValue(u.$dl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ho=v;function $(s){const n={},r={},c={};S(s,c);for(let P in c){P=P.length>150?P.substr(P.length-149):P;const I=c[P];typeof I=="number"?r[P]=I:typeof I=="boolean"?r[P]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${I.length}`),n[P]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[P]=I)}return{properties:n,measurements:r}}e.$io=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(s){if(!s)return"none";const n=(0,j.$Nk)(s);return h.has(n)?n:"other"}e.$jo=f;function S(s,n,r=0,c){if(s)for(const P of Object.getOwnPropertyNames(s)){const I=s[P],b=c?c+P:P;Array.isArray(I)?n[b]=(0,L.$Ym)(I):I instanceof Date?n[b]=I.toISOString():(0,N.$ne)(I)?r<2?S(I,n,r+1,b+"."):n[b]=(0,L.$Ym)(I):n[b]=I}}function p(s,n){const r=s.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,y.$9n)(r)||c}e.$ko=p;function E(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$lo=E;function t(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const c=[];for(const D of n)for(;;){const H=D.exec(s);if(!H)break;c.push([H.index,D.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(r="";;){const D=I.exec(s);if(!D)break;const H=c.some(([_,x])=>D.index<x&&_<I.lastIndex);!P.test(D[0])&&!H&&(r+=s.substring(b,D.index)+"<REDACTED: user-file-path>",b=I.lastIndex)}return b<s.length&&(r+=s.substr(b)),r}function o(s){if(!s)return s;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function i(s,n){return(0,L.$Vm)(s,r=>{if(r instanceof l||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=t(c,n);for(const P of n)c=c.replace(P,"");return c=o(c),c}})}e.$mo=i}),define(ne[27],re([0,1,29,21,37,13,11,9,34,39]),function(J,e,L,N,R,A,j,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;function O(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,L.$Jd)(i.id,s.id)===0}e.$no=O;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const n=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,n,r)}static parse(s){const n=k.exec(s);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?O(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$oo=g;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(i){const s=d.exec(i);return s&&s[1]?[$(s[1]),s[2]]:[$(i),void 0]}e.$po=w;function v(i,s){return`${i}.${s}`}e.$qo=v;function $(i){return i.toLowerCase()}e.$ro=$;function h(i,s){return $(v(i??R.$Pl,s))}e.$so=h;function f(i,s){const n=[],r=c=>{for(const P of n)if(P.some(I=>O(s(I),s(c))))return P;return null};for(const c of i){const P=r(c);P?P.push(c):n.push([c])}return n}e.$to=f;function S(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$uo=S;function p(i){return{id:new l.$0n(i.identifier.id),name:new l.$0n(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$vo=p,e.$wo=new R.$Tl("pprice.better-merge");function E(i,s){const n=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&n.every(P=>!O(P.identifier,{id:c}))){const P=i.filter(I=>O(I.identifier,{id:c}));P.length===1&&(n.push(P[0]),r.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$xo=E;async function t(i,s){if(!A.$k)return!1;let n;try{n=(await i.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,y.$8)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(i,s){const n=await t(i,s),r=(0,N.$Sn)(n?"alpine":A.$t,u.$6c);return s.debug("ComputeTargetPlatform:",r),r}e.$yo=o}),define(ne[140],re([0,1,20,9,15,17,43,11,93,21,27,37]),function(J,e,L,N,R,A,j,y,u,l,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=void 0;const g=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function w($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let v=class{constructor(h,f,S){this.a=h,this.b=f,this.d=S}get f(){}async listExtensions(h,f,S){let p=await this.b.getInstalled(1,S);const E=k.$Sl.map(o=>o.toLowerCase());if(f&&f!==""){if(E.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(s=>s.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),E.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((o,i)=>o.identifier.id.localeCompare(i.identifier.id));let t;for(const o of p)t!==o.identifier.id&&(t=o.identifier.id,this.a.info(w(o.manifest,h)))}async installExtensions(h,f,S,p){const E=[];try{const t=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const o=[];let i=[];const s=(r,c,P)=>{i.push({id:r,version:c!=="prerelease"?c:void 0,installOptions:{...S,isBuiltin:P,installPreReleaseVersion:c==="prerelease"||S.installPreReleaseVersion}})};for(const r of h)if(r instanceof y.URI)o.push({vsix:r,installOptions:S});else{const[c,P]=(0,O.$po)(r);s(c,P,!1)}for(const r of f)if(r instanceof y.URI)o.push({vsix:r,installOptions:{...S,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,P]=(0,O.$po)(r);s(c,P,!0)}const n=await this.b.getInstalled(1,S.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:c})=>{try{const P=await this.g(r,c,p,n);P&&t.push(P)}catch(P){this.a.error(P),E.push(r.toString())}})),i.length&&(i=i.filter(({id:r,version:c})=>{const P=n.find(I=>(0,O.$no)(I.identifier,{id:r}));if(P){if(!p&&(!c||c==="prerelease"&&P.preRelease))return this.a.info((0,u.localize)(5,null,r,P.manifest.version,r)),!1;if(c&&P.manifest.version===c)return this.a.info((0,u.localize)(6,null,`${r}@${c}`)),!1}return!0}),i.length)){const r=await this.h(i);await Promise.all(i.map(async c=>{const P=r.get(c.id.toLowerCase());if(P)try{const I=await this.j(c,P,n);I&&t.push(I)}catch(I){this.a.error(I.message||I.stack||I),E.push(c.id)}else this.a.error(`${g(c.version?`${c.id}@${c.version}`:c.id)}
${d}`),E.push(c.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,N.$8)(t))),t}if(E.length)throw new Error((0,u.localize)(8,null,E.join(", ")))}async g(h,f,S,p){const E=await this.b.getManifest(h);if(!E)throw new Error("Invalid vsix");if(await this.l(E,S,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,A.$dg)(h))),E}catch(o){if((0,N.$2)(o))return this.a.info((0,u.localize)(10,null,(0,A.$dg)(h))),null;throw o}return null}async h(h){const f=new Map,S=h.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),E=[];for(const t of h)l.$Ln.test(t.id)&&E.push({...t,preRelease:S});if(E.length){const t=await this.d.getExtensions(E,{targetPlatform:p},L.CancellationToken.None);for(const o of t)f.set(o.identifier.id.toLowerCase(),o)}return f}async j({id:h,version:f,installOptions:S},p,E){const t=await this.d.getManifest(p,L.CancellationToken.None);if(t&&!this.k(t))return null;const o=E.find(i=>(0,O.$no)(i.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{S.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const i=await this.b.installFromGallery(p,{...S,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,i.manifest.version)),t}catch(i){if((0,N.$2)(i))return this.a.info((0,u.localize)(18,null,h)),null;throw i}}k(h){return!0}async l(h,f,S,p){if(!f){const E={id:(0,O.$so)(h.publisher,h.name)},t=p.find(o=>(0,O.$no)(E,o.identifier)&&(0,j.gt)(o.manifest.version,h.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,S){const p=async t=>{if(t instanceof y.URI){const o=await this.b.getManifest(t);return w(o)}return t},E=[];for(const t of h){const o=await p(t),s=(await this.b.getInstalled(void 0,S)).filter(n=>(0,O.$no)(n.identifier,{id:o}));if(!s.length)throw new Error(`${this.m(o)}
${d}`);if(s.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,o));return}if(!f&&s.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,o));return}this.a.info((0,u.localize)(22,null,o));for(const n of s)await this.b.uninstall(n,{profileLocation:S}),E.push(n);this.f?this.a.info((0,u.localize)(23,null,o,this.f)):this.a.info((0,u.localize)(24,null,o))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(S=>{f.forEach(p=>{if(p.identifier.id===S&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$6o=v,e.$6o=v=$e([se(1,l.$Zn),se(2,l.$Xn)],v)}),define(ne[141],re([0,1,4,2,35,27,37]),function(J,e,L,N,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;class y extends N.$mb{constructor(l,O,k,g,d,w,v){super(),this.f=l,this.g=O,this.h=k,this.i=g,this.j=d,this.k=w,this.l=v,this.a=this.B(new L.$hc),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$ub),this.m().then(null,$=>v.error($))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(l=>this.p(l.added))),this.B(this.i.onAddExtensions(l=>this.r(l))),this.B(this.i.onDidAddExtensions(l=>this.s(l))),this.B(this.i.onRemoveExtensions(l=>this.t(l))),this.B(this.i.onDidRemoveExtensions(l=>this.u(l))),this.B(this.k.onDidFilesChange(l=>this.v(l)))}async p(l){try{l.length&&await Promise.all(l.map(O=>(this.c.set(O.id,(0,N.$jb)(this.k.watch(this.j.extUri.dirname(O.extensionsResource)),this.k.watch(O.extensionsResource))),this.y(O.extensionsResource))))}catch(O){throw this.l.error(O),O}}async r(l){for(const O of l.extensions)this.C(this.F(O.identifier,O.version),l.profileLocation)}async s(l){for(const O of l.extensions){const k=this.F(O.identifier,O.version);l.error?this.D(k,l.profileLocation):this.C(k,l.profileLocation)}}async t(l){for(const O of l.extensions)this.D(this.F(O.identifier,O.version),l.profileLocation)}async u(l){const O=[],k=[];for(const g of l.extensions){const d=this.F(g.identifier,g.version);l.error?this.C(d,l.profileLocation):(this.D(d,l.profileLocation),this.b.has(d)||(this.l.debug("Extension is removed from all profiles",g.identifier.id,g.version),k.push(this.f.scanInstalledExtensionAtLocation(g.location).then(w=>{w?O.push(w):this.l.info("Extension not found at the location",g.location.toString())},w=>this.l.error(w)))))}try{await Promise.all(k),O.length&&await this.z(O)}catch(g){this.l.error(g)}}v(l){for(const O of this.h.profiles)l.contains(O.extensionsResource,0,1)&&this.w(O.extensionsResource)}async w(l){const O=[],k=[],g=await this.i.scanProfileExtensions(l),d=new Set,w=new Set;for(const[v,$]of this.b)$.has(l)&&w.add(v);for(const v of g){const $=this.F(v.identifier,v.version);d.add($),w.has($)||(O.push(v.identifier),this.C($,l))}for(const v of w)if(!d.has(v)){const $=this.G(v);$&&(k.push($.identifier),this.D(v,l))}(O.length||k.length)&&this.a.fire({added:O.length?{extensions:O,profileLocation:l}:void 0,removed:k.length?{extensions:k,profileLocation:l}:void 0})}async y(l){const O=await this.i.scanProfileExtensions(l);for(const k of O)this.C(this.F(k.identifier,k.version),l)}async z(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.F(k.identifier,k.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}C(l,O){let k=this.b.get(l);k||this.b.set(l,k=new R.$yi(g=>this.j.extUri.getComparisonKey(g))),k.add(O)}D(l,O){const k=this.b.get(l);k&&k.delete(O),k?.size||this.b.delete(l)}F(l,O){return`${j.$Tl.toKey(l.id)}@${O}`}G(l){const[O,k]=(0,A.$po)(l);return k?{identifier:{id:O},version:k}:void 0}}e.$up=y}),define(ne[142],re([0,1,113,39]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0;async function R(A,j,y,u,l,O,k){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,N.$fo)(j,y)&&(0,N.$ho)(u)===3){const d=await(0,L.$Yo)(y,l,O);g["X-Market-User-Id"]=d,g["VSCode-SessionId"]=k.machineId||d}return g}e.$Zo=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let v=class extends d.$Gq{constructor(S,p,E,t){super(E),this.h=S,this.i=t,this.g=this.B(new $(p,t)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(S,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.i.warn(`No language pack found for ${p}`);return}const o=t.translations[S];return o?w.URI.file(o):void 0}async getInstalledLanguages(){const S=await this.g.getLanguagePacks(),p=Object.keys(S).map(E=>{const t=S[E];return{...this.f(E,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((E,t)=>E.label.localeCompare(t.label)),p}async j(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",S.identifier.id),await this.update())}async k(S){const p=await this.g.getLanguagePacks();Object.keys(p).some(E=>p[E]&&p[E].extensions.some(t=>(0,k.$no)(t.extensionIdentifier,S.identifier)))&&(this.i.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(p);return!(0,N.$of)(Object.keys(S),Object.keys(E))}};e.$Hq=v,e.$Hq=v=$e([se(0,O.$Zn),se(1,l.$Hh),se(2,O.$Xn),se(3,g.$3i)],v);let $=class extends A.$mb{constructor(S,p){super(),this.i=p,this.c={},this.f=(0,y.$$c)(S.userDataPath,"languagepacks.json"),this.g=new R.$Lg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(S){return this.m(p=>{Object.keys(p).forEach(E=>delete p[E]),this.j(p,...S)}).then(()=>this.c)}j(S,...p){for(const E of p)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.k(S,E);Object.keys(S).forEach(E=>this.l(S[E]))}k(S,p){const E=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of t)if(p.location.scheme===j.Schemas.file&&h(o)){let i=S[o.languageId];i||(i={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},S[o.languageId]=i);const s=i.extensions.filter(n=>(0,k.$no)(n.extensionIdentifier,E))[0];s?s.version=p.manifest.version:i.extensions.push({extensionIdentifier:E,version:p.manifest.version});for(const n of o.translations)i.translations[n.id]=(0,y.$$c)(p.location.fsPath,n.path)}}l(S){if(S){const p=(0,L.createHash)("md5");for(const E of S.extensions)p.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);S.hash=p.digest("hex")}}m(S=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(p=S(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.c=E,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>p,E=>this.i.error(E))})}};$=$e([se(0,l.$Hh),se(1,g.$3i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const S of f.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",y="https://mobile.events.data.microsoft.com/ping";async function u(O,k,g){const d=await(0,L.$9C)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,L.$9C)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new d.AppInsightsCore,$=new w.PostChannel,h={instrumentationKey:O,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(g){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[$.identifier]=f}return v.initialize(h,[]),v.addTelemetryInitializer(f=>{k&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),v}class l{constructor(k,g,d,w,v){this.e=k,this.f=g,this.g=d,this.h=v,this.c=j,this.d=y,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(g=>{k(g)},g=>{(0,N.$Y)(g),console.error(g)})}}log(k,g){if(!this.a)return;g=(0,R.$Wm)(g,this.g),g=(0,A.$io)(g);const d=this.f+"/"+k;try{this.i(w=>{w.pluginVersionString=g?.properties.version??"Unknown",w.track({name:d,baseData:{name:d,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$3M=l}),define(ne[145],re([0,1,2,30,13,29,105,25,44,146,31,36,26,39]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,S){this.k=f,this.l=S,this.d={},this.i=new L.$lb,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$sd)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$sd)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(g.$bl)||p.affectsConfiguration(g.$dl)||p.affectsConfiguration(g.$cl))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$ho)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const S=f.usage?3:f.error?2:0;h=Math.min(h,S)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,S){this.g<f||(S=(0,N.$Wm)(S,this.d),S=(0,d.$mo)(S,this.j),S=(0,N.$Wm)(S,this.c),this.b.forEach(p=>p.log(h,S)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Nq=w,e.$Nq=w=$e([se(1,y.$6h),se(2,O.$ij)],w);function v(){const $=(0,j.localize)(0,null,l.default.nameLong),h=l.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.$o?"":(0,j.localize)(3,null),S=(0,j.localize)(4,null),p=(0,j.localize)(5,null),E=(0,j.localize)(6,null),t=(0,j.localize)(7,null),o=`
|       | ${S} | ${p} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,j.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${t}
${o}

&nbsp;

${i}
`}k.$6m.as(u.$$m.Configuration).registerConfiguration({id:g.$al,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[g.$bl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$6m.as(u.$$m.Configuration).registerConfiguration({id:g.$al,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[g.$dl]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,j.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,j.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${g.$bl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,N,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=void 0;async function j(O,k){const g=await k.request(O,N.CancellationToken.None),d=(await(0,L.$Tc)(g.stream)).toString(),w=g.res.statusCode??200;return{headers:g.res.headers,statusCode:w,responseData:d}}async function y(O){const k={method:O.type,headers:O.headers};return new Promise((d,w)=>{const v=R.request(O.url??"",k,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){w(h)})});v.write(O.data,$=>{$&&w($)}),v.end()})}async function u(O,k,g){const d=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),w={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:d};try{const v=O?await j(w,O):await y(w);g(v.statusCode,v.headers,v.responseData)}catch{g(0,{})}}class l extends A.$3M{constructor(k,g,d,w,v){const $={sendPOST:(h,f)=>{u(k,h,f)}};super(g,d,w,v,$)}}e.$4M=l}),define(ne[148],re([0,1,16,24]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0;async function R(A,j){const y=Object.create(null),u=(O,k)=>{const g=JSON.parse(O);y[k]=g};if(j){const O=[],k=await N.Promises.readdir(j);for(const d of k)try{(await N.Promises.stat((0,L.$$c)(j,d))).isDirectory()&&O.push(d)}catch{}const g=[];for(const d of O)(await N.Promises.readdir((0,L.$$c)(j,d))).filter(v=>v==="telemetry.json").length===1&&g.push(d);for(const d of g){const w=(await N.Promises.readFile((0,L.$$c)(j,d,"telemetry.json"))).toString();u(w,d)}}let l=(await N.Promises.readFile((0,L.$$c)(A,"telemetry-core.json"))).toString();return u(l,"vscode-core"),l=(await N.Promises.readFile((0,L.$$c)(A,"telemetry-extensions.json"))).toString(),u(l,"vscode-extensions"),JSON.stringify(y,null,4)}e.$66b=R}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=void 0;async function A(j,y){let u=j.getItem(R.$_k);return(typeof u!="string"||L.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,N.$Gm)(y.error.bind(y))),u}e.$o6b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=void 0,e.$Ak=(0,L.$zh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,N,R,A,j,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class l{static{this._clock=0}constructor(g){this.uri=g,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let O=class{constructor(g){this.g=g,this.c=new u.$lb,this.f=2**16;const d=new Map,w=v=>{let $=d.get(v.scheme);return $===void 0&&($=g.hasProvider(v)&&!this.g.hasCapability(v,1024),d.set(v.scheme,$)),$};this.c.add(y.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(v=>{d.delete(v.scheme)})),this.extUri=new A.$8f(w),this.d=new j.$lr((v,$)=>this.extUri.compare(v,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,A.$hg)(g));const d=this.d.get(g);return d?d.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new l(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((w,v)=>w[1].time<v[1].time?1:w[1].time>v[1].time?-1:0);l._clock=0,this.d.clear();const d=this.f*.5;for(let w=0;w<d;w++)this.d.set(g[w][0],g[w][1].touch())}};e.$mr=O,e.$mr=O=$e([se(0,R.$4j)],O),(0,N.$jr)(L.$Ak,O,1)}),define(ne[151],re([0,1,4,2,12,41,46,14,3]),function(J,e,L,N,R,A,j,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=void 0;class l extends N.$mb{get capabilities(){return this.f.capabilities&-5}constructor(k,g,d,w){super(),this.c=k,this.f=g,this.g=d,this.h=w,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.$hc),this.onDidChangeFile=this.a.event,this.b=j.$Fh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(v=>this.i(v)))}watch(k,g){this.b.set(k,k);const d=this.f.watch(this.j(k),g);return(0,N.$kb)(()=>{this.b.delete(k),d.dispose()})}stat(k){return this.f.stat(this.j(k))}mkdir(k){return this.f.mkdir(this.j(k))}rename(k,g,d){return this.f.rename(this.j(k),this.j(g),d)}readFile(k){return this.f.readFile(this.j(k),{atomic:!0})}readFileStream(k,g,d){const w=(0,A.$vc)(v=>y.$Hc.concat(v.map($=>y.$Hc.wrap($))).buffer);return(async()=>{try{const v=await this.readFile(k);w.end(v)}catch(v){w.error(v),w.end()}})(),w}readdir(k){return this.f.readdir(this.j(k))}writeFile(k,g,d){return!(0,u.$ne)(d.atomic)&&(0,R.$_j)(this.f)&&(d={...d,atomic:{postfix:".vsctmp"}}),this.f.writeFile(this.j(k),g,d)}delete(k,g){return this.f.delete(this.j(k),g)}copy(k,g,d){if((0,R.$7j)(this.f))return this.f.copy(this.j(k),this.j(g),d);throw new Error("copy not supported")}i(k){const g=[];for(const d of k){if(d.resource.scheme!==this.c)continue;const w=this.k(d.resource);this.b.findSubstr(w)&&g.push({resource:w,type:d.type})}g.length&&(this.h.debug("User data changed"),this.a.fire(g))}j(k){return k.with({scheme:this.c})}k(k){return k.with({scheme:this.g})}}e.$J6b=l}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,N,R,A,j,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.WorkbenchState=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0,e.$Ih=(0,y.$zh)("contextService");function l(s){const n=s;return typeof n?.id=="string"&&j.URI.isUri(n.uri)}e.$Jh=l;function O(s){return typeof s?.id=="string"&&!l(s)&&!g(s)}e.$Kh=O,e.$Lh={id:"ext-dev"},e.$Mh={id:"empty-window"};function k(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$cd)(s)}:n?e.$Lh:e.$Mh;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Nh=k;function g(s){const n=s;return typeof n?.id=="string"&&j.URI.isUri(n.configPath)}e.$Oh=g;function d(s){const n=s;if(n?.uri)return{id:n.id,uri:j.URI.revive(n.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Ph=d;var w;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function v(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Qh=v;function $(s){const n=s;return!!(n&&typeof n=="object"&&j.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Rh=$;class h{constructor(n,r,c,P,I){this.h=n,this.j=c,this.k=P,this.l=I,this.c=R.$Fh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$Fh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Sh=h;class f{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$gg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Th=f;function S(s){return new f({uri:s,index:0,name:(0,A.$cg)(s)},{uri:s.toString()})}e.$Uh=S,e.$Vh="code-workspace",e.$Wh=`.${e.$Vh}`,e.$Xh=[{name:(0,L.localize)(0,null),extensions:[e.$Vh]}],e.$Yh="workspace.json";function p(s,n){return A.$0f.isEqualOrParent(s,n.untitledWorkspacesHome)}e.$Zh=p;function E(s){let n;return j.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===u.Schemas.tmp}e.$1h=E,e.$2h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$2h}e.$3h=t;function o(s,n){return!p(s,n)&&!E(s)}e.$4h=o;function i(s){return(typeof s=="string"?(0,N.$dd)(s):(0,A.$eg)(s))===e.$Wh}e.$5h=i}),define(ne[23],re([0,1,42,4,2,17,11,106,18,12,10,6,152,35,22,8,28,29,3]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.ProfileResourceType=void 0;var S;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(S||(e.ProfileResourceType=S={}));function p(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&j.URI.isUri(n.location)&&j.URI.isUri(n.globalStorageHome)&&j.URI.isUri(n.settingsResource)&&j.URI.isUri(n.keybindingsResource)&&j.URI.isUri(n.tasksResource)&&j.URI.isUri(n.snippetsHome)&&j.URI.isUri(n.extensionsResource))}e.$Bk=p,e.$Ck=(0,O.$zh)("IUserDataProfilesService");function E(s,n){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:j.URI.revive(s.location).with({scheme:n}),globalStorageHome:j.URI.revive(s.globalStorageHome).with({scheme:n}),settingsResource:j.URI.revive(s.settingsResource).with({scheme:n}),keybindingsResource:j.URI.revive(s.keybindingsResource).with({scheme:n}),tasksResource:j.URI.revive(s.tasksResource).with({scheme:n}),snippetsHome:j.URI.revive(s.snippetsHome).with({scheme:n}),extensionsResource:j.URI.revive(s.extensionsResource).with({scheme:n}),cacheHome:j.URI.revive(s.cacheHome).with({scheme:n}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Dk=E;function t(s,n,r,c,P,I){return{id:s,name:n,location:r,isDefault:!1,shortName:P?.shortName,globalStorageHome:I&&P?.useDefaultFlags?.globalState?I.globalStorageHome:(0,A.$gg)(r,"globalStorage"),settingsResource:I&&P?.useDefaultFlags?.settings?I.settingsResource:(0,A.$gg)(r,"settings.json"),keybindingsResource:I&&P?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,A.$gg)(r,"keybindings.json"),tasksResource:I&&P?.useDefaultFlags?.tasks?I.tasksResource:(0,A.$gg)(r,"tasks.json"),snippetsHome:I&&P?.useDefaultFlags?.snippets?I.snippetsHome:(0,A.$gg)(r,"snippets"),extensionsResource:I&&P?.useDefaultFlags?.extensions?I.extensionsResource:(0,A.$gg)(r,"extensions.json"),cacheHome:(0,A.$gg)(c,s),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$Ek=t;let o=class extends R.$mb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,r,c,P){super(),this.n=n,this.r=r,this.s=c,this.t=P,this.f=!0,this.h=this.B(new N.$hc),this.onDidChangeProfiles=this.h.event,this.i=this.B(new N.$hc),this.onWillCreateProfile=this.i.event,this.j=this.B(new N.$hc),this.onWillRemoveProfile=this.j.event,this.k=this.B(new N.$hc),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new d.$xi,emptyWindows:new Map},this.profilesHome=(0,A.$gg)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.$gg)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=this.w(),r=[n];if(this.f)try{for(const I of this.J()){if(!I.name||!(0,f.$le)(I.name)||!I.location){this.t.warn("Skipping the invalid stored profile",I.location||I.name);continue}r.push(t((0,A.$dg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.t.error(I)}const c=new d.$xi,P=new Map;if(r.length)try{const I=this.M();if(I.workspaces)for(const[b,D]of Object.entries(I.workspaces)){const H=j.URI.parse(b),_=r.find(x=>x.id===D);_&&c.set(H,_)}if(I.emptyWindows)for(const[b,D]of Object.entries(I.emptyWindows)){const H=r.find(_=>_.id===D);H&&P.set(b,H)}}catch(I){this.t.error(I)}this.u={profiles:r,workspaces:c,emptyWindows:P}}return this.u}w(){const n=t("__default__profile__",(0,y.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...n,extensionsResource:this.O()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",c=new RegExp(`${(0,h.$sd)(r)}\\s(\\d+)`);let P=0;for(const b of this.profiles){const D=c.exec(b.name),H=D?parseInt(D[1]):0;P=H>P?H:P}const I=`${r} ${P+1}`;return this.createProfile((0,L.$ni)((0,$.$6e)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,r,c){return this.createProfile((0,L.$ni)((0,$.$6e)()).toString(16),n,r,c)}async createProfile(n,r,c,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.y(n,r,c);return P&&await this.setProfileForWorkspace(P,I),I}async y(n,r,c){if(!(0,f.$le)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.l.get(r);return P||(P=(async()=>{try{const I=this.profiles.find(H=>H.name===r||H.id===n);if(I)return I;const b=t(n,r,(0,A.$gg)(this.profilesHome,n),this.g,c,this.defaultProfile);await this.r.createFolder(b.location);const D=[];return this.i.fire({profile:b,join(H){D.push(H)}}),await v.Promises.settled(D),this.D([b],[],[]),b}finally{this.l.delete(r)}})(),this.l.set(r,P)),P}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(P=>P.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=t(c.id,r.name??c.name,c.location,this.g,{shortName:r.shortName??c.shortName,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.D([],[],[c]),c}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(P=>P.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this.j.fire({profile:r,join(P){c.push(P)}});try{await Promise.allSettled(c)}catch(P){this.t.error(P)}for(const P of[...this.v.emptyWindows.keys()])r.id===this.v.emptyWindows.get(P)?.id&&this.v.emptyWindows.delete(P);for(const P of[...this.v.workspaces.keys()])r.id===this.v.workspaces.get(P)?.id&&this.v.workspaces.delete(P);this.H(),this.D([],[r],[]);try{await this.r.del(r.cacheHome,{recursive:!0})}catch(P){(0,l.$hk)(P)!==1&&this.t.error(P)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(P=>P.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.G(n,c)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,r)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.s.extUri.isEqual(c.location,r.resource))).map(r=>this.r.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(r=>!this.C(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.z(n);return j.URI.isUri(r)?this.m.workspaces.get(r)??this.v.workspaces.get(r):this.m.emptyWindows.get(r)??this.v.emptyWindows.get(r)}z(n){return(0,g.$Jh)(n)?n.uri:(0,g.$Oh)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,n.location))||[...this.m.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,n.location))||[...this.v.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,n.location))||[...this.v.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,n.location)))}D(n,r,c){const P=[...this.profiles,...n],I=[];this.m.profiles=[];for(let b of P)b.isDefault||r.some(D=>b.id===D.id)||(b=c.find(D=>b.id===D.id)??b,b.isTransient?this.m.profiles.push(b):I.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.L(I),this.u=void 0,this.F(n,r,c)}F(n,r,c){this.h.fire({added:n,removed:r,updated:c,all:this.profiles})}G(n,r,c){c=r?.isTransient?!0:c,c||this.G(n,void 0,!0);const P=this.z(n),I=c?this.m:this.v;j.URI.isUri(P)?(I.workspaces.delete(P),r&&I.workspaces.set(P,r)):(I.emptyWindows.delete(P),r&&I.emptyWindows.set(P,r)),c||this.H()}H(){const n={};for(const[c,P]of this.v.workspaces.entries())n[c.toString()]=P.id;const r={};for(const[c,P]of this.v.emptyWindows.entries())r[c.toString()]=P.id;this.N({workspaces:n,emptyWindows:r}),this.u=void 0}I(n){const r={},c=this.w();if(n.workspaces)for(const[I,b]of Object.entries(n.workspaces)){const D=j.URI.parse(b);r[I]=this.s.extUri.isEqual(D,c.location)?c.id:this.s.extUri.basename(D)}const P={};if(n.emptyWindows)for(const[I,b]of Object.entries(n.emptyWindows)){const D=j.URI.parse(b);P[I]=this.s.extUri.isEqual(D,c.location)?c.id:this.s.extUri.basename(D)}return{workspaces:r,emptyWindows:P}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};e.$Fk=o,e.$Fk=o=$e([se(0,u.$Gh),se(1,l.$4j),se(2,w.$Ak),se(3,k.$3i)],o);class i extends o{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.$Gk=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,31,26,22,23]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=void 0;let p=class extends y.$mb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(n,r,c,P,I,b){super(),this.u=n,this.v=r,this.w=c,this.y=P,this.z=I,this.C=b,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new j.$hc),this.m=this.B(new j.$hc),this.n=this.B(new j.$hc),this.p=this.B(new j.$hc),this.s=this.B(new j.$hc),this.t=[],this.B((0,y.$kb)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.k.forEach(D=>D.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(c=>(0,g.$Un)(c,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const P=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:I})=>(0,d.$no)(I,n.identifier));if(P?.local)return P?.local;throw P?.error?P.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(c){throw t(c)}}async installGalleryExtensions(n){if(!this.u.isEnabled())throw new g.$Yn(k.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],c=[];await Promise.allSettled(n.map(async({extension:P,options:I})=>{try{const b=await this.J(P,!!I?.installGivenVersion,!!I?.installPreReleaseVersion);c.push({...b,options:I})}catch(b){r.push({identifier:P.identifier,operation:2,source:P,error:b})}})),c.length&&r.push(...await this.D(c));for(const P of r)P.error&&(this.y.error("Failed to install extension.",P.identifier.id),this.y.error(P.error),P.source&&!O.URI.isUri(P.source)&&o(this.v,"extensionGallery:install",{extensionData:(0,d.$vo)(P.source),error:P.error}));return r}async uninstall(n,r={}){return this.y.trace("ExtensionManagementService#uninstall",n.identifier.id),this.M(n,r)}async toggleAppliationScope(n,r){if((0,w.$Wl)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let c=await this.updateMetadata(n,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)||(c=await this.X(n,this.C.defaultProfile.extensionsResource,r));for(const P of this.C.profiles){const I=(await this.getInstalled(1,P.extensionsResource)).find(b=>(0,d.$no)(b.identifier,n.identifier));I?this.s.fire(I):this.p.fire({identifier:n.identifier,profileLocation:P.extensionsResource})}return c}else{const c=this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(n,r,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.R(),this.h=n),this.g}registerParticipant(n){this.t.push(n)}async D(n){const r=[];return await Promise.allSettled(n.map(async c=>{try{const P=await this.F(c);r.push(...P)}catch(P){r.push({identifier:{id:(0,d.$so)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:P})}})),this.m.fire(r),r}async F({manifest:n,extension:r,options:c}){const P=c.isApplicationScoped||c.isBuiltin||(0,w.$Wl)(n),I={...c,installOnlyNewlyAddedFromExtensionPack:O.URI.isUri(r)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.C.defaultProfile.extensionsResource:c.profileLocation??this.S()},b=te=>`${d.$oo.create(te).toString()}${I.profileLocation?`-${I.profileLocation.toString()}`:""}`;if(!O.URI.isUri(r)){const te=this.j.get(b(r));if(te)return this.y.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const D=[],H=[],_=[],x=this.U(n,r,I);O.URI.isUri(r)||this.j.set(b(r),{task:x,waitingTasks:[]}),this.l.fire({identifier:x.identifier,source:r,profileLocation:I.profileLocation}),this.y.info("Installing extension:",x.identifier.id),D.push({task:x,manifest:n});let le=!1;try{if(I.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ce=await this.I(x.identifier,n,!!I.installOnlyNewlyAddedFromExtensionPack,!!I.installPreReleaseVersion,I.profileLocation),ue=await this.getInstalled(void 0,I.profileLocation),ie={...I,donotIncludePackAndDependencies:!0,context:{...I.context,[g.$Pn]:!0}};for(const{gallery:q,manifest:G}of(0,L.$Ff)(ce,({gallery:F})=>F.identifier.id)){le=le||!!G.extensionDependencies?.some(B=>(0,d.$no)({id:B},x.identifier));const F=b(q),U=this.j.get(F);if(U){if(this.G(x,U.task)){const B=U.task.identifier;this.y.info("Waiting for already requested installing extension",B.id,x.identifier.id),U.waitingTasks.push(x),H.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,Y=>Y.some(K=>(0,d.$no)(K.identifier,B)))).then(Y=>{if(this.y.info("Finished waiting for already requested installing extension",B.id,x.identifier.id),!Y.find(Q=>(0,d.$no)(Q.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!ue.some(({identifier:B})=>(0,d.$no)(B,q.identifier))){const B=this.U(G,q,ie);this.j.set(F,{task:B,waitingTasks:[x]}),this.l.fire({identifier:B.identifier,source:q,profileLocation:I.profileLocation}),this.y.info("Installing extension:",B.identifier.id,x.identifier.id),D.push({task:B,manifest:G})}}}catch(ce){if(O.URI.isUri(x.source))(0,L.$Ef)(n.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",x.identifier.id,ce.message),(0,L.$Ef)(n.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",x.identifier.id,ce.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ce}const te=D.reduce((ce,{task:ue,manifest:ie})=>(ce.set(ue.identifier.id.toLowerCase(),{task:ue,manifest:ie}),ce),new Map);for(;te.size;){let ce;const ue=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));ue.length?ce=te.size===1?ue:ue.filter(({task:ie})=>!(ie===x&&!le)):(this.y.info("Found extensions with circular dependencies",ue.map(({task:ie})=>ie.identifier.id)),ce=[...te.values()]),await this.H(ce.map(async({task:ie})=>{const q=new Date().getTime();try{const G=await ie.run();if(await this.H(this.t.map(F=>F.postInstall(G,ie.source,I,R.CancellationToken.None))),!O.URI.isUri(ie.source)){const F=ie.operation===3,U=F?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(o(this.v,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$vo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:U}),u.$o&&ie.operation!==3)try{await this.u.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}_.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw O.URI.isUri(ie.source)||o(this.v,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$vo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:G}),this.y.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return H.length&&await this.H(H),_.forEach(({identifier:ce})=>this.y.info("Extension installed successfully:",ce.id)),_}catch(te){if(D.forEach(({task:ce})=>ce.cancel()),_.length)try{const ce=await Promise.allSettled(_.map(({local:ue})=>this.W(ue,{versionOnly:!0,profileLocation:I.profileLocation}).run()));for(let ue=0;ue<ce.length;ue++){const ie=ce[ue],{identifier:q}=_[ue];ie.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",q.id):this.y.warn("Rollback: Error while uninstalling extension",q.id,(0,A.$8)(ie.reason))}}catch(ce){this.y.warn("Error while rolling back extensions",(0,A.$8)(ce),_.map(({identifier:ue})=>ue.id))}return D.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:I.context,profileLocation:I.profileLocation,error:te}))}finally{for(const{task:te}of D)te.source&&!O.URI.isUri(te.source)&&this.j.delete(b(te.source))}}G(n,r){for(const[,{task:c,waitingTasks:P}]of this.j.entries())if(c===n&&(P.includes(r)||P.some(I=>this.G(I,r)))||c===r&&P[0]&&!this.G(n,P[0]))return!1;return!0}async H(n){const r=[],c=[],P=await Promise.allSettled(n);for(const I of P)I.status==="fulfilled"?r.push(I.value):c.push(I.reason);if(c.length)throw E(c);return r}async I(n,r,c,P,I){if(!this.u.isEnabled())return[];const b=await this.getInstalled(void 0,I),D=[],H=[],_=async(x,le)=>{D.push(x);const te=le.extensionDependencies||[],ce=[...te];if(le.extensionPack){const ue=c?b.find(ie=>(0,d.$no)(ie.identifier,x)):void 0;for(const ie of le.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(q=>(0,d.$no)({id:q},{id:ie}))||ce.every(q=>!(0,d.$no)({id:q},{id:ie}))&&ce.push(ie)}if(ce.length){const ue=ce.filter(ie=>D.every(q=>!(0,d.$no)(q,{id:ie})));if(ue.length){const ie=await this.u.getExtensions(ue.map(q=>({id:q,preRelease:P})),R.CancellationToken.None);for(const q of ie){if(D.find(U=>(0,d.$no)(U,q.identifier)))continue;const G=te.some(U=>(0,d.$no)({id:U},q.identifier));let F;try{F=await this.J(q,!1,P)}catch(U){if(G)throw U;this.y.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$8)(U));continue}H.push({gallery:F.extension,manifest:F.manifest}),await _(F.extension.identifier,F.manifest)}}}};return await _(n,r),H}async J(n,r,c){let P;const I=await this.getExtensionsControlManifest();if(I.malicious.some(H=>(0,d.$no)(n.identifier,H)))throw new g.$Yn(k.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const b=I.deprecated[n.identifier.id.toLowerCase()];if(b?.extension?.autoMigrate){if(this.y.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${b.extension.id}' extension instead.`),P=(await this.u.getExtensions([{id:b.extension.id,preRelease:b.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!P)throw new g.$Yn(k.localize(2,null,n.identifier.id,b.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new g.$Yn(k.localize(3,null,n.identifier.id,this.z.nameLong,(0,g.$Qn)(H)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.L(n,r,c),!P)throw!c&&n.properties.isPreReleaseVersion&&(await this.u.getExtensions([n.identifier],R.CancellationToken.None))[0]?new g.$Yn(k.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$Yn(k.localize(5,null,n.identifier.id,this.z.nameLong,this.z.version),g.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",P.identifier.id);const D=await this.u.getManifest(P,R.CancellationToken.None);if(D===null)throw new g.$Yn(`Missing manifest for extension ${P.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(D.version!==P.version)throw new g.$Yn(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:D}}async L(n,r,c){const P=await this.getTargetPlatform();let I=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==c&&(I=(await this.u.getExtensions([{...n.identifier,preRelease:c}],{targetPlatform:P,compatible:!0},R.CancellationToken.None))[0]||null),!I&&await this.u.isExtensionCompatible(n,c,P)&&(I=n),I||(r?I=(await this.u.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:P,compatible:!0},R.CancellationToken.None))[0]||null:I=await this.u.getCompatibleExtension(n,c,P)),I}async M(n,r){const c={...r,profileLocation:n.isApplicationScoped?this.C.defaultProfile.extensionsResource:r.profileLocation??this.S()},P=x=>`${x.id.toLowerCase()}${c.versionOnly?`-${n.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,I=this.k.get(P(n.identifier));if(I)return this.y.info("Extensions is already requested to uninstall",n.identifier.id),I.waitUntilTaskIsFinished();const b=x=>{const le=this.W(x,c);return this.k.set(P(le.extension.identifier),le),c.profileLocation?this.y.info("Uninstalling extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString()):this.y.info("Uninstalling extension:",`${x.identifier.id}@${x.manifest.version}`),this.n.fire({identifier:x.identifier,profileLocation:c.profileLocation,applicationScoped:x.isApplicationScoped}),le},D=(x,le)=>{le?c.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString(),le.message):this.y.error("Failed to uninstall extension:",`${x.identifier.id}@${x.manifest.version}`,le.message):c.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${x.identifier.id}@${x.manifest.version}`),o(this.v,"extensionGallery:uninstall",{extensionData:(0,d.$uo)(x),error:le}),this.p.fire({identifier:x.identifier,error:le?.code,profileLocation:c.profileLocation,applicationScoped:x.isApplicationScoped})},H=[],_=[];try{H.push(b(n));const x=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const le=this.P(n,x);for(const te of le)this.k.has(P(te.identifier))?this.y.info("Extensions is already requested to uninstall",te.identifier.id):H.push(b(te))}c.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.N(H.map(le=>le.extension),x,n),await this.H(H.map(async le=>{try{if(await le.run(),await this.H(this.t.map(te=>te.postUninstall(le.extension,c,R.CancellationToken.None))),le.extension.identifier.uuid)try{await this.u.reportStatistic(le.extension.manifest.publisher,le.extension.manifest.name,le.extension.manifest.version,"uninstall")}catch{}D(le.extension)}catch(te){const ce=te instanceof g.$Yn?te:new g.$Yn((0,A.$8)(te),g.ExtensionManagementErrorCode.Internal);throw D(le.extension,ce),ce}finally{_.push(le)}}))}catch(x){const le=x instanceof g.$Yn?x:new g.$Yn((0,A.$8)(x),g.ExtensionManagementErrorCode.Internal);for(const te of H){try{te.cancel()}catch{}_.includes(te)||D(te.extension,le)}throw le}finally{for(const x of H)this.k.delete(P(x.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",x.extension.identifier.id)}}N(n,r,c){for(const P of n){const I=this.Q(P,r);if(I.length){const b=I.filter(D=>!n.some(H=>(0,d.$no)(H.identifier,D.identifier)));if(b.length)throw new Error(this.O(P,b,c))}}}O(n,r,c){return c===n?r.length===1?k.localize(6,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(7,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(8,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?k.localize(9,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(10,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(11,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}P(n,r,c=[]){if(c.indexOf(n)!==-1)return[];c.push(n);const P=n.manifest.extensionPack?n.manifest.extensionPack:[];if(P.length){const I=r.filter(D=>!D.isBuiltin&&P.some(H=>(0,d.$no)({id:H},D.identifier))),b=[];for(const D of I)b.push(...this.P(D,r,c));return[...I,...b]}return[]}Q(n,r){return r.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(P=>(0,d.$no)({id:P},n.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const n=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$cp=p,e.$cp=p=$e([se(0,g.$Xn),se(1,h.$7k),se(2,f.$Ak),se(3,v.$3i),se(4,$.$ij),se(5,S.$Ck)],p);function E(s){const n=Array.isArray(s)?s:[s];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,c)=>new Error(`${r.message}${r.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.$dp=E;function t(s){if(s instanceof g.$Yn)return s;const n=new g.$Yn(s.message,g.ExtensionManagementErrorCode.Internal);return n.stack=s.stack,n}e.$ep=t;function o(s,n,{extensionData:r,verificationStatus:c,duration:P,error:I,durationSinceUpdate:b}){let D,H;(0,l.$te)(c)&&(c===!0?c="Verified":(c===!1||(D=g.ExtensionManagementErrorCode.Signature,H=c),c="Unverified")),I&&(I instanceof g.$Yn?(D=I.code,I.code===g.ExtensionManagementErrorCode.Signature&&(H=I.message)):D=g.ExtensionManagementErrorCode.Internal),s.publicLog(n,{...r,verificationStatus:c,success:!I,duration:P,errorcode:D,errorcodeDetail:H,durationSinceUpdate:b})}class i{constructor(){this.d=new N.$Dg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$sg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$sg)(n=>new Promise((r,c)=>{const P=n.onCancellationRequested(()=>{P.dispose(),c(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$fp=i}),define(ne[40],re([0,1,8,14,2,4,35,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class S extends Error{constructor(i,s){super(i),this.code=s}}e.$gp=S,e.$hp=(0,k.$zh)("IExtensionsProfileScannerService");let p=class extends R.$mb{constructor(i,s,n,r,c,P){super(),this.i=i,this.j=s,this.k=n,this.l=r,this.m=c,this.n=P,this.b=this.B(new A.$hc),this.onAddExtensions=this.b.event,this.c=this.B(new A.$hc),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$hc),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$hc),this.onDidRemoveExtensions=this.g.event,this.h=new j.$xi}scanProfileExtensions(i,s){return this.p(i,void 0,s)}async addExtensionsToProfile(i,s){const n=[],r=[];try{return await this.p(s,c=>{const P=[];for(const I of c)i.some(([b])=>(0,l.$no)(b.identifier,I.identifier)&&b.manifest.version!==I.version)?n.push(I):P.push(I);for(const[I,b]of i){const D=P.findIndex(_=>(0,l.$no)(_.identifier,I.identifier)&&_.version===I.manifest.version),H={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:b};D===-1?(r.push(H),P.push(H)):P.splice(D,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),n.length&&this.f.fire({extensions:n,profileLocation:s}),P}),r.length&&this.c.fire({extensions:r,profileLocation:s}),n.length&&this.g.fire({extensions:n,profileLocation:s}),r}catch(c){throw r.length&&this.c.fire({extensions:r,error:c,profileLocation:s}),n.length&&this.g.fire({extensions:n,error:c,profileLocation:s}),c}}async updateMetadata(i,s){const n=[];return await this.p(s,r=>{const c=[];for(const P of r){const I=i.find(([b])=>(0,l.$no)(b.identifier,P.identifier)&&b.manifest.version===P.version);I&&(P.metadata={...P.metadata,...I[1]},n.push(P)),c.push(P)}return c}),n}async removeExtensionFromProfile(i,s){const n=[];try{await this.p(s,r=>{const c=[];for(const P of r)(0,l.$no)(P.identifier,i.identifier)?n.push(P):c.push(P);return n.length&&this.f.fire({extensions:n,profileLocation:s}),c}),n.length&&this.g.fire({extensions:n,profileLocation:s})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:s}),r}}async p(i,s,n){return this.w(i).queue(async()=>{let r=[],c;try{const P=await this.j.readFile(i);c=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,O.$hk)(P)!==1)throw P;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(c=await this.v()),!c&&n?.bailOutWhenFileNotFound)throw new S((0,$.$8)(P),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.r(i);let P=!1;for(const I of c){E(I)||this.r(i);let b;if((0,v.$le)(I.relativeLocation)&&I.relativeLocation)b=this.t(I.relativeLocation);else if((0,v.$le)(I.location))b=this.t(I.location),P=!0,I.relativeLocation=I.location,I.location=b.toJSON();else{b=y.URI.revive(I.location);const D=this.s(b);D&&(P=!0,I.relativeLocation=D)}r.push({identifier:I.identifier,location:b,version:I.version,metadata:I.metadata})}P&&await this.j.writeFile(i,N.$Hc.fromString(JSON.stringify(c)))}if(s){r=s(r);const P=r.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.s(I.location),metadata:I.metadata}));await this.j.writeFile(i,N.$Hc.fromString(JSON.stringify(P)))}return r})}r(i){const s=new S(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(i)).value.toString()}catch(c){if((0,O.$hk)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",i.toString());let r;try{const c=JSON.parse(n);Array.isArray(c)&&c.every(P=>E(P))?r=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(r)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,N.$Hc.fromString(JSON.stringify(r)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,O.$hk)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(i)}catch(c){(0,O.$hk)(c)!==1&&this.n.error(c)}try{await this.j.del(s)}catch(c){(0,O.$hk)(c)!==1&&this.n.error(c)}return r})()),this.u}w(i){let s=this.h.get(i);return s||(s=new L.$Lg,this.h.set(i,s)),s}};e.$ip=p,e.$ip=p=$e([se(1,O.$4j),se(2,d.$Ck),se(3,w.$Ak),se(4,h.$7k),se(5,g.$3i)],p);function E(o){return(0,v.$ne)(o)&&(0,u.$Wn)(o.identifier)&&(t(o.location)||(0,v.$le)(o.location)&&o.location)&&((0,v.$se)(o.relativeLocation)||(0,v.$le)(o.relativeLocation))&&o.version&&(0,v.$le)(o.version)}function t(o){return o?(0,v.$le)(o.path)&&(0,v.$le)(o.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,43,54,3,11,95,18,27,37,48,12,10,6,31,4,47,40,23,22,112]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f,S,p,E,t,o,i,s,n,r,c,P,I,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.Translations=void 0;var H;(function(ie){function q(G,F){if(G===F)return!0;const U=Object.keys(G),B=new Set;for(const Y of Object.keys(F))B.add(Y);if(U.length!==B.size)return!1;for(const Y of U){if(G[Y]!==F[Y])return!1;B.delete(Y)}return B.size===0}ie.equals=q})(H||(e.Translations=H={})),e.$lp=(0,i.$zh)("IExtensionsScannerService");let _=class extends l.$mb{constructor(q,G,F,U,B,Y,K,Q,C,z,a,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=G,this.l=F,this.m=U,this.n=B,this.r=Y,this.s=K,this.t=Q,this.u=C,this.v=z,this.w=a,this.y=m,this.g=this.B(new r.$hc),this.onDidChangeCache=this.g.event,this.h=(0,d.$gg)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(te,this.m,this.h)),this.j=this.B(this.y.createInstance(te,this.m,this.h)),this.k=this.B(this.y.createInstance(le,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,p.$yo)(this.s,this.t)),this.z}async scanAllExtensions(q,G,F){const[U,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(G)]),Y=F?await this.scanExtensionsUnderDevelopment(q,[...U,...B]):[];return this.G(U,B,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const G=[];G.push(this.H(!!q.useCache,q.language)),G.push(this.I(q.language,!!q.checkControlFile));const[F,U]=await Promise.all(G);return this.F([...F,...U],0,q,!1)}async scanUserExtensions(q){const G=q.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",G);const F=this.w.extUri.isEqual(q.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(G,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,F),B=q.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let Y;try{Y=await B.scanExtensions(U)}catch(K){if(K instanceof P.$gp&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),Y=await B.scanExtensions(U);else throw K}return Y=await this.F(Y,1,q,!0),this.t.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(q,G){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const F=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===O.Schemas.file).map(async U=>{const B=await this.L(U,!1,1,!0,q.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(B)).map(K=>(K.type=G.find(Q=>(0,p.$no)(Q.identifier,K.identifier))?.type??K.type,this.k.validate(K,B)))}))).flat();return this.F(F,"development",q,!0)}return[]}async scanExistingExtension(q,G,F){const U=await this.L(q,!1,G,!0,F.language,!0,void 0),B=await this.k.scanExtension(U);return!B||!F.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,G,F){const U=await this.L(q,!1,G,!0,F.language,!0,void 0),B=await this.k.scanOneOrMultipleExtensions(U);return this.F(B,G,F,!0)}async scanMetadata(q){const G=(0,d.$gg)(q,"package.json"),F=(await this.s.readFile(G)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(q,G){const F=(0,d.$gg)(q,"package.json"),U=(await this.s.readFile(F)).value.toString(),B=JSON.parse(U);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,B.__metadata={...B.__metadata,...G},await this.s.writeFile((0,d.$gg)(q,"package.json"),A.$Hc.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof P.$gp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw q}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.r.addExtensionsToProfile(q.map(G=>[G,G.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.$Hc.fromString(JSON.stringify([])))}catch(G){(0,o.$hk)(G)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$8)(G))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.t.error(q)}finally{this.C=void 0}})()),this.C}async F(q,G,F,U){return F.includeAllVersions||(q=this.G(G===0?q:void 0,G===1?q:void 0,G==="development"?q:void 0,await this.getTargetPlatform(),U)),F.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,Y)=>{const K=k.$cd(B.location.fsPath),Q=k.$cd(Y.location.fsPath);return K<Q?-1:K>Q?1:0})}G(q,G,F,U,B){const Y=(Q,C,z)=>{if(Q.isValid&&!C.isValid)return!1;if(Q.isValid===C.isValid){if(B&&w.gt(Q.manifest.version,C.manifest.version))return this.t.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(w.eq(Q.manifest.version,C.manifest.version)){if(Q.type===0)return this.t.debug(`Skipping extension ${C.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===U)return this.t.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return z?this.t.warn(`Overwriting user extension ${Q.location.path} with ${C.location.path}.`):this.t.debug(`Overwriting user extension ${Q.location.path} with ${C.location.path}.`),!0},K=new E.$Vl;return q?.forEach(Q=>{const C=K.get(Q.identifier.id);(!C||Y(C,Q,!1))&&K.set(Q.identifier.id,Q)}),G?.forEach(Q=>{const C=K.get(Q.identifier.id);if(!C&&q&&Q.type===0){this.t.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!C||Y(C,Q,!1))&&K.set(Q.identifier.id,Q)}),F?.forEach(Q=>{const C=K.get(Q.identifier.id);(!C||Y(C,Q,!0))&&K.set(Q.identifier.id,Q),K.set(Q.identifier.id,Q)}),[...K.values()]}async H(q,G){this.t.trace("Started scanning system extensions");const F=await this.L(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),B=await(q&&!F.devMode?this.i:this.k).scanExtensions(F);return this.t.trace("Scanned system extensions:",B.length),B}async I(q,G){const F=this.u.isBuilt?[]:this.v.builtInExtensions;if(!F?.length)return[];this.t.trace("Started scanning dev system extensions");const U=G?await this.J():{},B=[],Y=h.URI.file(k.$9c(k.$$c(O.$4e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of F){const C=U[Q.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":B.push((0,d.$gg)(Y,Q.name));break;default:B.push(h.URI.file(C));break}}const K=await Promise.all(B.map(async Q=>this.k.scanExtension(await this.L(Q,!1,0,!0,q,!0,void 0))));return this.t.trace("Scanned dev system extensions:",K.length),(0,L.$Af)(K)}async J(){try{const q=await this.s.readFile(this.l);return JSON.parse(q.value.toString())}catch{return{}}}async L(q,G,F,U,B,Y,K){const Q=await this.f(B??g.$v),C=await this.M(q),z=G&&!this.w.extUri.isEqual(q,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,a=z?await this.M(z):void 0;return new x(q,C,z,a,G,K,F,U,Y,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,B,Q)}async M(q){try{const G=await this.s.stat(q);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$mp=_,e.$mp=_=$e([se(4,I.$Ck),se(5,P.$hp),se(6,o.$4j),se(7,s.$3i),se(8,S.$Gh),se(9,n.$ij),se(10,b.$Ak),se(11,i.$yh)],_);class x{constructor(q,G,F,U,B,Y,K,Q,C,z,a,m,M,T,X){this.location=q,this.mtime=G,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=U,this.profile=B,this.profileScanOptions=Y,this.type=K,this.excludeObsolete=Q,this.validate=C,this.productVersion=z,this.productDate=a,this.productCommit=m,this.devMode=M,this.language=T,this.translations=X}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,G){return(0,d.$_f)(q.location,G.location)&&q.mtime===G.mtime&&(0,d.$_f)(q.applicationExtensionslocation,G.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&q.profile===G.profile&&R.$Xm(q.profileScanOptions,G.profileScanOptions)&&q.type===G.type&&q.excludeObsolete===G.excludeObsolete&&q.validate===G.validate&&q.productVersion===G.productVersion&&q.productDate===G.productDate&&q.productCommit===G.productCommit&&q.devMode===G.devMode&&q.language===G.language&&H.equals(q.translations,G.translations)}}e.$np=x;let le=class extends l.$mb{constructor(q,G,F,U,B){super(),this.f=q,this.g=G,this.h=F,this.i=U,this.j=B}async scanExtensions(q){const G=q.profile?await this.l(q):await this.k(q);let F={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();F=JSON.parse(U)}catch{}return(0,$.$ye)(F)?G:G.filter(U=>!F[p.$oo.create(U).toString()])}async k(q){const G=await this.i.resolve(q.location);if(!G.children?.length)return[];const F=await Promise.all(G.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,d.$dg)(U.resource).indexOf(".")===0)return null;const B=new x(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Af)(F).sort((U,B)=>U.location.path<B.location.path?-1:1)}async l(q){let G=await this.m(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){G=G.filter(U=>!U.metadata?.isApplicationScoped);const F=await this.m(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);G.push(...F)}return G}async m(q,G,F){const U=await this.g.scanProfileExtensions(q,F.profileScanOptions);if(!U.length)return[];const B=await Promise.all(U.map(async Y=>{if(G(Y)){const K=new x(Y.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(K,Y.metadata)}return null}));return(0,L.$Af)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.i.exists((0,d.$gg)(q.location,"package.json"))){const G=await this.scanExtension(q);return G?[G]:[]}else return await this.scanExtensions(q)}catch(G){return this.j.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$8)(G)),[]}}async scanExtension(q,G){try{let F=await this.scanExtensionManifest(q.location);if(F){F.publisher||(F.publisher=E.$Pl),G=G??F.__metadata,delete F.__metadata;const U=(0,p.$so)(F.publisher,F.name),B=G?.id?{id:U,uuid:G.id}:{id:U},Y=G?.isSystem?0:q.type,K=Y===0||!!G?.isBuiltin;F=await this.n(q.location,F,x.createNlsConfiguration(q));const Q={type:Y,identifier:B,manifest:F,location:q.location,isBuiltin:K,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return q.validate?this.validate(Q,q):Q}}catch(F){q.type!==0&&this.j.error(F)}return null}validate(q,G){let F=!0;const U=(0,t.$Do)(G.productVersion,G.productDate,G.location,q.manifest,q.isBuiltin);for(const[B,Y]of U)B===v.default.Error&&(F=!1,this.j.error(this.u(G.location,Y)));return q.isValid=F,q.validations=U,q}async scanExtensionManifest(q){const G=(0,d.$gg)(q,"package.json");let F;try{F=(await this.i.readFile(G)).value.toString()}catch(B){return(0,o.$hk)(B)!==1&&this.j.error(this.u(q,(0,f.localize)(0,null,G.path,B.message))),null}let U;try{U=JSON.parse(F)}catch{const Y=[];(0,y.$Jm)(F,Y);for(const K of Y)this.j.error(this.u(q,(0,f.localize)(1,null,G.path,K.offset,K.length,(0,u.$jp)(K.error))));return null}return(0,y.$Sm)(U)!=="object"?(this.j.error(this.u(q,(0,f.localize)(2,null,G.path))),null):U}async n(q,G,F){const U=await this.r(q,G,F);if(U)try{const B=[],Y=await this.s(U.default,B);if(B.length>0)return B.forEach(Q=>{this.j.error(this.u(q,(0,f.localize)(3,null,U.default?.path,(0,u.$jp)(Q.error))))}),G;if((0,y.$Sm)(U)!=="object")return this.j.error(this.u(q,(0,f.localize)(4,null,U.default?.path))),G;const K=U.values||Object.create(null);return(0,D.$kp)(G,K,Y)}catch{}return G}async r(q,G,F){const U=(0,d.$gg)(q,"package.nls.json"),B=(C,z)=>{z.forEach(a=>{this.j.error(this.u(q,(0,f.localize)(5,null,C?.path,(0,u.$jp)(a.error))))})},Y=C=>{this.j.error(this.u(q,(0,f.localize)(6,null,C?.path)))},K=`${G.publisher}.${G.name}`,Q=F.translations[K];if(Q)try{const C=h.URI.file(Q),z=(await this.i.readFile(C)).value.toString(),a=[],m=(0,y.$Jm)(z,a);return a.length>0?(B(C,a),{values:void 0,default:U}):(0,y.$Sm)(m)!=="object"?(Y(C),{values:void 0,default:U}):{values:m.contents?m.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let z;try{z=await this.t(q,F)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const a=(await this.i.readFile(z.localized)).value.toString(),m=[],M=(0,y.$Jm)(a,m);return m.length>0?(B(z.localized,m),{values:void 0,default:z.original}):(0,y.$Sm)(M)!=="object"?(Y(z.localized),{values:void 0,default:z.original}):{values:M,default:z.original}}catch{return{values:void 0,default:z.original}}}}async s(q,G){if(q)try{const F=(await this.i.readFile(q)).value.toString();return(0,y.$Jm)(F,G)}catch{}}t(q,G){return new Promise((F,U)=>{const B=Y=>{const K=(0,d.$gg)(q,`package.nls.${Y}.json`);this.i.exists(K).then(Q=>{Q&&F({localized:K,original:(0,d.$gg)(q,"package.nls.json")});const C=Y.lastIndexOf("-");C===-1?F({localized:(0,d.$gg)(q,"package.nls.json"),original:null}):(Y=Y.substring(0,C),B(Y))})};if(G.devMode||G.pseudo||!G.language)return F({localized:(0,d.$gg)(q,"package.nls.json"),original:null});B(G.language)})}u(q,G){return`[${q.path}]: ${G}`}};le=$e([se(1,P.$hp),se(2,b.$Ak),se(3,o.$4j),se(4,s.$3i)],le);let te=class extends le{constructor(q,G,F,U,B,Y,K){super(G,U,B,Y,K),this.z=q,this.C=F,this.w=this.B(new N.$Cg(3e3)),this.y=this.B(new r.$hc),this.onDidChangeCache=this.y.event}async scanExtensions(q){const G=this.H(q),F=await this.D(G);if(this.v=q,F&&F.input&&x.equals(F.input,this.v))return this.j.debug("Using cached extensions scan result",q.location.toString()),this.w.trigger(()=>this.G()),F.result.map(B=>(B.location=h.URI.revive(B.location),B));const U=await super.scanExtensions(q);return await this.F(G,{input:q,result:U}),U}async D(q){try{const G=await this.i.readFile(q),F=JSON.parse(G.value.toString());return{result:F.result,input:(0,c.$9g)(F.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",q.path,(0,j.$8)(G))}return null}async F(q,G){try{await this.i.writeFile(q,A.$Hc.fromString(JSON.stringify(G)))}catch(F){this.j.debug("Error while writing the extension cache file:",q.path,(0,j.$8)(F))}}async G(){if(!this.v)return;const q=this.H(this.v),G=await this.D(q);if(!G)return;const F=G.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!R.$Xm(U,F))try{this.j.info("Invalidating Cache",F,U),await this.i.del(q),this.y.fire()}catch(B){this.j.error(B)}}H(q){const G=this.I(q);return this.h.extUri.joinPath(G.cacheHome,q.type===0?E.$Ol:E.$Nl)}I(q){return q.type===0?this.C.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.z.extensionsResource)?this.z:this.C.profiles.find(G=>this.h.extUri.isEqual(q.location,G.extensionsResource))??this.z:this.C.defaultProfile}};te=$e([se(2,I.$Ck),se(3,P.$hp),se(4,b.$Ak),se(5,o.$4j),se(6,s.$3i)],te);function ce(ie,q){const G=(0,p.$qo)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new E.$Tl(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$op=ce;class ue extends _{constructor(q,G,F,U,B,Y,K,Q,C,z,a,m){super(q,G,(0,d.$gg)(F,".vscode-oss-dev","extensions","control.json"),U,B,Y,K,Q,C,z,a,m),this.N=(async()=>{if(g.$y)try{const M=await this.s.readFile(h.URI.file(g.$y));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f(q){return this.N}}e.$pp=ue}),define(ne[154],re([0,1,58,8,33,4,2,15,16,24,6,23]),function(J,e,L,N,R,A,j,y,u,l,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;let g=class extends j.$mb{constructor(w,v){super(),this.b=w,this.f=v,this.a=new N.$Kg(5)}async postUninstall(w){const v=this.g(w,"uninstall");v&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,w),this.f.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.f.error($)}}));try{await l.Promises.rm(this.j(w))}catch($){this.f.error("Error while removing extension storage path",w.identifier.id),this.f.error($)}}g(w,v){const $=`vscode:${v}`;if(w.location.scheme===y.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[$]=="string"){const h=w.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${$} should be a node script`),null):{script:(0,u.$$c)(w.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(w,v,$,h,f){return new Promise((S,p)=>{const E=this.i(w,v,$,f);let t;const o=i=>{t&&(clearTimeout(t),t=null),i?p(i):S(void 0)};E.on("error",i=>{o((0,R.$ki)(i)||"Unknown")}),E.on("exit",(i,s)=>{o(i?`post-${v} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,E.kill(),p("timed out")},5e3))})}i(w,v,$,h){const f={silent:!0,execArgv:void 0},S=(0,L.fork)(w,[`--type=extension-post-${v}`,...$],f);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(S.stdout,"data"),E=A.Event.fromNodeEventEmitter(S.stderr,"data");p(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${v}`,i)),E(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${v}`,i));const t=A.Event.any(A.Event.map(p,i=>({data:`%c${i}`,format:[""]})),A.Event.map(E,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),S}j(w){return(0,u.$$c)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};e.$rp=g,e.$rp=g=$e([se(0,k.$Ck),se(1,O.$3i)],g)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,N,R,A,j,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=void 0;let O=class extends j.$ip{constructor(g,d,w,v,$,h){super(l.URI.file(g.extensionsPath),d,w,v,$,h)}};e.$cN=O,e.$cN=O=$e([se(0,u.$Hh),se(1,y.$4j),se(2,N.$Ck),se(3,R.$Ak),se(4,A.$7k),se(5,L.$3i)],O)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,31,22,23]),function(J,e,L,N,R,A,j,y,u,l,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0;let g=class extends A.$pp{constructor(w,v,$,h,f,S,p,E){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,w.defaultProfile,w,v,$,h,f,S,p,E)}};e.$l6b=g,e.$l6b=g=$e([se(0,k.$Ck),se(1,R.$hp),se(2,j.$4j),se(3,u.$3i),se(4,N.$Hh),se(5,l.$ij),se(6,O.$Ak),se(7,y.$yh)],g)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,N,R,A,j,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$So=e.$Ro=e.$Qo=void 0,e.$Qo="__$__isNewStorageMarker",e.$Ro="__$__targetStorageMarker",e.$So=(0,u.$zh)("storageService");var O;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(O||(e.WillSaveStateReason=O={}));var k;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var g;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function d(f){const S=f.get(e.$Ro);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}e.$To=d;class w extends R.$mb{static{this.a=60*1e3}constructor(S={flushInterval:w.a}){super(),this.j=S,this.b=this.B(new N.$kc),this.c=this.B(new N.$kc),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$hc),this.onWillSaveState=this.f.event,this.h=this.B(new L.$Qg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new R.$nb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(S,p,E){return N.Event.filter(this.b.event,t=>t.scope===S&&(p===void 0||t.key===p),E)}k(){this.i.value=(0,L.$Ug)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,R.$hb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(S,p){const{key:E,external:t}=p;if(E===e.$Ro){switch(S){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:S})}else this.b.fire({scope:S,key:E,target:this.F(S)[E],external:t})}r(S){this.f.fire({reason:S})}get(S,p,E){return this.L(p)?.get(S,E)}getBoolean(S,p,E){return this.L(p)?.getBoolean(S,E)}getNumber(S,p,E){return this.L(p)?.getNumber(S,E)}getObject(S,p,E){return this.L(p)?.getObject(S,E)}storeAll(S,p){this.t(()=>{for(const E of S)this.store(E.key,E.value,E.scope,E.target,p)})}store(S,p,E,t,o=!1){if((0,j.$ue)(p)){this.remove(S,E,o);return}this.t(()=>{this.u(S,E,t),this.L(E)?.set(S,p,o)})}remove(S,p,E=!1){this.t(()=>{this.u(S,p,void 0),this.L(p)?.delete(S,E)})}t(S){this.b.pause(),this.c.pause();try{S()}finally{this.b.resume(),this.c.resume()}}keys(S,p){const E=[],t=this.F(S);for(const o of Object.keys(t))t[o]===p&&E.push(o);return E}u(S,p,E,t=!1){const o=this.F(p);typeof E=="number"?o[S]!==E&&(o[S]=E,this.L(p)?.set(e.$Ro,JSON.stringify(o),t)):typeof o[S]=="number"&&(delete o[S],this.L(p)?.set(e.$Ro,JSON.stringify(o),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(S){switch(S){case-1:return this.D;case 0:return this.z;default:return this.w}}G(S){const p=this.L(S);return p?d(p):Object.create(null)}isNew(S){return this.getBoolean(e.$Qo,S)===!0}async flush(S=O.NONE){this.f.fire({reason:S});const p=this.L(-1),E=this.L(0),t=this.L(1);switch(S){case O.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case O.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,E=this.L(1)?.items??new Map;return h(S,p,E,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async optimize(S){return await this.flush(),this.L(S)?.optimize()}async switch(S,p){return this.r(O.NONE),(0,l.$Bk)(S)?this.N(S,p):this.O(S,p)}H(S,p){return!(S.id===p.id||v(p)&&v(S))}I(S,p,E){this.t(()=>{const t=new Set;for(const[o,i]of S)t.add(o),p.get(o)!==i&&this.n(E,{key:o,external:!0});for(const[o]of p.items)t.has(o)||this.n(E,{key:o,external:!0})})}}e.$Uo=w;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Vo=v;class $ extends w{constructor(){super(),this.p=this.B(new y.$Oo(new y.$Po,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new y.$Oo(new y.$Po,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new y.$Oo(new y.$Po,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(S=>this.n(1,S))),this.B(this.P.onDidChangeStorage(S=>this.n(0,S))),this.B(this.p.onDidChangeStorage(S=>this.n(-1,S)))}L(S){switch(S){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(S){switch(S){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(S){return!1}}e.$Wo=$;async function h(f,S,p,E,t,o){const i=H=>{try{return JSON.parse(H)}catch{return H}},s=new Map,n=new Map;f.forEach((H,_)=>{s.set(_,H),n.set(_,i(H))});const r=new Map,c=new Map;S.forEach((H,_)=>{r.set(_,H),c.set(_,i(H))});const P=new Map,I=new Map;p.forEach((H,_)=>{P.set(_,H),I.set(_,i(H))}),console.group(E!==t?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const b=[];if(s.forEach((H,_)=>{b.push({key:_,value:H})}),console.table(b),console.groupEnd(),console.log(n),E!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const H=[];r.forEach((_,x)=>{H.push({key:x,value:_})}),console.table(H),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${o})`);const D=[];P.forEach((H,_)=>{D.push({key:_,value:H})}),console.table(D),console.groupEnd(),console.log(I)}e.$Xo=h}),define(ne[158],re([0,1,19,20,9,13,34,3,11,25,18,21,27,48,12,6,31,45,142,157,26,175]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;const t=A.$o?"web":(0,k.$Sn)(A.$t,j.$6c),o="X-Market-Search-Activity-Id";var i;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...a){return String(a.reduce((m,M)=>m|M,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class b{constructor(m=I){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,M=this.d.pageSize){return new b({...this.d,pageNumber:m,pageSize:M})}withFilter(m,...M){const T=[...this.d.criteria,...M.length?M.map(X=>({filterType:m,value:X})):[{filterType:m}]];return new b({...this.d,criteria:T})}withSortBy(m){return new b({...this.d,sortBy:m})}withSortOrder(m){return new b({...this.d,sortOrder:m})}withFlags(...m){return new b({...this.d,flags:m.reduce((M,T)=>M|T,0)})}withAssetTypes(...m){return new b({...this.d,assetTypes:m})}withSource(m){return new b({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:M,pageSize:T,sortBy:X,sortOrder:W,flags:oe,assetTypes:ae}=this.d;return{filters:[{criteria:m,pageNumber:M,pageSize:T,sortBy:X,sortOrder:W}],assetTypes:ae,flags:oe}}get searchText(){const m=this.d.criteria.filter(M=>M.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(a,m){const M=(a||[]).filter(T=>T.statisticName===m)[0];return M?M.value:0}function H(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(T=>T.assetType.indexOf(m)===0).reduce((T,X)=>{const W=le(a,X.assetType);return W&&T.push([X.assetType.substring(m.length),W]),T},[])}function _(a){if(a.properties){const m=a.properties.filter(X=>X.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=m.filter(X=>M.test(X.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return le(a,r.Repository)}function x(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function le(a,m){return a.files.filter(T=>T.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function te(a,m){const M=a.properties?a.properties.filter(X=>X.key===m):[],T=M.length>0&&M[0].value;return T?T.split(",").map(X=>(0,g.$ro)(X)):[]}function ce(a){const m=a.properties?a.properties.filter(M=>M.key===c.Engine):[];return m.length>0&&m[0].value||""}function ue(a){const m=a.properties?a.properties.filter(M=>M.key===c.PreRelease):[];return m.length>0&&m[0].value==="true"}function ie(a){const m=a.properties?a.properties.filter(T=>T.key===c.LocalizedLanguages):[],M=m.length>0&&m[0].value||"";return M?M.split(","):[]}function q(a){return a.properties?.find(m=>m.key===c.SponsorLink)?.value}function G(a){return a.indexOf("preview")!==-1}function F(a){return a.targetPlatform?(0,k.$Rn)(a.targetPlatform):"undefined"}function U(a){const m=(0,L.$Ff)(a.versions.map(F)),M=!!a.tags?.includes(k.$Mn),T=m.indexOf("web");return M?T===-1&&m.push("web"):T!==-1&&m.splice(T,1),m}function B(a,m){const M=(0,k.$Vn)(m);for(let T=0;T<a.length;T++){const X=a[T];if(X.version===a[T-1]?.version){let W=T;const oe=F(X);if(oe===m)for(;W>0&&a[W-1].version===X.version;)W--;else if(M.includes(oe))for(;W>0&&a[W-1].version===X.version&&F(a[W-1])!==m;)W--;W!==T&&(a.splice(T,1),a.splice(W,0,X))}}return a}e.$1o=B;function Y(a,m,M){a.telemetryData={index:m,querySource:M,queryActivityId:a.queryContext?.[o]}}function K(a,m,M,T){const X=a.versions[0],W={manifest:le(m,r.Manifest),readme:le(m,r.Details),changelog:le(m,r.Changelog),license:le(m,r.License),repository:_(m),download:x(m),icon:le(m,r.Icon),signature:le(m,r.Signature),coreTranslations:H(m)};return{identifier:{id:(0,g.$so)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(X),description:a.shortDescription||"",installCount:D(a.statistics,"install"),rating:D(a.statistics,"averagerating"),ratingCount:D(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:M,assets:W,properties:{dependencies:te(m,c.Dependency),extensionPack:te(m,c.ExtensionPack),engine:ce(m),localizedLanguages:ie(m),targetPlatform:F(m),isPreReleaseVersion:ue(m)},hasPreReleaseVersion:ue(X),hasReleaseVersion:!0,preview:G(a.flags),isSigned:!!W.signature,queryContext:T}}let Q=class{constructor(m,M,T,X,W,oe,ae,pe){this.k=M,this.l=T,this.n=X,this.o=W,this.q=oe,this.u=ae,this.w=pe;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$Zo)(ae.version,ae,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,M,T){const X=N.CancellationToken.isCancellationToken(M)?{}:M,W=N.CancellationToken.isCancellationToken(M)?M:T,oe=[],ae=[],pe=[],de=[];let ge=!0;for(const we of m){we.uuid?ae.push(we.uuid):oe.push(we.id);const be=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!ae.length&&!oe.length)return[];let fe=new b().withPage(1,m.length);ae.length&&(fe=fe.withFilter(n.ExtensionId,...ae)),oe.length&&(fe=fe.withFilter(n.ExtensionName,...oe)),(X.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),X.source&&(fe=fe.withSource(X.source));const{extensions:he}=await this.z(fe,{targetPlatform:X.targetPlatform??t,includePreRelease:pe,versions:de,compatible:!!X.compatible},W);return X.source&&he.forEach((we,be)=>Y(we,be,X.source)),he}async getCompatibleExtension(m,M,T){if((0,k.$Tn)(m.allTargetPlatforms,T))return null;if(await this.isExtensionCompatible(m,M,T))return m;const X=new b().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(X,{targetPlatform:T,compatible:!0,includePreRelease:M},N.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,M,T){if(!(0,k.$Un)(m.properties.targetPlatform,m.allTargetPlatforms,T)||!M&&m.properties.isPreReleaseVersion)return!1;let X=m.properties.engine;if(!X){const W=await this.getManifest(m,N.CancellationToken.None);if(!W)throw new Error("Manifest was not found");X=W.engines.vscode}return(0,d.$Fo)(X,this.u.version,this.u.date)}async y(m,M,T,X,W){if(!(0,k.$Un)(F(m),X,W)||M!=="any"&&ue(m)!==(M==="prerelease"))return!1;if(T)try{const oe=await this.E(m);if(!(0,d.$Fo)(oe,this.u.version,this.u.date))return!1}catch(oe){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,R.$8)(oe)),!1}return!0}async query(m,M){let T=m.text||"";const X=m.pageSize??50;let W=new b().withPage(1,X);T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),W=W.withFilter(n.SearchText,T)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const oe=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,Se)=>Y(be,(ge.pageNumber-1)*ge.pageSize+Se,m.source)),{extensions:he,total:we}},{extensions:ae,total:pe}=await oe(W,M),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$3;const{extensions:he}=await oe(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:pe,pageSize:W.pageSize,getPage:de}}async z(m,M,T){const X=m.flags;m.flags&i.IncludeLatestVersionOnly&&m.flags&i.IncludeVersions&&(m=m.withFlags(m.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(m.flags&i.IncludeLatestVersionOnly)&&!(m.flags&i.IncludeVersions)&&(m=m.withFlags(m.flags,i.IncludeLatestVersionOnly)),M.versions?.length&&(m=m.withFlags(m.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),m=m.withFlags(m.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:W,total:oe,context:ae}=await this.B(m,T);if(!(m.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,M,ae);we&&fe.push(we)}return{extensions:fe,total:oe}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,g.$so)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,y.$re)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Me=>(0,g.$no)(Me,we))?.includePreRelease;if(M.compatible&&(0,k.$Tn)(U(he),M.targetPlatform))continue;const Se=await this.A(he,M,ae);!Se||Se.properties.isPreReleaseVersion&&(!be||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==M.targetPlatform&&Se.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,Se])}if(ge.size){const fe=new E.$dc,he=new b().withFlags(X&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,M,T);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const Se=ge.get(be.identifier.uuid);de.push([Se,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:oe}}async A(m,M,T){const X={id:(0,g.$so)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=M.versions?.find(de=>(0,g.$no)(de,X))?.version,oe=(0,y.$re)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(de=>(0,g.$no)(de,X))?.includePreRelease,ae=U(m),pe=B(m.versions,M.targetPlatform);if(M.compatible&&(0,k.$Tn)(ae,M.targetPlatform))return null;for(let de=0;de<pe.length;de++){const ge=pe[de];if(!(W&&ge.version!==W)){if(await this.y(ge,oe?"any":"release",M.compatible,ae,M.targetPlatform))return K(m,ge,ae,T);if(W&&ge.version===W)return null}}return W||M.compatible?null:K(m,m.versions[0],ae)}async B(m,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,s(i.Unpublished));const T=await this.j,X=JSON.stringify(m.raw),W={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},oe=new E.$dc;let ae,pe,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:W},M),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$Lo)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw pe=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(X.length),duration:oe.elapsed(),success:!!ae&&(0,h.$Io)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:pe?(0,R.$2)(pe)?"canceled":(0,R.$8)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,M,T,X){if(!this.isEnabled())return;const W=A.$o?this.x(`/itemName/${m}.${M}/version/${T}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${M}/${T}/stats?statType=${X}`),oe=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:oe};try{await this.k.request({type:"POST",url:W,headers:pe},N.CancellationToken.None)}catch{}}async download(m,M,T){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const X=(0,g.$vo)(m),W=new Date().getTime(),oe=fe=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),ae=T===2?"install":T===3?"update":"",pe=ae?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:m.assets.download,de=m.queryContext?.[o]?{[o]:m.queryContext[o]}:void 0,ge=await this.D(pe,de?{headers:de}:void 0);await this.q.writeFile(M,ge.stream),oe(new Date().getTime()-W)}async downloadSignatureArchive(m,M){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const T=await this.D(m.assets.signature);await this.q.writeFile(M,T.stream)}async getReadme(m,M){if(m.assets.readme){const T=await this.D(m.assets.readme,{},M);return await(0,h.$Ko)(T)||""}return""}async getManifest(m,M){if(m.assets.manifest){const T=await this.D(m.assets.manifest,{},M),X=await(0,h.$Ko)(T);return X?JSON.parse(X):null}return null}async C(m,M){const T=le(m,r.Manifest);if(!T)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},W=await this.D(T,{headers:X});return await(0,h.$Lo)(W)}async getCoreTranslation(m,M){const T=m.assets.coreTranslations.filter(X=>X[0]===M.toUpperCase())[0];if(T){const X=await this.D(T[1]),W=await(0,h.$Ko)(X);return W?JSON.parse(W):null}return null}async getChangelog(m,M){if(m.assets.changelog){const T=await this.D(m.assets.changelog,{},M);return await(0,h.$Ko)(T)||""}return""}async getAllCompatibleVersions(m,M,T){let X=new b().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?X=X.withFilter(n.ExtensionId,m.identifier.uuid):X=X.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(X,N.CancellationToken.None);if(!W.length)return[];const oe=U(W[0]);if((0,k.$Tn)(oe,T))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,M?"any":"release",!0,oe,T)&&ae.push(ge)}catch{}}));const pe=[],de=new Set;for(const ge of B(ae,T))de.has(ge.version)||(de.add(ge.version),pe.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ue(ge)}));return pe}async D(m,M={},T=N.CancellationToken.None){const X=await this.j,W={type:"GET"},oe={...X,...M.headers||{}};M={...M,...W,headers:oe};const ae=m.uri,pe=m.fallbackUri,de={...M,url:ae};try{const ge=await this.k.request(de,T);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$Ko)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$2)(ge))throw ge;const fe=(0,R.$8)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...M,url:pe};return this.k.request(he,T)}}async E(m){let M=ce(m);if(!M){const T=await this.C(m,N.CancellationToken.None);if(!T)throw new Error("Manifest was not found");M=T.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,h.$Lo)(m),T=[],X={},W=[];if(M){for(const oe of M.malicious)T.push({id:oe});if(M.migrateToPreRelease)for(const[oe,ae]of Object.entries(M.migrateToPreRelease))(!ae.engine||(0,d.$Fo)(ae.engine,this.u.version,this.u.date))&&(X[oe.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[oe,ae]of Object.entries(M.deprecated))ae&&(X[oe.toLowerCase()]=(0,y.$re)(ae)?{}:ae);if(M.search)for(const oe of M.search)W.push(oe)}return{malicious:T,deprecated:X,search:W}}};Q=$e([se(1,h.$Go),se(2,v.$3i),se(3,O.$Gh),se(4,p.$7k),se(5,w.$4j),se(6,$.$ij),se(7,l.$6h)],Q);let C=class extends Q{constructor(m,M,T,X,W,oe,ae,pe){super(m,M,T,X,W,oe,ae,pe)}};e.$2o=C,e.$2o=C=$e([se(0,S.$So),se(1,h.$Go),se(2,v.$3i),se(3,O.$Gh),se(4,p.$7k),se(5,w.$4j),se(6,$.$ij),se(7,l.$6h)],C);let z=class extends Q{constructor(m,M,T,X,W,oe,ae){super(void 0,m,M,T,X,W,oe,ae)}};e.$3o=z,e.$3o=z=$e([se(0,h.$Go),se(1,v.$3i),se(2,O.$Gh),se(3,p.$7k),se(4,w.$4j),se(5,$.$ij),se(6,l.$6h)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,N,R,A,j,y,u,l,O){"use strict";var k,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=e.$_M=void 0;let d=class extends u.$Fk{static{k=this}static{this.a="profileAssociationsMigration"}constructor(h,f,S,p,E){super(S,p,f,E),this.P=h,this.Q=S}J(){return this.P.getItem(k.b,[]).map(f=>({...f,location:(0,l.$le)(f.location)?this.s.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}M(){const h=this.P.getItem(k.c,{});return this.P.getItem(k.a,!1)?h:this.I(h)}O(){return this.s.extUri.joinPath(L.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$_M=d,e.$_M=d=k=$e([se(0,j.$7M),se(1,y.$Ak),se(2,N.$Hh),se(3,R.$4j),se(4,A.$3i)],d);let w=g=class extends d{constructor(h,f,S,p,E){super(h,f,S,p,E),this.W=h}L(h){h.length?this.W.setItem(g.b,h.map(f=>({...f,location:this.s.extUri.basename(f.location)}))):this.W.removeItem(g.b)}J(){const h=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(h),this.W.setItem("userDataProfilesMigration",!0)),h}N(h){h.emptyWindows||h.workspaces?this.W.setItem(g.c,h):this.W.removeItem(g.c)}M(){const h="workspaceAndProfileInfo",f=this.W.getItem(h,void 0);if(f){this.W.removeItem(h);const p=f.reduce((E,{workspace:t,profile:o})=>(E[L.URI.revive(t).toString()]=L.URI.revive(o).toString(),E),{});this.W.setItem(g.c,{workspaces:p})}const S=super.M();return this.W.getItem(g.a,!1)||(this.N(S),this.W.setItem(g.a,!0)),S}};e.$aN=w,e.$aN=w=g=$e([se(0,j.$8M),se(1,y.$Ak),se(2,N.$Hh),se(3,R.$4j),se(4,A.$3i)],w);let v=class extends w{constructor(h,f,S,p){super(new O.$$M(0,f,p,S),h,f,S,p)}async init(){return await this.W.init(),super.init()}};e.$bN=v,e.$bN=v=$e([se(0,y.$Ak),se(1,N.$Hh),se(2,R.$4j),se(3,A.$3i)],v)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,N,R,A,j,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.zip=e.$$o=e.$0o=void 0,e.$0o="end of central directory record signature not found";const O=new RegExp(e.$0o);class k extends Error{constructor(o,i){let s=i.message;switch(o){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=o,this.cause=i}}e.$$o=k;function g(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>o&i).reduce((i,s)=>i+s,o&61440)}function d(t){if(t instanceof k)return t;let o;return O.test(t.message)&&(o="CorruptZip"),new k(o,t)}function w(t,o,i,s,n,r){const c=R.$bd(o),P=R.$$c(s,c);if(!P.startsWith(s))return Promise.reject(new Error(y.localize(0,null,o)));const I=R.$$c(s,o);let b;return r.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(j.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((D,H)=>{if(!r.isCancellationRequested)try{b=(0,L.createWriteStream)(I,{mode:i}),b.once("close",()=>D()),b.once("error",H),t.once("error",H),t.pipe(b)}catch(_){H(_)}}))}function v(t,o,i,s){let n=(0,N.$sg)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{n.cancel(),t.close()}),new Promise((c,P)=>{const I=new N.$zg,b=D=>{D.isCancellationRequested||(r++,t.readEntry())};t.once("error",P),t.once("close",()=>n.then(()=>{s.isCancellationRequested||t.entryCount===r?c():P(new k("Incomplete",new Error(y.localize(1,null,r,t.entryCount))))},P)),t.readEntry(),t.on("entry",D=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(D.fileName)){b(s);return}const H=D.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(H)){const le=R.$$c(o,H);n=(0,N.$sg)(te=>j.Promises.mkdir(le,{recursive:!0}).then(()=>b(te)).then(void 0,P));return}const _=h(t,D),x=g(D);n=(0,N.$sg)(le=>I.queue(()=>_.then(te=>w(te,H,x,o,i,le).then(()=>b(le)))).then(null,P))})})}function $(t,o=!1){return new Promise((i,s)=>{(0,u.open)(t,o?{lazyEntries:!0}:void 0,(n,r)=>{n?s(d(n)):i((0,A.$we)(r))})})}function h(t,o){return new Promise((i,s)=>{t.openReadStream(o,(n,r)=>{n?s(d(n)):i((0,A.$we)(r))})})}function f(t,o){return new Promise((i,s)=>{const n=new l.ZipFile;o.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const r=(0,L.createWriteStream)(t);n.outputStream.pipe(r),n.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>i(t))})}e.zip=f;function S(t,o,i={},s){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=$(t,!0);return i.overwrite&&(r=r.then(c=>j.Promises.rm(o).then(()=>c))),r.then(c=>v(c,o,{sourcePathRegex:n},s))}e.$ap=S;function p(t,o){return $(t).then(i=>new Promise((s,n)=>{i.on("entry",r=>{r.fileName===o&&h(i,r).then(c=>s(c),c=>n(c))}),i.once("close",()=>n(new Error(y.localize(2,null,o))))}))}function E(t,o){return p(t,o).then(i=>new Promise((s,n)=>{const r=[];i.once("error",n),i.on("data",c=>r.push(c)),i.on("end",()=>s(Buffer.concat(r)))}))}e.$bp=E}),define(ne[160],re([0,1,8,9,2,15,17,43,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;let p=class extends R.$mb{static{S=this}static{this.c=".sigzip"}constructor(t,o,i,s,n,r){super(),this.h=o,this.i=i,this.j=s,this.k=n,this.l=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(t,o,i){await this.g;const s=(0,j.$gg)(this.extensionsDownloadDir,this.u(t));try{await this.r(t,s,r=>this.i.download(t,r,o))}catch(r){throw new w.$Yn(r.message,w.ExtensionManagementErrorCode.Download)}let n=!1;if(i&&this.m(t)){const r=await this.n(t);try{n=await this.k.verify(s.fsPath,r.fsPath,this.l.getLevel()===f.LogLevel.Trace)}catch(c){const P=c;if(n=P.code,P.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${P.output}`),n===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new w.$Yn(k.$0o,w.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(c){this.l.error(c)}}}return n===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:s,verificationStatus:n}}m(t){if(!t.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,u.$re)(o)?o:!0}async n(t){await this.g;const o=(0,j.$gg)(this.extensionsDownloadDir,`${this.u(t)}${S.c}`);return await this.r(t,o,i=>this.i.downloadSignatureArchive(t,i)),o}async r(t,o,i){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await i(o);return}const s=(0,j.$gg)(this.extensionsDownloadDir,`.${(0,l.$6e)()}`);await this.h.exists(s)||await i(s);try{await O.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(s)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.l.info(`Rename failed because of ${(0,N.$8)(n)}. Deleted the file from downloaded location`,s.path),n}}async delete(t){await this.g,await this.h.del(t)}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],i=[],s=[];for(const c of t.children)if(c.name.endsWith(S.c))s.push(c.resource);else{const P=v.$oo.parse(c.name);P&&i.push([P,c])}const n=(0,v.$to)(i,([c])=>c),r=[];for(const c of n)c.sort((P,I)=>y.rcompare(P[0].version,I[0].version)),o.push(...c.slice(1).map(P=>P[1].resource)),r.push(c[0][1]);r.sort((c,P)=>c.mtime-P.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(c=>c.resource)),o.push(...s),await L.Promises.settled(o.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(t){this.l.error(t)}}u(t){return this.f?v.$oo.create(t).toString().toLowerCase():(0,l.$6e)()}};e.$qp=p,e.$qp=p=S=$e([se(0,d.$Hh),se(1,h.$4j),se(2,w.$Xn),se(3,g.$6h),se(4,$.$4o),se(5,f.$3i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;function R(A){return(0,L.$bp)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$sp=R}),define(ne[162],re([0,1,8,14,20,33,9,4,42,2,35,15,16,17,43,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,31,26,22,23]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f,S,p,E,t,o,i,s,n,r,c,P,I,b,D,H,_,x,le,te,ce,ue,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$vp=(0,x.$Ah)(i.$Zn);const q=".vsctmp";let G=class extends o.$cp{constructor(C,z,a,m,M,T,X,W,oe,ae,pe,de){super(C,z,pe,a,ae,de),this.bb=M,this.cb=T,this.db=X,this.eb=oe,this.ab=new Map,this.nb=new O.$yi;const ge=this.B(W.createInstance(P.$rp));this.Y=this.B(W.createInstance(F,he=>ge.postUninstall(he))),this.Z=this.B(new b.$tp(de,oe,pe,this,this.y)),this.$=this.B(W.createInstance(c.$qp));const fe=this.B(new D.$up(this,this.bb,de,T,pe,oe,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.mb(he))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,s.$yo)(this.eb,this.y)),this.fb}async zip(C){this.y.trace("ExtensionManagementService#zip",C.identifier.id);const z=await this.lb(C),a=await(0,S.zip)((0,d.$gg)(this.$.extensionsDownloadDir,(0,h.$6e)()).fsPath,z);return $.URI.file(a)}async unzip(C){return this.y.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:z,cleanup:a}=await this.hb(C),m=g.$_c(z.fsPath);try{return await(0,I.$sp)(m)}finally{await a()}}getInstalled(C,z=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(C??null,z)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.Y.scanUserExtensionAtLocation(C)}async install(C,z={}){this.y.trace("ExtensionManagementService#install",C.toString());const{location:a,cleanup:m}=await this.hb(C);try{const M=await(0,I.$sp)(g.$_c(a.fsPath)),T=(0,s.$so)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,H.$Fo)(M.engines.vscode,this.z.version,this.z.date))throw new Error(p.localize(0,null,T,this.z.version));const W=(await this.D([{manifest:M,extension:a,options:z}])).find(({identifier:oe})=>(0,s.$no)(oe,{id:T}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$ep)(new Error(`Unknown error while installing extension ${T}`))}finally{await m()}}async installFromLocation(C,z){this.y.trace("ExtensionManagementService#installFromLocation",C.toString());const a=await this.Y.scanUserExtensionAtLocation(C);if(!a)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.qb([[a,void 0]],z),this.y.info("Successfully installed extension",a.identifier.id,z.toString()),a}async installExtensionsFromProfile(C,z,a){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",C,z.toString(),a.toString());const m=(await this.Y.scanExtensions(1,z)).filter(M=>C.some(T=>(0,s.$no)(T,M.identifier)));if(m.length){const M=await Promise.all(m.map(T=>this.Y.scanMetadata(T,z)));await this.qb(m.map((T,X)=>[T,M[X]]),a),this.y.info("Successfully installed extensions",m.map(T=>T.identifier.id),a.toString())}return m}async updateMetadata(C,z,a=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",C.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.pinned=z.pinned||void 0,C=await this.Y.updateMetadata(C,z,a),this.Z.invalidate(a),this.s.fire(C),C}async reinstallFromGallery(C){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.u.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[a]=await this.u.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:z,compatible:!0},R.CancellationToken.None);if(!a)throw new Error(p.localize(2,null));await this.Y.setUninstalled(C);try{await this.Y.removeUninstalledExtension(C)}catch(m){throw new Error(p.localize(3,null,(0,A.$ki)(m)))}return this.installFromGallery(a)}X(C,z,a,m){return this.Y.copyExtension(C,z,a,m)}copyExtensions(C,z){return this.Y.copyExtensions(C,z)}markAsUninstalled(...C){return this.Y.setUninstalled(...C)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(C){this.y.error(C)}}async download(C,z,a){const{location:m}=await this.$.download(C,z,!a);return m}async hb(C){if(C.scheme===k.Schemas.file)return{location:C,async cleanup(){}};this.y.trace("Downloading extension from",C.toString());const z=(0,d.$gg)(this.$.extensionsDownloadDir,(0,h.$6e)());return await this.db.download(C,z),this.y.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.eb.del(z)}catch(m){this.y.error(m)}}}}S(){return this.C.defaultProfile.extensionsResource}U(C,z,a){if($.URI.isUri(z))return new Y(C,z,a,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const m=s.$oo.create(z).toString();let M=this.ab.get(m);return M||(this.ab.set(m,M=new B(C,z,a,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),M.waitUntilTaskIsFinished().finally(()=>this.ab.delete(m))),M}W(C,z){return new K(C,z.profileLocation,this.cb)}async lb(C){const z=async m=>{let M=await f.Promises.readdir(m);M=M.map(W=>g.$$c(m,W));const T=await Promise.all(M.map(W=>f.Promises.stat(W)));let X=Promise.resolve([]);return T.forEach((W,oe)=>{const ae=M[oe];W.isFile()&&(X=X.then(pe=>[...pe,ae])),W.isDirectory()&&(X=X.then(pe=>z(ae).then(de=>[...pe,...de])))}),X};return(await z(C.location.fsPath)).map(m=>({path:`extension/${g.$ad(C.location.fsPath,m)}`,localPath:m}))}async mb({added:C,removed:z}){if(z)for(const a of z.extensions)this.y.info("Extensions removed from another source",a.id,z.profileLocation.toString()),this.p.fire({identifier:a,profileLocation:z.profileLocation});if(C){const m=(await this.Y.scanExtensions(1,C.profileLocation)).filter(M=>C.extensions.some(T=>(0,s.$no)(T,M.identifier)));this.m.fire(m.map(M=>(this.y.info("Extensions added from another source",M.identifier.id,C.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:C.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(z=>this.nb.add(z)));const C=await this.eb.resolve(this.bb.userExtensionsLocation);for(const z of C.children??[])z.isDirectory&&this.nb.add(z.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(z=>this.pb(z)))}async pb(C){if(!C.affects(this.bb.userExtensionsLocation,1))return;const z=[];for(const a of C.rawAdded){if(this.nb.has(a)||!this.w.extUri.isEqual(this.w.extUri.dirname(a),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(a,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(a).startsWith(".")||!(await this.eb.stat(a)).isDirectory)continue;const m=await this.Y.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.nb.add(a),z.push(m))}z.length&&(await this.qb(z.map(a=>[a,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",z.map(a=>a.identifier.id)))}async qb(C,z){const a=C.map(m=>m[0]);await this.rb(a),await this.cb.addExtensionsToProfile(C,z),this.m.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:z})))}async rb(C){const z=await this.Y.getUninstalledExtensions();for(const a of C){const m=s.$oo.create(a);z[m.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",m.id),await this.Y.setInstalled(m),this.y.info("Removed the extension from uninstalled list:",m.id))}}};e.$wp=G,e.$wp=G=$e([se(0,i.$Xn),se(1,ce.$7k),se(2,le.$3i),se(3,t.$Hh),se(4,r.$lp),se(5,n.$hp),se(6,E.$Bn),se(7,x.$yh),se(8,_.$4j),se(9,te.$ij),se(10,ue.$Ak),se(11,ie.$Ck)],G);let F=class extends l.$mb{constructor(C,z,a,m,M,T){super(),this.j=C,this.k=z,this.l=a,this.m=m,this.n=M,this.p=T,this.h=this.B(new y.$hc),this.onExtract=this.h.event,this.c=(0,d.$gg)(this.l.userExtensionsLocation,".obsolete"),this.g=new L.$Lg}async cleanUp(){await this.C(),await this.z()}async scanExtensions(C,z){const a={includeInvalid:!0,profileLocation:z};let m=[];return C===null||C===0?m.push(...await this.l.scanAllExtensions({includeInvalid:!0},a,!1)):C===1&&m.push(...await this.l.scanUserExtensions(a)),m=C!==null?m.filter(M=>M.type===C):m,Promise.all(m.map(M=>this.y(M)))}async scanAllUserExtensions(C){const z=await this.l.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(z.map(a=>this.y(a)))}async scanUserExtensionAtLocation(C){try{const z=await this.l.scanExistingExtension(C,1,{includeInvalid:!0});if(z)return await this.y(z)}catch(z){this.p.error(z)}return null}async extractUserExtension(C,z,a,m,M){const T=C.toString(),X=$.URI.file(g.$$c(this.l.userExtensionsLocation.fsPath,`.${(0,h.$6e)()}`)),W=$.URI.file(g.$$c(this.l.userExtensionsLocation.fsPath,T));let oe=await this.k.exists(W);if(oe&&m){try{await this.t(C.id,W,"removeExisting")}catch{throw new i.$Yn(p.localize(4,null,W.fsPath,C.id),i.ExtensionManagementErrorCode.Delete)}oe=!1}if(!oe)try{try{this.p.trace(`Started extracting the extension from ${z} to ${W.fsPath}`),await(0,S.$ap)(z,X.fsPath,{sourcePath:"extension",overwrite:!0},M),this.p.info(`Extracted extension to ${W}:`,C.id)}catch(ae){let pe=i.ExtensionManagementErrorCode.Extract;throw ae instanceof S.$$o&&(ae.type==="CorruptZip"?pe=i.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(pe=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$Yn(ae.message,pe)}await this.l.updateMetadata(X,a);try{this.p.trace(`Started renaming the extension from ${X.fsPath} to ${W.fsPath}`),await this.v(X.fsPath,W.fsPath),this.p.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.p.info(`Rename failed because of ${(0,j.$8)(ae)}. Deleted from extracted location`,X),ae}this.h.fire(W)}catch(ae){try{await this.k.del(X,{recursive:!0})}catch{}throw ae}return this.w(W,1)}async scanMetadata(C,z){return z?(await this.s(C,z))?.metadata:this.l.scanMetadata(C.location)}async s(C,z){return(await this.m.scanProfileExtensions(z)).find(m=>(0,s.$no)(m.identifier,C.identifier))}async updateMetadata(C,z,a){return a?await this.m.updateMetadata([[C,z]],a):await this.l.updateMetadata(C.location,z),this.w(C.location,C.type,a)}getUninstalledExtensions(){return this.u()}async setUninstalled(...C){const z=C.map(a=>s.$oo.create(a));await this.u(a=>z.forEach(m=>{a[m.toString()]=!0,this.p.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(C){await this.u(z=>delete z[C.toString()])}async removeExtension(C,z){if(this.n.extUri.isEqualOrParent(C.location,this.l.userExtensionsLocation))return this.t(C.identifier.id,C.location,z)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.u(z=>delete z[s.$oo.create(C).toString()])}async copyExtension(C,z,a,m){const M=await this.s(C,z),T=await this.s(C,a);return m={...M?.metadata,...m},T?await this.m.updateMetadata([[C,{...T.metadata,...m}]],a):await this.m.addExtensionsToProfile([[C,m]],a),this.w(C.location,C.type,a)}async copyExtensions(C,z){const a=await this.scanExtensions(1,C),m=await Promise.all(a.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,C)]));await this.m.addExtensionsToProfile(m,z)}async t(C,z,a){this.p.trace(`Deleting ${a} extension from disk`,C,z.fsPath);const m=this.n.extUri.joinPath(this.n.extUri.dirname(z),`${this.n.extUri.basename(z)}.${(0,u.$ni)((0,h.$6e)()).toString(16)}${q}`);await this.v(z.fsPath,m.fsPath),await this.k.del(m,{recursive:!0}),this.p.info(`Deleted ${a} extension from disk`,C,z.fsPath)}async u(C){return this.g.queue(async()=>{let z;try{z=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,_.$hk)(m)!==1)throw m}let a={};if(z)try{a=JSON.parse(z)}catch{}return C&&(C(a),Object.keys(a).length?await this.k.writeFile(this.c,N.$Hc.fromString(JSON.stringify(a))):await this.k.del(this.c)),a})}async v(C,z){try{await f.Promises.rename(C,z,2*60*1e3)}catch(a){throw new i.$Yn(a.message||p.localize(5,null,C,z),a.code||i.ExtensionManagementErrorCode.Rename)}}async w(C,z,a){if(a){const M=(await this.l.scanUserExtensions({profileLocation:a})).find(T=>this.n.extUri.isEqual(T.location,C));if(M)return this.y(M)}else{const m=await this.l.scanExistingExtension(C,z,{includeInvalid:!0});if(m)return this.y(m)}throw new Error(p.localize(6,null,C.path))}async y(C){const z=await this.k.resolve(C.location);let a,m;return z.children&&(a=z.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,m=z.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async z(){const C=await this.getUninstalledExtensions();if(Object.keys(C).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(C));const z=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const M of z)C[s.$oo.create(M).toString()]||a.add(M.identifier.id.toLowerCase());try{const M=(0,s.$to)(z,T=>T.identifier);await L.Promises.settled(M.map(async T=>{const X=T.sort((W,oe)=>w.rcompare(W.manifest.version,oe.manifest.version))[0];a.has(X.identifier.id.toLowerCase())||await this.j(await this.y(X))}))}catch(M){this.p.error(M)}const m=z.filter(M=>M.metadata&&C[s.$oo.create(M).toString()]);await Promise.allSettled(m.map(M=>this.removeUninstalledExtension(M)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let C;try{C=await this.k.resolve(this.l.userExtensionsLocation)}catch(z){(0,_.$hk)(z)!==1&&this.p.error(z);return}if(C?.children)try{await Promise.allSettled(C.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(q))){this.p.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.k.del(z.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(a){(0,_.$hk)(a)!==1&&this.p.error(a)}}}))}catch{}}};e.$xp=F,e.$xp=F=$e([se(1,_.$4j),se(2,r.$lp),se(3,n.$hp),se(4,ue.$Ak),se(5,le.$3i)],F);class U extends o.$fp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$se)(this.options.operation)?this.l:this.options.operation}constructor(C,z,a,m,M,T,X,W,oe){super(),this.identifier=C,this.source=z,this.options=a,this.m=m,this.n=M,this.o=T,this.p=X,this.q=W,this.s=oe,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(C){const[z,a]=await this.x(C);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,a]],this.j),z}async u({zipPath:C,key:z,metadata:a},m,M){let T=await this.v(z);return T||(this.s.trace("Extracting extension...",z.id),T=await this.m.extractUserExtension(z,C,a,m,M),this.s.info("Extracting extension completed.",z.id)),T}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(m=>s.$oo.create(m).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class B extends U{constructor(C,z,a,m,M,T,X,W,oe,ae){super(z.identifier,z,a,M,T,X,W,oe,ae),this.y=z,this.z=m}async x(C){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(X=>(0,s.$no)(X.identifier,this.y.identifier));a&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$re)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,m),m];const{location:M,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.B(M.fsPath),[await this.u({zipPath:M.fsPath,key:s.$oo.create(this.y),metadata:m},!1,C),m]}catch(X){try{await this.z.delete(M)}catch(W){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,j.$8)(W))}throw X}}async B(C){try{await(0,I.$sp)(C)}catch(z){throw new i.$Yn((0,o.$dp)(z).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$yp=B;class Y extends U{constructor(C,z,a,m,M,T,X,W,oe,ae){super({id:(0,s.$so)(C.publisher,C.name)},z,a,M,T,X,W,oe,ae),this.y=C,this.z=z,this.A=m}async h(C){const z=await super.h(C);return this.D(z,C),z}async x(C){const z=new s.$oo(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(X=>(0,s.$no)(this.identifier,X.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this.l=3,z.equals(new s.$oo(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&w.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const X=await this.v(z);if(X)try{await this.m.removeExtension(X,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$_c(this.z.fsPath),key:z,metadata:M},!0,C),M]}async D(C,z){try{let[a]=await this.A.getExtensions([{id:C.identifier.id,version:C.manifest.version}],z);if(a||([a]=await this.A.getExtensions([{id:C.identifier.id}],z)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(C,m,this.options.profileLocation)}}catch{}}}class K extends o.$fp{constructor(C,z,a){super(),this.extension=C,this.j=z,this.k=a}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,45,136,178]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;let w=class extends k.$Ho{constructor(f,S,p,E){super(E),this.j=f,this.k=S,this.l=p,this.m(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const f=this.j.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,S){const{f:p,g:E}=this;let t;try{t=await(0,l.$Kl)(this.j,this.l,this.k.args,process.env)}catch(s){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.$8)(s)))}const o={...process.env,...t},i=f.agent?f.agent:await(0,g.$Kq)(f.url||"",o,{proxyUrl:p,strictSSL:E});return f.agent=i,f.strictSSL=E,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,S))}async resolveProxy(f){}};e.$Lq=w,e.$Lq=w=$e([se(0,y.$6h),se(1,u.$Hh),se(2,O.$3i),se(3,O.$4i)],w);async function v(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,E)=>{J(["https"],p,E)}):await new Promise((p,E)=>{J(["http"],p,E)})).request}async function $(h,f){return N.Promises.withAsyncBody(async(S,p)=>{const E=(0,L.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await v(h),o={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,j.$re)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password);const i=t(o,s=>{const n=(0,j.$pe)(h.followRedirects)?h.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)$({...h,url:s.headers.location,followRedirects:n-1},f).then(S,p);else{let r=s;!h.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,d.createGunzip)())),S({res:s,stream:(0,R.$Wc)(r)})}});i.on("error",p),h.timeout&&i.setTimeout(h.timeout),h.isChromiumNetwork&&i.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&i.write(h.data),i.end(),f.onCancellationRequested(()=>{i.abort(),p(new A.$3)})})}e.$Mq=$}),define(ne[179],re([0,1,32,8,33,9,2,15,16,13,34,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,31,45,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,N,R,A,j,y,u,l,O,k,g,d,w,v,$,h,f,S,p,E,t,o,i,s,n,r,c,P,I,b,D,H,_,x,le,te,ce,ue,ie,q,G,F,U,B,Y,K,Q,C,z,a,m,M,T,X,W,oe,ae,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$mb{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(x.$3i),Me=be.get(r.$4j),V=be.get(h.$Hh),Z=be.get(m.$Ck);Se.info("CLI main",this.b),this.g(Se),await this.h(V,Me,Z,he),await Promise.all(we.map(ee=>{(0,N.$wg)(ee.flush(),1e3)}))})}async f(){const he=new D.$xh,we={_serviceBrand:void 0,...ue.default};he.set(ie.$ij,we);const be=new f.$0l(this.b,we);he.set(h.$Hh,be),await Promise.all([be.appSettingsHome.with({scheme:y.Schemas.file}).fsPath,be.extensionsPath].map(Ne=>Ne?g.Promises.mkdir(Ne,{recursive:!0}):void 0));const Se=new oe.$6M((0,x.$ej)(be),be.logsHome);he.set(x.$4i,Se);const Me=this.B(Se.createLogger("cli",{name:(0,ae.localize)(0,null)})),V=[];Se.getLogLevel()===x.LogLevel.Trace&&V.push(new x.$$i(Se.getLogLevel()));const Z=this.B(new W.$dN(Me,V));he.set(x.$3i,Z);const ee=this.B(new c.$Ap(Z));he.set(r.$4j,ee);const me=this.B(new P.$Zp(Z));ee.registerProvider(y.Schemas.file,me),ee.registerProvider(y.Schemas.vscodeUserData,new pe.$J6b(y.Schemas.file,me,y.Schemas.vscodeUserData,Z));const ye=new a.$mr(ee);he.set(z.$Ak,ye);const De=new F.$0M(1,be,Z,ee),ke=new M.$_M(De,ye,be,ee,Z);he.set(m.$Ck,ke);const Le=l.$i&&we.win32RegValueName?this.B(new ce.$H6b(Z,we.win32RegValueName)):be.policyFile?this.B(new le.$I6b(be.policyFile,ee,Z)):new te.$0m;he.set(te.$8m,Le);const Ie=this.B(new w.$xn(ke.defaultProfile.settingsResource,ee,Le,Z));he.set(d.$6h,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ae;try{Ae=await(0,T.$o6b)(De,Z)}catch(Ne){Ne.code!=="ENOENT"&&Z.error(Ne)}ke.init(),he.set(z.$Ak,new a.$mr(ee));const Ce=new G.$Lq(Ie,be,Z,Se);he.set(q.$Go,Ce),he.set(v.$Bn,new I.$wh($.$sN,void 0,!0)),he.set(o.$hp,new I.$wh(X.$cN,void 0,!0)),he.set(i.$lp,new I.$wh(n.$l6b,void 0,!0)),he.set(E.$4o,new I.$wh(E.$5o,void 0,!0)),he.set(s.$vp,new I.$wh(s.$wp,void 0,!0)),he.set(p.$Xn,new I.$wh(S.$3o,void 0,!0)),he.set(H.$Fq,new I.$wh(_.$Hq,void 0,!1));const Oe=[],je=(0,K.$ko)(we,Ie);if((0,K.$fo)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new Q.$4M(Ce,je,"monacoworkbench",null,we.aiConfig.ariaKey));const Ne={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,U.$8n)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,je),piiPaths:(0,K.$lo)(be)};he.set(B.$7k,new I.$wh(Y.$Nq,[Ne],!1))}else he.set(B.$7k,K.$_n);return[new b.$3p(he),Oe]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$ki)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$X)(we)||(0,A.$Y)(we)}),process.on("unhandledRejection",we=>(0,A.$Y)(we))}async h(he,we,be,Se){let Me;if(he.args.profile&&(Me=be.profiles.find(Z=>Z.name===he.args.profile),!Me))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Me??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(t.$6o,new x.$$i(x.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Z={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Se.createInstance(t.$6o,new x.$$i(x.LogLevel.Info,!1)).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),Z,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(t.$6o,new x.$$i(x.LogLevel.Info,!1)).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Se.createInstance(t.$6o,new x.$$i(x.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$66b)(he.appRoot,he.extensionsPath))}}i(he){return he.map(we=>/\.vsix$/i.test(we)?k.URI.file((0,u.$0c)(we)?we:(0,u.$$c)((0,O.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5a400e53e985dc5e24f6ee574b07ab23943841c5/core/vs/code/node/cliProcessMain.js.map
