/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(pe){for(var e=[],y=0,R=pe.length;y<R;y++)e[y]=Pe[pe[y]];return e};define(Pe[64],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=e.$5g=e.$4g=void 0;function y(A){return(l,I,f)=>{let P=null,S=null;if(typeof f.value=="function"?(P="value",S=f.value):typeof f.get=="function"&&(P="get",S=f.get),!S)throw new Error("not supported");f[P]=A(S,I)}}function R(A,l,I){let f=null,P=null;if(typeof I.value=="function"?(f="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(f="get",P=I.get),!P)throw new Error("not supported");const S=`$memoize$${l}`;I[f]=function(...u){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[S]}}e.$4g=R;function C(A,l,I){return y((f,P)=>{const S=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...p){this[u]||(this[u]=I?I():void 0),clearTimeout(this[S]),l&&(this[u]=l(this[u],...p),p=[this[u]]),this[S]=setTimeout(()=>{f.apply(this,p),this[u]=I?I():void 0},A)}})}e.$5g=C;function L(A,l,I){return y((f,P)=>{const S=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...d){if(this[u]||(this[u]=I?I():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),l&&(this[u]=l(this[u],...d)),this[$])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),f.apply(this,[this[u]]),this[u]=I?I():void 0):(this[$]=!0,this[S]=setTimeout(()=>{this[$]=!1,this[p]=Date.now(),f.apply(this,[this[u]]),this[u]=I?I():void 0},t-Date.now()))}})}e.$6g=L}),define(Pe[88],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$XL=y,e.$YL=new y("id#")}),define(Pe[116],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(n,a=!1){let r=0;const o=n.length;let w="",v=0,E=16,D=0;function s(j){let U=0,z=0;for(;U<j;){const ie=n.charCodeAt(r);if(ie>=48&&ie<=57)z=z*16+ie-48;else if(ie>=65&&ie<=70)z=z*16+ie-65+10;else if(ie>=97&&ie<=102)z=z*16+ie-97+10;else break;r++,U++}return U<j&&(z=-1),z}function h(j){r=j,w="",v=0,E=16,D=0}function g(){const j=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&f(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&f(n.charCodeAt(r)))for(r++;r<n.length&&f(n.charCodeAt(r));)r++;else return D=3,n.substring(j,r);let U=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&f(n.charCodeAt(r))){for(r++;r<n.length&&f(n.charCodeAt(r));)r++;U=r}else D=3;return n.substring(j,U)}function M(){let j="",U=r;for(;;){if(r>=o){j+=n.substring(U,r),D=2;break}const z=n.charCodeAt(r);if(z===34){j+=n.substring(U,r),r++;break}if(z===92){if(j+=n.substring(U,r),r++,r>=o){D=2;break}switch(n.charCodeAt(r++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const X=s(4);X>=0?j+=String.fromCharCode(X):D=4;break}default:D=5}U=r;continue}if(z>=0&&z<=31)if(I(z)){j+=n.substring(U,r),D=2;break}else D=6;r++}return j}function W(){if(w="",D=0,v=r,r>=o)return v=o,E=17;let j=n.charCodeAt(r);if(l(j)){do r++,w+=String.fromCharCode(j),j=n.charCodeAt(r);while(l(j));return E=15}if(I(j))return r++,w+=String.fromCharCode(j),j===13&&n.charCodeAt(r)===10&&(r++,w+=`
`),E=14;switch(j){case 123:return r++,E=1;case 125:return r++,E=2;case 91:return r++,E=3;case 93:return r++,E=4;case 58:return r++,E=6;case 44:return r++,E=5;case 34:return r++,w=M(),E=10;case 47:{const U=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<o&&!I(n.charCodeAt(r));)r++;return w=n.substring(U,r),E=12}if(n.charCodeAt(r+1)===42){r+=2;const z=o-1;let ie=!1;for(;r<z;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,ie=!0;break}r++}return ie||(r++,D=1),w=n.substring(U,r),E=13}return w+=String.fromCharCode(j),r++,E=16}case 45:if(w+=String.fromCharCode(j),r++,r===o||!f(n.charCodeAt(r)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=g(),E=11;default:for(;r<o&&V(j);)r++,j=n.charCodeAt(r);if(v!==r){switch(w=n.substring(v,r),w){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return w+=String.fromCharCode(j),r++,E=16}}function V(j){if(l(j)||I(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let j;do j=W();while(j>=12&&j<=15);return j}return{setPosition:h,getPosition:()=>r,scan:a?B:W,getToken:()=>E,getTokenValue:()=>w,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>D}}e.$Hm=A;function l(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function S(n,a){const r=[],o=new Object;let w;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(s,h,g,M){v.value=s,v.offset=h,v.length=g,v.type=M,v.colonOffset=void 0,w=v}try{m(n,{onObjectBegin:(s,h)=>{if(a<=s)throw o;w=void 0,E=a>s,r.push("")},onObjectProperty:(s,h,g)=>{if(a<h||(D(s,h,g,"property"),r[r.length-1]=s,a<=h+g))throw o},onObjectEnd:(s,h)=>{if(a<=s)throw o;w=void 0,r.pop()},onArrayBegin:(s,h)=>{if(a<=s)throw o;w=void 0,r.push(0)},onArrayEnd:(s,h)=>{if(a<=s)throw o;w=void 0,r.pop()},onLiteralValue:(s,h,g)=>{if(a<h||(D(s,h,g,b(s)),a<=h+g))throw o},onSeparator:(s,h,g)=>{if(a<=h)throw o;if(s===":"&&w&&w.type==="property")w.colonOffset=h,E=!1,w=void 0;else if(s===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(E=!0,r[r.length-1]=""),w=void 0}}})}catch(s){if(s!==o)throw s}return{path:r,previousNode:w,isAtPropertyKey:E,matches:s=>{let h=0;for(let g=0;h<s.length&&g<r.length;g++)if(s[h]===r[g]||s[h]==="*")h++;else if(s[h]!=="**")return!1;return h===s.length}}}e.$Im=S;function u(n,a=[],r=L.DEFAULT){let o=null,w=[];const v=[];function E(s){Array.isArray(w)?w.push(s):o!==null&&(w[o]=s)}return m(n,{onObjectBegin:()=>{const s={};E(s),v.push(w),w=s,o=null},onObjectProperty:s=>{o=s},onObjectEnd:()=>{w=v.pop()},onArrayBegin:()=>{const s=[];E(s),v.push(w),w=s,o=null},onArrayEnd:()=>{w=v.pop()},onLiteralValue:E,onError:(s,h,g)=>{a.push({error:s,offset:h,length:g})}},r),w[0]}e.$Jm=u;function p(n,a=[],r=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(s){o.type==="property"&&(o.length=s-o.offset,o=o.parent)}function v(s){return o.children.push(s),s}m(n,{onObjectBegin:s=>{o=v({type:"object",offset:s,length:-1,parent:o,children:[]})},onObjectProperty:(s,h,g)=>{o=v({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:s,offset:h,length:g,parent:o})},onObjectEnd:(s,h)=>{o.length=s+h-o.offset,o=o.parent,w(s+h)},onArrayBegin:(s,h)=>{o=v({type:"array",offset:s,length:-1,parent:o,children:[]})},onArrayEnd:(s,h)=>{o.length=s+h-o.offset,o=o.parent,w(s+h)},onLiteralValue:(s,h,g)=>{v({type:b(s),offset:h,length:g,parent:o,value:s}),w(h+g)},onSeparator:(s,h,g)=>{o.type==="property"&&(s===":"?o.colonOffset=h:s===","&&w(h))},onError:(s,h,g)=>{a.push({error:s,offset:h,length:g})}},r);const D=o.children[0];return D&&delete D.parent,D}e.$Km=p;function $(n,a){if(!n)return;let r=n;for(const o of a)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let w=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===o){r=v.children[1],w=!0;break}if(!w)return}else{const w=o;if(r.type!=="array"||w<0||!Array.isArray(r.children)||w>=r.children.length)return;r=r.children[w]}return r}e.$Lm=$;function d(n){if(!n.parent||!n.parent.children)return[];const a=d(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;a.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&a.push(r)}return a}e.$Mm=d;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const a=Object.create(null);for(const r of n.children){const o=r.children[1];o&&(a[r.children[0].value]=t(o))}return a}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$Nm=t;function i(n,a,r=!1){return a>=n.offset&&a<n.offset+n.length||r&&a===n.offset+n.length}e.$Om=i;function c(n,a,r=!1){if(i(n,a,r)){const o=n.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=a;w++){const v=c(o[w],a,r);if(v)return v}return n}}e.$Pm=c;function m(n,a,r=L.DEFAULT){const o=A(n,!1);function w(we){return we?()=>we(o.getTokenOffset(),o.getTokenLength()):()=>!0}function v(we){return we?ae=>we(ae,o.getTokenOffset(),o.getTokenLength()):()=>!0}const E=w(a.onObjectBegin),D=v(a.onObjectProperty),s=w(a.onObjectEnd),h=w(a.onArrayBegin),g=w(a.onArrayEnd),M=v(a.onLiteralValue),W=v(a.onSeparator),V=w(a.onComment),B=v(a.onError),j=r&&r.disallowComments,U=r&&r.allowTrailingComma;function z(){for(;;){const we=o.scan();switch(o.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:j||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(we){case 12:case 13:j?ie(10):V();break;case 16:ie(1);break;case 15:case 14:break;default:return we}}}function ie(we,ae=[],x=[]){if(B(we),ae.length+x.length>0){let ue=o.getToken();for(;ue!==17;){if(ae.indexOf(ue)!==-1){z();break}else if(x.indexOf(ue)!==-1)break;ue=z()}}}function X(we){const ae=o.getTokenValue();return we?M(ae):D(ae),z(),!0}function ye(){switch(o.getToken()){case 11:{let we=0;try{we=JSON.parse(o.getTokenValue()),typeof we!="number"&&(ie(2),we=0)}catch{ie(2)}M(we);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return z(),!0}function De(){return o.getToken()!==10?(ie(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(W(":"),z(),le()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function Re(){E(),z();let we=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(we||ie(4,[],[]),W(","),z(),o.getToken()===2&&U)break}else we&&ie(6,[],[]);De()||ie(4,[],[2,5]),we=!0}return s(),o.getToken()!==2?ie(7,[2],[]):z(),!0}function Y(){h(),z();let we=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(we||ie(4,[],[]),W(","),z(),o.getToken()===4&&U)break}else we&&ie(6,[],[]);le()||ie(4,[],[4,5]),we=!0}return g(),o.getToken()!==4?ie(8,[4],[]):z(),!0}function le(){switch(o.getToken()){case 3:return Y();case 1:return Re();case 10:return X(!0);default:return ye()}}return z(),o.getToken()===17?r.allowEmptyContent?!0:(ie(4,[],[]),!1):le()?(o.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Qm=m;function k(n,a){const r=A(n),o=[];let w,v=0,E;do switch(E=r.getPosition(),w=r.scan(),w){case 12:case 13:case 17:v!==E&&o.push(n.substring(v,E)),a!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,a)),v=r.getPosition();break}while(w!==17);return o.join("")}e.$Rm=k;function b(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$Sm=b}),define(Pe[28],Ae([1,0]),function(pe,e){"use strict";var y,R,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.Touch=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;function L(t,i,c){let m=t.get(i);return m===void 0&&(m=c,t.set(i,m)),m}e.$ui=L;function A(t){const i=[];return t.forEach((c,m)=>{i.push(`${m} => ${c}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.$vi=A;function l(t){const i=[];return t.forEach(c=>{i.push(c)}),`Set(${t.size}) {${i.join(", ")}}`}e.$wi=l;class I{constructor(i,c){this.uri=i,this.value=c}}class f{static{this.a=i=>i.toString()}constructor(i,c){this[y]="ResourceMap",i instanceof f?(this.b=new Map(i.b),this.c=c??f.a):(this.b=new Map,this.c=i??f.a)}set(i,c){return this.b.set(this.c(i),new I(i,c)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,c){typeof c<"u"&&(i=i.bind(c));for(const[m,k]of this.b)i(k.value,k.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$xi=f;class P{constructor(i,c){this[R]="ResourceSet",!i||typeof i=="function"?this.a=new f(i):(this.a=new f(c),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,c){this.a.forEach((m,k)=>i.call(c,k,k,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$yi=P;var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S||(e.Touch=S={}));class u{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,c=0){const m=this.a.get(i);if(m)return c!==0&&this.j(m,c),m.value}set(i,c,m=0){let k=this.a.get(i);if(k)k.value=c,m!==0&&this.j(k,m);else{switch(k={key:i,value:c,next:void 0,previous:void 0},m){case 0:this.h(k);break;case 1:this.g(k);break;case 2:this.h(k);break;default:this.h(k);break}this.a.set(i,k),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const c=this.a.get(i);if(c)return this.a.delete(i),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,c){const m=this.e;let k=this.b;for(;k;){if(c?i.bind(c)(k.value,k.key,this):i(k.value,k.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");k=k.next}}keys(){const i=this,c=this.e;let m=this.b;const k={[Symbol.iterator](){return k},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.key,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return k}values(){const i=this,c=this.e;let m=this.b;const k={[Symbol.iterator](){return k},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.value,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return k}entries(){const i=this,c=this.e;let m=this.b;const k={[Symbol.iterator](){return k},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:[m.key,m.value],done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return k}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let c=this.b,m=this.size;for(;c&&m>i;)this.a.delete(c.key),c=c.next,m--;this.b=c,this.d=m,c&&(c.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const c=i.next,m=i.previous;if(!c||!m)throw new Error("Invalid list");c.previous=m,m.next=c}i.next=void 0,i.previous=void 0,this.e++}j(i,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(i===this.b)return;const m=i.next,k=i.previous;i===this.c?(k.next=void 0,this.c=k):(m.previous=k,k.next=m),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(c===2){if(i===this.c)return;const m=i.next,k=i.previous;i===this.b?(m.previous=void 0,this.b=m):(m.previous=k,k.next=m),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((c,m)=>{i.push([m,c])}),i}fromJSON(i){this.clear();for(const[c,m]of i)this.set(c,m)}}e.$zi=u;class p extends u{constructor(i,c=1){super(),this.k=i,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,c=2){return super.get(i,c)}peek(i){return super.get(i,0)}set(i,c){return super.set(i,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ai=p;class ${constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let c=this.a.get(i)||0;return c===0?!1:(c--,c===0?this.a.delete(i):this.a.set(i,c),!0)}has(i){return this.a.has(i)}}e.$Bi=$;class d{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[c,m]of i)this.set(c,m)}clear(){this.a.clear(),this.b.clear()}set(i,c){this.a.set(i,c),this.b.set(c,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const c=this.a.get(i);return c===void 0?!1:(this.a.delete(i),this.b.delete(c),!0)}forEach(i,c){this.a.forEach((m,k)=>{i.call(c,m,k,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ci=d}),function(pe,e){typeof define=="function"&&define.amd?define(Pe[117],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(ve,be){for(var ke=0;ke<be.length;ke++){var oe=be[ke];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ve,oe.key,oe)}}function y(ve,be,ke){return be&&e(ve.prototype,be),ke&&e(ve,ke),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function R(ve,be){if(ve){if(typeof ve=="string")return C(ve,be);var ke=Object.prototype.toString.call(ve).slice(8,-1);if(ke==="Object"&&ve.constructor&&(ke=ve.constructor.name),ke==="Map"||ke==="Set")return Array.from(ve);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return C(ve,be)}}function C(ve,be){(be==null||be>ve.length)&&(be=ve.length);for(var ke=0,oe=new Array(be);ke<be;ke++)oe[ke]=ve[ke];return oe}function L(ve,be){var ke=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(ke)return(ke=ke.call(ve)).next.bind(ke);if(Array.isArray(ve)||(ke=R(ve))||be&&ve&&typeof ve.length=="number"){ke&&(ve=ke);var oe=0;return function(){return oe>=ve.length?{done:!0}:{done:!1,value:ve[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=A();function l(ve){pe.defaults=ve}var I=/[&<>"']/,f=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(be){return u[be]};function $(ve,be){if(be){if(I.test(ve))return ve.replace(f,p)}else if(P.test(ve))return ve.replace(S,p);return ve}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(d,function(be,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(ve,be){ve=typeof ve=="string"?ve:ve.source,be=be||"";var ke={replace:function(de,se){return se=se.source||se,se=se.replace(i,"$1"),ve=ve.replace(de,se),ke},getRegex:function(){return new RegExp(ve,be)}};return ke}var m=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(ve,be,ke){if(ve){var oe;try{oe=decodeURIComponent(t(ke)).replace(m,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}be&&!k.test(ke)&&(ke=w(be,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var n={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(ve,be){n[" "+ve]||(a.test(ve)?n[" "+ve]=ve+"/":n[" "+ve]=s(ve,"/",!0)),ve=n[" "+ve];var ke=ve.indexOf(":")===-1;return be.substring(0,2)==="//"?ke?be:ve.replace(r,"$1")+be:be.charAt(0)==="/"?ke?be:ve.replace(o,"$1")+be:ve+be}var v={exec:function(){}};function E(ve){for(var be=1,ke,oe;be<arguments.length;be++){ke=arguments[be];for(oe in ke)Object.prototype.hasOwnProperty.call(ke,oe)&&(ve[oe]=ke[oe])}return ve}function D(ve,be){var ke=ve.replace(/\|/g,function(se,ne,me){for(var Ce=!1,F=ne;--F>=0&&me[F]==="\\";)Ce=!Ce;return Ce?"|":" |"}),oe=ke.split(/ \|/),de=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>be)oe.splice(be);else for(;oe.length<be;)oe.push("");for(;de<oe.length;de++)oe[de]=oe[de].trim().replace(/\\\|/g,"|");return oe}function s(ve,be,ke){var oe=ve.length;if(oe===0)return"";for(var de=0;de<oe;){var se=ve.charAt(oe-de-1);if(se===be&&!ke)de++;else if(se!==be&&ke)de++;else break}return ve.slice(0,oe-de)}function h(ve,be){if(ve.indexOf(be[1])===-1)return-1;for(var ke=ve.length,oe=0,de=0;de<ke;de++)if(ve[de]==="\\")de++;else if(ve[de]===be[0])oe++;else if(ve[de]===be[1]&&(oe--,oe<0))return de;return-1}function g(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(ve,be){if(be<1)return"";for(var ke="";be>1;)be&1&&(ke+=ve),be>>=1,ve+=ve;return ke+ve}function W(ve,be,ke,oe){var de=be.href,se=be.title?$(be.title):null,ne=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){oe.state.inLink=!0;var me={type:"link",raw:ke,href:de,title:se,text:ne,tokens:oe.inlineTokens(ne)};return oe.state.inLink=!1,me}return{type:"image",raw:ke,href:de,title:se,text:$(ne)}}function V(ve,be){var ke=ve.match(/^(\s+)(?:```)/);if(ke===null)return be;var oe=ke[1];return be.split(`
`).map(function(de){var se=de.match(/^\s+/);if(se===null)return de;var ne=se[0];return ne.length>=oe.length?de.slice(oe.length):de}).join(`
`)}var B=function(){function ve(ke){this.options=ke||pe.defaults}var be=ve.prototype;return be.space=function(oe){var de=this.rules.block.newline.exec(oe);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},be.code=function(oe){var de=this.rules.block.code.exec(oe);if(de){var se=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?se:s(se,`
`)}}},be.fences=function(oe){var de=this.rules.block.fences.exec(oe);if(de){var se=de[0],ne=V(se,de[3]||"");return{type:"code",raw:se,lang:de[2]?de[2].trim():de[2],text:ne}}},be.heading=function(oe){var de=this.rules.block.heading.exec(oe);if(de){var se=de[2].trim();if(/#$/.test(se)){var ne=s(se,"#");(this.options.pedantic||!ne||/ $/.test(ne))&&(se=ne.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:se,tokens:this.lexer.inline(se)}}},be.hr=function(oe){var de=this.rules.block.hr.exec(oe);if(de)return{type:"hr",raw:de[0]}},be.blockquote=function(oe){var de=this.rules.block.blockquote.exec(oe);if(de){var se=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},be.list=function(oe){var de=this.rules.block.list.exec(oe);if(de){var se,ne,me,Ce,F,q,H,Q,K,ee,ce,ze,Ue=de[1].trim(),Qe=Ue.length>1,He={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(ze=!1,!(!(de=et.exec(oe))||this.rules.block.hr.test(oe)));){if(se=de[0],oe=oe.substring(se.length),Q=de[2].split(`
`,1)[0],K=oe.split(`
`,1)[0],this.options.pedantic?(Ce=2,ce=Q.trimLeft()):(Ce=de[2].search(/[^ ]/),Ce=Ce>4?1:Ce,ce=Q.slice(Ce),Ce+=de[1].length),q=!1,!Q&&/^ *$/.test(K)&&(se+=K+`
`,oe=oe.substring(K.length+1),ze=!0),!ze)for(var Xe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");oe&&(ee=oe.split(`
`,1)[0],Q=ee,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Xe.test(Q)||_e.test(oe)));){if(Q.search(/[^ ]/)>=Ce||!Q.trim())ce+=`
`+Q.slice(Ce);else if(!q)ce+=`
`+Q;else break;!q&&!Q.trim()&&(q=!0),se+=ee+`
`,oe=oe.substring(ee.length+1)}He.loose||(H?He.loose=!0:/\n *\n *$/.test(se)&&(H=!0)),this.options.gfm&&(ne=/^\[[ xX]\] /.exec(ce),ne&&(me=ne[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:se,task:!!ne,checked:me,loose:!1,text:ce}),He.raw+=se}He.items[He.items.length-1].raw=se.trimRight(),He.items[He.items.length-1].text=ce.trimRight(),He.raw=He.raw.trimRight();var Ne=He.items.length;for(F=0;F<Ne;F++){this.lexer.state.top=!1,He.items[F].tokens=this.lexer.blockTokens(He.items[F].text,[]);var st=He.items[F].tokens.filter(function(Z){return Z.type==="space"}),_=st.every(function(Z){for(var $e=Z.raw.split(""),je=0,Oe=L($e),Ze;!(Ze=Oe()).done;){var nt=Ze.value;if(nt===`
`&&(je+=1),je>1)return!0}return!1});!He.loose&&st.length&&_&&(He.loose=!0,He.items[F].loose=!0)}return He}},be.html=function(oe){var de=this.rules.block.html.exec(oe);if(de){var se={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ne=this.options.sanitizer?this.options.sanitizer(de[0]):$(de[0]);se.type="paragraph",se.text=ne,se.tokens=this.lexer.inline(ne)}return se}},be.def=function(oe){var de=this.rules.block.def.exec(oe);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var se=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:de[0],href:de[2],title:de[3]}}},be.table=function(oe){var de=this.rules.block.table.exec(oe);if(de){var se={type:"table",header:D(de[1]).map(function(H){return{text:H}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=de[0];var ne=se.align.length,me,Ce,F,q;for(me=0;me<ne;me++)/^ *-+: *$/.test(se.align[me])?se.align[me]="right":/^ *:-+: *$/.test(se.align[me])?se.align[me]="center":/^ *:-+ *$/.test(se.align[me])?se.align[me]="left":se.align[me]=null;for(ne=se.rows.length,me=0;me<ne;me++)se.rows[me]=D(se.rows[me],se.header.length).map(function(H){return{text:H}});for(ne=se.header.length,Ce=0;Ce<ne;Ce++)se.header[Ce].tokens=this.lexer.inline(se.header[Ce].text);for(ne=se.rows.length,Ce=0;Ce<ne;Ce++)for(q=se.rows[Ce],F=0;F<q.length;F++)q[F].tokens=this.lexer.inline(q[F].text);return se}}},be.lheading=function(oe){var de=this.rules.block.lheading.exec(oe);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},be.paragraph=function(oe){var de=this.rules.block.paragraph.exec(oe);if(de){var se=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:se,tokens:this.lexer.inline(se)}}},be.text=function(oe){var de=this.rules.block.text.exec(oe);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},be.escape=function(oe){var de=this.rules.inline.escape.exec(oe);if(de)return{type:"escape",raw:de[0],text:$(de[1])}},be.tag=function(oe){var de=this.rules.inline.tag.exec(oe);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):$(de[0]):de[0]}},be.link=function(oe){var de=this.rules.inline.link.exec(oe);if(de){var se=de[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var ne=s(se.slice(0,-1),"\\");if((se.length-ne.length)%2===0)return}else{var me=h(de[2],"()");if(me>-1){var Ce=de[0].indexOf("!")===0?5:4,F=Ce+de[1].length+me;de[2]=de[2].substring(0,me),de[0]=de[0].substring(0,F).trim(),de[3]=""}}var q=de[2],H="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);Q&&(q=Q[1],H=Q[3])}else H=de[3]?de[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(se)?q=q.slice(1):q=q.slice(1,-1)),W(de,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},be.reflink=function(oe,de){var se;if((se=this.rules.inline.reflink.exec(oe))||(se=this.rules.inline.nolink.exec(oe))){var ne=(se[2]||se[1]).replace(/\s+/g," ");if(ne=de[ne.toLowerCase()],!ne||!ne.href){var me=se[0].charAt(0);return{type:"text",raw:me,text:me}}return W(se,ne,se[0],this.lexer)}},be.emStrong=function(oe,de,se){se===void 0&&(se="");var ne=this.rules.inline.emStrong.lDelim.exec(oe);if(ne&&!(ne[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ne[1]||ne[2]||"";if(!me||me&&(se===""||this.rules.inline.punctuation.exec(se))){var Ce=ne[0].length-1,F,q,H=Ce,Q=0,K=ne[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(K.lastIndex=0,de=de.slice(-1*oe.length+Ce);(ne=K.exec(de))!=null;)if(F=ne[1]||ne[2]||ne[3]||ne[4]||ne[5]||ne[6],!!F){if(q=F.length,ne[3]||ne[4]){H+=q;continue}else if((ne[5]||ne[6])&&Ce%3&&!((Ce+q)%3)){Q+=q;continue}if(H-=q,!(H>0)){if(q=Math.min(q,q+H+Q),Math.min(Ce,q)%2){var ee=oe.slice(1,Ce+ne.index+q);return{type:"em",raw:oe.slice(0,Ce+ne.index+q+1),text:ee,tokens:this.lexer.inlineTokens(ee)}}var ce=oe.slice(2,Ce+ne.index+q-1);return{type:"strong",raw:oe.slice(0,Ce+ne.index+q+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},be.codespan=function(oe){var de=this.rules.inline.code.exec(oe);if(de){var se=de[2].replace(/\n/g," "),ne=/[^ ]/.test(se),me=/^ /.test(se)&&/ $/.test(se);return ne&&me&&(se=se.substring(1,se.length-1)),se=$(se,!0),{type:"codespan",raw:de[0],text:se}}},be.br=function(oe){var de=this.rules.inline.br.exec(oe);if(de)return{type:"br",raw:de[0]}},be.del=function(oe){var de=this.rules.inline.del.exec(oe);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},be.autolink=function(oe,de){var se=this.rules.inline.autolink.exec(oe);if(se){var ne,me;return se[2]==="@"?(ne=$(this.options.mangle?de(se[1]):se[1]),me="mailto:"+ne):(ne=$(se[1]),me=ne),{type:"link",raw:se[0],text:ne,href:me,tokens:[{type:"text",raw:ne,text:ne}]}}},be.url=function(oe,de){var se;if(se=this.rules.inline.url.exec(oe)){var ne,me;if(se[2]==="@")ne=$(this.options.mangle?de(se[0]):se[0]),me="mailto:"+ne;else{var Ce;do Ce=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ce!==se[0]);ne=$(se[0]),se[1]==="www."?me="http://"+ne:me=ne}return{type:"link",raw:se[0],text:ne,href:me,tokens:[{type:"text",raw:ne,text:ne}]}}},be.inlineText=function(oe,de){var se=this.rules.inline.text.exec(oe);if(se){var ne;return this.lexer.state.inRawBlock?ne=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):$(se[0]):se[0]:ne=$(this.options.smartypants?de(se[0]):se[0]),{type:"text",raw:se[0],text:ne}}},ve}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=c(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=c(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=c(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=c(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=c(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=E({},j),j.gfm=E({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=c(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=E({},j.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:c(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=c(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=c(j._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=c(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=c(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=c(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=c(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=c(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=c(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=c(U.reflink).replace("label",U._label).replace("ref",j._label).getRegex(),U.nolink=c(U.nolink).replace("ref",j._label).getRegex(),U.reflinkSearch=c(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=E({},U),U.pedantic=E({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=E({},U.normal,{escape:c(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=c(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=E({},U.gfm,{br:c(U.br).replace("{2,}","*").getRegex(),text:c(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ie(ve){var be="",ke,oe,de=ve.length;for(ke=0;ke<de;ke++)oe=ve.charCodeAt(ke),Math.random()>.5&&(oe="x"+oe.toString(16)),be+="&#"+oe+";";return be}var X=function(){function ve(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||pe.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:U.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=U.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=U.breaks:oe.inline=U.gfm),this.tokenizer.rules=oe}ve.lex=function(oe,de){var se=new ve(de);return se.lex(oe)},ve.lexInline=function(oe,de){var se=new ve(de);return se.inlineTokens(oe)};var be=ve.prototype;return be.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},be.blockTokens=function(oe,de){var se=this;de===void 0&&(de=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(H,Q,K){return Q+"    ".repeat(K.length)});for(var ne,me,Ce,F;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(ne=H.call({lexer:se},oe,de))?(oe=oe.substring(ne.raw.length),de.push(ne),!0):!1}))){if(ne=this.tokenizer.space(oe)){oe=oe.substring(ne.raw.length),ne.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ne);continue}if(ne=this.tokenizer.code(oe)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ne.raw,me.text+=`
`+ne.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ne);continue}if(ne=this.tokenizer.fences(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.heading(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.hr(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.blockquote(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.list(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.html(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.def(oe)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ne.raw,me.text+=`
`+ne.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ne.tag]||(this.tokens.links[ne.tag]={href:ne.href,title:ne.title});continue}if(ne=this.tokenizer.table(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.lheading(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(Ce=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,Q=oe.slice(1),K=void 0;se.options.extensions.startBlock.forEach(function(ee){K=ee.call({lexer:this},Q),typeof K=="number"&&K>=0&&(H=Math.min(H,K))}),H<1/0&&H>=0&&(Ce=oe.substring(0,H+1))}(),this.state.top&&(ne=this.tokenizer.paragraph(Ce))){me=de[de.length-1],F&&me.type==="paragraph"?(me.raw+=`
`+ne.raw,me.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ne),F=Ce.length!==oe.length,oe=oe.substring(ne.raw.length);continue}if(ne=this.tokenizer.text(oe)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&me.type==="text"?(me.raw+=`
`+ne.raw,me.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ne);continue}if(oe){var q="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,de},be.inline=function(oe,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:oe,tokens:de}),de},be.inlineTokens=function(oe,de){var se=this;de===void 0&&(de=[]);var ne,me,Ce,F=oe,q,H,Q;if(this.tokens.links){var K=Object.keys(this.tokens.links);if(K.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)K.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,q.index)+"["+M("a",q[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,q.index)+"["+M("a",q[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,q.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(H||(Q=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(ne=ce.call({lexer:se},oe,de))?(oe=oe.substring(ne.raw.length),de.push(ne),!0):!1}))){if(ne=this.tokenizer.escape(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.tag(oe)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&ne.type==="text"&&me.type==="text"?(me.raw+=ne.raw,me.text+=ne.text):de.push(ne);continue}if(ne=this.tokenizer.link(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&ne.type==="text"&&me.type==="text"?(me.raw+=ne.raw,me.text+=ne.text):de.push(ne);continue}if(ne=this.tokenizer.emStrong(oe,F,Q)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.codespan(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.br(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.del(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.autolink(oe,ie)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(!this.state.inLink&&(ne=this.tokenizer.url(oe,ie))){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(Ce=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,ze=oe.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},ze),typeof Ue=="number"&&Ue>=0&&(ce=Math.min(ce,Ue))}),ce<1/0&&ce>=0&&(Ce=oe.substring(0,ce+1))}(),ne=this.tokenizer.inlineText(Ce,z)){oe=oe.substring(ne.raw.length),ne.raw.slice(-1)!=="_"&&(Q=ne.raw.slice(-1)),H=!0,me=de[de.length-1],me&&me.type==="text"?(me.raw+=ne.raw,me.text+=ne.text):de.push(ne);continue}if(oe){var ee="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return de},y(ve,null,[{key:"rules",get:function(){return{block:j,inline:U}}}]),ve}(),ye=function(){function ve(ke){this.options=ke||pe.defaults}var be=ve.prototype;return be.code=function(oe,de,se){var ne=(de||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(oe,ne);me!=null&&me!==oe&&(se=!0,oe=me)}return oe=oe.replace(/\n$/,"")+`
`,ne?'<pre><code class="'+this.options.langPrefix+$(ne,!0)+'">'+(se?oe:$(oe,!0))+`</code></pre>
`:"<pre><code>"+(se?oe:$(oe,!0))+`</code></pre>
`},be.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},be.html=function(oe){return oe},be.heading=function(oe,de,se,ne){if(this.options.headerIds){var me=this.options.headerPrefix+ne.slug(se);return"<h"+de+' id="'+me+'">'+oe+"</h"+de+`>
`}return"<h"+de+">"+oe+"</h"+de+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(oe,de,se){var ne=de?"ol":"ul",me=de&&se!==1?' start="'+se+'"':"";return"<"+ne+me+`>
`+oe+"</"+ne+`>
`},be.listitem=function(oe){return"<li>"+oe+`</li>
`},be.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(oe){return"<p>"+oe+`</p>
`},be.table=function(oe,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+de+`</table>
`},be.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},be.tablecell=function(oe,de){var se=de.header?"th":"td",ne=de.align?"<"+se+' align="'+de.align+'">':"<"+se+">";return ne+oe+("</"+se+`>
`)},be.strong=function(oe){return"<strong>"+oe+"</strong>"},be.em=function(oe){return"<em>"+oe+"</em>"},be.codespan=function(oe){return"<code>"+oe+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(oe){return"<del>"+oe+"</del>"},be.link=function(oe,de,se){if(oe=b(this.options.sanitize,this.options.baseUrl,oe),oe===null)return se;var ne='<a href="'+$(oe)+'"';return de&&(ne+=' title="'+de+'"'),ne+=">"+se+"</a>",ne},be.image=function(oe,de,se){if(oe=b(this.options.sanitize,this.options.baseUrl,oe),oe===null)return se;var ne='<img src="'+oe+'" alt="'+se+'"';return de&&(ne+=' title="'+de+'"'),ne+=this.options.xhtml?"/>":">",ne},be.text=function(oe){return oe},ve}(),De=function(){function ve(){}var be=ve.prototype;return be.strong=function(oe){return oe},be.em=function(oe){return oe},be.codespan=function(oe){return oe},be.del=function(oe){return oe},be.html=function(oe){return oe},be.text=function(oe){return oe},be.link=function(oe,de,se){return""+se},be.image=function(oe,de,se){return""+se},be.br=function(){return""},ve}(),Re=function(){function ve(){this.seen={}}var be=ve.prototype;return be.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(oe,de){var se=oe,ne=0;if(this.seen.hasOwnProperty(se)){ne=this.seen[oe];do ne++,se=oe+"-"+ne;while(this.seen.hasOwnProperty(se))}return de||(this.seen[oe]=ne,this.seen[se]=0),se},be.slug=function(oe,de){de===void 0&&(de={});var se=this.serialize(oe);return this.getNextSafeSlug(se,de.dryrun)},ve}(),Y=function(){function ve(ke){this.options=ke||pe.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Re}ve.parse=function(oe,de){var se=new ve(de);return se.parse(oe)},ve.parseInline=function(oe,de){var se=new ve(de);return se.parseInline(oe)};var be=ve.prototype;return be.parse=function(oe,de){de===void 0&&(de=!0);var se="",ne,me,Ce,F,q,H,Q,K,ee,ce,ze,Ue,Qe,He,et,Xe,_e,it,tt,Ne=oe.length;for(ne=0;ne<Ne;ne++){if(ce=oe[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){se+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(K="",Q="",F=ce.header.length,me=0;me<F;me++)Q+=this.renderer.tablecell(this.parseInline(ce.header[me].tokens),{header:!0,align:ce.align[me]});for(K+=this.renderer.tablerow(Q),ee="",F=ce.rows.length,me=0;me<F;me++){for(H=ce.rows[me],Q="",q=H.length,Ce=0;Ce<q;Ce++)Q+=this.renderer.tablecell(this.parseInline(H[Ce].tokens),{header:!1,align:ce.align[Ce]});ee+=this.renderer.tablerow(Q)}se+=this.renderer.table(K,ee);continue}case"blockquote":{ee=this.parse(ce.tokens),se+=this.renderer.blockquote(ee);continue}case"list":{for(ze=ce.ordered,Ue=ce.start,Qe=ce.loose,F=ce.items.length,ee="",me=0;me<F;me++)et=ce.items[me],Xe=et.checked,_e=et.task,He="",et.task&&(it=this.renderer.checkbox(Xe),Qe?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(et.tokens,Qe),ee+=this.renderer.listitem(He,_e,Xe);se+=this.renderer.list(ee,ze,Ue);continue}case"html":{se+=this.renderer.html(ce.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(ee=ce.tokens?this.parseInline(ce.tokens):ce.text;ne+1<Ne&&oe[ne+1].type==="text";)ce=oe[++ne],ee+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);se+=de?this.renderer.paragraph(ee):ee;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},be.parseInline=function(oe,de){de=de||this.renderer;var se="",ne,me,Ce,F=oe.length;for(ne=0;ne<F;ne++){if(me=oe[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Ce=this.options.extensions.renderers[me.type].call({parser:this},me),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){se+=Ce||"";continue}switch(me.type){case"escape":{se+=de.text(me.text);break}case"html":{se+=de.html(me.text);break}case"link":{se+=de.link(me.href,me.title,this.parseInline(me.tokens,de));break}case"image":{se+=de.image(me.href,me.title,me.text);break}case"strong":{se+=de.strong(this.parseInline(me.tokens,de));break}case"em":{se+=de.em(this.parseInline(me.tokens,de));break}case"codespan":{se+=de.codespan(me.text);break}case"br":{se+=de.br();break}case"del":{se+=de.del(this.parseInline(me.tokens,de));break}case"text":{se+=de.text(me.text);break}default:{var q='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return se},ve}();function le(ve,be,ke){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof be=="function"&&(ke=be,be=null),be=E({},le.defaults,be||{}),g(be),ke){var oe=be.highlight,de;try{de=X.lex(ve,be)}catch(F){return ke(F)}var se=function(q){var H;if(!q)try{be.walkTokens&&le.walkTokens(de,be.walkTokens),H=Y.parse(de,be)}catch(Q){q=Q}return be.highlight=oe,q?ke(q):ke(null,H)};if(!oe||oe.length<3||(delete be.highlight,!de.length))return se();var ne=0;le.walkTokens(de,function(F){F.type==="code"&&(ne++,setTimeout(function(){oe(F.text,F.lang,function(q,H){if(q)return se(q);H!=null&&H!==F.text&&(F.text=H,F.escaped=!0),ne--,ne===0&&se()})},0))}),ne===0&&se();return}function me(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+$(F.message+"",!0)+"</pre>";throw F}try{var Ce=X.lex(ve,be);if(be.walkTokens){if(be.async)return Promise.all(le.walkTokens(Ce,be.walkTokens)).then(function(){return Y.parse(Ce,be)}).catch(me);le.walkTokens(Ce,be.walkTokens)}return Y.parse(Ce,be)}catch(F){me(F)}}le.options=le.setOptions=function(ve){return E(le.defaults,ve),l(le.defaults),le},le.getDefaults=A,le.defaults=pe.defaults,le.use=function(){for(var ve=arguments.length,be=new Array(ve),ke=0;ke<ve;ke++)be[ke]=arguments[ke];var oe=E.apply(void 0,[{}].concat(be)),de=le.defaults.extensions||{renderers:{},childTokens:{}},se;be.forEach(function(ne){if(ne.extensions&&(se=!0,ne.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var F=de.renderers?de.renderers[Ce.name]:null;F?de.renderers[Ce.name]=function(){for(var q=arguments.length,H=new Array(q),Q=0;Q<q;Q++)H[Q]=arguments[Q];var K=Ce.renderer.apply(this,H);return K===!1&&(K=F.apply(this,H)),K}:de.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ce.level]?de[Ce.level].unshift(Ce.tokenizer):de[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?de.startBlock?de.startBlock.push(Ce.start):de.startBlock=[Ce.start]:Ce.level==="inline"&&(de.startInline?de.startInline.push(Ce.start):de.startInline=[Ce.start]))}Ce.childTokens&&(de.childTokens[Ce.name]=Ce.childTokens)})),ne.renderer&&function(){var Ce=le.defaults.renderer||new ye,F=function(Q){var K=Ce[Q];Ce[Q]=function(){for(var ee=arguments.length,ce=new Array(ee),ze=0;ze<ee;ze++)ce[ze]=arguments[ze];var Ue=ne.renderer[Q].apply(Ce,ce);return Ue===!1&&(Ue=K.apply(Ce,ce)),Ue}};for(var q in ne.renderer)F(q);oe.renderer=Ce}(),ne.tokenizer&&function(){var Ce=le.defaults.tokenizer||new B,F=function(Q){var K=Ce[Q];Ce[Q]=function(){for(var ee=arguments.length,ce=new Array(ee),ze=0;ze<ee;ze++)ce[ze]=arguments[ze];var Ue=ne.tokenizer[Q].apply(Ce,ce);return Ue===!1&&(Ue=K.apply(Ce,ce)),Ue}};for(var q in ne.tokenizer)F(q);oe.tokenizer=Ce}(),ne.walkTokens){var me=le.defaults.walkTokens;oe.walkTokens=function(Ce){var F=[];return F.push(ne.walkTokens.call(this,Ce)),me&&(F=F.concat(me.call(this,Ce))),F}}se&&(oe.extensions=de),le.setOptions(oe)})},le.walkTokens=function(ve,be){for(var ke=[],oe=function(){var me=se.value;switch(ke=ke.concat(be.call(le,me)),me.type){case"table":{for(var Ce=L(me.header),F;!(F=Ce()).done;){var q=F.value;ke=ke.concat(le.walkTokens(q.tokens,be))}for(var H=L(me.rows),Q;!(Q=H()).done;)for(var K=Q.value,ee=L(K),ce;!(ce=ee()).done;){var ze=ce.value;ke=ke.concat(le.walkTokens(ze.tokens,be))}break}case"list":{ke=ke.concat(le.walkTokens(me.items,be));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[me.type]?le.defaults.extensions.childTokens[me.type].forEach(function(Ue){ke=ke.concat(le.walkTokens(me[Ue],be))}):me.tokens&&(ke=ke.concat(le.walkTokens(me.tokens,be)))}},de=L(ve),se;!(se=de()).done;)oe();return ke},le.parseInline=function(ve,be){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");be=E({},le.defaults,be||{}),g(be);try{var ke=X.lexInline(ve,be);return be.walkTokens&&le.walkTokens(ke,be.walkTokens),Y.parseInline(ke,be)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+$(oe.message+"",!0)+"</pre>";throw oe}},le.Parser=Y,le.parser=Y.parse,le.Renderer=ye,le.TextRenderer=De,le.Lexer=X,le.lexer=X.lex,le.Tokenizer=B,le.Slugger=Re,le.parse=le;var we=le.options,ae=le.setOptions,x=le.use,ue=le.walkTokens,O=le.parseInline,J=le,he=Y.parse,Ee=X.lex;pe.Lexer=X,pe.Parser=Y,pe.Renderer=ye,pe.Slugger=Re,pe.TextRenderer=De,pe.Tokenizer=B,pe.getDefaults=A,pe.lexer=Ee,pe.marked=le,pe.options=we,pe.parse=J,pe.parseInline=O,pe.parser=he,pe.setOptions=ae,pe.use=x,pe.walkTokens=ue,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Pe[118],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.rot=e.$Fl=void 0;function y(l,I,f){return Math.min(Math.max(l,I),f)}e.$Fl=y;function R(l,I){return(I+l%I)%I}e.rot=R;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Hl=C;class L{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Il=L;class A{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const f=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jl=A}),function(){function pe(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function A(I){L.push(I,Date.now())}function l(){const I=[];for(let f=0;f<L.length;f+=2)I.push({name:L[f],startTime:L[f+1]});return I}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(C+A.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=y(R))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var R in y)(typeof exports=="object"?exports:pe)[R]=y[R]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function y(R){if(e[R])return e[R].exports;var C=e[R]={i:R,l:!1,exports:{}};return pe[R].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=pe,y.c=e,y.d=function(R,C,L){y.o(R,C)||Object.defineProperty(R,C,{enumerable:!0,get:L})},y.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},y.t=function(R,C){if(1&C&&(R=y(R)),8&C||4&C&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(y.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&C&&typeof R!="string")for(var A in R)y.d(L,A,function(l){return R[l]}.bind(null,A));return L},y.n=function(R){var C=R&&R.__esModule?function(){return R.default}:function(){return R};return y.d(C,"a",C),C},y.o=function(R,C){return Object.prototype.hasOwnProperty.call(R,C)},y.p="",y(y.s=0)}([function(pe,e,y){(function(R){var C;e=pe.exports=x,C=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],I=e.src=[],f=0,P=f++;I[P]="0|[1-9]\\d*";var S=f++;I[S]="[0-9]+";var u=f++;I[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=f++;I[p]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var $=f++;I[$]="("+I[S]+")\\.("+I[S]+")\\.("+I[S]+")";var d=f++;I[d]="(?:"+I[P]+"|"+I[u]+")";var t=f++;I[t]="(?:"+I[S]+"|"+I[u]+")";var i=f++;I[i]="(?:-("+I[d]+"(?:\\."+I[d]+")*))";var c=f++;I[c]="(?:-?("+I[t]+"(?:\\."+I[t]+")*))";var m=f++;I[m]="[0-9A-Za-z-]+";var k=f++;I[k]="(?:\\+("+I[m]+"(?:\\."+I[m]+")*))";var b=f++,n="v?"+I[p]+I[i]+"?"+I[k]+"?";I[b]="^"+n+"$";var a="[v=\\s]*"+I[$]+I[c]+"?"+I[k]+"?",r=f++;I[r]="^"+a+"$";var o=f++;I[o]="((?:<|>)?=?)";var w=f++;I[w]=I[S]+"|x|X|\\*";var v=f++;I[v]=I[P]+"|x|X|\\*";var E=f++;I[E]="[v=\\s]*("+I[v]+")(?:\\.("+I[v]+")(?:\\.("+I[v]+")(?:"+I[i]+")?"+I[k]+"?)?)?";var D=f++;I[D]="[v=\\s]*("+I[w]+")(?:\\.("+I[w]+")(?:\\.("+I[w]+")(?:"+I[c]+")?"+I[k]+"?)?)?";var s=f++;I[s]="^"+I[o]+"\\s*"+I[E]+"$";var h=f++;I[h]="^"+I[o]+"\\s*"+I[D]+"$";var g=f++;I[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=f++;I[M]="(?:~>?)";var W=f++;I[W]="(\\s*)"+I[M]+"\\s+",l[W]=new RegExp(I[W],"g");var V=f++;I[V]="^"+I[M]+I[E]+"$";var B=f++;I[B]="^"+I[M]+I[D]+"$";var j=f++;I[j]="(?:\\^)";var U=f++;I[U]="(\\s*)"+I[j]+"\\s+",l[U]=new RegExp(I[U],"g");var z=f++;I[z]="^"+I[j]+I[E]+"$";var ie=f++;I[ie]="^"+I[j]+I[D]+"$";var X=f++;I[X]="^"+I[o]+"\\s*("+a+")$|^$";var ye=f++;I[ye]="^"+I[o]+"\\s*("+n+")$|^$";var De=f++;I[De]="(\\s*)"+I[o]+"\\s*("+a+"|"+I[E]+")",l[De]=new RegExp(I[De],"g");var Re=f++;I[Re]="^\\s*("+I[E]+")\\s+-\\s+("+I[E]+")\\s*$";var Y=f++;I[Y]="^\\s*("+I[D]+")\\s+-\\s+("+I[D]+")\\s*$";var le=f++;I[le]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)C(we,I[we]),l[we]||(l[we]=new RegExp(I[we]));function ae(K,ee){if(K instanceof x)return K;if(typeof K!="string"||K.length>L||!(ee?l[r]:l[b]).test(K))return null;try{return new x(K,ee)}catch{return null}}function x(K,ee){if(K instanceof x){if(K.loose===ee)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof x))return new x(K,ee);C("SemVer",K,ee),this.loose=ee;var ce=K.trim().match(ee?l[r]:l[b]);if(!ce)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ue=+ze;if(Ue>=0&&Ue<A)return Ue}return ze}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ae,e.valid=function(K,ee){var ce=ae(K,ee);return ce?ce.version:null},e.clean=function(K,ee){var ce=ae(K.trim().replace(/^[=v]+/,""),ee);return ce?ce.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(K){return C("SemVer.compare",this.version,this.loose,K),K instanceof x||(K=new x(K,this.loose)),this.compareMain(K)||this.comparePre(K)},x.prototype.compareMain=function(K){return K instanceof x||(K=new x(K,this.loose)),O(this.major,K.major)||O(this.minor,K.minor)||O(this.patch,K.patch)},x.prototype.comparePre=function(K){if(K instanceof x||(K=new x(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var ee=0;do{var ce=this.prerelease[ee],ze=K.prerelease[ee];if(C("prerelease compare",ee,ce,ze),ce===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ce===void 0)return-1;if(ce!==ze)return O(ce,ze)}while(++ee)},x.prototype.inc=function(K,ee){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,ee,ce,ze){typeof ce=="string"&&(ze=ce,ce=void 0);try{return new x(K,ce).inc(ee,ze).version}catch{return null}},e.diff=function(K,ee){if(ve(K,ee))return null;var ce=ae(K),ze=ae(ee);if(ce.prerelease.length||ze.prerelease.length){for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==ze[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==ze[Ue])return Ue},e.compareIdentifiers=O;var ue=/^[0-9]+$/;function O(K,ee){var ce=ue.test(K),ze=ue.test(ee);return ce&&ze&&(K=+K,ee=+ee),ce&&!ze?-1:ze&&!ce?1:K<ee?-1:K>ee?1:0}function J(K,ee,ce){return new x(K,ce).compare(new x(ee,ce))}function he(K,ee,ce){return J(K,ee,ce)>0}function Ee(K,ee,ce){return J(K,ee,ce)<0}function ve(K,ee,ce){return J(K,ee,ce)===0}function be(K,ee,ce){return J(K,ee,ce)!==0}function ke(K,ee,ce){return J(K,ee,ce)>=0}function oe(K,ee,ce){return J(K,ee,ce)<=0}function de(K,ee,ce,ze){var Ue;switch(ee){case"===":typeof K=="object"&&(K=K.version),typeof ce=="object"&&(ce=ce.version),Ue=K===ce;break;case"!==":typeof K=="object"&&(K=K.version),typeof ce=="object"&&(ce=ce.version),Ue=K!==ce;break;case"":case"=":case"==":Ue=ve(K,ce,ze);break;case"!=":Ue=be(K,ce,ze);break;case">":Ue=he(K,ce,ze);break;case">=":Ue=ke(K,ce,ze);break;case"<":Ue=Ee(K,ce,ze);break;case"<=":Ue=oe(K,ce,ze);break;default:throw new TypeError("Invalid operator: "+ee)}return Ue}function se(K,ee){if(K instanceof se){if(K.loose===ee)return K;K=K.value}if(!(this instanceof se))return new se(K,ee);C("comparator",K,ee),this.loose=ee,this.parse(K),this.semver===ne?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(K,ee){return O(ee,K)},e.major=function(K,ee){return new x(K,ee).major},e.minor=function(K,ee){return new x(K,ee).minor},e.patch=function(K,ee){return new x(K,ee).patch},e.compare=J,e.compareLoose=function(K,ee){return J(K,ee,!0)},e.rcompare=function(K,ee,ce){return J(ee,K,ce)},e.sort=function(K,ee){return K.sort(function(ce,ze){return e.compare(ce,ze,ee)})},e.rsort=function(K,ee){return K.sort(function(ce,ze){return e.rcompare(ce,ze,ee)})},e.gt=he,e.lt=Ee,e.eq=ve,e.neq=be,e.gte=ke,e.lte=oe,e.cmp=de,e.Comparator=se;var ne={};function me(K,ee){if(K instanceof me)return K.loose===ee?K:new me(K.raw,ee);if(K instanceof se)return new me(K.value,ee);if(!(this instanceof me))return new me(K,ee);if(this.loose=ee,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Ce(K){return!K||K.toLowerCase()==="x"||K==="*"}function F(K,ee,ce,ze,Ue,Qe,He,et,Xe,_e,it,tt,Ne){return((ee=Ce(ce)?"":Ce(ze)?">="+ce+".0.0":Ce(Ue)?">="+ce+"."+ze+".0":">="+ee)+" "+(et=Ce(Xe)?"":Ce(_e)?"<"+(+Xe+1)+".0.0":Ce(it)?"<"+Xe+"."+(+_e+1)+".0":tt?"<="+Xe+"."+_e+"."+it+"-"+tt:"<="+et)).trim()}function q(K,ee){for(var ce=0;ce<K.length;ce++)if(!K[ce].test(ee))return!1;if(ee.prerelease.length){for(ce=0;ce<K.length;ce++)if(C(K[ce].semver),K[ce].semver!==ne&&K[ce].semver.prerelease.length>0){var ze=K[ce].semver;if(ze.major===ee.major&&ze.minor===ee.minor&&ze.patch===ee.patch)return!0}return!1}return!0}function H(K,ee,ce){try{ee=new me(ee,ce)}catch{return!1}return ee.test(K)}function Q(K,ee,ce,ze){var Ue,Qe,He,et,Xe;switch(K=new x(K,ze),ee=new me(ee,ze),ce){case">":Ue=he,Qe=oe,He=Ee,et=">",Xe=">=";break;case"<":Ue=Ee,Qe=ke,He=he,et="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(K,ee,ze))return!1;for(var _e=0;_e<ee.set.length;++_e){var it=ee.set[_e],tt=null,Ne=null;if(it.forEach(function(st){st.semver===ne&&(st=new se(">=0.0.0")),tt=tt||st,Ne=Ne||st,Ue(st.semver,tt.semver,ze)?tt=st:He(st.semver,Ne.semver,ze)&&(Ne=st)}),tt.operator===et||tt.operator===Xe||(!Ne.operator||Ne.operator===et)&&Qe(K,Ne.semver)||Ne.operator===Xe&&He(K,Ne.semver))return!1}return!0}se.prototype.parse=function(K){var ee=this.loose?l[X]:l[ye],ce=K.match(ee);if(!ce)throw new TypeError("Invalid comparator: "+K);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new x(ce[2],this.loose):this.semver=ne},se.prototype.toString=function(){return this.value},se.prototype.test=function(K){return C("Comparator.test",K,this.loose),this.semver===ne||(typeof K=="string"&&(K=new x(K,this.loose)),de(K,this.operator,this.semver,this.loose))},se.prototype.intersects=function(K,ee){if(!(K instanceof se))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new me(K.value,ee),H(this.value,ce,ee);if(K.operator==="")return ce=new me(this.value,ee),H(K.semver,ce,ee);var ze=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Qe=this.semver.version===K.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),et=de(this.semver,"<",K.semver,ee)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),Xe=de(this.semver,">",K.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return ze||Ue||Qe&&He||et||Xe},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(K){var ee=this.loose;K=K.trim(),C("range",K,ee);var ce=ee?l[Y]:l[Re];K=K.replace(ce,F),C("hyphen replace",K),K=K.replace(l[De],"$1$2$3"),C("comparator trim",K,l[De]),K=(K=(K=K.replace(l[W],"$1~")).replace(l[U],"$1^")).split(/\s+/).join(" ");var ze=ee?l[X]:l[ye],Ue=K.split(" ").map(function(Qe){return function(He,et){return C("comp",He),He=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(it){return function(tt,Ne){C("caret",tt,Ne);var st=Ne?l[ie]:l[z];return tt.replace(st,function(_,Z,$e,je,Oe){var Ze;return C("caret",tt,_,Z,$e,je,Oe),Ce(Z)?Ze="":Ce($e)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ce(je)?Ze=Z==="0"?">="+Z+"."+$e+".0 <"+Z+"."+(+$e+1)+".0":">="+Z+"."+$e+".0 <"+(+Z+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ze=Z==="0"?$e==="0"?">="+Z+"."+$e+"."+je+Oe+" <"+Z+"."+$e+"."+(+je+1):">="+Z+"."+$e+"."+je+Oe+" <"+Z+"."+(+$e+1)+".0":">="+Z+"."+$e+"."+je+Oe+" <"+(+Z+1)+".0.0"):(C("no pr"),Ze=Z==="0"?$e==="0"?">="+Z+"."+$e+"."+je+" <"+Z+"."+$e+"."+(+je+1):">="+Z+"."+$e+"."+je+" <"+Z+"."+(+$e+1)+".0":">="+Z+"."+$e+"."+je+" <"+(+Z+1)+".0.0"),C("caret return",Ze),Ze})}(it,_e)}).join(" ")}(He,et),C("caret",He),He=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(it){return function(tt,Ne){var st=Ne?l[B]:l[V];return tt.replace(st,function(_,Z,$e,je,Oe){var Ze;return C("tilde",tt,_,Z,$e,je,Oe),Ce(Z)?Ze="":Ce($e)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ce(je)?Ze=">="+Z+"."+$e+".0 <"+Z+"."+(+$e+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ze=">="+Z+"."+$e+"."+je+Oe+" <"+Z+"."+(+$e+1)+".0"):Ze=">="+Z+"."+$e+"."+je+" <"+Z+"."+(+$e+1)+".0",C("tilde return",Ze),Ze})}(it,_e)}).join(" ")}(He,et),C("tildes",He),He=function(Xe,_e){return C("replaceXRanges",Xe,_e),Xe.split(/\s+/).map(function(it){return function(tt,Ne){tt=tt.trim();var st=Ne?l[h]:l[s];return tt.replace(st,function(_,Z,$e,je,Oe,Ze){C("xRange",tt,_,Z,$e,je,Oe,Ze);var nt=Ce($e),gt=nt||Ce(je),vt=gt||Ce(Oe);return Z==="="&&vt&&(Z=""),nt?_=Z===">"||Z==="<"?"<0.0.0":"*":Z&&vt?(gt&&(je=0),vt&&(Oe=0),Z===">"?(Z=">=",gt?($e=+$e+1,je=0,Oe=0):vt&&(je=+je+1,Oe=0)):Z==="<="&&(Z="<",gt?$e=+$e+1:je=+je+1),_=Z+$e+"."+je+"."+Oe):gt?_=">="+$e+".0.0 <"+(+$e+1)+".0.0":vt&&(_=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),C("xRange return",_),_})}(it,_e)}).join(" ")}(He,et),C("xrange",He),He=function(Xe,_e){return C("replaceStars",Xe,_e),Xe.trim().replace(l[le],"")}(He,et),C("stars",He),He}(Qe,ee)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(ze)})),Ue=Ue.map(function(Qe){return new se(Qe,ee)})},me.prototype.intersects=function(K,ee){if(!(K instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ze){return K.set.some(function(Ue){return Ue.every(function(Qe){return ze.intersects(Qe,ee)})})})})},e.toComparators=function(K,ee){return new me(K,ee).set.map(function(ce){return ce.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},me.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new x(K,this.loose));for(var ee=0;ee<this.set.length;ee++)if(q(this.set[ee],K))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(K,ee,ce){var ze=null,Ue=null;try{var Qe=new me(ee,ce)}catch{return null}return K.forEach(function(He){Qe.test(He)&&(ze&&Ue.compare(He)!==-1||(Ue=new x(ze=He,ce)))}),ze},e.minSatisfying=function(K,ee,ce){var ze=null,Ue=null;try{var Qe=new me(ee,ce)}catch{return null}return K.forEach(function(He){Qe.test(He)&&(ze&&Ue.compare(He)!==1||(Ue=new x(ze=He,ce)))}),ze},e.validRange=function(K,ee){try{return new me(K,ee).range||"*"}catch{return null}},e.ltr=function(K,ee,ce){return Q(K,ee,"<",ce)},e.gtr=function(K,ee,ce){return Q(K,ee,">",ce)},e.outside=Q,e.prerelease=function(K,ee){var ce=ae(K,ee);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(K,ee,ce){return K=new me(K,ce),ee=new me(ee,ce),K.intersects(ee)},e.coerce=function(K){if(K instanceof x)return K;if(typeof K!="string")return null;var ee=K.match(l[g]);return ee==null?null:ae((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,y(1))},function(pe,e){var y,R,C=pe.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(y===setTimeout)return setTimeout(t,0);if((y===L||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:L}catch{y=L}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var I,f=[],P=!1,S=-1;function u(){P&&I&&(P=!1,I.length?f=I.concat(f):S=-1,f.length&&p())}function p(){if(!P){var t=l(u);P=!0;for(var i=f.length;i;){for(I=f,f=[];++S<i;)I&&I[S].run();S=-1,i=f.length}I=null,P=!1,function(c){if(R===clearTimeout)return clearTimeout(c);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(c);try{R(c)}catch{try{return R.call(null,c)}catch{return R.call(this,c)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function d(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];f.push(new $(t,i)),f.length!==1||P||l(p)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[119],Ae([1,0,9,6]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=void 0;function C(k){const b=k;return b?typeof b.read=="function":!1}e.$sc=C;function L(k){const b=k;return b?[b.on,b.pause,b.resume,b.destroy].every(n=>typeof n=="function"):!1}e.$tc=L;function A(k){const b=k;return b?L(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.$uc=A;function l(k,b){return new I(k,b)}e.$vc=l;class I{constructor(b,n){this.e=b,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(n=>n(b))}h(b){this.c.error.length===0?(0,y.$Y)(b):this.c.error.slice(0).forEach(n=>n(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,n){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(b,n){if(this.a.destroyed)return;let a;switch(b){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const r=a.indexOf(n);r>=0&&a.splice(r,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(k,b){const n=[];let a;for(;(a=k.read())!==null;)n.push(a);return b(n)}e.$wc=f;function P(k,b,n){const a=[];let r;for(;(r=k.read())!==null&&a.length<n;)a.push(r);return r===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const o=r;return r=void 0,o}return k.read()}}}e.$xc=P;function S(k,b){return new Promise((n,a)=>{const r=[];u(k,{onData:o=>{b&&r.push(o)},onError:o=>{b?a(o):n(void 0)},onEnd:()=>{n(b?b(r):void 0)}})})}e.$yc=S;function u(k,b,n){k.on("error",a=>{n?.isCancellationRequested||b.onError(a)}),k.on("end",()=>{n?.isCancellationRequested||b.onEnd()}),k.on("data",a=>{n?.isCancellationRequested||b.onData(a)})}e.$zc=u;function p(k,b){return new Promise((n,a)=>{const r=new R.$lb,o=[],w=D=>{if(o.push(D),o.length>b)return r.dispose(),k.pause(),n({stream:k,buffer:o,ended:!1})},v=D=>(r.dispose(),a(D)),E=()=>(r.dispose(),n({stream:k,buffer:o,ended:!0}));r.add((0,R.$kb)(()=>k.removeListener("error",v))),k.on("error",v),r.add((0,R.$kb)(()=>k.removeListener("end",E))),k.on("end",E),r.add((0,R.$kb)(()=>k.removeListener("data",w))),k.on("data",w)})}e.$Ac=p;function $(k,b){const n=l(b);return n.end(k),n}e.$Bc=$;function d(){const k=l(()=>{throw new Error("not supported")});return k.end(),k}e.$Cc=d;function t(k){let b=!1;return{read:()=>b?null:(b=!0,k)}}e.$Dc=t;function i(k,b,n){const a=l(n);return u(k,{onData:r=>a.write(b.data(r)),onError:r=>a.error(b.error?b.error(r):r),onEnd:()=>a.end()}),a}e.$Ec=i;function c(k,b,n){let a=!1;return{read:()=>{const r=b.read();return a?r:(a=!0,r!==null?n([k,r]):k)}}}e.$Fc=c;function m(k,b,n){let a=!1;const r=l(n);return u(b,{onData:o=>a?r.write(o):(a=!0,r.write(n([k,o]))),onError:o=>r.error(o),onEnd:()=>{a||(a=!0,r.write(k)),r.end()}}),r}e.$Gc=m}),define(Pe[25],Ae([1,0,65,119]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const C=typeof Buffer<"u",L=new y.$T(()=>new Uint8Array(256));let A,l;class I{static alloc(g){return C?new I(Buffer.allocUnsafe(g)):new I(new Uint8Array(g))}static wrap(g){return C&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new I(g)}static fromString(g,M){return!(M?.dontUseNodeBuffer||!1)&&C?new I(Buffer.from(g)):(A||(A=new TextEncoder),new I(A.encode(g)))}static fromByteArray(g){const M=I.alloc(g.length);for(let W=0,V=g.length;W<V;W++)M.buffer[W]=g[W];return M}static concat(g,M){if(typeof M>"u"){M=0;for(let B=0,j=g.length;B<j;B++)M+=g[B].byteLength}const W=I.alloc(M);let V=0;for(let B=0,j=g.length;B<j;B++){const U=g[B];W.set(U,V),V+=U.byteLength}return W}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=I.alloc(this.byteLength);return g.set(this),g}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(g,M){return new I(this.buffer.subarray(g,M))}set(g,M){if(g instanceof I)this.buffer.set(g.buffer,M);else if(g instanceof Uint8Array)this.buffer.set(g,M);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),M);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return u(this.buffer,g)}writeUInt32BE(g,M){p(this.buffer,g,M)}readUInt32LE(g){return $(this.buffer,g)}writeUInt32LE(g,M){d(this.buffer,g,M)}readUInt8(g){return t(this.buffer,g)}writeUInt8(g,M){i(this.buffer,g,M)}indexOf(g,M=0){return f(this.buffer,g instanceof I?g.buffer:g,M)}}e.$Hc=I;function f(h,g,M=0){const W=g.byteLength,V=h.byteLength;if(W===0)return 0;if(W===1)return h.indexOf(g[0]);if(W>V-M)return-1;const B=L.value;B.fill(g.length);for(let ie=0;ie<g.length;ie++)B[g[ie]]=g.length-ie-1;let j=M+g.length-1,U=j,z=-1;for(;j<V;)if(h[j]===g[U]){if(U===0){z=j;break}j--,U--}else j+=Math.max(g.length-U,B[h[j]]),U=g.length-1;return z}e.$Ic=f;function P(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0}e.$Jc=P;function S(h,g,M){h[M+0]=g&255,g=g>>>8,h[M+1]=g&255}e.$Kc=S;function u(h,g){return h[g]*2**24+h[g+1]*2**16+h[g+2]*2**8+h[g+3]}e.$Lc=u;function p(h,g,M){h[M+3]=g,g=g>>>8,h[M+2]=g,g=g>>>8,h[M+1]=g,g=g>>>8,h[M]=g}e.$Mc=p;function $(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0|h[g+2]<<16>>>0|h[g+3]<<24>>>0}e.$Nc=$;function d(h,g,M){h[M+0]=g&255,g=g>>>8,h[M+1]=g&255,g=g>>>8,h[M+2]=g&255,g=g>>>8,h[M+3]=g&255}e.$Oc=d;function t(h,g){return h[g]}e.$Pc=t;function i(h,g,M){h[M]=g}e.$Qc=i;function c(h){return R.$wc(h,g=>I.concat(g))}e.$Rc=c;function m(h){return R.$Dc(h)}e.$Sc=m;function k(h){return R.$yc(h,g=>I.concat(g))}e.$Tc=k;async function b(h){return h.ended?I.concat(h.buffer):I.concat([...h.buffer,await k(h.stream)])}e.$Uc=b;function n(h){return R.$Bc(h,g=>I.concat(g))}e.$Vc=n;function a(h){return R.$Ec(h,{data:g=>typeof g=="string"?I.fromString(g):I.wrap(g)},g=>I.concat(g))}e.$Wc=a;function r(h){return R.$vc(g=>I.concat(g),h)}e.$Xc=r;function o(h,g){return R.$Fc(h,g,M=>I.concat(M))}e.$Yc=o;function w(h,g){return R.$Gc(h,g,M=>I.concat(M))}e.$Zc=w;function v(h){let g=0,M=0,W=0;const V=new Uint8Array(Math.floor(h.length/4*3)),B=U=>{switch(M){case 3:V[W++]=g|U,M=0;break;case 2:V[W++]=g|U>>>2,g=U<<6,M=3;break;case 1:V[W++]=g|U>>>4,g=U<<4,M=2;break;default:g=U<<2,M=1}};for(let U=0;U<h.length;U++){const z=h.charCodeAt(U);if(z>=65&&z<=90)B(z-65);else if(z>=97&&z<=122)B(z-97+26);else if(z>=48&&z<=57)B(z-48+52);else if(z===43||z===45)B(62);else if(z===47||z===95)B(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${h[U]}`)}}const j=W;for(;M>0;)B(0);return I.wrap(V).slice(0,j)}e.$1c=v;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:h},g=!0,M=!1){const W=M?D:E;let V="";const B=h.byteLength%3;let j=0;for(;j<h.byteLength-B;j+=3){const U=h[j+0],z=h[j+1],ie=h[j+2];V+=W[U>>>2],V+=W[(U<<4|z>>>4)&63],V+=W[(z<<2|ie>>>6)&63],V+=W[ie&63]}if(B===1){const U=h[j+0];V+=W[U>>>2],V+=W[U<<4&63],g&&(V+="==")}else if(B===2){const U=h[j+0],z=h[j+1];V+=W[U>>>2],V+=W[(U<<4|z>>>4)&63],V+=W[z<<2&63],g&&(V+="=")}return V}e.$2c=s}),define(Pe[120],Ae([1,0,28,15]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.FuzzyScore=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.or=void 0;function C(...se){return function(ne,me){for(let Ce=0,F=se.length;Ce<F;Ce++){const q=se[Ce](ne,me);if(q)return q}return null}}e.or=C,e.$vj=L.bind(void 0,!1),e.$wj=L.bind(void 0,!0);function L(se,ne,me){if(!me||me.length<ne.length)return null;let Ce;return se?Ce=R.$Pd(me,ne):Ce=me.indexOf(ne)===0,Ce?ne.length>0?[{start:0,end:ne.length}]:[]:null}function A(se,ne){const me=ne.toLowerCase().indexOf(se.toLowerCase());return me===-1?null:[{start:me,end:me+se.length}]}e.$xj=A;function l(se,ne){return I(se.toLowerCase(),ne.toLowerCase(),0,0)}e.$yj=l;function I(se,ne,me,Ce){if(me===se.length)return[];if(Ce===ne.length)return null;if(se[me]===ne[Ce]){let F=null;return(F=I(se,ne,me+1,Ce+1))?i({start:Ce,end:Ce+1},F):null}return I(se,ne,me,Ce+1)}function f(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$zj=P;function S(se){return 48<=se&&se<=57}function u(se){return se===32||se===9||se===10||se===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>p.add(se.charCodeAt(0)));function $(se){return u(se)||p.has(se)}function d(se,ne){return se===ne||$(se)&&$(ne)}function t(se){return f(se)||P(se)||S(se)}function i(se,ne){return ne.length===0?ne=[se]:se.end===ne[0].start?ne[0].start=se.start:ne.unshift(se),ne}function c(se,ne){for(let me=ne;me<se.length;me++){const Ce=se.charCodeAt(me);if(P(Ce)||S(Ce)||me>0&&!t(se.charCodeAt(me-1)))return me}return se.length}function m(se,ne,me,Ce){if(me===se.length)return[];if(Ce===ne.length)return null;if(se[me]!==ne[Ce].toLowerCase())return null;{let F=null,q=Ce+1;for(F=m(se,ne,me+1,Ce+1);!F&&(q=c(ne,q))<ne.length;)F=m(se,ne,me+1,q),q++;return F===null?null:i({start:Ce,end:Ce+1},F)}}function k(se){let ne=0,me=0,Ce=0,F=0,q=0;for(let ce=0;ce<se.length;ce++)q=se.charCodeAt(ce),P(q)&&ne++,f(q)&&me++,t(q)&&Ce++,S(q)&&F++;const H=ne/se.length,Q=me/se.length,K=Ce/se.length,ee=F/se.length;return{upperPercent:H,lowerPercent:Q,alphaPercent:K,numericPercent:ee}}function b(se){const{upperPercent:ne,lowerPercent:me}=se;return me===0&&ne>.6}function n(se){const{upperPercent:ne,lowerPercent:me,alphaPercent:Ce,numericPercent:F}=se;return me>.2&&ne<.8&&Ce>.6&&F<.2}function a(se){let ne=0,me=0,Ce=0,F=0;for(let q=0;q<se.length;q++)Ce=se.charCodeAt(q),P(Ce)&&ne++,f(Ce)&&me++,u(Ce)&&F++;return(ne===0||me===0)&&F===0?se.length<=30:ne<=5}function r(se,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!a(se)||ne.length>60)return null;const me=k(ne);if(!n(me)){if(!b(me))return null;ne=ne.toLowerCase()}let Ce=null,F=0;for(se=se.toLowerCase();F<ne.length&&(Ce=m(se,ne,0,F))===null;)F=c(ne,F+1);return Ce}e.$Aj=r;function o(se,ne,me=!1){if(!ne||ne.length===0)return null;let Ce=null,F=0;for(se=se.toLowerCase(),ne=ne.toLowerCase();F<ne.length&&(Ce=w(se,ne,0,F,me))===null;)F=v(ne,F+1);return Ce}e.$Bj=o;function w(se,ne,me,Ce,F){if(me===se.length)return[];if(Ce===ne.length)return null;if(d(se.charCodeAt(me),ne.charCodeAt(Ce))){let q=null,H=Ce+1;if(q=w(se,ne,me+1,Ce+1,F),!F)for(;!q&&(H=v(ne,H))<ne.length;)q=w(se,ne,me+1,H,F),H++;return q?se.charCodeAt(me)!==ne.charCodeAt(Ce)?q:i({start:Ce,end:Ce+1},q):null}else return null}function v(se,ne){for(let me=ne;me<se.length;me++)if($(se.charCodeAt(me))||me>0&&$(se.charCodeAt(me-1)))return me;return se.length}const E=C(e.$wj,r,A),D=C(e.$wj,r,l),s=new y.$Ai(1e4);function h(se,ne,me=!1){if(typeof se!="string"||typeof ne!="string")return null;let Ce=s.get(se);Ce||(Ce=new RegExp(R.$yd(se),"i"),s.set(se,Ce));const F=Ce.exec(ne);return F?[{start:F.index,end:F.index+F[0].length}]:me?D(se,ne):E(se,ne)}e.$Cj=h;function g(se,ne){const me=he(se,se.toLowerCase(),0,ne,ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?W(me):null}e.$Dj=g;function M(se,ne,me,Ce,F,q){const H=Math.min(13,se.length);for(;me<H;me++){const Q=he(se,ne,me,Ce,F,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,q]}e.$Ej=M;function W(se){if(typeof se>"u")return[];const ne=[],me=se[1];for(let Ce=se.length-1;Ce>1;Ce--){const F=se[Ce]+me,q=ne[ne.length-1];q&&q.end===F?q.end=F+1:ne.push({start:F,end:F+1})}return ne}e.$Fj=W;const V=128;function B(){const se=[],ne=[];for(let me=0;me<=V;me++)ne[me]=0;for(let me=0;me<=V;me++)se.push(ne.slice(0));return se}function j(se){const ne=[];for(let me=0;me<=se;me++)ne[me]=0;return ne}const U=j(2*V),z=j(2*V),ie=B(),X=B(),ye=B(),De=!1;function Re(se,ne,me,Ce,F){function q(Q,K,ee=" "){for(;Q.length<K;)Q=ee+Q;return Q}let H=` |   |${Ce.split("").map(Q=>q(Q,3)).join("|")}
`;for(let Q=0;Q<=me;Q++)Q===0?H+=" |":H+=`${ne[Q-1]}|`,H+=se[Q].slice(0,F+1).map(K=>q(K.toString(),3)).join("|")+`
`;return H}function Y(se,ne,me,Ce){se=se.substr(ne),me=me.substr(Ce),console.log(Re(X,se,se.length,me,me.length)),console.log(Re(ye,se,se.length,me,me.length)),console.log(Re(ie,se,se.length,me,me.length))}function le(se,ne){if(ne<0||ne>=se.length)return!1;const me=se.codePointAt(ne);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$8d(me)}}function we(se,ne){if(ne<0||ne>=se.length)return!1;switch(se.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function ae(se,ne,me){return ne[se]!==me[se]}function x(se,ne,me,Ce,F,q,H=!1){for(;ne<me&&F<q;)se[ne]===Ce[F]&&(H&&(U[ne]=F),ne+=1),F+=1;return ne===me}e.$Gj=x;var ue;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ue||(ue={}));var O;(function(se){se.Default=[-100,0];function ne(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}se.isDefault=ne})(O||(e.FuzzyScore=O={}));class J{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ne,me){this.firstMatchCanBeWeak=ne,this.boostFullMatch=me}}e.$Hj=J;function he(se,ne,me,Ce,F,q,H=J.default){const Q=se.length>V?V:se.length,K=Ce.length>V?V:Ce.length;if(me>=Q||q>=K||Q-me>K-q||!x(ne,me,Q,F,q,K,!0))return;Ee(Q,K,me,q,ne,F);let ee=1,ce=1,ze=me,Ue=q;const Qe=[!1];for(ee=1,ze=me;ze<Q;ee++,ze++){const it=U[ze],tt=z[ze],Ne=ze+1<Q?z[ze+1]:K;for(ce=it-q+1,Ue=it;Ue<Ne;ce++,Ue++){let st=Number.MIN_SAFE_INTEGER,_=!1;Ue<=tt&&(st=ve(se,ne,ze,me,Ce,F,Ue,K,q,ie[ee-1][ce-1]===0,Qe));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,Z=st+X[ee-1][ce-1]);const $e=Ue>it,je=$e?X[ee][ce-1]+(ie[ee][ce-1]>0?-5:0):0,Oe=Ue>it+1&&ie[ee][ce-1]>0,Ze=Oe?X[ee][ce-2]+(ie[ee][ce-2]>0?-5:0):0;if(Oe&&(!$e||Ze>=je)&&(!_||Ze>=Z))X[ee][ce]=Ze,ye[ee][ce]=3,ie[ee][ce]=0;else if($e&&(!_||je>=Z))X[ee][ce]=je,ye[ee][ce]=2,ie[ee][ce]=0;else if(_)X[ee][ce]=Z,ye[ee][ce]=1,ie[ee][ce]=ie[ee-1][ce-1]+1;else throw new Error("not possible")}}if(De&&Y(se,me,Ce,q),!Qe[0]&&!H.firstMatchCanBeWeak)return;ee--,ce--;const He=[X[ee][ce],q];let et=0,Xe=0;for(;ee>=1;){let it=ce;do{const tt=ye[ee][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&ne[me+ee-1]===F[q+ce-1]&&!ae(it+q-1,Ce,F)&&et+1>ie[ee][it]&&(it=ce),it===ce?et++:et=1,Xe||(Xe=it),ee--,ce=it-1,He.push(ce)}K===Q&&H.boostFullMatch&&(He[0]+=2);const _e=Xe-Q;return He[0]-=_e,He}e.$Ij=he;function Ee(se,ne,me,Ce,F,q){let H=se-1,Q=ne-1;for(;H>=me&&Q>=Ce;)F[H]===q[Q]&&(z[H]=Q,H--),Q--}function ve(se,ne,me,Ce,F,q,H,Q,K,ee,ce){if(ne[me]!==q[H])return Number.MIN_SAFE_INTEGER;let ze=1,Ue=!1;return H===me-Ce?ze=se[me]===F[H]?7:5:ae(H,F,q)&&(H===0||!ae(H-1,F,q))?(ze=se[me]===F[H]?7:5,Ue=!0):le(q,H)&&(H===0||!le(q,H-1))?ze=5:(le(q,H-1)||we(q,H-1))&&(ze=5,Ue=!0),ze>1&&me===Ce&&(ce[0]=!0),Ue||(Ue=ae(H,F,q)||le(q,H-1)||we(q,H-1)),me===Ce?H>K&&(ze-=Ue?3:5):ee?ze+=Ue?2:0:ze+=Ue?0:1,H+1===Q&&(ze-=Ue?3:5),ze}function be(se,ne,me,Ce,F,q,H){return oe(se,ne,me,Ce,F,q,!0,H)}e.$Jj=be;function ke(se,ne,me,Ce,F,q,H){return oe(se,ne,me,Ce,F,q,!1,H)}e.$Kj=ke;function oe(se,ne,me,Ce,F,q,H,Q){let K=he(se,ne,me,Ce,F,q,Q);if(K&&!H)return K;if(se.length>=3){const ee=Math.min(7,se.length-1);for(let ce=me+1;ce<ee;ce++){const ze=de(se,ce);if(ze){const Ue=he(ze,ze.toLowerCase(),me,Ce,F,q,Q);Ue&&(Ue[0]-=3,(!K||Ue[0]>K[0])&&(K=Ue))}}}return K}function de(se,ne){if(ne+1>=se.length)return;const me=se[ne],Ce=se[ne+1];if(me!==Ce)return se.slice(0,ne)+Ce+me+se.slice(ne+2)}}),define(Pe[29],Ae([1,0,15]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const L="error",A="warning",l="warn",I="info",f="ignore";function P(u){return u?y.$Od(L,u)?C.Error:y.$Od(A,u)||y.$Od(l,u)?C.Warning:y.$Od(I,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function S(u){switch(u){case C.Error:return L;case C.Warning:return A;case C.Info:return I;default:return f}}C.toString=S}(R||(R={})),e.default=R}),define(Pe[121],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=void 0,e.$ec=Symbol("MicrotaskDelay")}),define(Pe[48],Ae([1,0,18,15]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const $=p.charCodeAt(0),d=this.b.charCodeAt(this.c);return $-d}value(){return this.b[this.c]}}e.$Bh=C;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,R.$Id)(p,this.b,0,p.length,this.c,this.d):(0,R.$Kd)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ch=L;class A{constructor(p=!0,$=!0){this.f=p,this.g=$}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let $=p.length-1;$>=0;$--,this.c--){const d=this.b.charCodeAt($);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,R.$Id)(p,this.b,0,p.length,this.d,this.e):(0,R.$Kd)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Dh=A;var l;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(l||(l={}));class I{constructor(p,$){this.f=p,this.g=$,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,R.$Jd)(p,this.c.scheme);if(this.d[this.e]===2)return(0,R.$Jd)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,R.$Hd)(p,this.c.query);if(this.d[this.e]===5)return(0,R.$Hd)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Eh=I;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class S{static forUris(p=()=>!1,$=()=>!1){return new S(new I(p,$))}static forPaths(p=!1){return new S(new A(void 0,!p))}static forStrings(){return new S(new C)}static forConfigKeys(){return new S(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,$){if($){const d=$.slice(0);(0,y.$Qf)(d);for(const t of d)this.set(t,p)}else{const d=p.slice(0);(0,y.$Qf)(d);for(const t of d)this.set(t[0],t[1])}}set(p,$){const d=this.b.reset(p);let t;this.c||(this.c=new f,this.c.segment=d.value());const i=[];for(t=this.c;;){const m=d.cmp(t.segment);if(m>0)t.left||(t.left=new f,t.left.segment=d.value()),i.push([-1,t]),t=t.left;else if(m<0)t.right||(t.right=new f,t.right.segment=d.value()),i.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new f,t.mid.segment=d.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=$,t.key=p;for(let m=i.length-1;m>=0;m--){const k=i[m][1];k.updateHeight();const b=k.balanceFactor();if(b<-1||b>1){const n=i[m][0],a=i[m+1][0];if(n===1&&a===1)i[m][1]=k.rotateLeft();else if(n===-1&&a===-1)i[m][1]=k.rotateRight();else if(n===1&&a===-1)k.right=i[m+1][1]=i[m+1][1].rotateRight(),i[m][1]=k.rotateLeft();else if(n===-1&&a===1)k.left=i[m+1][1]=i[m+1][1].rotateLeft(),i[m][1]=k.rotateRight();else throw new Error;if(m>0)switch(i[m-1][0]){case-1:i[m-1][1].left=i[m][1];break;case 1:i[m-1][1].right=i[m][1];break;case 0:i[m-1][1].mid=i[m][1];break}else this.c=i[0][1]}}return c}get(p){return this.d(p)?.value}d(p){const $=this.b.reset(p);let d=this.c;for(;d;){const t=$.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if($.hasNext())$.next(),d=d.mid;else break}return d}has(p){const $=this.d(p);return!($?.value===void 0&&$?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,$){const d=this.b.reset(p),t=[];let i=this.c;for(;i;){const c=d.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(d.hasNext())d.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:m,value:k,segment:b}=c;this.e(c.key,!1),i.key=m,i.value=k,i.segment=b}}else{const c=i.left??i.right;if(t.length>0){const[m,k]=t[t.length-1];switch(m){case-1:k.left=c;break;case 0:k.mid=c;break;case 1:k.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const m=t[c][1];m.updateHeight();const k=m.balanceFactor();if(k>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),t[c][1]=m.rotateLeft()):k<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),t[c][1]=m.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const $=this.b.reset(p);let d=this.c,t;for(;d;){const i=$.cmp(d.segment);if(i>0)d=d.left;else if(i<0)d=d.right;else if($.hasNext())$.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(p){return this.g(p,!1)}g(p,$){const d=this.b.reset(p);let t=this.c;for(;t;){const i=d.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[$,d]of this)p(d,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const $=[];return this.j(p,$),$[Symbol.iterator]()}j(p,$){p&&(p.left&&this.j(p.left,$),p.value&&$.push([p.key,p.value]),p.mid&&this.j(p.mid,$),p.right&&this.j(p.right,$))}_isBalanced(){const p=$=>{if(!$)return!0;const d=$.balanceFactor();return d<-1||d>1?!1:p($.left)&&p($.right)};return p(this.c)}}e.$Fh=S}),define(Pe[40],Ae([1,0,89]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Oj=e.ThemeColor=void 0;var R;(function(A){function l(I){return I&&typeof I=="object"&&typeof I.id=="string"}A.isThemeColor=l})(R||(e.ThemeColor=R={}));function C(A){return{id:A}}e.$Oj=C;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function I(c){const m=l.exec(c.id);if(!m)return I(y.$Nj.error);const[,k,b]=m,n=["codicon","codicon-"+k];return b&&n.push("codicon-modifier-"+b.substring(1)),n}A.asClassNameArray=I;function f(c){return I(c).join(" ")}A.asClassName=f;function P(c){return"."+I(c).join(".")}A.asCSSSelector=P;function S(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||R.isThemeColor(c.color))}A.isThemeIcon=S;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(c){const m=u.exec(c);if(!m)return;const[,k]=m;return{id:k}}A.fromString=p;function $(c){return{id:c}}A.fromId=$;function d(c,m){let k=c.id;const b=k.lastIndexOf("~");return b!==-1&&(k=k.substring(0,b)),m&&(k=`${k}~${m}`),{id:k}}A.modify=d;function t(c){const m=c.id.lastIndexOf("~");if(m!==-1)return c.id.substring(m+1)}A.getModifier=t;function i(c,m){return c.id===m.id&&c.color?.id===m.color?.id}A.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Pe[122],Ae([1,0,120,15,40]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=void 0;const L="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function I(i){return i.replace(l,(c,m)=>m?c:`\\${c}`)}e.$Pj=I;const f=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace(f,c=>`\\${c}`)}e.$Qj=P;const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(L)===-1?i:i.replace(S,(c,m,k,b)=>k?c:m||b||"")}e.$Rj=u;function p(i){return i?i.replace(/\$\((.*?)\)/g,(c,m)=>` ${m} `).trim():""}e.$Sj=p;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(i){$.lastIndex=0;let c="";const m=[];let k=0;for(;;){const b=$.lastIndex,n=$.exec(i),a=i.substring(b,n?.index);if(a.length>0){c+=a;for(let r=0;r<a.length;r++)m.push(k)}if(!n)break;k+=n[0].length}return{text:c,iconOffsets:m}}e.$Tj=d;function t(i,c,m=!1){const{text:k,iconOffsets:b}=c;if(!b||b.length===0)return(0,y.$Cj)(i,k,m);const n=(0,R.$wd)(k," "),a=k.length-n.length,r=(0,y.$Cj)(i,n,m);if(r)for(const o of r){const w=b[o.start+a]+a;o.start+=w,o.end+=w}return r}e.$Uj=t}),define(Pe[36],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(C){return y.test(C)}e.$5e=R,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let I=0;I<l.length;I++)l[I]=Math.floor(Math.random()*256);return l};const L=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let I=0,f="";return f+=A[L[I++]],f+=A[L[I++]],f+=A[L[I++]],f+=A[L[I++]],f+="-",f+=A[L[I++]],f+=A[L[I++]],f+="-",f+=A[L[I++]],f+=A[L[I++]],f+="-",f+=A[L[I++]],f+=A[L[I++]],f+="-",f+=A[L[I++]],f+=A[L[I++]],f+=A[L[I++]],f+=A[L[I++]],f+=A[L[I++]],f+=A[L[I++]],f}}()}),define(Pe[123],Ae([1,0,18,66,36]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=e.$Ns=e.$Ms=void 0;function L(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$Ms=L;function A(S,u,p){const $={id:(0,C.$6e)(),name:S,uri:u,data:p};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Ns=A;class l{constructor(){this.a=new Map}get size(){let u=0;for(const p of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const p=[...this.a.keys()];return R.Iterable.some(this,([$,d])=>d.asFile())&&p.push("files"),P(I(u),p)}get(u){return this.a.get(this.b(u))?.[0]}append(u,p){const $=this.a.get(u);$?$.push(p):this.a.set(this.b(u),[p])}replace(u,p){this.a.set(this.b(u),[p])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,p]of this.a)for(const $ of p)yield[u,$]}b(u){return I(u)}}e.$Os=l;function I(S){return S.toLowerCase()}function f(S,u){return P(I(S),u.map(I))}e.$Ps=f;function P(S,u){if(S==="*/*")return u.length>0;if(u.includes(S))return!0;const p=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[$,d,t]=p;return t==="*"?u.some(i=>i.startsWith(d+"/")):!1}e.$Qs=Object.freeze({create:S=>(0,y.$Ff)(S.map(u=>u.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$Qs.split(S).filter(u=>!u.startsWith("#"))})}),define(Pe[124],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0,e.$Rr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[125],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class R{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let I=0,f=l.notIn.length;I<f;I++)switch(l.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,I){if(l.getTokenCount()===0)return!0;const f=l.findTokenIndexAtOffset(I-2),P=l.getStandardTokenType(f);return this.isOK(P)}g(l,I){for(let f=l;f<=I;f++){const P=String.fromCharCode(f);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$dt=R;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of l)L(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),L(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),L(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),L(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&L(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$et=C;function L(A,l,I){A.has(l)?A.get(l).push(I):A.set(l,[I])}}),define(Pe[126],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$06=e.$96=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$96=y;class R{constructor(L){this.identifier=L}}e.$06=R}),define(Pe[127],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Pe[128],Ae([1,0,5,6,127]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0;class L extends R.$mb{constructor(u,p="",$="",d=!0,t){super(),this.h=this.B(new y.$hc),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=p,this.u=$,this.w=d,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,p){this.C&&await this.C(u)}}e.$ei=L;class A extends R.$mb{constructor(){super(...arguments),this.f=this.B(new y.$hc),this.onWillRun=this.f.event,this.k=this.B(new y.$hc),this.onDidRun=this.k.event}async run(u,p){if(!u.enabled)return;this.f.fire({action:u});let $;try{await this.l(u,p)}catch(d){$=d}this.k.fire({action:u,error:$})}async l(u,p){await u.run(p)}}e.$fi=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let p=[];for(const $ of u)$.length&&(p.length?p=[...p,new l,...$]:p=$);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$gi=l;class I{get actions(){return this.a}constructor(u,p,$,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=p,this.class=d,this.a=$}async run(){}}e.$hi=I;class f extends L{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,C.localize(0,null),void 0,!1)}}e.$ii=f;function P(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async()=>S.run(),tooltip:S.label}}e.$ji=P}),define(Pe[129],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Pe[130],Ae([1,0,129]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0;const R=60,C=R*60,L=C*24,A=L*7,l=L*30,I=L*365;function f(S,u,p,$){typeof S!="number"&&(S=S.getTime());const d=Math.round((new Date().getTime()-S)/1e3);if(d<-30)return(0,y.localize)(0,null,f(new Date().getTime()+d*1e3,!1));if(!$&&d<30)return(0,y.localize)(1,null);let t;return d<R?(t=d,u?t===1?p?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):p?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?p?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):p?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):d<C?(t=Math.floor(d/R),u?t===1?p?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):p?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?p?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):p?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):d<L?(t=Math.floor(d/C),u?t===1?p?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):p?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?p?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):p?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):d<A?(t=Math.floor(d/L),u?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):d<l?(t=Math.floor(d/A),u?t===1?p?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):p?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?p?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):p?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):d<I?(t=Math.floor(d/l),u?t===1?p?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):p?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?p?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):p?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(d/I),u?t===1?p?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):p?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?p?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):p?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$4l=f;function P(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$5l=P}),define(Pe[131],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Pe[41],Ae([1,0,18,16,131]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=void 0;function L(S,u){return u&&(S.stack||S.stacktrace)?C.localize(0,null,l(S),A(S.stack)||A(S.stacktrace)):l(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function l(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(1,null,S.message):S.message||C.localize(2,null)}function I(S=null,u=!1){if(!S)return C.localize(3,null);if(Array.isArray(S)){const p=y.$Af(S),$=I(p[0],u);return p.length>1?C.localize(4,null,$,p.length):$}if(R.$le(S))return S;if(S.detail){const p=S.detail;if(p.error)return L(p.error,u);if(p.exception)return L(p.exception,u)}return S.stack?L(S,u):S.message?S.message:C.localize(5,null)}e.$ki=I;function f(S){const u=S;return u instanceof Error&&Array.isArray(u.actions)}e.$li=f;function P(S,u){let p;return typeof S=="string"?p=new Error(S):p=S,p.actions=u,p}e.$mi=P}),define(Pe[132],Ae([1,0,65,19]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=void 0;const C=new y.$T(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),L=new y.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(D,s,h=!1){const g=D||"",M=s||"",W=C.value.collator.compare(g,M);return C.value.collatorIsNumeric&&W===0&&g!==M?g<M?-1:1:W}e.$7p=l;function I(D,s){const h=L.value.collator;return D=D||"",s=s||"",k(h,D,s)}e.$8p=I;function f(D,s){const h=L.value.collator;return D=D||"",s=s||"",r(D,s)||k(h,D,s)}e.$9p=f;function P(D,s){const h=L.value.collator;return D=D||"",s=s||"",a(D,s)||k(h,D,s)}e.$0p=P;function S(D,s){return D=D||"",s=s||"",D===s?0:D<s?-1:1}e.$$p=S;function u(D,s){const[h,g]=c(D),[M,W]=c(s);let V=C.value.collator.compare(g,W);if(V===0){if(C.value.collatorIsNumeric&&g!==W)return g<W?-1:1;if(V=C.value.collator.compare(h,M),C.value.collatorIsNumeric&&V===0&&h!==M)return h<M?-1:1}return V}e.$_p=u;function p(D,s){D=D||"",s=s||"";const h=m(D),g=m(s),M=L.value.collator,W=A.value.collator;return k(W,h,g)||k(M,D,s)}e.$aq=p;function $(D,s){D=D||"",s=s||"";const h=m(D),g=m(s),M=L.value.collator,W=A.value.collator;return k(W,h,g)||r(D,s)||k(M,D,s)}e.$bq=$;function d(D,s){D=D||"",s=s||"";const h=m(D),g=m(s),M=L.value.collator,W=A.value.collator;return k(W,h,g)||a(D,s)||k(M,D,s)}e.$cq=d;function t(D,s){D=D||"",s=s||"";const h=m(D).toLowerCase(),g=m(s).toLowerCase();return h!==g?h<g?-1:1:D!==s?D<s?-1:1:0}e.$dq=t;const i=/^(.*?)(\.([^.]*))?$/;function c(D,s=!1){const h=D?i.exec(D):[];let g=[h&&h[1]||"",h&&h[3]||""];return s&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function m(D){const s=D?i.exec(D):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function k(D,s,h){const g=D.compare(s,h);return g!==0?g:s.length!==h.length?s.length<h.length?-1:1:0}function b(D){const s=D.charAt(0);return s.toLocaleUpperCase()!==s}function n(D){const s=D.charAt(0);return s.toLocaleLowerCase()!==s}function a(D,s){return b(D)&&n(s)?-1:n(D)&&b(s)?1:0}function r(D,s){return n(D)&&b(s)?-1:b(D)&&n(s)?1:0}function o(D,s,h=!1){return h||(D=D&&D.toLowerCase(),s=s&&s.toLowerCase()),D===s?0:D<s?-1:1}function w(D,s,h=!1){const g=D.split(R.sep),M=s.split(R.sep),W=g.length-1,V=M.length-1;let B,j;for(let U=0;;U++){if(B=W===U,j=V===U,B&&j)return l(g[U],M[U],h);if(B)return-1;if(j)return 1;const z=o(g[U],M[U],h);if(z!==0)return z}}e.$eq=w;function v(D,s,h){const g=D.toLowerCase(),M=s.toLowerCase(),W=E(D,s,h);if(W)return W;const V=g.endsWith(h),B=M.endsWith(h);if(V!==B)return V?-1:1;const j=l(g,M);return j!==0?j:g.localeCompare(M)}e.$fq=v;function E(D,s,h){const g=D.toLowerCase(),M=s.toLowerCase(),W=g.startsWith(h),V=M.startsWith(h);if(W!==V)return W?-1:1;if(W&&V){if(g.length<M.length)return-1;if(g.length>M.length)return 1}return 0}e.$gq=E}),define(Pe[42],Ae([1,0,19,22,15,16]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function A(v){return v===47||v===92}e.$De=A;function l(v){return v.replace(/[\\/]/g,y.$8c.sep)}e.$Ee=l;function I(v){return v.indexOf("/")===-1&&(v=l(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}e.$Fe=I;function f(v,E=y.$8c.sep){if(!v)return"";const D=v.length,s=v.charCodeAt(0);if(A(s)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let g=3;const M=g;for(;g<D&&!A(v.charCodeAt(g));g++);if(M!==g&&!A(v.charCodeAt(g+1))){for(g+=1;g<D;g++)if(A(v.charCodeAt(g)))return v.slice(0,g+1).replace(/[\\/]/g,E)}}return E}else if(i(s)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+E:v.slice(0,2);let h=v.indexOf("://");if(h!==-1){for(h+=3;h<D;h++)if(A(v.charCodeAt(h)))return v.slice(0,h+1)}return""}e.$Ge=f;function P(v){if(!R.$i||!v||v.length<5)return!1;let E=v.charCodeAt(0);if(E!==92||(E=v.charCodeAt(1),E!==92))return!1;let D=2;const s=D;for(;D<v.length&&(E=v.charCodeAt(D),E!==92);D++);return!(s===D||(E=v.charCodeAt(D+1),isNaN(E)||E===92))}e.$He=P;const S=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(v,E=R.$i){const D=E?S:u;return!(!v||v.length===0||/^\s+$/.test(v)||(D.lastIndex=0,D.test(v))||E&&p.test(v)||v==="."||v===".."||E&&v[v.length-1]==="."||E&&v.length!==v.trim().length||v.length>255)}e.$Ie=$;function d(v,E,D){const s=v===E;return!D||s?s:!v||!E?!1:(0,C.$Od)(v,E)}e.$Je=d;function t(v,E,D,s=y.sep){if(v===E)return!0;if(!v||!E||E.length>v.length)return!1;if(D){if(!(0,C.$Pd)(v,E))return!1;if(E.length===v.length)return!0;let g=E.length;return E.charAt(E.length-1)===s&&g--,v.charAt(g)===s}return E.charAt(E.length-1)!==s&&(E+=s),v.indexOf(E)===0}e.$Ke=t;function i(v){return v>=65&&v<=90||v>=97&&v<=122}e.$Le=i;function c(v,E){return R.$i&&v.endsWith(":")&&(v+=y.sep),(0,y.$0c)(v)||(v=(0,y.$$c)(E,v)),v=(0,y.$9c)(v),R.$i?(v=(0,C.$xd)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,C.$xd)(v,y.sep),v||(v=y.sep)),v}e.$Me=c;function m(v){const E=(0,y.$9c)(v);return R.$i?v.length>3?!1:k(E)&&(v.length===2||E.charCodeAt(2)===92):E===y.$8c.sep}e.$Ne=m;function k(v,E=R.$i){return E?i(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}e.$Oe=k;function b(v,E=R.$i){return k(v,E)?v[0]:void 0}e.$Pe=b;function n(v,E,D){return E.length>v.length?-1:v===E?0:(D&&(v=v.toLowerCase(),E=E.toLowerCase()),v.indexOf(E))}e.$Qe=n;function a(v){const E=v.split(":");let D,s,h;for(const g of E){const M=Number(g);(0,L.$pe)(M)?s===void 0?s=M:h===void 0&&(h=M):D=D?[D,g].join(":"):g}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:s!==void 0?s:void 0,column:h!==void 0?h:s!==void 0?1:void 0}}e.$Re=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(v,E,D=8){let s="";for(let g=0;g<D;g++){let M;g===0&&R.$i&&!E&&(D===3||D===4)?M=o:M=r,s+=M.charAt(Math.floor(Math.random()*M.length))}let h;return E?h=`${E}-${s}`:h=s,v?(0,y.$$c)(v,h):h}e.$Se=w}),define(Pe[67],Ae([1,0,19]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0,e.$Er=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const S=(0,y.$dd)(P),u=R[S.toLowerCase()];return u!==void 0?u:A(P)}e.$Fr=L;function A(P){const S=(0,y.$dd)(P);return C[S.toLowerCase()]}e.$Gr=A;function l(P){for(const S in C)if(C[S]===P)return S}e.$Hr=l;const I=/^(.+)\/(.+?)(;.+)?$/;function f(P,S){const u=I.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:S?void 0:P}e.$Ir=f}),define(Pe[68],Ae([1,0,25,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.$8g=e.$7g=void 0;function C(I){return JSON.stringify(I,A)}e.$7g=C;function L(I){let f=JSON.parse(I);return f=l(f),f}e.$8g=L;function A(I,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function l(I,f=0){if(!I||f>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return R.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof y.$Hc||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let P=0;P<I.length;++P)I[P]=l(I[P],f+1);else for(const P in I)Object.hasOwnProperty.call(I,P)&&(I[P]=l(I[P],f+1))}return I}e.$9g=l}),define(Pe[12],Ae([1,0,9,22,2]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var L;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$We="vscode-tkn",e.$Xe="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,S,u){this.a[P]=S,this.b[P]=u}setConnectionToken(P,S){this.c[P]=S}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return y.$Y(t),P}const S=P.authority;let u=this.a[S];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const p=this.b[S],$=this.c[S];let d=`path=${encodeURIComponent(P.path)}`;return typeof $=="string"&&(d+=`&${e.$Xe}=${encodeURIComponent($)}`),C.URI.from({scheme:R.$o?this.d:L.vscodeRemoteResource,authority:`${u}:${p}`,path:this.f,query:d})}}e.$Ye=new A,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(P){const S=this.b(P,pe);return this.uriToBrowserUri(S)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Ye.rewrite(P):P.scheme===L.file&&(R.$m||R.$p&&R.$g.origin===`${L.vscodeFileResource}://${l.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||l.a,query:null,fragment:null}):P}asFileUri(P){const S=this.b(P,pe);return this.uriToFileUri(S)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==l.a?P.authority:null,query:null,fragment:null}):P}b(P,S){return C.URI.isUri(P)?P:C.URI.parse(S.toUrl(P))}}e.$4e=new l;var I;(function(f){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(P.get("3"));const S="vscode-coi";function u($){let d;typeof $=="string"?d=new URL($).searchParams:$ instanceof URL?d=$.searchParams:C.URI.isUri($)&&(d=new URL($.toString(!0)).searchParams);const t=d?.get(S);if(t)return P.get(t)}f.getHeadersFromQuery=u;function p($,d,t){if(!globalThis.crossOriginIsolated)return;const i=d&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(S,i):$[S]=i}f.addSearchParam=p})(I||(e.COI=I={}))}),define(Pe[23],Ae([1,0,42,12,19,22,15,2]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.DataUri=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=void 0;function I(p){return(0,l.$Ve)(p,!0)}e.$7f=I;class f{constructor($){this.a=$}compare($,d,t=!1){return $===d?0:(0,A.$Hd)(this.getComparisonKey($,t),this.getComparisonKey(d,t))}isEqual($,d,t=!1){return $===d?!0:!$||!d?!1:this.getComparisonKey($,t)===this.getComparisonKey(d,t)}getComparisonKey($,d=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,d,t=!1){if($.scheme===d.scheme){if($.scheme===R.Schemas.file)return y.$Ke(I($),I(d),this.a($))&&$.query===d.query&&(t||$.fragment===d.fragment);if((0,e.$lg)($.authority,d.authority))return y.$Ke($.path,d.path,this.a($),"/")&&$.query===d.query&&(t||$.fragment===d.fragment)}return!1}joinPath($,...d){return l.URI.joinPath($,...d)}basenameOrAuthority($){return(0,e.$dg)($)||$.authority}basename($){return C.$8c.basename($.path)}extname($){return C.$8c.extname($.path)}dirname($){if($.path.length===0)return $;let d;return $.scheme===R.Schemas.file?d=l.URI.file(C.$bd(I($))).path:(d=C.$8c.dirname($.path),$.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),d="/")),$.with({path:d})}normalizePath($){if(!$.path.length)return $;let d;return $.scheme===R.Schemas.file?d=l.URI.file(C.$9c(I($))).path:d=C.$8c.normalize($.path),$.with({path:d})}relativePath($,d){if($.scheme!==d.scheme||!(0,e.$lg)($.authority,d.authority))return;if($.scheme===R.Schemas.file){const c=C.$ad(I($),I(d));return L.$i?y.$Ee(c):c}let t=$.path||"/";const i=d.path||"/";if(this.a($)){let c=0;for(const m=Math.min(t.length,i.length);c<m&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return C.$8c.relative(t,i)}resolvePath($,d){if($.scheme===R.Schemas.file){const t=l.URI.file(C.$_c(I($),d));return $.with({authority:t.authority,path:t.path})}return d=y.$Fe(d),$.with({path:C.$8c.resolve($.path,d)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,d){return $===d||$!==void 0&&d!==void 0&&(0,A.$Od)($,d)}hasTrailingPathSeparator($,d=C.sep){if($.scheme===R.Schemas.file){const t=I($);return t.length>y.$Ge(t).length&&t[t.length-1]===d}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,d=C.sep){return(0,e.$mg)($,d)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,d=C.sep){let t=!1;if($.scheme===R.Schemas.file){const i=I($);t=i!==void 0&&i.length===y.$Ge(i).length&&i[i.length-1]===d}else{d="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$mg)($,d)?$.with({path:$.path+"/"}):$}}e.$8f=f,e.$9f=new f(()=>!1),e.$0f=new f(p=>p.scheme===R.Schemas.file?!L.$k:!0),e.$$f=new f(p=>!0),e.$_f=e.$9f.isEqual.bind(e.$9f),e.$ag=e.$9f.isEqualOrParent.bind(e.$9f),e.$bg=e.$9f.getComparisonKey.bind(e.$9f),e.$cg=e.$9f.basenameOrAuthority.bind(e.$9f),e.$dg=e.$9f.basename.bind(e.$9f),e.$eg=e.$9f.extname.bind(e.$9f),e.$fg=e.$9f.dirname.bind(e.$9f),e.$gg=e.$9f.joinPath.bind(e.$9f),e.$hg=e.$9f.normalizePath.bind(e.$9f),e.$ig=e.$9f.relativePath.bind(e.$9f),e.$jg=e.$9f.resolvePath.bind(e.$9f),e.$kg=e.$9f.isAbsolutePath.bind(e.$9f),e.$lg=e.$9f.isEqualAuthority.bind(e.$9f),e.$mg=e.$9f.hasTrailingPathSeparator.bind(e.$9f),e.$ng=e.$9f.removeTrailingPathSeparator.bind(e.$9f),e.$og=e.$9f.addTrailingPathSeparator.bind(e.$9f);function P(p,$){const d=[];for(let t=0;t<p.length;t++){const i=$(p[t]);p.some((c,m)=>m===t?!1:(0,e.$ag)(i,$(c)))||d.push(p[t])}return d}e.$pg=P;var S;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function $(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(m=>{const[k,b]=m.split(":");k&&b&&t.set(k,b)});const c=d.path.substring(0,d.path.indexOf(";"));return c&&t.set(p.META_DATA_MIME,c),t}p.parseMetaData=$})(S||(e.DataUri=S={}));function u(p,$,d){if($){let t=p.path;return t&&t[0]!==C.$8c.sep&&(t=C.$8c.sep+t),p.with({scheme:d,authority:$,path:t})}return p.with({scheme:d})}e.$qg=u}),define(Pe[13],Ae([1,0,21,9,5,6,23,22,121]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.$2g=e.$1g=e.Promises=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function f(O){return!!O&&typeof O.then=="function"}e.$rg=f;function P(O){const J=new y.$rc,he=O(J.token),Ee=new Promise((ve,be)=>{const ke=J.token.onCancellationRequested(()=>{ke.dispose(),J.dispose(),be(new R.$3)});Promise.resolve(he).then(oe=>{ke.dispose(),J.dispose(),ve(oe)},oe=>{ke.dispose(),J.dispose(),be(oe)})});return new class{cancel(){J.cancel()}then(ve,be){return Ee.then(ve,be)}catch(ve){return this.then(void 0,ve)}finally(ve){return Ee.finally(ve)}}}e.$sg=P;function S(O,J,he){return new Promise((Ee,ve)=>{const be=J.onCancellationRequested(()=>{be.dispose(),Ee(he)});O.then(Ee,ve).finally(()=>be.dispose())})}e.$tg=S;function u(O,J){return new Promise((he,Ee)=>{const ve=J.onCancellationRequested(()=>{ve.dispose(),Ee(new R.$3)});O.then(he,Ee).finally(()=>ve.dispose())})}e.$ug=u;async function p(O){let J=-1;const he=O.map((Ee,ve)=>Ee.then(be=>(J=ve,be)));try{return await Promise.race(he)}finally{O.forEach((Ee,ve)=>{ve!==J&&Ee.cancel()})}}e.$vg=p;function $(O,J,he){let Ee;const ve=setTimeout(()=>{Ee?.(void 0),he?.()},J);return Promise.race([O.finally(()=>clearTimeout(ve)),new Promise(be=>Ee=be)])}e.$wg=$;function d(O){return new Promise((J,he)=>{const Ee=O();f(Ee)?Ee.then(J,he):J(Ee)})}e.$xg=d;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=J,!this.b){const he=()=>{if(this.b=null,this.f)return;const Ee=this.queue(this.d);return this.d=null,Ee};this.b=new Promise(Ee=>{this.a.then(he,he).then(Ee)})}return new Promise((he,Ee)=>{this.b.then(he,Ee)})}return this.a=J(),new Promise((he,Ee)=>{this.a.then(ve=>{this.a=null,he(ve)},ve=>{this.a=null,Ee(ve)})})}dispose(){this.f=!0}}e.$yg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$zg=i;class c{constructor(){this.a=new Map}queue(J,he){const ve=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(J)===ve&&this.a.delete(J)});return this.a.set(J,ve),ve}}e.$Ag=c;const m=(O,J)=>{let he=!0;const Ee=setTimeout(()=>{he=!1,J()},O);return{isTriggered:()=>he,dispose:()=>{clearTimeout(Ee),he=!1}}},k=O=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,O())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class b{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,he=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ve,be)=>{this.d=ve,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const Ee=()=>{this.a=null,this.d?.(null)};return this.a=he===I.$ec?k(Ee):m(he,Ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bg=b;class n{constructor(J){this.a=new b(J),this.b=new t}trigger(J,he){return this.a.trigger(()=>this.b.queue(J),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Cg=n;class a{constructor(){this.a=!1,this.b=new Promise((J,he)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dg=a;class r extends a{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Eg=r;function o(O,J){return J?new Promise((he,Ee)=>{const ve=setTimeout(()=>{be.dispose(),he()},O),be=J.onCancellationRequested(()=>{clearTimeout(ve),be.dispose(),Ee(new R.$3)})}):P(he=>o(O,he))}e.$Fg=o;function w(O,J=0){const he=setTimeout(O,J);return(0,L.$kb)(()=>clearTimeout(he))}e.$Gg=w;function v(O){const J=[];let he=0;const Ee=O.length;function ve(){return he<Ee?O[he++]():null}function be(ke){ke!=null&&J.push(ke);const oe=ve();return oe?oe.then(be):Promise.resolve(J)}return Promise.resolve(null).then(be)}e.$Hg=v;function E(O,J=Ee=>!!Ee,he=null){let Ee=0;const ve=O.length,be=()=>{if(Ee>=ve)return Promise.resolve(he);const ke=O[Ee++];return Promise.resolve(ke()).then(de=>J(de)?Promise.resolve(de):be())};return be()}e.$Ig=E;function D(O,J=Ee=>!!Ee,he=null){if(O.length===0)return Promise.resolve(he);let Ee=O.length;const ve=()=>{Ee=-1;for(const be of O)be.cancel?.()};return new Promise((be,ke)=>{for(const oe of O)oe.then(de=>{--Ee>=0&&J(de)?(ve(),be(de)):Ee===0&&be(he)}).catch(de=>{--Ee>=0&&(ve(),ke(de))})})}e.$Jg=D;class s{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new C.$hc}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((he,Ee)=>{this.f.push({factory:J,c:he,e:Ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const he=J.factory();he.then(J.c,J.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Kg=s;class h extends s{constructor(){super(1)}}e.$Lg=h;class g{constructor(){this.a=new ye,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Mg=g;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new Y;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,he=A.$9f){const Ee=he.getComparisonKey(J);let ve=this.a.get(Ee);if(!ve){ve=new h;const be=this.f++,ke=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(Ee),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$ub),this.d.set(be,ke),this.a.set(Ee,ve)}return ve}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ng=M;class W{constructor(J,he){this.a=-1,typeof J=="function"&&typeof he=="number"&&this.setIfNotSet(J,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},he)}setIfNotSet(J,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},he))}}e.$Og=W;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,he){this.cancel(),this.a=setInterval(()=>{J()},he)}}e.$Pg=V;class B{constructor(J,he){this.b=-1,this.a=J,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qg=B;class j{constructor(J,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=J,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rg=j;class U extends B{constructor(J,he){super(J,he),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Sg=U;class z extends L.$mb{constructor(J,he){super(),this.g=J,this.h=he,this.a=[],this.b=this.B(new L.$nb),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of J)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Tg=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ug=O=>{(0,l.$A)(()=>{if(J)return;const he=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$Ug=(O,J)=>{const he=requestIdleCallback(O,typeof J=="number"?{timeout:J}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(he))}}}}();class ie{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.$Ug)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Vg=ie;async function X(O,J,he){let Ee;for(let ve=0;ve<he;ve++)try{return await O()}catch(be){Ee=be,await o(J)}throw Ee}e.$Wg=X;class ye{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,he,Ee){return this.a={taskId:J,cancel:()=>Ee?.(),promise:he},he.then(()=>this.d(J),()=>this.d(J)),he}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{let he,Ee;const ve=new Promise((be,ke)=>{he=be,Ee=ke});this.b={run:J,promise:ve,promiseResolve:he,promiseReject:Ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xg=ye;class De{constructor(J,he=()=>Date.now()){this.d=J,this.f=he,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Yg=De;var Re;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Re||(Re={}));class Y{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,he)=>{this.a=J,this.b=he})}complete(J){return new Promise(he=>{this.a(J),this.d={outcome:0,value:J},he()})}error(J){return new Promise(he=>{this.b(J),this.d={outcome:1,value:J},he()})}cancel(){return this.error(new R.$3)}}e.$Zg=Y;var le;(function(O){async function J(Ee){let ve;const be=await Promise.all(Ee.map(ke=>ke.then(oe=>oe,oe=>{ve||(ve=oe)})));if(typeof ve<"u")throw ve;return be}O.settled=J;function he(Ee){return new Promise(async(ve,be)=>{try{await Ee(ve,be)}catch(ke){be(ke)}})}O.withAsyncBody=he})(le||(e.Promises=le={}));var we;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(we||(we={}));class ae{static fromArray(J){return new ae(he=>{he.emitMany(J)})}static fromPromise(J){return new ae(async he=>{he.emitMany(await J)})}static fromPromises(J){return new ae(async he=>{await Promise.all(J.map(async Ee=>he.emitOne(await Ee)))})}static merge(J){return new ae(async he=>{await Promise.all(J.map(async Ee=>{for await(const ve of Ee)he.emitOne(ve)}))})}static{this.EMPTY=ae.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new C.$hc,queueMicrotask(async()=>{const he={emitOne:Ee=>this.g(Ee),emitMany:Ee=>this.h(Ee),reject:Ee=>this.k(Ee)};try{await Promise.resolve(J(he)),this.j()}catch(Ee){this.k(Ee)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(J,he){return new ae(async Ee=>{for await(const ve of J)Ee.emitOne(he(ve))})}map(J){return ae.map(this,J)}static filter(J,he){return new ae(async Ee=>{for await(const ve of J)he(ve)&&Ee.emitOne(ve)})}filter(J){return ae.filter(this,J)}static coalesce(J){return ae.filter(J,he=>!!he)}coalesce(){return ae.coalesce(this)}static async toPromise(J){const he=[];for await(const Ee of J)he.push(Ee);return he}toPromise(){return ae.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$1g=ae;class x extends ae{constructor(J,he){super(he),this.l=J}cancel(){this.l.cancel()}}e.$2g=x;function ue(O){const J=new y.$rc,he=O(J.token);return new x(J,async Ee=>{const ve=J.token.onCancellationRequested(()=>{ve.dispose(),J.dispose(),Ee.reject(new R.$3)});try{for await(const be of he){if(J.token.isCancellationRequested)return;Ee.emitOne(be)}ve.dispose(),J.dispose()}catch(be){ve.dispose(),J.dispose(),Ee.reject(be)}})}e.$3g=ue}),define(Pe[37],Ae([1,0,18,13,42,28,19,22,15]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0;function f(){return Object.create(null)}e.$kj=f,e.$lj="**",e.$mj="/";const P="[/\\\\]",S="[^/\\\\]",u=/\//g;function p(ye,De){switch(ye){case 0:return"";case 1:return`${S}*?`;default:return`(?:${P}|${S}+${P}${De?`|${P}${S}+`:""})*?`}}function $(ye,De){if(!ye)return[];const Re=[];let Y=!1,le=!1,we="";for(const ae of ye){switch(ae){case De:if(!Y&&!le){Re.push(we),we="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":le=!0;break;case"]":le=!1;break}we+=ae}return we&&Re.push(we),Re}e.$nj=$;function d(ye){if(!ye)return"";let De="";const Re=$(ye,e.$mj);if(Re.every(Y=>Y===e.$lj))De=".*";else{let Y=!1;Re.forEach((le,we)=>{if(le===e.$lj){if(Y)return;De+=p(2,we===Re.length-1)}else{let ae=!1,x="",ue=!1,O="";for(const J of le){if(J!=="}"&&ae){x+=J;continue}if(ue&&(J!=="]"||!O)){let he;J==="-"?he=J:(J==="^"||J==="!")&&!O?he="^":J===e.$mj?he="":he=(0,I.$sd)(J),O+=he;continue}switch(J){case"{":ae=!0;continue;case"[":ue=!0;continue;case"}":{const Ee=`(?:${$(x,",").map(ve=>d(ve)).join("|")})`;De+=Ee,ae=!1,x="";break}case"]":{De+="["+O+"]",ue=!1,O="";break}case"?":De+=S;continue;case"*":De+=p(1);continue;default:De+=(0,I.$sd)(J)}}we<Re.length-1&&(Re[we+1]!==e.$lj||we+2<Re.length)&&(De+=P)}Y=le===e.$lj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Ai(1e4),a=function(){return!1},r=function(){return null};function o(ye,De){if(!ye)return r;let Re;typeof ye!="string"?Re=ye.pattern:Re=ye,Re=Re.trim();const Y=`${Re}_${!!De.trimForExclusions}`;let le=n.get(Y);if(le)return w(le,ye);let we;return t.test(Re)?le=E(Re.substr(4),Re):(we=i.exec(v(Re,De)))?le=D(we[1],Re):(De.trimForExclusions?m:c).test(Re)?le=s(Re,De):(we=k.exec(v(Re,De)))?le=h(we[1].substr(1),Re,!0):(we=b.exec(v(Re,De)))?le=h(we[1],Re,!1):le=g(Re),n.set(Y,le),w(le,ye)}function w(ye,De){if(typeof De=="string")return ye;const Re=function(Y,le){return(0,C.$Ke)(Y,De.base,!l.$k)?ye((0,I.$wd)(Y.substr(De.base.length),A.sep),le):null};return Re.allBasenames=ye.allBasenames,Re.allPaths=ye.allPaths,Re.basenames=ye.basenames,Re.patterns=ye.patterns,Re}function v(ye,De){return De.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function E(ye,De){return function(Re,Y){return typeof Re=="string"&&Re.endsWith(ye)?De:null}}function D(ye,De){const Re=`/${ye}`,Y=`\\${ye}`,le=function(ae,x){return typeof ae!="string"?null:x?x===ye?De:null:ae===ye||ae.endsWith(Re)||ae.endsWith(Y)?De:null},we=[ye];return le.basenames=we,le.patterns=[De],le.allBasenames=we,le}function s(ye,De){const Re=ie(ye.slice(1,-1).split(",").map(x=>o(x,De)).filter(x=>x!==r),ye),Y=Re.length;if(!Y)return r;if(Y===1)return Re[0];const le=function(x,ue){for(let O=0,J=Re.length;O<J;O++)if(Re[O](x,ue))return ye;return null},we=Re.find(x=>!!x.allBasenames);we&&(le.allBasenames=we.allBasenames);const ae=Re.reduce((x,ue)=>ue.allPaths?x.concat(ue.allPaths):x,[]);return ae.length&&(le.allPaths=ae),le}function h(ye,De,Re){const Y=A.sep===A.$8c.sep,le=Y?ye:ye.replace(u,A.sep),we=A.sep+le,ae=A.$8c.sep+ye;let x;return Re?x=function(ue,O){return typeof ue=="string"&&(ue===le||ue.endsWith(we)||!Y&&(ue===ye||ue.endsWith(ae)))?De:null}:x=function(ue,O){return typeof ue=="string"&&(ue===le||!Y&&ue===ye)?De:null},x.allPaths=[(Re?"*/":"./")+ye],x}function g(ye){try{const De=new RegExp(`^${d(ye)}$`);return function(Re){return De.lastIndex=0,typeof Re=="string"&&De.test(Re)?ye:null}}catch{return r}}function M(ye,De,Re){return!ye||typeof De!="string"?!1:W(ye)(De,void 0,Re)}e.$oj=M;function W(ye,De={}){if(!ye)return a;if(typeof ye=="string"||V(ye)){const Re=o(ye,De);if(Re===r)return a;const Y=function(le,we){return!!Re(le,we)};return Re.allBasenames&&(Y.allBasenames=Re.allBasenames),Re.allPaths&&(Y.allPaths=Re.allPaths),Y}return U(ye,De)}e.$pj=W;function V(ye){const De=ye;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$qj=V;function B(ye){return ye.allBasenames||[]}e.$rj=B;function j(ye){return ye.allPaths||[]}e.$sj=j;function U(ye,De){const Re=ie(Object.getOwnPropertyNames(ye).map(x=>z(x,ye[x],De)).filter(x=>x!==r)),Y=Re.length;if(!Y)return r;if(!Re.some(x=>!!x.requiresSiblings)){if(Y===1)return Re[0];const x=function(J,he){let Ee;for(let ve=0,be=Re.length;ve<be;ve++){const ke=Re[ve](J,he);if(typeof ke=="string")return ke;(0,R.$rg)(ke)&&(Ee||(Ee=[]),Ee.push(ke))}return Ee?(async()=>{for(const ve of Ee){const be=await ve;if(typeof be=="string")return be}return null})():null},ue=Re.find(J=>!!J.allBasenames);ue&&(x.allBasenames=ue.allBasenames);const O=Re.reduce((J,he)=>he.allPaths?J.concat(he.allPaths):J,[]);return O.length&&(x.allPaths=O),x}const le=function(x,ue,O){let J,he;for(let Ee=0,ve=Re.length;Ee<ve;Ee++){const be=Re[Ee];be.requiresSiblings&&O&&(ue||(ue=(0,A.$cd)(x)),J||(J=ue.substr(0,ue.length-(0,A.$dd)(x).length)));const ke=be(x,ue,J,O);if(typeof ke=="string")return ke;(0,R.$rg)(ke)&&(he||(he=[]),he.push(ke))}return he?(async()=>{for(const Ee of he){const ve=await Ee;if(typeof ve=="string")return ve}return null})():null},we=Re.find(x=>!!x.allBasenames);we&&(le.allBasenames=we.allBasenames);const ae=Re.reduce((x,ue)=>ue.allPaths?x.concat(ue.allPaths):x,[]);return ae.length&&(le.allPaths=ae),le}function z(ye,De,Re){if(De===!1)return r;const Y=o(ye,Re);if(Y===r)return r;if(typeof De=="boolean")return Y;if(De){const le=De.when;if(typeof le=="string"){const we=(ae,x,ue,O)=>{if(!O||!Y(ae,x))return null;const J=le.replace("$(basename)",()=>ue),he=O(J);return(0,R.$rg)(he)?he.then(Ee=>Ee?ye:null):he?ye:null};return we.requiresSiblings=!0,we}}return Y}function ie(ye,De){const Re=ye.filter(x=>!!x.basenames);if(Re.length<2)return ye;const Y=Re.reduce((x,ue)=>{const O=ue.basenames;return O?x.concat(O):x},[]);let le;if(De){le=[];for(let x=0,ue=Y.length;x<ue;x++)le.push(De)}else le=Re.reduce((x,ue)=>{const O=ue.patterns;return O?x.concat(O):x},[]);const we=function(x,ue){if(typeof x!="string")return null;if(!ue){let J;for(J=x.length;J>0;J--){const he=x.charCodeAt(J-1);if(he===47||he===92)break}ue=x.substr(J)}const O=Y.indexOf(ue);return O!==-1?le[O]:null};we.basenames=Y,we.patterns=le,we.allBasenames=Y;const ae=ye.filter(x=>!x.basenames);return ae.push(we),ae}function X(ye,De){return(0,y.$of)(ye,De,(Re,Y)=>typeof Re=="string"&&typeof Y=="string"?Re===Y:typeof Re!="string"&&typeof Y!="string"?Re.base===Y.base&&Re.pattern===Y.pattern:!1)}e.$tj=X}),define(Pe[49],Ae([1,0,9,122,23,15,2]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class I{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=u(this.supportThemeIcons?(0,R.$Pj)(i):i).replace(/([ \t]+)/g,(m,k)=>"&nbsp;".repeat(k.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,m){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(i,c){const m=new RegExp((0,L.$sd)(c),"g");return i.replace(m,(k,b)=>i.charAt(b-1)!=="\\"?`\\${k}`:k)}}e.$Vj=I;function f(t){return P(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$Wj=f;function P(t){return t instanceof I?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Xj=P;function S(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$_f)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$Yj=S;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Zj=u;function p(t){return t.replace(/"/g,"&quot;")}e.$1j=p;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$2j=$;function d(t){const i=[],c=t.split("|").map(k=>k.trim());t=c[0];const m=c[1];if(m){const k=/height=(\d+)/.exec(m),b=/width=(\d+)/.exec(m),n=k?k[1]:"",a=b?b[1]:"",r=isFinite(parseInt(a)),o=isFinite(parseInt(n));r&&i.push(`width="${a}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$3j=d}),define(Pe[90],Ae([1,0,18,42,19,22,23,15]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=e.$bA=e.$aA=void 0;function I(o,w){const{os:v,tildify:E,relative:D}=w;if(D){const g=f(o,D,v);if(typeof g=="string")return g}let s=o.fsPath;if(v===1&&!L.$i?s=s.replace(/\//g,"\\"):v!==1&&L.$i&&(s=s.replace(/\\/g,"/")),v!==1&&E?.userHome){const g=E.userHome.fsPath;let M;o.scheme!==E.userHome.scheme&&o.path.startsWith(C.$8c.sep)?M=E.userHome.with({path:o.path}).fsPath:M=o.fsPath,s=u(M,g,v)}return(v===1?C.$7c:C.$8c).normalize(P(s,v===1))}e.$aA=I;function f(o,w,v){const E=v===1?C.$7c:C.$8c,D=v===3?A.$9f:A.$$f,s=w.getWorkspace(),h=(0,y.$Hf)(s.folders);if(!h)return;o.scheme!==h.uri.scheme&&o.path.startsWith(C.$8c.sep)&&(o=h.uri.with({path:o.path}));const g=w.getWorkspaceFolder(o);if(!g)return;let M;if(D.isEqual(g.uri,o)?M="":M=D.relativePath(g.uri,o)??"",M&&(M=E.normalize(M)),s.folders.length>1&&!w.noPrefix){const W=g.name?g.name:D.basenameOrAuthority(g.uri);M=M?`${W} \u2022 ${M}`:W}return M}function P(o,w=L.$i){return(0,R.$Oe)(o,w)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$bA=P;let S=Object.create(null);function u(o,w,v=L.OS){if(v===1||!o||!w)return o;let E=S.original===w?S.normalized:void 0;E||(E=w,L.$i&&(E=(0,R.$Ee)(E)),E=`${(0,l.$xd)(E,C.$8c.sep)}${C.$8c.sep}`,S={original:w,normalized:E});let D=o;return L.$i&&(D=(0,R.$Ee)(D)),(v===3?D.startsWith(E):(0,l.$Pd)(D,E))?`~/${D.substr(E.length)}`:o}e.$cA=u;function p(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.$dA=p;const $="\u2026",d="\\\\",t="~";function i(o,w=C.sep){const v=new Array(o.length);let E=!1;for(let D=0;D<o.length;D++){const s=o[D];if(s===""){v[D]=`.${w}`;continue}if(!s){v[D]=s;continue}E=!0;let h="",g=s;g.indexOf(d)===0?(h=g.substr(0,g.indexOf(d)+d.length),g=g.substr(g.indexOf(d)+d.length)):g.indexOf(w)===0?(h=g.substr(0,g.indexOf(w)+w.length),g=g.substr(g.indexOf(w)+w.length)):g.indexOf(t)===0&&(h=g.substr(0,g.indexOf(t)+t.length),g=g.substr(g.indexOf(t)+t.length));const M=g.split(w);for(let W=1;E&&W<=M.length;W++)for(let V=M.length-W;E&&V>=0;V--){E=!1;let B=M.slice(V,V+W).join(w);for(let j=0;!E&&j<o.length;j++)if(j!==D&&o[j]&&o[j].indexOf(B)>-1){const U=V+W===M.length,z=V>0&&o[j].indexOf(w)>-1?w+B:B,ie=o[j].endsWith(z);E=!U||ie}if(!E){let j="";(M[0].endsWith(":")||h!=="")&&(V===1&&(V=0,W++,B=M[0]+w+B),V>0&&(j=M[0]+w),j=h+j),V>0&&(j=j+$+w),j=j+B,V+W<M.length&&(j=j+w+$),v[D]=j}}E&&(v[D]=s)}return v}e.$eA=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function m(o,w=Object.create(null)){const v=[];let E=!1,D="";for(const s of o)if(s==="$"||E&&s==="{")D&&v.push({value:D,type:c.TEXT}),D="",E=!0;else if(s==="}"&&E){const h=w[D];if(typeof h=="string")h.length&&v.push({value:h,type:c.VARIABLE});else if(h){const g=v[v.length-1];(!g||g.type!==c.SEPARATOR)&&v.push({value:h.label,type:c.SEPARATOR})}D="",E=!1}else D+=s;return D&&!E&&v.push({value:D,type:c.TEXT}),v.filter((s,h)=>{if(s.type===c.SEPARATOR){const g=v[h-1],M=v[h+1];return[g,M].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(s=>s.value).join("")}e.$fA=m;function k(o,w){return L.$j||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):o.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.$gA=k;function b(o,w){return L.$j||w?o.replace(/\(&&\w\)|&&/g,""):L.$i?o.replace(/&&|&/g,v=>v==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$hA=b;function n(o){return o.replace(/&/g,"&&")}e.$iA=n;function a(o){if(o.endsWith("]")){const w=o.lastIndexOf(" [",o.length-2);if(w!==-1){const v=r(o.substring(0,w));return{name:v.name,parentPath:v.parentPath+o.substring(w)}}}return r(o)}e.$jA=a;function r(o){const w=o.indexOf("/")!==-1?C.$8c:C.$7c,v=w.basename(o),E=w.dirname(o);return v.length?{name:v,parentPath:E}:{name:E,parentPath:""}}}),define(Pe[133],Ae([1,0,25,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=void 0;function C(S){return S.toJSON()}class L{constructor(u){this.a=u}transformIncoming(u){const p=this.a.transformIncoming(u);return p===u?u:C(R.URI.from(p))}transformOutgoing(u){const p=this.a.transformOutgoing(u);return p===u?u:C(R.URI.from(p))}transformOutgoingURI(u){const p=this.a.transformOutgoing(u);return p===u?u:R.URI.from(p)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$zm=L,e.$Am=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,u,p){if(!S||p>200)return null;if(typeof S=="object"){if(S instanceof R.URI)return u.transformOutgoing(S);for(const $ in S)if(Object.hasOwnProperty.call(S,$)){const d=A(S[$],u,p+1);d!==null&&(S[$]=d)}}return null}function l(S,u){const p=A(S,u,0);return p===null?S:p}e.$Bm=l;function I(S,u,p,$){if(!S||$>200)return null;if(typeof S=="object"){if(S.$mid===1)return p?R.URI.revive(u.transformIncoming(S)):u.transformIncoming(S);if(S instanceof y.$Hc)return null;for(const d in S)if(Object.hasOwnProperty.call(S,d)){const t=I(S[d],u,p,$+1);t!==null&&(S[d]=t)}}return null}function f(S,u){const p=I(S,u,!1,0);return p===null?S:p}e.$Cm=f;function P(S,u){const p=I(S,u,!0,0);return p===null?S:p}e.$Dm=P}),define(Pe[134],Ae([1,0,37,19]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$E=void 0;function C(L,A,l,I,f,P){if(Array.isArray(L)){let S=0;for(const u of L){const p=C(u,A,l,I,f,P);if(p===10)return p;p>S&&(S=p)}return S}else{if(typeof L=="string")return I?L==="*"?5:L===l?10:0:0;if(L){const{language:S,pattern:u,scheme:p,hasAccessToAllModels:$,notebookType:d}=L;if(!I&&!$)return 0;d&&f&&(A=f);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(S)if(S===l)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(d)if(d===P)t=10;else if(d==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,R.$9c)(u.base)},i===A.fsPath||(0,y.$oj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$$E=C}),define(Pe[91],Ae([1,0,25,22]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g0=e.$f0=void 0;var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function L(S){for(let u=0,p=S.length;u<p;u+=4){const $=S[u+0],d=S[u+1],t=S[u+2],i=S[u+3];S[u+0]=i,S[u+1]=t,S[u+2]=d,S[u+3]=$}}function A(S){const u=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return R.$C()||L(u),y.$Hc.wrap(u)}function l(S){const u=S.buffer;if(R.$C()||L(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const p=new Uint8Array(u.byteLength);return p.set(u),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function I(S){const u=new Uint32Array(f(S));let p=0;if(u[p++]=S.id,S.type==="full")u[p++]=1,u[p++]=S.data.length,u.set(S.data,p),p+=S.data.length;else{u[p++]=2,u[p++]=S.deltas.length;for(const $ of S.deltas)u[p++]=$.start,u[p++]=$.deleteCount,$.data?(u[p++]=$.data.length,u.set($.data,p),p+=$.data.length):u[p++]=0}return A(u)}e.$f0=I;function f(S){let u=0;if(u+=1+1,S.type==="full")u+=1+S.data.length;else{u+=1,u+=(1+1+1)*S.deltas.length;for(const p of S.deltas)p.data&&(u+=p.data.length)}return u}function P(S){const u=l(S);let p=0;const $=u[p++];if(u[p++]===1){const c=u[p++],m=u.subarray(p,p+c);return p+=c,{id:$,type:"full",data:m}}const t=u[p++],i=[];for(let c=0;c<t;c++){const m=u[p++],k=u[p++],b=u[p++];let n;b>0&&(n=u.subarray(p,p+b),p+=b),i[c]={start:m,deleteCount:k,data:n}}return{id:$,type:"delta",deltas:i}}e.$g0=P}),define(Pe[135],Ae([10,11]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Pe[136],Ae([1,0,18,24,22,124,137,135]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(I||(e.EditorAutoIndentStrategy=I={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=f;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class S{constructor(Z,$e,je,Oe){this.id=Z,this.name=$e,this.defaultValue=je,this.schema=Oe}applyUpdate(Z,$e){return p(Z,$e)}compute(Z,$e,je){return je}}class u{constructor(Z,$e){this.newValue=Z,this.didChange=$e}}e.ApplyUpdateResult=u;function p(_,Z){if(typeof _!="object"||typeof Z!="object"||!_||!Z)return new u(Z,_!==Z);if(Array.isArray(_)||Array.isArray(Z)){const je=Array.isArray(_)&&Array.isArray(Z)&&y.$of(_,Z);return new u(Z,!je)}let $e=!1;for(const je in Z)if(Z.hasOwnProperty(je)){const Oe=p(_[je],Z[je]);Oe.didChange&&(_[je]=Oe.newValue,$e=!0)}return new u(_,$e)}class ${constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,$e){return p(Z,$e)}validate(Z){return this.defaultValue}}class d{constructor(Z,$e,je,Oe){this.id=Z,this.name=$e,this.defaultValue=je,this.schema=Oe}applyUpdate(Z,$e){return p(Z,$e)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,$e,je){return je}}function t(_,Z){return typeof _>"u"?Z:_==="false"?!1:!!_}e.boolean=t;class i extends d{constructor(Z,$e,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=je),super(Z,$e,je,Oe)}validate(Z){return t(Z,this.defaultValue)}}function c(_,Z,$e,je){if(typeof _>"u")return Z;let Oe=parseInt(_,10);return isNaN(Oe)?Z:(Oe=Math.max($e,Oe),Oe=Math.min(je,Oe),Oe|0)}e.clampedInt=c;class m extends d{static clampedInt(Z,$e,je,Oe){return c(Z,$e,je,Oe)}constructor(Z,$e,je,Oe,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=je,nt.minimum=Oe,nt.maximum=Ze),super(Z,$e,je,nt),this.minimum=Oe,this.maximum=Ze}validate(Z){return m.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function k(_,Z,$e,je){if(typeof _>"u")return Z;const Oe=b.float(_,Z);return b.clamp(Oe,$e,je)}e.clampedFloat=k;class b extends d{static clamp(Z,$e,je){return Z<$e?$e:Z>je?je:Z}static float(Z,$e){if(typeof Z=="number")return Z;if(typeof Z>"u")return $e;const je=parseFloat(Z);return isNaN(je)?$e:je}constructor(Z,$e,je,Oe,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=je),super(Z,$e,je,Ze),this.validationFn=Oe}validate(Z){return this.validationFn(b.float(Z,this.defaultValue))}}class n extends d{static string(Z,$e){return typeof Z!="string"?$e:Z}constructor(Z,$e,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=je),super(Z,$e,je,Oe)}validate(Z){return n.string(Z,this.defaultValue)}}function a(_,Z,$e,je){return typeof _!="string"?Z:je&&_ in je?je[_]:$e.indexOf(_)===-1?Z:_}e.stringSet=a;class r extends d{constructor(Z,$e,je,Oe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Oe,Ze.default=je),super(Z,$e,je,Ze),this.c=Oe}validate(Z){return a(Z,this.defaultValue,this.c)}}class o extends S{constructor(Z,$e,je,Oe,Ze,nt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Ze,gt.default=Oe),super(Z,$e,je,gt),this.c=Ze,this.d=nt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function w(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,$e,je){return je===0?Z.accessibilitySupport:je}}class E extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{insertSpace:t($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function s(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(h||(e.TextEditorCursorStyle=h={}));function g(_){switch(_){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function M(_){switch(_){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class W extends ${constructor(){super(140)}compute(Z,$e,je){const Oe=["monaco-editor"];return $e.get(39)&&Oe.push($e.get(39)),Z.extraEditorClassName&&Oe.push(Z.extraEditorClassName),$e.get(73)==="default"?Oe.push("mouse-default"):$e.get(73)==="copy"&&Oe.push("mouse-copy"),$e.get(110)&&Oe.push("showUnused"),$e.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class V extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Z,$e,je){return je&&Z.emptySelectionClipboard}}class B extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:l.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:l.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{cursorMoveOnType:t($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":a($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":a($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t($e.loop,this.defaultValue.loop)}}}class j extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?j.OFF:Z==="true"?j.ON:Z:Z?j.ON:j.OFF}}e.EditorFontLigatures=j;class U extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?U.OFF:Z==="true"?U.TRANSLATE:Z:Z?U.TRANSLATE:U.OFF}compute(Z,$e,je){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=U;class z extends ${constructor(){super(50)}compute(Z,$e,je){return Z.fontInfo}}class ie extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Z){const $e=b.float(Z,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:b.clamp($e,6,100)}compute(Z,$e,je){return Z.fontInfo.fontSize}}class X extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(m.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class ye extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:je,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:je,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:je,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:je,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:je,description:l.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{multiple:a($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??a($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??a($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??a($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??a($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??a($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends S{constructor(){const Z={enabled:!0,delay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:l.localize(44,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:l.localize(45,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:t($e.enabled,this.defaultValue.enabled),delay:m.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:t($e.sticky,this.defaultValue.sticky),above:t($e.above,this.defaultValue.above)}}}var Re;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Re||(e.RenderMinimap=Re={}));class Y extends ${constructor(){super(143)}compute(Z,$e,je){return Y.computeLayout($e,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const $e=Z.height/Z.lineHeight,je=Math.floor(Z.paddingTop/Z.lineHeight);let Oe=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Oe=Math.max(Oe,$e-1));const Ze=(je+Z.viewLineCount+Oe)/(Z.pixelRatio*Z.height),nt=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Oe,desiredRatio:Ze,minimapLineCount:nt}}static c(Z,$e){const je=Z.outerWidth,Oe=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=$e.stableMinimapLayoutInput,gt=nt&&Z.outerHeight===nt.outerHeight&&Z.lineHeight===nt.lineHeight&&Z.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===nt.pixelRatio&&Z.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Z.paddingTop===nt.paddingTop&&Z.paddingBottom===nt.paddingBottom&&Z.minimap.enabled===nt.minimap.enabled&&Z.minimap.side===nt.minimap.side&&Z.minimap.size===nt.minimap.size&&Z.minimap.showSlider===nt.minimap.showSlider&&Z.minimap.renderCharacters===nt.minimap.renderCharacters&&Z.minimap.maxColumn===nt.minimap.maxColumn&&Z.minimap.scale===nt.minimap.scale&&Z.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Z.isViewportWrapping===nt.isViewportWrapping,vt=Z.lineHeight,Tt=Z.typicalHalfwidthCharacterWidth,Zt=Z.scrollBeyondLastLine,Vt=Z.minimap.renderCharacters;let wt=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Lt=Z.minimap.maxColumn,zt=Z.minimap.size,Jt=Z.minimap.side,Pt=Z.verticalScrollbarWidth,At=Z.viewLineCount,Ot=Z.remainingWidth,jt=Z.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Ze*Oe);const at=Bt/Ze;let ut=!1,Ht=!1,Ct=qt*wt,Dt=wt/Ze,ht=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:ge,extraLinesBeyondLastLine:G,desiredRatio:Te,minimapLineCount:Be}=Y.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Zt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Oe,lineHeight:vt,pixelRatio:Ze});if(At/Be>1)ut=!0,Ht=!0,wt=1,Ct=1,Dt=wt/Ze;else{let We=!1,xe=wt+1;if(zt==="fit"){const pt=Math.ceil((ge+At+G)*Ct);jt&&gt&&Ot<=$e.stableFitRemainingWidth?(We=!0,xe=$e.stableFitMaxMinimapScale):We=pt>Bt}if(zt==="fill"||We){ut=!0;const pt=wt;Ct=Math.min(vt*Ze,Math.max(1,Math.floor(1/Te))),jt&&gt&&Ot<=$e.stableFitRemainingWidth&&(xe=$e.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(Ct/qt))),wt>pt&&(ht=Math.min(2,wt/pt)),Dt=wt/Ze/ht,Bt=Math.ceil(Math.max(Fe,ge+At+G)*Ct),jt?($e.stableMinimapLayoutInput=Z,$e.stableFitRemainingWidth=Ot,$e.stableFitMaxMinimapScale=wt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const St=Math.floor(Lt*Dt),Mt=Math.min(St,Math.max(0,Math.floor((Ot-Pt-2)*Dt/(Tt+Dt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Ze*Mt);const qe=Et/Ze;Et=Math.floor(Et*ht);const Nt=Vt?1:2,Ie=Jt==="left"?0:je-Mt-Pt;return{renderMinimap:Nt,minimapLeft:Ie,minimapWidth:Mt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ht,minimapScale:wt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(Z,$e){const je=$e.outerWidth|0,Oe=$e.outerHeight|0,Ze=$e.lineHeight|0,nt=$e.lineNumbersDigitCount|0,gt=$e.typicalHalfwidthCharacterWidth,vt=$e.maxDigitWidth,Tt=$e.pixelRatio,Zt=$e.viewLineCount,Vt=Z.get(135),wt=Vt==="inherit"?Z.get(134):Vt,Lt=wt==="inherit"?Z.get(130):wt,zt=Z.get(133),Jt=$e.isDominatedByLongLines,Pt=Z.get(57),At=Z.get(67).renderType!==0,Ot=Z.get(68),jt=Z.get(104),qt=Z.get(83),Bt=Z.get(72),at=Z.get(102),ut=at.verticalScrollbarSize,Ht=at.verticalHasArrows,Ct=at.arrowSize,Dt=at.horizontalScrollbarSize,ht=Z.get(43),St=Z.get(109)!=="never";let Mt=Z.get(65);ht&&St&&(Mt+=16);let Et=0;if(At){const dt=Math.max(nt,Ot);Et=Math.round(dt*vt)}let qe=0;Pt&&(qe=Ze*$e.glyphMarginDecorationLaneCount);let Nt=0,Ie=Nt+qe,Fe=Ie+Et,ge=Fe+Mt;const G=je-qe-Et-Mt;let Te=!1,Be=!1,Ge=-1;wt==="inherit"&&Jt?(Te=!0,Be=!0):Lt==="on"||Lt==="bounded"?Be=!0:Lt==="wordWrapColumn"&&(Ge=zt);const We=Y.c({outerWidth:je,outerHeight:Oe,lineHeight:Ze,typicalHalfwidthCharacterWidth:gt,pixelRatio:Tt,scrollBeyondLastLine:jt,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:ut,viewLineCount:Zt,remainingWidth:G,isViewportWrapping:Be},$e.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Nt+=We.minimapWidth,Ie+=We.minimapWidth,Fe+=We.minimapWidth,ge+=We.minimapWidth);const xe=G-We.minimapWidth,pt=Math.max(1,Math.floor((xe-ut-2)/gt)),bt=Ht?Ct:0;return Be&&(Ge=Math.max(1,pt),Lt==="bounded"&&(Ge=Math.min(Ge,zt))),{width:je,height:Oe,glyphMarginLeft:Nt,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Ie,lineNumbersWidth:Et,decorationsLeft:Fe,decorationsWidth:Mt,contentLeft:ge,contentWidth:xe,minimap:We,viewportColumn:pt,isWordWrapMinified:Te,isViewportWrapping:Be,wrappingColumn:Ge,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Dt,overviewRuler:{top:bt,width:ut,height:Oe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=Y;class le extends S{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(46,null),l.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(48,null)}})}validate(Z){return a(Z,"simple",["simple","advanced"])}compute(Z,$e,je){return $e.get(2)===2?"advanced":je}}class we extends S{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:l.localize(49,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class ae extends S{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:l.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:l.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:l.localize(52,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:l.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:t($e.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class x extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:l.localize(54,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(55,null),l.localize(56,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:l.localize(59,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:l.localize(60,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:l.localize(61,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:a($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string($e.fontFamily,this.defaultValue.fontFamily),padding:t($e.padding,this.defaultValue.padding)}}}class ue extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):m.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,$e,je){return je<0?m.clampedInt(-je*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class O extends b{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>b.clamp(Z,0,150),{markdownDescription:l.localize(62,null)})}compute(Z,$e,je){return Z.fontInfo.lineHeight}}class J extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:l.localize(63,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:l.localize(64,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(65,null),l.localize(66,null),l.localize(67,null)],default:Z.size,description:l.localize(68,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:l.localize(69,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:l.localize(70,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(71,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:l.localize(72,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:l.localize(73,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:t($e.enabled,this.defaultValue.enabled),autohide:t($e.autohide,this.defaultValue.autohide),size:a($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:a($e.side,this.defaultValue.side,["right","left"]),showSlider:a($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t($e.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt($e.scale,1,1,3),maxColumn:m.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends S{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(74,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{top:m.clampedInt($e.top,0,0,1e3),bottom:m.clampedInt($e.bottom,0,0,1e3)}}}class ve extends S{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:l.localize(76,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:l.localize(77,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:t($e.enabled,this.defaultValue.enabled),cycle:t($e.cycle,this.defaultValue.cycle)}}}class be extends ${constructor(){super(141)}compute(Z,$e,je){return Z.pixelRatio}}class ke extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(78,null),l.localize(79,null),l.localize(80,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:Z.strings,description:l.localize(81,null)},comments:{anyOf:$e,default:Z.comments,description:l.localize(82,null)},other:{anyOf:$e,default:Z.other,description:l.localize(83,null)}},default:Z,markdownDescription:l.localize(84,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Tt=Z?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:$e,comments:je,strings:Oe}=Z,Ze=["on","inline","off"];let nt,gt,vt;return typeof $e=="boolean"?nt=$e?"on":"off":nt=a($e,this.defaultValue.other,Ze),typeof je=="boolean"?gt=je?"on":"off":gt=a(je,this.defaultValue.comments,Ze),typeof Oe=="boolean"?vt=Oe?"on":"off":vt=a(Oe,this.defaultValue.strings,Ze),{other:nt,comments:gt,strings:vt}}}var oe;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class de extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(85,null),l.localize(86,null),l.localize(87,null),l.localize(88,null)],default:"on",description:l.localize(89,null)})}validate(Z){let $e=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?($e=4,je=Z):Z==="interval"?$e=3:Z==="relative"?$e=2:Z==="on"?$e=1:$e=0),{renderType:$e,renderFn:je}}}function se(_){const Z=_.get(97);return Z==="editable"?_.get(90):Z!=="on"}e.filterValidationDecorations=se;class ne extends S{constructor(){const Z=[],$e={type:"number",description:l.localize(90,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:l.localize(91,null),format:"color-hex"}}}]},default:Z,description:l.localize(92,null)})}validate(Z){if(Array.isArray(Z)){const $e=[];for(const je of Z)if(typeof je=="number")$e.push({column:m.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Oe=je;$e.push({column:m.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return $e.sort((je,Oe)=>je.column-Oe.column),$e}return this.defaultValue}}class me extends S{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(_,Z){if(typeof _!="string")return Z;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(93,null),l.localize(94,null),l.localize(95,null)],default:"auto",description:l.localize(96,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(97,null),l.localize(98,null),l.localize(99,null)],default:"auto",description:l.localize(100,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:l.localize(101,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:l.localize(103,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z,je=m.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=m.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce($e.vertical,this.defaultValue.vertical),horizontal:Ce($e.horizontal,this.defaultValue.horizontal),useShadows:t($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:t($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:m.clampedInt($e.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:m.clampedInt($e.verticalSliderSize,Oe,0,1e3),scrollByPage:t($e.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:l.localize(104,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:l.localize(109,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:l.localize(110,null)}})}applyUpdate(Z,$e){let je=!1;$e.allowedCharacters&&Z&&(R.$Xm(Z.allowedCharacters,$e.allowedCharacters)||(Z={...Z,allowedCharacters:$e.allowedCharacters},je=!0)),$e.allowedLocales&&Z&&(R.$Xm(Z.allowedLocales,$e.allowedLocales)||(Z={...Z,allowedLocales:$e.allowedLocales},je=!0));const Oe=super.applyUpdate(Z,$e);return je?new u(Oe.newValue,!0):Oe}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,$e){if(typeof Z!="object"||!Z)return $e;const je={};for(const[Oe,Ze]of Object.entries(Z))Ze===!0&&(je[Oe]=!0);return je}}class H extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:l.localize(111,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(112,null),l.localize(113,null)],description:l.localize(114,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:l.localize(115,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:t($e.enabled,this.defaultValue.enabled),mode:a($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a($e.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends S{constructor(){const Z={enabled:L.$Rr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Rr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(116,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:l.localize(117,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:t($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(118,null),l.localize(119,null),l.localize(120,null)],default:Z.bracketPairs,description:l.localize(121,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(122,null),l.localize(123,null),l.localize(124,null)],default:Z.bracketPairsHorizontal,description:l.localize(125,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:l.localize(126,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:l.localize(127,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(128,null),l.localize(129,null),l.localize(130,null)],default:Z.highlightActiveIndentation,description:l.localize(131,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(_,Z,$e){const je=$e.indexOf(_);return je===-1?Z:$e[je]}class ce extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(132,null),l.localize(133,null)],default:Z.insertMode,description:l.localize(134,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:l.localize(135,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:l.localize(136,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:l.localize(137,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(138,null),l.localize(139,null),l.localize(140,null),l.localize(141,null)],default:Z.selectionMode,markdownDescription:l.localize(142,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:l.localize(143,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:l.localize(144,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:l.localize(145,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:l.localize(146,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:l.localize(147,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(148,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(149,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{insertMode:a($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t($e.showIcons,this.defaultValue.showIcons),showStatusBar:t($e.showStatusBar,this.defaultValue.showStatusBar),preview:t($e.preview,this.defaultValue.preview),previewMode:a($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t($e.showMethods,this.defaultValue.showMethods),showFunctions:t($e.showFunctions,this.defaultValue.showFunctions),showConstructors:t($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:t($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t($e.showFields,this.defaultValue.showFields),showVariables:t($e.showVariables,this.defaultValue.showVariables),showClasses:t($e.showClasses,this.defaultValue.showClasses),showStructs:t($e.showStructs,this.defaultValue.showStructs),showInterfaces:t($e.showInterfaces,this.defaultValue.showInterfaces),showModules:t($e.showModules,this.defaultValue.showModules),showProperties:t($e.showProperties,this.defaultValue.showProperties),showEvents:t($e.showEvents,this.defaultValue.showEvents),showOperators:t($e.showOperators,this.defaultValue.showOperators),showUnits:t($e.showUnits,this.defaultValue.showUnits),showValues:t($e.showValues,this.defaultValue.showValues),showConstants:t($e.showConstants,this.defaultValue.showConstants),showEnums:t($e.showEnums,this.defaultValue.showEnums),showEnumMembers:t($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t($e.showKeywords,this.defaultValue.showKeywords),showWords:t($e.showWords,this.defaultValue.showWords),showColors:t($e.showColors,this.defaultValue.showColors),showFiles:t($e.showFiles,this.defaultValue.showFiles),showReferences:t($e.showReferences,this.defaultValue.showReferences),showFolders:t($e.showFolders,this.defaultValue.showFolders),showTypeParameters:t($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t($e.showSnippets,this.defaultValue.showSnippets),showUsers:t($e.showUsers,this.defaultValue.showUsers),showIssues:t($e.showIssues,this.defaultValue.showIssues)}}}class ze extends S{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(180,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(181,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends S{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(182,null),l.localize(183,null),l.localize(184,null),l.localize(185,null)],description:l.localize(186,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,$e,je){return $e.get(2)===2?0:je}}class He extends ${constructor(){super(144)}compute(Z,$e,je){const Oe=$e.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class et extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(187,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(188,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(189,null),l.localize(190,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:t($e.enabled,this.defaultValue.enabled),showDropSelector:a($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(191,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(192,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(193,null),l.localize(194,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:t($e.enabled,this.defaultValue.enabled),showPasteSelector:a($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:_e,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(195,null)})),acceptSuggestionOnEnter:Ne(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(196,null),""],markdownDescription:l.localize(197,null)})),accessibilitySupport:Ne(new v),accessibilityPageSize:Ne(new m(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(198,null),tags:["accessibility"]})),ariaLabel:Ne(new n(4,"ariaLabel",l.localize(199,null))),ariaRequired:Ne(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(200,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(201,null),l.localize(202,null),""],description:l.localize(203,null)})),autoClosingComments:Ne(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(204,null),l.localize(205,null),""],description:l.localize(206,null)})),autoClosingDelete:Ne(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(207,null),""],description:l.localize(208,null)})),autoClosingOvertype:Ne(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(209,null),""],description:l.localize(210,null)})),autoClosingQuotes:Ne(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(211,null),l.localize(212,null),""],description:l.localize(213,null)})),autoIndent:Ne(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[l.localize(214,null),l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null)],description:l.localize(219,null)})),automaticLayout:Ne(new i(13,"automaticLayout",!1)),autoSurround:Ne(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(220,null),l.localize(221,null),l.localize(222,null),""],description:l.localize(223,null)})),bracketPairColorization:Ne(new Q),bracketPairGuides:Ne(new K),stickyTabStops:Ne(new i(115,"stickyTabStops",!1,{description:l.localize(224,null)})),codeLens:Ne(new i(17,"codeLens",!0,{description:l.localize(225,null)})),codeLensFontFamily:Ne(new n(18,"codeLensFontFamily","",{description:l.localize(226,null)})),codeLensFontSize:Ne(new m(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(227,null)})),colorDecorators:Ne(new i(20,"colorDecorators",!0,{description:l.localize(228,null)})),colorDecoratorActivatedOn:Ne(new r(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(229,null),l.localize(230,null),l.localize(231,null)],description:l.localize(232,null)})),colorDecoratorsLimit:Ne(new m(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(233,null)})),columnSelection:Ne(new i(22,"columnSelection",!1,{description:l.localize(234,null)})),comments:Ne(new E),contextmenu:Ne(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(235,null)})),cursorBlinking:Ne(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:l.localize(236,null)})),cursorSmoothCaretAnimation:Ne(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(237,null),l.localize(238,null),l.localize(239,null)],description:l.localize(240,null)})),cursorStyle:Ne(new o(28,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:l.localize(241,null)})),cursorSurroundingLines:Ne(new m(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(242,null)})),cursorSurroundingLinesStyle:Ne(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(243,null),l.localize(244,null)],description:l.localize(245,null)})),cursorWidth:Ne(new m(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(246,null)})),disableLayerHinting:Ne(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new i(34,"domReadOnly",!1)),dragAndDrop:Ne(new i(35,"dragAndDrop",!0,{description:l.localize(247,null)})),emptySelectionClipboard:Ne(new V),dropIntoEditor:Ne(new et),stickyScroll:Ne(new ae),experimentalWhitespaceRendering:Ne(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(248,null),l.localize(249,null),l.localize(250,null)],description:l.localize(251,null)})),extraEditorClassName:Ne(new n(39,"extraEditorClassName","")),fastScrollSensitivity:Ne(new b(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:l.localize(252,null)})),find:Ne(new B),fixedOverflowWidgets:Ne(new i(42,"fixedOverflowWidgets",!1)),folding:Ne(new i(43,"folding",!0,{description:l.localize(253,null)})),foldingStrategy:Ne(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(254,null),l.localize(255,null)],description:l.localize(256,null)})),foldingHighlight:Ne(new i(45,"foldingHighlight",!0,{description:l.localize(257,null)})),foldingImportsByDefault:Ne(new i(46,"foldingImportsByDefault",!1,{description:l.localize(258,null)})),foldingMaximumRegions:Ne(new m(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(259,null)})),unfoldOnClickAfterEndOfLine:Ne(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(260,null)})),fontFamily:Ne(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(261,null)})),fontInfo:Ne(new z),fontLigatures2:Ne(new j),fontSize:Ne(new ie),fontWeight:Ne(new X),fontVariations:Ne(new U),formatOnPaste:Ne(new i(55,"formatOnPaste",!1,{description:l.localize(262,null)})),formatOnType:Ne(new i(56,"formatOnType",!1,{description:l.localize(263,null)})),glyphMargin:Ne(new i(57,"glyphMargin",!0,{description:l.localize(264,null)})),gotoLocation:Ne(new ye),hideCursorInOverviewRuler:Ne(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(265,null)})),hover:Ne(new De),inDiffEditor:Ne(new i(61,"inDiffEditor",!1)),letterSpacing:Ne(new b(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>b.clamp(_,-5,20),{description:l.localize(266,null)})),lightbulb:Ne(new we),lineDecorationsWidth:Ne(new ue),lineHeight:Ne(new O),lineNumbers:Ne(new de),lineNumbersMinChars:Ne(new m(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new i(69,"linkedEditing",!1,{description:l.localize(267,null)})),links:Ne(new i(70,"links",!0,{description:l.localize(268,null)})),matchBrackets:Ne(new r(71,"matchBrackets","always",["always","near","never"],{description:l.localize(269,null)})),minimap:Ne(new J),mouseStyle:Ne(new r(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new b(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:l.localize(270,null)})),mouseWheelZoom:Ne(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(271,null)})),multiCursorMergeOverlapping:Ne(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(272,null)})),multiCursorModifier:Ne(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[l.localize(273,null),l.localize(274,null)],markdownDescription:l.localize(275,null)})),multiCursorPaste:Ne(new r(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(276,null),l.localize(277,null)],markdownDescription:l.localize(278,null)})),multiCursorLimit:Ne(new m(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(279,null)})),occurrencesHighlight:Ne(new i(80,"occurrencesHighlight",!0,{description:l.localize(280,null)})),overviewRulerBorder:Ne(new i(81,"overviewRulerBorder",!0,{description:l.localize(281,null)})),overviewRulerLanes:Ne(new m(82,"overviewRulerLanes",3,0,3)),padding:Ne(new Ee),pasteAs:Ne(new Xe),parameterHints:Ne(new ve),peekWidgetDefaultFocus:Ne(new r(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(282,null),l.localize(283,null)],description:l.localize(284,null)})),definitionLinkOpensInPeek:Ne(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(285,null)})),quickSuggestions:Ne(new ke),quickSuggestionsDelay:Ne(new m(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(286,null)})),readOnly:Ne(new i(90,"readOnly",!1)),readOnlyMessage:Ne(new me),renameOnType:Ne(new i(92,"renameOnType",!1,{description:l.localize(287,null),markdownDeprecationMessage:l.localize(288,null)})),renderControlCharacters:Ne(new i(93,"renderControlCharacters",!0,{description:l.localize(289,null),restricted:!0})),renderFinalNewline:Ne(new r(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(290,null)})),renderLineHighlight:Ne(new r(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(291,null)],description:l.localize(292,null)})),renderLineHighlightOnlyWhenFocus:Ne(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(293,null)})),renderValidationDecorations:Ne(new r(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new r(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(294,null),l.localize(295,null),l.localize(296,null),""],description:l.localize(297,null)})),revealHorizontalRightPadding:Ne(new m(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new i(100,"roundedSelection",!0,{description:l.localize(298,null)})),rulers:Ne(new ne),scrollbar:Ne(new F),scrollBeyondLastColumn:Ne(new m(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(299,null)})),scrollBeyondLastLine:Ne(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(300,null)})),scrollPredominantAxis:Ne(new i(105,"scrollPredominantAxis",!0,{description:l.localize(301,null)})),selectionClipboard:Ne(new i(106,"selectionClipboard",!0,{description:l.localize(302,null),included:C.$k})),selectionHighlight:Ne(new i(107,"selectionHighlight",!0,{description:l.localize(303,null)})),selectOnLineNumbers:Ne(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new r(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(304,null),l.localize(305,null),l.localize(306,null)],description:l.localize(307,null)})),showUnused:Ne(new i(110,"showUnused",!0,{description:l.localize(308,null)})),showDeprecated:Ne(new i(138,"showDeprecated",!0,{description:l.localize(309,null)})),inlayHints:Ne(new x),snippetSuggestions:Ne(new r(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(310,null),l.localize(311,null),l.localize(312,null),l.localize(313,null)],description:l.localize(314,null)})),smartSelect:Ne(new ze),smoothScrolling:Ne(new i(113,"smoothScrolling",!1,{description:l.localize(315,null)})),stopRenderingLineAfter:Ne(new m(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new ce),inlineSuggest:Ne(new H),inlineCompletionsAccessibilityVerbose:Ne(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(316,null)})),suggestFontSize:Ne(new m(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(317,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new m(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(319,null)})),suggestSelection:Ne(new r(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(320,null),l.localize(321,null),l.localize(322,null)],description:l.localize(323,null)})),tabCompletion:Ne(new r(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(324,null),l.localize(325,null),l.localize(326,null)],description:l.localize(327,null)})),tabIndex:Ne(new m(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new q),unusualLineTerminators:Ne(new r(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(328,null),l.localize(329,null),l.localize(330,null)],description:l.localize(331,null)})),useShadowDOM:Ne(new i(126,"useShadowDOM",!0)),useTabStops:Ne(new i(127,"useTabStops",!0,{description:l.localize(332,null)})),wordBreak:Ne(new r(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(333,null),l.localize(334,null)],description:l.localize(335,null)})),wordSeparators:Ne(new n(129,"wordSeparators",A.$Sr,{description:l.localize(336,null)})),wordWrap:Ne(new r(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(337,null),l.localize(338,null),l.localize(339,null),l.localize(340,null)],description:l.localize(341,null)})),wordWrapBreakAfterCharacters:Ne(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new m(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(342,null)})),wordWrapOverride1:Ne(new r(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new r(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new W),defaultColorDecorators:Ne(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(343,null)})),pixelRatio:Ne(new be),tabFocusMode:Ne(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(344,null)})),layoutInfo:Ne(new Y),wrappingInfo:Ne(new He),wrappingIndent:Ne(new Qe),wrappingStrategy:Ne(new le)}}),define(Pe[138],Ae([10,11]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[139],Ae([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[140],Ae([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[141],Ae([10,11]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[142],Ae([10,11]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[143],Ae([10,11]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Pe[144],Ae([10,11]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Pe[145],Ae([10,11]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[146],Ae([10,11]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Pe[147],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChat",e)}),define(Pe[148],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[149],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[150],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[151],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[152],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[153],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[154],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[155],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[156],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[157],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[158],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[159],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[160],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Pe[161],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Pe[162],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[163],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[164],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[165],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[166],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[167],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[168],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[169],Ae([1,0,9,140]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.TokenType=void 0;var C;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(C||(e.TokenType=C={}));function L(...f){switch(f.length){case 1:return(0,R.localize)(0,null,f[0]);case 2:return(0,R.localize)(1,null,f[0],f[1]);case 3:return(0,R.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,R.localize)(3,null),l=(0,R.localize)(4,null);class I{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,y.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const S=this.d,u=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:u};this.g.push({offset:S,lexeme:u,additionalInfo:P}),this.f.push(p)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const S=this.c.substring(this.d,this.e),u=I.b.get(S);u?this.k(u):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,S=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(l);return}const $=this.c.charCodeAt(P);if(S)S=!1;else if($===47&&!u){P++;break}else $===91?u=!0:$===92?S=!0:$===93&&(u=!1);P++}for(;P<this.c.length&&I.a.has(this.c.charCodeAt(P));)P++;this.e=P;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Di=I}),define(Pe[170],Ae([1,0,23,29,142,276]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function I(i){return i=i.trim(),i==="*"||A.test(i)}e.$zo=I;function f(i){if(!I(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Ao=f;function P(i){if(!i)return null;const c=i.majorBase,m=i.majorMustEqual,k=i.minorBase;let b=i.minorMustEqual;const n=i.patchBase;let a=i.patchMustEqual;i.hasCaret&&(c===0||(b=!1),a=!1);let r=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,w,v,E]=o;r=Date.UTC(Number(w),Number(v)-1,Number(E))}}return{majorBase:c,majorMustEqual:m,minorBase:k,minorMustEqual:b,patchBase:n,patchMustEqual:a,isMinimum:i.hasGreaterEquals,notBefore:r}}e.$Bo=P;function S(i,c,m){let k;typeof i=="string"?k=P(f(i)):k=i;let b;c instanceof Date?b=c.getTime():typeof c=="string"&&(b=new Date(c).getTime());let n;if(typeof m=="string"?n=P(f(m)):n=m,!k||!n)return!1;const a=k.majorBase,r=k.minorBase,o=k.patchBase;let w=n.majorBase,v=n.minorBase,E=n.patchBase;const D=n.notBefore;let s=n.majorMustEqual,h=n.minorMustEqual,g=n.patchMustEqual;return n.isMinimum?a>w?!0:a<w?!1:r>v?!0:r<v||b&&b<D?!1:o>=E:(a===1&&w===0&&(!s||!h||!g)&&(w=1,v=0,E=0,s=!0,h=!1,g=!1),a<w?!1:a>w?!s:r<v?!1:r>v?!h:o<E?!1:o>E?!g:!(b&&b<D))}e.$Co=S;function u(i,c,m,k,b){const n=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return n.push([R.default.Error,C.localize(0,null)]),n;if(typeof k.name!="string")return n.push([R.default.Error,C.localize(1,null,"name")]),n;if(typeof k.version!="string")return n.push([R.default.Error,C.localize(2,null,"version")]),n;if(!k.engines)return n.push([R.default.Error,C.localize(3,null,"engines")]),n;if(typeof k.engines.vscode!="string")return n.push([R.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof k.extensionDependencies<"u"&&!t(k.extensionDependencies))return n.push([R.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof k.activationEvents<"u"){if(!t(k.activationEvents))return n.push([R.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof k.main>"u"&&typeof k.browser>"u")return n.push([R.default.Error,C.localize(7,null,"activationEvents","main","browser")]),n}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&n.push([R.default.Warning,C.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return n.push([R.default.Error,C.localize(9,null,"main")]),n;{const o=(0,y.$gg)(m,k.main);(0,y.$ag)(o,m)||n.push([R.default.Warning,C.localize(10,null,o.path,m.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return n.push([R.default.Error,C.localize(11,null,"browser")]),n;{const o=(0,y.$gg)(m,k.browser);(0,y.$ag)(o,m)||n.push([R.default.Warning,C.localize(12,null,o.path,m.path)])}}if(!L.valid(k.version))return n.push([R.default.Error,C.localize(13,null)]),n;const a=[];if(!p(i,c,k,b,a))for(const o of a)n.push([R.default.Error,o]);return n}e.$Do=u;function p(i,c,m,k,b){return k||typeof m.main>"u"&&typeof m.browser>"u"?!0:d(i,c,m.engines.vscode,b)}e.$Eo=p;function $(i,c,m){return i==="*"||d(c,m,i)}e.$Fo=$;function d(i,c,m,k=[]){const b=P(f(m));if(!b)return k.push(C.localize(14,null,m)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return k.push(C.localize(15,null,m)),!1}else if(!b.majorMustEqual)return k.push(C.localize(16,null,m)),!1;return S(i,c,b)?!0:(k.push(C.localize(17,null,i,m)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,m=i.length;c<m;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Pe[69],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=void 0;class y{constructor(C,L=[],A=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$wh=y}),define(Pe[70],Ae([1,0,69]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.InstantiationType=void 0;const R=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L(l,I,f){I instanceof y.$wh||(I=new y.$wh(I,[],!!f)),R.push([l,I])}e.$jr=L;function A(){return R}e.$kr=A}),define(Pe[171],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class y{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$1p=y;class R{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const l=this.lookupOrInsertNode(L),I=this.lookupOrInsertNode(A);l.outgoing.set(I.key,I),I.incoming.set(l.key,l)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let l=this.a.get(A);return l||(l=new y(A,L),this.a.set(A,l)),l}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,l]of this.a)L.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const l=new Set([L]),I=this.c(A,l);if(I)return I}}c(L,A){for(const[l,I]of L.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const f=this.c(I,A);if(f)return f;A.delete(l)}}}e.$2p=R}),define(Pe[4],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(I){return I[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(y||(e._util=y={})),e.$yh=C("instantiationService");function R(A,l,I){l[y.DI_TARGET]===l?l[y.DI_DEPENDENCIES].push({id:A,index:I}):(l[y.DI_DEPENDENCIES]=[{id:A,index:I}],l[y.DI_TARGET]=l)}function C(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const l=function(I,f,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(l,I,P)};return l.toString=()=>A,y.serviceIds.set(A,l),l}e.$zh=C;function L(A){return A}e.$Ah=L}),define(Pe[43],Ae([1,0,16,2,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.ConfigurationTarget=e.$8h=e.$7h=e.$6h=void 0,e.$6h=(0,C.$zh)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.$7h=L;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof R.URI)}e.$8h=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function I(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$9h=I;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$0h=f;function P(i,c){const m=Object.create(null);for(const k in i)S(m,k,i[k],c);return m}e.$$h=P;function S(i,c,m,k){const b=c.split("."),n=b.pop();let a=i;for(let r=0;r<b.length;r++){const o=b[r];let w=a[o];switch(typeof w){case"undefined":w=a[o]=Object.create(null);break;case"object":break;default:k(`Ignoring ${c} as ${b.slice(0,r+1).join(".")} is ${JSON.stringify(w)}`);return}a=w}if(typeof a=="object"&&a!==null)try{a[n]=m}catch{k(`Ignoring ${c} as ${b.join(".")} is ${JSON.stringify(a)}`)}else k(`Ignoring ${c} as ${b.join(".")} is ${JSON.stringify(a)}`)}e.$_h=S;function u(i,c){const m=c.split(".");p(i,m)}e.$ai=u;function p(i,c){const m=c.shift();if(c.length===0){delete i[m];return}if(Object.keys(i).indexOf(m)!==-1){const k=i[m];typeof k=="object"&&!Array.isArray(k)&&(p(k,c),Object.keys(k).length===0&&delete i[m])}}function $(i,c,m){function k(a,r){let o=a;for(const w of r){if(typeof o!="object"||o===null)return;o=o[w]}return o}const b=c.split("."),n=k(i,b);return typeof n>"u"?m:n}e.$bi=$;function d(i,c,m){Object.keys(c).forEach(k=>{k!=="__proto__"&&(k in i?y.$ne(i[k])&&y.$ne(c[k])?d(i[k],c[k],m):m&&(i[k]=c[k]):i[k]=c[k])})}e.$ci=d;function t(i){return i.replace(/[\[\]]/g,"")}e.$di=t}),define(Pe[32],Ae([1,0,22,15,169,4,139,9]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.ContextKeyExprType=e.$Ei=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",y.$j),I.set("isLinux",y.$k),I.set("isWindows",y.$i),I.set("isWeb",y.$o),I.set("isMacNative",y.$j&&!y.$o),I.set("isEdge",y.$G),I.set("isFirefox",y.$E),I.set("isChrome",y.$D),I.set("isSafari",y.$F);function f(ue,O){if(I.get(ue)!==void 0)throw(0,l.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set(ue,O)}e.$Ei=f;const P=Object.prototype.hasOwnProperty;var S;(function(ue){ue[ue.False=0]="False",ue[ue.True=1]="True",ue[ue.Defined=2]="Defined",ue[ue.Not=3]="Not",ue[ue.Equals=4]="Equals",ue[ue.NotEquals=5]="NotEquals",ue[ue.And=6]="And",ue[ue.Regex=7]="Regex",ue[ue.NotRegex=8]="NotRegex",ue[ue.Or=9]="Or",ue[ue.In=10]="In",ue[ue.NotIn=11]="NotIn",ue[ue.Greater=12]="Greater",ue[ue.GreaterEquals=13]="GreaterEquals",ue[ue.Smaller=14]="Smaller",ue[ue.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const u={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),$=(0,A.localize)(1,null),d=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),m=(0,A.localize)(6,null),k=(0,A.localize)(7,null);class b{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=u){this.k=O,this.d=new C.$Di,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const he=this.D(),Ee=he.type===17?c:void 0;throw this.h.push({message:i,offset:he.offset,lexeme:C.$Di.getLexeme(he),additionalInfo:Ee}),b.c}return J}catch(J){if(J!==b.c)throw J;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const J=this.o();O.push(J)}return O.length===1?O[0]:n.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const J=this.s();O.push(J)}return O.length===1?O[0]:n.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const J=this.l();return this.A(1,t),J?.negate()}case 17:return this.z(),M.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const J=this.l();return this.A(1,t),J}case 17:{const J=O.lexeme;if(this.z(),this.y(9)){const Ee=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ee.type!==10)throw this.B("REGEX",Ee);const ve=Ee.lexeme,be=ve.lastIndexOf("/"),ke=be===ve.length-1?void 0:this.w(ve.substring(be+1));let oe;try{oe=new RegExp(ve.substring(1,be),ke)}catch{throw this.B("REGEX",Ee)}return z.create(J,oe)}switch(Ee.type){case 10:case 19:{const ve=[Ee.lexeme];this.z();let be=this.D(),ke=0;for(let me=0;me<Ee.lexeme.length;me++)Ee.lexeme.charCodeAt(me)===40?ke++:Ee.lexeme.charCodeAt(me)===41&&ke--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let me=0;me<be.lexeme.length;me++)be.lexeme.charCodeAt(me)===40?ke++:Ee.lexeme.charCodeAt(me)===41&&ke--}if(ke<0)break;ve.push(C.$Di.getLexeme(be)),this.z(),be=this.D()}const oe=ve.join(""),de=oe.lastIndexOf("/"),se=de===oe.length-1?void 0:this.w(oe.substring(de+1));let ne;try{ne=new RegExp(oe.substring(1,de),se)}catch{throw this.B("REGEX",Ee)}return n.regex(J,ne)}case 18:{const ve=Ee.lexeme;this.z();let be=null;if(!(0,R.$od)(ve)){const ke=ve.indexOf("/"),oe=ve.lastIndexOf("/");if(ke!==oe&&ke>=0){const de=ve.slice(ke+1,oe),se=ve[oe+1]==="i"?"i":"";try{be=new RegExp(de,se)}catch{throw this.B("REGEX",Ee)}}}if(be===null)throw this.B("REGEX",Ee);return z.create(J,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const Ee=this.u();return n.notIn(J,Ee)}switch(this.D().type){case 3:{this.z();const Ee=this.u();if(this.x().type===18)return n.equals(J,Ee);switch(Ee){case"true":return n.has(J);case"false":return n.not(J);default:return n.equals(J,Ee)}}case 4:{this.z();const Ee=this.u();if(this.x().type===18)return n.notEquals(J,Ee);switch(Ee){case"true":return n.not(J);case"false":return n.has(J);default:return n.notEquals(J,Ee)}}case 5:return this.z(),j.create(J,this.u());case 6:return this.z(),U.create(J,this.u());case 7:return this.z(),V.create(J,this.u());case 8:return this.z(),B.create(J,this.u());case 13:return this.z(),n.in(J,this.u());default:return n.has(J)}}case 20:throw this.h.push({message:m,offset:O.offset,lexeme:"",additionalInfo:k}),b.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,J){if(this.C(O))return this.z();throw this.B(J,this.D())}B(O,J,he){const Ee=(0,A.localize)(8,null,O,C.$Di.getLexeme(J)),ve=J.offset,be=C.$Di.getLexeme(J);return this.h.push({message:Ee,offset:ve,lexeme:be,additionalInfo:he}),b.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Fi=b;class n{static false(){return w.INSTANCE}static true(){return v.INSTANCE}static has(O){return E.create(O)}static equals(O,J){return D.create(O,J)}static notEquals(O,J){return g.create(O,J)}static regex(O,J){return z.create(O,J)}static in(O,J){return s.create(O,J)}static notIn(O,J){return h.create(O,J)}static not(O){return M.create(O)}static and(...O){return ye.create(O,null,!0)}static or(...O){return De.create(O,null,!0)}static greater(O,J){return V.create(O,J)}static greaterEquals(O,J){return B.create(O,J)}static smaller(O,J){return j.create(O,J)}static smallerEquals(O,J){return U.create(O,J)}static{this.c=new b({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Gi=n;function a(ue){const O=new b({regexParsingWithErrorRecovery:!1});return ue.map(J=>(O.parse(J),O.lexingErrors.length>0?O.lexingErrors.map(he=>({errorMessage:he.additionalInfo?(0,A.localize)(9,null,he.additionalInfo):(0,A.localize)(10,null),offset:he.offset,length:he.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(he=>({errorMessage:he.additionalInfo?`${he.message}. ${he.additionalInfo}`:he.message,offset:he.offset,length:he.lexeme.length})):[]))}e.$Hi=a;function r(ue,O){const J=ue?ue.substituteConstants():void 0,he=O?O.substituteConstants():void 0;return!J&&!he?!0:!J||!he?!1:J.equals(he)}e.$Ii=r;function o(ue,O){return ue.cmp(O)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return v.INSTANCE}}e.$Ji=w;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return w.INSTANCE}}e.$Ki=v;class E{static create(O,J=null){const he=I.get(O);return typeof he=="boolean"?he?v.INSTANCE:w.INSTANCE:new E(O,J)}constructor(O,J){this.key=O,this.c=J,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:Y(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=I.get(this.key);return typeof O=="boolean"?O?v.INSTANCE:w.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Li=E;class D{static create(O,J,he=null){if(typeof J=="boolean")return J?E.create(O,he):M.create(O,he);const Ee=I.get(O);return typeof Ee=="boolean"?J===(Ee?"true":"false")?v.INSTANCE:w.INSTANCE:new D(O,J,he)}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=I.get(this.c);if(typeof O=="boolean"){const J=O?"true":"false";return this.d===J?v.INSTANCE:w.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.$Mi=D;class s{static create(O,J){return new s(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:le(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const J=O.getValue(this.f),he=O.getValue(this.d);return Array.isArray(J)?J.includes(he):typeof he=="string"&&typeof J=="object"&&J!==null?P.call(J,he):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.$Ni=s;class h{static create(O,J){return new h(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=11,this.c=s.create(O,J)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oi=h;class g{static create(O,J,he=null){if(typeof J=="boolean")return J?M.create(O,he):E.create(O,he);const Ee=I.get(O);return typeof Ee=="boolean"?J===(Ee?"true":"false")?w.INSTANCE:v.INSTANCE:new g(O,J,he)}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=I.get(this.c);if(typeof O=="boolean"){const J=O?"true":"false";return this.d===J?w.INSTANCE:v.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Pi=g;class M{static create(O,J=null){const he=I.get(O);return typeof he=="boolean"?he?w.INSTANCE:v.INSTANCE:new M(O,J)}constructor(O,J){this.c=O,this.d=J,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:Y(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=I.get(this.c);return typeof O=="boolean"?O?w.INSTANCE:v.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$Qi=M;function W(ue,O){if(typeof ue=="string"){const J=parseFloat(ue);isNaN(J)||(ue=J)}return typeof ue=="string"||typeof ue=="number"?O(ue):w.INSTANCE}class V{static create(O,J,he=null){return W(J,Ee=>new V(O,Ee,he))}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ri=V;class B{static create(O,J,he=null){return W(J,Ee=>new B(O,Ee,he))}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Si=B;class j{static create(O,J,he=null){return W(J,Ee=>new j(O,Ee,he))}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ti=j;class U{static create(O,J,he=null){return W(J,Ee=>new U(O,Ee,he))}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Ui=U;class z{static create(O,J){return new z(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const J=this.f?this.f.source:"",he=O.f?O.f.source:"";return J<he?-1:J>he?1:0}equals(O){if(O.type===this.type){const J=this.f?this.f.source:"",he=O.f?O.f.source:"";return this.d===O.d&&J===he}return!1}substituteConstants(){return this}evaluate(O){const J=O.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Vi=z;class ie{static create(O){return new ie(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ie(this.c.map(O))}negate(){return this.c}}e.$Wi=ie;function X(ue){let O=null;for(let J=0,he=ue.length;J<he;J++){const Ee=ue[J].substituteConstants();if(ue[J]!==Ee&&O===null){O=[];for(let ve=0;ve<J;ve++)O[ve]=ue[ve]}O!==null&&(O[J]=Ee)}return O===null?ue:O}class ye{static create(O,J,he){return ye.d(O,J,he)}constructor(O,J){this.expr=O,this.c=J,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let J=0,he=this.expr.length;J<he;J++){const Ee=o(this.expr[J],O.expr[J]);if(Ee!==0)return Ee}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let J=0,he=this.expr.length;J<he;J++)if(!this.expr[J].equals(O.expr[J]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:ye.create(O,this.c,!1)}evaluate(O){for(let J=0,he=this.expr.length;J<he;J++)if(!this.expr[J].evaluate(O))return!1;return!0}static d(O,J,he){const Ee=[];let ve=!1;for(const be of O)if(be){if(be.type===1){ve=!0;continue}if(be.type===0)return w.INSTANCE;if(be.type===6){Ee.push(...be.expr);continue}Ee.push(be)}if(Ee.length===0&&ve)return v.INSTANCE;if(Ee.length!==0){if(Ee.length===1)return Ee[0];Ee.sort(o);for(let be=1;be<Ee.length;be++)Ee[be-1].equals(Ee[be])&&(Ee.splice(be,1),be--);if(Ee.length===1)return Ee[0];for(;Ee.length>1;){const be=Ee[Ee.length-1];if(be.type!==9)break;Ee.pop();const ke=Ee.pop(),oe=Ee.length===0,de=De.create(be.expr.map(se=>ye.create([se,ke],null,he)),null,oe);de&&(Ee.push(de),Ee.sort(o))}if(Ee.length===1)return Ee[0];if(he){for(let be=0;be<Ee.length;be++)for(let ke=be+1;ke<Ee.length;ke++)if(Ee[be].negate().equals(Ee[ke]))return w.INSTANCE;if(Ee.length===1)return Ee[0]}return new ye(Ee,J)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const J of this.expr)O.push(...J.keys());return O}map(O){return new ye(this.expr.map(J=>J.map(O)),null)}negate(){if(!this.c){const O=[];for(const J of this.expr)O.push(J.negate());this.c=De.create(O,this,!0)}return this.c}}e.$Xi=ye;class De{static create(O,J,he){return De.d(O,J,he)}constructor(O,J){this.expr=O,this.c=J,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let J=0,he=this.expr.length;J<he;J++){const Ee=o(this.expr[J],O.expr[J]);if(Ee!==0)return Ee}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let J=0,he=this.expr.length;J<he;J++)if(!this.expr[J].equals(O.expr[J]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:De.create(O,this.c,!1)}evaluate(O){for(let J=0,he=this.expr.length;J<he;J++)if(this.expr[J].evaluate(O))return!0;return!1}static d(O,J,he){let Ee=[],ve=!1;if(O){for(let be=0,ke=O.length;be<ke;be++){const oe=O[be];if(oe){if(oe.type===0){ve=!0;continue}if(oe.type===1)return v.INSTANCE;if(oe.type===9){Ee=Ee.concat(oe.expr);continue}Ee.push(oe)}}if(Ee.length===0&&ve)return w.INSTANCE;Ee.sort(o)}if(Ee.length!==0){if(Ee.length===1)return Ee[0];for(let be=1;be<Ee.length;be++)Ee[be-1].equals(Ee[be])&&(Ee.splice(be,1),be--);if(Ee.length===1)return Ee[0];if(he){for(let be=0;be<Ee.length;be++)for(let ke=be+1;ke<Ee.length;ke++)if(Ee[be].negate().equals(Ee[ke]))return v.INSTANCE;if(Ee.length===1)return Ee[0]}return new De(Ee,J)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const J of this.expr)O.push(...J.keys());return O}map(O){return new De(this.expr.map(J=>J.map(O)),null)}negate(){if(!this.c){const O=[];for(const J of this.expr)O.push(J.negate());for(;O.length>1;){const J=O.shift(),he=O.shift(),Ee=[];for(const ve of x(J))for(const be of x(he))Ee.push(ye.create([ve,be],null,!1));O.unshift(De.create(Ee,null,!1))}this.c=De.create(O,this,!0)}return this.c}}e.$Yi=De;class Re extends E{static{this.d=[]}static all(){return Re.d.values()}constructor(O,J,he){super(O,null),this.f=J,typeof he=="object"?Re.d.push({...he,key:O}):he!==!0&&Re.d.push({key:O,description:he,type:J!=null?typeof J:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return D.create(this.key,O)}notEqualsTo(O){return g.create(this.key,O)}}e.$Zi=Re,e.$1i=(0,L.$zh)("contextKeyService");function Y(ue,O){return ue<O?-1:ue>O?1:0}function le(ue,O,J,he){return ue<J?-1:ue>J?1:O<he?-1:O>he?1:0}function we(ue,O){if(ue.type===0||O.type===1)return!0;if(ue.type===9)return O.type===9?ae(ue.expr,O.expr):!1;if(O.type===9){for(const J of O.expr)if(we(ue,J))return!0;return!1}if(ue.type===6){if(O.type===6)return ae(O.expr,ue.expr);for(const J of ue.expr)if(we(J,O))return!0;return!1}return ue.equals(O)}e.$2i=we;function ae(ue,O){let J=0,he=0;for(;J<ue.length&&he<O.length;){const Ee=ue[J].cmp(O[he]);if(Ee<0)return!1;Ee===0&&J++,he++}return J===ue.length}function x(ue){return ue.type===9?ue.expr:[ue]}}),define(Pe[172],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=void 0,e.$Gh=(0,y.$zh)("environmentService"),e.$Hh=(0,y.$Ah)(e.$Gh)}),define(Pe[92],Ae([1,0,141,4]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Xn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0,e.$Kn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ln=new RegExp(e.$Kn),e.$Mn="__web_extension",e.$Nn="skipWalkthrough",e.$On="extensionsSync",e.$Pn="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Qn=C;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Rn=L;function A(c,m){switch(c){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Sn=A;function l(c,m){return m==="web"&&!c.includes("web")}e.$Tn=l;function I(c,m,k){return l(m,k)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===k?!0:f(k).includes(c)}e.$Un=I;function f(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Vn=f;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Wn=P;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var u;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var p;(function(c){c.Install="install",c.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var $;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Xn=(0,R.$zh)("extensionGalleryService");var d;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(m,k){super(m),this.code=k,this.name=k}}e.$Yn=i,e.$Zn=(0,R.$zh)("extensionManagementService"),e.$1n="extensionsIdentifiers/disabled",e.$2n="extensionsIdentifiers/enabled",e.$3n=(0,R.$zh)("IGlobalExtensionEnablementService"),e.$4n=(0,R.$zh)("IExtensionTipsService"),e.$5n=(0,y.localize)(0,null),e.$6n={value:e.$5n,original:"Extensions"},e.$7n={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Pe[38],Ae([1,0,48,19,15,16,2,143,4,22,12]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileKind=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileOperationResult=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileChangeType=e.$ik=e.FileOperation=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderErrorCode=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$5j=e.$4j=void 0,e.$4j=(0,I.$zh)("fileService");function S(Y){return Y.create===!0}e.$5j=S;var u;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var p;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var $;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function d(Y){return!!(Y.capabilities&2)}e.$6j=d;function t(Y){return!!(Y.capabilities&8)}e.$7j=t;function i(Y){return!!(Y.capabilities&131072)}e.$8j=i;function c(Y){return!!(Y.capabilities&4)}e.$9j=c;function m(Y){return!!(Y.capabilities&16)}e.$0j=m;function k(Y){return d(Y)?!!(Y.capabilities&16384):!1}e.$$j=k;function b(Y){return d(Y)?!!(Y.capabilities&32768):!1}e.$_j=b;function n(Y){return!!(Y.capabilities&65536)}e.$ak=n;function a(Y){return!!(Y.capabilities&2048)}e.$bk=a;var r;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(le,we){const ae=new o(le.toString(),we);return E(ae,we),ae}constructor(le,we){super(le),this.code=we}}e.$ck=o;function w(Y,le){return o.create(Y,le)}e.$dk=w;function v(Y){return Y||w((0,l.localize)(0,null),r.Unknown)}e.$ek=v;function E(Y,le){return Y.name=le?`${le} (FileSystemError)`:"FileSystemError",Y}e.$fk=E;function D(Y){if(!Y)return r.Unknown;if(Y instanceof o)return Y.code;const le=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!le)return r.Unknown;switch(le[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$gk=D;function s(Y){if(Y instanceof B)return Y.fileOperationResult;switch(D(Y)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$hk=s;var h;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class g{constructor(le,we,ae){this.resource=le,this.operation=we,this.target=ae}isOperation(le){return this.operation===le}}e.$ik=g;var M;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class W{constructor(le,we){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const x of le){const ue=ae.get(x.type);switch(ue?ue.push([x.resource,x]):ae.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,ue]of ae)switch(x){case 1:this.a=y.$Fh.forUris(()=>we),this.a.fill(ue);break;case 0:this.b=y.$Fh.forUris(()=>we),this.b.fill(ue);break;case 2:this.c=y.$Fh.forUris(()=>we),this.c.fill(ue);break}}contains(le,...we){return this.d(le,{includeChildren:!1},...we)}affects(le,...we){return this.d(le,{includeChildren:!0},...we)}d(le,we,...ae){if(!le)return!1;const x=ae.length>0;return!!((!x||ae.includes(1))&&(this.a?.get(le)||we.includeChildren&&this.a?.findSuperstr(le))||(!x||ae.includes(0))&&(this.b?.get(le)||we.includeChildren&&this.b?.findSuperstr(le))||(!x||ae.includes(2))&&(this.c?.findSubstr(le)||we.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$jk=W;function V(Y,le,we){return!Y||!le||Y===le||le.length>Y.length?!1:(le.charAt(le.length-1)!==R.sep&&(le+=R.sep),we?(0,C.$Pd)(Y,le):Y.indexOf(le)===0)}e.$kk=V;class B extends Error{constructor(le,we,ae){super(le),this.fileOperationResult=we,this.options=ae}}e.$lk=B;class j extends B{constructor(le,we,ae,x){super(le,we,x),this.fileOperationResult=we,this.size=ae}}e.$mk=j;class U extends B{constructor(le,we,ae){super(le,2,ae),this.stat=we}}e.$nk=U;var z;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.$ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$qk="files.associations",e.$rk="files.exclude",e.$sk="files.readonlyInclude",e.$tk="files.readonlyExclude",e.$uk="files.readonlyFromPermissions";var ie;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie||(e.FileKind=ie={})),e.$vk="";function X(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.$wk=X;async function ye(Y,le){if(!le.hasProvider(A.URI.from({scheme:Y.scheme})))return new Promise(we=>{const ae=le.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===Y.scheme&&x.added&&(ae.dispose(),we())})})}e.$xk=ye;class De{static{this.KB=1024}static{this.MB=De.KB*De.KB}static{this.GB=De.MB*De.KB}static{this.TB=De.GB*De.KB}static formatSize(le){return(0,L.$pe)(le)||(le=0),le<De.KB?(0,l.localize)(1,null,le.toFixed(0)):le<De.MB?(0,l.localize)(2,null,(le/De.KB).toFixed(2)):le<De.GB?(0,l.localize)(3,null,(le/De.MB).toFixed(2)):le<De.TB?(0,l.localize)(4,null,(le/De.GB).toFixed(2)):(0,l.localize)(5,null,(le/De.TB).toFixed(2))}}e.$yk=De;function Re(Y){const le=typeof Y=="string"||Y?.scheme===P.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===P.Schemas.file?1024*De.MB:le?10*De.MB:f.$o?50*De.MB:1024*De.MB}e.$zk=Re}),define(Pe[71],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class y{constructor(...C){this.a=new Map;for(const[L,A]of C)this.set(L,A)}set(C,L){const A=this.a.get(C);return this.a.set(C,L),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$xh=y}),define(Pe[173],Ae([1,0,13,9,6,69,171,4,71,174]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;const P=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new I.$xh,i=!1,c,m=P){this.f=t,this.g=i,this.h=c,this.i=m,this.o=new Set,this.f.set(l.$yh,this),this._globalGraph=m?c?._globalGraph??new A.$2p(k=>k):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const c=$.traceInvocation(this.i,t);let m=!1;try{return t({get:b=>{if(m)throw(0,R.$6)("service accessor is only valid during the invocation of its target method");const n=this.m(b,c);if(!n)throw new Error(`[invokeFunction] unknown service '${b}'`);return n}},...i)}finally{m=!0,c.stop()}}createInstance(t,...i){let c,m;return t instanceof L.$wh?(c=$.traceCreation(this.i,t.ctor),m=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=$.traceCreation(this.i,t),m=this.j(t,i,c)),c.stop(),m}j(t,i=[],c){const m=l._util.getServiceDependencies(t).sort((n,a)=>n.index-a.index),k=[];for(const n of m){const a=this.m(n.id,c);a||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),k.push(a)}const b=m.length>0?m[0].index:i.length;if(i.length!==b){console.trace(`[createInstance] First service dependency of ${t.name} at position ${b+1} conflicts with ${i.length} static arguments`);const n=b-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,b)}return Reflect.construct(t,i.concat(k))}k(t,i){if(this.f.get(t)instanceof L.$wh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof L.$wh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const m=new A.$2p(n=>n.id.toString());let k=0;const b=[{id:t,desc:i,_trace:c}];for(;b.length;){const n=b.pop();if(m.lookupOrInsertNode(n),k++>1e3)throw new S(m);for(const a of l._util.getServiceDependencies(n.desc.ctor)){const r=this.l(a.id);if(r||this.u(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(a.id)),r instanceof L.$wh){const o={id:a.id,desc:r,_trace:n._trace.branch(a.id,!0)};m.insertEdge(n,o),b.push(o)}}}for(;;){const n=m.roots();if(n.length===0){if(!m.isEmpty())throw new S(m);break}for(const{data:a}of n){if(this.l(a.id)instanceof L.$wh){const o=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,o)}m.removeNode(a)}}return this.l(t)}s(t,i,c=[],m,k){if(this.f.get(t)instanceof L.$wh)return this.t(t,i,c,m,k);if(this.h)return this.h.s(t,i,c,m,k);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],m,k){if(m){const b=new u(void 0,this.g,this,this.i);b.c=String(t);const n=new Map,a=new y.$Vg(()=>{const r=b.j(i,c,k);for(const[o,w]of n){const v=r[o];if(typeof v=="function")for(const E of w)v.apply(r,E)}return n.clear(),r});return new Proxy(Object.create(null),{get(r,o){if(!a.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let E=n.get(o);return E||(E=new f.$vb,n.set(o,E)),(s,h,g)=>{const M=E.push([s,h,g]);return(0,C.$kb)(M)}}if(o in r)return r[o];const w=a.value;let v=w[o];return typeof v!="function"||(v=v.bind(w),r[o]=v),v},set(r,o,w){return a.value[o]=w,!0},getPrototypeOf(r){return i.prototype}})}else return this.j(i,c,k)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$3p=u;var p;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(p||(p={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new $(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function c(k,b){const n=[],a=new Array(k+1).join("	");for(const[r,o,w]of b.h)if(o&&w){i=!0,n.push(`${a}CREATES -> ${r}`);const v=c(k+1,w);v&&n.push(v)}else n.push(`${a}uses -> ${r}`);return n.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(m.join(`
`))}}e.$4p=$}),define(Pe[14],Ae([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.log=e.$6i=e.LogLevel=e.$5i=e.$4i=e.$3i=void 0,e.$3i=(0,u.$zh)("logService"),e.$4i=(0,u.$zh)("loggerService");function p(){return new Date().toISOString()}function $(s){return(0,f.$pe)(s)}e.$5i=$;var d;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$6i=d.Info;function t(s,h,g){switch(h){case d.Trace:s.trace(g);break;case d.Debug:s.debug(g);break;case d.Info:s.info(g);break;case d.Warning:s.warn(g);break;case d.Error:s.error(g);break;case d.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=t;function i(s,h=!1){let g="";for(let M=0;M<s.length;M++){let W=s[M];if(W instanceof Error&&(W=(0,y.$ki)(W,h)),typeof W=="object")try{W=JSON.stringify(W)}catch{}g+=(M>0?" ":"")+W}return g}class c extends L.$mb{constructor(){super(...arguments),this.b=e.$6i,this.c=this.B(new R.$hc),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==d.Off&&this.b<=h}}e.$8i=c;class m extends c{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...g){this.f(d.Trace)&&this.g(d.Trace,i([h,...g],!0))}debug(h,...g){this.f(d.Debug)&&this.g(d.Debug,i([h,...g]))}info(h,...g){this.f(d.Info)&&this.g(d.Info,i([h,...g]))}warn(h,...g){this.f(d.Warning)&&this.g(d.Warning,i([h,...g]))}error(h,...g){if(this.f(d.Error))if(h instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=h.stack,this.g(d.Error,i(M))}else this.g(d.Error,i([h,...g]))}flush(){}}e.$9i=m;class k extends c{constructor(h=e.$6i){super(),this.setLevel(h),this.g=!l.$i}trace(h,...g){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,h,...g):console.log(`[main ${p()}]`,h,...g))}debug(h,...g){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,h,...g):console.log(`[main ${p()}]`,h,...g))}info(h,...g){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,h,...g):console.log(`[main ${p()}]`,h,...g))}warn(h,...g){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,h,...g):console.warn(`[main ${p()}]`,h,...g))}error(h,...g){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,h,...g):console.error(`[main ${p()}]`,h,...g))}dispose(){}flush(){}}e.$0i=k;class b extends c{constructor(h=e.$6i,g=!0){super(),this.g=g,this.setLevel(h)}trace(h,...g){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",h,...g):console.log(h,...g))}debug(h,...g){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",h,...g):console.log(h,...g))}info(h,...g){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",h,...g):console.log(h,...g))}warn(h,...g){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",h,...g):console.log(h,...g))}error(h,...g){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",h,...g):console.error(h,...g))}dispose(){}flush(){}}e.$$i=b;class n extends c{constructor(h,g=e.$6i){super(),this.g=h,this.setLevel(g)}trace(h,...g){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(h),...g])}debug(h,...g){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(h),...g])}info(h,...g){this.f(d.Info)&&this.g.log(d.Info,[this.h(h),...g])}warn(h,...g){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(h),...g])}error(h,...g){this.f(d.Error)&&this.g.log(d.Error,[this.h(h),...g])}h(h){return typeof h=="string"?h:(0,y.$ki)(h,this.f(d.Trace))}dispose(){}flush(){}}e.$_i=n;class a extends c{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const g of this.g)g.setLevel(h);super.setLevel(h)}trace(h,...g){for(const M of this.g)M.trace(h,...g)}debug(h,...g){for(const M of this.g)M.debug(h,...g)}info(h,...g){for(const M of this.g)M.info(h,...g)}warn(h,...g){for(const M of this.g)M.warn(h,...g)}error(h,...g){for(const M of this.g)M.error(h,...g)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.$aj=a;class r extends L.$mb{constructor(h,g,M){if(super(),this.h=h,this.j=g,this.b=new A.$xi,this.c=this.B(new R.$hc),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$hc),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$hc),this.onDidChangeVisibility=this.g.event,M)for(const W of M)this.b.set(W.resource,{logger:void 0,info:W})}k(h){return(0,f.$le)(h)?[...this.b.values()].find(g=>g.info.id===h):this.b.get(h)}getLogger(h){return this.k(h)?.logger}createLogger(h,g){const M=this.l(h),W=(0,f.$le)(h)?h:g?.id??(0,C.$ni)(M.toString()).toString(16);let V=this.b.get(M)?.logger;const B=g?.logLevel==="always"?d.Trace:g?.logLevel;V||(V=this.m(M,B??this.getLogLevel(M)??this.h,{...g,id:W}));const j={logger:V,info:{resource:M,id:W,logLevel:B,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger(j.info),this.b.set(M,j),V}l(h){return(0,f.$le)(h)?(0,I.$gg)(this.j,`${h}.log`):h}setLogLevel(h,g){if(P.URI.isUri(h)){const M=h,W=g,V=this.b.get(M);V&&W!==V.info.logLevel&&(V.info.logLevel=W===this.h?void 0:W,V.logger?.setLevel(W),this.b.set(V.info.resource,V),this.f.fire([M,W]))}else{this.h=h;for(const[M,W]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,g){const M=this.k(h);M&&g!==!M.info.hidden&&(M.info.hidden=!g,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,g]))}getLogLevel(h){let g;return h&&(g=this.b.get(h)?.info.logLevel),g??this.h}registerLogger(h){const g=this.b.get(h.resource);g?g.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const g=this.b.get(h);g&&(g.logger&&g.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bj=r;class o{constructor(){this.onDidChangeLogLevel=new R.$hc().event}setLevel(h){}getLevel(){return d.Info}trace(h,...g){}debug(h,...g){}info(h,...g){}warn(h,...g){}error(h,...g){}critical(h,...g){}dispose(){}flush(){}}e.$cj=o;class w extends o{}e.$dj=w;function v(s){if(s.verbose)return d.Trace;if(typeof s.logLevel=="string"){const h=D(s.logLevel.toLowerCase());if(h!==void 0)return h}return e.$6i}e.$ej=v;function E(s){switch(s){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.$fj=E;function D(s){switch(s){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$gj=D,e.$hj=new S.$Zi("logLevel",E(d.Info))}),define(Pe[175],Ae([1,0,6,14]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=void 0;class C extends y.$mb{constructor(A,l=[]){super(),this.a=new R.$aj([A,...l]),this.B(A.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$dN=C}),define(Pe[94],Ae([1,0,29,144,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(I){I[I.Unnecessary=1]="Unnecessary",I[I.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(I){I[I.Hint=1]="Hint",I[I.Info=2]="Info",I[I.Warning=4]="Warning",I[I.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(I){function f($,d){return d-$}I.compare=f;const P=Object.create(null);P[I.Error]=(0,R.localize)(0,null),P[I.Warning]=(0,R.localize)(1,null),P[I.Info]=(0,R.localize)(2,null);function S($){return P[$]||""}I.toString=S;function u($){switch($){case y.default.Error:return I.Error;case y.default.Warning:return I.Warning;case y.default.Info:return I.Info;case y.default.Ignore:return I.Hint}}I.fromSeverity=u;function p($){switch($){case I.Error:return y.default.Error;case I.Warning:return y.default.Warning;case I.Info:return y.default.Info;case I.Hint:return y.default.Ignore}}I.toSeverity=p}(A||(e.MarkerSeverity=A={}));var l;(function(I){const f="";function P(u){return S(u,!0)}I.makeKey=P;function S(u,p){const $=[f];return u.source?$.push(u.source.replace("\xA6","\\\xA6")):$.push(f),u.code?typeof u.code=="string"?$.push(u.code.replace("\xA6","\\\xA6")):$.push(u.code.value.replace("\xA6","\\\xA6")):$.push(f),u.severity!==void 0&&u.severity!==null?$.push(A.toString(u.severity)):$.push(f),u.message&&p?$.push(u.message.replace("\xA6","\\\xA6")):$.push(f),u.startLineNumber!==void 0&&u.startLineNumber!==null?$.push(u.startLineNumber.toString()):$.push(f),u.startColumn!==void 0&&u.startColumn!==null?$.push(u.startColumn.toString()):$.push(f),u.endLineNumber!==void 0&&u.endLineNumber!==null?$.push(u.endLineNumber.toString()):$.push(f),u.endColumn!==void 0&&u.endColumn!==null?$.push(u.endColumn.toString()):$.push(f),$.push(f),$.join("\xA6")}I.makeKeyOptionalMessage=S})(l||(e.IMarkerData=l={})),e.$Zs=(0,C.$zh)("markerService")}),define(Pe[176],Ae([1,0,5,29,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Vu=e.Severity=void 0,e.Severity=R.default,e.$Vu=(0,C.$zh)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class I{constructor(){this.progress=new f,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$Wu=I;class f{infinite(){}done(){}total(S){}worked(S){}}e.$Xu=f}),define(Pe[95],Ae([1,0,15,2,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DT=e.$CT=e.$BT=e.$AT=e.$zT=void 0,e.$zT=(0,C.$zh)("openerService");function L(f,P){return R.URI.isUri(f)?(0,y.$Od)(f.scheme,P):(0,y.$Pd)(f,P+":")}e.$AT=L;function A(f,...P){return P.some(S=>L(f,S))}e.$BT=A;function l(f,P){return f.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$CT=l;function I(f){let P;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return S&&(P={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},f=f.with({fragment:""})),{selection:P,uri:f}}e.$DT=I}),define(Pe[177],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=void 0,e.$ij=(0,y.$zh)("productService"),e.$jj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(pe,e,y,R){var C=arguments.length,L=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,y):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(pe,e,y,R);else for(var l=pe.length-1;l>=0;l--)(A=pe[l])&&(L=(C<3?A(L):C>3?A(e,y,L):A(e,y))||L);return C>3&&L&&Object.defineProperty(e,y,L),L},Ve=this&&this.__param||function(pe,e){return function(y,R){e(y,R,pe)}};define(Pe[72],Ae([1,0,13,21,6,4]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.ProgressLocation=e.$Yu=void 0,e.$Yu=(0,L.$zh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Zu=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(S,u){this.c=S,this.report=u?.async?this.e.bind(this):this.d.bind(this)}d(S){this.a=S,this.c(this.a)}e(S){Promise.resolve(this.b).finally(()=>{this.a=S;const u=this.c(this.a);this.b=Promise.resolve(u).finally(()=>this.b=void 0)})}}e.$1u=l;let I=class extends C.$mb{constructor(S,u){super(),this.a=new y.$Zg,u.withProgress(S,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$kb)(()=>this.a.complete()))}report(S){this.b?this.b.report(S):this.c=S}};e.$2u=I,e.$2u=I=Ke([Ve(1,e.$Yu)],I);class f extends C.$mb{constructor(S){super(),this.g=S,this.a=0,this.b=this.B(new C.$lb)}start(S){this.stop();const u=++this.a,p=new R.$rc;return this.f=setTimeout(()=>{u===this.a&&(this.c=this.g.show(!0))},S),this.b.add((0,C.$kb)(()=>clearTimeout(this.f))),this.b.add((0,C.$kb)(()=>p.cancel())),this.b.add((0,C.$kb)(()=>this.c?this.c.done():void 0)),{id:u,token:p.token,stop:()=>this.h(u),isCurrent:()=>this.a===u}}stop(){this.h(this.a)}h(S){this.a===S&&this.b.clear()}}e.$3u=f,e.$4u=(0,L.$zh)("editorProgressService")}),define(Pe[30],Ae([1,0,50,16]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;class C{constructor(){this.a=new Map}add(A,l){y.ok(R.$le(A)),y.ok(R.$ne(l)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$6m=new C}),define(Pe[73],Ae([1,0,5,30]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$7m={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class L{constructor(){this.b=new y.$hc,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,f){this.a[C(I)]=f,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;R.$6m.add(e.$7m.JSONContribution,A)}),define(Pe[96],Ae([1,0,18,5,16,138,43,73,30]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ConfigurationScope=e.$$m=e.EditPresentationTypes=void 0;var f;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$$m={Configuration:"base.contributions.configuration"};var P;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$_m={properties:{},patternProperties:{}},e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn="vscode://schemas/settings/resourceLanguage",e.$gn="vscode://schemas/settings/configurationDefaults";const S=I.$6m.as(l.$7m.JSONContribution);class u{constructor(){this.h=new Set,this.i=new R.$hc,this.onDidSchemaChange=this.i.event,this.j=new R.$hc,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$fn,this.g),this.v()}registerConfiguration(n,a=!0){this.registerConfigurations([n],a)}registerConfigurations(n,a=!0){const r=new Set;this.n(n,a,r),S.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(n){const a=new Set;this.o(n,a),S.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:n,remove:a}){const r=new Set;this.o(a,r),this.n(n,!1,r),S.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(n){const a=new Set;this.k(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(n,a){const r=[];for(const{overrides:o,source:w}of n)for(const v in o)if(a.add(v),e.$in.test(v)){const E=this.a.get(v),D=E?.valuesSources??new Map;if(w)for(const M of Object.keys(o[v]))D.set(M,w);const s={...E?.value||{},...o[v]};this.a.set(v,{source:w,value:s,valuesSources:D});const h=(0,A.$di)(v),g={type:"object",default:s,description:L.localize(1,null,h),$ref:e.$fn,defaultDefaultValue:s,source:C.$le(w)?void 0:w,defaultValueSource:w};r.push(...d(v)),this.d[v]=g,this.b.properties[v]=g}else{this.a.set(v,{value:o[v],source:w});const E=this.d[v];E&&(this.w(v,E),this.r(v,E))}this.m(r)}deregisterDefaultConfigurations(n){const a=new Set;this.l(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(n,a){for(const{overrides:r,source:o}of n)for(const w in r){const v=this.a.get(w),E=C.$le(o)?o:o?.id,D=C.$le(v?.source)?v?.source:v?.source?.id;if(E===D)if(a.add(w),this.a.delete(w),e.$in.test(w))delete this.d[w],delete this.b.properties[w];else{const s=this.d[w];s&&(this.w(w,s),this.r(w,s))}}this.u()}deltaConfiguration(n){let a=!1;const r=new Set;n.removedDefaults&&(this.l(n.removedDefaults,r),a=!0),n.addedDefaults&&(this.k(n.addedDefaults,r),a=!0),n.removedConfigurations&&this.o(n.removedConfigurations,r),n.addedConfigurations&&this.n(n.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const a of n)this.h.add(a);this.u()}n(n,a,r){n.forEach(o=>{this.p(o,a,o.extensionInfo,o.restrictedProperties,void 0,r),this.c.push(o),this.q(o)})}o(n,a){const r=o=>{if(o.properties)for(const w in o.properties){a.add(w);const v=this.d[w];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[w],this.s(w,o.properties[w])}o.allOf?.forEach(w=>r(w))};for(const o of n){r(o);const w=this.c.indexOf(o);w!==-1&&this.c.splice(w,1)}}p(n,a=!0,r,o,w=3,v){w=C.$ue(n.scope)?w:n.scope;const E=n.properties;if(E)for(const s in E){const h=E[s];if(a&&m(s,h)){delete E[s];continue}if(h.source=r,h.defaultDefaultValue=E[s].default,this.w(s,h),e.$in.test(s)?h.scope=void 0:(h.scope=C.$ue(h.scope)?w:h.scope,h.restricted=C.$ue(h.restricted)?!!o?.includes(s):h.restricted),E[s].hasOwnProperty("included")&&!E[s].included){this.f[s]=E[s],delete E[s];continue}else this.d[s]=E[s],E[s].policy?.name&&this.e.set(E[s].policy.name,s);!E[s].deprecationMessage&&E[s].markdownDeprecationMessage&&(E[s].deprecationMessage=E[s].markdownDeprecationMessage),v.add(s)}const D=n.allOf;if(D)for(const s of D)this.p(s,a,r,o,w,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const a=r=>{const o=r.properties;if(o)for(const v in o)this.r(v,o[v]);r.allOf?.forEach(a)};a(n)}r(n,a){switch(e.$_m.properties[n]=a,a.scope){case 1:e.$an.properties[n]=a;break;case 2:e.$bn.properties[n]=a;break;case 6:e.$cn.properties[n]=a;break;case 3:e.$dn.properties[n]=a;break;case 4:e.$en.properties[n]=a;break;case 5:e.$en.properties[n]=a,this.g.properties[n]=a;break}}s(n,a){switch(delete e.$_m.properties[n],a.scope){case 1:delete e.$an.properties[n];break;case 2:delete e.$bn.properties[n];break;case 6:delete e.$cn.properties[n];break;case 3:delete e.$dn.properties[n];break;case 4:case 5:delete e.$en.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const a=`[${n}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$fn};this.w(a,r),e.$_m.properties[a]=r,e.$an.properties[a]=r,e.$bn.properties[a]=r,e.$cn.properties[a]=r,e.$dn.properties[a]=r,e.$en.properties[a]=r}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$fn};e.$_m.patternProperties[e.$hn]=n,e.$an.patternProperties[e.$hn]=n,e.$bn.patternProperties[e.$hn]=n,e.$cn.patternProperties[e.$hn]=n,e.$dn.patternProperties[e.$hn]=n,e.$en.patternProperties[e.$hn]=n,this.i.fire()}w(n,a){const r=this.a.get(n);let o=r?.value,w=r?.source;C.$se(o)&&(o=a.defaultDefaultValue,w=void 0),C.$se(o)&&(o=i(a.type)),a.default=o,a.defaultValueSource=w}}const p="\\[([^\\]]+)\\]",$=new RegExp(p,"g");e.$hn=`^(${p})+$`,e.$in=new RegExp(e.$hn);function d(b){const n=[];if(e.$in.test(b)){let a=$.exec(b);for(;a?.length;){const r=a[1].trim();r&&n.push(r),a=$.exec(b)}}return(0,y.$Ff)(n)}e.$jn=d;function t(b){return b.reduce((n,a)=>`${n}[${a}]`,"")}e.$kn=t;function i(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ln=i;const c=new u;I.$6m.add(e.$$m.Configuration,c);function m(b,n){return b.trim()?e.$in.test(b)?L.localize(7,null,b):c.getConfigurationProperties()[b]!==void 0?L.localize(8,null,b):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,b,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.$mn=m;function k(){const b=[],n=c.getConfigurationProperties();for(const a of Object.keys(n))b.push([a,n[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.$nn=k}),define(Pe[178],Ae([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=void 0;function p(a){return Object.isFrozen(a)?a:l.$Um(a)}class ${constructor(r={},o=[],w=[],v){this.b=r,this.c=o,this.d=w,this.raw=v,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof $)return o;const w=new d("");return w.parseRaw(o),w.configurationModel});this.f=r.reduce((o,w)=>w===o?w:o.merge(w),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,P.$bi)(this.contents,r):this.contents}inspect(r,o){const w=this.rawConfiguration.getValue(r),v=o?this.rawConfiguration.getOverrideValue(r,o):void 0,E=o?this.rawConfiguration.override(o).getValue(r):w;return{value:w,override:v,merged:E}}getOverrideValue(r,o){const w=this.i(o);return w?r?(0,P.$bi)(w,r):w:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const w of this.overrides)w.identifiers.includes(r)&&o.push(...w.keys);return y.$Ff(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return y.$Ff(r)}override(r){let o=this.a.get(r);return o||(o=this.g(r),this.a.set(r,o)),o}merge(...r){const o=l.$Tm(this.contents),w=l.$Tm(this.overrides),v=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const D of r)if(E.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(o,D.contents);for(const s of D.overrides){const[h]=w.filter(g=>y.$of(g.identifiers,s.identifiers));h?(this.h(h.contents,s.contents),h.keys.push(...s.keys),h.keys=y.$Ff(h.keys)):w.push(l.$Tm(s))}for(const s of D.keys)v.indexOf(s)===-1&&v.push(s)}return new $(o,v,w,E.every(D=>D instanceof $)?void 0:E)}g(r){const o=this.i(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const w={};for(const v of y.$Ff([...Object.keys(this.contents),...Object.keys(o)])){let E=this.contents[v];const D=o[v];D&&(typeof E=="object"&&typeof D=="object"?(E=l.$Tm(E),this.h(E,D)):E=D),w[v]=E}return new $(w,this.keys,this.overrides)}h(r,o){for(const w of Object.keys(o)){if(w in r&&I.$ne(r[w])&&I.$ne(o[w])){this.h(r[w],o[w]);continue}r[w]=l.$Tm(o[w])}}i(r){let o=null,w=null;const v=E=>{E&&(w?this.h(w,E):w=l.$Tm(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===r?o=E.contents:E.identifiers.includes(r)&&v(E.contents);return v(o),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,o){this.j(r,o,!0)}setValue(r,o){this.j(r,o,!1)}removeValue(r){const o=this.keys.indexOf(r);o!==-1&&(this.keys.splice(o,1),(0,P.$ai)(this.contents,r),S.$in.test(r)&&this.overrides.splice(this.overrides.findIndex(w=>y.$of(w.identifiers,(0,S.$jn)(r))),1))}j(r,o,w){(0,P.$_h)(this.contents,r,o,v=>console.error(v)),w=w||this.keys.indexOf(r)===-1,w&&this.keys.push(r),S.$in.test(r)&&this.overrides.push({identifiers:(0,S.$jn)(r),keys:Object.keys(this.contents[r]),contents:(0,P.$$h)(this.contents[r],v=>console.error(v))})}}e.$on=$;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,o){if(!I.$ue(r)){const w=this.g(r);this.parseRaw(w,o)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,o){this.a=r;const{contents:w,keys:v,overrides:E,restricted:D,hasExcludedProperties:s}=this.h(r,o);this.b=new $(w,v,E,s?[r]:void 0),this.c=D||[]}g(r){let o={},w=null,v=[];const E=[],D=[];function s(g){Array.isArray(v)?v.push(g):w!==null&&(v[w]=g)}const h={onObjectBegin:()=>{const g={};s(g),E.push(v),v=g,w=null},onObjectProperty:g=>{w=g},onObjectEnd:()=>{v=E.pop()},onArrayBegin:()=>{const g=[];s(g),E.push(v),v=g,w=null},onArrayEnd:()=>{v=E.pop()},onLiteralValue:s,onError:(g,M,W)=>{D.push({error:g,offset:M,length:W})}};if(r)try{C.$Qm(r,h),o=v[0]||{}}catch(g){console.error(`Error while parsing settings file ${this.f}: ${g}`),this.d=[g]}return o}h(r,o){const w=u.$6m.as(S.$$m.Configuration).getConfigurationProperties(),v=this.i(r,w,!0,o);r=v.raw;const E=(0,P.$$h)(r,h=>console.error(`Conflict in settings file ${this.f}: ${h}`)),D=Object.keys(r),s=this.j(r,h=>console.error(`Conflict in settings file ${this.f}: ${h}`));return{contents:E,keys:D,overrides:s,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}i(r,o,w,v){let E=!1;if(!v?.scopes&&!v?.skipRestricted&&!v?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:E};const D={},s=[];for(const h in r)if(S.$in.test(h)&&w){const g=this.i(r[h],o,!1,v);D[h]=g.raw,E=E||g.hasExcludedProperties,s.push(...g.restricted)}else{const g=o[h],M=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&s.push(h),!v.exclude?.includes(h)&&(v.include?.includes(h)||(M===void 0||v.scopes===void 0||v.scopes.includes(M))&&!(v.skipRestricted&&g?.restricted))?D[h]=r[h]:E=!0}return{raw:D,restricted:s,hasExcludedProperties:E}}j(r,o){const w=[];for(const v of Object.keys(r))if(S.$in.test(v)){const E={};for(const D in r[v])E[D]=r[v][D];w.push({identifiers:(0,S.$jn)(v),keys:Object.keys(E),contents:(0,P.$$h)(E,o)})}return w}}e.$pn=d;class t extends L.$mb{constructor(r,o,w,v){super(),this.c=r,this.f=o,this.g=v,this.b=this.B(new R.$hc),this.onDidChange=this.b.event,this.a=new d(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&w.isEqual(E.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qn=t;class i{constructor(r,o,w,v,E,D,s,h,g,M,W,V,B){this.a=r,this.b=o,this.c=w,this.overrideIdentifiers=v,this.d=E,this.f=D,this.g=s,this.h=h,this.i=g,this.j=M,this.k=W,this.l=V,this.m=B}get value(){return p(this.c)}n(r,o,w){const v=r.inspect(o,w);return{get value(){return p(v.value)},get override(){return p(v.override)},get merged(){return p(v.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(r,o,w,v,E=new $,D=new $,s=new A.$xi,h=new $,g=new A.$xi){this.c=r,this.d=o,this.f=w,this.g=v,this.h=E,this.i=D,this.j=s,this.l=h,this.m=g,this.a=null,this.b=new A.$xi,this.n=null}getValue(r,o,w){return this.q(r,o,w).getValue(r)}updateValue(r,o,w={}){let v;w.resource?(v=this.m.get(w.resource),v||(v=new $,this.m.set(w.resource,v))):v=this.l,o===void 0?v.removeValue(r):v.setValue(r,o),w.resource||(this.a=null)}inspect(r,o,w){const v=this.q(r,o,w),E=this.u(o.resource,w),D=o.resource?this.m.get(o.resource)||this.l:this.l,s=new Set;for(const h of v.overrides)for(const g of h.identifiers)v.getOverrideValue(r,g)!==void 0&&s.add(g);return new i(r,o,v.getValue(r),s.size?[...s]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,E||void 0,D)}keys(r){const o=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,o){this.j.set(r,o),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const w=[];if(!o){const{added:v,updated:E,removed:D}=b(this.c,r);o=[...v,...E,...D]}for(const v of o)for(const E of(0,S.$jn)(v)){const D=this.c.getKeysForOverrideIdentifier(E),s=r.getKeysForOverrideIdentifier(E),h=[...s.filter(g=>D.indexOf(g)===-1),...D.filter(g=>s.indexOf(g)===-1),...D.filter(g=>!l.$Xm(this.c.override(E).getValue(g),r.override(E).getValue(g)))];w.push([E,h])}return this.updateDefaultConfiguration(r),{keys:o,overrides:w}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:w,removed:v}=b(this.d,r),E=[...o,...w,...v];return E.length&&this.updatePolicyConfiguration(r),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:w,removed:v,overrides:E}=b(this.applicationConfiguration,r),D=[...o,...w,...v];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:E}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:w,removed:v,overrides:E}=b(this.localUserConfiguration,r),D=[...o,...w,...v];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:E}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:w,removed:v,overrides:E}=b(this.remoteUserConfiguration,r),D=[...o,...w,...v];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:E}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:w,removed:v,overrides:E}=b(this.workspaceConfiguration,r),D=[...o,...w,...v];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:E}}compareAndUpdateFolderConfiguration(r,o){const w=this.p.get(r),{added:v,updated:E,removed:D,overrides:s}=b(w,o),h=[...v,...E,...D];return(h.length||!w)&&this.updateFolderConfiguration(r,o),{keys:h,overrides:s}}compareAndDeleteFolderConfiguration(r){const o=this.p.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:w,updated:v,removed:E,overrides:D}=b(o,void 0);return{keys:[...w,...v,...E],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,o,w){let v=this.r(o,w);return o.overrideIdentifier&&(v=v.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(v=v.merge(this.d)),v}r({resource:r},o){let w=this.s();if(o&&r){const v=o.getFolder(r);v&&(w=this.t(v.uri)||w);const E=this.m.get(r);E&&(w=w.merge(E))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let o=this.b.get(r);if(!o){const w=this.s(),v=this.j.get(r);v?(o=w.merge(v),this.b.set(r,o)):o=w}return o}u(r,o){if(o&&r){const w=o.getFolder(r);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,o)=>{const{contents:w,overrides:v,keys:E}=this.j.get(o);return r.push([o,{contents:w,overrides:v,keys:E}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(o=>r.add(o)),this.userConfiguration.keys.forEach(o=>r.add(o)),this.i.keys.forEach(o=>r.add(o)),this.j.forEach(o=>o.keys.forEach(w=>r.add(w))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(w=>r.add(w))),[...r.values()]}w(r){const o=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(w=>o.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(w=>o.add(w)),this.i.getKeysForOverrideIdentifier(r).forEach(w=>o.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(r).forEach(v=>o.add(v))),[...o.values()]}static parse(r){const o=this.x(r.defaults),w=this.x(r.policy),v=this.x(r.application),E=this.x(r.user),D=this.x(r.workspace),s=r.folders.reduce((h,g)=>(h.set(f.URI.revive(g[0]),this.x(g[1])),h),new A.$xi);return new c(o,w,v,E,new $,D,s,new $,new A.$xi)}static x(r){return new $(r.contents,r.keys,r.overrides)}}e.$rn=c;function m(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,o=new Map;for(const v of a)v.keys.forEach(E=>r.add(E)),v.overrides.forEach(([E,D])=>{const s=(0,A.$ui)(o,E,new Set);D.forEach(h=>s.add(h))});const w=[];return o.forEach((v,E)=>w.push([E,[...v.values()]])),{keys:[...r.values()],overrides:w}}e.$sn=m;class k{constructor(r,o,w,v){this.change=r,this.f=o,this.g=w,this.h=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const E of r.keys)this.affectedKeys.add(E);for(const[,E]of r.overrides)for(const D of E)this.affectedKeys.add(D);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(r,o){const w=this.a+r,v=this.d.indexOf(w);if(v<0)return!1;const E=v+w.length;if(E>=this.d.length)return!1;const D=this.d.charCodeAt(E);if(D!==this.b&&D!==this.c)return!1;if(o){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.f?.workspace):void 0,h=this.g.getValue(r,o,this.h);return!l.$Xm(s,h)}return!0}}e.$tn=k;function b(a,r){const{added:o,removed:w,updated:v}=n(r?.rawConfiguration,a?.rawConfiguration),E=[],D=a?.getAllOverrideIdentifiers()||[],s=r?.getAllOverrideIdentifiers()||[];if(r){const h=s.filter(g=>!D.includes(g));for(const g of h)E.push([g,r.getKeysForOverrideIdentifier(g)])}if(a){const h=D.filter(g=>!s.includes(g));for(const g of h)E.push([g,a.getKeysForOverrideIdentifier(g)])}if(r&&a){for(const h of D)if(s.includes(h)){const g=n({contents:a.getOverrideValue(void 0,h)||{},keys:a.getKeysForOverrideIdentifier(h)},{contents:r.getOverrideValue(void 0,h)||{},keys:r.getKeysForOverrideIdentifier(h)});E.push([h,[...g.added,...g.removed,...g.updated]])}}return{added:o,removed:w,updated:v,overrides:E}}function n(a,r){const o=a?r?a.keys.filter(E=>r.keys.indexOf(E)===-1):[...a.keys]:[],w=r?a?r.keys.filter(E=>a.keys.indexOf(E)===-1):[...r.keys]:[],v=[];if(a&&r){for(const E of r.keys)if(a.keys.indexOf(E)!==-1){const D=(0,P.$bi)(r.contents,E),s=(0,P.$bi)(a.contents,E);l.$Xm(D,s)||v.push(E)}}return{added:o,removed:w,updated:v}}}),define(Pe[97],Ae([1,0,9,4]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.RemoteAuthorityResolverErrorCode=e.$Jk=e.$Ik=e.RemoteConnectionType=e.$Hk=void 0,e.$Hk=(0,R.$zh)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ik=L;class A{constructor(S,u){this.host=S,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jk=A;var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class I extends y.$_{static isNotAvailable(S){return S instanceof I&&S._code===l.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof I&&S._code===l.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof I&&S._code===l.NoResolverFound}static isInvalidAuthority(S){return S instanceof I&&S._code===l.InvalidAuthority}static isHandled(S){return S instanceof I&&S.isHandled}constructor(S,u=l.Unknown,p){super(S),this._message=S,this._code=u,this._detail=p,this.isHandled=u===l.NotAvailable&&p===!0,Object.setPrototypeOf(this,I.prototype)}}e.$Kk=I;function f(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}e.$Lk=f}),define(Pe[51],Ae([1,0,12]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=void 0;function R(f){return f.scheme===y.Schemas.vscodeRemote?f.authority:void 0}e.$Mk=R;function C(f){if(!f)return;const P=f.indexOf("+");return P<0?f:f.substr(0,P)}e.$Nk=C;function L(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Ok=L;function A(f){const{host:P,port:S}=I(f);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:S}}e.$Pk=A;function l(f,P){let{host:S,port:u}=I(f);return typeof u>"u"&&(u=P),{host:S,port:u}}e.$Qk=l;function I(f){const P=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const S=f.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const u=f.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:f,port:void 0}}}),define(Pe[20],Ae([1,0,15,4,51]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.TargetPlatform=e.ExtensionType=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl="extensions.user.cache",e.$Ol="extensions.builtin.cache",e.$Pl="undefined_publisher",e.$Ql=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$Rl=L,e.$Sl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class I{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,m=typeof i=="string"?i:i.value;return y.$Od(c,m)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Tl=I;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(I.toKey(t))}delete(t){return this.c.delete(I.toKey(t))}has(t){return this.c.has(I.toKey(t))}}e.$Ul=f;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(I.toKey(t))}get(t){return this.c.get(I.toKey(t))}has(t){return this.c.has(I.toKey(t))}set(t,i){this.c.set(I.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vl=P;function S(d){return u(d)}e.$Wl=S;function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.$Xl=u;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.$Yl=p;function $(d,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Nk)(t)}`;return!!d.activationEvents?.includes(i)}return!1}e.$Zl=$,e.$1l=(0,R.$zh)("IBuiltinExtensionsScannerService")}),define(Pe[98],Ae([1,0,9,20]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wF=e.$vF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const I of A){const f=this.readActivationEvents(I);f.length>0&&(l[R.$Tl.toKey(I.identifier)]=f)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const I in A.contributes){const f=this.a.get(I);if(!f)continue;const P=A.contributes[I],S=Array.isArray(P)?P:[P];try{f(S,l)}catch(u){(0,y.$Y)(u)}}return l}}e.$vF=C,e.$wF=new C}),define(Pe[179],Ae([1,0,22,74,36]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=void 0;function L(I){if(y.$t===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function A(I,f,P,S,u,p,$,d){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$6e)()+Date.now(),t.commitHash=S,t.version=u,t["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,y.$h)(y.$t),t["common.nodePlatform"]=R.$5c,t["common.nodeArch"]=P,t["common.product"]=d||"desktop",$&&(t["common.msftInternal"]=$);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),y.$l&&(t["common.snap"]="true");const m=L(f);return m&&(t["common.platformDetail"]=m),t}e.$8n=A;function l(I){const f=R.env.USERDNSDOMAIN;if(!f)return!1;const P=f.toLowerCase();return I.some(S=>P===S)}e.$9n=l}),define(Pe[180],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0,e.$7k=(0,y.$zh)("telemetryService"),e.$8k=(0,y.$zh)("customEndpointTelemetryService"),e.$9k="telemetry.currentSessionDate",e.$0k="telemetry.firstSessionDate",e.$$k="telemetry.lastSessionDate",e.$_k="telemetry.machineId",e.$al="telemetry",e.$bl="telemetry.telemetryLevel",e.$cl="telemetry.enableCrashReporter",e.$dl="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[52],Ae([1,0,24,16,5,43,51,179,180]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0;class f{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$0n=f;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$$n=P,e.$_n=new P;class S{async publicLog(w,v,E){}async publicLogError(w,v,E){}}e.$ao=S,e.$bo="telemetry",e.$co="extensionTelemetryLog",e.$do={log:()=>null,flush:()=>Promise.resolve(null)};function u(o,w){return C.Event.debounce(w.onDidChangeConfiguration,(E,D)=>{const s=E?new Set([...E.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:s}},1e3,!0)(E=>{E.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.$9h)(E.source),configurationKeys:Array.from(E.affectedKeys)})})}e.$eo=u;function p(o,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!o.enableTelemetry||w.extensionTestsLocationURI)}e.$fo=p;function $(o,w){return!(w.isBuilt||w.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$go=$;function d(o){const w=o.getValue(I.$bl),v=o.getValue(I.$cl);if(o.getValue(I.$dl)===!1||v===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ho=d;function t(o){const w={},v={},E={};m(o,E);for(let D in E){D=D.length>150?D.substr(D.length-149):D;const s=E[D];typeof s=="number"?v[D]=s:typeof s=="boolean"?v[D]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${s.length}`),w[D]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(w[D]=s)}return{properties:w,measurements:v}}e.$io=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const w=(0,A.$Nk)(o);return i.has(w)?w:"other"}e.$jo=c;function m(o,w,v=0,E){if(o)for(const D of Object.getOwnPropertyNames(o)){const s=o[D],h=E?E+D:D;Array.isArray(s)?w[h]=(0,y.$Ym)(s):s instanceof Date?w[h]=s.toISOString():(0,R.$ne)(s)?v<2?m(s,w,v+1,h+"."):w[h]=(0,y.$Ym)(s):w[h]=s}}function k(o,w){const v=o.msftInternalDomains||[],E=w.getValue("telemetry.internalTesting");return(0,l.$9n)(v)||E}e.$ko=k;function b(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$lo=b;function n(o,w){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let v=o;const E=[];for(const g of w)for(;;){const M=g.exec(o);if(!M)break;E.push([M.index,g.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(v="";;){const g=s.exec(o);if(!g)break;const M=E.some(([W,V])=>g.index<V&&W<s.lastIndex);!D.test(g[0])&&!M&&(v+=o.substring(h,g.index)+"<REDACTED: user-file-path>",h=s.lastIndex)}return h<o.length&&(v+=o.substr(h)),v}function a(o){if(!o)return o;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const v of w)if(v.regex.test(o))return`<REDACTED: ${v.label}>`;return o}function r(o,w){return(0,y.$Vm)(o,v=>{if(v instanceof f||Object.hasOwnProperty.call(v,"isTrustedTelemetryValue"))return v.value;if(typeof v=="string"){let E=v.replaceAll("%20"," ");E=n(E,w);for(const D of w)E=E.replace(D,"");return E=a(E),E}})}e.$mo=r}),define(Pe[181],Ae([1,0,15,92,20,22,2,9,74,52]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;function P(r,o){return r.uuid&&o.uuid?r.uuid===o.uuid:r.id===o.id?!0:(0,y.$Jd)(r.id,o.id)===0}e.$no=P;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(o){const w=o.manifest?o.manifest.version:o.version,v=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new u(o.identifier,w,v)}static parse(o){const w=S.exec(o);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor(o,w,v="undefined"){this.version=w,this.targetPlatform=v,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof u?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$oo=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(r){const o=p.exec(r);return o&&o[1]?[t(o[1]),o[2]]:[t(r),void 0]}e.$po=$;function d(r,o){return`${r}.${o}`}e.$qo=d;function t(r){return r.toLowerCase()}e.$ro=t;function i(r,o){return t(d(r??C.$Pl,o))}e.$so=i;function c(r,o){const w=[],v=E=>{for(const D of w)if(D.some(s=>P(o(s),o(E))))return D;return null};for(const E of r){const D=v(E);D?D.push(E):w.push([E])}return w}e.$to=c;function m(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$uo=m;function k(r){return{id:new f.$0n(r.identifier.id),name:new f.$0n(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$vo=k,e.$wo=new C.$Tl("pprice.better-merge");function b(r,o){const w=[],v=o.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const E=v.shift();if(E&&w.every(D=>!P(D.identifier,{id:E}))){const D=r.filter(s=>P(s.identifier,{id:E}));D.length===1&&(w.push(D[0]),v.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$xo=b;async function n(r,o){if(!L.$k)return!1;let w;try{w=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){o.debug("Error while getting the os-release file.",(0,l.$8)(E))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,o){const w=await n(r,o),v=(0,R.$Sn)(w?"alpine":L.$t,I.$6c);return o.debug("ComputeTargetPlatform:",v),v}e.$yo=a}),define(Pe[182],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=e.$ar=e.$_q=e.$$q=e.$0q=void 0;function y(I){return[...I.entries()]}e.$0q=y;function R(I){return I?[...I.entries()]:[]}e.$$q=R;function C(I){return new Map(I)}e.$_q=C;function L(I){return new Map(I??[])}e.$ar=L;function A(I){return Array.from(I.entries()).map(f=>[f[0],y(f[1].map),R(f[1].descriptionMap)])}e.$br=A;function l(I){return new Map(I.map(f=>[f[0],{map:C(f[1]),descriptionMap:L(f[2])}]))}e.$cr=l}),define(Pe[183],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,L,A=5){const l=L(I=>{const f=typeof I=="string"?I:I.data;let P=this.a.get(C);if(P){P.data.push(f);return}const S=setTimeout(()=>this.flushBuffer(C),A);P={data:[f],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),l.dispose()}},this.a.set(C,P)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const L=this.a.get(C);L&&(this.a.delete(C),this.b(C,L.data.join("")))}}e.$qkb=y}),define(Pe[184],Ae([1,0,13,89,40,5,16,2,145,73,30]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.IconFontDefinition=e.IconContribution=e.$5u=void 0,e.$5u={IconContribution:"base.contributions.icons"};var S;(function(k){function b(n,a){let r=n.defaults;for(;C.ThemeIcon.isThemeIcon(r);){const o=$.getIcon(r.id);if(!o)return;r=o.defaults}return r}k.getDefinition=b})(S||(e.IconContribution=S={}));var u;(function(k){function b(a){return{weight:a.weight,style:a.style,src:a.src.map(r=>({format:r.format,location:r.location.toString()}))}}k.toJSONObject=b;function n(a){const r=o=>(0,A.$le)(o)?o:void 0;if(a&&Array.isArray(a.src)&&a.src.every(o=>(0,A.$le)(o.format)&&(0,A.$le)(o.location)))return{weight:r(a.weight),style:r(a.style),src:a.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}k.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class p{constructor(){this.a=new L.$hc,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,n,a,r){const o=this.b[b];if(o){if(a&&!o.description){o.description=a,this.d.properties[b].markdownDescription=`${a} $(${b})`;const E=this.e.enum.indexOf(b);E!==-1&&(this.e.enumDescriptions[E]=a),this.a.fire()}return o}const w={id:b,description:a,defaults:n,deprecationMessage:r};this.b[b]=w;const v={$ref:"#/definitions/icons"};return r&&(v.deprecationMessage=r),a&&(v.markdownDescription=`${a}: $(${b})`),this.d.properties[b]=v,this.e.enum.push(b),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const n=this.e.enum.indexOf(b);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,n){const a=this.f[b];return a||(this.f[b]=n,this.a.fire(),n)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(o,w)=>o.id.localeCompare(w.id),n=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(o=>this.b[o]);for(const o of r.filter(w=>!!w.description).sort(b))a.push(`|<i class="${n(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const o of r.filter(w=>!C.ThemeIcon.isThemeIcon(w.defaults)).sort(b))a.push(`|<i class="${n(o)}"></i>|${o.id}|`);return a.join(`
`)}}const $=new p;P.$6m.add(e.$5u.IconContribution,$);function d(k,b,n,a){return $.registerIcon(k,b,n,a)}e.$6u=d;function t(){return $}e.$7u=t;function i(){const k=(0,R.$Lj)();for(const b in k){const n="\\"+k[b].toString(16);$.registerIcon(b,{fontCharacter:n})}}i(),e.$8u="vscode://schemas/icons";const c=P.$6m.as(f.$7m.JSONContribution);c.registerSchema(e.$8u,$.getIconSchema());const m=new y.$Qg(()=>c.notifySchemaChanged(e.$8u),200);$.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.$9u=d("widget-close",R.$Nj.close,(0,I.localize)(2,null)),e.$0u=d("goto-previous-location",R.$Nj.arrowUp,(0,I.localize)(3,null)),e.$$u=d("goto-next-location",R.$Nj.arrowDown,(0,I.localize)(4,null)),e.$_u=C.ThemeIcon.modify(R.$Nj.sync,"spin"),e.$av=C.ThemeIcon.modify(R.$Nj.loading,"spin")}),define(Pe[185],Ae([1,0,5,43,4,14]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.$Vz=e.ProvidedOnAutoForward=e.$Uz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tz=e.$Sz=void 0,e.$Sz=(0,C.$zh)("tunnelService"),e.$Tz=(0,C.$zh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function I(t){return!!t.forwardPort}e.$Uz=I;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$Vz=P,e.$Wz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.$Wz.indexOf(t)>=0}e.$Xz=S,e.$Yz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$Yz.indexOf(t)>=0}e.$Zz=u;function p(t,i,c,m){if(c===1)return!1;if(c===2&&u(i)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(k?.length===4&&parseInt(k[1])>=18)return!1}return t<1024}e.$1z=p;class ${constructor(i,c,m){this.remoteAddress=i,this.localAddress=c,this.b=m,this.a=new y.$hc,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$2z=$;let d=class{constructor(i,c){this.j=i,this.k=c,this.a=new y.$hc,this.onTunnelOpened=this.a.event,this.b=new y.$hc,this.onTunnelClosed=this.b.event,this.c=new y.$hc,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const m of c){const k=Array.from(m.values());for(const b of k){const n=await b.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(m=>typeof m!="string"?m?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,m,k,b){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:m,privacy:k,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(u(i)||S(i))&&(i=e.$Wz[0]);const m=this.r(i,c);if(m)return++m.refcount,m.value}openTunnel(i,c,m,k,b,n=!1,a,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${m} on local port ${b}.`);const o=this.f??i;if(!o)return;if(c||(c="localhost"),k||(k=this.l),this.f&&this.i.has(m)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(o,c,m,k,b,n,a,r);return w?w.then(v=>{if(v){if(typeof v=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,m),v}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,m);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.n(v);return(v.tunnelRemoteHost!==c||v.tunnelRemotePort!==m)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&v.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const m=c.get(i.tunnelRemotePort);m&&(m.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,m))}}}}async o(i,c,m){if(m.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const k=m.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),k}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const m=this.e.get(i);if(m&&m.has(c)){const k=m.get(c);k.refcount=0,await this.o(i,c,k)}}p(i,c,m){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:m})}async q(i,c){const m=this.e.get(i);if(m){const k=m.get(c),b=k?await k.value:void 0;(!b||typeof b=="string")&&m.delete(c),m.size===0&&this.e.delete(i)}}r(i,c){const m=[i];S(i)?(m.push(...e.$Wz),m.push(...e.$Yz)):u(i)&&m.push(...e.$Yz);const k=m.map(b=>this.e.get(b));for(const b of k){const n=b?.get(c);if(n)return n}}canTunnel(i){return!!P(i)}t(i,c,m,k,b,n,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${m} on local port ${k}.`);const r=m;this.i.add(r);const o=k===void 0?m:k,w={elevationRequired:b?this.isPortPrivileged(o):!1},v={remoteAddress:{host:c,port:m},localAddressPort:k,privacy:n,public:n?n!==l.Private:void 0,protocol:a},E=i.forwardPort(v,w);return E?(this.p(c,m,E),E.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),E}};e.$3z=d,e.$3z=d=Ke([Ve(0,L.$3i),Ve(1,R.$6h)],d)}),define(Pe[186],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$4z=void 0,e.$4z=(0,y.$zh)("editSessionIdentityService");var R;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Pe[187],Ae([1,0,12]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=void 0;function R(I){return I.scheme!==y.Schemas.file&&I.scheme!==y.Schemas.vscodeRemote}e.$hJ=R;function C(I){if(I.folders.length)return I.folders.every(f=>R(f.uri))?I.folders[0].uri:void 0;if(I.configuration&&R(I.configuration))return I.configuration}e.$iJ=C;function L(I){return C(I)?.scheme}e.$jJ=L;function A(I){return C(I)?.authority}e.$kJ=A;function l(I){return C(I)!==void 0}e.$lJ=l}),define(Pe[53],Ae([1,0,146,19,48,23,2,4,12]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.WorkbenchState=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0,e.$Ih=(0,l.$zh)("contextService");function f(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}e.$Jh=f;function P(o){return typeof o?.id=="string"&&!f(o)&&!u(o)}e.$Kh=P,e.$Lh={id:"ext-dev"},e.$Mh={id:"empty-window"};function S(o,w){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,R.$cd)(o)}:w?e.$Lh:e.$Mh;const v=o;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}e.$Nh=S;function u(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}e.$Oh=u;function p(o){const w=o;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const v=o;if(v?.configPath)return{id:v.id,configPath:A.URI.revive(v.configPath)};if(o?.id)return{id:o.id}}e.$Ph=p;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function d(o){const w=o;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$Qh=d;function t(o){const w=o;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$Rh=t;class i{constructor(w,v,E,D,s){this.h=w,this.j=E,this.k=D,this.l=s,this.c=C.$Fh.forUris(this.l,()=>!0),this.folders=v}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=C.$Fh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Sh=i;class c{constructor(w,v){this.raw=v,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,L.$gg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Th=c;function m(o){return new c({uri:o,index:0,name:(0,L.$cg)(o)},{uri:o.toString()})}e.$Uh=m,e.$Vh="code-workspace",e.$Wh=`.${e.$Vh}`,e.$Xh=[{name:(0,y.localize)(0,null),extensions:[e.$Vh]}],e.$Yh="workspace.json";function k(o,w){return L.$0f.isEqualOrParent(o,w.untitledWorkspacesHome)}e.$Zh=k;function b(o){let w;return A.URI.isUri(o)?w=o:w=o.configuration,w?.scheme===I.Schemas.tmp}e.$1h=b,e.$2h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$2h}e.$3h=n;function a(o,w){return!k(o,w)&&!b(o)}e.$4h=a;function r(o){return(typeof o=="string"?(0,R.$dd)(o):(0,L.$eg)(o))===e.$Wh}e.$5h=r}),define(Pe[54],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const L=this.c++;return this.b.set(L,C),this.e(),L}get(C,L){return this.b.has(C)?this.b.get(C)[L]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$nac=y}),define(Pe[39],Ae([1,0,12,23,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=e.$pac=void 0;class L{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new R.$8f(l=>{const I=this.b.get(l.scheme);return!(I===void 0||I&1024)})}$acceptProviderInfos(l,I){I===null?this.b.delete(l.scheme):this.b.set(l.scheme,I)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$pac=L,e.$qac=(0,C.$zh)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=void 0,e.$9L=(0,y.$zh)("IExtHostInitDataService")}),define(Pe[188],Ae([1,0,151,14,175,27]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;let A=class extends C.$dN{constructor(I,f,P){const S=P.remote.isRemote?"remoteexthost":I?"workerexthost":"exthost",u=P.remote.isRemote?(0,y.localize)(0,null):I?(0,y.localize)(1,null):(0,y.localize)(2,null);super(f.createLogger(S,{name:u}))}};e.$wcc=A,e.$wcc=A=Ke([Ve(1,R.$4i),Ve(2,L.$9L)],A)}),define(Pe[189],Ae([1,0,13]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=void 0;class R{constructor(A,l,I){this.h=new Map,this.a=A,this.b=l,this.c=I,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new y.$Qg(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of f.values())P.complete()}catch(P){for(const S of f.values())S.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let I=this.f[A];return typeof I>"u"&&(I=l),I}update(A,l){this.f[A]=l;const I=this.h.get(A);if(I!==void 0)return I.p;const f=new y.$Zg;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$Sac=R;class C extends R{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$Tac=C}),define(Pe[190],Ae([1,0,5,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class C{constructor(A){this.c=A,this.a=new y.$hc,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$hc,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,I,f){const S=this.c.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(l.value,I,f);this.b.fire(S)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(R.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(R.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$fcc=C}),define(Pe[17],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=void 0,e.$SL=(0,y.$zh)("IExtHostRpcService");class R{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$TL=R}),define(Pe[191],Ae([1,0,20,5]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0;class C{#e;constructor(A,l){this.b=new R.$hc,this.onDidChange=this.b.event,this.a=y.$Tl.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(I=>{I.extensionId===this.a&&this.b.fire({key:I.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$5ac=C}),define(Pe[55],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=e.$Aac=void 0,e.$Aac=(0,y.$zh)("IURITransformerService");class R{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Bac=R}),define(Pe[192],Ae([1,0,25]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbb=e.$Lbb=void 0;class R{constructor(){this.buffers=[]}add(I){let f=this.buffers.indexOf(I);return f<0&&(f=this.buffers.length,this.buffers.push(I)),f}}function C(l,I){if(I.serializeBuffersForPostMessage){const f=new R,S=JSON.stringify(l,(p,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add($)};if(ArrayBuffer.isView($)){const d=L($);if(d)return{$$vscode_array_buffer_reference$$:!0,index:f.add($.buffer),view:{type:d,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),u=f.buffers.map(p=>{const $=new Uint8Array(p);return y.$Hc.wrap($)});return{message:S,buffers:u}}else return{message:JSON.stringify(l),buffers:[]}}e.$Lbb=C;function L(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,I){const f=I.map(u=>{const p=new ArrayBuffer(u.byteLength);return new Uint8Array(p).set(u.buffer),p}),P=I.length?(u,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const $=p,{index:d}=$,t=f[d];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(l,P),arrayBuffers:f}}e.$Mbb=A}),define(Pe[99],Ae([1,0,160,16,2,6,4,30,38,12,41,128,29]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=e.$1E=e.EditorsOrder=e.$ZE=e.CloseDirection=e.$YE=e.$XE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.EditorInputCapabilities=e.$OE=e.SaveReason=e.Verbosity=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=void 0,e.$CE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$DE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$EE="workbench.editor.sidebysideEditor",e.$FE="workbench.editors.textDiffEditor",e.$GE="workbench.editors.binaryResourceDiffEditor";var p;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var $;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function d(ae){const x=ae;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.$HE=d;function t(ae,x,ue){for(const O of ue.visibleEditorPanes)if(O.group.id===x&&ae.matches(O.input))return O.getViewState()}e.$IE=t;function i(ae){if(v(ae))return!1;const x=ae;return C.URI.isUri(x?.resource)}e.$JE=i;function c(ae){if(v(ae))return!1;const x=ae;return x?.original!==void 0&&x.modified!==void 0}e.$KE=c;function m(ae){if(v(ae)||c(ae))return!1;const x=ae;return x?.primary!==void 0&&x.secondary!==void 0}e.$LE=m;function k(ae){if(v(ae))return!1;const x=ae;return x?x.resource===void 0||x.resource.scheme===f.Schemas.untitled||x.forceUntitled===!0:!1}e.$ME=k;function b(ae){if(v(ae))return!1;const x=ae;return C.URI.isUri(x?.base?.resource)&&C.URI.isUri(x?.input1?.resource)&&C.URI.isUri(x?.input2?.resource)&&C.URI.isUri(x?.result?.resource)}e.$NE=b;var n;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var a;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class r{constructor(){this.a=new Map}registerSource(x,ue){let O=this.a.get(x);return O||(O={source:x,label:ue},this.a.set(x,O)),O.source}getSourceLabel(x){return this.a.get(x)?.label??x}}e.$OE=new r;var o;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class w extends L.$mb{}e.$PE=w;function v(ae){return ae instanceof w}e.$QE=v;function E(ae){const x=ae;return C.URI.isUri(x?.preferredResource)}function D(ae){const x=ae;return v(x?.primary)&&v(x?.secondary)}e.$RE=D;function s(ae){const x=ae;return v(x?.modified)&&v(x?.original)}e.$SE=s;function h(ae,x,ue,O,J){return we(O,[(0,S.$ji)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const he={...ue,limits:{size:Number.MAX_VALUE}};ae.openEditor(x,he)}}),(0,S.$ji)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>J.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$TE=h;function g(ae){return v(ae?.editor)}e.$UE=g;function M(ae){const x=ae;return g(ae)&&x?.group!==void 0}e.$VE=M;function W(ae){const x=ae;return typeof x?.groupId=="number"&&v(x.editor)}e.$WE=W;var V;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var B;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var j;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(x,ue){if(!x)return;if(b(x))return e.$YE.getOriginalUri(x.result,ue);if(ue?.supportSideBySide){const{primary:J,secondary:he}=this.a(x);if(J&&he){if(ue?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:ue.filterByScheme}),secondary:this.getOriginalUri(he,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===j.ANY)return this.getOriginalUri(J,{filterByScheme:ue.filterByScheme})??this.getOriginalUri(he,{filterByScheme:ue.filterByScheme});x=ue.supportSideBySide===j.PRIMARY?J:he}}if(c(x)||m(x)||b(x))return;const O=E(x)?x.preferredResource:x.resource;return!O||!ue||!ue.filterByScheme?O:this.b(O,ue.filterByScheme)}a(x){return D(x)||m(x)?{primary:x.primary,secondary:x.secondary}:s(x)||c(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,ue){if(!x)return;if(b(x))return e.$YE.getCanonicalUri(x.result,ue);if(ue?.supportSideBySide){const{primary:J,secondary:he}=this.a(x);if(J&&he){if(ue?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:ue.filterByScheme}),secondary:this.getCanonicalUri(he,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===j.ANY)return this.getCanonicalUri(J,{filterByScheme:ue.filterByScheme})??this.getCanonicalUri(he,{filterByScheme:ue.filterByScheme});x=ue.supportSideBySide===j.PRIMARY?J:he}}if(c(x)||m(x)||b(x))return;const O=x.resource;return!O||!ue||!ue.filterByScheme?O:this.b(O,ue.filterByScheme)}b(x,ue){if(Array.isArray(ue)){if(ue.some(O=>x.scheme===O))return x}else if(ue===x.scheme)return x}}var z;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function ie(ae,x,ue,O){if(!ae.isSticky(x))return!1;switch(O.preventPinnedEditorClose){case"keyboardAndMouse":return ue===z.MOUSE||ue===z.KEYBOARD;case"mouse":return ue===z.MOUSE;case"keyboard":return ue===z.KEYBOARD}return!1}e.$XE=ie,e.$YE=new U;var X;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(x){const ue=this.a=x.get(A.$yh);for(const[O,J]of this.c)this.e(O,J,ue);this.c.clear()}e(x,ue,O){const J=O.createInstance(ue);this.d.set(x,J)}registerFileEditorFactory(x){if(this.b)throw new Error("Can only register one file editor factory.");this.b=x}getFileEditorFactory(){return(0,R.$we)(this.b)}registerEditorSerializer(x,ue){if(this.c.has(x)||this.d.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.a?this.e(x,ue,this.a):this.c.set(x,ue),(0,L.$kb)(()=>{this.c.delete(x),this.d.delete(x)})}getEditorSerializer(x){return this.d.get(typeof x=="string"?x:x.typeId)}}l.$6m.add(e.$CE.EditorFactory,new ye);async function De(ae,x,ue){return!ae||!ae.length?[]:await Promise.all(ae.map(async O=>{const J=C.URI.revive(O.fileUri);if(!J){ue.info("Cannot resolve the path because it is not valid.",O);return}if(!await x.canHandleResource(J)){ue.info("Cannot resolve the path because it cannot be handled",O);return}let Ee=O.exists,ve=O.type;if(typeof Ee!="boolean"||typeof ve!="number")try{ve=(await x.stat(J)).isDirectory?I.FileType.Directory:I.FileType.Unknown,Ee=!0}catch(ke){ue.error(ke),Ee=!1}if(!Ee&&O.openOnlyIfExists){ue.info("Cannot resolve the path because it does not exist",O);return}if(ve===I.FileType.Directory){ue.info("Cannot resolve the path because it is a directory",O);return}const be={...O.options,pinned:!0};return Ee?{resource:J,options:be}:{resource:J,options:be,forceUntitled:!0}}))}e.$ZE=De;var Re;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Re||(e.EditorsOrder=Re={}));function Y(ae){const x=ae;if(!x)return!1;const ue=x;if(ue.modified)return Y(ue.modified);const O=x;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.$1E=Y;function le(ae){return(0,P.$li)(ae)}e.$2E=le;function we(ae,x,ue){const O=(0,P.$mi)(ae,x);return O.forceMessage=ue?.forceMessage,O.forceSeverity=ue?.forceSeverity,O.allowDialog=ue?.allowDialog,O}e.$3E=we}),define(Pe[193],Ae([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$8E=e.$7E=e.ViewContentGroups=e.$6E=e.$5E=e.ViewContainerLocation=e.Extensions=e.$4E=void 0,e.$4E=(0,u.$6u)("default-view-icon",S.$Nj.window,(0,R.localize)(0,null));var p;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var $;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$5E=[0,1,2];function d(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$6E=d;class t extends L.$mb{constructor(){super(...arguments),this.c=this.B(new y.$hc),this.onDidRegister=this.c.event,this.f=this.B(new y.$hc),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,I.$Kf)([...this.g.values()])}registerViewContainer(o,w,v){const E=this.get(o.id);if(E)return E;const D=o;return D.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,A.$ui)(this.g,w,[]).push(D),v?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:w}),D}deregisterViewContainer(o){for(const w of this.g.keys()){const v=this.g.get(w),E=v?.indexOf(o);if(E!==-1){v?.splice(E,1),v.length===0&&this.g.delete(w),this.f.fire({viewContainer:o,viewContainerLocation:w});return}}}get(o){return this.all.filter(w=>w.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(w=>this.getViewContainers(w).filter(v=>v?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(w=>this.getViewContainerLocation(w)===o)}}l.$6m.add(p.ViewContainersRegistry,new t);var i;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(i||(e.ViewContentGroups=i={}));function c(r,o){const w=r.group??i.More,v=o.group??i.More;return w!==v?w.localeCompare(v):(r.order??5)-(o.order??5)}class m extends L.$mb{constructor(){super(...arguments),this.c=this.B(new y.$hc),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$hc),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$hc),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$hc),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new f.$L}registerViews(o,w){this.registerViews2([{views:o,viewContainer:w}])}registerViews2(o){o.forEach(({views:w,viewContainer:v})=>this.l(w,v)),this.c.fire(o)}deregisterViews(o,w){const v=this.m(o,w);v.length&&this.f.fire({views:v,viewContainer:w})}moveViews(o,w){for(const v of this.j.keys())if(v!==w){const E=this.m(o,v);E.length&&(this.l(E,w),this.g.fire({views:E,from:v,to:w}))}}getViews(o){return this.j.get(o)||[]}getView(o){for(const w of this.i){const v=(this.j.get(w)||[]).filter(E=>E.id===o)[0];if(v)return v}return null}getViewContainer(o){for(const w of this.i)if((this.j.get(w)||[]).filter(E=>E.id===o)[0])return w;return null}registerViewWelcomeContent(o,w){return this.k.add(o,w),this.h.fire(o),(0,L.$kb)(()=>{this.k.delete(o,w),this.h.fire(o)})}registerViewWelcomeContent2(o,w){const v=new Map;for(const[E,D]of w)this.k.add(o,D),v.set(E,(0,L.$kb)(()=>{this.k.delete(o,D),this.h.fire(o)}));return this.h.fire(o),v}getViewWelcomeContent(o){const w=[];return this.k.forEach(o,v=>w.push(v)),w.sort(c)}l(o,w){let v=this.j.get(w);v||(v=[],this.j.set(w,v),this.i.push(w));for(const E of o){if(this.getView(E.id)!==null)throw new Error((0,R.localize)(1,null,E.id));v.push(E)}}m(o,w){const v=this.j.get(w);if(!v)return[];const E=[],D=[];for(const s of v)o.includes(s)?E.push(s):D.push(s);return E.length&&(D.length?this.j.set(w,D):(this.j.delete(w),this.i.splice(this.i.indexOf(w),1))),E}}l.$6m.add(p.ViewsRegistry,new m),e.$7E=(0,C.$zh)("viewsService"),e.$8E=(0,C.$zh)("viewDescriptorService");var k;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(k||(e.ViewVisibilityState=k={}));var b;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(b||(e.TreeItemCollapsibleState=b={}));class n{constructor(o,w){this.c=!1,this.d=!1,(0,P.$Wm)(this,o),this.d=!!w,this.resolve=async v=>{if(w&&!this.c){const E=await w(v);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$9E=n;class a extends Error{constructor(o){super((0,R.localize)(2,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$0E=a}),define(Pe[194],Ae([1,0,5,13,162]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new y.$hc,this.n=new y.$hc,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,I,f,P){const S={command:l};if(I&&Object.keys(I).length>0&&(S.arguments=I),this.s("request",S),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const p=this.f.get(S.seq);if(p){this.f.delete(S.seq);const $={type:"response",seq:0,request_seq:S.seq,success:!1,command:l,message:(0,C.localize)(0,null,P,l)};p($)}},P)}return f&&this.f.set(S.seq,f),S.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,I){return l.type!=="event"||I.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,R.$Fg)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const I=l,f=this.f.get(I.request_seq);f&&(this.f.delete(I.request_seq),f(I));break}}}}s(l,I){I.type=l,I.seq=this.d++,this.sendMessage(I)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((I,f)=>l.set(f,I)),await(0,R.$Fg)(500),l.forEach((I,f)=>{I({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$fcb=L}),define(Pe[195],Ae([1,0,163,32,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$iH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$hH=e.MemoryRangeType=e.$gH=e.State=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=void 0,e.$eG="workbench.view.debug",e.$fG="workbench.debug.variablesView",e.$gG="workbench.debug.watchExpressionsView",e.$hG="workbench.debug.callStackView",e.$iG="workbench.debug.loadedScriptsView",e.$jG="workbench.debug.breakPointsView",e.$kG="workbench.debug.disassemblyView",e.$lG="workbench.panel.repl",e.$mG="workbench.panel.repl.view",e.$nG=new R.$Zi("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$oG=new R.$Zi("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$pG=new R.$Zi("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$qG="debugUx",e.$rG=new R.$Zi(e.$qG,"default",{type:"string",description:y.localize(3,null)}),e.$sG=new R.$Zi("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$tG=new R.$Zi("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$uG=new R.$Zi("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$vG=new R.$Zi("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$wG=new R.$Zi("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$xG=new R.$Zi("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$yG=new R.$Zi("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$zG=new R.$Zi("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$AG=new R.$Zi("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$BG=new R.$Zi("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$CG=new R.$Zi("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$DG=new R.$Zi("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$EG=new R.$Zi("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$FG=new R.$Zi("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$GG=new R.$Zi("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$HG=new R.$Zi("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$IG=new R.$Zi("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$JG=new R.$Zi("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$KG=new R.$Zi("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$LG=new R.$Zi("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$MG=new R.$Zi("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$NG=new R.$Zi("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$OG=new R.$Zi("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$PG=new R.$Zi("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$QG=new R.$Zi("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$RG=new R.$Zi("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$SG=new R.$Zi("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$TG=new R.$Zi("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$UG=new R.$Zi("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$VG=new R.$Zi("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$WG=new R.$Zi("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$XG=new R.$Zi("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$YG=new R.$Zi("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$ZG=new R.$Zi("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$1G=new R.$Zi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$2G=new R.$Zi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$3G=new R.$Zi("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$4G=new R.$Zi("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$5G=new R.$Zi("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$6G=new R.$Zi("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$7G=new R.$Zi("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$8G=new R.$Zi("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$9G=new R.$Zi("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$0G=new R.$Zi("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$$G=new R.$Zi("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$_G=new R.$Zi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$aH=new R.$Zi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const L=u=>y.localize(51,null,u);e.$bH=L,e.$cH="editor.contrib.debug",e.$dH="editor.contrib.breakpoint",e.$eH="debug",e.$fH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function l(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$gH=l;var I;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(I||(e.MemoryRangeType=I={})),e.$hH="vscode-debug-memory";var f;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$iH=(0,C.$zh)("debugService");var S;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Pe[196],Ae([1,0,15,2,19,24,12,44,21,18]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const P=/{([^}]+)}/g;function S(E,D,s){return E.replace(P,function(h,g){return D&&g.length>0&&g[0]!=="_"?h:s&&s.hasOwnProperty(g)?s[g]:h})}e.$eF=S;function u(E){const D={};for(const s of Object.keys(E))s.startsWith("!")||(D[s]=E[s]);return D}e.$fF=u;function p(E){return E.configuration.request==="attach"&&!$(E)&&(!E.parentSession||p(E.parentSession))}e.$gF=p;function $(E){let D=E.configuration.type;if(D)return D==="vslsShare"&&(D=E.configuration.adapterProxy.configuration.type),(0,y.$Od)(D,"extensionhost")||(0,y.$Od)(D,"pwa-extensionhost")?E:E.parentSession?$(E.parentSession):void 0}e.$hF=$;function d(E){return E.type&&(E.label||E.program||E.runtime)}e.$iF=d;function t(E,D,s){let h,g=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=M.exec(E);){const V=W.index+1,B=V+W[0].length;if(V<=D&&B>=s){h=W[0],g=V;break}}if(h){const V=/\w+/g;let B=null;for(;(B=V.exec(h))&&!(B.index+1+g+B[0].length>=s););B&&(h=h.substring(0,V.lastIndex))}return h?{start:g,end:g+h.length-1}:{start:0,end:0}}e.$jF=t;async function i(E,D,s,h){if(E.evaluatableExpressionProvider.has(D)){const g=E.evaluatableExpressionProvider.ordered(D),M=(0,f.$Af)(await Promise.all(g.map(async W=>{try{return await W.provideEvaluatableExpression(D,s,h??I.CancellationToken.None)}catch{return}})));if(M.length>0){let W=M[0].expression;const V=M[0].range;return W||(W=D.getLineContent(s.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const g=D.getLineContent(s.lineNumber),{start:M,end:W}=t(g,s.column,s.column),V=g.substring(M-1,W);return{matchingExpression:V,range:new l.$hs(s.lineNumber,M,s.lineNumber,M+V.length)}}return null}e.$kF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(E){return!!(E&&E.match(c))}e.$lF=m;function k(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(m(E.path))return R.URI.parse(E.path);if((0,C.$0c)(E.path))return R.URI.file(E.path)}return E.path}function b(E){if(typeof E.path=="object"){const D=R.URI.revive(E.path);if(D)return D.scheme===A.Schemas.file?D.fsPath:D.toString()}return E.path}function n(E,D){const s=D?k:b,h=(0,L.$Tm)(E);return r(h,(g,M)=>{g&&M&&(M.path=s(M))}),h}e.$mF=n;function a(E,D){const s=D?k:b,h=(0,L.$Tm)(E);return r(h,(g,M)=>{!g&&M&&(M.path=s(M))}),h}e.$nF=a;function r(E,D){switch(E.type){case"event":{const s=E;switch(s.event){case"output":D(!1,s.body.source);break;case"loadedSource":D(!1,s.body.source);break;case"breakpoint":D(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=E;switch(s.command){case"setBreakpoints":D(!0,s.arguments.source);break;case"breakpointLocations":D(!0,s.arguments.source);break;case"source":D(!0,s.arguments.source);break;case"gotoTargets":D(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(h=>D(!1,h));break;default:break}break}case"response":{const s=E;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(h=>D(!1,h.source));break;case"loadedSources":s.body.sources.forEach(h=>D(!1,h));break;case"scopes":s.body.scopes.forEach(h=>D(!1,h.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(h=>D(!1,h.source));break;case"setBreakpoints":s.body.breakpoints.forEach(h=>D(!1,h.source));break;case"disassemble":s.body?.instructions.forEach(g=>D(!1,g.location));break;default:break}break}}}function o(E){return E.filter(D=>!D.presentation?.hidden).sort((D,s)=>D.presentation?s.presentation?D.presentation.group?s.presentation.group?D.presentation.group!==s.presentation.group?D.presentation.group.localeCompare(s.presentation.group):w(D.presentation.order,s.presentation.order):-1:s.presentation.group?1:w(D.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.$oF=o;function w(E,D){return typeof E!="number"?typeof D!="number"?0:1:typeof D!="number"?-1:E-D}async function v(E,D){const s=E.getValue("debug.saveBeforeStart",{overrideIdentifier:D.activeTextEditorLanguageId});if(s!=="none"&&(await D.saveAll(),s==="allEditorsInActiveGroup")){const h=D.activeEditorPane;h&&h.input.resource?.scheme===A.Schemas.untitled&&await D.save({editor:h.input,groupId:h.group.id})}await E.reloadConfiguration()}e.$pF=v}),define(Pe[75],Ae([1,0,25,37,66,67,12,19,22,32]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1H=e.$ZH=e.$YH=e.$XH=e.CellStatusbarAlignment=e.$WH=e.$VH=e.$UH=e.NotebookEditorPriority=e.$TH=e.$SH=e.$RH=e.$QH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$PH=e.$OH=e.$NH=e.$MH=e.CellKind=e.$LH=e.$KH=e.$JH=void 0,e.$JH="workbench.editor.notebook",e.$KH="workbench.editor.notebookTextDiffEditor",e.$LH="workbench.editor.interactive";var P;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(P||(e.CellKind=P={})),e.$MH=["application/json","application/javascript","text/html","image/svg+xml",L.$Er.latex,L.$Er.markdown,"image/png","image/jpeg",L.$Er.text],e.$NH=[L.$Er.latex,L.$Er.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Er.text],e.$OH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$PH="_notAvailable";var S;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var u;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var p;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var $;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var d;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var m;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;const ie=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ie.join("")}]+`),ye=7;function De(x,ue){const O=ue.toString(ye),he=`${O.length<ie.length?ie[O.length-1]:"z"}${O}s${(0,y.$2c)(y.$Hc.fromString(x.scheme),!0,!0)}`;return x.with({scheme:z.scheme,fragment:he})}z.generate=De;function Re(x){if(x.scheme!==z.scheme)return;const ue=x.fragment.indexOf("s");if(ue<0)return;const O=parseInt(x.fragment.substring(0,ue).replace(X,""),ye),J=(0,y.$1c)(x.fragment.substring(ue+1)).toString();if(!isNaN(O))return{handle:O,notebook:x.with({scheme:J,fragment:null})}}z.parse=Re;function Y(x,ue){return x.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${x.scheme!==A.Schemas.file?x.scheme:""}`})}z.generateCellOutputUri=Y;function le(x){if(x.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!ue)return;const O=ue[1]&&ue[1]!==""?ue[1]:void 0,J=ue[2];return{outputId:O,notebook:x.with({scheme:J||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=le;function we(x,ue,O){return z.generate(x,ue).with({scheme:O})}z.generateCellPropertyUri=we;function ae(x,ue){if(x.scheme===ue)return z.parse(x.with({scheme:z.scheme}))}z.parseCellPropertyUri=ae})(m||(e.CellUri=m={}));const k=z=>I.$i?z.replace(/\//g,"\\"):z;class b{constructor(ie=[],X=e.$MH){this.e=X,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:R.$pj(k(ye))}))}sort(ie){const X=new Map(C.Iterable.map(ie,De=>[De,k(De)]));let ye=[];for(const{matches:De}of this.d)for(const[Re,Y]of X)if(De(Y)){ye.push(Re),X.delete(Re);break}return X.size&&(ye=ye.concat([...X.keys()].sort((De,Re)=>this.e.indexOf(De)-this.e.indexOf(Re)))),ye}prioritize(ie,X){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:R.$pj(k(ie))});return}const De=new Set(X.map(Y=>this.f(Y,ye)));De.delete(-1);const Re=Array.from(De).sort();this.d.splice(ye+1,0,...Re.map(Y=>this.d[Y]));for(let Y=Re.length-1;Y>=0;Y--)this.d.splice(Re[Y],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,X=this.d.length){const ye=k(ie);for(let De=0;De<X;De++)if(this.d[De].matches(ye))return De;return-1}}e.$QH=b;function n(z,ie,X,ye=(De,Re)=>De===Re){const De=[];function Re(we,ae,x){if(ae===0&&x.length===0)return;const ue=De[De.length-1];ue&&ue.start+ue.deleteCount===we?(ue.deleteCount+=ae,ue.toInsert.push(...x)):De.push({start:we,deleteCount:ae,toInsert:x})}let Y=0,le=0;for(;;){if(Y===z.length){Re(Y,0,ie.slice(le));break}if(le===ie.length){Re(Y,z.length-Y,[]);break}const we=z[Y],ae=ie[le];if(ye(we,ae)){Y+=1,le+=1;continue}X(ae)?(Re(Y,1,[]),Y+=1):(Re(Y,0,[ae]),le+=1)}return De}e.$RH=n,e.$SH=new f.$Zi("notebookEditorCursorAtBoundary","none"),e.$TH=new f.$Zi("notebookEditorCursorAtLineBoundary","none");var a;(function(z){z.default="default",z.option="option"})(a||(e.NotebookEditorPriority=a={}));function r(z){const ie=z;return!!((typeof ie.include=="string"||R.$qj(ie.include))&&(typeof ie.exclude=="string"||R.$qj(ie.exclude)))}e.$UH=r;function o(z,ie,X){if(Array.isArray(z.viewType)&&z.viewType.indexOf(ie)>=0||z.viewType===ie)return!0;if(z.filenamePattern){const ye=r(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,De=r(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(R.$oj(ye,(0,l.$cd)(X.fsPath).toLowerCase()))return!(De&&R.$oj(De,(0,l.$cd)(X.fsPath).toLowerCase()))}return!1}e.$VH=o,e.$WH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var w;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$XH=v;function E(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$YH=E;const D=new TextDecoder;function s(z){const ie=[];let X=!1;for(const Y of z)(ie.length===0||X)&&(ie.push(Y),X=!0);let ye=M(ie);const De=y.$Hc.concat(ie.map(Y=>y.$Hc.wrap(Y))),Re=U(De);return ye=ye||Re.byteLength!==De.byteLength,{data:Re,didCompression:ye}}e.$ZH=s,e.$1H=`${String.fromCharCode(27)}[A`;const h=e.$1H.split("").map(z=>z.charCodeAt(0)),g=10;function M(z){let ie=!1;return z.forEach((X,ye)=>{if(ye===0||X.length<e.$1H.length)return;const De=z[ye-1],Re=X.subarray(0,e.$1H.length);if(Re[0]===h[0]&&Re[1]===h[1]&&Re[2]===h[2]){const Y=De.lastIndexOf(g);if(Y===-1)return;ie=!0,z[ye-1]=De.subarray(0,Y),z[ye]=X.subarray(e.$1H.length)}}),ie}function W(z){let ie=z;do z=ie,ie=z.replace(/[^\n]\x08/gm,"");while(ie.length<z.length);return z}function V(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const ie=z.match(/^(.*)\r+/m)[1];let X=z.match(/\r+(.*)$/m)[1];X=X+ie.slice(X.length,ie.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return z}const B="\b".charCodeAt(0),j="\r".charCodeAt(0);function U(z){return!z.buffer.includes(B)&&!z.buffer.includes(j)?z:y.$Hc.fromString(V(W(D.decode(z.buffer))))}}),define(Pe[7],Ae([1,0,18,9,49,28,67,15,16,2,36,20,38,97,75]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$){"use strict";var d,t,i,c,m,k,b,n,a,r,o,w,v,E,D,s,h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$HL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.TestRunProfileKind=e.TestResultState=e.$oL=e.$nL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$mL=e.$lL=e.$kL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$jL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.ColorThemeKind=e.$dL=e.$cL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$bL=e.DebugConsoleMode=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$8K=e.$7K=e.FileChangeType=e.$6K=e.$5K=e.$4K=e.$3K=e.InlineCompletionTriggerKind=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.ConfigurationTarget=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$FK=e.ViewBadge=e.ProgressLocation=e.$EK=e.$DK=e.TaskScope=e.ShellQuoting=e.$CK=e.$BK=e.$AK=e.TaskPanelKind=e.TaskRevealKind=e.$zK=e.TerminalLocation=e.$yK=e.$xK=e.$wK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$vK=e.$uK=e.$tK=e.$sK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$rK=e.StatusBarAlignment=e.ViewColumn=e.$qK=e.$pK=e.$oK=e.$nK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$mK=e.$lK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.LanguageStatusSeverity=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.CodeActionTriggerKind=e.$$J=e.$0J=e.SymbolTag=e.SymbolKind=e.$9J=e.DocumentHighlightKind=e.$8J=e.$7J=e.$6J=e.$5J=e.DiagnosticSeverity=e.DiagnosticTag=e.$4J=e.$3J=e.FileEditType=e.$2J=e.$1J=e.$ZJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function M(N){return Object.assign(N,{apply:function(...re){if(re.length===0)return Reflect.construct(N,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(N,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(N,[]);{const[Se,...Je]=re;return Reflect.construct(N,Je,Se.constructor)}}})}var W;(function(N){N[N.Top=0]="Top",N[N.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var V;(function(N){N[N.TerminalCommand=0]="TerminalCommand",N[N.Opener=1]="Opener",N[N.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let B=d=class{static from(...T){let re=T;return new d(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$SJ=B,e.$SJ=B=d=Ke([M],B);let j=t=class{static Min(...T){if(T.length===0)throw new TypeError;let re=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isBefore(re)&&(re=Je)}return re}static Max(...T){if(T.length===0)throw new TypeError;let re=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isAfter(re)&&(re=Je)}return re}static isPosition(T){if(!T)return!1;if(T instanceof t)return!0;const{line:re,character:Se}=T;return typeof re=="number"&&typeof Se=="number"}static of(T){if(T instanceof t)return T;if(this.isPosition(T))return new t(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,re){if(T<0)throw(0,R.$5)("line must be non-negative");if(re<0)throw(0,R.$5)("character must be non-negative");this.c=T,this.e=re}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,re=0){if(T===null||re===null)throw(0,R.$5)();let Se;return typeof T>"u"?Se=0:typeof T=="number"?Se=T:(Se=typeof T.lineDelta=="number"?T.lineDelta:0,re=typeof T.characterDelta=="number"?T.characterDelta:0),Se===0&&re===0?this:new t(this.line+Se,this.character+re)}with(T,re=this.character){if(T===null||re===null)throw(0,R.$5)();let Se;return typeof T>"u"?Se=this.line:typeof T=="number"?Se=T:(Se=typeof T.line=="number"?T.line:this.line,re=typeof T.character=="number"?T.character:this.character),Se===this.line&&re===this.character?this:new t(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$TJ=j,e.$TJ=j=t=Ke([M],j);let U=i=class{static isRange(T){return T instanceof i?!0:T?j.isPosition(T.start)&&j.isPosition(T.end):!1}static of(T){if(T instanceof i)return T;if(this.isRange(T))return new i(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,re,Se,Je){let Ye,ot;if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ye=new j(T,re),ot=new j(Se,Je)):j.isPosition(T)&&j.isPosition(re)&&(Ye=j.of(T),ot=j.of(re)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(T){return i.isRange(T)?this.contains(T.start)&&this.contains(T.end):j.isPosition(T)?!(j.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const re=j.Max(T.start,this.c),Se=j.Min(T.end,this.e);if(!re.isAfter(Se))return new i(re,Se)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const re=j.Min(T.start,this.c),Se=j.Max(T.end,this.end);return new i(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,re=this.end){if(T===null||re===null)throw(0,R.$5)();let Se;return T?j.isPosition(T)?Se=T:(Se=T.start||this.start,re=T.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new i(Se,re)}toJSON(){return[this.start,this.end]}};e.$UJ=U,e.$UJ=U=i=Ke([M],U);let z=c=class extends U{static isSelection(T){return T instanceof c?!0:T?U.isRange(T)&&j.isPosition(T.anchor)&&j.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,re,Se,Je){let Ye,ot;if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ye=new j(T,re),ot=new j(Se,Je)):j.isPosition(T)&&j.isPosition(re)&&(Ye=j.of(T),ot=j.of(re)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$VJ=z,e.$VJ=z=c=Ke([M],z);const ie=N=>{if(typeof N!="string"||N.length===0||!/^[0-9A-Za-z_\-]+$/.test(N))throw(0,R.$5)("connectionToken")};class X{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,re,Se){if(typeof T!="string"||T.length===0)throw(0,R.$5)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,R.$5)("port");typeof Se<"u"&&ie(Se),this.host=T,this.port=Math.round(re),this.connectionToken=Se}}e.$WJ=X;class ye{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,re){this.makeConnection=T,this.connectionToken=re,typeof re<"u"&&ie(re)}}e.$XJ=ye;class De extends Error{static NotAvailable(T,re){return new De(T,p.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(T){return new De(T,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,re=p.RemoteAuthorityResolverErrorCode.Unknown,Se){super(T),this._message=T,this._code=re,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$YJ=De;var Re;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(Re||(e.EndOfLine=Re={}));var Y;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let le=m=class{static isTextEdit(T){return T instanceof m?!0:T?U.isRange(T)&&typeof T.newText=="string":!1}static replace(T,re){return new m(T,re)}static insert(T,re){return m.replace(new U(T,T),re)}static delete(T){return m.replace(T,"")}static setEndOfLine(T){const re=new m(new U(new j(0,0),new j(0,0)),"");return re.newEol=T,re}get range(){return this.c}set range(T){if(T&&!U.isRange(T))throw(0,R.$5)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,R.$5)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,R.$5)("newEol");this.f=T}constructor(T,re){this.c=T,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ZJ=le,e.$ZJ=le=m=Ke([M],le);let we=k=class{static isNotebookCellEdit(T){return T instanceof k?!0:T?Xt.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,re){return new k(T,re)}static insertCells(T,re){return new k(new Xt(T,T),re)}static deleteCells(T){return new k(T,[])}static updateCellMetadata(T,re){const Se=new k(new Xt(T,T),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(T){const re=new k(new Xt(0,0),[]);return re.newNotebookMetadata=T,re}constructor(T,re){this.range=T,this.newCells=re}};e.$1J=we,e.$1J=we=k=Ke([M],we);class ae{static isSnippetTextEdit(T){return T instanceof ae?!0:T?U.isRange(T.range)&&O.isSnippetString(T.snippet):!1}static replace(T,re){return new ae(T,re)}static insert(T,re){return ae.replace(new U(T,T),re)}constructor(T,re){this.range=T,this.snippet=re}}e.$2J=ae;var x;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace",N[N.Snippet=6]="Snippet"})(x||(e.FileEditType=x={}));let ue=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,re,Se,Je){this.c.push({_type:1,from:T,to:re,options:Se,metadata:Je})}createFile(T,re,Se){this.c.push({_type:1,from:void 0,to:T,options:re,metadata:Se})}deleteFile(T,re,Se){this.c.push({_type:1,from:T,to:void 0,options:re,metadata:Se})}e(T,re,Se){this.c.push({_type:3,metadata:Se,uri:T,edit:{editType:5,metadata:re},notebookMetadata:re})}f(T,re,Se,Je){const Ye=re.start,ot=re.end;(Ye!==ot||Se.length>0)&&this.c.push({_type:5,uri:T,index:Ye,count:ot-Ye,cells:Se,metadata:Je})}g(T,re,Se,Je){this.c.push({_type:3,metadata:Je,uri:T,edit:{editType:3,index:re,metadata:Se}})}replace(T,re,Se,Je){this.c.push({_type:2,uri:T,edit:new le(re,Se),metadata:Je})}insert(T,re,Se,Je){this.replace(T,new U(re,re),Se,Je)}delete(T,re,Se){this.replace(T,re,"",Se)}has(T){return this.c.some(re=>re._type===2&&re.uri.toString()===T.toString())}set(T,re){if(re)for(const Se of re){if(!Se)continue;let Je,Ye;Array.isArray(Se)?(Je=Se[0],Ye=Se[1]):Je=Se,we.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(T,Je.range.start,Je.newCellMetadata,Ye):Je.newNotebookMetadata?this.e(T,Je.newNotebookMetadata,Ye):this.f(T,Je.range,Je.newCells,Ye):ae.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:T,range:Je.range,edit:Je.snippet,metadata:Ye}):this.c.push({_type:2,uri:T,edit:Je,metadata:Ye})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===T.toString()&&(this.c[Se]=void 0);break}}(0,y.$Bf)(this.c)}}get(T){const re=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===T.toString()&&re.push(Se.edit);return re}entries(){const T=new L.$xi;for(const re of this.c)if(re._type===2){let Se=T.get(re.uri);Se||(Se=[re.uri,[]],T.set(re.uri,Se)),Se[1].push(re.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$3J=ue,e.$3J=ue=Ke([M],ue);let O=b=class{static isSnippetString(T){return T instanceof b?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=b.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,re=this.e++){if(typeof T=="function"){const Se=new b;Se.e=this.e,T(Se),this.e=Se.e,T=Se.value}else T=b.c(T);return this.value+="${",this.value+=re,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,re=this.e++){const Se=T.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(T,re){if(typeof re=="function"){const Se=new b;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$4J=O,e.$4J=O=b=Ke([M],O);var J;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var he;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(he||(e.DiagnosticSeverity=he={}));let Ee=n=class{static isLocation(T){return T instanceof n?!0:T?U.isRange(T.range)&&f.URI.isUri(T.uri):!1}constructor(T,re){if(this.uri=T,re)if(U.isRange(re))this.range=U.of(re);else if(j.isPosition(re))this.range=new U(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$5J=Ee,e.$5J=Ee=n=Ke([M],Ee);let ve=class{static is(T){return T?typeof T.message=="string"&&T.location&&U.isRange(T.location.range)&&f.URI.isUri(T.location.uri):!1}constructor(T,re){this.location=T,this.message=re}static isEqual(T,re){return T===re?!0:!T||!re?!1:T.message===re.message&&T.location.range.isEqual(re.location.range)&&T.location.uri.toString()===re.location.uri.toString()}};e.$6J=ve,e.$6J=ve=Ke([M],ve);let be=class{constructor(T,re,Se=he.Error){if(!U.isRange(T))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=T,this.message=re,this.severity=Se}toJSON(){return{severity:he[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,re){return T===re?!0:!T||!re?!1:T.message===re.message&&T.severity===re.severity&&T.code===re.code&&T.severity===re.severity&&T.source===re.source&&T.range.isEqual(re.range)&&(0,y.$of)(T.tags,re.tags)&&(0,y.$of)(T.relatedInformation,re.relatedInformation,ve.isEqual)}};e.$7J=be,e.$7J=be=Ke([M],be);let ke=class{constructor(T,re){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=re}};e.$8J=ke,e.$8J=ke=Ke([M],ke);var oe;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let de=class{constructor(T,re=oe.Text){this.range=T,this.kind=re}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$9J=de,e.$9J=de=Ke([M],de);var se;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var ne;(function(N){N[N.Deprecated=1]="Deprecated"})(ne||(e.SymbolTag=ne={}));let me=a=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,re,Se,Je,Ye){this.name=T,this.kind=re,this.containerName=Ye,typeof Se=="string"&&(this.containerName=Se),Je instanceof Ee?this.location=Je:Se instanceof U&&(this.location=new Ee(Je,Se)),a.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$0J=me,e.$0J=me=a=Ke([M],me);let Ce=r=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(r.validate)}constructor(T,re,Se,Je,Ye){this.name=T,this.detail=re,this.kind=Se,this.range=Je,this.selectionRange=Ye,this.children=[],r.validate(this)}};e.$$J=Ce,e.$$J=Ce=r=Ke([M],Ce);var F;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(F||(e.CodeActionTriggerKind=F={}));let q=class{constructor(T,re){this.title=T,this.kind=re}};e.$_J=q,e.$_J=q=Ke([M],q);let H=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$aK=H,e.$aK=H=o=Ke([M],H);class Q extends H{constructor(T){super(T),this.value=T}}e.$bK=Q,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let K=class{constructor(T,re){if(this.range=T,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$cK=K,e.$cK=K=Ke([M],K);class ee{constructor(T,re,Se,Je,Ye,ot){this.kind=T,this.name=re,this.detail=Se,this.uri=Je,this.range=Ye,this.selectionRange=ot}}e.$dK=ee;class ce{constructor(T,re){this.fromRanges=re,this.from=T}}e.$eK=ce;class ze{constructor(T,re){this.fromRanges=re,this.to=T}}e.$fK=ze;var Ue;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let Qe=class{constructor(T,re){this.range=T,this.command=re}get isResolved(){return!!this.command}};e.$gK=Qe,e.$gK=Qe=Ke([M],Qe);let He=w=class{#e;static isMarkdownString(T){return T instanceof w?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,re=!1){this.#e=new C.$Vj(T,{supportThemeIcons:re})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,re){return this.#e.appendCodeblock(re??"",T),this}};e.$hK=He,e.$hK=He=w=Ke([M],He);let et=class{constructor(T,re){this.label=T,this.documentation=re}};e.$iK=et,e.$iK=et=Ke([M],et);let Xe=class{constructor(T,re){this.label=T,this.documentation=re,this.parameters=[]}};e.$jK=Xe,e.$jK=Xe=Ke([M],Xe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$kK=_e,e.$kK=_e=Ke([M],_e);var it;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var tt;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Ne=class{constructor(T){this.value=T}};e.$lK=Ne,e.$lK=Ne=Ke([M],Ne);let st=class{constructor(T,re,Se){this.position=T,this.label=re,this.kind=Se}};e.$mK=st,e.$mK=st=Ke([M],st);var _;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(e.CompletionTriggerKind=_={}));var Z;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Z||(e.CompletionItemKind=Z={}));var $e;(function(N){N[N.Deprecated=1]="Deprecated"})($e||(e.CompletionItemTag=$e={}));let je=class{constructor(T,re){this.label=T,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$nK=je,e.$nK=je=Ke([M],je);let Oe=class{constructor(T=[],re=!1){this.items=T,this.isIncomplete=re}};e.$oK=Oe,e.$oK=Oe=Ke([M],Oe);let Ze=class{constructor(T,re,Se){this.insertText=T,this.range=re,this.command=Se}};e.$pK=Ze,e.$pK=Ze=Ke([M],Ze);let nt=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$qK=nt,e.$qK=nt=Ke([M],nt);var gt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(gt||(e.ViewColumn=gt={}));var vt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Tt(N,T){return`${S.$Tl.toKey(N)}.${T}`}e.$rK=Tt;var Zt;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Zt||(e.TextEditorLineNumbersStyle=Zt={}));var Vt;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var wt;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Lt;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Lt||(e.TextEditorSelectionChangeKind=Lt={}));var zt;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Jt;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(N){function T(re){switch(re){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=T}(Lt||(e.TextEditorSelectionChangeKind=Lt={}));let Pt=class{constructor(T,re){if(re&&!f.URI.isUri(re))throw(0,R.$5)("target");if(!U.isRange(T)||T.isEmpty)throw(0,R.$5)("range");this.range=T,this.target=re}};e.$sK=Pt,e.$sK=Pt=Ke([M],Pt);let At=class{constructor(T,re,Se,Je){this.red=T,this.green=re,this.blue=Se,this.alpha=Je}};e.$tK=At,e.$tK=At=Ke([M],At);let Ot=class{constructor(T,re){if(re&&!(re instanceof At))throw(0,R.$5)("color");if(!U.isRange(T)||T.isEmpty)throw(0,R.$5)("range");this.range=T,this.color=re}};e.$uK=Ot,e.$uK=Ot=Ke([M],Ot);let jt=class{constructor(T){if(!T||typeof T!="string")throw(0,R.$5)("label");this.label=T}};e.$vK=jt,e.$vK=jt=Ke([M],jt);var qt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var at;(function(N){N[N.Unknown=0]="Unknown",N[N.Shutdown=1]="Shutdown",N[N.Process=2]="Process",N[N.User=3]="User",N[N.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(T,re,Se){if(this.startIndex=T,this.length=re,this.tooltip=Se,typeof T!="number"||T<0)throw(0,R.$5)("startIndex");if(typeof re!="number"||re<1)throw(0,R.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,R.$5)("tooltip")}}e.$wK=ut;class Ht{constructor(T){this.uri=T}}e.$xK=Ht;class Ct{constructor(T){this.terminalCommand=T}}e.$yK=Ct;var Dt;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class ht{constructor(T){if(this.options=T,typeof T!="object")throw(0,R.$5)("options")}}e.$zK=ht;var St;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var Mt;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Mt||(e.TaskPanelKind=Mt={}));let Et=class{static{v=this}static{this.Clean=new v("clean","Clean")}static{this.Build=new v("build","Build")}static{this.Rebuild=new v("rebuild","Rebuild")}static{this.Test=new v("test","Test")}static from(T){switch(T){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(T,re){if(this.label=re,typeof T!="string"||typeof re!="string")throw(0,R.$5)("name");this.c=T}get id(){return this.c}};e.$AK=Et,e.$AK=Et=v=Ke([M],Et);function qe(N){let T="";for(let re=0;re<N.length;re++)T+=N[re].replace(/,/g,",,")+",";return T}let Nt=class{constructor(T,re,Se){if(typeof T!="string")throw(0,R.$5)("process");this.e=[],this.c=T,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,R.$5)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const re of this.e)T.push(re);return qe(T)}};e.$BK=Nt,e.$BK=Nt=Ke([M],Nt);let Ie=class{constructor(T,re,Se){if(this.f=[],Array.isArray(re)){if(!T)throw(0,R.$5)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,R.$5)("command");this.e=T,this.f=re,this.g=Se}else{if(typeof T!="string")throw(0,R.$5)("commandLine");this.c=T,this.g=re}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,R.$5)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,R.$5)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)T.push(typeof re=="string"?re:re.value);return qe(T)}};e.$CK=Ie,e.$CK=Ie=Ke([M],Ie);var Fe;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Fe||(e.ShellQuoting=Fe={}));var ge;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ge||(e.TaskScope=ge={}));class G{constructor(T){this.c=T}computeId(){return"customExecution"+(0,P.$6e)()}set callback(T){this.c=T}get callback(){return this.c}}e.$DK=G;let Te=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,re,Se,Je,Ye,ot){this.j=!1,this.k=this.definition=T;let lt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=Se,this.execution=Je,lt=Ye,this.j=!0):re===ge.Global||re===ge.Workspace?(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ye,lt=ot):(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ye,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Nt?this.k={type:E.e,id:this.n.computeId()}:this.n instanceof Ie?this.k={type:E.f,id:this.n.computeId()}:this.n instanceof G?this.k={type:E.c,id:this.n.computeId()}:this.k={type:E.g,id:(0,P.$6e)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,R.$5)("Kind can't be undefined or null");this.y(),this.k=T}get scope(){return this.l}set target(T){this.y(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,R.$5)("name");this.y(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.y(),this.n=T;const re=this.k.type;(E.g===re||E.e===re||E.f===re||E.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.y(),this.o=T,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.y(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,R.$5)("source must be a string of length > 0");this.y(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.y(),this.u=T}get detail(){return this.x}set detail(T){T===null&&(T=void 0),this.x=T}get presentationOptions(){return this.v}set presentationOptions(T){T==null&&(T=Object.create(null)),this.y(),this.v=T}get runOptions(){return this.w}set runOptions(T){T==null&&(T=Object.create(null)),this.y(),this.w=T}};e.$EK=Te,e.$EK=Te=E=Ke([M],Te);var Be;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Be||(e.ProgressLocation=Be={}));var Ge;(function(N){function T(re){const Se=re;return(0,I.$pe)(Se.value)?Se.tooltip&&!(0,I.$le)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}N.isViewBadge=T})(Ge||(e.ViewBadge=Ge={}));let We=D=class{static isTreeItem(T,re){const Se=T;if(Se.checkboxState!==void 0){const Je=(0,I.$pe)(Se.checkboxState)?Se.checkboxState:(0,I.$ne)(Se.checkboxState)&&(0,I.$pe)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ye=!(0,I.$pe)(Se.checkboxState)&&(0,I.$ne)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==pt.Checked&&Je!==pt.Unchecked||Ye!==void 0&&!(0,I.$le)(Ye))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(T instanceof D)return!0;if(Se.label!==void 0&&!(0,I.$le)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,I.$le)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,I.$le)(Se.iconPath)&&!f.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,I.$le)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,I.$le)(Je.light)&&!f.URI.isUri(Je.light)&&!(0,I.$le)(Je.dark)&&!f.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,I.$le)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!f.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,I.$le)(Se.tooltip)&&!(Se.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<xe.None&&Se.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,I.$le)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(T,re=xe.None){this.collapsibleState=re,f.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$FK=We,e.$FK=We=D=Ke([M],We);var xe;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var pt;(function(N){N[N.Unchecked=0]="Unchecked",N[N.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$GK=bt,e.$GK=bt=Ke([M],bt);class dt extends bt{}e.$HK=dt;class ft extends dt{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$IK=ft;class mt{constructor(T,re,Se,Je){this.name=T,this.uri=re,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$JK=mt;let gi=class{#e=new Map;constructor(T){for(const[re,Se]of T??[]){const Je=this.#e.get(this.#t(re));Je?Je.push(Se):this.#e.set(this.#t(re),[Se])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,re){this.#e.set(this.#t(T),[re])}forEach(T,re){for(const[Se,Je]of this.#e)for(const Ye of Je)T.call(re,Ye,Se,this)}*[Symbol.iterator](){for(const[T,re]of this.#e)for(const Se of re)yield[T,Se]}#t(T){return T.toLowerCase()}};e.$KK=gi,e.$KK=gi=Ke([M],gi);let Kt=class{constructor(T){this.insertText=T}};e.$LK=Kt,e.$LK=Kt=Ke([M],Kt);let Ei=class{constructor(T,re){this.label=re,this.insertText=T}};e.$MK=Ei,e.$MK=Ei=Ke([M],Ei);let Wt=class{constructor(T,re){this.id=T,this.color=re}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$NK=Wt,e.$NK=Wt=Ke([M],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(T){this.id=T}};e.$OK=mi,e.$OK=mi=Ke([M],mi);var It;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let Di=class{get base(){return this.c}set base(T){this.c=T,this.e=f.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,re){if(typeof T!="string"&&(!T||!f.URI.isUri(T)&&!f.URI.isUri(T.uri)))throw(0,R.$5)("base");if(typeof re!="string")throw(0,R.$5)("pattern");typeof T=="string"?this.baseUri=f.URI.file(T):f.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PK=Di,e.$PK=Di=Ke([M],Di);const Vi=new WeakMap;function kt(N,T){Vi.set(N,T)}e.$QK=kt;let ti=class{constructor(T,re,Se,Je){this.enabled=typeof T=="boolean"?T:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$6e)()),this.c}};e.$RK=ti,e.$RK=ti=Ke([M],ti);let $i=class extends ti{constructor(T,re,Se,Je,Ye){if(super(re,Se,Je,Ye),T===null)throw(0,R.$5)("location");this.location=T}};e.$SK=$i,e.$SK=$i=Ke([M],$i);let si=class extends ti{constructor(T,re,Se,Je,Ye){super(re,Se,Je,Ye),this.functionName=T}};e.$TK=si,e.$TK=si=Ke([M],si);let ki=class extends ti{constructor(T,re,Se,Je,Ye,ot,lt){if(super(Je,Ye,ot,lt),!re)throw(0,R.$5)("dataId");this.label=T,this.dataId=re,this.canPersist=Se}};e.$UK=ki,e.$UK=ki=Ke([M],ki);let Si=class{constructor(T,re,Se){this.command=T,this.args=re||[],this.options=Se}};e.$VK=Si,e.$VK=Si=Ke([M],Si);let Rt=class{constructor(T,re){this.port=T,this.host=re}};e.$WK=Rt,e.$WK=Rt=Ke([M],Rt);let pi=class{constructor(T){this.path=T}};e.$XK=pi,e.$XK=pi=Ke([M],pi);let Ii=class{constructor(T){this.implementation=T}};e.$YK=Ii,e.$YK=Ii=Ke([M],Ii);let oi=class{constructor(T,re,Se){this.session=T,this.threadId=re,this.frameId=Se}};e.$ZK=oi,e.$ZK=oi=Ke([M],oi);let ai=class{constructor(T,re){this.session=T,this.threadId=re}};e.$1K=ai,e.$1K=ai=Ke([M],ai);let ct=class{constructor(T,re){this.range=T,this.expression=re}};e.$2K=ct,e.$2K=ct=Ke([M],ct);var qi;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Yt=class{constructor(T,re){this.range=T,this.text=re}};e.$3K=Yt,e.$3K=Yt=Ke([M],Yt);let ii=class{constructor(T,re,Se=!0){this.range=T,this.variableName=re,this.caseSensitiveLookup=Se}};e.$4K=ii,e.$4K=ii=Ke([M],ii);let bi=class{constructor(T,re){this.range=T,this.expression=re}};e.$5K=bi,e.$5K=bi=Ke([M],bi);let Ci=class{constructor(T,re){this.frameId=T,this.stoppedLocation=re}};e.$6K=Ci,e.$6K=Ci=Ke([M],Ci);var Ki;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=s=class extends Error{static FileExists(T){return new s(T,u.FileSystemProviderErrorCode.FileExists,s.FileExists)}static FileNotFound(T){return new s(T,u.FileSystemProviderErrorCode.FileNotFound,s.FileNotFound)}static FileNotADirectory(T){return new s(T,u.FileSystemProviderErrorCode.FileNotADirectory,s.FileNotADirectory)}static FileIsADirectory(T){return new s(T,u.FileSystemProviderErrorCode.FileIsADirectory,s.FileIsADirectory)}static NoPermissions(T){return new s(T,u.FileSystemProviderErrorCode.NoPermissions,s.NoPermissions)}static Unavailable(T){return new s(T,u.FileSystemProviderErrorCode.Unavailable,s.Unavailable)}constructor(T,re=u.FileSystemProviderErrorCode.Unknown,Se){super(f.URI.isUri(T)?T.toString(!0):T),this.code=Se?.name??"Unknown",(0,u.$fk)(this,re),Object.setPrototypeOf(this,s.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$7K=Pi,e.$7K=Pi=s=Ke([M],Pi);let vi=class{constructor(T,re,Se){this.start=T,this.end=re,this.kind=Se}};e.$8K=vi,e.$8K=vi=Ke([M],vi);var Ji;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Hi;(function(N){N[N.Published=0]="Published",N[N.Draft=1]="Draft"})(Hi||(e.CommentState=Hi={}));var wi;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(T,re=[]){this.tokenTypes=T,this.tokenModifiers=re}}e.$9K=Ri;function cn(N){return typeof N>"u"||(0,I.$me)(N)}class Fi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let re=0,Se=T.tokenTypes.length;re<Se;re++)this.j.set(T.tokenTypes[re],re);for(let re=0,Se=T.tokenModifiers.length;re<Se;re++)this.k.set(T.tokenModifiers[re],re)}}push(T,re,Se,Je,Ye){if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(T,re,Se,Je,Ye);if(U.isRange(T)&&typeof re=="string"&&cn(Se))return this.m(T,re,Se);throw(0,R.$5)()}m(T,re,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Je=T.start.line,Ye=T.start.character,ot=T.end.character-T.start.character,lt=this.j.get(re);let Ut=0;if(Se)for(const Qt of Se){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Qt);Ut|=1<<xt>>>0}this.n(Je,Ye,ot,lt,Ut)}n(T,re,Se,Je,Ye){if(this.f&&(T<this.c||T===this.c&&re<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Qt=0,xt=0;for(let ei=0;ei<Ut;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Qt,Bi+=xt):ri+=Qt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Qt=ri,xt=Bi}}let ot=T,lt=re;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Ye,this.c=T,this.e=re}static o(T){const re=[],Se=T.length/5|0;for(let lt=0;lt<Se;lt++)re[lt]=lt;re.sort((lt,Ut)=>{const Qt=T[5*lt],xt=T[5*Ut];if(Qt===xt){const ei=T[5*lt+1],ri=T[5*Ut+1];return ei-ri}return Qt-xt});const Je=new Uint32Array(T.length);let Ye=0,ot=0;for(let lt=0;lt<Se;lt++){const Ut=5*re[lt],Qt=T[Ut+0],xt=T[Ut+1],ei=T[Ut+2],ri=T[Ut+3],Bi=T[Ut+4],wn=Qt-Ye,Fn=wn===0?xt-ot:xt,Wi=5*lt;Je[Wi+0]=wn,Je[Wi+1]=Fn,Je[Wi+2]=ei,Je[Wi+3]=ri,Je[Wi+4]=Bi,Ye=Qt,ot=xt}return Je}build(T){return this.f?new ni(new Uint32Array(this.g),T):new ni(Fi.o(this.g),T)}}e.$0K=Fi;class ni{constructor(T,re){this.resultId=re,this.data=T}}e.$$K=ni;class un{constructor(T,re,Se){this.start=T,this.deleteCount=re,this.data=Se}}e.$_K=un;class ln{constructor(T,re){this.resultId=re,this.edits=T}}e.$aL=ln;var Gi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$bL=fi,e.$bL=fi=Ke([M],fi);var Qi;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var ui;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Yi{static validate(T){if(typeof T.badge=="string"){let re=(0,l.$Yd)(T.badge,0);if(re<T.badge.length&&(re+=(0,l.$Yd)(T.badge,re)),T.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Wt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,re,Se){this.badge=T,this.tooltip=re,this.color=Se}}e.$cL=Yi;let Ti=class{constructor(T){this.kind=T}};e.$dL=Ti,e.$dL=Ti=Ke([M],Ti);var Xi;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class Xt{static isNotebookRange(T){return T instanceof Xt?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,re){if(T<0)throw(0,R.$5)("start must be positive");if(re<0)throw(0,R.$5)("end must be positive");T<=re?(this.c=T,this.e=re):(this.c=re,this.e=T)}with(T){let re=this.c,Se=this.e;return T.start!==void 0&&(re=T.start),T.end!==void 0&&(Se=T.end),re===this.c&&Se===this.e?this:new Xt(re,Se)}}e.$eL=Xt;class yi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(re=>yi.isNotebookCellData(re))}static isNotebookCellData(T){return!0}constructor(T,re,Se,Je,Ye,ot,lt){this.kind=T,this.value=re,this.languageId=Se,this.mime=Je,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$fL=yi;class hn{constructor(T){this.cells=T}}e.$gL=hn;class Gt{static isNotebookCellOutputItem(T){return T instanceof Gt?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const re={name:T.name,message:T.message,stack:T.stack};return Gt.json(re,"application/vnd.code.notebook.error")}static stdout(T){return Gt.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return Gt.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,re="application/octet-stream"){return new Gt(T,re)}static#e=new TextEncoder;static text(T,re=A.$Er.text){const Se=Gt.#e.encode(String(T));return new Gt(Se,re)}static json(T,re="text/x-json"){const Se=JSON.stringify(T,void 0,"	");return Gt.text(Se,re)}constructor(T,re){this.data=T,this.mime=re;const Se=(0,A.$Ir)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$hL=Gt;class li{static isNotebookCellOutput(T){return T instanceof li?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,re=!1){const Se=new Set,Je=new Set;for(let Ye=0;Ye<T.length;Ye++){const ot=T[Ye],lt=(0,A.$Ir)(ot.mime);if(!Se.has(lt)||(0,$.$YH)(lt)){Se.add(lt);continue}Je.add(Ye),re&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?T:T.filter((Ye,ot)=>!Je.has(ot))}constructor(T,re,Se){this.items=li.ensureUniqueMimeTypes(T,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,P.$6e)(),this.metadata=re??Se)}}e.$iL=li;var Li;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Li||(e.NotebookCellKind=Li={}));var Me;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Me||(e.NotebookCellExecutionState=Me={}));var _t;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Mi||(e.NotebookEditorRevealType=Mi={}));class $t{constructor(T,re){this.text=T,this.alignment=re}}e.$jL=$t;var _i;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(_i||(e.NotebookControllerAffinity=_i={}));var xi;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred",N[N.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class en{constructor(T,re=[]){this.uri=T,this.provides=(0,y.$Vf)(re)}}e.$kL=en;class dn{constructor(T){this.label=T}}e.$lL=dn;let hi=class{constructor(T,re){this.label=T,this.timestamp=re}};e.$mL=hi,e.$mL=hi=Ke([M],hi);var tn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(T,re){this.ranges=T,this.wordPattern=re}}e.$nL=sn;class fn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$oL=fn;var on;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let zi=class{constructor(T=void 0,re=void 0,Se=void 0,Je=!1){this.include=T,this.exclude=re,this.profile=Se,this.continuous=Je}};e.$pL=zi,e.$pL=zi=Ke([M],zi);let Oi=h=class{static diff(T,re,Se){const Je=new h(T);return Je.expectedOutput=re,Je.actualOutput=Se,Je}constructor(T){this.message=T}};e.$qL=Oi,e.$qL=Oi=h=Ke([M],Oi);let Ni=class{constructor(T){this.id=T}};e.$rL=Ni,e.$rL=Ni=Ke([M],Ni);let di=class{constructor(T,re){this.covered=T,this.total=re}};e.$sL=di,e.$sL=di=Ke([M],di);let Ui=g=class{static fromDetails(T,re){const Se=new di(0,0),Je=new di(0,0),Ye=new di(0,0);for(const lt of re)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)Je.total+=1,Je.covered+=Ut.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const ot=new g(T,Se,Je.total>0?Je:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=re,ot}constructor(T,re,Se,Je){this.uri=T,this.statementCoverage=re,this.branchCoverage=Se,this.functionCoverage=Je}};e.$tL=Ui,e.$tL=Ui=g=Ke([M],Ui);let ji=class{constructor(T,re,Se=[]){this.executionCount=T,this.location=re,this.branches=Se}};e.$uL=ji,e.$uL=ji=Ke([M],ji);let te=class{constructor(T,re){this.executionCount=T,this.location=re}};e.$vL=te,e.$vL=te=Ke([M],te);let fe=class{constructor(T,re){this.executionCount=T,this.location=re}};e.$wL=fe,e.$wL=fe=Ke([M],fe);var Le;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Le||(e.ExternalUriOpenerPriority=Le={}));var rt;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var yt;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Ft{constructor(T,re,Se,Je,Ye,ot){this.kind=T,this.name=re,this.detail=Se,this.uri=Je,this.range=Ye,this.selectionRange=ot}}e.$xL=Ft;class yn{constructor(T){this.uri=T}}e.$yL=yn;class En{constructor(T,re){this.original=T,this.modified=re}}e.$zL=En;class Dn{constructor(T,re,Se,Je){this.base=T,this.input1=re,this.input2=Se,this.result=Je}}e.$AL=Dn;class kn{constructor(T,re){this.uri=T,this.viewType=re}}e.$BL=kn;class Sn{constructor(T){this.viewType=T}}e.$CL=Sn;class In{constructor(T,re){this.uri=T,this.notebookType=re}}e.$DL=In;class Cn{constructor(T,re,Se){this.original=T,this.modified=re,this.notebookType=Se}}e.$EL=Cn;class Pn{constructor(){}}e.$FL=Pn;class An{constructor(T,re){this.uri=T,this.inputBoxUri=re}}e.$GL=An;var gn;(function(N){N[N.Up=1]="Up",N[N.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(N){N[N.Action=1]="Action",N[N.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(N){N[N.Unhelpful=0]="Unhelpful",N[N.Helpful=1]="Helpful",N[N.Undone=2]="Undone",N[N.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.Assistant=2]="Assistant",N[N.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var bn;(function(N){N[N.Short=1]="Short",N[N.Medium=2]="Medium",N[N.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Rn{constructor(T,re){this.role=T,this.content=re}}e.$HL=Rn;var vn;(function(N){N[N.SymbolInformation=1]="SymbolInformation",N[N.CommandInformation=2]="CommandInformation",N[N.SearchInformation=3]="SearchInformation",N[N.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(Pe[101],Ae([1,0,50,12,15,277,137,7,18]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=e.$UL=void 0;const f=new Map;function P($,d){d?f.set($,d):f.delete($)}e.$UL=P;function S($){return f.get($)}class u extends L.$Ju{constructor(d,t,i,c,m,k,b,n){super(t,i,c,m),this.c=d,this.m=k,this.q=b,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,I.$of)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===R.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,i){return d.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,y.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,y.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,m=t.end.line,k=[];k.push(this.f[c].substring(t.start.character));for(let b=c+1;b<m;b++)k.push(this.f[b]);return k.push(this.f[m].substring(0,t.end.character)),k.join(i)}t(d){let t;if(d instanceof l.$TJ?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const t=this.j.getIndexOf(d),i=this.f[t.index].length;return new l.$TJ(t.index,Math.min(t.remainder,i))}w(d){if(!(d instanceof l.$UJ))throw new Error("Invalid argument");const t=this.x(d.start),i=this.x(d.end);return t===d.start&&i===d.end?d:new l.$UJ(t.line,t.character,i.line,i.character)}x(d){if(!(d instanceof l.$TJ))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:t,character:i}=d,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const m=this.f[t].length;i<0?(i=0,c=!0):i>m&&(i=m,c=!0)}return c?new l.$TJ(t,i):d}y(d,t){const i=this.x(d);if(!t)t=S(this.m);else if((0,C.$Bd)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$Wr)(i.character+1,(0,A.$Ur)(t),this.f[i.line],0);if(c)return new l.$UJ(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$VL=u;class p{constructor(d,t,i){this.a=d,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$UJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$UJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$WL=p}),define(Pe[197],Ae([1,0,7,17,5]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;let L=class{constructor(l){this.a=new y.$dL(y.ColorThemeKind.Dark),this.b=new C.$hc}get activeColorTheme(){return this.a}$onColorThemeChange(l){let I;switch(l){case"light":I=y.ColorThemeKind.Light;break;case"hcDark":I=y.ColorThemeKind.HighContrast;break;case"hcLight":I=y.ColorThemeKind.HighContrastLight;break;default:I=y.ColorThemeKind.Dark}this.a=new y.$dL(I),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1bc=L,e.$1bc=L=Ke([Ve(0,R.$SL)],L)}),define(Pe[198],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3H=e.CellExecutionUpdateType=void 0;var R;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$3H=(0,y.$zh)("INotebookExecutionService")}),define(Pe[45],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(L){L.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var R;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class C{static fromExtHostTestItem(A,l,I=A.parent){if(A._isRoot)return new C([l]);const f=[A.id];for(let P=I;P&&P.id!==l;P=P.parent)f.push(P.id);return f.push(l),new C(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$DI=C}),define(Pe[56],Ae([1,0,2,44,45]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$JI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$II=e.$HI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$GI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$FI=e.$EI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(D){D[D.Unset=0]="Unset",D[D.Queued=1]="Queued",D[D.Running=2]="Running",D[D.Passed=3]="Passed",D[D.Failed=4]="Failed",D[D.Skipped=5]="Skipped",D[D.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(D){D[D.Run=1]="Run",D[D.Debug=2]="Debug",D[D.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(D){D[D.Run=2]="Run",D[D.Debug=4]="Debug",D[D.Coverage=8]="Coverage",D[D.HasNonDefaultProfile=16]="HasNonDefaultProfile",D[D.HasConfigurable=32]="HasConfigurable",D[D.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$EI=[2,4,8,16,32,64];const I=D=>"runId"in D;e.$FI=I;var f;(function(D){D.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),D.deserialize=s=>({range:R.$hs.lift(s.range),uri:y.URI.revive(s.uri)})})(f||(e.IRichLocation=f={}));var P;(function(D){D[D.Error=0]="Error",D[D.Output=1]="Output"})(P||(e.TestMessageType=P={}));var S;(function(D){D.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,contextValue:s.contextValue,location:s.location&&f.serialize(s.location)}),D.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,contextValue:s.contextValue,location:s.location&&f.deserialize(s.location)})})(S||(e.ITestErrorMessage=S={}));const u=(D,s)=>`${s?"s":"e"}${D}`;e.$GI=u;var p;(function(D){D.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&f.serialize(s.location)}),D.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&f.deserialize(s.location)})})(p||(e.ITestOutputMessage=p={}));var $;(function(D){D.serialize=s=>s.type===0?S.serialize(s):p.serialize(s),D.deserialize=s=>s.type===0?S.deserialize(s):p.deserialize(s)})($||(e.ITestMessage=$={}));var d;(function(D){D.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),D.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map($.serialize)}),D.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map($.deserialize)})})(d||(e.ITestTaskState=d={}));const t="\0",i=(D,s)=>D+t+s;e.$HI=i;const c=D=>{const s=D.indexOf(t);return{ctrlId:D.slice(0,s),tagId:D.slice(s+1)}};e.$II=c;var m;(function(D){D.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),D.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?y.URI.revive(s.uri):void 0,range:s.range?R.$hs.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(m||(e.ITestItem=m={}));var k;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(k||(e.TestItemExpandState=k={}));var b;(function(D){D.serialize=s=>({expand:s.expand,item:m.serialize(s.item)}),D.deserialize=s=>({controllerId:C.$DI.root(s.item.extId),expand:s.expand,item:m.deserialize(s.item)})})(b||(e.InternalTestItem=b={}));var n;(function(D){D.serialize=s=>{let h;return s.item&&(h={},s.item.label!==void 0&&(h.label=s.item.label),s.item.tags!==void 0&&(h.tags=s.item.tags),s.item.busy!==void 0&&(h.busy=s.item.busy),s.item.uri!==void 0&&(h.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(h.range=s.item.range?.toJSON()),s.item.description!==void 0&&(h.description=s.item.description),s.item.error!==void 0&&(h.error=s.item.error),s.item.sortText!==void 0&&(h.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:h}},D.deserialize=s=>{let h;return s.item&&(h={},s.item.label!==void 0&&(h.label=s.item.label),s.item.tags!==void 0&&(h.tags=s.item.tags),s.item.busy!==void 0&&(h.busy=s.item.busy),s.item.range!==void 0&&(h.range=s.item.range?R.$hs.lift(s.item.range):null),s.item.description!==void 0&&(h.description=s.item.description),s.item.error!==void 0&&(h.error=s.item.error),s.item.sortText!==void 0&&(h.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:h}}})(n||(e.ITestItemUpdate=n={}));const a=(D,s)=>{s.expand!==void 0&&(D.expand=s.expand),s.item!==void 0&&(D.item=D.item?Object.assign(D.item,s.item):s.item)};e.$JI=a;var r;(function(D){D.serializeWithoutMessages=s=>({...b.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(d.serializeWithoutMessages)}),D.serialize=s=>({...b.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(d.serialize)}),D.deserialize=s=>({...b.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(d.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var o;(function(D){D[D.Function=0]="Function",D[D.Statement=1]="Statement"})(o||(e.DetailType=o={}));var w;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.DocumentSynced=2]="DocumentSynced",D[D.Remove=3]="Remove",D[D.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",D[D.Retire=5]="Retire",D[D.AddTag=6]="AddTag",D[D.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var v;(function(D){D.deserialize=s=>s.op===0?{op:s.op,item:b.deserialize(s.item)}:s.op===1?{op:s.op,item:n.deserialize(s.item)}:s.op===2?{op:s.op,uri:y.URI.revive(s.uri),docv:s.docv}:s,D.serialize=s=>s.op===0?{op:s.op,item:b.serialize(s.item)}:s.op===1?{op:s.op,item:n.serialize(s.item)}:s})(v||(e.TestsDiffOp=v={}));class E{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(s){const h=this.p();for(const g of s)switch(g.op){case 0:this.k(b.deserialize(g.item),h);break;case 1:this.l(n.deserialize(g.item),h);break;case 3:this.m(g.itemId,h);break;case 5:this.o(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.d.set(g.tag.id,g.tag);break;case 7:this.d.delete(g.id);break}h.complete?.()}k(s,h){const g=C.$DI.parentId(s.item.extId)?.toString();let M;if(!g)M=this.q(s),this.g.add(M),this.f.set(s.item.extId,M);else if(this.f.has(g)){const W=this.f.get(g);W.children.add(s.item.extId),M=this.q(s,W),this.f.set(s.item.extId,M)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return h.add?.(M),s.expand===2&&this.h++,M}l(s,h){const g=this.f.get(s.extId);if(g)return s.expand!==void 0&&(g.expand===2&&this.h--,s.expand===2&&this.h++),(0,e.$JI)(g,s),h.update?.(g),g}m(s,h){const g=this.f.get(s);if(!g)return;const M=C.$DI.parentId(g.item.extId)?.toString();M?this.f.get(M).children.delete(g.item.extId):this.g.delete(g);const W=[[s]];for(;W.length;)for(const V of W.pop()){const B=this.f.get(V);B&&(W.push(B.children),this.f.delete(V),h.remove?.(B,B!==g),B.expand===2&&this.h--)}}o(s){}updatePendingRoots(s){this.j+=s}p(){return{}}}e.$KI=E}),define(Pe[76],Ae([1,0,13,5,6,50,56,45]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.TestItemEventOp=void 0;var I;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(I||(e.TestItemEventOp=I={}));const f=(c,m)=>c===m,S=Object.entries({range:(c,m)=>c===m?!0:!c||!m?!1:c.equalsRange(m),busy:f,label:f,description:f,error:f,sortText:f,tags:(c,m)=>!(c.length!==m.length||c.some(k=>!m.includes(k)))}),u=(c,m)=>{let k;for(const[b,n]of S)n(c[b],m[b])||(k?k[b]=m[b]:k={[b]:m[b]});return k};class p extends C.$mb{get root(){return this.m.root}constructor(m){super(),this.m=m,this.f=this.B(new y.$Qg(()=>this.flushDiff(),200)),this.g=this.B(new R.$hc),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(m){this.h=m;for(const k of this.tree.values())this.G(k)}get resolveHandler(){return this.h}collectDiff(){const m=this.k;return this.k=[],m}pushDiff(m){switch(m.op){case 2:{for(const k of this.k)if(k.op===2&&k.uri===m.uri){k.docv=m.docv;return}break}case 1:{const k=this.k[this.k.length-1];if(k){if(k.op===1&&k.item.extId===m.item.extId){(0,A.$JI)(k.item,m.item);return}if(k.op===0&&k.item.item.extId===m.item.extId){(0,A.$JI)(k.item,m.item);return}}break}}this.k.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,k){const b=this.tree.get(m);if(b){if((b.expandLevels===void 0||k>b.expandLevels)&&(b.expandLevels=k),b.expand===1){const n=this.I(b);return n.isOpen()?this.H(b,k-1):n.wait().then(()=>this.H(b,k-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.H(b,k-1)):this.H(b,k-1)}}dispose(){for(const m of this.tree.values())this.m.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(m,k){switch(k.op){case 3:this.L(l.$DI.joinToString(m.fullId,k.id));break;case 0:this.u(k.item,m);break;case 5:for(const b of k.ops)this.p(m,b);break;case 1:this.w(k.new,k.old,m.fullId.toString());break;case 2:this.G(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:k.update}});break;case 6:this.s(m.actual.uri);break;default:(0,L.$xb)(k)}}s(m){m&&this.pushDiff({op:2,uri:m,docv:this.m.getDocumentVersion(m)})}u(m,k){const b=l.$DI.fromExtHostTestItem(m,this.root.id,k?.actual),n=this.m.getApiFor(m);n.parent&&n.parent!==k?.actual&&this.m.getChildren(n.parent).delete(m.id);let a=this.tree.get(b.toString());if(!a){a={fullId:b,actual:m,expandLevels:k?.expandLevels?k.expandLevels-1:void 0,expand:0},m.tags.forEach(this.y,this),this.tree.set(a.fullId.toString(),a),this.C(m,k),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:a.expand,item:this.m.toITestItem(m)}}),this.F(m,a,k);return}if(a.actual===m){this.D(m,a,k);return}if(a.actual.uri?.toString()!==m.uri?.toString())return this.L(b.toString()),this.u(m,k);const r=this.m.getChildren(a.actual),o=a.actual,w=u(this.m.toITestItem(o),this.m.toITestItem(m));this.m.getApiFor(o).listener=void 0,a.actual=m,a.expand=0,w&&(w.hasOwnProperty("tags")&&(this.w(m.tags,o.tags,b.toString()),delete w.tags),this.p(a,{op:4,update:w})),this.F(m,a,k);for(const[v,E]of r)this.m.getChildren(m).get(E.id)||this.L(l.$DI.joinToString(b,E.id));this.s(a.actual.uri)}w(m,k,b){const n=new Set(k.map(a=>a.id));for(const a of m)n.delete(a.id)||this.y(a);this.pushDiff({op:1,item:{extId:b,item:{tags:m.map(a=>(0,A.$HI)(this.m.controllerId,a.id))}}}),n.forEach(this.z,this)}y(m){const k=this.j.get(m.id);k?k.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$HI)(this.m.controllerId,m.id)}}))}z(m){const k=this.j.get(m);k&&!--k.refCount&&(this.j.delete(m),this.pushDiff({op:7,id:(0,A.$HI)(this.m.controllerId,m)}))}C(m,k){this.m.getApiFor(m).parent=k&&k.actual!==this.root?k.actual:void 0}D(m,k,b){this.C(m,b);const n=this.m.getApiFor(m);n.parent=b?.actual,n.listener=a=>this.p(k,a),this.G(k)}F(m,k,b){this.D(m,k,b);for(const[n,a]of this.m.getChildren(m))this.u(a,k)}G(m){let k;this.h?m.resolveBarrier?k=m.resolveBarrier.isOpen()?3:2:k=m.actual.canResolveChildren?1:0:k=0,k!==m.expand&&(m.expand=k,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:k}}),k===1&&m.expandLevels!==void 0&&this.I(m))}H(m,k){if(k<0)return;const b=[];for(const[n,a]of this.m.getChildren(m.actual)){const r=this.expand(l.$DI.joinToString(m.fullId,a.id),k);(0,y.$rg)(r)&&b.push(r)}if(b.length)return Promise.all(b).then(()=>{})}I(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const a=new y.$Dg;return a.open(),a}m.expand=2,this.J(m);const k=m.resolveBarrier=new y.$Dg,b=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,a)};let n;try{n=this.h(m.actual===this.root?void 0:m.actual)}catch(a){b(a)}return(0,y.$rg)(n)?n.catch(b).then(()=>{k.open(),this.G(m)}):(k.open(),this.G(m)),m.resolveBarrier}J(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}L(m){const k=this.tree.get(m);if(!k)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const b=[k];for(;b.length;){const n=b.pop();if(n){this.m.getApiFor(n.actual).listener=void 0;for(const a of n.actual.tags)this.z(a.id);this.tree.delete(n.fullId.toString());for(const[a,r]of this.m.getChildren(n.actual))b.push(this.tree.get(l.$DI.joinToString(n.fullId,r.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.$IL=p;class $ extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.$JL=$;class d extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$KL=d;class t extends Error{constructor(m,k,b){super(`TestItem with ID "${m}" is from controller "${k}" and cannot be added as a child of an item from controller "${b}".`)}}e.$LL=t;const i=(c,m,k)=>{let b=new Map;return{get size(){return b.size},forEach(n,a){for(const r of b.values())n.call(a,r,this)},[Symbol.iterator](){return b.entries()},replace(n){const a=new Map,r=new Set(b.keys()),o={op:5,ops:[]};for(const w of n){if(!(w instanceof k))throw new d(w.id);const v=m(w).controllerId;if(v!==c.controllerId)throw new t(w.id,v,c.controllerId);if(a.has(w.id))throw new $(w.id);a.set(w.id,w),r.delete(w.id),o.ops.push({op:0,item:w})}for(const w of r.keys())o.ops.push({op:3,id:w});c.listener?.(o),b=a},add(n){if(!(n instanceof k))throw new d(n.id);b.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){b.delete(n)&&c.listener?.({op:3,id:n})},get(n){return b.get(n)},toJSON(){return Array.from(b.values())}}};e.$ML=i}),define(Pe[102],Ae([1,0,76]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=void 0;const R=new WeakMap,C=(A,l)=>{const I={controllerId:l};return R.set(A,I),I};e.$NL=C;const L=A=>{const l=R.get(A);if(!l)throw new y.$KL(A?.id||"<unknown>");return l};e.$OL=L}),define(Pe[77],Ae([1,0,12,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yob=e.$xob=e.$wob=e.$vob=e.$uob=void 0,e.$uob="vscode-cdn.net",e.$vob=`vscode-resource.${e.$uob}`,e.$wob=`'self' https://*.${e.$uob}`;function C(l,I){return l.scheme===y.Schemas.http||l.scheme===y.Schemas.https?l:(I&&I.authority&&I.isRemote&&l.scheme===y.Schemas.file&&(l=R.URI.from({scheme:y.Schemas.vscodeRemote,authority:I.authority,path:l.path})),R.URI.from({scheme:y.Schemas.https,authority:`${l.scheme}+${L(l.authority)}.${e.$vob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$xob=C;function L(l){return l.replace(/./g,I=>{const f=I.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?I:"-"+f.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(I,f)=>String.fromCharCode(parseInt(f,16)))}e.$yob=A}),define(Pe[199],Ae([1,0,5,6,77]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;class L{constructor(l,I,f){this.d=l,this.e=I,this.f=f,this.a=0,this.b=new R.$lb,this.c=new Map,this.b.add(I.onDidChangeVisibleTextEditors(()=>{const P=I.getVisibleTextEditors();for(const S of this.c.values())P.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,I,f,P,S){let u;for(const m of this.e.getVisibleTextEditors(!0))if(m.value===l){u=m;break}if(!u)throw new Error("not a visible editor");const p=this,$=this.a++,d=new y.$hc,t=new y.$hc,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(m){return(0,C.$xob)(m,p.f)}get cspSource(){return C.$wob}set options(m){this.b=m,p.d.$setOptions($,m)}get options(){return this.b}set html(m){this.a=m,p.d.$setHtml($,m)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(m){return p.d.$postMessage($,m)}},c=new class{constructor(){this.editor=l,this.line=I,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){p.c.has($)&&(p.c.delete($),p.d.$disposeEditorInset($),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset($,u.id,u.value.document.uri,I+1,f,P||{},S.identifier,S.extensionLocation),this.c.set($,{editor:l,inset:c,onDidReceiveMessage:d}),c}$onDidDispose(l){const I=this.c.get(l);I&&I.inset.dispose()}$onDidReceiveMessage(l,I){this.c.get(l)?.onDidReceiveMessage.fire(I)}}e.$ybc=L}),define(Pe[200],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.VariableKind=e.$EM=void 0,e.$EM=(0,y.$zh)("configurationResolverService");var R;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$FM=C}),define(Pe[201],Ae([1,0,19,74,16,24,22,90,166,200,15]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,$,d,t){this.h=new Map,this.a=p,this.b=$,this.g=d,t&&(this.c=t.then(i=>this.i(i)))}i(p){if(A.$i){const $=Object.create(null);return Object.keys(p).forEach(d=>{$[d.toLowerCase()]=p[d]}),$}return p}resolveWithEnvironment(p,$,d){return this.l({env:this.i(p),userHome:void 0},$?$.uri:void 0,d)}async resolveAsync(p,$){const d={env:await this.c,userHome:await this.g};return this.l(d,p?p.uri:void 0,$)}async j(p,$,d,t){const i=L.$Tm($);A.$i&&i.windows?Object.keys(i.windows).forEach(m=>i[m]=i.windows[m]):A.$j&&i.osx?Object.keys(i.osx).forEach(m=>i[m]=i.osx[m]):A.$k&&i.linux&&Object.keys(i.linux).forEach(m=>i[m]=i.linux[m]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,p?p.uri:void 0,i,d,t)}async resolveAnyAsync(p,$,d){return this.j(p,$,d)}async resolveAnyMap(p,$,d){const t=new Map;return{newConfig:await this.j(p,$,d,t),resolvedVariables:t}}resolveWithInteractionReplace(p,$,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,$,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,$){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,$)}async l(p,$,d,t,i){if(C.$le(d))return this.m(p,$,d,t,i);if(Array.isArray(d))return Promise.all(d.map(c=>this.l(p,$,c,t,i)));if(C.$ne(d)){const c=Object.create(null),m=await Promise.all(Object.keys(d).map(async k=>[await this.m(p,$,k,t,i),await this.l(p,$,d[k],t,i)]));for(const[k,b]of m)c[k]=b;return c}return d}m(p,$,d,t,i){return(0,P.$Gd)(d,S.VARIABLE_REGEXP,async(c,m)=>{if(m.includes(S.VARIABLE_LHS))return c;let k=await this.o(p,c,m,$,t);return i?.set(m,k),k!==c&&C.$le(k)&&k.match(S.VARIABLE_REGEXP)&&(k=await this.m(p,$,k,t,i)),k})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,$,d,t,i){let c;const m=d.split(":");m.length>1&&(d=m[0],c=m[1]);const k=a=>{const r=this.a.getFilePath();if(r)return(0,l.$bA)(r);throw new f.$FM(a,(0,I.localize)(0,null,$))},b=a=>{const r=k(a);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$bA)(o)}throw new f.$FM(a,(0,I.localize)(1,null,$,y.$cd(r)))},n=a=>{if(c){const r=this.a.getFolderUri(c);if(r)return r;throw new f.$FM(a,(0,I.localize)(2,null,$,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$FM(a,(0,I.localize)(3,null,$)):new f.$FM(a,(0,I.localize)(4,null,$))};switch(d){case"env":if(c){if(p.env){const a=p.env[A.$i?c.toLowerCase():c];if(C.$le(a))return a}return""}throw new f.$FM(f.VariableKind.Env,(0,I.localize)(5,null,$));case"config":if(c){const a=this.a.getConfigurationValue(t,c);if(C.$ue(a))throw new f.$FM(f.VariableKind.Config,(0,I.localize)(6,null,$,c));if(C.$ne(a))throw new f.$FM(f.VariableKind.Config,(0,I.localize)(7,null,$,c));return a}throw new f.$FM(f.VariableKind.Config,(0,I.localize)(8,null,$));case"command":return this.p(f.VariableKind.Command,$,c,i,"command");case"input":return this.p(f.VariableKind.Input,$,c,i,"input");case"extensionInstallFolder":if(c){const a=await this.a.getExtension(c);if(!a)throw new f.$FM(f.VariableKind.ExtensionInstallFolder,(0,I.localize)(9,null,$,c));return this.n(a.extensionLocation)}throw new f.$FM(f.VariableKind.ExtensionInstallFolder,(0,I.localize)(10,null,$));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,l.$bA)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,l.$bA)(this.n(n(f.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$bA)(y.$cd(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new f.$FM(f.VariableKind.UserHome,(0,I.localize)(11,null,$))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new f.$FM(f.VariableKind.LineNumber,(0,I.localize)(12,null,$))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new f.$FM(f.VariableKind.SelectedText,(0,I.localize)(13,null,$))}case"file":return k(f.VariableKind.File);case"fileWorkspaceFolder":return b(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?y.$ad(this.n(n(f.VariableKind.RelativeFile)),k(f.VariableKind.RelativeFile)):k(f.VariableKind.RelativeFile);case"relativeFileDirname":{const a=y.$bd(k(f.VariableKind.RelativeFileDirname));if(t||c){const r=y.$ad(this.n(n(f.VariableKind.RelativeFileDirname)),a);return r.length===0?".":r}return a}case"fileDirname":return y.$bd(k(f.VariableKind.FileDirname));case"fileExtname":return y.$dd(k(f.VariableKind.FileExtname));case"fileBasename":return y.$cd(k(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=y.$cd(k(f.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-y.$dd(a).length)}case"fileDirnameBasename":return y.$cd(y.$bd(k(f.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||$}case"execInstallFolder":{const a=this.a.getAppRoot();return a||$}case"pathSeparator":return y.sep;default:try{const a=c?`${d}:${c}`:d;return this.p(f.VariableKind.Unknown,$,a,i,void 0)}catch{return $}}}}p(p,$,d,t,i){if(d&&t){const c=i===void 0?t[d]:t[i+":"+d];if(typeof c=="string")return c;throw new f.$FM(p,(0,I.localize)(14,null,$))}return $}}e.$TM=S}),define(Pe[103],Ae([1,0,4,99]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.$3C=e.OpenEditorContext=e.GroupsOrder=e.$2C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$1C=void 0,e.$1C=(0,y.$zh)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var L;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var I;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(I||(e.MergeGroupMode=I={}));function f($){const d=$;return(0,R.$QE)(d?.editor)&&(0,R.$QE)(d?.replacement)}e.$2C=f;var P;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var S;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function u($){const d=$;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.$3C=u;function p($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$4C=p}),define(Pe[202],Ae([1,0,4,103]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=e.$7C=e.$6C=e.$5C=void 0,e.$5C=(0,y.$zh)("editorService"),e.$6C=-1,e.$7C=-2;function C(L){const A=L;return typeof L=="number"||(0,R.$3C)(A)}e.$8C=C}),define(Pe[8],Ae([1,0,18,25,123,203,49,28,117,68,67,24,16,2,44,78,94,102,99,75,45,56,202,7]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$RL=e.$QL=e.MarkdownString=e.$PL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ie){function Fe(G){const{selectionStartLineNumber:Te,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:We}=G,xe=new a.$TJ(Te-1,Be-1),pt=new a.$TJ(Ge-1,We-1);return new a.$VJ(xe,pt)}Ie.to=Fe;function ge(G){const{anchor:Te,active:Be}=G;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ie.from=ge})(r||(e.Selection=r={}));var o;(function(Ie){function Fe(G){if(!G)return;const{start:Te,end:Be}=G;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ie.from=Fe;function ge(G){if(!G)return;const{startLineNumber:Te,startColumn:Be,endLineNumber:Ge,endColumn:We}=G;return new a.$UJ(Te-1,Be-1,Ge-1,We-1)}Ie.to=ge})(o||(e.Range=o={}));var w;(function(Ie){function Fe(ge){switch(ge){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ie.to=Fe})(w||(e.TokenType=w={}));var v;(function(Ie){function Fe(G){return new a.$TJ(G.lineNumber-1,G.column-1)}Ie.to=Fe;function ge(G){return{lineNumber:G.line+1,column:G.character+1}}Ie.from=ge})(v||(e.Position=v={}));var E;(function(Ie){function Fe(Te,Be,Ge){return(0,y.$Af)((0,y.$Vf)(Te).map(We=>ge(We,Be,Ge)))}Ie.from=Fe;function ge(Te,Be,Ge){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Ge?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:G(Te.scheme,Be),pattern:st.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Ge?.isBuiltin}}function G(Te,Be){return Be&&typeof Te=="string"?Be.transformOutgoingScheme(Te):Te}})(E||(e.DocumentSelector=E={}));var D;(function(Ie){function Fe(G){switch(G){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ie.from=Fe;function ge(G){switch(G){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ie.to=ge})(D||(e.DiagnosticTag=D={}));var s;(function(Ie){function Fe(G){let Te;return G.code&&((0,u.$le)(G.code)||(0,u.$pe)(G.code)?Te=String(G.code):Te={value:String(G.code.value),target:G.code.target}),{...o.from(G.range),message:G.message,source:G.source,code:Te,severity:g.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(h.from),tags:Array.isArray(G.tags)?(0,y.$Af)(G.tags.map(D.from)):void 0}}Ie.from=Fe;function ge(G){const Te=new a.$7J(o.to(G),G.message,g.to(G.severity));return Te.source=G.source,Te.code=(0,u.$le)(G.code)?G.code:G.code?.value,Te.relatedInformation=G.relatedInformation&&G.relatedInformation.map(h.to),Te.tags=G.tags&&(0,y.$Af)(G.tags.map(D.to)),Te}Ie.to=ge})(s||(e.Diagnostic=s={}));var h;(function(Ie){function Fe(G){return{...o.from(G.location.range),message:G.message,resource:G.location.uri}}Ie.from=Fe;function ge(G){return new a.$6J(new a.$5J(G.resource,o.to(G)),G.message)}Ie.to=ge})(h||(e.DiagnosticRelatedInformation=h={}));var g;(function(Ie){function Fe(G){switch(G){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Fe;function ge(G){switch(G){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ie.to=ge})(g||(e.DiagnosticSeverity=g={}));var M;(function(Ie){function Fe(G){return typeof G=="number"&&G>=a.ViewColumn.One?G-1:G===a.ViewColumn.Beside?n.$7C:n.$6C}Ie.from=Fe;function ge(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=ge})(M||(e.ViewColumn=M={}));function W(Ie){return typeof Ie.range<"u"}function V(Ie){return Ie.length===0?!0:!!W(Ie[0])}e.$PL=V;var B;(function(Ie){function Fe(We){return We.map(Ie.from)}Ie.fromMany=Fe;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function G(We){let xe;if(ge(We)){const{language:ft,value:mt}=We;xe={value:"```"+ft+`
`+mt+"\n```\n"}}else a.$hK.isMarkdownString(We)?xe={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?xe={value:We}:xe={value:""};const pt=Object.create(null);xe.uris=pt;const bt=ft=>{try{let mt=p.URI.parse(ft,!0);mt=mt.with({query:Te(mt.query,pt)}),pt[ft]=mt}catch{}return""},dt=new I.marked.Renderer;return dt.link=bt,dt.image=ft=>typeof ft=="string"?bt(A.$3j(ft).href):"",(0,I.marked)(xe.value,{renderer:dt}),xe}Ie.from=G;function Te(We,xe){if(!We)return We;let pt;try{pt=(0,f.$8g)(We)}catch{}if(!pt)return We;let bt=!1;return pt=(0,S.$Vm)(pt,dt=>{if(p.URI.isUri(dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[ft]=dt,bt=!0,ft}else return}),bt?JSON.stringify(pt):We}function Be(We){const xe=new a.$hK(We.value,We.supportThemeIcons);return xe.isTrusted=We.isTrusted,xe.supportHtml=We.supportHtml,xe.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,xe}Ie.to=Be;function Ge(We){if(We)return typeof We=="string"?We:Ie.from(We)}Ie.fromStrict=Ge})(B||(e.MarkdownString=B={}));function j(Ie){return V(Ie)?Ie.map(Fe=>({range:o.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?B.fromMany(Fe.hoverMessage):Fe.hoverMessage?B.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ie.map(Fe=>({range:o.from(Fe)}))}e.$QL=j;function U(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?p.URI.file(Ie):Ie}e.$RL=U;var z;(function(Ie){function Fe(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?U(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ie.from=Fe})(z||(e.ThemableDecorationAttachmentRenderOptions=z={}));var ie;(function(Ie){function Fe(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?U(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?z.from(ge.before):void 0,after:ge.after?z.from(ge.after):void 0}}Ie.from=Fe})(ie||(e.ThemableDecorationRenderOptions=ie={}));var X;(function(Ie){function Fe(ge){if(typeof ge>"u")return ge;switch(ge){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Fe})(X||(e.DecorationRangeBehavior=X={}));var ye;(function(Ie){function Fe(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?X.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ie.from(ge.light):void 0,dark:ge.dark?ie.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?U(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?z.from(ge.before):void 0,after:ge.after?z.from(ge.after):void 0}}Ie.from=Fe})(ye||(e.DecorationRenderOptions=ye={}));var De;(function(Ie){function Fe(G){return{text:G.newText,eol:G.newEol&&Xe.from(G.newEol),range:o.from(G.range)}}Ie.from=Fe;function ge(G){const Te=new a.$ZJ(o.to(G.range),G.text);return Te.newEol=typeof G.eol>"u"?void 0:Xe.to(G.eol),Te}Ie.to=ge})(De||(e.TextEdit=De={}));var Re;(function(Ie){function Fe(G,Te){const Be={edits:[]};if(G instanceof a.$3J){const Ge=new l.$yi;for(const We of G._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of G._allEntries())if(We._type===1){let xe;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?xe={type:"base64",value:(0,R.$2c)(R.$Hc.wrap(We.options.contents))}:xe={type:"dataTransferItem",id:We.options.contents._itemId}),Be.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:xe},metadata:We.metadata})}else We._type===2?Be.edits.push({resource:We.uri,textEdit:De.from(We.edit),versionId:Ge.has(We.uri)?void 0:Te?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Be.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Te?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Be.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Be.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Te?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(gt.from)}})}return Be}Ie.from=Fe;function ge(G){const Te=new a.$3J,Be=new l.$xi;for(const Ge of G.edits)if(Ge.textEdit){const We=Ge,xe=p.URI.revive(We.resource),pt=o.to(We.textEdit.range),bt=We.textEdit.text,dt=We.textEdit.insertAsSnippet;let ft;dt?ft=a.$2J.replace(pt,new a.$4J(bt)):ft=a.$ZJ.replace(pt,bt);const mt=Be.get(xe);mt?mt.push(ft):Be.set(xe,[ft])}else Te.renameFile(p.URI.revive(Ge.oldResource),p.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of Be)Te.set(Ge,We);return Te}Ie.to=ge})(Re||(e.WorkspaceEdit=Re={}));var Y;(function(Ie){const Fe=Object.create(null);Fe[a.SymbolKind.File]=0,Fe[a.SymbolKind.Module]=1,Fe[a.SymbolKind.Namespace]=2,Fe[a.SymbolKind.Package]=3,Fe[a.SymbolKind.Class]=4,Fe[a.SymbolKind.Method]=5,Fe[a.SymbolKind.Property]=6,Fe[a.SymbolKind.Field]=7,Fe[a.SymbolKind.Constructor]=8,Fe[a.SymbolKind.Enum]=9,Fe[a.SymbolKind.Interface]=10,Fe[a.SymbolKind.Function]=11,Fe[a.SymbolKind.Variable]=12,Fe[a.SymbolKind.Constant]=13,Fe[a.SymbolKind.String]=14,Fe[a.SymbolKind.Number]=15,Fe[a.SymbolKind.Boolean]=16,Fe[a.SymbolKind.Array]=17,Fe[a.SymbolKind.Object]=18,Fe[a.SymbolKind.Key]=19,Fe[a.SymbolKind.Null]=20,Fe[a.SymbolKind.EnumMember]=21,Fe[a.SymbolKind.Struct]=22,Fe[a.SymbolKind.Event]=23,Fe[a.SymbolKind.Operator]=24,Fe[a.SymbolKind.TypeParameter]=25;function ge(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Ie.from=ge;function G(Te){for(const Be in Fe)if(Fe[Be]===Te)return Number(Be);return a.SymbolKind.Property}Ie.to=G})(Y||(e.SymbolKind=Y={}));var le;(function(Ie){function Fe(G){switch(G){case a.SymbolTag.Deprecated:return 1}}Ie.from=Fe;function ge(G){switch(G){case 1:return a.SymbolTag.Deprecated}}Ie.to=ge})(le||(e.SymbolTag=le={}));var we;(function(Ie){function Fe(G){return{name:G.name,kind:Y.from(G.kind),tags:G.tags&&G.tags.map(le.from),containerName:G.containerName,location:J.from(G.location)}}Ie.from=Fe;function ge(G){const Te=new a.$0J(G.name,Y.to(G.kind),G.containerName,J.to(G.location));return Te.tags=G.tags&&G.tags.map(le.to),Te}Ie.to=ge})(we||(e.WorkspaceSymbol=we={}));var ae;(function(Ie){function Fe(G){const Te={name:G.name||"!!MISSING: name!!",detail:G.detail,range:o.from(G.range),selectionRange:o.from(G.selectionRange),kind:Y.from(G.kind),tags:G.tags?.map(le.from)??[]};return G.children&&(Te.children=G.children.map(Fe)),Te}Ie.from=Fe;function ge(G){const Te=new a.$$J(G.name,G.detail,Y.to(G.kind),o.to(G.range),o.to(G.selectionRange));return(0,y.$Ef)(G.tags)&&(Te.tags=G.tags.map(le.to)),G.children&&(Te.children=G.children.map(ge)),Te}Ie.to=ge})(ae||(e.DocumentSymbol=ae={}));var x;(function(Ie){function Fe(G){const Te=new a.$dK(Y.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Te._sessionId=G._sessionId,Te._itemId=G._itemId,Te}Ie.to=Fe;function ge(G,Te,Be){if(Te=Te??G._sessionId,Be=Be??G._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,name:G.name,detail:G.detail,kind:Y.from(G.kind),uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(le.from)}}Ie.from=ge})(x||(e.CallHierarchyItem=x={}));var ue;(function(Ie){function Fe(ge){return new a.$eK(x.to(ge.from),ge.fromRanges.map(G=>o.to(G)))}Ie.to=Fe})(ue||(e.CallHierarchyIncomingCall=ue={}));var O;(function(Ie){function Fe(ge){return new a.$fK(x.to(ge.to),ge.fromRanges.map(G=>o.to(G)))}Ie.to=Fe})(O||(e.CallHierarchyOutgoingCall=O={}));var J;(function(Ie){function Fe(G){return{range:G.range&&o.from(G.range),uri:G.uri}}Ie.from=Fe;function ge(G){return new a.$5J(p.URI.revive(G.uri),o.to(G.range))}Ie.to=ge})(J||(e.location=J={}));var he;(function(Ie){function Fe(G){const Te=G,Be=G;return{originSelectionRange:Te.originSelectionRange?o.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Be.uri,range:o.from(Te.targetRange?Te.targetRange:Be.range),targetSelectionRange:Te.targetSelectionRange?o.from(Te.targetSelectionRange):void 0}}Ie.from=Fe;function ge(G){return{targetUri:p.URI.revive(G.uri),targetRange:o.to(G.range),targetSelectionRange:G.targetSelectionRange?o.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?o.to(G.originSelectionRange):void 0}}Ie.to=ge})(he||(e.DefinitionLink=he={}));var Ee;(function(Ie){function Fe(G){return{range:o.from(G.range),contents:B.fromMany(G.contents)}}Ie.from=Fe;function ge(G){return new a.$8J(G.contents.map(B.to),o.to(G.range))}Ie.to=ge})(Ee||(e.Hover=Ee={}));var ve;(function(Ie){function Fe(G){return{range:o.from(G.range),expression:G.expression}}Ie.from=Fe;function ge(G){return new a.$2K(o.to(G.range),G.expression)}Ie.to=ge})(ve||(e.EvaluatableExpression=ve={}));var be;(function(Ie){function Fe(G){if(G instanceof a.$3K)return{type:"text",range:o.from(G.range),text:G.text};if(G instanceof a.$4K)return{type:"variable",range:o.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof a.$5K)return{type:"expression",range:o.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Fe;function ge(G){switch(G.type){case"text":return{range:o.to(G.range),text:G.text};case"variable":return{range:o.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:o.to(G.range),expression:G.expression}}}Ie.to=ge})(be||(e.InlineValue=be={}));var ke;(function(Ie){function Fe(G){return{frameId:G.frameId,stoppedLocation:o.from(G.stoppedLocation)}}Ie.from=Fe;function ge(G){return new a.$6K(G.frameId,o.to(G.stoppedLocation))}Ie.to=ge})(ke||(e.InlineValueContext=ke={}));var oe;(function(Ie){function Fe(G){return{range:o.from(G.range),kind:G.kind}}Ie.from=Fe;function ge(G){return new a.$9J(o.to(G.range),G.kind)}Ie.to=ge})(oe||(e.DocumentHighlight=oe={}));var de;(function(Ie){function Fe(ge){switch(ge){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ie.to=Fe})(de||(e.CompletionTriggerKind=de={}));var se;(function(Ie){function Fe(ge){return{triggerKind:de.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ie.to=Fe})(se||(e.CompletionContext=se={}));var ne;(function(Ie){function Fe(G){switch(G){case a.CompletionItemTag.Deprecated:return 1}}Ie.from=Fe;function ge(G){switch(G){case 1:return a.CompletionItemTag.Deprecated}}Ie.to=ge})(ne||(e.CompletionItemTag=ne={}));var me;(function(Ie){const Fe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ge(Be){return Fe.get(Be)??9}Ie.from=ge;const G=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Te(Be){return G.get(Be)??a.CompletionItemKind.Property}Ie.to=Te})(me||(e.CompletionItemKind=me={}));var Ce;(function(Ie){function Fe(ge,G){const Te=new a.$nK(ge.label);return Te.insertText=ge.insertText,Te.kind=me.to(ge.kind),Te.tags=ge.tags?.map(ne.to),Te.detail=ge.detail,Te.documentation=A.$Xj(ge.documentation)?B.to(ge.documentation):ge.documentation,Te.sortText=ge.sortText,Te.filterText=ge.filterText,Te.preselect=ge.preselect,Te.commitCharacters=ge.commitCharacters,$.$hs.isIRange(ge.range)?Te.range=o.to(ge.range):typeof ge.range=="object"&&(Te.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Te.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Te.insertText=new a.$4J(ge.insertText):(Te.insertText=ge.insertText,Te.textEdit=Te.range instanceof a.$UJ?new a.$ZJ(Te.range,Te.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Te.additionalTextEdits=ge.additionalTextEdits.map(Be=>De.to(Be))),Te.command=G&&ge.command?G.fromInternal(ge.command):void 0,Te}Ie.to=Fe})(Ce||(e.CompletionItem=Ce={}));var F;(function(Ie){function Fe(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:B.fromStrict(G.documentation)}}Ie.from=Fe;function ge(G){return{label:G.label,documentation:A.$Xj(G.documentation)?B.to(G.documentation):G.documentation}}Ie.to=ge})(F||(e.ParameterInformation=F={}));var q;(function(Ie){function Fe(G){return{label:G.label,documentation:B.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(F.from):[],activeParameter:G.activeParameter}}Ie.from=Fe;function ge(G){return{label:G.label,documentation:A.$Xj(G.documentation)?B.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(F.to):[],activeParameter:G.activeParameter}}Ie.to=ge})(q||(e.SignatureInformation=q={}));var H;(function(Ie){function Fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.from):[]}}Ie.from=Fe;function ge(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.to):[]}}Ie.to=ge})(H||(e.SignatureHelp=H={}));var Q;(function(Ie){function Fe(ge,G){const Te=new a.$mK(v.to(G.position),typeof G.label=="string"?G.label:G.label.map(K.to.bind(void 0,ge)),G.kind&&ee.to(G.kind));return Te.textEdits=G.textEdits&&G.textEdits.map(De.to),Te.tooltip=A.$Xj(G.tooltip)?B.to(G.tooltip):G.tooltip,Te.paddingLeft=G.paddingLeft,Te.paddingRight=G.paddingRight,Te}Ie.to=Fe})(Q||(e.InlayHint=Q={}));var K;(function(Ie){function Fe(ge,G){const Te=new a.$lK(G.label);return Te.tooltip=A.$Xj(G.tooltip)?B.to(G.tooltip):G.tooltip,d.Command.is(G.command)&&(Te.command=ge.fromInternal(G.command)),G.location&&(Te.location=J.to(G.location)),Te}Ie.to=Fe})(K||(e.InlayHintLabelPart=K={}));var ee;(function(Ie){function Fe(G){return G}Ie.from=Fe;function ge(G){return G}Ie.to=ge})(ee||(e.InlayHintKind=ee={}));var ce;(function(Ie){function Fe(G){return{range:o.from(G.range),url:G.target,tooltip:G.tooltip}}Ie.from=Fe;function ge(G){let Te;if(G.url)try{Te=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new a.$sK(o.to(G.range),Te)}Ie.to=ge})(ce||(e.DocumentLink=ce={}));var ze;(function(Ie){function Fe(G){const Te=new a.$vK(G.label);return G.textEdit&&(Te.textEdit=De.to(G.textEdit)),G.additionalTextEdits&&(Te.additionalTextEdits=G.additionalTextEdits.map(Be=>De.to(Be))),Te}Ie.to=Fe;function ge(G){return{label:G.label,textEdit:G.textEdit?De.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Te=>De.from(Te)):void 0}}Ie.from=ge})(ze||(e.ColorPresentation=ze={}));var Ue;(function(Ie){function Fe(G){return new a.$tK(G[0],G[1],G[2],G[3])}Ie.to=Fe;function ge(G){return[G.red,G.green,G.blue,G.alpha]}Ie.from=ge})(Ue||(e.Color=Ue={}));var Qe;(function(Ie){function Fe(G){return{range:o.from(G.range)}}Ie.from=Fe;function ge(G){return new a.$cK(o.to(G.range))}Ie.to=ge})(Qe||(e.SelectionRange=Qe={}));var He;(function(Ie){function Fe(ge){switch(ge){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ie.to=Fe})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Ie){function Fe(G){switch(G){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Fe;function ge(G){switch(G){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ie.to=ge})(et||(e.TextEditorLineNumbersStyle=et={}));var Xe;(function(Ie){function Fe(G){if(G===a.EndOfLine.CRLF)return 1;if(G===a.EndOfLine.LF)return 0}Ie.from=Fe;function ge(G){if(G===1)return a.EndOfLine.CRLF;if(G===0)return a.EndOfLine.LF}Ie.to=ge})(Xe||(e.EndOfLine=Xe={}));var _e;(function(Ie){function Fe(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Fe})(_e||(e.ProgressLocation=_e={}));var it;(function(Ie){function Fe(G){const Te={start:G.start+1,end:G.end+1};return G.kind&&(Te.kind=tt.from(G.kind)),Te}Ie.from=Fe;function ge(G){const Te={start:G.start-1,end:G.end-1};return G.kind&&(Te.kind=tt.to(G.kind)),Te}Ie.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ie){function Fe(G){if(G)switch(G){case a.FoldingRangeKind.Comment:return d.$9s.Comment;case a.FoldingRangeKind.Imports:return d.$9s.Imports;case a.FoldingRangeKind.Region:return d.$9s.Region}}Ie.from=Fe;function ge(G){if(G)switch(G.value){case d.$9s.Comment.value:return a.FoldingRangeKind.Comment;case d.$9s.Imports.value:return a.FoldingRangeKind.Imports;case d.$9s.Region.value:return a.FoldingRangeKind.Region}}Ie.to=ge})(tt||(e.FoldingRangeKind=tt={}));var Ne;(function(Ie){function Fe(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.$DE.id:void 0}}Ie.from=Fe})(Ne||(e.TextEditorOpenOptions=Ne={}));var st;(function(Ie){function Fe(Be){return Be instanceof a.$PK?Be.toJSON():typeof Be=="string"?Be:ge(Be)||G(Be)?new a.$PK(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ie.from=Fe;function ge(Be){const Ge=Be;return Ge?p.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function G(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Te(Be){return typeof Be=="string"?Be:new a.$PK(p.URI.revive(Be.baseUri),Be.pattern)}Ie.to=Te})(st||(e.GlobPattern=st={}));var _;(function(Ie){function Fe(ge){if(ge){if(Array.isArray(ge))return ge.map(Fe);if(typeof ge=="string")return ge;{const G=ge;return{language:G.language,scheme:G.scheme,pattern:st.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ie.from=Fe})(_||(e.LanguageSelector=_={}));var Z;(function(Ie){function Fe(G){return!!G&&typeof G=="object"&&"selections"in G&&Array.isArray(G.selections)&&G.selections.every(Te=>Te instanceof a.$VJ)&&"related"in G&&Array.isArray(G.related)&&G.related.every(Te=>Te&&typeof Te=="object"&&p.URI.isUri(Te.uri)&&Te.range instanceof a.$UJ)}Ie.is=Fe;function ge(G){return{selections:G.selections.map(Te=>r.from(Te)),related:G.related.map(Te=>({uri:p.URI.from(Te.uri),range:o.from(Te.range)}))}}Ie.from=ge})(Z||(e.MappedEditsContext=Z={}));var $e;(function(Ie){function Fe(G){return{start:G.start,end:G.end}}Ie.from=Fe;function ge(G){return new a.$eL(G.start,G.end)}Ie.to=ge})($e||(e.NotebookRange=$e={}));var je;(function(Ie){function Fe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ie.to=Fe;function ge(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ie.from=ge})(je||(e.NotebookCellExecutionSummary=je={}));var Oe;(function(Ie){function Fe(ge){if(ge===m.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ge===m.NotebookCellExecutionState.Pending)return;if(ge===m.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ie.to=Fe})(Oe||(e.NotebookCellExecutionState=Oe={}));var Ze;(function(Ie){function Fe(G){switch(G){case a.NotebookCellKind.Markup:return m.CellKind.Markup;case a.NotebookCellKind.Code:default:return m.CellKind.Code}}Ie.from=Fe;function ge(G){switch(G){case m.CellKind.Markup:return a.NotebookCellKind.Markup;case m.CellKind.Code:default:return a.NotebookCellKind.Code}}Ie.to=ge})(Ze||(e.NotebookCellKind=Ze={}));var nt;(function(Ie){function Fe(G){const Te={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)a.$fL.validate(Be),Te.cells.push(gt.from(Be));return Te}Ie.from=Fe;function ge(G){const Te=new a.$gL(G.cells.map(gt.to));return(0,u.$ye)(G.metadata)||(Te.metadata=G.metadata),Te}Ie.to=ge})(nt||(e.NotebookData=nt={}));var gt;(function(Ie){function Fe(G){return{cellKind:Ze.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:je.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Tt.from):[]}}Ie.from=Fe;function ge(G){return new a.$fL(Ze.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Tt.to):void 0,G.metadata,G.internalMetadata?je.to(G.internalMetadata):void 0)}Ie.to=ge})(gt||(e.NotebookCellData=gt={}));var vt;(function(Ie){function Fe(G){return{mime:G.mime,valueBytes:R.$Hc.wrap(G.data)}}Ie.from=Fe;function ge(G){return new a.$hL(G.valueBytes.buffer,G.mime)}Ie.to=ge})(vt||(e.NotebookCellOutputItem=vt={}));var Tt;(function(Ie){function Fe(G){return{outputId:G.id,items:G.items.map(vt.from),metadata:G.metadata}}Ie.from=Fe;function ge(G){const Te=G.items.map(vt.to);return new a.$iL(Te,G.outputId,G.metadata)}Ie.to=ge})(Tt||(e.NotebookCellOutput=Tt={}));var Zt;(function(Ie){function Fe(Te){return G(Te)?{include:st.from(Te.include)??void 0,exclude:st.from(Te.exclude)??void 0}:st.from(Te)??void 0}Ie.from=Fe;function ge(Te){return G(Te)?{include:st.to(Te.include),exclude:st.to(Te.exclude)}:st.to(Te)}Ie.to=ge;function G(Te){const Be=Te;return Be?!(0,u.$ue)(Be.include)&&!(0,u.$ue)(Be.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Vt;(function(Ie){function Fe(ge,G,Te){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Te),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ie.from=Fe})(Vt||(e.NotebookStatusBarItem=Vt={}));var wt;(function(Ie){function Fe(ge,G,Te){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:G.toInternal(Be,Te),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ie.from=Fe})(wt||(e.NotebookKernelSourceAction=wt={}));var Lt;(function(Ie){function Fe(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ie.from=Fe})(Lt||(e.NotebookDocumentContentOptions=Lt={}));var zt;(function(Ie){function Fe(G){return{uri:G.uri,provides:G.provides}}Ie.from=Fe;function ge(G){return new a.$kL(p.URI.revive(G.uri),G.provides)}Ie.to=ge})(zt||(e.NotebookRendererScript=zt={}));var Jt;(function(Ie){function Fe(G){return{message:B.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:o.from(G.location.range),uri:G.location.uri}}}Ie.from=Fe;function ge(G){const Te=new a.$qL(typeof G.message=="string"?G.message:B.to(G.message));return Te.actualOutput=G.actual,Te.expectedOutput=G.expected,Te.contextValue=G.contextValue,Te.location=G.location?J.to(G.location):void 0,Te}Ie.to=ge})(Jt||(e.TestMessage=Jt={}));var Pt;(function(Ie){Ie.namespace=b.$HI,Ie.denamespace=b.$II})(Pt||(e.TestTag=Pt={}));var At;(function(Ie){function Fe(G){const Te=(0,i.$OL)(G).controllerId;return{extId:k.$DI.fromExtHostTestItem(G,Te).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Pt.namespace(Te,Be.id)),range:$.$hs.lift(o.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&B.fromStrict(G.error)||null}}Ie.from=Fe;function ge(G){return{parent:void 0,error:void 0,id:k.$DI.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Te=>{const{tagId:Be}=Pt.denamespace(Te);return new a.$rL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ie.toPlain=ge})(At||(e.TestItem=At={})),function(Ie){function Fe(G){return{id:G.id}}Ie.from=Fe;function ge(G){return new a.$rL(G.id)}Ie.to=ge}(Pt||(e.TestTag=Pt={}));var Ot;(function(Ie){const Fe=(G,Te)=>{const Be=[];for(const[We,xe]of Te)k.$DI.compare(xe.item.extId,We)===2&&(Te.delete(We),Be.push(xe));const Ge={...At.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(xe=>xe.type===0).map(Jt.to)})),children:Be.map(We=>Fe(We,Te))};for(const We of Ge.children)We.parent=Ge;return Ge};function ge(G){const Te=[],Be=new Map;for(const Ge of G.items){Be.set(Ge.item.extId,Ge);const We=k.$DI.root(Ge.item.extId);G.request.targets.some(xe=>xe.controllerId===We&&xe.testIds.includes(Ge.item.extId))&&Te.push(Ge)}return{completedAt:G.completedAt,results:Te.map(Ge=>Fe(Ge,Be))}}Ie.to=ge})(Ot||(e.TestResults=Ot={}));var jt;(function(Ie){function Fe(Be){return{covered:Be.covered,total:Be.covered}}function ge(Be){return"line"in Be?v.from(Be):o.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:ge(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ge(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:ge(Be.location)}}Ie.fromDetailed=G;function Te(Be){return{uri:Be.uri,statement:Fe(Be.statementCoverage),branch:Be.branchCoverage&&Fe(Be.branchCoverage),function:Be.functionCoverage&&Fe(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Ie.fromFile=Te})(jt||(e.TestCoverage=jt={}));var qt;(function(Ie){function Fe(ge){switch(ge){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ie.to=Fe})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Ie){function Fe(G){const Te=new a.$xL(Y.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Te._sessionId=G._sessionId,Te._itemId=G._itemId,Te}Ie.to=Fe;function ge(G,Te,Be){if(Te=Te??G._sessionId,Be=Be??G._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,kind:Y.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(le.from)}}Ie.from=ge})(Bt||(e.TypeHierarchyItem=Bt={}));var at;(function(Ie){function Fe(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ie.from=Fe})(at||(e.ViewBadge=at={}));var ut;(function(Ie){function Fe(Be,Ge,We){const xe=Ge.fileData;return xe?new a.$IK(new a.$JK(xe.name,p.URI.revive(xe.uri),xe.id,(0,L.$bb)(()=>We(xe.id)))):Be===P.$Er.uriList&&Ge.uriListData?new a.$HK(Te(Ge.uriListData)):new a.$HK(Ge.asString)}Ie.to=Fe;async function ge(Be,Ge){const We=await Ge.asString();if(Be===P.$Er.uriList)return{asString:We,fileData:void 0,uriListData:G(We)};const xe=Ge.asFile();return{asString:We,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}Ie.from=ge;function G(Be){return C.$Qs.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return p.URI.parse(Ge)}catch{}return Ge})}function Te(Be){return C.$Qs.create(Be.map(Ge=>typeof Ge=="string"?Ge:p.URI.revive(Ge)))}})(ut||(e.DataTransferItem=ut={}));var Ht;(function(Ie){function Fe(G,Te){const Be=G.items.map(([Ge,We])=>[Ge,ut.to(Ge,We,Te)]);return new a.$KK(Be)}Ie.toDataTransfer=Fe;async function ge(G){const Te={items:[]},Be=[];for(const[Ge,We]of G)Be.push((async()=>{Te.items.push([Ge,await ut.from(Ge,We)])})());return await Promise.all(Be),Te}Ie.from=ge})(Ht||(e.DataTransfer=Ht={}));var Ct;(function(Ie){function Fe(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ie.to=Fe;function ge(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ie.from=ge})(Ct||(e.ChatReplyFollowup=Ct={}));var Dt;(function(Ie){function Fe(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Ct.from(ge)}Ie.from=Fe})(Dt||(e.ChatFollowup=Dt={}));var ht;(function(Ie){function Fe(G){const Te=new a.$HL(St.to(G.role),G.content);return Te.name=G.name,Te}Ie.to=Fe;function ge(G){return{role:St.from(G.role),content:G.content,name:G.name}}Ie.from=ge})(ht||(e.ChatMessage=ht={}));var St;(function(Ie){function Fe(G){switch(G){case 0:return a.ChatMessageRole.System;case 1:return a.ChatMessageRole.User;case 2:return a.ChatMessageRole.Assistant;case 3:return a.ChatMessageRole.Function}}Ie.to=Fe;function ge(G){switch(G){case a.ChatMessageRole.System:return 0;case a.ChatMessageRole.Assistant:return 2;case a.ChatMessageRole.Function:return 3;case a.ChatMessageRole.User:default:return 1}}Ie.from=ge})(St||(e.ChatMessageRole=St={}));var Mt;(function(Ie){function Fe(G){return{level:Et.to(G.level),value:G.value,description:G.description}}Ie.to=Fe;function ge(G){return{level:Et.from(G.level),value:G.value,description:G.description}}Ie.from=ge})(Mt||(e.ChatVariable=Mt={}));var Et;(function(Ie){function Fe(G){switch(G){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}Ie.to=Fe;function ge(G){switch(G){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}Ie.from=ge})(Et||(e.ChatVariableLevel=Et={}));var qe;(function(Ie){function Fe(ge){switch(ge){case 1:return a.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return a.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return a.InteractiveEditorResponseFeedbackKind.Undone;case 3:return a.InteractiveEditorResponseFeedbackKind.Accepted}}Ie.to=Fe})(qe||(e.InteractiveEditorResponseFeedbackKind=qe={}));var Nt;(function(Ie){function Fe(ge,G,Te){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:G.toInternal(ge,Te)}Ie.from=Fe})(Nt||(e.TerminalQuickFix=Nt={}))}),define(Pe[204],Ae([1,0,2,9,7,8,174]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;class l{constructor(f,P,S,u={timeout:1500,errors:3}){this.c=f,this.d=P,this.f=S,this.g=u,this.a=new A.$vb,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(P,S,u)=>{const $={dispose:this.a.push([P,S,f])};return Array.isArray(u)&&u.push($),$}}async $participateInSave(f,P){const S=y.URI.revive(f);let u=!1;const p=setTimeout(()=>u=!0,this.g.timeout),$=[];try{for(const d of[...this.a]){if(u)break;const t=this.d.getDocument(S),i=await this.h(d,{document:t,reason:L.TextDocumentSaveReason.to(P)});$.push(i)}}finally{clearTimeout(p)}return $}h([f,P,S],u){const p=this.b.get(f);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(S,f,P,u).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const d=this.b.get(f);this.b.set(f,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,P,S,u){const p=[],$=Date.now(),{document:d,reason:t}=u,{version:i}=d,c=Object.freeze({document:d,reason:t,waitUntil(m){if(Object.isFrozen(p))throw(0,R.$6)("waitUntil can not be called async");p.push(Promise.resolve(m))}});try{P.apply(S,[c])}catch(m){return Promise.reject(m)}return Object.freeze(p),new Promise((m,k)=>{const b=setTimeout(()=>k(new Error("timeout")),this.g.timeout);return Promise.all(p).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(b),m(n)}).catch(n=>{clearTimeout(b),k(n)})}).then(m=>{const k={edits:[]};for(const b of m)if(Array.isArray(b)&&b.every(n=>n instanceof C.$ZJ))for(const{newText:n,newEol:a,range:r}of b)k.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:r&&L.Range.from(r),text:n,eol:a&&L.EndOfLine.from(a)}});if(k.edits.length!==0)return i===d.version?this.f.$tryApplyWorkspaceEdit(k):Promise.reject(new Error("concurrent_edits"))})}}e.$Jac=l}),define(Pe[205],Ae([1,0,12,2,8,7,75]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0;class l{constructor(S,u,p,$){this.start=S,this.deletedCount=u,this.deletedItems=p,this.items=$}asApiEvent(){return{range:new L.$eL(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class I{static asModelAddData(S,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,u,p){this.notebook=S,this.h=u,this.j=p,this.handle=p.handle,this.uri=R.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return S.g},set mime($){S.g=$},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(p)}return this.f}setOutputs(S){this.a=S.map(C.NotebookCellOutput.to)}setOutputItems(S,u,p){const $=p.map(C.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===S);if(d&&(u||(d.items.length=0),d.items.push(...$),d.items.length>1&&d.items.every(t=>A.$YH(t.mime)))){const t=new Map,i=[];d.items.forEach(c=>{let m;t.has(c.mime)?m=t.get(c.mime):(m=[],t.set(c.mime,m),i.push(c.mime)),m.push(c.data)}),d.items.length=0,i.forEach(c=>{const m=A.$ZH(t.get(c));d.items.push({mime:c,data:m.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Wbc=I;class f{static{this.a=0}constructor(S,u,p,$,d){this.k=S,this.l=u,this.m=p,this.uri=$,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,u={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===y.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(p){return p=S.n(p),S.b[p].apiCell},getCells(p){return(p?S.p(p):S.b).map(d=>d.apiCell)},save(){return S.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,u,p){this.g=S.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:p});const $={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},d=[];for(const i of S.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),d.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),d.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<d.length;i++){const c=d[i],m=t.get(c.cell);if(m===void 0){const k=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,k-1)}else $.cellChanges[m]={...$.cellChanges[m],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let u=S.start|0,p=S.end|0;return u<0&&(u=0),p>this.b.length&&(p=this.b.length),S.with({start:u,end:p})}p(S){S=this.o(S);const u=[];for(let p=S.start;p<S.end;p++)u.push(this.b[p]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,u,p){if(this.j)return;const $=[],d=[],t=[];if(S.reverse().forEach(i=>{const m=i[2].map(n=>{const a=new I(this,this.l,n);return u||d.push(I.asModelAddData(this.apiNotebook,n)),a}),k=new l(i[0],i[1],[],m),b=this.b.splice(i[0],i[1],...m);for(const n of b)t.push(n.uri),k.deletedItems.push(n.apiCell);$.push(k)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),p)for(const i of $)p.push(i.asApiEvent())}s(S,u,p,$){const d=this.b.splice(S,u);this.b.splice(p,0,...d);const t=[new l(S,u,d.map(i=>i.apiCell),[]),new l(p,0,[],d)];for(const i of t)$.push(i.asApiEvent())}t(S,u){this.b[S].setOutputs(u)}u(S,u,p,$){this.b[S].setOutputItems(u,p,$)}v(S,u){const p=this.b[S];p.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(p.uri,u)}w(S,u){const p=this.b[S];p.apiCell.mime=u}x(S,u){this.b[S].setMetadata(u)}y(S,u){this.b[S].setInternalMetadata(u)}getCellFromApiCell(S){return this.b.find(u=>u.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(u=>u.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Xbc=f}),define(Pe[206],Ae([1,0,5,2,8,7]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class A{constructor(I,f,P,S={timeout:1500,errors:3}){this.b=I,this.c=f,this.d=P,this.f=S,this.a=new y.$jc}dispose(){}getOnWillSaveNotebookDocumentEvent(I){return(f,P,S)=>{const u=function($){f.call(P,$)};return u.extension=I,this.a.event(u,void 0,S)}}async $participateInSave(I,f,P){const S=R.URI.revive(I),u=this.c.getNotebookDocument(S);if(!u)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:C.TextDocumentSaveReason.to(f)},P,async(d,t)=>{const i=Date.now(),c=await await Promise.resolve(d);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof L.$3J?p.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(p.length===0)return!0;const $={edits:[]};for(const d of p){const{edits:t}=C.WorkspaceEdit.from(d);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$lcc=A}),define(Pe[104],Ae([1,0,9,8,7]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,I,f,P,S,u){this.id=l,this.f=I,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=P,this.c=u}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(I){this.selections=[I]},get selections(){return l.a},set selections(I){if(!Array.isArray(I)||!I.every(C.$eL.isNotebookRange))throw(0,y.$5)("selections");l.a=I,l.g(I)},get visibleRanges(){return l.b},revealRange(I,f){l.f.$tryRevealRange(l.id,R.NotebookRange.from(I),f??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(R.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$Ybc=L}),define(Pe[207],Ae([1,0,9,5,14,8]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;let A=class{constructor(I,f){this.c=I,this.d=f,this.a=new R.$hc({onListenerError:y.$Z}),this.b=new R.$hc({onListenerError:y.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(I,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,f);const P=this.d.getEditorById(I);f.visibleRanges&&P._acceptVisibleRanges(f.visibleRanges.ranges.map(L.NotebookRange.to)),f.selections&&P._acceptSelections(f.selections.selections.map(L.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const f in I)this.d.getEditorById(f)._acceptViewColumn(L.ViewColumn.to(I[f]))}};e.$ecc=A,e.$ecc=A=Ke([Ve(0,C.$3i)],A)}),define(Pe[208],Ae([1,0,8,72,153,21,64,9]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;class I{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,p,$){const d=this.b++,{title:t,location:i,cancellable:c}=p,m={label:(0,C.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(d,{location:y.ProgressLocation.from(i),title:t,source:m,cancellable:c},u.isUnderDevelopment?void 0:u.identifier.value).catch(l.$Z),this.d(d,$,!!c)}d(u,p,$){let d;$&&(d=new L.$rc,this.c.set(u,d));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let i;try{i=p(new P(this.a,u),$&&d?d.token:L.CancellationToken.None)}catch(c){throw t(u),c}return i.then(c=>t(u),c=>t(u)),i}$acceptProgressCanceled(u){const p=this.c.get(u);p&&(p.cancel(),this.c.delete(u))}}e.$ibc=I;function f(S,u){return S.message=u.message,typeof u.increment=="number"&&(typeof S.increment=="number"?S.increment+=u.increment:S.increment=u.increment),S}class P extends R.$1u{constructor(u,p){super($=>this.throttledReport($)),this.f=u,this.g=p}throttledReport(u){this.f.$progressReport(this.g,u)}}Ke([(0,A.$6g)(100,(S,u)=>f(S,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Pe[105],Ae([1,0,44,102,45,76,56,8,2]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=e.$6L=e.$5L=void 0;const f=(m,k,b,n)=>{let a=k;return{enumerable:!0,configurable:!1,get(){return a},set(r){if(!b(a,r)){const o=a;a=r,m.listener?.(n(r,o))}}}},P=(m,k)=>m===k,S={range:(m,k)=>m===k?!0:!m||!k?!1:m.isEqual(k),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(m,k)=>!(m.length!==k.length||m.some(b=>!k.find(n=>b.id===n.id)))},u=m=>k=>({op:4,update:m(k)}),p=(m,k)=>({range:(()=>{let b;const n=u(a=>({range:y.$hs.lift(l.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return b},set(a){m.listener?.({op:6}),S.range(b,a)||(b=a,m.listener?.(n(a)))}}})(),label:f(m,k,S.label,u(b=>({label:b}))),description:f(m,void 0,S.description,u(b=>({description:b}))),sortText:f(m,void 0,S.sortText,u(b=>({sortText:b}))),canResolveChildren:f(m,!1,S.canResolveChildren,b=>({op:2,state:b})),busy:f(m,!1,S.busy,u(b=>({busy:b}))),error:f(m,void 0,S.error,u(b=>({error:l.MarkdownString.fromStrict(b)||null}))),tags:f(m,[],S.tags,(b,n)=>({op:1,new:b.map(l.TestTag.from),old:n.map(l.TestTag.from)}))}),$=m=>{const k=C.$DI.fromString(m.extId),b=new t(k.controllerId,k.localId,m.label,I.URI.revive(m.uri)||void 0);return b.range=l.Range.to(m.range||void 0),b.description=m.description||void 0,b.sortText=m.sortText||void 0,b.tags=m.tags.map(n=>l.TestTag.to({id:(0,A.$II)(n).tagId})),b},d=m=>{let k;for(const b of m.tests){const n=$(b.item);(0,R.$OL)(n).parent=k,k=n}return k};e.$5L=d;class t{constructor(k,b,n,a){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const r=(0,R.$NL)(this,k);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof i?void 0:r.parent}},children:{value:(0,L.$ML)(r,R.$OL,t),enumerable:!0,writable:!1},...p(r,n)})}}e.$6L=t;class i extends t{constructor(k,b){super(k,k,b,void 0),this._isRoot=!0}}e.$7L=i;class c extends L.$IL{constructor(k,b,n){super({controllerId:k,getDocumentVersion:a=>a&&n.getDocument(a)?.version,getApiFor:R.$OL,getChildren:a=>a.children,root:new i(k,b),toITestItem:l.TestItem.from})}}e.$8L=c}),define(Pe[106],Ae([1,0,50,9,88,8,7]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.$ZL=void 0;class l{static{this.c=new C.$XL("TextEditorDecorationType")}constructor(u,p,$){const d=l.c.nextId();u.$registerTextEditorDecorationType(p.identifier,d,L.DecorationRenderOptions.from($)),this.value=Object.freeze({key:d,dispose(){u.$removeTextEditorDecorationType(d)}})}}e.$ZL=l;class I{constructor(u,p){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,p){this.k();let $=null;if(u instanceof A.$TJ)$=new A.$UJ(u,u);else if(u instanceof A.$UJ)$=u;else throw new Error("Unrecognized location");this.l($,p,!1)}insert(u,p){this.k(),this.l(new A.$UJ(u,u),p,!0)}delete(u){this.k();let p=null;if(u instanceof A.$UJ)p=u;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(u,p,$){const d=this.c.validateRange(u);this.g.push({range:d,text:p,forceMoveMarkers:$})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,R.$5)("endOfLine");this.h=u}}class f{constructor(u,p,$,d){this.c=u,this.d=p,this._accept($),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}m(u){const p=this.l(u);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}o(u){const p=this.n(u);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const p=this.p(u);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(u)})))}assign(u){const p={};let $=!1;if(typeof u.tabSize<"u"){const d=this.l(u.tabSize);d==="auto"?($=!0,p.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,$=!0,p.tabSize=d)}if(typeof u.indentSize<"u"){const d=this.n(u.indentSize);d==="tabSize"?($=!0,p.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,$=!0,p.indentSize=d)}if(typeof u.insertSpaces<"u"){const d=this.p(u.insertSpaces);d==="auto"?($=!0,p.insertSpaces=d):this.h!==d&&(this.h=d,$=!0,p.insertSpaces=d)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,$=!0,p.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,$=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(u.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(u,p){p.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn($)})}}e.$1L=f;class P{constructor(u,p,$,d,t,i,c,m){this.id=u,this.j=p,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,$),this.e=c,this.f=m;const k=this;this.value=Object.freeze({get document(){return d.value},set document(b){throw new R.$7("document")},get selection(){return k.c&&k.c[0]},set selection(b){if(!(b instanceof A.$VJ))throw(0,R.$5)("selection");k.c=[b],k.l()},get selections(){return k.c},set selections(b){if(!Array.isArray(b)||b.some(n=>!(n instanceof A.$VJ)))throw(0,R.$5)("selections");k.c=b,k.l()},get visibleRanges(){return k.e},set visibleRanges(b){throw new R.$7("visibleRanges")},get options(){return k.d.value},set options(b){k.g||k.d.assign(b)},get viewColumn(){return k.f},set viewColumn(b){throw new R.$7("viewColumn")},edit(b,n={undoStopBefore:!0,undoStopAfter:!0}){if(k.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new I(d.value,n);return b(a),k.m(a)},insertSnippet(b,n,a={undoStopBefore:!0,undoStopAfter:!0}){if(k.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=k.c.map(o=>L.Range.from(o));else if(n instanceof A.$TJ){const{lineNumber:o,column:w}=L.Position.from(n);r=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(n instanceof A.$UJ)r=[L.Range.from(n)];else{r=[];for(const o of n)if(o instanceof A.$UJ)r.push(L.Range.from(o));else{const{lineNumber:w,column:v}=L.Position.from(o);r.push({startLineNumber:w,startColumn:v,endLineNumber:w,endColumn:v})}}return p.$tryInsertSnippet(u,d.value.version,b.value,r,a)},setDecorations(b,n){const a=n.length===0;a&&!k.h.has(b.key)||(a?k.h.delete(b.key):k.h.add(b.key),k.n(()=>{if(L.$PL(n))return p.$trySetDecorations(u,b.key,L.$QL(n));{const r=new Array(4*n.length);for(let o=0,w=n.length;o<w;o++){const v=n[o];r[4*o]=v.start.line+1,r[4*o+1]=v.start.character+1,r[4*o+2]=v.end.line+1,r[4*o+3]=v.end.character+1}return p.$trySetDecorationsFast(u,b.key,r)}}))},revealRange(b,n){k.n(()=>p.$tryRevealRange(u,L.Range.from(b),n||A.TextEditorRevealType.Default))},show(b){p.$tryShowEditor(u,L.ViewColumn.from(b))},hide(){p.$tryHideEditor(u)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,y.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,y.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,y.ok)(!this.g),this.f=u}_acceptSelections(u){(0,y.ok)(!this.g),this.c=u}async l(){const u=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const p=u.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const $=p.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const c=$[t].end;if($[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=p.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,d,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$2L=P}),define(Pe[209],Ae([1,0,4,172]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8I=void 0,e.$8I=(0,y.$Ah)(R.$Gh)}),define(Pe[107],Ae([1,0,20,5,19,6]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z2b=e.$Y2b=e.$X2b=e.$W2b=e.$V2b=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.$V2b=A;class l{static isHostExtension(t,i,c){if(i.getExtensionDescription(t))return!1;const m=c.getExtensionDescription(t);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(t,i){this.h=t,this.c=new R.$hc,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(p),this.e=new y.$Vl,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const i=this.h.readActivationEvents(t);if(Array.isArray(i))for(let c of i)c==="onUri"&&(c=`onUri:${y.$Tl.toKey(t.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,i){this.d=$(this.d,i),this.d=this.d.concat(t);const c=l.k(this.d);return this.d=$(this.d,c.map(m=>m.identifier)),this.j(),this.c.fire(void 0),new A(c)}static k(t){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,a){this.addNode(n),this.addNode(a),this.c.has(n)?this.c.get(n).push(a):this.c.set(n,[a])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,a){const r=i.getArcs(n);for(let o=0;o<r.length;o++)if(!a.has(r[o]))return!1;return!0}getNodes(){return this.e}},c=new y.$Vl;for(const n of t)if(c.set(n.identifier,n),n.extensionDependencies)for(const a of n.extensionDependencies)i.addArc(y.$Tl.toKey(n.identifier),y.$Tl.toKey(a));const m=new Set;i.getNodes().filter(n=>i.getArcs(n).length===0).forEach(n=>m.add(n));const k=i.getNodes().filter(n=>!m.has(n));let b;do{b=!1;for(let n=0;n<k.length;n++){const a=k[n];i.hasOnlyGoodArcs(a,m)&&(k.splice(n,1),n--,m.add(a),b=!0)}}while(b);return k.map(n=>c.get(n))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this.g.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const i=this.e.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this.f)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$W2b=l,e.$X2b={readActivationEvents:d=>d.activationEvents};class I{constructor(t){this.d=new S,this.c=new l(t,[])}async acquireLock(t){const i=await this.d.acquire(t);return new f(this,i)}deltaExtensions(t,i,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this.c.getExtensionDescriptionByIdOrUUID(t,i)}}e.$Y2b=I;class f extends L.$mb{constructor(t,i){super(),this.f=t,this.c=!1,this.B(i)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$Z2b=f;class P{constructor(t){this.name=t,this.promise=new Promise((i,c)=>{this.c=i})}resolve(t){this.c(t)}}class S{constructor(){this.c=[],this.d=!1}async acquire(t){const i=new P(t);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};t.resolve((0,L.$kb)(m))}}var u;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(u||(u={}));function p(d,t){const i=d.isBuiltin?0:d.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==c)return i-c;const m=C.$8c.basename(d.extensionLocation.path),k=C.$8c.basename(t.extensionLocation.path);return m<k?-1:m>k?1:0}function $(d,t){const i=new y.$Ul(t);return d.filter(c=>!i.has(c.identifier))}}),define(Pe[79],Ae([1,0,25]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$3l=e.$2l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(R||(e.UIKind=R={}));var C;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var L;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(f){const P=y.$Hc.alloc(1);switch(f){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$2l=A;function l(f,P){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$3l=l;var I;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(I||(e.NativeLogMarkers=I={}))}),define(Pe[57],Ae([1,0,4,5,14,27,79,51,52,24,2,6,155]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=e.$$L=e.$0L=void 0;let p=class extends S.$mb{constructor(i,c){super(),this.n=i,this.p=c,this.a=this.B(new R.$hc),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$hc),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=P.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:I.$co,name:(0,u.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(m=>{(0,C.$5i)(m)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,m){const k=this.getTelemetryDetails(),b=new $(c,m,i,this.k,this.i,this.getBuiltInCommonProperties(i),{isUsageEnabled:k.isUsageEnabled,isErrorsEnabled:k.isErrorsEnabled}),n=this.m.get(i.identifier.value)??[];return this.m.set(i.identifier.value,[...n,b]),b.apiTelemetryLogger}$initializeTelemetryLevel(i,c,m){this.f=i,this.g=c,this.c=m??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=d(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,l.$Nk)((0,I.$jo)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.m.forEach((m,k)=>{const b=m.filter(n=>!n.isDisposed);b.length===0?this.m.delete(k):this.m.set(k,b)}),this.m.forEach(m=>{for(const k of m)k.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(i,c){const k=this.m.get(i.value)?.filter(n=>!n.isDisposed);if(!k)return this.m.delete(i.value),!1;let b=!1;for(const n of k)n.ignoreUnhandledExtHostErrors||(n.logError(c),b=!0);return b}};e.$0L=p,e.$0L=p=Ke([Ve(0,L.$9L),Ve(1,C.$4i)],p);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,m,k,b,n,a){this.g=m,this.h=k,this.i=b,this.j=n,this.a=new R.$hc,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,I.$mo)(c,[]),this.c&&(c=(0,f.$Wm)(c,this.c)),this.b||(c=(0,f.$Wm)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const m={name:i.name,message:i.message,stack:i.stack,cause:i.cause},k=(0,I.$mo)(m,[]),b=new Error(k.message,{cause:k.cause});b.stack=k.stack,b.name=k.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(b,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$$L=$;function d(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$_L=d,e.$aM=(0,y.$zh)("IExtHostTelemetry")}),define(Pe[26],Ae([1,0,5,2,181,98,20,4]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new A.$Tl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,l.$zh)("extensionService");class I{constructor(b){this.dependency=b}}e.$IF=I;var f;(function(k){k[k.EagerAutoStart=1]="EagerAutoStart",k[k.EagerManualStart=2]="EagerManualStart",k[k.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.$wF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(b,n){const a=[],r=[],o=[],w=[],v=S(this.c),E=S(b),D=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.c){const V=E.get(W.identifier);if(!V){a.push(W.identifier),v.delete(W.identifier);continue}if(!D(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}for(const W of b){const V=v.get(W.identifier);if(!V){r.push(W);continue}if(!D(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}const s=new A.$Ul(this.d),h=new A.$Ul(n);for(const W of this.d)h.has(W)||o.push(W);for(const W of n)s.has(W)||w.push(W);const g=L.$wF.createActivationEventsMap(r),M={toRemove:a,toAdd:r,addActivationEvents:g,myToRemove:o,myToAdd:w};return this.delta(M),M}delta(b){const{toRemove:n,toAdd:a,myToRemove:r,myToAdd:o}=b,w=new A.$Ul(n),v=new A.$Ul(r);for(let E=0;E<this.c.length;E++)w.has(this.c[E].identifier)&&(this.c.splice(E,1),E--);for(let E=0;E<this.d.length;E++)v.has(this.d[E])&&(this.d.splice(E,1),E--);for(const E of a)this.c.push(E);for(const E of o)this.d.push(E)}containsExtension(b){for(const n of this.d)if(A.$Tl.equals(n,b))return!0;return!1}}e.$JF=P;function S(k){const b=new A.$Vl;for(const n of k)b.set(n.identifier,n);return b}function u(k,b){return k.enabledApiProposals?k.enabledApiProposals.includes(b):!1}e.$KF=u;function p(k,b){if(!u(k,b))throw new Error(`Extension '${k.identifier.value}' CANNOT use API proposal: ${b}.
Its package.json#enabledApiProposals-property declares: ${k.enabledApiProposals?.join(", ")??"[]"} but NOT ${b}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${k.identifier.value}`)}e.$LF=p;class ${constructor(b,n,a,r){this.codeLoadingTime=b,this.activateCallTime=n,this.activateResolvedTime=a,this.activationReason=r}}e.$MF=$;class d{constructor(b,n){this.description=b,this.value=n}}e.$NF=d;var t;(function(k){k[k.Normal=0]="Normal",k[k.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(k){return{type:k.isBuiltin?0:1,isBuiltin:k.isBuiltin||k.isUserBuiltin,identifier:{id:(0,C.$so)(k.publisher,k.name),uuid:k.uuid},manifest:k,location:k.extensionLocation,targetPlatform:k.targetPlatform,validations:[],isValid:!0}}e.$OF=i;function c(k,b){return{identifier:new A.$Tl((0,C.$qo)(k.manifest.publisher,k.manifest.name)),isBuiltin:k.type===0,isUserBuiltin:k.type===1&&k.isBuiltin,isUnderDevelopment:!!b,extensionLocation:k.location,...k.manifest,uuid:k.identifier.uuid,targetPlatform:k.targetPlatform}}e.$PF=c;class m{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(b){return Promise.resolve(void 0)}activationEventIsDone(b){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(b,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=m}),define(Pe[210],Ae([1,0,9,107,20,26,14,13]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=e.$Nac=e.$Mac=e.$Lac=e.$Kac=void 0;class I{static{this.NONE=new I(!1,-1,-1,-1)}constructor(i,c,m,k){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=m,this.activateResolvedTime=k}}e.$Kac=I;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new I(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Lac=f;class P{constructor(i,c,m,k,b,n){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=m,this.module=k,this.exports=b,this.subscriptions=n}}e.$Mac=P;class S extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Nac=S;class u extends P{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Oac=u;class p extends P{constructor(i){super(!0,i,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,c,m,k){this.g=k,this.a=i,this.b=c,this.c=m,this.d=new C.$Vl,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,m]of this.d)i.push(m.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const m=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(m.map(k=>({id:k.identifier,reason:{startup:c,extensionId:k.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const m=this.a.getExtensionDescription(i);if(!m)throw new Error(`Extension '${i}' is not known`);return this.h([{id:m.identifier,reason:c}])}async h(i){const c=i.filter(m=>!this.isActivated(m.id)).map(m=>this.j(m));await Promise.all(c.map(m=>m.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const b=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new p(b));return this.c.onExtensionActivationError(i.id,b,new L.$IF(i.id.value)),n}const m=[],k=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const b of k){if(this.m(b))continue;const n=this.d.get(b);if(n){m.push(n);continue}if(this.l(b)){m.push(this.j({id:this.b.getExtensionDescription(b).identifier,reason:i.reason}));continue}const a=this.a.getExtensionDescription(b);if(a){if(!a.main&&!a.browser)continue;m.push(this.j({id:a.identifier,reason:i.reason}));continue}const r=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${b}'`),w=this.k(i,c.displayName,[],new p(o));return this.c.onExtensionActivationError(c.identifier,o,new L.$IF(b)),w}return this.k(i,c.displayName,m,null)}k(i,c,m,k){const b=new d(i.id,c,i.reason,m,k,this.c,this.g);return this.d.set(i.id,b),b}l(i){return R.$W2b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$Pac=$,e.$Pac=$=Ke([Ve(3,A.$3i)],$);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,m,k,b,n,a){this.c=i,this.d=c,this.f=m,this.g=k,this.h=b,this.j=n,this.k=a,this.a=new l.$Dg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const m=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);m.detail=c.value.activationFailedError,this.h=new p(m),this.j.onExtensionActivationError(this.c,m,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new p(c),this.b&&y.$2(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};d=Ke([Ve(6,A.$3i)],d)}),define(Pe[211],Ae([1,0,157,23,2,5,6,193,13,7,16,18,8,49,21,126,26]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;function i(k,b){if((0,P.$le)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let n;return Array.isArray(k.highlights)&&(n=k.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),n=n.length?n:void 0),{label:k.label,highlights:n}}}class c{constructor(b,n,a){this.d=b,this.e=n,this.f=a,this.a=new Map,this.b=new d.$96;function r(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>r(o)?this.i(o):Array.isArray(o)&&o.length>0?o.map(w=>r(w)?this.i(w):w):o})}registerTreeDataProvider(b,n,a){const r=this.createTreeView(b,{treeDataProvider:n},a);return{dispose:()=>r.dispose()}}createTreeView(b,n,a){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],w=!!n.dragAndDropController?.handleDrag,v=!!n.dragAndDropController?.handleDrop,E=this.h(b,n,a),D={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:r,dragMimeTypes:o,hasHandleDrag:w,hasHandleDrop:v,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},s=this.d.$registerTreeViewDataProvider(b,D);return{get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,t.$LF)(a,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,t.$LF)(a,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(g){(0,p.$Xj)(g)&&(0,t.$LF)(a,"treeViewMarkdownMessage"),E.message=g},get title(){return E.title},set title(g){E.title=g},get description(){return E.description},set description(g){E.description=g},get badge(){return E.badge},set badge(g){g!==void 0&&f.ViewBadge.isViewBadge(g)?E.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(E.badge=void 0)},reveal:(g,M)=>E.reveal(g,M),dispose:async()=>{await s,this.a.delete(b),E.dispose()}}}$getChildren(b,n){const a=this.a.get(b);return a?a.getChildren(n):Promise.reject(new l.$0E(b))}async $handleDrop(b,n,a,r,o,w,v,E){const D=this.a.get(b);if(!D)return Promise.reject(new l.$0E(b));const s=u.DataTransfer.toDataTransfer(a,async h=>(await this.d.$resolveDropFileData(b,n,h)).buffer);return v===b&&E&&await this.g(s,D,E,o,w),D.onDrop(s,r,o)}async g(b,n,a,r,o){const w=this.b.removeDragOperationTransfer(o);if(w)(await w)?.forEach((v,E)=>{v&&b.set(E,v)});else if(o&&n.handleDrag){const v=n.handleDrag(a,b,r);this.b.addDragOperationTransfer(o,v),await v}return b}async $handleDrag(b,n,a,r){const o=this.a.get(b);if(!o)return Promise.reject(new l.$0E(b));const w=await this.g(new f.$KK,o,n,r,a);if(!(!w||r.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(b){const n=this.a.get(b);if(!n)throw new l.$0E(b);return n.hasResolve}$resolve(b,n,a){const r=this.a.get(b);if(!r)throw new l.$0E(b);return r.resolveTreeItem(n,a)}$setExpanded(b,n,a){const r=this.a.get(b);if(!r)throw new l.$0E(b);r.setExpanded(n,a)}$setSelectionAndFocus(b,n,a){const r=this.a.get(b);if(!r)throw new l.$0E(b);r.setSelectionAndFocus(n,a)}$setVisible(b,n){const a=this.a.get(b);if(!a){if(!n)return;throw new l.$0E(b)}a.setVisible(n)}$changeCheckboxState(b,n){const a=this.a.get(b);if(!a)throw new l.$0E(b);a.setCheckboxState(n)}h(b,n,a){const r=new m(b,n,this.d,this.e.converter,this.f,a);return this.a.set(b,r),r}i(b){const n=this.a.get(b.$treeViewId);return n&&"$treeItemHandle"in b?n.getExtensionElement(b.$treeItemHandle):n&&"$focusedTreeItem"in b&&b.$focusedTreeItem?n.focusedElement:null}}e.$pbc=c;class m extends A.$mb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(b=>this.getExtensionElement(b)).filter(b=>!(0,P.$ue)(b))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(b,n,a,r,o,w){if(super(),this.D=b,this.F=a,this.G=r,this.H=o,this.I=w,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new L.$hc),this.onDidExpandElement=this.r.event,this.s=this.B(new L.$hc),this.onDidCollapseElement=this.s.event,this.t=this.B(new L.$hc),this.onDidChangeSelection=this.t.event,this.u=this.B(new L.$hc),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new L.$hc),this.onDidChangeVisibility=this.v.event,this.w=this.B(new L.$hc),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new L.$hc),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new $.$rc,w.contributes&&w.contributes.views)for(const D in w.contributes.views)for(const s of w.contributes.views[D])s.id===b&&(this.L=s.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(D=>this.y.fire({message:!1,element:D})));let v,E;this.B(L.Event.debounce(this.y.event,(D,s)=>(D||(D={message:!1,elements:[]}),s.element!==!1&&(v||(v=new Promise(h=>E=h),this.z=this.z.then(()=>v)),Array.isArray(s.element)?D.elements.push(...s.element):D.elements.push(s.element)),s.message&&(D.message=!0),D),200,!0)(({message:D,elements:s})=>{s.length&&(this.C=this.C.then(()=>{const h=E;return v=null,this.W(s).then(()=>h())})),D&&this.F.$setMessage(this.D,u.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(b){const n=b?this.getExtensionElement(b):void 0;if(b&&!n)return this.H.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let a=this.R(b);return a||(a=await this.S(n)),a?a.map(r=>r.item):void 0}getExtensionElement(b){return this.i.get(b)}reveal(b,n){n=n||{select:!0,focus:!1};const a=(0,P.$ue)(n.select)?!0:n.select,r=(0,P.$ue)(n.focus)?!1:n.focus,o=(0,P.$ue)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.z.then(()=>this.O(b)).then(w=>this.Q(b,w[w.length-1]).then(v=>this.F.$reveal(this.D,{item:v.item,parentChain:w.map(E=>E.item)},{select:a,focus:r,expand:o})),w=>this.H.error(w)):this.F.$reveal(this.D,void 0,{select:a,focus:r,expand:o})}get message(){return this.J}set message(b){this.J=b,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(b){this.L=b,this.F.$setTitle(this.D,b,this.M)}get description(){return this.M}set description(b){this.M=b,this.F.$setTitle(this.D,this.L,b)}get badge(){return this.N}set badge(b){this.N?.value===b?.value&&this.N?.tooltip===b?.tooltip||(this.N=u.ViewBadge.from(b),this.F.$setBadge(this.D,b))}setExpanded(b,n){const a=this.getExtensionElement(b);a&&(n?this.r.fire(Object.freeze({element:a})):this.s.fire(Object.freeze({element:a})))}setSelectionAndFocus(b,n){const a=!(0,S.$of)(this.l,b);this.l=b;const r=this.m!==n;this.m=n,a&&this.t.fire(Object.freeze({selection:this.selectedElements})),r&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(b){b!==this.k&&(this.k=b,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(b){const n=(await Promise.all(b.map(async a=>{const r=this.getExtensionElement(a.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:a.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);n.forEach(a=>{a.treeItem.checkboxState=a.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.w.fire({items:n.map(a=>[a.extensionItem,a.newState])})}async handleDrag(b,n,a){const r=[];for(const o of b){const w=this.getExtensionElement(o);w&&r.push(w)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,n,a),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(b,n,a){const r=n?this.getExtensionElement(n):void 0;if(!(!r&&n||!this.g?.handleDrop))return(0,I.$xg)(()=>this.g?.handleDrop?this.g.handleDrop(r,b,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(b,n){if(!this.f.resolveTreeItem)return;const a=this.i.get(b);if(a){const r=this.j.get(a);if(r){const o=await this.f.resolveTreeItem(r.extensionItem,a,n)??r.extensionItem;return this.db(o),r.item.tooltip=this.ab(o.tooltip),r.item.command=this.bb(r.disposableStore,o.command),r.item}}}O(b){return this.P(b).then(n=>n?this.O(n).then(a=>this.Q(n,a[a.length-1]).then(r=>(a.push(r),a))):Promise.resolve([]))}P(b){const n=this.j.get(b);return n?Promise.resolve(n.parent?this.i.get(n.parent.item.handle):void 0):(0,I.$xg)(()=>this.f.getParent(b))}Q(b,n){const a=this.j.get(b);return a?Promise.resolve(a):(0,I.$xg)(()=>this.f.getTreeItem(b)).then(r=>this.gb(b,r,n,!0)).then(r=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(r);if(o){const w=this.j.get(o);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.I.identifier.value}`)}))}R(b){if(b){let n;if(typeof b=="string"){const a=this.getExtensionElement(b);n=a?this.j.get(a):void 0}else n=b;return n&&n.children||void 0}return this.h}async S(b){this.nb(b);const n=new $.$rc(this.U.token);try{const a=b?this.j.get(b):void 0,r=await this.f.getChildren(b);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,S.$Af)(r||[]).map(async w=>{const v=await this.f.getTreeItem(w);return v&&!n.token.isCancellationRequested?this.$(w,v,a):null}));return n.token.isCancellationRequested?void 0:(0,S.$Af)(o)}finally{n.dispose()}}W(b){if(b.some(a=>!a))return this.U.dispose(!0),this.U=new $.$rc,this.pb(),this.F.$refresh(this.D);{const a=this.X(b);if(a.length)return this.Y(a)}return Promise.resolve(void 0)}X(b){const n=new Set,a=b.map(o=>this.j.get(o));for(const o of a)if(o&&!n.has(o.item.handle)){let w=o;for(;w&&w.parent&&a.findIndex(v=>w&&w.parent&&v&&v.item.handle===w.parent.item.handle)===-1;){const v=this.i.get(w.parent.item.handle);w=v?this.j.get(v):void 0}w&&!w.parent&&n.add(o.item.handle)}const r=[];return n.forEach(o=>{const w=this.i.get(o);if(w){const v=this.j.get(w);v&&(!v.parent||!n.has(v.parent.item.handle))&&r.push(o)}}),r}Y(b){const n={};return Promise.all(b.map(a=>this.Z(a).then(r=>{r&&(n[a]=r.item)}))).then(()=>Object.keys(n).length?this.F.$refresh(this.D,n):void 0)}Z(b){const n=this.getExtensionElement(b);if(n){const a=this.j.get(n);if(a)return this.nb(n),(0,I.$xg)(()=>this.f.getTreeItem(n)).then(r=>{if(r){const o=this.eb(n,r,a.parent);return this.lb(n,o,a,a.parent),a.dispose(),o}return null})}return Promise.resolve(null)}$(b,n,a){const r=this.eb(b,n,a);if(n.id&&this.i.has(r.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.kb(b,r),this.mb(r,a),r}ab(b){return f.$hK.isMarkdownString(b)?u.MarkdownString.from(b):b}bb(b,n){return n?{...this.G.toInternal(n,b),originalId:n.command}:void 0}cb(b){if(b.checkboxState===void 0)return;let n,a,r;return typeof b.checkboxState=="number"?n=b.checkboxState:(n=b.checkboxState.state,a=b.checkboxState.tooltip,r=b.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:r}}db(b){if(!f.$FK.isTreeItem(b,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(b,n,a){this.db(n);const r=new A.$lb,o=this.gb(b,n,a),w=this.hb(n);return{item:{handle:o,parentHandle:a?a.item.handle:void 0,label:i(n.label,this.I),description:n.description,resourceUri:n.resourceUri,tooltip:this.ab(n.tooltip),command:this.bb(r,n.command),contextValue:n.contextValue,icon:w,iconDark:this.ib(n)||w,themeIcon:this.fb(n),collapsibleState:(0,P.$ue)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.cb(n)},extensionItem:n,parent:a,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(b){return b.iconPath instanceof f.$NK?b.iconPath:void 0}gb(b,{id:n,label:a,resourceUri:r},o,w){if(n)return`${m.b}/${n}`;const v=i(a,this.I),E=o?o.item.handle:m.a;let D=v?v.label:r?(0,R.$dg)(r):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const s=this.j.has(b)?this.j.get(b).item.handle:void 0,h=this.R(o)||[];let g,M=0;do{if(g=`${E}/${M}:${D}`,w||!this.i.has(g)||s===g)break;M++}while(M<=h.length);return g}hb(b){if(b.iconPath&&!(b.iconPath instanceof f.$NK))return typeof b.iconPath=="string"||C.URI.isUri(b.iconPath)?this.jb(b.iconPath):this.jb(b.iconPath.light)}ib(b){if(b.iconPath&&!(b.iconPath instanceof f.$NK)&&b.iconPath.dark)return this.jb(b.iconPath.dark)}jb(b){return C.URI.isUri(b)?b:C.URI.file(b)}kb(b,n){this.i.set(n.item.handle,b),this.j.set(b,n)}lb(b,n,a,r){this.i.delete(n.item.handle),this.j.delete(b),n.item.handle!==a.item.handle&&this.i.delete(a.item.handle),this.kb(b,n);const o=this.R(r)||[],w=o.filter(v=>v.item.handle===a.item.handle)[0];w&&o.splice(o.indexOf(w),1,n)}mb(b,n){n?(n.children||(n.children=[]),n.children.push(b)):(this.h||(this.h=[]),this.h.push(b))}nb(b){if(b){const n=this.j.get(b);if(n){if(n.children)for(const a of n.children){const r=this.i.get(a.item.handle);r&&this.ob(r)}n.children=void 0}}else this.pb()}ob(b){const n=this.j.get(b);if(n){if(n.children)for(const a of n.children){const r=this.i.get(a.item.handle);r&&this.ob(r)}this.j.delete(b),this.i.delete(n.item.handle),n.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(b=>b.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(Pe[212],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[213],Ae([1,0,167,9,29,92,73,30,20,212,177,98]),function(pe,e,y,R,C,L,A,l,I,f,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0;const u=l.$6m.as(A.$7m.JSONContribution);class p{constructor(b,n,a){this.a=b,this.b=n,this.c=a}d(b,n){this.a({type:b,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(C.default.Error,b)}warn(b){this.d(C.default.Warning,b)}info(b){this.d(C.default.Info,b)}}e.$RF=p;class ${static a(b){const n=new I.$Ul;for(let a=0,r=b.length;a<r;a++)n.add(b[a].description.identifier);return n}static compute(b,n){if(!b||!b.length)return new $(n,[]);if(!n||!n.length)return new $([],b);const a=this.a(b),r=this.a(n),o=n.filter(v=>!a.has(v.description.identifier)),w=b.filter(v=>!r.has(v.description.identifier));return new $(o,w)}constructor(b,n){this.added=b,this.removed=n}}e.$SF=$;class d{constructor(b,n){this.name=b,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=$.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,R.$Y)(b)}}}e.$TF=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$UF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:I.$Sl},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Kn}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Kn}},extensionKind:{description:y.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const n=new d(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,n),b.activationEventsGenerator&&S.$wF.register(b.extensionPoint,b.activationEventsGenerator),e.$UF.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,u.registerSchema(i,e.$UF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$VF=c;const m={ExtensionsRegistry:"ExtensionsRegistry"};l.$6m.add(m.ExtensionsRegistry,new c),e.$WF=l.$6m.as(m.ExtensionsRegistry),u.registerSchema(i,e.$UF),u.registerSchema(P.$jj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Pe[214],Ae([1,0,164,16,24,213,32,5]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=void 0;const I={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var f;(function(u){function p($,d,t){if(!$)return;const i=R.$le($.type)?$.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const c=[];if(Array.isArray($.required))for(const m of $.required)R.$le(m)&&c.push(m);return{extensionId:d.value,taskType:i,required:c,properties:$.properties?C.$Tm($.properties):{},when:$.when?A.$Gi.deserialize($.when):void 0}}u.from=p})(f||(f={}));const P=L.$WF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,p)=>{for(const $ of u)$.type&&p.push(`onTaskType:${$.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:I}});class S{constructor(){this.d=new l.$hc,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,$)=>{P.setHandler((d,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const m of c)this.a&&m.type&&this.a[m.type]&&delete this.a[m.type]}for(const i of t.added){const c=i.value;for(const m of c){const k=f.from(m,i.description.identifier,i.collector);k&&(this.a[k.taskType]=k)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const $ of this.all()){const d={type:"object",additionalProperties:!1};$.required.length>0&&(d.required=$.required.slice(0)),$.properties!==void 0?d.properties=C.$Tm($.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[$.taskType]},p.push(d)}this.c={oneOf:p}}return this.c}}e.$6F=new S}),define(Pe[215],Ae([1,0,165,16,23,24,32,214]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$dG=e.JsonSchemaVersion=e.ExecutionEngine=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$0F=e.ShellQuoting=e.$9F=e.$8F=e.$7F=void 0,e.$7F="settings",e.$8F=new A.$Zi("taskRunning",!1,y.localize(0,null)),e.$9F={value:y.localize(1,null),original:"Tasks"};var I;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(I||(e.ShellQuoting=I={})),e.$0F="$customized",function(U){function z(ie){if(!ie)return U.Strong;switch(ie.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=z}(I||(e.ShellQuoting=I={}));var f;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var P;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(P||(e.RevealKind=P={})),function(U){function z(ie){switch(ie.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=z}(P||(e.RevealKind=P={}));var S;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(U){function z(ie){switch(ie.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=z}(S||(e.RevealProblemKind=S={}));var u;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(u||(e.PanelKind=u={})),function(U){function z(ie){switch(ie.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=z}(u||(e.PanelKind=u={}));var p;(function(U){U.defaults={echo:!0,reveal:P.Always,revealProblems:S.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var $;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(U){function z(X){switch(X.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=z;function ie(X){switch(X){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=ie}($||(e.RuntimeType=$={}));var d;(function(U){function z(ie){return R.$le(ie)?ie:ie.value}U.value=z})(d||(e.CommandString=d={}));var t;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function z(X){return X===U.Clean._id||X===U.Build._id||X===U.Rebuild._id||X===U.Test._id}U.is=z;function ie(X){if(X!==void 0)return R.$le(X)?z(X)?{_id:X,isDefault:!1}:void 0:X}U.from=ie})(t||(e.TaskGroup=t={}));var i;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function z(ie){switch(ie){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=z})(c||(e.TaskSourceKind=c={}));var m;(function(U){U.parallel="parallel",U.sequence="sequence"})(m||(e.DependsOrder=m={}));var k;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(k||(e.RunOnOptions=k={}));var b;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:k.default,instanceLimit:1}})(b||(e.RunOptions=b={}));class n{constructor(z,ie,X,ye,De,Re){this._label="",this._id=z,ie&&(this._label=ie),X&&(this.type=X),this.runOptions=ye,this.configurationProperties=De,this._source=Re}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,ie=!1){if(z===void 0)return!1;if(R.$le(z))return z===this._label||z===this.configurationProperties.identifier||ie&&z===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$$F=n;class a extends n{constructor(z,ie,X,ye,De,Re,Y,le){super(z,X,void 0,Y,le,ie),this.command={},this._source=ie,this.hasDefinedMatchers=Re,De&&(this.command=De)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case $.Shell:ie="shell";break;case $.Process:ie="process";break;case $.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(z){return z instanceof a}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$7F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ie=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ie+=this._source.kind);const X={type:e.$0F,folder:z,id:ie};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$dg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new a(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$_F=a;class r extends n{constructor(z,ie,X,ye,De,Re,Y){super(z,X,ye,Re,Y,ie),this._source=ie,this.configures=De}static is(z){return z instanceof r}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$dg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$7F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ie=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ie+=this._source.kind);const X={type:e.$0F,folder:z,id:ie};return JSON.stringify(X)}}e.$aG=r;class o extends n{constructor(z,ie,X,ye,De,Re,Y,le,we){super(z,X,ye,le,we,ie),this.defines=De,this.hasDefinedMatchers=Y,this.command=Re,this.icon=we.icon,this.hide=we.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof o}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new o(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$bG=o;class w extends n{constructor(z,ie,X,ye,De,Re){super(z,X,ye,De,Re,ie),this._source=ie}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new w(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$cG=w;var v;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(U){U._default=U.Terminal}(v||(e.ExecutionEngine=v={}));var E;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class D{constructor(z){this.c=new Map;for(let ie=0;ie<z.length;ie++)this.c.set(z[ie].uri.toString(),ie)}compare(z,ie){const X=z.getWorkspaceFolder(),ye=ie.getWorkspaceFolder();if(X&&ye){let De=this.c.get(X.uri.toString());De=De===void 0?0:De+1;let Re=this.c.get(ye.uri.toString());return Re=Re===void 0?0:Re+1,De===Re?z._label.localeCompare(ie._label):De-Re}else return!X&&ye?-1:X&&!ye?1:0}}e.$dG=D;var s;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(s||(e.TaskEventKind=s={}));var h;(function(U){U.SingleRun="singleRun",U.Background="background"})(h||(e.TaskRunType=h={}));var g;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(g||(e.TaskRunSource=g={}));var M;(function(U){function z(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function ie(le,we,ae){return{...z(le),kind:"start",terminalId:we,resolvedVariables:ae}}U.start=ie;function X(le,we,ae){return{...z(le),kind:"processStarted",terminalId:we,processId:ae}}U.processStarted=X;function ye(le,we,ae){return{...z(le),kind:"processEnded",terminalId:we,exitCode:ae}}U.processEnded=ye;function De(le,we,ae){return{...z(le),kind:"terminated",exitReason:ae,terminalId:we}}U.terminated=De;function Re(le,we,ae){return{...z(we),kind:le,terminalId:ae}}U.general=Re;function Y(){return{kind:"changed"}}U.changed=Y})(M||(e.TaskEvent=M={}));var W;(function(U){function z(X){const ye=Object.keys(X).sort();let De="";for(const Re of ye){let Y=X[Re];Y instanceof Object?Y=z(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),De+=Re+","+Y+","}return De}function ie(X){const De={_key:z(X),type:X.taskType};return Object.assign(De,X),De}U.create=ie})(W||(e.KeyedTaskIdentifier=W={}));var V;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var B;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(B||(e.TasksSchemaProperties=B={}));var j;(function(U){function z(ie,X){const ye=l.$6F.get(ie.type);if(ye===void 0){const le=L.$Tm(ie);return delete le._key,W.create(le)}const De=Object.create(null);De.type=ye.taskType;const Re=new Set;ye.required.forEach(le=>Re.add(le));const Y=ye.properties;for(const le of Object.keys(Y)){const we=ie[le];if(we!=null)De[le]=we;else if(Re.has(le)){const ae=Y[le];if(ae.default!==void 0)De[le]=L.$Tm(ae.default);else switch(ae.type){case"boolean":De[le]=!1;break;case"number":case"integer":De[le]=0;break;case"string":De[le]="";break;default:X.error(y.localize(2,null,JSON.stringify(ie,void 0,0),le));return}}}return W.create(De)}U.createTaskIdentifier=z})(j||(e.TaskDefinition=j={}))}),define(Pe[216],Ae([1,0,9]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22b=e.$12b=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$Y)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$12b=R;class C extends R{constructor(){super(),this.h=!0,this.i=new y.$3}}e.$22b=C}),define(Pe[46],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_z=e.$$z=e.$0z=e.$9z=void 0;class y{static{this.count=0}constructor(I){this._proxyIdentifierBrand=void 0,this.sid=I,this.nid=++y.count}}e.$9z=y;const R=[];function C(l){const I=new y(l);return R[I.nid]=I,I}e.$0z=C;function L(l){return R[l].sid}e.$$z=L;class A{constructor(I){this.value=I}}e.$_z=A}),define(Pe[3],Ae([1,0,46]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RJ=e.$QJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$PJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var C;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var L;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var I;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(I||(e.CellOutputKind=I={}));var f;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class S{static{this.a=0}static mixin(t){return t._id=S.a++,t}}e.$PJ=S;var u;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var p;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var $;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$QJ={MainThreadAuthentication:(0,y.$0z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$0z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$0z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,y.$0z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,y.$0z)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$0z)("MainThreadClipboard"),MainThreadCommands:(0,y.$0z)("MainThreadCommands"),MainThreadComments:(0,y.$0z)("MainThreadComments"),MainThreadConfiguration:(0,y.$0z)("MainThreadConfiguration"),MainThreadConsole:(0,y.$0z)("MainThreadConsole"),MainThreadDebugService:(0,y.$0z)("MainThreadDebugService"),MainThreadDecorations:(0,y.$0z)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$0z)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$0z)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$0z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$0z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$0z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$0z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$0z)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$0z)("MainThreadErrors"),MainThreadTreeViews:(0,y.$0z)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$0z)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$0z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$0z)("MainThreadLanguages"),MainThreadLogger:(0,y.$0z)("MainThreadLogger"),MainThreadMessageService:(0,y.$0z)("MainThreadMessageService"),MainThreadOutputService:(0,y.$0z)("MainThreadOutputService"),MainThreadProgress:(0,y.$0z)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$0z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$0z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$0z)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$0z)("MainThreadSecretState"),MainThreadStorage:(0,y.$0z)("MainThreadStorage"),MainThreadTelemetry:(0,y.$0z)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$0z)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$0z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$0z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$0z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$0z)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$0z)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$0z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$0z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$0z)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$0z)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.$0z)("MainThreadExtensionService"),MainThreadSCM:(0,y.$0z)("MainThreadSCM"),MainThreadSearch:(0,y.$0z)("MainThreadSearch"),MainThreadShare:(0,y.$0z)("MainThreadShare"),MainThreadTask:(0,y.$0z)("MainThreadTask"),MainThreadWindow:(0,y.$0z)("MainThreadWindow"),MainThreadLabelService:(0,y.$0z)("MainThreadLabelService"),MainThreadNotebook:(0,y.$0z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$0z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$0z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$0z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$0z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$0z)("MainThreadInteractive"),MainThreadChat:(0,y.$0z)("MainThreadChat"),MainThreadInlineChat:(0,y.$0z)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$0z)("MainThreadTheming"),MainThreadTunnelService:(0,y.$0z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$0z)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$0z)("MainThreadTimeline"),MainThreadTesting:(0,y.$0z)("MainThreadTesting"),MainThreadLocalization:(0,y.$0z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$0z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$0z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$0z)("MainThreadIssueReporter")},e.$RJ={ExtHostCommands:(0,y.$0z)("ExtHostCommands"),ExtHostConfiguration:(0,y.$0z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$0z)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$0z)("ExtHostDebugService"),ExtHostDecorations:(0,y.$0z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$0z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$0z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$0z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$0z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$0z)("ExtHostEditors"),ExtHostTreeViews:(0,y.$0z)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$0z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$0z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$0z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$0z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$0z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$0z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$0z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$0z)("ExtHostStatusBar"),ExtHostShare:(0,y.$0z)("ExtHostShare"),ExtHostExtensionService:(0,y.$0z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$0z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$0z)("ExtHostTerminalService"),ExtHostSCM:(0,y.$0z)("ExtHostSCM"),ExtHostSearch:(0,y.$0z)("ExtHostSearch"),ExtHostTask:(0,y.$0z)("ExtHostTask"),ExtHostWorkspace:(0,y.$0z)("ExtHostWorkspace"),ExtHostWindow:(0,y.$0z)("ExtHostWindow"),ExtHostWebviews:(0,y.$0z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$0z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$0z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$0z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$0z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$0z)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$0z)("ExtHostProgress"),ExtHostComments:(0,y.$0z)("ExtHostComments"),ExtHostSecretState:(0,y.$0z)("ExtHostSecretState"),ExtHostStorage:(0,y.$0z)("ExtHostStorage"),ExtHostUrls:(0,y.$0z)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$0z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$0z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$0z)("ExtHostOutputService"),ExtHosLabelService:(0,y.$0z)("ExtHostLabelService"),ExtHostNotebook:(0,y.$0z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$0z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$0z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$0z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$0z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$0z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$0z)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$0z)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$0z)("ExtHostChat"),ExtHostChatSlashCommands:(0,y.$0z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,y.$0z)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$0z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,y.$0z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$0z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$0z)("ExtHostTheming"),ExtHostTunnelService:(0,y.$0z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$0z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$0z)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$0z)("ExtHostTimeline"),ExtHostTesting:(0,y.$0z)("ExtHostTesting"),ExtHostTelemetry:(0,y.$0z)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$0z)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$0z)("ExtHostIssueReporter")}}),define(Pe[217],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$QJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,I){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(l,I)??[]}getRelatedInformation(A,l,I){return this.c.$getAiRelatedInformation(l,I)}registerRelatedInformationProvider(A,l,I){const f=this.b;return this.b++,this.a.set(f,I),this.c.$registerAiRelatedInformationProvider(f,l),new R.$SJ(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$rcc=C}),define(Pe[80],Ae([1,0,4,14,3,17]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=e.$uac=e.$tac=void 0,e.$tac=(0,y.$zh)("IExtHostApiDeprecationService");let A=class{constructor(I,f){this.c=f,this.a=new Set,this.b=I.getProxy(C.$QJ.MainThreadTelemetry)}report(I,f,P){const S=this.d(I,f);this.a.has(S)||(this.a.add(S),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${I}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:I}))}d(I,f){return`${I}-${f.identifier.value}`}};e.$uac=A,e.$uac=A=Ke([Ve(0,L.$SL),Ve(1,R.$3i)],A),e.$vac=Object.freeze(new class{report(l,I,f){}})}),define(Pe[218],Ae([1,0,5,3,7,20]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new y.$hc,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=f.getProxy(R.$QJ.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,P,S,u={}){const p=L.$Tl.toKey(f.identifier),$=[...S].sort().join(" ");return await this.f.getOrCreate(`${p} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const d=f.displayName||f.name;return this.a.$getSession(P,S,p,d,u)})}async getSessions(f,P,S){const u=L.$Tl.toKey(f.identifier),p=[...S].sort().join(" ");return await this.g.getOrCreate(`${u} ${p}`,async()=>{await this.a.$ensureProvider(P);const $=f.displayName||f.name;return this.a.$getSessions(P,S,u,$)})}async removeSession(f,P){const S=this.b.get(f);return S?S.provider.removeSession(P):this.a.$removeSession(f,P)}registerAuthenticationProvider(f,P,S,u){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:P,provider:S,options:u??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===f)||this.c.push({id:f,label:P});const p=S.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(f,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(f,P,u?.supportsMultipleAccounts??!1),new C.$SJ(()=>{p.dispose(),this.b.delete(f);const $=this.c.findIndex(d=>d.id===f);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,P,S){const u=this.b.get(f);if(u)return Promise.resolve(u.provider.createSession(P,S));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,P){const S=this.b.get(f);if(S)return Promise.resolve(S.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,P){const S=this.b.get(f);if(S)return Promise.resolve(S.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,P){return this.d.fire({provider:{id:f,label:P}}),Promise.resolve()}}e.$2bc=A;class l{constructor(){this.a=new Map}getOrCreate(f,P){const S=this.a.get(f);if(S)return S;const u=P().finally(()=>this.a.delete(f));return this.a.set(f,u),u}}}),define(Pe[219],Ae([1,0,3,17,8]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;let L=class{constructor(l,I){this.a=l.getProxy(y.$QJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>I.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,I,f){const P=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,f?.isRefactoring??!1)}};e.$8bc=L,e.$8bc=L=Ke([Ve(0,R.$SL)],L)}),define(Pe[220],Ae([1,0,13,5,66,6,58,147,3,8]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class P{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=P.a++}}class S{static{this.a=0}constructor(p,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new R.$hc,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(I.$QJ.MainThreadChat)}registerChatProvider(p,$,d){const t=new P(p,d);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,L.$kb)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,$){const d=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof d=="number"&&this.g.$transferChatSession(d,$)}addChatRequest(p){this.g.$addRequest(p)}sendInteractiveRequestToProvider(p,$){this.g.$sendRequestToProvider(p,$)}async $prepareChat(p,$,d){const t=this.b.get(p);if(!t)return;const i=await t.provider.prepareSession($,d);if(!i)return;const c=S.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(p,$,d,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($);if(!c||!i.provider.resolveRequest)return;const m=await i.provider.resolveRequest(c,d,t);if(m)return{message:typeof m.message=="string"?m.message:f.ChatReplyFollowup.from(m.message)}}async $provideWelcomeMessage(p,$){const d=this.b.get(p);if(!d||!d.provider.provideWelcomeMessage)return;const t=await d.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>f.ChatReplyFollowup.from(c)))}async $provideFollowups(p,$,d){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,d))?.map(m=>f.ChatFollowup.from(m))}$removeRequest(p,$,d){const t=this.b.get(p);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,d)}async $provideReply(p,$,d,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($);if(!c)return;const m={session:c,message:typeof d.message=="string"?d.message:f.ChatReplyFollowup.to(d.message),variables:{}};if(d.variables)for(const o of Object.keys(d.variables))m.variables[o]=d.variables[o].map(f.ChatVariable.to);const k=A.$dc.create(!1);let b;const n={report:o=>{if(!t.isCancellationRequested)if(typeof b>"u"&&(b=k.elapsed()),"responseId"in o)this.g.$acceptResponseProgress(p,$,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const w=Promise.all([this.g.$acceptResponseProgress(p,$,{placeholder:o.placeholder}),o.resolvedContent]);(0,y.$tg)(w,t).then(v=>{if(!v)return;const[E,D]=v;this.g.$acceptResponseProgress(p,$,D,E??void 0)})}else"content"in o?this.g.$acceptResponseProgress(p,$,{content:typeof o.content=="string"?o.content:f.MarkdownString.from(o.content)}):this.g.$acceptResponseProgress(p,$,o)}};let a;try{a=await i.provider.provideResponseWithProgress(m,n,t),a||(a={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){a={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has($)){const o=c.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const r={firstProgress:b??0,totalElapsed:k.elapsed()};return{errorDetails:a.errorDetails,timings:r}}async $provideSlashCommands(p,$,d){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,d))?.map(m=>({...m,kind:f.CompletionItemKind.from(m.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$jcc=S}),define(Pe[221],Ae([1,0,6,3,8,72,20]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class l{static{this.a=1}constructor(f,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Vl,this.b=f.getProxy(R.$QJ.MainThreadChatProvider)}registerProvider(f,P,S,u){const p=l.a++;return this.c.set(p,{extension:f,provider:S}),this.b.$registerProvider(p,P,{extension:f,displayName:u.name??f.value}),(0,y.$kb)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(f,P,S,u,p){const $=this.c.get(f);if(!$)return;const d=new L.$1u(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return $.provider.provideChatResponse(S.map(C.ChatMessage.to),u,d,p)}allowListExtensionWhile(f,P){this.f.set(f,P),P.finally(()=>this.f.delete(f))}async requestChatResponseProvider(f,P){if(!this.f.has(f))throw new Error("Extension is NOT allowed to make chat requests");const S=this;return{get isRevoked(){return!S.f.has(f)},async makeRequest(u,p,$,d){if(!S.f.has(f))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;S.e.set(t,$);try{await S.b.$fetchResponse(f,P,t,u.map(C.ChatMessage.from),p,d)}finally{S.e.delete(t)}}}}async $handleResponseFragment(f,P){this.e.get(f)?.report(P)}}e.$occ=l}),define(Pe[222],Ae([1,0,6,3,7,8,72,13]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class I{static{this.a=0}constructor(S,u,p){this.d=u,this.e=p,this.b=new Map,this.c=S.getProxy(R.$QJ.MainThreadChatSlashCommands)}registerCommand(S,u,p,$){const d=I.a++;return this.b.set(d,{extension:S,command:p}),this.c.$registerCommand(d,u,$.description),(0,y.$kb)(()=>{this.c.$unregisterCommand(d),this.b.delete(d)})}async $executeCommand(S,u,p,$,d){const t=this.b.get(S);if(!t){this.e.warn(`[CHAT](${S}) CANNOT execute command because the command is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const m=new l.$Zg;d.onCancellationRequested(()=>m.complete()),setTimeout(()=>m.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,m.p);const k=t.command({role:C.ChatMessageRole.User,content:p},{history:$.history.map(L.ChatMessage.to)},new A.$1u(b=>{c(),this.c.$handleProgressChunk(u,{content:f(b.message)?b.message:b.message.value})}),d);try{return await(0,l.$tg)(Promise.resolve(k).then(b=>{if(b&&"followUp"in b)return{followUp:b?.followUp?.map(a=>L.ChatFollowup.from(a))}}),d)}finally{i=!0,m.complete()}}}e.$pcc=I;function f(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Pe[223],Ae([1,0,6,3,9,8]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class A{static{this.a=0}constructor(I){this.b=new Map,this.c=I.getProxy(R.$QJ.MainThreadChatVariables)}async $resolveVariable(I,f,P){const S=this.b.get(I);if(S)try{const u=await S.resolver.resolve(S.data.name,{message:f},P);if(u)return u.map(L.ChatVariable.from)}catch(u){(0,C.$Z)(u)}}registerVariableResolver(I,f,P,S){const u=A.a++;return this.b.set(u,{extension:I.identifier,data:{name:f,description:P},resolver:S}),this.c.$registerVariable(u,{name:f,description:P}),(0,y.$kb)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$qcc=A}),define(Pe[224],Ae([1,0,3]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0;class R{constructor(L){const A=L.getProxy(y.$QJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$yac=R}),define(Pe[31],Ae([1,0,16,7,8,24,3,18,14,68,44,278,2,6,4,17,105,25,46,41,58,52,57]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=void 0;let a=class{#e;#t;#i;constructor(D,s,h){this.b=new Map,this.c=new Map,this.#e=D.getProxy(A.$QJ.MainThreadCommands),this.d=s,this.#i=h,this.#t=D.getProxy(A.$QJ.MainThreadTelemetry),this.converter=new r(this,g=>{const M=this.c.get(g);return M?.result===w.Void?M:void 0},s),this.f=[{processArgument(g){return(0,f.$9g)(g)}},{processArgument(g){return(0,L.$Vm)(g,function(M){if(P.$hs.isIRange(M))return C.Range.to(M);if(S.$gs.isIPosition(M))return C.Position.to(M);if(P.$hs.isIRange(M.range)&&u.URI.isUri(M.uri))return C.location.to(M);if(M instanceof i.$Hc)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const s=this.registerCommand(!1,D.id,async(...h)=>{const g=D.args.map((W,V)=>{if(!W.validate(h[V]))throw new Error(`Invalid argument '${W.name}' when running '${D.id}', received: ${h[V]}`);return W.convert(h[V])}),M=await this.executeCommand(D.internalId,...g);return D.result.convert(M,h,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new R.$SJ(()=>{s.dispose(),this.c.delete(D.id)})}registerCommand(D,s,h,g,M,W){if(this.d.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this.b.has(s))throw new Error(`command '${s}' already exists`);return this.b.set(s,{callback:h,thisArg:g,description:M,extension:W}),D&&this.#e.$registerCommand(s),new R.$SJ(()=>{this.b.delete(s)&&D&&this.#e.$unregisterCommand(s)})}executeCommand(D,...s){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,s,!0)}async g(D,s,h){if(this.b.has(D))return this.#e.$fireCommandActivationEvent(D),this.h(D,s,!1);{let g=!1;const M=(0,L.$Vm)(s,function(W){if(W instanceof R.$TJ)return C.Position.from(W);if(W instanceof R.$UJ)return C.Range.from(W);if(W instanceof R.$5J)return C.location.from(W);if(R.$eL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return g=!0,i.$Hc.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return g=!0,i.$Hc.wrap(W);if(W instanceof i.$Hc)return g=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(D,g?new c.$_z(M):M,h);return(0,f.$9g)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(D,s,!1);throw W}}}async h(D,s,h){const g=this.b.get(D);if(!g)throw new Error("Unknown command");const{callback:M,thisArg:W,description:V}=g;if(V)for(let j=0;j<V.args.length;j++)try{(0,y.$Ce)(s[j],V.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${V.args[j].name}' - ${V.args[j].description}`)}const B=k.$dc.create();try{return await M.apply(W,s)}catch(j){if(D===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...s);U&&(D=U.command)}if(this.d.error(j,D,g.extension?.identifier),!h)throw j;if(g.extension?.identifier){const U=this.#i.onExtensionError(g.extension.identifier,j);this.d.trace("forwarded error to extension?",U,g.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.$ki)(j)),this.id=D,this.source=g.extension?.displayName??g.extension?.name}}}finally{this.j(g,D,B.elapsed())}}j(D,s,h){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new b.$0n(s),duration:h})}$executeContributedCommand(D,...s){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const h=this.b.get(D);return h?(s=s.map(g=>this.f.reduce((M,W)=>W.processArgument(M,h.extension?.identifier),g)),this.h(D,s,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then(s=>(D&&(s=s.filter(h=>h[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const D=Object.create(null);for(const[s,h]of this.b){const{description:g}=h;g&&(D[s]=g)}return Promise.resolve(D)}};e.$bM=a,e.$bM=a=Ke([Ve(0,d.$SL),Ve(1,I.$3i),Ve(2,n.$aM)],a),e.$cM=(0,$.$zh)("IExtHostCommands");class r{constructor(D,s,h){this.d=D,this.f=s,this.g=h,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,s){if(!D)return;const h={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return h;const g=this.f(D.command);if(g)h.id=g.internalId,h.arguments=g.args.map((M,W)=>M.convert(D.arguments&&D.arguments[W]));else if((0,l.$Ef)(D.arguments)){const M=`${D.command}/${++this.c}`;this.b.set(M,D),s.add((0,p.$kb)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),h.$ident=M,h.id=this.delegatingCommandId,h.arguments=[M],this.g.trace("CommandsConverter#CREATE",D.command,M)}return h}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const s=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],s?s.command:"MISSING"),s?this.d.executeCommand(s.command,...s.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$dM=r;class o{static{this.Uri=new o("uri","Uri of a text document",D=>u.URI.isUri(D),D=>D)}static{this.Position=new o("position","A position in a text document",D=>R.$TJ.isPosition(D),C.Position.from)}static{this.Range=new o("range","A range in a text document",D=>R.$UJ.isRange(D),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",D=>R.$VJ.isSelection(D),C.Selection.from)}static{this.Number=new o("number","",D=>typeof D=="number",D=>D)}static{this.String=new o("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=o.Arr(o.String)}static Arr(D){return new o(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,s=>Array.isArray(s)&&s.every(h=>D.validate(h)),s=>s.map(h=>D.convert(h)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",D=>D instanceof R.$dK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",D=>D instanceof R.$xL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",D=>D instanceof t.$6L,C.TestItem.from)}constructor(D,s,h,g){this.name=D,this.description=s,this.validate=h,this.convert=g}optional(){return new o(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,s){return new o(D??this.name,s??this.description,this.validate,this.convert)}}e.$eM=o;class w{static{this.Void=new w("no result",D=>D)}constructor(D,s){this.description=D,this.convert=s}}e.$fM=w;class v{constructor(D,s,h,g,M){this.id=D,this.internalId=s,this.description=h,this.args=g,this.result=M}}e.$gM=v}),define(Pe[225],Ae([1,0,18,12,2,78,91,32,95,31,8,7]),function(pe,e,y,R,C,L,A,l,I,f,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=void 0;const u=[new f.$gM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of DocumentHighlight-instances.",$(P.DocumentHighlight.to))),new f.$gM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$eM.Uri],new f.$fM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Df)(t))return;class c extends S.$0J{static to(k){const b=new c(k.name,P.SymbolKind.to(k.kind),k.containerName||"",new S.$5J(i[0],P.Range.to(k.range)));return b.detail=k.detail,b.range=b.location.range,b.selectionRange=P.Range.to(k.selectionRange),b.children=k.children?k.children.map(c.to):[],b}}return t.map(c.to)})),new f.$gM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$eM.Uri,new f.$eM("options","Formatting options",t=>!0,t=>t)],new f.$fM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new f.$gM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$eM.Uri,f.$eM.Range,new f.$eM("options","Formatting options",t=>!0,t=>t)],new f.$fM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new f.$gM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$eM.Uri,f.$eM.Position,new f.$eM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$eM("options","Formatting options",t=>!0,t=>t)],new f.$fM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new f.$gM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$gM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$gM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$gM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$gM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of Location-instances.",$(P.location.to))),new f.$gM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of Hover-instances.",$(P.Hover.to))),new f.$gM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$eM.Uri,new f.$eM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>S.$TJ.isPosition(i)),t=>t.map(P.Position.from))],new f.$fM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const m of i.reverse())c=new S.$cK(P.Range.to(m),c);return c}))),new f.$gM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$eM.String.with("query","Search string")],new f.$fM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new f.$gM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new f.$gM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$eM.CallHierarchyItem],new f.$fM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new f.$gM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$eM.CallHierarchyItem],new f.$fM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new f.$gM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new f.$gM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$eM.Uri,f.$eM.Position,f.$eM.String.with("newName","The new symbol name")],new f.$fM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new f.$gM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$eM.Uri,f.$eM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$fM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new f.$gM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$eM.Uri],new f.$fM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$9K(t.tokenTypes,t.tokenModifiers)})),new f.$gM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$eM.Uri],new f.$fM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$g0)(t);if(i.type==="full")return new S.$$K(i.data,void 0)})),new f.$gM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$eM.Uri,f.$eM.Range.optional()],new f.$fM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$9K(t.tokenTypes,t.tokenModifiers)})),new f.$gM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$eM.Uri,f.$eM.Range],new f.$fM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$g0)(t);if(i.type==="full")return new S.$$K(i.data,void 0)})),new f.$gM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$eM.Uri,f.$eM.Position,f.$eM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$eM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$fM("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new S.$oK([]);const m=t.suggestions.map(k=>P.CompletionItem.to(k,c));return new S.$oK(m,t.incomplete)})),new f.$gM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$eM.Uri,f.$eM.Position,f.$eM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$fM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new f.$gM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$eM.Uri,f.$eM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$fM("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>$(m=>new S.$gK(P.Range.to(m.range),m.command&&c.fromInternal(m.command)))(t))),new f.$gM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$eM.Uri,new f.$eM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.$UJ.isRange(t),t=>S.$VJ.isSelection(t)?P.Selection.from(t):P.Range.from(t)),f.$eM.String.with("kind","Code action kind to return code actions for").optional(),f.$eM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$fM("A promise that resolves to an array of Command-instances.",(t,i,c)=>$(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(m.command)}else{const k=new S.$_J(m.title,m.kind?new S.$aK(m.kind):void 0);return m.edit&&(k.edit=P.WorkspaceEdit.to(m.edit)),m.command&&(k.command=c.fromInternal(m.command)),k.isPreferred=m.isPreferred,k}})(t))),new f.$gM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$eM.Uri],new f.$fM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new S.$uK(P.Range.to(i.range),P.Color.to(i.color))):[])),new f.$gM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$eM("color","The color to show and insert",t=>t instanceof S.$tK,P.Color.from),new f.$eM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new f.$fM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new f.$gM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$eM.Uri,f.$eM.Range],new f.$fM("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new f.$gM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$eM.Uri],new f.$fM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new f.$gM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$fM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new f.$gM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$eM.Uri,f.$eM.Range],new f.$fM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new f.$gM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$eM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,I.$BT)(t,R.Schemas.http,R.Schemas.https),t=>t),new f.$eM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),f.$eM.String.with("label","").optional()],f.$fM.Void),new f.$gM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$eM.Uri.with("resource","Resource to open"),f.$eM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new f.$eM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],f.$fM.Void),new f.$gM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$eM.Uri.with("left","Left-hand side resource of the diff editor"),f.$eM.Uri.with("right","Right-hand side resource of the diff editor"),f.$eM.String.with("title","Human readable title for the diff editor").optional(),new f.$eM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],f.$fM.Void),new f.$gM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$eM.Uri,f.$eM.Position],new f.$fM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$gM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$eM.TypeHierarchyItem],new f.$fM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$gM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$eM.TypeHierarchyItem],new f.$fM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$gM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$eM.TestItem],f.$fM.Void),new f.$gM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$eM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$fM.Void),new f.$gM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$eM.String.with("name","The context key name"),new f.$eM("value","The context key value",()=>!0,t=>t)],f.$fM.Void),new f.$gM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$eM.Uri,f.$eM.StringArray,new f.$eM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new f.$fM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class p{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Hi)}}e.$xac=p;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function d(t){if(!Array.isArray(t))return;const i=[];for(const c of t)L.$5s(c)?i.push(P.DefinitionLink.to(c)):i.push(P.location.to(c));return i}}),define(Pe[226],Ae([1,0,13,64,5,6,2,78,20,8,7,3,26]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=void 0;function p($,d,t){const i=$.getProxy(S.$QJ.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new I.$Vl,d.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const E=this.b.get(v.handle);return E?E.value:v}else if(v&&v.$mid===7){const E=this.b.get(v.commentControlHandle);if(!E)return v;const D=E.getCommentThread(v.commentThreadHandle);return D?D.value:v}else if(v&&(v.$mid===9||v.$mid===8)){const E=this.b.get(v.thread.commentControlHandle);if(!E)return v;const D=E.getCommentThread(v.thread.commentThreadHandle);return D?v.$mid===8?D.value:{thread:D.value,text:v.text}:v}else if(v&&v.$mid===10){const E=this.b.get(v.thread.commentControlHandle);if(!E)return v;const D=E.getCommentThread(v.thread.commentThreadHandle);if(!D)return v;const s=v.commentUniqueId,h=D.getCommentByUniqueId(s);return h||v}else if(v&&v.$mid===11){const E=this.b.get(v.thread.commentControlHandle);if(!E)return v;const D=E.getCommentThread(v.thread.commentThreadHandle);if(!D)return v;const s=v.text,h=v.commentUniqueId,g=D.getCommentByUniqueId(h);return g?(typeof g.body=="string"?g.body=s:g.body=new P.$hK(s),g):v}return v}})}createCommentController(v,E,D){const s=c.a++,h=new k(v,s,E,D);this.b.set(h.handle,h);const g=this.c.get(v.identifier)||[];return g.push(h),this.c.set(v.identifier,g),h.value}$createCommentThreadTemplate(v,E,D){const s=this.b.get(v);s&&s.$createCommentThreadTemplate(E,D)}async $updateCommentThreadTemplate(v,E,D){const s=this.b.get(v);s&&s.$updateCommentThreadTemplate(E,D)}$deleteCommentThread(v,E){this.b.get(v)?.$deleteCommentThread(E)}$provideCommentingRanges(v,E,D){const s=this.b.get(v);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const h=t.getDocument(A.URI.revive(E));return(0,y.$xg)(async()=>{const g=await s.commentingRangeProvider.provideCommentingRanges(h,D);let M;return Array.isArray(g)?M={ranges:g,fileComments:!1}:g?M={ranges:g.ranges||[],fileComments:g.fileComments||!1}:M=g??void 0,M}).then(g=>{let M;return g&&(M={ranges:g.ranges.map(W=>f.Range.from(W)),fileComments:g.fileComments}),M})}$toggleReaction(v,E,D,s,h){const g=this.b.get(v);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,y.$xg)(()=>{const M=g.getCommentThread(E);if(M){const W=M.getCommentByUniqueId(s.uniqueIdInThread);if(g!==void 0&&W&&g.reactionHandler)return g.reactionHandler(W,a(h))}return Promise.resolve(void 0)})}}class m{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,E,D,s,h,g,M,W){this.m=E,this.n=D,this.o=s,this.p=h,this.q=g,this.extensionDescription=M,this.r=W,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$hc,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$nb,this.l.value=new L.$lb,this.n===void 0&&(this.n=`${v}.${this.handle}`),i.$createCommentThread(E,this.handle,this.n,this.o,f.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this.i.push({dispose:()=>{i.$deleteCommentThread(E,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(B){V.range=B},get comments(){return V.comments},set comments(B){V.comments=B},get collapsibleState(){return V.collapsibleState},set collapsibleState(B){V.collapsibleState=B},get canReply(){return V.canReply},set canReply(B){V.canReply=B},get contextValue(){return V.contextValue},set contextValue(B){V.contextValue=B},get label(){return V.label},set label(B){V.label=B},get state(){return V.state},set state(B){V.state=B},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$lb);const v=D=>Object.prototype.hasOwnProperty.call(this.b,D),E={};v("range")&&(E.range=f.Range.from(this.p)),v("label")&&(E.label=this.label),v("contextValue")&&(E.contextValue=this.contextValue??null),v("comments")&&(E.comments=this.q.map(D=>b(this,D,this.k,this.extensionDescription))),v("collapsibleState")&&(E.collapseState=r(this.g)),v("canReply")&&(E.canReply=this.canReply),v("state")&&(E.state=o(this.h)),v("isTemplate")&&(E.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(v){for(const E of this.k){const D=E[0],s=E[1];if(v===s)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Ke([(0,R.$5g)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class k{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(v,E,D,s){this.f=v,this.g=E,this.h=D,this.i=s,this.a=new Map,i.$registerCommentController(this.handle,D,s);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(g){h.options=g},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(g){h.commentingRangeProvider=g},get reactionHandler(){return h.reactionHandler},set reactionHandler(g){h.reactionHandler=g},createCommentThread(g,M,W){return h.createCommentThread(g,M,W).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(v,E,D){E===void 0&&(0,u.$LF)(this.f,"fileComments");const s=new m(this.id,this.handle,void 0,v,E,D,this.f,!1);return this.a.set(s.handle,s),s}$createCommentThreadTemplate(v,E){const D=new m(this.id,this.handle,void 0,A.URI.revive(v),f.Range.to(E),[],this.f,!0);return D.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(v,E){const D=this.a.get(v);D&&(D.range=f.Range.to(E))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.e.forEach(v=>v.dispose())}}function b(w,v,E,D){let s=E.get(v);return s||(s=++w.commentHandle,E.set(v,s)),v.state!==void 0&&(0,u.$LF)(D,"commentsDraftState"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:s,body:typeof v.body=="string"?v.body:f.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(h=>n(h)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function n(w){return{label:w.label,iconPath:w.iconPath?f.$RL(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function a(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?A.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function r(w){if(w!==void 0)switch(w){case P.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(w){if(w!==void 0)switch(w){case P.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new c}e.$zac=p}),define(Pe[227],Ae([1,0,24,3,27,17]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;let A=class{constructor(P,S){this.a=P.getProxy(R.$QJ.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,S){const u=this,p=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,S,p,arguments)}})}e(P,S,u,p){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:I(p,this.b)}),this.c&&this.f(P,u,p)}};e.$vcc=A,e.$vcc=A=Ke([Ve(0,L.$SL),Ve(1,C.$9L)],A);const l=1e5;function I(f,P){const S=[];if(f.length)for(let u=0;u<f.length;u++){let p=f[u];if(typeof p>"u")p="undefined";else if(p instanceof Error){const $=p;$.stack?p=$.stack:p=$.toString()}S.push(p)}if(P){const u=new Error().stack;u&&S.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,y.$Ym)(S);return u.length>l?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[108],Ae([1,0,2,3,7,4,17,14,18,15,19,26]),function(pe,e,y,R,C,L,A,l,I,f,P,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=void 0;let p=class{static{u=this}static{this.c=0}static{this.d=250}constructor(d,t){this.h=t,this.f=new Map,this.g=d.getProxy(R.$QJ.MainThreadDecorations)}registerFileDecorationProvider(d,t){const i=u.c++;this.f.set(i,{provider:d,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(m=>{if(!m){this.g.$onDidChange(i,null);return}const k=(0,I.$Vf)(m);if(k.length<=u.d){this.g.$onDidChange(i,k);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,k.length);const b=k.map(r=>({uri:r,rank:(0,f.$td)(r.path,"/")})),n=(0,I.$tf)(b,(r,o)=>r.rank-o.rank||(0,f.$Hd)(r.uri.path,o.uri.path)),a=[];e:for(const r of n){let o;for(const w of r){const v=(0,P.$bd)(w.uri.path);if(o!==v&&(o=v,a.push(w.uri)>=u.d))break e}}this.g.$onDidChange(i,a)});return new C.$SJ(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(d,t,i){if(!this.f.has(d))return Object.create(null);const c=Object.create(null),{provider:m,extensionDescription:k}=this.f.get(d);return await Promise.all(t.map(async b=>{try{const{uri:n,id:a}=b,r=await Promise.resolve(m.provideFileDecoration(y.URI.revive(n),i));if(!r)return;try{C.$cL.validate(r),r.badge&&typeof r.badge!="string"&&(0,S.$LF)(k,"codiconDecoration"),c[a]=[r.propagate,r.tooltip,r.badge,r.color]}catch(o){this.h.warn(`INVALID decoration from extension '${k.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),c}};e.$Abc=p,e.$Abc=p=u=Ke([Ve(0,A.$SL),Ve(1,l.$3i)],p),e.$Bbc=(0,L.$zh)("IExtHostDecorations")}),define(Pe[228],Ae([1,0,148,94,2,3,7,8,5,14,28,39]),function(pe,e,y,R,C,L,A,l,I,f,P,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=e.$rac=void 0;class p{#e;#t;#i;constructor(t,i,c,m,k,b,n,a){this.d=t,this.e=i,this.f=c,this.g=m,this.h=k,this.c=!1,this.f=Math.max(m,c),this.#i=new P.$xi(r=>b.getComparisonKey(r)),this.#e=n,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let b;t=[...t].sort(p.k);for(const n of t){const[a,r]=n;if((!b||a.toString()!==b.toString())&&(b&&this.#i.get(b).length===0&&this.#i.delete(b),b=a,c.push(a),this.#i.set(a,[])),r)this.#i.get(a)?.push(...r);else{const o=this.#i.get(a);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const m=[];let k=0;for(const b of c){let n=[];const a=this.#i.get(b);if(a)if(a.length>this.g){n=[];const r=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const w of a)if(w.severity===r[o]&&n.push({...l.Diagnostic.from(w),modelVersionId:this.h(b)})===this.g)break e;n.push({severity:R.MarkerSeverity.Info,message:(0,y.localize)(0,null,a.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=a.map(r=>({...l.Diagnostic.from(r),modelVersionId:this.h(b)}));if(m.push([b,n]),k+=n.length,k>this.f)break}this.#e.$changeMany(this.e,m)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,m]of this)t.call(i,c,m,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$rac=p;let $=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new P.$xi;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,m){this.j=i,this.k=c,this.l=m,this.g=new Map,this.h=new I.$lc({merge:k=>k.flat(),delay:50}),this.onDidChangeDiagnostics=I.Event.map(this.h.event,u._mapper),this.f=t.getProxy(L.$QJ.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:m,h:k,j:b,k:n,l:a}=this,r=new class{$changeMany(v,E){m.$changeMany(v,E),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,v,E.length===0?"CLEARING":E)}$clear(v){m.$clear(v),b.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,v)}dispose(){m.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,o=i;else if(!c.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+u.c++;while(c.has(o))}return new class extends p{constructor(){super(i,o,u.e,u.d,v=>a.getDocument(v)?.version,n.extUri,r,k),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const m of this.g.values())m.forEach((k,b)=>{let n=i.get(k.toString());typeof n>"u"&&(n=c.length,i.set(k.toString(),n),c.push([k,[]])),c[n][1]=c[n][1].concat(...b)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new p(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,m=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(C.URI.revive(i),c.map(l.Diagnostic.to))}};e.$sac=$,e.$sac=$=u=Ke([Ve(1,f.$3i),Ve(2,S.$qac)],$)}),define(Pe[229],Ae([1,0,2,3,26]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;class L{constructor(l){this.a=l.getProxy(R.$QJ.MainThreadDialogs)}showOpenDialog(l,I){return I?.allowUIResources&&(0,C.$LF)(l,"showLocal"),this.a.$showOpenDialog(I).then(f=>f?f.map(P=>y.URI.revive(P)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(I=>I?y.URI.revive(I):void 0)}}e.$Hac=L}),define(Pe[230],Ae([1,0,9,2,7,3,12,21,15]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class f{static{this.a=0}constructor(S,u,p){this.d=u,this.e=p,this.b=new Map,this.c=S.getProxy(L.$QJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,u){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const p=f.a++;this.b.set(p,u),this.c.$registerTextContentProvider(p,S);let $;return typeof u.onDidChange=="function"&&($=u.onDidChange(d=>{if(d.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(p,d).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(d);if(!i)return;const c=(0,I.$Cd)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(d,t)},y.$Y)})),new C.$SJ(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(S,u){const p=this.b.get(S);return p?Promise.resolve(p.provideTextDocumentContent(R.URI.revive(u),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Iac=f}),define(Pe[231],Ae([1,0,5,6,2,3,101,8,16,24,7,9]),function(pe,e,y,R,C,L,A,l,I,f,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;class u{constructor($,d){this.a=new y.$hc({onListenerError:S.$Z}),this.b=new y.$hc({onListenerError:S.$Z}),this.c=new y.$hc({onListenerError:S.$Z}),this.d=new y.$hc({onListenerError:S.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$lb,this.h=new Map,this.f=$.getProxy(L.$QJ.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const d=this.g.getDocument($);if(d)return d}getDocument($){const d=this.getDocumentData($);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return d.document}ensureDocumentData($){const d=this.g.getDocument($);if(d)return Promise.resolve(d);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const c=C.URI.revive(i);return(0,I.$we)(this.g.getDocument(c))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(d=>C.URI.revive(d))}$acceptModelLanguageChanged($,d){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(d),this.a.fire(i.document)}$acceptModelSaved($){const d=C.URI.revive($),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,d){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,d,t){const i=C.URI.revive($),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(d);let m;d.isUndoing?m=P.TextDocumentChangeReason.Undo:d.isRedoing&&(m=P.TextDocumentChangeReason.Redo),this.c.fire((0,f.$Um)({document:c.document,contentChanges:d.changes.map(k=>({range:l.Range.to(k.range),rangeOffset:k.rangeOffset,rangeLength:k.rangeLength,text:k.text})),reason:m}))}setWordDefinitionFor($,d){(0,A.$UL)($,d)}}e.$oac=u}),define(Pe[59],Ae([1,0,50,5,6,2,4,3,101,17,106,8,14,28,12,66,65]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=void 0;class i{constructor(k){this.value=k,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(k,b){this.h=k,this.i=b,this.a=null,this.b=new Map,this.c=new p.$xi,this.d=new R.$hc,this.e=new R.$hc,this.f=new R.$hc,this.g=new R.$hc,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(k){this.acceptDocumentsAndEditorsDelta(k)}acceptDocumentsAndEditorsDelta(k){const b=[],n=[],a=[];if(k.removedDocuments)for(const r of k.removedDocuments){const o=L.URI.revive(r),w=this.c.get(o);w?.unref()&&(this.c.delete(o),b.push(w.value))}if(k.addedDocuments)for(const r of k.addedDocuments){const o=L.URI.revive(r.uri);let w=this.c.get(o);if(w&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new i(new I.$VL(this.h.getProxy(l.$QJ.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(o,w),n.push(w.value)),w.ref()}if(k.removedEditors)for(const r of k.removedEditors){const o=this.b.get(r);this.b.delete(r),o&&a.push(o)}if(k.addedEditors)for(const r of k.addedEditors){const o=L.URI.revive(r.documentUri);y.ok(this.c.has(o),`document '${o}' does not exist`),y.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const w=this.c.get(o).value,v=new P.$2L(r.id,this.h.getProxy(l.$QJ.MainThreadTextEditors),this.i,new t.$T(()=>w.document),r.selections.map(S.Selection.to),r.options,r.visibleRanges.map(E=>S.Range.to(E)),typeof r.editorPosition=="number"?S.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,v)}k.newActiveEditor!==void 0&&(y.ok(k.newActiveEditor===null||this.b.has(k.newActiveEditor),`active editor '${k.newActiveEditor}' does not exist`),this.a=k.newActiveEditor),(0,C.$hb)(b),(0,C.$hb)(a),k.removedDocuments&&this.e.fire(b),k.addedDocuments&&this.d.fire(n),(k.removedEditors||k.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),k.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(k){return this.c.get(k)?.value}allDocuments(){return d.Iterable.map(this.c.values(),k=>k.value)}getEditor(k){return this.b.get(k)}activeEditor(k){if(!this.a)return;const b=this.b.get(this.a);return k?b:b?.value}allEditors(){return[...this.b.values()]}};e.$3L=c,e.$3L=c=Ke([Ve(0,f.$SL),Ve(1,u.$3i)],c),e.$4L=(0,A.$zh)("IExtHostDocumentsAndEditors")}),define(Pe[60],Ae([1,0,8,3,2,5,4,7,17,16,100]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.$Fbc=void 0,e.$Fbc=(0,A.$zh)("IExtHostEditorTabs");class S{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$yL(C.URI.revive(this.b.input.uri));case 2:return new l.$zL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$AL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$BL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$CL(this.b.input.viewType);case 4:return new l.$DL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$EL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$FL;case 9:return new l.$GL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new S(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return y.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new S(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new L.$hc,this.c=new L.$hc,this.e=[],this.a=t.getProxy(R.$QJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,f.$we)(t.e.find(k=>k.groupId===c)?.apiObject)},close:async(c,m)=>{const k=Array.isArray(c)?c:[c];return k.length?$(k[0])?this.j(k,m):this.i(k,m):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(r=>r.groupId)),c=new Set(t.map(r=>r.groupId)),m=(0,P.$J)(i,c),k=this.e.filter(r=>m.removed.includes(r.groupId)).map(r=>r.apiObject),b=[],n=[];this.e=t.map(r=>{const o=new u(r,()=>this.d);return m.added.includes(o.groupId)?b.push(o.apiObject):n.push(o.apiObject),o});const a=(0,f.$we)(t.find(r=>r.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:b,closed:k,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(m=>m.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const m of t){const k=this.g(m);if(!k)throw new Error("Tab close: Invalid tab not found!");c.push(k.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const m of t){const k=this.h(m);if(!k)throw new Error("Group close: Invalid group not found!");c.push(k.groupId)}return this.a.$closeGroup(c,i)}};e.$Gbc=p,e.$Gbc=p=Ke([Ve(0,I.$SL)],p);function $(d){return d.tabs!==void 0}}),define(Pe[232],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$QJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,I){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const P=await f.provideEmbeddingVector(l,I);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,l,I){const f=this.b;return this.b++,this.a.set(f,I),this.c.$registerAiEmbeddingVectorProvider(l,f),new R.$SJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$scc=C}),define(Pe[233],Ae([1,0,2,3,6,7,8,279,15,25,26,49]),function(pe,e,y,R,C,L,A,l,I,f,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=void 0;class u{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const t=this.a.indexOf(d);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),t=[];let i,c,m=14,k=14;for(const b of d){let n=i?(0,I.$Qd)(i,b):0;for(n===0?c=1:c=k;n<b.length;n++)n+1===b.length?(m=k,k=9):k+=1,t.push([c,b.toUpperCase().charCodeAt(n),k]),t.push([c,b.toLowerCase().charCodeAt(n),k]),c=k;i=b,k=m}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$kY(t)}}provideDocumentLinks(d){this.c();const t=[],i=l.$lY.computeLinks({getLineContent(c){return d.lineAt(c-1).text},getLineCount(){return d.lineCount}},this.b);for(const c of i){const m=A.DocumentLink.to(c);m.target&&t.push(m)}return t}}class p{constructor(d,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(R.$QJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,t,i,c={}){if(p.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const m=this.h++;this.b.add(t),this.d.add(t),this.c.set(m,i);let k=2;c.isCaseSensitive&&(k+=1024),c.isReadonly&&(k+=2048),typeof i.copy=="function"&&(k+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$LF)(d,"fsChunks"),k+=4);let b;c.isReadonly&&(0,S.$Xj)(c.isReadonly)&&((0,P.$LF)(d,"readonlyMessage"),b={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(m,t,k,b).catch(a=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${t}`),console.error(a)});const n=i.onDidChangeFile(a=>{const r=[];for(const o of a){const{uri:w,type:v}=o;if(w.scheme!==t)continue;let E;switch(v){case L.FileChangeType.Changed:E=0;break;case L.FileChangeType.Created:E=1;break;case L.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:w,type:E})}this.a.$onFileSystemChange(m,r)});return(0,C.$kb)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:t,ctime:i,mtime:c,size:m,permissions:k}=d;return{type:t,ctime:i,mtime:c,size:m,permissions:k}}$stat(d,t){return Promise.resolve(this.l(d).stat(y.URI.revive(t))).then(i=>p.k(i))}$readdir(d,t){return Promise.resolve(this.l(d).readDirectory(y.URI.revive(t)))}$readFile(d,t){return Promise.resolve(this.l(d).readFile(y.URI.revive(t))).then(i=>f.$Hc.wrap(i))}$writeFile(d,t,i,c){return Promise.resolve(this.l(d).writeFile(y.URI.revive(t),i.buffer,c))}$delete(d,t,i){return Promise.resolve(this.l(d).delete(y.URI.revive(t),i))}$rename(d,t,i,c){return Promise.resolve(this.l(d).rename(y.URI.revive(t),y.URI.revive(i),c))}$copy(d,t,i,c){const m=this.l(d);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(y.URI.revive(t),y.URI.revive(i),c))}$mkdir(d,t){return Promise.resolve(this.l(d).createDirectory(y.URI.revive(t)))}$watch(d,t,i,c){const m=this.l(d).watch(y.URI.revive(i),c);this.f.set(t,m)}$unwatch(d,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(d,t,i){const c=this.l(d);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(y.URI.revive(t),i))}$close(d,t){const i=this.l(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(d,t,i,c){const m=this.l(d);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const k=f.$Hc.alloc(c);return Promise.resolve(m.read(t,i,k.buffer,0,c)).then(b=>k.slice(0,b))}$write(d,t,i,c){const m=this.l(d);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(t,i,c.buffer,0,c.byteLength))}l(d){const t=this.c.get(d);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$cbc=p}),define(Pe[61],Ae([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=e.$Uac=void 0;let $=p=class{constructor(t,i){this.b=new Map,this.c=new P.$Ng,this.a=t.getProxy(y.$QJ.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(m){try{let k;const b=c.b.get(m.scheme);return b?(await c.a.$ensureActivation(m.scheme),k=await b.impl.stat(m)):k=await c.a.$stat(m),{type:k.type,ctime:k.ctime,mtime:k.mtime,size:k.size,permissions:k.permissions===R.FilePermission.Readonly?1:void 0}}catch(k){p.e(k)}},async readDirectory(m){try{const k=c.b.get(m.scheme);return k?(await c.a.$ensureActivation(m.scheme),(await k.impl.readDirectory(m)).slice()):await c.a.$readdir(m)}catch(k){return p.e(k)}},async createDirectory(m){try{const k=c.b.get(m.scheme);return k&&!k.isReadonly?(await c.a.$ensureActivation(m.scheme),await c.d(k.impl,k.extUri,m)):await c.a.$mkdir(m)}catch(k){return p.e(k)}},async readFile(m){try{const k=c.b.get(m.scheme);return k?(await c.a.$ensureActivation(m.scheme),(await k.impl.readFile(m)).slice()):(await c.a.$readFile(m)).buffer}catch(k){return p.e(k)}},async writeFile(m,k){try{const b=c.b.get(m.scheme);return b&&!b.isReadonly?(await c.a.$ensureActivation(m.scheme),await c.d(b.impl,b.extUri,b.extUri.dirname(m)),await c.c.queueFor(m).queue(()=>Promise.resolve(b.impl.writeFile(m,k,{create:!0,overwrite:!0})))):await c.a.$writeFile(m,L.$Hc.wrap(k))}catch(b){return p.e(b)}},async delete(m,k){try{const b=c.b.get(m.scheme);return b&&!b.isReadonly?(await c.a.$ensureActivation(m.scheme),await b.impl.delete(m,{recursive:!1,...k})):await c.a.$delete(m,{recursive:!1,useTrash:!1,atomic:!1,...k})}catch(b){return p.e(b)}},async rename(m,k,b){try{return await c.a.$rename(m,k,{overwrite:!1,...b})}catch(n){return p.e(n)}},async copy(m,k,b){try{return await c.a.$copy(m,k,{overwrite:!1,...b})}catch(n){return p.e(n)}},isWritableFileSystem(m){const k=i.getCapabilities(m);if(typeof k=="number")return!(k&2048)}})}async d(t,i,c){const m=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&R.FileType.Directory))throw C.$7K.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(k){if(R.$gk(k)!==R.FileSystemProviderErrorCode.FileNotFound)throw k;m.push(i.basename(c)),c=i.dirname(c)}for(let k=m.length-1;k>=0;k--){c=i.joinPath(c,m[k]);try{await t.createDirectory(c)}catch(b){if(R.$gk(b)!==R.FileSystemProviderErrorCode.FileExists)throw b}}}static e(t){if(t instanceof C.$7K)throw t;if(t instanceof R.$ck)switch(t.code){case R.FileSystemProviderErrorCode.FileExists:throw C.$7K.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.$7K.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.$7K.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.$7K.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.$7K.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.$7K.Unavailable(t.message);default:throw new C.$7K(t.message,t.name)}if(!(t instanceof Error))throw new C.$7K(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$7K.Unavailable(t.message);switch(t.name){case R.FileSystemProviderErrorCode.FileExists:throw C.$7K.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.$7K.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.$7K.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.$7K.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.$7K.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.$7K.Unavailable(t.message);default:throw new C.$7K(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?S.$9f:S.$$f,isReadonly:!!c?.isReadonly}),(0,f.$kb)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??S.$9f}};e.$Uac=$,e.$Uac=$=p=Ke([Ve(0,l.$SL),Ve(1,I.$qac)],$),e.$Vac=(0,A.$zh)("IExtHostConsumerFileSystem")}),define(Pe[234],Ae([1,0,5,37,2,3,8,7]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=void 0;class I{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(S,u,p,$,d,t,i,c){this.a=new y.$hc,this.b=new y.$hc,this.c=new y.$hc;const m=this.h(S,p,d);this.g=0,t&&(this.g+=1),i&&(this.g+=2),c&&(this.g+=4);const k=(0,R.$pj)(d),b=typeof d=="string",n=$(a=>{if(!t)for(const r of a.created){const o=C.URI.revive(r);k(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.a.fire(o)}if(!i)for(const r of a.changed){const o=C.URI.revive(r);k(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.b.fire(o)}if(!c)for(const r of a.deleted){const o=C.URI.revive(r);k(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=l.$SJ.from(m,this.a,this.b,this.c,n)}h(S,u,p){const $=l.$SJ.from();if(typeof p=="string")return $;const d=S.getProxy(L.$QJ.MainThreadFileSystem);let t=!1;(p.pattern.includes(R.$lj)||p.pattern.includes(R.$mj))&&(t=!0);const i=Math.random();return d.$watch(u.identifier.value,i,p.baseUri,{recursive:t,excludes:[]}),l.$SJ.from({dispose:()=>d.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class f{constructor(S,u,p){this.j=S,this.k=u,this.l=p,this.a=new y.$hc,this.b=new y.$hc,this.c=new y.$hc,this.d=new y.$hc,this.g=new y.$jc,this.h=new y.$jc,this.i=new y.$jc,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,u,p,$,d,t){return new I(this.j,S,u,this.a.event,A.GlobPattern.from(p),$,d,t)}$onFileEvent(S){this.a.fire(S)}$onDidRunFileOperation(S,u){switch(S){case 2:this.b.fire(Object.freeze({files:u.map(p=>({oldUri:C.URI.revive(p.source),newUri:C.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:u.map(p=>C.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:u.map(p=>C.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,u){return(p,$,d)=>{const t=function(c){p.call($,c)};return t.extension=S,u.event(t,void 0,d)}}async $onWillRunFileOperation(S,u,p,$){switch(S){case 2:return await this.n(this.g,{files:u.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))},p,$);case 1:return await this.n(this.i,{files:u.map(d=>C.URI.revive(d.target))},p,$);case 0:case 3:return await this.n(this.h,{files:u.map(d=>C.URI.revive(d.target))},p,$)}}async n(S,u,p,$){const d=new Set,t=[];if(await S.fireAsync(u,$,async(c,m)=>{const k=Date.now(),b=await Promise.resolve(c);b instanceof l.$3J&&(t.push([m.extension,b]),d.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-k>p&&this.k.warn("SLOW file-participant",m.extension.identifier)}),$.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,c]of t){const{edits:m}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:k=>this.l.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(m)}return{edit:i,extensionNames:Array.from(d)}}}e.$dbc=f}),define(Pe[235],Ae([1,0,6,2,3,8,7,31]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class I{static{this.a=0}constructor(u,p){this.extension=u,this.provider=p,this.handle=I.a++}}class f{constructor(u){this.session=u,this.responses=[]}}class P{static{this.a=0}constructor(u,p,$,d){this.f=$,this.g=d,this.b=new Map,this.d=new Map,this.e=u.getProxy(C.$QJ.MainThreadInlineChat),p.registerApiCommand(new l.$gM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$eM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?L.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?L.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?L.Position.from(t.position):void 0}})],l.$fM.Void))}registerProvider(u,p){const $=new I(u,p);return this.b.set($.handle,$),this.e.$registerInteractiveEditorProvider($.handle,p.label,u.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,y.$kb)(()=>{this.e.$unregisterInteractiveEditorProvider($.handle),this.b.delete($.handle)})}async $prepareSession(u,p,$,d){const t=this.b.get(u);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(R.URI.revive(p)),c=L.Selection.to($),m=await t.provider.prepareInteractiveEditorSession({document:i,selection:c},d);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const k=P.a++;return this.d.set(k,new f(m)),{id:k,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(b=>({command:b.command,detail:b.detail,refer:b.refer,executeImmediately:b.executeImmediately})),wholeRange:L.Range.from(m.wholeRange),message:m.message}}async $provideResponse(u,p,$,d){const t=this.b.get(u);if(!t)return;const i=this.d.get(p.id);if(!i)return;const c={session:i.session,prompt:$.prompt,selection:L.Selection.to($.selection),wholeRange:L.Range.to($.wholeRange),attempt:$.attempt,live:$.live};let m=!1;const k={report:a=>{if(!$.live)throw new Error("Progress reporting is only supported for live sessions");m||d.isCancellationRequested||!a.message&&!a.edits||this.e.$handleProgressChunk($.requestId,{message:a.message,edits:a.edits?.map(L.TextEdit.from)})}},b=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(c,k,d):t.provider.provideInteractiveEditorResponse(c,d);Promise.resolve(b).finally(()=>m=!0);const n=await b;if(n){const a=i.responses.push(n)-1,r={wholeRange:L.Range.from(n.wholeRange),placeholder:n.placeholder};if(P.h(n))return{...r,id:a,type:"message",message:L.MarkdownString.from(n.contents)};const{edits:o}=n;if(o instanceof A.$3J)return{...r,id:a,type:"bulkEdit",edits:L.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...r,id:a,type:"editorEdit",edits:o.map(L.TextEdit.from)}}}$handleFeedback(u,p,$,d){const t=this.b.get(u),i=this.d.get(p),c=i?.responses[$];if(t&&c){const m=L.InteractiveEditorResponseFeedbackKind.to(d);t.provider.handleInteractiveEditorResponseFeedback?.(i.session,c,m)}}$releaseSession(u,p){const $=this.d.get(p),d=this.b.get(u);$&&d&&d.provider.releaseInteractiveEditorSession?.($.session),this.d.delete(p)}static h(u){return typeof u=="object"&&typeof u.contents=="object"}}e.$kcc=P}),define(Pe[236],Ae([1,0,2,31]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class C{constructor(A,l,I,f,P){this.a=l,this.b=I,this.c=f;const S=new R.$gM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$eM("showOptions","Show Options",u=>!0,u=>u),new R.$eM("resource","Interactive resource Uri",u=>!0,u=>u),new R.$eM("controllerId","Notebook controller Id",u=>!0,u=>u),new R.$eM("title","Interactive editor title",u=>!0,u=>u)],new R.$fM("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const p=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri),notebookEditor:p.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(A,l,I,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:I,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$gcc=C}),define(Pe[237],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(y.$QJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const I=this.a.get(A);if(!I)throw new Error("Issue request handler not found");const f=await I.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}registerIssueUriRequestHandler(A,l){const I=A.identifier.value;return this.a.set(I,l),this.b.$registerIssueUriRequestHandler(I),new R.$SJ(()=>{this.b.$unregisterIssueUriRequestHandler(I),this.a.delete(I)})}}e.$mcc=C}),define(Pe[238],Ae([1,0,6,3]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(R.$QJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,y.$kb)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$zbc=C}),define(Pe[239],Ae([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,54,58,9,13,26,150]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0;class r{constructor(F,q){this.d=F,this.e=q}async provideDocumentSymbols(F,q){const H=this.d.getDocument(F),Q=await this.e.provideDocumentSymbols(H,q);if(!(0,P.$Df)(Q))return Q[0]instanceof L.$$J?Q.map(C.DocumentSymbol.from):r.f(Q)}static f(F){F=F.slice(0).sort((Q,K)=>{let ee=Q.location.range.start.compareTo(K.location.range.start);return ee===0&&(ee=K.location.range.end.compareTo(Q.location.range.end)),ee});const q=[],H=[];for(const Q of F){const K={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(H.length===0){H.push(K),q.push(K);break}const ee=H[H.length-1];if(f.$hs.containsRange(ee.range,K.range)&&!f.$hs.equalsRange(ee.range,K.range)){ee.children?.push(K),H.push(K);break}H.pop()}}return q}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,q,H){this.g=F,this.h=q,this.j=H,this.e=new c.$nac("CodeLens"),this.f=new Map}async provideCodeLenses(F,q){const H=this.g.getDocument(F),Q=await this.j.provideCodeLenses(H,q);if(!Q||q.isCancellationRequested)return;const K=this.e.add(Q),ee=new d.$lb;this.f.set(K,ee);const ce={cacheId:K,lenses:[]};for(let ze=0;ze<Q.length;ze++)ce.lenses.push({cacheId:[K,ze],range:C.Range.from(Q[ze].range),command:this.h.toInternal(Q[ze].command,ee)});return ce}async resolveCodeLens(F,q){const H=F.cacheId&&this.e.get(...F.cacheId);if(!H)return;let Q;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?Q=H:Q=await this.j.resolveCodeLens(H,q),Q||(Q=H),q.isCancellationRequested)return;const K=F.cacheId&&this.f.get(F.cacheId[0]);if(K)return F.command=this.h.toInternal(Q.command??o.d,K),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function w(Ce){return Array.isArray(Ce)?Ce.map(C.DefinitionLink.from):Ce?[C.DefinitionLink.from(Ce)]:[]}class v{constructor(F,q){this.d=F,this.e=q}async provideDefinition(F,q,H){const Q=this.d.getDocument(F),K=C.Position.to(q),ee=await this.e.provideDefinition(Q,K,H);return w(ee)}}class E{constructor(F,q){this.d=F,this.e=q}async provideDeclaration(F,q,H){const Q=this.d.getDocument(F),K=C.Position.to(q),ee=await this.e.provideDeclaration(Q,K,H);return w(ee)}}class D{constructor(F,q){this.d=F,this.e=q}async provideImplementation(F,q,H){const Q=this.d.getDocument(F),K=C.Position.to(q),ee=await this.e.provideImplementation(Q,K,H);return w(ee)}}class s{constructor(F,q){this.d=F,this.e=q}async provideTypeDefinition(F,q,H){const Q=this.d.getDocument(F),K=C.Position.to(q),ee=await this.e.provideTypeDefinition(Q,K,H);return w(ee)}}class h{constructor(F,q){this.d=F,this.e=q}async provideHover(F,q,H){const Q=this.d.getDocument(F),K=C.Position.to(q),ee=await this.e.provideHover(Q,K,H);if(!(!ee||(0,P.$Df)(ee.contents)))return ee.range||(ee.range=Q.getWordRangeAtPosition(K)),ee.range||(ee.range=new L.$UJ(K,K)),C.Hover.from(ee)}}class g{constructor(F,q){this.d=F,this.e=q}async provideEvaluatableExpression(F,q,H){const Q=this.d.getDocument(F),K=C.Position.to(q),ee=await this.e.provideEvaluatableExpression(Q,K,H);if(ee)return C.EvaluatableExpression.from(ee)}}class M{constructor(F,q){this.d=F,this.e=q}async provideInlineValues(F,q,H,Q){const K=this.d.getDocument(F),ee=await this.e.provideInlineValues(K,C.Range.to(q),C.InlineValueContext.to(H),Q);if(Array.isArray(ee))return ee.map(ce=>C.InlineValue.from(ce))}}class W{constructor(F,q){this.d=F,this.e=q}async provideDocumentHighlights(F,q,H){const Q=this.d.getDocument(F),K=C.Position.to(q),ee=await this.e.provideDocumentHighlights(Q,K,H);if(Array.isArray(ee))return ee.map(C.DocumentHighlight.from)}}class V{constructor(F,q){this.d=F,this.e=q}async provideLinkedEditingRanges(F,q,H){const Q=this.d.getDocument(F),K=C.Position.to(q),ee=await this.e.provideLinkedEditingRanges(Q,K,H);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,P.$Af)(ee.ranges.map(C.Range.from)),wordPattern:ee.wordPattern}}}class B{constructor(F,q){this.d=F,this.e=q}async provideReferences(F,q,H,Q){const K=this.d.getDocument(F),ee=C.Position.to(q),ce=await this.e.provideReferences(K,ee,H,Q);if(Array.isArray(ce))return ce.map(C.location.from)}}class j{static{this.d=1e3}constructor(F,q,H,Q,K,ee,ce){this.h=F,this.j=q,this.k=H,this.l=Q,this.m=K,this.n=ee,this.o=ce,this.e=new c.$nac("CodeAction"),this.f=new Map,this.g=new L.$aK("notebook")}async provideCodeActions(F,q,H,Q){const K=this.h.getDocument(F),ee=u.$js.isISelection(q)?C.Selection.to(q):C.Range.to(q),ce=[];for(const Xe of this.k.getDiagnostics(F))if(ee.intersection(Xe.range)&&ce.push(Xe)>j.d)break;const ze={diagnostics:ce,only:H.only?new L.$aK(H.only):void 0,triggerKind:C.CodeActionTriggerKind.to(H.trigger)},Ue=await this.l.provideCodeActions(K,ee,ze,Q);if(!(0,P.$Ef)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),He=new d.$lb;this.f.set(Qe,He);const et=[];for(let Xe=0;Xe<Ue.length;Xe++){const _e=Ue[Xe];if(_e)if(j.p(_e))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this.j.toInternal(_e,He)});else{if(ze.triggerKind!==L.CodeActionTriggerKind.Invoke&&_e.kind&&this.g.contains(_e.kind))continue;ze.only&&(_e.kind?ze.only.contains(_e.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Qe,Xe],title:_e.title,command:_e.command&&this.j.toInternal(_e.command,He),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})}}return{cacheId:Qe,actions:et}}async resolveCodeAction(F,q){const[H,Q]=F,K=this.e.get(H,Q);if(!K||j.p(K))return{};if(!this.l.resolveCodeAction)return{};const ee=await this.l.resolveCodeAction(K,q)??K;let ce;ee.edit&&(ce=C.WorkspaceEdit.from(ee.edit,void 0));let ze;if(ee.command){const Ue=this.f.get(H);Ue&&(ze=this.j.toInternal(ee.command,Ue))}return{edit:ce,command:ze}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static p(F){return typeof F.command=="string"&&typeof F.title=="string"}}class U{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,H,Q,K){this.d=F,this.e=q,this.f=H,this.g=Q,this.h=K}async prepareDocumentPaste(F,q,H,Q){if(!this.f.prepareDocumentPaste)return;const K=this.e.getDocument(F),ee=q.map(Ue=>C.Range.to(Ue)),ce=C.DataTransfer.toDataTransfer(H,()=>{throw new k.$9});if(await this.f.prepareDocumentPaste(K,ee,ce,Q),Q.isCancellationRequested)return;const ze=Array.from(ce).filter(([,Ue])=>!(Ue instanceof L.$HK));return C.DataTransfer.from(ze)}async providePasteEdits(F,q,H,Q,K){if(!this.f.provideDocumentPasteEdits)return;const ee=this.e.getDocument(q),ce=H.map(Qe=>C.Range.to(Qe)),ze=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(ee,ce,ze,K);if(Ue)return{label:Ue.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:U.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class z{constructor(F,q){this.d=F,this.e=q}async provideDocumentFormattingEdits(F,q,H){const Q=this.d.getDocument(F),K=await this.e.provideDocumentFormattingEdits(Q,q,H);if(Array.isArray(K))return K.map(C.TextEdit.from)}}class ie{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeFormattingEdits(F,q,H,Q){const K=this.d.getDocument(F),ee=C.Range.to(q),ce=await this.e.provideDocumentRangeFormattingEdits(K,ee,H,Q);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,q,H,Q){(0,S.$ve)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const K=this.d.getDocument(F),ee=q.map(C.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(K,ee,H,Q);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class X{constructor(F,q){this.d=F,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,q,H,Q,K){const ee=this.d.getDocument(F),ce=C.Position.to(q),ze=await this.e.provideOnTypeFormattingEdits(ee,ce,H,Q,K);if(Array.isArray(ze))return ze.map(C.TextEdit.from)}}class ye{constructor(F,q){this.e=F,this.f=q,this.d=new c.$nac("WorkspaceSymbols")}async provideWorkspaceSymbols(F,q){const H=await this.e.provideWorkspaceSymbols(F,q);if(!(0,P.$Ef)(H))return{symbols:[]};const Q=this.d.add(H),K={cacheId:Q,symbols:[]};for(let ee=0;ee<H.length;ee++){const ce=H[ee];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}K.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[Q,ee]})}return K}async resolveWorkspaceSymbol(F,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const H=this.d.get(...F.cacheId);if(H){const Q=await this.e.resolveWorkspaceSymbol(H,q);return Q&&(0,R.$Wm)(F,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class De{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,q,H){this.d=F,this.e=q,this.f=H}async provideRenameEdits(F,q,H,Q){const K=this.d.getDocument(F),ee=C.Position.to(q);try{const ce=await this.e.provideRenameEdits(K,ee,H,Q);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const ze=De.g(ce);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(F,q,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(F),K=C.Position.to(q);try{const ee=await this.e.prepareRename(Q,K,H);let ce,ze;if(L.$UJ.isRange(ee)?(ce=ee,ze=Q.getText(ee)):(0,S.$ne)(ee)&&(ce=ee.range,ze=ee.placeholder),!ce||!ze)return;if(ce.start.line>K.line||ce.end.line<K.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:ze}}catch(ee){const ce=De.g(ee);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(ee)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Re{constructor(F,q){this.resultId=F,this.tokens=q}}class Y{constructor(F,q){this.f=F,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,q,H){const Q=this.f.getDocument(F),K=q!==0?this.d.get(q):null;let ee=typeof K?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,K.resultId,H):await this.g.provideDocumentSemanticTokens(Q,H);return K&&this.d.delete(q),ee?(ee=Y.h(ee),this.o(Y.n(K,ee),ee)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return Y.j(F)?Y.k(F)?F:new L.$$K(new Uint32Array(F.data),F.resultId):Y.l(F)?Y.m(F)?F:new L.$aL(F.edits.map(q=>new L.$_K(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const q of F.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(F,q){if(!Y.j(q)||!F||!F.tokens)return q;const H=F.tokens,Q=H.length,K=q.data,ee=K.length;let ce=0;const ze=Math.min(Q,ee);for(;ce<ze&&H[ce]===K[ce];)ce++;if(ce===Q&&ce===ee)return new L.$aL([],q.resultId);let Ue=0;const Qe=ze-ce;for(;Ue<Qe&&H[Q-Ue-1]===K[ee-Ue-1];)Ue++;return new L.$aL([{start:ce,deleteCount:Q-ce-Ue,data:K.subarray(ce,ee-Ue)}],q.resultId)}o(F,q){if(Y.j(F)){const H=this.e++;return this.d.set(H,new Re(F.resultId,F.data)),(0,t.$f0)({id:H,type:"full",data:F.data})}if(Y.l(F)){const H=this.e++;return Y.j(q)?this.d.set(H,new Re(q.resultId,q.data)):this.d.set(H,new Re(F.resultId)),(0,t.$f0)({id:H,type:"delta",deltas:(F.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class le{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeSemanticTokens(F,q,H){const Q=this.d.getDocument(F),K=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(q),H);return K?this.f(K):null}f(F){return(0,t.$f0)({id:0,type:"full",data:F.data})}}class we{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,q,H,Q,K){this.f=F,this.g=q,this.h=H,this.j=Q,this.k=K,this.d=new c.$nac("CompletionItem"),this.e=new Map}async provideCompletionItems(F,q,H,Q){const K=this.f.getDocument(F),ee=C.Position.to(q),ce=K.getWordRangeAtPosition(ee)||new L.$UJ(ee,ee),ze=ce.with({end:ee}),Ue=new m.$dc,Qe=await this.h.provideCompletionItems(K,ee,Q,C.CompletionContext.to(H));if(!Qe||Q.isCancellationRequested)return;const He=Array.isArray(Qe)?new L.$oK(Qe):Qe,et=we.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Xe=new d.$lb;this.e.set(et,Xe);const _e=[],it={x:et,b:_e,a:{replace:C.Range.from(ce),insert:C.Range.from(ze)},c:He.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<He.items.length;tt++){const Ne=He.items[tt],st=this.l(Ne,[et,tt],ze,ce);_e.push(st)}return it}async resolveCompletionItem(F,q){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...F);if(!H)return;const Q=this.l(H,F),K=await this.h.resolveCompletionItem(H,q);if(!K)return;const ee=this.l(K,F);return(Q.h!==ee.h||Q.i!==ee.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==ee.n||Q.o!==ee.o||!(0,R.$Xm)(Q.p,ee.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:ee.d,c:ee.c,l:ee.l,h:ee.h,i:ee.i,n:ee.n,o:ee.o,p:ee.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q,H,Q){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const ee=this.g.toInternal(F.command,K),ce={x:q,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:ee?.$ident,o:ee?.id,p:ee?.$ident?void 0:ee?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=F.textEdit.newText):typeof F.insertText=="string"?ce.h=F.insertText:F.insertText instanceof L.$4J&&(ce.h=F.insertText.value,ce.i|=4);let ze;return F.textEdit?ze=F.textEdit.range:F.range&&(ze=F.range),L.$UJ.isRange(ze)?ce.j=C.Range.from(ze):ze&&(!H?.isEqual(ze.inserting)||!Q?.isEqual(ze.replacing))&&(ce.j={insert:C.Range.from(ze.inserting),replace:C.Range.from(ze.replacing)}),ce}}class ae{async provideInlineCompletions(F,q,H,Q){}disposeCompletions(F){}handleDidShowCompletionItem(F,q,H){}handlePartialAccept(F,q,H){}}class x extends ae{constructor(F,q,H,Q){super(),this.f=F,this.g=q,this.h=H,this.j=Q,this.d=new ue,this.e=(0,n.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,q,H,Q){const K=this.g.getDocument(F),ee=C.Position.to(q),ce=await this.h.provideInlineCompletionItems(K,ee,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:C.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},Q);if(!ce||Q.isCancellationRequested)return;const ze=Array.isArray(ce)?ce:ce.items,Ue=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:ze}),items:ze.map((Xe,_e)=>{let it;Xe.command&&(He||(He=new d.$lb),it=this.j.toInternal(Xe.command,He));const tt=Xe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Xe.filterText,range:Xe.range?C.Range.from(Xe.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:Ue.map(Xe=>(He||(He=new d.$lb),this.j.toInternal(Xe,He))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,q,H){const Q=this.d.get(F)?.items[q];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,H)}handlePartialAccept(F,q,H){const Q=this.d.get(F)?.items[q];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,H)}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const q=this.e++;return this.d.set(q,F),q}disposeReferenceId(F){const q=this.d.get(F);return this.d.delete(F),q}get(F){return this.d.get(F)}}class O{constructor(F,q){this.e=F,this.f=q,this.d=new c.$nac("SignatureHelp")}async provideSignatureHelp(F,q,H,Q){const K=this.e.getDocument(F),ee=C.Position.to(q),ce=this.g(H),ze=await this.f.provideSignatureHelp(K,ee,Q,ce);if(ze){const Ue=this.d.add([ze]);return{...C.SignatureHelp.from(ze),id:Ue}}}g(F){let q;if(F.activeSignatureHelp){const H=C.SignatureHelp.to(F.activeSignatureHelp),Q=this.d.get(F.activeSignatureHelp.id,0);Q?(q=Q,q.activeSignature=H.activeSignature,q.activeParameter=H.activeParameter):q=H}return{...F,activeSignatureHelp:q}}releaseSignatureHelp(F){this.d.delete(F)}}class J{constructor(F,q,H,Q,K){this.f=F,this.g=q,this.h=H,this.j=Q,this.k=K,this.d=new c.$nac("InlayHints"),this.e=new Map}async provideInlayHints(F,q,H){const Q=this.f.getDocument(F),K=C.Range.to(q),ee=await this.h.provideInlayHints(Q,K,H);if(!Array.isArray(ee)||ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(H.isCancellationRequested)return;const ce=this.d.add(ee);this.e.set(ce,new d.$lb);const ze={hints:[],cacheId:ce};for(let Ue=0;Ue<ee.length;Ue++)this.l(ee[Ue],K)&&ze.hints.push(this.m(ee[Ue],[ce,Ue]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),ze}async resolveInlayHint(F,q){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...F);if(!H)return;const Q=await this.h.resolveInlayHint(H,q);if(Q&&this.l(Q))return this.m(Q,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q){return F.label.length===0||Array.isArray(F.label)&&F.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(q&&!q.contains(F.position))}m(F,q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:q,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?Q.label=F.label:Q.label=F.label.map(K=>{const ee={label:K.value};return ee.tooltip=C.MarkdownString.fromStrict(K.tooltip),L.$5J.isLocation(K.location)&&(ee.location=C.location.from(K.location)),K.command&&(ee.command=this.g.toInternal(K.command,H)),ee}),Q}}class he{constructor(F,q){this.e=F,this.f=q,this.d=new c.$nac("DocumentLink")}async provideLinks(F,q){const H=this.e.getDocument(F),Q=await this.f.provideDocumentLinks(H,q);if(!(!Array.isArray(Q)||Q.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(he.g).map(C.DocumentLink.from)};{const K=this.d.add(Q),ee={links:[],cacheId:K};for(let ce=0;ce<Q.length;ce++){if(!he.g(Q[ce]))continue;const ze=C.DocumentLink.from(Q[ce]);ze.cacheId=[K,ce],ee.links.push(ze)}return ee}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,q){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...F);if(!H)return;const Q=await this.f.resolveDocumentLink(H,q);if(!(!Q||!he.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(F){this.d.delete(F)}}class Ee{constructor(F,q){this.d=F,this.e=q}async provideColors(F,q){const H=this.d.getDocument(F),Q=await this.e.provideDocumentColors(H,q);return Array.isArray(Q)?Q.map(ee=>({color:C.Color.from(ee.color),range:C.Range.from(ee.range)})):[]}async provideColorPresentations(F,q,H){const Q=this.d.getDocument(F),K=C.Range.to(q.range),ee=C.Color.to(q.color),ce=await this.e.provideColorPresentations(ee,{document:Q,range:K},H);if(Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ve{constructor(F,q){this.d=F,this.e=q}async provideFoldingRanges(F,q,H){const Q=this.d.getDocument(F),K=await this.e.provideFoldingRanges(Q,q,H);if(Array.isArray(K))return K.map(C.FoldingRange.from)}}class be{constructor(F,q,H){this.d=F,this.e=q,this.f=H}async provideSelectionRanges(F,q,H){const Q=this.d.getDocument(F),K=q.map(C.Position.to),ee=await this.e.provideSelectionRanges(Q,K,H);if(!(0,P.$Ef)(ee))return[];if(ee.length!==K.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let ze=0;ze<K.length;ze++){const Ue=[];ce.push(Ue);let Qe=K[ze],He=ee[ze];for(;;){if(!He.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(He)),!He.parent)break;Qe=He.range,He=He.parent}}return ce}}class ke{constructor(F,q){this.f=F,this.g=q,this.d=new i.$XL(""),this.e=new Map}async prepareSession(F,q,H){const Q=this.f.getDocument(F),K=C.Position.to(q),ee=await this.g.prepareCallHierarchy(Q,K,H);if(!ee)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(ee)?ee.map(ze=>this.h(ce,ze)):[this.h(ce,ee)]}async provideCallsTo(F,q,H){const Q=this.j(F,q);if(!Q)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyIncomingCalls(Q,H);if(K)return K.map(ee=>({from:this.h(F,ee.from),fromRanges:ee.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(F,q,H){const Q=this.j(F,q);if(!Q)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyOutgoingCalls(Q,H);if(K)return K.map(ee=>({to:this.h(F,ee.to),fromRanges:ee.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(F){this.e.delete(F)}h(F,q){const H=this.e.get(F),Q=C.CallHierarchyItem.from(q,F,H.size.toString(36));return H.set(Q._itemId,q),Q}j(F,q){return this.e.get(F)?.get(q)}}class oe{constructor(F,q){this.f=F,this.g=q,this.d=new i.$XL(""),this.e=new Map}async prepareSession(F,q,H){const Q=this.f.getDocument(F),K=C.Position.to(q),ee=await this.g.prepareTypeHierarchy(Q,K,H);if(!ee)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(ee)?ee.map(ze=>this.h(ce,ze)):[this.h(ce,ee)]}async provideSupertypes(F,q,H){const Q=this.j(F,q);if(!Q)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySupertypes(Q,H);if(K)return K.map(ee=>this.h(F,ee))}async provideSubtypes(F,q,H){const Q=this.j(F,q);if(!Q)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySubtypes(Q,H);if(K)return K.map(ee=>this.h(F,ee))}releaseSession(F){this.e.delete(F)}h(F,q){const H=this.e.get(F),Q=C.TypeHierarchyItem.from(q,F,H.size.toString(36));return H.set(Q._itemId,q),Q}j(F,q){return this.e.get(F)?.get(q)}}class de{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,H,Q,K){this.d=F,this.e=q,this.f=H,this.g=Q,this.h=K}async provideDocumentOnDropEdits(F,q,H,Q,K){const ee=this.e.getDocument(q),ce=C.Position.to(H),ze=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(ee,ce,ze,K);if(Ue)return{label:Ue.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:de.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(F,q){this.d=F,this.e=q}async provideMappedEdits(F,q,H,Q){const K=y.URI.revive(F),ee=this.d.getDocument(K),ce={selections:H.selections.map(Ue=>C.Selection.to(Ue)),related:H.related.map(Ue=>({uri:y.URI.revive(Ue.uri),range:C.Range.to(Ue.range)}))},ze=await this.e.provideMappedEdits(ee,q,ce,Q);return ze?C.WorkspaceEdit.from(ze):null}}class ne{constructor(F,q){this.adapter=F,this.extension=q}}class me{static{this.d=0}constructor(F,q,H,Q,K,ee,ce,ze){this.g=q,this.h=H,this.j=Q,this.k=K,this.l=ee,this.m=ce,this.n=ze,this.f=new Map,this.e=F.getProxy(l.$QJ.MainThreadLanguageFeatures)}o(F,q){return C.DocumentSelector.from(F,this.g,q)}p(F){return new L.$SJ(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return me.d++}async t(F,q,H,Q,K,ee=!1){const ce=this.f.get(F);if(!ce||!(ce.adapter instanceof q))return Q;const ze=Date.now();ee||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ue=H(ce.adapter,ce.extension);return Promise.resolve(Ue).catch(Qe=>{(0,k.$2)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{ee||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),p.CancellationToken.isCancellationToken(K)?(0,b.$ug)(Ue,K):Ue}u(F,q){const H=this.q();return this.f.set(H,new ne(F,q)),H}static w(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,q,H,Q){const K=this.u(new r(this.h,H),F),ee=Q&&Q.label||me.w(F);return this.e.$registerDocumentSymbolProvider(K,this.o(q,F),ee),this.p(K)}$provideDocumentSymbols(F,q,H){return this.t(F,r,Q=>Q.provideDocumentSymbols(y.URI.revive(q),H),void 0,H)}registerCodeLensProvider(F,q,H){const Q=this.q(),K=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ne(new o(this.h,this.j.converter,H),F)),this.e.$registerCodeLensSupport(Q,this.o(q,F),K);let ee=this.p(Q);if(K!==void 0){const ce=H.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(K));ee=L.$SJ.from(ee,ce)}return ee}$provideCodeLenses(F,q,H){return this.t(F,o,Q=>Q.provideCodeLenses(y.URI.revive(q),H),void 0,H)}$resolveCodeLens(F,q,H){return this.t(F,o,Q=>Q.resolveCodeLens(q,H),void 0,void 0)}$releaseCodeLenses(F,q){this.t(F,o,H=>Promise.resolve(H.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(F,q,H){const Q=this.u(new v(this.h,H),F);return this.e.$registerDefinitionSupport(Q,this.o(q,F)),this.p(Q)}$provideDefinition(F,q,H,Q){return this.t(F,v,K=>K.provideDefinition(y.URI.revive(q),H,Q),[],Q)}registerDeclarationProvider(F,q,H){const Q=this.u(new E(this.h,H),F);return this.e.$registerDeclarationSupport(Q,this.o(q,F)),this.p(Q)}$provideDeclaration(F,q,H,Q){return this.t(F,E,K=>K.provideDeclaration(y.URI.revive(q),H,Q),[],Q)}registerImplementationProvider(F,q,H){const Q=this.u(new D(this.h,H),F);return this.e.$registerImplementationSupport(Q,this.o(q,F)),this.p(Q)}$provideImplementation(F,q,H,Q){return this.t(F,D,K=>K.provideImplementation(y.URI.revive(q),H,Q),[],Q)}registerTypeDefinitionProvider(F,q,H){const Q=this.u(new s(this.h,H),F);return this.e.$registerTypeDefinitionSupport(Q,this.o(q,F)),this.p(Q)}$provideTypeDefinition(F,q,H,Q){return this.t(F,s,K=>K.provideTypeDefinition(y.URI.revive(q),H,Q),[],Q)}registerHoverProvider(F,q,H,Q){const K=this.u(new h(this.h,H),F);return this.e.$registerHoverProvider(K,this.o(q,F)),this.p(K)}$provideHover(F,q,H,Q){return this.t(F,h,K=>K.provideHover(y.URI.revive(q),H,Q),void 0,Q)}registerEvaluatableExpressionProvider(F,q,H,Q){const K=this.u(new g(this.h,H),F);return this.e.$registerEvaluatableExpressionProvider(K,this.o(q,F)),this.p(K)}$provideEvaluatableExpression(F,q,H,Q){return this.t(F,g,K=>K.provideEvaluatableExpression(y.URI.revive(q),H,Q),void 0,Q)}registerInlineValuesProvider(F,q,H,Q){const K=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ee=this.u(new M(this.h,H),F);this.e.$registerInlineValuesProvider(ee,this.o(q,F),K);let ce=this.p(ee);if(K!==void 0){const ze=H.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(K));ce=L.$SJ.from(ce,ze)}return ce}$provideInlineValues(F,q,H,Q,K){return this.t(F,M,ee=>ee.provideInlineValues(y.URI.revive(q),H,Q,K),void 0,K)}registerDocumentHighlightProvider(F,q,H){const Q=this.u(new W(this.h,H),F);return this.e.$registerDocumentHighlightProvider(Q,this.o(q,F)),this.p(Q)}$provideDocumentHighlights(F,q,H,Q){return this.t(F,W,K=>K.provideDocumentHighlights(y.URI.revive(q),H,Q),void 0,Q)}registerLinkedEditingRangeProvider(F,q,H){const Q=this.u(new V(this.h,H),F);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(q,F)),this.p(Q)}$provideLinkedEditingRanges(F,q,H,Q){return this.t(F,V,async K=>{const ee=await K.provideLinkedEditingRanges(y.URI.revive(q),H,Q);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?me.y(ee.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(F,q,H){const Q=this.u(new B(this.h,H),F);return this.e.$registerReferenceSupport(Q,this.o(q,F)),this.p(Q)}$provideReferences(F,q,H,Q,K){return this.t(F,B,ee=>ee.provideReferences(y.URI.revive(q),H,Q,K),void 0,K)}registerCodeActionProvider(F,q,H,Q){const K=new d.$lb,ee=this.u(new j(this.h,this.j.converter,this.k,H,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(ee,this.o(q,F),{providedKinds:Q?.providedCodeActionKinds?.map(ce=>ce.value),documentation:Q?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,K)}))},me.w(F),!!H.resolveCodeAction),K.add(this.p(ee)),K}$provideCodeActions(F,q,H,Q,K){return this.t(F,j,ee=>ee.provideCodeActions(y.URI.revive(q),H,Q,K),void 0,K)}$resolveCodeAction(F,q,H){return this.t(F,j,Q=>Q.resolveCodeAction(q,H),{},void 0)}$releaseCodeActions(F,q){this.t(F,j,H=>Promise.resolve(H.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(F,q,H){const Q=this.u(new z(this.h,H),F);return this.e.$registerDocumentFormattingSupport(Q,this.o(q,F),F.identifier,F.displayName||F.name),this.p(Q)}$provideDocumentFormattingEdits(F,q,H,Q){return this.t(F,z,K=>K.provideDocumentFormattingEdits(y.URI.revive(q),H,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(F,q,H){const Q=typeof H.provideDocumentRangesFormattingEdits=="function",K=this.u(new ie(this.h,H),F);return this.e.$registerRangeFormattingSupport(K,this.o(q,F),F.identifier,F.displayName||F.name,Q),this.p(K)}$provideDocumentRangeFormattingEdits(F,q,H,Q,K){return this.t(F,ie,ee=>ee.provideDocumentRangeFormattingEdits(y.URI.revive(q),H,Q,K),void 0,K)}$provideDocumentRangesFormattingEdits(F,q,H,Q,K){return this.t(F,ie,ee=>ee.provideDocumentRangesFormattingEdits(y.URI.revive(q),H,Q,K),void 0,K)}registerOnTypeFormattingEditProvider(F,q,H,Q){const K=this.u(new X(this.h,H),F);return this.e.$registerOnTypeFormattingSupport(K,this.o(q,F),Q,F.identifier),this.p(K)}$provideOnTypeFormattingEdits(F,q,H,Q,K,ee){return this.t(F,X,ce=>ce.provideOnTypeFormattingEdits(y.URI.revive(q),H,Q,K,ee),void 0,ee)}registerWorkspaceSymbolProvider(F,q){const H=this.u(new ye(q,this.l),F);return this.e.$registerNavigateTypeSupport(H,typeof q.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(F,q,H){return this.t(F,ye,Q=>Q.provideWorkspaceSymbols(q,H),{symbols:[]},H)}$resolveWorkspaceSymbol(F,q,H){return this.t(F,ye,Q=>Q.resolveWorkspaceSymbol(q,H),void 0,void 0)}$releaseWorkspaceSymbols(F,q){this.t(F,ye,H=>H.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(F,q,H){const Q=this.u(new De(this.h,H,this.l),F);return this.e.$registerRenameSupport(Q,this.o(q,F),De.supportsResolving(H)),this.p(Q)}$provideRenameEdits(F,q,H,Q,K){return this.t(F,De,ee=>ee.provideRenameEdits(y.URI.revive(q),H,Q,K),void 0,K)}$resolveRenameLocation(F,q,H,Q){return this.t(F,De,K=>K.resolveRenameLocation(y.URI.revive(q),H,Q),void 0,Q)}registerDocumentSemanticTokensProvider(F,q,H,Q){const K=this.u(new Y(this.h,H),F),ee=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(K,this.o(q,F),Q,ee);let ce=this.p(K);if(ee){const ze=H.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(ee));ce=L.$SJ.from(ce,ze)}return ce}$provideDocumentSemanticTokens(F,q,H,Q){return this.t(F,Y,K=>K.provideDocumentSemanticTokens(y.URI.revive(q),H,Q),null,Q)}$releaseDocumentSemanticTokens(F,q){this.t(F,Y,H=>H.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,q,H,Q){const K=this.u(new le(this.h,H),F);return this.e.$registerDocumentRangeSemanticTokensProvider(K,this.o(q,F),Q),this.p(K)}$provideDocumentRangeSemanticTokens(F,q,H,Q){return this.t(F,le,K=>K.provideDocumentRangeSemanticTokens(y.URI.revive(q),H,Q),null,Q)}registerCompletionItemProvider(F,q,H,Q){const K=this.u(new we(this.h,this.j.converter,H,this.m,F),F);return this.e.$registerCompletionsProvider(K,this.o(q,F),Q,we.supportsResolving(H),F.identifier),this.p(K)}$provideCompletionItems(F,q,H,Q,K){return this.t(F,we,ee=>ee.provideCompletionItems(y.URI.revive(q),H,Q,K),void 0,K)}$resolveCompletionItem(F,q,H){return this.t(F,we,Q=>Q.resolveCompletionItem(q,H),void 0,H)}$releaseCompletionItems(F,q){this.t(F,we,H=>H.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(F,q,H,Q){const K=new x(F,this.h,H,this.j.converter),ee=this.u(K,F);return this.e.$registerInlineCompletionsSupport(ee,this.o(q,F),K.supportsHandleEvents,$.$Tl.toKey(F.identifier.value),Q?.yieldTo?.map(ce=>$.$Tl.toKey(ce))||[]),this.p(ee)}$provideInlineCompletions(F,q,H,Q,K){return this.t(F,ae,ee=>ee.provideInlineCompletions(y.URI.revive(q),H,Q,K),void 0,K)}$handleInlineCompletionDidShow(F,q,H,Q){this.t(F,ae,async K=>{K.handleDidShowCompletionItem(q,H,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,q,H,Q){this.t(F,ae,async K=>{K.handlePartialAccept(q,H,Q)},void 0,void 0)}$freeInlineCompletionsList(F,q){this.t(F,ae,async H=>{H.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(F,q,H,Q){const K=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,ee=this.u(new O(this.h,H),F);return this.e.$registerSignatureHelpProvider(ee,this.o(q,F),K),this.p(ee)}$provideSignatureHelp(F,q,H,Q,K){return this.t(F,O,ee=>ee.provideSignatureHelp(y.URI.revive(q),H,Q,K),void 0,K)}$releaseSignatureHelp(F,q){this.t(F,O,H=>H.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(F,q,H){const Q=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,K=this.u(new J(this.h,this.j.converter,H,this.l,F),F);this.e.$registerInlayHintsProvider(K,this.o(q,F),typeof H.resolveInlayHint=="function",Q,me.w(F));let ee=this.p(K);if(Q!==void 0){const ce=H.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(Q));ee=L.$SJ.from(ee,ce)}return ee}$provideInlayHints(F,q,H,Q){return this.t(F,J,K=>K.provideInlayHints(y.URI.revive(q),H,Q),void 0,Q)}$resolveInlayHint(F,q,H){return this.t(F,J,Q=>Q.resolveInlayHint(q,H),void 0,H)}$releaseInlayHints(F,q){this.t(F,J,H=>H.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(F,q,H){const Q=this.u(new he(this.h,H),F);return this.e.$registerDocumentLinkProvider(Q,this.o(q,F),typeof H.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(F,q,H){return this.t(F,he,Q=>Q.provideLinks(y.URI.revive(q),H),void 0,H,q.scheme==="output")}$resolveDocumentLink(F,q,H){return this.t(F,he,Q=>Q.resolveLink(q,H),void 0,void 0,!0)}$releaseDocumentLinks(F,q){this.t(F,he,H=>H.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(F,q,H){const Q=this.u(new Ee(this.h,H),F);return this.e.$registerDocumentColorProvider(Q,this.o(q,F)),this.p(Q)}$provideDocumentColors(F,q,H){return this.t(F,Ee,Q=>Q.provideColors(y.URI.revive(q),H),[],H)}$provideColorPresentations(F,q,H,Q){return this.t(F,Ee,K=>K.provideColorPresentations(y.URI.revive(q),H,Q),void 0,Q)}registerFoldingRangeProvider(F,q,H){const Q=this.q(),K=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ne(new ve(this.h,H),F)),this.e.$registerFoldingRangeProvider(Q,this.o(q,F),F.identifier,K);let ee=this.p(Q);if(K!==void 0){const ce=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(K));ee=L.$SJ.from(ee,ce)}return ee}$provideFoldingRanges(F,q,H,Q){return this.t(F,ve,K=>K.provideFoldingRanges(y.URI.revive(q),H,Q),void 0,Q)}registerSelectionRangeProvider(F,q,H){const Q=this.u(new be(this.h,H,this.l),F);return this.e.$registerSelectionRangeProvider(Q,this.o(q,F)),this.p(Q)}$provideSelectionRanges(F,q,H,Q){return this.t(F,be,K=>K.provideSelectionRanges(y.URI.revive(q),H,Q),[],Q)}registerCallHierarchyProvider(F,q,H){const Q=this.u(new ke(this.h,H),F);return this.e.$registerCallHierarchyProvider(Q,this.o(q,F)),this.p(Q)}$prepareCallHierarchy(F,q,H,Q){return this.t(F,ke,K=>Promise.resolve(K.prepareSession(y.URI.revive(q),H,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(F,q,H,Q){return this.t(F,ke,K=>K.provideCallsTo(q,H,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(F,q,H,Q){return this.t(F,ke,K=>K.provideCallsFrom(q,H,Q),void 0,Q)}$releaseCallHierarchy(F,q){this.t(F,ke,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(F,q,H){const Q=this.u(new oe(this.h,H),F);return this.e.$registerTypeHierarchyProvider(Q,this.o(q,F)),this.p(Q)}$prepareTypeHierarchy(F,q,H,Q){return this.t(F,oe,K=>Promise.resolve(K.prepareSession(y.URI.revive(q),H,Q)),void 0,Q)}$provideTypeHierarchySupertypes(F,q,H,Q){return this.t(F,oe,K=>K.provideSupertypes(q,H,Q),void 0,Q)}$provideTypeHierarchySubtypes(F,q,H,Q){return this.t(F,oe,K=>K.provideSubtypes(q,H,Q),void 0,Q)}$releaseTypeHierarchy(F,q){this.t(F,oe,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(F,q,H,Q){const K=this.q();this.f.set(K,new ne(new de(this.e,this.h,H,K,F),F));const ee=(0,n.$KF)(F,"dropMetadata")&&Q?de.toInternalProviderId(F.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(K,this.o(q,F),ee,(0,n.$KF)(F,"dropMetadata")?Q:void 0),this.p(K)}$provideDocumentOnDropEdits(F,q,H,Q,K,ee){return this.t(F,de,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(q,y.URI.revive(H),Q,K,ee)),void 0,void 0)}registerMappedEditsProvider(F,q,H){const Q=this.u(new se(this.h,H),F);return this.e.$registerMappedEditsProvider(Q,this.o(q,F)),this.p(Q)}$provideMappedEdits(F,q,H,Q,K){return this.t(F,se,ee=>Promise.resolve(ee.provideMappedEdits(q,H,Q,K)),null,K)}registerDocumentPasteEditProvider(F,q,H,Q){const K=this.q();this.f.set(K,new ne(new U(this.e,this.h,H,K,F),F));const ee=U.toInternalProviderId(F.identifier.value,Q.id);return this.e.$registerPasteEditProvider(K,this.o(q,F),ee,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(K)}$prepareDocumentPaste(F,q,H,Q,K){return this.t(F,U,ee=>ee.prepareDocumentPaste(y.URI.revive(q),H,Q,K),void 0,K)}$providePasteEdits(F,q,H,Q,K,ee){return this.t(F,U,ce=>ce.providePasteEdits(q,y.URI.revive(H),Q,K,ee),void 0,ee)}static y(F){return{pattern:F.source,flags:F.flags}}static z(F){return{decreaseIndentPattern:me.y(F.decreaseIndentPattern),increaseIndentPattern:me.y(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?me.y(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?me.y(F.unIndentedLinePattern):void 0}}static B(F){return{beforeText:me.y(F.beforeText),afterText:F.afterText?me.y(F.afterText):void 0,previousLineText:F.previousLineText?me.y(F.previousLineText):void 0,action:F.action}}static C(F){return F.map(me.B)}setLanguageConfiguration(F,q,H){const{wordPattern:Q}=H;if(Q&&(0,I.$Bd)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(q,Q):this.h.setWordDefinitionFor(q,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use."),H.autoClosingPairs&&(0,n.$LF)(F,"languageConfigurationAutoClosingPairs");const K=this.q(),ee={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?me.y(H.wordPattern):void 0,indentationRules:H.indentationRules?me.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?me.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs};return this.e.$setLanguageConfiguration(K,q,ee),this.p(K)}$setWordDefinitions(F){for(const q of F)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$wac=me}),define(Pe[240],Ae([1,0,3,8,7,29,13,6]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;class I{constructor(P,S,u,p){this.c=S,this.d=u,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(y.$QJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,S){await this.a.$changeLanguage(P,S);const u=this.c.getDocumentData(P);if(!u)throw new Error(`document '${P.toString()}' NOT found`);return u.document}async tokenAtPosition(P,S){const u=P.version,p=R.Position.from(S),$=await this.a.$tokensAtPosition(P.uri,p),d={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(S)??new C.$UJ(S.line,S.character,S.line,S.character)};if(!$)return d;const t={range:R.Range.to($.range),type:R.TokenType.to($.type)};return!t.range.contains(S)||u!==P.version?d:t}createLanguageStatusItem(P,S,u){const p=this.f++,$=this.a,d=this.g,t=`${P.identifier.value}/${S}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);d.add(t);const i={selector:u,id:S,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const m=new l.$lb,k=()=>{if(c?.dispose(),!d.has(t)){console.warn(`LanguageStatusItem (${S}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Gg)(()=>{m.clear(),this.a.$setLanguageStatus(p,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:R.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===C.LanguageStatusSeverity.Error?L.default.Error:i.severity===C.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,m),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},b={dispose(){m.dispose(),c?.dispose(),$.$removeLanguageStatus(p),d.delete(t)},get id(){return i.id},get name(){return i.name},set name(n){i.name=n,k()},get selector(){return i.selector},set selector(n){i.selector=n,k()},get text(){return i.text},set text(n){i.text=n,k()},get detail(){return i.detail},set detail(n){i.detail=n,k()},get severity(){return i.severity},set severity(n){i.severity=n,k()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(n){i.accessibilityInformation=n,k()},get command(){return i.command},set command(n){i.command=n,k()},get busy(){return i.busy},set busy(n){i.busy=n,k()}};return k(),b}}e.$ebc=I}),define(Pe[81],Ae([1,0,22,15,2,4,14,3,27,17]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=e.$6ac=void 0;let P=class{constructor(u,p,$){this.f=$,this.d=new Map,this.a=p.getProxy(l.$QJ.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===y.$f}getMessage(u,p){const{message:$,args:d,comment:t}=p;if(this.c)return(0,R.$qd)($,d??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(u)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,R.$qd)(c??$,d??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let p;const $=await this.g(u);if(!$){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents($),t=JSON.parse(d);p=u.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${u.identifier.value} from ${$}: ${d.message}`);return}p&&this.d.set(u.identifier.value,{contents:p,uri:$})}async g(u){if(u.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(p)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$6ac=P,e.$6ac=P=Ke([Ve(0,I.$9L),Ve(1,f.$SL),Ve(2,A.$3i)],P),e.$7ac=(0,L.$zh)("IExtHostLocalizationService")}),define(Pe[241],Ae([1,0,14,3,27,17,2,68]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;let I=class extends y.$bj{constructor(S,u){super(u.logLevel,u.logsLocation,u.loggers.map(p=>(0,l.$9g)(p))),this.n=S.getProxy(R.$QJ.MainThreadLogger)}$setLogLevel(S,u){u?this.setLogLevel(A.URI.revive(u),S):this.setLogLevel(S)}setVisibility(S,u){super.setVisibility(S,u),this.n.$setVisibility(S,u)}m(S,u,p){return new f(this.n,S,u,p)}};e.$ucc=I,e.$ucc=I=Ke([Ve(0,L.$SL),Ve(1,C.$9L)],I);class f extends y.$9i{constructor(S,u,p,$){super($?.logLevel==="always"),this.m=S,this.n=u,this.k=!1,this.l=[],this.setLevel(p),this.m.$createLogger(u,$).then(()=>{this.r(this.l),this.k=!0})}g(S,u){const p=[[S,u]];this.k?this.r(p):this.l.push(...p)}r(S){this.m.$log(this.n,S)}flush(){this.m.$flush(this.n)}}}),define(Pe[82],Ae([1,0,3,4,6,17,25]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=e.$8ac=void 0,e.$8ac=(0,R.$zh)("IExtHostManagedSockets");let l=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(y.$QJ.MainThreadManagedSockets)}setFactory(S,u){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new I(S,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const u=++this.b,p=await this.c.makeConnection(),$=new C.$lb;return this.d.set(u,new f(u,p,$)),$.add((0,C.$kb)(()=>this.d.delete(u))),$.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),$.dispose()})),$.add(p.onDidClose(d=>{this.a.$onDidManagedSocketClose(u,d?.stack??d?.message),$.dispose()})),$.add(p.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(u,A.$Hc.wrap(d)))),u}$remoteSocketWrite(S,u){this.d.get(S)?.actual.send(u.buffer)}$remoteSocketEnd(S){const u=this.d.get(S);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$9ac=l,e.$9ac=l=Ke([Ve(0,L.$SL)],l);class I{constructor(S,u){this.socketFactoryId=S,this.makeConnection=u}}class f extends C.$mb{constructor(S,u,p){super(),this.socketId=S,this.actual=u,this.B(p)}}}),define(Pe[242],Ae([1,0,3,14,26]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=void 0;function L(l){return l&&l.title}let A=class{constructor(I,f){this.b=f,this.a=I.getProxy(y.$QJ.MainThreadMessageService)}showMessage(I,f,P,S,u){const p={source:{identifier:I.identifier,label:I.displayName||I.name}};let $;typeof S=="string"||L(S)?$=[S,...u]:(p.modal=S?.modal,p.useCustom=S?.useCustom,p.detail=S?.detail,$=u),p.useCustom&&(0,C.$LF)(I,"resolvers");const d=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")d.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:m}=i;d.push({title:c,isCloseAffordance:!!m,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,P,p,d).then(t=>{if(typeof t=="number")return $[t]})}};e.$fbc=A,e.$fbc=A=Ke([Ve(1,R.$3i)],A)}),define(Pe[243],Ae([1,0,152,25,5,6,28,15,16,2,38,54,3,31,8,7,46,205,104,9,24,12]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(r=>r.apiEditor)}constructor(r,o,w,v,E){this.q=w,this.r=v,this.s=E,this.f=new Map,this.g=new A.$xi,this.h=new Map,this.j=new C.$hc({onListenerError:m.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$hc({onListenerError:m.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$hc({onListenerError:m.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$hc({onListenerError:m.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$nac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=r.getProxy(u.$QJ.MainThreadNotebook),this.c=r.getProxy(u.$QJ.MainThreadNotebookDocuments),this.d=r.getProxy(u.$QJ.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const s=D.notebookEditor?.notebookUri,h=D.cell.handle,M=this.g.get(s)?.getCell(h);if(M)return M.apiCell}if(D&&D.$mid===14){const s=D.uri,h=this.g.get(s);if(h)return h.apiNotebook}return D}}),n.A(o)}getEditorById(r){const o=this.h.get(r);if(!o)throw new Error(`unknown text editor: ${r}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(r){for(const[o,w]of this.h)if(w.apiEditor===r)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(r,o){const w=this.g.get(r);if(!w&&!o)throw new Error(`NO notebook document for '${r}'`);return w}static t(r,o){if(!o)return;const w=o.filenamePattern.map(v=>$.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(o.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:o.displayName,filenamePattern:w,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,o,w){const v=n.a++,E=typeof w.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(v,w),this.b.$registerNotebookCellStatusBarItemProvider(v,E,o);let D;return E!==void 0&&(D=w.onDidChangeCellStatusBarItems(s=>this.b.$emitCellStatusBarEvent(E))),new d.$SJ(()=>{this.f.delete(v),this.b.$unregisterNotebookCellStatusBarItemProvider(v,E),D?.dispose()})}async createNotebookDocument(r){const o=await this.c.$tryCreateNotebook({viewType:r.viewType,content:r.content&&$.NotebookData.from(r.content)});return f.URI.revive(o)}async openNotebookDocument(r){const o=this.g.get(r);if(o)return o.apiNotebook;const w=await this.c.$tryOpenNotebook(r),v=this.g.get(f.URI.revive(w));return(0,I.$we)(v?.apiNotebook)}async showNotebookDocument(r,o){f.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let w;typeof o=="object"?w={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:w={preserveFocus:!1};const v=await this.d.$tryShowNotebookDocument(r.uri,r.notebookType,w),E=v&&this.h.get(v)?.apiEditor;if(E)return E;throw v?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,o,w,v){const E=this.f.get(r),D=f.URI.revive(o),s=this.g.get(D);if(!s||!E)return;const h=s.getCellFromIndex(w);if(!h)return;const g=await E.provideCellStatusBarItems(h.apiCell,v);if(!g)return;const M=new L.$lb,W=this.p.add([M]),B=(Array.isArray(g)?g:[g]).map(j=>$.NotebookStatusBarItem.from(j,this.i,M));return{cacheId:W,items:B}}$releaseNotebookCellStatusBarItems(r){this.p.delete(r)}registerNotebookSerializer(r,o,w,v,E){if((0,l.$od)(o))throw new Error("viewType cannot be empty or just whitespace");const D=this.u++;return this.w.set(D,{viewType:o,serializer:w,options:v}),this.b.$registerNotebookSerializer(D,{id:r.identifier,location:r.extensionLocation},o,$.NotebookDocumentContentOptions.from(v),n.t(r,E)),(0,L.$kb)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(r,o,w){const v=this.w.get(r);if(!v)throw new Error("NO serializer found");const E=await v.serializer.deserializeNotebook(o.buffer,w);return new t.$_z($.NotebookData.from(E))}async $notebookToData(r,o,w){const v=this.w.get(r);if(!v)throw new Error("NO serializer found");const E=await v.serializer.serializeNotebook($.NotebookData.to(o.value),w);return R.$Hc.wrap(E)}async $saveNotebook(r,o,w,v,E){const D=f.URI.revive(o),s=this.w.get(r);if(!s)throw new Error("NO serializer found");const h=this.g.get(D);if(!h)throw new Error("Document NOT found");if(h.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new P.$lk((0,y.localize)(0,null,this.y(D)),6);await this.x(D,v);const g={metadata:(0,k.$2m)(h.apiNotebook.metadata,j=>!(s.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of h.apiNotebook.getCells()){const U=new d.$fL(j.kind,j.document.getText(),j.document.languageId,j.mime,s.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,k.$2m)(j.metadata,z=>!(s.options?.transientCellMetadata??{})[z]),g.cells.push(U)}const M=await s.serializer.serializeNotebook(g,E);await this.s.value.writeFile(D,M);const W=this.s.getFileSystemProviderExtUri(D.scheme),V=await this.s.value.stat(D);return{name:W.basename(D),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$wk({mtime:V.mtime,size:V.size}),children:void 0}}async x(r,o){const w=await this.s.value.stat(r);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$vk&&typeof w.mtime=="number"&&typeof w.size=="number"&&o.mtime<w.mtime&&o.etag!==P.$wk({mtime:o.mtime,size:w.size}))throw new P.$lk((0,y.localize)(1,null),3,o)}y(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString()}z(r,o,w){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const v=new c.$Ybc(o,this.d,r,w.visibleRanges.map($.NotebookRange.to),w.selections.map($.NotebookRange.to),typeof w.viewColumn=="number"?$.ViewColumn.to(w.viewColumn):void 0);this.h.set(o,v)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const w of r.value.removedDocuments){const v=f.URI.revive(w),E=this.g.get(v);E&&(E.dispose(),this.g.delete(v),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(E.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===v.toString()&&this.h.delete(D.id)}if(r.value.addedDocuments){const w=[];for(const v of r.value.addedDocuments){const E=f.URI.revive(v.uri);if(this.g.has(E))throw new Error(`adding EXISTING notebook ${E} `);const D=new i.$Xbc(this.c,this.q,this.r,E,v);w.push(...v.cells.map(s=>i.$Wbc.asModelAddData(D.apiNotebook,s))),this.g.get(E)?.dispose(),this.g.set(E,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(D.apiNotebook)}}if(r.value.addedEditors)for(const w of r.value.addedEditors){if(this.h.has(w.id))return;const v=f.URI.revive(w.documentUri),E=this.g.get(v);E&&this.z(E,w.id,w)}const o=[];if(r.value.removedEditors)for(const w of r.value.removedEditors){const v=this.h.get(w);v&&(this.h.delete(w),this.k?.id===v.id&&(this.k=void 0),o.push(v))}if(r.value.visibleEditors){this.l=r.value.visibleEditors.map(v=>this.h.get(v)).filter(v=>!!v);const w=new Set;this.l.forEach(v=>w.add(v.id));for(const v of this.h.values()){const E=w.has(v.id);v._acceptVisibility(E)}this.l=[...this.h.values()].map(v=>v).filter(v=>v.visible),this.o.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this.k=void 0:r.value.newActiveEditor&&(this.h.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this.k=this.h.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(r){const o=p.$eM.String.with("notebookType","A notebook type"),w=new p.$gM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$eM("data","Bytes to convert to data",E=>E instanceof Uint8Array,E=>R.$Hc.wrap(E))],new p.$fM("Notebook Data",E=>$.NotebookData.to(E.value))),v=new p.$gM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$eM("NotebookData","Notebook data to convert to bytes",E=>!0,E=>new t.$_z($.NotebookData.from(E)))],new p.$fM("Bytes",E=>E.buffer));r.registerApiCommand(w),r.registerApiCommand(v)}}e.$Zbc=n}),define(Pe[244],Ae([1,0,18,13,21,5,6,28,2,20,14,54,3,31,8,7,77,198,26,46]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=void 0;let k=class{constructor(E,D,s,h,g){this.m=D,this.n=s,this.o=h,this.q=g,this.b=new l.$xi,this.c=new l.$xi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new S.$nac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$hc,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=E.getProxy(u.$QJ.MainThreadNotebookKernels);const M=new p.$gM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$eM("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],p.$fM.Void);this.o.registerApiCommand(M)}createNotebookController(E,D,s,h,g,M){for(const we of this.j.values())if(we.controller.id===D&&f.$Tl.equals(E.identifier,we.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const W=this.k++,V=this;this.q.trace(`NotebookController[${W}], CREATED by ${E.identifier.value}, ${D}`);const B=()=>console.warn(`NO execute handler from notebook controller '${ie.id}' of extension: '${E.identifier}'`);let j=!1;const U=new L.$hc,z=new L.$hc,ie={id:w(E.identifier,D),notebookType:s,extensionId:E.identifier,extensionLocation:E.extensionLocation,label:h||E.identifier.value,preloads:M?M.map($.NotebookRendererScript.from):[]};let X=g??B,ye;this.a.$addKernel(W,ie).catch(we=>{console.log(we),j=!0});let De=0;const Re=()=>{if(j)return;const we=++De;Promise.resolve().then(()=>{we===De&&this.a.$updateKernel(W,ie)})},Y=new l.$xi,le={get id(){return D},get notebookType(){return ie.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return ie.label},set label(we){ie.label=we??E.displayName??E.name,Re()},get detail(){return ie.detail??""},set detail(we){ie.detail=we,Re()},get description(){return ie.description??""},set description(we){ie.description=we,Re()},get supportedLanguages(){return ie.supportedLanguages},set supportedLanguages(we){ie.supportedLanguages=we,Re()},get supportsExecutionOrder(){return ie.supportsExecutionOrder??!1},set supportsExecutionOrder(we){ie.supportsExecutionOrder=we,Re()},get rendererScripts(){return ie.preloads?ie.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(we){X=we??B},get interruptHandler(){return ye},set interruptHandler(we){ye=we,ie.supportsInterrupt=!!we,Re()},createNotebookCellExecution(we){if(j)throw new Error("notebook controller is DISPOSED");if(!Y.has(we.notebook.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return V._createNotebookCellExecution(we,w(E.identifier,this.id))},createNotebookExecution(we){if((0,c.$LF)(E,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!Y.has(we.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return V._createNotebookExecution(we,w(E.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${W}], DISPOSED`),j=!0,this.j.delete(W),U.dispose(),z.dispose(),this.a.$removeKernel(W))},updateNotebookAffinity(we,ae){ae===d.NotebookControllerAffinity2.Hidden&&(0,c.$LF)(E,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(W,we.uri,ae)},onDidReceiveMessage:z.event,postMessage(we,ae){return(0,c.$LF)(E,"notebookMessaging"),V.a.$postMessage(W,ae&&V.n.getIdByEditor(ae),we)},asWebviewUri(we){return(0,c.$LF)(E,"notebookMessaging"),(0,t.$xob)(we,V.m.remote)}};return this.j.set(W,{extensionId:E.identifier,controller:le,onDidReceiveMessage:z,onDidChangeSelection:U,associatedNotebooks:Y}),le}getIdByController(E){for(const[D,s]of this.j)if(s.controller===E)return w(s.extensionId,E.id);return null}createNotebookControllerDetectionTask(E,D){const s=this.f++,h=this;this.q.trace(`NotebookControllerDetectionTask[${s}], CREATED by ${E.identifier.value}`),this.a.$addKernelDetectionTask(s,D);const g={dispose:()=>{this.e.delete(s),h.a.$removeKernelDetectionTask(s)}};return this.e.set(s,g),g}registerKernelSourceActionProvider(E,D,s){const h=this.h++,g=typeof s.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,M=this;this.g.set(h,s),this.q.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${E.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,D);let W;return g!==void 0&&(W=s.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.g.delete(h),M.a.$removeKernelSourceActionProvider(h,h),W?.dispose()}}}async $provideKernelSourceActions(E,D){const s=this.g.get(E);if(s){const h=new A.$lb;return this.i.add([h]),(await s.provideNotebookKernelSourceActions(D)??[]).map(M=>$.NotebookKernelSourceAction.from(M,this.o.converter,h))}return[]}$acceptNotebookAssociation(E,D,s){const h=this.j.get(E);if(h){const g=this.n.getNotebookDocument(I.URI.revive(D));s?h.associatedNotebooks.set(g.uri,!0):h.associatedNotebooks.delete(g.uri),this.q.trace(`NotebookController[${E}] ASSOCIATE notebook`,g.uri.toString(),s),h.onDidChangeSelection.fire({selected:s,notebook:g.apiNotebook})}}async $executeCells(E,D,s){const h=this.j.get(E);if(!h)return;const g=this.n.getNotebookDocument(I.URI.revive(D)),M=[];for(const W of s){const V=g.getCell(W);V&&M.push(V.apiCell)}try{this.q.trace(`NotebookController[${E}] EXECUTE cells`,g.uri.toString(),M.length),await h.controller.executeHandler.call(h.controller,M,g.apiNotebook,h.controller)}catch(W){this.q.error(`NotebookController[${E}] execute cells FAILED`,W),console.error(W)}}async $cancelCells(E,D,s){const h=this.j.get(E);if(!h)return;const g=this.n.getNotebookDocument(I.URI.revive(D));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,g.apiNotebook);else for(const M of s){const W=g.getCell(M);W&&this.b.get(W.uri)?.cancel()}if(h.controller.interruptHandler){const M=this.c.get(g.uri);s.length&&Array.isArray(M)&&M.length&&M.forEach(W=>W.dispose())}}$acceptKernelMessageFromRenderer(E,D,s){const h=this.j.get(E);if(!h)return;const g=this.n.getEditorById(D);h.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:s}))}$cellExecutionChanged(E,D,s){const g=this.n.getNotebookDocument(I.URI.revive(E)).getCell(D);if(g){const M=s?$.NotebookCellExecutionState.to(s):d.NotebookCellExecutionState.Idle;M!==void 0&&this.l.fire({cell:g.apiCell,state:M})}}_createNotebookCellExecution(E,D){if(E.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.n.getNotebookDocument(E.notebook.uri).getCellFromApiCell(E);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const g=new n(D,h,this.a);this.b.set(h.uri,g);const M=g.onDidChangeState(()=>{g.state===b.Resolved&&(g.dispose(),M.dispose(),this.b.delete(h.uri))});return g.asApiObject()}_createNotebookExecution(E,D){const s=this.n.getNotebookDocument(E.uri),h=E.getCells().find(W=>{const V=s.getCellFromApiCell(W);return V&&this.b.has(V.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(s.uri))throw new Error(`duplicate notebook execution for ${s.uri}`);const g=new r(D,s,this.a),M=g.onDidChangeState(()=>{g.state===a.Resolved&&(g.dispose(),M.dispose(),this.c.delete(s.uri))});return this.c.set(s.uri,[g,M]),g.asApiObject()}};e.$bcc=k,e.$bcc=k=Ke([Ve(4,P.$3i)],k);var b;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(b||(b={}));class n extends A.$mb{static{this.a=0}get state(){return this.f}constructor(E,D,s){super(),this.j=D,this.k=s,this.b=n.a++,this.c=new L.$hc,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new C.$rc),this.h=new o(10,h=>this.m(h)),this.i=D.internalMetadata.executionOrder,this.k.$createExecution(this.b,E,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(E){await this.h.addItem(E)}async m(E){const D=Array.isArray(E)?E:[E];return this.k.$updateExecution(this.b,new m.$_z(D))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(E){let D=this.j;if(E&&(D=this.j.notebook.getCellFromApiCell(E)),!D)throw new Error("INVALID cell");return D.handle}s(E){return E.map(D=>{const s=d.$iL.ensureUniqueMimeTypes(D.items,!0);return s===D.items?$.NotebookCellOutput.from(D):$.NotebookCellOutput.from({items:s,id:D.id,metadata:D.metadata})})}async t(E,D,s){const h=this.r(D),g=this.s((0,y.$Vf)(E));return this.l({editType:i.CellExecutionUpdateType.Output,cellHandle:h,append:s,outputs:g})}async w(E,D,s){return E=d.$iL.ensureUniqueMimeTypes((0,y.$Vf)(E),!0),this.l({editType:i.CellExecutionUpdateType.OutputItems,items:E.map($.NotebookCellOutputItem.from),outputId:D.id,append:s})}asApiObject(){const E=this;return Object.freeze({get token(){return E.g.token},get cell(){return E.j.apiCell},get executionOrder(){return E.i},set executionOrder(s){E.i=s,E.m([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:E.i}])},start(s){if(E.f===b.Resolved||E.f===b.Started)throw new Error("Cannot call start again");E.f=b.Started,E.c.fire(),E.m({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:s})},end(s,h){if(E.f===b.Resolved)throw new Error("Cannot call resolve twice");E.f=b.Resolved,E.c.fire(),E.h.flush(),E.k.$completeExecution(E.b,new m.$_z({runEndTime:h,lastRunSuccess:s}))},clearOutput(s){return E.n(),E.t([],s,!1)},appendOutput(s,h){return E.n(),E.t(s,h,!0)},replaceOutput(s,h){return E.n(),E.t(s,h,!1)},appendOutputItems(s,h){return E.n(),E.w(s,h,!0)},replaceOutputItems(s,h){return E.n(),E.w(s,h,!1)}})}}var a;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(a||(a={}));class r extends A.$mb{static{this.a=0}get state(){return this.f}constructor(E,D,s){super(),this.h=D,this.i=s,this.b=r.a++,this.c=new L.$hc,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new C.$rc),this.i.$createNotebookExecution(this.b,E,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class o{constructor(E,D){this.e=E,this.f=D,this.a=[],this.b=Date.now()}addItem(E){return this.a.push(E),this.c||(this.c=new R.$Zg,this.b=Date.now(),(0,R.$Fg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const E=this.c;this.c=void 0;const D=this.a;return this.a=[],this.f(D).finally(()=>E.complete())}}function w(v,E){return`${v.value}/${E}`}e.$ccc=w}),define(Pe[245],Ae([1,0,5,3,104]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class L{constructor(l,I){this.c=I,this.a=new Map,this.b=l.getProxy(R.$QJ.MainThreadNotebookRenderers)}$postRendererMessage(l,I,f){const P=this.c.getEditorById(l);this.a.get(I)?.fire({editor:P.apiEditor,message:f})}createRendererMessaging(l,I){if(!l.contributes?.notebookRenderer?.some(P=>P.id===I))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${I})`);return{onDidReceiveMessage:(P,S,u)=>this.d(I).event(P,S,u),postMessage:(P,S)=>{C.$Ybc.apiEditorsToExtHost.has(P)&&([P,S]=[S,P]);const u=S&&C.$Ybc.apiEditorsToExtHost.get(S);return this.b.$postMessage(u?.id,I,P)}}}d(l){let I=this.a.get(l);return I||(I=new y.$hc({onDidRemoveLastListener:()=>{I?.dispose(),this.a.delete(l)}}),this.a.set(l,I),I)}}e.$dcc=L}),define(Pe[246],Ae([1,0,6,16,2,26,3]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class l{constructor(f){this.b=new Map,this.a=f.getProxy(A.$QJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,P,S){if((0,L.$LF)(f,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,S),this.a.$registerProfileContentHandler(P,S.name,S.description,f.identifier.value),(0,y.$kb)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(f,P,S,u){const p=this.b.get(f);if(!p)throw new Error(`Unknown handler with id: ${f}`);return p.saveProfile(P,S,u)}async $readProfile(f,P,S){const u=this.b.get(f);if(!u)throw new Error(`Unknown handler with id: ${f}`);return u.readProfile((0,R.$le)(P)?P:C.URI.revive(P),S)}}e.$hcc=l}),define(Pe[247],Ae([1,0,2,3,13,8]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class A{static{this.a=0}constructor(I,f){this.d=f,this.c=new Map,this.b=I.getProxy(R.$QJ.MainThreadQuickDiff)}$provideOriginalResource(I,f,P){const S=y.URI.revive(f),u=this.c.get(I);return u?(0,C.$xg)(()=>u.provideOriginalResource(S,P)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(I,f,P,S){const u=A.a++;return this.c.set(u,f),this.b.$registerQuickDiffProvider(u,L.DocumentSelector.from(I,this.d),P,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$icc=A}),define(Pe[248],Ae([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;function $(d,t,i){const c=d.getProxy(L.$QJ.MainThreadQuickOpen);class m{constructor(E,D){this.e=new Map,this.f=0,this.a=E,this.b=D}showQuickPick(E,D,s,h=y.CancellationToken.None){this.c=void 0;const g=Promise.resolve(D),M=++this.f,W=c.$show(M,{title:s?.title,placeHolder:s?.placeHolder,matchOnDescription:s?.matchOnDescription,matchOnDetail:s?.matchOnDetail,ignoreFocusLost:s?.ignoreFocusOut,canPickMany:s?.canPickMany},h),V={},B=W.then(()=>V);return Promise.race([B,g]).then(j=>{if(j===V)return;const U=(0,u.$KF)(E,"quickPickItemTooltip");return g.then(z=>{const ie=[];for(let X=0;X<z.length;X++){const ye=z[X];if(typeof ye=="string")ie.push({label:ye,handle:X});else if(ye.kind===l.QuickPickItemKind.Separator)ie.push({type:"separator",label:ye.label});else{ye.tooltip&&!U&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const De=ye.iconPath?r(ye.iconPath):void 0;ie.push({label:ye.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:U?p.MarkdownString.fromStrict(ye.tooltip):void 0,handle:X})}}return s&&typeof s.onDidSelectItem=="function"&&(this.c=X=>{s.onDidSelectItem(z[X])}),c.$setItems(M,ie),W.then(X=>{if(typeof X=="number")return z[X];if(Array.isArray(X))return X.map(ye=>z[ye])})})}).then(void 0,j=>{if(!(0,I.$2)(j))return c.$setError(M,j),Promise.reject(j)})}$onItemSelected(E){this.c?.(E)}showInput(E,D=y.CancellationToken.None){return this.d=E?.validateInput,c.$input(E,typeof this.d=="function",D).then(void 0,s=>{if(!(0,I.$2)(s))return Promise.reject(s)})}async $validateInput(E){if(!this.d)return;const D=await this.d(E);if(!D||typeof D=="string")return D;let s;switch(D.severity){case l.InputBoxValidationSeverity.Info:s=P.default.Info;break;case l.InputBoxValidationSeverity.Warning:s=P.default.Warning;break;case l.InputBoxValidationSeverity.Error:s=P.default.Error;break;default:s=D.message?P.default.Error:P.default.Ignore;break}return{content:D.message,severity:s}}async showWorkspaceFolderPick(E,D=y.CancellationToken.None){const s=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!s)return;const h=await this.a.getWorkspaceFolders2();if(h)return h.find(g=>g.uri.toString()===s.uri.toString())}createQuickPick(E){const D=new o(E,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(E){const D=new w(E,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(E,D){this.e.get(E)?._fireDidChangeValue(D)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,D){const s=this.e.get(E);s instanceof o&&s._fireDidChangeActive(D)}$onDidChangeSelection(E,D){const s=this.e.get(E);s instanceof o&&s._fireDidChangeSelection(D)}$onDidTriggerButton(E,D){this.e.get(E)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(E,D,s){const h=this.e.get(E);h instanceof o&&h._fireDidTriggerItemButton(D,s)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class k{static{this.a=1}constructor(E,D){this.x=E,this.y=D,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$hc,this.q=new R.$hc,this.r=new R.$hc,this.s=new R.$hc,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){this.n=E.slice(),this.o.clear(),E.forEach((D,s)=>{const h=D===l.$bL.Back?-1:s;this.o.set(h,D)}),this.z({buttons:E.map((D,s)=>({...r(D.iconPath),tooltip:D.tooltip,handle:D===l.$bL.Back?-1:s}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const D=this.o.get(E);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$hb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(E){if(!this.v){for(const D of Object.keys(E)){const s=E[D];this.u[D]=s===void 0?null:s}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function b(v){if(v instanceof l.$NK)return{id:v.id};const E=a(v),D=n(v);return{dark:typeof E=="string"?A.URI.file(E):E,light:typeof D=="string"?A.URI.file(D):D}}function n(v){return typeof v=="object"&&"light"in v?v.light:v}function a(v){return typeof v=="object"&&"dark"in v?v.dark:v}function r(v){const E=b(v);let D,s;return"id"in E?s=S.ThemeIcon.asClassName(E):D=E,{iconPath:D,iconClass:s}}class o extends k{constructor(E,D){super(E.identifier,D),this.O=E,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$hc,this.L=[],this.M=new R.$hc,this.N=new R.$hc,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((h,g)=>{this.C.set(g,h),this.D.set(h,g)});const D=(0,u.$KF)(this.O,"quickPickItemTooltip"),s=[];for(let h=0;h<E.length;h++){const g=E[h];if(g.kind===l.QuickPickItemKind.Separator)s.push({type:"separator",label:g.label});else{g.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const M=g.iconPath?r(g.iconPath):void 0;s.push({handle:h,label:g.label,iconPath:M?.iconPath,iconClass:M?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:D?p.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((W,V)=>({...r(W.iconPath),tooltip:W.tooltip,handle:V}))})}}this.z({items:s})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(E){const D=(0,f.$Af)(E.map(s=>this.C.get(s)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(E){const D=(0,f.$Af)(E.map(s=>this.C.get(s)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(E,D){const s=this.C.get(E);if(!s||!s.buttons||!s.buttons.length)return;const h=s.buttons[D];h&&this.N.fire({button:h,item:s})}}class w extends k{constructor(E,D){super(E.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:P.default.Error}):this.z({validationMessage:E.message,severity:E.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new m(t,i)}e.$jbc=$}),define(Pe[249],Ae([1,0,2,5,64,6,13,3,18,132,14,20,40,8,26,12]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=e.$kbc=void 0;function i(D){if(D)return typeof D.iconPath=="string"?y.URI.file(D.iconPath):y.URI.isUri(D.iconPath)||u.ThemeIcon.isThemeIcon(D.iconPath)?D.iconPath:void 0}function c(D,s){if(!D.iconPath&&!s.iconPath)return 0;if(D.iconPath){if(!s.iconPath)return 1}else return-1;const h=typeof D.iconPath=="string"?D.iconPath:y.URI.isUri(D.iconPath)?D.iconPath.fsPath:D.iconPath.id,g=typeof s.iconPath=="string"?s.iconPath:y.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,f.$eq)(h,g)}function m(D,s){let h=0;if(D.strikeThrough!==s.strikeThrough)return D.strikeThrough?1:-1;if(D.faded!==s.faded)return D.faded?1:-1;if(D.tooltip!==s.tooltip)return(D.tooltip||"").localeCompare(s.tooltip||"");if(h=c(D,s),h!==0)return h;if(D.light&&s.light)h=c(D.light,s.light);else{if(D.light)return 1;if(s.light)return-1}if(h!==0)return h;if(D.dark&&s.dark)h=c(D.dark,s.dark);else{if(D.dark)return 1;if(s.dark)return-1}return h}function k(D,s){if(D.command!==s.command)return D.command<s.command?-1:1;if(D.title!==s.title)return D.title<s.title?-1:1;if(D.tooltip!==s.tooltip){if(D.tooltip!==void 0&&s.tooltip!==void 0)return D.tooltip<s.tooltip?-1:1;if(D.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(D.arguments===s.arguments)return 0;if(D.arguments)if(s.arguments){if(D.arguments.length!==s.arguments.length)return D.arguments.length-s.arguments.length}else return 1;else return-1;for(let h=0;h<D.arguments.length;h++){const g=D.arguments[h],M=s.arguments[h];if(g!==M)return g<M?-1:1}return 0}function b(D,s){let h=(0,f.$eq)(D.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(h!==0)return h;if(D.command&&s.command)h=k(D.command,s.command);else{if(D.command)return 1;if(s.command)return-1}if(h!==0)return h;if(D.decorations&&s.decorations)h=m(D.decorations,s.decorations);else{if(D.decorations)return 1;if(s.decorations)return-1}return h}function n(D,s){for(let h=0;h<D.length;h++)if(D[h]!==s[h])return!1;return!0}function a(D,s){return D.command===s.command&&D.title===s.title&&D.tooltip===s.tooltip&&(D.arguments&&s.arguments?n(D.arguments,s.arguments):D.arguments===s.arguments)}function r(D,s){return(0,I.$of)(D,s,a)}class o{#e;#t;get value(){return this.d}set value(s){s=s??"",this.#e.$setInputBoxValue(this.l,s),this.n(s)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(s){this.#e.$setInputBoxPlaceholder(this.l,s),this.f=s}get validateInput(){return(0,$.$LF)(this.k,"scmValidation"),this.g}set validateInput(s){if((0,$.$LF)(this.k,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=s,this.#e.$setValidationProviderIsEnabled(this.l,!!s)}get enabled(){return this.h}set enabled(s){s=!!s,this.h!==s&&(this.h=s,this.#e.$setInputBoxEnablement(this.l,s))}get visible(){return this.j}set visible(s){s=!!s,this.j!==s&&(this.j=s,this.#e.$setInputBoxVisibility(this.l,s))}get document(){return(0,$.$LF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(s,h,g,M,W){this.k=s,this.l=M,this.m=W,this.d="",this.e=new R.$hc,this.f="",this.h=!0,this.j=!0,this.#t=h,this.#e=g}showValidationMessage(s,h){(0,$.$LF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,s,h)}$onInputBoxValueChange(s){this.n(s)}n(s){this.d=s,this.e.fire(s)}}e.$kbc=o;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(s){this.v=s,this.q.$updateGroupLabel(this.t,this.handle,s)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(s){this.p=s,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(s){this.f=[...s],this.k.fire()}constructor(s,h,g,M,W){this.q=s,this.s=h,this.t=g,this.u=M,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$hc,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.$hc,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(s){return this.g.get(s)}$executeResourceCommand(s,h){const g=this.h.get(s);return g?(0,A.$xg)(()=>this.s.executeCommand(g.command,...g.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this.f].sort(b),g=(0,I.$wf)(this.o,s,b).map(V=>{const B=V.toInsert.map(j=>{const U=this.e++;this.g.set(U,j);const z=j.resourceUri;let ie;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const ue=new L.$lb;ie=this.s.converter.toInternal(j.command,ue),this.j.set(U,ue)}else this.h.set(U,j.command);const X=i(j.decorations),ye=j.decorations&&i(j.decorations.light)||X,De=j.decorations&&i(j.decorations.dark)||X,Re=[ye,De],Y=j.decorations&&j.decorations.tooltip||"",le=j.decorations&&!!j.decorations.strikeThrough,we=j.decorations&&!!j.decorations.faded,ae=j.contextValue||"";return{rawResource:[U,z,Re,Y,le,we,ae,ie],handle:U}});return{start:V.start,deleteCount:V.deleteCount,toInsert:B}}),M=g.map(({start:V,deleteCount:B,toInsert:j})=>[V,B,j.map(U=>U.rawResource)]),W=g.reverse();for(const{start:V,deleteCount:B,toInsert:j}of W){const U=j.map(ie=>ie.handle),z=this.n.splice(V,B,...U);for(const ie of z)this.g.delete(ie),this.h.delete(ie),this.j.get(ie)?.dispose(),this.j.delete(ie)}return this.o=s,M}dispose(){this.l=!0,this.m.fire()}}class v{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(s){this.g!==s&&(this.g=s,this.#e.$updateSourceControl(this.t,{count:s}))}get quickDiffProvider(){return this.h}set quickDiffProvider(s){this.h=s;let h;(0,$.$KF)(this.u,"quickDiffProvider")&&(h=s?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!s,quickDiffLabel:h})}get commitTemplate(){return this.j}set commitTemplate(s){s!==this.j&&(this.j=s,this.#e.$updateSourceControl(this.t,{commitTemplate:s}))}get acceptInputCommand(){return this.l}set acceptInputCommand(s){this.k.value=new L.$lb,this.l=s;const h=this.v.converter.toInternal(s,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:h})}get actionButton(){return(0,$.$LF)(this.u,"scmActionButton"),this.n}set actionButton(s){(0,$.$LF)(this.u,"scmActionButton"),this.m.value=new L.$lb,this.n=s;const h=s!==void 0?{command:this.v.converter.toInternal(s.command,this.m.value),secondaryCommands:s.secondaryCommands?.map(g=>g.map(M=>this.v.converter.toInternal(M,this.m.value))),description:s.description,enabled:s.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:h??null})}get statusBarCommands(){return this.p}set statusBarCommands(s){if(this.p&&s&&r(this.p,s))return;this.o.value=new L.$lb,this.p=s;const h=(s||[]).map(g=>this.v.converter.toInternal(g,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:h})}get selected(){return this.q}constructor(s,h,g,M,W,V,B){this.u=s,this.v=M,this.w=W,this.x=V,this.y=B,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$nb,this.l=void 0,this.m=new L.$nb,this.o=new L.$nb,this.p=void 0,this.q=!1,this.s=new R.$hc,this.onDidChangeSelection=this.s.event,this.t=v.d++,this.z=new Map,this.A=new Set,this.#e=g;const j=y.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${W}/scm${this.t}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new o(s,h,this.#e,this.t,j),this.#e.$registerSourceControl(this.t,W,V,B,j)}createResourceGroup(s,h){const g=new w(this.#e,this.v,this.t,s,h),M=R.Event.once(g.onDidDispose)(()=>this.z.delete(g));return this.z.set(g,M),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const s=[],h=[];for(const[g,M]of this.z){M.dispose();const W=g.onDidUpdateResourceStates(()=>{this.A.add(g),this.eventuallyUpdateResourceStates()});R.Event.once(g.onDidDispose)(()=>{this.A.delete(g),W.dispose(),this.e.delete(g.handle),this.#e.$unregisterGroup(this.t,g.handle)}),s.push([g.handle,g.id,g.label,g.features]);const V=g._takeResourceStateSnapshot();V.length>0&&h.push([g.handle,V]),this.e.set(g.handle,g)}this.#e.$registerGroups(this.t,s,h),this.z.clear()}eventuallyUpdateResourceStates(){const s=[];this.A.forEach(h=>{const g=h._takeResourceStateSnapshot();g.length!==0&&s.push([h.handle,g])}),s.length>0&&this.#e.$spliceResourceStates(this.t,s),this.A.clear()}getResourceGroup(s){return this.e.get(s)}setSelectionState(s){this.q=s,this.s.fire(s)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(s=>s.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,C.$5g)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$5g)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(s,h,g,M){this.l=h,this.m=g,this.n=M,this.g=new Map,this.h=new S.$Vl,this.j=new R.$hc,this.e=s.getProxy(l.$QJ.MainThreadSCM),this.f=s.getProxy(l.$QJ.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const V=this.g.get(W.sourceControlHandle);if(!V)return W;const B=V.getResourceGroup(W.groupHandle);return B?B.getResourceState(W.handle):W}else if(W&&W.$mid===4){const V=this.g.get(W.sourceControlHandle);return V?V.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const V=this.g.get(W.handle);return V||W}return W}})}createSourceControl(s,h,g,M){this.n.trace("ExtHostSCM#createSourceControl",s.identifier.value,h,g,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const W=t.d++,V=new v(s,this.m,this.e,this.l,h,g,M);this.g.set(W,V);const B=this.h.get(s.identifier)||[];return B.push(V),this.h.set(s.identifier,B),V}getLastInputBox(s){this.n.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const h=this.h.get(s.identifier),g=h&&h[h.length-1];return g&&g.inputBox}$provideOriginalResource(s,h,g){const M=y.URI.revive(h);this.n.trace("ExtHostSCM#$provideOriginalResource",s,M.toString());const W=this.g.get(s);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xg)(()=>W.quickDiffProvider.provideOriginalResource(M,g)).then(V=>V||null)}$onInputBoxValueChange(s,h){this.n.trace("ExtHostSCM#$onInputBoxValueChange",s);const g=this.g.get(s);return g&&g.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(s,h,g,M){this.n.trace("ExtHostSCM#$executeResourceCommand",s,h,g);const W=this.g.get(s);if(!W)return Promise.resolve(void 0);const V=W.getResourceGroup(h);return V?V.$executeResourceCommand(g,M):Promise.resolve(void 0)}$validateInput(s,h,g){this.n.trace("ExtHostSCM#$validateInput",s);const M=this.g.get(s);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xg)(()=>M.inputBox.validateInput(h,g)).then(W=>{if(!W)return Promise.resolve(void 0);const V=p.MarkdownString.fromStrict(W.message);return V?Promise.resolve([V,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this.g.get(s)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=s,Promise.resolve(void 0)}};e.$lbc=E,e.$lbc=E=t=Ke([Ve(3,P.$3i)],E)}),define(Pe[83],Ae([1,0,3,5,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=e.$3ac=void 0;class L{constructor(l){this.b=new R.$hc,this.onDidChangePassword=this.b.event,this.a=l.getProxy(y.$QJ.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,I){return this.a.$getPassword(l,I)}store(l,I,f){return this.a.$setPassword(l,I,f)}delete(l,I){return this.a.$deletePassword(l,I)}}e.$3ac=L,e.$4ac=(0,C.$zh)("IExtHostSecretState")}),define(Pe[250],Ae([1,0,3,8,2]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class L{static{this.a=0}constructor(l,I){this.d=I,this.c=new Map,this.b=l.getProxy(y.$QJ.MainThreadShare)}async $provideShare(l,I,f){return await this.c.get(l)?.provideShare({selection:R.Range.to(I.selection),resourceUri:C.URI.revive(I.resourceUri)},f)??void 0}registerShareProvider(l,I){const f=L.a++;return this.c.set(f,I),this.b.$registerShareProvider(f,R.DocumentSelector.from(l,this.d),I.id,I.label,I.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$ncc=L}),define(Pe[251],Ae([1,0,7,3,154,6,8,16]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=e.$mbc=void 0;class I{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$OK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$OK("statusBarItem.warningForeground")]])}#e;#t;constructor(u,p,$,d,t,i=y.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new L.$lb,this.#e=u,this.#t=p,t&&d){this.c=(0,y.$rK)(d.identifier,t);const m=$.get(this.c);m&&(i=m.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,c=m.priority,this.j=!0,this.name=m.name,this.text=m.text,this.tooltip=m.tooltip,this.command=m.command,this.accessibilityInformation=m.accessibilityInformation)}else this.c=String(I.a++);this.e=d,this.f=t,this.g=i,this.h=this.u(c)}u(u){if((0,l.$pe)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!I.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new L.$lb,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=I.b.get(this.o.id));const d=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,p,this.k,d,this.r?.internal,$,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$mbc=I;class f{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const p={message:u};return this.b.unshift(p),this.c(),new y.$SJ(()=>{const $=this.b.indexOf(p);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,p){this.e=new Map,this.a=u.getProxy(R.$QJ.MainThreadStatusBar),this.b=p,this.c=new f(this)}$acceptStaticEntries(u){for(const p of u)this.e.set(p.entryId,p)}createStatusBarEntry(u,p,$,d){return new I(this.a,this.b,this.e,u,p,$,d)}setStatusBarMessage(u,p){const $=this.c.setMessage(u);let d;return typeof p=="number"?d=setTimeout(()=>$.dispose(),p):typeof p<"u"&&p.then(()=>$.dispose(),()=>$.dispose()),new y.$SJ(()=>{$.dispose(),clearTimeout(d)})}}e.$nbc=P}),define(Pe[84],Ae([1,0,3,5,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=e.$Qac=void 0;class L{constructor(l,I){this.c=I,this.b=new R.$hc,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(y.$QJ.MainThreadStorage)}registerExtensionStorageKeysToSync(l,I){this.a.$registerExtensionStorageKeysToSync(l,I)}async initializeExtensionStorage(l,I,f){const P=await this.a.$initializeExtensionStorage(l,I);let S;return P&&(S=this.d(l,I,P)),S||f}setValue(l,I,f){return this.a.$setValue(l,I,f)}$acceptValue(l,I,f){const P=this.d(l,I,f);P&&this.b.fire({shared:l,key:I,value:P})}d(l,I,f){try{return JSON.parse(f)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${I}, global: ${l}): ${P}`)}}}e.$Qac=L,e.$Rac=(0,C.$zh)("IExtHostStorage")}),define(Pe[85],Ae([1,0,4,27,14,61,2]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=e.$Wac=void 0,e.$Wac=(0,y.$zh)("IExtensionStoragePaths");let l=class{constructor(f,P,S){this.d=P,this.f=S,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,P=await this.g(f);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Xac=l,e.$Xac=l=Ke([Ve(0,R.$9L),Ve(1,C.$3i),Ve(2,L.$Vac)],l)}),define(Pe[62],Ae([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,13,8,31]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=e.$1ac=e.$Zac=e.$Yac=void 0,e.$Yac=(0,C.$zh)("IExtHostTerminalService");class m{constructor(s,h,g,M){this.k=s,this._id=h,this.l=g,this.m=M,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const W=this;this.value={get name(){return W.m||""},get processId(){return W.b},get creationOptions(){return W.l},get exitStatus(){return W.h},get state(){return W.i},get selection(){return W.j},sendText(V,B=!0){W.o(),W.k.$sendText(W._id,V,B)},show(V){W.o(),W.k.$show(W._id,V)},hide(){W.o(),W.k.$hide(W._id)},dispose(){W.a||(W.a=!0,W.k.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(s,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:s.name,shellPath:s.shellPath??void 0,shellArgs:s.shellArgs??void 0,cwd:s.cwd??void 0,env:s.env??void 0,icon:w(s.iconPath)??void 0,color:d.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:s.message??void 0,strictEnv:s.strictEnv??void 0,hideFromUser:s.hideFromUser??void 0,isFeatureTerminal:h?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:h?.useShellEnvironment??void 0,location:h?.location||this.n(s.location,h?.resolvedExtHostIdentifier),isTransient:s.isTransient??void 0})}async createExtensionTerminal(s,h,g,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:d.ThemeColor.isThemeColor(M)?M.id:void 0,location:this.n(s,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(s,h){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in s?{viewColumn:i.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(s){this.m=s}setExitStatus(s,h){this.h=Object.freeze({code:s,reason:h})}setDimensions(s,h){return s===this.d&&h===this.g||s===0||h===0?!1:(this.d=s,this.g=h,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(s){this.j=s}_setProcessId(s){this.f?(this.f(s),this.f=void 0):this.b.then(h=>{h!==s&&(this.b=Promise.resolve(s))})}}e.$Zac=m;class k{get onProcessReady(){return this.b.event}constructor(s){this.g=s,this.id=0,this.shouldPersist=!1,this.a=new y.$hc,this.onProcessData=this.a.event,this.b=new y.$hc,this.d=new y.$hc,this.onDidChangeProperty=this.d.event,this.f=new y.$hc,this.onProcessExit=this.f.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${h}`)}async start(){}shutdown(){this.g.close()}input(s){this.g.handleInput?.(s)}resize(s,h){this.g.setDimensions?.({columns:s,rows:h})}clearBuffer(){}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(s){this.g.onDidWrite(h=>this.a.fire(h)),this.g.onDidClose?.((h=void 0)=>{this.f.fire(h===void 0?void 0:h)}),this.g.onDidOverrideDimensions?.(h=>{h&&this.d.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this.g.onDidChangeName?.(h=>{this.d.fire({type:"title",value:h})}),this.g.open(s||void 0),s&&this.g.setDimensions?.(s),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let b=1,n=class extends l.$mb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(s=>s.value)}constructor(s,h,g){super(),this.M=h,this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.n=this.B(new l.$nb),this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new y.$hc,this.onDidCloseTerminal=this.C.event,this.D=new y.$hc,this.onDidOpenTerminal=this.D.event,this.F=new y.$hc,this.onDidChangeActiveTerminal=this.F.event,this.G=new y.$hc,this.onDidChangeTerminalDimensions=this.G.event,this.H=new y.$hc,this.onDidChangeTerminalState=this.H.event,this.I=new y.$hc,this.onDidChangeShell=this.I.event,this.J=new y.$hc({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.J.event,this.L=new y.$hc({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.L.event,this.a=g.getProxy(R.$QJ.MainThreadTerminalService),this.s=new $.$qkb(this.a.$sendProcessData),this.a.$registerProcessSupport(s),this.B({dispose:()=>{for(const[M,W]of this.g)W.shutdown(!0)}})}getDefaultShell(s){return(s?this.m:this.l)?.path||""}getDefaultShellArgs(s){return(s?this.m:this.l)?.args||[]}createExtensionTerminal(s,h){const g=new m(this.a,(0,p.$6e)(),s,s.name),M=new k(s.pty);return g.createExtensionTerminal(s.location,this.N(s,h).resolvedExtHostIdentifier,w(s.iconPath),v(s.color)).then(W=>{const V=this.O(W,M);this.h[W]=V}),this.f.push(g),g.value}N(s,h){if(h=h||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const g=s.location.parentTerminal;if(g){const M=this.f.find(W=>W.value===g);M&&(h.resolvedExtHostIdentifier=M._id)}}else s.location&&typeof s.location!="object"?h.location=s.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(s,h){if(!this.Q(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const M=new k(h),W=this.O(s,M);this.h[s]=W}async $acceptActiveTerminalChanged(s){const h=this.b;if(s===null){this.b=void 0,h!==this.b&&this.F.fire(this.b);return}const g=this.Q(s);g&&(this.b=g,h!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(s,h){const g=this.Q(s);g&&this.J.fire({terminal:g.value,data:h})}async $acceptTerminalDimensions(s,h,g){const M=this.Q(s);M&&M.setDimensions(h,g)&&this.G.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptDidExecuteCommand(s,h){const g=this.Q(s);g&&this.L.fire({terminal:g.value,...h})}async $acceptTerminalMaximumDimensions(s,h,g){this.g.get(s)?.resize(h,g)}async $acceptTerminalTitleChange(s,h){const g=this.Q(s);g&&(g.name=h)}async $acceptTerminalClosed(s,h,g){const M=this.S(this.f,s);if(M!==null){const W=this.f.splice(M,1)[0];W.setExitStatus(h,g),this.C.fire(W.value)}}$acceptTerminalOpened(s,h,g,M){if(h){const B=this.S(this.f,h);if(B!==null){this.f[B]._id=s,this.D.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const W={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:L.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},V=new m(this.a,s,W,g);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(s,h){this.Q(s)?._setProcessId(h)}async $startExtensionTerminal(s,h){const g=this.Q(s);if(!g)return{message:(0,f.localize)(0,null,s)};g.isOpen||await new Promise(W=>{const V=this.onDidOpenTerminal(async B=>{B===g.value&&(V.dispose(),W())})});const M=this.g.get(s);M?M.startSendingEvents(h):this.i[s]={initialDimensions:h}}O(s,h){const g=new l.$lb;g.add(h.onProcessReady(W=>this.a.$sendProcessReady(s,W.pid,W.cwd,W.windowsPty))),g.add(h.onDidChangeProperty(W=>this.a.$sendProcessProperty(s,W))),this.s.startBuffering(s,h.onProcessData),g.add(h.onProcessExit(W=>this.P(s,W))),this.g.set(s,h);const M=this.i[s];return M&&h instanceof k&&(h.startSendingEvents(M.initialDimensions),delete this.i[s]),g}$acceptProcessAckDataEvent(s,h){this.g.get(s)?.acknowledgeDataEvent(h)}$acceptProcessInput(s,h){this.g.get(s)?.input(h)}$acceptTerminalInteraction(s){const h=this.Q(s);h?.setInteractedWith()&&this.H.fire(h.value)}$acceptTerminalSelection(s,h){this.Q(s)?.setSelection(h)}$acceptProcessResize(s,h,g){try{this.g.get(s)?.resize(h,g)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(s,h){this.g.get(s)?.shutdown(h)}$acceptProcessRequestInitialCwd(s){this.g.get(s)?.getInitialCwd().then(h=>this.a.$sendProcessProperty(s,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(s){this.g.get(s)?.getCwd().then(h=>this.a.$sendProcessProperty(s,{type:"cwd",value:h}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this.u.add(s),this.u.size===1&&this.a.$startLinkProvider(),new I.$SJ(()=>{this.u.delete(s),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(s,h,g){if(this.v.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this.v.set(h,g),this.a.$registerProfileProvider(h,s.identifier.value),new I.$SJ(()=>{this.v.delete(h),this.a.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(s,h,g){if(this.w.has(s))throw new Error(`Terminal quick fix provider "${s}" is already registered`);return this.w.set(s,g),this.a.$registerQuickFixProvider(s,h),new I.$SJ(()=>{this.w.delete(s),this.a.$unregisterQuickFixProvider(s)})}async $provideTerminalQuickFixes(s,h){const g=new u.$rc().token;if(g.isCancellationRequested)return;const M=this.w.get(s);if(!M)return;const W=await M.provideTerminalQuickFixes(h,g);if(W===null||Array.isArray(W)&&W.length===0)return;const V=new l.$lb;if(this.n.value=V,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.M.converter,V):void 0;const B=[];for(const j of W){const U=i.TerminalQuickFix.from(j,this.M.converter,V);U&&B.push(U)}return B}async $createContributedProfileTerminal(s,h){const g=new u.$rc().token;let M=await this.v.get(s)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,h);return}this.createTerminalFromOptions(M.options,h)}}async $provideLinks(s,h){const g=this.Q(s);if(!g)return[];this.y.delete(s),this.z.get(s)?.dispose(!0);const W=new u.$rc;this.z.set(s,W);const V=[],B={terminal:g.value,line:h},j=[];for(const ie of this.u)j.push(t.Promises.withAsyncBody(async X=>{W.token.onCancellationRequested(()=>X({provider:ie,links:[]}));const ye=await ie.provideTerminalLinks(B,W.token)||[];W.token.isCancellationRequested||X({provider:ie,links:ye})}));const U=await Promise.all(j);if(W.token.isCancellationRequested)return[];const z=new Map;for(const ie of U)ie&&ie.links.length>0&&V.push(...ie.links.map(X=>{const ye={id:b++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return z.set(ye.id,{provider:ie.provider,link:X}),ye}));return this.y.set(s,z),V}$activateLink(s,h){const g=this.y.get(s)?.get(h);g&&g.provider.handleTerminalLink(g.link)}P(s,h){this.s.stopBuffering(s),this.g.delete(s),delete this.i[s];const g=this.h[s];g&&(g.dispose(),delete this.h[s]),this.a.$sendProcessExit(s,h)}Q(s){return this.R(this.f,s)}R(s,h){const g=this.S(s,h);return g!==null?s[g]:null}S(s,h){const g=s.findIndex(M=>M._id===h);return g===-1?null:g}getEnvironmentVariableCollection(s){let h=this.k.get(s.identifier.value);return h||(h=new a,this.W(s.identifier.value,h)),h.getScopedEnvironmentVariableCollection(void 0)}U(s,h){const g=(0,S.$0q)(h.map),M=(0,S.$$q)(h.descriptionMap);this.a.$setEnvironmentVariableCollection(s,h.persistent,g.length===0?void 0:g,M)}$initEnvironmentVariableCollections(s){s.forEach(h=>{const g=h[0],M=new a(h[1]);this.W(g,M)})}$acceptDefaultProfile(s,h){const g=this.l;this.l=s,this.m=h,g?.path!==s.path&&this.I.fire(s.path)}W(s,h){this.k.set(s,h),h.onDidChangeCollection(()=>{this.U(s,h)})}};e.$1ac=n,e.$1ac=n=Ke([Ve(1,c.$cM),Ve(2,A.$SL)],n);class a{get persistent(){return this.b}set persistent(s){this.b=s,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(s){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$hc,this.map=new Map(s)}getScopedEnvironmentVariableCollection(s){const h=this.h(s);let g=this.a.get(h);return g||(g=new r(this,s),this.a.set(h,g),g.onDidChangeCollection(()=>this.d.fire())),g}replace(s,h,g,M){this.f(s,{value:h,type:I.EnvironmentVariableMutatorType.Replace,options:g??{applyAtProcessCreation:!0},scope:M})}append(s,h,g,M){this.f(s,{value:h,type:I.EnvironmentVariableMutatorType.Append,options:g??{applyAtProcessCreation:!0},scope:M})}prepend(s,h,g,M){this.f(s,{value:h,type:I.EnvironmentVariableMutatorType.Prepend,options:g??{applyAtProcessCreation:!0},scope:M})}f(s,h){if(h.options&&h.options.applyAtProcessCreation===!1&&!h.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const g=this.g(s,h.scope),M=this.map.get(g),W=h.options?{applyAtProcessCreation:h.options.applyAtProcessCreation??!1,applyAtShellIntegration:h.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!M||M.value!==h.value||M.type!==h.type||M.options?.applyAtProcessCreation!==W.applyAtProcessCreation||M.options?.applyAtShellIntegration!==W.applyAtShellIntegration||M.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index){const V=this.g(s,h.scope),B={variable:s,...h,options:W};this.map.set(V,B),this.d.fire()}}get(s,h){const g=this.g(s,h),M=this.map.get(g);return M?E(M):void 0}g(s,h){const g=this.h(h);return g.length?`${s}:::${g}`:s}h(s){return this.i(s?.workspaceFolder)??""}i(s){return s?s.uri.toString():void 0}getVariableMap(s){const h=new Map;for(const[g,M]of this.map)this.h(M.scope)===this.h(s)&&h.set(M.variable,E(M));return h}delete(s,h){const g=this.g(s,h);this.map.delete(g),this.d.fire()}clear(s){if(s?.workspaceFolder){for(const[h,g]of this.map)g.scope?.workspaceFolder?.index===s.workspaceFolder.index&&this.map.delete(h);this.j(s)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(s,h){const g=this.h(h),M=this.descriptionMap.get(g);if(!M||M.description!==s){let W;typeof s=="string"?W=s:W=s?.value.split(`

`)[0];const V={description:W,scope:h};this.descriptionMap.set(g,V),this.d.fire()}}getDescription(s){const h=this.h(s);return this.descriptionMap.get(h)?.description}j(s){const h=this.h(s);this.descriptionMap.delete(h)}}class r{get persistent(){return this.b.persistent}set persistent(s){this.b.persistent=s}get onDidChangeCollection(){return this.a&&this.a.event}constructor(s,h){this.b=s,this.d=h,this.a=new y.$hc}getScoped(s){return this.b.getScopedEnvironmentVariableCollection(s)}replace(s,h,g){this.b.replace(s,h,g,this.d)}append(s,h,g){this.b.append(s,h,g,this.d)}prepend(s,h,g){this.b.prepend(s,h,g,this.d)}get(s){return this.b.get(s,this.d)}forEach(s,h){this.b.getVariableMap(this.d).forEach((g,M)=>s.call(h,M,g,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(s){this.b.delete(s,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(s){this.b.setDescription(s,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(s,h){super(!1,s,h)}createTerminal(s,h,g){throw new P.$0}createTerminalFromOptions(s,h){throw new P.$0}};e.$2ac=o,e.$2ac=o=Ke([Ve(0,c.$cM),Ve(1,A.$SL)],o);function w(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function v(D){return d.ThemeColor.isThemeColor(D)?D:void 0}function E(D){const s={...D};return delete s.scope,s.options=s.options??void 0,delete s.variable,s}}),define(Pe[252],Ae([1,0,281,13,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,56,26]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=e.$0bc=e.$9bc=void 0;let n=class{constructor(B,j,U){this.k=U,this.d=new A.$hc,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=B.getProxy(p.$QJ.MainThreadTesting),this.j=new g(this.g),this.h=new w(this.g),j.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 15:{const ie=z,X=ie.tests[ie.tests.length-1].item.extId;return this.f.get(c.$DI.root(X))?.collection.tree.get(X)?.actual??(0,d.$5L)(z)}case 17:{const{extId:ie,message:X}=z;return{test:this.f.get(c.$DI.root(ie))?.collection.tree.get(ie)?.actual,message:t.TestMessage.to(X)}}default:return z}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await j.executeCommand("_testing.getExplorerSelection"),ie=X=>{const ye=this.f.get(c.$DI.root(X));if(ye)return c.$DI.isRoot(X)?ye.controller:ye.collection.tree.get(X)?.actual};return{include:z?.include.map(ie).filter(S.$te)||[],exclude:z?.exclude.map(ie).filter(S.$te)||[]}})}createTestController(B,j,U,z){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const ie=new f.$lb,X=ie.add(new d.$8L(j,U,this.k));X.root.label=U;const ye=new Map,De=this.g,Re={items:X.root.children,get label(){return U},set label(le){U=le,X.root.label=le,De.$updateController(j,{label:U})},get refreshHandler(){return z},set refreshHandler(le){z=le,De.$updateController(j,{canRefresh:!!le})},get id(){return j},createRunProfile:(le,we,ae,x,ue,O)=>{let J=(0,I.$ni)(le);for(;ye.has(J);)J++;return new M(this.g,ye,j,J,le,we,ae,x,ue,O)},createTestItem(le,we,ae){return new d.$6L(j,le,we,ae)},createTestRun:(le,we,ae=!0)=>this.h.createTestRun(B,j,X,le,we,ae),invalidateTestResults:le=>{if(le===void 0)this.g.$markTestRetired(void 0);else{const we=le instanceof Array?le:[le];this.g.$markTestRetired(we.map(ae=>c.$DI.fromExtHostTestItem(ae,j).toString()))}},set resolveHandler(le){X.resolveHandler=le},get resolveHandler(){return X.resolveHandler},dispose:()=>{ie.dispose()}};De.$registerTestController(j,U,!!z),ie.add((0,f.$kb)(()=>De.$unregisterTestController(j)));const Y={controller:Re,collection:X,profiles:ye,extension:B};return this.f.set(j,Y),ie.add((0,f.$kb)(()=>this.f.delete(j))),ie.add(X.onDidGenerateDiff(le=>De.$publishDiff(j,le.map(k.TestsDiffOp.serialize)))),Re}createTestObserver(){return this.j.checkout()}async runTests(B,j=L.CancellationToken.None){const U=v(B);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.f.get(U.controllerId);if(!z)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(ie=>c.$DI.fromExtHostTestItem(ie,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:W[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:B.exclude?.map(ie=>ie.id)},j)}$syncTests(){for(const{collection:B}of this.f.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,j,U){return(0,y.$lf)(this.h.trackers,ie=>ie.id===B?ie.getCoverage(j):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(B,j,U,z){return(0,y.$lf)(this.h.trackers,X=>X.id===B?X.getCoverage(j):void 0)?.resolveFileCoverage(U,z)??Promise.resolve([])}$configureRunProfile(B,j){this.f.get(B)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(B,j){await this.f.get(B)?.controller.refreshHandler?.(j)}$publishTestResults(B){this.results=Object.freeze(B.map(j=>(0,P.$Um)(t.TestResults.to(j))).concat(this.results).sort((j,U)=>U.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(B,j){const U=this.f.get(c.$DI.fromString(B).controllerId)?.collection;U&&(await U.expand(B,j<0?1/0:j),U.flushDiff())}$acceptDiff(B){this.j.applyDiff(B.map(k.TestsDiffOp.deserialize))}async $runControllerTests(B,j){return Promise.all(B.map(U=>this.l(U,!1,j)))}async $startContinuousRun(B,j){const U=new L.$rc(j),z=await Promise.all(B.map(ie=>this.l(ie,!0,U.token)));return!j.isCancellationRequested&&!z.some(ie=>ie.error)&&await new Promise(ie=>j.onCancellationRequested(ie)),U.dispose(!0),z}async l(B,j,U){const z=this.f.get(B.controllerId);if(!z)return{};const{collection:ie,profiles:X,extension:ye}=z,De=X.get(B.profileId);if(!De)return{};const Re=B.testIds.map(ae=>ie.tree.get(ae)).filter(S.$te),Y=B.excludeExtIds.map(ae=>z.collection.tree.get(ae)).filter(S.$te).filter(ae=>Re.some(x=>x.fullId.compare(ae.fullId)===2));if(!Re.length)return{};const le=new i.$pL(Re.some(ae=>ae.actual instanceof d.$7L)?void 0:Re.map(ae=>ae.actual),Y.map(ae=>ae.actual),De,j),we=(0,k.$FI)(B)&&this.h.prepareForMainThreadTestRun(le,E.fromInternal(B,z.collection),ye,U);try{return await De.runHandler(le,U),{}}catch(ae){return{error:String(ae)}}finally{we&&(we.hasRunningTasks&&!U.isCancellationRequested&&await A.Event.toPromise(we.onEnd),we.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.h.cancelAllRuns():this.h.cancelRunById(B)}};e.$9bc=n,e.$9bc=n=Ke([Ve(0,$.$SL)],n);const a=1e4;var r;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(r||(r={}));class o extends f.$mb{get hasRunningTasks(){return this.g.size>0}get id(){return this.l.id}constructor(B,j,U,z){super(),this.l=B,this.m=j,this.p=U,this.f=0,this.g=new Map,this.h=new Set,this.k=this.B(new A.$hc),this.onEnd=this.k.event,this.j=this.B(new L.$rc(z));const ie=this.B(new R.$Qg(()=>this.s(),a));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.s()}getCoverage(B){return this.g.get(B)?.coverage}createRun(B){const j=this.l.id,U=this.l.controllerId,z=(0,u.$6e)(),ie=new D(this.m,j,z),X=Y=>(le,...we)=>{if(De){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.l.isIncluded(le)&&(this.v(le),Y(le,...we))},ye=(Y,le)=>{const we=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(we.some(ae=>ae.contextValue!==void 0)&&(0,b.$LF)(this.p,"testMessageContextValue"),Y.uri&&Y.range){const ae={range:t.Range.from(Y.range),uri:Y.uri};for(const x of we)x.location=x.location||ae}this.m.$appendTestMessagesInRun(j,z,c.$DI.fromExtHostTestItem(Y,U).toString(),we)};let De=!1;const Re={isPersisted:this.l.isPersisted,token:this.j.token,name:B,get coverageProvider(){return ie.coverageProvider},set coverageProvider(Y){ie.coverageProvider=Y},enqueued:X(Y=>{this.m.$updateTestStateInRun(j,z,c.$DI.fromExtHostTestItem(Y,U).toString(),1)}),skipped:X(Y=>{this.m.$updateTestStateInRun(j,z,c.$DI.fromExtHostTestItem(Y,U).toString(),5)}),started:X(Y=>{this.m.$updateTestStateInRun(j,z,c.$DI.fromExtHostTestItem(Y,U).toString(),2)}),errored:X((Y,le,we)=>{ye(Y,le),this.m.$updateTestStateInRun(j,z,c.$DI.fromExtHostTestItem(Y,U).toString(),6,we)}),failed:X((Y,le,we)=>{ye(Y,le),this.m.$updateTestStateInRun(j,z,c.$DI.fromExtHostTestItem(Y,U).toString(),4,we)}),passed:X((Y,le)=>{this.m.$updateTestStateInRun(j,z,c.$DI.fromExtHostTestItem(Y,this.l.controllerId).toString(),3,le)}),appendOutput:(Y,le,we)=>{De||(we&&(this.l.isIncluded(we)?this.v(we):we=void 0),this.m.$appendOutputToRun(j,z,C.$Hc.fromString(Y),le&&t.location.from(le),we&&c.$DI.fromExtHostTestItem(we,U).toString()))},end:()=>{De||(De=!0,this.m.$finishedTestRunTask(j,z),this.g.delete(z),this.g.size||this.u())}};return this.g.set(z,{run:Re,coverage:ie}),this.m.$startedTestRunTask(j,{id:z,name:B,running:!0}),Re}s(){for(const{run:B}of this.g.values())B.end()}u(){this.f!==2&&(this.f=2,this.k.fire())}v(B){if(!(B instanceof d.$6L))throw new m.$KL(B.id);if(this.h.has(c.$DI.fromExtHostTestItem(B,this.l.controllerId).toString()))return;const j=[],U=this.l.colllection.root;for(;;){const z=t.TestItem.from(B);if(j.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),B===U))break;B=B.parent||U}this.m.$addTestsToRun(this.l.controllerId,this.l.id,j)}dispose(){this.u(),super.dispose()}}class w{get trackers(){return this.d.values()}constructor(B){this.f=B,this.d=new Map}prepareForMainThreadTestRun(B,j,U,z){return this.g(B,j,U,z)}cancelRunById(B){for(const j of this.d.values())if(j.id===B){j.cancel();return}}cancelAllRuns(){for(const B of this.d.values())B.cancel()}createTestRun(B,j,U,z,ie,X){const ye=this.d.get(z);if(ye)return ye.createRun(ie);const De=E.fromPublic(j,U,z,X),Re=v(z);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!z.continuous,profile:Re&&{group:W[Re.kind],id:Re.profileId},exclude:z.exclude?.map(le=>c.$DI.fromExtHostTestItem(le,U.root.id).toString())??[],id:De.id,include:z.include?.map(le=>c.$DI.fromExtHostTestItem(le,U.root.id).toString())??[U.root.id],persist:X});const Y=this.g(z,De,B);return A.Event.once(Y.onEnd)(()=>{this.f.$finishedExtensionTestRun(De.id),Y.dispose()}),Y.createRun(ie)}g(B,j,U,z){const ie=new o(j,this.f,U,z);return this.d.set(B,ie),A.Event.once(ie.onEnd)(()=>this.d.delete(B)),ie}}e.$0bc=w;const v=V=>{if(V.profile){if(!(V.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class E{static fromPublic(B,j,U,z){return new E(B,(0,u.$6e)(),U.include?.map(ie=>c.$DI.fromExtHostTestItem(ie,B).toString())??[B],U.exclude?.map(ie=>c.$DI.fromExtHostTestItem(ie,B).toString())??[],z,j)}static fromInternal(B,j){return new E(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,j)}constructor(B,j,U,z,ie,X){this.controllerId=B,this.id=j,this.isPersisted=ie,this.colllection=X,this.d=U.map(ye=>ye+"\0"),this.f=z.map(ye=>ye+"\0")}isIncluded(B){const j=c.$DI.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const U of this.f)if(j===U||j.startsWith(U))return!1;for(const U of this.d)if(j===U||j.startsWith(U))return!0;return!1}}e.$$bc=E;class D{set coverageProvider(B){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");B&&(this.d=B,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(B,j,U){this.g=B,this.h=j,this.j=U}async provideFileCoverage(B){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(B))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(B,j){const U=await this.f;let z=U?.[B];return!this.d||!U||!z?[]:(z.detailedCoverage||(z=U[B]=await this.d.resolveFileCoverage?.(z,j)??z),z.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class s{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(B){this.j=B,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(B){this.d.add(B)}update(B){Object.assign(B.revived,t.TestItem.toPlain(B.item)),this.d.has(B)||this.f.add(B)}remove(B){if(this.d.has(B)){this.d.delete(B);return}this.f.delete(B);const j=c.$DI.parentId(B.item.extId);if(j&&this.h.has(j.toString())){this.h.add(B.item.extId);return}this.g.add(B)}getChangeEvent(){const{d:B,f:j,g:U}=this;return{get added(){return[...B].map(z=>z.revived)},get updated(){return[...j].map(z=>z.revived)},get removed(){return[...U].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class h extends k.$KI{constructor(){super(...arguments),this.s=new A.$hc,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(B){return this.f.get(B)}getMirroredTestDataByReference(B){return this.f.get(B.id)}q(B,j){return{...B,revived:t.TestItem.toPlain(B.item),depth:j?j.depth+1:0,children:new Set}}p(){return new s(this.s)}}class g{constructor(B){this.f=B}checkout(){this.d||(this.d=this.g());const B=this.d;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(j=>j.revived)},dispose:(0,l.$bb)(()=>{--B.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(B){return this.d?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.d?.tests.apply(B)}g(){const B=new h;return this.f.$subscribeToDiffs(),{observers:0,tests:B}}}class M{#e;#t;get label(){return this.f}set label(B){B!==this.f&&(this.f=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(B){B!==this.h&&(this.h=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:B}))}get isDefault(){return this.g}set isDefault(B){B!==this.g&&(this.g=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?t.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.d}set configureHandler(B){B!==this.d&&(this.d=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,j,U,z,ie,X,ye,De=!1,Re=void 0,Y=!1){this.controllerId=U,this.profileId=z,this.f=ie,this.kind=X,this.runHandler=ye,this.g=De,this._tag=Re,this.h=Y,this.#e=B,this.#t=j,j.set(z,this);const le=W[X];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);this.#e.$publishTestRunProfile({profileId:z,controllerId:U,tag:Re?t.TestTag.namespace(this.controllerId,Re.id):null,label:ie,group:le,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:Y})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$_bc=M;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[253],Ae([1,0,18,9,5,3,106,8,7]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=void 0;class f{constructor(S,u){this.i=u,this.a=new C.$hc({onListenerError:R.$Z}),this.b=new C.$hc({onListenerError:R.$Z}),this.c=new C.$hc({onListenerError:R.$Z}),this.d=new C.$hc({onListenerError:R.$Z}),this.f=new C.$hc({onListenerError:R.$Z}),this.g=new C.$hc({onListenerError:R.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(L.$QJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const u=this.i.allEditors();return S?u:u.map(p=>p.value)}async showTextDocument(S,u,p){let $;typeof u=="number"?$={position:l.ViewColumn.from(u),preserveFocus:p}:typeof u=="object"?$={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?l.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:$={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(S.uri,$),t=d&&this.i.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,u){return new A.$ZL(this.h,S,u).value}$acceptEditorPropertiesChanged(S,u){const p=this.i.getEditor(S);if(!p)throw new Error("unknown text editor");if(u.options&&p._acceptOptions(u.options),u.selections){const $=u.selections.selections.map(l.Selection.to);p._acceptSelections($)}if(u.visibleRanges){const $=y.$Af(u.visibleRanges.map(l.Range.to));p._acceptVisibleRanges($)}if(u.options&&this.b.fire({textEditor:p.value,options:{...u.options,lineNumbers:l.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const $=I.TextEditorSelectionChangeKind.fromValue(u.selections.source),d=u.selections.selections.map(l.Selection.to);this.a.fire({textEditor:p.value,selections:d,kind:$})}if(u.visibleRanges){const $=y.$Af(u.visibleRanges.map(l.Range.to));this.c.fire({textEditor:p.value,visibleRanges:$})}}$acceptEditorPositionData(S){for(const u in S){const p=this.i.getEditor(u);if(!p)throw new Error("Unknown text editor");const $=l.ViewColumn.to(S[u]);p.value.viewColumn!==$&&(p._acceptViewColumn($),this.d.fire({textEditor:p.value,viewColumn:$}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$obc=f}),define(Pe[254],Ae([1,0,2,4,3,6,7,8,20,16]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0,e.$3bc=(0,R.$zh)("IExtHostTimeline");class P{constructor(p,$){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$QJ.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&I.$Tl.equals(t,this.b.get(d.source)?.extension)){const i=d.uri===void 0?void 0:y.URI.revive(d.uri);return this.c.get(d.source)?.get(S(i))?.get(d.handle)}else return;return d}})}async $getTimeline(p,$,d,t){return this.b.get(p)?.provider.provideTimeline(y.URI.revive($),d,t)}registerTimelineProvider(p,$,d,t){const i=new L.$lb,c=this.d($.id,t,i).bind(this);let m;$.onDidChange&&(m=$.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:$.id}),this));const k=this.c;return this.f({...$,scheme:p,onDidChange:void 0,async provideTimeline(b,n,a){n?.resetCache&&(i.clear(),k.get($.id)?.clear());const r=await $.provideTimeline(b,n,a);if(r==null)return;const o=c(b,n);return{...r,source:$.id,items:r.items.map(o)}},dispose(){for(const b of k.values())b.get($.id)?.clear();m?.dispose(),i.dispose()}},d)}d(p,$,d){return(t,i)=>{let c;if(i?.cacheResults){let m=this.c.get(p);m===void 0&&(m=new Map,this.c.set(p,m));const k=S(t);c=m.get(k),c===void 0&&(c=new Map,m.set(k,c))}return m=>{const{iconPath:k,...b}=m,n=`${p}|${m.id??m.timestamp}`;c?.set(n,m);let a,r,o;m.iconPath&&(k instanceof A.$NK?o={id:k.id,color:k.color}:y.URI.isUri(k)?(a=k,r=k):{light:a,dark:r}=k);let w;return A.$hK.isMarkdownString(b.tooltip)?w=l.MarkdownString.from(b.tooltip):(0,f.$le)(b.tooltip)?w=b.tooltip:A.$hK.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=l.MarkdownString.from(b.detail)):(0,f.$le)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=b.detail),{...b,id:b.id??void 0,handle:n,source:p,command:m.command?$.toInternal(m.command,d):void 0,icon:a,iconDark:r,themeIcon:o,tooltip:w,accessibilityInformation:m.accessibilityInformation}}}}f(p,$){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:$}),(0,L.$kb)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$4bc=P;function S(u){return u?.toString()}}),define(Pe[86],Ae([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1rb=e.$Zrb=e.TunnelDtoConverter=void 0;class p extends I.$2z{}var $;(function(t){function i(m){return{remoteAddress:m.remoteAddress,localAddress:m.localAddress,public:!!m.public,privacy:m.privacy??(m.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:m.protocol}}t.fromApiTunnel=i;function c(m){return{remoteAddress:{host:m.tunnelRemoteHost,port:m.tunnelRemotePort},localAddress:m.localAddress,public:m.privacy!==I.TunnelPrivacyId.ConstantPrivate&&m.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:m.privacy,protocol:m.protocol}}t.fromServiceTunnel=c})($||(e.TunnelDtoConverter=$={})),e.$Zrb=(0,A.$zh)("IExtHostTunnelService");let d=class extends C.$mb{constructor(i,c,m){super(),this.n=m,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$hc,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=i.getProxy(f.$QJ.MainThreadTunnelService)}async openTunnel(i,c){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const m=await this.a.$openTunnel(c,i.displayName);if(m){const k=new p(m.remoteAddress,m.localAddress,()=>this.a.$closeTunnel(m.remoteAddress));return this.B(k),k}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(i,c){const m=this.p();return this.l.set(m,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,m),new u.$SJ(()=>{this.l.delete(m),this.a.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(i,c,m,k,b){const n=[];for(const r of i){const o=this.l.get(r);if(!o)return[];n.push(...await Promise.all(c.map(async w=>{let v;try{v=await o.provider.providePortAttributes({port:w,pid:m,commandLine:k},b)}catch{v=await o.provider.providePortAttributes(w,m,k,b)}return{providedAttributes:v,port:w}})))}const a=n.filter(r=>!!r.providedAttributes);return a.length>0?a.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(k,b)=>await i.provideTunnel(k,b,new y.$rc().token)??void 0;const m=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(m),Promise.resolve((0,C.$kb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const m=i.tunnelFactory??(c?this.r(c):void 0);if(m){this.b=m;let k=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&k.length===0&&(k=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const b=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:k}:void 0;this.a.$setTunnelProvider(b)}}else this.b=void 0;return(0,C.$kb)(()=>{this.b=void 0})}r(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const m=this.g.get(i.host);m.has(i.port)&&(c&&m.get(i.port).disposeListener.dispose(),await m.get(i.port).tunnel.dispose(),m.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this.b(i,c);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const k=await m;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),k===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const b=this.B(k.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(k.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:k,disposeListener:b}),$.fromApiTunnel(k)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(m){if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),m instanceof Error)return m.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(k=>this.f(k.host,k.port,k.detail??""))),m=i.filter((k,b)=>c[b]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(k=>k.port).join(", ")} to ${m.map(k=>k.port).join(", ")}`),m}};e.$1rb=d,e.$1rb=d=Ke([Ve(0,S.$SL),Ve(1,P.$9L),Ve(2,l.$3i)],d)}),define(Pe[255],Ae([1,0,6,12,2,3]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;class A{static{this.a=new Set([R.Schemas.http,R.Schemas.https])}constructor(I){this.c=new Map,this.b=I.getProxy(L.$QJ.MainThreadUriOpeners)}registerExternalUriOpener(I,f,P,S){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const u=S.schemes.find(p=>!A.a.has(p));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(f,P),this.b.$registerUriOpener(f,S.schemes,I,S.label),(0,y.$kb)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(I,f,P){const S=this.c.get(I);if(!S)throw new Error(`Unknown opener with id: ${I}`);const u=C.URI.revive(f);return S.canOpenExternalUri(u,P)}async $openUri(I,f,P){const S=this.c.get(I);if(!S)throw new Error(`Unknown opener id: '${I}'`);return S.openExternalUri(C.URI.revive(f.resolvedUri),{sourceUri:C.URI.revive(f.sourceUri)},P)}}e.$acc=A}),define(Pe[256],Ae([1,0,3,2,6,9,20]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0;class l{static{this.a=0}constructor(f){this.c=new A.$Ul,this.d=new Map,this.b=f.getProxy(y.$QJ.MainThreadUrls)}registerUriHandler(f,P){const S=f.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const u=l.a++;return this.c.add(S),this.d.set(u,P),this.b.$registerUriHandler(u,S,f.displayName||f.name),(0,C.$kb)(()=>{this.c.delete(S),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(f,P){const S=this.d.get(f);if(!S)return Promise.resolve(void 0);try{S.handleUri(R.URI.revive(P))}catch(u){(0,L.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(f){return R.URI.revive(await this.b.$createAppUri(f))}}e.$qbc=l}),define(Pe[63],Ae([1,0,5,6,12,24,2,170,192,77,3]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=e.$ubc=e.$tbc=e.$sbc=e.$rbc=void 0;class S{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(k,b,n,a,r,o,w){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new y.$hc,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$hc,this._onDidDispose=this.#h.event,this.#e=k,this.#t=b,this.#r=n,this.#l=a,this.#u=r,this.#n=o,this.#c=u(o),this.#d=p(o),this.#i=w}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(k){return this.#a=!0,(0,f.$xob)(k,this.#l)}get cspSource(){const k=this.#n.extensionLocation;if(k.scheme===C.Schemas.https||k.scheme===C.Schemas.http){let b=k.toString();return b.endsWith("/")||(b+="/"),b+" "+f.$wob}return f.$wob}get html(){return this.a(),this.#s}set html(k){this.a(),this.#s!==k&&(this.#s=k,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(k)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(k)))}get options(){return this.a(),this.#r}set options(k){this.a(),L.$Xm(this.#r,k)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,k)),this.#r=k}async postMessage(k){if(this.#o)return!1;const b=(0,I.$Lbb)(k,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,b.message,...b.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(k){if(!this.#d)return k;const b=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return k.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,r,o,w,v,E)=>{const D=A.URI.from({scheme:w||"file",path:decodeURIComponent(v)}),s=(0,f.$xob)(D,{isRemote:b,authority:n}).toString();return`${r}${s}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,r,o,w,v,E)=>{const D=A.URI.from({scheme:w||"file",path:decodeURIComponent(v)}),s=(0,f.$xob)(D,{isRemote:b,authority:n}).toString();return`${r}${s}${E}`})}}e.$rbc=S;function u(m){try{const k=(0,l.$Bo)((0,l.$Ao)(m.engines.vscode));return!!k&&k.majorBase>=1&&k.minorBase>=57}catch{return!1}}e.$sbc=u;function p(m){try{const k=(0,l.$Bo)((0,l.$Ao)(m.engines.vscode));return k?k.majorBase<1||k.majorBase===1&&k.minorBase<60:!1}catch{return!1}}class $ extends R.$mb{constructor(k,b,n,a,r){super(),this.c=b,this.f=n,this.g=a,this.h=r,this.b=new Map,this.a=k.getProxy(P.$QJ.MainThreadWebviews)}dispose(){super.dispose();for(const k of this.b.values())k.dispose();this.b.clear()}$onMessage(k,b,n){const a=this.i(k);if(a){const{message:r}=(0,I.$Mbb)(b,n.value);a._onMessageEmitter.fire(r)}}$onMissingCsp(k,b){this.g.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(k,b,n){const a=new S(k,this.a,i(b),this.c,this.f,n,this.h);this.b.set(k,a);const r=a._onDidDispose(()=>{r.dispose(),this.deleteWebview(k)});return a}deleteWebview(k){this.b.delete(k)}i(k){return this.b.get(k)}}e.$tbc=$;function d(m){return{id:m.identifier,location:m.extensionLocation}}e.$ubc=d;function t(m,k,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||c(m,k)}}e.$vbc=t;function i(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(k=>A.URI.from(k))}}function c(m,k){return[...(k?.getWorkspaceFolders()||[]).map(b=>b.uri),m.extensionLocation]}}),define(Pe[257],Ae([1,0,21,93,6,12,23,2,8,63,54,3,7]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=void 0;class p{constructor(a,r){this.document=a,this.b=r,this.a=1,this.c=new P.$nac("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,r){await this.f(a).undo(),r||this.disposeBackup()}async redo(a,r){await this.f(a).redo(),r||this.disposeBackup()}disposeEdits(a){for(const r of a)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=b(this.document.uri)+this.a++;return(0,A.$gg)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const r=this.c.get(a,0);if(!r)throw new Error("No edit found");return r}}class ${constructor(){this.a=new Map}get(a,r){return this.a.get(this.b(a,r))}add(a,r,o){const w=this.b(a,r.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${a} resource:${r.uri}`);const v=new p(r,o);return this.a.set(w,v),v}delete(a,r){const o=this.b(a,r.uri);this.a.delete(o)}b(a,r){return`${a}@@@${r}`}}var d;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(a,r,o){return this.b(0,a,r,o)}addCustomProvider(a,r,o){return this.b(1,a,r,o)}get(a){return this.a.get(a)}b(a,r,o,w){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:a,extension:o,provider:w}),new u.$SJ(()=>this.a.delete(r))}}class i{constructor(a,r,o,w,v){this.d=r,this.f=o,this.g=w,this.h=v,this.b=new t,this.c=new $,this.a=a.getProxy(S.$QJ.MainThreadCustomEditors)}registerCustomEditorProvider(a,r,o,w){const v=new C.$lb;return m(o)?(v.add(this.b.addTextProvider(r,a,o)),this.a.$registerTextEditorProvider((0,f.$ubc)(a),r,w.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,f.$sbc)(a))):(v.add(this.b.addCustomProvider(r,a,o)),c(o)&&v.add(o.onDidChangeCustomDocument(E=>{const D=this.i(r,E.document.uri);if(k(E)){const s=D.addEdit(E);this.a.$onDidEdit(E.document.uri,r,s,E.label)}else this.a.$onContentChange(E.document.uri,r)})),this.a.$registerCustomEditorProvider((0,f.$ubc)(a),r,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,f.$sbc)(a))),u.$SJ.from(v,new u.$SJ(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(a,r,o,w,v){const E=this.b.get(r);if(!E)throw new Error(`No provider found for '${r}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${r}'`);const D=l.URI.revive(a),s=await E.provider.openCustomDocument(D,{backupId:o,untitledDocumentData:w?.buffer},v);let h;return c(E.provider)&&this.f&&(h=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(r,s,h),{editable:c(E.provider)}}async $disposeCustomDocument(a,r){const o=this.b.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const w=l.URI.revive(a),{document:v}=this.i(r,w);this.c.delete(r,v),v.dispose()}async $resolveCustomEditor(a,r,o,w,v,E){const D=this.b.get(o);if(!D)throw new Error(`No provider found for '${o}'`);const s=I.ViewColumn.to(v),h=this.g.createNewWebview(r,w.contentOptions,D.extension),g=this.h.createNewWebviewPanel(r,o,w.title,s,w.options,h,w.active),M=l.URI.revive(a);switch(D.type){case 1:{const{document:W}=this.i(o,M);return D.provider.resolveCustomEditor(W,g,E)}case 0:{const W=this.d.getDocument(M);return D.provider.resolveCustomTextEditor(W,g,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,r,o){this.i(r,a).disposeEdits(o)}async $onMoveCustomEditor(a,r,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const v=this.h.getWebviewPanel(a);if(!v)throw new Error("No webview found");const E=l.URI.revive(r),D=this.d.getDocument(E);await w.provider.moveCustomTextEditor(D,v,y.CancellationToken.None)}async $undo(a,r,o,w){return this.i(r,a).undo(o,w)}async $redo(a,r,o,w){return this.i(r,a).redo(o,w)}async $revert(a,r,o){const w=this.i(r,a);await this.j(r).revertCustomDocument(w.document,o),w.disposeBackup()}async $onSave(a,r,o){const w=this.i(r,a);await this.j(r).saveCustomDocument(w.document,o),w.disposeBackup()}async $onSaveAs(a,r,o,w){const v=this.i(r,a);return this.j(r).saveCustomDocumentAs(v.document,l.URI.revive(o),w)}async $backup(a,r,o){const w=this.i(r,a),E=await this.j(r).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},o);return w.updateBackup(E),E.id}i(a,r){const o=this.c.get(a,l.URI.revive(r));if(!o)throw new Error("No custom document found");return o}j(a){const o=this.b.get(a)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$7bc=i;function c(n){return!!n.onDidChangeCustomDocument}function m(n){return typeof n.resolveCustomTextEditor=="function"}function k(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function b(n){const a=n.scheme===L.Schemas.file||n.scheme===L.Schemas.untitled?n.fsPath:n.toString();return(0,R.$ni)(a)+""}}),define(Pe[258],Ae([1,0,5,6,2,36,8,63,3,7]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class P extends R.$mb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,d,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new y.$hc),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$hc),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=d,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!d})}c(){if(this.#c)throw new Error("Webview is disposed")}}class S extends R.$mb{static c(){return(0,L.$6e)()}constructor($,d,t){super(),this.i=d,this.j=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(I.$QJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,d,t,i,c={}){const m=typeof i=="object"?i.viewColumn:i,k={viewColumn:A.ViewColumn.from(m),preserveFocus:typeof i=="object"&&!!i.preserveFocus},b=(0,l.$sbc)($),n=S.c();this.f.$createWebviewPanel((0,l.$ubc)($),n,d,{title:t,panelOptions:u(c),webviewOptions:(0,l.$vbc)($,this.j,c),serializeBuffersForPostMessage:b},k);const a=this.i.createNewWebview(n,c,$);return this.createNewWebviewPanel(n,d,t,m,c,a,!0)}$onDidChangeWebviewPanelViewStates($){const d=Object.keys($);d.sort((t,i)=>{const c=$[t],m=$[i];return c.active?1:m.active?-1:+c.visible-+m.visible});for(const t of d){const i=this.getWebviewPanel(t);if(!i)continue;const c=$[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.i.deleteWebview($)}registerWebviewPanelSerializer($,d,t){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:t,extension:$}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,l.$sbc)($)}),new f.$SJ(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel($,d,t,i){const c=this.h.get(d);if(!c)throw new Error(`No serializer found for '${d}'`);const{serializer:m,extension:k}=c,b=this.i.createNewWebview($,t.webviewOptions,k),n=this.createNewWebviewPanel($,d,t.title,i,t.panelOptions,b,t.active);await m.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel($,d,t,i,c,m,k){const b=new P($,this.f,m,{viewType:d,title:t,viewColumn:i,panelOptions:c,active:k});return this.g.set($,b),b}getWebviewPanel($){return this.g.get($)}}e.$6bc=S;function u(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[259],Ae([1,0,5,6,63,8,3,7]),function(pe,e,y,R,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class I extends R.$mb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(S,u,p,$,d,t){super(),this.#u=!1,this.#a=this.B(new y.$hc),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new y.$hc),this.onDidDispose=this.#c.event,this.#i=p,this.#s=$,this.#e=S,this.#t=u,this.#l=d,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#r}set description(S){this.a(),this.#r!==S&&(this.#r=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#u||(this.#n=S,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(S){this.a(),!(S?.value===this.#o?.value&&S?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#u)throw new Error("Webview is disposed")}}class f{constructor(S,u){this.d=u,this.b=new Map,this.c=new Map,this.a=S.getProxy(A.$QJ.MainThreadWebviewViews)}registerWebviewViewProvider(S,u,p,$){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:p,extension:S}),this.a.$registerWebviewViewProvider((0,C.$ubc)(S),u,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$sbc)(S)}),new l.$SJ(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(S,u,p,$,d){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:c}=t,m=this.d.createNewWebview(S,{},c),k=new I(S,this.a,u,p,m,!0);this.c.set(S,k),await i.resolveWebviewView(k,{state:$},d)}async $onDidChangeWebviewViewVisibility(S,u){this.e(S)._setVisible(u)}async $disposeWebviewView(S){const u=this.e(S);this.c.delete(S),u.dispose(),this.d.deleteWebview(S)}e(S){const u=this.c.get(S);if(!u)throw new Error("No webview found");return u}}e.$5bc=f}),define(Pe[109],Ae([1,0,5,3,2,12,15,4,17,26]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=void 0;let S=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(p){const $=this.d;return{get focused(){return $.focused},get active(){return(0,f.$LF)(p,"windowActivity"),$.active}}}constructor(p){this.c=new y.$hc,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=p.getProxy(R.$QJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:d})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,$){$!==this.d[p]&&(this.d={...this.d,[p]:$},this.c.fire(this.d))}openUri(p,$){let d;if(typeof p=="string"){d=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$od)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,d,$)}async asExternalUri(p,$){if((0,A.$od)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(p,$);return C.URI.from(d)}};e.$wbc=S,e.$wbc=S=P=Ke([Ve(0,I.$SL)],S),e.$xbc=(0,l.$zh)("IExtHostWindow")}),define(Pe[260],Ae([1,0,227,27,17]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;let L=class extends y.$vcc{constructor(l,I){super(l,I)}f(l,I,f){I.apply(console,f)}};e.$Cec=L,e.$Cec=L=Ke([Ve(0,C.$SL),Ve(1,R.$9L)],L)}),define(Pe[261],Ae([1,0,13,25,21,9,5,6,133,216,46]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$52b=e.ResponsiveState=e.RequestInitiator=e.$42b=e.$32b=void 0;function u(h,g){try{return JSON.stringify(h,g)}catch{return"null"}}const p="$$ref$$",$={[p]:-1};class d{constructor(g,M){this.jsonString=g,this.referencedBuffers=M}}function t(h,g=null,M=!1){const W=[];return{jsonString:(M?u:JSON.stringify)(h,(B,j)=>{if(typeof j>"u")return $;if(typeof j=="object"){if(j instanceof R.$Hc){const U=W.push(j)-1;return{[p]:U}}if(g)return g(B,j)}return j}),referencedBuffers:W}}e.$32b=t;function i(h,g,M){return JSON.parse(h,(W,V)=>{if(V){const B=V[p];if(typeof B=="number")return g[B];if(M&&V.$mid===1)return M.transformIncoming(V)}return V})}e.$42b=i;function c(h,g){return JSON.stringify(h,g)}function m(h){return h?(g,M)=>M&&M.$mid===1?h.transformOutgoing(M):M:null}var k;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));var b;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(b||(e.ResponsiveState=b={}));const n=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends l.$mb{static{S=a}static{this.a=3*1e3}constructor(g,M=null,W=null){super(),this[S]=!0,this.b=this.B(new A.$hc),this.onDidChangeResponsiveState=this.b.event,this.c=g,this.f=M,this.g=W,this.h=m(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,B=P.$9z.count;V<B;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new y.$Qg(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(g=>{this.s[g].resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(g){this.u===0&&(this.v=Date.now()+o.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(g){this.v=Date.now()+o.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(g){this.t!==g&&(this.t=g,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(g){return this.g?(0,I.$Cm)(g,this.g):g}getProxy(g){const{nid:M,sid:W}=g;return this.l[M]||(this.l[M]=this.F(M,W)),this.l[M]}F(g,M){const W={get:(V,B)=>(typeof B=="string"&&!V[B]&&B.charCodeAt(0)===36&&(V[B]=(...j)=>this.O(g,B,j)),B===r?M:V[B])};return new Proxy(Object.create(null),W)}set(g,M){return this.k[g.nid]=M,M}assertRegistered(g){for(let M=0,W=g.length;M<W;M++){const V=g[M];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(g){if(this.j)return;const M=g.byteLength,W=w.read(g,0),V=W.readUInt8(),B=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:j,method:U,args:z}=E.deserializeRequestJSONArgs(W);this.g&&(z=(0,I.$Cm)(z,this.g)),this.H(M,B,j,U,z,V===2);break}case 3:case 4:{let{rpcId:j,method:U,args:z}=E.deserializeRequestMixedArgs(W);this.g&&(z=(0,I.$Cm)(z,this.g)),this.H(M,B,j,U,z,V===4);break}case 5:{this.f?.logIncoming(M,B,0,"ack"),this.z(B);break}case 6:{this.I(M,B);break}case 7:{this.J(M,B,void 0);break}case 9:{let j=E.deserializeReplyOKJSON(W);this.g&&(j=(0,I.$Cm)(j,this.g)),this.J(M,B,j);break}case 10:{const j=E.deserializeReplyOKJSONWithBuffers(W,this.g);this.J(M,B,j);break}case 8:{const j=E.deserializeReplyOKVSBuffer(W);this.J(M,B,j);break}case 11:{let j=E.deserializeReplyErrError(W);this.g&&(j=(0,I.$Cm)(j,this.g)),this.L(M,B,j);break}case 12:{this.L(M,B,void 0);break}default:console.error("received unexpected message"),console.error(g)}}H(g,M,W,V,B,j){this.f?.logIncoming(g,M,1,`receiveRequest ${(0,P.$$z)(W)}.${V}(`,B);const U=String(M);let z,ie;if(j){const ye=new C.$rc;B.push(ye.token),z=this.M(W,V,B),ie=()=>ye.cancel()}else z=this.M(W,V,B),ie=n;this.p[U]=ie;const X=E.serializeAcknowledged(M);this.f?.logOutgoing(X.byteLength,M,1,"ack"),this.c.send(X),z.then(ye=>{delete this.p[U];const De=E.serializeReplyOK(M,ye,this.h);this.f?.logOutgoing(De.byteLength,M,1,"reply:",ye),this.c.send(De)},ye=>{delete this.p[U];const De=E.serializeReplyErr(M,ye);this.f?.logOutgoing(De.byteLength,M,1,"replyErr:",ye),this.c.send(De)})}I(g,M){this.f?.logIncoming(g,M,1,"receiveCancel");const W=String(M);this.p[W]?.()}J(g,M,W){this.f?.logIncoming(g,M,0,"receiveReply:",W);const V=String(M);if(!this.s.hasOwnProperty(V))return;const B=this.s[V];delete this.s[V],B.resolveOk(W)}L(g,M,W){this.f?.logIncoming(g,M,0,"receiveReplyErr:",W);const V=String(M);if(!this.s.hasOwnProperty(V))return;const B=this.s[V];delete this.s[V];let j;W&&(W.$isError?(j=new Error,j.name=W.name,j.message=W.message,j.stack=W.stack):j=W),B.resolveErr(j)}M(g,M,W){try{return Promise.resolve(this.N(g,M,W))}catch(V){return Promise.reject(V)}}N(g,M,W){const V=this.k[g];if(!V)throw new Error("Unknown actor "+(0,P.$$z)(g));const B=V[M];if(typeof B!="function")throw new Error("Unknown method "+M+" on actor "+(0,P.$$z)(g));return B.apply(V,W)}O(g,M,W){if(this.j)return new f.$22b;let V=null;if(W.length>0&&C.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(L.$4());const B=E.serializeRequestArguments(W,this.h),j=++this.m,U=String(j),z=new f.$12b;V&&V.onCancellationRequested(()=>{const X=E.serializeCancel(j);this.f?.logOutgoing(X.byteLength,j,0,"cancel"),this.c.send(E.serializeCancel(j))}),this.s[U]=z,this.y(j);const ie=E.serializeRequest(j,g,M,B,!!V);return this.f?.logOutgoing(ie.byteLength,j,0,`request: ${(0,P.$$z)(g)}.${M}(`,W),this.c.send(ie),z}}e.$52b=o;class w{static alloc(g,M,W){const V=new w(R.$Hc.alloc(W+1+4),0);return V.writeUInt8(g),V.writeUInt32(M),V}static read(g,M){return new w(g,M)}get buffer(){return this.a}constructor(g,M){this.a=g,this.b=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(g){this.a.writeUInt8(g,this.b),this.b+=1}readUInt8(){const g=this.a.readUInt8(this.b);return this.b+=1,g}writeUInt32(g){this.a.writeUInt32BE(g,this.b),this.b+=4}readUInt32(){const g=this.a.readUInt32BE(this.b);return this.b+=4,g}static sizeShortString(g){return 1+g.byteLength}writeShortString(g){this.a.writeUInt8(g.byteLength,this.b),this.b+=1,this.a.set(g,this.b),this.b+=g.byteLength}readShortString(){const g=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+g).toString();return this.b+=g,W}static sizeLongString(g){return 4+g.byteLength}writeLongString(g){this.a.writeUInt32BE(g.byteLength,this.b),this.b+=4,this.a.set(g,this.b),this.b+=g.byteLength}readLongString(){const g=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+g).toString();return this.b+=g,W}writeBuffer(g){this.a.writeUInt32BE(g.byteLength,this.b),this.b+=4,this.a.set(g,this.b),this.b+=g.byteLength}static sizeVSBuffer(g){return 4+g.byteLength}writeVSBuffer(g){this.a.writeUInt32BE(g.byteLength,this.b),this.b+=4,this.a.set(g,this.b),this.b+=g.byteLength}readVSBuffer(){const g=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+g);return this.b+=g,M}static sizeMixedArray(g){let M=0;M+=1;for(let W=0,V=g.length;W<V;W++){const B=g[W];switch(M+=1,B.type){case 1:M+=this.sizeLongString(B.value);break;case 2:M+=this.sizeVSBuffer(B.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(B.value);for(let j=0;j<B.buffers.length;++j)M+=this.sizeVSBuffer(B.buffers[j]);break;case 4:break}}return M}writeMixedArray(g){this.a.writeUInt8(g.length,this.b),this.b+=1;for(let M=0,W=g.length;M<W;M++){const V=g[M];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let B=0;B<V.buffers.length;++B)this.writeBuffer(V.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const g=this.a.readUInt8(this.b);this.b+=1;const M=new Array(g);for(let W=0;W<g;W++)switch(this.readUInt8()){case 1:M[W]=this.readLongString();break;case 2:M[W]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),j=this.readLongString(),U=[];for(let z=0;z<B;++z)U.push(this.readVSBuffer());M[W]=new P.$_z(i(j,U,null));break}case 4:M[W]=void 0;break}return M}}var v;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(v||(v={}));class E{static a(g){for(let M=0,W=g.length;M<W;M++)if(g[M]instanceof R.$Hc||g[M]instanceof P.$_z||typeof g[M]>"u")return!0;return!1}static serializeRequestArguments(g,M){if(this.a(g)){const W=[];for(let V=0,B=g.length;V<B;V++){const j=g[V];if(j instanceof R.$Hc)W[V]={type:2,value:j};else if(typeof j>"u")W[V]={type:4};else if(j instanceof P.$_z){const{jsonString:U,referencedBuffers:z}=t(j.value,M);W[V]={type:3,value:R.$Hc.fromString(U),buffers:z}}else W[V]={type:1,value:R.$Hc.fromString(c(j,M))}}return{type:1,args:W}}return{type:0,args:c(g,M)}}static serializeRequest(g,M,W,V,B){switch(V.type){case 0:return this.b(g,M,W,V.args,B);case 1:return this.c(g,M,W,V.args,B)}}static b(g,M,W,V,B){const j=R.$Hc.fromString(W),U=R.$Hc.fromString(V);let z=0;z+=w.sizeUInt8(),z+=w.sizeShortString(j),z+=w.sizeLongString(U);const ie=w.alloc(B?2:1,g,z);return ie.writeUInt8(M),ie.writeShortString(j),ie.writeLongString(U),ie.buffer}static deserializeRequestJSONArgs(g){const M=g.readUInt8(),W=g.readShortString(),V=g.readLongString();return{rpcId:M,method:W,args:JSON.parse(V)}}static c(g,M,W,V,B){const j=R.$Hc.fromString(W);let U=0;U+=w.sizeUInt8(),U+=w.sizeShortString(j),U+=w.sizeMixedArray(V);const z=w.alloc(B?4:3,g,U);return z.writeUInt8(M),z.writeShortString(j),z.writeMixedArray(V),z.buffer}static deserializeRequestMixedArgs(g){const M=g.readUInt8(),W=g.readShortString(),V=g.readMixedArray(),B=new Array(V.length);for(let j=0,U=V.length;j<U;j++){const z=V[j];typeof z=="string"?B[j]=JSON.parse(z):B[j]=z}return{rpcId:M,method:W,args:B}}static serializeAcknowledged(g){return w.alloc(5,g,0).buffer}static serializeCancel(g){return w.alloc(6,g,0).buffer}static serializeReplyOK(g,M,W){if(typeof M>"u")return this.d(g);if(M instanceof R.$Hc)return this.e(g,M);if(M instanceof P.$_z){const{jsonString:V,referencedBuffers:B}=t(M.value,W,!0);return this.g(g,V,B)}else return this.f(g,u(M,W))}static d(g){return w.alloc(7,g,0).buffer}static e(g,M){let W=0;W+=w.sizeVSBuffer(M);const V=w.alloc(8,g,W);return V.writeVSBuffer(M),V.buffer}static deserializeReplyOKVSBuffer(g){return g.readVSBuffer()}static f(g,M){const W=R.$Hc.fromString(M);let V=0;V+=w.sizeLongString(W);const B=w.alloc(9,g,V);return B.writeLongString(W),B.buffer}static g(g,M,W){const V=R.$Hc.fromString(M);let B=0;B+=w.sizeUInt32,B+=w.sizeLongString(V);for(const U of W)B+=w.sizeVSBuffer(U);const j=w.alloc(10,g,B);j.writeUInt32(W.length),j.writeLongString(V);for(const U of W)j.writeBuffer(U);return j.buffer}static deserializeReplyOKJSON(g){const M=g.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(g,M){const W=g.readUInt32(),V=g.readLongString(),B=[];for(let j=0;j<W;++j)B.push(g.readVSBuffer());return new P.$_z(i(V,B,M))}static serializeReplyErr(g,M){const W=M?u(L.$1(M),null):void 0;if(typeof W!="string")return this.h(g);const V=R.$Hc.fromString(W);let B=0;B+=w.sizeLongString(V);const j=w.alloc(11,g,B);return j.writeLongString(V),j.buffer}static deserializeReplyErrError(g){const M=g.readLongString();return JSON.parse(M)}static h(g){return w.alloc(12,g,0).buffer}}var D;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(D||(D={}));var s;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(s||(s={}))}),define(Pe[262],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;const y=function(L){const A=l=>{globalThis.removeEventListener("message",A);const I=l.data;Object.defineProperties(globalThis,{postMessage:{value(f,P){I.postMessage(f,P)}},onmessage:{get(){return I.onmessage},set(f){I.onmessage=f}}}),I.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),I.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(L,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const I=`((${y})('${A}'))`,f=new Blob([I],{type:"application/javascript"}),P=URL.createObjectURL(f),S=new MessageChannel,u=P,p={type:"_newWorker",id:u,port:S.port2,url:P,options:l};L(p,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{L({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set($){S.port1.onmessage=$}},onmessageerror:{get(){return S.port1.onmessageerror},set($){S.port1.onmessageerror=$}}}),S.port1.addEventListener("messageerror",$=>{const d=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(d)}),S.port1.addEventListener("message",$=>{const d=new MessageEvent("message",{data:$.data});this.dispatchEvent(d)}),S.port1.start()}}e.$Eec=R}),define(Pe[263],Ae([1,0,5,30,32,4]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7I=e.$6I=e.OutputChannelUpdateMode=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=void 0,e.$UI="text/x-code-output",e.$VI="output",e.$WI="Log",e.$XI="text/x-code-log-output",e.$YI="log",e.$ZI="log",e.$1I="workbench.panel.output",e.$2I=new C.$Zi("inOutput",!1),e.$3I=new C.$Zi("activeLogOutput",!1),e.$4I=new C.$Zi("outputView.scrollLock",!1),e.$5I=(0,L.$zh)("outputService");var A;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$6I={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new y.$hc,this.onDidRegisterChannel=this.b.event,this.c=new y.$hc,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(P=>f.push(P)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}R.$6m.add(e.$6I.OutputChannels,new l),e.$7I=new C.$Zi("activeOutputChannel","")}),define(Pe[110],Ae([1,0,3,4,17,20,14,263,61,27,39,130,25,16,38,5,6]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=void 0;class i extends A.$9i{get disposed(){return this.l}constructor(b,n,a,r,o){super(),this.id=b,this.name=n,this.m=a,this.n=r,this.extension=o,this.k=0,this.l=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.k;this.m.flush(),this.n.$update(this.id,l.OutputChannelUpdateMode.Clear,b)}replace(b){const n=this.k;this.info(b),this.n.$update(this.id,l.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(b,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof b=="boolean"?b:n))}hide(){this.n.$close(this.id)}g(b,n){this.k+=u.$Hc.fromString(n).byteLength,(0,A.log)(this.m,b,n),this.visible&&(this.m.flush(),this.n.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class c extends i{appendLine(b){this.append(b)}}let m=class{constructor(b,n,a,r,o,w){this.i=n,this.j=a,this.k=r,this.l=o,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(y.$QJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,S.$5l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[n,a]of this.g)a.visible=n===this.h}createOutputChannel(b,n,a){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const r=typeof n=="object"&&n.log,o=(0,p.$le)(n)?n:void 0;if((0,p.$le)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const v=this.i.environment.extensionLogLevel?.find(([D])=>L.$Tl.equals(a.identifier,D))?.[1];v&&(w=(0,A.$gj)(v));const E=r?this.o(b,w,a):this.n(b,o,a);return E.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),r?this.r(b,w??this.m.getLevel(),E):this.q(b,E)}async n(b,n,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,o=this.k.extUri.joinPath(r,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(b,o,n,a.identifier.value);return new i(v,b,w,this.a,a)}async o(b,n,a){const r=await this.p(a),o=b.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(r,`${o}.log`),v=`${a.identifier.value}.${o}`,E=this.l.createLogger(w,{id:v,name:b,logLevel:n,extensionId:a.identifier.value});return new c(v,b,E,this.a,a)}p(b){let n=this.d.get(b.identifier.value);if(!n){const a=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(a)}catch(r){if((0,$.$gk)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return n}q(b,n){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return b},append(o){r(),n.then(w=>w.append(o))},appendLine(o){r(),n.then(w=>w.appendLine(o))},clear(){r(),n.then(o=>o.clear())},replace(o){r(),n.then(w=>w.replace(o))},show(o,w){r(),n.then(v=>v.show(o,w))},hide(){r(),n.then(o=>o.hide())},dispose(){a=!0,n.then(o=>o.dispose())}}}r(b,n,a){const r=new t.$lb,o=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},w=r.add(new d.$hc);function v(E){n=E,w.fire(E)}return a.then(E=>{r.add(E),E.logLevel!==n&&v(E.logLevel),r.add(E.onDidChangeLogLevel(D=>v(D)))}),{...this.q(b,a),get logLevel(){return n},onDidChangeLogLevel:w.event,trace(E,...D){o(),a.then(s=>s.trace(E,...D))},debug(E,...D){o(),a.then(s=>s.debug(E,...D))},info(E,...D){o(),a.then(s=>s.info(E,...D))},warn(E,...D){o(),a.then(s=>s.warn(E,...D))},error(E,...D){o(),a.then(s=>s.error(E,...D))},dispose(){r.dispose()}}}};e.$gbc=m,e.$gbc=m=Ke([Ve(0,C.$SL),Ve(1,f.$9L),Ve(2,I.$Vac),Ve(3,P.$qac),Ve(4,A.$4i),Ve(5,A.$3i)],m),e.$hbc=(0,R.$zh)("IExtHostOutputService")}),define(Pe[264],Ae([1,0,4,13]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=void 0,e.$hm=(0,y.$zh)("remoteAgentService"),e.$im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let L=1/0;for(let l=0;l<this.maxSampleCount;l++){const I=await C.getRoundTripTime();if(I===void 0)return;L=Math.min(L,I/2),await(0,R.$Fg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((l,I)=>l+I,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((l,I)=>l+I,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[265],Ae([1,0,42,12,19,22,23,2,4,187,53,209,264]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.$mJ=void 0,e.$mJ=(0,I.$zh)("pathService");let $=p=class{constructor(t,i,c,m){this.d=t,this.e=i,this.f=c,this.g=m,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const k=await this.e.getEnvironment();return this.c=k?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(m=>this.h(t,m,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===R.Schemas.file||t.scheme===R.Schemas.vscodeRemote?(0,y.$Ie)(c??(0,A.$dg)(t),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return R.Schemas.vscodeRemote;const c=(0,f.$jJ)(i.getWorkspace());if(c)return c;const m=i.getWorkspace().folders[0];if(m)return m.uri.scheme;const k=i.getWorkspace().configuration;return k?k.scheme:R.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$7c:C.$8c)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const m=t.indexOf("/",2);m===-1?(i=t.substring(2),t="/"):(i=t.substring(2,m),t=t.substring(m)||"/")}return l.URI.from({scheme:R.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$nJ=$,e.$nJ=$=p=Ke([Ve(1,u.$hm),Ve(2,S.$8I),Ve(3,P.$Ih)],$)}),define(Pe[111],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$0H=e.$9H=void 0;class y{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new y(0,0)}with(A){return new y(0,0)}}e.$9H=y;class R{constructor(A,l,I,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,l),this.end=new y(I,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.$0H=R;var C;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[47],Ae([1,0,18,37,24,42,15,4,19,9,111,13]),function(pe,e,y,R,C,L,A,l,I,f,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.SearchErrorCode=e.$lI=e.$kI=e.SearchSortOrder=e.ViewMode=e.$jI=e.$iI=e.$hI=e.$gI=e.SearchCompletionExitCode=e.$fI=e.$eI=e.$dI=e.QueryType=e.SearchProviderType=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$$H="workbench.view.search",e.$_H="workbench.panel.search",e.$aI="workbench.view.search",e.$bI="search.exclude";const u="\u27EA ",p=" characters skipped \u27EB",$=(u.length+p.length+5)*2;e.$cI=(0,l.$zh)("searchService");var d;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(d||(e.SearchProviderType=d={}));var t;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(t||(e.QueryType=t={}));function i(Y){return!!Y.preview}e.$dI=i;function c(Y){return!!Y.resource}e.$eI=c;function m(Y){return!!Y.message}e.$fI=m;var k;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(k||(e.SearchCompletionExitCode=k={}));class b{constructor(le){this.resource=le,this.results=[]}}e.$gI=b;class n{constructor(le,we,ae,x){this.ranges=we,this.webviewIndex=x;const ue=Array.isArray(we)?we:[we];if(ae&&ae.matchLines===1&&a(ue)){le=(0,A.$ee)(le,ae.matchLines);let O="",J=0,he=0;const Ee=Math.floor(ae.charsPerLine/5),ve=[];for(const be of ue){const ke=Math.max(be.startColumn-Ee,0),oe=be.startColumn+ae.charsPerLine;if(ke>he+Ee+$){const de=u+(ke-he)+p;O+=de+le.slice(ke,oe),J+=ke-(he+de.length)}else O+=le.slice(he,oe);ve.push(new o(0,be.startColumn-J,be.endColumn-J)),he=oe}this.preview={text:O,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const O=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:le,matches:(0,y.$Uf)(we,J=>new r(J.startLineNumber-O,J.startColumn,J.endLineNumber-O,J.endColumn))}}}}e.$hI=n;function a(Y){const le=Y[0].startLineNumber;for(const we of Y)if(we.startLineNumber!==le||we.endLineNumber!==le)return!1;return!0}class r{constructor(le,we,ae,x){this.startLineNumber=le,this.startColumn=we,this.endLineNumber=ae,this.endColumn=x}}e.$iI=r;class o extends r{constructor(le,we,ae){super(le,we,le,ae)}}e.$jI=o;var w;(function(Y){Y.List="list",Y.Tree="tree"})(w||(e.ViewMode=w={}));var v;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function E(Y,le=!0){const we=Y&&Y.files&&Y.files.exclude,ae=le&&Y&&Y.search&&Y.search.exclude;if(!we&&!ae)return;if(!we||!ae)return we||ae;let x=Object.create(null);return x=C.$Wm(x,C.$Tm(we)),x=C.$Wm(x,C.$Tm(ae),!0),x}e.$kI=E;function D(Y,le){return Y.excludePattern&&R.$oj(Y.excludePattern,le)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&R.$oj(Y.includePattern,le)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(we=>{const ae=we.folder.fsPath;if(L.$Ke(le,ae)){const x=I.$ad(ae,le);return!we.includePattern||!!R.$oj(we.includePattern,x)}else return!1}):!1:!0}e.$lI=D;var s;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(s||(e.SearchErrorCode=s={}));class h extends Error{constructor(le,we){super(le),this.code=we}}e.$mI=h;function g(Y){const le=Y.message;if((0,f.$2)(Y))return new h(le,s.canceled);try{const we=JSON.parse(le);return new h(we.message,we.code)}catch{return new h(le,s.other)}}e.$nI=g;function M(Y){const le={message:Y.message,code:Y.code};return new Error(JSON.stringify(le))}e.$oI=M;function W(Y){return Y.type==="error"?!0:Y.type==="success"}e.$pI=W;function V(Y){return Y.type==="success"}e.$qI=V;function B(Y){return!!Y.path}e.$rI=B;function j(Y,le){const we=Y.searchPath?Y.searchPath:Y.relativePath;return(0,A.$be)(we,le)}e.$sI=j;class U{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$tI=U;function z(Y,le){const we={...Y||{},...le||{}};return Object.keys(we).filter(ae=>{const x=we[ae];return typeof x=="boolean"&&x})}e.$uI=z;class ie{constructor(le,we){this.c=null,this.a={...le.excludePattern||{},...we.excludePattern||{}},this.b=R.$pj(this.a);let ae=le.includePattern;we.includePattern&&(ae?ae={...ae,...we.includePattern}:ae=we.includePattern),ae&&(this.c=R.$pj(ae))}matchesExcludesSync(le,we,ae){return!!(this.b&&this.b(le,we,ae))}includedInQuerySync(le,we,ae){return!(this.b&&this.b(le,we,ae)||this.c&&!this.c(le,we,ae))}includedInQuery(le,we,ae){const x=this.b(le,we,ae),ue=()=>this.c?!!this.c(le,we,ae):!0;return(0,S.$rg)(x)?x.then(O=>O?!1:ue()):ue()}hasSiblingExcludeClauses(){return X(this.a)}}e.$vI=ie;function X(Y){for(const le in Y)if(typeof Y[le]!="boolean")return!0;return!1}function ye(Y){if(!Y)return;let le;return we=>(le||(le=(Y()||Promise.resolve([])).then(ae=>ae?Re(ae):{})),le.then(ae=>!!ae[we]))}e.$wI=ye;function De(Y){if(!Y)return;let le;return we=>{if(!le){const ae=Y();le=ae?Re(ae):{}}return!!le[we]}}e.$xI=De;function Re(Y){const le={};for(const we of Y)le[we]=!0;return le}}),define(Pe[33],Ae([1,0,18,13,21,5,6,48,12,118,23,15,2,159,4,14,176,53,39,27,17,8,7,55,47,3]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b,n,a,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=e.$Cac=void 0;function w(W,V,B){return new P.$8f(j=>s(j,B)).isEqual(W,V)}function v(W,V,B){return w(W.uri,V.uri,B)?0:(0,S.$Hd)(W.uri.toString(),V.uri.toString())}function E(W,V,B){return W.index!==V.index?W.index<V.index?-1:1:w(W.uri,V.uri,B)?(0,S.$Hd)(W.name,V.name):(0,S.$Hd)(W.uri.toString(),V.uri.toString())}function D(W,V,B,j){const U=W.slice(0).sort((ie,X)=>B(ie,X,j)),z=V.slice(0).sort((ie,X)=>B(ie,X,j));return(0,y.$xf)(U,z,(ie,X)=>B(ie,X,j))}function s(W,V){const B=V.getCapabilities(W.scheme);return!(B&&B&1024)}class h extends i.$Sh{static toExtHostWorkspace(V,B,j,U){if(!V)return{workspace:null,added:[],removed:[]};const{id:z,name:ie,folders:X,configuration:ye,transient:De,isUntitled:Re}=V,Y=[],le=B;B?X.forEach((ue,O)=>{const J=u.URI.revive(ue.uri),he=h.o(j||B,J,U);he?(he.name=ue.name,he.index=ue.index,Y.push(he)):Y.push({uri:J,name:ue.name,index:O})}):Y.push(...X.map(({uri:ue,name:O,index:J})=>({uri:u.URI.revive(ue),name:O,index:J}))),Y.sort((ue,O)=>ue.index<O.index?-1:1);const we=new h(z,ie,Y,!!De,ye?u.URI.revive(ye):null,!!Re,ue=>s(ue,U)),{added:ae,removed:x}=D(le?le.workspaceFolders:[],we.workspaceFolders,v,U);return{workspace:we,added:ae,removed:x}}static o(V,B,j){for(let U=0;U<V.folders.length;U++){const z=V.workspaceFolders[U];if(w(z.uri,B,j))return z}}constructor(V,B,j,U,z,ie,X){super(V,j.map(ye=>new i.$Th(ye)),U,z,X),this.t=B,this.u=ie,this.q=[],this.s=l.$Fh.forUris(X),j.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,B){return B&&this.s.get(V)&&(V=(0,P.$fg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let g=class{constructor(V,B,j,U,z){this.c=new L.$hc,this.onDidChangeWorkspace=this.c.event,this.g=new L.$hc,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$jc,this.B=new Map,this.h=U,this.s=j,this.t=z,this.j=new f.$Hl,this.k=new R.$Dg,this.o=V.getProxy(o.$QJ.MainThreadWorkspace),this.q=V.getProxy(o.$QJ.MainThreadMessageService);const ie=B.workspace;this.l=ie?new h(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,X=>s(X,j)):void 0}$initializeWorkspace(V,B){this.v=B,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:I.Schemas.untitled,path:(0,P.$dg)((0,P.$fg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,B,j,...U){const z=[];if(Array.isArray(U)&&U.forEach(Re=>{u.URI.isUri(Re.uri)&&!z.some(Y=>w(Y.uri,Re.uri,this.s))&&z.push({uri:Re.uri,name:Re.name||(0,P.$cg)(Re.uri)})}),this.n||[B,j].some(Re=>typeof Re!="number"||Re<0)||j===0&&z.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(B+j>ie.length)return!1;const X=ie.slice(0);X.splice(B,j,...z.map(Re=>({uri:Re.uri,name:Re.name||(0,P.$cg)(Re.uri),index:void 0})));for(let Re=0;Re<X.length;Re++){const Y=X[Re];if(X.some((le,we)=>we!==Re&&w(Y.uri,le.uri,this.s)))return!1}X.forEach((Re,Y)=>Re.index=Y);const{added:ye,removed:De}=D(ie,X,E,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const Re=V.displayName||V.name;this.o.$updateWorkspaceFolders(Re,B,j,z).then(void 0,Y=>{this.n=void 0;const le={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Re,Y.toString()),le,[])})}return this.y(X),!0}getWorkspaceFolder(V,B){if(this.x)return this.x.getWorkspaceFolder(V,B)}async getWorkspaceFolder2(V,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,B)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,B){let j,U="";if(typeof V=="string"?(j=u.URI.file(V),U=V):typeof V<"u"&&(j=V,U=V.fsPath),!j)return U;const z=this.getWorkspaceFolder(j,!0);if(!z)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let ie=(0,P.$ig)(z.uri,j);return B&&z.name&&(ie=`${z.name}/${ie}`),ie}y(V){this.x&&(this.n=h.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:B,added:j,removed:U}=h.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:U}))}findFiles(V,B,j,U,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ie;if(B===null?ie=!1:B&&(typeof B=="string"?ie=B:ie=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:ye}=M(b.GlobPattern.from(V));return this.o.$startFileSearch(X??null,ye??null,ie??null,j??null,z).then(De=>Array.isArray(De)?De.map(Re=>u.URI.revive(Re)):[])}async findTextInFiles(V,B,j,U,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),X=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ye,folder:De}=M(b.GlobPattern.from(B.include)),Re=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,Y={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:X,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ye,excludePattern:Re},le=!1;if(this.u[ie]=we=>{if(le)return;const ae=u.URI.revive(we.resource);we.results.forEach(x=>{(0,r.$dI)(x)?j({uri:ae,preview:{text:x.preview.text,matches:(0,y.$Uf)(x.preview.matches,ue=>new n.$UJ(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))},ranges:(0,y.$Uf)(x.ranges,ue=>new n.$UJ(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))}):j({uri:ae,text:x.text,lineNumber:x.lineNumber})})},z.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(V,De??null,Y,ie,z);return delete this.u[ie],we||{}}catch(we){throw delete this.u[ie],we}}$handleTextSearchResult(V,B){this.u[B]?.(V)}async save(V){const B=await this.o.$save(V,{saveAs:!1});return u.URI.revive(B)}async saveAs(V){const B=await this.o.$save(V,{saveAs:!0});return u.URI.revive(B)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,B){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,B);const j=this.t.transformOutgoingScheme(V),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,j),(0,A.$kb)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(V,B){this.h.info("Getting edit session identifier for workspaceFolder",V);const j=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(j,B);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(V,B,j,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const z=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const ie=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!ie),!ie)return;const X=await ie.provideEditSessionIdentityMatch?.(B,j,U);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(V){return(B,j,U)=>{const z=function(X){B.call(j,X)};return z.extension=V,this.A.event(z,void 0,U)}}async $onWillCreateEditSessionIdentity(V,B,j){const U=await this.resolveWorkspaceFolder(u.URI.revive(V));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},B,async(z,ie)=>{const X=Date.now();await Promise.resolve(z),Date.now()-X>j&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(V,B){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,B);const j=this.t.transformOutgoingScheme(V),U=this.z++;return this.o.$registerCanonicalUriProvider(U,j),(0,A.$kb)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(V,B,j){const U=this.B.get(V.scheme);if(!U)return;const z=await U.provideCanonicalUri?.(u.URI.revive(V),B,j);if(z)return z}async $provideCanonicalUri(V,B,j){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:B},j)}};e.$Cac=g,e.$Cac=g=Ke([Ve(0,k.$SL),Ve(1,m.$9L),Ve(2,c.$qac),Ve(3,d.$3i),Ve(4,a.$Aac)],g),e.$Dac=(0,$.$zh)("IExtHostWorkspace");function M(W){let V,B;return W&&(typeof W=="string"?V=W:(V=W.pattern,B=u.URI.revive(W.baseUri))),{includePattern:V,folder:B}}}),define(Pe[34],Ae([1,0,24,5,33,3,7,178,96,16,13,4,17,14,2]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=e.$Eac=void 0;function d(a,r){if(r){const o=r.split(".");let w=a;for(let v=0;w&&v<o.length;v++)w=w[o[v]];return w}}function t(a){return a instanceof $.URI}function i(a){return a&&a.uri instanceof $.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function m(a){return a&&a.uri instanceof $.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function k(a){if(t(a))return{resource:a};if(i(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(m(a))return{resource:a.uri};if(a===null)return{resource:null}}let b=class{constructor(r,o,w){this.a=r.getProxy(L.$QJ.MainThreadConfiguration),this.c=o,this.b=w,this.d=new P.$Dg,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new n(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(r,o))}};e.$Eac=b,e.$Eac=b=Ke([Ve(0,u.$SL),Ve(1,C.$Dac),Ve(2,p.$3i)],b);class n{constructor(r,o,w,v){this.a=new R.$hc,this.b=r,this.f=v,this.c=o,this.e=l.$rn.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,o){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$rn.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(o,w))}getConfiguration(r,o,w){const v=k(o)||{},E=this.g(r?d(this.e.getValue(void 0,v,this.c.workspace),r):this.e.getValue(void 0,v,this.c.workspace));r&&this.h(r,v,w?.identifier);function D(h){if(h==null)return null;if(typeof h=="boolean")return h?2:5;switch(h){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const s={has(h){return typeof d(E,h)<"u"},get:(h,g)=>{this.h(r?`${r}.${h}`:h,v,w?.identifier);let M=d(E,h);if(typeof M>"u")M=g;else{let W;const V=(B,j)=>{if((0,f.$ne)(B)){let U;const z=()=>{W=W||(0,y.$Tm)(E),U=U||d(W,j)};return new Proxy(B,{get:(ie,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return z(),()=>U;if(W)return U=U||d(W,j),U[X];const ye=ie[X];return typeof X=="string"?V(ye,`${j}.${X}`):ye},set:(ie,X,ye)=>(z(),U&&(U[X]=ye),!0),deleteProperty:(ie,X)=>(z(),U&&delete U[X],!0),defineProperty:(ie,X,ye)=>(z(),U&&Object.defineProperty(U,X,ye),!0)})}return Array.isArray(B)?(0,y.$Tm)(B):B};M=V(M,h)}return M},update:(h,g,M,W)=>{h=r?`${r}.${h}`:h;const V=D(M);return g!==void 0?this.b.$updateConfigurationOption(V,h,g,v,W):this.b.$removeConfigurationOption(V,h,v,W)},inspect:h=>{h=r?`${r}.${h}`:h;const g=this.e.inspect(h,v,this.c.workspace);if(g)return{key:h,defaultValue:(0,y.$Tm)(g.policy?.value??g.default?.value),globalValue:(0,y.$Tm)(g.user?.value??g.application?.value),workspaceValue:(0,y.$Tm)(g.workspace?.value),workspaceFolderValue:(0,y.$Tm)(g.workspaceFolder?.value),defaultLanguageValue:(0,y.$Tm)(g.default?.override),globalLanguageValue:(0,y.$Tm)(g.user?.override??g.application?.override),workspaceLanguageValue:(0,y.$Tm)(g.workspace?.override),workspaceFolderLanguageValue:(0,y.$Tm)(g.workspaceFolder?.override),languageIds:(0,y.$Tm)(g.overrideIdentifiers)}}};return typeof E=="object"&&(0,y.$Wm)(s,E,!1),Object.freeze(s)}g(r){const o=w=>(0,f.$ne)(w)?new Proxy(w,{get:(v,E)=>o(v[E]),set:(v,E,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(v,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(v,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(r)}h(r,o,w){const v=I.$in.test(r)?4:this.d.get(r),E=w?`[${w.value}] `:"";if(v===4){typeof o?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){o?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,o){const w=new l.$tn(r,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(v,E)=>w.affectsConfiguration(v,k(E))})}k(r){return r.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.$Fac=n,e.$Gac=(0,S.$zh)("IExtHostConfiguration")}),define(Pe[112],Ae([1,0,2,13,5,3,7,33,59,34,21,62,17,27,4,12,22,14,80,215,9]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=e.$Cbc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var b;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(b||(b={}));var n;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(n||(n={}));var a;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(a||(a={}));var r;(function(V){function B(z){if(z){const ie=z;return ie&&!!ie.process}else return!1}V.is=B;function j(z){if(z==null)return;const ie={process:z.process,args:z.args};return z.options&&(ie.options=a.from(z.options)),ie}V.from=j;function U(z){if(z!=null)return new A.$BK(z.process,z.args,z.options)}V.to=U})(r||(r={}));var o;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(o||(o={}));var w;(function(V){function B(z){if(z){const ie=z;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}V.is=B;function j(z){if(z==null)return;const ie={};return z.commandLine!==void 0?ie.commandLine=z.commandLine:(ie.command=z.command,ie.args=z.args),z.options&&(ie.options=o.from(z.options)),ie}V.from=j;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$CK(z.commandLine,z.options):new A.$CK(z.command,z.args?z.args:[],z.options)}V.to=U})(w||(w={}));var v;(function(V){function B(z){if(z){const ie=z;return ie&&ie.customExecution==="customExecution"}else return!1}V.is=B;function j(z){return{customExecution:"customExecution"}}V.from=j;function U(z,ie){return ie.get(z)}V.to=U})(v||(e.CustomExecutionDTO=v={}));var E;(function(V){function B(j,U){let z;return j.scope!==void 0&&typeof j.scope!="number"?z=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=m.$7F),{id:j._id,workspaceFolder:z}}V.from=B})(E||(e.TaskHandleDTO=E={}));var D;(function(V){function B(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}V.from=B})(D||(D={}));var s;(function(V){function B(z,ie){if(z==null)return[];const X=[];for(const ye of z){const De=j(ye,ie);De&&X.push(De)}return X}V.fromMany=B;function j(z,ie){if(z==null)return;let X;z.execution instanceof A.$BK?X=r.from(z.execution):z.execution instanceof A.$CK?X=w.from(z.execution):z.execution&&z.execution instanceof A.$DK&&(X=v.from(z.execution));const ye=b.from(z.definition);let De;return z.scope?typeof z.scope=="number"?De=z.scope:De=z.scope.uri:De=A.TaskScope.Workspace,!ye||!De?void 0:{_id:z._id,definition:ye,name:z.name,source:{extensionId:ie.identifier.value,label:z.source,scope:De},execution:X,isBackground:z.isBackground,group:D.from(z.group),presentationOptions:n.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=j;async function U(z,ie,X){if(z==null)return;let ye;r.is(z.execution)?ye=r.to(z.execution):w.is(z.execution)?ye=w.to(z.execution):v.is(z.execution)&&(ye=v.to(z._id,X));const De=b.to(z.definition);let Re;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Re=z.source.scope:Re=await ie.resolveWorkspaceFolder(y.URI.revive(z.source.scope)):Re=A.TaskScope.Workspace),!De||!Re)return;const Y=new A.$EK(De,Re,z.name,z.source.label,ye,z.problemMatchers);return z.isBackground!==void 0&&(Y.isBackground=z.isBackground),z.group!==void 0&&(Y.group=A.$AK.from(z.group._id),Y.group&&z.group.isDefault&&(Y.group=new A.$AK(Y.group.id,Y.group.label),z.group.isDefault===!0&&(Y.group.isDefault=z.group.isDefault))),z.presentationOptions&&(Y.presentationOptions=n.to(z.presentationOptions)),z._id&&(Y._id=z._id),z.detail&&(Y.detail=z.detail),Y}V.to=U})(s||(e.TaskDTO=s={}));var h;(function(V){function B(U){return U}V.from=B;function j(U){if(U)return Object.assign(Object.create(null),U)}V.to=j})(h||(h={}));class g{#e;constructor(B,j,U){this._id=j,this.a=U,this.#e=B}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}let M=class{constructor(B,j,U,z,ie,X,ye,De){this.q=new C.$hc,this.r=new C.$hc,this.s=new C.$hc,this.t=new C.$hc,this.a=B.getProxy(L.$QJ.MainThreadTask),this.b=U,this.c=z,this.d=ie,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,j,U){if(!U)return new A.$SJ(()=>{});const z=this.w();return this.j.set(z,{type:j,provider:U,extension:B}),this.a.$registerTaskProvider(z,j),new A.$SJ(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(B,j){this.a.$registerTaskSystem(B,j)}fetchTasks(B){return this.a.$fetchTasks(h.from(B)).then(async j=>{const U=[];for(const z of j){const ie=await s.to(z,this.b,this.m);ie&&U.push(ie)}return U})}get taskExecutions(){const B=[];return this.k.forEach(j=>B.push(j)),B}terminateTask(B){if(!(B instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,j,U){const z=this.m.get(B.id);z&&(this.o.set(B.id,z),this.e.attachPtyToTerminal(j,await z.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const j=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const j=await this.y(B.id);this.s.fire({execution:j,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const j=await this.y(B.id);this.t.fire({execution:j,exitCode:B.exitCode})}$provideTasks(B,j){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const z=[],ie=(0,R.$xg)(()=>U.provider.provideTasks(P.CancellationToken.None)).then(X=>this.u(j,z,U,X));return new Promise(X=>{ie.then(ye=>{Promise.all(z).then(()=>{X(ye)})})})}async $resolveTask(B,j){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await s.to(j,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ie=await U.provider.resolveTask(z,P.CancellationToken.None);if(!ie)return;this.z(ie,U);const X=s.from(ie,U.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(X.execution)&&await this.x(X,ie,!0),await this.v(X)}w(){return this.h++}async x(B,j,U){const z=await this.a.$createTaskId(B);!U&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,j.execution)),this.m.set(z,j.execution)}async y(B,j){if(typeof B=="string"){const ie=this.l.get(B);if(!ie)throw new k.$_("Unexpected: The specified task is missing an execution");return ie}const U=this.l.get(B.id);if(U)return U;const z=new Promise((ie,X)=>{function ye(De,Re,Y){Y?ie(new g(De,Re.id,Y)):X("Unexpected: Task does not exist.")}j?ye(this,B,j):s.to(B.task,this.b,this.m).then(De=>ye(this,B,De))});return this.l.set(B.id,z),z.then(ie=>(this.k.set(B.id,ie),ie),ie=>Promise.reject(ie))}z(B,j){B._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let z=U.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=U.next()}};e.$Cbc=M,e.$Cbc=M=Ke([Ve(0,u.$SL),Ve(1,p.$9L),Ve(2,l.$Dac),Ve(3,I.$4L),Ve(4,f.$Gac),Ve(5,S.$Yac),Ve(6,i.$3i),Ve(7,c.$tac)],M);let W=class extends M{constructor(B,j,U,z,ie,X,ye,De){super(B,j,U,z,ie,X,ye,De),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(B,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=s.from(j,B);if(U===void 0)throw new Error("Task is not valid");if(v.is(U.execution))await this.x(U,j,!1);else throw new k.$0;const z=await this.y(await this.a.$getTaskExecution(U),j);return this.a.$executeTask(U).catch(ie=>{throw new Error(ie)}),z}u(B,j,U,z){const ie=[];if(z)for(const X of z){this.z(X,U),(!X.definition||!B[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=s.from(X,U.extension);ye&&v.is(ye.execution)?(ie.push(ye),j.push(this.x(ye,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:U.extension}}async v(B){if(v.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,j,U){}};e.$Dbc=W,e.$Dbc=W=Ke([Ve(0,u.$SL),Ve(1,p.$9L),Ve(2,l.$Dac),Ve(3,I.$4L),Ve(4,f.$Gac),Ve(5,S.$Yac),Ve(6,i.$3i),Ve(7,c.$tac)],W),e.$Ebc=(0,$.$zh)("IExtHostTask")}),define(Pe[266],Ae([1,0,19,21,41,37,23,58,47]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class f{constructor(u,p,$){this.k=u,this.l=p,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&L.$pj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&L.$pj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const p=this.k.folderQueries||[];return new Promise(($,d)=>{const t=i=>{this.f++,u(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),m=y.$cd(c);this.j&&this.j(c,m)||this.v(t,{base:i,basename:m})}),Promise.all(p.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{d(new Error((0,C.$ki)(i)))})})}async p(u,p){const $=new R.$rc,d=this.q(u),t=this.r(),i=new I.$vI(this.k,u),c=!i.hasSiblingExcludeClauses();let m;try{this.h.add($),m=l.$dc.create();const k=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,$.token),b=m.elapsed(),n=l.$dc.create();return this.g&&!this.e||(k&&k.forEach(a=>{const r=y.$8c.relative(u.folder.path,a.path);if(c){const o=y.$cd(a.path);this.v(p,{base:u.folder,relativePath:r,basename:o});return}this.s(t,u.folder,r,p)}),this.g&&!this.e)?null:(this.u(t,i,p),{providerTime:b,postProcessTime:n.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(u){const p=(0,I.$uI)(this.k.includePattern,u.includePattern),$=(0,I.$uI)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:$,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},p,$,d){if($===this.a){const i=y.$cd(this.a);this.v(d,{base:p,relativePath:this.a,basename:i})}function t(i){const c=y.$cd(i),m=y.$bd(i);let k=u[m];k||(k=u[m]=[],t(m)),k.push({base:p,relativePath:i,basename:c})}t($)}u({rootEntries:u,pathToEntries:p},$,d){const t=this,i=this.a;function c(m){const k=(0,I.$xI)(()=>m.map(b=>b.basename));for(let b=0,n=m.length;b<n;b++){const a=m[b],{relativePath:r,basename:o}=a;if($.matchesExcludesSync(r,o,i!==o?k:void 0))continue;const w=p[r];if(w)c(w);else{if(r===i)continue;t.v(d,a)}if(t.e)break}}c(u)}v(u,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(p))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,p,$,d){const t=this.c(u.cacheKey),i=new f(u,p,t&&t.token);let c=0;const m=k=>{c+=k.length,$(k.map(b=>this.d(b)))};return this.e(i,P.a,m,d).then(k=>({limitHit:k.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:k.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new R.$rc),this.b.get(u)}d(u){return u.relativePath?{resource:A.$gg(u.base,u.relativePath)}:{resource:u.base}}e(u,p,$,d){const t=d.onCancellationRequested(()=>{u.cancel()}),i=m=>{m&&(c.push(m),p>0&&c.length>=p&&($(c),c=[]))};let c=[];return u.search(i).then(m=>(c.length&&$(c),t.dispose(),m),m=>(c.length&&$(c),t.dispose(),Promise.reject(m)))}}e.$Obc=P}),define(Pe[267],Ae([1,0,18,100,37,90,28,12,19,23,15,16,2,282,168,43,14,53,103,265,47]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.$oJ=void 0;let b=class{constructor(h,g,M,W,V){this.a=h,this.b=g,this.c=M,this.d=W,this.e=V}text(h,g,M={}){h=this.f(h,M);const W=this.a.getValue(),V=g&&g.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(g?.map(i.$Uh),M),type:2,contentPattern:h,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:W.search.usePCRE2||V||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(h,g){const M=this.a.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const W={...h,wordSeparators:M.editor.wordSeparators};return this.j(h,g)&&(W.isCaseSensitive=!0),this.k(h)&&(W.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),W}file(h,g={}){return{...this.h(h,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}g(h,g){return h?(h=Array.isArray(h)?h.map(w):w(h),g?this.parseSearchPaths(h):{pattern:a(...Array.isArray(h)?h:[h])}):{}}h(h=[],g={}){const M=this.g(g.includePattern,g.expandPatterns),W=this.g(g.excludePattern,g.expandPatterns),V=h.length>1,B=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(z=>this.q(z,g,W)):h.map(z=>this.r(z,g,W,V))).filter(z=>!!z),j={_reason:g._reason,folderQueries:B,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:W.pattern,includePattern:M.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const z=y.$Af(y.$Kf(this.c.groups.map(ye=>ye.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const ie=z.filter(ye=>(0,k.$lI)(j,ye.fsPath)),X=this.i(ie);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...j,...X}}const U=g.extraFileResources&&g.extraFileResources.filter(z=>(0,k.$lI)(j,z.fsPath));return j.extraFileResources=U&&U.length?U:void 0,j}i(h){const g=[],M=new A.$xi,W={};let V=!1;return h.forEach(B=>{if(B.scheme===l.Schemas.walkThrough)return;if((0,f.$kg)(B)){const U=this.b.getWorkspaceFolder(B)?.uri??B.with({path:I.$bd(B.fsPath)});let z=M.get(U);z||(V=!0,z={folder:U,includePattern:{}},g.push(z),M.set(U,z));const ie=I.$ad(U.fsPath,B.fsPath);(0,S.$we)(z.includePattern)[ie.replace(/\\/g,"/")]=!0}else B.fsPath&&(V=!0,W[B.fsPath]=!0)}),{folderQueries:g,includePattern:W,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(h,g){if(g.isSmartCase){if(h.isRegExp){if(P.$ce(h.pattern,!0))return!0}else if(P.$ce(h.pattern))return!0}return!!h.isCaseSensitive}k(h){return h.isMultiline||h.isRegExp&&(0,p.$eC)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const g=X=>I.$0c(X)||/^\.\.?([\/\\]|$)/.test(X),W=(Array.isArray(h)?h:r(h)).map(X=>{const ye=this.e.resolvedUserHome;return ye?(0,L.$dA)(X,ye.scheme===l.Schemas.file?ye.fsPath:ye.path):X}),V=R.$I(W,X=>g(X)?"searchPaths":"exprSegments"),B=(V.exprSegments||[]).map(X=>P.$xd(X,"/")).map(X=>P.$xd(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),j={},U=this.m(V.searchPaths||[]);U&&U.length&&(j.searchPaths=U);const z=y.$Kf(B),ie=a(...z);return ie&&(j.pattern=ie),j}l(h,g){return g.disregardExcludeSettings?void 0:(0,k.$kI)(h,!g.disregardSearchExcludeSettings)}m(h){if(!h||!h.length)return[];const g=h.flatMap(W=>{let{pathPortion:V,globPortion:B}=n(W);return B&&(B=v(B)),this.n(V).flatMap(U=>this.o(U,B))}),M=new Map;return g.forEach(W=>{const V=W.searchPath.toString(),B=M.get(V);B?W.pattern&&(B.pattern=B.pattern||{},B.pattern[W.pattern]=!0):M.set(V,{searchPath:W.searchPath,pattern:W.pattern?a(W.pattern):void 0})}),Array.from(M.values())}n(h){if(I.$0c(h)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==l.Schemas.file?[{searchPath:g[0].uri.with({path:h})}]:[{searchPath:u.URI.file(I.$9c(h))}]}if(this.b.getWorkbenchState()===2){const g=this.b.getWorkspace().folders[0].uri;if(h=w(h),h.startsWith("../")||h===".."){const W=I.$8c.resolve(g.path,h);return[{searchPath:g.with({path:W})}]}const M=v(h);return[{searchPath:g,pattern:M}]}else{if(h==="./"||h===".\\")return[];{const g=h.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(V=>{const B=g.match(new RegExp(`^${P.$sd(V.name)}(?:/(.*)|$)`));return B?{match:B,folder:V}:null}).filter(S.$te);if(W.length)return W.map(V=>{const B=V.match[1];return{searchPath:V.folder.uri,pattern:B&&v(B)}});{const V=h.match(/\.[\/\\](.+)[\/\\]?/),B=V?V[1]:h,j=$.localize(0,null,B);throw new Error(j)}}}}o(h,g){const M=h.pattern&&g?`${h.pattern}/${g}`:h.pattern||g,W=[{searchPath:h.searchPath,pattern:M}];return M&&!M.endsWith("**")&&W.push({searchPath:h.searchPath,pattern:M+"/**"}),W}q(h,g,M){const W=this.r((0,i.$Uh)(h.searchPath),g,M,!1);return W?{...W,includePattern:h.pattern}:null}r(h,g,M,W){let V;const B=u.URI.isUri(h)?h:h.uri;if(M.searchPaths){const X=M.searchPaths.filter(ye=>(0,f.$_f)(ye.searchPath,B))[0];if(X&&!X.pattern)return null;X&&(V=X.pattern)}const j=this.a.getValue({resource:B}),z={...this.l(j,g)||{},...V||{}},ie=u.URI.isUri(h)?(0,f.$dg)(h):h.name;return{folder:B,folderName:W?ie:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!j.search.followSymlinks}}};e.$oJ=b,e.$oJ=b=Ke([Ve(0,d.$6h),Ve(1,i.$Ih),Ve(2,c.$1C),Ve(3,t.$3i),Ve(4,m.$mJ)],b);function n(s){const h=s.match(/[\*\{\}\(\)\[\]\?]/);if(h){const g=h.index,M=s.substr(0,g).match(/[/|\\][^/\\]*$/);if(M){let W=s.substr(0,M.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:s.substr((M.index||0)+1)}}}return{pathPortion:s}}function a(...s){return s.length?s.reduce((h,g)=>(h[g]=!0,h),Object.create(null)):void 0}function r(s){return C.$nj(s,",").map(h=>h.trim()).filter(h=>!!h.length)}function o(s){return[`**/${s}/**`,`**/${s}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function w(s){return s.replace(/\\/g,"/")}function v(s){return w(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(s){return s.replace(/([?*[\]])/g,"[$1]")}function D(s,h){s=y.$Ff(s,W=>W.toString());const g=[],M=h.getWorkspace();return s&&s.forEach(W=>{let V;if(h.getWorkbenchState()===2)V=(0,f.$ig)(M.folders[0].uri,W),V&&V!=="."&&(V="./"+V);else{const B=h.getWorkspaceFolder(W);if(B){const j=B.name;if(M.folders.filter(z=>z.name===j).length===1){const z=(0,f.$ig)(B.uri,W);z===""?V=`./${B.name}`:V=`./${B.name}/${z}`}else V=W.fsPath}}V&&g.push(E(V))}),g}e.$pJ=D}),define(Pe[268],Ae([1,0,23,2,21,9,4,267,47,53]),function(pe,e,y,R,C,L,A,l,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kb=e.$0kb=void 0;const P=7e3;function S(d,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],m=[];for(const o of i)if(/^workspaceContains:/.test(o)){const w=o.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||d.forceUsingSearch?m.push(w):c.push(w)}if(c.length===0&&m.length===0)return Promise.resolve(void 0);let k;const b=new Promise((o,w)=>{k=o}),n=o=>k({activationEvent:o}),a=Promise.all(c.map(o=>u(d,o,n))).then(()=>{}),r=p(d,t.identifier,m,n);return Promise.all([a,r]).then(()=>{k(void 0)}),b}e.$0kb=S;async function u(d,t,i){for(const c of d.folders)if(await d.exists(y.$gg(R.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function p(d,t,i,c){if(i.length===0)return Promise.resolve(void 0);const m=new C.$rc,k=d.checkExists(d.folders,i,m.token),b=setTimeout(async()=>{m.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let n=!1;try{n=await k}catch(a){L.$2(a)||L.$Y(a)}m.dispose(),clearTimeout(b),n&&c(`workspaceContains:${i.join(",")}`)}function $(d,t,i,c){const m=d.get(A.$yh),k=d.get(I.$cI),n=m.createInstance(l.$oJ).file(t.map(a=>(0,f.$Uh)(R.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return k.fileSearch(n,c).then(a=>!!a.limitHit,a=>L.$2(a)?!1:Promise.reject(a))}e.$$kb=$}),define(Pe[35],Ae([1,0,149,19,87,23,13,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,71,86,62,5,268,83,191,12,81,58,22,82]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b,n,a,r,o,w,v,E,D,s,h,g,M,W,V,B,j,U,z){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=e.$abc=e.$_ac=e.$$ac=e.$0ac=void 0,e.$0ac=(0,r.$zh)("IHostUtils");let X=ie=class extends l.$mb{constructor(x,ue,O,J,he,Ee,ve,be,ke,oe,de,se){super(),this.R=se,this.a=this.B(new h.$hc),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=ue,this.g=O,this.f=ve,this.j=J,this.k=he,this.l=Ee,this.m=ke,this.p=oe,this.s=de,this.t=this.g.getProxy(S.$QJ.MainThreadWorkspace),this.u=this.g.getProxy(S.$QJ.MainThreadTelemetry),this.v=this.g.getProxy(S.$QJ.MainThreadExtensionService),this.w=new A.$Dg,this.y=new A.$Dg,this.z=new A.$Dg,this.C=new A.$Dg,this.D=new we(this.f.activationEvents),this.G=new i.$W2b(this.D,this.f.allExtensions);const ne=new m.$Ul(this.f.myExtensions);this.F=new i.$W2b(this.D,Y(this.G,ne)),this.H=new $.$Qac(this.g,this.l),this.I=new M.$3ac(this.g),this.J=be,this.h=x.createChild(new E.$xh([$.$Rac,this.H],[M.$4ac,this.I])),this.L=this.B(new p.$Pac(this.F,this.G,{onExtensionActivationError:(me,Ce,F)=>{this.v.$onExtensionActivationError(me,c.$1(Ce),F)},actualActivateExtension:async(me,Ce)=>{if(i.$W2b.isHostExtension(me,this.F,this.G))return await this.v.$activateExtension(me,Ce),new p.$Oac;const F=this.F.getExtensionDescription(me);return this.$(F,Ce)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(x){c.$Y(x)}}async S(){this.J.onWillDeactivateAll();let x=[];try{x=this.F.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.Z(he))}catch{}await Promise.all(x)}terminate(x,ue=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${x}`),this.l.flush(),this.p.dispose(),this.L.dispose(),c.setUnexpectedErrorHandler(J=>{this.l.error(J)}),this.g.dispose();const O=this.S();Promise.race([(0,A.$Fg)(5e3),O]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${ue}`):this.l.info(`Extension host exiting with code ${ue}`),this.l.flush(),this.l.dispose(),this.c.exit(ue)})}isActivated(x){return this.z.isOpen()?this.L.isActivated(x):!1}async getExtension(x){const ue=await this.v.$getExtension(x);return ue&&{...ue,identifier:new m.$Tl(ue.identifier.value),extensionLocation:f.URI.revive(ue.extensionLocation)}}U(x,ue){return this.L.activateByEvent(x,ue)}W(x,ue){return this.L.activateById(x,ue)}activateByIdWithErrors(x,ue){return this.W(x,ue).then(()=>{const O=this.L.getActivatedExtension(x);if(O.activationFailed)return Promise.reject(O.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(x=>this.F)}getExtensionExports(x){if(this.z.isOpen())return this.L.getActivatedExtension(x).exports;try{return this.L.getActivatedExtension(x).exports}catch{return null}}async X(x){if(x.scheme===V.Schemas.file&&this.c.fsRealpath){const ue=await this.c.fsRealpath(x.fsPath);return f.URI.file(ue)}return x}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(x=>new le(x))),this.M}async Y(x){const ue=I.$Fh.forUris(O=>L.$0f.ignorePathCasing(O));return await Promise.all(x.map(async O=>{if(this.qb(O)){const J=await this.X(O.extensionLocation);ue.set(J,O)}})),ue}Z(x){let ue=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(x))return ue;const O=this.L.getActivatedExtension(x);if(!O)return ue;try{typeof O.module.deactivate=="function"&&(ue=Promise.resolve(O.module.deactivate()).then(void 0,J=>(this.l.error(J),Promise.resolve(void 0))))}catch(J){this.l.error(`An error occurred when deactivating the extension '${x.value}':`),this.l.error(J)}try{(0,l.$hb)(O.subscriptions)}catch(J){this.l.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.l.error(J)}return ue}async $(x,ue){return this.f.remote.isRemote?this.v.$onWillActivateExtension(x.identifier):await this.v.$onWillActivateExtension(x.identifier),this.bb(x,ue).then(O=>{const J=O.activationTimes;return this.v.$onDidActivateExtension(x.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,ue),this.ab(x,ue,"success",J),O},O=>{throw this.ab(x,ue,"failure"),O})}ab(x,ue,O,J){const he=De(x,ue);this.u.$publicLog2("extensionActivationTimes",{...he,...J||{},outcome:O})}bb(x,ue){const O=De(x,ue);this.u.$publicLog2("activatePlugin",O);const J=this.qb(x);if(!J)return Promise.resolve(new p.$Nac(p.$Kac.NONE));this.l.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${x.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this.l.flush();const he=new p.$Lac(ue.startup);return Promise.all([this.rb(x,(0,L.$gg)(x.extensionLocation,J),he),this.cb(x)]).then(Ee=>(C.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),ie.db(this.l,x.identifier,Ee[0],Ee[1],he))).then(Ee=>(C.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Ee))}cb(x){const ue=new b.$Tac(x,this.H),O=new b.$Sac(x.identifier.value,!1,this.H),J=new W.$5ac(x,this.I),he=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Ee=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([ue.whenReady,O.whenReady,this.J.whenReady]).then(()=>{const ve=this;let be,ke;const oe=(0,t.$KF)(x,"ipc")?this.f.messagePorts?.get(m.$Tl.toKey(x.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:O,secrets:J,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(de){return R.$$c(x.extensionLocation.fsPath,de)},get storagePath(){return ve.J.workspaceValue(x)?.fsPath},get globalStoragePath(){return ve.J.globalValue(x).fsPath},get logPath(){return R.$$c(ve.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return f.URI.joinPath(ve.f.logsLocation,x.identifier.value)},get storageUri(){return ve.J.workspaceValue(x)},get globalStorageUri(){return ve.J.globalValue(x)},get extensionMode(){return he},get extension(){return be===void 0&&(be=new Re(ve,x.identifier,x,Ee,!1)),be},get extensionRuntime(){return(0,t.$LF)(x,"extensionRuntime"),ve.extensionRuntime},get environmentVariableCollection(){return ve.p.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!ke){if(!oe)return;const de=h.Event.buffer(h.Event.fromDOMEventEmitter(oe,"message",se=>se.data));oe.start(),ke={onDidReceiveMessage:de,postMessage:oe.postMessage.bind(oe)}}return ke}})})}static db(x,ue,O,J,he){return O=O||{activate:void 0,deactivate:void 0},this.eb(x,ue,O,J,he).then(Ee=>new p.$Mac(!1,null,he.build(),O,Ee,J.subscriptions))}static eb(x,ue,O,J,he){if(typeof O.activate=="function")try{he.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const Ee=typeof global=="object"?global:self,ve=O.activate.apply(Ee,[J]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(ve).then(be=>(he.activateResolveStop(),be))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(O)}fb(x,ue){this.W(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:ue}).then(void 0,O=>{this.l.error(O)})}gb(x,ue=0){const J=Date.now();(0,U.$A)(()=>{for(let he=ue;he<x.length;he+=1){const Ee=x[he];for(const ve of Ee.activationEvents??[])if(ve==="onStartupFinished")if(Date.now()-J>50){this.gb(x,he);break}else this.fb(Ee,ve)}})}hb(){this.v.$setPerformanceMarks(C.getMarks()),this.k.getConfigProvider().then(x=>{const ue=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),O=this.F.getAllExtensionDescriptions();if(ue)this.gb(O);else for(const J of O)if(J.activationEvents)for(const he of J.activationEvents)he==="onStartupFinished"&&this.fb(J,he)})}ib(){const x=this.U("*",!0).then(void 0,Ee=>{this.l.error(Ee)});this.B(this.j.onDidChangeWorkspace(Ee=>this.jb(Ee.added)));const ue=this.j.workspace?this.j.workspace.folders:[],O=this.jb(ue),J=this.lb(),he=Promise.all([J,x,O]).then(()=>{});return Promise.race([he,(0,A.$Fg)(1e4)]).then(()=>{this.hb()}),he}jb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(ue=>this.kb(x,ue))).then(()=>{})}async kb(x,ue){if(this.isActivated(ue.identifier))return;const O=!this.f.remote.isRemote&&!!this.f.remote.authority,J={logService:this.l,folders:x.map(Ee=>Ee.uri),forceUsingSearch:O||!this.c.fsExists,exists:Ee=>this.c.fsExists(Ee.fsPath),checkExists:(Ee,ve,be)=>this.t.$checkExists(Ee,ve,be)},he=await(0,g.$0kb)(J,ue);if(he)return this.W(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:he.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(x){throw console.error(x),x}}async mb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:ue}=this.f.environment;if(!x||!ue)throw new Error(y.localize(0,null));const O=await this.rb(null,ue,new p.$Lac(!1));if(!O||typeof O.run!="function")throw new Error(y.localize(1,null,ue.toString()));return new Promise((J,he)=>{const Ee=(ke,oe)=>{ke?he(ke):J(typeof oe=="number"&&oe>0?1:0)},ve=(0,L.$7f)(ue),be=O.run(ve,Ee);be&&be.then&&be.then(()=>{J(0)}).catch(ke=>{he(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,A.$Fg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,ue){return this.N[x]=ue,(0,l.$kb)(()=>{delete this.N[x]})}async getRemoteExecServer(x){const{resolver:ue}=await this.ob(x);return ue?.resolveExecServer?.(x,{resolveAttempt:0})}async ob(x){const ue=x.indexOf("+");if(ue===-1)throw new n.$YJ("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const O=x.substr(0,ue);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${O}`,!1),{authorityPrefix:O,resolver:this.N[O]}}async $resolveAuthority(x,ue){const O=j.$dc.create(!1),J=()=>`[resolveAuthority(${(0,a.$Lk)(x)},${ue})][${O.elapsed()}ms] `,he=H=>this.l.info(`${J()}${H}`),Ee=H=>this.l.warn(`${J()}${H}`),ve=(H,Q=void 0)=>this.l.error(`${J()}${H}`,Q),be=H=>{if(H instanceof n.$YJ)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},ke=async H=>{he(`activating resolver for ${H}...`);const{resolver:Q,authorityPrefix:K}=await this.ob(H);if(!Q)throw ve(`no resolver for ${K}`),new n.$YJ(`No remote extension installed to resolve ${K}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:K,remoteAuthority:H}},oe=x.split(/@|%40/g).reverse();he(`activating remote resolvers ${oe.join(" -> ")}`);let de;try{de=await Promise.all(oe.map(ke)).catch(async H=>{if(!(H instanceof n.$YJ)||H._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return Ee(`resolving nested authorities failed: ${H.message}`),[await ke(x)]})}catch(H){return be(H)}const se=new A.$Pg;se.cancelAndSet(()=>he("waiting..."),1e3);let ne,me;for(const[H,{authorityPrefix:Q,resolver:K,remoteAuthority:ee}]of de.entries())try{if(H===de.length-1)he("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${Q}`),ne=await K.resolve(ee,{resolveAttempt:ue,execServer:me}),C.mark(`code/extHost/didResolveAuthorityOK/${Q}`),he("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(K,n.$XJ.isManagedResolvedAuthority(ne)?ne:void 0));else{if(he(`invoking resolveExecServer() for ${ee}`),C.mark(`code/extHost/willResolveExecServer/${Q}`),me=await K.resolveExecServer?.(ee,{resolveAttempt:ue,execServer:me}),!me)throw new n.$YJ(`Exec server was not available for ${ee}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(ce){return C.mark(`code/extHost/didResolveAuthorityError/${Q}`),ve("returned an error",ce),se.dispose(),be(ce)}se.dispose();const Ce={environmentTunnels:ne.environmentTunnels,features:ne.tunnelFeatures},F={extensionHostEnv:ne.extensionHostEnv,isTrusted:ne.isTrusted,authenticationSession:ne.authenticationSessionForInitializingExtensions?{id:ne.authenticationSessionForInitializingExtensions.id,providerId:ne.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${n.$XJ.isManagedResolvedAuthority(ne)?"managed authority":`${ne.host}:${ne.port}`}`);let q;if(n.$XJ.isManagedResolvedAuthority(ne)){const H=ue;this.R.setFactory(H,ne.makeConnection),q={authority:x,connectTo:new a.$Ik(H),connectionToken:ne.connectionToken}}else q={authority:x,connectTo:new a.$Jk(ne.host,ne.port),connectionToken:ne.connectionToken};return{type:"ok",value:{authority:q,options:F,tunnelInformation:Ce}}}async $getCanonicalURI(x,ue){this.l.info(`$getCanonicalURI invoked for authority (${(0,a.$Lk)(x)})`);const{resolver:O}=await this.ob(x);if(!O)return null;const J=f.URI.revive(ue);if(typeof O.getCanonicalURI>"u")return J;const he=await(0,A.$xg)(()=>O.getCanonicalURI(J));return he||J}$startExtensionHost(x){x.toAdd.forEach(J=>J.extensionLocation=f.URI.revive(J.extensionLocation));const{globalRegistry:ue,myExtensions:O}=ye(this.D,this.G,this.F,x);return this.G.set(ue.getAllExtensionDescriptions()),this.F.set(O),this.nb()}$activateByEvent(x,ue){return ue===1?this.w.wait().then(O=>this.U(x,!1)):this.z.wait().then(O=>this.U(x,!1))}async $activate(x,ue){return await this.z.wait(),this.F.getExtensionDescription(x)?(await this.W(x,ue),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(Ee=>Ee.extensionLocation=f.URI.revive(Ee.extensionLocation));const{globalRegistry:ue,myExtensions:O}=ye(this.D,this.G,this.F,x),J=await this.Y(O);return(await this.getExtensionPathIndex()).setSearchTree(J),this.G.set(ue.getAllExtensionDescriptions()),this.F.set(O),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const ue=k.$Hc.alloc(x),O=Math.random()%256;for(let J=0;J<x;J++)ue.writeUInt8(O,J);return ue}async $updateRemoteConnectionData(x){this.Q=x,this.a.fire()}};e.$$ac=X,e.$$ac=X=ie=Ke([Ve(0,r.$yh),Ve(1,e.$0ac),Ve(2,v.$SL),Ve(3,d.$Dac),Ve(4,u.$Gac),Ve(5,P.$3i),Ve(6,o.$9L),Ve(7,w.$Wac),Ve(8,D.$Zrb),Ve(9,s.$Yac),Ve(10,B.$7ac),Ve(11,z.$8ac)],X);function ye(ae,x,ue,O){ae.addActivationEvents(O.addActivationEvents);const J=new i.$W2b(ae,x.getAllExtensionDescriptions());J.deltaExtensions(O.toAdd,O.toRemove);const he=new m.$Ul(ue.getAllExtensionDescriptions().map(ve=>ve.identifier));for(const ve of O.myToRemove)he.delete(ve);for(const ve of O.myToAdd)he.add(ve);const Ee=Y(J,he);return{globalRegistry:J,myExtensions:Ee}}function De(ae,x){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.$_ac=(0,r.$zh)("IExtHostExtensionService");class Re{#e;#t;#i;constructor(x,ue,O,J,he){this.#e=x,this.#t=ue,this.#i=O.identifier,this.id=O.identifier.value,this.extensionUri=O.extensionLocation,this.extensionPath=R.$9c((0,L.$7f)(O.extensionLocation)),this.packageJSON=O,this.extensionKind=J,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$abc=Re;function Y(ae,x){return ae.getAllExtensionDescriptions().filter(ue=>x.has(ue.identifier))}class le{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.$bbc=le;class we{constructor(x){this.a=new m.$Vl,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)}addActivationEvents(x){for(const ue of Object.keys(x))this.a.set(ue,x[ue])}}}),define(Pe[269],Ae([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;let d=class{constructor(k,b,n,a,r,o,w){this.c=k,this.d=b,this.e=n,this.f=a,this.g=r,this.h=o,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const k=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const b=await this.g.getExtensionPathIndex();this.register(new i(this.c,b,this.d,k,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,b,this.h.environment.appUriScheme))}register(k){if("nodeModuleName"in k)if(Array.isArray(k.nodeModuleName))for(const b of k.nodeModuleName)this.a.set(b,k);else this.a.set(k.nodeModuleName,k);typeof k.alternativeModuleName=="function"&&this.b.push(b=>k.alternativeModuleName(b))}};e.$xcc=d,e.$xcc=d=Ke([Ve(2,P.$yh),Ve(3,L.$Gac),Ve(4,S.$_ac),Ve(5,f.$9L),Ve(6,u.$3i)],d);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(k){if(k.environment.appRoot&&$.a.size){const b=(0,p.$sd)(this.c(k.environment.appRoot.fsPath)),n="[a-z0-9_.-]",a=`@${n}+\\/${n}+|${n}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${b}/${r}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(k){if(!this.b)return;const b=this.b.exec(this.c(k));if(!b)return;const[,n,a,r]=b,o=$.a.get(a);if(o!==void 0)return console.warn(`${a} as been renamed to ${o}, please update your imports`),n+o+r}c(k){return k.replace(/\\/g,"/")}};t=$=Ke([Ve(0,f.$9L)],t);class i{constructor(k,b,n,a,r){this.c=k,this.d=b,this.e=n,this.f=a,this.g=r,this.nodeModuleName="vscode",this.a=new l.$Vl}load(k,b){const n=this.d.findSubstr(b);if(n){let a=this.a.get(n.identifier);return a||(a=this.c(n,this.e,this.f),this.a.set(n.identifier,a)),a}if(!this.b){let a="";this.d.forEach((r,o)=>a+=`	${o} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${b}. These are the extension path mappings: 
${a}`),this.b=this.c(A.$FF,this.e,this.f)}return this.b}}let c=class{constructor(k,b,n){this.e=k,this.f=b,this.nodeModuleName=["open","opn"],this.d=n.getProxy(C.$QJ.MainThreadTelemetry);const a=n.getProxy(C.$QJ.MainThreadWindow);this.c=(r,o)=>{const w=R.URI.parse(r);return o?this.g(r,o):w.scheme==="http"||w.scheme==="https"?a.$openUri(w,r,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?a.$openUri(w,r,{}):this.g(r,o)}}load(k,b,n){const a=this.e.findSubstr(b);return a&&(this.a=a.identifier.value,this.h()),this.b=n(k),this.c}g(k,b){return this.i(),this.b(k,b)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([Ve(2,I.$SL)],c)}),define(Pe[113],Ae([1,0,65,6,19,74,4,59,60,35,7,33,201,34]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=void 0,e.$Hbc=(0,A.$zh)("IExtHostVariableResolverProvider");class $ extends u.$TM{constructor(i,c,m,k,b,n,a){function r(){if(m){const o=m.activeEditor();if(o)return o.document.uri;const w=k.tabGroups.all.find(v=>v.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof P.$zL||w.input instanceof P.$EL)return w.input.modified;if(w.input instanceof P.$yL||w.input instanceof P.$DL||w.input instanceof P.$BL)return w.input.uri}}}super({getFolderUri:o=>{const w=n.folders.filter(v=>v.name===o);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,w)=>b.getConfiguration(void 0,o).get(w),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=r();if(o)return C.$9c(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=r();if(o){const w=c.getWorkspaceFolder(o);if(w)return C.$9c(w.uri.fsPath)}}},getSelectedText:()=>{if(m){const o=m.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(m){const o=m.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let d=class extends R.$mb{constructor(i,c,m,k,b){super(),this.b=i,this.c=c,this.g=m,this.h=k,this.i=b,this.a=new y.$T(async()=>{const n=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.i,n,r,this.j())})}getResolver(){return this.a.value}j(){}};e.$Ibc=d,e.$Ibc=d=Ke([Ve(0,f.$_ac),Ve(1,S.$Dac),Ve(2,l.$4L),Ve(3,p.$Gac),Ve(4,I.$Fbc)],d)}),define(Pe[114],Ae([1,0,13,5,2,4,3,60,35,17,7,33,194,196,34,113]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=e.$Lbc=e.$Kbc=e.$Jbc=void 0,e.$Jbc=(0,L.$zh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,r,o,w,v,E){this.E=r,this.F=o,this.G=w,this.H=v,this.I=E,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new R.$hc,this.n=new R.$hc,this.o=new R.$hc,this.u=new R.$hc,this.k=a.getProxy(A.$QJ.MainThreadDebugService),this.y=new R.$hc,this.A=new R.$hc,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(D=>{D.onDidChange(s=>{this.J(D)}),this.J(D)})}asDebugSourceUri(a,r){const o=a;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let w=`debug:${encodeURIComponent(o.path||"")}`,v="?";return r&&(w+=`${v}session=${encodeURIComponent(r.id)}`,v="&"),w+=`${v}ref=${o.sourceReference}`,C.URI.parse(w)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const r=[];for(const o of a.getAllExtensionDescriptions())if(o.contributes){const w=o.contributes.debuggers;if(w&&w.length>0)for(const v of w)(0,p.$iF)(v)&&r.push(v.type)}this.k.$registerDebugTypes(r)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const a=[];return this.w.forEach(r=>a.push(r)),a}addBreakpoints(a){const r=a.filter(v=>{const E=v.id;return this.w.has(E)?!1:(this.w.set(E,v),!0)});this.U(r,[],[]);const o=[],w=new Map;for(const v of r)if(v instanceof P.$SK){let E=w.get(v.location.uri.toString());E||(E={type:"sourceMulti",uri:v.location.uri,lines:[]},w.set(v.location.uri.toString(),E),o.push(E)),E.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof P.$TK&&o.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(a){const r=a.filter(E=>this.w.delete(E.id));this.U([],r,[]);const o=r.filter(E=>E instanceof P.$SK).map(E=>E.id),w=r.filter(E=>E instanceof P.$TK).map(E=>E.id),v=r.filter(E=>E instanceof P.$UK).map(E=>E.id);return this.k.$unregisterBreakpoints(o,w,v)}startDebugging(a,r,o){return this.k.$startDebugging(a?a.uri:void 0,r,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,r,o){if(!r)return new P.$SJ(()=>{});const w=this.d++;return this.f.push({type:a,handle:w,provider:r}),this.k.$registerDebugConfigurationProvider(a,o,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,w),new P.$SJ(()=>{this.f=this.f.filter(v=>v.provider!==r),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(a,r,o){if(!o)return new P.$SJ(()=>{});if(!this.Q(a,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.N(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:r,handle:w,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(r,w),new P.$SJ(()=>{this.h=this.h.filter(v=>v.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(a,r){if(!r)return new P.$SJ(()=>{});const o=this.i++;return this.j.push({type:a,handle:o,factory:r}),new P.$SJ(()=>{this.j=this.j.filter(w=>w.factory!==r)})}async $runInTerminal(a,r){return Promise.resolve(void 0)}async $substituteVariables(a,r){let o;const w=await this.W(a);return w&&(o={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,r)}K(a,r){if(a.type==="implementation")return new k(a.implementation)}L(){}async $startDASession(a,r){const o=this,w=await this.V(r);return this.S(this.N(w.type),w).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const E=this.M(v),D=this.K(E,w);if(!D)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const s=D;return this.B.set(a,s),this.R(w).then(h=>(h&&this.C.set(a,h),s.onMessage(async g=>{if(g.type==="request"&&g.command==="handshake"){const M=g,W={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(M.arguments.value);W.body={signature:V},s.sendResponse(W)}else throw new Error("no signer")}catch(V){W.success=!1,W.message=V.message,s.sendResponse(W)}}else h&&h.onDidSendMessage&&h.onDidSendMessage(g),g=(0,p.$nF)(g,!0),o.k.$acceptDAMessage(a,g)}),s.onError(g=>{h&&h.onError&&h.onError(g),this.k.$acceptDAError(a,g.name,g.message,g.stack)}),s.onExit(g=>{h&&h.onExit&&h.onExit(g??void 0,void 0),this.k.$acceptDAExit(a,g??void 0,void 0)}),h&&h.onWillStartSession&&h.onWillStartSession(),s.startSession()))})}$sendDAMessage(a,r){r=(0,p.$mF)(r,!1);const o=this.C.get(a);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(r),this.B.get(a)?.sendMessage(r)}$stopDASession(a){const r=this.C.get(a);this.C.delete(a),r&&r.onWillStopSession&&r.onWillStopSession();const o=this.B.get(a);return this.B.delete(a),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const r=[],o=[],w=[];if(a.added)for(const v of a.added){const E=v.id;if(E&&!this.w.has(E)){let D;if(v.type==="function")D=new P.$TK(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")D=new P.$UK(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const s=C.URI.revive(v.uri);D=new P.$SK(new P.$5J(s,new P.$TJ(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}(0,P.$QK)(D,E),this.w.set(E,D),r.push(D)}}if(a.removed)for(const v of a.removed){const E=this.w.get(v);E&&(this.w.delete(v),o.push(E))}if(a.changed){for(const v of a.changed)if(v.id){const E=this.w.get(v.id);if(E){if(E instanceof P.$TK&&v.type==="function"){const D=E;D.enabled=v.enabled,D.condition=v.condition,D.hitCondition=v.hitCondition,D.logMessage=v.logMessage,D.functionName=v.functionName}else if(E instanceof P.$SK&&v.type==="source"){const D=E;D.enabled=v.enabled,D.condition=v.condition,D.hitCondition=v.hitCondition,D.logMessage=v.logMessage,D.location=new P.$5J(C.URI.revive(v.uri),new P.$TJ(v.line,v.character))}w.push(E)}}}this.U(r,o,w)}async $acceptStackFrameFocus(a){let r;const o=a.sessionId?await this.V(a.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?r=new P.$1K(o,a.threadId):r=new P.$ZK(o,a.threadId,a.frameId),this.z=r,this.A.fire(this.z)}$provideDebugConfigurations(a,r,o){return(0,y.$xg)(async()=>{const w=this.P(a);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.W(r);return w.provideDebugConfigurations(v,o)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(a,r,o,w){return(0,y.$xg)(async()=>{const v=this.P(a);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.W(r);return v.resolveDebugConfiguration(E,o,w)})}$resolveDebugConfigurationWithSubstitutedVariables(a,r,o,w){return(0,y.$xg)(async()=>{const v=this.P(a);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.W(r);return v.resolveDebugConfigurationWithSubstitutedVariables(E,o,w)})}async $provideDebugAdapter(a,r){const o=this.O(a);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(r);return this.S(o,w).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(v)})}async $acceptDebugSessionStarted(a){const r=await this.V(a);this.m.fire(r)}async $acceptDebugSessionTerminated(a){const r=await this.V(a);r&&(this.n.fire(r),this.l.delete(r.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,r){(await this.V(a))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(a,r){const w={session:await this.V(a),event:r.event,body:r.body};this.u.fire(w)}M(a){if(a instanceof P.$VK)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.$WK)return{type:"server",port:a.port,host:a.host};if(a instanceof P.$XK)return{type:"pipeServer",path:a.path};if(a instanceof P.$YK)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const r=this.h.filter(o=>o.type===a);if(r.length>0)return r[0].factory}O(a){const r=this.h.filter(o=>o.handle===a);if(r.length>0)return r[0].factory}P(a){const r=this.f.filter(o=>o.handle===a);if(r.length>0)return r[0].provider}Q(a,r){if(a.contributes){const o=a.contributes.debuggers;if(o&&o.length>0){for(const w of o)if(w.label&&w.type&&w.type===r)return!0}}return!1}R(a){const o=a.configuration.type,w=this.j.filter(v=>v.type===o||v.type==="*").map(v=>(0,y.$xg)(()=>v.factory.createDebugAdapterTracker(a)).then(E=>E,E=>null));return Promise.race([Promise.all(w).then(v=>{const E=v.filter(D=>!!D);if(E.length>0)return new m(E)}),new Promise(v=>setTimeout(()=>v(void 0),1e3))]).catch(v=>{})}async S(a,r){const o=r.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$WK(o));if(a){const v=await this.F.getExtensionRegistry();return(0,y.$xg)(()=>a.createDebugAdapterDescriptor(r,this.T(r,v))).then(E=>{if(E)return E})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(r,w))}T(a,r){}U(a,r,o){(a.length>0||r.length>0||o.length>0)&&this.y.fire(Object.freeze({added:a,removed:r,changed:o}))}async V(a){if(a)if(typeof a=="string"){const r=this.l.get(a);if(r)return r}else{let r=this.l.get(a.id);if(!r){const o=await this.W(a.folderUri),w=a.parent?this.l.get(a.parent):void 0;r=new i(this.k,a.id,a.type,a.name,o,a.configuration,w),this.l.set(r.id,r),this.k.$sessionCached(r.id)}return r}throw new Error("cannot find session")}W(a){if(a){const r=C.URI.revive(a);return this.E.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};e.$Kbc=t,e.$Kbc=t=Ke([Ve(0,f.$SL),Ve(1,S.$Dac),Ve(2,I.$_ac),Ve(3,$.$Gac),Ve(4,l.$Fbc),Ve(5,d.$Hbc)],t);class i{constructor(a,r,o,w,v,E,D){this.d=a,this.f=r,this.g=o,this.h=w,this.i=v,this.j=E,this.k=D}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,r){return this.d.$customDebugAdapterRequest(this.f,a,r)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.$Lbc=i;class c{constructor(a){this.value=Object.freeze({append(r){a.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.$Mbc=c;class m{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(r=>r.onError?r.onError(a):void 0)}onExit(a,r){this.d.forEach(o=>o.onExit?o.onExit(a,r):void 0)}}class k extends u.$fcb{constructor(a){super(),this.h=a,a.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends t{constructor(a,r,o,w,v,E){super(a,r,o,w,v,E)}};e.$Nbc=b,e.$Nbc=b=Ke([Ve(0,f.$SL),Ve(1,S.$Dac),Ve(2,I.$_ac),Ve(3,$.$Gac),Ve(4,l.$Fbc),Ve(5,d.$Hbc)],b)}),define(Pe[270],Ae([1,0,9,87,2,3,261,14,70,71,27,173,17,55,35,57]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=e.$ycc=void 0;class t{static async installEarlyHandler(m){Error.stackTraceLimit=100;const k=m.get(l.$3i),n=m.get(u.$SL).getProxy(L.$QJ.MainThreadErrors);y.setUnexpectedErrorHandler(a=>{k.error(a);const r=y.$1(a);n.$onUnexpectedError(r)})}static async installFullHandler(m){const k=m.get(l.$3i),b=m.get(u.$SL),n=m.get($.$_ac),a=m.get(d.$aM),r=b.getProxy(L.$QJ.MainThreadExtensionService),o=b.getProxy(L.$QJ.MainThreadErrors),w=await n.getExtensionPathIndex(),v=new WeakMap;function E(h,g){if(v.has(h))return v.get(h).stack;let M="",W,V;for(const j of g)M+=`
	at ${j.toString()}`,V=j.getFileName(),!W&&V&&(W=w.findSubstr(C.URI.file(V)));const B=`${h.name||"Error"}: ${h.message||""}${M}`;return v.set(h,{extensionIdentifier:W?.identifier,stack:B}),B}const D=Symbol("prepareStackTrace wrapped");let s=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return s},set(h){if(h===E||!h||h[D]){s=h||E;return}s=function(g,M){return E(g,M),h.call(Error,g,M)},Object.assign(s,{[D]:!0})}}),y.setUnexpectedErrorHandler(h=>{k.error(h);const g=y.$1(h),M=v.get(h);if(!M?.extensionIdentifier){o.$onUnexpectedError(g);return}r.$onExtensionRuntimeError(M.extensionIdentifier,g);const W=a.onExtensionError(M.extensionIdentifier,h);k.trace("forwarded error to extension?",W,M)})}}e.$ycc=t;class i{constructor(m,k,b,n,a){this.a=b,this.b=new A.$52b(m,null,n),k=i.e(k,this.b);const r=new f.$xh(...(0,I.$kr)());r.set(P.$9L,{_serviceBrand:void 0,...k,messagePorts:a}),r.set(u.$SL,new u.$TL(this.b)),r.set(p.$Aac,new p.$Bac(n)),r.set($.$0ac,b);const o=new S.$3p(r,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(w=>w.get(l.$3i)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",k),this.c=o.invokeFunction(w=>w.get($.$_ac)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(m){const k=this.b.getProxy(L.$QJ.MainThreadExtensionService);return C.URI.revive(await k.$asBrowserUri(m))}terminate(m){this.c.terminate(m)}static e(m,k){m.allExtensions.forEach(n=>{n.extensionLocation=C.URI.revive(k.transformIncomingURIs(n.extensionLocation))}),m.environment.appRoot=C.URI.revive(k.transformIncomingURIs(m.environment.appRoot));const b=m.environment.extensionDevelopmentLocationURI;return b&&(m.environment.extensionDevelopmentLocationURI=b.map(n=>C.URI.revive(k.transformIncomingURIs(n)))),m.environment.extensionTestsLocationURI=C.URI.revive(k.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=C.URI.revive(k.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=C.URI.revive(k.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=C.URI.revive(k.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=C.URI.revive(k.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=C.URI.revive(k.transformIncomingURIs(m.logsLocation)),m.workspace=k.transformIncomingURIs(m.workspace),m}}e.$zcc=i}),define(Pe[271],Ae([1,0,18,13,21,41,12,19,23,2,47]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=e.$Rbc=e.$Qbc=e.$Pbc=void 0;class S{constructor(c,m,k,b){this.d=c,this.e=m,this.f=k,this.g=b,this.a=null,this.b=!1,this.c=0}search(c,m){const k=this.d.folderQueries||[],b=new C.$rc(m);return new Promise((n,a)=>{this.a=new p(c);let r=!1;const o=(w,v)=>{if(!r&&!this.b){const E=this.h(w);d(w)&&typeof this.d.maxResults=="number"&&this.c+E>this.d.maxResults&&(this.b=!0,r=!0,b.cancel(),w=this.j(w,this.d.maxResults-this.c));const D=this.h(w);this.c+=D,(D>0||!d(w))&&this.a.add(w,v)}};Promise.all(k.map((w,v)=>this.k(w,E=>o(E,v),b.token))).then(w=>{b.dispose(),this.a.flush();const v=w.some(E=>!!E&&!!E.limitHit);n({limitHit:this.b||v,messages:(0,y.$Kf)(w.map(E=>E?.message?Array.isArray(E.message)?E.message:[E.message]:[])),stats:{type:this.g}})},w=>{b.dispose();const v=(0,L.$ki)(w);a(new Error(v))})})}h(c){return d(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,m){const k=Array.isArray(c.ranges)?c.ranges:[c.ranges],b=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:k.slice(0,m),preview:{matches:b.slice(0,m),text:c.preview.text},uri:c.uri}}async k(c,m,k){const b=new P.$vI(this.d,c),n=[],a={report:w=>{if(!this.l(w))return;const v=c.folder.scheme===A.Schemas.file?(0,P.$wI)(()=>this.f.readdir(I.$fg(w.uri))):void 0,E=I.$ig(c.folder,w.uri);if(E){const D=b.includedInQuery(E,l.$cd(E),v);(0,R.$rg)(D)?n.push(D.then(s=>{s&&m(w)})):D&&m(w)}}},r=this.n(c),o=await this.e.provideTextSearchResults(u(this.d.contentPattern),r,a,k);return n.length&&await Promise.all(n),o}l(c){if(d(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const m=(0,P.$uI)(this.d.includePattern,c.includePattern),k=(0,P.$uI)(this.d.excludePattern,c.excludePattern),b={folder:f.URI.from(c.folder),excludes:k,includes:m,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.$Pbc=S;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,m=>this.g(m))}add(c,m){this.d&&(this.b!==m||!I.$_f(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=m,this.d={resource:c.uri,results:[]}),this.d.results.push($(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$Qbc=p;function $(i){return d(i)?{preview:{matches:(0,y.$Uf)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,y.$Uf)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function d(i){return!!i.preview}e.$Rbc=d;class t{static{this.a=4e3}static{this.b=50}constructor(c,m){this.g=c,this.h=m,this.c=0,this.d=[],this.e=0}addItem(c,m){c&&this.j(c,m)}addItems(c,m){c&&this.k(c,m)}j(c,m){this.d.push(c),this.e+=m,this.l()}k(c,m){this.d=this.d.concat(c),this.e+=m,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Sbc=t}),define(Pe[115],Ae([1,0,6,3,4,266,17,55,14,2,271]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=e.$Ubc=e.$Tbc=void 0,e.$Tbc=(0,C.$zh)("IExtHostSearch");let S=class{constructor(d,t,i){this.k=d,this.l=t,this.n=i,this.c=this.k.getProxy(R.$QJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$Obc}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(d)),(0,y.$kb)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(d)),(0,y.$kb)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(d,t,i,c){const m=u(i),k=this.h.get(d);if(k)return this.j.fileSearch(m,k,b=>{this.c.$handleFileMatch(d,t,b.map(n=>n.resource))},c);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,i,c){const m=this.e.get(d);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const k=u(i);return this.q(k,m).search(n=>this.c.$handleTextMatch(d,t,n),c)}$enableExtensionHostSearch(){}q(d,t){return new P.$Pbc(d,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$Ubc=S,e.$Ubc=S=Ke([Ve(0,A.$SL),Ve(1,l.$Aac),Ve(2,I.$3i)],S);function u($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(p),extraFileResources:$.extraFileResources&&$.extraFileResources.map(d=>f.URI.revive(d))}}e.$Vbc=u;function p($){return{...$,folder:f.URI.revive($.folder)}}}),define(Pe[272],Ae([1,0,21,9,5,29,2,136,283,125,134,38,3,79,225,224,31,226,34,228,229,230,204,231,59,35,233,234,239,240,242,110,208,248,249,251,84,62,253,211,8,7,52,256,63,109,33,20,199,238,51,108,112,114,115,14,55,17,27,243,197,86,80,218,254,85,61,259,257,258,219,39,252,255,83,60,57,244,111,245,12,95,207,190,236,6,26,195,81,186,246,247,220,235,206,237,82,250,221,222,223,217,232]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b,n,a,r,o,w,v,E,D,s,h,g,M,W,V,B,j,U,z,ie,X,ye,De,Re,Y,le,we,ae,x,ue,O,J,he,Ee,ve,be,ke,oe,de,se,ne,me,Ce,F,q,H,Q,K,ee,ce,ze,Ue,Qe,He,et,Xe,_e,it,tt,Ne,st,_,Z,$e,je,Oe,Ze,nt,gt,vt,Tt,Zt,Vt,wt,Lt,zt,Jt,Pt,At,Ot,jt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;function Bt(at){const ut=at.get(oe.$9L),Ht=at.get(ze.$qac),Ct=at.get(H.$Vac),Dt=at.get(o.$_ac),ht=at.get(le.$Dac),St=at.get(Xe.$aM),Mt=at.get(c.$Gac),Et=at.get(be.$Aac),qe=at.get(ke.$SL),Nt=at.get(B.$Rac),Ie=at.get(q.$Wac),Fe=at.get(ve.$4i),ge=at.get(ve.$3i),G=at.get(ne.$Zrb),Te=at.get(me.$tac),Be=at.get(Y.$xbc),Ge=at.get(He.$4ac),We=at.get(et.$Fbc),xe=at.get(zt.$8ac);qe.set(u.$RJ.ExtHostFileSystemInfo,Ht),qe.set(u.$RJ.ExtHostLogLevelServiceShape,Fe),qe.set(u.$RJ.ExtHostWorkspace,ht),qe.set(u.$RJ.ExtHostConfiguration,Mt),qe.set(u.$RJ.ExtHostExtensionService,Dt),qe.set(u.$RJ.ExtHostStorage,Nt),qe.set(u.$RJ.ExtHostTunnelService,G),qe.set(u.$RJ.ExtHostWindow,Be),qe.set(u.$RJ.ExtHostSecretState,Ge),qe.set(u.$RJ.ExtHostTelemetry,St),qe.set(u.$RJ.ExtHostEditorTabs,We),qe.set(u.$RJ.ExtHostManagedSockets,xe);const pt=qe.set(u.$RJ.ExtHostDecorations,at.get(O.$Bbc)),bt=qe.set(u.$RJ.ExtHostDocumentsAndEditors,at.get(r.$4L)),dt=qe.set(u.$RJ.ExtHostCommands,at.get(t.$cM)),ft=qe.set(u.$RJ.ExtHostTerminalService,at.get(j.$Yac)),mt=qe.set(u.$RJ.ExtHostDebugService,at.get(he.$Jbc)),gi=qe.set(u.$RJ.ExtHostSearch,at.get(Ee.$Tbc)),Kt=qe.set(u.$RJ.ExtHostTask,at.get(J.$Ebc)),Ei=qe.set(u.$RJ.ExtHostOutputService,at.get(h.$hbc)),Wt=qe.set(u.$RJ.ExtHostLocalization,at.get(nt.$7ac)),mi=qe.set(u.$RJ.ExtHostUrls,new De.$qbc(qe)),It=qe.set(u.$RJ.ExtHostDocuments,new a.$oac(qe,bt)),Di=qe.set(u.$RJ.ExtHostDocumentContentProviders,new b.$Iac(qe,bt,ge)),Vi=qe.set(u.$RJ.ExtHostDocumentSaveParticipant,new n.$Jac(ge,It,qe.getProxy(u.$QJ.MainThreadBulkEdits))),kt=qe.set(u.$RJ.ExtHostNotebook,new de.$Zbc(qe,dt,bt,It,Ct)),ti=qe.set(u.$RJ.ExtHostNotebookDocuments,new Z.$fcc(kt)),$i=qe.set(u.$RJ.ExtHostNotebookEditors,new _.$ecc(ge,kt)),si=qe.set(u.$RJ.ExtHostNotebookKernels,new _e.$bcc(qe,ut,kt,dt,ge)),ki=qe.set(u.$RJ.ExtHostNotebookRenderers,new tt.$dcc(qe,kt)),Si=qe.set(u.$RJ.ExtHostNotebookDocumentSaveParticipant,new wt.$lcc(ge,kt,qe.getProxy(u.$QJ.MainThreadBulkEdits))),Rt=qe.set(u.$RJ.ExtHostEditors,new U.$obc(qe,bt)),pi=qe.set(u.$RJ.ExtHostTreeViews,new z.$pbc(qe.getProxy(u.$QJ.MainThreadTreeViews),dt,ge)),Ii=qe.set(u.$RJ.ExtHostEditorInsets,new ae.$ybc(qe.getProxy(u.$QJ.MainThreadEditorInsets),Rt,ut.remote)),oi=qe.set(u.$RJ.ExtHostDiagnostics,new m.$sac(qe,ge,Ht,bt)),ai=qe.set(u.$RJ.ExtHostLanguages,new D.$ebc(qe,It,dt.converter,Et)),ct=qe.set(u.$RJ.ExtHostLanguageFeatures,new E.$wac(qe,Et,It,dt,oi,ge,Te,St)),qi=qe.set(u.$RJ.ExtHostFileSystem,new w.$cbc(qe,ct)),Yt=qe.set(u.$RJ.ExtHostFileSystemEventService,new v.$dbc(qe,ge,bt)),ii=qe.set(u.$RJ.ExtHostQuickOpen,(0,M.$jbc)(qe,ht,dt)),bi=qe.set(u.$RJ.ExtHostSCM,new W.$lbc(qe,dt,It,ge)),Ci=qe.set(u.$RJ.ExtHostQuickDiff,new Tt.$icc(qe,Et)),Ki=qe.set(u.$RJ.ExtHostShare,new Jt.$ncc(qe,Et)),Pi=qe.set(u.$RJ.ExtHostComments,(0,i.$zac)(qe,dt,It)),vi=qe.set(u.$RJ.ExtHostProgress,new g.$ibc(qe.getProxy(u.$QJ.MainThreadProgress))),Ji=qe.set(u.$RJ.ExtHosLabelService,new x.$zbc(qe)),Ai=qe.set(u.$RJ.ExtHostTheming,new se.$1bc(qe)),ci=qe.set(u.$RJ.ExtHostAuthentication,new Ce.$2bc(qe)),Hi=qe.set(u.$RJ.ExtHostTimeline,new F.$4bc(qe,dt)),wi=qe.set(u.$RJ.ExtHostWebviews,new Re.$tbc(qe,ut.remote,ht,ge,Te)),Ri=qe.set(u.$RJ.ExtHostWebviewPanels,new ee.$6bc(qe,wi,ht)),cn=qe.set(u.$RJ.ExtHostCustomEditors,new K.$7bc(qe,It,Ie,wi,Ri)),Fi=qe.set(u.$RJ.ExtHostWebviewViews,new Q.$5bc(qe,wi)),ni=qe.set(u.$RJ.ExtHostTesting,new Ue.$9bc(qe,dt,bt)),un=qe.set(u.$RJ.ExtHostUriOpeners,new Qe.$acc(qe)),ln=qe.set(u.$RJ.ExtHostProfileContentHandlers,new vt.$hcc(qe));qe.set(u.$RJ.ExtHostInteractive,new $e.$gcc(qe,kt,bt,dt,ge));const Gi=qe.set(u.$RJ.ExtHostInlineChat,new Vt.$kcc(qe,dt,It,ge)),fi=qe.set(u.$RJ.ExtHostChatProvider,new Pt.$occ(qe,ge)),Qi=qe.set(u.$RJ.ExtHostChatSlashCommands,new At.$pcc(qe,fi,ge)),Zi=qe.set(u.$RJ.ExtHostChatVariables,new Ot.$qcc(qe)),ui=qe.set(u.$RJ.ExtHostChat,new Zt.$jcc(qe,ge)),Yi=qe.set(u.$RJ.ExtHostAiRelatedInformation,new jt.$rcc(qe)),Ti=qe.set(u.$RJ.ExtHostAiEmbeddingVector,new qt.$scc(qe)),Xi=qe.set(u.$RJ.ExtHostIssueReporter,new Lt.$mcc(qe)),Xt=qe.set(u.$RJ.ExtHostStatusBar,new V.$nbc(qe,dt.converter)),yi=Object.values(u.$RJ);qe.assertRegistered(yi);const hn=new ce.$8bc(qe,bt),Gt=new d.$yac(qe),li=new s.$fbc(qe,ge),Li=new k.$Hac(qe);return $.$xac.register(dt),function(Me,_t,Mi){const $t=function(){let te=!Me.isUnderDevelopment;function fe(){te||(ge.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")fe();else{const yt=rt;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,Oe.$LF)(Me,"documentFiltersExclusive")}return rt}}(),_i={getSession(te,fe,Le){return ci.getSession(Me,te,fe,Le)},getSessions(te,fe){return(0,Oe.$LF)(Me,"authGetSessions"),ci.getSessions(Me,te,fe)},async hasSession(te,fe){return(0,Oe.$LF)(Me,"authSession"),!!await ci.getSession(Me,te,fe,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,fe,Le,rt){return ci.registerAuthenticationProvider(te,fe,Le,rt)}},xi={registerCommand(te,fe,Le){return dt.registerCommand(!0,te,fe,Le,void 0,Me)},registerTextEditorCommand(te,fe,Le){return dt.registerCommand(!0,te,(...rt)=>{const yt=Rt.getActiveTextEditor();if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return yt.edit(Ft=>{fe.apply(Le,[yt,Ft,...rt])}).then(Ft=>{Ft||ge.warn("Edits from command "+te+" were not applied.")},Ft=>{ge.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Me)},registerDiffInformationCommand:(te,fe,Le)=>((0,Oe.$LF)(Me,"diffCommand"),dt.registerCommand(!0,te,async(...rt)=>{const yt=bt.activeEditor(!0);if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await Rt.getDiffInformation(yt.id);fe.apply(Le,[Ft,...rt])},void 0,void 0,Me)),executeCommand(te,...fe){return dt.executeCommand(te,...fe)},getCommands(te=!1){return dt.getCommands(te)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return ft.getDefaultShell(!1)},get onDidChangeShell(){return(0,Oe.$LF)(Me,"envShellEvent"),ft.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$LF)(Me,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$LF)(Me,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$_L)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,fe){return Xe.$$L.validateSender(te),St.instantiateLogger(Me,te,fe)},openExternal(te,fe){return Be.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return mi.createAppUri(te);try{return await Be.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(fe){if((0,st.$AT)(te,Ne.Schemas.http)||(0,st.$AT)(te,Ne.Schemas.https))return te;throw fe}},get remoteName(){return(0,ue.$Nk)(ut.remote.authority)},get remoteAuthority(){return(0,Oe.$LF)(Me,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return ge.getLevel()},get onDidChangeLogLevel(){return ge.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$LF)(Me,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Me,te)},get appQuality(){return(0,Oe.$LF)(Me,"resolvers"),ut.quality},get appCommit(){return(0,Oe.$LF)(Me,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(te,fe,Le){return ni.createTestController(Me,te,fe,Le)},createTestObserver(){return(0,Oe.$LF)(Me,"testObserver"),ni.createTestObserver()},runTests(te){return(0,Oe.$LF)(Me,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$LF)(Me,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Oe.$LF)(Me,"testObserver"),ni.results}},hi=ut.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,tn={getExtension(te,fe){(0,Oe.$KF)(Me,"extensionsAny")||(fe=!1);const Le=_t.mine.getExtensionDescription(te);if(Le)return new o.$abc(Dt,Me.identifier,Le,hi,!1);if(fe){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$abc(Dt,Me.identifier,rt,hi,!0)}},get all(){const te=[];for(const fe of _t.mine.getAllExtensionDescriptions())te.push(new o.$abc(Dt,Me.identifier,fe,hi,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$LF)(Me,"extensionsAny");const te=new we.$Ul(_t.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),fe=[];for(const Le of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Le.identifier);fe.push(new o.$abc(Dt,Me.identifier,Le,hi,rt))}return fe},get onDidChange(){return(0,Oe.$KF)(Me,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Me.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,fe){return ai.changeLanguage(te.uri,fe)},match(te,fe){const Le=It.getDocumentData(fe.uri)?.notebook;return(0,P.$$E)(ie.LanguageSelector.from(te),fe.uri,fe.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(te,fe,Le){return ct.registerCodeActionProvider(Me,$t(te),fe,Le)},registerDocumentPasteEditProvider(te,fe,Le){return(0,Oe.$LF)(Me,"documentPaste"),ct.registerDocumentPasteEditProvider(Me,$t(te),fe,Le)},registerCodeLensProvider(te,fe){return ct.registerCodeLensProvider(Me,$t(te),fe)},registerDefinitionProvider(te,fe){return ct.registerDefinitionProvider(Me,$t(te),fe)},registerDeclarationProvider(te,fe){return ct.registerDeclarationProvider(Me,$t(te),fe)},registerImplementationProvider(te,fe){return ct.registerImplementationProvider(Me,$t(te),fe)},registerTypeDefinitionProvider(te,fe){return ct.registerTypeDefinitionProvider(Me,$t(te),fe)},registerHoverProvider(te,fe){return ct.registerHoverProvider(Me,$t(te),fe,Me.identifier)},registerEvaluatableExpressionProvider(te,fe){return ct.registerEvaluatableExpressionProvider(Me,$t(te),fe,Me.identifier)},registerInlineValuesProvider(te,fe){return ct.registerInlineValuesProvider(Me,$t(te),fe,Me.identifier)},registerDocumentHighlightProvider(te,fe){return ct.registerDocumentHighlightProvider(Me,$t(te),fe)},registerLinkedEditingRangeProvider(te,fe){return ct.registerLinkedEditingRangeProvider(Me,$t(te),fe)},registerReferenceProvider(te,fe){return ct.registerReferenceProvider(Me,$t(te),fe)},registerRenameProvider(te,fe){return ct.registerRenameProvider(Me,$t(te),fe)},registerDocumentSymbolProvider(te,fe,Le){return ct.registerDocumentSymbolProvider(Me,$t(te),fe,Le)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Me,te)},registerDocumentFormattingEditProvider(te,fe){return ct.registerDocumentFormattingEditProvider(Me,$t(te),fe)},registerDocumentRangeFormattingEditProvider(te,fe){return ct.registerDocumentRangeFormattingEditProvider(Me,$t(te),fe)},registerOnTypeFormattingEditProvider(te,fe,Le,...rt){return ct.registerOnTypeFormattingEditProvider(Me,$t(te),fe,[Le].concat(rt))},registerDocumentSemanticTokensProvider(te,fe,Le){return ct.registerDocumentSemanticTokensProvider(Me,$t(te),fe,Le)},registerDocumentRangeSemanticTokensProvider(te,fe,Le){return ct.registerDocumentRangeSemanticTokensProvider(Me,$t(te),fe,Le)},registerSignatureHelpProvider(te,fe,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Me,$t(te),fe,Le):ct.registerSignatureHelpProvider(Me,$t(te),fe,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(te,fe,...Le){return ct.registerCompletionItemProvider(Me,$t(te),fe,Le)},registerInlineCompletionItemProvider(te,fe,Le){return fe.handleDidShowCompletionItem&&(0,Oe.$LF)(Me,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$LF)(Me,"inlineCompletionsAdditions"),Le&&(0,Oe.$LF)(Me,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Me,$t(te),fe,Le)},registerDocumentLinkProvider(te,fe){return ct.registerDocumentLinkProvider(Me,$t(te),fe)},registerColorProvider(te,fe){return ct.registerColorProvider(Me,$t(te),fe)},registerFoldingRangeProvider(te,fe){return ct.registerFoldingRangeProvider(Me,$t(te),fe)},registerSelectionRangeProvider(te,fe){return ct.registerSelectionRangeProvider(Me,te,fe)},registerCallHierarchyProvider(te,fe){return ct.registerCallHierarchyProvider(Me,te,fe)},registerTypeHierarchyProvider(te,fe){return ct.registerTypeHierarchyProvider(Me,te,fe)},setLanguageConfiguration:(te,fe)=>ct.setLanguageConfiguration(Me,te,fe),getTokenInformationAtPosition(te,fe){return(0,Oe.$LF)(Me,"tokenInformation"),ai.tokenAtPosition(te,fe)},registerInlayHintsProvider(te,fe){return ct.registerInlayHintsProvider(Me,te,fe)},createLanguageStatusItem(te,fe){return ai.createLanguageStatusItem(Me,te,fe)},registerDocumentDropEditProvider(te,fe,Le){return ct.registerDocumentOnDropEditProvider(Me,te,fe,(0,Oe.$KF)(Me,"dropMetadata")?Le:void 0)}},rn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,fe,Le){const rt=await(A.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Rt.showTextDocument(rt,fe,Le)},createTextEditorDecorationType(te){return Rt.createTextEditorDecorationType(Me,te)},onDidChangeActiveTextEditor(te,fe,Le){return Rt.onDidChangeActiveTextEditor(te,fe,Le)},onDidChangeVisibleTextEditors(te,fe,Le){return Rt.onDidChangeVisibleTextEditors(te,fe,Le)},onDidChangeTextEditorSelection(te,fe,Le){return Rt.onDidChangeTextEditorSelection(te,fe,Le)},onDidChangeTextEditorOptions(te,fe,Le){return Rt.onDidChangeTextEditorOptions(te,fe,Le)},onDidChangeTextEditorVisibleRanges(te,fe,Le){return Rt.onDidChangeTextEditorVisibleRanges(te,fe,Le)},onDidChangeTextEditorViewColumn(te,fe,Le){return Rt.onDidChangeTextEditorViewColumn(te,fe,Le)},onDidCloseTerminal(te,fe,Le){return ft.onDidCloseTerminal(te,fe,Le)},onDidOpenTerminal(te,fe,Le){return ft.onDidOpenTerminal(te,fe,Le)},onDidChangeActiveTerminal(te,fe,Le){return ft.onDidChangeActiveTerminal(te,fe,Le)},onDidChangeTerminalDimensions(te,fe,Le){return(0,Oe.$LF)(Me,"terminalDimensions"),ft.onDidChangeTerminalDimensions(te,fe,Le)},onDidChangeTerminalState(te,fe,Le){return ft.onDidChangeTerminalState(te,fe,Le)},onDidWriteTerminalData(te,fe,Le){return(0,Oe.$LF)(Me,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(te,fe,Le)},onDidExecuteTerminalCommand(te,fe,Le){return(0,Oe.$LF)(Me,"terminalExecuteCommandEvent"),ft.onDidExecuteTerminalCommand(te,fe,Le)},get state(){return Be.getState(Me)},onDidChangeWindowState(te,fe,Le){return Be.onDidChangeWindowState(te,fe,Le)},showInformationMessage(te,...fe){return li.showMessage(Me,L.default.Info,te,fe[0],fe.slice(1))},showWarningMessage(te,...fe){return li.showMessage(Me,L.default.Warning,te,fe[0],fe.slice(1))},showErrorMessage(te,...fe){return li.showMessage(Me,L.default.Error,te,fe[0],fe.slice(1))},showQuickPick(te,fe,Le){return ii.showQuickPick(Me,te,fe,Le)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,fe){return ii.showInput(te,fe)},showOpenDialog(te){return Li.showOpenDialog(Me,te)},showSaveDialog(te){return Li.showSaveDialog(te)},createStatusBarItem(te,fe,Le){let rt,yt,Ft;return typeof te=="string"?(rt=te,yt=fe,Ft=Le):(yt=te,Ft=fe),Xt.createStatusBarEntry(Me,rt,yt,Ft)},setStatusBarMessage(te,fe){return Xt.setStatusBarMessage(te,fe)},withScmProgress(te){return Te.report("window.withScmProgress",Me,"Use 'withProgress' instead."),vi.withProgress(Me,{location:X.ProgressLocation.SourceControl},(fe,Le)=>te({report(rt){}}))},withProgress(te,fe){return vi.withProgress(Me,te,fe)},createOutputChannel(te,fe){return Ei.createOutputChannel(te,fe,Me)},createWebviewPanel(te,fe,Le,rt){return Ri.createWebviewPanel(Me,te,fe,Le,rt)},createWebviewTextEditorInset(te,fe,Le,rt){return(0,Oe.$LF)(Me,"editorInsets"),Ii.createWebviewEditorInset(te,fe,Le,rt,Me)},createTerminal(te,fe,Le){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):ft.createTerminalFromOptions(te):ft.createTerminal(te,fe,Le)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTerminalProfileProvider(te,fe){return ft.registerProfileProvider(Me,te,fe)},registerTerminalQuickFixProvider(te,fe){return(0,Oe.$LF)(Me,"terminalQuickFixProvider"),ft.registerTerminalQuickFixProvider(te,Me.identifier.value,fe)},registerTreeDataProvider(te,fe){return pi.registerTreeDataProvider(te,fe,Me)},createTreeView(te,fe){return pi.createTreeView(te,fe,Me)},registerWebviewPanelSerializer:(te,fe)=>Ri.registerWebviewPanelSerializer(Me,te,fe),registerCustomEditorProvider:(te,fe,Le={})=>cn.registerCustomEditorProvider(Me,te,fe,Le),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,Me)},registerUriHandler(te){return mi.registerUriHandler(Me,te)},createQuickPick(){return ii.createQuickPick(Me)},createInputBox(){return ii.createInputBox(Me)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,fe,Le){return Ai.onDidChangeActiveColorTheme(te,fe,Le)},registerWebviewViewProvider(te,fe,Le){return Fi.registerWebviewViewProvider(Me,te,fe,Le?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,fe,Le){return kt.onDidChangeActiveNotebookEditor(te,fe,Le)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,fe,Le){return $i.onDidChangeNotebookEditorSelection(te,fe,Le)},onDidChangeNotebookEditorVisibleRanges(te,fe,Le){return $i.onDidChangeNotebookEditorVisibleRanges(te,fe,Le)},showNotebookDocument(te,fe){return kt.showNotebookDocument(te,fe)},registerExternalUriOpener(te,fe,Le){return(0,Oe.$LF)(Me,"externalUriOpener"),un.registerExternalUriOpener(Me.identifier,te,fe,Le)},registerProfileContentHandler(te,fe){return(0,Oe.$LF)(Me,"profileContentHandlers"),ln.registrProfileContentHandler(Me,te,fe)},registerQuickDiffProvider(te,fe,Le,rt){return(0,Oe.$LF)(Me,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(te),fe,Le,rt)},get tabGroups(){return We.tabGroups},registerShareProvider(te,fe){return(0,Oe.$LF)(Me,"shareProvider"),Ki.registerShareProvider($t(te),fe)}},sn={get rootPath(){return Te.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new R.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new R.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new R.$7("workspaceFile")},updateWorkspaceFolders:(te,fe,...Le)=>ht.updateWorkspaceFolders(Me,te,fe||0,...Le),onDidChangeWorkspaceFolders:function(te,fe,Le){return ht.onDidChangeWorkspace(te,fe,Le)},asRelativePath:(te,fe)=>ht.getRelativePath(te,fe),findFiles:(te,fe,Le,rt)=>ht.findFiles(te,fe,Le,Me.identifier,rt),findTextInFiles:(te,fe,Le,rt)=>{(0,Oe.$LF)(Me,"findTextInFiles");let yt,Ft;return typeof fe=="object"?(yt=fe,Ft=Le):(yt={},Ft=fe,rt=Le),ht.findTextInFiles(te,yt||{},Ft,Me.identifier,rt)},save:te=>((0,Oe.$LF)(Me,"saveEditor"),ht.save(te)),saveAs:te=>((0,Oe.$LF)(Me,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,fe){return hn.applyWorkspaceEdit(te,Me,fe)},createFileSystemWatcher:(te,fe,Le,rt)=>Yt.createFileSystemWatcher(ht,Me,te,fe,Le,rt),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new R.$7("textDocuments")},openTextDocument(te){let fe;const Le=te;if(typeof te=="string")fe=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))fe=Promise.resolve(te);else if(!Le||typeof Le=="object")fe=It.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>It.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(te,fe,Le)=>It.onDidAddDocument(te,fe,Le),onDidCloseTextDocument:(te,fe,Le)=>It.onDidRemoveDocument(te,fe,Le),onDidChangeTextDocument:(te,fe,Le)=>It.onDidChangeDocument(te,fe,Le),onDidSaveTextDocument:(te,fe,Le)=>It.onDidSaveDocument(te,fe,Le),onWillSaveTextDocument:(te,fe,Le)=>Vi.getOnWillSaveTextDocumentEvent(Me)(te,fe,Le),get notebookDocuments(){return kt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,fe){let Le;if(A.URI.isUri(te))Le=te,await kt.openNotebookDocument(te);else if(typeof te=="string")Le=A.URI.revive(await kt.createNotebookDocument({viewType:te,content:fe}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(te,fe,Le){return ti.onDidSaveNotebookDocument(te,fe,Le)},onDidChangeNotebookDocument(te,fe,Le){return ti.onDidChangeNotebookDocument(te,fe,Le)},onWillSaveNotebookDocument(te,fe,Le){return Si.getOnWillSaveNotebookDocumentEvent(Me)(te,fe,Le)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(te,fe,Le,rt){return kt.registerNotebookSerializer(Me,te,fe,Le,(0,Oe.$KF)(Me,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,fe,Le)=>Mi.onDidChangeConfiguration(te,fe,Le),getConfiguration(te,fe){return fe=arguments.length===1?void 0:fe,Mi.getConfiguration(te,fe,Me)},registerTextDocumentContentProvider(te,fe){return Di.registerTextDocumentContentProvider(te,fe)},registerTaskProvider:(te,fe)=>(Te.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Me,te,fe)),registerFileSystemProvider(te,fe,Le){return(0,je.$jb)(qi.registerFileSystemProvider(Me,te,fe,Le),Ct.addFileSystemProvider(te,fe,Le))},get fs(){return Ct.value},registerFileSearchProvider:(te,fe)=>((0,Oe.$LF)(Me,"fileSearchProvider"),gi.registerFileSearchProvider(te,fe)),registerTextSearchProvider:(te,fe)=>((0,Oe.$LF)(Me,"textSearchProvider"),gi.registerTextSearchProvider(te,fe)),registerRemoteAuthorityResolver:(te,fe)=>((0,Oe.$LF)(Me,"resolvers"),Dt.registerRemoteAuthorityResolver(te,fe)),registerResourceLabelFormatter:te=>((0,Oe.$LF)(Me,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$LF)(Me,"resolvers"),Dt.getRemoteExecServer(te)),onDidCreateFiles:(te,fe,Le)=>Yt.onDidCreateFile(te,fe,Le),onDidDeleteFiles:(te,fe,Le)=>Yt.onDidDeleteFile(te,fe,Le),onDidRenameFiles:(te,fe,Le)=>Yt.onDidRenameFile(te,fe,Le),onWillCreateFiles:(te,fe,Le)=>Yt.getOnWillCreateFileEvent(Me)(te,fe,Le),onWillDeleteFiles:(te,fe,Le)=>Yt.getOnWillDeleteFileEvent(Me)(te,fe,Le),onWillRenameFiles:(te,fe,Le)=>Yt.getOnWillRenameFileEvent(Me)(te,fe,Le),openTunnel:te=>((0,Oe.$LF)(Me,"tunnels"),G.openTunnel(Me,te).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Oe.$LF)(Me,"tunnels"),G.getTunnels()},onDidChangeTunnels:(te,fe,Le)=>((0,Oe.$LF)(Me,"tunnels"),G.onDidChangeTunnels(te,fe,Le)),registerPortAttributesProvider:(te,fe)=>((0,Oe.$LF)(Me,"portsAttributes"),G.registerPortsAttributesProvider(te,fe)),registerTunnelProvider:(te,fe)=>((0,Oe.$LF)(Me,"tunnelFactory"),G.registerTunnelProvider(te,fe)),registerTimelineProvider:(te,fe)=>((0,Oe.$LF)(Me,"timeline"),Hi.registerTimelineProvider(te,fe,Me.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Oe.$LF)(Me,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,fe,Le)=>ht.onDidGrantWorkspaceTrust(te,fe,Le),registerEditSessionIdentityProvider:(te,fe)=>((0,Oe.$LF)(Me,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,fe)),onWillCreateEditSessionIdentity:(te,fe,Le)=>((0,Oe.$LF)(Me,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Me)(te,fe,Le)),registerCanonicalUriProvider:(te,fe)=>((0,Oe.$LF)(Me,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,fe)),getCanonicalUri:(te,fe,Le)=>((0,Oe.$LF)(Me,"canonicalUriProvider"),ht.provideCanonicalUri(te,fe,Le))},fn={get inputBox(){return Te.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Me)},createSourceControl(te,fe,Le){return bi.createSourceControl(Me,te,fe,Le)}},on={createCommentController(te,fe){return Pi.createCommentController(Me,te,fe)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(te,fe,Le){return mt.onDidStartDebugSession(te,fe,Le)},onDidTerminateDebugSession(te,fe,Le){return mt.onDidTerminateDebugSession(te,fe,Le)},onDidChangeActiveDebugSession(te,fe,Le){return mt.onDidChangeActiveDebugSession(te,fe,Le)},onDidReceiveDebugSessionCustomEvent(te,fe,Le){return mt.onDidReceiveDebugSessionCustomEvent(te,fe,Le)},onDidChangeBreakpoints(te,fe,Le){return mt.onDidChangeBreakpoints(te,fe,Le)},onDidChangeStackFrameFocus(te,fe,Le){return(0,Oe.$LF)(Me,"debugFocus"),mt.onDidChangeStackFrameFocus(te,fe,Le)},registerDebugConfigurationProvider(te,fe,Le){return mt.registerDebugConfigurationProvider(te,fe,Le||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,fe){return mt.registerDebugAdapterDescriptorFactory(Me,te,fe)},registerDebugAdapterTrackerFactory(te,fe){return mt.registerDebugAdapterTrackerFactory(te,fe)},startDebugging(te,fe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?mt.startDebugging(te,fe,{parentSession:Le}):mt.startDebugging(te,fe,Le||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,fe){return mt.asDebugSourceUri(te,fe)}},zi={registerTaskProvider:(te,fe)=>Kt.registerTaskProvider(Me,te,fe),fetchTasks:te=>Kt.fetchTasks(te),executeTask:te=>Kt.executeTask(Me,te),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(te,fe,Le)=>Kt.onDidStartTask(te,fe,Le),onDidEndTask:(te,fe,Le)=>Kt.onDidEndTask(te,fe,Le),onDidStartTaskProcess:(te,fe,Le)=>Kt.onDidStartTaskProcess(te,fe,Le),onDidEndTaskProcess:(te,fe,Le)=>Kt.onDidEndTaskProcess(te,fe,Le)},Oi={createNotebookController(te,fe,Le,rt,yt){return si.createNotebookController(Me,te,fe,Le,rt,(0,Oe.$KF)(Me,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(te,fe)=>kt.registerNotebookCellStatusBarItemProvider(Me,te,fe),createRendererMessaging(te){return ki.createRendererMessaging(Me,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$LF)(Me,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Me,te)},registerKernelSourceActionProvider(te,fe){return(0,Oe.$LF)(Me,"notebookKernelSource"),si.registerKernelSourceActionProvider(Me,te,fe)},onDidChangeNotebookCellExecutionState(te,fe,Le){return(0,Oe.$LF)(Me,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,fe,Le)}},Ni={t(...te){if(typeof te[0]=="string"){const fe=te.shift(),Le=!te||typeof te[0]!="object"?te:te[0];return Wt.getMessage(Me.identifier.value,{message:fe,args:Le})}return Wt.getMessage(Me.identifier.value,te[0])},get bundle(){return Wt.getBundle(Me.identifier.value)},get uri(){return Wt.getBundleUri(Me.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(te){return(0,Oe.$LF)(Me,"interactive"),Gi.registerProvider(Me,te)},registerInteractiveSessionProvider(te,fe){return(0,Oe.$LF)(Me,"interactive"),ui.registerChatProvider(Me,te,fe)},addInteractiveRequest(te){return(0,Oe.$LF)(Me,"interactive"),ui.addChatRequest(te)},sendInteractiveRequestToProvider(te,fe){return(0,Oe.$LF)(Me,"interactive"),ui.sendInteractiveRequestToProvider(te,fe)},get onDidPerformUserAction(){return(0,Oe.$LF)(Me,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(te,fe){return(0,Oe.$LF)(Me,"interactive"),ui.transferChatSession(te,fe)}},Ui={getRelatedInformation(te,fe){return(0,Oe.$LF)(Me,"aiRelatedInformation"),Yi.getRelatedInformation(Me,te,fe)},registerRelatedInformationProvider(te,fe){return(0,Oe.$LF)(Me,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Me,te,fe)},registerEmbeddingVectorProvider(te,fe){return(0,Oe.$LF)(Me,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(Me,te,fe)}},ji={registerChatResponseProvider(te,fe,Le){return(0,Oe.$LF)(Me,"chatProvider"),fi.registerProvider(Me.identifier,te,fe,Le)},registerSlashCommand(te,fe,Le){return(0,Oe.$LF)(Me,"chatSlashCommands"),Qi.registerCommand(Me.identifier,te,fe,Le??{description:""})},requestChatAccess(te){return(0,Oe.$LF)(Me,"chatRequestAccess"),fi.requestChatResponseProvider(Me.identifier,te)},registerVariable(te,fe,Le){return(0,Oe.$LF)(Me,"chatVariables"),Zi.registerVariableResolver(Me,te,fe,Le)},registerMappedEditsProvider(te,fe){return(0,Oe.$LF)(Me,"mappedEditsProvider"),ct.registerMappedEditsProvider(Me,te,fe)}};return{version:ut.version,ai:Ui,authentication:_i,commands:xi,comments:on,chat:ji,debug:an,env:en,extensions:tn,interactive:di,l10n:Ni,languages:nn,notebooks:Oi,scm:fn,tasks:zi,tests:dn,window:rn,workspace:sn,Breakpoint:X.$RK,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatMessage:X.$HL,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$eK,CallHierarchyItem:X.$dK,CallHierarchyOutgoingCall:X.$fK,CancellationError:R.$3,CancellationTokenSource:y.$rc,CandidatePortSource:u.CandidatePortSource,CodeAction:X.$_J,CodeActionKind:X.$aK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$gK,Color:X.$tK,ColorInformation:X.$uK,ColorPresentation:X.$vK,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$nK,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$oK,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$DK,DebugAdapterExecutable:X.$VK,DebugAdapterInlineImplementation:X.$YK,DebugAdapterNamedPipeServer:X.$XK,DebugAdapterServer:X.$WK,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$7J,DiagnosticRelatedInformation:X.$6J,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$SJ,DocumentHighlight:X.$9J,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$sK,DocumentSymbol:X.$$J,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$2K,InlineValueText:X.$3K,InlineValueVariableLookup:X.$4K,InlineValueEvaluatableExpression:X.$5K,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:C.$hc,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$cL,FileDecoration2:X.$cL,FileSystemError:X.$7K,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:X.$8K,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$TK,InlineCompletionItem:X.$pK,InlineCompletionList:X.$qK,Hover:X.$8J,IndentAction:f.IndentAction,Location:X.$5J,MarkdownString:X.$hK,OverviewRulerLane:I.OverviewRulerLane,ParameterInformation:X.$iK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$TJ,ProcessExecution:X.$BK,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$bL,Range:X.$UJ,RelativePattern:X.$PK,Selection:X.$VJ,SelectionRange:X.$cK,SemanticTokens:X.$$K,SemanticTokensBuilder:X.$0K,SemanticTokensEdit:X.$_K,SemanticTokensEdits:X.$aL,SemanticTokensLegend:X.$9K,ShellExecution:X.$CK,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$kK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$jK,SnippetString:X.$4J,SourceBreakpoint:X.$SK,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$0J,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$EK,TaskGroup:X.$AK,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$wK,TerminalQuickFixExecuteTerminalCommand:X.$yK,TerminalQuickFixOpener:X.$xK,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$zK,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$ZJ,SnippetTextEdit:X.$2J,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$OK,ThemeIcon:X.$NK,TreeItem:X.$FK,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$xL,UIKind:p.UIKind,Uri:A.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$3J,DocumentDropEdit:X.$LK,DocumentPasteEdit:X.$MK,InlayHint:X.$mK,InlayHintLabelPart:X.$lK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$YJ,ResolvedAuthority:X.$WJ,ManagedResolvedAuthority:X.$XJ,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$mL,NotebookRange:X.$eL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$fL,NotebookData:X.$gL,NotebookRendererScript:X.$kL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$iL,NotebookCellOutputItem:X.$hL,NotebookCellStatusBarItem:X.$jL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$1J,NotebookKernelSourceAction:X.$lL,PortAttributes:X.$oL,LinkedEditingRanges:X.$nL,TestResultState:X.TestResultState,TestRunRequest:X.$pL,TestMessage:X.$qL,TestMessage2:X.$qL,TestTag:X.$rL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$KK,DataTransferItem:X.$GK,CoveredCount:X.$sL,FileCoverage:X.$tL,StatementCoverage:X.$uL,BranchCoverage:X.$vL,FunctionCoverage:X.$wL,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$yL,TabInputTextDiff:X.$zL,TabInputTextMerge:X.$AL,TabInputCustom:X.$BL,TabInputNotebook:X.$DL,TabInputNotebookDiff:X.$EL,TabInputWebview:X.$CL,TabInputTerminal:X.$FL,TabInputInteractiveWindow:X.$GL,TelemetryTrustedValue:ye.$0n,LogLevel:ve.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$ZK,ThreadFocus:X.$1K,NotebookCodeActionKind:X.$bK,RelatedInformationType:X.RelatedInformationType}}}e.$tcc=Bt}),define(Pe[273],Ae([1,0,70,110,33,108,34,31,59,62,112,114,115,84,86,80,109,61,39,83,57,60,241,14,113,81,82]),function(pe,e,y,R,C,L,A,l,I,f,P,S,u,p,$,d,t,i,c,m,k,b,n,a,r,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$jr)(o.$7ac,o.$6ac,1),(0,y.$jr)(a.$4i,n.$ucc,1),(0,y.$jr)(d.$tac,d.$uac,1),(0,y.$jr)(l.$cM,l.$bM,0),(0,y.$jr)(A.$Gac,A.$Eac,0),(0,y.$jr)(i.$Vac,i.$Uac,0),(0,y.$jr)(S.$Jbc,S.$Nbc,0),(0,y.$jr)(L.$Bbc,L.$Abc,0),(0,y.$jr)(I.$4L,I.$3L,0),(0,y.$jr)(w.$8ac,w.$9ac,0),(0,y.$jr)(c.$qac,c.$pac,0),(0,y.$jr)(R.$hbc,R.$gbc,1),(0,y.$jr)(u.$Tbc,u.$Ubc,0),(0,y.$jr)(p.$Rac,p.$Qac,0),(0,y.$jr)(P.$Ebc,P.$Dbc,0),(0,y.$jr)(f.$Yac,f.$2ac,0),(0,y.$jr)($.$Zrb,$.$1rb,0),(0,y.$jr)(t.$xbc,t.$wbc,0),(0,y.$jr)(C.$Dac,C.$Cac,0),(0,y.$jr)(m.$4ac,m.$3ac,0),(0,y.$jr)(k.$aM,k.$0L,0),(0,y.$jr)(b.$Fbc,b.$Gbc,0),(0,y.$jr)(r.$Hbc,r.$Ibc,0)}),define(Pe[274],Ae([1,0,272,35,2,269,7,13,260]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class f extends L.$xcc{j(){}getModule(p,$){for(const d of this.b){const t=d(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends R.$$ac{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(I.$Cec);const p=this.h.invokeFunction(y.$tcc);this.r=this.h.createInstance(f,p,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(p){return p.browser}async rb(p,$,d){$=$.with({path:S($.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.v.$asBrowserUri($)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const m=await c.text(),k=`${$.toString(!0)}#vscode-extension`,b=`${m}
//# sourceURL=${k}`;let n;try{n=new Function("module","exports","require",b)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${$.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}p&&await this.s.initializeLocalizedMessages(p);const a={},r={exports:a},o=w=>{const v=this.r.getModule(w,$);if(v===void 0)throw new Error(`Cannot load module '${w}'`);return v};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(r,a,o),r.exports!==a?r.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(p){}async vb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+p;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Fg)(10)}}e.$Dec=P;function S(u,p){return u.endsWith(p)?u:u+p}}),define(Pe[275],Ae([1,0,69,70,14,35,188,85,274]),function(pe,e,y,R,C,L,A,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.$jr)(C.$3i,new y.$wh(A.$wcc,[!0],!0)),(0,R.$jr)(L.$_ac,I.$Dec,0),(0,R.$jr)(l.$Wac,l.$Xac,0)}),define(Pe[284],Ae([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(pe,e,y,R,C,L,A,l,I,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(n){return/^(file|vscode-remote):/i.test(n)}const $=fetch.bind(self);function d(n){self.fetch=async function(a,r){return a instanceof Request||p(String(a))&&(a=(await n(P.URI.parse(String(a)))).toString(!0)),$(a,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,r,o,w,v){(async()=>(p(r.toString())&&(r=(await n(P.URI.parse(r.toString()))).toString(!0)),super.open(a,r,o??!0,w,v)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(a,r){if(/^file:/i.test(a.toString()))a=f.$4e.uriToBrowserUri(P.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(s){function h(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const g=fetch.bind(self);self.fetch=function(W,V){return W instanceof Request?g(W,V):g(h(W),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,V,B,j,U){return super.open(W,h(V),B??!0,j,U)}};const M=importScripts.bind(self);self.importScripts=(...W)=>{M(...W.map(h))},M(s)}.toString()}('${a}'))`;r=r||{},r.name=r.name||l.$cd(a.toString());const v=new Blob([w],{type:"application/javascript"}),E=URL.createObjectURL(v);return new n(E,r)}}else self.Worker=class extends A.$Eec{constructor(n,a){super(u,n,{name:l.$cd(n.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(n){S()}};class i{constructor(){const a=new MessageChannel,r=new R.$hc;let o=!1;u(a.port2,[a.port2]),a.port1.onmessage=w=>{const{data:v}=w;if(!(v instanceof ArrayBuffer)){console.warn("UNKNOWN data received",v);return}const E=y.$Hc.wrap(new Uint8Array(v,0,v.byteLength));if((0,C.$3l)(E,2)){o=!0,m("received terminate message from renderer");return}r.fire(E)},this.protocol={onMessage:r.event,send:w=>{if(!o){const v=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);a.port1.postMessage(v,[v])}}}}}function c(n){return new Promise(a=>{const r=n.onMessage(o=>{r.dispose();const w=JSON.parse(o.toString());n.send((0,C.$2l)(0)),a({protocol:n,initData:w})});n.send((0,C.$2l)(1))})}let m=n=>S();function k(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function b(){I.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(a){k(a)&&c(n.protocol).then(r=>{I.mark("code/extHost/didWaitForInitData");const o=new L.$zcc(r.protocol,r.initData,t,null,a.data);d(w=>o.asBrowserUri(w)),m=w=>o.terminate(w)})}}}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5a400e53e985dc5e24f6ee574b07ab23943841c5/core/vs/workbench/api/worker/extensionHostWorker.js.map
